/*******************************************************************************
 * @author Gaurav Sharma (g.sharma@samsung.com)
 * @file This file implements Dishwasher module and routes declaration
 * Copyright 2016 by Samsung Electronics, Inc.,
 * @license This software is the confidential and proprietary information of Samsung
 * Electronics, Inc. ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with Samsung.
 ******************************************************************************/
var debug_tag = 'DW',
app = angular.module("SmartHome", ['toaster', 'angular-svg-round-progress', 'ngSanitize', 'ngTouch', 'ui.router']);
app.config(['$stateProvider', routeConfig]);
app.run(['$state', function ($state) {
    $state.transitionTo('SplashPage');
}]);

/**
 * @name routeConfig
 * @param {type} $stateProvider
 * @returns {Void}
 * @description Defines routes config for dishwasher pages, any new pages required for the module has to be defined here
 */
function routeConfig($stateProvider) {
    var SplashPage = {
        name: 'SplashPage',
        url: '/',
        templateUrl: 'common/views/splash.html'
    },
    AboutPage = {
        name: 'AboutPage',
        url: '/',
        templateUrl: 'DW/views/about.html'
    },
    SettingsPage = {
        name: 'SettingsPage',
        url: '/',
        templateUrl: 'DW/views/settings.html'
    },
    ErrorPage = {
        name: 'ErrorPage',
        url: '/',
        templateUrl: 'DW/views/error.html'
    },
    HomePage = {
        name: 'HomePage',
        url: '/',
        templateUrl: 'DW/views/home.html'
    },
    SelfCarePage = {
        name: 'SelfCarePage',
        url: '/',
        templateUrl: 'DW/views/self_care.html'
    },
    EnergyMonitorPage = {
        name: 'EnergyMonitorPage',
        url: '/',
        templateUrl: 'common/views/energyMonitor.html'
    },
    FavoritePage = {
        name: 'FavoritePage',
        url: '/',
        templateUrl: 'DW/views/favorite.html'
    },
    SelfCleanHistoryPage = {
        name: 'SelfCleanHistoryPage',
        url: '/',
        templateUrl:'DW/views/self_clean_history.html'
    },
    AddFavoritePage = {
        name: 'AddFavoritePage',
        url: '/',
        templateUrl:'DW/views/add_favorite.html'
    },
    CyclePage = {
        name: 'CyclePage',
        url: '/',
        templateUrl:'DW/views/cycle.html'
    };

    $stateProvider.state(SplashPage);
    $stateProvider.state(AboutPage);
    $stateProvider.state(SettingsPage);
    $stateProvider.state(ErrorPage);
    $stateProvider.state(HomePage);
    $stateProvider.state(SelfCarePage);
    $stateProvider.state(EnergyMonitorPage);
    $stateProvider.state(FavoritePage);
    $stateProvider.state(SelfCleanHistoryPage);
    $stateProvider.state(AddFavoritePage);
    $stateProvider.state(CyclePage);
}