// call back from native
function nativeCallback(response) {
    setTimeout(function () {
        var scope = angular.element(document.getElementById("bodyTag")).scope();
        scope.$apply(function () {
            scope.updateDeviceData(response);
        });
    }, 0);
}

var app = angular.module("SmartThings", ['ionic']);

app.constant('STCONST', {
    MAX_TIME_INTERVAL: 20000,
    MIN_TIME_INTERVAL: 1000,
    STATUS_401: 401,
    STATUS_99000: 99000,
    STATUS_MINUS1: -1
});

app.controller("HomeMultiFacRacController", function ($scope, STCONST) {
    var stopVar, initialTime, timeDiff, counter = 0;
    var deviceResponseHomeMulti = '{"type":"requestResponse","status":200,"resourceURL":"/000001_LGL26H5BFNOUOVJ35OMDBJMAEO000/devices","data":{"Devices":[{"description":"14K Memory RAC1","id":"1","Alarms":[{"id":"0","alarmType":"Device","code":"FilterAlarm_OFF","triggeredTime":"2015-08-22T12:39:15"}],"Camera":{"CapturesLink":{"href":"/devices/0/camera/captures"}},"ConfigurationLink":{"href":"/devices/1/configuration"},"Detection":{"motionDetectionInUse":false},"InformationLink":{"href":"/devices/1/information"},"Mode":{"modes":["Auto"],"options":["Comode_Off","Sleep_0","Autoclean_Off","Light_Off","Volume_100","RacOptionCode_1","FilterCleanAlarm_FilterAlarm_OFF","Optioncode_190"],"supportedModes":["Cool","Dry","Wind","CoolClean","DryClean","Auto","Heat","HeatClean"]},"Operation":{"power":"Off"},"Wind":{"direction":"Fix","maxSpeedLevel":4,"speedLevel":0},"connected":true,"name":"Room Air Conditioner 1","resources":["Alarms","Camera","Configuration","Detection","EnergyConsumption","Information","Mode","Operation","Temperatures","Wind"],"type":"Air_Conditioner","uuid":"BC8CCDB5-AA7D-0000-0000-000000000001","Temperatures":[{"id":"0","current":25,"desired":0,"unit":"Celsius"}]},{"description":"14K Memory FAC","id":"0","Alarms":[{"id":"0","alarmType":"Device","code":"FilterAlarm_OFF","triggeredTime":"2015-08-22T12:39:15"}],"Camera":{"CapturesLink":{"href":"/devices/0/camera/captures"}},"ConfigurationLink":{"href":"/devices/0/configuration"},"Detection":{"motionDetectionInUse":false},"EnergyConsumption":{"cumulativeConsumption":100,"usageThreshold":5000},"InformationLink":{"href":"/devices/0/information"},"Mode":{"modes":["Cool"],"options":["Operation_Family","Comode_Off","OnTimer_0","OffTimer_0","Sleep_0","RestWind_Off","Blooming_7","Autoclean_Off","Sterilize_Off","Humidi_Off","Panel_Close","Light_On","Smarton_LockOff","Weather_Off","Volume_66","VoiceSet_Disable","FilterCleanAlarm_FilterAlarm_OFF","OptionCode_190","RacInfo_First","ModelInfo_14K_MEMORY_M1","ReadyForCam_Ready","UpdateAllow_NotAllowed","PanelVerison_1311528","WattNotice_0"],"supportedModes":["Cool","Dry","Wind","CoolClean","DryClean","Auto","Heat","HeatClean"]},"Operation":{"power":"On"},"Wind":{"direction":"Off","maxSpeedLevel":4,"speedLevel":3},"connected":true,"name":"Air Conditioner","resources":["Alarms","Camera","Configuration","Detection","EnergyConsumption","Information","Mode","Operation","Temperatures","Wind"],"type":"Air_Conditioner","uuid":"BC8CCDB5-AA7D-0000-0000-000000000000","Temperatures":[{"id":"0","current":25,"desired":23,"unit":"Celsius"}]}]}}';
    $scope.sampleInitial = '{"type": "initial", "deviceUuid": "BC8CCDB5-AA7D-0000-0000-000000000000", "peerId": "000001_699EH4VDJ071QAMLFABARMQC08000"}';
    $scope.isFACSelected = true;
    var scope = angular.element(document.getElementById("bodyTag")).scope();

    var LANG;
    if (window.navigator.platform === 'iPhone' || window.navigator.platform === 'iPad') {
        LANG = navigator.userLanguage || navigator.language;
    } else {
        LANG = navigator.userAgent;
    }

    var langArr = Object.keys(LANGUAGE_FILE.language);
    if (langArr.indexOf(LANG.toUpperCase())!== -1){
        $scope.translation = LANGUAGE_FILE["language"][LANG.toUpperCase()];
    } else if(langArr.indexOf(LANG.toUpperCase().substring(0,2))!== -1){
        $scope.translation = LANGUAGE_FILE["language"][LANG.toUpperCase().substring(0,2)];
    } else {
        $scope.translation = LANGUAGE_FILE["language"]["DEFAULT"];
    }

    $scope.getDevices = function () {
        nativeInterface.getResourceUrl("/" + $scope.peerId + "/devices");
    };

    // Call back from native
    var response, getDeviceResponse;
    $scope.updateDeviceData = function (data) {
        console.log(data);
        clearInterval(stopVar);
        response = JSON.parse(data);

        if (response["type"] === "requestResponse") {
            if (angular.isDefined(response["status"]) && response["status"] === STCONST.STATUS_99000) {
                $scope.showConnectionFailurePopup();
            }
        }

        if (response["type"] === "requestResponse" && angular.isDefined(response["data"]) && angular.isDefined(response["data"]["Devices"])) {
            getDeviceResponse = response["data"]["Devices"];

            var temp = getDeviceResponse.length - 1;
            if (angular.isDefined(getDeviceResponse[temp]["Mode"]) && angular.isDefined(getDeviceResponse[temp]["Mode"]["options"])) {
                $scope.options = getDeviceResponse[temp]["Mode"]["options"];
                $scope.options.forEach(function (value) {
                    if (value.indexOf("Smarton_") !== -1) {
                        $scope.SmartonLockOff = value.indexOf("Smarton_LockOff") !== -1 ? true : false;
                    }
                });
            }

            if (!$scope.SmartonLockOff) {
                document.getElementById("popupcancel").style.visibility = "hidden";
                $scope.showSmartLockPopup = true;
            } else {
                if (getDeviceResponse.length === 2) {
                    $scope.showFacRacSelectionPopup = true;
                } else if (getDeviceResponse.length === 1) {
                    window.location.assign("fac.html");
                } else {
                    // Nothing
                }
            }

        } else if (response["type"] === "initial" && angular.isDefined(response["peerId"]) && angular.isDefined(response["deviceUuid"])) {
            $scope.peerId = response["peerId"];
            $scope.deviceUuid = response["deviceUuid"];
            if (response["demoMode"]) {
                $scope.isStatic = true;
                $scope.parseStaticData();
            } else {
                $scope.getDevices();

                // 20 seconds handling here
                initialTime = new Date();
                stopVar = setInterval(function () {
                    timeDiff = new Date() - initialTime;
                    if (timeDiff > STCONST.MAX_TIME_INTERVAL) {
                        counter++;
                        if (counter < 2) {
                            initialTime = new Date();
                            scope.getDevices();
                        } else {
                            scope.$apply(function () {
                                scope.showConnectionFailurePopup();
                            });
                            clearInterval(stopVar);
                        }
                    }
                }, STCONST.MIN_TIME_INTERVAL);
            }
        } else if (response["type"] === "notification" && angular.isDefined(response["data"])) {
            if (response["data"] === "backPressed") {
                nativeInterface.runOnNative("closeWebApp", "");
                return;
            }
            if (angular.isDefined(response["data"][0]) && angular.isDefined(response["data"][0]["Device"]) && !response["data"][0]["Device"]["connected"]) {
                $scope.showConnectionFailurePopup();
                return;
            }
        } else if (response["type"] === "connectionerror") {
            $scope.showConnectionFailurePopup();
        } else if (response["type"] === "requestFailed") {
            if (response["status"] === STCONST.STATUS_401 || response["status"] === STCONST.STATUS_MINUS1) {
                // Status 401 is coming when we get message "your token is not allowed"
                $scope.showConnectionFailurePopup();
            }
        } else {
            //SONAR ISSUE
        }
    };

    $scope.onHomeMultiSelect = function (bool) {
        if (bool) {
            $scope.isFACSelected = true;
        } else {
            $scope.isFACSelected = false;
        }
    };

    $scope.onHomeMultiOk = function (bool) {
        $scope.showFacRacSelectionPopup = false;
        if (bool) {
            if ($scope.isFACSelected) {
                nativeInterface.runOnNative("changeDeviceUuid", '{"deviceUuid": "' + getDeviceResponse[1]["uuid"] + '"}');
                window.location.assign("fac.html");

            } else {
                nativeInterface.runOnNative("changeDeviceUuid", '{"deviceUuid": "' + getDeviceResponse[0]["uuid"] + '"}');
                window.location.assign("rac_hm.html");
            }
        } else {
            nativeInterface.runOnNative("closeWebApp", "");
        }
    };

    $scope.smartLockOk = function () {
        nativeInterface.runOnNative("closeWebApp", "");
    };

    $scope.parseStaticData = function () {
        $scope.updateDeviceData(deviceResponseHomeMulti);
    };

    // Connection failure handling
    $scope.showConnectionFailurePopup = function () {
        document.getElementById("connFailCancel").style.visibility = 'hidden';
        $scope.showConnFailurePopup = true;
    };

    $scope.connFailureAction = function () {
        nativeInterface.runOnNative("closeWebApp", "");
    };

    // Close the app
    $scope.closeApp = function () {
        nativeInterface.runOnNative("closeWebApp", "");
    };
});



//ST Functions
var ST_URL = window.location.host;
var nowURL = "graph.api.smartthings.com";
var _stImageUrl = "";
var cWidth, i;
function setBaseFont() {
    if (window.navigator.platform === 'iPhone' || window.navigator.platform === 'iPad') {
        cWidth = window.screen.availWidth;
    } else {
        cWidth = document.body.clientWidth;
    }
    var baseFontSize = (80 * cWidth) / 1440;
    document.getElementById("htmlTag").style.fontSize = baseFontSize + "px";
}
