var Debug_tag = 'RAC : ';
var app = angular.module("SmartThings", ['toaster', 'ngSanitize', 'angularRangeSlider']);

app.controller("RACController", function ($scope, SHPService, EnergyService, ScheduleService, WeatherService, toaster, $timeout, $interval, UtilityService, STCONST) {
    var promise,
    RACCONST = {
        TEMPCHANGE: "TEMPCHANGE",
        COMODE: "COMODE",
        AI: "AI",
        SCHEDULEDATA: "SCHEDULEDATA",
        MODECHANGE: "MODECHANGE",
        WINDSTRENGTH_CHANGE: "WINDSTRENGTH_CHANGE",
        WINDDIRECTION_CHANGE: "WINDDIRECTION_CHANGE",
        POWEROPERATION: "POWEROPERATION",
        GETDEVICES: "getDevices",
        COLOROFWIND: "COLOROFWIND",
        VIRUSDOCTOR: "VIRUSDOCTOR",
        AUTOCLEAN: "AUTOCLEAN",
        FILTERALARMTIME: "FILTER_ALARM_TIME",
        FILTERTIME: "FILTERTIME",
        WINDCOMMAND: "WINDCOMMAND",
        VOLUME_MUTE: "VOLUME_MUTE",
        LIGHTING: "LIGHTING",
        PARSE_MODULEINFO: "PARSE_MODULEINFO",
        FILTER_CLEAN_ALARM: "FILTER_CLEAN_ALARM",
        STATUS_204: 204,
        STATUS_201: 201,
        STATUS_200: 200,
        HOMEMULTI_RAC_VERSION: "AF.1.0.25",
        RAC_VERSION: "AR.1.0.3", 
        SINGLE_RAC: 0,
        HOMEMULTI_RAC: 1,
        DB_RESET: "UsagesDB_reset",
        DIAGNOSIS: "DIAGNOSIS",
        VOL_NOT_SUPPORTED: "Volume_NotSupported",
        MYWIND_KEY: "MyWindList",
        MYWIND_KEY_DEMO: "MyWindListDemo",
        AIWORKSTATUS_ON: "On",
        AIWORKSTATUS_OFF: "Off",
        AIWORKSTATUS_ING: "Ing"
    },
    RACSCREENS = {
        HOME: 1,
        OPTIONS: 2,
        SCHEDULELIST: 3,
        FILTER: 4,
        ADDSCHEDULE: 5,
        SETTINGS: 6,
        ABOUT: 7,
        ENERGYMONITOR: 8,
        MYWINDLIST: 9,
        ADDWIND: 10,
        ERRORPAGE: 11,
        ERRORTEXT: 12,
        SMARTCARE: 13,
        SMARTCAREERROR: 14,
        TUTORIALPAGE: 15,
        DETAILEDTUTORIALPAGE: 16,
        AICOOLLEARNING: 17
    },
    ALERT_STATE = {
        SERVICE_CALL: 1,
        SERVICE_CENTER_SELECTION: 2
    },
    FACCONST = {
        PARSE_CONFIG: "PARSE_CONFIG"
    },
    strCelsius = 'Celsius',
    strFahrenheit = 'Fahrenheit',
    strFix = "Fix",
    strUpNLow = "Up_And_Low",
    strLeftNRight = "Left_And_Right",
    strAll = "All",
    strCool = "Cool",
    strCoolClean = "CoolClean",
    strHeat = "Heat",
    strDry = "Dry", 
    strWind = "Wind", 
    strAuto = "Auto",
    strContainsSub = "containSub",
    strOff = "Off",
    increaseTempConinous = false,
    decreaseTempConinous = false,
    currentWindKey,
    tempFilterStatusShow,
    reqParamCountrySelection;

    //Scope level variable declaration.
    $scope.checkResponse = [];
   
    $scope.countrySelectionPopupVisible = false;
    $scope.countrySelectedIndex = 0;
    $scope.countryToSelect = [];
    $scope.countryToSelect.push({'Country': 'Belgium'});
    $scope.countryToSelect.push({'Country': 'Belgium(F)'});
    
    $scope.arrHeader = ["How to clean the filter"]; //Tutorial arrays
    $scope.arrSubHeader = ["Room A/C"]; //Tutorial arrays
    $scope.arrImages = ["rac"];  //Tutorial arrays
    $scope.ModeSelectionPopupDivCls = '';// Initially no class should be applicable.
    $scope.BottomPopupDivCls = '';// Initially no class should be applicable.
    $scope.BottomPopupDimBackgroundDiv = '';// Initially no class should be applicable.
    $scope.containSubCl = strContainsSub; //initially the class should be present.
    $scope.showSmartLockPopup = false;
    $scope.showGoodSleepPopup = false;
    $scope.showModeSelectionPopup = false;
    $scope.showAddWindModeSelectionPopup = false;
    $scope.showWindStrengthPopup = false;
    $scope.showWindDirectionPopup = false;
    $scope.showColorOfWindPopup = false;
    $scope.dialogPopup = false;
    $scope.alertState = -1;
    $scope.isRadioSelection = false;
    $scope.showServiceCenterText = false;
    $scope.popupTitle = '';
    $scope.popupMessage = '';
    $scope.popupOkBtn = '';
    $scope.popupCancelBtn = '';
    $scope.supportedModes = [];
    $scope.supportedModesIcon = [];
    $scope.supportedWindDirection = [];
    $scope.currentScreen = RACSCREENS.HOME;
    $scope.previousScreen = RACSCREENS.HOME;
    $scope.Actions = [{id: '0', 'Actuators': [{Operation: {power: ''}, deviceIDs: []}], dayOfWeek: [], disposable: false, enabled: true, startTime: ''}];
    $scope.selectedSchedule = {id: '', power: 'On', dayOfWeek: [], disposable: true, hours: 0, minutes: 0, amPm: 0, keypadOn: false};
    $scope.isRunningTimeGraph = false;

    $scope.aiSupported = false;
    $scope.aiEnabled = false;
    $scope.aiActive = '';
    $scope.aiGuideText = '';
    $scope.aiFavorTemp = 0;
    $scope.is_aiConnectionFail = false;
    $scope.aiConnectionFailTimerOn = false;
    $scope.ai401ErrorCount = 0;

    //Function declaration.
    $scope.isEnergySimulatorSupported = isEnergySimulatorSupported;
    $scope.isColorOfWindOn = isColorOfWindOn;
    $scope.closePopup = closePopup;
    $scope.isPopupOpen = isPopupOpen;
    $scope.increaseTemp = increaseTemp;
    $scope.decreaseTemp = decreaseTemp;
    $scope.showUsageHelpPage = showUsageHelpPage;
    $scope.closeUsageHelpPage = closeUsageHelpPage;
    $scope.showOptionPopUp = showOptionPopUp;
    $scope.closeOptionPopUp = closeOptionPopUp;
    $scope.selectIndexFromOptionMenu = selectIndexFromOptionMenu;
    $scope.getScrollableAreaClass = getScrollableAreaClass;
    $scope.getFilterStatusVisibility = getFilterStatusVisibility;
    $scope.isShow_aiConnectionFailPanel = isShow_aiConnectionFailPanel;
    $scope.filterNotificationClose = filterNotificationClose;
    $scope.getModeSelectionPopupClass = getModeSelectionPopupClass;
    $scope.showOptionItemsVisible = showOptionItemsVisible;
    $scope.addSchedule = addSchedule;
    $scope.addWind = addWind;    
    $scope.goToEnergyMonitor = goToEnergyMonitor;
    $scope.scheduleList = scheduleList;
    $scope.parseRequestResponse = parseRequestResponse;    
    $scope.parseNotification = parseNotification;
    $scope.parseRequestAccepted = parseRequestAccepted;
    $scope.callGetDevice = callGetDevice;
    $scope.showConnectionFailurePopup = showConnectionFailurePopup;
    $scope.onBackPressed = onBackPressed;
    $scope.openPopup = openPopup;
    $scope.popupBtnClicked = popupBtnClicked;
    $scope.onRadioBtnSelected = onRadioBtnSelected;
    $scope.increaseGoodSleepHr = increaseGoodSleepHr;
    $scope.increaseGoodSleepMin = increaseGoodSleepMin;
    $scope.isAIStatusOn = isAIStatusOn;
    $scope.isAIStatusIng = isAIStatusIng;
    $scope.getAIGuideText = getAIGuideText;
    $scope.isAICoolLearningEnable = isAICoolLearningEnable;

    var min_yAxes = 15;
    var max_yAxes = 30;
    var min_xAxes = 16;
    var max_xAxes = 38;
    $scope.myChart;
    $scope.ctxGraph = document.getElementById("aiChart");
    
    function localInit() {
        var langArr = Object.keys(LANGUAGE_FILE.language),
            lang = LANG.toUpperCase(),
            strLang = LANG.toUpperCase().substring(0,2);
    
        if (langArr.indexOf(lang)!== -1){
            $scope.translation = LANGUAGE_FILE["language"][lang];
        } else if(langArr.indexOf(strLang)!== -1){
            $scope.translation = LANGUAGE_FILE["language"][strLang];
        } else {
            $scope.translation = LANGUAGE_FILE["language"]["DEFAULT"];
        }
    }
    $scope.selectedLanguage = LANG;
    
    if (window.navigator.platform === 'iPhone' || window.navigator.platform === 'iPad') {
        $scope.isAppleDevice = true;
    } else {
        $scope.isAppleDevice = false;
    }
    
    function parseRequestResponse(response) {
        if (angular.isDefined(response["status"]) && response["status"] === STCONST.STATUS_99000) {
            showConnectionFailurePopup();
        }
        
        if (angular.isDefined(response["data"])) {
            // For home multi specific code
            var device;
            if (angular.isDefined(response["data"]["Devices"])) {
                response["data"]["Devices"].forEach(function (value) {
                    if (value["uuid"] === $scope.deviceUuid) {
                        device = value;
                    }
                });
                if (angular.isDefined(device)) {
                    init();
                    parseDeviceData(device, response.resourceURL);
                } else {
                    showConnectionFailurePopup();
                }
                if (!!!$scope.loadingBar) { // No loading bar means request handled properly. So, clear array.
                    SHPService.clearStopVarArray();
                }
                isCallFromReset = 1;    //Lokesh 16Nov11_1840 -> For energy monitor reset not working first time.
                return;
            }
            if (angular.isDefined(response["data"]["Actions"])) {
                parseActionData(response["data"]["Actions"]);
            }
            if (angular.isDefined(response["data"]["Information"])) {
                parseModuleInformation(response["data"]["Information"]);
            }
            if (angular.isDefined(response["data"]["Configuration"])) {
                parseConfiguration(response["data"]["Configuration"]);
                if(!$scope.isStatic && $scope.aiSupported) {
                    getTrainingAIInfo();
                }

            }
            if (angular.isDefined(response["data"]["getTrainingDate"])) {
                if (angular.isDefined(response["status"]) && response["status"] >= 200 && response["status"] <= 300) {
                    parseGetTrainingDate(response["data"]["getTrainingDate"]);
                } else {
                    //show 'Server connection Failed.' notification.
                    parseGetTrainingDate(response["data"]["getTrainingDate"]);
                    if(angular.isDefined(response["status"]) && response["status"] == 401){
                        $scope.ai401ErrorCount++;
                    }
                    if($scope.ai401ErrorCount == 2){
                        console.log("retry for 401 error");
                        getTrainingAIInfo();
                    }
                    else if($scope.ai401ErrorCount > 2 || $scope.ai401ErrorCount == 0) {
                        if (!$scope.is_aiConnectionFail) {
                            console.log("show error");
                            $scope.is_aiConnectionFail = true;
                            $scope.aiConnectionFailTimerOn = true;
                            $timeout(function () {
                                $scope.aiConnectionFailTimerOn = false;
                            }, 3000);
                        }
                    }
                }
            }
        }
        if (angular.isDefined(response["resourceURL"])) {
            if (response["resourceURL"].indexOf("files") != -1) {
                $scope.isDBDownloaded = true;
                isDBDownloadedJS = true;
                if (isCallFromReset === 2) {
                    $scope.loadingBar = false;
                    isCallFromReset = 1;
                    goToEnergyMonitor();
                }
            }
            if (angular.isDefined(response["data"])) {
                if (!angular.isDefined(response["data"]["Actions"]) && (response["resourceURL"].indexOf("/actions/") !== -1 || response["resourceURL"].indexOf("/actions") !== -1)) {
                    if (angular.isDefined(response["status"]) && response["status"] === STCONST.STATUS_99000) {
                        // Nothing
                    } else {
                        scheduleList(true);
                    }                    
                }                    
            } else {
                if (response["resourceURL"].indexOf("/undefined/") !== -1 || response["resourceURL"].indexOf("/undefined") !== -1) {
                    return;
                }
                if (response["resourceURL"].indexOf("/actions/") !== -1 || response["resourceURL"].indexOf("/actions") !== -1) {
                    if (angular.isDefined(response["status"]) && response["status"] === STCONST.STATUS_99000) {
                        // Nothing
                    } else {
                        scheduleList(true);
                    }                    
                }
            }
        }
        if (response.status >= 200 && response.status < 300) { //<300 is succes only. Refer http://www.w3.org/Protocols/rfc2616/rfc2616-sec10.html for status code definitions.
            handleStatusCode(response.status, response);
        }
    }
    
    function parseNotification(response) {
        if (angular.isDefined(response["softKeypadVisibility"])) {
            onKeypadShown(false);
        }
        if (angular.isDefined(response["data"])) {
            if (response["data"] === "backPressed") {
                //if loding bar visible, don't handle back key
                if (!!!$scope.loadingBar) {
                    onBackPressed();
                }
                return;
            }
            if (angular.isDefined(response["data"]["mobileTimeChanged"])){
                return;
            }
            if (angular.isDefined(response["data"].isApplicationActive) && !$scope.isStatic) {
                callGetDevice();
                return;
            }
            if (angular.isDefined(response["data"][0]) && angular.isDefined(response["data"][0]["Device"]) && angular.isDefined(response["data"][0]["Device"]["scsConnectionState"])) {
                if (!response["data"][0]["Device"]["scsConnectionState"]) {
                    showConnectionFailurePopup();
                } else if (response["data"][0]["Device"]["scsConnectionState"]) {
                    closeConnectionFailurePopup();                        
                    callGetDevice();
                }
                return;
            }
            if(response["data"] instanceof Array) {
                response["data"].forEach(function (value) {
                    parseDeviceData(value);
                });
            } else {
                parseDeviceData(response["data"]);
            }
        }
    }

    $scope.aiGraphData = {};
    function parseGetTrainingDate(trainingDate) {
        console.log("parseGetTrainingDate", trainingDate);
        $scope.trainingHistoryData = [];
        $scope.predictionData = undefined;

        var mode = trainingDate["mode"];//.toLowerCase();
        if (angular.isDefined(mode)) {
            $scope.aiGraphData[mode] = trainingDate;
        } else {
            //error data
            if (angular.isUndefined($scope.aiGraphData["error"]))
                $scope.aiGraphData["error"] = [];
            $scope.aiGraphData["error"].push(trainingDate);
        }
        dismissLoadingBar("getTrainingDate");
        $scope.createNewChart();
    }
    
    function parseRequestAccepted(response){
        if (angular.isDefined(response["data"]) && angular.isDefined(response["data"]["energyData"])) {
            $scope.parseEnergyUsageData(response["data"]);
        }
    }
    
    function callGetDevice() {
        SHPService.getDevices($scope);
    }

    // Toggle class for body
    function toggleAnimClass() {
        if ($scope.containSubCl === strContainsSub) {
            $scope.containSubCl = "";
        } else {
            $scope.containSubCl = strContainsSub;
        }
    }
    
    //Tutorial code start
    this.playVideo = function(ind){ 
        
        $scope.currentScreen = RACSCREENS.DETAILEDTUTORIALPAGE;
        $scope.changeScreen();
      
        $scope.videoPopup = ind;
        document.getElementById("vid").src = "https://s3.amazonaws.com/smartthingsda/solutionmodule/tutorial/cleanfilter.mp4";
    }; 
    //Tutorial code end

    // Toggle class for Mode drop down
    function changePopUpClass() {
        if ($scope.showModeSelectionPopup) {
            $scope.ModeSelectionPopupDivCls = "ModeSelectionPopupDiv";
        } else {
            $scope.ModeSelectionPopupDivCls = "ModeSelectionPopOutDiv";
        }
    }

    // Toggle class for Mode drop down
    function toggleBottomPopUpClass(popupName) {
        if (popupName) {
            $scope.BottomPopupDimBackgroundDiv = "BottomPopupDimBackgroundDivIn";
            $scope.BottomPopupDivCls = "BottomPopupBGIn";
        } else {
            $scope.BottomPopupDimBackgroundDiv = "BottomPopupDimBackgroundDivOut";
            $scope.BottomPopupDivCls = "BottomPopupBGOut";
        }
    }

    function closePopup(popup) {
        $scope[popup] = false;
        toggleBottomPopUpClass($scope[popup]);
    }

    $scope.$watch('currentWindStrength'
    , function (newVal, oldVal) {
        if (newVal !== oldVal && angular.isDefined($scope.currentWindStrength)) {
            $scope.getWindStrengthImage($scope.currentWindStrength);
        }
    });

    $scope.$watch('currentWindDirection', function (newVal, oldVal) {
        if (newVal !== oldVal && angular.isDefined($scope.currentWindDirection)) {
            $scope.getWindDirectionImage($scope.currentWindDirection);
        }
    });

    // Control hours value in add schedule screen    
    $scope.$watch(function () {
        return $scope.selectedSchedule.hours;
    }, function (newVal, oldVal) {
        if (newVal > 12) {
            $scope.selectedSchedule.hours = oldVal;
        }
        if (newVal === undefined) {
            $scope.selectedSchedule.hours = oldVal;
        }
    });

    // Control minutes value in add schedule screen
    $scope.$watch(function () {
        return $scope.selectedSchedule.minutes;
    }, function (newVal, oldVal) {
        if (newVal > 59) {
            $scope.selectedSchedule.minutes = oldVal;
        }
        if (newVal === undefined) {
            $scope.selectedSchedule.minutes = oldVal;
        }
    });

    $scope.onHoursLostFocus = function () {
        $scope.inputFocusHoursMin = false;
        if ($scope.selectedSchedule.hours === "0" || $scope.selectedSchedule.hours === "00") {
            $scope.selectedSchedule.hours = 12;
        }
        if ($scope.selectedSchedule.hours === "") {
            $scope.selectedSchedule.hours = $scope.oldValueHours;
        }
        $scope.selectedSchedule.hours = Number($scope.selectedSchedule.hours);
        $scope.selectedSchedule.hours = ($scope.selectedSchedule.hours < 10) ? ('0' + $scope.selectedSchedule.hours) : $scope.selectedSchedule.hours;
    };

    $scope.onMinsLostFocus = function () {
        $scope.inputFocusHoursMin = false;
        if ($scope.selectedSchedule.minutes === "") {
            $scope.selectedSchedule.minutes = $scope.oldValueMins;
        }
        $scope.selectedSchedule.minutes = Number($scope.selectedSchedule.minutes);
        $scope.selectedSchedule.minutes = ($scope.selectedSchedule.minutes < 10) ? ('0' + $scope.selectedSchedule.minutes) : $scope.selectedSchedule.minutes;
    };

    $scope.onHoursMinsFocusGain = function () {
        $scope.oldValueHours = $scope.selectedSchedule.hours;
        $scope.oldValueMins = $scope.selectedSchedule.minutes;
        if (!$scope.isAppleDevice) {
            $scope.inputFocusHoursMin = true;
            setTimeout(function() {
                document.activeElement.scrollIntoView();
            }, 10);
        }
    };

    // Array items for all popups    
    $scope.listOfModes =
            [{
                    id: 1,
                    imageID: 'FAC/assets/img/main_drop_list_ic_cool.svg#Layer_1',
                    modeName: strCool,
                    textToDisplay: "RACMOB_ac_mode_cool"
                }, {
                    id: 2,
                    imageID: 'FAC/assets/img/main_drop_list_ic_dry.svg#Layer_1',
                    modeName: strDry,
                    textToDisplay: "RACMOB_ac_mode_dry"
                }, {
                    id: 4,
                    imageID: 'FAC/assets/img/main_drop_list_ic_heat.svg#Layer_1',
                    modeName: strHeat,
                    textToDisplay: "RACMOB_ac_mode_heat"
                }, {
                    id: 0,
                    imageID: 'FAC/assets/img/main_drop_list_ic_auto.svg#Layer_1',
                    modeName: strAuto,
                    textToDisplay: "RACMOB_ac_mode_auto"
                }, {
                    id: 3,
                    imageID: 'FAC/assets/img/main_drop_list_ic_purifiy.svg#Layer_1',
                    modeName: strWind,
                    textToDisplay: "WEBMOB_device_rac_mode_purify"
                }, {
                    id: 5,
                    imageID: 'FAC/assets/img/main_drop_list_ic_cool_purify_selected.svg#Layer_1',
                    modeName: "CoolClean",
                    textToDisplay: "WEBMOB_device_rac_mode_cool_purify"
                }, {
                    id: 6,
                    imageID: 'FAC/assets/img/main_drop_list_ic_dry_purify_selected.svg#Layer_1',
                    modeName: "DryClean",
                    textToDisplay: "WEBMOB_device_rac_mode_dry_purify"
                }, {
                    id: 7,
                    imageID: 'FAC/assets/img/main_drop_list_ic_heat_purify_selected.svg#Layer_1',
                    modeName: "HeatClean",
                    textToDisplay: "WEBMOB_device_rac_mode_heat_purify"
                }];
    $scope.listWindStrength =
            [{
                    id: 0,
                    imageID: 'FAC/assets/img/main_list_ic_wind_auto.svg#Layer_1',
                    modeName: strAuto,
                    textToDisplay: "RACMOB_wind_level_auto"
                }, {
                    id: 1,
                    imageID: 'FAC/assets/img/main_list_ic_wind_low.svg#Layer_1',
                    modeName: "Low",
                    textToDisplay: "RACMOB_wind_level_low"
                }, {
                    id: 2,
                    imageID: 'FAC/assets/img/main_list_ic_wind_medium.svg#Layer_1',
                    modeName: "Medium",
                    textToDisplay: "RACMOB_wind_level_medium"
                }, {
                    id: 3,
                    imageID: 'FAC/assets/img/main_list_ic_wind_high.svg#Layer_1',
                    modeName: "High",
                    textToDisplay: "RACMOB_wind_level_high"
                }, {
                    id: 4,
                    imageID: 'FAC/assets/img/main_list_ic_wind_turbo.svg#Layer_1',
                    modeName: "Turbo",
                    textToDisplay: "RACMOB_wind_level_turbo"
                }];
    $scope.listWindDirection =
            [{
                id: 1,
                imageID: 'FAC/assets/img/main_list_ic_fix.svg#Layer_1',
                modeName: "Fix",
                textToDisplay: "RACMOB_wind_direction_fix"
            }, {
                id: 2,
                imageID: 'FAC/assets/img/main_list_ic_all_swing.svg#Layer_1',
                modeName: "All",
                textToDisplay: "RACMOB_wind_direction_all"
            }, {
                id: 3,
                imageID: 'FAC/assets/img/main_list_ic_vertical_swing.svg#Layer_1',
                modeName: "Up_And_Low",
                textToDisplay: "RACMOB_wind_direction_vertical"
            }, {
                id: 4,
                imageID: 'FAC/assets/img/main_list_ic_horizontal_swing.svg#Layer_1',
                modeName: "Left_And_Right",
                textToDisplay: "RACMOB_wind_direction_horizontal"
            }];

    // List of color of wind
    $scope.ListOfColorWind =
            [{
                key: strOff,
                textToDisplay: "WEBMOB_common_off"
            }, {
                key: "Alps",
                textToDisplay: "RACMOB_cow_alps"
            }, {
                key: "Florida",
                textToDisplay: "RACMOB_cow_florida"
            }, {
                key: "Serengeti",
                textToDisplay: "RACMOB_cow_serengeti"
            }];

    // List of default data
    $scope.defaultConfig = {
        Auto: {
            configTempLow: 16,
            configTempHigh: 30,
            configTempDefault: 24,
            configWindStrength: 0,
            configWindDirection: "Fix"
        },
        Cool: {
            configTempLow: 16,
            configTempHigh: 30,
            configTempDefault: 18,
            configWindStrength: 3,
            configWindDirection: "Fix"
        },
        Dry: {
            configTempLow: 18,
            configTempHigh: 30,
            configTempDefault: 24,
            configWindStrength: 1,
            configWindDirection: "Fix"
        },
        Heat: {
            configTempLow: 16,
            configTempHigh: 30,
            configTempDefault: 24,
            configWindStrength: 0,
            configWindDirection: "Fix"
        },
        Wind: {
            configTempLow: 16,
            configTempHigh: 30,
            configTempDefault: 24,
            configWindStrength: 2,
            configWindDirection: "Fix"
        },
        "CoolClean": {
            "configTempLow": 16,
            "configTempHigh": 30,
            "configTempDefault": 18,
            "configWindStrength": 3,
            "configWindDirection": "Fix"
        },
        "HeatClean": {
            "configTempLow": 16,
            "configTempHigh": 30,
            "configTempDefault": 24,
            "configWindStrength": 0,
            "configWindDirection": "Fix"
        },
        "DryClean": {
            "configTempLow": 18,
            "configTempHigh": 30,
            "configTempDefault": 24,
            "configWindStrength": 1,
            "configWindDirection": "Fix"
        }
    };

    $scope.optimusTime = [{
            value: 180
        }, {
            value: 300
        }, {
            value: 500
        }, {
            value: 700
        }];

    $scope.Device = {
        Alarms: [{
                alarmType: '',
                code: '',
                id: '',
                triggeredTime: ''
            }]
    };

    //power button
    $scope.powerOnOff = function () {
        if (!$scope.isStatic) {
            $scope.checkResponse.push(RACCONST.POWEROPERATION);
            if ($scope.powerOperation) {
                SHPService.sendSHPCommand(CONSTANTS.PUT, getPowerCommand($scope.powerOperation), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
            } else {
                SHPService.sendSHPCommand(CONSTANTS.PUT, getPowerCommand($scope.powerOperation), "/" + $scope.peerId + "/devices/" + $scope.deviceID + "/operation");
            }
        } else {
            $scope.powerOperation = !$scope.powerOperation;
        }
    };
   
    // Temperature controller start here
    function increaseTemp() {
    	//add parseInt to prevent the case that temp is updated in String like "081"  => change 08 as int and +1 -> 9
        canIncreaseTemp($scope.desiredTemp) && updateTemp(parseInt($scope.desiredTemp,10) + 1);
    }
    
    function decreaseTemp() {
        canDecreaseTemp($scope.desiredTemp) && updateTemp(parseInt($scope.desiredTemp,10) - 1);
    }
    
    function canIncreaseTemp(temp, diff) {
        var tempDesiredTemp = parseInt(temp, 10);
        tempDesiredTemp -= (diff || 0);
        var returnVal = (!$scope.disableTempControl && ((isHomeMultiRAC() 
                && tempDesiredTemp < $scope.defaultConfig[$scope.currentMode].configTempHigh)
                || (isSingleRAC() && tempDesiredTemp < $scope.singleRACMaxTemp)));
        return returnVal;
    }
    
    function canDecreaseTemp(temp, diff) {
         var tempDesiredTemp = parseInt(temp, 10);
         tempDesiredTemp += (diff || 0);
        var returnVal = (!$scope.disableTempControl && !!!$scope.disableTempDec 
                    && ((isHomeMultiRAC() 
                    && ($scope.smartSensor ? tempDesiredTemp > 24 : tempDesiredTemp > $scope.defaultConfig[$scope.currentMode].configTempLow))
                    || (isSingleRAC() 
                    && tempDesiredTemp > $scope.singleRACMinTemp)));
        return returnVal;
    }
    
    //While long press, changingDesiredTemp value is changing (not real desired temp value. real desired temp value is set after get notification from device)
    function changeTempOnTouch(isIncreasing) {
        var elem = document.getElementById("tempDisp");
        if (isIncreasing && canIncreaseTemp($scope.changingDesiredTemp)) {
            $scope.changingDesiredTemp = +$scope.changingDesiredTemp + 1;
            $scope.changingDesiredTemp = ($scope.changingDesiredTemp < 10 ? '0' : '') + $scope.changingDesiredTemp;
            elem.innerHTML = $scope.changingDesiredTemp;
        } else if (!isIncreasing && canDecreaseTemp($scope.changingDesiredTemp)){
            $scope.changingDesiredTemp = +$scope.changingDesiredTemp - 1;
            $scope.changingDesiredTemp = ($scope.changingDesiredTemp < 10 ? '0' : '') + $scope.changingDesiredTemp;
            elem.innerHTML = $scope.changingDesiredTemp;            
        }
    }
    
  //temp = destination temp. desiredTemp is changed when get notification . not this time.
    function updateTemp(temp) {
        if (!$scope.isStatic) {
            $scope.checkResponse.push(RACCONST.TEMPCHANGE);
            SHPService.sendSHPCommand(CONSTANTS.PUT, getTempCommand($scope.currentMode, temp, 0), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
            $scope.defaultConfig[$scope.currentMode].configTempDefault = temp;

            if (temp >= $scope.outDoorTemp) {
                // Nothing
            } else {
                doEnergySimulator(temp);
            }
        } else {
            $scope.desiredTemp = temp;
        }
    }
    
    //when long click starts, add new var : changingDesiredTemp (It is the temp value in screen.) . set this value as current desired temp.
    // when long press finish, send command using changingDesiredTemp. 
    $scope.setIncreaseTempOnTouchStart = function() {
    	$scope.changingDesiredTemp = $scope.desiredTemp;
        if (!!!promise) {
            promise = $interval(function () {
                if (canIncreaseTemp($scope.changingDesiredTemp)) {
                    increaseTempConinous = true;
                    changeTempOnTouch(true);
                }
            }, 300);
        }
    };   
    
    $scope.setDecreaseTempOnTouchStart = function() {
    	$scope.changingDesiredTemp = $scope.desiredTemp;
        if (!!!promise) {
            promise = $interval(function () {
                if (canDecreaseTemp($scope.changingDesiredTemp)) {
                    decreaseTempConinous = true;
                    changeTempOnTouch(false);
                }
            }, 300);
        }
    };  
    // Temperature controller end here

    /* Energy Monitor */
    $scope.getYAxisValue = EnergyService.getYAxisValue;

    $scope.showDailyData = function () {
        EnergyService.showDailyData($scope);
    };

    $scope.showWeeklyData = function () {
        EnergyService.showWeeklyData($scope);
    };

    $scope.showMonthlyData = function () {
        EnergyService.showMonthlyData($scope);
    };

    $scope.showNextDaysData = function () {
        EnergyService.showNextDaysData($scope);
    };

    $scope.showPreviousDaysData = function () {
        EnergyService.showPreviousDaysData($scope);
    };

    $scope.fetchDBfromDevice = function () {
        if (!$scope.isStatic) {
            nativeInterface.getResourceUrl("/" + $scope.peerId + $scope.energyMonitorLocation);
        }
    };
    function sendResetCommand() {
        if (!$scope.isStatic) {
//            $scope.checkResponse.push(RACCONST.DB_RESET); //Lokesh 16Nov15_2124 -> Commented for Energy Monitor Reset.
            SHPService.sendSHPCommand(CONSTANTS.PUT, getResetCommand(), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
        }
    }
    $scope.parseEnergyUsageData = function (energyResponse) {
        EnergyService.parseEnergyUsageData($scope, energyResponse);
    };
    $scope.handleEnergyMonitorErrors = function () {
        toaster.clear();
        $timeout(function () {
            toaster.success({title: "", body: $scope.translation.WEBMOB_common_no_data, bodyOutputType: 'trustedHtml'});
        }, 500);
        
    };
    function isEnergyReset() {
        return true;
    }
    // Device commands start
    // //*********** command for Energy monitor RESET

    function getResetCommand()
    {
        return '{"Device":{"Mode":{"options":["UsagesDB_reset"]}}}';
    }
    //(For wind mode, don't not send temperature and temp control is disabled)
    function getModeCommand(mode, c_direction, c_speedlevel, c_defaultTemp, currentWindDirection) {
        // If nano wind is ON, then we should send comode nano, direction fix, speed level 0
        if ($scope.nanoWind && mode !== "Auto" && mode !== "Heat" && mode !== "HeatClean") {
            return '{"Device":{"Mode":{"modes":["' + mode + '"],"options":["Comode_Nano"]},"Wind":{"direction":"Fix","speedLevel":0},"Temperatures":[{"id":"0","desired":' + c_defaultTemp + '}]}}';
        } else {
            var isComodeNano = "Comode_Off";
            if (mode === strWind) {
                return '{"Device":{"Mode":{"modes":["' + mode + '"],"options":["'+ isComodeNano +'"]},"Wind":{"direction":"' + c_direction + '","speedLevel":' + c_speedlevel + '}}}';
            } else if (mode === strAuto) {
                if (currentWindDirection === "Up_And_Low") {
                    return '{"Device":{"Mode":{"modes":["Auto"],"options":["'+ isComodeNano +'"]},"Wind":{"direction":"Fix","speedLevel":0},"Temperatures":[{"id":"0","desired":' + c_defaultTemp + '}]}}';
                } else if (currentWindDirection === "All") {
                    return '{"Device":{"Mode":{"modes":["Auto"],"options":["'+ isComodeNano +'"]},"Wind":{"direction":"Left_And_Right","speedLevel":0},"Temperatures":[{"id":"0","desired":' + c_defaultTemp + '}]}}';
                } else {
                    return '{"Device":{"Mode":{"modes":["Auto"],"options":["'+ isComodeNano +'"]},"Wind":{"direction":"' + c_direction + '","speedLevel":0},"Temperatures":[{"id":"0","desired":' + c_defaultTemp + '}]}}';
                }
            } else if (mode === strDry) {
                return '{"Device":{"Mode":{"modes":["Dry"],"options":["'+ isComodeNano +'"]},"Wind":{"direction":"' + c_direction + '","speedLevel":0},"Temperatures":[{"id":"0","desired":' + c_defaultTemp + '}]}}';
            } else { // Cool, Heat mode
                return '{"Device":{"Mode":{"modes":["' + mode + '"],"options":["'+ isComodeNano +'"]},"Wind":{"direction":"' + c_direction + '","speedLevel":' + c_speedlevel + '},"Temperatures":[{"id":"0","desired":' + c_defaultTemp + '}]}}';
            }
        }
    }

    function getTempCommand(mode, tempValue, tempId) {
    	//add parseInt to prevent the case that temp is sent as 08 => we should send 8 as integer.
        return '{"Device":{"Mode":{"modes":["' + mode + '"]},"Temperatures":[{"id":"' + tempId + '","desired":' +  parseInt(tempValue , 10) + '}]}}';
    }

    function getPowerCommand(status) {
        if (status) {
            return '{"Device":{"Mode":{"options":["Comode_Off"]},"Operation":{"power":"Off"}}}';
        } else {
            return '{"Operation": {"power": "On"}}';
        }
    }

    function getWindStrengthCommand(speedLevel) {
        return '{"Device":{"Wind":{"speedLevel":' + speedLevel + '}}}';
    }

    function getWindDirectionCommand(windDirection) {
        if ($scope.nanoWind) {
            return '{"Device":{"Mode":{"options":["Comode_Off"]},"Wind":{"direction" : "' + windDirection + '"}}}';
        }
        return '{"Device":{"Wind":{"direction" : "' + windDirection + '"}}}';
    }

    function getAutoCleanCommand(autoClean) {
        if (autoClean) {
            return '{"Mode":{"options":["Autoclean_Off"]}}';
        } else {
            return '{"Mode":{"options":["Autoclean_On"]}}';
        }
    }

    function getVolumeMuteCommand(bool) {
        if (bool) {
            return '{"Mode":{"options":["Volume_100"]}}';
        } else {
            return '{"Mode":{"options":["Volume_Mute"]}}';
        }
    }

    function getLightCommand(light) {

        //this is for home multi RAC. Not sure for single RAC. Need to check.
        return '{"Device":{"Mode":{"options":["Light_' + (light ? 'On' : 'Off') + '"]}}}';
    }

    function getFilterClearAlarmCommand(bool) {
        if (bool) {
            return '{"Device":{"Mode":{"options":["FilterCleanAlarm_FilterAlarm_OFF"]}}}';    //As per Mr. Kim, FilterCleanAlarm_0 changed to FilterCleanAlarm_FilterAlarm_OFF.
        }
    }

    function getVirusDoctorCommand(bool) {
        if (bool) {
            return '{"Mode":{"options":["Spi_Off"]}}';
        } else {
            return '{"Mode":{"options":["Spi_On"]}}';
        }
    }

    function getSmartSensorCommand(smartOperation) {
        if (smartOperation) {
            return '{"Device":{"Mode":{"options":["Comode_Off"]}}}';
        } else {
            if ($scope.desiredTemp < 24) {
                return '{"Device":{"Mode":{"options":["Comode_Smart"]},"Wind":{"direction":"Up_And_Low"},"Temperatures":[{"id":"0","desired":24}]}}';
            } else {
                return '{"Device":{"Mode":{"options":["Comode_Smart"]},"Wind":{"direction":"Up_And_Low"}}}';
            }            
        }
    }

    $scope.getAICommand = function (aiEnabled) {
        if (aiEnabled) {
            return '{"Device":{"Mode":{"options":["AI_Disable"]}}}';
        } else {
            return '{"Device":{"Mode":{"options":["AI_Enable"]}}}';
        }
    };
    
    function getNanoWindCommand(bool) {
        var command;
        if (bool) {
            var comode = "Comode_Off";
            if (is17KModel() && $scope.goodSleep) {
                comode = "Comode_Sleep";
            }
            command = '{"Device":{"Mode":{"options":["' + comode + '"]},"Wind":{"direction":"Fix"}}}';
        } else {
            var comode = "Comode_Nano";
            if (is17KModel() && $scope.goodSleep) {
                comode = "Comode_NanoSleep";
            }
            command = '{"Device":{"Mode":{"options":["' + comode + '"]},"Wind":{"direction":"Fix","speedLevel":0}}}';
        }
        return command;
    }

    function getStepCoolingCommand(bool) {
        if (bool) {
            return '{"Device":{"Mode":{"options":["Comode_Off"]}}}';
        } else {
            return '{"Device":{"Mode":{"options":["Comode_2Step"]},"Wind":{"direction":"Fix","speedLevel":0}}}';
        }
    }

    function getFastTurboCommand(bool) {
        if (bool) {
            return '{"Device":{"Mode":{"options":["Comode_Off"]}}}';
        } else {
            return '{"Device":{"Mode":{"options":["Comode_Speed"]},"Wind":{"direction":"Fix","speedLevel":0}}}';
        }
    }

    function getComfortCommand(bool) {
        if (bool) {
            return '{"Device":{"Mode":{"options":["Comode_Off"]}}}';
        } else {
            //Lokesh 19Nov15_1806 -> As per Mr. Kim, according to new spec, for Home Multi RAC, speedLevel should be 0.
            return '{"Device":{"Mode":{"options":["Comode_Comfort"]},"Wind":{"direction":"Fix","speedLevel":' + (isSingleRAC() ? 1 : 0) + '}}}';
        }
    }

    function getDlightCommand(bool, currentWindDirection) {
        if (bool) {
            return '{"Device":{"Mode":{"options":["Comode_Off"]}}}';
        } else {
            if (currentWindDirection === "Up_And_Low" || currentWindDirection === "Fix") {
                return '{"Device":{"Mode":{"options":["Comode_DlightCool"]},"Wind":{"direction":"Up_And_Low","speedLevel":0}}}';
            } else {
                return '{"Device":{"Mode":{"options":["Comode_DlightCool"]},"Wind":{"direction":"All","speedLevel":0}}}';
            }
        }
    }

    function getSingleUserCommand(bool, currentMode, desiredTemp, currentWindDirection) {
        //Lokesh 03Dec15_1453 -> No time to test below code. Hence, commented.
        var thresholdTemp = getThresholdTemp(),
                returnVal = {Device:{Mode:{options:["Comode_Off"]}}};;
        if (!bool) {
            returnVal.Device.Mode.options[0] = "Comode_Smart";
            switch(currentWindDirection) {
                case strFix:
                    returnVal.Device.Wind = {direction:strUpNLow};
                    break;
                    
                case strLeftNRight:
                    returnVal.Device.Wind = {direction:strAll};
                    break;
                default:
                    break;
            }
            
            if(currentMode === strCool && desiredTemp < thresholdTemp) {
                $scope.defaultConfig.Cool.configTempDefault = thresholdTemp;
                returnVal.Device.Temperatures = [{id:"0",desired:thresholdTemp,unit: $scope.temperatureUnit}];
            }
        }
        return JSON.stringify(returnVal);
    }

    function getThresholdTemp() {
        //The value need to be hard coded. The set doesn't send threshold values to us. Same as native, as per Ms. Jihee Jang.
        return ($scope.temperatureUnit === strCelsius ? 24 : 76);
    }

    function getQuietCommand(bool) {
        if (bool) {
            return '{"Device":{"Mode":{"options":["Comode_Off"]}}}';
        } else {
            return '{"Device":{"Mode":{"options":["Comode_Quiet"]},"Wind":{"speedLevel":0}}}';
        }
    }

    function getGoodSleepCommand(sleepTime) {
        var goodSleepCommand;
        if (!!sleepTime) { // in case of 0, send comode_off command. i.e. turn off good sleep.
            var comode = "Comode_Sleep";
            if (is17KModel() && $scope.nanoWind) {
                comode = "Comode_NanoSleep";
            }
            goodSleepCommand = '{"Device":{"Mode":{"options":["' + comode + '","Sleep_' + sleepTime + '"]},"Wind":{"direction":"Fix"}}}';
        } else {
            var comode = "Comode_Off";
            if (is17KModel() && $scope.nanoWind) {
                comode = "Comode_Nano";
            }
            goodSleepCommand = '{"Device":{"Mode":{"options":["' + comode + '"]}}}';
        }
        return goodSleepCommand;
    }

    function getColorWindCommand(value) {
        if (value === strOff) {
            return '{"Device":{"Mode":{"options":["Comode_Off"]}}}';
        } else {
            return '{"Device":{"Mode":{"options":["Comode_' + value + '"]},"Wind":{"speedLevel":0}}}';
        }
    }

    function getFilterOptimusTimeCommand(value) {
        return '{"Device":{"Mode":{"options":["FilterAlarmTime_' + value + '"]}}}';
    }

    function getFilterResetCommand() {
        return '{"Device":{"Mode":{"options":["FilterCleanAlarm_Clear"]}}}';
    }
    
    function getDiagnosisCommand() {
        return '{"Diagnosis": {"diagnosisStart": "Run"}}';
    }
    
    function serviceCallCommand(centerNumber){
        var payload = '{"selectedCountry" : "' + $scope.selectedCountry + '","selectedDial" :"'+centerNumber+'"}';
        nativeInterface.runOnNative("callDial", payload);
    }
    // Device command end

    $scope.onAIEnable = function(){
        if (!$scope.isStatic) {
            $scope.checkResponse.push(RACCONST.AI);
            SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getAICommand($scope.aiEnabled), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
        } else {
            $scope.aiEnabled = !$scope.aiEnabled;
        }
    }

    $scope.onOptionsUpdate = function (id) {
        $timeout(function () {
            switch (id) {
                case "stepcooling":
                    if (!$scope.isStatic) {
                        $scope.checkResponse.push(RACCONST.COMODE);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, getStepCoolingCommand($scope.stepcooling), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
                    } else {
                        $scope.stepcooling = !$scope.stepcooling;
                    }
                    $scope.optionStepCooling = false;
                    break;
                case "fastturbo":
                    if (!$scope.isStatic) {
                        $scope.checkResponse.push(RACCONST.COMODE);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, getFastTurboCommand($scope.fastturbo), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
                    } else {
                        $scope.fastturbo = !$scope.fastturbo;
                    }
                    $scope.optionFastTurbo = false;
                    break;
                case "comfort":
                    if (!$scope.isStatic) {
                        $scope.checkResponse.push(RACCONST.COMODE);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, getComfortCommand($scope.comfort), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
                    } else {
                        $scope.comfort = !$scope.comfort;
                    }
                    $scope.optionComfort = false;
                    break;
                case "dlightcool":
                    if (!$scope.isStatic) {
                        $scope.checkResponse.push(RACCONST.COMODE);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, getDlightCommand($scope.dlightcool, $scope.currentWindDirection), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
                    } else {
                        $scope.dlightcool = !$scope.dlightcool;
                    }
                    $scope.optionDlightCool = false;
                    break;
                case "singleuser":
                    if (!$scope.isStatic) {
                        $scope.checkResponse.push(RACCONST.COMODE);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, getSingleUserCommand($scope.singleuser, $scope.currentMode, parseInt($scope.desiredTemp, 10), $scope.currentWindDirection), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
                    } else {
                        $scope.singleuser = !$scope.singleuser;
                    }
                    break;
                case "quiet":
                    if (!$scope.isStatic) {
                        $scope.checkResponse.push(RACCONST.COMODE);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, getQuietCommand($scope.quiet), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
                    } else {
                        $scope.quiet = !$scope.quiet;
                    }
                    $scope.optionQuiet = false;
                    break;
                case "virusdoctor":
                    if (!$scope.isStatic) {
                        $scope.checkResponse.push(RACCONST.VIRUSDOCTOR);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, getVirusDoctorCommand($scope.virusdoctor), "/" + $scope.peerId + "/devices/" + $scope.deviceID + "/mode");
                    } else {
                        $scope.virusdoctor = !$scope.virusdoctor;
                    }
                    $scope.optionVirusDoctor = false;
                    break;
                case "smartSensor":
                    if (!$scope.isStatic) {
                        $scope.checkResponse.push(RACCONST.COMODE);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, getSmartSensorCommand($scope.smartSensor), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
                    } else {
                        $scope.smartSensor = !$scope.smartSensor;
                    }
                    break;
                case "nanoWind":
                    if (!$scope.isStatic) {
                        if (!$scope.disableNanoWindOption) {
                            $scope.checkResponse.push(RACCONST.COMODE);
                            SHPService.sendSHPCommand(CONSTANTS.PUT, getNanoWindCommand($scope.nanoWind), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
                        }
                    } else {
                        $scope.nanoWind = !$scope.nanoWind;
                    }
                    break;
                default:
                    break;
            }            
        }, MATERIAL_DESIGN.TOGGLE_TIME);        
    };
    var arrayGoodSleep = ["0:00", "0:30", "1:00", "1:30", "2:00", "2:30", "3:00", "4:00", "5:00", "6:00", "7:00", "8:00", "9:00", "10:00", "11:00", "12:00"];
    var arrayDeviceTime = [0, 1, 2, 3, 4, 5, 6, 8, 10, 12, 14, 16, 18, 20, 22, 24];
    var arrayIndexGS;
    $scope.$watch(function () {
        return $scope.tempGoodSleepHr;
    }, function () {
        if ($scope.tempGoodSleepHr > 2) {
            $scope.disableGoodSleepMin = true;
        } else {
            $scope.disableGoodSleepMin = false;
        }
    });
    $scope.openGoodSleepPopup = function () {
        if ($scope.powerOperation && $scope.enableGoodSleepOption) {
            $scope.showGoodSleepPopup = true;
            toggleBottomPopUpClass($scope.showGoodSleepPopup);
            if ($scope.sleep !== 0) {
                arrayDeviceTime.forEach(function (value, index) {
                    if (value === $scope.sleep) {
                        arrayIndexGS = index;
                    }
                });
            } else {
                arrayIndexGS = getLocalStorageData('goodSleepTime#' + $scope.deviceUuid) === null ? 11 : getLocalStorageData('goodSleepTime#' + $scope.deviceUuid);   
            }
            $scope.tempGoodSleepHr = parseInt(arrayGoodSleep[arrayIndexGS].split(":")[0], 10);
            $scope.tempGoodSleepMin = arrayGoodSleep[arrayIndexGS].split(":")[1];
        }
    };
    function increaseGoodSleepHr(bool) {
        if (bool) { // increase
            if ($scope.tempGoodSleepMin === "30" && $scope.tempGoodSleepHr === 2) {
                showToast("", $scope.translation.WEBMOB_device_rac_good_sleep_guide_exception);
                return;
            }            
            if ($scope.tempGoodSleepHr !== 12) {
                $scope.tempGoodSleepHr++;
            } else {
                $scope.tempGoodSleepHr = 0;
            }
        } else { // decrease
            if ($scope.tempGoodSleepMin === "30" && $scope.tempGoodSleepHr === 0) {
                showToast("", $scope.translation.WEBMOB_device_rac_good_sleep_guide_exception);
                return;
            }
            if ($scope.tempGoodSleepHr > 0) {
                $scope.tempGoodSleepHr--;
            } else {
                $scope.tempGoodSleepHr = 12;
            }
        }
    }
    function increaseGoodSleepMin() {
        $scope.tempGoodSleepMin = $scope.tempGoodSleepMin === "00" ? "30" : "00";
    }
    $scope.onGoodSleepUpdate = function (bool) {        
        if (bool) { // Yes
            // If it is not correct time, then display toast message and change time to 8:00
            if ($scope.tempGoodSleepHr > 2 && $scope.tempGoodSleepMin === "30") {
                arrayIndexGS = 11;
                $scope.tempGoodSleepHr = parseInt(arrayGoodSleep[arrayIndexGS].split(":")[0], 10);
                $scope.tempGoodSleepMin = arrayGoodSleep[arrayIndexGS].split(":")[1];
                showToast("", $scope.translation.WEBMOB_device_rac_good_sleep_guide_exception);
                return;
            }
            var tempSleepCalc = $scope.tempGoodSleepHr + ":" + $scope.tempGoodSleepMin;
            arrayGoodSleep.forEach(function (value, index) {
                if (value === tempSleepCalc) {
                    arrayIndexGS = index;
                }
            });
            if (!$scope.isStatic) {
                if ($scope.sleep !== arrayDeviceTime[arrayIndexGS]) {
                    $scope.checkResponse.push(RACCONST.COMODE);
                    SHPService.sendSHPCommand(CONSTANTS.PUT, getGoodSleepCommand(arrayDeviceTime[arrayIndexGS]), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
                    if (arrayIndexGS !== 0 && arrayIndexGS !== undefined){
                        setLocalStorageData('goodSleepTime#' + $scope.deviceUuid, arrayIndexGS);
                    }
                }
            } else {
                $scope.sleep = arrayDeviceTime[arrayIndexGS];
            }
        }
        $scope.showGoodSleepPopup = false;
        toggleBottomPopUpClass($scope.showGoodSleepPopup);
    };
    $scope.checkGoodSleepOnOff = function () {
        return $scope.translation[!!$scope.sleep ? 'WEBMOB_common_on' : 'WEBMOB_common_off'];
    };
    // Options end

    $scope.onSettingsUpdate = function (id) {
        $timeout(function () {
            switch (id) {
                case "autoClean":
                    if (!$scope.isStatic) {
                        $scope.checkResponse.push(RACCONST.AUTOCLEAN);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, getAutoCleanCommand($scope.autoClean), "/" + $scope.peerId + "/devices/" + $scope.deviceID + "/mode");
                    } else {
                        $scope.autoClean = !$scope.autoClean;
                    }
                    break;
                case "volumeMute":
                    if (!$scope.isStatic) {
                        $scope.checkResponse.push(RACCONST.VOLUME_MUTE);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, getVolumeMuteCommand($scope.volumeMute), "/" + $scope.peerId + "/devices/" + $scope.deviceID + "/mode");
                    } else {
                        $scope.volumeMute = !$scope.volumeMute;
                    }
                    break;
                case "lighting":
                    if ($scope.powerOperation) {
                        if (!$scope.isStatic) {
                            $scope.checkResponse.push(RACCONST.LIGHTING);
                            SHPService.sendSHPCommand(CONSTANTS.PUT, getLightCommand($scope.lighting), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
                        } else {
                            $scope.lighting = !$scope.lighting;
                        }
                    }
                    break;
                case "filterCleanAlarm":
                    if (!$scope.disableFilterCleanAlarm) {
                        if (!$scope.isStatic) {
                            $scope.checkResponse.push(RACCONST.FILTER_CLEAN_ALARM);
                            SHPService.sendSHPCommand(CONSTANTS.PUT, getFilterClearAlarmCommand($scope.filterCleanAlarm), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
                        } else {
                            $scope.filterCleanAlarm = !$scope.filterCleanAlarm;
                        }
                    }
                    break;
                default:
                    break;
            }
        }, MATERIAL_DESIGN.TOGGLE_TIME);
    };
    // Settings end
    
    // Go to ai cool learning page
    $scope.aiCoolLearningRACScreen = function () {
        setTimeout(function(){
            document.getElementById("scrollable_area_id").scrollTop = 0;
        }, 10);
        $scope.currentScreen = RACSCREENS.AICOOLLEARNING;
        $scope.changeScreen();
        setTimeout(function(){
            $scope.createNewChart();
        }, 10);
    };

    $scope.aiCoolLearningOnSubTitle = function () {
        var displayMode = "";
        if ($scope.powerOperation && $scope.stepcooling) {
            displayMode = $scope.translation.RACMOB_conv_2tep_cooling;
        } else if ($scope.powerOperation && $scope.sleep) {
            displayMode = $scope.translation.WEBMOB_fac_options_good_sleep;
        }

        return $scope.translation.WEBMOB_device_fac_ai_learning_graph + '(' + displayMode + ')';
    };

    $scope.aiCooLearningDescription = function() {
        return $scope.translation.WEBMOB_device_fac_ai_good_sleep_on_message.replace("00", $scope.aiFavorTemp);
    };

    $scope.aiTab = {
        INDOOR: 'indoor',
        OUTDOOR: 'outdoor'
    };
    $scope.current_aiTab = $scope.aiTab.INDOOR;
    $scope.onClick_aiTab = function (tab) {
        console.log("onClick_aiTab::: tab = ", tab);
        $scope.current_aiTab = tab;
        $scope.createNewChart();
    };

    $scope.isOutdoor_ai = function(tab) {
        return (angular.isDefined(tab) && tab === $scope.aiTab.OUTDOOR);
    };

    $scope.isIndoor_ai = function(tab) {
        return (angular.isDefined(tab) && tab === $scope.aiTab.INDOOR);
    };

    $scope.aiDataDays = function() {
        var mode = ai_check_currentMode();
        if (angular.isDefined($scope.aiGraphData[mode]) && angular.isDefined($scope.aiGraphData[mode]['dataStartDate']) && angular.isDefined($scope.aiGraphData[mode]['dataEndDate'])) {
            var startDate = new Date($scope.aiGraphData[mode]['dataStartDate']);
            var endDate = new Date($scope.aiGraphData[mode]['dataEndDate']);

            return '(' + (startDate.getMonth() + 1) + '.' + startDate.getDate() + '~' + (endDate.getMonth() + 1) + '.' + endDate.getDate() + ')';
        }
        return '';
    };

    function ai_check_currentMode() {
        if ($scope.powerOperation && $scope.stepcooling) {
            return '2stepcooling';
        } else if ($scope.powerOperation && $scope.sleep) {
            return 'sleep';
        }
        return '';
    }

    function getBubbleCurrentTemp(){
        var bubbleCurrentTemp = [];
        var bubbleRadius = 0.225 * parseInt(document.getElementById("htmlTag").style.fontSize);

        var mode = ai_check_currentMode();

        if ($scope.isStatic) {
            bubbleCurrentTemp.push({x: 21, y: 21, r: bubbleRadius});
            bubbleCurrentTemp.push({x: 21, y: 19, r: bubbleRadius});
        }
        else if (angular.isDefined($scope.aiGraphData[mode]) && angular.isDefined($scope.aiGraphData[mode]["currentTData"])) {
            $scope.aiGraphData[mode]["currentTData"].forEach(function(dot) {
                if (angular.isDefined(dot.weight) && dot.weight === "0")
                    bubbleRadius = 0.15 * parseInt(document.getElementById("htmlTag").style.fontSize);
                else
                    bubbleRadius = 0.225 * parseInt(document.getElementById("htmlTag").style.fontSize);

                var x = parseInt(dot.currentT);
                var y = parseInt(dot.desiredT);
                if (min_xAxes <= x && x <= max_xAxes && min_yAxes <= y && y <= max_yAxes)
                    bubbleCurrentTemp.push({x: x, y: y, r: bubbleRadius});
            });
        }

        console.log("bubbleCurrentTemp = ", bubbleCurrentTemp);
        return bubbleCurrentTemp;
    }

    function getBubble_cpCurrentTemp(){
        var bubble_cpCurrentTemp = [];
        var bubbleRadius = 0.225 * parseInt(document.getElementById("htmlTag").style.fontSize);

        var mode = ai_check_currentMode();

        if ($scope.isStatic) {
            bubble_cpCurrentTemp.push({x: 21, y: 21, r: bubbleRadius});
            bubble_cpCurrentTemp.push({x: 21, y: 19, r: bubbleRadius});
        }
        else if (angular.isDefined($scope.aiGraphData[mode]) && angular.isDefined($scope.aiGraphData[mode]["cpCurrentTData"])) {
            $scope.aiGraphData[mode]["cpCurrentTData"].forEach(function(dot) {
                if (angular.isDefined(dot.weight) && dot.weight === "0")
                    bubbleRadius = 0.15 * parseInt(document.getElementById("htmlTag").style.fontSize);
                else
                    bubbleRadius = 0.225 * parseInt(document.getElementById("htmlTag").style.fontSize);

                var x = parseInt(dot.cpCurrentT);
                var y = parseInt(dot.desiredT);
                if (min_xAxes <= x && x <= max_xAxes && min_yAxes <= y && y <= max_yAxes)
                    bubble_cpCurrentTemp.push({x: x, y: y, r: bubbleRadius});
            });
        }

        console.log("bubble_cpCurrentTemp = ", bubble_cpCurrentTemp);
        return bubble_cpCurrentTemp;
    }

    function getBubblePredictedTemp(){
        var bubblePredictedTemp = [];
        var bubbleRadius = 0.225 * parseInt(document.getElementById("htmlTag").style.fontSize);

        var mode = ai_check_currentMode();

        if ($scope.isStatic) {
            bubblePredictedTemp.push({x: 21, y: 20, r: bubbleRadius});
            bubblePredictedTemp.push({x: 22, y: 20, r: bubbleRadius});
            bubblePredictedTemp.push({x: 23, y: 20, r: bubbleRadius});
            bubblePredictedTemp.push({x: 24, y: 20, r: bubbleRadius});
        }
        else if (angular.isDefined($scope.aiGraphData[mode]) && angular.isDefined($scope.aiGraphData[mode]["currentTPrediction"])) {
            $scope.aiGraphData[mode]["currentTPrediction"].forEach(function(dot) {
                var x = parseInt(dot.currentT);
                var y = parseInt(dot.predictedT);
                if (min_xAxes <= x && x <= max_xAxes && min_yAxes <= y && y <= max_yAxes)
                    bubblePredictedTemp.push({x: x, y: y, r: bubbleRadius});
            });
        }

        console.log("bubblePredictedTemp = ", bubblePredictedTemp);
        return bubblePredictedTemp;
    }

    function getBubble_cpPredictedTemp(){
        var bubble_cpPredictedTemp = [];
        var bubbleRadius = 0.225 * parseInt(document.getElementById("htmlTag").style.fontSize);

        var mode = ai_check_currentMode();

        if ($scope.isStatic) {
            bubble_cpPredictedTemp.push({x: 21, y: 20, r: bubbleRadius});
            bubble_cpPredictedTemp.push({x: 22, y: 21, r: bubbleRadius});
            bubble_cpPredictedTemp.push({x: 23, y: 22, r: bubbleRadius});
            bubble_cpPredictedTemp.push({x: 24, y: 22, r: bubbleRadius});
        }
        else if (angular.isDefined($scope.aiGraphData[mode]) && angular.isDefined($scope.aiGraphData[mode]["cpCurrentTPrediction"])) {
            $scope.aiGraphData[mode]["cpCurrentTPrediction"].forEach(function(dot) {
                var x = parseInt(dot.cpCurrentT);
                var y = parseInt(dot.predictedT);
                if (min_xAxes <= x && x <= max_xAxes && min_yAxes <= y && y <= max_yAxes)
                    bubble_cpPredictedTemp.push({x: x, y: y, r: bubbleRadius});
            });
        }

        console.log("bubble_cpPredictedTemp = ", bubble_cpPredictedTemp);
        return bubble_cpPredictedTemp;
    }

    // Go to options page (Enable options only when power is ON and Mode is Cool or Heat)
    $scope.optionsScreen = function () {
        if (!$scope.disableOptions) {
            toggleAnimClass();
            $timeout(function () {
                toggleAnimClass();
                $scope.currentScreen = RACSCREENS.OPTIONS;
                $scope.changeScreen();
            }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
        }
    };

    function getBubbleGraphData(){
        var graphData = [];

        //tab 별로 그래프 분기
        if ($scope.current_aiTab === $scope.aiTab.INDOOR) {
            var bubblePredictedTemp = getBubblePredictedTemp();
            var bubbleCurrentTemp = getBubbleCurrentTemp();
            var cpBubblePredictedTemp = getBubble_cpPredictedTemp();
            var cpBubbleCurrentTemp = getBubble_cpCurrentTemp();

            if(bubblePredictedTemp.length == 0 && bubbleCurrentTemp.length == 0){
                $scope.is_aiIndoorDataNone = true;
            }
            else{
                $scope.is_aiIndoorDataNone = false;
            }
            if(cpBubblePredictedTemp.length == 0 && cpBubbleCurrentTemp.length == 0){
                $scope.is_aiOutdoorDataNone = true;
            }
            else{
                $scope.is_aiOutdoorDataNone = false;
            }

            if($scope.is_aiIndoorDataNone || $scope.is_aiOutdoorDataNone){
                bubblePredictedTemp = [];
                bubbleCurrentTemp = [];
            }

            graphData.push({
                data: bubblePredictedTemp,
                label: $scope.translation.WEBMOB_device_fac_ai_graph_indoor_temp,
                borderWidth: 0,
                borderColor:'rgba(85,175,229,1)',
                backgroundColor:"rgba(85,175,229,1)",
                // set below not to be changed when tapping dot. or else after tapping dot, dot will be bigger.
                hoverBorderWidth:0,
                hoverRadius:0,
                hoverBackgroundColor:'rgba(85,175,229,1)'
            });
            graphData.push({
                data: bubbleCurrentTemp,
                label:$scope.translation.WEBMOB_device_fac_ai_graph_target_temp,
                borderWidth: 0,
                borderColor:'rgba(172,210,115,1)',
                backgroundColor:'rgba(172,210,115,1)',
                // set below not to be changed when tapping dot. or else after tapping dot, dot will be bigger.
                hoverBorderWidth:0,
                hoverRadius:0,
                hoverBackgroundColor:'rgba(172,210,115,1)'
            });
        } else if($scope.current_aiTab === $scope.aiTab.OUTDOOR) {
            var bubblePredictedTemp = getBubblePredictedTemp();
            var bubbleCurrentTemp = getBubbleCurrentTemp();
            var cpBubblePredictedTemp = getBubble_cpPredictedTemp();
            var cpBubbleCurrentTemp = getBubble_cpCurrentTemp();

            if(bubblePredictedTemp.length == 0 && bubbleCurrentTemp.length == 0){
                $scope.is_aiIndoorDataNone = true;
            }
            else{
                $scope.is_aiIndoorDataNone = false;
            }
            if(cpBubblePredictedTemp.length == 0 && cpBubbleCurrentTemp.length == 0){
                $scope.is_aiOutdoorDataNone = true;
            }
            else{
                $scope.is_aiOutdoorDataNone = false;
            }

            if($scope.is_aiIndoorDataNone || $scope.is_aiOutdoorDataNone){
                cpBubblePredictedTemp = [];
                cpBubbleCurrentTemp = [];
            }

            graphData.push({
                data: cpBubblePredictedTemp,
                label: $scope.translation.WEBMOB_device_fac_ai_graph_outdoor_temp,
                borderWidth: 0,
                borderColor:'rgba(85,175,229,1)',
                backgroundColor:"rgba(85,175,229,1)",
                // set below not to be changed when tapping dot. or else after tapping dot, dot will be bigger.
                hoverBorderWidth:0,
                hoverRadius:0,
                hoverBackgroundColor:'rgba(85,175,229,1)'
            });
            graphData.push({
                data: cpBubbleCurrentTemp,
                label:$scope.translation.WEBMOB_device_fac_ai_graph_target_temp,
                borderWidth: 0,
                borderColor:'rgba(172,210,115,1)',
                backgroundColor:'rgba(172,210,115,1)',
                // set below not to be changed when tapping dot. or else after tapping dot, dot will be bigger.
                hoverBorderWidth:0,
                hoverRadius:0,
                hoverBackgroundColor:'rgba(172,210,115,1)'
            });
        }
        return graphData;
    }

    $scope.createNewChart = function() {
        $scope.myChart = null;
        $scope.ctxGraph = null;
        $scope.ctxGraph = document.getElementById("aiChart");

        $scope.myChart = new Chart($scope.ctxGraph, {
            type: 'bubble',
            data: {
                datasets: getBubbleGraphData()
            },
            options: {
                responsive: true,
                maintainAspectRatio: false,
                layout: {
                    padding: {
                        left: 0,
                        right: 0,
                        top: 0,
                        bottom: 0
                    }
                },
                legend: {   // 볌례
                    display: false
                },
                scales: {
                    yAxes: [{
                        ticks: {
                            min: min_yAxes,
                            max: max_yAxes,
                            stepSize: 3,
                            fontColor: 'rgb(137, 137, 137)',
                            fontFamily: 'Sans-serif","HelveticaNeue" ,"AppleSDGothicNeo-Regular',
                            fontSize: parseInt(document.getElementById("htmlTag").style.fontSize) * 0.75,
                            fontStyle: 'normal',
                            padding: parseInt(document.getElementById("htmlTag").style.fontSize) * 0.5,
                            backdropPaddingX: parseInt(document.getElementById("htmlTag").style.fontSize) * 0.5
                        },
                        gridLines: {
                            display: true,
                            lineWidth: parseInt(document.getElementById("htmlTag").style.fontSize) * 0.025,
                            zeroLineWidth: parseInt(document.getElementById("htmlTag").style.fontSize) * 0.025,
                            color: 'rgba(206, 208, 210, 0.6)',
                            zeroLineColor: 'rgba(206, 208, 210, 0.6)',
                            drawTicks: false,
                            drawOnChartArea: true,
                            drawBorder: true
                        },
                        scaleLabel:{
                            display: false,
                            labelString : "(°C)"
                        }
                    }],
                    xAxes: [{
                        ticks: {
                            min: min_xAxes,
                            max: max_xAxes,
                            stepSize: 4,
                            fontColor: 'rgb(137, 137, 137)',
                            fontFamily: 'Sans-serif","HelveticaNeue" ,"AppleSDGothicNeo-Regular',
                            fontSize: parseInt(document.getElementById("htmlTag").style.fontSize) * 0.75,
                            fontStyle: 'normal',
                            padding: parseInt(document.getElementById("htmlTag").style.fontSize) * 0.35,
                            backdropPaddingY: parseInt(document.getElementById("htmlTag").style.fontSize) * 0.35
                        },
                        gridLines: {
                            display: false
                        },
                        scaleLabel:{
                            display: false,
                            labelString : "(°C)"
                        }
                    }]
                },
                tooltips:{
                    enabled: false
                }
            }
        });
    };


    // Go to schedule list screen
    function scheduleList() {
        //if no schedule available, open add schedule screen
        if($scope.Actions.length === 0 && $scope.currentScreen === RACSCREENS.HOME) {
            addSchedule(-1);
            return;
        }
        
        toggleAnimClass();
        $timeout(function () {
            toggleAnimClass();
            if ($scope.isStatic) {
                var actData = [{"id": "1", "Actuators": [{"Operation": {"power": strOff}, "deviceIDs": ["0"]}], "dayOfWeek": ["Thu", "Sat"], "disposable": true, "enabled": true, "startTime": "0000-00-00T007:28:00"}, {"id": "2", "Actuators": [{"Operation": {"power": strOff}, "deviceIDs": ["0"]}], "dayOfWeek": ["Sun", "Tue", "Wed"], "disposable": true, "enabled": true, "startTime": "0000-00-00T14:17:00"}, {"id": "3", "Actuators": [{"Operation": {"power": "On"}, "deviceIDs": ["0"]}], "dayOfWeek": ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], "disposable": false, "enabled": true, "repeatPeriod": "Daily", "startTime": "0000-00-00T10:53:00"}, {"id": "4", "Actuators": [{"Operation": {"power": strOff}, "deviceIDs": ["0"]}], "dayOfWeek": ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], "disposable": false, "enabled": true, "repeatPeriod": "Daily", "startTime": "0000-00-00T11:53:00"}, {"id": "5", "Actuators": [{"Operation": {"power": strOff}, "deviceIDs": ["0"]}], "dayOfWeek": ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], "disposable": false, "enabled": true, "repeatPeriod": "Daily", "startTime": "0000-00-00T16:53:00"}, {"id": "0", "Actuators": [{"Operation": {"power": "On"}, "deviceIDs": ["0"]}], "dayOfWeek": ["Wed", "Fri"], "disposable": false, "enabled": true, "repeatPeriod": "Weekly", "startTime": "0000-00-00T08:16:00"}];
                parseActionData(actData);
            } else {
                $scope.checkResponse.push(RACCONST.SCHEDULEDATA);
                getSchedules();
            }
            $scope.currentScreen = RACSCREENS.SCHEDULELIST;
            $scope.changeScreen();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }
    // Go to add schedule screen
    $scope.gotoAddSchedule = function () {
        toggleAnimClass();
        $timeout(function () {
            toggleAnimClass();
            $scope.currentScreen = RACSCREENS.ADDSCHEDULE;
            $scope.changeScreen();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };

    function getSchedules(noLoadingBar) {
        if ($scope.isStatic) {
            var actData = [{"id": "1", "Actuators": [{"Operation": {"power": "Off"}, "deviceIDs": ["0"]}], "dayOfWeek": ["Thu", "Sat"], "disposable": true, "enabled": true, "startTime": "0000-00-00T04:17:00"}, {"id": "1", "Actuators": [{"Operation": {"power": "Off"}, "deviceIDs": ["0"]}], "dayOfWeek": ["Thu", "Sat"], "disposable": true, "enabled": true, "startTime": "0000-00-00T04:17:00"}, {"id": "2", "Actuators": [{"Operation": {"power": "Off"}, "deviceIDs": ["0"]}], "dayOfWeek": ["Sun", "Tue", "Wed"], "disposable": true, "enabled": true, "startTime": "0000-00-00T14:17:00"}, {"id": "3", "Actuators": [{"Operation": {"power": "On"}, "deviceIDs": ["0"]}], "dayOfWeek": ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], "disposable": false, "enabled": true, "repeatPeriod": "Daily", "startTime": "0000-00-00T10:53:00"}, {"id": "4", "Actuators": [{"Operation": {"power": "Off"}, "deviceIDs": ["0"]}], "dayOfWeek": ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], "disposable": false, "enabled": true, "repeatPeriod": "Daily", "startTime": "0000-00-00T11:53:00"}, {"id": "5", "Actuators": [{"Operation": {"power": "Off"}, "deviceIDs": ["0"]}], "dayOfWeek": ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], "disposable": false, "enabled": true, "repeatPeriod": "Daily", "startTime": "0000-00-00T16:53:00"}, {"id": "0", "Actuators": [{"Operation": {"power": "On"}, "deviceIDs": ["0"]}], "dayOfWeek": ["Wed", "Fri"], "disposable": false, "enabled": true, "repeatPeriod": "Weekly", "startTime": "0000-00-00T08:16:00"}];
            parseActionData(actData);
        } else {
            if (!!!noLoadingBar) {
                $scope.checkResponse.push(RACCONST.SCHEDULEDATA);
            }
            SHPService.sendSHPCommand(CONSTANTS.GET, "/" + $scope.peerId + "/actions", '', !noLoadingBar);
        }
    }
    
    function sortWindList() {
        $scope.windList.sort(function (left, right) {
            return left.name.split(" ")[2] - right.name.split(" ")[2];
        });
    }

    // Go to my wind list screen
    $scope.gotoMyWindList = function () {
        //if no wind is available, open add wind screen
        if($scope.windList.length === 0) {
            addWind(-1);
            return;
        }
        
        sortWindList();
        toggleAnimClass();
        $timeout(function () {
            toggleAnimClass();
            $scope.currentScreen = RACSCREENS.MYWINDLIST;
            $scope.changeScreen();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };
    // Go to add schedule screen
    $scope.gotoAddMyWind = function () {
        toggleAnimClass();
        $timeout(function () {
            toggleAnimClass();
            $scope.currentScreen = RACSCREENS.ADDWIND;
            $scope.changeScreen();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };
    // Go to energy moitor screen
    function goToEnergyMonitor() {
        if ((!$scope.isStatic)) {
            if (!isDBDownloadedJS)
            {
                return;
            }
        }
        EnergyService.goToEnergyMonitor($scope);
        toggleAnimClass();
        $timeout(function () {
            toggleAnimClass();
            $scope.currentScreen = RACSCREENS.ENERGYMONITOR;
            $scope.changeScreen();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }

    // Go to Settings page
    function goToSettings() {
        toggleAnimClass();
        $timeout(function () {
            toggleAnimClass();
            $scope.currentScreen = RACSCREENS.SETTINGS;
            $scope.changeScreen();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }
    // Go to About screen
    function goToAbout() {
        toggleAnimClass();
        $timeout(function () {
            toggleAnimClass();
            $scope.currentScreen = RACSCREENS.ABOUT;
            $scope.changeScreen();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }
    // Go to Filter screen
    $scope.goToFilter = function () {
        toggleAnimClass();
        $timeout(function () {
            toggleAnimClass();
            $scope.currentScreen = RACSCREENS.FILTER;
            $scope.changeScreen();
            filterLayerStyle();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };
    // Go to error page
    $scope.gotoErrorPage = function () {
        $scope.currentScreen = RACSCREENS.ERRORPAGE;
        $scope.changeScreen();
    };

    // Change screen
    $scope.changeScreen = function () {
        $scope.homePage = false;
        $scope.optionsPage = false;
        $scope.scheduleListPage = false;
        $scope.addSchedulePage = false;
        $scope.myWindListPage = false;
        $scope.addWindPage = false;
        $scope.energyMonitorPage = false;
        $scope.settingsPage = false;
        $scope.aboutPage = false;
        $scope.showErrorPage = false;
        $scope.filterPage = false;
        $scope.smartcarepage = false;
        $scope.smartcareerror = false;
        $scope.tutorialPage = false; 
        $scope.detailedTutorial = false;
        $scope.errorTextpage = false;
        $scope.showAICoolLearning = false;
        switch ($scope.currentScreen) {
            case RACSCREENS.HOME:                
                $scope.subHeaderTitle = $scope.translation.WEBMOB_common_device_rac;
                updateWindStrengthList($scope.currentMode);
                $scope.homePage = true;
                break;
            case RACSCREENS.OPTIONS:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_common_options;
                $scope.optionsPage = true;
                break;
            case RACSCREENS.FILTER:
                $scope.subHeaderTitle = $scope.translation.RACMOB_filter_replacement;
                $scope.filterPage = true;
                break;
            case RACSCREENS.SCHEDULELIST:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_common_schedule_schedule;
                $scope.scheduleListPage = true;
                break;
            case RACSCREENS.ADDSCHEDULE:
                $scope.addSchedulePage = true;
                break;
            case RACSCREENS.MYWINDLIST:
                $scope.subHeaderTitle = $scope.translation.RACMOB_mywind;
                $scope.myWindListPage = true;
                break;
            case RACSCREENS.ADDWIND:
                $scope.addWindPage = true;
                break;
            case RACSCREENS.ENERGYMONITOR:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_common_energy_monitor_title;                
                $scope.energyMonitorPage = true;
                break;
            case RACSCREENS.SETTINGS:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_common_settings;
                $scope.settingsPage = true;
                break;
            case RACSCREENS.ABOUT:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_common_about_device;
                $scope.aboutPage = true;
                break;
            case RACSCREENS.ERRORPAGE:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_common_error_notification;
                $scope.showErrorPage = true;
                dismissAllPopups();
                break;
            case RACSCREENS.ERRORTEXT:
                $scope.errorTextpage = true;
                break;
            case RACSCREENS.SMARTCARE:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_common_self_diagnosis;
                $scope.smartcarepage = true;
                break;
            case RACSCREENS.SMARTCAREERROR:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_common_self_diagnosis;
                $scope.smartcareerror = true;
                break;
            case RACSCREENS.TUTORIALPAGE:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_common_tutorial;
                $scope.tutorialPage = true;
                document.getElementById("vid").src = "";
                break;
            case RACSCREENS.DETAILEDTUTORIALPAGE:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_common_tutorial;
                $scope.detailedTutorial = true;
                document.getElementById("vid").src = "https://s3.amazonaws.com/smartthingsda/solutionmodule/tutorial/cleanfilter.mp4";
                break;
            case RACSCREENS.AICOOLLEARNING:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_device_fac_ai_comfort_cooling;
                $scope.showAICoolLearning = true;
                break;
            default:
                break;
        }        
    };
    // On back key pressed
    function onBackPressed() {
        if ($scope.diagnosisStart === "Run") {
            return;
        }

        if (dismissAllPopups()) {
            return;
        }

        switch ($scope.currentScreen) {
            case RACSCREENS.WEATHERINFO:
            case RACSCREENS.POWERCONSUMPTION:
            case RACSCREENS.OPTIONS:                      
            case RACSCREENS.SETTINGS:
            case RACSCREENS.ABOUT:
                $scope.currentScreen = RACSCREENS.HOME;
                $scope.changeScreen();
                break;
            case RACSCREENS.AICOOLLEARNING:
                $scope.currentScreen = RACSCREENS.HOME;
                $scope.changeScreen();
                setTimeout(function(){
                    document.getElementById("scrollable_area_id").scrollTop = 0;
                }, 10);
                break;
            case RACSCREENS.SCHEDULELIST:
                $scope.currentScreen = RACSCREENS.HOME;
                $scope.changeScreen();
                getSchedules();
                break;
            case RACSCREENS.ADDSCHEDULE:
                if($scope.Actions.length !== 0) {
                    scheduleList();
                } else {
                    $scope.currentScreen = RACSCREENS.HOME;
                    $scope.changeScreen();
                    getSchedules();
                }
                break;
            case RACSCREENS.ADDWIND:
                if($scope.windList.length !== 0) {
                    $scope.currentScreen = RACSCREENS.MYWINDLIST;
                    $scope.changeScreen();
                    return;
                } else {
                    $scope.currentScreen = RACSCREENS.SETTINGS;
                    $scope.changeScreen();
                }
                break;
            case RACSCREENS.FILTER:
            case RACSCREENS.MYWINDLIST:
            case RACSCREENS.ENERGYMONITOR:
                $scope.currentScreen = RACSCREENS.SETTINGS;
                $scope.changeScreen();
                break;
            case RACSCREENS.HOME:
                $scope.closeApp();
                break;
            case RACSCREENS.ERRORPAGE:
                if ($scope.isStatic) {
                    $scope.closeApp();
                } else {
                    if ($scope.previousScreen === RACSCREENS.SMARTCARE || $scope.previousScreen === RACSCREENS.SMARTCAREERROR) {
                        $scope.currentScreen = RACSCREENS.HOME;
                    } else {
                        $scope.currentScreen = $scope.previousScreen;
                    }
                    $scope.changeScreen();
                }
                break;
            case RACSCREENS.ERRORTEXT:
                $scope.currentScreen = RACSCREENS.ABOUT;
                $scope.changeScreen();
                break;
            case RACSCREENS.TUTORIALPAGE:
            case RACSCREENS.SMARTCARE:
                $scope.currentScreen = RACSCREENS.ABOUT;
                $scope.changeScreen();
                break;
            case RACSCREENS.SMARTCAREERROR:
                $scope.currentScreen = RACSCREENS.HOME;
                $scope.changeScreen();
                break;
            case RACSCREENS.DETAILEDTUTORIALPAGE:
                $scope.currentScreen = RACSCREENS.TUTORIALPAGE;
                $scope.changeScreen();
                break;
            default:
                break;
        }
    }
        
    /**    	 
     * @function
     * @private
     * @name isPopupOpen
     * @description To check any popup is shown or not
     */
    function isPopupOpen () {
        if ($scope.showModeSelectionPopup || $scope.showWindStrengthPopup || $scope.showWindDirectionPopup || $scope.bOptionPopUp
                || $scope.showColorOfWindPopup || $scope.showGoodSleepPopup || $scope.showOptimusTimePopup || $scope.filterResetPopup 
                || $scope.showAddWindModeSelectionPopup || $scope.showConnFailurePopup || $scope.showModuleInfoPopup || $scope.loadingBar
                || $scope.bUsageHelpPage) {
            return true;
        }
        return false;
    }

    // Dismiss all popups
    function dismissAllPopups() {
        if ($scope.dialogPopup) {
            $scope.dialogPopup = false;
            $scope.isRadioSelection = false;
            $scope.showServiceCenterText = false;
            return true;
        }
        if ($scope.showModeSelectionPopup) {
            $scope.showModeSelectionPopup = false;
            return true;
        }
        if ($scope.showWindStrengthPopup) {
            $scope.showWindStrengthPopup = false;
            return true;
        }
        if ($scope.showWindDirectionPopup) {
            $scope.showWindDirectionPopup = false;
            return true;
        }
        if ($scope.showGoodSleepPopup) {
            $scope.showGoodSleepPopup = false;
            return true;
        }
        if ($scope.showColorOfWindPopup) {
            $scope.showColorOfWindPopup = false;
            return true;
        }
        if ($scope.showOptimusTimePopup) {
            $scope.showOptimusTimePopup = false;
            return true;
        }
        if ($scope.filterResetPopup) {
            $scope.filterResetPopup = false;
            return true;
        }
        if ($scope.showAddWindModeSelectionPopup) {
            $scope.showAddWindModeSelectionPopup = false;
            return true;
        }
        if ($scope.countrySelectionPopupVisible) {
            $scope.countrySelectionPopupVisible = false;
            return true;
        }
        if ($scope.bOptionPopUp) {
            $scope.bOptionPopUp = false;
            return true;
        }
        if ($scope.bUsageHelpPage) {
            $scope.bUsageHelpPage = false;
            return true;
        }
        if ($scope.showModuleInfoPopup) {
            $scope.showModuleInfoPopup = false;
            return true;
        }
        return false;
    }

    // To display static data
    $scope.parseStaticData = function () {
        $scope.isStatic = true;
        init();
        var RACResponse = '{"Device":{"description":"TP6X_RAC_15K","id":"0","Alarms":[{"id":"0","alarmType":"Device","code":"FilterAlarm_OFF","triggeredTime":"2015-07-25T03:00:46"}],"ConfigurationLink":{"href":"/devices/0/configuration"},"Consumables":[{"id":"0"}],"EnergyConsumption":{"saveLocation":"/files/usage.db"},"InformationLink":{"href":"/devices/0/information"},"Mode":{"modes":["Cool"],"options":["Comode_Off","Sleep_0","Autoclean_Off","Spi_Off","OutdoorTemp_55","CoolCapa_0","WarmCapa_0","UsagesDB_254","FilterTime_520","OptionCode_62650","ExtendOptionCode_1","FilterAlarmTime_180","Function_15"],"supportedModes":["Cool","Dry","Wind","Auto"]},"Operation":{"power":"On"},"Wind":{"direction":"Fix","maxSpeedLevel":4,"speedLevel":3},"connected":true,"name":"RAC","resources":["Alarms","Configuration","EnergyConsumption","Information","Mode","Operation","Temperatures","Wind"],"type":"RAC","uuid":"54880E19-4FA9-0000-0000-000000000000","Temperatures":[{"id":"0","current":27,"desired":25,"maximum":30,"minimum":16,"unit":"Celsius"}]}}';
//        var RACResponse = '{"Device":{"description":"TP6X_RAC_15K","id":"0","Alarms":[{"id":"0","alarmType":"Device","code":"FilterAlarm_OFF","triggeredTime":"2015-07-25T03:00:46"}],"ConfigurationLink":{"href":"/devices/0/configuration"},"Consumables":[{"id":"0"}],"EnergyConsumption":{"saveLocation":"/files/usage.db"},"InformationLink":{"href":"/devices/0/information"},"Mode":{"modes":["Cool"],"options":["Comode_Off","Sleep_0","Autoclean_Off","Spi_Off","OutdoorTemp_55","CoolCapa_0","WarmCapa_0","UsagesDB_254","FilterTime_520","OptionCode_62650","ExtendOptionCode_1","FilterAlarmTime_180","Function_15", "AI_Enable","ArtificialWork_Ing"],"supportedModes":["Cool","Dry","Wind","Auto"]},"Operation":{"power":"On"},"Wind":{"direction":"Fix","maxSpeedLevel":4,"speedLevel":3},"connected":true,"name":"RAC","resources":["Alarms","Configuration","EnergyConsumption","Information","Mode","Operation","Temperatures","Wind"],"type":"RAC","uuid":"54880E19-4FA9-0000-0000-000000000000","Temperatures":[{"id":"0","current":27,"desired":25,"maximum":30,"minimum":16,"unit":"Celsius"}]}}';
        var device = JSON.parse(RACResponse);
        parseDeviceData(device.Device);

        // If we get error code in demo initial response, go to error page
        if (angular.isDefined($scope.demoErrorCode)) {
            $scope.currentErrorCode = $scope.demoErrorCode;
            $scope.currentErrorDesc = "RACMOB_error_message_" + $scope.currentErrorCode.toLowerCase() + "_result";
            if (angular.isDefined($scope.translation[$scope.currentErrorDesc])) {
                if ($scope.currentScreen !== RACSCREENS.ERRORPAGE) {
                    $scope.previousScreen = $scope.currentScreen;
                }
                $scope.gotoErrorPage();
            }
        }
        
        //$scope.errorList = [];
        //$scope.errorList[0] = {};
    };

    // init function
    function init() {
        $scope.windList = [];
        currentWindKey = $scope.isStatic ? RACCONST.MYWIND_KEY_DEMO : RACCONST.MYWIND_KEY;
        var tempWindList = JSON.parse(getLocalStorageData(currentWindKey));
        if (tempWindList !== null) {
            $scope.windList = tempWindList;
        }

        if (!$scope.isStatic) {
            // Get configuration for region code
            $scope.checkResponse.push(FACCONST.PARSE_CONFIG);
            SHPService.sendSHPCommand(CONSTANTS.GET, "/" + $scope.peerId + "/devices/0/configuration");
        }
    }
    // Call back from native
    $scope.updateDeviceData = function (data) {
        SHPService.updateDeviceData($scope, data);
    };

    // Parse configuration for region
    function parseConfiguration(configuration) {
        dismissLoadingBar(FACCONST.PARSE_CONFIG);
        if (angular.isDefined(configuration["region"])) {
            $scope.selectedWeatherLocationCode = configuration["region"];
        }
    }

    // One parsing is done start the app
    function startApp() {
        $scope.pageLoaded = true;
        $scope.mainLoadingScreen = true;
        $scope.changeScreen();
        // Show help screen on launch for the first time
        if (getLocalStorageData('HomeMultiRacFUGLaunch') === null) {
            showUsageHelpPage();
            setLocalStorageData('HomeMultiRacFUGLaunch', true);
        }
    }

    // Close the app
    $scope.closeApp = function () {
        nativeInterface.runOnNative("closeWebApp", "");
    };

    // About page start
    $scope.onAboutAction = function (reqParam) {
        if (reqParam === "smartcare") {
            $scope.currentScreen = RACSCREENS.SMARTCARE;
            $scope.changeScreen();
            return;
        }
        if (reqParam === "errorpage") {
            $scope.currentScreen = RACSCREENS.ERRORTEXT;
            $scope.changeScreen();
            return;
        }
        if(reqParam === 'tutorial' || reqParam === 'manual' || reqParam === 'helpdesk') {
            if($scope.selectedCountry === "BE") {
                $scope.countryToSelect = [];
                $scope.countryToSelect.push({'Country': 'Belgium'});
                $scope.countryToSelect.push({'Country': 'Belgium(French)'});
                reqParamCountrySelection = reqParam;
                $scope.showcustCountrySelectionPopup();
            } else if($scope.selectedCountry === "CA") {
                $scope.countryToSelect = [];
                $scope.countryToSelect.push({'Country': 'Canada'});
                $scope.countryToSelect.push({'Country': 'Canada(French)'});
                reqParamCountrySelection = reqParam;
                $scope.showcustCountrySelectionPopup();
            } else if($scope.selectedCountry === "CH") {
                $scope.countryToSelect = [];
                $scope.countryToSelect.push({'Country': 'Switzerland'});
                $scope.countryToSelect.push({'Country': 'Switzerland(French)'});
                reqParamCountrySelection = reqParam;
                $scope.showcustCountrySelectionPopup();
            } else {
                /*if($scope.isStatic) {
                    $scope.selectedCountry = "BE";
                    $scope.showcustCountrySelectionPopup();
                    return;
                }*/
                $timeout(function () {
                    nativeInterface.runOnNative("customerService", aboutCommand(reqParam));
                }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
            }
        } else {
            $timeout(function () {
                nativeInterface.runOnNative("customerService", aboutCommand(reqParam));
            }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
        }
    };
    
    function aboutCommand(cmdstring, changedCode) {
        if(changedCode) {
            return '{"service" : "' + cmdstring + '","selectedCountry" : "' + $scope.selectedCountry + '_FR"}';
        } else {
            return '{"service" : "' + cmdstring + '","selectedCountry" : "' + $scope.selectedCountry + '"}';
        }
    }
    
    $scope.showcustCountrySelectionPopup = function() {
        $scope.countrySelectionPopupVisible = true;
    };
    
    $scope.onCountrySelected = function (countryIndex) {
        console.log("country selected is "+countryIndex);
        $scope.countrySelectedIndex = countryIndex;
    };
    
    $scope.onCountrySelectedOkClicked = function (isCountrySelected) {
        if(isCountrySelected) {
            if($scope.countrySelectedIndex === 0){
                $timeout(function () {
                    nativeInterface.runOnNative("customerService", aboutCommand(reqParamCountrySelection));
                }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
            } else {
                $timeout(function () {
                    nativeInterface.runOnNative("customerService", aboutCommand(reqParamCountrySelection, true));
                }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
            }
        }
        $scope.closeCountrySelectionPopup();
    };
    
    $scope.closeCountrySelectionPopup = function () {
        $scope.countrySelectionPopupVisible = false;
    };    

    $scope.smartcareerrorcheck = function () {
        $scope.checkResponse.push(RACCONST.DIAGNOSIS);
        SHPService.sendSHPCommand(CONSTANTS.PUT, getDiagnosisCommand(), "/" + $scope.peerId + "/devices/0/diagnosis", true, 300000);    //Lokesh 16Nov15_1421 -> fall back time for smart care is 5 minutes (300000 ms).
    };

    $scope.versionTouchStart = function () {
        if (!promise) {
            promise = $timeout(function () {
                if (!$scope.isStatic) {
                    $scope.checkResponse.push(RACCONST.PARSE_MODULEINFO);
                    SHPService.sendSHPCommand(CONSTANTS.GET, "/" + $scope.peerId + "/devices/" + +$scope.deviceID + "/information");
                }
            }, 5000);
        }
    };

    $scope.versionTouchEnd = function () {
        if (promise) {
            $timeout.cancel(promise);
            promise = null;
        }
    };

    function parseModuleInformation(moduleInfo) {
        if (angular.isDefined(moduleInfo.Versions) && moduleInfo.Versions.length > 0) {
            $scope.moduleInfoText = "Software Ver : " + moduleInfo.Versions[0].number + " <br> Firmware Ver : " + moduleInfo.Versions[1].number;
            dismissLoadingBar(RACCONST.PARSE_MODULEINFO);
            document.getElementById("moduleInfoCancelID").style.visibility = 'hidden';
            $scope.showModuleInfoPopup = true;
            toggleBottomPopUpClass($scope.showModuleInfoPopup);
        }
    }
    $scope.moduleInfoOk = function () {
        $scope.showModuleInfoPopup = false;
        toggleBottomPopUpClass($scope.showModuleInfoPopup);
    };
    // About page end

    var event;
    // Parse device, notification data
    function parseDeviceData(device) {
        // Need to take FAC WiFi module smart lock notification in case of Home Multi RAC
        // In case home multi RAC, FAC - only last digit is different in device uuid
        // In case Single RAC, following should not be executed
        if ((!!device.id && parseInt(device.id, 10) === RACCONST.HOMEMULTI_RAC)
                && (angular.isDefined(device["uuid"]) && (!!$scope.deviceUuid && ($scope.deviceUuid).slice(0, -1) === device["uuid"].slice(0, -1)))) {
            if (angular.isDefined(device["Mode"]) && angular.isDefined(device["Mode"]["options"])) {
                $scope.options = device["Mode"]["options"];
                $scope.options.forEach(function (value) {
                    if (value.indexOf("Smarton_") !== -1) {
                        $scope.SmartonLockOff = value.indexOf("Smarton_LockOff") !== -1;
                        if (!$scope.SmartonLockOff) {
                            document.getElementById("popupcancel_smartlock").style.visibility = "hidden";
                            $scope.showSmartLockPopup = true;
                            toggleBottomPopUpClass($scope.showSmartLockPopup);
                        }
                    }
                });
            }
        }

        // Checking Uuid
        if (angular.isDefined(device["uuid"]) && device["uuid"] !== $scope.deviceUuid && !$scope.isStatic) {
            return;
        }

        if (angular.isDefined(device["type"])) {
            $scope.deviceType = device["type"];
        }
        // Device ID
        if (angular.isDefined(device["id"])) {
            $scope.deviceID = parseInt(device["id"], 10);
            updateDefaultConfig();
        }
        // Model
        if (angular.isDefined(device["description"])) {
            $scope.currentModel = device["description"];
        }

        // Smart care
        if (angular.isDefined(device["Diagnosis"]) && angular.isDefined(device["Diagnosis"].diagnosisStart)) {
            $scope.showSmartCare = true;
            $scope.diagnosisStart = device["Diagnosis"].diagnosisStart;
            if ($scope.diagnosisStart === "Ready") {
                //Lokesh 17Nov15_2050 -> Should dismiss loading bar as soon as getting 'Ready' for diagnosis.
                //As per Jihee Jang, after 'Run', we get ready only when diagnosis is completed.
                dismissLoadingBar(RACCONST.DIAGNOSIS);
                if ($scope.currentScreen === RACSCREENS.SMARTCARE || $scope.currentScreen === RACSCREENS.SMARTCAREERROR) {
                    $scope.currentScreen = RACSCREENS.SMARTCAREERROR;
                    $scope.changeScreen();
                }
            } else {
                $scope.currentScreen = RACSCREENS.SMARTCARE;
                $scope.changeScreen();
            }
        }

        // Power operation
        /** Lokesh 14Dec15_1730 -> if Single RAC, then check for power value also. 
         *  In app.js, a fony operation object is created. That should not be allowed inside this block.
         *  Otherwise, it will create lot of issues related to power on / off state.
         *  Don't know what should happen to Home Multi RAC. So, leaving it as it is.
         */
        if (!!device.Operation && ((isSingleRAC() && !!device.Operation.power) || isHomeMultiRAC())) {
            $scope.powerOperation = device.Operation.power === "On";
            if (!$scope.powerOperation) {
                dismissAllPopups();
            }
            if (!$scope.isStatic) { //call getSchedules only when receiving power operation, without showing loading bar.
                getSchedules(true);
            }
            dismissLoadingBar(RACCONST.POWEROPERATION);
        }
        // Current mode
        if (angular.isDefined(device["Mode"]) && angular.isDefined(device["Mode"].modes)) {
            $scope.currentMode = device["Mode"].modes[0];
            dismissLoadingBar(RACCONST.MODECHANGE);
            if ($scope.currentScreen === RACSCREENS.HOME && !!$scope.showModeSelectionPopup) {
                $scope.showModeSelectionPopup = false;
                changePopUpClass();
            }
            // As heat mode is not supported color of wind, if it is opened, close it
            if ($scope.currentMode === strHeat && $scope.showColorOfWindPopup) {
                $scope.showColorOfWindPopup = false;
            }            
        }

        //handle events for filter alarm as of now.
        if (!!device.event) {
            event = device.event.toLowerCase();
        }

        // Wind direction
        if (angular.isDefined(device["Wind"]) && angular.isDefined(device["Wind"].direction)) {
            $scope.currentWindDirection = device["Wind"].direction;
            dismissLoadingBar(RACCONST.WINDDIRECTION_CHANGE);
            if ($scope.currentMode === strAuto) {
                dismissLoadingBar(RACCONST.MODECHANGE);
            }
        }
        // Wind strength
        if (angular.isDefined(device["Wind"]) && angular.isDefined(device["Wind"].speedLevel)) {
            $scope.currentWindStrength = device["Wind"].speedLevel;
            dismissLoadingBar(RACCONST.WINDSTRENGTH_CHANGE);
            if ($scope.currentMode === strAuto) {
                dismissLoadingBar(RACCONST.MODECHANGE);
            }
        }
        // Options
        if (angular.isDefined(device["Mode"]) && angular.isDefined(device["Mode"]["options"])) {
            $scope.options = device["Mode"]["options"];
            $scope.options.forEach(function (value) {
                if (value.indexOf("Operation") !== -1) {
                    $scope.solo = value.indexOf("Operation_Solo") !== -1;
                }
                if (value.indexOf("UsagesDB_ok") !== -1) {
//                    dismissLoadingBar(RACCONST.DB_RESET);     //Lokesh 16Nov15_2124 -> Commented for Energy Monitor Reset.

                    //Lokesh 16Nov15_2124 -> If this call is from Energy Monitor screen, then update the flag for Energy DB reset.
                    if(isCallFromReset === 1 && $scope.currentScreen === RACSCREENS.ENERGYMONITOR){
                        isCallFromReset = 2;
                    }
                    isDBDownloadedJS = false;   //Lokesh 16Nov15_2124 -> Reset the flag to avoid unexpected calls to energy monitor page.
                    // get DB request
                    $scope.fetchDBfromDevice();
                }

                if(value.indexOf("AI") !== -1){
                    dismissLoadingBar(RACCONST.AI);
                    $scope.aiSupported = true;
                    $scope.aiEnabled = value.indexOf("AI_Enable") !== -1;
                }

                if(value.indexOf("ArtificialWork") !== -1){
                    $scope.aiActive = value.split("_")[1];
                }

                if (value.indexOf("Comode") !== -1) {
                    $scope.comodeOff = value.indexOf("Comode_Off") !== -1;
                    $scope.stepcooling = value.indexOf("Comode_2Step") !== -1;
                    $scope.fastturbo = value.indexOf("Comode_Speed") !== -1;
                    $scope.comfort = value.indexOf("Comode_Comfort") !== -1;
                    $scope.dlightcool = value.indexOf("Comode_DlightCool") !== -1;
                    $scope.singleuser = isSingleRAC() && value.indexOf("Comode_Smart") !== -1;
                    $scope.quiet = value.indexOf("Comode_Quiet") !== -1;
                    $scope.goodSleep = value.indexOf("Comode_Sleep") !== -1;
                    $scope.smartSensor = isHomeMultiRAC() && value.indexOf("Comode_Smart") !== -1;
                    $scope.nanoWind = value.indexOf("Comode_Nano") !== -1;
                    if (value.indexOf("Comode_NanoSleep") !== -1) { // 17K model Nano Wind and Good Sleep both ON is possible
                        $scope.nanoWind = $scope.goodSleep = true;
                    }
                    dismissLoadingBar(RACCONST.COMODE);

                    // Color of wind parsing
                    $scope.currentColorOfWind = strOff;
                    $scope.ListOfColorWind.forEach(function (colorOfWind) {
                        if (colorOfWind.key === value.split("_")[1]) {
                            $scope.currentColorOfWind = colorOfWind.key;
                            disableItems();
                        }
                    });
                    dismissLoadingBar(RACCONST.COLOROFWIND);
                }
                if (value.indexOf("Sleep_") !== -1) {
                    $scope.sleep = parseInt(value.split("_")[1], 10);
                    if($scope.sleep < 0){
                        $scope.sleep = 0;
                    }
                    else if($scope.sleep > 24){
                        $scope.sleep = 24;
                    }
                    else if($scope.sleep === undefined || isNaN($scope.sleep)){
                        $scope.sleep = 16;
                    }
                    dismissLoadingBar(RACCONST.COMODE);
                }
                if (value.indexOf("Autoclean_") !== -1) {
                    $scope.autoClean = value.indexOf("Autoclean_On") !== -1;
                    dismissLoadingBar(RACCONST.AUTOCLEAN);
                }
                if (value.indexOf("Volume_") !== -1 && value !== RACCONST.VOL_NOT_SUPPORTED) {
                    $scope.volumeMute = value.split("_")[1] === "Mute";
                    dismissLoadingBar(RACCONST.VOLUME_MUTE);
                }                
                if (value.indexOf("Light_") !== -1) {
                    if (isHomeMultiRAC()) {
                        $scope.lighting = value.indexOf("Light_On") < 0;      //Only for Home Multi RAC. if lighting comes ON, then it should be displayed OFF and vice versa.   
                    } else {
                        $scope.lighting = value.indexOf("Light_On") !== -1;
                    }
                    dismissLoadingBar(RACCONST.LIGHTING);
                }
                if (value.indexOf("Spi_") !== -1) {
                    $scope.virusdoctor = value.indexOf("Spi_On") !== -1;
                    dismissLoadingBar(RACCONST.VIRUSDOCTOR);
                }
                if (value.indexOf("OptionCode_") !== -1) {
                    $scope.optionCodeValue = value;
                    $scope.optionCode = UtilityService.pad(parseInt(value.split("_")[1], 10).toString(2), 16); //pad the number to 16 bits.
                    $scope.isRunningTimeGraph = !isPowerConsumptionSupported(); //if power consumption not supported.
                    updateDefaultConfig(device);
                }
                // RAC Option code - This is for Home Multi RAC
                if (value.indexOf("RacOptionCode_") !== -1) {
                    $scope.RacOptionCode = parseInt(value.split("_")[1], 10);
                }
                if (value.indexOf("OutdoorTemp_") !== -1) {
                    $scope.outDoorTemp = parseInt(value.split("_")[1], 10) - 55;
                }
                if (value.indexOf("FilterAlarmTime_") !== -1) {
                    $scope.setOptimusTime = parseInt(value.split("_")[1], 10);
                    // If we get value which is not available in optimus time array then assign default value 180
                    var isOptimusTimeAvailable = false;
                    $scope.optimusTime.forEach(function (item) {
                        if (item.value === $scope.setOptimusTime) {
                            isOptimusTimeAvailable = true;
                        }
                    });
                    if (!isOptimusTimeAvailable) {
                        $scope.setOptimusTime = $scope.optimusTime[0].value;
                    }
                    filterNotificationOpen();
                    dismissLoadingBar(RACCONST.FILTERALARMTIME);
                }
                // (Ex: FilterTime_520 -> last one digit is minutes * 6 and remainig bits are hours)
                if (value.indexOf("FilterTime_") !== -1) {
                    var tempFilterTime = value.split("_")[1];
                    if (tempFilterTime.length === 1) {
                        $scope.resetOptimusTimeHrs = 0;
                        $scope.resetOptimusTimeMns = parseInt(tempFilterTime, 10) * 6;
                        $scope.showFilterTimeHours = false;
                    } else {
                        $scope.resetOptimusTimeHrs = parseInt(tempFilterTime.substring(0, tempFilterTime.length - 1), 10);
                        $scope.resetOptimusTimeMns = parseInt(tempFilterTime.charAt(tempFilterTime.length - 1), 10) * 6;
                        $scope.showFilterTimeHours = !!$scope.resetOptimusTimeHrs;
                    }
                    filterNotificationOpen();
                    dismissLoadingBar(RACCONST.FILTERTIME);
                }
                // Filter clean alarm for Home Multi RAC - "0" or "1"
                if (value.indexOf("FilterCleanAlarm_") !== -1) {
                    $scope.filterCleanAlarm = value.split("_")[1] === "1";
                    if ($scope.filterCleanAlarm) {
                        $scope.disableFilterCleanAlarm = false;
                    } else {
                        $scope.disableFilterCleanAlarm = true;
                    }
                    dismissLoadingBar(RACCONST.FILTER_CLEAN_ALARM);
                }
            });
        }
        // Temperatures
        if (angular.isDefined(device["Temperatures"])) {
            if (angular.isDefined(device["Temperatures"][0]["current"])) {
                $scope.homeTemp = device["Temperatures"][0]["current"];
            }
            if (angular.isDefined(device["Temperatures"][0]["desired"])) {
                $scope.desiredTemp = device["Temperatures"][0]["desired"];
                if ($scope.desiredTemp < 10) {
                    $scope.desiredTemp = ('0' + $scope.desiredTemp);
                }
                if (parseInt($scope.desiredTemp, 10) === 0) { // If we get zero assign default value
                    $scope.desiredTemp = getThresholdTemp();
                }
                if ((angular.isDefined(device["id"]) && parseInt(device["id"], 10) === RACCONST.HOMEMULTI_RAC) ||
                    (angular.isDefined(device["resourceURI"]) && device["resourceURI"] === '/devices/1/temperatures')) {
                    console.log('aiFavorTemp = ', $scope.aiFavorTemp);
                    $scope.aiFavorTemp = $scope.desiredTemp;
                }
                dismissLoadingBar(RACCONST.TEMPCHANGE);
            }
            if (isSingleRAC() /*|| isHomeMultiRAC()*/) {    //AC0600063734 - As per Mr. Kim, Ignore temperature limits received from server for Home Multi RAC.
                if (angular.isDefined(device["Temperatures"][0]["maximum"])) {
                    $scope.defaultConfig[$scope.currentMode].configTempHigh = device["Temperatures"][0]["maximum"];
                    $scope.singleRACMaxTemp = device["Temperatures"][0]["maximum"];
                }
                if (angular.isDefined(device["Temperatures"][0]["minimum"])) {
                    $scope.defaultConfig[$scope.currentMode].configTempLow = device["Temperatures"][0]["minimum"];
                    $scope.singleRACMinTemp = device["Temperatures"][0]["minimum"];
                }
            }
            if (angular.isDefined(device["Temperatures"][0]["unit"])) {
                $scope.temperatureUnit = device["Temperatures"][0]["unit"];
            }
            setBaseEnergy($scope.outDoorTemp, parseInt($scope.desiredTemp, 10));
            disableItems();
        }
        // Supported modes
        if (angular.isDefined(device["Mode"]) && angular.isDefined(device["Mode"].supportedModes)) {    
            if(isHomeMultiRAC()) {
                $scope.supportedModes = angular.copy(device["Mode"].supportedModes);
            } else if(isSingleRAC()) {    //Lokesh 10Dec15_1824 -> As per Ms. Jihee Jang, Single RAC does not use supported modes. Instead hard code 5 modes for Single RAC and remove heat if 'CoolOnly' bit is present in OptionCode.
                //For Single RAC.    
                $scope.supportedModes = [strCool, strDry, strWind, strAuto];
            } else {    //For SONAR.
                //Null.
            }
            updateSupportedModesWithIcon();
        }

        // Energy monitor
        if (angular.isDefined(device["EnergyConsumption"]) && angular.isDefined(device["EnergyConsumption"].saveLocation)) {
            $scope.energyMonitorLocation = device["EnergyConsumption"].saveLocation;
            if (!$scope.isStatic) {
                nativeInterface.getResourceUrl("/" + $scope.peerId + $scope.energyMonitorLocation);
            }
        }

        // Alarms parsing
        if (angular.isDefined(device["Alarms"]) && device["Alarms"].length > 0) {
            for (var i = 0; i < device["Alarms"].length; i++) {
                if ($scope.Device.Alarms[i] === undefined) {
                    $scope.Device.Alarms[i] = {alarmType: '', code: '', id: '', triggeredTime: ''};
                }
                if (angular.isDefined(device["Alarms"][i].alarmType)) {
                    $scope.Device.Alarms[i].alarmType = device["Alarms"][i].alarmType;
                }
                if (angular.isDefined(device["Alarms"][i].code)) {
                    //set filter clean alarm to enable.
                    if (isHomeMultiRAC() && device["Alarms"][i].code === 'FilterAlarm') {
                        if (event === 'deleted') {
                            //set filter clean alarm to disabled and false.
                            $scope.filterCleanAlarm = false;
                            $scope.disableFilterCleanAlarm = true;
                            dismissLoadingBar(RACCONST.FILTER_CLEAN_ALARM);
                            
                            // To dismiss in-app panel popup notification on home page
                            $scope.isFilterStatusShow = false;
                        } else {
                            $scope.filterCleanAlarm = true;
                            $scope.disableFilterCleanAlarm = false;
                            
                            // To display in-app panel popup notification on home page
                            $scope.isFilterStatusShow = true;
                            $scope.inAppPanelPopupText = $scope.translation.RACMOB_filter_clean_filter;
                        }
                    } else {
                        $scope.Device.Alarms[i].code = device["Alarms"][i].code;
                    }
                }
                if (angular.isDefined(device["Alarms"][i].id)) {
                    $scope.Device.Alarms[i].id = device["Alarms"][i].id;
                }
                if (angular.isDefined(device["Alarms"][i].triggeredTime)) {
                    $scope.Device.Alarms[i].triggeredTime = device["Alarms"][i].triggeredTime;
                }
            }
            //Lokesh 17Nov15_2052 -> call handleAlarms() only when 'Alarms' object received. Otherwise there were side effects reported of calling handleAlarms() with below set of functions.
            $scope.handleAlarms();
            
            //Lokesh 19Nov15_1359 -> Common service handle alarms call should be like below, if used.
            //homeMultiService.handleAlarms($scope.Device.Alarms, "ErrorCode_", "_", "RACMOB_error_message_", "_result", RACSCREENS.ERRORPAGE)
        }

        updateDeviceOffScreen();
        updateWindStrengthList($scope.currentMode); // Update wind strength and wind direction list
        updateWindDirectionList($scope.currentMode);
        updateBottomOptionList();
        updateOptionsList();
        updateSettinsList();
        disableItems();
        filterLayerStyle();
        startApp();
        dismissLoadingBar(RACCONST.GETDEVICES);
    }

    function getTrainingAIInfo() {
        // console.log("request to native to retrive TrainingDate");

        var region;
        if (angular.isDefined($scope.selectedWeatherLocationCode))
            region = $scope.selectedWeatherLocationCode;
        else
            region = "000";

        var requestForSleep_RAC = {
            uuid : $scope.deviceUuid,
            tempType : "Celsius",
            timeZone: "UTC+09:00",
            mode : "Sleep",
            acType : "MultiRac",
            region : region
        };

        var requestFor2StepCooling_RAC = {
            uuid : $scope.deviceUuid,
            tempType : "Celsius",
            timeZone: "UTC+09:00",
            mode : "2StepCooling",
            acType : "MultiRac",
            region : region
        };

        $scope.checkResponse.push("getTrainingDate");
        SHPService.sendSHPCommand(CONSTANTS.RUNONNATIVE, "getTrainingDate", JSON.stringify(requestForSleep_RAC));
        $scope.checkResponse.push("getTrainingDate");
        SHPService.sendSHPCommand(CONSTANTS.RUNONNATIVE, "getTrainingDate", JSON.stringify(requestFor2StepCooling_RAC));
    }

    function updateDeviceOffScreen() {
        $scope.deviceOffText2 = "";
    }

    // Update bottom options list on home screen based on condition
    function updateBottomOptionList() {
        $scope.showEnergyMonitorOption = !isHomeMultiRAC(); //true, if not home multi RAC
    }

    // Update default config based on Single RAC, Home Multi RAC
    function updateDefaultConfig(device) {
        var defCon = $scope.defaultConfig;
        // For Home Multi RAC -> Minium temperature is 18
        if (isHomeMultiRAC()) {
            $scope.versionInfo = RACCONST.HOMEMULTI_RAC_VERSION;
                
            //20170104 For Cool, Cool + Purify, Heat, Heat + purify - min temp is 16
            $scope.listOfModes.forEach(function (item) {
                if (defCon[item.modeName].configTempLow === 16) {
                    if (item.modeName === strHeat || item.modeName === "HeatClean" || item.modeName === "Cool" || item.modeName === "CoolClean") {
                        // Nothing
                    } else {
                        defCon[item.modeName].configTempLow = 18;
                    }
                }
            });
            
            $scope.listOfModes[4].textToDisplay = "WEBMOB_device_rac_mode_purify";
        } else { //for Single RAC
            $scope.versionInfo = RACCONST.RAC_VERSION;
            
            $scope.listOfModes[4].textToDisplay = "RACMOB_ac_mode_fan";
            
            //if temperature unit is not already set, Get temperature unit from device
            if(!!!$scope.temperatureUnit) {
                if(!!device && 
                    !!device.Temperatures && 
                    !!device.Temperatures[0] && 
                    !!device.Temperatures[0].unit) {
                    $scope.temperatureUnit = device.Temperatures[0].unit;
                }
            }
            
            //Now, if only temperature unit exist, then only do further calculations.
            if(!!$scope.temperatureUnit) {
                if($scope.temperatureUnit === strFahrenheit) {
                    //Set fahrenheit temperatures for lower limit
                    defCon.Auto.configTempLow = defCon.Auto.configMyWindTempLow = 
                    defCon.Cool.configTempLow = defCon.Cool.configMyWindTempLow = 
                    defCon.Wind.configTempLow = defCon.Wind.configMyWindTempLow =  //Fan mode
                    defCon.Heat.configTempLow = defCon.Heat.configMyWindTempLow = 61;
                    defCon.Dry.configTempLow = defCon.Dry.configMyWindTempLow = 65;

                    //Set fahrenheit temperatures for higher limit. All values should be set to 86.
                    defCon.Auto.configTempHigh = 
                            defCon.Cool.configTempHigh = 
                            defCon.Dry.configTempHigh = 
                            defCon.Wind.configTempHigh = 
                            defCon.Heat.configTempHigh = 
                            defCon.Auto.configMyWindTempHigh = 
                            defCon.Cool.configMyWindTempHigh = 
                            defCon.Dry.configMyWindTempHigh = 
                            defCon.Wind.configMyWindTempHigh = 
                            defCon.Heat.configMyWindTempHigh = 86;
                    
                    //Update default temperature to 76
                    defCon.Auto.configTempDefault = 
                            defCon.Cool.configTempDefault = 
                            defCon.Dry.configTempDefault = 
                            defCon.Wind.configTempDefault = 
                            defCon.Heat.configTempDefault = 76;
                    
                    if(isColdAreaModel() && isSingleRAC()) { //If this is Cold Area model. Only for Single RAC
                        defCon.Heat.configTempLow = defCon.Heat.configMyWindTempLow = 47;
                    }
                } else {    //Set default temp for Celcius mode.
                    
                    //Add default low / high temperatures for my wind section.
                    defCon.Auto.configMyWindTempLow = 
                            defCon.Cool.configMyWindTempLow = 
                            defCon.Wind.configMyWindTempLow = 
                            defCon.Heat.configMyWindTempLow = 16;
                    defCon.Dry.configMyWindTempLow = 18;
                        
                    defCon.Auto.configMyWindTempHigh = 
                            defCon.Cool.configMyWindTempHigh = 
                            defCon.Dry.configMyWindTempHigh = 
                            defCon.Wind.configMyWindTempHigh = 
                            defCon.Heat.configMyWindTempHigh = 30;
                        
                    if(isColdAreaModel() && isSingleRAC()) { //If this is Cold Area model. Only for Single RAC
                        defCon.Heat.configTempLow = defCon.Heat.configMyWindTempLow = 8;
                    }
                    
                    if(isEgyptModel()) { //If this is Egypt model. Only for Single RAC
                        //Set minimum temperature to 20.
                        defCon.Auto.configTempLow = 
                                defCon.Cool.configTempLow = 
                                defCon.Dry.configTempLow = 
                                defCon.Wind.configTempLow = 
                                defCon.Heat.configTempLow = 
                                defCon.Auto.configMyWindTempLow = 
                                defCon.Cool.configMyWindTempLow = 
                                defCon.Dry.configMyWindTempLow = 
                                defCon.Wind.configMyWindTempLow = 
                                defCon.Heat.configMyWindTempLow = 20;
                        
                        //Set maximum temperature to 28.
                        defCon.Auto.configTempHigh = 
                            defCon.Cool.configTempHigh = 
                            defCon.Dry.configTempHigh = 
                            defCon.Wind.configTempHigh = 
                            defCon.Heat.configTempHigh =
                            defCon.Auto.configMyWindTempHigh = 
                            defCon.Cool.configMyWindTempHigh = 
                            defCon.Dry.configMyWindTempHigh = 
                            defCon.Wind.configMyWindTempHigh = 
                            defCon.Heat.configMyWindTempHigh =28;
                    }
                    
                    //Update default temperature to 24
                    defCon.Auto.configTempDefault = 
                            defCon.Cool.configTempDefault = 
                            defCon.Dry.configTempDefault = 
                            defCon.Wind.configTempDefault = 
                            defCon.Heat.configTempDefault = 24;
                }
            }
        }
    }

    // Handle alarms
    $scope.handleAlarms = function () {
        if (angular.isDefined($scope.Device.Alarms)) {
            $scope.Device.Alarms.forEach(function (value) {
                if ((value.code).indexOf("ErrorCode_") !== -1) {
                    $scope.currentErrorCode = (value.code).split("_")[1];
                    $scope.currentErrorDesc = "RACMOB_error_message_" + $scope.currentErrorCode.toLowerCase() + "_result";
                    if (angular.isDefined($scope.translation[$scope.currentErrorDesc])) {
                        if ($scope.currentScreen !== RACSCREENS.ERRORPAGE) {
                            $scope.previousScreen = $scope.currentScreen;
                        }
                        $scope.gotoErrorPage();
                    }
                } else if(value.code === "ErrorCode" && $scope.currentScreen !== $scope.previousScreen && !!$scope.previousScreen && $scope.currentScreen === RACSCREENS.ERRORPAGE) {
                    //Lokesh 17Nov15_2053 -> As per Native Code, when receiving only 'ErrorCode', it means remove error dialog if it is visible to user. 
                    //'ErrorCode' may come at random time also. So, check if showing error page or not.
                    //Also make sure that previouScreen exist and it is not same as currentScreen.
                    $scope.currentScreen = $scope.previousScreen;
                    $scope.changeScreen();
                }
            });
        }
    };

    function isPowerConsumptionSupported() {
        return !!$scope.optionCode && $scope.optionCode[1] === "1";
    }
    
    function isDLightCool() {
        return !!$scope.optionCode && $scope.optionCode[2] === "1";
    }
    
    function isSingleUserCoolOption() {
        return !!$scope.optionCode && $scope.optionCode[3] === "1";
    }
    
    function isHumidSensorSupported() {
        return !!$scope.optionCode && $scope.optionCode[4] === "1";
    }
    
    function isLeftRightLouver() {
        return !!$scope.optionCode && $scope.optionCode[5] === "1";
    }
    
    function isEnergySimulatorSupported() {
        return isSingleRAC() && !!$scope.optionCode && $scope.optionCode[6] === '1';   //7th bit to identify Energy Simulator.
    }
    
    function isColdAreaModel() {
        //only for Single RAC. Since, Model (Single or Home Multi) already checked, we are not checking here again.
        return !!$scope.optionCode && $scope.optionCode[7] === '1'; //8th bit to identify Cold Area Model.
    }
    
    function isColorOfWindOption() {
        return !!$scope.optionCode && $scope.optionCode[8] === "1";
    }
    
    function isCoolOnlyOption() {
        return !!$scope.optionCode && $scope.optionCode[9] === "1";
    }
    
    function isQuietOption() {
        return !!$scope.optionCode && $scope.optionCode[10] === "1";
    }
    
    function isSingleUserHeatOption() {
        return !!$scope.optionCode && $scope.optionCode[11] === "1";
    }
    
    function isTurboComfortHeat() {
        return !!$scope.optionCode && $scope.optionCode[12] === "1";
    }
    
    function isSPIBitSet() {
        //only for Single RAC. Since, Model (Single or Home Multi) already checked, we are not checking here again.
        return !!$scope.optionCode && $scope.optionCode[14] === '1';   //15th bit to identify SPI.
    }
    
    function isEgyptModel() {
        //only for Single RAC. Since, Model (Single or Home Multi) already checked, we are not checking here again.
        return !!$scope.optionCode && $scope.optionCode[15] === '1';    //16th (last) bit to identify Egypt Model.
    }
    
    function is17KModel() {
        return ($scope.currentModel && ~$scope.currentModel.indexOf("17K"));
    }
    
    function isSingleRAC() {
        return $scope.deviceID === RACCONST.SINGLE_RAC;
    }
    
    function isHomeMultiRAC() {
        return $scope.deviceID === RACCONST.HOMEMULTI_RAC;
    }
    
    function isColorOfWindOn() {
        return $scope.currentColorOfWind !== strOff;
    }

    // Update options list based on conditions
    function updateOptionsList() {
        // Nano wind condition
        if (is17KModel()) {
            $scope.showNanoWindOption = true;
            if ($scope.powerOperation) {
                $scope.disableNanoWindOption = ($scope.currentMode === "Auto" || $scope.currentMode === "Heat" || $scope.currentMode === "HeatClean") ? true : false;
            } else {
                $scope.disableNanoWindOption = true;
            }
        } else {
            $scope.showNanoWindOption = false;
        }
        
        // Fast turbo option condtions
        if (isSingleRAC()) {
            if ($scope.currentMode === strCool) {
                $scope.showFastTurboOption = true;
            } else if ($scope.currentMode === strHeat) {
                $scope.showFastTurboOption = isTurboComfortHeat();
            } else {
                // Nothing
            }
        } else {
            $scope.showFastTurboOption = ($scope.currentMode === "Cool" || $scope.currentMode === "CoolClean" || $scope.currentMode === "Heat" || $scope.currentMode === "HeatClean");
        }

        // Dlight cool and 2-step cooling options conditions
        $scope.showStepCoolingOption = $scope.currentMode === strCool;
        $scope.showDlightCoolOption = ($scope.currentMode === strCool && isDLightCool());

        // Single user (solo) option conditions
        if (!!$scope.optionCode) {
            $scope.showSingleUserOption = (isSingleUserCoolOption() || (isSingleUserHeatOption() && $scope.currentMode === strHeat));
        }

        // Quiet option coditions
        if (isSingleRAC()) {
            $scope.showQuietOption = isQuietOption();
        } else {
            $scope.showQuietOption = ($scope.currentMode === "Cool" || $scope.currentMode === "CoolClean");
        }

        // Comfort option conditions
        if (!!$scope.optionCode) {
            if (!isTurboComfortHeat() && $scope.currentMode === strHeat && isSingleRAC()) {
                $scope.showComfortOption = false;
            } else {
                $scope.showComfortOption = ($scope.currentMode === strCool || $scope.currentMode === strHeat);
            }
        }

        // Color of wind condition
        //disable SPI / Virus Doctor whenever Color Of Wind is dispalyed.
        $scope.showColorOfWindOption = ($scope.currentMode === strCool && isColorOfWindOption());

        if (isSingleRAC()) {
            $scope.showVirusDoctorOption = isSPIBitSet();
            $scope.showSaverOption = false;
        } else {
            $scope.showVirusDoctorOption = false;
            $scope.showSaverOption = ($scope.currentMode === "Cool" || $scope.currentMode === "CoolClean");
        }

        // Conditions to display Good Sleep option
        if (isSingleRAC()) {
            $scope.enableGoodSleepOption = $scope.currentMode === strCool || $scope.currentMode === strHeat;
        } else {
            $scope.enableGoodSleepOption = ($scope.currentMode === "Cool" || $scope.currentMode === "CoolClean");
        }
    }

    // Update settings list
    function updateSettinsList() {
        if (isSingleRAC()) {
            $scope.showFilterOption = true;
            $scope.showMyWindOption = true;
            if (angular.isDefined($scope.volumeMute)) {
                $scope.showMuteOption = true; //Mute option will depend upon model of Single RAC. 15K model doesn't support mute option.
            }
            $scope.showLightingSetting = false;
            $scope.showClearnFilterAlarmOption = false;
        } else {
            $scope.showFilterOption = false;
            $scope.showMyWindOption = false;
            $scope.showMuteOption = true;            
            if (angular.isDefined($scope.lighting)) {
                $scope.showLightingSetting = true; // If we don't get Light option in options list then don't display it
            }
            $scope.showClearnFilterAlarmOption = true;
        }
    }

    function disableItems() {
        var desiredTemp = parseInt($scope.desiredTemp, 10);
        //work around for a runtime crash.
        if (!!$scope.desiredTemp &&
                !!$scope.currentMode &&
                !!$scope.defaultConfig[$scope.currentMode]) { //first check all required objects exist.           

            if ((isHomeMultiRAC() && desiredTemp >= $scope.defaultConfig[$scope.currentMode].configTempHigh)
                    || (isSingleRAC() && desiredTemp >= $scope.singleRACMaxTemp)) {
                $scope.disableTempInc = true;
                $scope.disableTempDec = false;
            } else if (((isHomeMultiRAC() && desiredTemp <= $scope.defaultConfig[$scope.currentMode].configTempLow)
                    || (isSingleRAC() && desiredTemp <= $scope.singleRACMinTemp))
                    || (!!$scope.smartSensor && desiredTemp <= 24 && ($scope.currentMode === strCool || $scope.currentMode === strCoolClean))) { //Lokesh 11Dec15_1527 -> As per Mr. Kim, In Saver mode (smartSensor), minimum temperatue can be 24. So, using 24 instead of $scope.defaultConfig[$scope.currentMode].configTempLow.
                $scope.disableTempDec = true;
                $scope.disableTempInc = false;
            } else {
                $scope.disableTempDec = false;
                $scope.disableTempInc = false;
            }
        }
        if ($scope.currentMode === strWind || (isHomeMultiRAC() && $scope.currentMode === strAuto) || $scope.dlightcool || $scope.fastturbo || !$scope.powerOperation
                || (isSingleRAC() && (($scope.currentMode === strDry && isHumidSensorSupported()) || isColorOfWindOn()))) {  //If color of wind is on, disable temperature control
            $scope.disableTempControl = true;
        } else {
            $scope.disableTempControl = false;
        }
        if ((($scope.fastturbo || $scope.comfort || $scope.stepcooling) && isSingleRAC())
                || isColorOfWindOn() || !$scope.powerOperation) {
            $scope.disableWindStrength = true;
        } else {
            $scope.disableWindStrength = false;
        }
        if (($scope.currentMode === strCool && $scope.goodSleep && isSingleRAC()) || isColorOfWindOn() || !$scope.powerOperation) {
            $scope.disableWindDirection = true;
        } else {
            $scope.disableWindDirection = false;
        }
        if ($scope.powerOperation && ($scope.currentMode === "Cool" || $scope.currentMode === "CoolClean" || $scope.currentMode === "Heat" || $scope.currentMode === "HeatClean")) {
            $scope.disableOptions = false;
        } else {
            $scope.disableOptions = true;
        }
        // If options item is disable, user is on Options screen then it should move to Home Screen
        if ($scope.disableOptions) {
            if ($scope.currentScreen === RACSCREENS.OPTIONS) {
                // Before moving to home screen, if good sleep or color of wind popups are opened, close it
                if ($scope.showGoodSleepPopup) {
                    $scope.showGoodSleepPopup = false;
                }
                if ($scope.showColorOfWindPopup) {
                    $scope.showColorOfWindPopup = false;
                }
                $scope.currentScreen = RACSCREENS.HOME;
                $scope.changeScreen();
            }
        }
        
        // If wind strength or wind direction option is disabled, then it should close the respective popup
        if ($scope.disableWindStrength && $scope.showWindStrengthPopup) {
            $scope.showWindStrengthPopup = false;
        }
        if ($scope.disableWindDirection && $scope.showWindDirectionPopup) {
            $scope.showWindDirectionPopup = false;
        }

        //If AI Cool Learning is disable, user is on AI page screen then it should move to Home Screen
        if (!isAICoolLearningEnable() && $scope.currentScreen === RACSCREENS.AICOOLLEARNING) {
            onBackPressed();
        }
    }

    // Mode updation start
    function updateSupportedModesWithIcon() {
        $scope.supportedModesIcon = []; // clear items

        // In case of Single RAC, if we don't get supported modes from getDevice response, add 'Auto, Cool, Dry, Fan'
        // and Heat is depends upon option code
        if (isSingleRAC() && $scope.supportedModes.length === 0) {
            $scope.supportedModes = [strCool, strDry, strWind, strAuto];
        } else if(isHomeMultiRAC()) {
            // 1stJan2016 - As per Kim, if heat is available and HeatClean is not available
            // in supported modes array then add HeatClean in FAC, Home Multi RAC for all models
            if(~$scope.supportedModes.indexOf("Heat") && !~$scope.supportedModes.indexOf("HeatClean")) {
                $scope.supportedModes.push("HeatClean");
            }
        }

        $scope.supportedModes.forEach(function (value) {
            updateImageIDInModes(value);
        });
        
        // If option code's 9th bit is zero, then add heat mode - Single RAC
        if (isSingleRAC() && !isCoolOnlyOption()) {    
            if ($scope.supportedModes.indexOf(strHeat) === -1) {
                updateImageIDInModes(strHeat);
            }
        }

	// Lokesh 11Dec15_1536 -> As per Mr. Kim, For Home Multi RAC, don't use option code to add any modes. Rely only on Supported Modes. Hence, removed check for Home Multi RAC.	
//	// If option code last bit is 0, then add heat, heat purify mode - Home Multi RAC
//        if ($scope.deviceID === RACCONST.HOMEMULTI_RAC) {
//            if ($scope.RacOptionCode % 2 === 0) {
//                if ($scope.supportedModes.indexOf("Heat") === -1) {
//                    $scope.updateImageIDInModes("Heat");
//                }
//                if ($scope.supportedModes.indexOf("HeatClean") === -1) {
//                    $scope.updateImageIDInModes("HeatClean");
//                }
//            }
//        }
        
        // Sorting the array based on requirement
        $scope.supportedModesIcon.sort(function (a, b) {
            return a.id - b.id;
        });
    }
    function updateImageIDInModes(mode) {
        $scope.listOfModes.forEach(function (value) {
            if (value.modeName === mode) {
                $scope.supportedModesIcon.push({"id": value.id, "imageID": value.imageID, "modeName": value.modeName, "textToDisplay": value.textToDisplay});
            }
        });
    }
    $scope.getModeText = function (mode) {
        var temp;
        $scope.listOfModes.forEach(function (value) {
            if (value.modeName === mode) {
                temp = value.textToDisplay;
            }
        });
        return temp;
    };
    // Mode updation end

    // Wind strength start
    $scope.getWindStrengthText = function (speed) {
        var temp;
        $scope.listWindStrength.forEach(function (value) {
            if (value.id === speed) {
                temp = value.textToDisplay;
            }
        });
        if (isSingleRAC() && $scope.fastturbo) {
            return "RACMOB_wind_level_turbo";
        }
        return temp;
    };
    $scope.getWindStrengthImage = function (speed) {
        var temp;
        $scope.listWindStrength.forEach(function (value) {
            if (value.id === speed) {
                temp = value.imageID;
            }
        });
        if (isSingleRAC() && $scope.fastturbo) {
            temp = "FAC/assets/img/main_list_ic_wind_turbo.svg#Layer_1";
        }
        var svg = document.getElementById('windSVG');
        SHPService.loadSVG(temp, svg);
        //return temp;
    };
    function getWindStrengthObj(mode) {
        var temp;
        $scope.listWindStrength.forEach(function (value) {
            if (value.modeName === mode) {
                temp = value;
            }
        });
        return temp;
    }
    function updateWindStrengthList(mode) {
        $scope.supportedWindStrength = [];
        switch (mode) {
            case strAuto:
            case strDry:
            case "DryClean":
                $scope.supportedWindStrength.push(getWindStrengthObj(strAuto));
                break;
            case strCool:
            case "CoolClean":
            case strHeat:
            case "HeatClean":
                $scope.supportedWindStrength.push(getWindStrengthObj(strAuto));
                $scope.supportedWindStrength.push(getWindStrengthObj("Low"));
                $scope.supportedWindStrength.push(getWindStrengthObj("Medium"));
                $scope.supportedWindStrength.push(getWindStrengthObj("High"));
                $scope.supportedWindStrength.push(getWindStrengthObj("Turbo"));
                break;
            case strWind:
                $scope.supportedWindStrength.push(getWindStrengthObj("Low"));
                $scope.supportedWindStrength.push(getWindStrengthObj("Medium"));
                $scope.supportedWindStrength.push(getWindStrengthObj("High"));
                $scope.supportedWindStrength.push(getWindStrengthObj("Turbo"));
                break;
            default:
                break;
        }
        if ($scope.dlightcool || $scope.quiet || $scope.nanoWind || (($scope.currentMode === strCool || $scope.currentMode === "CoolClean") && $scope.goodSleep)
                || (($scope.stepcooling || $scope.fastturbo || $scope.comfort) && isHomeMultiRAC())) {
            $scope.supportedWindStrength = [];
            $scope.supportedWindStrength.push(getWindStrengthObj(strAuto));
            $scope.currentWindStrength = 0;
        }
    }
    // Wind strength end

    // Wind direction start
    $scope.getWindDirectionText = function (direction) {
        var temp;
        $scope.listWindDirection.forEach(function (value) {
            if (value.modeName === direction) {
                temp = value.textToDisplay;
            }
        });
        return temp;
    };
    $scope.getWindDirectionImage = function (direction) {
        var temp;
        $scope.listWindDirection.forEach(function (value) {
            if (value.modeName === direction) {
                temp = value.imageID;
            }
        });
        var svg = document.getElementById('windDirSVG');
        SHPService.loadSVG(temp, svg);
        //return temp;
    };
    function getWindDirectionObj(mode) {
        var temp;
        $scope.listWindDirection.forEach(function (value) {
            if (value.modeName === mode) {
                temp = value;
            }
        });
        return temp;
    }
    function updateWindDirectionList(mode) {
        $scope.supportedWindDirection = [];
        switch (mode) {
            case strAuto:
            case strCool:
            case strDry:
            case strWind:
            case strHeat:
            case "CoolClean":
            case "DryClean":
            case "HeatClean":
                $scope.supportedWindDirection.push(getWindDirectionObj("Fix"));
                $scope.supportedWindDirection.push(getWindDirectionObj("Up_And_Low"));
                if ((isSingleRAC() && isLeftRightLouver()) || (isHomeMultiRAC() && $scope.RacOptionCode % 2 === 1)) {
                    $scope.supportedWindDirection.push(getWindDirectionObj("Left_And_Right"));
                    $scope.supportedWindDirection.push(getWindDirectionObj("All"));
                }
                break;
            default:
                break;
        }

        // When good sleep is ON and it is home multi rac then only show fix
        if ($scope.goodSleep && isHomeMultiRAC()) {
            $scope.supportedWindDirection = [];
            $scope.supportedWindDirection.push(getWindDirectionObj("Fix"));
            $scope.currentWindDirection = "Fix";
        }
    }
    // Wind direction end

    // Show popup
    $scope.openPopoverMode = function () {
        if ($scope.powerOperation) {
            $scope.showModeSelectionPopup = true;
            changePopUpClass();
        }
    };
    // close popovermode
    $scope.closePopoverMode = function () {
        $scope.showModeSelectionPopup = false;
        changePopUpClass();
    };
    $scope.openPopoverWindStrength = function () {
        $timeout(function () {
            if (!$scope.disableWindStrength) {
                $scope.showWindStrengthPopup = true;
                toggleBottomPopUpClass($scope.showWindStrengthPopup);
            }
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };
    $scope.openPopoverWindDirection = function () {
        $timeout(function () {
            if (!$scope.disableWindDirection) {
                $scope.showWindDirectionPopup = true;
                toggleBottomPopUpClass($scope.showWindDirectionPopup);
            }
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };


    // My wind popups
    $scope.openMyWindModeSelection = function () {
        $timeout(function () {
            $scope.showAddWindModeSelectionPopup = true;
            toggleBottomPopUpClass($scope.showAddWindModeSelectionPopup);
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };
    $scope.openMyWindWindStrength = function () {
        $timeout(function () {
            $scope.showWindStrengthPopup = true;
            toggleBottomPopUpClass($scope.showWindStrengthPopup);
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };
    $scope.openMyWindWindDirection = function () {
        $timeout(function () {
            $scope.showWindDirectionPopup = true;
            toggleBottomPopUpClass($scope.showWindDirectionPopup);
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };

    $scope.openPopoverFilterReset = function () {
        $timeout(function () {
            $scope.filterResetPopup = true;
            toggleBottomPopUpClass($scope.filterResetPopup);
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };
    $scope.openPopoverColorWind = function () {
        $timeout(function () {
            $scope.showColorOfWindPopup = true;
            toggleBottomPopUpClass($scope.showColorOfWindPopup);
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };
    // popup selection - onClick
    $scope.selectMode = function (selectedItem) {
        if ($scope.currentScreen === RACSCREENS.HOME) {
            $scope.showModeSelectionPopup = false;
            changePopUpClass();
            if ($scope.currentMode !== selectedItem.modeName || (selectedItem.modeName === strAuto && ($scope.currentWindDirection === "Up_And_Low" || $scope.currentWindDirection === "All"))) {
                if (!$scope.isStatic) {
                    $scope.checkResponse.push(RACCONST.MODECHANGE);
                    SHPService.sendSHPCommand(CONSTANTS.PUT, getModeCommand(selectedItem.modeName, $scope.defaultConfig[selectedItem.modeName].configWindDirection, $scope.defaultConfig[selectedItem.modeName].configWindStrength, $scope.defaultConfig[selectedItem.modeName].configTempDefault, $scope.currentWindDirection), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
                } else {
                    $scope.currentMode = selectedItem.modeName;
                }
            }
            isMonthSelected = false;
        } else if ($scope.currentScreen === RACSCREENS.ADDWIND) {
            $scope.showAddWindModeSelectionPopup = false;
            toggleBottomPopUpClass($scope.showAddWindModeSelectionPopup);
            $scope.selectedWind.mode = selectedItem.modeName;
            updateWindStrengthList($scope.selectedWind.mode);
            $scope.selectedWind.temp = $scope.defaultConfig[$scope.selectedWind.mode].configTempDefault;
            if ($scope.selectedWind.mode === strWind) {
                $scope.selectedWind.windStrength = 1;
            } else {
                $scope.selectedWind.windStrength = 0;
            }
        } else {
            // Nothing
        }
    };
    $scope.isModeSelected = function (selectedItem) {
        if ($scope.currentScreen === RACSCREENS.HOME) {
            return $scope.currentMode === selectedItem.modeName;
        } else if ($scope.currentScreen === RACSCREENS.ADDWIND) {
            return ($scope.selectedWind.mode === selectedItem.modeName);
        } else {
            // Nothing
        }
        return false;   //default value.
    };
    
    $scope.selectWindStrenth = function (selectedItem) {
        $scope.showWindStrengthPopup = false;
        toggleBottomPopUpClass($scope.showWindStrengthPopup);
        if ($scope.currentScreen === RACSCREENS.HOME) {
            if ($scope.currentWindStrength !== selectedItem.id) {
                if (!$scope.isStatic) {
                    $scope.checkResponse.push(RACCONST.WINDSTRENGTH_CHANGE);
                    $scope.defaultConfig[$scope.currentMode].configWindStrength = selectedItem.id;
                    SHPService.sendSHPCommand(CONSTANTS.PUT, getWindStrengthCommand(selectedItem.id), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
                } else {
                    $scope.currentWindStrength = selectedItem.id;
                }
            }
        } else if ($scope.currentScreen === RACSCREENS.ADDWIND) {
            $scope.selectedWind.windStrength = selectedItem.id;
        } else {
            // Nothing
        }
    };
    $scope.isWindStrengthSelected = function (selectedItem) {
        if ($scope.currentScreen === RACSCREENS.HOME) {
            return ($scope.currentWindStrength === selectedItem.id);
        } else if ($scope.currentScreen === RACSCREENS.ADDWIND) {
            return ($scope.selectedWind.windStrength === selectedItem.id);
        } else {
            // Nothing
        }
        return false; //default value.
    };
    $scope.selectWindDirection = function (selectedItem) {
        $scope.showWindDirectionPopup = false;
        toggleBottomPopUpClass($scope.showWindDirectionPopup);
        if ($scope.currentScreen === RACSCREENS.HOME) {
            if ($scope.currentWindDirection !== selectedItem.modeName) {
                if (!$scope.isStatic) {
                    $scope.checkResponse.push(RACCONST.WINDDIRECTION_CHANGE);
                    $scope.defaultConfig[$scope.currentMode].configWindDirection = selectedItem.modeName;
                    SHPService.sendSHPCommand(CONSTANTS.PUT, getWindDirectionCommand(selectedItem.modeName), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
                } else {
                    $scope.currentWindDirection = selectedItem.modeName;
                }
            }
        } else if ($scope.currentScreen === RACSCREENS.ADDWIND) {
            $scope.selectedWind.windDirection = selectedItem.modeName;
        } else {
            // Nothing
        }
    };
    $scope.isWindDirectionSelected = function (selectedItem) {
        if ($scope.currentScreen === RACSCREENS.HOME) {
            return ($scope.currentWindDirection === selectedItem.modeName);
        } else if ($scope.currentScreen === RACSCREENS.ADDWIND) {
            return ($scope.selectedWind.windDirection === selectedItem.modeName);
        } else {
            // Nothing
        }
        return false; //default value.
    };
    $scope.selectColorWind = function (selectedItem) {
        $scope.showColorOfWindPopup = false;
        toggleBottomPopUpClass($scope.showColorOfWindPopup);
        if ($scope.currentColorOfWind !== selectedItem.key) {
            if (!$scope.isStatic) {
                $scope.checkResponse.push(RACCONST.COLOROFWIND);
                SHPService.sendSHPCommand(CONSTANTS.PUT, getColorWindCommand(selectedItem.key), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
            } else {
                $scope.currentColorOfWind = selectedItem.key;
                disableItems();
            }
        }
    };
    $scope.isColorOfWindSelected = function (selectedItem) {
        return ($scope.currentColorOfWind === selectedItem.key);
    };
    $scope.getColorOfWindSelected = function () {
        var temp;
        $scope.ListOfColorWind.forEach(function (item) {
            if ($scope.currentColorOfWind === item.key) {
                temp = item.textToDisplay;
            }
        });
        return temp;
    };

    // Filter page start
    $scope.openPopoverOptimusTime = function () {
        $timeout(function () {
            $scope.showOptimusTimePopup = true;
            toggleBottomPopUpClass($scope.showOptimusTimePopup);
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };
    $scope.filterResetOK = function () {
        $scope.filterResetPopup = false;
        if (!$scope.isStatic) {
            if ($scope.resetOptimusTimeHrs === 0 && $scope.resetOptimusTimeMns === 0) {
                // If Hrs and Mns are 0, don't send for reset command
            } else {
                $scope.checkResponse.push(RACCONST.FILTERTIME);
                SHPService.sendSHPCommand(CONSTANTS.PUT, getFilterResetCommand(), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
            }
        } else {
            $scope.resetOptimusTimeHrs = 0;
            $scope.resetOptimusTimeMns = 0;
            $scope.showFilterTimeHours = false;
            filterLayerStyle();
            filterNotificationClose();
        }
    };
    $scope.filterResetCancel = function () {
        $scope.filterResetPopup = false;
    };
    function filterLayerStyle() {
        if ($scope.currentScreen === RACSCREENS.FILTER) {
            var filterLayerElement = document.getElementById('filterlayerstyle');
            var areacovered = (($scope.resetOptimusTimeHrs + ($scope.resetOptimusTimeMns / 60)) / $scope.setOptimusTime) * 100;
            if (areacovered > 100) {
                filterLayerElement.style.width = "100%";
                filterLayerElement.style.backgroundColor = "#ff7366";
                $scope.showFilterAlertLayerText = true;
            } else {
                areacovered = areacovered + '%';
                filterLayerElement.style.width = areacovered;
                filterLayerElement.style.backgroundColor = "#89cfec";
                $scope.showFilterAlertLayerText = false;
            }
        }
    }
    $scope.selectOptimusTime = function (selectedItem) {
        $timeout(function () {
            $scope.showOptimusTimePopup = false;
            toggleBottomPopUpClass($scope.showOptimusTimePopup);
            if ($scope.setOptimusTime !== selectedItem.value) {
                if (!$scope.isStatic) {
                    $scope.checkResponse.push(RACCONST.FILTERALARMTIME);
                    SHPService.sendSHPCommand(CONSTANTS.PUT, getFilterOptimusTimeCommand(selectedItem.value), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
                } else {
                    $scope.setOptimusTime = selectedItem.value;
                    filterLayerStyle();
                    filterNotificationOpen();
                }
            }
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };
    /* Filter page end */


    // Schedule logic start (schedule list, add/edit/remove schedule)
    //give weather day list in local language.
    $scope.getWeatherDayList = ScheduleService.getWeatherDayList;
    
    function checkForScheduleDataAvailable(length) {
        $scope.scheduleDataAvailable = !!length;
    }

    function parseActionData(actData) {
        var len,
                cnt1,
                cnt2,
                tempSch1,
                tempSch2;
        checkForScheduleDataAvailable(actData.length);

        if (actData.length > 0) {
            // Remove the items if device ID is not matching
            for (var k = actData.length - 1; k >= 0; k--) {
                if (angular.isDefined(actData[k].Actuators)) {
                    if (actData[k].Actuators[0].deviceIDs[0] !== $scope.deviceID.toString()) {
                        actData.splice(k, 1);
                    } else {
                        // Nothing
                    }
                }
            }
            checkForScheduleDataAvailable(actData.length);

            //Lokesh -> patch for deleting duplicate schedule.
            //Hope once FAC hardware starts working fine, we will not need this code.
            len = actData.length;
            for (cnt1 = 0; cnt1 < len; ++cnt1) {
                for (cnt2 = cnt1 + 1; cnt2 < len; ++cnt2) {
                    tempSch1 = angular.copy(actData[cnt1]); //avoid refernce assignment. Copy whole object.
                    tempSch2 = angular.copy(actData[cnt2]); //avoid refernce assignment. Copy whole object.
                    tempSch1.id = tempSch2.id = ''; //Ids can be different. So, ignore them.

                    if (JSON.stringify(tempSch1) === JSON.stringify(tempSch2)) {
                        actData.splice(cnt2, 1);
                        --len;
                        --cnt2;
                    }
                }
            }

            for (var i = 0; i < actData.length; i++) {
                if ($scope.Actions[i] === undefined) {
                    $scope.Actions[i] = {id: '', 'Actuators': [{Operation: {power: ''}, deviceIDs: []}], dayOfWeek: [], disposable: false, enabled: true, startTime: ''};
                }
                if (angular.isDefined(actData[i].id)) {
                    $scope.Actions[i].id = actData[i].id;
                }
                if (angular.isDefined(actData[i].Actuators) && actData[i].Actuators.length > 0) {
                    var Actuators = actData[i].Actuators;
                    for (var j = 0; j < Actuators.length; j++) {
                        if ($scope.Actions[i].Actuators[j] === undefined) {
                            $scope.Actions[i].Actuators[j] = {Operation: {power: ''}, deviceIDs: []};
                        }
                        if (angular.isDefined(Actuators[j].Operation) && angular.isDefined(Actuators[j].Operation.power)) {
                            $scope.Actions[i].Actuators[j].Operation.power = Actuators[j].Operation.power;
                        }
                        if (angular.isDefined(Actuators[j].deviceIDs)) {
                            $scope.Actions[i].Actuators[j].deviceIDs = Actuators[j].deviceIDs;
                        }
                    }
                }
                if (!!actData[i].dayOfWeek && !!actData[i].startTime) {
                    $scope.Actions[i].dayOfWeek = ScheduleService.getAdjustedWeekDays(actData[i].dayOfWeek, actData[i].startTime);
                }
                if (angular.isDefined(actData[i].disposable)) {
                    $scope.Actions[i].disposable = actData[i].disposable;
                }
                if (angular.isDefined(actData[i].enabled)) {
                    $scope.Actions[i].enabled = actData[i].enabled;
                }
                if (angular.isDefined(actData[i].startTime)) {
                    $scope.Actions[i].startTime = actData[i].startTime;
                    var gmt = ScheduleService.setTimeInGMT(actData[i].startTime);;

                    $scope.Actions[i].newStartTime = gmt[0] + ':' + gmt[1];
                    $scope.Actions[i].timeConvention = gmt[2];
                }
            }
        }
        for (var m = actData.length; m < $scope.Actions.length; m++) {
            $scope.Actions.splice(m, 1);
        }
        if ($scope.Actions.length === 0) {
            $scope.ScheduleText = $scope.translation.WEBMOB_common_none;
        } else {
            ScheduleService.calculateUpcomingSchedule($scope);
        }
        dismissLoadingBar(RACCONST.SCHEDULEDATA);
    }
    
    function addSchedule(act) {
        ScheduleService.addSchedule($scope, act);
    }

    $scope.asTabSelected = function (bool) {
        ScheduleService.asTabSelected($scope, bool);
    };
    $scope.increaseHours = function () {
        ScheduleService.increaseHours($scope);
    };
    $scope.decreaseHours = function () {
        ScheduleService.decreaseHours($scope);
    };

    $scope.onAsRepeatWeakly = function () {
        ScheduleService.onAsRepeatWeakly($scope);
    };
    $scope.increaseMinutes = function () {
        ScheduleService.increaseMinutes($scope);
    };

    $scope.decreaseMinutes = function () {
        ScheduleService.decreaseMinutes($scope);
    };
    $scope.changeMeridian = function () {
        ScheduleService.changeMeridian($scope);
    };

    $scope.saveSchedule = function () {
        ScheduleService.saveSchedule($scope);
    };


    //This code will be required later. please don't delete it.
    $scope.keypadClicked = function () {
        ScheduleService.keypadClicked();
    };

    $scope.daySelected = function (dayValue) {
        ScheduleService.daySelected($scope, dayValue);
    };

    $scope.dayColorSelected = function (dayValue) {
        return ScheduleService.dayColorSelected($scope, dayValue);
    };

    $scope.removeItemFromSchedule = function (schedule) {
        ScheduleService.removeItemFromSchedule($scope, schedule, RACCONST.SCHEDULEDATA);
    };
    
    // Schedue logic end

    // Wind logic start here
    function addWind(item) {
        if (item === -1) {
            if ($scope.windList.length === 10) {
                toaster.clear();
                $timeout(function () {
                    toaster.success({title: "", body: $scope.translation.RACMOB_mywind_max_10_noti, bodyOutputType: 'trustedHtml'});
                }, 500);
                return;
            }
            $scope.isEditWindMode = false;
            $scope.selectedWind = {};
            $scope.selectedWind.id = $scope.generateWindID();
            $scope.selectedWind.name = $scope.generateWindName();
            $scope.selectedWind.mode = $scope.currentMode;
            $scope.selectedWind.temp = parseInt($scope.desiredTemp, 10);
            $scope.selectedWind.windStrength = $scope.currentWindStrength;
            $scope.selectedWind.windDirection = $scope.currentWindDirection;
        } else {
            $scope.isEditWindMode = true;
            $scope.selectedWind = Object.create(item);
        }
        updateWindStrengthList($scope.selectedWind.mode);
        $scope.gotoAddMyWind();
    };

    $scope.saveWind = function () {
        toaster.clear();
        updateWindNameFromInputField();
        if ($scope.selectedWind.name.length === 0) {
            $timeout(function () {
                toaster.success({title: "", body: $scope.translation.RACMOB_mywind_please_input_name, bodyOutputType: 'trustedHtml'});
            }, 500);
            return;
        }

        if (!$scope.isEditWindMode) {
            var duplicateNameExist = false;
            for (var a = 0; a < $scope.windList.length; a++) {
                if ($scope.windList[a].name === $scope.selectedWind.name) {
                    duplicateNameExist = true;
                    toaster.clear();
                    $timeout(function () {
                        toaster.success({title: "", body: $scope.translation.WEBMOB_common_duplicate_name, bodyOutputType: 'trustedHtml'});
                    }, 500);
                    break;
                }
            }
            if (!duplicateNameExist) {
                $scope.windList.push($scope.selectedWind);
                setLocalStorageData(currentWindKey, JSON.stringify($scope.windList));
                $scope.gotoMyWindList();
                toaster.clear();
                $timeout(function () {
                    toaster.success({title: "", body: $scope.translation.RACMOB_mywind_saved, bodyOutputType: 'trustedHtml'});
                }, 500);
            }
        } else {
            for (var b = 0; b < $scope.windList.length; b++) {
                if ($scope.windList[b].id === $scope.selectedWind.id) {
                    $scope.windList[b].name = $scope.selectedWind.name;
                    $scope.windList[b].mode = $scope.selectedWind.mode;
                    $scope.windList[b].temp = $scope.selectedWind.temp;
                    $scope.windList[b].windStrength = $scope.selectedWind.windStrength;
                    $scope.windList[b].windDirection = $scope.selectedWind.windDirection;
                    setLocalStorageData(currentWindKey, JSON.stringify($scope.windList));
                    $scope.gotoMyWindList();
                    $timeout(function () {
                        toaster.success({title: "", body: $scope.translation.RACMOB_mywind_saved, bodyOutputType: 'trustedHtml'});
                    }, 500);
                    break;
                }
            }
        }
    };
    
    // Model is not getting the latest value of input field by itself when predictive text is enabled on mobile.
    // Hence, we've to give the latest inputs to the model explicitly.
    function updateWindNameFromInputField() {
        $scope.selectedWind.name = document.getElementById("addWindNameID").value;
    }

    $scope.removeItemFromWind = function (item) {
        $scope.windList.forEach(function (value, index) {
            if (value.id === item.id) {
                $scope.windList.splice(index, 1);
            }
        });
        setLocalStorageData(currentWindKey, JSON.stringify($scope.windList));
        toaster.clear();
        $timeout(function () {
            toaster.success({title: "", body: $scope.translation.WEBMOB_common_schedule_delete_success, bodyOutputType: 'trustedHtml'});
        }, 500);
        
    };
    $scope.windItemToggleUpdate = function (item) {
        item.enabled = !item.enabled;
        $scope.windList.forEach(function (value) {
            if (value.id !== item.id) {
                value.enabled = false;
            }
        });
    };
    var myWindCommandFlag = false;
    $scope.sendMyWindCommand = function (item) {
        if (!$scope.isStatic) {
            if (!$scope.powerOperation) {
                SHPService.sendSHPCommand(CONSTANTS.PUT, getPowerCommand($scope.powerOperation), "/" + $scope.peerId + "/devices/" + $scope.deviceID + "/operation");
            }
            $scope.checkResponse.push(RACCONST.WINDCOMMAND);
            SHPService.sendSHPCommand(CONSTANTS.PUT, getModeCommand(item.mode, item.windDirection, item.windStrength, item.temp), "/" + $scope.peerId + "/devices/" + $scope.deviceID);
            myWindCommandFlag = true;
        }
    };

    // Findout maxium ID value and add plus one to generate new ID
    $scope.generateWindID = function () {
        var max = 0;
        $scope.windList.forEach(function (item) {
            if (item.id > max) {
                max = item.id;
            }
        });
        return max + 1;
    };
    // Find out missing wind ID from 1 to 10 to generate new wind name
    $scope.generateWindName = function () {
        var myWindStr = $scope.translation.RACMOB_mywind + " ";
        if ($scope.windList.length === 0) {
            return myWindStr + "1";
        }
        var tempWindName;
        var windNameNotAvailable = false;
        for (var i = 1; i <= 10; i++) {
            tempWindName = myWindStr + i;
            for (var j = 0; j < $scope.windList.length; j++) {
                if ($scope.windList[j].name === tempWindName) {
                    windNameNotAvailable = false;
                    break;
                } else {
                    windNameNotAvailable = true;
                }
            }
            if (windNameNotAvailable) {
                break;
            }
        }
        return tempWindName;
    };
    // Wind logic end here


    // Request fail handler
    $scope.requestFailHandler = function (response) {
        // When requestFailed occurs, dismiss loading bar
        $scope.checkResponse = [];
        $scope.loadingBar = false;

        var msg;
        if (angular.isDefined(response["resourceURL"]) && response["resourceURL"].indexOf("/actions") !== -1 && response["resourceURL"].indexOf("/actions/") === -1) {
            toaster.clear();
            $timeout(function () {
                toaster.success({title: "", body: $scope.translation.WEBMOB_common_schedule_save_failed, bodyOutputType: 'trustedHtml'});
            }, 500);

            scheduleList();

        } else if (angular.isDefined(response["resourceURL"]) && response["resourceURL"].indexOf("/actions/") !== -1) {
            if (response.data.message.indexOf('InvokeDelScheduleFunc') !== -1) {
                msg = $scope.translation.WEBMOB_common_schedule_delele_fail_reservation;
            } else if (response.data.message.indexOf('InvokeSetScheduleFunc') !== -1) {
                msg = $scope.translation.WEBMOB_common_schedule_save_failed;
            } else {
                // Nothing
            }
            if (angular.isDefined(msg)) {
                toaster.clear();
                $timeout(function () {
                    toaster.success({title: "", body: msg, bodyOutputType: 'trustedHtml'});
                }, 500);
            }
            scheduleList();
        } else {
            // Nothing
        }
    };

    // Connection failure handling
    function showConnectionFailurePopup() {
        dismissAllPopups();
        document.getElementById("connFailCancel").style.visibility = 'hidden';
        $scope.showConnFailurePopup = true;
        toggleBottomPopUpClass($scope.showConnFailurePopup);
    }
    
    function closeConnectionFailurePopup() {
        $scope.showConnFailurePopup = false;
        toggleBottomPopUpClass($scope.showConnFailurePopup);
    }

    $scope.connFailureAction = function () {
        $scope.closeApp();
    };

    function handleStatusCode(status, response) {
        //handle schedule list in later section
        if (status === RACCONST.STATUS_204 && $scope.currentScreen !== RACSCREENS.SCHEDULELIST) {
            if (myWindCommandFlag) {
                myWindCommandFlag = false;
                dismissLoadingBar(RACCONST.WINDCOMMAND);
            } else {
                //None.
            }
        } else if ($scope.currentScreen === RACSCREENS.SCHEDULELIST && !!!response.data && status === RACCONST.STATUS_200) { //if status = 200, current screen is schedule list and no data object in response then this is response of schedule delete.
            toaster.clear();
            $timeout(function () {
                toaster.success({title: "", body: $scope.translation.WEBMOB_common_schedule_delete_success});
            }, 500);
            dismissLoadingBar(RACCONST.SCHEDULEDATA);
        } else if (($scope.currentScreen === RACSCREENS.SCHEDULELIST || $scope.currentScreen === RACSCREENS.ADDSCHEDULE) && status === RACCONST.STATUS_201) {
            //if status = 201, current screen is schedule list then this is response of add schedule.
            toaster.clear();
            $timeout(function () {
                toaster.success({title: "", body: $scope.translation.WEBMOB_common_schedule_save_successful, bodyOutputType: 'trustedHtml'});
            }, 500);
            dismissLoadingBar(RACCONST.SCHEDULEDATA);
        }
        //dismiss loading bar anonymously for all success responses.
        /** Lokesh_14Dec15_1648 -> Don't dismiss loading bar for power operation in Single RAC.
            Sometimes set delays the response of power on/ off. At that time, loading bar is closed from here after getting some other Acknowledgement. 
            This is causing discrepancy in power operation status. Hence, don't send dismissLoading command for power operation from here. 
         **/
        else if ($scope.checkResponse.length && !(isSingleRAC() && $scope.checkResponse[$scope.checkResponse.length - 1] === RACCONST.POWEROPERATION)) {   //on a positive side, check for fony success response.
            dismissLoadingBar($scope.checkResponse[$scope.checkResponse.length - 1]);
        } else {
            //None.
        }
    }

    function dismissLoadingBar(value) {
        if ($scope.checkResponse.indexOf(value) !== -1) {
            $scope.checkResponse.splice($scope.checkResponse.indexOf(value), 1);
            if ($scope.checkResponse.length === 0) {
                $scope.loadingBar = false;
            }
        }
    }


    /*Static Error page in about */
    $scope.erroTextArray = [
        "RACMOB_error_message_e101_result",
        "RACMOB_error_message_e121_result",
        "RACMOB_error_message_e122_result",
        "RACMOB_error_message_e123_result",
        "RACMOB_error_message_e154_result",
        "RACMOB_error_message_e162_result",
        "RACMOB_error_message_e163_result",
        "RACMOB_error_message_e201_result",
        "RACMOB_error_message_e202_result",
        "RACMOB_error_message_e203_result",
        "RACMOB_error_message_e221_result",
        "RACMOB_error_message_e231_result",
        "RACMOB_error_message_e251_result",
        "RACMOB_error_message_e320_result",
        "RACMOB_error_message_e403_result",
        "RACMOB_error_message_e404_result",
        "RACMOB_error_message_e416_result",
        "RACMOB_error_message_e422_result",
        "RACMOB_error_message_e425_result",
        "RACMOB_error_message_e440_result",
        "RACMOB_error_message_e441_result",
        "RACMOB_error_message_e458_result",
        "RACMOB_error_message_e461_result",
        "RACMOB_error_message_e462_result",
        "RACMOB_error_message_e463_result",
        "RACMOB_error_message_e464_result",
        "RACMOB_error_message_e465_result",
        "RACMOB_error_message_e466_result",
        "RACMOB_error_message_e467_result",
        "RACMOB_error_message_e468_result",
        "RACMOB_error_message_e469_result",
        "RACMOB_error_message_e470_result",
        "RACMOB_error_message_e471_result",
        "RACMOB_error_message_e472_result",
        "RACMOB_error_message_e473_result",
        "RACMOB_error_message_e474_result",
        "RACMOB_error_message_e475_result",
        "RACMOB_error_message_e483_result",
        "RACMOB_error_message_e484_result",
        "RACMOB_error_message_e485_result",
        "RACMOB_error_message_e488_result",
        "RACMOB_error_message_e500_result",
        "RACMOB_error_message_e554_result",
        "RACMOB_error_message_e660_result",
        "RACMOB_error_message_e237_result"
    ];

    $scope.openErrorTextArray = function (errordemoString) {
        var errorTxt = errordemoString.split("_")[3];
        $scope.selectedCountry = "KR";
        $scope.currentErrorCode = errorTxt;
        $scope.currentErrorDesc = "RACMOB_error_message_" + errorTxt + "_result";
        if ($scope.currentScreen !== RACSCREENS.ERRORPAGE) {
            $scope.previousScreen = $scope.currentScreen;
        }
        $scope.gotoErrorPage();
    };
    /*Static Error page in about end*/

    //when finish long press, update temp to the temp which is last value in screen. (changingDesiredTemp)
    $scope.stopLongPressEvent = function () {
        cancelInterval();
        if($scope.longPress) {
            $scope.longPress = false;
        }
        if (increaseTempConinous) {
            increaseTempConinous = false;
            updateTemp($scope.changingDesiredTemp);
        }
        if (decreaseTempConinous) {
            decreaseTempConinous = false;
            updateTemp($scope.changingDesiredTemp);
        }
    };

    function cancelInterval() {
        if (!!promise) {
            //check if promise exist. Then call cancel.
            $interval.cancel(promise);
            promise = undefined;
        }
    }
    
    $scope.increaseHrContinuously = function () {
        cancelInterval();
        if (!!!promise) {
            promise = $interval(function () {
                increaseHrTime();
            }, 200);
        }
    };

    $scope.decreaseHrContinuously = function () {
        cancelInterval();
        if (!!!promise) {
            promise = $interval(function () {
                decreaseHrTime();
            }, 200);
        }
    };

    $scope.increaseMinContinuously = function () {
        cancelInterval();
        if (!!!promise) {
            promise = $interval(function () {
                increaseMinTime();
            }, 200);
        }
    };

    $scope.decreaseMinContinuously = function () {
        cancelInterval();
        if (!!!promise) {
            promise = $interval(function () {
                decreaseMinTime();
            }, 200);
        }
    };

    function increaseHrTime() {
        $scope.selectedSchedule.hours = Number($scope.selectedSchedule.hours);
        if ($scope.selectedSchedule.hours !== 12) {
            $scope.selectedSchedule.hours += 1;
        } else {
            $scope.selectedSchedule.hours = 1;
        }
        $scope.selectedSchedule.hours = ($scope.selectedSchedule.hours < 10) ? ('0' + $scope.selectedSchedule.hours) : $scope.selectedSchedule.hours;

        document.getElementById("asHoursID").value = $scope.selectedSchedule.hours;
    }

    function decreaseHrTime() {
        $scope.selectedSchedule.hours = Number($scope.selectedSchedule.hours);
        if ($scope.selectedSchedule.hours > 1) {
            $scope.selectedSchedule.hours -= 1;
        } else {
            $scope.selectedSchedule.hours = 12;
        }
        $scope.selectedSchedule.hours = ($scope.selectedSchedule.hours < 10) ? ('0' + $scope.selectedSchedule.hours) : $scope.selectedSchedule.hours;

        document.getElementById("asHoursID").value = $scope.selectedSchedule.hours;
    }

    function increaseMinTime() {
        $scope.selectedSchedule.minutes = Number($scope.selectedSchedule.minutes);
        // defined steps as 1
        var step = 1;
        if ($scope.selectedSchedule.minutes !== (60 - step)) {
            $scope.selectedSchedule.minutes += step;
        } else {
            $scope.selectedSchedule.minutes = 0;
        }
        $scope.selectedSchedule.minutes = ($scope.selectedSchedule.minutes < 10) ? ('0' + $scope.selectedSchedule.minutes) : $scope.selectedSchedule.minutes;

        document.getElementById("asMinutesID").value = $scope.selectedSchedule.minutes;
    }

    function decreaseMinTime() {
        $scope.selectedSchedule.minutes = Number($scope.selectedSchedule.minutes);
        var step = 1;
        if ($scope.selectedSchedule.minutes !== 0) {
            $scope.selectedSchedule.minutes -= step;
        } else {
            $scope.selectedSchedule.minutes = 60 - step;
        }
        $scope.selectedSchedule.minutes = ($scope.selectedSchedule.minutes < 10) ? ('0' + $scope.selectedSchedule.minutes) : $scope.selectedSchedule.minutes;

        document.getElementById("asMinutesID").value = $scope.selectedSchedule.minutes;
    }

    // Energy simulator start
    var mBaseEnergy = 0.0;
    function setBaseEnergy(outTemp, tempSet) {
        mBaseEnergy = calculateEnergy(outTemp, tempSet);
    }

    function calculateEnergy(outTemp, tempSet) {
        var result = 0.0;

        // 관계식
        // 실외온도 35도 이상
        if (outTemp >= 35) {
            var alpha = 0.2 * (outTemp - 35);

            if (outTemp - tempSet < 8) {
                result = 1 - (8 - (outTemp - tempSet)) * 0.14 + 0.2 * alpha / (outTemp - tempSet);
            } else if (outTemp - tempSet > 8) {
                result = 1 + ((outTemp - tempSet) - 8) * 0.22 + (outTemp - tempSet) * 0.01 * alpha;
            } else {
                result = 1 + 0.08 * alpha;
            }
            // 실외온도 35도 미만
        } else if (outTemp < 35) {
            var beta = 0.2 * (outTemp - 25);

            if (outTemp - tempSet < 8) {
                if (outTemp - tempSet < 1) {
                    result = 1 - (8 - (1)) * 0.14 + 0.18 * beta / (1);
                } else {
                    result = 1 - (8 - (outTemp - tempSet)) * 0.14 + 0.18 * beta / (outTemp - tempSet);
                }
            } else if (outTemp - tempSet > 8) {
                result = 1 + ((outTemp - tempSet) - 8) * 0.22 + (outTemp - tempSet) * 0.01 * beta;
            } else {
                result = 1 + 0.08 * beta;
            }
        }

        // 10%보다 작으면 10%, 200%보다 높으면 200%
        if (result < 0.1) {
            result = 0.1;
        } else if (result > 2) {
            result = 2;
        }

        result = result * 100;
        return result;
    }

    function doEnergySimulator(desTemp) {
        if (isSingleRAC() && $scope.powerOperation && $scope.currentMode === strCool && isEnergySimulatorSupported()) {
            var energyValue = calculateEnergy($scope.outDoorTemp, desTemp) - mBaseEnergy;
            displayenergy(energyValue);
        }
    }

    function displayenergy(energyValue) {
        var unitStr = null;
        switch ($scope.temperatureUnit) {
            case strFahrenheit:
                unitStr = "℉";
                break;
            case strCelsius:
            default:
                unitStr = "℃";
                break;
        }

        if (energyValue <= 0) {
            //add -
            var saveStr = $scope.translation.RACMOB_energy_simulator_use;

            var percentStr = Math.abs(energyValue).toFixed(1) + "%";
            percentStr = "-" + percentStr;

            saveStr = saveStr.replace("#1#", percentStr);
            saveStr = saveStr.replace("#2#", parseInt($scope.desiredTemp, 10) + unitStr);
            toaster.clear();
            $timeout(function () {
                toaster.success({title: "", body: saveStr, bodyOutputType: 'trustedHtml'});
            }, 500);

        } else {
            //add +
            var useStr = $scope.translation.RACMOB_energy_simulator_use;

            var percentStr = Math.abs(energyValue).toFixed(1) + "%";
            percentStr = "+" + percentStr;

            useStr = useStr.replace("#1#", percentStr);
            useStr = useStr.replace("#2#", parseInt($scope.desiredTemp, 10) + unitStr);
            toaster.clear();
            $timeout(function () {
                toaster.success({title: "", body: useStr, bodyOutputType: 'trustedHtml'});
            }, 500);
        }
    }
    // Energy simulator end
    
    // First use guide starts here
    function showUsageHelpPage() {
        setTimeout(function(){
            document.getElementById("scrollable_area_id").scrollTop = 0;
        }, 10);
        $scope.bUsageHelpPage = true;
        tempFilterStatusShow = $scope.isFilterStatusShow;
        $scope.isFilterStatusShow = false;
    }

    function closeUsageHelpPage() {
        $scope.isFilterStatusShow = tempFilterStatusShow;
        $scope.bUsageHelpPage = false;        
    }
    // First use guide ends here
    
    // Option popup starts here
    function showOptionPopUp() {
        $scope.bOptionPopUp = true;
    }
     
    function closeOptionPopUp() {
       $scope.bOptionPopUp = false;
    }
    
    function selectIndexFromOptionMenu(optionMenuIndex) {
        switch (optionMenuIndex) {
            case 0:
                goToSettings();
                break;
            case 1:
                goToAbout();
                break;
            case 2:
                sendResetCommand();
                break;
            default:
                break;
        }
        closeOptionPopUp();
    }
    function showOptionItemsVisible(itemIndex) {
        var isVisible = (($scope.homePage && itemIndex < 2) || ($scope.energyMonitorPage && itemIndex === 2 && isEnergyReset()))?true:false;
        return isVisible;
    }
    // Option popup end here
    
    // In-App panel starts here
    function getFilterStatusVisibility() {
        if ($scope.isFilterStatusShow && $scope.homePage) {
            return true;
        }
        return false;
    }
    function filterNotificationOpen() {
        var areacovered = (($scope.resetOptimusTimeHrs + ($scope.resetOptimusTimeMns / 60)) / $scope.setOptimusTime) * 100;
        if (areacovered > 100) {
            $scope.isFilterStatusShow = true;
            $scope.inAppPanelPopupText = $scope.translation.RACMOB_filter_noti;
        } else {
            $scope.isFilterStatusShow = false;
        }
    }
    function filterNotificationClose() {
        $scope.isFilterStatusShow = false;
    }

    function isShow_aiConnectionFailPanel() {
        return ($scope.is_aiConnectionFail && $scope.aiConnectionFailTimerOn && $scope.homePage);
    }
    // In-App panel ends here
    
    function getScrollableAreaClass() {
        var scrollClass = "";
        if (isPopupOpen()) {
            scrollClass += "noscroll";
        }
        if ($scope.addSchedulePage || $scope.addWindPage) {
            if ($scope.isAppV2) {
                scrollClass += " scrollable_area_no_header scrollable_area_no_header_V2";
            } else {
                scrollClass += " scrollable_area_no_header";
            }
        } else if ($scope.homePage) {
            if ($scope.isAppV2) {
                if(getFilterStatusVisibility()) {
                    scrollClass += " scrollable_area scrollable_area_in_app_noti_V2";
                } else {
                    scrollClass += " scrollable_area scrollable_area_V2";
                }
            } else {
                if(getFilterStatusVisibility()) {
                    scrollClass += " scrollable_area scrollable_area_in_app_noti";
                } else {
                    scrollClass += " scrollable_area";
                }                    
            }
        } else if (!$scope.homePage) {
            if ($scope.isAppV2) {
                scrollClass += " scrollable_area_others scrollable_area_others_V2";
            } else {
                scrollClass += " scrollable_area_others";
            }
        }
        return scrollClass;
    }
    
    function getModeSelectionPopupClass() {
        var modeClass = ""; 
        if(getFilterStatusVisibility()) {
            if ($scope.isAppV2) {
                modeClass += " ModeSelectionPopupConInAppNoti_V2";
            } else {
                modeClass += " ModeSelectionPopupConInAppNoti";
            }
        } else {
            if ($scope.isAppV2) {
                modeClass += " ModeSelectionPopupCon_V2";
            }
        }
        return modeClass;
    }
    
    function openPopup(popupName) {
        debugMessage("openPopup >>>>>> name >>>>> " + popupName);
        switch(popupName) {
            case "serviceCenter": //Display service center numbers
                if ($scope.serviceCenterNumber !== undefined) {
                    $scope.radioBtnToSelect = [];
                    $scope.radioBtnSelectedIndex = 0;
                    if ($scope.serviceCenterNumber.indexOf(',') !== -1) {
                        $scope.isRadioSelection = true;
                        $scope.showServiceCenterText = true;
                        $scope.radioBtnToSelect = $scope.serviceCenterNumber.split(",");
                        showDialog(ALERT_STATE.SERVICE_CENTER_SELECTION, $scope.translation.WEBMOB_common_service_call, $scope.translation.WEBMOB_common_connect_service_call, $scope.translation.WEBMOB_common_cancel_capital, $scope.translation.WEBMOB_common_ok);
                    } else {
                        $scope.radioBtnToSelect[0] = $scope.serviceCenterNumber;
                        var msg = ($scope.translation.WEBMOB_common_connect_service_call) + "<br>" + ($scope.serviceCenterNumber || "");
                        showDialog(ALERT_STATE.SERVICE_CALL, $scope.translation.WEBMOB_common_service_call, msg, $scope.translation.WEBMOB_common_cancel_capital, $scope.translation.WEBMOB_common_ok);
                    }
                }
                break;    
            default:
                //Do nothing
                break;
        }
    }
    
    function showDialog(state, title, message,cancelBtn, okBtn) {
        debugMessage("showDialog", title);
        dismissAllPopups();
        $scope.alertState = state;        
        $scope.popupTitle = title;
        $scope.popupMessage = message;
        $scope.popupOkBtn = okBtn;
        $scope.popupCancelBtn = cancelBtn;
        $scope.dialogPopup = true;
        toggleBottomPopUpClass(true);
    }
    
    function popupBtnClicked(state) {
        debugMessage("popupBtnClick >>> State >>> " +state);
        if (state === 1) { //OK Click
            switch ($scope.alertState) {
                case ALERT_STATE.SERVICE_CENTER_SELECTION:
                    if ($scope.supportCalling) {
                        serviceCallCommand($scope.radioBtnToSelect[$scope.radioBtnSelectedIndex]);
                    }
                    break;
                 case ALERT_STATE.SERVICE_CALL:
                    if ($scope.supportCalling) {
                        serviceCallCommand($scope.radioBtnToSelect[0]);
                    }
                    break;
                default:
                    break;
            }
        } else if (state === 2) { //Cancel Click
            switch ($scope.alertState) {
                case ALERT_STATE.SERVICE_CENTER_SELECTION:
                    debugMessage("User canceled service center selection popup");
                    break;
                case ALERT_STATE.SERVICE_CALL:
                    debugMessage("User canceled service call popup");
                    break;    
                default:
                    break;
            }
        } else {
            //nothing
        }
        
        $scope.dialogPopup = false;
        $scope.alertState = -1;
        $scope.isRadioSelection = false;
        $scope.showServiceCenterText = false;
        toggleBottomPopUpClass(false);
    }
    
    function onRadioBtnSelected (selectedIndex) {
        debugMessage("selected index is " + selectedIndex);
        $scope.radioBtnSelectedIndex = selectedIndex;
    }
    
    function onKeypadShown(boolean) {
        if (!boolean && !$scope.isAppleDevice && $scope.inputFocusHoursMin) {
            document.activeElement.blur();
            $scope.inputFocusHoursMin = false;
        }
    }
    
    function showToast(title, body) {
        $timeout(function () {
            toaster.success({title: title, body: body, bodyOutputType: 'trustedHtml'});
        }, 500);
    }

    function isAIStatusOn(){
        return $scope.aiActive === RACCONST.AIWORKSTATUS_ON;
    }

    function isAIStatusIng(){
        return $scope.aiActive === RACCONST.AIWORKSTATUS_ING;
    }

    function isAIStatusOff(){
        return $scope.aiActive === RACCONST.AIWORKSTATUS_OFF;
    }
    
    function getAIGuideText(){
       var tempAIString = $scope.translation.WEBMOB_common_ai_status_text_on.replace('00', $scope.aiFavorTemp);
       return (isAIStatusIng())? $scope.translation.WEBMOB_common_ai_status_text_ing:(isAIStatusOn())?tempAIString:'';
    }
    
    function isAICoolLearningEnable(){        
        return ($scope.powerOperation && ($scope.stepcooling || $scope.sleep));
        //return true;
    }
    
    localInit();
    
    $scope.optionsMenu = [{
        id: 0,
        title: $scope.translation.WEBMOB_common_settings
    }, {
        id: 1,
        title: $scope.translation.WEBMOB_common_about_device
    }, {
        id: 2,
        title: $scope.translation.WEBMOB_common_energy_monitor_reset
    }];
    $scope.ScheduleText = $scope.translation.WEBMOB_common_none;
});
