/*******************************************************************************
 * @author Gaurav Sharma (g.sharma@samsung.com)
 * @file This file implements Dishwasher module and routes declaration
 * Copyright 2016 by Samsung Electronics, Inc.,
 * @license This software is the confidential and proprietary information of Samsung
 * Electronics, Inc. ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with Samsung.
 ******************************************************************************/
var debug_tag = 'REF',
app = angular.module("SmartHome", ['toaster', 'ngSanitize', 'ui.router', 'ngTouch']);
app.config(['$stateProvider', routeConfig]);
app.run(['$state', function ($state) {
    $state.transitionTo('SplashPage');
}]);

/**
 * @name routeConfig
 * @param {type} $stateProvider
 * @returns {Void}
 * @description Defines routes config for dishwasher pages, any new pages required for the module has to be defined here
 */
function routeConfig($stateProvider) {
    var SplashPage = {
        name: 'SplashPage',
        url: '/',
        templateUrl: 'common/views/splash.html'
    },
    AboutPage = {
        name: 'AboutPage',
        url: '/',
        templateUrl: 'REF/views/about.html'
    },
    SettingsPage = {
        name: 'SettingsPage',
        url: '/',
        templateUrl: 'REF/views/settings.html'
    },
    ErrorPage = {
        name: 'ErrorPage',
        url: '/',
        templateUrl: 'REF/views/error.html'
    },
    HomePage = {
        name: 'HomePage',
        url: '/',
        templateUrl: 'REF/views/home.html'
    },
    SelfCarePage = {
        name: 'SelfCarePage',
        url: '/',
        templateUrl: 'REF/views/self_care.html'
    },
    EnergyMonitorPage = {
        name: 'EnergyMonitorPage',
        url: '/',
        templateUrl: 'common/views/energyMonitor.html'
    };

    $stateProvider.state(SplashPage);
    $stateProvider.state(AboutPage);
    $stateProvider.state(SettingsPage);
    $stateProvider.state(ErrorPage);
    $stateProvider.state(HomePage);
    $stateProvider.state(SelfCarePage);
    $stateProvider.state(EnergyMonitorPage);
}