/*
 * This javascript file is used to show the press animation effect
 * 
 */

var prevTime, currentTime, timeOffset;
var PRESS_EFFECT_ANIMATION = 750;
var isAnim;

function addPressEffect(id, isAnimSupport){
   
    isAnim = isAnimSupport;
    setTimeout(function(){
        
        $(id).on("touchstart",   pressHandler);
        $(id).on("touchend", releaseHandler);
        $(id).on("touchcancel", releaseHandler);
        $(id).on("touchleave", releaseHandler);
        
        $(id).on("vmousecancel", releaseHandler);
        $(id).on("vmousedown", pressHandler);
	$(id).on("vmouseup", releaseHandler);
	$(id).on("vmouseout", releaseHandler);
	$(id).on("vmousecancel", releaseHandler);

    }, PRESS_EFFECT_ANIMATION);
	
    function pressHandler(e){
        prevTime = currentTime;
        var realTime = new Date();
        currentTime = realTime.getTime();
        timeOffset = currentTime - prevTime;

        if(prevTime == null){
            var rippleElement = $(this);
            addRippleElement(rippleElement, e);
        }
        else {
            if(timeOffset >= 50){
                var rippleElement = $(this);
                addRippleElement(rippleElement, e);
            }
        }
    }

    function releaseHandler(e) {
        var rippleElement = $(this);
        removeRippleElement(rippleElement, e);
    }
}

var addRippleElement = function(rippleElement, e) {
    console.log("***********Add ripple **************");
    if(isAnim){
        var zoomLevel = $("html").css("zoom");
        var touchX = event.touches[0].pageX;
    //  for each ripple element, set sizes
        var elementWidth = rippleElement.outerWidth();
        var elementHeight = rippleElement.outerHeight();
        var d = Math.max(elementWidth, elementHeight);

        var rippleX = (touchX / zoomLevel) - rippleElement.offset().left - d/2 + $(document).scrollLeft();

        var pressEffect = rippleElement.find('.ripple-press-effect');
        TweenMax.set(pressEffect, {css:{width:d, height:d, opacity:1, left:rippleX+"px", scaleX:0}});
        TweenMax.to(pressEffect, .3, {css:{scaleX:2.5}, ease:Sine.easeIn});
        
        var pressEffectActionBar = rippleElement.find('.ripple-press-effect-action-bar');
        TweenMax.set(pressEffectActionBar, {css:{width:d, height:d, opacity:1, left:rippleX+"px", scaleX:0}});
        TweenMax.to(pressEffectActionBar, .3, {css:{scaleX:2.5}, ease:Sine.easeIn});

    }
    else {
        var pressEffect = rippleElement.find('.ripple-press-effect');
	TweenMax.set(pressEffect, {css:{opacity:1}});
        
        var pressEffectActionBar = rippleElement.find('.ripple-press-effect-action-bar');
	TweenMax.set(pressEffectActionBar, {css:{opacity:1}});

    }
}

var removeRippleElement = function(rippleElement, e) {
    console.log("***********Remove ripple **************");
    
    var pressEffect = rippleElement.find('.ripple-press-effect');
    TweenMax.to(pressEffect, .2, {delay:.05, css:{opacity:0}, ease:Linear.easeNone});
    
    var pressEffectActionBar = rippleElement.find('.ripple-press-effect-action-bar');
    TweenMax.to(pressEffectActionBar, .2, {delay:.05, css:{opacity:0}, ease:Linear.easeNone});

}

