/* jQuery MaterialRipple Plugin */
/* 2014 Dominik Biedebach */

$.fn.materialripple = function(options) {
	var defaults = {
		rippleClass: 'ripple-wrapper'
	}
	$.extend(defaults, options);

	$('body').on('animationend webkitAnimationEnd oAnimationEnd', '.' + defaults.rippleClass, function () {
    removeRippleElement(this);
});

	var addRippleElement = function(element, e) {
		$(element).append('<span class="added '+defaults.rippleClass+'"></span>');
		newRippleElement = $(element).find('.added');
		newRippleElement.removeClass('added');

		// get Mouse Position
		var mouseX = e.pageX;
		var mouseY = e.pageY;

		// for each ripple element, set sizes
		elementWidth = $(element).outerWidth();
		elementHeight = $(element).outerHeight();
		d = Math.max(elementWidth, elementHeight);
		newRippleElement.css({'width': d, 'height': d});

		var rippleX = e.clientX - $(element).offset().left - d/2 + $(window).scrollLeft();
		var rippleY = e.clientY - $(element).offset().top - d/2 + $(window).scrollTop();

		// Position the Ripple Element
		newRippleElement.css('top', rippleY+'px').css('left', rippleX+'px').addClass('animated');
	}

	var removeRippleElement = function($element) {
		$element.remove();
	}

	// add Ripple-Wrapper to all Elements
	$(this).addClass('has-ripple');

	// Let it ripple on click
	$(this).bind('mouseup', function(e){
		addRippleElement(this, e);
	});
}


$.fn.materialrippleImp = function(options) {
	var defaults = {
		rippleClass: 'ripple-wrapper'
	}
	$.extend(defaults, options);

	$('body').on('animationend webkitAnimationEnd oAnimationEnd', '.' + defaults.rippleClass, function () {
		$(this).parent(".ripple.touchstart").removeClass("touchstart");
    removeRippleElement(this);
});

	var addRippleElement = function(element, e) {
    		$(element).append('<span class="added '+defaults.rippleClass+'"></span>');
		newRippleElement = $(element).find('.added');
		newRippleElement.removeClass('added');

		// get Mouse Position
		var mouseX = e.pageX;
		var mouseY = e.pageY;

		// for each ripple element, set sizes
		elementWidth = $(element).outerWidth();
		elementHeight = $(element).outerHeight();
		d = Math.max(elementWidth, elementHeight);
		newRippleElement.css({'width': d, 'height': d});

		var rippleX = e.clientX - $(element).offset().left - d/2 + $(window).scrollLeft();
		var rippleY = e.clientY - $(element).offset().top - d/2 + $(window).scrollTop();

		// Position the Ripple Element
		newRippleElement.css('top', rippleY+'px').css('left', rippleX+'px').addClass('animated');
	}

	var removeRippleElement = function($element) {
		$element.remove();
	}

	// add Ripple-Wrapper to all Elements
	$(this).addClass('has-ripple');

	// Let it ripple on click
	var rippleTimer = -1;
	$(this).bind('touchstart mousedown', function(e){
		$(this).addClass('touchstart');
		rippleTimer = setTimeout(function (el,ev) {
			rippleTimer = -1;
			addRippleElement(el,ev);
		}, 300, this, e);
		// addRippleElement(this, e);

	});
	$(this).bind('touchend mouseup', function(e){
	
		if (rippleTimer!=-1) {
			clearTimeout(rippleTimer);
			rippleTimer = null;
			addRippleElement(this,e);
			// $(this).removeClass('touchstart');
		}
	});
}



$.fn.materialrippletab = function(options) {
	var defaults = {
		rippletabClass: 'rippletab-wrapper'
	}
	$.extend(defaults, options);

	$('body').on('animationend webkitAnimationEnd oAnimationEnd', '.' + defaults.rippletabClass, function () {
    removeRippleElement(this);
});

	var addRippleElement = function(element, e) {
		$(element).append('<span class="added '+defaults.rippletabClass+'"></span>');
		newRippleElement = $(element).find('.added');
		newRippleElement.removeClass('added');

		// get Mouse Position
		var mouseX = e.pageX;
		var mouseY = e.pageY;

		// for each rippletab element, set sizes
		elementWidth = $(element).outerWidth();
		elementHeight = $(element).outerHeight();
		d = Math.max(elementWidth, elementHeight);
		newRippleElement.css({'width': d, 'height': d});

		var rippletabX = e.clientX - $(element).offset().left - d/2 + $(window).scrollLeft();
		var rippletabY = e.clientY - $(element).offset().top - d/2 + $(window).scrollTop();

		// Position the Ripple Element
		newRippleElement.css('top', rippletabY+'px').css('left', rippletabX+'px').addClass('animated');
	}

	var removeRippleElement = function($element) {
		$element.remove();
	}

	// add Ripple-Wrapper to all Elements
	$(this).addClass('has-rippletab');

	// Let it rippletab on click
	$(this).bind('click', function(e){
		addRippleElement(this, e);
	});
}

$.fn.materialChkBoxChecked = function (options) {
    var defaults = {
        rippleChkBoxClass: 'ripplechkbox-wrapper'
    }, lastEvTimestamp;
    $.extend(defaults, options);

    $('body').on('animationend webkitAnimationEnd oAnimationEnd', '.' + defaults.rippleChkBoxClass, function () {
        removeRippleElement(this);
    });
    var type = 1;
    var state = false;
    var addCheckBoxRippleElement = function (element, e) {
        $(element).addClass(defaults.rippleChkBoxClass);

				if (state) { // if checkbox is checked
					$(element).addClass('animatedChkA1').removeClass('checked').addClass('unchecked');
				} else {
					$(element).addClass('animatedChkA1').removeClass('unchecked').addClass('checked');
				}

    }

    var addChkAnimA2 = function (element) {
        $(element).addClass('animatedChkA2');
    }

    var addChkAnimB1 = function (element, e) {
        $(element).addClass('animatedChkB1');
    }

    var addChkAnimB2 = function (element, e) {
        $(element).addClass('animatedChkB2');
    }

    var addUnChkAnimA2 = function (element) {
        $(element).addClass('animatedUnChkA2');
    }

    var addUnChkAnimB1 = function (element, e) {
        $(element).addClass('animatedUnChkB1');
    }

    var addUnChkAnimB2 = function (element, e) {
        $(element).addClass('animatedUnChkB2');
    }

    var removeRippleElement = function ($element) {
        if (state) {
            switch (type) {
                case 1:
                    type = 2;
                    $($element).removeClass('animatedChkA1');
                    addChkAnimA2($element);
                    break;
                case 2:
                    type = 1;
                    $($element).removeClass('animatedChkA2').removeClass(defaults.rippleChkBoxClass);
                    // addChkAnimB1($element);
                    break;
                case 3:
                    type = 4;
                    $($element).removeClass('animatedChkB1');
                    addChkAnimB2($element);
                    break;
                case 4:
                    type = 1;
                    $($element).removeClass('animatedChkB2').removeClass(defaults.rippleChkBoxClass).removeClass('ripplechkbox2').removeClass('ripplechkbox3').addClass('ripplechkbox4').addClass('ripplechkbox5');
                    break;
                    break;
                default :
                    break;
            }
        }
        else {
            switch (type) {
                case 1:
                    type = 2;
                    $($element).removeClass('animatedChkA1');
                    addUnChkAnimA2($element);
                    break;
                case 2:
                    type = 1;
                    $($element).removeClass('animatedUnChkA2').removeClass(defaults.rippleChkBoxClass);
                    // addUnChkAnimB1($element);
                    break;
                case 3:
                    type = 4;
                    $($element).removeClass('animatedUnChkB1');
                    addUnChkAnimB2($element);
                    break;
                case 4:
                    type = 1;
                    $($element).removeClass('animatedUnChkB2').removeClass(defaults.rippleChkBoxClass).addClass('ripplechkbox2').addClass('ripplechkbox3').removeClass('ripplechkbox4').removeClass('ripplechkbox5');
                    break;
                default :
                    break;
            }
        }
    }

    // check box click
    $(this).bind('click', function (e) {
        if (e.timeStamp != lastEvTimestamp) {
            if($(this).hasClass(defaults.rippleChkBoxClass)) {
                $(this).removeClass('animatedChkA1').removeClass('animatedChkA2').removeClass('animatedUnChkA2').removeClass(defaults.rippleChkBoxClass);
            }
            type = 1;
            if ($(this).hasClass('checked')) {
                state = true;
            }
            else {
                state = false;
            }
           //e.stopPropagation();
            addCheckBoxRippleElement(this, e);
            lastEvTimestamp = e.timeStamp;
        }
    });


}