var isDaySelected = false;
var isMonthSelected = false;
var isWeekSelected = false;
var lastDayValueOnX = [];
var lastWeekValueOnX = [];
var lastMonthValueOnX = [];
var isLeftClicked = false;
var isAvailDay=false;
var isAvailMonth=false;
var isAvailWeek=false;
var isRunningTime = false;
var lastTabClicked ='';
/*******************************************************************************
 * @author Ajay Singh (ajay1.s@samsung.com), Manish Kumar(manish.kumar@samsung.com)
 * @file This file implements Energy monitor functions and services.  
 * Copyright 2015 by Samsung Electronics, Inc.,
 * @license This software is the confidential and proprietary information of Samsung
 * Electronics, Inc. ("Confidential Information"). You shall not disclose such
 * Confidential Information and shall use it only in accordance with the terms
 * of the license agreement you entered into with Samsung.
 ******************************************************************************/
//(function () {
    
    //'use strict';


var endDateNative='';
var deviceType;
var lastValueDayStored;
var lastValueWeekStored;
var lastValueMonthStored;
var isWeekAlreadyClicked = false;
var isMonthAlreadyClicked = false;

Date.prototype.yyyymmdd = function () {
    var yyyy = this.getFullYear().toString();
    var mm = (this.getMonth() + 1).toString(); // getMonth() is zero-based
    var dd = this.getDate().toString();
    return yyyy + (mm[1] ? mm : "0" + mm[0]) + (dd[1] ? dd : "0" + dd[0]); // padding
};

app.service("EnergyService", function (SHPService) {
    
    this.getYAxisValue = getYAxisValue;
    
    function getYAxisValue(value) {
        return value * getThreshold();
    }
    
    //welgate add
    this.currPage = null;
    this.energyManagerDataState = false;
    this.currMonthEnergyData = "0.0";
    this.prevMonthEnergyData = "0.0";
        
    this.goToEnergyMonitor = function($scope) {
    	this.currPage = 'energyMonitor';
        deviceType=$scope.deviceType;
        isWeekAlreadyClicked=false;
        isMonthAlreadyClicked=false;
        if(typeof ($scope.isRunningTimeGraph) !== 'undefined')
        {
            if($scope.isRunningTimeGraph)
            {
              isRunningTime=true;
            }
            else
             {
              isRunningTime=false;
             }
        }
        else
        {
             isRunningTime=false;
        }
        if ($scope.isStatic) {
            this.showDailyData($scope);
        } else {
            var date = new Date();
            lastValueDayStored = undefined;
            if(!energyResetDone) {
                nativeInterface.runOnNative("getEnergyData", '{"deviceUuid" : "' + $scope.deviceUuid + '", "date" : "'+date.yyyymmdd()+'","dataType" : "day","optionCode" :"'+$scope.optionCodeValue+'"}');
            }
            this.showDailyData($scope);
        }
    };
    
    this.showDailyData = function ($scope) {
        lastTabClicked = $scope.enrgyMonitorTab;
        $scope.enrgyMonitorTab = "day";  
        isDaySelected = true;
        isMonthSelected = false;
        isWeekSelected = false;
        if(energyResetDone){
            var date = new Date();
            var jsr = '{"dataType": "day","endDate":"'+date.yyyymmdd()+'", "energyData": [{"value": "0.0", "date":"'+ date.yyyymmdd()+'"}]}';
            jsr = JSON.parse(jsr);
            this.parseEnergyUsageData($scope, jsr);
        } else if (!$scope.isStatic) {
            makeDailyDatas($scope.deviceUuid, $scope.optionCodeValue, $scope.isStatic,false);
        } else {
            var jsr = {"dataType": "day","endDate":"20160215", "energyData": [{"value": "12.345", "date": "20160310"}, {"value": "21.657", "date": "20160309"}, {"value": "7.0904", "date": "20160308"}, {"value": "22", "date": "20151007"}]};
            this.parseEnergyUsageData($scope, jsr);

        }
    };
    
    this.showWeeklyData = function ($scope) {
        lastTabClicked = $scope.enrgyMonitorTab;
        $scope.enrgyMonitorTab = "week";
        isDaySelected = false;
        isMonthSelected = false;
        isWeekSelected = true;
        if(energyResetDone){
            var someDate = new Date();
            var val = someDate.getDate()+6;
            var weekDate = new Date();
            weekDate.setDate(val); 
            var jsr = '{"dataType": "week", "endDate":'+someDate.yyyymmdd()+',"energyData": [{"value": "0.0", "date": "'+weekDate.yyyymmdd()+'-'+someDate.yyyymmdd()+'"}]}';
            jsr = JSON.parse(jsr);
            this.parseEnergyUsageData($scope, jsr);
        } else if (!$scope.isStatic) {
            makeWeeklyDatas($scope.deviceUuid, $scope.optionCodeValue, $scope.isStatic);
        } else {
            var jsr = {"dataType": "week", "endDate":"20160215","energyData": [{"value": "22.345", "date": "20160310-20160304"}, {"value": "4.345", "date": "20160303-20160227"}, {"value": "10", "date": "20160226-20160220"}, {"value": "11", "date": "20160219-20160213"}]};
            this.parseEnergyUsageData($scope, jsr);
        }
        isWeekAlreadyClicked=true;
    };
    
    this.showMonthlyData = function ($scope) {
        lastTabClicked = $scope.enrgyMonitorTab;
        $scope.enrgyMonitorTab = "month";
        isDaySelected = false;
        isMonthSelected = true;
        isWeekSelected = false;
        if(energyResetDone){
            var monthsDate = new Date();
            var mVal = monthsDate.getMonth() + 1;
            var monthValue = mVal>9 ? mVal : "0" + mVal; 
            var jsr = '{"dataType": "month", "endDate":'+monthsDate.yyyymmdd()+',"energyData": [{"value": "0.0", "date": "2015'+monthValue+'01-2015'+monthValue+'15"}]}';
            jsr = JSON.parse(jsr);
            this.parseEnergyUsageData($scope, jsr);
        } else if (!$scope.isStatic) {
            makeMonthlyDatas($scope.deviceUuid, $scope.optionCodeValue, $scope.isStatic);
        } else {
            var jsr = {"dataType": "month", "endDate":"20150915","energyData": [{"value": "23", "date": "20151001-20151015"}, {"value": "11", "date": "20150901-20150930"}, {"value": "16", "date": "20150501-20150531"}]};
            this.parseEnergyUsageData($scope, jsr);
        }
        isMonthAlreadyClicked = true;
    };
    
    this.showPreviousDaysData = function ($scope) {
        if (isDaySelected) {
            getPreviousFourDaysData($scope.deviceUuid, $scope.optionCodeValue, $scope.isStatic);
        } else if (isWeekSelected) {
            getPreviousFourWeeksData($scope.deviceUuid, $scope.optionCodeValue, $scope.isStatic);
        } else {
            getPreviousFourMonthsData($scope.deviceUuid, $scope.optionCodeValue, $scope.isStatic);
        }
    };
    
    this.showNextDaysData = function ($scope) {
        isLeftButtonPressed = false;
        if (isDaySelected) {
            getNextFourDaysData($scope.deviceUuid, $scope.optionCodeValue);
        } else if (isWeekSelected) {
            getNextFourWeeksData($scope.deviceUuid, $scope.optionCodeValue);
        } else {
            getNextFourMonthsData($scope.deviceUuid, $scope.optionCodeValue);
        }
    };
    
    getDateFromStringFormat= function(strFromat) {
            var yearStr;
            var monthStr;
            var dayStr;
            yearStr = strFromat.substring(0,4);
            monthStr = strFromat.substring(4,6);
            dayStr = strFromat.substring(6,8);
            var foryear = parseInt(yearStr, 10);
            var formonth = parseInt(monthStr, 10);
            var forday = parseInt(dayStr, 10);
            var modifiedDate = new Date('2016/01/01');
            modifiedDate.setFullYear(foryear);
            modifiedDate.setMonth(formonth-1);
            modifiedDate.setDate(forday);
            return modifiedDate;
    }
    
    navigationButtonHandler = function (dataType,endDate, isStatic) {
        
        if(isStatic) {
            document.getElementById("leftImg").className = "em_left_arrow_disabled";
            document.getElementById("rightImg").className = "em_right_arrow_disabled";
            return;
        }  
        var d = new Date();
        d.setDate(d.getDate() - 180);
        if (dataType === "day") {
            
            if(lastDayValueOnX[lastDayValueOnX.length-1]>endDate) {
                isAvailDay=true;
                document.getElementById("leftImg").className = "em_left_arrow"; 
            } else {
                isAvailDay=false;
                document.getElementById("leftImg").className = "em_left_arrow_disabled";
            }
           var modifiedDate = getDateFromStringFormat(lastDayValueOnX[lastDayValueOnX.length-1]);
            
            if( (modifiedDate.getTime() <= d.getTime()))
            {
                isAvailDay=false;
                 document.getElementById("leftImg").className = "em_left_arrow_disabled";
            }
        }
        else if (dataType === "week") {
            var weekDateStartVal = lastWeekValueOnX[lastWeekValueOnX.length-1].split("-");
           if(weekDateStartVal[1]>endDate)
            {
                isAvailWeek=true;
                document.getElementById("leftImg").className = "em_left_arrow"; 
            }
            else
            {
                isAvailWeek=false;
                document.getElementById("leftImg").className = "em_left_arrow_disabled";
            }
            var modifiedDate = getDateFromStringFormat(weekDateStartVal[1]);
            if( (modifiedDate.getTime() <= d.getTime()))
            {
                 isAvailWeek=false;
                 document.getElementById("leftImg").className = "em_left_arrow_disabled";
            }
            if(lastWeekValueOnX.length<4)
            {
                 isAvailWeek=false;
                 document.getElementById("leftImg").className = "em_left_arrow_disabled";
            }
        }
        else if (dataType === "month") {
           var monthDateStartVal = lastMonthValueOnX[lastMonthValueOnX.length-1].split("-");
            if(monthDateStartVal[1]>endDate)
            {
                isAvailMonth=true;
                document.getElementById("leftImg").className = "em_left_arrow"; 
            }   
            else
            {
                isAvailMonth=false;
                document.getElementById("leftImg").className = "em_left_arrow_disabled";
            }
            var modifiedDate = getDateFromStringFormat(monthDateStartVal[1]);

            if((modifiedDate.getYear() === d.getYear()) && (modifiedDate.getMonth() <= d.getMonth()))
            {
                isAvailMonth=false;
                 document.getElementById("leftImg").className = "em_left_arrow_disabled";
            }
        }
        else
        {
            // do nothing
        }
    }
    this.parseEnergyUsageData = function($scope, energyResponse) {
       var enrgyArray = [];
       lastMonthValueOnX = [];
       lastWeekValueOnX=[];
       lastDayValueOnX=[];
       
       var daysVal = [];
       var energyData = [];
       var dayDisplayBottom = [];
       var dayDisplayTop = [];
       var dataType;
       if(LANG.toUpperCase() === "KO-KR") {
           $scope.isKoreanGraph = true;
       } else {
           $scope.isKoreanGraph = false;
       }
       enrgyArray = energyResponse.energyData;
       endDateNative = energyResponse.endDate;
        if(enrgyArray.length > 0) { 
             dataType= energyResponse.dataType;             
            var monthNames = [
                $scope.translation.WEBMOB_common_energy_monitor_january, 
                $scope.translation.WEBMOB_common_energy_monitor_february,
                $scope.translation.WEBMOB_common_energy_monitor_march,
                $scope.translation.WEBMOB_common_energy_monitor_april,
                $scope.translation.WEBMOB_common_energy_monitor_may,
                $scope.translation.WEBMOB_common_energy_monitor_june,
                $scope.translation.WEBMOB_common_energy_monitor_july,
                $scope.translation.WEBMOB_common_energy_monitor_august,
                $scope.translation.WEBMOB_common_energy_monitor_september,
                $scope.translation.WEBMOB_common_energy_monitor_october,
                $scope.translation.WEBMOB_common_energy_monitor_november,
                $scope.translation.WEBMOB_common_energy_monitor_december
            ];
            
            if (dataType === "day") {
                $scope.enrgyMonitorTab = "day";
                isDaySelected = true;
                isWeekSelected = false;
                isMonthSelected = false;
                if (enrgyArray.length < 1) {
                    return;
                }
                for (var i = 0; i < enrgyArray.length; i++) {
                    daysVal[i] = energyResponse.energyData[i].date;
                    dayDisplayTop[i] = getFormattedDateAtTopForDay($scope,daysVal[i], monthNames);
                    lastDayValueOnX[i] = energyResponse.energyData[i].date;
                    dayDisplayBottom[i] = getDayFormat(daysVal[i]);
                    energyData[i] = energyResponse.energyData[i].value;
                }
                lastValueDayStored=lastDayValueOnX[0];

            } else if (dataType === "week") {
                if (enrgyArray.length < 1) {
                    return;
                }
                isDaySelected = false;
                isWeekSelected = true;
                isMonthSelected = false;
                for (var i = 0; i < enrgyArray.length; i++) {
                    daysVal[i] = energyResponse.energyData[i].date;
                    dayDisplayTop[i] = getFormattedDateAtTop(daysVal[i], monthNames);
                    lastWeekValueOnX[i] = energyResponse.energyData[i].date;
                    dayDisplayBottom[i] = getWeekFormat(daysVal[i], monthNames);
                    energyData[i] = energyResponse.energyData[i].value;
                }
                lastValueWeekStored=lastWeekValueOnX[0];

            } else if (dataType === "month") {
                if (enrgyArray.length < 1) {
                    return;
                }
                isDaySelected = false;
                isWeekSelected = false;
                isMonthSelected = true;
                
                for (var i = 0; i < enrgyArray.length; i++) {
                    daysVal[i] = energyResponse.energyData[i].date;
                    dayDisplayTop[i] = getFormattedDateAtTopForMonth($scope,daysVal[i], monthNames);
                    lastMonthValueOnX[i] = energyResponse.energyData[i].date;
                    dayDisplayBottom[i] = monthNames[parseInt((daysVal[i].substring(4,6)-1), 10)];
                    energyData[i] = energyResponse.energyData[i].value;
                }
                lastValueMonthStored=lastMonthValueOnX[0];
                
                //energy management data save
                if(!this.energyManagerDataState){
                    if(energyData[0] != undefined){                	
                            this.currMonthEnergyData = energyData[0] == '0' ? '0.0' : energyData[0];	                	
                    }
                    if(energyData[1] != undefined){                	
                            this.prevMonthEnergyData = energyData[1] == '0' ? '0.0' : energyData[1];               	
                    }
                    this.energyManagerDataState = true;		
                }					
                
            } else {
                // do nothing corrupt value
            }
            if(this.currPage == 'energyMonitor'){
            	navigationButtonHandler(energyResponse.dataType,energyResponse.endDate, $scope.isStatic);
                if(!$scope.isStatic) {
                    var isTrue = isNextDataAvilable(energyResponse.dataType);
                    if(isTrue) {
                    	document.getElementById("rightImg").className = "em_right_arrow";
                    } else {
                    	document.getElementById("rightImg").className = "em_right_arrow_disabled";
                    }
                } 
                else {
                    document.getElementById("rightImg").className = "em_right_arrow_disabled";
                }            
                sendValueToUI(energyData, dayDisplayBottom, dayDisplayTop, energyData.length);
            }            
        } 
        else {
            $scope.handleEnergyMonitorErrors();
        }

        $scope.loadingBar = false;
        
    };
    
    this.isEnergyDataAvailable = function(isNext) {
        var dataType;
        if(isDaySelected) {
            dataType = 'day';
        } else if(isWeekSelected) {
            dataType = 'week';
        } else if(isMonthSelected) {
            dataType = 'month';
        }
        isDataAvilable(dataType, isNext);
    };
    
    this.dismissLoadingBar = function($scope, value) {
        if ($scope.checkResponse.indexOf(value) !== -1) {
            $scope.checkResponse.splice($scope.checkResponse.indexOf(value), 1);
            if ($scope.checkResponse.length === 0) {
                $scope.loadingBar = false;
            }
        } 
    };
});


function getFormattedDateAtTop(daysVal, monthNames) {
    var twoDates = daysVal.toString().split("-");
    var lastDay = twoDates[0];
    var firstDay = twoDates[1];
        
    var month = firstDay.substring(4,6);
    var day = firstDay.substring(6,8);
    var lmonth = lastDay.substring(4,6);
    var lday = lastDay.substring(6,8);
    var monthName = monthNames[parseInt(month, 10)-1];
    var lmonthName = monthNames[parseInt(lastDay.substring(4,6), 10)-1];
    
    if(monthName === lmonthName) {
        if(LANG.toUpperCase() === "KO-KR") {            
            return monthName+" "+day+"일 - "+lday+"일";
        } else {
           return day+"-"+lday+" "+monthName;
        }
    } else {        
       if(LANG.toUpperCase() === "KO-KR") {
            return monthName+" "+day+"일 -"+lmonthName+" "+lday+"일";
        } else {
            return day+" "+monthName+"-"+lday+" "+lmonthName;
        }
    }
    
    
    if(monthName === lmonthName) {
        return day+"-"+lday + " " + lmonthName;
    } else {
        return day+" "+monthName+"-"+lday+" "+lmonthName;
    }
  

 } 

function getFormattedDateAtTopForDay($scope,daysVal, monthNames) {
    var year = daysVal.substring(0,4);        
    var month = daysVal.substring(4,6);
    var day = daysVal.substring(6,8);
    
    var monthName = monthNames[parseInt(month, 10)-1];
    
    if(LANG.toUpperCase() === "KO-KR") {
        return year+$scope.translation.WEBMOB_common_energy_monitor_year+monthName+day+$scope.translation.WEBMOB_common_energy_monitor_day;
    } else {
        return day+" "+monthName+" "+year;
    }
 }
 
 function getFormattedDateAtTopForMonth($scope,daysVal, monthNames) {
     var year = daysVal.substring(0,4);        
    var month = daysVal.substring(4,6);
    var day = daysVal.substring(6,8);
    
    var monthName = monthNames[parseInt(month, 10)-1];

    if(LANG.toUpperCase() === "KO-KR") {
        return year+$scope.translation.WEBMOB_common_energy_monitor_year+monthName;
    } else {
        return monthName+" "+year;
    }
    
    //date_display_selected_month

    /*if(!$scope.isStatic){      
    	var day_start = daysVal.substring(15,17);
    	var day_end = daysVal.substring(6,8);
    	
	    if(LANG.toUpperCase() === "KO-KR") 
	    {
	    	return year+$scope.translation.WEBMOB_common_energy_monitor_year+monthName+"<br>"+day_start+"-"+day_end;
	    } 
	    else 
	    {
	        return monthName+" "+year+"<br>"+day_start+"-"+day_end;
	    }
    }
    else
    {
	    if(LANG.toUpperCase() === "KO-KR") 
	    {
	    	return year+$scope.translation.WEBMOB_common_energy_monitor_year+monthName+"<br>"+day_end+"-"+day_start;
	    } 
	    else 
	    {
	        return monthName+" "+year+"<br>"+day_end+"-"+day_start;
	    }
    }*/
 }
 
 function getDayFormat(daysVal) {
    return daysVal.substring(6,8);
 }
 
 function getWeekFormat(daysVal, monthNames) {
    var twoDates = daysVal.toString().split("-");
    var lastDay = twoDates[0];
    var firstDay = twoDates[1];
    var day = firstDay.substring(6,8);
    var lday = lastDay.substring(6,8);
    var month = firstDay.substring(4,6);
    var lmonth = lastDay.substring(4,6);
    var monthName = monthNames[parseInt(month, 10)-1];
    var lmonthName = monthNames[parseInt(lmonth, 10)-1];
    
     if(monthName === lmonthName) {
        if(LANG.toUpperCase() === "KO-KR") {
            return day+"일 - "+lday+"일<br>" + month +"월";
        } else {
            return day+"-"+lday + "<br>" + lmonthName;
        }
    } else {
        if(LANG.toUpperCase() === "KO-KR") {
           return month +"월 "+day+"일 <br>- "+lmonth+"월 "+lday+"일"; 
        } else {
            return day+" "+monthName+"<br>-"+lday+" "+lmonthName;
        }
    }
    
}
 
/**    	 
* @function
* @private
* @name getThreshold        
* @description : Threshold value for
*               daily : 35kWh
*               week : 150kWh
*               month : 500kWh
*               default: 100kWh  
*/
function getThreshold() {
    
    var dayVal,weekVal,monthVal;
    if(deviceType === "Washer"){
        dayVal = 2;
        weekVal = 10;
        monthVal = 40;
    } else if(deviceType === "Dryer"){
        dayVal = 20;
        weekVal = 100;
        monthVal = 400;
    } 
    else if(deviceType === "FAC")
    {
        dayVal = 150000;
        weekVal = 1050000;
        monthVal = 4500000;
    }else {
        dayVal = 35;
        weekVal = 150;
        monthVal = 500;
    }
    return isDaySelected ? dayVal : (isWeekSelected ? weekVal : (isMonthSelected ? monthVal : 100));
}
    
 function sendValueToUI(powerUsageValue, dateFormated, dateAtTop,energyDataLength) {
    var HEIGHTMULTIPLICATIONFACTOR = 0.095 * (100 / getThreshold());
    var fontSizeValue;
    var bOne = document.getElementById("x1");
    var bTwo = document.getElementById("x2");
    var bThree = document.getElementById("x3");
    var bFour = document.getElementById("x4");

    var dateID = document.getElementById("dateID");

    var hLablOne = document.getElementById("h1");
    var hLablTwo = document.getElementById("h2");
    var hLablThree = document.getElementById("h3");
    var hLablFour = document.getElementById("h4");

    var bubbleOne = document.getElementById("bubbleOne");
    var bubbleTwo = document.getElementById("bubbleTwo");
    var bubbleThree = document.getElementById("bubbleThree");
    var bubbleFour = document.getElementById("bubbleFour");

    var valOne = document.getElementById("valOne");
    var valTwo = document.getElementById("valTwo");
    var valThree = document.getElementById("valThree");
    var valFour = document.getElementById("valFour");
    
    var kwhIdOne = document.getElementById("kwhIdOne");
    var kwhIdTwo = document.getElementById("kwhIdTwo");
    
    var strH = "h",
        strkWh = "kWh",
        strWh = "Wh";
	
    hLablOne.innerHTML="";
    hLablTwo.innerHTML="";
    hLablThree.innerHTML="";
    hLablFour.innerHTML="";
    valOne.innerHTML="";
    valTwo.innerHTML="";
    valThree.innerHTML="";
    valFour.innerHTML="";

    bubbleOne.style.display="none";
    bubbleTwo.style.display="none";
    bubbleThree.style.display="none";
    bubbleFour.style.display="none"; 

    bOne.style.display="block";
    bTwo.style.display="block";
    bThree.style.display="block";
    bFour.style.display="block";
	
    switch (energyDataLength) {
        case 0:
            bOne.style.display="none";
            bTwo.style.display="none";
            bThree.style.display="none";
            bFour.style.display="none";
            break;
        case 1:
            bOne.style.display="none";
            bTwo.style.display="none";
            bThree.style.display="none";
            break;
        case 2:
            bOne.style.display="none";
            bTwo.style.display="none";
            break;
        case 3:
            bOne.style.display="none";
            break;
        default:
            break;
    }  
    
    var heightOne; 
    var heightTwo;
    var heightThree;
    var heightFour;
	
    bOne.style.height = 0;
    bubbleOne.style.bottom =1 + "rem";
    bTwo.style.height = 0;
    bubbleTwo.style.bottom =1 + "rem";
    bThree.style.height = 0;
    bubbleThree.style.bottom =1 + "rem";
    bFour.style.height = 0;
    bubbleFour.style.bottom =1 + "rem";
    for(var i=0;i<energyDataLength;i++) {
       if(deviceType === "FAC")
        {
           powerUsageValue[i]=powerUsageValue[i]*10; 
           v1.style.fontSize="0.40rem";
           v2.style.fontSize="0.40rem";
           v3.style.fontSize="0.40rem";
           v4.style.fontSize="0.40rem";
           v5.style.fontSize="0.40rem";
           v6.style.fontSize="0.40rem";
        } 
        else
        {
           v1.style.fontSize="0.75rem";
           v2.style.fontSize="0.75rem";
           v3.style.fontSize="0.75rem";
           v4.style.fontSize="0.75rem";
           v5.style.fontSize="0.75rem";
           v6.style.fontSize="0.75rem"; 
       }
     }
     for(var i=0;i<energyDataLength;i++) {
        if(Number(powerUsageValue[i]).toFixed(1).toString().length>=5)
        {
            fontSizeValue=1;
               if(powerUsageValue[i].toString().length>6)
                   fontSizeValue=2;
               break;
        }else
        {
            fontSizeValue=0;
        }       
     } 
    for(var i=0;i<energyDataLength;i++) {

    if(i==0) {	
        bubbleFour.style.display="block";
        hLablFour.innerHTML = dateFormated[i];
        
        if(powerUsageValue[i]==0)
        {
            valFour.innerHTML = "0.0";
        }
        else
        valFour.innerHTML = addZeroBeforeDecimal(powerUsageValue[i]); 
        if(powerUsageValue[i].toString().length>=5)
        {
            valFour.style.width="2.86rem";
            bubbleFour.style.width = "2.86rem";
        } 
        else
        {
            valFour.style.width="2.22rem";
            bubbleFour.style.width="2.22rem";
        }
        heightFour= powerUsageValue[i] * HEIGHTMULTIPLICATIONFACTOR;
        if (heightFour > 10.8) {
            heightFour = 10.8;
        }  
        if (powerUsageValue[i]==0) {
              bFour.style.display="none";     
              bubbleFour.style.bottom = heightFour +0.16 + "rem";							
        } else {
            bubbleFour.style.bottom = heightFour +0.3 + "rem";
        }
        bFour.style.height = heightFour+"rem";			

    } else if(i==1) {	
        bubbleThree.style.display="block";
        hLablThree.innerHTML = dateFormated[i];
        if(powerUsageValue[i]==0)
         valThree.innerHTML = "0.0";
        else
        valThree.innerHTML = addZeroBeforeDecimal(powerUsageValue[i]);      
        if(powerUsageValue[i].toString().length>=5)
        {
            valThree.style.width="2.86rem";
            bubbleThree.style.width = "2.86rem";
        } 
        else
        {
            valThree.style.width="2.22rem";
            bubbleThree.style.width="2.22rem";
        }
        heightThree= powerUsageValue[i] * HEIGHTMULTIPLICATIONFACTOR;
            if (heightThree > 10.8) {
                heightThree = 10.8;
        }
        if (powerUsageValue[i]==0) {
            bThree.style.display="none";     
            bubbleThree.style.bottom = heightThree +0.16 + "rem";							
        } else {
            bubbleThree.style.bottom = heightThree +0.3 + "rem";
        }
        bThree.style.height = heightThree+"rem";

    } else if(i==2) {
        bubbleTwo.style.display="block";
        hLablTwo.innerHTML = dateFormated[i];
       if(powerUsageValue[i]==0)
        valTwo.innerHTML = "0.0";
        else   
        valTwo.innerHTML = addZeroBeforeDecimal(powerUsageValue[i]);
        if(powerUsageValue[i].toString().length>=5)
        {
            valTwo.style.width="2.86rem";
            bubbleTwo.style.width = "2.86rem";
        } 
        else
        {
            valTwo.style.width="2.22rem";
            bubbleTwo.style.width="2.22rem";
        }
        heightTwo= powerUsageValue[i] * HEIGHTMULTIPLICATIONFACTOR;
        if (heightTwo > 10.8) {
            heightTwo = 10.8;
        }
        if (powerUsageValue[i]==0) {
            bTwo.style.display="none";     
            bubbleTwo.style.bottom = heightTwo +0.16 + "rem";							
        } else {
            bubbleTwo.style.bottom = heightTwo +0.3 + "rem";
        }
            bTwo.style.height = heightTwo+"rem";
      } else if(i==3) {
            bubbleOne.style.display="block";            
            hLablOne.innerHTML = dateFormated[i];
            if(powerUsageValue[i]==0) {
                valOne.innerHTML = "0.0";
            } else {
                valOne.innerHTML = addZeroBeforeDecimal(powerUsageValue[i]);
            }
            if(powerUsageValue[i].toString().length>=5) {
                valOne.style.width="2.86rem";
                bubbleOne.style.width = "2.86rem";                
            } else {
                valOne.style.width="2.22rem";
                bubbleOne.style.width="2.22rem";
            }
            heightOne= powerUsageValue[i] * HEIGHTMULTIPLICATIONFACTOR;
            if (heightOne > 10.8) {
                heightOne = 10.8;
            }
            if (powerUsageValue[i]==0) {
                bOne.style.display="none";     
                bubbleOne.style.bottom = heightOne +0.16 + "rem";							
            } else {
                bubbleOne.style.bottom = heightOne +0.3 + "rem";
            }
            bOne.style.height = heightOne+"rem";
        }
    }
   switch(fontSizeValue)
        {
            case 0:
                valOne.style.fontSize="0.825rem"; 
                valTwo.style.fontSize="0.825rem"; 
                valThree.style.fontSize="0.825rem"; 
                valFour.style.fontSize="0.825rem"; 
                break;
            case 1:
                valOne.style.fontSize="0.625rem"; 
                valTwo.style.fontSize="0.625rem"; 
                valThree.style.fontSize="0.625rem"; 
                valFour.style.fontSize="0.625rem"; 
                break;
            case 2:
                valOne.style.fontSize="0.525rem"; 
                valTwo.style.fontSize="0.525rem"; 
                valThree.style.fontSize="0.525rem"; 
                valFour.style.fontSize="0.525rem"; 
                break;
            default :
                valOne.style.fontSize="0.825rem"; 
                valTwo.style.fontSize="0.825rem"; 
                valThree.style.fontSize="0.825rem"; 
                valFour.style.fontSize="0.825rem"; 
                break;
        }
    dateID.innerHTML = dateAtTop[0];
    //date_display_selected_month
    /*if(isMonthSelected)
    {
    	dateID.style.fontSize = "1.3rem";
    }
    else
    {
    	dateID.style.fontSize = "1.55rem";
    }*/
    
    if(isRunningTime)
    {
         kwhIdOne.innerHTML= strH;
         kwhIdTwo.innerHTML= strH;
    } else if(deviceType === "FAC") {
         kwhIdOne.innerHTML= strWh;
         kwhIdTwo.innerHTML= strWh;
    }
    else
    {
         kwhIdOne.innerHTML= strkWh;
         kwhIdTwo.innerHTML= strkWh;
    }
    var bubbleOne = document.getElementById("bubbleOne");
    var bubbleTwo = document.getElementById("bubbleTwo");
    var bubbleThree = document.getElementById("bubbleThree");
    var bubbleFour = document.getElementById("bubbleFour");

    var pointer1 = document.getElementById("pointer1");
    var pointer2 = document.getElementById("pointer2");
    var pointer3 = document.getElementById("pointer3");
    var pointer4 = document.getElementById("pointer4");
    
    if(deviceType == "Refrigerator")    	
    {
    	if(LANG.toUpperCase() === "ZH-CN")
    	{
	    	document.getElementById("h1").style.fontSize="0.6rem"; 
	    	document.getElementById("h2").style.fontSize="0.6rem";
	    	document.getElementById("h3").style.fontSize="0.6rem";
	    	document.getElementById("h4").style.fontSize="0.6rem";
    	}
    	else if(LANG.toUpperCase() === "KO-KR")
    	{
	    	document.getElementById("h1").style.fontSize="0.5rem"; 
	    	document.getElementById("h2").style.fontSize="0.5rem";
	    	document.getElementById("h3").style.fontSize="0.5rem";
	    	document.getElementById("h4").style.fontSize="0.5rem";
    	}
    }  
    
    if(deviceType=="Refrigerator" || deviceType=="Washer" || deviceType === "Dryer")
    {
       document.getElementById("powerUnit").style.visibility = "hidden";
       document.getElementById("v1").innerHTML="";
       document.getElementById("v2").innerHTML="";
       document.getElementById("v3").innerHTML="";
       document.getElementById("v4").innerHTML="";
       document.getElementById("v5").innerHTML="";
       document.getElementById("v6").innerHTML="";

       bubbleOne.style.backgroundColor="transparent";
       bubbleTwo.style.backgroundColor="transparent";
       bubbleThree.style.backgroundColor="transparent";
       bubbleFour.style.backgroundColor="transparent";
       pointer1.style.border="transparent";
       pointer2.style.border="transparent";
       pointer3.style.border="transparent";
       pointer4.style.border="transparent";
       valOne.innerHTML="";
       valTwo.innerHTML="";
       valThree.innerHTML="";
       valFour.innerHTML="";           
    }
    else{
       bubbleOne.style.backgroundColor="orange";
       bubbleTwo.style.backgroundColor="orange";
       bubbleThree.style.backgroundColor="orange";
       bubbleFour.style.backgroundColor="orange";
       pointer1.style.border="orange transparent";
       pointer2.style.border="orange transparent";
       pointer3.style.border="orange transparent";
       pointer4.style.border="orange transparent"; 
    }
  
};

function addZeroBeforeDecimal(val) {
    val = Number(val).toFixed(1);
    return val;
}

function monthDisplayAtTop(date) {
    var pDate = new Date();
    var monthVal = date.getMonth() + 1;
    var formatData;
    if (monthVal < 10) {
        monthVal = "0" + monthVal;
    }
    var dateVal = date.getDate();
    
    if (monthVal === (pDate.getMonth() + 1) && date.getFullYear() === pDate.getFullYear()) {
        formatData = pDate.getFullYear() + "." + monthVal + "." + pDate.getDate();
    } else {
        if (dateVal < 10) {
            dateVal = "0" + dateVal;
        }
        formatData = date.getFullYear() + "." + monthVal + "." + dateVal;
    }

    return formatData;
};

function dayDisplayAtTop(date) {

    var monthVal = date.getMonth() + 1;
    if (monthVal < 10)
        monthVal = "0" + monthVal;
    var dateVal = date.getDate();
    if (dateVal < 10)
        dateVal = "0" + dateVal;
    var formatData = date.getFullYear() + "." + monthVal + "." + dateVal;

    return formatData;
};

function getPreviousFourDaysData(deviceUuid,optionCodeValue, isStatic) {
    if(isAvailDay)
    {
    isLeftClicked=true;
    var lengthArray = lastDayValueOnX.length;
    var yearStr= lastDayValueOnX[lengthArray-1].substring(0,4);
    var monthStr = lastDayValueOnX[lengthArray-1].substring(4,6);
    var dayStr= lastDayValueOnX[lengthArray-1].substring(6,8);
    var year = parseInt(yearStr, 10);
    var month = parseInt(monthStr, 10);
    var day = parseInt(dayStr, 10);		
    var modifiedDate = new Date('2016/01/01');
    modifiedDate.setFullYear(year);    
    modifiedDate.setMonth(month-1);
    modifiedDate.setDate(day-1);
    var reqFormat =modifiedDate.yyyymmdd();
    if(!isStatic) {
	nativeInterface.runOnNative("getEnergyData", '{"deviceUuid" : "' + deviceUuid + '", "date" : "'+reqFormat+'","dataType" : "day","optionCode" :"'+optionCodeValue+'"}');
    }
    }
}

function getPreviousFourWeeksData(deviceUuid,optionCodeValue, isStatic) {
    if(isAvailWeek && lastWeekValueOnX.length==4)
    {
        isLeftClicked=true;
        var lengthArray = lastWeekValueOnX.length;
        var weekDateVal = lastWeekValueOnX[lengthArray-1].split("-");
        var yearStr = weekDateVal[1].substring(0,4);
        var monthStr = weekDateVal[1].substring(4,6);
        var dayStr = weekDateVal[1].substring(6,8);
        var year = parseInt(yearStr, 10);
        var month = parseInt(monthStr, 10);
        var day = parseInt(dayStr, 10);
        var modifiedDate = new Date('2016/01/01');
        modifiedDate.setFullYear(year);
        modifiedDate.setMonth(month-1);
        modifiedDate.setDate(day-1);
        var reqFormat =modifiedDate.yyyymmdd();
        if(!isStatic) {
            nativeInterface.runOnNative("getEnergyData", '{"deviceUuid" : "' + deviceUuid + '", "date" : "'+reqFormat+'","dataType" : "week","optionCode" :"' +optionCodeValue+'"}');
        }
    }
}

function getPreviousFourMonthsData(deviceUuid,optionCodeValue, isStatic) {
    if(isAvailMonth)
    {
        isLeftClicked=true;
        var lengthArray = lastMonthValueOnX.length;
        var monthDateVal = lastMonthValueOnX[lengthArray-1].split("-");
        var yearStr = monthDateVal[0].substring(0,4);
        var monthStr = monthDateVal[0].substring(4,6);
        var dayStr = monthDateVal[0].substring(6,8);
        var year = parseInt(yearStr, 10);
        var month = parseInt(monthStr, 10);
        var day = parseInt(dayStr, 10);
        var modifiedDate = new Date('2016/01/01');
        modifiedDate.setFullYear(year);
        modifiedDate.setMonth(month-2);
        modifiedDate.setDate(1);
        var reqFormat =modifiedDate.yyyymmdd();
        if(!isStatic) {
            nativeInterface.runOnNative("getEnergyData", '{"deviceUuid" : "' + deviceUuid + '", "date" : "'+reqFormat+'","dataType" : "month","optionCode" :"' +optionCodeValue+'"}');
        }
    }
}

function isNextDataAvilable(dataType) {
    var yearStr, monthStr, dayStr;
        
    if(dataType === 'month') {
        if(lastMonthValueOnX.length > 0) { 
            var monthDateStartVal = lastMonthValueOnX[0].split("-");
            yearStr = monthDateStartVal[0].substring(0,4);
            monthStr = monthDateStartVal[0].substring(4,6);
            dayStr = monthDateStartVal[0].substring(6,8);
        } else {
            yearStr = new Date().getFullYear();
            monthStr = new Date().getMonth()+1;
            dayStr = new Date().getDate();
        }
        
    } else if(dataType === 'week') {
        if(lastWeekValueOnX.length > 0) {
            var weekDateStartVal = lastWeekValueOnX[0].split("-");
            yearStr = weekDateStartVal[0].substring(0,4);
            monthStr = weekDateStartVal[0].substring(4,6);
            dayStr = weekDateStartVal[0].substring(6,8);
        } else {
            yearStr = new Date().getFullYear();
            monthStr = new Date().getMonth()+1;
            dayStr = new Date().getDate();
        }
        
    } else {
        if(lastDayValueOnX.length > 0) {
            yearStr = lastDayValueOnX[0].substring(0,4);
            monthStr = lastDayValueOnX[0].substring(4,6);
            dayStr = lastDayValueOnX[0].substring(6,8);
        } else {
            yearStr = new Date().getFullYear();
            monthStr = new Date().getMonth()+1;
            dayStr = new Date().getDate();
        }
    
    }
    
    var foryear = parseInt(yearStr, 10);
    var formonth = parseInt(monthStr, 10);
    var forday = parseInt(dayStr, 10);   
    var modifiedDate = new Date();
    modifiedDate.setFullYear(foryear);
    modifiedDate.setMonth(formonth-1);
    modifiedDate.setDate(forday);
    var forweek = modifiedDate.getWeek();
    
    var curDay = new Date().getDate();
    var curMonth = new Date().getMonth()+1;
    var curYear = new Date().getFullYear();
    var curweek = (new Date()).getWeek();
    
    if(foryear < curYear)
    {
        return true;
    }
    else if (dataType === 'month' && (formonth >= curMonth && foryear === curYear)) { 
	return false;
    } else if (dataType === 'week' && (formonth === curMonth && forweek === curweek && foryear === curYear)) {
        return false;
    } else if(foryear > curYear) {
            return false;
    } else if(formonth > curMonth) {
            return false;
    } else if( forday >= curDay && formonth== curMonth && foryear === curYear) {
        return false;
        
    } else {
        return true;
    }
    
}

function isDataAvilable(dataType, isNext) {
    var dayDiff, yearStr, monthStr, dayStr;
    var modifiedDate = new Date('2016/01/01');
    
    if(dataType === 'month') {
        if(lastMonthValueOnX.length > 0) { 
            var monthDateStartVal = lastMonthValueOnX[0].split("-");
            yearStr = monthDateStartVal[0].substring(0,4);
            monthStr = monthDateStartVal[0].substring(4,6);
            dayStr = monthDateStartVal[0].substring(6,8);
        } else {
            yearStr = new Date().getFullYear();
            monthStr = new Date().getMonth()+1;
            dayStr = new Date().getDate();
        }
        dayDiff = 1;
        
    } else if(dataType === 'week') {
        if(lastWeekValueOnX.length > 0) {
            var weekDateStartVal = lastWeekValueOnX[0].split("-");
            yearStr = weekDateStartVal[1].substring(0,4);
            monthStr = weekDateStartVal[1].substring(4,6);
            dayStr = weekDateStartVal[1].substring(6,8);
        } else {
            yearStr = new Date().getFullYear();
            monthStr = new Date().getMonth()+1;
            dayStr = new Date().getDate();
        }
        dayDiff = parseInt(dayStr, 10) +28;
    
    } else {
        if(lastDayValueOnX.length > 0) {
            yearStr = lastDayValueOnX[0].substring(0,4);
            monthStr = lastDayValueOnX[0].substring(4,6);
            dayStr = lastDayValueOnX[0].substring(6,8);
        } else {
            yearStr = new Date().getFullYear();
            monthStr = new Date().getMonth()+1;
            dayStr = new Date().getDate();
        }
        dayDiff = parseInt(dayStr, 10) + 4;
    }
    var foryearV = parseInt(yearStr, 10);
    var formonthV = parseInt(monthStr, 10);
    var fordayV = parseInt(dayStr, 10);
     
    var year = parseInt(yearStr, 10);
    var month = parseInt(monthStr, 10);
        
    modifiedDate.setFullYear(year);
    dataType === 'month' ? modifiedDate.setMonth(month+3) : modifiedDate.setMonth(month-1);
    modifiedDate.setDate(dayDiff);
    
    var reqFormat = modifiedDate.yyyymmdd();
    var foryearStr = reqFormat.substring(0,4);
    var formonthStr = reqFormat.substring(4,6);
    var fordayStr = reqFormat.substring(6,8);
    var foryear = parseInt(foryearStr, 10);
    var formonth = parseInt(formonthStr, 10);
    var forday = parseInt(fordayStr, 10);
   if(foryearV < new Date().getFullYear())
    {
        return reqFormat;
    }
  else if (dataType === 'month' && (formonthV >= new Date().getMonth()+1 && foryearV === new Date().getFullYear())) { 
    	return false;
    }  if (dataType === 'week' && (formonthV === new Date().getMonth()+1 && fordayV === new Date().getDate() && foryearV === new Date().getFullYear())) {
        return false;
    } else if(foryear > new Date().getFullYear()) {
            return false;
    } else if(formonth > new Date().getMonth()+1) {
            return false;
    } else if( forday > new Date().getDate() && formonth== new Date().getMonth()+1 && foryear === new Date().getFullYear()) {
        return false;
        
    } else {
        return reqFormat;
    }
}
function getNextFourDaysData(deviceUuid,optionCodeValue) {
    var reqFormat = isDataAvilable('day', true);
    
    if(reqFormat !== false) {
        nativeInterface.runOnNative("getEnergyData", '{"deviceUuid" : "' + deviceUuid + '", "date" : "'+reqFormat+'","dataType" : "day","optionCode" :"' +optionCodeValue+'"}');
    }
}

function getNextFourWeeksData(deviceUuid,optionCodeValue) {
    var reqFormat = isDataAvilable('week', true);
    if(reqFormat !== false) {
        nativeInterface.runOnNative("getEnergyData", '{"deviceUuid" : "' + deviceUuid + '", "date" : "'+reqFormat+'","dataType" : "week","optionCode" :"' +optionCodeValue+'"}');
    }
}

function getNextFourMonthsData(deviceUuid,optionCodeValue) {
   var reqFormat = isDataAvilable('month', true);
   if(reqFormat !== false) {
        nativeInterface.runOnNative("getEnergyData", '{"deviceUuid" : "' + deviceUuid + '", "date" : "'+reqFormat+'","dataType" : "month","optionCode" :"' +optionCodeValue+'"}'); 
   }
};

function dateFromatconvertor(mDatesCopy) {
    var monthNames = [
        "Jan", "Feb", "Mar",
        "Apr", "May", "June", "July",
        "Aug", "Sept", "October",
        "Nov", "Dec"
    ];
    
    var formattedVal = mDatesCopy.getDate();
    if (formattedVal < 10)
        formattedVal = "0" + formattedVal;
    return formattedVal;
}

function makeDailyDatas(deviceUuid,optionCodeValue, isStatic) {
    getDayEnergyData(deviceUuid,optionCodeValue, isStatic);  
}

function getDayEnergyData(deviceUuid,optionCodeValue, isStatic) {  

    var todayDate = new Date();   
    if(!isStatic) { 
        if(lastValueDayStored!= undefined)
        {
            var xAxisval = lastValueDayStored; 
            var yearStr = xAxisval.substring(0,4);
            var monthStr = xAxisval.substring(4,6);
            var dayStr = xAxisval.substring(6,8);
            var year= parseInt(yearStr, 10);
            var month= parseInt(monthStr, 10);
            var day= parseInt(dayStr, 10);
            todayDate = new Date('2016/01/01');
            todayDate.setFullYear(year, 10);
            todayDate.setMonth(month-1);
            todayDate.setDate(day);    
        }
 
        var date = todayDate.yyyymmdd();        
        nativeInterface.runOnNative("getEnergyData", '{"deviceUuid" : "' + deviceUuid + '", "date" : "'+date+'","dataType" : "day","optionCode" :"' +optionCodeValue+'"}');
    }
}

function makeWeeklyDatas(deviceUuid,optionCodeValue, isStatic) {
    var todayDate = new Date();   
    
    if(!isWeekAlreadyClicked)
    {

    }
    else
    {
        var xAxisval = lastValueWeekStored.split("-");            
        var yearStr = xAxisval[0].substring(0,4);
        var monthStr = xAxisval[0].substring(4,6);
        var dayStr = xAxisval[0].substring(6,8);
        var year= parseInt(yearStr,10);
        var month= parseInt(monthStr,10);
        var day= parseInt(dayStr,10);
        todayDate = new Date('2016/01/01');
        todayDate.setFullYear(year);
        todayDate.setMonth(month-1);
        todayDate.setDate(day); 
    }

   getWeekEnergyData(todayDate.yyyymmdd(), deviceUuid,optionCodeValue, isStatic);
   
}

function getWeekEnergyData(date, deviceUuid,optionCodeValue, isStatic) {    
    if(!isStatic) {
        nativeInterface.runOnNative("getEnergyData", '{"deviceUuid" : "' + deviceUuid + '", "date" : "'+date+'","dataType" : "week","optionCode" :"' +optionCodeValue+'"}');
    }
}

function getMonthEnergyData(date, deviceUuid,optionCodeValue, isStatic) {
    if(!isStatic) {
        nativeInterface.runOnNative("getEnergyData", '{"deviceUuid" : "' + deviceUuid + '", "date" : "'+date+'","dataType" : "month","optionCode" :"' +optionCodeValue+'"}');
    } 
}

function makeMonthlyDatas(deviceUuid,optionCodeValue, isStatic) {
    var todayDate = new Date();
    if(!isMonthAlreadyClicked)
    {

    }
    else
    {
        var xAxisval = lastValueMonthStored.split("-"); 
        var yearStr = xAxisval[0].substring(0,4);
        var monthStr = xAxisval[0].substring(4,6);
        var dayStr = xAxisval[0].substring(6,8);
        var year= parseInt(yearStr, 10);
        var month= parseInt(monthStr, 10);
        var day= parseInt(dayStr, 10);
        todayDate = new Date('2016/01/01');
        todayDate.setFullYear(year);
        todayDate.setMonth(month-1);
        todayDate.setDate(day); 
    }

    getMonthEnergyData(todayDate.yyyymmdd(), deviceUuid,optionCodeValue, isStatic);
}

function MonthFromatconvertor(mDatesCopy) {
    var monthNames = [
        "Jan", "Feb", "Mar",
        "Apr", "May", "June", "July",
        "Aug", "Sept", "Oct",
        "Nov", "Dec"
    ];
    var formattedVal = monthNames[mDatesCopy.getMonth()];
    return formattedVal;
}

Date.prototype.getWeek = function() {
    var onejan = new Date(this.getFullYear(), 0, 1);
    return Math.ceil((((this - onejan) / 86400000) + onejan.getDay() + 1) / 7);
};
