var app = angular.module("SmartThings", ['toaster', 'ngTouch', 'ngSanitize']);

app.controller("RVCController", ["$scope", "SHPService", "ScheduleService", "toaster", "$timeout", "$interval", "UtilityService", "EnergyService", function($scope, SHPService, ScheduleService, toaster, $timeout, $interval, UtilityService, EnergyService) {
    //Local variable declaration.
    $scope.historyData = [];
    $scope.isStatic = false;
    $scope.isAppV2 = false;
    $scope.isDBDownloaded = false;
    $scope.mapSelectable = false;
    $scope.isMoving = false;
    
    var reqParamCountrySelection;
    $scope.countrySelectionPopupVisible = false;
    $scope.countrySelectedIndex = 0;
    $scope.countryToSelect = [];
    $scope.countryToSelect.push({'Country': 'Belgium'});
    $scope.countryToSelect.push({'Country': 'Belgium(F)'});
    
    var CLEANING_STATE = {
            NONE: 0,
            MANNUAL: 1,
            AUTO: 2,
            MAP: 3,
            SPOT: 4,
            POINT: 5,
            IDLE: 6,
            PAUSE: 7,
            HOMING: 8,
            CHARGING: 9,
            ALARM: 10,
            AFTER: 11
        }
    var STATE_BTN_AVAILABLE = {
            "Access_Lock": {
            	title: 'VCMOB_status_remote',
                power: false,
                play: true,
                playDisable: true,
                manualCtrlEnabled: false,
                spot: false,
                charging: false,
                suction: false,
                schedule_old: false,
                schedule_new: false,
                energyMonitor: false,
                history: false,
                setting: false,
                aboutDevice: true, 
                changeMapEnabled: false,
                mapActionBtnText:"START",
                mapActionBtnEnabled:false,
                selectingRoom:"disable",
                oobe456:false,
                mapCreateBtn:false,
                progressStatus : false
            },
            "Control_Point": {
            	cleaningType: CLEANING_STATE.POINT,
            	title:'VCMOB_status_pointclening',
                power: false,
                play: true,
                playDisable: true,
                manualCtrlEnabled: false,
                spot: false,
                charging: false,
                suction: false,
                schedule_old: false,
                schedule_new: false,
                energyMonitor: false,
                history: false,
                setting: false,
                aboutDevice: true, 
                changeMapEnabled: false,
                mapActionBtnText:"START",
                mapActionBtnEnabled:false,
                selectingRoom:"popup",
                oobe123Start:"popup",
                mapSave:false,
                oobe456:false,
                mapCreateBtn:true,
                progressStatus : true
            },
            "Control_PowerOff": {
                power: true,
                play: true,
                playDisable: true,
                manualCtrlEnabled: false,
                spot: false,
                charging: false,
                suction: false,
                schedule_old: false,
                schedule_new: false,
                energyMonitor: false,
                history: false,
                setting: false,
                aboutDevice: true, 
                changeMapEnabled: false,
                mapActionBtnText:"START",
                mapActionBtnEnabled:false,
                selectingRoom:"disable",
                oobe456:false,
                mapCreateBtn:false,
                progressStatus : false
            },
            "Control_Alarm": { 
            	title:"",
            	power: false,
                play: false,
                playDisable: false,
                manualCtrlEnabled: false,
                spot: false,
                suction: false,
                schedule_old: false,
                schedule_new: false,
                energyMonitor: false,
                history: false,
                setting: true,
                aboutDevice: true, 
                changeMapEnabled: false,
                mapActionBtnText:"START",
                mapActionBtnEnabled:false,
                selectingRoom:"popup",
                oobe456:false,
                mapCreateBtn:false,
                progressStatus : false
            },
            "Control_Alarm_21": { 
            	title:"",
            	power: false,
                play: true,
                playDisable: false,
                manualCtrlEnabled: false,
                spot: false,
                suction: false,
                schedule_old: false,
                schedule_new: false,
                energyMonitor: false,
                history: false,
                setting: true,
                aboutDevice: true, 
                changeMapEnabled: false,
                mapActionBtnText:"START",
                mapActionBtnEnabled:false,
                selectingRoom:"popup",
                oobe456:false,
                mapCreateBtn:false,
                progressStatus : false 
            },
            "Control_Alarm_10": { //When error code is 10.
            	title:"",
            	power: false,
                play: false,
                playDisable: false,
                manualCtrlEnabled: false,
                spot: false,
                charging: false,
                suction: true,
                schedule_old: false,
                schedule_new: true,
                energyMonitor: true,
                history: true,
                setting: true,
                aboutDevice: true, 
                changeMapEnabled: false,
                mapActionBtnText:"START",
                mapActionBtnEnabled:false,
                selectingRoom:"popup",
                mapSave:false,
                oobe456:false,
                mapCreateBtn:false,
                progressStatus : false
                
            },
            "Control_Alarm_9": { //When error code is 0,1,2,3,5,7,8,9,27
            	cleaningType : CLEANING_STATE.ALARM,
            	title:"",
                charging: false,
                setting: false,
                progressStatus : false
            },
            "Control_Alarm_27": { //27 special
            	title:"",
            	play:true,
                playDisable:true,
                progressStatus : false
            },
            "Control_After": {
            	cleaningType : CLEANING_STATE.AFTER,
            	title: 'VCMOB_alarm_ChargingForBattery_10',
                power: false,
                play: false,
                playDisable: false,
                manualCtrlEnabled: false,
                spot: false,
                charging: false,
                suction: true,
                schedule_old: false,
                schedule_new: true,
                energyMonitor: true,
                history: true,
                setting: true,
                aboutDevice: true, 
                changeMapEnabled: false,
                mapActionBtnText:"START",
                mapActionBtnEnabled:false,
                selectingRoom:"popup_after",
                oobe123Start:"popup",
                mapSave:false,
                oobe456:false,
                mapCreateBtn:true,
                progressStatus : false
            },
            "Control_Homing": {
            	cleaningType : CLEANING_STATE.HOMING,
            	title: 'WEBMOB_device_rvc_status_returning_for_charging',
                power: true,
                play: false,
                playDisable: false,
                manualCtrlEnabled: false,
                spot: false,
                charging: false,
                suction: false,
                schedule_old: false,
                schedule_new: true,
                energyMonitor: true,
                history: true,
                setting: true,
                aboutDevice: true, 
                changeMapEnabled: false,
                mapActionBtnText:"START",
                mapActionBtnEnabled:false,
                selectingRoom:"popup",
                oobe123Start:"popup",
                mapSave:false,
                oobe456:false,
                mapCreateBtn:true,
                progressStatus : false
            },
            "Control_Idle": {
            	cleaningType:CLEANING_STATE.IDLE,
            	title: 'WEBMOB_device_rvc_status_waiting',
                power: true,
                play: true,
                playDisable: false,
                manualCtrlEnabled: true,
                spot: true,
                charging: true,
                suction: true,
                schedule_old: false,
                schedule_new: true,
                energyMonitor: true,
                history: true,
                setting: true,
                aboutDevice: true, 
                changeMapEnabled: false,
                mapActionBtnText:"START",
                mapActionBtnEnabled:false,
                selectingRoom:"popup",
                oobe123Start:"popup",
                mapSave:false,
                oobe456:false,
                mapCreateBtn:true,
                progressStatus : false
            },
            "Control_Charging": {
            	cleaningType: CLEANING_STATE.CHARGING,
            	title: 'VCMOB_status_charging',
                power: false,
                play: true,
                playDisable: false,
                manualCtrlEnabled: true,
                spot: false,
                charging: false,
                suction: true,
                schedule_old: true,
                schedule_new: true,
                energyMonitor: true,
                history: true,
                setting: true,
                aboutDevice: true, 
                changeMapEnabled: true,
                mapActionBtnText:"START",
                mapActionBtnEnabled:true,
                selectingRoom:"enable",
                oobe123Start:"enable",
                mapSave:true,
                oobe456:false,
                mapCreateBtn:true,
                progressStatus : false
            },
            "Control_Reserve": {
            	title:'VCMOB_status_reserve',
            	power: true,
                play: true,
                playDisable: false,
                manualCtrlEnabled: false,
                spot: false,
                charging: false,
                suction: true,
                schedule_old: true,
                schedule_new: true,
                energyMonitor: true,
                history: true,
                setting: true,
                aboutDevice: true, 
                changeMapEnabled: false,
                mapActionBtnText:"START",
                mapActionBtnEnabled:false,
                selectingRoom:"popup_reserve",
                oobe123Start:"enable",
                mapSave:false,
                oobe456:false,
                mapCreateBtn:true,
                progressStatus : false
            },
            "Control_Pause": {
            	cleaningType:CLEANING_STATE.PAUSE,
            	title: 'VCMOB_status_pause',
                power: true,
                play: true,
                playDisable: false,
                manualCtrlEnabled: true,
                spot: true,
                charging: true,
                suction: true,
                schedule_old: false,
                schedule_new: true,
                energyMonitor: true,
                history: true,
                setting: true,
                aboutDevice: true, 
                changeMapEnabled: false,
                mapActionBtnText:"START",
                mapActionBtnEnabled:false,
                selectingRoom:"popup",
                oobe123Start:"popup",
                mapSave:false,
                oobe456:false,
                mapCreateBtn:true,
                progressStatus : false
            },
            "Cleaning_Manual": {
            	cleaningType: CLEANING_STATE.MANNUAL,
            	title: 'WEBMOB_device_rvc_status_manual_cleaning',
                manualCtrlEnabled: true,
            },
            "Cleaning_Auto": {
            	cleaningType: CLEANING_STATE.AUTO,
            	title: 'WEBMOB_device_rvc_status_auto_cleaning',
                manualCtrlEnabled: false,
                progressStatus : true
            },
            "Cleaning_Part": {
            	cleaningType: CLEANING_STATE.SPOT,
            	title: 'WEBMOB_device_rvc_status_spot_cleaning',
                manualCtrlEnabled: false,
            	progressStatus : true
            },
            "Cleaning_map":{
            	cleaningType : CLEANING_STATE.MAP,
            	title:'WEBMOB_device_rvc_status_creating_map',
            	manualCtrlEnabled: false,
            	progressStatus : true
            },
            "Control_Cleaning": {
                power: true,
                play: false,
                playDisable: false,
                spot: false,
                charging: true,
                suction: true,
                schedule_old: false,
                schedule_new: true,
                energyMonitor: true,
                history: true,
                setting: true,
                aboutDevice: true, 
                changeMapEnabled: false,
                mapActionBtnText:"START",
                mapActionBtnEnabled:false,
                selectingRoom:"popup",
                oobe123Start:"popup",
                mapSave:false,
                oobe456:false,
                mapCreateBtn:true,
                progressStatus : true
            },
            "Control_Creating": {
            	title: 'WEBMOB_device_rvc_map_guide_creating_title',
                power: true,
                play: false,
                playDisable: false,
                manualCtrlEnabled: false,
                spot: false,
                charging: true,
                suction: false,
                schedule_old: false,
                schedule_new: true,
                energyMonitor: true,
                history: true,
                setting: true,
                aboutDevice: true, 
                changeMapEnabled: false,
                oobe456:true,
                mapCreateBtn:true,
                progressStatus : true
            },
            "Control_CreatingPause": {
            	title: 'WEBMOB_device_rvc_status_pause_creating',
                power: true,
                play: true,
                playDisable: false,
                manualCtrlEnabled: false,
                spot: false,
                charging: true,
                suction: false,
                schedule_old: false,
                schedule_new: true,
                energyMonitor: true,
                history: true,
                setting: true,
                aboutDevice: true, 
                changeMapEnabled: false,
                oobe456:true,
                mapCreateBtn:true,
                progressStatus : false
            },
            "Control_MapMoving": {
            	cleaningType : CLEANING_STATE.MAP,
                power: true,
                play: false,
                playDisable: false,
                manualCtrlEnabled: false,
                spot: false,
                charging: true,
                suction: true,
                schedule_old: false,
                schedule_new: true,
                energyMonitor: true,
                history: true,
                setting: true,
                aboutDevice: true, 
                changeMapEnabled: false,
                mapActionBtnText:"PAUSE",
                mapActionBtnEnabled:true,
                selectingRoom:"disable",
                oobe456:false,
                mapCreateBtn:true,
                progressStatus : true
                	
            },
            "Control_MapCleaning": {
            	cleaningType: CLEANING_STATE.MAP,
                power: true,
                play: false,
                playDisable: false,
                manualCtrlEnabled: false,
                spot: false,
                charging: true,
                suction: true,
                schedule_old: false,
                schedule_new: true,
                energyMonitor: true,
                history: true,
                setting: true,
                aboutDevice: true, 
                changeMapEnabled: false,
                mapActionBtnText:"PAUSE",
                mapActionBtnEnabled:true,
                selectingRoom:"disable",
                oobe456:false,
                mapCreateBtn:true,
                progressStatus : true
            },
            'Control_MapSelected':{
            	title:'WEBMOB_device_rvc_status_room_selected',
                cleaningType : CLEANING_STATE.MAP
            },
            'Control_MapCleaned' : {
            	//title: 'WEBMOB_device_rvc_map_room_clean_done'
            },
            'Control_MapStopped' : {
            	//title: 'WEBMOB_device_rvc_map_room_cleaning_stop'
            },
            'Control_MapFailed' : {
            	//title: 'WEBMOB_device_rvc_status_room_cleaning_failed'
            },
            "Control_MapPause": {
            	title: 'WEBMOB_device_rvc_status_sng_pause',
            	cleaningType: CLEANING_STATE.MAP,
            	power: true,
                play: true,
                playDisable: false,
                manualCtrlEnabled: true,
                spot: true,
                charging: true,
                suction: true,
                schedule_old: false,
                schedule_new: true,
                energyMonitor: true,
                history: true,
                setting: true,
                aboutDevice: true, 
                changeMapEnabled: false,
                mapActionBtnText:"RESUME",
                mapActionBtnEnabled:true,
                selectingRoom:"popup",
                oobe123Start:"popup",
                mapSave:false,
                oobe456:false,
                mapCreateBtn:false,
                progressStatus : false
            }
        };
    
    var tempControlsStatus = {};
    var debugMode = false,
        promise,
        langArr = Object.keys(LANGUAGE_FILE.language),
        RVCCONST = {
            TURBO_ON: 0,
            TURBO_OFF: 1,
            TURBO_SILENCE: 2,
            GET: "GET",
            PUT: "PUT",
            POST: "POST",
            DELETE: "DELETE",
            GET_DEVICE: "getDevices",
            GET_ACTIONS: "actions",
            SET_TIME: "setTIme",
            POWER: "power",
            MODES: "modes",
            MOVEMENT: "movement",
            MAP: "map",
            CLEANING_AREA: "cleaningArea",
            HISTORY_REQUEST: "historyRequest",
            ENERGY_MONITOR: "energyMonitor",
            //	    STOP_CREATING_MAP : 14,
            DOOR_WIDTH: 60,
            DOOR_HEIGHT: 68,
            CHARGER_WIDTH: 88,
            CHARGER_HEIGHT: 104,
            CREATING_MAP_REQUEST: 500,
            PARSE_MODULEINFO: 501
        },
        SCREEN = {
            HOME: 1,
            SCHEDULELIST: 3,
            ADDSCHEDULE: 4,
            SETTINGS: 5,
            SETTINGOPTION: 6,
            ABOUT: 7,
            CHANGEMAP: 8,
            RENAME: 9,
            INTRO: 10,
            CREATING_MAP: 11,
            HISTORY: 12,
            ENERGY: 13,
            TUTORIALPAGE: 14,
            DETAILEDTUTORIALPAGE: 15
        },
        TAB = {
            CONTROLLER: 1,
            MAP: 2
        },
        BATTERY_IMG = {
            100: 5,
            75: 4,
            50: 3,
            25: 2
        },
        RVC_ERR = {
            0: 'VCMOB_alarm_Imprisonment_0',
            1: 'VCMOB_alarm_BrushDamage_1',
            2: 'VCMOB_alarm_LeftWheelDamage_2',
            3: 'VCMOB_alarm_RightWheelDamage_3',
            5: 'VCMOB_alarm_BumperSensorDamage_5',
            6: 'VCMOB_alarm_ObstacleSensorDamage_6',
            7: 'VCMOB_alarm_FallSensorDamage_7',
            8: 'VCMOB_alarm_DustCanisterNotDetect_8',
            9: 'VCMOB_alarm_SideBrushDamage_9',
            10: 'VCMOB_alarm_ChargingForBattery_10',
            27: 'VCMOB_alarm_LiftedUp_27',
            //            28: 'toast for smartphone'    //Lokesh 07Nov15_2230 -> It generates toast for Native app. Not used in web app. But, kept here for information.           
            29: 'VCMOB_alarm_ScheduleCleaning_29',
            30: 'VCMOB_alarm_FailScheduleCleaning_30'
        },
        RVCLOCALSTORAGE = {
            DONTSHOWAGAIN: "DONTSHOWAGAIN"
        },
        RVCSCHEDULE = {
            NONE: 0,
            A: 1,
            B: 2
        },
        STRINGTOBEREPLACED = {
            NO_MAP_DATA: "No Maps Available. Please create one.",
            MASTER_MAP_CHANGED: "Master map has changed.",
            SELECT_ROOM: "Please select the area.",
            REMOTE_LOCKED_ERR: " Set is in remote lock state."
        },
        MAP_STATE = {
            NONE: 0,
            AVAILABLE: 1,
            NOT_AVAILABE: 2,
            CREATING: 3,
            CREATING_PAUSE: 4
        },
        SLIDE = {
            LEFT: 0,
            RIGHT: 1
        },
        oobe123 = [{
            id: 0,
            title: "WEBMOB_device_rvc_map_guide_before_check_title",
            img: "images/rvc/charging_image_01.png",
            txt: "WEBMOB_device_rvc_map_guide_before_check_msg"
        }, {
            id: 1,
            title: "WEBMOB_device_rvc_map_guide_before_check_title",
            img: "images/rvc/charging_image_02.png",
            txt: 'WEBMOB_device_rvc_map_guide_for_creaging_map'
        }],
        oobe456 = [{
            id: 0,
            title: "WEBMOB_device_rvc_map_guide_rvc_title",
            img: 'images/rvc/creating_map_preview_image_01.png',
            txt: 'WEBMOB_device_rvc_map_guide_creating_step1_msg'

        }, {
            id: 1,
            title: "WEBMOB_device_rvc_map_guide_rvc_title",
            img: 'images/rvc/creating_map_preview_image_02.png',
            txt: 'WEBMOB_device_rvc_map_guide_creating_step2_msg'
        }, {
            id: 2,
            title: "WEBMOB_device_rvc_map_guide_rvc_title",
            img: 'images/rvc/creating_map_preview_image_03.png',
            txt: 'WEBMOB_device_rvc_map_guide_creating_step3_msg'
        }],
        
        MAP_CLEANING_STATE = { //Lokesh 07Nov15_1551 -> The values 1, 2, 3 ,4 resembles values received from RVC in map clea text file. So, keep them as it is. This object is used to track map cleaning notifications received from RVC.
            NONE: 0,
            SELECTED: 1, //received when room is selected for map cleaning.
            MOVING: 2, //received when RVC moves in a room for cleaning.
            CLEANING: 3, //received when RVC is cleaning room.
            CLEANED: 4 //received when RVC has cleaned the room.
            ,PAUSE: 7 //received when RVC has cleaning pause
        },
        slideScrnCnt = 3,
        currentSelectedRoom = -1,
        deviceID = "",
        maxWidthX,
        maxHeightY,
        doorHeight,
        doorWidth,
        chargerWidth,
        chagerHeight,
        roomNameWidth,
        roomNameHeight,
        roomStatusWidth,
        roomStatusHeight,
        currentScreen = SCREEN.NONE,
        mapCleanRoomState = MAP_CLEANING_STATE.NONE,
        selectedRoomsForCleaning = [];
        touchStartTime = -1;
        touchEndTime = -1;
        mannualCtrChargingFlag = false;
        prevMasterMapId = '';
        isMapCreationComplete = false;
        scheduleRemoved = false;

    //Scope variables declaration.
    $scope.Device = {
        id: '',
        description: '',
        AVSourcesLink: {
            href: ''
        },
        Alarms: [{
            alarmType: '',
            code: '',
            id: '',
            triggeredTime: '',
            errormsg: ''
        }],
        Audio: {
            micPower: 'Off'
        },
        ConfigurationLink: {
            href: ''
        },
        Detection: {
            motionDetected: false
        },
        EnergyConsumption: {
            batteryCharge: 0
        },
        InformationLink: {
            href: ''
        },
        Light: {
            dimmingLevel: 0,
            lightPower: 'Off',
            maxDimmingLevel: 0
        },
        Mode: {
            modes: [],
            supportedModes: []
        },
        Movement: {
            Map: '',
            behavior: '',
            MapDetailData: '',
            MapCleaningStatusData: ''
        },
        Operation: {
            power: ''
        },
        connected: '',
        name: '',
        resources: [],
        type: '',
        uuid: ''
    };
    $scope.DeviceOptions = {
        scheduleOnce: false,
        scheduleDaily: false,
        alarm: false,
        selectedArrow: '',
        selectedText: '',
        selectedMode: {},
        selectedVoice: 'VCMOB_setting_voice_title',
        controls: {
            manualCtrlEnabled: true, //merge left / right/ up flag into one.
            spot: true,
            play: true,
            charging: true,
            suction: true,
            schedule: false,
            history: true,
            energyMonitor: true,
            setting: true, // Default State
            mapCleaning: false,
            changeMapEnabled: false,
            mapActionBtnEnabled: false,
            isReserved: false,
            mapTabDisable: false,
            aboutDevice: true // Default is true
        },
        cleaning_type: CLEANING_STATE.NONE
    };
    $scope.selectedSchedule = {
        id: '',
        Actuators: [{
            "Mode": {
                "modes": ["Cleaning_Auto"]
            },
            "deviceIDs": ["0"]
        }],
        dayOfWeek: [],
        disposable: true,
        enabled: true,
        repeatPeriod: '',
        startTime: '',
        hours: 0,
        minutes: 0,
        amPm: 0,
        keypadOn: false
    };
    $scope.dialogPopup = {
        show: false,
        dialogPopupTitle: '',
        dialogPopupText: '',
        button1Title: '',
        button1Handler: function() {
            $scope.dialogPopup.show = false;
        },
        button2Enabled: false,
        button2Title: '',
        button2Handler: function() {}
    };
    $scope.tutorialPage = {
        tutorialPageIndex: 1,
        totalPages: 0,
        pageButtonText: ["NEXT", "START"],
        pageButtonImg: ["images/rvc/charging_image_02.png", "images/rvc/charging_image_01.png"],
        showCreateMapScreenPage: false,
        startScreen: false,
        doneTutorial: false
    };
    
    $scope.SuctionPowerList = [{
        id: 'TURBO_ON',
        imageID: "images/rvc/main_list_ic_max.svg#Layer_1",
        modeName: "WEBMOB_device_rvc_suction_power_max"
    }, {
        id: 'TURBO_OFF',
        imageID: "images/rvc/main_list_ic_normal.svg#Layer_1",
        modeName: "WEBMOB_device_rvc_suction_power_normal"
    }, {
        id: 'TURBO_SILENCE',
        imageID: "images/rvc/main_list_ic_quiet.svg#Layer_1",
        modeName: "WEBMOB_device_rvc_suction_power_quiet"
    }];

    $scope.voiceControlList = [{
        id: 'SOUND_EFFECT',
        modeName: "VCMOB_setting_soundeffect_contents"

    }, {
        id: 'SOUND_MUTE',
        modeName: "VCMOB_setting_mute_contents"
    }];

    $scope.mapFileLoc = {
        cleaingTxt: '',
        masterMap: '',
        masterMapLoc: '',
        allMap: ''
    };

    $scope.checkResponse = [];
    $scope.tabIdx = 1;
    $scope.powerState = true;

    $scope.selectedRoomList = [];
    $scope.masterMapIndex = 0;
    $scope.maxLengthRoomName = 60;
    $scope.roomNameOffset = $scope.maxLengthRoomName / 2;
    
    $scope.Actions_new = [];
    $scope.Actions_old = [];
    
    $scope.isRVC = true;
    $scope.currentSelectedMap = $scope.masterMapIndex;
    $scope.additionalInfoSelectedText = '';
    $scope.mapListWidth = " ";

    $scope.containSubCl = "containSub"; //initially the class should be present.
    $scope.BottomPopupDivCls = ''; // Initially no class should be applicable.
    $scope.BottomPopupDimBackgroundDiv = ''; // Initially no class should be applicable.
    $scope.showTutorialPage = false;
    $scope.currentTab = 1;
    $scope.deviceID = "";
    $scope.roomStatusNotetionWidth = 90;
    $scope.roomStatusNotetionWidth = 92;
    $scope.roomStatusNotetionHeight = 92;
    $scope.roomNotationBottomMargin = 16;
    $scope.direction = SLIDE.LEFT;
    $scope.currentIndex = 0;
    $scope.isMap = false;
    $scope.scheduleType;
    $scope.selectedScheduleType; //App can show two type of schedule. so selectedSchedyleType indicate what user currently selected type. 
    $scope.mapState = MAP_STATE.NOT_AVAILABE; //used to judge map State. Possible values are NONE, AVAILABE, NOT_AVAILABLE, and CREATING. Default state is not available.
    $scope.dontShowButtonClicked = JSON.parse(getLocalStorageData(RVCLOCALSTORAGE.DONTSHOWAGAIN));
    $scope.noMapTxt = STRINGTOBEREPLACED.NO_MAP_DATA;
    $scope.showRenameRoomPopup = false;
    $scope.renameRoomList = {};
    $scope.focus = false;
    $scope.tutVidIndex = 0;
    $scope.vidTutorialPage = false;
    $scope.detailedTutorial = false;
    $scope.isSuctionA = false;
    $scope.isKorean = false;
    //Function declaration.

    //Service Fucntions
    $scope.getWeatherDayList = ScheduleService.getWeatherDayList; //give weather day list in local language.
    $scope.keypadClicked = ScheduleService.keypadClicked;
    var dismissLoadingBar = UtilityService.dismissLoadingBar,
        appendZero = UtilityService.appendZero,
        setTimeInGMT = ScheduleService.setTimeInGMT;
    setTimeInGMTforRVC = ScheduleService.setTimeInGMTforRVC;
    getDayIndexFromText = ScheduleService.getDayIndexFromText;
    getWeatherDayText = ScheduleService.getWeatherDayText;
    
    //Local Functions
    $scope.onClickTab = onClickTab;
    $scope.isHomeScreen = isHomeScreen;
    $scope.isMapDataAvailable = isMapDataAvailable;
    $scope.showIntroScreen = showIntroScreen;
    $scope.textHeightCheck = textHeightCheck;
    $scope.checkBeforeCreatingMap = checkBeforeCreatingMap;
    $scope.init = init;
    $scope.handleStatusCode = handleStatusCode;
    $scope.showConnectionFailurePopup = showConnectionFailurePopup;
    $scope.closeConnectionFailurePopup = closeConnectionFailurePopup;
    $scope.updateDeviceData = updateDeviceData;
    $scope.parseDeviceData = parseDeviceData;
    $scope.parseHistoryData = parseHistoryData;
    $scope.parseEnergyUsageData = parseEnergyUsageData;
    $scope.parseStaticData = parseStaticData;
    $scope.powerOnOff = powerOnOff;
    $scope.ModeChangeRVC = ModeChangeRVC;
    $scope.MovementChangeRVC = MovementChangeRVC;
    $scope.toggleRoomCleaning = toggleRoomCleaning;
    $scope.changeAnimScreen = changeAnimScreen;
    $scope.gotoAddSchedule = gotoAddSchedule;
    $scope.startProgress = startProgress;
    $scope.scheduleList = scheduleList;
    $scope.historyList = historyList;
    $scope.goToEnergyMonitor = goToEnergyMonitor;
    $scope.onBackPressed = onBackPressed;
    $scope.openPopoverTemp = openPopoverTemp;
    $scope.getCurrentSelectedRoomName = getCurrentSelectedRoomName;
    $scope.closeSuctionPowerPopup = closeSuctionPowerPopup;
    $scope.openPopoverTempSetting = openPopoverTempSetting;
    $scope.setSuctionPower = setSuctionPower;
    $scope.changeVoiceControl = changeVoiceControl;
    $scope.increaseHours = increaseHours;
    $scope.decreaseHours = decreaseHours;
    $scope.onAsRepeatWeakly = onAsRepeatWeakly;
    $scope.increaseMinutes = increaseMinutes;
    $scope.decreaseMinutes = decreaseMinutes;
    $scope.changeMeridian = changeMeridian;
    $scope.turnOnOffSchedule = turnOnOffSchedule;
    $scope.deletSchedulePopupCancelHandler = deletSchedulePopupCancelHandler;
    $scope.deletScheduleOkHandler = deletScheduleOkHandler;
    $scope.addSchedule = addSchedule;
    $scope.saveSchedule = saveSchedule;
    $scope.onHoursLostFocus = onHoursLostFocus;
    $scope.onMinsLostFocus = onMinsLostFocus;
    $scope.onHoursMinsFocusGain = onHoursMinsFocusGain;
    $scope.increaseHrContinuously = increaseHrContinuously;
    $scope.decreaseHrContinuously = decreaseHrContinuously;
    $scope.increaseMinContinuously = increaseMinContinuously;
    $scope.decreaseMinContinuously = decreaseMinContinuously;
    $scope.asTabSelected = asTabSelected;
    $scope.stopLongPressEvent = stopLongPressEvent;
    $scope.daySelected = daySelected;
    $scope.dayColorSelected = dayColorSelected;
    $scope.removeItemFromSchedule = removeItemFromSchedule;
    $scope.getBatteryClass = getBatteryClass;
    $scope.requestFailHandler = requestFailHandler;
    $scope.onRoomClicked = onRoomClicked;
    $scope.onRoomNameClicked = onRoomNameClicked;
    $scope.checkForRoomSelection = checkForRoomSelection;
    $scope.onMapClicked = onMapClicked;
    $scope.onClickChangeMapBottomBtn = onClickChangeMapBottomBtn;
    $scope.getRoomBoundryColor = getRoomBoundryColor;
    $scope.getRoomBoundryWidth = getRoomBoundryWidth;
    $scope.prepareRoomPolygonData = prepareRoomPolygonData;
    $scope.getDoorImage = getDoorImage;
    $scope.getDoorPos = getDoorPos;
    $scope.getDoorDim = getDoorDim;
    $scope.getChargerPos = getChargerPos;
    $scope.getRoomNamePos = getRoomNamePos;
    $scope.getRoomStatus = getRoomStatus;
    $scope.getRoomBGColor = getRoomBGColor;
    $scope.getRoomStatusPosition = getRoomStatusPosition;
    $scope.getRoomStatusNotationDim = getRoomStatusNotationDim;
    $scope.onDontShowAgainButtonClicked = onDontShowAgainButtonClicked;
    $scope.goToLeft = goToLeft;
    $scope.goToRight = goToRight;
    $scope.setCurrentSlideIndex = setCurrentSlideIndex;
    $scope.isCurrentSlideIndex = isCurrentSlideIndex;
    $scope.checkTodayDate = checkTodayDate;
    $scope.closeApp = closeApp;
    $scope.toggleCreateMap = toggleCreateMap;
    $scope.getMapActionBtnText = getMapActionBtnText;
    $scope.getCreateBtnTxt = getCreateBtnTxt;
    $scope.stopMannaulCtr = stopMannaulCtr;
    $scope.touchStart = touchStart;
    $scope.touchEnd = touchEnd;
    $scope.getDayOfWeekMulti = getDayOfWeekMulti;
    $scope.openRenameRoomPopover = openRenameRoomPopover;
    $scope.onRenameKeyEnter = onRenameKeyEnter;
    $scope.onClickRenameBtn = onClickRenameBtn;
    $scope.focusInputBox = focusInputBox;
    $scope.getRoomNameForDisplayonRenamePage = getRoomNameForDisplayonRenamePage;
    $scope.maxLengthCheck = maxLengthCheck;
    $scope.getYAxisValue = EnergyService.getYAxisValue;
    $scope.onFocusChanged = onFocusChanged;
    $scope.isSelectedRoomName = isSelectedRoomName;
    $scope.mapDateTimeArr = [];
    $scope.tempText = "Unable to show this layout because it was not completed correctly."
    
    $scope.getPxByPx = getPxByPx;
    $scope.getRemByPx = getRemByPx;
    $scope.getLRPosition = getLRPosition;
    $scope.getLang = getLang;
    $scope.isFirstManualPopup = true;
    
    $scope.getRoomBoundrySize = getRoomBoundrySize;
    $scope.moveToSchedule = moveToSchedule;
    $scope.rotationDeg = getLocalStorageData("rotationDeg");
    $scope.rotateMap = rotateMap;
    
    $scope.getOffsetPath = getOffsetPath;
    $scope.getRoomName = getRoomName;
    
    $scope.getPathMaskId =  getPathMaskId;
    
    $scope.getPathStrokeWidth = getPathStrokeWidth;
    $scope.Math = Math;
    $scope.brushSize = 4.0;
    	
    function toggleAnimClass() {
        if ($scope.containSubCl === "containSub") {
            $scope.containSubCl = "";
        } else {
            $scope.containSubCl = "containSub";
        }
    }
    
    
//    if (langArr.indexOf(LANG.toUpperCase()) === -1) {
//        $scope.translation = LANGUAGE_FILE["language"]["DEFAULT"];
//    } else {
//        $scope.translation = LANGUAGE_FILE["language"][LANG.toUpperCase()];
//    }
    
    if (langArr.indexOf(LANG.toUpperCase())!== -1){
        $scope.translation = LANGUAGE_FILE["language"][LANG.toUpperCase()];
    } else if(langArr.indexOf(LANG.toUpperCase().substring(0,2))!== -1) {
        $scope.translation = LANGUAGE_FILE["language"][LANG.toUpperCase().substring(0,2)];
    } else {
        $scope.translation = LANGUAGE_FILE["language"]["DEFAULT"];
    } 
    
    if(LANG.toUpperCase().substring(0,2) === 'KO') {
        $scope.isKorean = true;
    }

    $scope.ScheduleText = $scope.translation.WEBMOB_common_none;
    // About page start
    $scope.onAboutAction = function(reqParam) {
        var selectedCountry;
        selectedCountry = $scope.selectedCountry;
        /*if(reqParam === "tutorial"){           
            changeScreen(SCREEN.TUTORIALPAGE);
            return;
        }*/
        if(reqParam === 'tutorial' || reqParam === 'manual' || reqParam === 'helpdesk') {
            if($scope.selectedCountry === "BE") {
                $scope.countryToSelect = [];
                $scope.countryToSelect.push({'Country': 'Belgium'});
                $scope.countryToSelect.push({'Country': 'Belgium(French)'});
                reqParamCountrySelection = reqParam;
                $scope.showcustCountrySelectionPopup();
            } else if($scope.selectedCountry === "CA") {
                $scope.countryToSelect = [];
                $scope.countryToSelect.push({'Country': 'Canada'});
                $scope.countryToSelect.push({'Country': 'Canada(French)'});
                reqParamCountrySelection = reqParam;
                $scope.showcustCountrySelectionPopup();
            } else if($scope.selectedCountry === "CH") {
                $scope.countryToSelect = [];
                $scope.countryToSelect.push({'Country': 'Switzerland'});
                $scope.countryToSelect.push({'Country': 'Switzerland(French)'});
                reqParamCountrySelection = reqParam;
                $scope.showcustCountrySelectionPopup();
            } else {
                /*if($scope.isStatic) {
                    $scope.selectedCountry = "BE";
                    $scope.showcustCountrySelectionPopup();
                    return;
                }*/
                $timeout(function () {
                    nativeInterface.runOnNative("customerService", aboutCommand(reqParam));
                }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
            }
        } else {
            $timeout(function () {
                nativeInterface.runOnNative("customerService", aboutCommand(reqParam));
            }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
        }
    };
    
    function aboutCommand(cmdstring, changedCode) {
        if(changedCode) {
            return '{"service" : "' + cmdstring + '","selectedCountry" : "' + $scope.selectedCountry + '_FR"}';
        } else {
            return '{"service" : "' + cmdstring + '","selectedCountry" : "' + $scope.selectedCountry + '"}';
        }
    }
    
    $scope.showcustCountrySelectionPopup = function() {
        //debugMessage("showcustCountrySelectionPopup :: "+countryName[0]);
        $scope.countrySelectionPopupVisible = true;
    };
    
    $scope.onCountrySelected = function (countryIndex) {
        console.log("country selected is "+countryIndex);
        $scope.countrySelectedIndex = countryIndex;
    };
    
    $scope.onCountrySelectedOkClicked = function (isCountrySelected) {
        if(isCountrySelected) {
            if($scope.countrySelectedIndex === 0){
                $timeout(function () {
                    nativeInterface.runOnNative("customerService", aboutCommand(reqParamCountrySelection));
                }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
            } else {
                $timeout(function () {
                    nativeInterface.runOnNative("customerService", aboutCommand(reqParamCountrySelection, true));
                }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
            }
        }
        $scope.closeCountrySelectionPopup();
    };
    
    $scope.closeCountrySelectionPopup = function () {
        $scope.countrySelectionPopupVisible = false;
    };

    //Set Watches

    // Control hours value in add schedule screen
    $scope.$watch(function() {
        return $scope.selectedSchedule.hours;
    }, changeScheduleHours);

    // Control minutes value in add schedule screen
    $scope.$watch(function() {
        return $scope.selectedSchedule.minutes;
    }, changeScheduleMins);

    $scope.$watch(function() {
        return $scope.DeviceOptions.selectedMode.imageID;
    }, function(newVal, oldVal) {
        if (newVal !== oldVal) {
            changeSuctionPowerImage($scope.DeviceOptions.selectedMode.imageID);
        }
    });
    
    $scope.$watch(function() {
        return $scope.Device.EnergyConsumption.batteryCharge;
    }, function(newVal, oldVal) {
        if (newVal !== oldVal) {
            getBatteryClass();
        }
    });

    function getCreateBtnTxt() {
        var langObj = $scope.translation,
            txt;
        switch ($scope.mapState) {
            case MAP_STATE.CREATING:
                txt = langObj.VCMOB_status_pause;
                break;
            case MAP_STATE.CREATING_PAUSE:
                txt = langObj.WEBMOB_device_rvc_status_resume;
                break;
            default:
                txt = langObj.WEBMOB_device_rvc_map_create_new_map;
                break;
        }
        return txt;
    }

    function goToLeft(number) {
        $scope.direction = SLIDE.RIGHT;
        $scope.currentIndex = ($scope.currentIndex > 0) ? --$scope.currentIndex : number - 1;
        //TODO
    }
    function goToRight(number) {
        $scope.direction = SLIDE.LEFT;
        $scope.currentIndex = ($scope.currentIndex < number - 1) ? ++$scope.currentIndex : 0;
        //TODO
    }

    function setCurrentSlideIndex(index) {
        $scope.direction = (index > $scope.currentIndex) ? SLIDE.LEFT : SLIDE.RIGHT;
        $scope.currentIndex = index;
    }

    function isCurrentSlideIndex(index) {
        return $scope.currentIndex === index;
    };

    function changeScheduleHours(newVal, oldVal) {
        if (newVal === undefined || newVal > 12) {
            $scope.selectedSchedule.hours = oldVal;
        }
    }

    function changeScheduleMins(newVal, oldVal) {
        if (newVal === undefined || newVal > 59) {
            $scope.selectedSchedule.minutes = oldVal;
        }
    }

    function changeSuctionPowerImage(temp) {
        var svg = document.getElementById('suctionPowerId');
        SHPService.loadSVG(temp, svg);
        //return temp;
    }

    function onClickTab(val) {
        if ($scope.tabIdx === val) { //if remote locked or same tab clicked.
            return; // if remote locked, dont hanle click
        }
        $scope.tabIdx = val;
        $scope.showController = val !== TAB.CONTROLLER;
        if (val === TAB.CONTROLLER) {
            changeScreen(SCREEN.HOME);
        } else if (val === TAB.MAP) {
            $scope.selectedRoomList = [];
            selectedRoomNameIndex = -1;

            //map should not be in creating process.
            if ($scope.mapState !== MAP_STATE.CREATING && $scope.mapState !== MAP_STATE.CREATING_PAUSE) {
                if (isMapDataAvailable()) {   
                	var allErrMap = true;
                    for(var i=0; i<$scope.Device.Movement.Map.length;i++){
                    	if($scope.Device.Movement.Map[i].errMap != true){
                    		allErrMap = false;
                    		break;
                    	}        	
                    }
                    if(allErrMap){
            	        showErrorMapPopup();
            			$scope.mapState = MAP_STATE.NOT_AVAILABE;
            	        $scope.tutScreens = oobe123;
                    }else{
                    	$scope.mapState = MAP_STATE.AVAILABLE;
                        $scope.tutScreens = null;
                    }
                } else {
                    $scope.mapState = MAP_STATE.NOT_AVAILABE;
                    $scope.tutScreens = oobe123;
                }
            }
            if ('VCMOB_status_charging'===$scope.DeviceOptions.selectedText)
            {
            	console.log(isMapDataAvailable() + "//" + $scope.DeviceOptions.selectedText);
                $scope.DeviceOptions.controls.changeMapEnabled = isMapDataAvailable();
            }

        } else { //For SONAR
            //Null
        }
    }

    function calcMaxDim(mapIndex) {
        if ($scope.Device.Movement.Map && $scope.Device.Movement.Map.length > 0) {
            maxWidthX = $scope.Device.Movement.Map[mapIndex].maxWidthX;
            maxHeightY = $scope.Device.Movement.Map[mapIndex].maxHeightY;
            //$scope.roomFont = 66 * maxWidthX / 1440;
            $scope.roomFont = 80 * maxWidthX / 1440;
            roomNameWidth = -1;
            roomNameHeight = -1;
        }
    }

    // Toggle class for Mode drop down
    function toggleBottomPopUpClass(popupName) {
        if (popupName) {
            $scope.BottomPopupDimBackgroundDiv = "BottomPopupDimBackgroundDivIn-rvc";
            $scope.BottomPopupDivCls = "BottomPopupBGIn-rvc";
        } else {
            $scope.BottomPopupDimBackgroundDiv = "BottomPopupDimBackgroundDivOut-rvc";
            $scope.BottomPopupDivCls = "BottomPopupBGOut-rvc";
        }
    }

    function isHomeScreen() {
        return currentScreen === SCREEN.HOME;
    }

    function isMapDataAvailable() { // check for wheather to show map tab or not
        var map = $scope.Device.Movement.Map;
        return (!!$scope.isMap && !!$scope.isMapDownloaded && !!map && !!map.length); // if map file downloaded, and map data available, show map screen
    }

    function showHomeScreen(controllerTab) {
        $scope.showController = controllerTab;
        changeScreen(SCREEN.HOME);
    }

    function showIntroScreen() {
        if ($scope.remoteLocked || !$scope.powerState || $scope.DeviceOptions.alarm) {
            showHomeScreen(true);
            return;
        }
        $scope.currentIndex = 0;
        $scope.isPopup = true;
    }

    function showMapTabHandle() {
        if ($scope.mapState === MAP_STATE.CREATING || $scope.mapState === MAP_STATE.CREATING_PAUSE) {
            $scope.mapState = MAP_STATE.NONE;
            if ($scope.tabIdx === TAB.MAP) {
                $scope.tabIdx = -1;
                onClickTab(TAB.MAP);
            } else {
                onClickTab(TAB.CONTROLLER);
            }

        }
        if ($scope.isPopup && currentScreen !== SCREEN.HOME) {
            $scope.isPopup = false;
            showHomeScreen(true);
        }
        if ($scope.isPopup) {
            $scope.isPopup = false;
        }
    }

    function textHeightCheck() {
        if ($(".rvc_create_map_text").height() == 17) {
            $(".rvc_create_map_text").css("margin-top", "0.85rem");
        }
    }

    function hideIntroScreen() {
        $scope.isPopup = false;
    }

    function toggleCreateMap() {
        switch ($scope.mapState) {
            case MAP_STATE.CREATING:
                //if map is already in creating state, then stop creation and come to pause state.
                ModeChangeRVC('STOP');
                break;
            case MAP_STATE.CREATING_PAUSE:
                //if map creation was paused, then resume map creation.
                ModeChangeRVC('CREATING_MAP');
                $scope.tutScreens = oobe456;
                break;
            default:
                //in rest other cases, show intro screen.
                showIntroScreen();
                break;
        }
    }

    /* Rename page source code Starts here */
    function openRenameRoomPopover(roomIndex) {
        currentSelectedRoom = roomIndex;
        $scope.showRenameRoomPopup = true;
        toggleBottomPopUpClass($scope.showRenameRoomPopup);
        $scope.renVal = $scope.getRoomNameForDisplayonRenamePage(roomIndex, $scope.masterMapIndex);
        $timeout(function() { document.getElementById("room_name_input").value = $scope.renVal;}, 10);
    }
         
    function onRenameKeyEnter(event) {
        //Handling 'ENTER' key of keyboard
        if (event.keyCode === 13) {
            $timeout(function() {
                document.getElementById("room_name_input").blur();
            }, 100);
        }
    };
    
    function focusInputBox() {
        document.getElementById("room_name_input").focus();
    }
    
    function onFocusChanged(hasFocus) {
        if(hasFocus) { //focus gained
            $scope.focus = true;
        } else { //focus lost
              $scope.focus = false;
        }
    }
    
    function onClickRenameBtn(button, changeRenameScreen) {
        var key, input, value;
        if(changeRenameScreen) {
            if(button === 'SAVE') { // Screen save button
                for (key in $scope.renameRoomList) {
                    localStorage.setItem(key, $scope.renameRoomList[key]);
                }
            } else { // Screen Cancel Button
                $scope.renameRoomList = {};
            }
            initDataForMapDrwaing($scope.masterMapIndex);
            changeScreen(SCREEN.HOME);
        } else {
            if (button === 'SAVE') { // popup-save button
                input = document.getElementById("room_name_input");
                value = input.value.trim();
                key = $scope.deviceUuid+"¿"+$scope.Device.Movement.Map[$scope.masterMapIndex].mapId+ "¿" + getCurrentSelectedRoomName();
                $scope.renameRoomList[key] = value;
            }
            closeRenameRoomPopup();
        }
    }
    function closeRenameRoomPopup() {
        $scope.showRenameRoomPopup = false;
        $scope.focus = false;
        toggleBottomPopUpClass($scope.showRenameRoomPopup);
    }
    
    function maxLengthCheck(object, maxLength) {
        var maxLen = maxLength || object.maxLength;
        if (object.value.length > maxLen) {
            object.value = object.value.slice(0, maxLen);
        }
    }
    
    function getRoomNameForDisplayonRenamePage(roomIndex, mapIndex) {
        var roomName = '';
        var key = $scope.deviceUuid + "¿" + $scope.Device.Movement.Map[mapIndex].mapId+ "¿" +roomIndex;
        
        if(!!Object.keys($scope.renameRoomList).length && !!$scope.renameRoomList[key]) {
            roomName = $scope.renameRoomList[key];
        } else {
            roomName = (!!localStorage.getItem(key) ? localStorage.getItem(key) : ('A' +getRoomIndex(parseInt(roomIndex))) ); 
        	
        } 
        return roomName;
    }
    function getRoomIndex(index)
    {
    	rst = index;
    	if (index<10)
    		rst = "0"+rst;
    	else
    		rst = roomIndex+"";
    	return rst;
    }
    
    /* Rename page source ends here*/
    function checkBeforeCreatingMap() {
    	if($scope.DeviceOptions.controls.oobe123Start == "enable") { 
            $scope.mapState = MAP_STATE.CREATING;
            $scope.tutScreens = oobe456;
            ModeChangeRVC('CREATING_MAP');
            $scope.isPopup = false;
            //$scope.mapState = MAP_STATE.CREATING; //map state is now creating.
            //$scope.tutScreens = oobe456;
            //dismissLoadingBar(RVCCONST.CREATING_MAP_REQUEST);
            $timeout(function() {
                changeScreen(SCREEN.HOME);
            }, 1600);
        } else if ($scope.DeviceOptions.controls.oobe123Start == "popup") { 
        	showMapGuidePopup();
        } 
    }


    function changeScreen(screen) {
        if (!!screen) {
            currentScreen = screen;
        }
        $scope.homePage = false;
        $scope.optionsPage = false;
        $scope.scheduleListPage = false;
        $scope.addSchedulePage = false;
        $scope.historyPage = false;
        $scope.energyMonitorPage = false;
        $scope.settingsOptionsPage = false;
        $scope.aboutPage = false;
        $scope.changeMapPage = false;
        $scope.renamePage = false;
        $scope.introPage = false;
        $scope.creatingMapPage = false;
        $scope.vidTutorialPage = false;
        $scope.detailedTutorial = false;
        
        switch (currentScreen) {
            case SCREEN.HOME:
                $scope.homePage = true;
                $scope.isSubHeader = true;
                break;

            case SCREEN.SETTINGS:
                $scope.optionsPage = true;
                break;

            case SCREEN.ADDSCHEDULE:
                $scope.addSchedulePage = true;
                break;
            case SCREEN.SCHEDULELIST:
                $scope.scheduleListPage = true;
                break;
            case SCREEN.HISTORY:
                $scope.historyPage = true;
                break;
            case SCREEN.ENERGY:
                $scope.energyMonitorPage = true;
                break;
            case SCREEN.SETTINGOPTION:
                $scope.settingsOptionsPage = true;
                break;
            case SCREEN.ABOUT:
                $scope.aboutPage = true;
                break;
            case SCREEN.TUTORIALPAGE:
                //document.getElementById("scrollSettings").className = "scrollable_area_others";
                //$scope.backText = $scope.translation.WEBMOB_common_tutorial;
                $scope.vidTutorialPage = true; 
                document.getElementById("vid").src = "";
                break; 
            case SCREEN.DETAILEDTUTORIALPAGE:
                $scope.detailedTutorial = true;
                document.getElementById("vid").src = "https://s3.amazonaws.com/smartthingsda/solutionmodule/tutorial/"+arrVideos[addIndex]+".mp4";
                
                break;     
            case SCREEN.CHANGEMAP:
                $scope.currentSelectedMap = $scope.masterMapIndex;
                $scope.changeMapPage = true;
                break;
            case SCREEN.RENAME:
                 $scope.renameRoomList = {}; // reset rename temp array
                $scope.renamePage = true;
                break;
            default:
                break;
        }
    }

    function init() {
        $scope.isRVC = true;
        currentScreen = SCREEN.HOME;
        $scope.isSubHeader = false;

        if (window.navigator.platform === 'iPhone' || window.navigator.platform === 'iPad') {
            $scope.deviceWidth = window.screen.availWidth;
        } else {
            $scope.deviceWidth = document.body.clientWidth;
        }
    }

    function handleStatusCode(status, response) {
        var value;
        //handle schedule list in later section
        if (status === 204) {
            dismissLoadingBar(RVCCONST.MAP);
            //            dismissLoadingBar(RVCCONST.MODES);

            //if tutorial page, then show creating ap screen after loading bar dismissal
            if ($scope.introPage === true) {
                $scope.introPage = false;
                $scope.tutorialPage.doneTutorial = true;
                hideIntroScreen();
                changeScreen(SCREEN.CREATING_MAP);
            }

            //if stop command from craeating map page, then hide creating map screen after loading bar dismissal
            else if (currentScreen === SCREEN.CREATING_MAP) {
                //                changeScreen(SCREEN.HOME);
            } else if (currentScreen === SCREEN.CHANGEMAP) {
                initDataForMapDrwaing($scope.masterMapIndex);
                changeScreen(SCREEN.HOME);
                value = localStorage.getItem(RVCLOCALSTORAGE.DONTSHOWAGAIN);
                //localStorage.clear(); // Removing the room Rename data
                setLocalStorageData(RVCLOCALSTORAGE.DONTSHOWAGAIN, value);
            }

            if (response.resourceURL.indexOf('configuration/time/0') !== -1)
                dismissLoadingBar(RVCCONST.SET_TIME);
            
            if (response.resourceURL.indexOf('configuration/time') !== -1)
                dismissLoadingBar(RVCCONST.SET_TIME);

            if (response.resourceURL.indexOf('devices/0/operation') !== -1) {
                dismissLoadingBar(RVCCONST.POWER);
            }
        }

        if (status === 200) {
        	 dismissLoadingBar(RVCCONST.MAP);
            dismissLoadingBar("ADD_SCHEDULE");
            dismissLoadingBar("UPDATE_SCHEDULE");
            dismissLoadingBar("DELETE_SCHEDULE");

        }
    }

    // Connection failure handling
    function showConnectionFailurePopup() {
        var popup = $scope.dialogPopup;
        popup.show = true;
        toggleBottomPopUpClass(popup.show);
        popup.dialogPopupTitle = $scope.translation.WEBMOB_common_connection_failure;
        popup.dialogPopupText = $scope.translation.WEBMOB_common_check_power_and_network;
        popup.button1Title = $scope.translation.WEBMOB_common_ok;
        popup.button1Handler = closeConnFailPopUp;
        popup.button2Enabled = false;
    }
    
    function showErrorMapPopup() {
    	var popup = $scope.dialogPopup;
        popup.show = true;
        toggleBottomPopUpClass(popup.show);
        //popup.dialogPopupTitle = "Error by Map";
        popup.dialogPopupTitle = $scope.translation.WEBMOB_device_rvc_map_error_map_title;
        //popup.dialogPopupText = "Error Map. Please recreate map.";
        popup.dialogPopupText = $scope.translation.WEBMOB_device_rvc_map_error_map_description;
        
        popup.button1Title = $scope.translation.WEBMOB_common_ok;
        popup.button1Handler = closeErrorMapPopup;
        popup.button2Enabled = false;
    }
    
    //closing connection failure popup
     function closeConnectionFailurePopup() {
         var popup = $scope.dialogPopup;
         popup.show = false;
     }

    function showPlayInReservedMessage() {
        var popup = $scope.dialogPopup;
        popup.show = true;
        toggleBottomPopUpClass(popup.show);
        popup.dialogPopupTitle = $scope.translation.WEBMOB_common_confrim;
        popup.dialogPopupText = $scope.translation.VCMOB_schedule_cancel_popup_message;
        popup.button1Title = $scope.translation.WEBMOB_common_cancel_capital;
        popup.button2Title = $scope.translation.WEBMOB_common_ok;
        popup.button2Enabled = true;
        $scope.dialogPopup.button2Handler = clearScheduleOkHandler;
        $scope.dialogPopup.button1Handler = function()
        {
        	$scope.dialogPopup.show = false;
        }
    }

    function clearScheduleOkHandler() {
        $scope.dialogPopup.show = false; //remove dialog from screen.
        $scope.DeviceOptions.controls.isReserved = false;
        toggleBottomPopUpClass($scope.dialogPopup.show);
        ModeChangeRVC('AUTO'); //Send AUTO command to RVC
    }

    function showChargingForBatteryError() {
        var popup = $scope.dialogPopup,
            translate = $scope.translation;
        popup.show = true;
        toggleBottomPopUpClass(popup.show);
        popup.dialogPopupTitle = ""; //No title
        popup.dialogPopupText = translate[RVC_ERR[10]]; //show error 10 popup.
        popup.button1Title = translate.WEBMOB_common_cancel_capital;
        popup.button2Title = translate.VCMOB_cleaning_stop;
        popup.button2Enabled = true;
        $scope.dialogPopup.button2Handler = chargingForBatteryOkHandler;
    }

    function chargingForBatteryOkHandler() {
        $scope.dialogPopup.show = false; //remove dialog from screen.
        toggleBottomPopUpClass($scope.dialogPopup.show);
        ModeChangeRVC('STOP'); //Send STOP command to RVC

        $scope.Device.Alarms[0].errorCode = -1; //reset error code.
    }

    function showRoomCleaningGuidePopup() {
        //14Nov, Implementation changed according to SQE, Now popup will have only ok button
        var popup = $scope.dialogPopup;
        popup.show = true;
        toggleBottomPopUpClass(popup.show);
        popup.dialogPopupTitle = '';
        popup.dialogPopupText = $scope.translation[$scope.DeviceOptions.selectedText] +". "+ $scope.translation.WEBMOB_device_rvc_map_roomcleaning_popup;
        
        popup.button1Title = $scope.translation.WEBMOB_common_ok;
        popup.button2Enabled = false;
    }
    function showRoomCleaningGuidePopupForAfter() {
       
        var popup = $scope.dialogPopup;
        popup.show = true;
        toggleBottomPopUpClass(popup.show);
        popup.dialogPopupTitle = '';
        popup.dialogPopupText =  $scope.translation.WEBMOB_device_rvc_map_roomcleaning_popup_for_after;
        
        popup.button1Title = $scope.translation.WEBMOB_common_ok;
        popup.button2Enabled = false;
    }
    function showRoomCleaningGuidePopupForReserve() {
        
        var popup = $scope.dialogPopup;
        popup.show = true;
        toggleBottomPopUpClass(popup.show);
        popup.dialogPopupTitle = '';
        popup.dialogPopupText =  $scope.translation.WEBMOB_device_rvc_map_roomcleaning_popup_for_reserved;
        
        popup.button1Title = $scope.translation.WEBMOB_common_ok;
        popup.button2Enabled = false;
    }

    function showChangeMapErrPopup() {
        var popup = $scope.dialogPopup;
        popup.show = true;
        toggleBottomPopUpClass(popup.show);
        popup.dialogPopupTitle = $scope.translation.WEBMOB_common_confrim;
        popup.dialogPopupText = $scope.translation.WEBMOB_device_rvc_map_guide_for_charge;
        popup.button1Title = $scope.translation.WEBMOB_common_ok;
        popup.button2Enabled = false;
    }

    function showMapGuidePopup() {
        $scope.dialogPopup.show = true;
        toggleBottomPopUpClass($scope.dialogPopup.show);
        $scope.dialogPopup.dialogPopupTitle = $scope.translation.WEBMOB_common_confrim;
        $scope.dialogPopup.dialogPopupText = $scope.translation.WEBMOB_device_rvc_map_guide_before_check_msg;
        $scope.dialogPopup.button1Title = $scope.translation.WEBMOB_common_ok;
        $scope.dialogPopup.button1Handler = createMapErrorButtonHandler;
        $scope.dialogPopup.button2Enabled = false;
    }

    function createMapErrorButtonHandler() {
        toggleBottomPopUpClass(false);
        $scope.dialogPopup.show = false;
        hideIntroScreen();
        showHomeScreen(true);
    }

    function closeConnFailPopUp() {
        $scope.dialogPopup.show = false;
        toggleBottomPopUpClass($scope.dialogPopup.show);
        closeApp();
    }
    
    function closeErrorMapPopup() {
    	$scope.dialogPopup.show = false;
        toggleBottomPopUpClass($scope.dialogPopup.show);
    }

    function closeApp() {
        nativeInterface.runOnNative("closeWebApp", "");
    }

    // method for closing setting popup
    function CloseSettingPopup() {
        if ($scope.showSuctionPowerPopup) {
            $scope.showSuctionPowerPopup = false;
        }
    }

    function updateDeviceData(data) {
        debugMessage("updateDeviceData for RVC");
        SHPService.updateDeviceData($scope, data);; 
    }


    var isGetActionByMyself = false;
    function parseNewRVCActionData(actData) {
    	if (!!actData.length) {
            
            $scope.scheduleDataAvailable = false;
            $scope.Actions_new = new Array(); 
            for (var i = 0; i < actData.length; i++) {
            	
            	if(actData[i].Actuators[0].deviceIDs[0] == "0") //Filtering old schedule info. 
            		continue; 
            	
                $scope.Actions_new.push({
                    id: '',
                    'Actuators': [{
                        Operation: {
                            power: ''
                        },
                        deviceIDs: []
                    }],
                    dayOfWeek: [],
                    disposable: false,
                    enabled: true,
                    startTime: ''
                });
                
                var indexOfActions = $scope.Actions_new.length - 1;
                
                if (angular.isDefined(actData[i].id)) {
                    $scope.Actions_new[indexOfActions].id = actData[i].id;
                }
                if (angular.isDefined(actData[i].Actuators) && actData[i].Actuators.length > 0) {
                    var Actuators = actData[i].Actuators;
                    for (var j = 0; j < Actuators.length; j++) {
                        if ($scope.Actions_new[indexOfActions].Actuators[j] === undefined) {
                            $scope.Actions_new[indexOfActions].Actuators[j] = {
                                Operation: {
                                    power: ''
                                },
                                deviceIDs: []
                            };
                        }
                        if (angular.isDefined(Actuators[j].Operation) && angular.isDefined(Actuators[j].Operation.power)) {
                            $scope.Actions_new[indexOfActions].Actuators[j].Operation.power = Actuators[j].Operation.power;
                        }
                        if (angular.isDefined(Actuators[j].deviceIDs)) {
                            $scope.Actions_new[indexOfActions].Actuators[j].deviceIDs = Actuators[j].deviceIDs;
                        }
                    }
                }
                if (angular.isDefined(actData[i].dayOfWeek)) {
                	 $scope.Actions_new[indexOfActions].dayOfWeek = ScheduleService.getAdjustedWeekDaysRVC(actData[i].dayOfWeek, actData[i].startTime);
                }
                if (angular.isDefined(actData[i].disposable)) {
                    $scope.Actions_new[indexOfActions].disposable = actData[i].disposable;
                }
                if (angular.isDefined(actData[i].enabled)) {
                    $scope.Actions_new[indexOfActions].enabled = actData[i].enabled;
                }
                if (!!actData[i].startTime) {
                	$scope.Actions_new[indexOfActions].startTime = actData[i].startTime;
                    var gmt = setTimeInGMT(actData[i].startTime);

                    $scope.Actions_new[indexOfActions].newStartTime = gmt[0] + ':' + gmt[1];
                    $scope.Actions_new[indexOfActions].timeConvention = gmt[2];
                }
            }
            if($scope.Actions_new.length)
            	$scope.scheduleDataAvailable = true;
            
        } 
        
        if ($scope.Actions_new.length === 0 && !scheduleRemoved) { // if schedule deleted then just stay on schedule list page, other wiase go to add schedule page
            console.log(" No Action Data ");
            
            if (isGetActionByMyself ==true)
            {
            	addSchedule(-1);
            }
            //changeAnimScreen(SCREEN.ADDSCHEDULE);
        } else {
            scheduleRemoved = false;
            //changeAnimScreen(SCREEN.SCHEDULELIST);
        }
        
        isGetActionByMyself = false;
        dismissLoadingBar(RVCCONST.GET_ACTIONS);
        dismissLoadingBar("SCHEDULEDATA");
        dismissLoadingBar("cleaningArea");
    }
    
    function getDayOfWeekMulti( days ){
    	var daySplit = days.split(",");
    	var ret ="";
    	for(var i = 0 ; i < daySplit.length ; i++ ){
    		ret += getWeatherDayText($scope.translation, daySplit[i]) + ",";
    	}
    	ret = ret.slice(0,ret.length-1);
    	return ret; 
    }
    
    function parseActionData(actData) {
        if (actData.length > 0) {
        	$scope.Actions_old = new Array();
            for (var i = 0; i < actData.length; i++) {
            	if(actData[i].Actuators[0].deviceIDs[0] == "1") //Filtering new schedule info. 
            		continue; 
            	
                $scope.Actions_old.push({
                    id: '',
                    'Actuators': [{
                        Operation: {
                            power: ''
                        },
                        Mode: {
                            modes: []
                        },
                        deviceIDs: []
                    }],
                    dayOfWeek: [],
                    disposable: false,
                    enabled: false,
                    startTime: '',
                    endTime: '',
                    repeatPeriod: '',
                    newStartTime: '',
                    timeConvention: ''
                });
                
                var indexOfActions = $scope.Actions_old.length - 1; 
                
                if (angular.isDefined(actData[i].id)) {
                    $scope.Actions_old[indexOfActions].id = actData[i].id;
                }
                if (angular.isDefined(actData[i].disposable)) {
                    $scope.Actions_old[indexOfActions].disposable = actData[i].disposable;
                }
                if (angular.isDefined(actData[i].Actuators)) {
                    var Actuators = actData[i].Actuators;
                    if (Actuators.length > 0) {
                        for (var j = 0; j < Actuators.length; j++) {
                            if ($scope.Actions_old[indexOfActions].Actuators[j] === undefined) {
                                $scope.Actions_old[indexOfActions].Actuators[j] = {
                                    Operation: {
                                        power: ''
                                    },
                                    Mode: {
                                        modes: []
                                    },
                                    deviceIDs: []
                                };
                            }
                            if (angular.isDefined(Actuators[j].Operation) && angular.isDefined(Actuators[j].Operation.power)) {
                                $scope.Actions_old[indexOfActions].Actuators[j].Operation.power = Actuators[j].Operation.power;
                            }
                            if (angular.isDefined(Actuators[j].Mode) && angular.isDefined(Actuators[j].Mode.modes)) {
                                $scope.Actions_old[indexOfActions].Actuators[j].Mode.modes = Actuators[j].Mode.modes;
                            }
                            if (angular.isDefined(Actuators[j].deviceIDs)) {
                                $scope.Actions_old[indexOfActions].Actuators[j].deviceIDs = Actuators[j].deviceIDs;
                            }
                        }
                    }
                }

                if (angular.isDefined(actData[i].enabled)) {
                    $scope.Actions_old[indexOfActions].enabled = actData[i].enabled;
                }
                if (angular.isDefined(actData[i].repeatPeriod)) {
                    $scope.Actions_old[indexOfActions].repeatPeriod = actData[i].repeatPeriod;
                }
                if (angular.isDefined(actData[i].endTime)) {
                    $scope.Actions_old[indexOfActions].endTime = actData[i].endTime;
                }
                if (angular.isDefined(actData[i].startTime)) {
                    if (actData[i].startTime !== '0000-00-00T00:00:00' && actData[i].enabled) {
                        if (actData[i].startTime.indexOf("T12") !== -1)
                            actData[i].startTime = actData[i].startTime.replace("T12", "T00");
                        if (actData[i].startTime.indexOf("T24") !== -1)
                            actData[i].startTime = actData[i].startTime.replace("T24", "T12");


                        $scope.Actions_old[indexOfActions].startTime = actData[i].startTime;
                        var gmt = getTimeWithAMPM(actData[i].startTime);
                        $scope.Actions_old[indexOfActions].newStartTime = gmt[0] + ':' + gmt[1];
                        $scope.Actions_old[indexOfActions].timeConvention = gmt[2];
                    } else {
                        $scope.Actions_old[indexOfActions].startTime = '0000-00-00T00:00:00';
                    }
                }
            }
        }

        if ($scope.Actions_old.length === 0) {
            $scope.ScheduleText = $scope.translation.WEBMOB_common_none;

        } else {
            // Converting local time to 24 hours format in startTime
            var firstArray = [];
            var textrr = [];
            $scope.Actions_old.forEach(function(value) {
                if (value.enabled == false)
                    return;

                var temp = "";
                if (value.timeConvention === "PM") {
                    var a = Number((value.newStartTime).split(":")[0]) + 12;
                    temp = a + ":" + (value.newStartTime).split(":")[1] + ":00";
                } else {
                    temp = value.newStartTime + ":00";
                }
                firstArray.push(temp);
                if (value.disposable) {
                    textrr[temp] = $scope.translation.WEBMOB_common_schedule_once;
                } else {
                    textrr[temp] = $scope.translation.WEBMOB_common_schedule_daily;
                }
            });
        }
        
        
        dismissLoadingBar(RVCCONST.GET_ACTIONS);
        dismissLoadingBar("SCHEDULEDATA");
        dismissLoadingBar("cleaningArea");
    }

    $scope.parseActionData = function(actData) {
        if ($scope.selectedScheduleType === RVCSCHEDULE.B) {
            parseNewRVCActionData(actData);
        } else if ($scope.selectedScheduleType === RVCSCHEDULE.A) {
            parseActionData(actData);
        }
    };
    
    $scope.suctionPowerFilter = function(suctionType) {
    	return function(item){
    		if(!suctionType)
    			return true;
    		if(item.id == "TURBO_ON")
    			return false;
    		else
    			return true;
    	};
    }

    function restorePrevState() {
    	console.log('********************************* restorePrevState() *******************************');
        var devc = $scope.Device; //object reference for shorter name.
        devc.Alarms[0].code = 4; //keep it for future use.
        devc.Alarms[0].errorCode = -1; //Future proofing to avoid any bug. -1 is below error codes. Error codes start from 0. See RVC_ERR for reference.
        $scope.DeviceOptions.alarm = false; //code 4 is an indication of clearing alarm.

        if(!!tempControlsStatus)
        {
        	setControlStatus(tempControlsStatus);	
        	tempControlsStatus = {};
        }
    }

    function manageAlarms(device) {
        //$scope.Device.Alarms = angular.copy(device.Alarms);
       
        //if (!!$scope.Device.Alarms[0].code) {
        if (!!device.Alarms[0].code) {
        	//$scope.Device.Alarms = angular.copy(device.Alarms);
            var tempArr = device.Alarms[0].code.split("_");
            var errCode = (tempArr.length > 1) ? parseInt(tempArr[1]) : parseInt(tempArr[0]);

            if (errCode === 4) { //if we recieve code 4.
            	$scope.Device.Alarms = angular.copy(device.Alarms);
                restorePrevState();
            } else { //if it is not code 4 then it must be an error code.

            	

                switch (errCode) {
                    //C00 ~ C09 ==> Error Popup -> Yes, State Area (below Spot)-> delete (Empty), If clicks Pause button -> send Stop, Control Buttons -> all disable except Pause.
                    //C27 ==> Error Popup -> Yes, State Area (below Spot)-> delete (Empty), If clicks Pause button -> ------, Control Buttons -> all disable.
                    case 0:
                    case 1:
                    case 2:
                    case 3:
                    case 5:
                    case 6:
                    case 7:
                    case 8:
                    case 9:
                    case 27:
                    	$scope.Device.Alarms = angular.copy(device.Alarms);
                    	tempControlsStatus = getControlStatus("Alarms", errCode);
                        setControlStatus(tempControlsStatus);
                        $scope.Device.Alarms[0].errorCode = errCode; //keep error code for future use.                   	
                        //Show error popup for highest priority error.
                        $scope.DeviceOptions.alarm = true;
                        showMapTabHandle();
                        $scope.Device.Alarms[0].errormsg = $scope.translation[RVC_ERR[$scope.Device.Alarms[0].errorCode]] || ""; //If no error string there then assign empty string to avoid unforeseen errors.
                        //$scope.Device.Alarms[0].errormsg = $scope.translation.VCMOB_alarm_SideBrushDamage_9 || ""; //If no error string there then assign empty string to avoid unforeseen errors.
                        break;
                        
                    default:
                        //$scope.DeviceOptions.alarm = false; //Don't show error popup for normal or low priority error.
                        break;
                }
                
            }
        }
    }

    function getControlStatus(mode, alarm_code) {
        console.log("**************************** Mode : " + mode + " : " + alarm_code);        
        var tempControlsStatus = {};
        if (STATE_BTN_AVAILABLE[mode] != undefined) {
        		angular.merge(tempControlsStatus, STATE_BTN_AVAILABLE[mode]);
            
            
        } else if (mode === "Alarms") {
            if (alarm_code == 10)
            		angular.merge(tempControlsStatus, STATE_BTN_AVAILABLE["Control_Alarm_10"]);
                                
            else if(alarm_code == 21)
            		angular.merge(tempControlsStatus, STATE_BTN_AVAILABLE["Control_Alarm_21"]);
                
            else {
            	//	angular.merge(tempControlsStatus, STATE_BTN_AVAILABLE["Control_Alarm"]);
                                
                switch (alarm_code) {
                    case 0:
                    case 1:
                    case 2:
                    case 3:
                    case 5:
                    case 6:
                    case 7:
                    case 8:
                    case 9:
                    		angular.merge(tempControlsStatus, STATE_BTN_AVAILABLE["Control_Alarm"]);
                    		angular.merge(tempControlsStatus, STATE_BTN_AVAILABLE["Control_Alarm_9"]);
                    	break;
                    case 27:
                    		angular.merge(tempControlsStatus, STATE_BTN_AVAILABLE["Control_Alarm"]);
                    		angular.merge(tempControlsStatus, STATE_BTN_AVAILABLE["Control_Alarm_9"], STATE_BTN_AVAILABLE["Control_Alarm_27"]);
                    	
                        break;
                    default:
                        break;
                }
            }
        } else {
            console.log(mode + " mode does not update menu item");
        }
        for (var x in tempControlsStatus)
            console.log(x + " = " + tempControlsStatus[x]);
        console.log("^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^");
        return tempControlsStatus;
    }

    function setControlStatus(status)
    {
    	if(!!!status) return;
    	console.log('@@@@@@@@@@@@@@@@@@@@@@@@@@@@ Set Controls status @@@@@@@@@@@@@@@@@@@@@@@@@@@@');
    	if(angular.isDefined(status.cleaningType)){
			$scope.DeviceOptions.cleaning_type = status.cleaningType;
			delete status.cleaningType;
		}
		if(angular.isDefined(status.title)) {
			$scope.additionalInfoSelectedText = '';
			$scope.DeviceOptions.selectedText = status.title;
			//ksum111
			
			$timeout(function() {
				var d=  document.getElementById("divCurrentStatus");
				if (d!=null)
				{
					if ($scope.DeviceOptions.selectedText==="")
					{
						d.style.visibility = "hidden";					
					}
					else
					{
						d.style.visibility = "visible";
					}
				}
			}, 200);
			
			delete status.title;
		}
		
		if(status.oobe456 == false && ($scope.mapState == MAP_STATE.CREATING || $scope.mapState == MAP_STATE.CREATING_PAUSE)) 
		{
			if (isMapDataAvailable()) {
                $scope.mapState = MAP_STATE.AVAILABLE;
                $scope.tutScreens = null;
            } else {
                $scope.mapState = MAP_STATE.NOT_AVAILABE;
                $scope.tutScreens = oobe123;
            }
		}
		$timeout(function() {
			angular.merge( $scope.DeviceOptions.controls,status);
        }, 2);
    }
    function manageModes(device) {
    	
    	for (var m = 0; m < device.Mode.modes.length; m++) {
    		
    		
        	if (device.Mode.modes[m].indexOf("Schedule_") == 0) {
                var representSchedule = device.Mode.modes[m].split("_");
                if (representSchedule[1] == "0") {
                    $scope.ScheduleText = $scope.translation.WEBMOB_common_none;
                } else {
                    var tempDate = new Date(Number(representSchedule[1]) * 1000);
                    var tempDateArr = setTimeInGMTforRVC(tempDate.toISOString(), $scope);
                    $scope.ScheduleText = tempDateArr[0] + ":" + tempDateArr[1] + " " + tempDateArr[2] + ", " + tempDateArr[3];
                }
                return;
            }

        	tempControlsStatus = getControlStatus(device.Mode.modes[m]);
            if($scope.DeviceOptions.alarm == false ){
            	setControlStatus(tempControlsStatus)
            	tempControlsStatus = {};
        	}
            
            switch (device.Mode.modes[m]) {
                case 'Control_PowerOff':
                	if($scope.DeviceOptions.alarm && !$scope.remoteLocked)
                	{
                		setControlStatus(tempControlsStatus);
                	}
                    $scope.powerState = false;
                    CloseSettingPopup(); //if open,close suction power and voice popup
                    showMapTabHandle();
                    
                    if(!$scope.homePage) //if current page is not homepage, Move to homePage. 
                    	changeScreen(SCREEN.HOME);
                    break;
                case 'Control_Reserve':
                    $scope.DeviceOptions.controls.isReserved = true;
                    break;
                case 'Control_Idle':
                    $scope.selectedRoomList = []; //empty selected room list.
                    selectedRoomNameIndex = -1;
                    break;
                case 'Cleaning_Stop':
                    break;
                case 'Cleaning_Auto':
                case 'Cleaning_Part':
                case 'Cleaning_Manual':
                case 'Control_Point':
                    //$scope.Device.Movement.MapCleaningStatusData = {};
                    $scope.selectedRoomList = [];
                    selectedRoomNameIndex = -1;
                    break;
                case 'Control_Pause':
                    break;
                case 'Control_After':
                    break;
                case 'Control_Homing':
                    break;
                case 'Control_Charging':
                    $scope.DeviceOptions.controls.changeMapEnabled = isMapDataAvailable();
                    if (isMapDataAvailable()) {
                        $scope.mapState = MAP_STATE.AVAILABLE;
                        $scope.tutScreens = null;
                    } else {
                        $scope.mapState = MAP_STATE.NOT_AVAILABE;
                        $scope.tutScreens = oobe123;
                    }
                    break;
                case 'Control_Creating':
                    $scope.selectedRoomList = []; //There should not be any room selected.
                    selectedRoomNameIndex = -1;
                    $scope.mapState = MAP_STATE.CREATING; //map state is now creating.
                    $scope.tutScreens = oobe456;
                    dismissLoadingBar(RVCCONST.CREATING_MAP_REQUEST);
                    break;
                case 'Control_CreatingPause':
                    $scope.selectedRoomList = []; //There should not be any room selected.
                    selectedRoomNameIndex = -1;
                    $scope.mapState = MAP_STATE.CREATING_PAUSE; //map state is now creating puase because map creation is paused.
                    $scope.tutScreens = oobe456;
                    break;
                case 'Access_Lock':
                	if($scope.DeviceOptions.alarm)
                	{
                		angular.merge( $scope.DeviceOptions.controls,tempControlsStatus);
                		$scope.DeviceOptions.alarm = false;
                	}
                    $scope.remoteLocked = true;
                    CloseSettingPopup(); //if open,close suction power and voice popup
                    showMapTabHandle();
                    if(!$scope.homePage) //if current page is not homepage, Move to homePage. 
                    	changeScreen(SCREEN.HOME);
                    
                    break;
                case 'Access_UnLock':
                    $scope.remoteLocked = false;
                    break;
                case 'Turbo_On':
                    $scope.DeviceOptions.selectedMode = $scope.SuctionPowerList[RVCCONST.TURBO_ON];
                    break;
                case 'Turbo_Off':
                    $scope.DeviceOptions.selectedMode = $scope.SuctionPowerList[RVCCONST.TURBO_OFF];
                    break;
                case 'Turbo_Silence':
                    $scope.DeviceOptions.selectedMode = $scope.SuctionPowerList[RVCCONST.TURBO_SILENCE];
                    break;
                case 'Sound_VoiceM':
                    $scope.DeviceOptions.selectedVoice = 'VCMOB_setting_voice_man';
                    break;
                case 'Sound_VoiceW':
                    $scope.DeviceOptions.selectedVoice = 'VCMOB_setting_voice_waman';
                    break;
                case 'Sound_Mute':
                    $scope.DeviceOptions.selectedVoice = 'VCMOB_setting_mute_contents';
                    break;
                case 'Sound_SoundEffect':
                    $scope.DeviceOptions.selectedVoice = 'VCMOB_setting_soundeffect_contents';
                    break;
                case 'Control_MapCleaning':
                    $scope.isMoving = false;
                    mapCleanRoomState = MAP_CLEANING_STATE.CLEANING;
                    $scope.selectedRoomList = [];
                    selectedRoomNameIndex = -1;
                    $scope.DeviceOptions.selectedText = 'WEBMOB_device_rvc_status_cleaning_in'
                    downloadCleanTxtFile();
                    break;
                case 'Control_MapMoving':
                    mapCleanRoomState = MAP_CLEANING_STATE.MOVING;
                    $scope.selectedRoomList = [];
                    selectedRoomNameIndex = -1;
                    $scope.DeviceOptions.selectedText = 'WEBMOB_device_rvc_map_going_to_room_for_cleaning';
 /*                   if (!!selectedRoomsForCleaning && !!selectedRoomsForCleaning.length) {
                        $scope.additionalInfoSelectedText = ' ' + getRoomNameForDisplayonRenamePage(selectedRoomsForCleaning[0],$scope.masterMapIndex);
                        $scope.DeviceOptions.selectedText = 'WEBMOB_device_rvc_map_going_to_room_for_cleaning';
                    } */
                    $scope.isMoving = true;
                    downloadCleanTxtFile();
                    for (i=1 ; i<= 5;i++)
                    {
                    	$timeout(function() {
                        	downloadCleanTxtFile();
                        }, 3300*i);
                    }
                    break;
                case 'Cleaning_Map':
                    downloadCleanTxtFile();
                    break;
                case 'Control_MapSelected':
                    mapCleanRoomState = MAP_CLEANING_STATE.SELECTED;
                    downloadCleanTxtFile();
                    break;
                case 'Control_MapCleaned':
                    selectedRoomsForCleaning.splice(0, 1); // remove the cleaned room from the list 
                    mapCleanRoomState = MAP_CLEANING_STATE.CLEANED;
                    downloadCleanTxtFile();
                    break;
                case 'Control_MapStopped':
                    mapCleanRoomState = MAP_CLEANING_STATE.NONE;
                    downloadCleanTxtFile();
                    $scope.isMoving = false;
                    break;
                case 'Control_MapFailed':
                    //Lokesh 02Nov15_2212 -> When map cleaning is failed due to any condition then RVC sends 'Control_MapFaild'.
                    downloadCleanTxtFile();
                    $scope.isMoving = false;
                    break;
                case 'Control_MapPause':
                	mapCleanRoomState = MAP_CLEANING_STATE.PAUSE;
                	downloadCleanTxtFile();
                	$scope.isMoving = false;
                	break;
                default:
                    break;
            }
        }
    	
    	
    		
    	
    	
    }

    function manageMapNotification(notificaion) {
        switch (notificaion) {
        //ksum    
        case 'Notify_MasterMapChange':
                $scope.Device.Movement.MapCleaningStatusData = {};
//                prevMasterMapId = $scope.Device.Movement.Map[$scope.masterMapIndex].mapId;
                
                showToast({title: "",body: $scope.translation.WEBMOB_device_rvc_map_master_map_changed});
                
                requestToDownloadMapData();
                $scope.selectedRoomList = [];
                selectedRoomNameIndex = -1;
                break;
            case 'Notify_CleaningCompleted':
                //Lokesh 07Nov15_1716 -> Map cleaning completed.
                mapCleanRoomState = MAP_CLEANING_STATE.NONE;
                downloadCleanTxtFile();
                break;
            case 'Notify_MapCreatingCompleted':
                //Lokesh 08Nov15_1505-> As per Mr. Chang, once map creation is completed, do following:
                //1. remove popup
                //2. Take user to Controller screen. and 
                //3. Request data for new map and disable till new data comes up.
                //4. Native app will show toast or pop-up. Web app will not show anything.

                //remove popup as per new requirement.
                //                showMapCompletedPopup();
            	if ($scope.powerState && !$scope.DeviceOptions.alarm) {
                    if (isMapDataAvailable()) {
                        $scope.mapState = MAP_STATE.AVAILABLE;
                        $scope.tutScreens = null;
                    } else {
                        $scope.mapState = MAP_STATE.NOT_AVAILABE;
                        $scope.tutScreens = oobe123;
                    }
                }
 		isMapCreationComplete = true;
                //$scope.DeviceOptions.selectedText = 'WEBMOB_device_rvc_map_creating_map_done';

                //send fresh request for data.
                requestToDownloadMapData();

                //make map data unavailable.
                $scope.Device.Movement.Map = [];
                $scope.isMapDownloaded = false;

                //move user to controller tab.
                changeScreen(SCREEN.HOME);
                onClickTab(TAB.CONTROLLER);
                break;
        }
    }

    function downloadCleanTxtFile() {
    	if (!!!$scope.Device.Movement.MapDetailData["cleaningArea"] || !!!$scope.Device.Movement.MapDetailData["masterMap"])
            return; // if no path available for clean.txt, return

        var mapData = '{\"deviceUuid\" : \"' + $scope.deviceUuid + '",\"cleaningArea\" : \"' + $scope.Device.Movement.MapDetailData["cleaningArea"] + '\" , \"mapId\": \" ' + $scope.Device.Movement.MapDetailData["masterMap"] + '\"}';
        if (!$scope.isStatic) {
            nativeInterface.runOnNative("downloadCleanTxtFile", mapData);
        }
    }

    function parseHistoryData(data) {
        /* Temp data
        data = JSON.parse(
        		'{"History":[{ \
        			"start_time":1445424872, \
        			"turbo_status":1, \
        			"start_mode":0, \
        			"end_status":16, \
        			"end_time":1445424872, \
        			"history_id":7},{"start_time":1445424860,"turbo_status":2,"start_mode":4,"end_status":2,"end_time":1445424864,"history_id":6},{"start_time":1445424536,"turbo_status":1,"start_mode":0,"end_status":6,"end_time":1445424536,"history_id":5},{"start_time":1445424485,"turbo_status":1,"start_mode":0,"end_status":5,"end_time":1445424485,"history_id":4},{"start_time":1445424207,"turbo_status":2,"start_mode":5,"end_status":3,"end_time":1445424222,"history_id":3},{"start_time":1445424192,"turbo_status":1,"start_mode":1,"end_status":17,"end_time":1445424202,"history_id":2},{"start_time":1445424139,"turbo_status":1,"start_mode":0,"end_status":16,"end_time":1445424139,"history_id":1}]}'
        		);
        */
        $scope.historyData = [];
        var dateData = [];
        var start_mode_String_Array = [ // status 1~6
            $scope.translation.WEBMOB_device_rvc_history_start_status_auto_cleaning,
            $scope.translation.WEBMOB_device_rvc_history_start_status_max_cleaning,
            $scope.translation.WEBMOB_device_rvc_history_start_status_spot_cleaning,
            $scope.translation.WEBMOB_device_rvc_history_start_status_schedule_cleaning,
            $scope.translation.WEBMOB_device_rvc_history_start_status_room_cleaning,
            $scope.translation.WEBMOB_device_rvc_history_start_status_creating_map
        ];

        var end_status_String_Array = [
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_Imprisonment_0,
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_BrushDamage_1,
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_LeftWheelDamage_2,
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_RightWheelDamage_3,
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_BumperSensorDamage_5,
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_ObstacleSensorDamage_6,
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_FallSensorDamage_7,
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_DustCanisterNotDetect_8,
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_SideBrushDamage_9,
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_ChargingForBattery_10,
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_poweroff,
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_returning_for_charging,
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_lowbattery,
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_poweroff_during_charging,
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_fail_returning_for_charging,
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_returning_for_charging,
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_LiftedUp_27,
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_cleaning_done,
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_StopbyInterrupt,
            $scope.translation.WEBMOB_device_rvc_history_end_status_alarm_HomingforCharging
        ];

        var turbo_status_String_Array = [
            $scope.translation.WEBMOB_device_rvc_suction_power_normal,
            $scope.translation.WEBMOB_device_rvc_suction_power_max,
            $scope.translation.WEBMOB_device_rvc_suction_power_quiet
        ];


        for (var i = 0; i < data.History.length; i++) {

            var startTime = new Date(Number(data.History[i].start_time) * 1000);
            var tempDate = new Date(startTime.getFullYear(), startTime.getMonth(), startTime.getDate());
            dateData.push(tempDate);
        }

        Array.prototype.unique = function() {
            var a = {};
            for (var i = 0; i < this.length; i++) {
                if (typeof a[this[i]] == "undefined")
                    a[this[i]] = 1;
            }
            this.length = 0;
            for (var i in a)
                this[this.length] = i;
            return this;
        }

        dateData = dateData.unique();
        for (var i = 0; i < dateData.length; i++) {
            dateData[i] = new Date(dateData[i]).getTime();
        }
        dateData.sort().reverse();

        for (var i = 0; i < dateData.length; i++) {
            $scope.historyData.push({
                date: new Date(dateData[i]),
                task: []
            });
        }

        function makeTime(time) {
            var tempStr = "";
            var hours = time.getHours();
            var minutes = time.getMinutes();
            var amPm = ["AM", "PM"];

            if (minutes < 10)
                minutes = "0" + minutes;

            if (hours > 12)
                tempStr += (hours - 12) + ":" + minutes + amPm[1];
            else
                tempStr += hours + ":" + minutes + amPm[0];

            return tempStr;
        }

        function makeHistoryTime(startTime, endTime) {
            if (startTime.getTime() == endTime.getTime())
                return makeTime(startTime);
            else;
            return makeTime(startTime) + " ~ " + makeTime(endTime);
        }

        function makeResult(startMode, endStatus, turbo) {
            var result;
            if (startMode == 0)
                result = end_status_String_Array[endStatus - 1];
            else
                result = start_mode_String_Array[startMode - 1] + " / " + turbo_status_String_Array[turbo];

            return result;
        }
        
        function makePathData(paths)
        {
        	var  size = paths.length;

        	var rst  = [];
        	var i=0;
        	for (var i=0 ; i<size;i++ ){
        		var tmpPath = paths[i].sp.trim().split( " " );			//trim
        		var xyArr=[];
        		
        		for (var j=2 ; j<tmpPath.length ; j++)
        		{
        			xyArr.push(tmpPath[j])
        		}
        		xyArr = translationXY( xyArr); 
        		var sSet = translationScale( xyArr, getPxByPx(500, 1440) );
        		sSet.path = translationOnCenter(sSet.path , getPxByPx(500, 1440));
        		
        		var paddingScale = 1.0 - ( (sSet.scale * $scope.brushSize) / getPxByPx(500, 1440));
        		
        		for (var k=0 ; k< sSet.path.length ; k++)
        		{
        			sSet.path[k] = (sSet.path[k] * paddingScale)+ (($scope.brushSize/2) * sSet.scale);
        		}
        		var minX=10000000,maxX=0;
        		var minY=10000000,maxY=0;
        		
        		for (var k=0 ; k< sSet.path.length ; k++)
        		{
        			if (k % 2 == 0)
        			{
        				maxX = sSet.path[k]>maxX ? sSet.path[k]:maxX;
        				minX = sSet.path[k]<minX ? sSet.path[k]:minX;
        			}
        			else
        			{
        				maxY = sSet.path[k]>maxY ? sSet.path[k]:maxY;
        				minY = sSet.path[k]<minY ? sSet.path[k]:minY;
        			}
        		}
        		var polylineStd = getXY(sSet.path);
        		
        		rst.push({
        			mapId : paths[i].map_id
        			,roomId: tmpPath[0]
        			,path:polylineStd
        			,scale :sSet.scale

        			,minX : minX
        			,maxX : maxX
        			
        			,minY : minY
        			,maxY : maxY
        			
        		});
        	}
        	return rst;
        }
        
        function translationXY(pathArr)
        {
        	var minX = 1000000;
        	var minY = 1000000;
        	var i=0;
        	for (i=0 ;i<pathArr.length ; i=i+2)
        	{
        		if (pathArr[i] == undefined || pathArr[i]==undefined) break;
        		var x = parseInt(pathArr[i]);
        		var y = parseInt(pathArr[i+1]);
        		minX = x<minX ? x: minX;
        		minY = y<minY ? y: minY;
        	}
        	
        	for (i=0 ;i<pathArr.length ; i=i+2)
        	{
        		if (pathArr[i] == undefined || pathArr[i+1]==undefined || pathArr[i]=="" || pathArr[i+1]=="") break;
        		pathArr[i] = (parseInt(pathArr[i]) - minX)+"";
        		pathArr[i+1] = (parseInt(pathArr[i+1]) - minY)+"";
        	}
        	
        	return pathArr;
        }
        function translationScale(pathArr,svgLineLen)
        {
        	var maxX = 0;
        	var maxY = 0;
        	var scaleVal = 1.0;
        	var i=0;
        	for (var i=0 ;i<pathArr.length ; i=i+2)
        	{
        		if (pathArr[i] == undefined || pathArr[i]==undefined) break;
        		var x = parseInt(pathArr[i]);
        		var y = parseInt(pathArr[i+1]);
        		maxX = x>maxX ? x: maxX;
        		maxY = y>maxY ? y: maxY;
        	}
        	
        	if (maxX > maxY)
        	{
        		if(maxX!=0)
        			scaleVal = (svgLineLen*(1.0)) / (maxX * (1.0));
        	}
        	else
        	{
        		if (maxY!=0)
        			scaleVal = (svgLineLen*(1.0)) / (maxY * (1.0));
        	}
        	console.log("ksum:::"+scaleVal)	;
        	
        	for (var i=0 ;i<pathArr.length ; i++)
        	{
        		if (pathArr[i] == undefined ) break;
        		pathArr[i] = parseInt(parseInt(pathArr[i]) * scaleVal)+"";
        	}
        	
        	var rst = {
        		scale : scaleVal,
        		path : pathArr
        	};
        	return rst;
        	//return pathArr;
        	
        }
        function getPathWithSplit(p)
        {	
         	var arr = p.sp.split(" ");
         	arr = translationXY(arr);
         	var sSet = translationScale(arr , getPxByPx(500, 1440));
         	arr = translationOnCenter(sSet.path , getPxByPx(500, 1440));
         	
         	return arr;
        }
        function translationOnCenter(arr,svgLineLen)
        {
        	var maxX = 0; 
        	var maxY = 0;
        	for (var i=0 ;i<arr.length ; i=i+2)
        	{
        		if (arr[i] == undefined || arr[i+1]==undefined  ) break;
        		var x = parseInt(arr[i]);
        		var y = parseInt(arr[i+1]);
        		maxX = x>maxX ? x: maxX;
        		maxY = y>maxY ? y: maxY;
        	}
        	
        	if (maxX>maxY)
        	{
        		var offset = (svgLineLen - maxY) /2
        		for (var i=1 ;i<arr.length  ; i=i+2)
        		{
        			arr[i] = parseInt(arr[i])+ offset;
        		}
        	}else
        	{
        		var offset = (svgLineLen - maxX) /2
        		for (var i=0 ;i<arr.length  ; i=i+2)
        		{
        			arr[i] = (parseInt(arr[i])+ offset)+ "";
        		}
        	}
        	return arr;
        	
        	
        }
        function getXY(pts)
        {
        	var rst ="";
        	var size= pts.length;
        	var i=0;
        	for (i=0 ; i<size; i+=2)
        	{
        		//if (i==0 || i==1) continue;
        		
        		if (pts[i] != undefined &&  pts[i+1] != undefined || pts[i] !=NaN )
        		{
        			var xy = " " + pts[i]+"," +pts[i+1];
        			rst = rst+xy;
        		}
        		else break;
        			
        	}
        	return rst;
        	
        }
        

        for (var i = 0; i < data.History.length - 1; i++) {
            for (var j = i + 1; j < data.History.length; j++) {
                if (data.History[i].start_time < data.History[j].start_time) {
                    var temp = data.History[j];
                    data.History[j] = data.History[i];
                    data.History[i] = temp;
                }
            }
        }

        for (var i = 0; i < data.History.length; i++) {

            var startTime = new Date(Number(data.History[i].start_time) * 1000);
            var endTime = new Date(Number(data.History[i].end_time) * 1000);
            var tempDate = new Date(startTime.getFullYear(), startTime.getMonth(), startTime.getDate());
            var pathData = data.History[i].path_data;
            for (var j = 0; j < $scope.historyData.length; j++) {
                if ($scope.historyData[j].date.getTime() == tempDate.getTime())
                    $scope.historyData[j].task.push({
                        time: makeHistoryTime(startTime, endTime),
                        result: makeResult(data.History[i].start_mode, data.History[i].end_status, data.History[i].turbo_status),
                        errMsg: (data.History[i].start_mode == 0 || data.History[i].end_status == 18) ? "" : end_status_String_Array[data.History[i].end_status - 1]
                    	, pathData : makePathData(pathData)
                    });
            }
        }
        /* 
        $scope.historyData.push({
            date: new Date(dateData[i]),
            task: []
        });
      
 		    
        for (k=0 ; k<start_mode_String_Array.length ; k++)
        {
        	$scope.historyData[$scope.historyData.length-1].task.push({
                time: "-",
                result: start_mode_String_Array[k],
                errMsg: ""

            });

        }
        $scope.historyData.push({
            date: new Date(dateData[i]),
            task: []
        });
        
       
        
        for (k=0 ;k<end_status_String_Array.length ; k++)
        {
        	if (k%7==0)
       	 	{
       		 $scope.historyData.push({
       	            date: new Date(dateData[i]),
       	            task: []
       	        });
       	 	} 
        	$scope.historyData[$scope.historyData.length-1].task.push({
                 time: "-",
                 result: end_status_String_Array[k],
                 errMsg: ""

             });	
        	 
        }
        
        
        */
        changeAnimScreen(SCREEN.HISTORY);
        dismissLoadingBar(RVCCONST.HISTORY_REQUEST);
    }

    function checkTodayDate(date) {
        var today = new Date();

        var yesterdayDate = new Date();
        yesterdayDate.setDate(today.getDate() - 1);

        var returnDate = date.getFullYear() + "/" + (date.getMonth() + 1) + "/" + date.getDate();

        if (today.getFullYear() == date.getFullYear()) {
            if (today.getMonth() == date.getMonth()) {
                if (today.getDate() == date.getDate())
                    return $scope.translation.WEBMOB_device_rvc_comm_today;
                else if (yesterdayDate.getDate() == date.getDate())
                    return $scope.translation.WEBMOB_device_rvc_comm_yesterday;
                else
                    return returnDate;
            } else {
                if (yesterdayDate.getMonth() == date.getMonth() && yesterdayDate.getDate() == date.getDate())
                    return $scope.translation.WEBMOB_device_rvc_comm_yesterday;
                else
                    return returnDate;
            }
        } else {
            if (yesterdayDate.getMonth() == date.getMonth() && yesterdayDate.getDate() == date.getDate())
                return $scope.translation.WEBMOB_device_rvc_comm_yesterday;
            else
                return returnDate;
        }
    }
    function requestEnergyData()
    {
    	if($scope.energyLocation && !energyDBRequested)
    	{
    		energyDBRequested = true;
    		console.log('JJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJJust one called. ');
    		nativeInterface.getResourceUrl("/" + $scope.peerId + $scope.energyLocation);
    	}
    		
    }
    var energyDBRequested = false;
    function parseDeviceData(device) {
        //        console.log("Data is : " + JSON.stringify(device));
        // Checking Uuid
        if ($scope.isStatic === false && angular.isDefined(device["uuid"])) {
            if (device["uuid"] !== $scope.deviceUuid) {
                debugMessage("RVC: Uuid is mismatch!");
                return;
            }
        }

        if ($scope.isStatic === false && angular.isDefined(device["Movement"]) && angular.isDefined(device["Movement"]["History"]) && angular.isDefined(device["Movement"]["History"]["historyLocation"])) {
            $scope.historyLocation = device["Movement"]["History"]["historyLocation"];
        }

        if ($scope.isStatic === false && angular.isDefined(device["EnergyConsumption"]) && angular.isDefined(device["EnergyConsumption"]["saveLocation"])) {
            $scope.energyLocation = device["EnergyConsumption"]["saveLocation"];
            
        }

        if (!!device.Operation && !$scope.remoteLocked) { // if operation but not remote locked
            if (!!device.Operation.power) {
                $scope.Device.Operation.power = device.Operation.power;
                if ($scope.Device.Operation.power === "On") {
                    $scope.powerState = true;
                    //TODO:: Check if we can remove this as we already requesting get Device
                } else {
                    $scope.powerState = false;
                }
            }
            dismissLoadingBar(RVCCONST.POWER);
        }

        if (!$scope.remoteLocked && !!device.Alarms && !!device.Alarms.length) {
            manageAlarms(device);
        }

        if (!!device.Audio && angular.isDefined(device.Audio.micPower)) {
            $scope.Device.Audio.micPower = device.Audio.micPower;
        }

        if (angular.isDefined(device["Detection"])) {
            if (angular.isDefined(device["Detection"].motionDetected)) {
                $scope.Device.Detection.motionDetected = device["Detection"].motionDetected;
            }
            if (angular.isDefined(device["Detection"].motionDetectionInUse)) {
                $scope.Device.Detection.motionDetectionInUse = device["Detection"].motionDetectionInUse;
            }
        }
        if (angular.isDefined(device["EnergyConsumption"]) && angular.isDefined(device["EnergyConsumption"].batteryCharge)) {
            $scope.Device.EnergyConsumption.batteryCharge = device["EnergyConsumption"].batteryCharge;
        }
        if (angular.isDefined(device["AVSourcesLink"]) && angular.isDefined(device["AVSourcesLink"].href)) {
            $scope.Device.AVSourcesLink.href = device["AVSourcesLink"].href;
        }
        if (angular.isDefined(device["ConfigurationLink"]) && angular.isDefined(device["ConfigurationLink"].href)) {
            $scope.Device.ConfigurationLink.href = device["ConfigurationLink"].href;
        }
        if (angular.isDefined(device["InformationLink"]) && angular.isDefined(device["InformationLink"].href)) {
            $scope.Device.InformationLink.href = device["InformationLink"].href;
        }
        if (angular.isDefined(device["Light"])) {
            if (angular.isDefined(device["Light"].dimmingLevel)) {
                $scope.Device.Light.dimmingLevel = device["Light"].dimmingLevel;
            }
            if (angular.isDefined(device["Light"].lightPower)) {
                $scope.Device.Light.lightPower = device["Light"].lightPower;
            }
            if (angular.isDefined(device["Light"].maxDimmingLevel)) {
                $scope.Device.Light.maxDimmingLevel = device["Light"].maxDimmingLevel;
            }
        }
        if (angular.isDefined(device["Movement"])) {
            $scope.Device.Movement.behavior = device["Movement"].behavior;
            dismissLoadingBar(RVCCONST.MOVEMENT);
        }

        if (angular.isDefined(device["Map"])) {
            $scope.Device.Movement.Map = device["Map"];
            /*
            var temp = $scope.Device.Movement.Map[0];
            $scope.Device.Movement.Map.sort(sortMapData);           
            $scope.Device.Movement.Map[0] = temp;
            */
            sortMapByMapId($scope.Device.Movement.Map);
            initDataForMapDrwaing($scope.masterMapIndex);
        }

        if (angular.isDefined(device["isSuccess"])) {
            $scope.isMapDownloaded = device["isSuccess"];
            var dat = device["data"];
            if ($scope.isMapDownloaded && dat["Map"].length> 0) {
                $scope.Device.Movement.Map = device["data"]["Map"]; 
               /*
                var temp = $scope.Device.Movement.Map[0];
                $scope.Device.Movement.Map.sort(sortMapData);
                $scope.Device.Movement.Map[0] = temp;
                */
                
                //
                sortMapByMapId($scope.Device.Movement.Map);
                	
                
                //if set has only 2 map (1 from all fp and 1 from master fp),
                // then send the command to change mastermap to this map as set dont have master fp by default
                if(isMapCreationComplete && !!$scope.Device.Movement.Map && $scope.Device.Movement.Map.length === 2) {
                    changeMasterMap();
                    isMapCreationComplete = false;
                }
                //if there exist prev masterMapId(in case of master map changed), and master map are different, then show toast
                if(!!prevMasterMapId && prevMasterMapId !== $scope.Device.Movement.Map[$scope.masterMapIndex].mapId) {
                    //showToast({title: "",body: STRINGTOBEREPLACED.MASTER_MAP_CHANGED});
                    prevMasterMapId = '';
                }
                initDataForMapDrwaing($scope.masterMapIndex);
                $scope.DeviceOptions.controls.changeMapEnabled = !!$scope.Device.Movement.Map && !!$scope.Device.Movement.Map.length && $scope.DeviceOptions.cleaning_type === CLEANING_STATE.CHARGING;
                if (!!$scope.Device.Movement.MapCleaningStatusData) { // if there exists room cleanig data, show it with map
                    showMapCleaningStatus();
                }
                
                prepareTimeStampArray();
                prepareRoomCoord();
                initDataForMapDrwaing($scope.masterMapIndex);
                
            }
            
            requestEnergyData(); //This function should be called after map request complete. 
            
            
        }

        if (!!device.cleanMapRoomData) {
            //Lokesh 07Nov15_1610 -> we want cleaning room index from old data. Hence, before updating 'MapCleaningStatusData', we should get current cleaning room index.
            $scope.Device.Movement.MapCleaningStatusData = device.cleanMapRoomData;
            if (mapCleanRoomState === MAP_CLEANING_STATE.MOVING || mapCleanRoomState === MAP_CLEANING_STATE.CLEANING) {
                showMapCleaningStatus();
            }
        }

        if (angular.isDefined(device["Movement"]) && angular.isDefined(device["Movement"].Map)) {
            $scope.Device.Movement.MapDetailData = device["Movement"].Map;
            $scope.mapFileLoc.cleaingTxt = device["Movement"].Map["cleaningArea"];
            $scope.mapFileLoc.allMap = device["Movement"].Map["mapLocation"];
            $scope.mapFileLoc.masterMap = device["Movement"].Map["masterMap"];
            $scope.mapFileLoc.masterMapLoc = device["Movement"].Map["masterMapLocation"];

            requestToDownloadMapData();
            downloadCleanTxtFile();
            $scope.isMap = true;
            //$scope.mapState = MAP_STATE.AVAILABLE; //map is available.
            $scope.tutScreens = null;
        }

        if (angular.isDefined(device["connected"])) {
            $scope.Device.connected = device["connected"];
            if (device["connected"] === false) {
                $scope.showConnectionFailurePopup();
            }
        }
        if (angular.isDefined(device["id"])) {
            $scope.Device.id = device["id"];
            deviceID = $scope.Device.id;
        }
        if (angular.isDefined(device["name"])) {
            $scope.Device.name = device["name"];
        }
        if (angular.isDefined(device["resources"])) {
            $scope.Device.resources = device["resources"];
        }
        if (angular.isDefined(device["type"])) {
            $scope.Device.type = device["type"];
        }
        if (angular.isDefined(device["uuid"])) {
            $scope.Device.uuid = device["uuid"];
        }
        if (angular.isDefined(device["Mode"])) {

            if (device["Mode"].modes.length === 1 && device.Mode.modes[0] === 'Access_UnLock' && $scope.remoteLocked) { // if set is in remote lock state and get 'Access_Unlock', remove remote lock state and get latest state  
                $scope.remoteLocked = false;
                sendSHPCommand(RVCCONST.GET, "/" + $scope.peerId + "/devices/0");
            }

            if ($scope.remoteLocked) // if set is remote locked, dont handle any further noti, till set is unlocked
                return;

            if (!!device["Mode"].modes && device["Mode"].modes.length === 1 && (device.Mode.modes[0] === 'Notify_MasterMapChange' || device.Mode.modes[0] === 'Notify_CleaningCompleted' || device.Mode.modes[0] === 'Notify_MapCreatingCompleted' || device.Mode.modes[0] === 'Notify_ChangeHistory' || device.Mode.modes[0] === 'Notify_ChangeSchedule' || device.Mode.modes[0] === 'Turbo_On' || device.Mode.modes[0] === 'Turbo_Off' || device.Mode.modes[0] === 'Turbo_Silence' || device.Mode.modes[0] === 'Sound_VoiceM' || device.Mode.modes[0] === 'Sound_VoiceW' || device.Mode.modes[0] === 'Sound_Mute' || device.Mode.modes[0] === 'Sound_SoundEffect' || device.Mode.modes[0] === 'SmartTurbo_Off' || device.Mode.modes[0] === 'SmartTurbo_On' || device.Mode.modes[0].indexOf("Schedule_") === 0)) {
                //When user change suction option, voice option or map single noti, do not reset the control button state and handle these noti separatly
                manageSingleMode(device.Mode.modes[0]);
            } else {
                if (device.Mode.modes.length === 1 && ($scope.DeviceOptions.alarm && device.Mode.modes[0] === 'Cleaning_Stop') || device.Mode.modes[0] === 'Control_Alarm') {
                    return; // 9Nov, In case of 'Control_Alam', we get errorcode which is being handled separtly, so no need to handle 'Control_Alarm' here
                }
                $scope.Device.Mode.modes = device["Mode"].modes;               
                $scope.DeviceOptions.controls.isReserved = false;
                $scope.DeviceOptions.cleaning_type = CLEANING_STATE.NONE;
                
                if (angular.isDefined(device["Mode"].supportedModes)) {
                    $scope.Device.Mode.supportedModes = device["Mode"].supportedModes;
                    if (device["Mode"].supportedModes.indexOf('Schedule_A') > -1) { // old schedule
                        $scope.scheduleType = RVCSCHEDULE.A;
                    } else if (device["Mode"].supportedModes.indexOf('Schedule_B') > -1) { // New schedule
                        $scope.scheduleType = RVCSCHEDULE.B;
                    }
                    if(device["Mode"].supportedModes.indexOf('Suction_A') > -1) {
                    	$scope.isSuctionA = true;
                    }
                }
                if (angular.isDefined(device["Mode"].modes)) {
                	if(device["Mode"].modes.indexOf('Locale_410') > -1) {
                    	$scope.voiceControlList = [{
                            id: 'SOUND_VOICEW',
                            modeName: "VCMOB_setting_voice_waman"
                        }, {
                            id: 'SOUND_VOICEM',
                            modeName: "VCMOB_setting_voice_man"
                        }, {
                            id: 'SOUND_EFFECT',
                            modeName: "VCMOB_setting_soundeffect_contents"
                        }, {
                            id: 'SOUND_MUTE',
                            modeName: "VCMOB_setting_mute_contents"
                        }];
                    }
                }
                manageModes(device);
                dismissLoadingBar(RVCCONST.MODES);
            }
        }
        $scope.mainLoadingScreen = true;
        changeScreen();
        dismissLoadingBar(RVCCONST.GET_DEVICE);
    }

    function manageSingleMode(mode) {

        if (mode.indexOf("Schedule_") == 0) {
            var representSchedule = mode.split("_");
            if (representSchedule[1] == "0") {
                $scope.ScheduleText = $scope.translation.WEBMOB_common_none;
            } else {
                var tempDate = new Date(Number(representSchedule[1]) * 1000);
                var tempDateArr = setTimeInGMTforRVC(tempDate.toISOString(), $scope);
                $scope.ScheduleText = tempDateArr[0] + ":" + tempDateArr[1] + " " + tempDateArr[2] + ", " + tempDateArr[3];
            }
        }
        //ksum160222
        switch (mode) {
            case 'Notify_MasterMapChange': //Fallthrough
            case 'Notify_CleaningCompleted': //Fallthrough
            case 'Notify_MapCreatingCompleted': //Fallthrough
                manageMapNotification(mode);
                break;
            case 'Turbo_On':
                $scope.DeviceOptions.selectedMode = $scope.SuctionPowerList[RVCCONST.TURBO_ON];
                break;
            case 'Turbo_Off':
                $scope.DeviceOptions.selectedMode = $scope.SuctionPowerList[RVCCONST.TURBO_OFF];
                break;
            case 'Turbo_Silence':
                $scope.DeviceOptions.selectedMode = $scope.SuctionPowerList[RVCCONST.TURBO_SILENCE];
                break;
            case 'Sound_VoiceM':
                $scope.DeviceOptions.selectedVoice = 'VCMOB_setting_voice_man';
                break;
            case 'Sound_VoiceW':
                $scope.DeviceOptions.selectedVoice = 'VCMOB_setting_voice_waman';
                break;
            case 'Sound_Mute':
                $scope.DeviceOptions.selectedVoice = 'VCMOB_setting_mute_contents';
                break;
            case 'Sound_SoundEffect':
                $scope.DeviceOptions.selectedVoice = 'VCMOB_setting_soundeffect_contents';
                break;
                
            case 'Notify_ChangeSchedule':
            	sendSHPCommand(RVCCONST.GET, "/" + $scope.peerId + "/actions", "", RVCCONST.GET_ACTIONS,false);
                break;
            default:
                break;
        };
        dismissLoadingBar(RVCCONST.MODES);
    }

    function showMapCleaningStatus() {
        var mapData = $scope.Device.Movement.MapCleaningStatusData,
            cnt,
            len = mapData.length;
        if (!$scope.isMapDownloaded) // if map data is not downloaded, dont show status
            return;

        if (mapCleanRoomState == MAP_CLEANING_STATE.MOVING) {
            for (cnt = 0; cnt < len; ++cnt) {
                if (MAP_CLEANING_STATE.MOVING == mapData[cnt].cleanRoomStatus) {
                	$scope.DeviceOptions.selectedText = 'WEBMOB_device_rvc_map_going_to_room_for_cleaning';
                    $scope.additionalInfoSelectedText = ' ' + getRoomNameForDisplayonRenamePage(mapData[cnt].cleanRoomIndex,$scope.masterMapIndex); 
                    break;
                }
            }
        } else if (mapCleanRoomState == MAP_CLEANING_STATE.CLEANING) {
            for (cnt = 0; cnt < len; ++cnt) {
                if (MAP_CLEANING_STATE.CLEANING == mapData[cnt].cleanRoomStatus) {
                	$scope.DeviceOptions.selectedText = 'WEBMOB_device_rvc_status_cleaning_in',
                    $scope.additionalInfoSelectedText = ' ' + getRoomNameForDisplayonRenamePage(mapData[cnt].cleanRoomIndex,$scope.masterMapIndex);
                    break;
                }
            }
        }
        
        console.log('=========> showMapClaningStatus ::: ' + $scope.DeviceOptions.selectedText + " : " + $scope.additionalInfoSelectedText);
    }

    function requestToDownloadMapData() {
        if (!!!$scope.mapFileLoc.allMap || !!!$scope.mapFileLoc.masterMapLoc)
            return; // if no path available for allMap.zip and mastermap file, return

        var mapData = "\"cleaningArea\" : \"" + $scope.mapFileLoc.cleaingTxt + "\" , \"mapLocation\": \"" + $scope.mapFileLoc.allMap + "\" , \"masterMap\" : \"" + $scope.mapFileLoc.masterMap + "\" , \"masterMapLocation\": \"" + $scope.mapFileLoc.masterMapLoc + " \" ";
        if (!$scope.isStatic) {
            nativeInterface.runOnNative("downloadRVCMasterMapFiles", "{\"deviceUuid\" : \"" + $scope.deviceUuid + "\", \"Map\": {" + mapData + "}}");
        }
    }

    function parseStaticData() {
        var device;
        $scope.isStatic = true;
        init();
        device = JSON.parse(SHPService.getSHPData('Robot_Cleaner', 'getDevices'));
        $scope.parseDeviceData(device.Device);
        $scope.isMapDownloaded = true;
        //        SHPService.updateDeviceData($scope, JSON.stringify({data:device, type:'requestResponse', status:99000})); // to check 99000
        $scope.Device.Movement.Map = [{"mapId":"06","mapName":"006.map","roomCount":3,"chargerPoint":{"x":56,"y":25},"maxWidthX":61,"maxHeightY":71,"floorPlanShiftPoint":{"x":-29,"y":-9},"isPortrait":0,"dateTime":1453181746,"room":[{"roomIndex":0,"roomName":"Room0","doorCount":1,"doorType":0,"doorStart":{"x":0,"y":0},"doorEnd":{"x":0,"y":0},"doorRobotStart":{"x":0,"y":0},"doorRobotEnd":{"x":0,"y":0},"vertexCount":10,"vertexPointList":[{"x":61,"y":0},{"x":61,"y":44},{"x":0,"y":44},{"x":0,"y":44},{"x":0,"y":37},{"x":0,"y":20},{"x":28,"y":20},{"x":28,"y":0},{"x":42,"y":0},{"x":60,"y":0}],"notationStart":{"x":44,"y":21.5},"notationEnd":{"x":44,"y":21.5},"ref_X":-2,"ref_Y":15,"cellCount":1907},{"roomIndex":1,"roomName":"Room1","doorCount":1,"doorType":4,"doorStart":{"x":47,"y":44},"doorEnd":{"x":40,"y":44},"doorRobotStart":{"x":19,"y":9},"doorRobotEnd":{"x":19,"y":16},"vertexCount":4,"vertexPointList":[{"x":61,"y":44},{"x":61,"y":71},{"x":40,"y":71},{"x":40,"y":44}],"notationStart":{"x":50.5,"y":57.5},"notationEnd":{"x":50.5,"y":57.5},"ref_X":32,"ref_Y":5,"cellCount":533},{"roomIndex":2,"roomName":"Room2","doorCount":1,"doorType":6,"doorStart":{"x":23,"y":20},"doorEnd":{"x":19,"y":20},"doorRobotStart":{"x":-5,"y":33},"doorRobotEnd":{"x":-5,"y":37},"vertexCount":4,"vertexPointList":[{"x":27,"y":0},{"x":27,"y":20},{"x":2,"y":20},{"x":2,"y":0}],"notationStart":{"x":14.5,"y":10},"notationEnd":{"x":14.5,"y":10},"ref_X":-15,"ref_Y":41,"cellCount":426}]},            
            {"mapId":"06","mapName":"006.map","roomCount":3,"chargerPoint":{"x":56,"y":25},"maxWidthX":61,"maxHeightY":71,"floorPlanShiftPoint":{"x":-29,"y":-9},"isPortrait":0,"dateTime":1453181746,"room":[{"roomIndex":0,"roomName":"Room0","doorCount":1,"doorType":0,"doorStart":{"x":0,"y":0},"doorEnd":{"x":0,"y":0},"doorRobotStart":{"x":0,"y":0},"doorRobotEnd":{"x":0,"y":0},"vertexCount":10,"vertexPointList":[{"x":61,"y":0},{"x":61,"y":44},{"x":0,"y":44},{"x":0,"y":44},{"x":0,"y":37},{"x":0,"y":20},{"x":28,"y":20},{"x":28,"y":0},{"x":42,"y":0},{"x":60,"y":0}],"notationStart":{"x":44,"y":21.5},"notationEnd":{"x":44,"y":21.5},"ref_X":-2,"ref_Y":15,"cellCount":1907},{"roomIndex":1,"roomName":"Room1","doorCount":1,"doorType":4,"doorStart":{"x":47,"y":44},"doorEnd":{"x":40,"y":44},"doorRobotStart":{"x":19,"y":9},"doorRobotEnd":{"x":19,"y":16},"vertexCount":4,"vertexPointList":[{"x":61,"y":44},{"x":61,"y":71},{"x":40,"y":71},{"x":40,"y":44}],"notationStart":{"x":50.5,"y":57.5},"notationEnd":{"x":50.5,"y":57.5},"ref_X":32,"ref_Y":5,"cellCount":533},{"roomIndex":2,"roomName":"Room2","doorCount":1,"doorType":6,"doorStart":{"x":23,"y":20},"doorEnd":{"x":19,"y":20},"doorRobotStart":{"x":-5,"y":33},"doorRobotEnd":{"x":-5,"y":37},"vertexCount":4,"vertexPointList":[{"x":27,"y":0},{"x":27,"y":20},{"x":2,"y":20},{"x":2,"y":0}],"notationStart":{"x":14.5,"y":10},"notationEnd":{"x":14.5,"y":10},"ref_X":-15,"ref_Y":41,"cellCount":426}]},            
            {"mapId":"01","mapName":"001.map","roomCount":3,"chargerPoint":{"x":58,"y":26},"maxWidthX":60,"maxHeightY":77,"floorPlanShiftPoint":{"x":-30,"y":-6},"isPortrait":0,"dateTime":1453181746,"room":[{"roomIndex":0,"roomName":"Room0","doorCount":1,"doorType":0,"doorStart":{"x":0,"y":0},"doorEnd":{"x":0,"y":0},"doorRobotStart":{"x":0,"y":0},"doorRobotEnd":{"x":0,"y":0},"vertexCount":12,"vertexPointList":[{"x":60,"y":0},{"x":60,"y":48},{"x":57,"y":48},{"x":0,"y":48},{"x":0,"y":41},{"x":0,"y":22},{"x":17,"y":22},{"x":17,"y":13},{"x":28,"y":13},{"x":28,"y":0},{"x":31,"y":0},{"x":60,"y":0}],"notationStart":{"x":34,"y":30.5},"notationEnd":{"x":34,"y":30.5},"ref_X":0,"ref_Y":19,"cellCount":1947},{"roomIndex":1,"roomName":"Room1","doorCount":1,"doorType":4,"doorStart":{"x":43,"y":48},"doorEnd":{"x":39,"y":48},"doorRobotStart":{"x":22,"y":15},"doorRobotEnd":{"x":22,"y":19},"vertexCount":4,"vertexPointList":[{"x":56,"y":48},{"x":56,"y":77},{"x":33,"y":77},{"x":33,"y":48}],"notationStart":{"x":44.5,"y":62.5},"notationEnd":{"x":44.5,"y":62.5},"ref_X":36,"ref_Y":13,"cellCount":566},{"roomIndex":2,"roomName":"Room2","doorCount":1,"doorType":6,"doorStart":{"x":21,"y":21},"doorEnd":{"x":18,"y":21},"doorRobotStart":{"x":-5,"y":37},"doorRobotEnd":{"x":-5,"y":40},"vertexCount":4,"vertexPointList":[{"x":26,"y":3},{"x":26,"y":21},{"x":2,"y":21},{"x":2,"y":3}],"notationStart":{"x":14,"y":12},"notationEnd":{"x":14,"y":12},"ref_X":-14,"ref_Y":44,"cellCount":372}]},
            {"mapId":"02","mapName":"002.map","roomCount":3,"chargerPoint":{"x":55,"y":25},"maxWidthX":59,"maxHeightY":73,"floorPlanShiftPoint":{"x":-28,"y":-8},"isPortrait":0,"dateTime": 1388534400,"room":[{"roomIndex":0,"roomName":"Room0","doorCount":1,"doorType":0,"doorStart":{"x":0,"y":0},"doorEnd":{"x":0,"y":0},"doorRobotStart":{"x":0,"y":0},"doorRobotEnd":{"x":0,"y":0},"vertexCount":10,"vertexPointList":[{"x":59,"y":0},{"x":59,"y":47},{"x":55,"y":47},{"x":0,"y":47},{"x":0,"y":38},{"x":0,"y":19},{"x":26,"y":19},{"x":26,"y":0},{"x":28,"y":0},{"x":59,"y":0}],"notationStart":{"x":42,"y":23.5},"notationEnd":{"x":42,"y":23.5},"ref_X":6,"ref_Y":17,"cellCount":1840},{"roomIndex":1,"roomName":"Room1","doorCount":1,"doorType":4,"doorStart":{"x":42,"y":46},"doorEnd":{"x":36,"y":46},"doorRobotStart":{"x":21,"y":13},"doorRobotEnd":{"x":21,"y":19},"vertexCount":4,"vertexPointList":[{"x":55,"y":46},{"x":55,"y":73},{"x":32,"y":73},{"x":32,"y":46}],"notationStart":{"x":43.5,"y":59.5},"notationEnd":{"x":43.5,"y":59.5},"ref_X":34,"ref_Y":11,"cellCount":533},{"roomIndex":2,"roomName":"Room2","doorCount":1,"doorType":6,"doorStart":{"x":24,"y":19},"doorEnd":{"x":16,"y":19},"doorRobotStart":{"x":-6,"y":31},"doorRobotEnd":{"x":-6,"y":39},"vertexCount":4,"vertexPointList":[{"x":26,"y":1},{"x":26,"y":19},{"x":3,"y":19},{"x":3,"y":1}],"notationStart":{"x":14.5,"y":10},"notationEnd":{"x":14.5,"y":10},"ref_X":-15,"ref_Y":40,"cellCount":371}]},
            {"mapId":"04","mapName":"004.map","roomCount":3,"chargerPoint":{"x":55,"y":26},"maxWidthX":57,"maxHeightY":70,"floorPlanShiftPoint":{"x":-29,"y":-6},"isPortrait":0,"dateTime": 1388534400,"room":[{"roomIndex":0,"roomName":"Room0","doorCount":1,"doorType":0,"doorStart":{"x":0,"y":0},"doorEnd":{"x":0,"y":0},"doorRobotStart":{"x":0,"y":0},"doorRobotEnd":{"x":0,"y":0},"vertexCount":10,"vertexPointList":[{"x":57,"y":0},{"x":57,"y":44},{"x":54,"y":44},{"x":0,"y":44},{"x":0,"y":39},{"x":0,"y":21},{"x":26,"y":21},{"x":26,"y":0},{"x":28,"y":0},{"x":32,"y":0}],"notationStart":{"x":41,"y":22.5},"notationEnd":{"x":41,"y":22.5},"ref_X":0,"ref_Y":18,"cellCount":1656},{"roomIndex":1,"roomName":"Room1","doorCount":1,"doorType":4,"doorStart":{"x":43,"y":44},"doorEnd":{"x":37,"y":44},"doorRobotStart":{"x":18,"y":12},"doorRobotEnd":{"x":18,"y":18},"vertexCount":4,"vertexPointList":[{"x":55,"y":44},{"x":55,"y":70},{"x":33,"y":70},{"x":33,"y":44}],"notationStart":{"x":44,"y":57},"notationEnd":{"x":44,"y":57},"ref_X":31,"ref_Y":11,"cellCount":492},{"roomIndex":2,"roomName":"Room2","doorCount":1,"doorType":6,"doorStart":{"x":23,"y":21},"doorEnd":{"x":15,"y":21},"doorRobotStart":{"x":-5,"y":32},"doorRobotEnd":{"x":-5,"y":40},"vertexCount":4,"vertexPointList":[{"x":26,"y":2},{"x":26,"y":21},{"x":1,"y":21},{"x":1,"y":2}],"notationStart":{"x":13.5,"y":11.5},"notationEnd":{"x":13.5,"y":11.5},"ref_X":-15,"ref_Y":41,"cellCount":402}]},
            {"mapId":"07","mapName":"007.map","roomCount":3,"chargerPoint":{"x":59,"y":27},"maxWidthX":61,"maxHeightY":74,"floorPlanShiftPoint":{"x":-31,"y":-6},"isPortrait":0,"dateTime": 1388534400,"room":[{"roomIndex":0,"roomName":"Room0","doorCount":1,"doorType":0,"doorStart":{"x":0,"y":0},"doorEnd":{"x":0,"y":0},"doorRobotStart":{"x":0,"y":0},"doorRobotEnd":{"x":0,"y":0},"vertexCount":10,"vertexPointList":[{"x":61,"y":0},{"x":61,"y":46},{"x":0,"y":46},{"x":0,"y":46},{"x":0,"y":37},{"x":0,"y":22},{"x":17,"y":22},{"x":17,"y":0},{"x":50,"y":0},{"x":60,"y":0}],"notationStart":{"x":39,"y":22.5},"notationEnd":{"x":39,"y":22.5},"ref_X":-5,"ref_Y":18,"cellCount":1968},{"roomIndex":1,"roomName":"Room1","doorCount":1,"doorType":4,"doorStart":{"x":47,"y":46},"doorEnd":{"x":42,"y":46},"doorRobotStart":{"x":19,"y":12},"doorRobotEnd":{"x":19,"y":17},"vertexCount":4,"vertexPointList":[{"x":60,"y":46},{"x":60,"y":74},{"x":38,"y":74},{"x":38,"y":46}],"notationStart":{"x":49,"y":60},"notationEnd":{"x":49,"y":60},"ref_X":33,"ref_Y":10,"cellCount":542},{"roomIndex":2,"roomName":"Room2","doorCount":1,"doorType":6,"doorStart":{"x":25,"y":21},"doorEnd":{"x":17,"y":21},"doorRobotStart":{"x":-6,"y":34},"doorRobotEnd":{"x":-6,"y":42},"vertexCount":4,"vertexPointList":[{"x":25,"y":0},{"x":25,"y":21},{"x":1,"y":21},{"x":1,"y":0}],"notationStart":{"x":13,"y":10.5},"notationEnd":{"x":13,"y":10.5},"ref_X":-17,"ref_Y":46,"cellCount":471}]},
            {"mapId":"05","mapName":"005.map","roomCount":2,"chargerPoint":{"x":59,"y":26},"maxWidthX":61,"maxHeightY":72,"floorPlanShiftPoint":{"x":-30,"y":-6},"isPortrait":0,"dateTime":1452079057,"room":[{"roomIndex":0,"roomName":"Room0","doorCount":1,"doorType":0,"doorStart":{"x":0,"y":0},"doorEnd":{"x":0,"y":0},"doorRobotStart":{"x":0,"y":0},"doorRobotEnd":{"x":0,"y":0},"vertexCount":8,"vertexPointList":[{"x":61,"y":0},{"x":61,"y":44},{"x":60,"y":44},{"x":0,"y":44},{"x":0,"y":6},{"x":0,"y":0},{"x":28,"y":0},{"x":59,"y":0}],"notationStart":{"x":30.5,"y":22},"notationEnd":{"x":30.5,"y":22},"ref_X":-5,"ref_Y":18,"cellCount":2382},{"roomIndex":1,"roomName":"Room1","doorCount":1,"doorType":4,"doorStart":{"x":44,"y":44},"doorEnd":{"x":41,"y":44},"doorRobotStart":{"x":18,"y":15},"doorRobotEnd":{"x":18,"y":18},"vertexCount":4,"vertexPointList":[{"x":61,"y":44},{"x":61,"y":72},{"x":39,"y":72},{"x":39,"y":44}],"notationStart":{"x":50,"y":58},"notationEnd":{"x":50,"y":58},"ref_X":32,"ref_Y":9,"cellCount":555}]},     
            {"mapId":"08","mapName":"008.map","roomCount":2,"chargerPoint":{"x":25,"y":3},"maxWidthX":45,"maxHeightY":58,"floorPlanShiftPoint":{"x":-28,"y":-7},"isPortrait":1,"dateTime":1452079057,"room":[{"roomIndex":0,"roomName":"Room0","doorCount":1,"doorType":0,"doorStart":{"x":0,"y":0},"doorEnd":{"x":0,"y":0},"doorRobotStart":{"x":0,"y":0},"doorRobotEnd":{"x":0,"y":0},"vertexCount":10,"vertexPointList":[{"x":0,"y":0},{"x":45,"y":0},{"x":45,"y":10},{"x":45,"y":58},{"x":40,"y":58},{"x":20,"y":58},{"x":20,"y":32},{"x":0,"y":32},{"x":0,"y":30},{"x":0,"y":2}],"notationStart":{"x":22.5,"y":16},"notationEnd":{"x":22.5,"y":16},"ref_X":-2,"ref_Y":15,"cellCount":1856},{"roomIndex":1,"roomName":"Room1","doorCount":1,"doorType":2,"doorStart":{"x":20,"y":34},"doorEnd":{"x":20,"y":39},"doorRobotStart":{"x":-5,"y":31},"doorRobotEnd":{"x":-5,"y":36},"vertexCount":4,"vertexPointList":[{"x":1,"y":33},{"x":20,"y":33},{"x":20,"y":57},{"x":1,"y":57}],"notationStart":{"x":10.5,"y":45},"notationEnd":{"x":10.5,"y":45},"ref_X":-15,"ref_Y":42,"cellCount":382}]},
            {"mapId":"03","mapName":"003.map","roomCount":2,"chargerPoint":{"x":51,"y":23},"maxWidthX":52,"maxHeightY":66,"floorPlanShiftPoint":{"x":-26,"y":-6},"isPortrait":0,"dateTime":1452147844,"room":[{"roomIndex":0,"roomName":"Room0","doorCount":1,"doorType":0,"doorStart":{"x":0,"y":0},"doorEnd":{"x":0,"y":0},"doorRobotStart":{"x":0,"y":0},"doorRobotEnd":{"x":0,"y":0},"vertexCount":10,"vertexPointList":[{"x":52,"y":0},{"x":52,"y":41},{"x":46,"y":41},{"x":0,"y":41},{"x":0,"y":22},{"x":0,"y":19},{"x":20,"y":19},{"x":20,"y":0},{"x":43,"y":0},{"x":50,"y":0}],"notationStart":{"x":36,"y":20.5},"notationEnd":{"x":36,"y":20.5},"ref_X":-3,"ref_Y":20,"cellCount":1456},{"roomIndex":1,"roomName":"Room1","doorCount":1,"doorType":4,"doorStart":{"x":41,"y":41},"doorEnd":{"x":33,"y":41},"doorRobotStart":{"x":18,"y":10},"doorRobotEnd":{"x":18,"y":18},"vertexCount":4,"vertexPointList":[{"x":52,"y":41},{"x":52,"y":66},{"x":31,"y":66},{"x":31,"y":41}],"notationStart":{"x":41.5,"y":53.5},"notationEnd":{"x":41.5,"y":53.5},"ref_X":30,"ref_Y":9,"cellCount":507}]},
            {"mapId":"09","mapName":"009.map","roomCount":3,"chargerPoint":{"x":53,"y":24},"maxWidthX":56,"maxHeightY":69,"floorPlanShiftPoint":{"x":-28,"y":-7},"isPortrait":0,"dateTime":1452103826,"room":[{"roomIndex":0,"roomName":"Room0","doorCount":1,"doorType":0,"doorStart":{"x":0,"y":0},"doorEnd":{"x":0,"y":0},"doorRobotStart":{"x":0,"y":0},"doorRobotEnd":{"x":0,"y":0},"vertexCount":8,"vertexPointList":[{"x":56,"y":0},{"x":56,"y":43},{"x":0,"y":43},{"x":0,"y":20},{"x":25,"y":20},{"x":25,"y":0},{"x":26,"y":0},{"x":55,"y":0}],"notationStart":{"x":40,"y":21.5},"notationEnd":{"x":40,"y":21.5},"ref_X":-2,"ref_Y":15,"cellCount":1757},{"roomIndex":1,"roomName":"Room1","doorCount":1,"doorType":4,"doorStart":{"x":44,"y":43},"doorEnd":{"x":36,"y":43},"doorRobotStart":{"x":19,"y":9},"doorRobotEnd":{"x":19,"y":17},"vertexCount":4,"vertexPointList":[{"x":56,"y":43},{"x":56,"y":69},{"x":35,"y":69},{"x":35,"y":43}],"notationStart":{"x":45.5,"y":56},"notationEnd":{"x":45.5,"y":56},"ref_X":32,"ref_Y":7,"cellCount":493},{"roomIndex":2,"roomName":"Room2","doorCount":1,"doorType":6,"doorStart":{"x":21,"y":20},"doorEnd":{"x":17,"y":20},"doorRobotStart":{"x":-4,"y":32},"doorRobotEnd":{"x":-4,"y":36},"vertexCount":4,"vertexPointList":[{"x":24,"y":1},{"x":24,"y":20},{"x":0,"y":20},{"x":0,"y":1}],"notationStart":{"x":12,"y":10.5},"notationEnd":{"x":12,"y":10.5},"ref_X":-14,"ref_Y":41,"cellCount":402}]},
            {"mapId":"10","mapName":"010.map","roomCount":3,"chargerPoint":{"x":58,"y":26},"maxWidthX":60,"maxHeightY":77,"floorPlanShiftPoint":{"x":-30,"y":-6},"isPortrait":0,"dateTime":1452103180,"room":[{"roomIndex":0,"roomName":"Room0","doorCount":1,"doorType":0,"doorStart":{"x":0,"y":0},"doorEnd":{"x":0,"y":0},"doorRobotStart":{"x":0,"y":0},"doorRobotEnd":{"x":0,"y":0},"vertexCount":12,"vertexPointList":[{"x":60,"y":0},{"x":60,"y":48},{"x":57,"y":48},{"x":0,"y":48},{"x":0,"y":41},{"x":0,"y":22},{"x":17,"y":22},{"x":17,"y":13},{"x":28,"y":13},{"x":28,"y":0},{"x":31,"y":0},{"x":60,"y":0}],"notationStart":{"x":34,"y":30.5},"notationEnd":{"x":34,"y":30.5},"ref_X":0,"ref_Y":19,"cellCount":1947},{"roomIndex":1,"roomName":"Room1","doorCount":1,"doorType":4,"doorStart":{"x":43,"y":48},"doorEnd":{"x":39,"y":48},"doorRobotStart":{"x":22,"y":15},"doorRobotEnd":{"x":22,"y":19},"vertexCount":4,"vertexPointList":[{"x":56,"y":48},{"x":56,"y":77},{"x":33,"y":77},{"x":33,"y":48}],"notationStart":{"x":44.5,"y":62.5},"notationEnd":{"x":44.5,"y":62.5},"ref_X":36,"ref_Y":13,"cellCount":566},{"roomIndex":2,"roomName":"Room2","doorCount":1,"doorType":6,"doorStart":{"x":21,"y":21},"doorEnd":{"x":18,"y":21},"doorRobotStart":{"x":-5,"y":37},"doorRobotEnd":{"x":-5,"y":40},"vertexCount":4,"vertexPointList":[{"x":26,"y":3},{"x":26,"y":21},{"x":2,"y":21},{"x":2,"y":3}],"notationStart":{"x":14,"y":12},"notationEnd":{"x":14,"y":12},"ref_X":-14,"ref_Y":44,"cellCount":372}]}];

        //        $scope.Device.Movement.Map = '';
        /*
        var temp = $scope.Device.Movement.Map[0];
        $scope.Device.Movement.Map.sort(sortMapData);
        $scope.Device.Movement.Map[0] = temp;
        */
        sortMapByMapId($scope.Device.Movement.Map);
        prepareTimeStampArray();
        prepareRoomCoord();
        $scope.isMap = true;
        isMapDataAvailable();
        initDataForMapDrwaing($scope.masterMapIndex);
        
        //FIXME:: please remove this in case of dynamic data
        //var lift = {"type":"notification","status":200,"data":[{"Mode":{"modes":["Control_Charging"]},"event":"Notified","eventTime":"2015-11-01T06:32:59","resourceURI":"/devices/0/mode","uuid":"F8042EBA-A517-0000-0000-000000000000"},{"Alarms":[{"id":"0","code":"ErrorCode_2","triggeredTime":"2015-11-01T06:32:59"}],"event":"Created","eventTime":"2015-11-01T06:32:59","resourceURI":"/devices/0/alarms","uuid":"F8042EBA-A517-0000-0000-000000000000"}]};
        //	 var lift = {"type":"notification","status":200,"data":[{"Mode":{"modes":["Control_Charging"]},"event":"Notified","eventTime":"2015-11-01T06:32:59","resourceURI":"/devices/0/mode","uuid":"F8042EBA-A517-0000-0000-000000000000"},{"Alarms":[{"id":"0","code":"ErrorCode_10","triggeredTime":"2015-11-01T06:32:59"}],"event":"Created","eventTime":"2015-11-01T06:32:59","resourceURI":"/devices/0/alarms","uuid":"F8042EBA-A517-0000-0000-000000000000"}]};
        //         $timeout(function () { SHPService.updateDeviceData($scope, JSON.stringify(lift)); }, 6000);
        
    };

    function powerOnOff(status) {
        var payload;
        if ($scope.powerState !== status) {
            return;
        }

        //in case of alarm also, the button should not be clickable.
        if ($scope.remoteLocked || $scope.DeviceOptions.controls.isReserved || $scope.DeviceOptions.cleaning_type === CLEANING_STATE.CHARGING || $scope.DeviceOptions.cleaning_type === CLEANING_STATE.POINT || $scope.DeviceOptions.cleaning_type === CLEANING_STATE.AFTER || $scope.DeviceOptions.alarm) {
            return;
        }

        payload = '{"Operation": {"power": ' + (status ? '"Off"' : '"On"') + '}}';
        debugMessage('payload = ' + payload);

        if ($scope.isStatic) {
            $scope.powerState = !$scope.powerState;
        } else {
            sendSHPCommand(RVCCONST.PUT, payload, "/" + $scope.peerId + "/devices/0/operation", RVCCONST.POWER);
        }
    }

    function sendSHPCommand(method, payload, uri, state, isLoading) {
        if (!!$scope.Device.Alarms && $scope.Device.Alarms.length && $scope.Device.Alarms[0].errorCode === 10) { //if it is error code 10, then show error popup to user.
            showChargingForBatteryError();
        } else {
            if (!$scope.isStatic) {
                if (!!state) {
                    $scope.checkResponse.push(state);
                }
                SHPService.sendSHPCommand(method, payload, uri, isLoading);
            }
        }
    }

    function ModeChangeRVC(mode, showLoadingBar) {
        debugMessage("ModeChangeRVC : " + mode);
        var RVCpayload = '',
            controls = $scope.DeviceOptions.controls,
            state;
        switch (mode) {
            case 'AUTO':
                if ($scope.DeviceOptions.controls.isReserved) { // if set in reserved mode, show popup and return
                	if($scope.scheduleType != RVCSCHEDULE.B) {
                		showPlayInReservedMessage();
                		return;
                	}
                	else{
                		$scope.DeviceOptions.controls.isReserved = false;
                	}
                }
                RVCpayload = "Cleaning_Auto";
                break;
            case 'STOP':
                RVCpayload = "Cleaning_Stop";
                if (touchStartTime !== -1 && touchEndTime !== -1 && touchStartTime >= touchEndTime) { // there is new mannual command, then dont proceed and return
                    return;
                }
                touchStartTime = -1;
                touchEndTime = -1;
                break;
            case 'CHARGE':
                if (!controls.charging) {
                    return;
                }
                RVCpayload = "Control_Homing";
                break;
            case 'TURBO_OFF':
                RVCpayload = "Turbo_Off";
                break;
            case 'TURBO_ON':
                RVCpayload = "Turbo_On";
                break;
            case 'TURBO_SILENCE':
                RVCpayload = "Turbo_Silence";
                break;
            case 'SPOT':
                RVCpayload = "Cleaning_Part";
                break;
            case 'SOUND_VOICEM':
                RVCpayload = "Sound_VoiceM";
                break;
            case 'SOUND_VOICEW':
                RVCpayload = "Sound_VoiceW";
                break;
            case 'SOUND_EFFECT':
                RVCpayload = "Sound_SoundEffect";
                break;
            case 'SOUND_MUTE':
                RVCpayload = "Sound_Mute";
                break;
            case 'CREATING_MAP':
                RVCpayload = "Cleaning_Map"; // changing SHP the specification
                break;
            case 'MAP_RESUME':
            	RVCpayload = "Cleaning_Area";
            	break;    
            default:
                break;
        }
        if (!!RVCpayload) {
            RVCpayload = '{"Mode": {"modes": ["' + RVCpayload + '"]}}';
        }
        debugMessage('mode payload = ' + RVCpayload);
        if (!$scope.isStatic) {
            if (mode === 'CREATING_MAP') {
                hideIntroScreen();
                state = RVCCONST.CREATING_MAP_REQUEST;
            } else {
                state = RVCCONST.MODES;
            }
            sendSHPCommand(RVCCONST.PUT, RVCpayload, "/" + $scope.peerId + "/devices/0/mode", state, showLoadingBar);
        } else {
            if (mode === 'CREATING_MAP') {
                //                $scope.isCreatingPause = false;
                $scope.mapState = MAP_STATE.CREATING;
                $scope.tutScreens = oobe456;
            } else if (mode === 'STOP') {
                $scope.mapState = MAP_STATE.CREATING_PAUSE;
                $scope.tutScreens = oobe456;
                //                $scope.isCreatingPause = true;
            } else {
                $scope.tutScreens = null;
            }
        }
    }

    function initDataForMapDrwaing(mapIndex) {
        if (!$scope.Device.Movement.Map || !$scope.Device.Movement.Map.length) // if no map data, no need to init data
            return;
        calcMaxDim(mapIndex);
        $scope.mapListWidth = (($scope.Device.Movement.Map.length + 1) * 448) / 80 + "rem"; // Total no of map + unit box lenght(404) + margin left(44) + margin Right(44) + one for create map button
        $scope.masterMapViewBox = "0 0 " + maxWidthX + " " + maxHeightY;
        //$scope.currentMapViewBox = $scope.masterMapViewBox;
        $scope.currentMapViewBox = "0 0 " +Math.floor($scope.Device.Movement.Map[mapIndex].maxWidthX)  + " " +  Math.floor($scope.Device.Movement.Map[mapIndex].maxHeightY);        
        $scope.masterMapIconDim = 128 * 404 / $scope.deviceWidth;
    }
    //qqq
    $scope.getSmallMapViewBox = function(mapIndex) {
        var maxX = $scope.Device.Movement.Map[mapIndex].maxWidthX  ;//*   $scope.deviceWidth*(8.0/9.0))   ;
        var maxY = $scope.Device.Movement.Map[mapIndex].maxHeightY ;//*  $scope.deviceWidth*(8.0/9.0));

        return "0 0 " + maxX + " " + maxY;
    };
    //var isFirstManualPopup = true;
    function MovementChangeRVC(movement) {
        var RVCpayload = '';
        if ($scope.remoteLocked) // if remote locked, dont do anything
            return;
        
       // $scope.dontShowButtonClicked = false;
        debugMessage("MovementChangeRVC" + movement);
        if (!!!$scope.dontShowButtonClicked && $scope.isFirstManualPopup ) {
            showManualCleaningPopUp();
            $scope.isFirstManualPopup = false;
            return;
        }

        $scope.DeviceOptions.selectedArrow = movement;
        switch (movement) {
            case 'LEFT':
                RVCpayload = "Left";
                break;
            case 'RIGHT':
                RVCpayload = "Right";
                break;
            case 'TOP':
                RVCpayload = "Forward";
                break;
            default:
                $scope.DeviceOptions.selectedArrow = '';
                break;
        }

        if (RVCpayload.length) {
            RVCpayload = '{"Movement": {"behavior": "' + RVCpayload + '"}}';
        }
        debugMessage('movement payload = ' + RVCpayload);

        //Lokesh 04Nov15_0333 -> Send indefinite command to move until ng-touchend received. 
        //ng-touchend may not work on iPhone. Need to look for a solution when iphone is supported.
        //Android gives ng-touchend when touch is moved instead of ng-touchmove. So, android should not be a problem.
        sendSHPCommand(RVCCONST.PUT, RVCpayload, "/" + $scope.peerId + "/devices/0/movement", undefined, false); //send first command immediately.
        //
        ////Lokesh 07Nov15_2145 -> As per Mr. Chang and Mr. Um, now on single press, we should send single command. Hence, committing interval set.
        //        promise = $interval(function () {
        //            sendSHPCommand(RVCCONST.PUT, RVCpayload, "/" + $scope.peerId + "/devices/0/movement", undefined, false);
        //        }, 1000);

        $scope.loadingBar = false; //We don't need loading bar here.


        document.addEventListener("touchcancel", touchCancelEvent);
    }

    function touchCancelEvent(e) {
        //Lokesh 07Nov15_2148 -> As per Mr. Chang and Mr. Um, we should send only 1 manual command on single press.
        stopLongPressEvent();
        startProgress('STOP', false);

        document.removeEventListener("touchcancel", touchCancelEvent)
    }

    function MapActionRVC(mapAction) {
        var RVCpayload = '',
            roomCount,
            mapName;
        switch (mapAction) {
            case 'START':
                roomCount = $scope.selectedRoomList.length;
                mapName = $scope.Device.Movement.Map[$scope.masterMapIndex].mapId;

                var roomDataArray = "";
                for (var i = 0; i < roomCount; i++) {
                    roomDataArray += '{"roomData" : "' + $scope.selectedRoomList[i] + ' ' + 1 + ' ' + 0 + '"},';
                }
                roomDataArray = roomDataArray.substr(0, roomDataArray.length - 1); //Remove last ',' character.
                RVCpayload = '{"data": {"mapId": "' + mapName + '","cleaningArea":"' + $scope.Device.Movement.MapDetailData["cleaningArea"] + '\" ,"cleanCommandCount" :  "' + roomCount + '", "roomDataArray" :[ ' + roomDataArray + '] }}';

                sendSHPCommand(RVCCONST.PUT, RVCpayload, "/" + $scope.peerId + "/devices/0/map/cleaning", RVCCONST.MAP);

                $scope.isAutoCleaning = true;
                break;

            case 'STOP':
                ModeChangeRVC('STOP');
                $scope.isAutoCleaning = false;
                break;

            case 'CHANGE_MASTER_MAP':
                mapName = $scope.Device.Movement.Map[$scope.masterMapIndex].mapId;
                RVCpayload = '{"data": {"mapId": "' + mapName + '", "masterMapLocation" : " ' + $scope.Device.Movement.MapDetailData["masterMapLocation"] + '\"}}';

                sendSHPCommand(RVCCONST.PUT, RVCpayload, "/" + $scope.peerId + "/devices/0/map/mastermap", RVCCONST.MAP);
                break;
			case 'MPAUSE':
				//ModeChangeRVC('MAP_PAUSE', false);
				ModeChangeRVC('STOP');
				break;
			case 'MRESUME':
				//ModeChangeRVC('MAP_CLEANING', false);
				ModeChangeRVC('MAP_RESUME');
				break;
            default:
                break;
        }
        debugMessage('Map Action payload = ' + RVCpayload);
    }

    function showToast(toastObj) {
        $timeout(function() {
            toaster.success(toastObj);
        }, 500);
    }

    function showToast(toastObj, delay) {
        $timeout(function() {
            toaster.success(toastObj);
        }, delay);
    }

    function getMapActionBtnText() {
        var text;
        
        if ($scope.DeviceOptions.controls.mapActionBtnText == "PAUSE") {
        	text = $scope.translation.VCMOB_status_pause;
        }else if ($scope.DeviceOptions.controls.mapActionBtnText == "RESUME")   {
        	text = 	 $scope.translation.WEBMOB_device_rvc_status_resume
        }else {
           text = $scope.translation.WEBMOB_device_rvc_map_start_button;
        }
        return text;
    }

    function toggleRoomCleaning() {
        if ($scope.DeviceOptions.cleaning_type !== CLEANING_STATE.CHARGING && $scope.DeviceOptions.cleaning_type !== CLEANING_STATE.MAP) { //If not charging or not cleaning map, Show room cleaning guide popup
            showRoomCleaningGuidePopup();
            return;
        }
        //ksum160413
        if ($scope.DeviceOptions.cleaning_type === CLEANING_STATE.CHARGING) { // if charging, start cleaning 
            if (!$scope.selectedRoomList.length) { // if no room selected, show toast
                showToast({
                    title: "",
                    //body: STRINGTOBEREPLACED.SELECT_ROOM
                    body: $scope.translation.WEBMOB_device_rvc_map_select_room
                }, 10);
                return;
            }
            MapActionRVC('START');
            selectedRoomsForCleaning = $scope.selectedRoomList;
            $scope.selectedRoomList = [];
            selectedRoomNameIndex = -1;
           
        }
        /* else if($scope.DeviceOptions.cleaning_type === CLEANING_STATE.IDLE) { // Show room cleaning guide popup
                       showRoomCleaningGuidePopup();
                 } */
        else if ($scope.DeviceOptions.cleaning_type === CLEANING_STATE.MAP) {
            // Show stop button
            
            if (mapCleanRoomState==MAP_CLEANING_STATE.CLEANING || mapCleanRoomState==MAP_CLEANING_STATE.MOVING )
            {
            	//ModeChangeRVC('MAP_CLEANING', false);
            	MapActionRVC('MPAUSE');
            }
            else if (mapCleanRoomState== MAP_CLEANING_STATE.PAUSE)
            {
            	MapActionRVC('MRESUME');
            }
            //MapActionRVC('STOP');
        }
    }

    function ConfigurationTime() {
        var d = new Date();
        var _month = appendZero(d.getMonth() + 1);
        var _date = appendZero(d.getDate());
        var _hours = appendZero(d.getHours());
        var _minutes = appendZero(d.getMinutes());
        var _seconds = appendZero(d.getSeconds());

        var cur_time = d.getFullYear() + '-' + _month + '-' + _date + 'T' + _hours + ':' + _minutes + ':' + _seconds;

        var RVCpayload = '{"Time": {"currentTime": "' + cur_time + '"}}';
        debugMessage('configuration time payload = ' + RVCpayload);
//        sendSHPCommand(RVCCONST.PUT, RVCpayload, "/" + $scope.peerId + "/devices/0/configuration/time/0", RVCCONST.SET_TIME);
        sendSHPCommand(RVCCONST.PUT, RVCpayload, "/" + $scope.peerId + "/devices/"+$scope.Device.id+"/configuration/time", RVCCONST.SET_TIME);
    }

    //Change Screen Animatedly.
    function changeAnimScreen(screenName, mustCond) {
        changeScreen(SCREEN[screenName] || screenName);
    }

    function startProgress(status, showLoadingBar) {
        if ($scope.remoteLocked) // if remote locked, dont do anything
            return;

        $scope.DeviceOptions.selectedArrow = '';

        debugMessage("startProgress " + status);
        ModeChangeRVC(status, showLoadingBar);
    }

    function touchStart(status) {
        touchStartTime = new Date().getTime();
        //Flag for checking the state before starting mannual cleaning
        if($scope.DeviceOptions.cleaning_type === CLEANING_STATE.CHARGING)
            mannualCtrChargingFlag = true;
        else
            mannualCtrChargingFlag = false;
        
        MovementChangeRVC(status);
    }

    function touchEnd() {
        console.log("touchEnd");
        
        if (!!!$scope.dontShowButtonClicked && $scope.isFirstManualPopup ) {
            return;
        }
        
        if(mannualCtrChargingFlag) {  // if Device was in charging state, then during first mannual button press, dont send stop command and let first mannual command execute     
            $scope.DeviceOptions.selectedArrow = '';
            return;
        }
        
        touchEndTime = new Date().getTime();
        stopMannaulCtr();
        $scope.DeviceOptions.selectedArrow = ' ';
    }


    function stopMannaulCtr() {
    	//qqq
        if ($scope.remoteLocked ||  !$scope.powerState) // if remote locked, dont do anything
        {
        	$scope.DeviceOptions.selectedArrow = '';
        	return;
        }

        $scope.DeviceOptions.selectedArrow = '';
        var timeout;

        if (touchEndTime - touchStartTime >= 500) {
            timeout = 500;
        } else {
            timeout = 100;
        }

        $timeout(function() {
            if (touchStartTime >= touchEndTime) // if new event started before sending STOP, return
                return;
            ModeChangeRVC('STOP', false);
        }, timeout);
    }

    function scheduleList(scheduleType, needToCurrentTime) {
        
    	switch(scheduleType)
    	{
    	case "OLD":
    		$scope.selectedScheduleType = RVCSCHEDULE.A;
    		break;
    	case "NEW":
    		$scope.selectedScheduleType = RVCSCHEDULE.B;
    		break;
    	}
        	
        //set Current Configuration time while opening the schedule
        if (needToCurrentTime) {
            ConfigurationTime();
        } 
        isGetActionByMyself = true;
        if ($scope.selectedScheduleType == RVCSCHEDULE.A && scheduleType !== "OLD" && scheduleType !== "NEW") {//reload
            //reloading data needs some time to process a request (100ms) in old-schedule 
            setTimeout(function () {
                //ksum160224
            	
            	sendSHPCommand(RVCCONST.GET, "/" + $scope.peerId + "/actions", "", RVCCONST.GET_ACTIONS);
                //changeAnimScreen(SCREEN.SCHEDULELIST);
            }, 200);

        } else {
            sendSHPCommand(RVCCONST.GET, "/" + $scope.peerId + "/actions", "", RVCCONST.GET_ACTIONS);
            //changeAnimScreen(SCREEN.SCHEDULELIST);                	
        }
        	
        	
        
    }

    function historyList() {
        //var requestArgu = '{ "deviceUuid": "'+$scope.deviceUuid+'", "historyLocation":"'+$scope.historyLocation+'" }';
        //nativeInterface.runOnNative("getHistoryData",requestArgu );
        $scope.loadingBar = true;
        $scope.checkResponse.push(RVCCONST.HISTORY_REQUEST);
        nativeInterface.getResourceUrl("/" + $scope.peerId + $scope.historyLocation);

    }
    $scope.showDailyData = function() {
        EnergyService.showDailyData($scope);
    };

    $scope.showWeeklyData = function() {
        EnergyService.showWeeklyData($scope);
    };

    $scope.showMonthlyData = function() {
        EnergyService.showMonthlyData($scope);
    };

    $scope.showNextDaysData = function() {
        EnergyService.showNextDaysData($scope);
    };

    $scope.showPreviousDaysData = function() {
        EnergyService.showPreviousDaysData($scope);
    };

    function parseEnergyUsageData(energyResponse) {
    	
        EnergyService.parseEnergyUsageData($scope, energyResponse);
        
    };

    function goToEnergyMonitor() {
        if (!isDBDownloadedJS || $scope.isStatic)
            return;
        changeAnimScreen(SCREEN.ENERGY);
        EnergyService.goToEnergyMonitor($scope);
        
    }

    function onBackPressed() {
        if($scope.countrySelectionPopupVisible) {
            $scope.countrySelectionPopupVisible = false;
            return;
        }
        
        if ($scope.showSuctionPowerPopup) {
            $scope.showSuctionPowerPopup = false;
            return;
        }
        if ($scope.showVoiceControlPopup) {
            $scope.showVoiceControlPopup = false;
            return;
        }

        if ($scope.showRenameRoomPopup) {
            $scope.showRenameRoomPopup = false;
            return;
        }

        if ($scope.deleteSchedulePopup) {
            $scope.deleteSchedulePopup = false;
            return;
        }

        if ($scope.isPopup) {
            $scope.isPopup = false; //Disable only popup on back pressed. Don't change screen state.
            return;
        }

        if ($scope.popUpVisible) {
            $scope.popUpVisible = false;
            return;
        }

        if ($scope.dialogPopup.show === true) {
            $scope.dialogPopup.show = false;
            return;
        }

        switch (currentScreen) {
            case SCREEN.SCHEDULELIST:
            case SCREEN.SETTINGOPTION:
            case SCREEN.ABOUT:
            case SCREEN.SETTINGS:
            case SCREEN.HISTORY:
            case SCREEN.ENERGY:
                changeScreen(SCREEN.HOME);
                break;

            case SCREEN.RENAME:
                $scope.renameRoomList = {};  // Clear the temp renamed room List
                changeScreen(SCREEN.HOME);
                break;
            case SCREEN.CHANGEMAP:
                initDataForMapDrwaing($scope.masterMapIndex);
                changeScreen(SCREEN.HOME);
                break;
            case SCREEN.ADDSCHEDULE:
                /*
            	if($scope.Actions_new.length === 0) {
                  changeScreen(SCREEN.HOME);   
                } else { 
                     changeScreen(SCREEN.SCHEDULELIST);
                }
                
                */
                changeScreen(SCREEN.SCHEDULELIST);
               
                break;
            case SCREEN.TUTORIALPAGE:  
                changeScreen(SCREEN.ABOUT);
                break;
            case SCREEN.DETAILEDTUTORIALPAGE:    
                changeScreen(SCREEN.TUTORIALPAGE);
                break;
            case SCREEN.INTRO:
            case SCREEN.CREATING_MAP:
                hideIntroScreen();
                if ($scope.Device.Movement.Map && $scope.Device.Movement.Map.length > 0) {
                    $scope.showController = true;
                } else {
                    $scope.showController = false;
                }
                changeScreen(SCREEN.HOME);
                break;

            default:
                closeApp(); //Close Application.
                break;
        }
    }

    $scope.openPopovermode = function() {
        setTimeout(function($event) {
            if ($scope.disableContents) {
                return;
            }
            $scope.popovermode.show($event);
        }, 500);
    };

    function openPopoverTemp() {
        if (!$scope.DeviceOptions.controls.suction) {
            return;
        }
        $scope.showSuctionPowerPopup = true;
        toggleBottomPopUpClass($scope.showSuctionPowerPopup);
    }

    function getCurrentSelectedRoomName() {
        if (currentSelectedRoom === -1)
            return;

        return $scope.Device.Movement.Map[$scope.masterMapIndex].room[currentSelectedRoom].roomIndex;
    }

    function closeSuctionPowerPopup() {
        $scope.showSuctionPowerPopup = false;
        toggleBottomPopUpClass($scope.showSuctionPowerPopup);
    }

    function openPopoverTempSetting() {
        $timeout(function() {
            $scope.showVoiceControlPopup = true;
            toggleBottomPopUpClass($scope.showVoiceControlPopup);
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }

    function setSuctionPower(selectedItem) {
        $scope.showSuctionPowerPopup = false;
        toggleBottomPopUpClass($scope.showSuctionPowerPopup);
        if ($scope.DeviceOptions.selectedMode.modeName === selectedItem.modeName) {
            return;
        }
        ModeChangeRVC(selectedItem.id);
        $scope.DeviceOptions.selectedMode = selectedItem;
    }

    function changeVoiceControl(selectedItem) {
        $scope.showVoiceControlPopup = false;
        toggleBottomPopUpClass($scope.showVoiceControlPopup);
        //if device is remote locked, close the popup and show controller screen
        if ($scope.remoteLocked) {
            showHomeScreen(false);
            return;
        }

        if ($scope.DeviceOptions.selectedVoice === selectedItem.modeName) {
            return;
        }
        ModeChangeRVC(selectedItem.id);
        $scope.DeviceOptions.selectedVoice = selectedItem.modeName;
    }
    
   function  increaseHrContinuously () {
        if (!!!promise) {
        	document.addEventListener("touchcancel", touchCancelEvent);
            promise = $interval(function () {
            	$scope.increaseHours();
            }, 200);
        }
    };
    
    function decreaseHrContinuously () {
        if (!!!promise) {
        	document.addEventListener("touchcancel", touchCancelEvent);
            promise = $interval(function () {
            	$scope.decreaseHours();
            }, 200);
        }
    };
    
    function increaseMinContinuously () {
        if (!!!promise) {
        	document.addEventListener("touchcancel", touchCancelEvent);
            promise = $interval(function () {
            	$scope.increaseMinutes();
            }, 200);
        }
    };
    
    function decreaseMinContinuously () {
        if (!!!promise) {
        	document.addEventListener("touchcancel", touchCancelEvent);
            promise = $interval(function () {
            	$scope.decreaseMinutes();
            }, 200);
        }
    };
    
    function increaseHours() {
    	ScheduleService.increaseHours($scope);
    }

    function decreaseHours() {
    	 ScheduleService.decreaseHours($scope);
    }

    function onAsRepeatWeakly() {
        ScheduleService.onAsRepeatWeakly($scope);
    }

    function increaseMinutes() {
    	 ScheduleService.increaseMinutes($scope);
    }

    function decreaseMinutes() {
    	 ScheduleService.decreaseMinutes($scope);
    }

    function changeMeridian() {
        ScheduleService.changeMeridian($scope);
    }

    function daySelected(dayValue) {
        ScheduleService.daySelected($scope, dayValue);
    }

    function dayColorSelected(dayValue) {
        return ScheduleService.dayColorSelected($scope, dayValue);
    }

    function removeItemFromSchedule(act) {
        scheduleRemoved = true;
        $scope.selectedSchedule.id = act.id;
        ScheduleService.saveScheduleRVC($scope, true);
    }

    function turnOnOffSchedule(act) {
        if (act.enabled) {
            debugMessage("turnOnOffSchedule  enabled");
            $scope.deleteSchedulePopup = true;
            toggleBottomPopUpClass($scope.dialogPopup.show);
            $scope.dialogPopup.dialogPopupTitle = $scope.translation.WEBMOB_common_delete_confirm;
            $scope.dialogPopup.dialogPopupText = $scope.translation.WEBMOB_common_delete_confirm_msg;
            $scope.dialogPopup.button1Title = $scope.translation.WEBMOB_common_cancel_capital;
            $scope.dialogPopup.button2Enabled = true;
            $scope.dialogPopup.button2Title = $scope.translation.WEBMOB_common_delete;
            $scope.dialogPopup.extraData = act;
        } else {
            $scope.addSchedule(act);
        }
    }

    function deletSchedulePopupCancelHandler() {
        debugMessage("Detet popup canel called");
        $scope.deleteSchedulePopup = false;
        toggleBottomPopUpClass(false);
    }

    function deletScheduleOkHandler(act) {
        $scope.deleteSchedulePopup = false;
        toggleBottomPopUpClass(false);
        deleteSchedule(act);
    }

    function gotoAddSchedule() {
		changeAnimScreen(SCREEN.ADDSCHEDULE);
    }

    function deleteSchedule(act) {
        debugMessage(act);    
        
        if (act.id ==1 )
        {
        	var p = "{\"Action\": {\"Actuators\": [{ \"Mode\": {\"modes\": [\"Cleaning_Auto\"]}, \"deviceIDs\": [\"0\"]}], \"disposable\": false, \"enabled\": false, \"repeatPeriod\": \"Daily\", \"startTime\": \"2016-02-29T13:58:06\" }}";
            sendSHPCommand('PUT', p, "/" + $scope.peerId + "/actions/0");
        }
        else if( act.id ==0) 
        {
			var dis= act.disposable;
			
			if (dis)
			{
				var p = "{\"Action\": {\"Actuators\": [{ \"Mode\": {\"modes\": [\"Cleaning_Auto\"]}, \"deviceIDs\": [\"0\"]}], \"disposable\": true, \"enabled\": false, \"repeatPeriod\": \"Daily\", \"startTime\": \"2016-02-29T13:58:06\" }}";
				sendSHPCommand('PUT', p, "/" + $scope.peerId + "/actions/0");
			}
			else
			{
				var p = "{\"Action\": {\"Actuators\": [{ \"Mode\": {\"modes\": [\"Cleaning_Auto\"]}, \"deviceIDs\": [\"0\"]}], \"disposable\": false, \"enabled\": false, \"repeatPeriod\": \"Daily\", \"startTime\": \"2016-02-29T13:58:06\" }}";
				sendSHPCommand('PUT', p, "/" + $scope.peerId + "/actions/0");
			}
			
        }
        else 
        {
        	sendSHPCommand('DELETE', "/" + $scope.peerId + "/actions/" + act.id);
        }
//      if ($scope.selectedScheduleType === RVCSCHEDULE.A)
        act.timeConvention = "AM";
    }
    
    function addSchedule(act) {
    	debugMessage(act);
    	
        if ($scope.selectedScheduleType === RVCSCHEDULE.B) {
        	$scope.Actions = $scope.Actions_new;
            ScheduleService.addSchedule($scope, act);
        } else if ($scope.selectedScheduleType === RVCSCHEDULE.A) {
        	$scope.Actions = $scope.Actions_old;
            ScheduleService.addScheduleRVC($scope, act);
        }
        delete $scope.Actions;
        
        $timeout(function() {
                 var d =  document.getElementById("new_add_schedule");
                 d.style.visibility = "hidden";
                 d.style.width = "10%";
                 d.style.width = "100%";;
                 d.style.visibility = "visible";
               }
         , 100);
        
    }

    function saveSchedule() {
        if ($scope.selectedScheduleType === RVCSCHEDULE.B) {
        	$scope.Actions = $scope.Actions_new;
            ScheduleService.saveScheduleRVC($scope, false);
        } else if ($scope.selectedScheduleType === RVCSCHEDULE.A) {
        	$scope.Actions = $scope.Actions_old;
            saveScheduleOld();
        }
        //ksum160222
        changeAnimScreen(SCREEN.SCHEDULELIST);        
        delete $scope.Actions;
    }

    function saveScheduleOld() {
        debugMessage("saveScheduleOld");
        var payload,
            d,
            startTime;

        if (parseInt($scope.selectedSchedule.hours) === NaN || parseInt($scope.selectedSchedule.minutes) === NaN) { //check against Nan to avoid '0' number error.
            showToast({
                title: "",
                body: $scope.translation.WEBMOB_common_schedule_inform_time
            });
            return;
        }

        d = new Date();

        if ($scope.selectedSchedule.amPm === 'PM' && $scope.selectedSchedule.hours !== 12) {
            d.setHours(parseInt($scope.selectedSchedule.hours) + 12);
        } else if ($scope.selectedSchedule.hours === 12 && $scope.selectedSchedule.amPm === 'AM') {
            d.setHours(0);
        } else {
            d.setHours(parseInt($scope.selectedSchedule.hours));
        }
        d.setMinutes(parseInt($scope.selectedSchedule.minutes));

        startTime = d.getFullYear() + '-' + appendZero(d.getMonth() + 1) + '-' + appendZero(d.getDate()) + 'T' + appendZero(d.getHours()) + ':' + appendZero(d.getMinutes()) + ':' + appendZero(d.getSeconds());
        payload = '{"Action": {"Actuators": [{ "Mode": {"modes": ["Cleaning_Auto"]}, "deviceIDs": ["0"]}], "disposable": ' + $scope.selectedSchedule.disposable + ', "enabled": true, "repeatPeriod": "Daily", "startTime": "' + startTime + '" }}';
        debugMessage(payload);

        $scope.checkResponse.push("UPDATE_SCHEDULE");
        sendSHPCommand('PUT', payload, "/" + $scope.peerId + "/actions/0");
    }

    function onHoursLostFocus() {
        if (window.navigator.platform === 'iPhone' || window.navigator.platform === 'iPad') {
               setTimeout(function(){
                   window.scrollTo(0, 0);
               }, 10);
        }
        ScheduleService.onHoursLostFocus($scope);
    }

    function onMinsLostFocus() {
         if (window.navigator.platform === 'iPhone' || window.navigator.platform === 'iPad') {
               setTimeout(function(){
                   window.scrollTo(0, 0);
               }, 10);
        }
        ScheduleService.onMinsLostFocus($scope);
    }

    function onHoursMinsFocusGain() {
        ScheduleService.onHoursMinsFocusGain($scope);
    }

    function asTabSelected(bool) {
        ScheduleService.asTabSelected($scope, bool);
    }

    function stopLongPressEvent() {
        //Lokesh 04Nov15_0603 -> Release the button.
        $scope.DeviceOptions.selectedArrow = '';
        if (!!promise) {
            //check if promise exist. Then call cancel.
            $interval.cancel(promise);
            promise = undefined;
        }
        if ($scope.longPress) {
            $scope.longPress = false;
            clearInterval($scope.timer);
            return;
        }
        document.removeEventListener("touchcancel", touchCancelEvent);
    }

    function getBatteryClass() {
        var svg = document.getElementById('batterySVG');
        temp = 'images/rvc/main_list_ic_battery_0' + (BATTERY_IMG[$scope.Device.EnergyConsumption.batteryCharge] || BATTERY_IMG[100]) + ".svg#Layer_1";
        SHPService.loadSVG(temp, svg);
        
        var svg1 = document.getElementById('batterySVG1');
        temp = 'images/rvc/main_list_ic_battery_0' + (BATTERY_IMG[$scope.Device.EnergyConsumption.batteryCharge] || BATTERY_IMG[100]) + ".svg#Layer_1";
        SHPService.loadSVG(temp, svg1);
    }

    function requestFailHandler(response) {
        if (angular.isDefined(response["resourceURL"]) && response["resourceURL"].indexOf("/actions") !== -1 && response["resourceURL"].indexOf("/actions/") === -1) {
            showToast({
                title: "",
                //body: $scope.translation.WEBMOB_common_schedule_duplication
                body: $scope.translation.WEBMOB_common_schedule_save_failed
            });
            $timeout(function() {
                toaster.clear();
            }, 2500);

            scheduleList();
        } else if (angular.isDefined(response["resourceURL"]) && response["resourceURL"].indexOf("/actions/") !== -1) {
            var msg;
            if (response.data.message === 'InvokeDelScheduleFunc') {
                msg = $scope.translation.WEBMOB_common_schedule_delele_fail_reservation;
            } else if (response.data.message === 'InvokeSetScheduleFunc') {
                msg = $scope.translation.WEBMOB_common_schedule_duplicate;
            } else { //Fixing Sonar issue
                $scope.showConnectionFailurePopup();
            }

            showToast({
                title: "",
                body: msg
            });
            scheduleList();
        } else if (angular.isDefined(response["resourceURL"]) && response["resourceURL"].indexOf($scope.historyLocation) !== -1) {
            //occur history request error
            dismissLoadingBar(RVCCONST.HISTORY_REQUEST);
        } else if (angular.isDefined(response["isSuccess"])) {
            //                isMapDataAvailable()
            $scope.isMapDownloaded = true; // map data request complete
            requestEnergyData(); //This function should be called after map request complete.
            
        } else { //Fixing Sonar issue
            //Null
        }
    }

    $scope.stopEvent = function(event) {

        event.preventDefault();
    };
    var selectedRoomNameIndex = -1;
    function onRoomNameClicked(roomIndex) {
    	onRoomClicked(roomIndex);
    	selectedRoomNameIndex = roomIndex;
    }
    
    function isSelectedRoomName(roomIndex)
    {
    	return roomIndex == selectedRoomNameIndex;
    }

    function onRoomClicked(roomIndex) {
        debugMessage("onRoomClicked index:" + roomIndex);
        selectedRoomNameIndex = -1;
        
        if($scope.DeviceOptions.controls.selectingRoom == "disable") {
        	return;
        } else if ($scope.DeviceOptions.controls.selectingRoom == "popup") { // If RVC is cleaning, dont let user select a room
            showRoomCleaningGuidePopup();
            return;
        } else if ($scope.DeviceOptions.controls.selectingRoom == "popup_after") 
        {
        	showRoomCleaningGuidePopupForAfter();
            return;
        }
        else if ($scope.DeviceOptions.controls.selectingRoom == "popup_reserve")
        {
        	showRoomCleaningGuidePopupForReserve();
            return;
        }

        if (checkForRoomSelection(roomIndex)) {
            $scope.selectedRoomList.splice($scope.selectedRoomList.indexOf(roomIndex), 1);
        } else {
            $scope.selectedRoomList.push(roomIndex); // Select room
            selectedRoomNameIndex = roomIndex;
        }
    }

    function checkForRoomSelection(roomIndex) {
        return ($scope.selectedRoomList.indexOf(roomIndex) !== -1);
    }

    function onMapClicked(mapIndex) {
        debugMessage("onMapClicked index:" + mapIndex);
        document.getElementById("change_rvc_map").style.visibility = "hidden";
        //document.getElementById("change_rvc_map").style.width = 0;
        
        if ($scope.currentSelectedMap !== mapIndex) {
            $scope.currentSelectedMap = mapIndex;
            calcMaxDim(mapIndex);
            //$scope.currentMapViewBox = "0 0 " + maxWidthX + " " + maxHeightY;
            $scope.currentMapViewBox = "0 0 " +Math.floor($scope.Device.Movement.Map[mapIndex].maxWidthX)  + " " +  Math.floor($scope.Device.Movement.Map[mapIndex].maxHeightY);
        }
        if ($scope.Device.Movement.Map[$scope.masterMapIndex].mapId !== $scope.Device.Movement.Map[$scope.currentSelectedMap].mapId) {
        	$scope.mapSelectable = true;
        	if($scope.Device.Movement.Map[$scope.currentSelectedMap].errMap == true){
            	$scope.mapSelectable = false;
            }
        }else
        	$scope.mapSelectable = false;
        
        
        $timeout(function() { 
        	//document.getElementById("change_rvc_map").style.width = "17.0rem";
        	document.getElementById("change_rvc_map").style.visibility = "visible";
        	}
        , 100);
        
       
    }


    function onClickChangeMapBottomBtn(button) {
        if (button === 'SAVE') {
            if ($scope.remoteLocked || !$scope.powerState) {
                showHomeScreen(true);
            }

            //                if ($scope.masterMapIndex === $scope.currentSelectedMap)
            //                    return;

            if ($scope.Device.Movement.Map[$scope.masterMapIndex].mapId === $scope.Device.Movement.Map[$scope.currentSelectedMap].mapId) {
                showHomeScreen(true);
                return;
            }
            if ($scope.DeviceOptions.cleaning_type === CLEANING_STATE.CHARGING) {
                prevMasterMapId = $scope.Device.Movement.Map[$scope.masterMapIndex].mapId;
                reArrangeMap($scope.currentSelectedMap);
                changeMasterMap();
                changeScreen(SCREEN.HOME);
            } else {
                showChangeMapErrPopup();
            }
        } else if (button === 'CANCEL') {
            $scope.currentSelectedMap = $scope.masterMapIndex;
            initDataForMapDrwaing($scope.masterMapIndex);
            changeScreen(SCREEN.HOME);
        }
    }

    function reArrangeMap(newIdx) {
        var mapData = $scope.Device.Movement.Map;
        var temp = mapData[newIdx];
        mapData[0] = temp;
        $scope.masterMapIndex = 0;
        $scope.currentSelectedMap = $scope.masterMapIndex;
    }

    function changeMasterMap() {
        $scope.selectedRoomList = []; // reset selected room list
        MapActionRVC('CHANGE_MASTER_MAP');
        selectedRoomNameIndex = -1;
    }

    function getRoomBoundryColor(roomIndex) {
        debugMessage("getRoomBoundryColor index:" + roomIndex);
        return checkForRoomSelection(roomIndex) ? 'rgba(0,198,255,0.3)' : 'rgb(145,134,111)';
    }
    function getRoomBoundrySize(roomIndex,size) {
        var rst = 0;
        
        if ( checkForRoomSelection (roomIndex) )
        	rst = getPxByPx(size, 1440);
        else
        	rst = 0;
    	debugMessage("getRoomBoundryColor :" + rst);
        return rst;
    }

    function getRoomBoundryWidth(roomIndex) {
        if(!roomIndex) {
            return checkForRoomSelection(roomIndex) ? (8 * maxWidthX / 1440) : (5 * maxWidthX / 1440);
        }
        
        return (5 * maxWidthX / 1440);
    }

    function prepareRoomPolygonData(roomIndex, mapIndex, isMasterMap) {
        var pointString = "",
            verticesList, j;
        verticesList = $scope.Device.Movement.Map[mapIndex].room[roomIndex].vertexPointList;

        for (j = 0; j < verticesList.length; j++) {
            pointString = pointString + verticesList[j].x + "," + verticesList[j].y + " ";
        }

        return pointString;
    }
    //ksum 160406
    function getOffsetPath(roomIndex, mapIndex) {
        
    	var scale = 1;
    	var pointString = "",
            verticesList, j;
        verticesList = $scope.Device.Movement.Map[mapIndex].room[roomIndex].vertexPointList;

        for (j = 0; j < verticesList.length; j++) {
            pointString = pointString + verticesList[j].x + "," + verticesList[j].y + " ";
        }
        var newPath = getPath(verticesList);
        ClipperLib.JS.ScaleUpPaths(newPath, scale);
      	var co = new ClipperLib.ClipperOffset(2, 0.25);
      	
      	co.AddPaths(newPath, ClipperLib.JoinType.jtRound, ClipperLib.EndType.etClosedPolygon);
      	var offsetted_paths = new ClipperLib.Paths();
      	co.Execute(offsetted_paths, -20 * scale);
      	
      	
        var rst = paths2string(offsetted_paths) ; 
        
        console.log(rst);
        
        
        //return pointString;
        //return newPath;
        return rst
        
    }
    
    function getPath(prePath)
    {
    	var rst = [[]];
    	
    	for (j = 0; j < prePath.length; j++) {
    		rst[0].push({X:prePath[j].x, Y :prePath[j].y});
        }
    	return rst;
    	
    }
    function paths2string (paths)
  	{
  		var svgpath = "", i, j;
  		
  		for(i = 0; i < paths.length; i++)
  		{
  			for(j = 0; j < paths[i].length; j++)
  			{
  				if (!j) svgpath += "M";
  				else svgpath += "L";
  				svgpath += (paths[i][j].X ) + ", " + (paths[i][j].Y );
  			}
  			svgpath += "Z";
  		}
  		if (svgpath=="") svgpath = "M0,0";
  		return svgpath;
  	}
    
    function getDoorImage(type) {
        return ((type > 0 && type < 7) ? "images/rvc/main_rv_door_" + type + ".png" : "");
    }

    function getDoorPos(point, doorType) {
        var p = point;
        if (doorType === 1 || doorType === 4 || doorType === 2 || doorType === 8) {
            p = point - doorHeight;
        }
        return p;
    }

    function getDoorDim(isWidth) {
        var dim;
        if (isWidth) {
            dim = RVCCONST.DOOR_WIDTH * maxWidthX / 1440;
            doorWidth = dim; // new calculated door width according to device screen width
        } else {
            dim = RVCCONST.DOOR_HEIGHT * maxHeightY / 1440;
            doorHeight = dim; // new calculated door height according to device screen height
        }
        return dim;
    }

    $scope.getChargerDim = function(isWidth) {
        var dim;
        /*
        if (isWidth) {
            dim = 140 * maxWidthX / 1440;
            chargerWidth = dim;
        } else {
            dim = 120 * maxHeightY / 1440;
            chagerHeight = dim;
        }
        return dim;
        */ 
        return (134.0/1440.0) * $scope.deviceWidth ;
    };

    function getChargerPos(point, isX) {
        var calPoint = point,
            dim;

        if (isX) {
            dim = RVCCONST.CHARGER_WIDTH * maxWidthX / 1440;
            calPoint = point - dim;
        } else {
            dim = RVCCONST.CHARGER_HEIGHT * maxHeightY / 1440;
            calPoint = point - dim / 2;
        }
        return calPoint;
    };

    function getRoomNamePos(point, isX) {
        var calPoint;
        if (!roomNameWidth || roomNameWidth === -1) {
            var item = document.getElementById("rname").getBBox();
            roomNameWidth = item.width * maxWidthX / 1440;
            roomNameHeight = item.height * maxHeightY / 1440;
        }
        if (isX) {
            calPoint = point;
        } else {
            calPoint = point;
        }
        return calPoint;
    };

    function getRoomStatus(roomIndex) {
        var cleaningStatusImg = "",
            statusList = $scope.Device.Movement.MapCleaningStatusData,
            idx;
        for (idx = 0; idx < statusList.length; idx++) {
        	var crIndex= statusList[idx].cleanRoomIndex+"";
        	var rIndex= roomIndex+"";
        	if (crIndex===rIndex) {
                var crStatus = parseInt(statusList[idx].cleanRoomStatus);
        		switch (crStatus) {
                    case 3: // STATUS_CLEANING
                        cleaningStatusImg = "images/rvc/main_rv_cleaning.png";
                        break;

                    case 4: // STATUS_CLEANED
                        cleaningStatusImg = "images/rvc/main_rv_clean_done.png";
                        break;

                    case 5: // STATUS_STOPPED
                    case 6: // STATUS_FAILED
                        cleaningStatusImg = "images/rvc/main_rv_noti.png";
                        break;

                    case 0: // STATUS_DEFAULT
                    case 1: // STATUS_SELECTED
                    case 2: // STATUS_MOVING
                    default:
                        break;
                }
            }
        }
        return cleaningStatusImg;
    }



    function getRoomNameBasedOnCleaningStatus() {
        var statusList = $scope.Device.Movement.MapCleaningStatusData;
        var roomIndex = statusList[0].cleanRoomIndex;
        var roomName = $scope.Device.Movement.Map[$scope.masterMapIndex].room[roomIndex].roomName;
        return roomName;
    }

    function getRoomBGColor(roomIndex) {
        var statusList = $scope.Device.Movement.MapCleaningStatusData,
            //colorBg = 'rgb(217,204,182)',
        	colorBg = 'rgb(238,231,219)',
            idx;
        var rIndex= roomIndex+""; 	
        if (rIndex ==="0") 
    		colorBg = 'rgb(217,204,182)';
    	else
    		colorBg = 'rgb(238,231,219)';
        
        /*
        for (idx = 0; idx < statusList.length; idx++) {
        	var crIndex= statusList[idx].cleanRoomIndex+"";
        	
        	if (crIndex===rIndex) {
                var crStatus = parseInt(statusList[idx].cleanRoomStatus);
        		switch (crStatus) {
                    case 0: // STATUS_DEFAULT
                        //colorBg = 'rgb(217,204,182)';
                    	if (rIndex ==="0") 
                    		colorBg = 'rgb(217,204,182)';
                    	else
                    		colorBg = 'rgb(238,231,219)';
                    	if (checkForRoomSelection(roomIndex))
                    		colorBg = 'rgba(0,198,255,0.3)';
                        break;
                    case 1: 
                    	//colorBg = 'rgb(0,198,255)';
                    	break;
                    case 2: // STATUS_MOVING
                    case 3: // STATUS_CLEANING
                        //colorBg = 'rgb(238,231,219)';
                    	if (rIndex ==="0") 
                    		colorBg = 'rgb(217,204,182)';
                    	else
                    		colorBg = 'rgb(238,231,219)';
                        break;
                    case 4: // STATUS_CLEANED
                        colorBg = 'rgb(255,255,255)';
                        break;
                }
                //return colorBg;
            }
        }
        if (checkForRoomSelection(roomIndex))
    		colorBg = 'rgba(0,198,255,0.3)';
    		*/
        return colorBg;
    }

    function getRoomStatusPosition(ptX, ptY, isX) {
        var calPoint = 0;;
        /*
        if (!roomStatusWidth) {
            var item = document.getElementById("notation").getBBox();
            roomStatusWidth = item.width; // *  maxWidthX / 1440;
            roomStatusHeight = item.height; // * maxHeightY / 1440;
        }
        */
        roomStatusWidth = getPxByPx(92,1440);
        roomStatusHeight = getPxByPx(92,1440);
        var tx= ptX; 
        var ty= ptY - getPxByPx(85,1440);
        
        tx = tx - ptX;
        ty = ty - ptY;
        var fx = Math.cos($scope.rotationDeg/180*Math.PI) * tx   +  Math.sin($scope.rotationDeg/180*Math.PI) * ty ; 
        var fy = -Math.sin($scope.rotationDeg/180*Math.PI) * tx   +  Math.cos($scope.rotationDeg/180*Math.PI) * ty ;
        fx = fx + ptX;
        fy = fy + ptY;
        
        fx = fx - roomStatusWidth / 2;
        fy = fy - roomStatusHeight / 2;
        
        if (isX) {
            calPoint =fx;
        } else {
        	calPoint =fy;
        }
        /*
        if (isX) {
            calPoint = point - roomStatusWidth / 2;
        } else {
            //calPoint = point - roomStatusHeight * 1.15;
        	calPoint = point - getPxByPx(110,1440);
        }
        */
        return calPoint;
    }

    
    function getRoomStatusNotationDim(isWidth) {
        /*
    	var dim;
        if (isWidth) {
            dim = RVCCONST.CHARGER_WIDTH * maxWidthX / 1440;
            chargerWidth = dim;
        } else {
            dim = RVCCONST.CHARGER_HEIGHT * maxHeightY / 1440;
            chagerHeight = dim;
        }
        return dim;
        */
    	return (82.0/1440.0) * $scope.deviceWidth ;
    }

    //Sorting map data in desc order (handle for iphone)
     function sortMapData(a, b) {
        if(a.mapName > b.mapName)
            return -1;
        
        if(a.mapName < b.mapName)
            return 1;
        
        return 0;
    }
    
    function debugMessage(message) {
        if (debugMode) {
            console.log(message);
        }
    }

    function showManualCleaningPopUp() {
        if (!!!$scope.dontShowButtonClicked) {
            showcustDialog($scope.translation.WEBMOB_device_rvc_status_manual_cleaning, $scope.translation.VC_mmsg_manualguide, $scope.translation.WEBMOB_common_ok);
        }
    }

    function showcustDialog(msgHeader, popuptext, txtButton1, txtButton2) {
        $scope.txtButton2Invisbile = !txtButton2;

        $scope.popUpVisible = true;

        document.getElementById("custpopupheadertext").innerHTML = msgHeader;
        document.getElementById("custpopuptext").innerHTML = popuptext;

        if (txtButton1 !== undefined) {
            document.getElementById("alertbutton1").innerHTML = txtButton1;
            document.getElementById("alertbutton1").style.visibility = "visible";
        } else {
            document.getElementById("alertbutton1").style.visibility = "hidden";
        }

        if (txtButton2 !== undefined) {
            document.getElementById("alertbutton2").innerHTML = txtButton2;
            document.getElementById("alertbutton2").style.visibility = "visible";
        } else {
            document.getElementById("alertbutton2").style.visibility = "hidden";
        }
    }

    function onDontShowAgainButtonClicked() {
        $scope.dontShowButtonClicked = !$scope.dontShowButtonClicked;
        setLocalStorageData(RVCLOCALSTORAGE.DONTSHOWAGAIN, $scope.dontShowButtonClicked);
    }
    function sortMapByMapId(mapdata)
    {
    	for ( i=1 ; i < mapdata.length ; i++ )
        {
        	for ( j=i ; j< mapdata.length ; j++ )
        	{
        		if (mapdata[i].mapId.localeCompare(mapdata[j].mapId)< 0){
        			var tmp = mapdata[i];
        			 mapdata[i] = mapdata[j];
        			 mapdata[j] = tmp;
        			
        		}
        	}
        }
    }

    $scope.versionTouchStart = function() {
        if (!promise) {
            promise = $timeout(function() {
                if (!$scope.isStatic) {
                    $scope.checkResponse.push(RVCCONST.PARSE_MODULEINFO);
                    sendSHPCommand(CONSTANTS.GET, "/" + $scope.peerId + "/devices/0/information");
                }
            }, 5000);
        }
    };

    $scope.versionTouchEnd = function() {
        if (promise) {
            $timeout.cancel(promise);
            promise = null;
        }
    };

    $scope.parseModuleInformation = function(moduleInfo) {
        if (angular.isDefined(moduleInfo.Versions) && moduleInfo.Versions.length > 0) {
            var software = '',
                firmware = '';
            for (var i = 0; i < moduleInfo.Versions.length; i++) {
                if (i === 0 || i === 1) {
                    software = software + moduleInfo.Versions[i].name.charAt(0) + "_" + moduleInfo.Versions[i].number + ", ";
                } else {
                    firmware = firmware + moduleInfo.Versions[i].name.charAt(0) + "_" + moduleInfo.Versions[i].number + ", ";
                }
            }
            $scope.moduleInfoText = "Software : " + software.slice(0, software.length - 2) + " <br><br> Firmware : " + firmware.slice(0, firmware.length - 2);
            dismissLoadingBar(RVCCONST.PARSE_MODULEINFO);
            document.getElementById("moduleInfoCancelID").style.visibility = 'hidden';
            $scope.showModuleInfoPopup = true;
            toggleBottomPopUpClass($scope.showModuleInfoPopup);
        }
    };

    $scope.moduleInfoOk = function() {
        $scope.showModuleInfoPopup = false;
        toggleBottomPopUpClass($scope.showModuleInfoPopup);
    };
    
    function moveToSchedule(scheduleType, needToCurrentTime)
    {
    	ScheduleService.isCallByMyselfOnScheduleList = true;
    	scheduleList(scheduleType, needToCurrentTime);
    	changeAnimScreen(SCREEN.SCHEDULELIST);
    };

    function getTimeWithAMPM(gmtString) {
        var firstSplit = gmtString.split("T");
        var hourMinSplit = firstSplit[1].split(":");
        var hour = parseInt(hourMinSplit[0], 10);
        var minute = parseInt(hourMinSplit[1], 10);

        var start_date = new Date();
        start_date.setHours(hour);
        start_date.setMinutes(minute);

        var amPm = 'AM';
        var newHour = start_date.getHours();
        if (newHour >= 12) {
            if (newHour > 12) {
                newHour = newHour - 12;
            }
            amPm = 'PM';
        } else if (newHour === 0) {
            newHour = 12; //0 is not hour in AM/PM scenario.
        }

        var newMinutes = start_date.getMinutes();
        newHour = newHour >= 10 ? newHour : '0' + newHour;
        newMinutes = newMinutes >= 10 ? newMinutes : '0' + newMinutes;
        return [newHour, newMinutes, amPm];

    }

    function moveMapToCenter(map)
    {
    	var halfMaxWidth = map.maxWidthX/2.0;    	
    	//var d= ($scope.deviceWidth/10.0)*9.0;
    	var d= getPxByPx(1160,1440);
    	var halfSvgWidth = d/2.0;
    	var offWidth = halfSvgWidth-halfMaxWidth+getPxByPx(20,1440);
    	var offHeight = getPxByPx(20,1440);
    	
    	map.maxWidthX = d;
    	map.maxHeightY = map.maxHeightY + offHeight;
    	map.chargerPoint.x = map.chargerPoint.x  + offWidth ; 
    	map.chargerPoint.y = map.chargerPoint.y + offHeight;;
    	
    	for (j=0 ; j< map.room.length;j++ )
    	{
    		var roo =  map.room[j];
    		for (k=0 ; k< roo.vertexPointList.length ; k++)
    		{
    			map.room[j].vertexPointList[k].x = map.room[j].vertexPointList[k].x + offWidth ;
    			map.room[j].vertexPointList[k].y = map.room[j].vertexPointList[k].y + offHeight ;
    		}
    		roo.doorStart.x = roo.doorStart.x+ offWidth ;    		
    		roo.doorEnd.x = roo.doorEnd.x + offWidth;    		
    		roo.notationStart.x = roo.notationStart.x + offWidth;    		
    		roo.notationEnd.x = roo.notationEnd.x + offWidth;
    		
    		roo.doorStart.y = roo.doorStart.y+ offHeight ;    		
    		roo.doorEnd.y = roo.doorEnd.y + offHeight;    		
    		roo.notationStart.y = roo.notationStart.y + offHeight;    		
    		roo.notationEnd.y = roo.notationEnd.y + offHeight;
    	}
    }
    
    function moveMapToCenterX(map)
    {
    	var halfMaxHeight = map.maxHeightY/2.0;    	
    	//var d= ($scope.deviceWidth/10.0)*9.0;
    	var d= getPxByPx(1160,1440);
    	var halfSvgHeight = d/2.0;
    	var offWidth =  getPxByPx(20,1440);
    	var offHeight = halfSvgHeight- halfMaxHeight + getPxByPx(20,1440);
    	
    	map.maxHeightY = d;
    	map.maxWidthX = map.maxWidthX + offWidth;
    	map.chargerPoint.x = map.chargerPoint.x  + offWidth ; 
    	map.chargerPoint.y = map.chargerPoint.y + offHeight;;
    	
    	for (j=0 ; j< map.room.length;j++ )
    	{
    		var roo =  map.room[j];
    		for (k=0 ; k< roo.vertexPointList.length ; k++)
    		{
    			map.room[j].vertexPointList[k].x = map.room[j].vertexPointList[k].x + offWidth ;
    			map.room[j].vertexPointList[k].y = map.room[j].vertexPointList[k].y + offHeight ;
    		}
    		roo.doorStart.x = roo.doorStart.x+ offWidth ;    		
    		roo.doorEnd.x = roo.doorEnd.x + offWidth;    		
    		roo.notationStart.x = roo.notationStart.x + offWidth;    		
    		roo.notationEnd.x = roo.notationEnd.x + offWidth;
    		
    		roo.doorStart.y = roo.doorStart.y+ offHeight ;    		
    		roo.doorEnd.y = roo.doorEnd.y + offHeight;    		
    		roo.notationStart.y = roo.notationStart.y + offHeight;    		
    		roo.notationEnd.y = roo.notationEnd.y + offHeight;
    	}
    }
    
    function getRemByPx(valPx, baseWidth)
    {
    	var rst = "0rem";
    	var v =getPxByPx(valPx, baseWidth );
    	rst = (v/80.0)+ "rem";
    	return rst;
    }
    function getPxByPx(valPx , baseWidth)
    {
    	var rst=0;    	
    	rst = valPx * ($scope.deviceWidth * 1.0);    	
    	rst = rst /(baseWidth * 1.0); 
    	return rst ;
    }
    function getLRPosition(xVal , offsetWidth)
    {
    	var rst = "";
    	var hWidth =$scope.deviceWidth/2.0; 
    	if (xVal < hWidth )
    	{
    		rst = "left : " + (xVal-offsetWidth);
    	}
    	else
    	{
    		//rst = "right : " +($scope.deviceWidth- (xVal+offsetWidth) - getPxByPx(20,1440));
    		rst = "right : " +(getPxByPx(300,360)- (xVal+offsetWidth) - getPxByPx(20,1440));
    	}
    	
    	
    	return rst;
    }
    function getLang()
    {
    	return LANG;
    }
    
 //Tutorial arrays
    $scope.arrHeader = [$scope.translation.WEBMOB_device_rvc_tutorial_c01_code_title, $scope.translation.WEBMOB_device_rvc_tutorial_c02_code_title, $scope.translation.WEBMOB_device_rvc_tutorial_c05_code_title, $scope.translation.WEBMOB_device_rvc_tutorial_c06_code_title, $scope.translation.WEBMOB_device_rvc_tutorial_c07_code_title];
    $scope.arrSubHeader = ["Robot Vacuum", "Robot Vacuum", "Robot Vacuum", "Robot Vacuum", "Robot Vacuum"];
    $scope.arrImages = ["robot_cleaner_01", "robot_cleaner_01", "robot_cleaner_01", "robot_cleaner_01", "robot_cleaner_01"];
    $scope.arrDesc = [$scope.translation.WEBMOB_device_rvc_tutorial_c01_code_description, $scope.translation.WEBMOB_device_rvc_tutorial_c02_code_description, $scope.translation.WEBMOB_device_rvc_tutorial_c05_code_description, $scope.translation.WEBMOB_device_rvc_tutorial_c06_code_description, $scope.translation.WEBMOB_device_rvc_tutorial_c07_code_description];
    $scope.errCode = [$scope.translation.WEBMOB_device_rvc_tutorial_c01_code, $scope.translation.WEBMOB_device_rvc_tutorial_c02_code, $scope.translation.WEBMOB_device_rvc_tutorial_c05_code, $scope.translation.WEBMOB_device_rvc_tutorial_c06_code, $scope.translation.WEBMOB_device_rvc_tutorial_c07_code];
    var arrVideos = ["C01erroroccurs", "C02orC03erroroccurs", "C05erroroccurs", "C06erroroccurs", "C07erroroccurs"];   
    var addIndex;
    //Tutorial code start     
    $scope.playVideo = function(ind){
        changeScreen(SCREEN.DETAILEDTUTORIALPAGE);
        addIndex = ind;
        $scope.tutVidIndex = ind;
        document.getElementById("vid").src = "https://s3.amazonaws.com/smartthingsda/solutionmodule/tutorial/"+arrVideos[addIndex]+".mp4";
    };    
    //Tutorial code end
    $scope.scheduleTypeFilter = function(type) {
    	return function(item) {
    		return type == item.Actuators[0].deviceIDs[0];
    	}
    }
    
    function prepareTimeStampArray() {
            $scope.mapDateTimeArr = [];
            for (i = 0; i < $scope.Device.Movement.Map.length; i++) {
                var m = $scope.Device.Movement.Map[i];
                for (var j = 0; j < m.room.length; j++) {
                    if (m.room[j].roomIndex === -1) {
                        m.errMap = true;
                        break;
                    }
                }
                if (m.dateTime !== undefined) {
                    var datetime = new Date(m.dateTime * 1000);
                    var YY = datetime.getFullYear();
                    var MM = datetime.getMonth() + 1;
                    var DD = datetime.getDate();
                    var mapDateTime = YY + "." + MM + "." + DD;
                    $scope.mapDateTimeArr.push(mapDateTime);
                }
            }
        }
        
    function prepareRoomCoord() {
            for (i = 0; i < $scope.Device.Movement.Map.length; i++) {
                    var m = $scope.Device.Movement.Map[i];
                    var maxLen = m.maxWidthX > m.maxHeightY ? m.maxWidthX : m.maxHeightY;
                    //var sVal = ($scope.deviceWidth * (8.0 / 9.3)) / (maxLen * 1.0);
                    var sVal = (getPxByPx(1160,1440) * (1.0)) / (maxLen * 1.0);
                    m.maxWidthX = m.maxWidthX * sVal;
                    m.maxHeightY = m.maxHeightY * sVal;
                    m.chargerPoint.x = m.chargerPoint.x * sVal;
                    m.chargerPoint.y = m.chargerPoint.y * sVal;

                        for (j = 0; j < m.room.length; j++) {
                            var roo = m.room[j];
                            for (k = 0; k < roo.vertexPointList.length; k++) {
                                $scope.Device.Movement.Map[i].room[j].vertexPointList[k].x = $scope.Device.Movement.Map[i].room[j].vertexPointList[k].x * sVal;
                                $scope.Device.Movement.Map[i].room[j].vertexPointList[k].y = $scope.Device.Movement.Map[i].room[j].vertexPointList[k].y * sVal;
                            }
                            roo.doorStart.x = roo.doorStart.x * sVal;
                            roo.doorStart.y = roo.doorStart.y * sVal;
                            roo.doorEnd.x = roo.doorEnd.x * sVal;
                            roo.doorEnd.y = roo.doorEnd.y * sVal;
                            roo.notationStart.x = roo.notationStart.x * sVal;
                            roo.notationStart.y = roo.notationStart.y * sVal;
                            roo.notationEnd.x = roo.notationEnd.x * sVal;
                            roo.notationEnd.y = roo.notationEnd.y * sVal;
                        }

                        if (m.maxWidthX < m.maxHeightY)
                            moveMapToCenter(m);
                        else
                        	moveMapToCenterX(m);
                        	

                    }
        } 
    function rotateMap()
    {
    	$scope.rotationDeg = ($scope.rotationDeg +90) %360;
    	localStorage.setItem("rotationDeg", $scope.rotationDeg);
    	
    }
    function getRoomName(roomIndex, mapId) {
        var roomName = '';
        var key = $scope.deviceUuid + "¿"+mapId + "¿" +roomIndex;
        
        if(!!Object.keys($scope.renameRoomList).length && !!$scope.renameRoomList[key]) {
            roomName = $scope.renameRoomList[key];
        } else {
            roomName = (!!localStorage.getItem(key) ? localStorage.getItem(key) : ('A' + getRoomIndex(parseInt(roomIndex)))); 
        } 
        return roomName;
    }
    function getPathMaskId(rowIndex, roomIndex)
    {
    	return "rowIndex"+rowIndex+"!!+roomIndex"+roomIndex;
    	
    }
    function getPathStrokeWidth(pathArr,svgLineLen)
    {
    	var scaleVal=1;
    	
    	var maxX = 0;
    	var maxY = 0;
    	var scaleVal = 1.0;
    	var i=0;
    	var tmpArr = pathArr.split(" ");
    	//for (i=2 ;i<pathArr.length ; i=i+2)
    	for (i=0 ;i<tmpArr.length ; i=i+2)
    	{
    		/*
    		if (pathArr[i] == undefined || pathArr[i]==undefined) break;
    		var x = parseInt(pathArr[i]);
    		var y = parseInt(pathArr[i+1]);
    		maxX = x>maxX ? x: maxX;
    		maxY = y>maxY ? y: maxY;
    		*/
    		if (tmpArr[0]=="") continue;
    		var v = tmpArr[0].split(",");
    		if (v.length != 2  ) continue;
    		
    		var x = parseInt(v[0]);
    		var y = parseInt(v[1]);
    		maxX = x>maxX ? x: maxX;
    		maxY = y>maxY ? y: maxY;
    		
    	}
    	
    	if (maxX > maxY)
    	{
    		if(maxX!=0)
    			scaleVal = (svgLineLen*(1.0)) / (maxX * (1.0));
    	}
    	else
    	{
    		if (maxY!=0)
    			scaleVal = (svgLineLen*(1.0)) / (maxY * (1.0));
    	}
    	
    	console.log("getScale "+scaleVal);
    	
    	
    	return scaleVal * 0.648414 ;
    }
     

}]);

app.directive('elemReady', function () {
    return {        
        restrict: 'A',
        link: function (scope, element) {      
//            $(element).bind('animationend webkitAnimationEnd MSAnimationEnd oAnimationEnd', function(e){
                $(this).removeClass('press-basic-checkbox');
//            });           
        }
    };
});

