/*
 * IReferenced.cpp
 *
 *  Created on: Feb 20, 2016
 *      Author: bhupathi.r
 */

#include "JNIGlobal.h"
#include "IReferenced.h"

class _scopeLock
{
	Sec::Shp::Platform::Thread::Mutex *mpMutex ;
public:
	_scopeLock(Sec::Shp::Platform::Thread::Mutex *pMutex)
	{
		mpMutex = pMutex ;
		mpMutex->lock();
	}

	~ _scopeLock()
	{
		mpMutex->unlock();
	}
};

void
IReferenced::increaseReference( IReferenced *pObject )
{
	_scopeLock(&(pObject->mRefereceMutex));

	if (NULL != pObject)
	{
		pObject->referenceCount++;
	}
}

void
IReferenced::decreaseReference( IReferenced *pObject )
{
	bool bDelete = false ;

	{
		_scopeLock(&(pObject->mRefereceMutex));

		if (NULL != pObject)
		{
			pObject->referenceCount--;

			if (pObject->referenceCount == 0)
			{
				bDelete = true;
			}
		}		
	}

	if (bDelete == true)
	{
		delete pObject;
	}
}


IReferenced::IReferenced()
{
	referenceCount = 1;
}

IReferenced::~IReferenced()
{

}
