/*
 * JNIClientConnector.cpp
 *
 *  Created on: Feb 5, 2014
 *      Author: bhupathi.r
 */

#include "Sec_Shp_Connector_Client_IClientConnector.h"
#include "JNISHPClientConnector.h"
#include "SHPClientConnector.h"
#include "JNIGlobal.h"


/*
 * Class:     Sec_Shp_Connector_Client_IClientConnector
 * Method:    constructNativeConnector
 * Signature: ()J
 */
JNIEXPORT jlong JNICALL Java_Sec_Shp_Connector_Client_IClientConnector_constructNativeConnector
  (JNIEnv *pEnv, jobject thisObject)
{
	return (jlong) new JNISHPClientConnector(thisObject);
}

/*
 * Class:     Sec_Shp_Connector_Client_IClientConnector
 * Method:    deleteNativeConnector
 * Signature: (J)V
 */
JNIEXPORT void JNICALL Java_Sec_Shp_Connector_Client_IClientConnector_deleteNativeConnector
  (JNIEnv *pEnv, jobject thisObject, jlong nativeHandle)
{
	Sec::Shp::Connector::Client::IClientConnector* clientConnector =  ( JNISHPClientConnector *) nativeHandle ;
	if (NULL != clientConnector)
	{
		delete clientConnector;
	}
}

/*
 * Class:     Sec_Shp_Connector_Client_IClientConnector
 * Method:    getConnectorConfiguration
 * Signature: (J)J
 */
JNIEXPORT jlong JNICALL Java_Sec_Shp_Connector_Client_IClientConnector_getConnectorConfiguration
  (JNIEnv *pEnv, jobject thisObject, jlong nativeHandle)
{
	Sec::Shp::Connector::Client::IClientConnector* conObject =  ( JNISHPClientConnector *) nativeHandle ;
	if (conObject == NULL)
	{
		return (jlong)0;
	}

	return (jlong)(conObject->getConnectorConfiguration());
}

/*
 * Class:     Sec_Shp_Connector_Client_IClientConnector
 * Method:    getProtocol
 * Signature: (J)Ljava/lang/String;
 */
JNIEXPORT jstring JNICALL Java_Sec_Shp_Connector_Client_IClientConnector_getProtocol
  (JNIEnv *pEnv, jobject thisObject, jlong nativeHandle)
{
	Sec::Shp::Connector::Client::IClientConnector* conObject =  ( JNISHPClientConnector *) nativeHandle ;
	if (conObject == NULL)
	{
		return NULL;
	}

	std::string protocol = conObject->getProtocol() ;
	return JNIGlobal::convertToJString(protocol);
}
