/*
 * JNIClientListener.cpp
 *
 *  Created on: Feb 4, 2014
 *      Author: bhupathi.r
 */

#include "Sec_Shp_Connector_Client_IClientListener.h"
#include "SHPClientConnector.h"


/*
 * Class:     Sec_Shp_Connector_Client_IClientListener
 * Method:    onResponseReceived
 * Signature: (JJ)V
 */
JNIEXPORT void JNICALL Java_Sec_Shp_Connector_Client_IClientListener_onResponseReceived
  (JNIEnv *pEnv, jobject thisObj, jlong nativeHandle, jlong session)
{
	Sec::Shp::Connector::Client::IClientListener *listener = (Sec::Shp::Connector::Client::IClientListener *)nativeHandle ;
	Sec::Shp::Connector::Client::ClientSession *clientSession = (Sec::Shp::Connector::Client::ClientSession *)session ;

	if ((NULL == listener) || (NULL == clientSession))
	{
		return ;
	}

	listener->onResponseReceived(*clientSession);
}

/*
 * Class:     Sec_Shp_Connector_Client_IClientListener
 * Method:    onErrorRecieved
 * Signature: (JJI)V
 */
JNIEXPORT void JNICALL Java_Sec_Shp_Connector_Client_IClientListener_onErrorRecieved
  (JNIEnv *pEnv, jobject thisObj, jlong nativeHandle, jlong session, jint errorCode)
{
	Sec::Shp::Connector::Client::IClientListener *listener = (Sec::Shp::Connector::Client::IClientListener *)nativeHandle ;
	Sec::Shp::Connector::Client::ClientSession *clientSession = (Sec::Shp::Connector::Client::ClientSession *)session ;

	if ((NULL == listener) || (NULL == clientSession))
	{
		return ;
	}

	listener->onErrorRecieved((Sec::Shp::ErrorCode)errorCode, *clientSession);
}
