/*
 * JNIConnectors.cpp
 *
 *  Created on: Feb 4, 2014
 *      Author: bhupathi.r
 */

#include "Sec_Shp_Connector_Client_HTTPS_SHPHTTPSClientConnector.h"
#include "Sec_Shp_Connector_Client_HTTP_SHPHTTPClientConnector.h"
#include "Sec_Shp_Connector_Server_HTTPS_SHPHTTPSServerConnector.h"
#include "Sec_Shp_Connector_Server_HTTP_SHPHTTPServerConnector.h"

#include "SHPHTTPClientConnector.h"
#include "SHPHTTPSClientConnector.h"
#include "SHPHTTPServerConnector.h"
#include "SHPHTTPSServerConnector.h"
#include "JNIGlobal.h"

JNIEXPORT jlong JNICALL Java_Sec_Shp_Connector_Client_HTTPS_SHPHTTPSClientConnector_constructNative
	(JNIEnv *pEnv, jclass classObj)
{
	return (jlong)(Sec::Shp::Connector::Client::SHPHTTPSClientConnector::createInstance());
}

JNIEXPORT jlong JNICALL Java_Sec_Shp_Connector_Client_HTTP_SHPHTTPClientConnector_constructNative
	(JNIEnv *pEnv, jclass classObj)
{
	return (jlong)(Sec::Shp::Connector::Client::SHPHTTPClientConnector::createInstance());
}

JNIEXPORT jlong JNICALL Java_Sec_Shp_Connector_Server_HTTPS_SHPHTTPSServerConnector_constructNative
  (JNIEnv *pEnv, jclass classObj, jstring ipAddress, jstring jport)
{
	std::string ipAddr ;
	if(false == JNIGlobal::convertToStdString(ipAddress, ipAddr))
		return (jlong)0;

	std::string port ;
	if(false == JNIGlobal::convertToStdString(jport, port))
		return (jlong)0;
	return (jlong)(Sec::Shp::Connector::Server::SHPHTTPSServerConnector::createInstance(ipAddr, port));
}

JNIEXPORT jlong JNICALL Java_Sec_Shp_Connector_Server_HTTP_SHPHTTPServerConnector_constructNative
  (JNIEnv *pEnv, jclass classObj, jstring ipAddress, jstring jport)
{
	std::string ipAddr ;
	if(false == JNIGlobal::convertToStdString(ipAddress, ipAddr))
		return (jlong)0;

	std::string port ;
	if(false == JNIGlobal::convertToStdString(jport, port))
		return (jlong)0;

	return (jlong)(Sec::Shp::Connector::Server::SHPHTTPServerConnector::createInstance(ipAddr, port));
}
