/*
 * JNIDeviceToken.cpp
 *
 *  Created on: 10-Mar-2014
 *      Author: sanjay
 */

#include "JNIDeviceToken.h"
#include "Sec_Shp_DeviceToken.h"
#include "JNIGlobal.h"

JNIDeviceToken::JNIDeviceToken( jobject jdeviceToken)
:Sec::Shp::DeviceToken()
{
	m_deviceToken = JNIGlobal::getGlobleRef(jdeviceToken) ;
}

JNIDeviceToken::~JNIDeviceToken()
{
	JNIGlobal::executeVoidMethod("Sec/Shp/DeviceToken", "onNativeDelete", "()V", m_deviceToken);
	JNIGlobal::releaseGlobleRef(m_deviceToken) ;
}

JNIEXPORT jlong JNICALL Java_Sec_Shp_DeviceToken_constructNative
  (JNIEnv *env, jobject thisObj)
{
	Sec::Shp::DeviceToken* deviceTokenObj = new JNIDeviceToken(thisObj);
	JNI_TryReturn( NULL != deviceTokenObj, 0, "Memory Allocation failed : Out of memory")

	return (jlong)(deviceTokenObj);
}

JNIEXPORT void JNICALL Java_Sec_Shp_DeviceToken_deleteNative
  (JNIEnv *, jobject, jlong dev)
{
	Sec::Shp::DeviceToken* deviceToken = (Sec::Shp::DeviceToken*) dev;

	if (NULL != deviceToken)
	{
		delete deviceToken;
	}
}

JNIEXPORT void JNICALL Java_Sec_Shp_DeviceToken_setUUID
  (JNIEnv *, jobject, jlong dev, jstring juuid)
{
	Sec::Shp::DeviceToken* deviceToken = (Sec::Shp::DeviceToken*) dev;
	JNI_TryReturnVoid( NULL != deviceToken, "Native device is invalid")

	std::string uuid ;
	JNI_TryReturnVoid( ( true == JNIGlobal::convertToStdString(juuid, uuid)), "device uuid conversion failed") ;

	deviceToken->setUUID(uuid.c_str());
}

JNIEXPORT void JNICALL Java_Sec_Shp_DeviceToken_setDeviceToken
  (JNIEnv *, jobject, jlong dev, jstring jdeviceToken)
{
	Sec::Shp::DeviceToken* deviceToken = (Sec::Shp::DeviceToken*) dev;
	JNI_TryReturnVoid( NULL != deviceToken, "Native device is invalid")

	std::string devicetoken ;
	JNI_TryReturnVoid( ( true == JNIGlobal::convertToStdString(jdeviceToken, devicetoken)), "device token conversion failed") ;

	deviceToken->setDeviceToken(devicetoken.c_str());
}

JNIEXPORT jstring JNICALL Java_Sec_Shp_DeviceToken_getUUID
  (JNIEnv *, jobject, jlong dev)
{
	Sec::Shp::DeviceToken* deviceToken = (Sec::Shp::DeviceToken*) dev;
	JNI_TryReturn( NULL != deviceToken, NULL, "Native device is invalid")

	return JNIGlobal::convertToJString(deviceToken->getUUID()) ;
}


JNIEXPORT jstring JNICALL Java_Sec_Shp_DeviceToken_getDeviceToken
  (JNIEnv *, jobject, jlong dev)
{
	Sec::Shp::DeviceToken* deviceToken = (Sec::Shp::DeviceToken*) dev;
	JNI_TryReturn( NULL != deviceToken, NULL, "Native device is invalid")

	return JNIGlobal::convertToJString(deviceToken->getDeviceToken()) ;
}
