/*
 * JNIHeadersList.cpp
 *
 *  Created on: Jul 5, 2013
 *      Author: kirtigupta
 */

#include <jni.h>
#include "Sec_Shp_Connector_HeadersList.h"
#include "SHPConnector.h"
#include "JNIGlobal.h"
#include "list"
   
JNIEXPORT jlong JNICALL Java_Sec_Shp_Connector_HeadersList_constructNative(JNIEnv *env, jobject thisObj)
{
	Sec::Shp::Connector::HeadersList* headersList = new Sec::Shp::Connector::HeadersList();
	return (jlong) (headersList);
}

JNIEXPORT void JNICALL Java_Sec_Shp_Connector_HeadersList_deleteNative
  (JNIEnv *env, jobject thisObj, jlong headersList)
{
	Sec::Shp::Connector::HeadersList* headersListObj = (Sec::Shp::Connector::HeadersList*) headersList;
	if (headersListObj != NULL)
	{
		delete headersListObj;
	}
}

JNIEXPORT jboolean JNICALL Java_Sec_Shp_Connector_HeadersList_setHeader(JNIEnv *env,jobject thisObj,jlong headersList,jstring name,jstring value)
{
	Sec::Shp::Connector::HeadersList* headersListObj = (Sec::Shp::Connector::HeadersList*) headersList;
	if ((jlong)0 == headersList)
	{
		return JNI_FALSE ;
	}

	std::string hName ;
	if (false == JNIGlobal::convertToStdString(name, hName))
	{
		return JNI_FALSE;
	}

	std::string hVal ;
	if (false == JNIGlobal::convertToStdString(value, hVal))
	{
		return JNI_FALSE;
	}

	return (headersListObj->setHeader(hName,hVal)) ? JNI_TRUE : JNI_FALSE;
}


JNIEXPORT jstring JNICALL Java_Sec_Shp_Connector_HeadersList_getHeader(JNIEnv *env,jobject thisObj,jlong headersList,jstring name)
{
	const char* headerName = env->GetStringUTFChars(name,0);

	jstring headerValue ;

	Sec::Shp::Connector::HeadersList* headersListObj = (Sec::Shp::Connector::HeadersList*) headersList;

	std::string hName( headerName );
	std::string value ;

	bool getH = headersListObj->getHeader(hName, value);

	env->ReleaseStringUTFChars(name,headerName);

	if(getH == true)
	{
		headerValue = env->NewStringUTF(value.c_str());
		return headerValue;
	}
	else
		return NULL;
}

JNIEXPORT jobjectArray JNICALL Java_Sec_Shp_Connector_HeadersList_getHeaderNameList(JNIEnv *env,jobject thisObj,jlong headersList)
{
	jobjectArray resultList = NULL ;

	Sec::Shp::Connector::HeadersList* headersListObj = (Sec::Shp::Connector::HeadersList*) headersList;

	Sec::Shp::Connector::IHeadersListIterator* headers = headersListObj->getIterator();

	std::list <std::string> headerNameList ;

	while ( headers->isEnd() == false )
	{
		std::string name, value ;

		if ( true == headers->get(name, value) )
		{
			headerNameList.push_back(name) ;
		}

		headers->moveToNext() ;
	}

	delete headers ;

	resultList = NULL ;

	int index = 0 ;
	for (std::list<std::string>::const_iterator itr = headerNameList.begin(); itr != headerNameList.end(); itr++, index++ )
	{
		std::string headerName = (*itr) ;
		jstring jheader = env->NewStringUTF(headerName.c_str()) ;

		if (NULL == resultList)
		{
			jclass javaStringClass = env->GetObjectClass(jheader) ;
			resultList = env->NewObjectArray(headerNameList.size(), javaStringClass, NULL) ;
		}

		env->SetObjectArrayElement( resultList, index , jheader ) ;
	}

	return resultList ;
}
