/*
 * JNIHttpClient.h
 *
 *  Created on: Feb 19, 2016
 *      Author: bhupathi.r
 */

#ifndef SRC_JNIHTTPCLIENT_H_
#define SRC_JNIHTTPCLIENT_H_

#include <Client/Client.h>
#include "IReferenced.h"

namespace Sec {
namespace Shp {
namespace Jni {


class JNIHTTPClient : public Sec::Shp::Connector::Client::IClientListener,
					  public IReferenced
{

public:

	Sec::Shp::Connector::Client::IClientConnector *pClientConnector ;
	Sec::Shp::Core::Client::Client* pClient;
	Sec::Shp::Configuration mConfiguration; // dummy not used any where
	bool bUseSSL ;
	bool bisInternal;
	bool	isValid ;

	JNIHTTPClient( Sec::Shp::Connector::Client::IClientConnector *pClientConnector, bool bUseSSL, bool isInternal ) ;

	~JNIHTTPClient() ;

	void invalidateConnector() ;

	bool init( ) ;

	/**
	 *
	 * listener method to receive response from a client connector. SHP framework will register a
	 * IClientListener with client connector. client connector is supposed to call this method on receiving
	 * the response of a request
	 *
	 *
	 * @param[in] client_sessioin	client session object
	 * @since   1.0.0*/

	void onResponseReceived( Sec::Shp::Connector::Client::ClientSession& client_sessioin ) ;


	/**
	 *
	 * listener method to receive response from a client connector. SHP framework will register a
	 * IClientListener with client connector. client connector is supposed to call this method on receiving
	 * error response for a request
	 *
	 * @param[in] error				error code
	 * @param[in] client_sessioin	client session object
	 *
	 * @since   1.0.0*/
	void onErrorRecieved( Sec::Shp::ErrorCode error,
						  Sec::Shp::Connector::Client::ClientSession& client_sessioin) ;

	/**
	 *
	 * listener method to notify a specific client session is completed and application can free the resources related to
	 * this session (including session)
	 *
	 * @param[in] client_sessioin	client session object
	 *
	 * @since   1.0.0*/
	virtual void onClientSessionCompleted( Sec::Shp::Connector::Client::ClientSession& client_sessioin) ;

private:

};



}  // namespace Jni
}  // namespace Shp
}  // namespace Sec



#endif /* SRC_JNIHTTPCLIENT_H_ */
