/*
 * JNIMessage.cpp
 *
 *  Created on: Mar 14, 2014
 *      Author: bhupathi.r
 */

#include "Sec_Shp_Connector_SHPMessage.h"
#include "SHPConnector.h"
#include "JNIGlobal.h"

/*
 * Class:     Sec_Shp_Connector_SHPMessage
 * Method:    getPayloadType
 * Signature: (JZ)Ljava/lang/String;
 */
JNIEXPORT jstring JNICALL Java_Sec_Shp_Connector_SHPMessage_getPayloadType
  (JNIEnv *pEnv, jobject thisObj, jlong nativeHandle, jboolean isRequest)
{
	jstring retValue = NULL;

	if (isRequest)
	{
		Sec::Shp::Connector::SHPRequest* pRequest = (Sec::Shp::Connector::SHPRequest*)nativeHandle ;
		if ( NULL != pRequest )
		{
			retValue = JNIGlobal::convertToJString(pRequest->m_payloadType) ;
		}
	}
	else
	{
		Sec::Shp::Connector::SHPResponse* pResponse = (Sec::Shp::Connector::SHPResponse*)nativeHandle ;
		if ( NULL != pResponse )
		{
			retValue = JNIGlobal::convertToJString(pResponse->m_payloadType) ;
		}
	}

	return retValue ;
}

/*
 * Class:     Sec_Shp_Connector_SHPMessage
 * Method:    getPayload
 * Signature: (JZ)Ljava/lang/String;
 */
JNIEXPORT jstring JNICALL Java_Sec_Shp_Connector_SHPMessage_getPayload
  (JNIEnv *pEnv, jobject thisObj, jlong nativeHandle, jboolean isRequest)
{
	jstring retValue = NULL;

	if (isRequest)
	{
		Sec::Shp::Connector::SHPRequest* pRequest = (Sec::Shp::Connector::SHPRequest*)nativeHandle ;
		if ( NULL != pRequest )
		{
			retValue = JNIGlobal::convertToJString(pRequest->m_payload) ;
		}
	}
	else
	{
		Sec::Shp::Connector::SHPResponse* pResponse = (Sec::Shp::Connector::SHPResponse*)nativeHandle ;
		if ( NULL != pResponse )
		{
			retValue = JNIGlobal::convertToJString(pResponse->m_payload) ;
		}
	}

	return retValue ;
}

/*
 * Class:     Sec_Shp_Connector_SHPMessage
 * Method:    getPayloadSize
 * Signature: (JZ)Ljava/lang/String;
 */
JNIEXPORT jint JNICALL Java_Sec_Shp_Connector_SHPMessage_getPayloadSize
  (JNIEnv *pEnv, jobject thisObj, jlong nativeHandle, jboolean isRequest)
{
	jint retValue = -1;

	if (isRequest)
	{
		Sec::Shp::Connector::SHPRequest* pRequest = (Sec::Shp::Connector::SHPRequest*)nativeHandle ;
		if ( NULL != pRequest )
		{
			retValue = pRequest->m_payloadSize ;
		}
	}
	else
	{
		Sec::Shp::Connector::SHPResponse* pResponse = (Sec::Shp::Connector::SHPResponse*)nativeHandle ;
		if ( NULL != pResponse )
		{
			retValue = pResponse->m_payloadSize ;
		}
	}

	return retValue ;
}

/*
 * Class:     Sec_Shp_Connector_SHPMessage
 * Method:    getHeaders
 * Signature: (JZ)J
 */
JNIEXPORT jlong JNICALL Java_Sec_Shp_Connector_SHPMessage_getHeaders
  (JNIEnv *pEnv, jobject thisObj, jlong nativeHandle, jboolean isRequest)
{
	jlong retValue = 0;

	if (isRequest)
	{
		Sec::Shp::Connector::SHPRequest* pRequest = (Sec::Shp::Connector::SHPRequest*)nativeHandle ;
		if ( NULL != pRequest )
		{
			retValue = (jlong)( & (pRequest->m_headers) );
		}
	}
	else
	{
		Sec::Shp::Connector::SHPResponse* pResponse = (Sec::Shp::Connector::SHPResponse*)nativeHandle ;
		if ( NULL != pResponse )
		{
			retValue = (jlong)( & (pResponse->m_headers) );
		}
	}

	return retValue ;
}

/*
 * Class:     Sec_Shp_Connector_SHPMessage
 * Method:    setResourcePath
 * Signature: (JLjava/lang/String;Z)V
 */
JNIEXPORT void JNICALL Java_Sec_Shp_Connector_SHPMessage_setResourcePath
  (JNIEnv *pEnv, jobject thisObj, jlong nativeHandle, jstring jResourcePath, jboolean isRequest)
{
	std::string resourcePath ;
	if( false == JNIGlobal::convertToStdString( jResourcePath, resourcePath))
		return;

	if (isRequest)
	{
		Sec::Shp::Connector::SHPRequest* pRequest = (Sec::Shp::Connector::SHPRequest*)nativeHandle ;
		if ( NULL != pRequest )
		{
			pRequest->m_resourceIdentifier.setResourcePath(resourcePath);
		}
	}
	else
	{
		Sec::Shp::Connector::SHPResponse* pResponse = (Sec::Shp::Connector::SHPResponse*)nativeHandle ;
		if ( NULL != pResponse )
		{
			pResponse->m_resourceIdentifier.setResourcePath(resourcePath);
		}
	}
}

/*
 * Class:     Sec_Shp_Connector_SHPMessage
 * Method:    getResourcePath
 * Signature: (JZ)Ljava/lang/String;
 */
JNIEXPORT jstring JNICALL Java_Sec_Shp_Connector_SHPMessage_getResourcePath
  (JNIEnv *pEnv, jobject thisObj, jlong nativeHandle, jboolean isRequest)
{
	jstring retValue = NULL;

	if (isRequest)
	{
		Sec::Shp::Connector::SHPRequest* pRequest = (Sec::Shp::Connector::SHPRequest*)nativeHandle ;
		if ( NULL != pRequest )
		{
			retValue = JNIGlobal::convertToJString(pRequest->m_resourceIdentifier.getResourcePath()) ;
		}
	}
	else
	{
		Sec::Shp::Connector::SHPResponse* pResponse = (Sec::Shp::Connector::SHPResponse*)nativeHandle ;
		if ( NULL != pResponse )
		{
			retValue = JNIGlobal::convertToJString(pResponse->m_resourceIdentifier.getResourcePath()) ;
		}
	}

	return retValue ;
}

/*
 * Class:     Sec_Shp_Connector_SHPMessage
 * Method:    getMethod
 * Signature: (JZ)Ljava/lang/String;
 */
JNIEXPORT jstring JNICALL Java_Sec_Shp_Connector_SHPMessage_getMethod
  (JNIEnv *pEnv, jobject thisObj, jlong nativeHandle, jboolean isRequest)
{
	jstring retValue = NULL;

	if (isRequest)
	{
		Sec::Shp::Connector::SHPRequest* pRequest = (Sec::Shp::Connector::SHPRequest*)nativeHandle ;
		if ( NULL != pRequest )
		{
			retValue = JNIGlobal::convertToJString(pRequest->m_methodIdentifier.getMethod()) ;
		}
	}
	else
	{
		Sec::Shp::Connector::SHPResponse* pResponse = (Sec::Shp::Connector::SHPResponse*)nativeHandle ;
		if ( NULL != pResponse )
		{
			retValue = JNIGlobal::convertToJString(pResponse->m_methodIdentifier.getMethod()) ;
		}
	}

	return retValue ;
}

/*
 * Class:     Sec_Shp_Connector_SHPMessage
 * Method:    setMethod
 * Signature: (JLjava/lang/String;Z)V
 */
JNIEXPORT void JNICALL Java_Sec_Shp_Connector_SHPMessage_setMethod
  (JNIEnv *pEnv, jobject thisObj, jlong nativeHandle, jstring jResourcePath, jboolean isRequest)
{
	std::string resourcePath ;
	if( false == JNIGlobal::convertToStdString( jResourcePath, resourcePath))
		return;

	if (isRequest)
	{
		Sec::Shp::Connector::SHPRequest* pRequest = (Sec::Shp::Connector::SHPRequest*)nativeHandle ;
		if ( NULL != pRequest )
		{
			pRequest->m_methodIdentifier.setMethod(resourcePath);
		}
	}
	else
	{
		Sec::Shp::Connector::SHPResponse* pResponse = (Sec::Shp::Connector::SHPResponse*)nativeHandle ;
		if ( NULL != pResponse )
		{
			pResponse->m_methodIdentifier.setMethod(resourcePath);
		}
	}
}

/*
 * Class:     Sec_Shp_Connector_SHPMessage
 * Method:    getQueryParam
 * Signature: (JLjava/lang/String;Z)Ljava/lang/String;
 */
JNIEXPORT jstring JNICALL Java_Sec_Shp_Connector_SHPMessage_getQueryParam
  (JNIEnv *pEnv, jobject thisObj, jlong nativeHandle, jstring jQueryParam, jboolean isRequest)
{
	jstring retValue = NULL;

	std::string queryParam ;
	if( false==JNIGlobal::convertToStdString( jQueryParam, queryParam))
		return retValue;


	if (isRequest)
	{
		Sec::Shp::Connector::SHPRequest* pRequest = (Sec::Shp::Connector::SHPRequest*)nativeHandle ;
		if ( NULL != pRequest )
		{
			std::string paramValue ;
			if (pRequest->m_methodIdentifier.getParam(queryParam, paramValue))
			{
				retValue = JNIGlobal::convertToJString(paramValue) ;
			}
		}
	}
	else
	{
		Sec::Shp::Connector::SHPResponse* pResponse = (Sec::Shp::Connector::SHPResponse*)nativeHandle ;
		if ( NULL != pResponse )
		{
			std::string paramValue ;
			if (pResponse->m_methodIdentifier.getParam(queryParam, paramValue))
			{
				retValue = JNIGlobal::convertToJString(paramValue) ;
			}
		}
	}

	return retValue;
}

/*
 * Class:     Sec_Shp_Connector_SHPMessage
 * Method:    setQueryParam
 * Signature: (JLjava/lang/String;Ljava/lang/String;Z)V
 */
JNIEXPORT void JNICALL Java_Sec_Shp_Connector_SHPMessage_setQueryParam
  (JNIEnv *pEnv, jobject thisObj, jlong nativeHandle, jstring jQueryParam, jstring jparamValue, jboolean isRequest)
{
	std::string queryParam ;
	if( false == JNIGlobal::convertToStdString( jQueryParam, queryParam ) )
		return;

	std::string paramValue ;
	if( false == JNIGlobal::convertToStdString( jparamValue, paramValue ) )
		return;

	if (isRequest)
	{
		Sec::Shp::Connector::SHPRequest* pRequest = ( Sec::Shp::Connector::SHPRequest* )nativeHandle ;
		if ( NULL != pRequest )
		{
			pRequest->m_methodIdentifier.m_queryParams.insert( std::pair< std::string, std::string > ( queryParam, paramValue ) );
		}
	}
	else
	{
		Sec::Shp::Connector::SHPResponse* pResponse = ( Sec::Shp::Connector::SHPResponse* )nativeHandle ;
		if ( NULL != pResponse )
		{
			pResponse->m_methodIdentifier.m_queryParams.insert( std::pair< std::string, std::string > ( queryParam, paramValue ) );
		}
	}
}

/*
 * Class:     Sec_Shp_Connector_SHPMessage
 * Method:    getResponseCode
 * Signature: (J)I
 */
JNIEXPORT jint JNICALL Java_Sec_Shp_Connector_SHPMessage_getResponseCode
  (JNIEnv *pEnv, jobject thisObj, jlong nativeHandle)
{
	jint retValue = -1;

	Sec::Shp::Connector::SHPResponse* pResponse = (Sec::Shp::Connector::SHPResponse*)nativeHandle ;
	if ( NULL != pResponse )
	{
		retValue = pResponse->m_response_code ;
	}

	return retValue ;
}

/*
 * Class:     Sec_Shp_Connector_SHPMessage
 * Method:    setResponseCode
 * Signature: (JI)V
 */
JNIEXPORT void JNICALL Java_Sec_Shp_Connector_SHPMessage_setResponseCode
  (JNIEnv *pEnv, jobject thisObj, jlong nativeHandle, jint statusCode)
{
	Sec::Shp::Connector::SHPResponse* pResponse = (Sec::Shp::Connector::SHPResponse*)nativeHandle ;
	if ( NULL != pResponse )
	{
		pResponse->m_response_code = statusCode;
	}
}
