/*
 * JNIResourceHandlerFactory.cpp
 *
 *  Created on: Jul 8, 2013
 *      Author: kirtigupta
 */
#include "Sec_Shp_Server_ResourceHandler_ResourceHandlerFactory.h"
#include "SHPResourceHandlerFactory.h"

JNIEXPORT jlong JNICALL Java_Sec_Shp_Server_ResourceHandler_ResourceHandlerFactory_constructNative
(JNIEnv *env, jobject thisObj, jobject factory)
{
	SHPResourceHandlerFactory* rObject = new SHPResourceHandlerFactory(factory);
	return (jlong) rObject;
}

JNIEXPORT void JNICALL Java_Sec_Shp_Server_ResourceHandler_ResourceHandlerFactory_deleteNative
(JNIEnv *env, jobject thisObj, jlong rFactory)
{
	SHPResourceHandlerFactory* rObject =  ( SHPResourceHandlerFactory*) rFactory;
	if (NULL != rObject)
	{
		delete rObject;
	}
}

JNIEXPORT void JNICALL Java_Sec_Shp_Server_ResourceHandler_ResourceHandlerFactory_registerResourceType
  (JNIEnv *env, jobject thisObj, jlong rFactory, jint type, jstring path)
{
	SHPResourceHandlerFactory* rObject =  ( SHPResourceHandlerFactory*) rFactory;
	JNI_TryReturnVoid( NULL != rObject, "Native instance is invalid")

	std::string pathS ;
	JNI_TryReturnVoid( ( true == JNIGlobal::convertToStdString(path, pathS)), "pathS conversion failed")

	rObject->registerResourceHandler(type, pathS.c_str()) ;
}

JNIEXPORT jint JNICALL Java_Sec_Shp_Server_ResourceHandler_ResourceHandlerFactory_getResourceType
  (JNIEnv *pEnv, jobject thisObj, jlong rFactory, jstring path)
{
	SHPResourceHandlerFactory* rObject =  ( SHPResourceHandlerFactory*) rFactory;
	JNI_TryReturn( NULL != rObject, -1,"Native instance is invalid")

	std::string pathS ;
	JNI_TryReturn( ( true == JNIGlobal::convertToStdString(path, pathS)),-1, "pathS conversion failed")

	std::map<std::string, std::string> templateParams ;
	return rObject->getResourceType(pathS.c_str(), templateParams) ;
}




