/*
 * JNIServerConnector.cpp
 *
 *  Created on: Sep 30, 2013
 *      Author: kirtigupta
 */

#include <jni.h>
#include "Sec_Shp_Connector_Server_IServerConnector.h"
#include "Connector/Server/IServerConnector.h"
#include "JNISHPServerConnector.h"
#include "JNIGlobal.h" 

JNIEXPORT jlong JNICALL Java_Sec_Shp_Connector_Server_IServerConnector_constructNativeConnector
(JNIEnv *env, jobject thisObject)
{
	return (jlong) new JNISHPServerConnector(thisObject);
}

JNIEXPORT void JNICALL Java_Sec_Shp_Connector_Server_IServerConnector_deleteNativeConnector
(JNIEnv *env, jobject thisObj, jlong con)
{
	Sec::Shp::Connector::Server::IServerConnector* conObject =  ( JNISHPServerConnector *) con ;
	delete conObject;
}


JNIEXPORT jstring JNICALL Java_Sec_Shp_Connector_Server_IServerConnector_getProtocol
(JNIEnv *env, jobject thisObj, jlong con)
{
	Sec::Shp::Connector::Server::IServerConnector* conObject =  ( JNISHPServerConnector *) con ;
	if (conObject == NULL)
	{
		return NULL;
	}

	std::string protocol = conObject->getProtocol() ;
	return JNIGlobal::convertToJString(protocol);
}


JNIEXPORT jlong JNICALL Java_Sec_Shp_Connector_Server_IServerConnector_getConnectorConfiguration
(JNIEnv *env, jobject thisObj, jlong con)
{
	Sec::Shp::Connector::Server::IServerConnector* conObject =  ( JNISHPServerConnector *) con ;
	if (conObject == NULL)
	{
		return (jlong)0;
	}

	return (jlong)(conObject->getConnectorConfiguration());
}
