/*
 * JNIServerListener.cpp
 *
 *  Created on: Feb 4, 2014
 *      Author: bhupathi.r
 */

#include "Sec_Shp_Connector_Server_IServerListener.h"
#include "JNIGlobal.h"
#include "SHPServerConnector.h"


JNIEXPORT void JNICALL Java_Sec_Shp_Connector_Server_IServerListener_onServerStarted
  (JNIEnv *pEnv, jobject thisObject, jlong nativeHandle, jint serverId, jstring jaddress)
{
	Sec::Shp::Connector::Server::IServerListener *listener = (Sec::Shp::Connector::Server::IServerListener *)nativeHandle ;

	std::string address ;
	JNI_TryReturnVoid( ( true == JNIGlobal::convertToStdString(jaddress, address)), "string conversion failed") ;

	if (listener != NULL)
	{
		listener->onServerStarted((int) serverId, address) ;
	}
}

/*
 * Class:     Sec_Shp_Connector_Server_IServerListener
 * Method:    onServerStopped
 * Signature: (J)V
 */
JNIEXPORT void JNICALL Java_Sec_Shp_Connector_Server_IServerListener_onServerStopped
  (JNIEnv *pEnv, jobject thisObject, jlong nativeHandle, jint serverId)
{
	Sec::Shp::Connector::Server::IServerListener *listener = (Sec::Shp::Connector::Server::IServerListener *)nativeHandle ;

	if (listener != NULL)
	{
		listener->onServerStopped((int) serverId) ;
	}
}

/*
 * Class:     Sec_Shp_Connector_Server_IServerListener
 * Method:    onServerError
 * Signature: (JI)V
 */
JNIEXPORT void JNICALL Java_Sec_Shp_Connector_Server_IServerListener_onServerError
  (JNIEnv *pEnv, jobject thisObject, jlong nativeHandle, jint serverId, jint errorCode)
{
	Sec::Shp::Connector::Server::IServerListener *listener = (Sec::Shp::Connector::Server::IServerListener *)nativeHandle ;

	if (listener != NULL)
	{
		listener->onServerError((int) serverId, (Sec::Shp::ErrorCode) errorCode) ;
	}
}

/*
 * Class:     Sec_Shp_Connector_Server_IServerListener
 * Method:    onServerSessionStarted
 * Signature: (JJ)V
 */
JNIEXPORT void JNICALL Java_Sec_Shp_Connector_Server_IServerListener_onServerSessionStarted
  (JNIEnv *pEnv, jobject thisObject, jlong nativeHandle,  jint serverId, jlong session)
{
	Sec::Shp::Connector::Server::IServerListener *listener = (Sec::Shp::Connector::Server::IServerListener *)nativeHandle ;
	Sec::Shp::Connector::Server::ServerSession *serverSession = (Sec::Shp::Connector::Server::ServerSession *)session ;

	if ((listener == NULL) || (NULL == serverSession))
	{
		return;
	}

	listener->onServerSessionStarted((int) serverId, *serverSession) ;
}

/*
 * Class:     Sec_Shp_Connector_Server_IServerListener
 * Method:    onServerSessionCompleted
 * Signature: (JJ)V
 */
JNIEXPORT void JNICALL Java_Sec_Shp_Connector_Server_IServerListener_onServerSessionCompleted
  (JNIEnv *pEnv, jobject thisObject, jlong nativeHandle,  jint serverId, jlong session)
{
	Sec::Shp::Connector::Server::IServerListener *listener = (Sec::Shp::Connector::Server::IServerListener *)nativeHandle ;
	Sec::Shp::Connector::Server::ServerSession *serverSession = (Sec::Shp::Connector::Server::ServerSession *)session ;

	if ((listener == NULL) || (NULL == serverSession))
	{
		return;
	}

	listener->onServerSessionCompleted((int) serverId, *serverSession) ;
}

/*
 * Class:     Sec_Shp_Connector_Server_IServerListener
 * Method:    handleRequest
 * Signature: (JJ)Z
 */
JNIEXPORT jboolean JNICALL Java_Sec_Shp_Connector_Server_IServerListener_handleRequest
  (JNIEnv *pEnv, jobject thisObject, jlong nativeHandle, jlong session)
{
	Sec::Shp::Connector::Server::IServerListener *listener = (Sec::Shp::Connector::Server::IServerListener *)nativeHandle ;
	Sec::Shp::Connector::Server::ServerSession *serverSession = (Sec::Shp::Connector::Server::ServerSession *)session ;

	if ((listener == NULL) || (NULL == serverSession))
	{
		return JNI_FALSE;
	}

	return (listener->handleRequest(*serverSession)) ? JNI_TRUE : JNI_FALSE ;
}
