/*
 * JNIServerSession.cpp
 *
 *  Created on: Jul 9, 2013
 *      Author: kirtigupta
 */

#include <jni.h>
#include "Connector/Server/ServerSession.h"
#include "JNISHPDev.h"
#include "JNIGlobal.h"

JNIEXPORT jlong JNICALL Java_Sec_Shp_Connector_Server_ServerSession_constructNativeSession
  (JNIEnv *env, jobject thisObj,  jint serverId, jlong context, jstring jprotocol, jstring jdeviceAddress)
{
	std::string deviceAddress ;
	if (false == JNIGlobal::convertToStdString(jdeviceAddress, deviceAddress)) {
		return (jlong)0;
	}

	std::string protocol ;
	if (false == JNIGlobal::convertToStdString(jprotocol, protocol)) {
		return (jlong)0;
	}

	Sec::Shp::Connector::Server::ServerSession* sSession = new Sec::Shp::Connector::Server::ServerSession(serverId, protocol, deviceAddress) ;
	return (jlong)sSession;
}

JNIEXPORT jint JNICALL Java_Sec_Shp_Connector_Server_ServerSession_getServerId
  (JNIEnv *env, jobject thisObj, jlong servSession)
{
	Sec::Shp::Connector::Server::ServerSession* sSession = (Sec::Shp::Connector::Server::ServerSession*) servSession ;

	return (jint)sSession->getServerId();

}

JNIEXPORT jstring JNICALL Java_Sec_Shp_Connector_Server_ServerSession_getClientProtocol
  (JNIEnv *env, jobject thisObj, jlong servSession)
{
	Sec::Shp::Connector::Server::ServerSession* sSession = (Sec::Shp::Connector::Server::ServerSession*) servSession ;

	std::string protocol = sSession->getClientProtocol();

	return env->NewStringUTF(protocol.c_str());
}

JNIEXPORT jstring JNICALL Java_Sec_Shp_Connector_Server_ServerSession_getClientAddress
  (JNIEnv *env, jobject thisObj, jlong servSession)
{
	Sec::Shp::Connector::Server::ServerSession* sSession = (Sec::Shp::Connector::Server::ServerSession*) servSession ;

	std::string cAddress = sSession->getClientAddress();

	return env->NewStringUTF(cAddress.c_str());
}

JNIEXPORT jobject JNICALL Java_Sec_Shp_Connector_Server_ServerSession_getClientDevice
  (JNIEnv *env, jobject thisObj, jlong servSession)
{
//	Sec::Shp::Connector::Server::ServerSession* sSession = (Sec::Shp::Connector::Server::ServerSession*) servSession ;
//
//	JNISHPDevice *jniDevice = (JNISHPDevice*) (sSession->getClientDevice()) ;
//	jobject javaDeviceObject = jniDevice->m_device ;

	return NULL ;
}

extern "C" JNIEXPORT jboolean JNICALL Java_Sec_Shp_Connector_Server_ServerSession_setResponseHeader
  (JNIEnv *env, jobject thisObj, jlong servSession, jstring name, jstring value)
{
	Sec::Shp::Connector::Server::ServerSession* sSession = (Sec::Shp::Connector::Server::ServerSession*) servSession ;
	if ( NULL == sSession)
	{
		return JNI_FALSE;
	}

	const char* property = env->GetStringUTFChars(name,0);
	std::string nameStr(property);
	env->ReleaseStringUTFChars(name,property);

	const char* pValue = env->GetStringUTFChars(value,0);
	std::string valueStr(pValue);
	env->ReleaseStringUTFChars(value,pValue);

	if (sSession->getResponse().m_headers.setHeader(nameStr, valueStr))
	{
		return JNI_TRUE;
	}
	else
	{
		return JNI_FALSE;
	}
} 
 
extern "C" JNIEXPORT jstring JNICALL Java_Sec_Shp_Connector_Server_ServerSession_getTemplateParameter
  (JNIEnv *env, jobject thisObj, jlong servSession1, jstring name)
{
	Sec::Shp::Connector::Server::ServerSession* sSession = (Sec::Shp::Connector::Server::ServerSession*) servSession1 ;
	if ( NULL == sSession)
	{
		return JNI_FALSE; 
	}

	const char* property = env->GetStringUTFChars(name,0);
	std::string nameStr(property);
	env->ReleaseStringUTFChars(name,property);

	std::string value = sSession->getRequest().m_template_parameters[nameStr];

	return env->NewStringUTF(value.c_str());
}



