/*
 * JNISqliteDB.cpp
 *
 *  Created on: Feb 19, 2014
 *      Author: bhupathi.r
 */


#include <jni.h>
#include "Sec_Shp_SHP.h"
#include "SHP.h"
#include "SqliteSubscriptionDatabase.h"
#include "SubscriptionManager.h"

/*
 * Class:     Sec_Shp_SHP
 * Method:    configureSqliteSubscriptionManager
 * Signature: (J)Z
 */
JNIEXPORT jboolean JNICALL Java_Sec_Shp_SHP_configureSqliteSubscriptionManager
 (JNIEnv *env, jobject thisObj, jlong shp)
{
	Sec::Shp::SHP* shpObj = (Sec::Shp::SHP*) shp;
	if ( NULL == shpObj)
	{
		jclass mapClass = env->FindClass("java/lang/Exception");
		(env)->ThrowNew(mapClass, "Shp object is NULL") ;
		return -1;
	}

	Sec::Shp::Notification::ISubscriptionDB* db = new Sec::Shp::Notification::SqliteSubscriptionDatabase();
	shpObj->setSubscriptionManager(*new Sec::Shp::Notification::SubscriptionManager(db)) ;

	return JNI_TRUE;
}

