/*
 * MyDeviceFinderListener.cpp
 *
 *  Created on: Jun 11, 2013
 *      Author: kirtigupta
 */

#include "MyDeviceFinderListener.h"
#include "SHPDeviceFinder.h"
#include "JNISHPDev.h"
//#include "Log.h"

using namespace std ;

MyDeviceFinderListener::MyDeviceFinderListener(jobject mylistener) {

	listener = JNIGlobal::getGlobleRef(mylistener) ;
	this->isCIListener = false;
}

MyDeviceFinderListener::MyDeviceFinderListener(jobject mylistener, bool isCIListener) {

	listener = JNIGlobal::getGlobleRef(mylistener) ;
	this->isCIListener = isCIListener ;
}

MyDeviceFinderListener::~MyDeviceFinderListener()
{
	JNIGlobal::releaseGlobleRef(listener) ;
}

void
MyDeviceFinderListener::onDeviceAdded( Sec::Shp::Device& device)
{
	if (isCIListener == false)
	{
		JNISHPDevice *jniDevice = (JNISHPDevice*) (&device) ;
		jobject javaDeviceObject = jniDevice->m_device ;

		JNIGlobal::executeVoidMethod("Sec/Shp/DeviceFinder/IDeviceFinderListener","OnDeviceAdded","(LSec/Shp/Device;)V",listener,javaDeviceObject);
	}
	else
	{
		jstring juuid = JNIGlobal::convertToJString(device.getUUID());
		JNIGlobal::executeVoidMethod("com/sec/shp/sdk/ra/ci/ICIDevicePresenceListener", "OnDeviceAdded","(Ljava/lang/String;)V", listener, juuid);
		JNIGlobal::releaseLocalRef(juuid);
	}
}

void
MyDeviceFinderListener::onDeviceRemoved( Sec::Shp::Device& device)
{
	if (isCIListener == false)
	{
		JNISHPDevice *jniDevice = (JNISHPDevice*) (&device) ;
		jobject javaDeviceObject = jniDevice->m_device ;
		JNIGlobal::executeVoidMethod("Sec/Shp/DeviceFinder/IDeviceFinderListener","OnDeviceRemoved","(LSec/Shp/Device;)V",listener,javaDeviceObject);
	}
	else
	{
		jstring juuid = JNIGlobal::convertToJString(device.getUUID());
		JNIGlobal::executeVoidMethod("com/sec/shp/sdk/ra/ci/ICIDevicePresenceListener", "OnDeviceRemoved","(Ljava/lang/String;)V", listener, juuid);
		JNIGlobal::releaseLocalRef(juuid);
	}
}

void
MyDeviceFinderListener::onDeviceUpdated( Sec::Shp::Device& device)
{
	JNISHPDevice *jniDevice = (JNISHPDevice*) (&device) ;
	jobject javaDeviceObject = jniDevice->m_device ;
	JNIGlobal::executeVoidMethod("Sec/Shp/DeviceFinder/IDeviceFinderListener","OnDeviceUpdated","(LSec/Shp/Device;)V",listener,javaDeviceObject);
}

void
MyDeviceFinderListener::onDeviceError( Sec::Shp::Device& device )
{
	JNISHPDevice *jniDevice = (JNISHPDevice*) (&device) ;
	jobject javaDeviceObject = jniDevice->m_device ;
	JNIGlobal::executeVoidMethod("Sec/Shp/DeviceFinder/IDeviceFinderListener","OnDeviceError","(LSec/Shp/Device;)V",listener,javaDeviceObject);
}
