/*
 * MyResourceResponseListener.cpp
 *
 *  Created on: Jun 11, 2013
 *      Author: kirtigupta
 */

#include "MyResourceResponseListener.h"
//#include "Log.h"
#include <jni.h>
#include "Serializable.h"


using namespace std ;

MyResourceResponseListener::MyResourceResponseListener(jobject myListener)
{
	listener = JNIGlobal::getGlobleRef(myListener) ;
	m_reqCount = 1 ;
	forceDeleteOnError = false ;
}

MyResourceResponseListener::~MyResourceResponseListener()
{
	JNIGlobal::releaseGlobleRef(listener) ;
}

void
MyResourceResponseListener::onGetResponseReceived(int clientSessionId, int status, Sec::Shp::Connector::HeadersList& headers,  Sec::Shp::Serialization::ISerializable* response)
{
	/*jclass 		clsSer	= NULL;
	jmethodID	m_constructor 	= NULL;
	jobject		jheaderList = NULL  ;

	//Obtaining Classes
	clsSer = env->FindClass("Sec/Shp/Connector/HeadersList");

	//Obtaining Method IDs
	if (clsSer != NULL)
	{
		m_constructor = env->GetMethodID(clsSer, "<init>", "(J)V");
		jheaderList = env->NewObject(clsSer, m_constructor, (jlong)(&headers));
	}*/
	jobject		jheaderList = NULL  ;

	jheaderList = JNIGlobal::constructObject("Sec/Shp/Connector/HeadersList","(J)V",(jlong)(&headers)) ;

	Serializable *jniSer = (Serializable*) (response) ;

	jobject javaSerObject = NULL ;

	if (jniSer != NULL)
	{
		javaSerObject = jniSer->ser_handler ;
	}


	JNIGlobal::executeVoidMethod("Sec/Shp/Client/Resource/IResourceResponseListener","OnGetResponseReceived","(IILSec/Shp/Connector/HeadersList;LSec/Shp/Serialization/ISerializable;)V",listener, clientSessionId,status,jheaderList,javaSerObject);

	JNIGlobal::releaseLocalRef(jheaderList);
}

void
MyResourceResponseListener::onPutResponseReceived(int clientSessionId, int status, Sec::Shp::Connector::HeadersList& headers, Sec::Shp::Serialization::ISerializable* response)
{
	/*jclass 		clsSer	= NULL;
	jmethodID	m_constructor 	= NULL;
	jobject		jheaderList = NULL  ;

	//Obtaining Classes
	clsSer = env->FindClass("Sec/Shp/Connector/HeadersList");

	//Obtaining Method IDs
	if (clsSer != NULL)
	{
		m_constructor = env->GetMethodID(clsSer, "<init>", "(J)V");
		jheaderList = env->NewObject(clsSer, m_constructor, (jlong)(&headers));
	}
*/
	jobject		jheaderList = NULL  ;

	jheaderList = JNIGlobal::constructObject("Sec/Shp/Connector/HeadersList","(J)V",(jlong)(&headers)) ;

	Serializable *jniSer = (Serializable*) (response) ;
	jobject javaSerObject = NULL ;

	if (jniSer != NULL)
	{
		javaSerObject = jniSer->ser_handler ;
	}

	JNIGlobal::executeVoidMethod("Sec/Shp/Client/Resource/IResourceResponseListener","OnPutResponseReceived","(IILSec/Shp/Connector/HeadersList;LSec/Shp/Serialization/ISerializable;)V",listener, clientSessionId,status,jheaderList,javaSerObject);

	JNIGlobal::releaseLocalRef(jheaderList);
}

void
MyResourceResponseListener::onPostResponseReceived(int clientSessionId, int status, Sec::Shp::Connector::HeadersList& headers,  Sec::Shp::Serialization::ISerializable* response)
{
	/*jclass 		clsSer	= NULL;
	jmethodID	m_constructor 	= NULL;
	jobject		jheaderList = NULL  ;

	//Obtaining Classes
	clsSer = env->FindClass("Sec/Shp/Connector/HeadersList");

	//Obtaining Method IDs
	if (clsSer != NULL)
	{
		m_constructor = env->GetMethodID(clsSer, "<init>", "(J)V");
		jheaderList = env->NewObject(clsSer, m_constructor, (jlong)(&headers));
	}*/

	jobject		jheaderList = NULL  ;

	jheaderList = JNIGlobal::constructObject("Sec/Shp/Connector/HeadersList","(J)V",(jlong)(&headers)) ;

	Serializable *jniSer = (Serializable*) (response) ;
	jobject javaSerObject = NULL ;

	if (jniSer != NULL)
	{
		javaSerObject = jniSer->ser_handler ;
	}

	JNIGlobal::executeVoidMethod("Sec/Shp/Client/Resource/IResourceResponseListener","OnPostResponseReceived","(IILSec/Shp/Connector/HeadersList;LSec/Shp/Serialization/ISerializable;)V",listener, clientSessionId,status,jheaderList,javaSerObject);

	JNIGlobal::releaseLocalRef(jheaderList);
}

void
MyResourceResponseListener::onDeleteResponseReceived(int clientSessionId, int status, Sec::Shp::Connector::HeadersList& headers, Sec::Shp::Serialization::ISerializable* response)
{
	/*jclass 		clsSer	= NULL;
	jmethodID	m_constructor 	= NULL;
	jobject		jheaderList = NULL  ;

	//Obtaining Classes
	clsSer = env->FindClass("Sec/Shp/Connector/HeadersList");

	//Obtaining Method IDs
	if (clsSer != NULL)
	{
		m_constructor = env->GetMethodID(clsSer, "<init>", "(J)V");
		jheaderList = env->NewObject(clsSer, m_constructor, (jlong)(&headers));
	}*/
	jobject		jheaderList = NULL  ;

	jheaderList = JNIGlobal::constructObject("Sec/Shp/Connector/HeadersList","(J)V",(jlong)(&headers)) ;

	Serializable *jniSer = (Serializable*) (response) ;

	jobject javaSerObject = NULL ;

	if (jniSer != NULL)
	{
		javaSerObject = jniSer->ser_handler ;
	}

	JNIGlobal::executeVoidMethod("Sec/Shp/Client/Resource/IResourceResponseListener","onDeleteResponseReceived","(IILSec/Shp/Connector/HeadersList;LSec/Shp/Serialization/ISerializable;)V",listener, clientSessionId,status,jheaderList,javaSerObject);

	JNIGlobal::releaseLocalRef(jheaderList);
}

void
MyResourceResponseListener::onSubscribeResponseReceived( int clientSessionId, int status, std::string& subscriptionUri )
{
	jstring jsubsriptionUri = JNIGlobal::convertToJString(subscriptionUri);
	JNIGlobal::executeVoidMethod("Sec/Shp/Client/Resource/IResourceResponseListener","onSubscribeResponseReceived","(IILjava/lang/String;)V",listener, clientSessionId,status, jsubsriptionUri);

	JNIGlobal::releaseLocalRef(jsubsriptionUri);
}

void
MyResourceResponseListener::onUnSubscribeResponseReceived(int clientSessionId, int status )
{
	JNIGlobal::executeVoidMethod("Sec/Shp/Client/Resource/IResourceResponseListener","onUnSubscribeResponseReceived","(II)V",listener, clientSessionId,status);
}

void
MyResourceResponseListener::onErrorReceived(int clientSessionId, int statusCode, Sec::Shp::SHPError error, Sec::Shp::Serialization::ISerializable* errorResponse)
{
	//JNIEnv* pEnv = JNIGlobal::getEnv(true, isAttached) ;

	jobject jErrorObject = JNIGlobal::getEnum("Sec/Shp/SHPErrorCode", "getErrorCode", "(I)LSec/Shp/SHPErrorCode;" , (int)error.getErrorCode());

	// find class(I)LSec/Shp/SHPErrorCode;
//	ClsErrorCode = pEnv->FindClass("Sec/Shp/SHPErrorCode");

	// find static method
//	if (ClsErrorCode != NULL)
//	{
//		m_getErrorCode = pEnv->GetStaticMethodID(ClsErrorCode,"getErrorCode", "(I)LSec/Shp/SHPErrorCode;");
//	}

	// invoke method
	//jobject jErrorObject = pEnv->CallStaticObjectMethod(ClsErrorCode,m_getErrorCode,jdomain);

	if (forceDeleteOnError)
	{
		m_reqCount = 1 ;
	}

	Serializable *jniSer = (Serializable*) (errorResponse);

	jobject javaSerObject = NULL ;

	if (jniSer != NULL)
	{
		javaSerObject = jniSer->ser_handler ;
	}

	jstring errMsg = JNIGlobal::convertToJString(error.getErrorMessage()) ;
	JNIGlobal::executeVoidMethod("Sec/Shp/Client/Resource/IResourceResponseListener","onErrorReceived","(IILSec/Shp/SHPErrorCode;Ljava/lang/String;LSec/Shp/Serialization/ISerializable;)V",listener, clientSessionId, statusCode, jErrorObject, errMsg, javaSerObject);

	JNIGlobal::releaseLocalRef(errMsg);
	JNIGlobal::releaseLocalRef(jErrorObject);
}

void 
MyResourceResponseListener::onRequestComplete(int requestId, std::string requestPayload,  std::string responsePayload)
{
	bool 	isAttached 		= false ;
	JNIEnv* pEnv = JNIGlobal::getEnv(true, isAttached) ;
	if (NULL == pEnv)
	{
		return ;
	}

	const char* stringRequestPayload = requestPayload.c_str();
	jstring jrequestPayload = pEnv->NewStringUTF(stringRequestPayload);

	const char* stringResponsePayload = responsePayload.c_str();
	jstring jresponsePayload = pEnv->NewStringUTF(stringResponsePayload);

	JNIGlobal::executeVoidMethod("Sec/Shp/Client/Resource/IResourceResponseListener","onRequestComplete","(ILjava/lang/String;Ljava/lang/String;)V", listener, requestId,jrequestPayload, jresponsePayload);
	m_reqCount = m_reqCount - 1 ;

	if (m_reqCount <= 0)
	{
		delete this ;
	}

	JNIGlobal::releaseLocalRef(jrequestPayload);
	JNIGlobal::releaseLocalRef(jresponsePayload);
}

void
MyResourceResponseListener::setRequestCount(int reqCount)
{
	m_reqCount = reqCount ;
}


