/*
 * MyResourceResponseListener.h
 *
 * Created on: Jun 11, 2013
 * Author: kirtigupta
 */

#ifndef MYRESOURCERESPONSELISTENER_H_
#define MYRESOURCERESPONSELISTENER_H_

#include "SHPClientResource.h"
#include "JNIGlobal.h"
#include <jni.h>

using namespace std;

class MyResourceResponseListener :public Sec::Shp::Client::Resource::IResourceResponseListener
{
public:
    MyResourceResponseListener(jobject myListener);

    virtual ~MyResourceResponseListener();

    virtual void onGetResponseReceived(int clientSessionId, int status, Sec::Shp::Connector::HeadersList& headers, Sec::Shp::Serialization::ISerializable* response);

    virtual void onPutResponseReceived(int clientSessionId, int status, Sec::Shp::Connector::HeadersList& headers, Sec::Shp::Serialization::ISerializable* response);

    virtual void onPostResponseReceived(int clientSessionId, int status, Sec::Shp::Connector::HeadersList& headers, Sec::Shp::Serialization::ISerializable* response);

    virtual void onDeleteResponseReceived(int clientSessionId, int status, Sec::Shp::Connector::HeadersList& headers, Sec::Shp::Serialization::ISerializable* response);

    virtual void onSubscribeResponseReceived(int clientSessionId, int status, std::string& subscriptionUri);

    virtual void onUnSubscribeResponseReceived(int clientSessionId, int status);

    virtual void onErrorReceived(int clientSessionId, int statusCode, Sec::Shp::SHPError error, Sec::Shp::Serialization::ISerializable* errorResponse);

    virtual void onRequestComplete(int requestId, std::string requestPayload,  std::string responsePayload);

    void setRequestCount(int reqCount);

    bool forceDeleteOnError;

private:
    jobject listener;

    int m_reqCount;
};

#endif /* MYRESOURCERESPONSELISTENER_H_ */
