/*
 * MySHPListener.h
 *
 *  Created on: Jul 5, 2013
 *      Author: kirtigupta
 */

#ifndef MYSHPLISTENER_H_
#define MYSHPLISTENER_H_

#include "ISHPListener.h"
#include "JNIGlobal.h"
#include <jni.h>

using namespace std ;

class MySHPListener : public Sec::Shp::ISHPListener  {
public:

	MySHPListener(jobject mylistener);

	virtual ~MySHPListener();

	void onStarted(std::string address);

	void onStopped();

	void onError(Sec::Shp::SHPError error);

	std::string getMyDeviceToken(void);
	void updateUUIDAndTokenMap(std::string, std::string);
	void tokenRequestNotification(std::string uuid);
	void easySetupNotification(int notif);

	std::string getCurrentTimeStamp() ;
	void onDeviceTokenCancelled(std::string,std::string);

#ifdef REMOTE_ACCESS_SUPPORT
	void scsErrorNotification(int errorCode);
	void onChannelCreated(std::string channelName, int connID);
	std::string getAuthCode();
	std::string getAccessToken();
	std::string getRefreshToken();
	std::string getUserID();
#endif /* REMOTE_ACCESS_SUPPORT */

private:

	jobject listener;
};

#endif /* MYSHPLISTENER_H_ */
