/*
 * SHPDeviceFactory.cpp
 *
 *  Created on: Jul 7, 2013
 *      Author: kirtigupta
 */

#include "SHPDeviceFactory.h"
#include "Sec_Shp_Device.h"
#include "JNISHPDev.h"
#include "JNIGlobal.h"

using namespace std ;

SHPDeviceFactory::SHPDeviceFactory(jobject obj)
{
	this->m_deviceFactoryObj = JNIGlobal::getGlobleRef(obj) ;
}

SHPDeviceFactory::~SHPDeviceFactory() {
	JNIGlobal::executeVoidMethod("Sec/Shp/DeviceFinder/DeviceFactory", "onNativeDelete", "()V", m_deviceFactoryObj);
	JNIGlobal::releaseGlobleRef(m_deviceFactoryObj) ;
}

Sec::Shp::Device*
SHPDeviceFactory::createDevice(Sec::Shp::DeviceType type,Sec::Shp::DeviceDomain domain)
{
	jobject jdomain = JNIGlobal::getEnum("Sec/Shp/DeviceDomain", "getDeviceDomain", "(I)LSec/Shp/DeviceDomain;" , (int)domain);
	jobject jdeviceType = JNIGlobal::getEnum("Sec/Shp/DeviceType", "getDeviceType", "(I)LSec/Shp/DeviceType;" , (int)type);
	
	jlong device = JNIGlobal::executeLongMethod("Sec/Shp/DeviceFinder/DeviceFactory", "createDevice",
									"(LSec/Shp/DeviceType;LSec/Shp/DeviceDomain;)J", m_deviceFactoryObj , jdeviceType, jdomain);

	JNIGlobal::releaseLocalRef(jdomain);
	JNIGlobal::releaseLocalRef(jdeviceType);

	return (Sec::Shp::Device*)device ;
}
