/*
 * SHPJNISubscriptionProviderImpl.cpp
 *
 *  Created on: Sep 24, 2013
 *      Author: bhupathi.r
 */

#include "SHPJNISubscriptionProviderImpl.h"
#include "IContext.h"
#include "JNIGlobal.h"
#include "JNISHPDev.h"

SHPJNISubscriptionProviderImpl::SHPJNISubscriptionProviderImpl(jobject provider) {
	mProvider = JNIGlobal::getGlobleRef(provider) ;
}

SHPJNISubscriptionProviderImpl::~SHPJNISubscriptionProviderImpl() {
	JNIGlobal::releaseGlobleRef(mProvider) ;
}


bool
SHPJNISubscriptionProviderImpl::shouldAllowSubscriptionRequest( Sec::Shp::Device& device, std::string& resourcePath )
{
	bool isAttached = false ;

	JNIEnv *pEnv = JNIGlobal::getEnv(true, isAttached) ;
	if (NULL == pEnv)
	{
		return false;
	}

	JNISHPDevice *jniDevice = (JNISHPDevice*) (&device) ;
	jobject javaDeviceObject = jniDevice->m_device ;

	const char* cResourcePath = resourcePath.c_str();
	jstring javaResourceStr = pEnv->NewStringUTF(cResourcePath);


	jboolean retValue = JNIGlobal::executeBoolMethod("Sec/Shp/Notification/ISubscriptionProvider", "shouldAllowSubscriptionRequest",
			"(LSec/Shp/Device;Ljava/lang/String;)Z", javaDeviceObject, javaResourceStr) ;

	if ( isAttached )
	{
		JNIGlobal::detachCurrentThread() ;
	}

	return (retValue == JNI_TRUE);
}
