/*
 * SHPResourceHandler.cpp
 *
 *  Created on: Jul 8, 2013
 *      Author: kirtigupta
 */

#include "SHPResourceHandler.h"
#include "JNIGlobal.h"
#include "Serializable.h"
#include "iostream"
#include "Log.h"

using namespace std ;

#define CLASS_NAME "SHPResourceHandler"

SHPResourceHandler::SHPResourceHandler(jlong context, jobject handler)
:Sec::Shp::Server::ResourceHandler::SyncResourceHandler((Sec::Shp::IContext *) context)
{
	//res_handler = JNIGlobal::getGlobleRef(handler) ;
	res_handler = (handler) ;
}

SHPResourceHandler::~SHPResourceHandler() {
	JNIGlobal::releaseGlobleRef(res_handler) ;
}

bool
SHPResourceHandler::handleSyncResource( Sec::Shp::Connector::Server::ServerSession& session,
									 std::string& methodId,
									 int& statusCode,
									 Sec::Shp::Serialization::ISerializable*  request,
									 Sec::Shp::Serialization::ISerializable*  response)
{
	SHP_LOG_DEBUG_A(SHP_JNI, "%s", "Enter");

	bool isAttached = false ;

	JNIEnv *pEnv = JNIGlobal::getEnv(true, isAttached) ;
	if (NULL == pEnv)
	{
		return false;
	}

	jobject		jserverSesison = NULL  ;

	jserverSesison = JNIGlobal::constructObject("Sec/Shp/Connector/Server/ServerSession","(JJ)V",(jlong)(&session), (jlong)p_context) ;

	//Serializable *jniReq = (Serializable*) (&request) ;
//	Serializable *jniResp = (Serializable*) (&response) ;
	jobject reqObj = NULL ;
	jobject respObj = NULL ;

	if (request != NULL)
	{
		SHP_LOG_DEBUG_A(SHP_JNI, "%s", "Request object is not NULL");

		reqObj = ((Serializable*) (request))->ser_handler ;

		if (reqObj == NULL)
			SHP_LOG_DEBUG_A(SHP_JNI, "%s", "Java request object is NULL");
	}

	if (response != NULL)
	{
		SHP_LOG_DEBUG_A(SHP_JNI, "%s", "Response object is not NULL");

		respObj = ((Serializable*) (response))->ser_handler ;

		if (respObj == NULL)
			SHP_LOG_DEBUG_A(SHP_JNI, "%s", "Java response object is NULL");
	}

	const char* stringGetAdd = methodId.c_str();

	jstring jmethod = pEnv->NewStringUTF(stringGetAdd);

	if ( isAttached )
	{
		JNIGlobal::detachCurrentThread() ;
	}

	SHP_LOG_DEBUG_A(SHP_JNI, "%s", "Invoking");

	statusCode = JNIGlobal::executeIntMethod("Sec/Shp/Server/ResourceHandler/IResourceHandler","handleSyncResource","(LSec/Shp/Connector/Server/ServerSession;Ljava/lang/String;LSec/Shp/Serialization/ISerializable;LSec/Shp/Serialization/ISerializable;)I", res_handler,
								jserverSesison, jmethod, reqObj, respObj);

	JNIGlobal::releaseLocalRef(jserverSesison);

	return true ; // TODO: handle Exceptions
}



//
//bool
//SHPResourceHandler::onInit()
//{
//	return JNIGlobal::executeBoolMethod("Sec/Shp/Server/ResourceHandler/IResourceHandler","onInit","(J)Z", res_handler);
//}
//
//bool
//SHPResourceHandler::onDeinit()
//{
//	return JNIGlobal::executeBoolMethod("Sec/Shp/Server/ResourceHandler/IResourceHandler","onDeinit", "(J)Z", res_handler);
//}
//
//bool
//SHPResourceHandler::handleResource( Sec::Shp::Connector::Server::ServerSession& session,std::string methodId,Sec::Shp::Serialization::ISerializable* request,
//								Sec::Shp::Serialization::ISerializable* response)
//{
//	/*jclass 		clsSer	= NULL;
//	jmethodID	m_constructor 	= NULL;
//	jobject		jserverSesison = NULL  ;
//
//	//Obtaining Classes
//	clsSer = env->FindClass("Sec/Shp/Connector/Server/ServerSession");
//
//	//Obtaining Method IDs
//	if (clsSer != NULL)
//	{
//		m_constructor = env->GetMethodID(clsSer, "<init>", "(J)V");
//		jserverSesison = env->NewObject(clsSer, m_constructor, (jlong)(&session));
//	}
//*/
//	bool isAttached = false ;
//
//	JNIEnv *pEnv = JNIGlobal::getEnv(true, isAttached) ;
//
//	jobject		jserverSesison = NULL  ;
//
//	jserverSesison = JNIGlobal::constructObject("Sec/Shp/Connector/Server/ServerSession","(J)V",(jlong)(&session)) ;
//
//	Serializable *jniReq = (Serializable*) (&request) ;
//	Serializable *jniResp = (Serializable*) (&response) ;
//
//	const char* stringGetAdd = methodId.c_str();
//
//	jstring jmethod = pEnv->NewStringUTF(stringGetAdd);
//
//	if ( isAttached )
//	{
//		JNIGlobal::detachCurrentThread() ;
//	}
//
//	return JNIGlobal::executeBoolMethod("Sec/Shp/Server/ResourceHandler/IResourceHandler","handleResource","(JJLSec/Shp/Connector/Server/ServerSession;Ljava/lang/String;LSec/Shp/Serialization/ISerializable;LSec/Shp/Serialization/ISerializable;)Z",res_handler,
//								jserverSesison, jmethod, jniReq->ser_handler, jniResp->ser_handler);
//}
