/*
 * SHPResourceHandlerFactory.cpp
 *
 *  Created on: Jul 8, 2013
 *      Author: kirtigupta
 */

#include "SHPResourceHandlerFactory.h"
#include "SHPResourceHandler.h"


using namespace std ;

SHPResourceHandlerFactory::SHPResourceHandlerFactory(jobject dataFactoryObj)
{
	m_resHandlerObj = JNIGlobal::getGlobleRef(dataFactoryObj) ;
	context = (jlong)0; ;
}

void
SHPResourceHandlerFactory::setContext(jlong context)
{
	this->context = context ;
}

SHPResourceHandlerFactory::~SHPResourceHandlerFactory()
{
	JNIGlobal::executeVoidMethod("Sec/Shp/Server/ResourceHandler/ResourceHandlerFactory", "onNativeDelete", "()V", m_resHandlerObj);
	JNIGlobal::releaseGlobleRef(m_resHandlerObj) ;
}

int
SHPResourceHandlerFactory::getResourceType( const char* path, std::map<std::string, std::string>& templateParams ) 
{
	int resourceType = -1 ;

	if (-1 == resourceType)
	{
		resourceType = Sec::Shp::Server::ResourceHandler::ResourceHandlerFactory::getResourceType(path, templateParams);
	}

	return resourceType;
}

Sec::Shp::Server::ResourceHandler::IResourceHandler*
SHPResourceHandlerFactory::createResourceHandler(int resourceType)
{
	Sec::Shp::Server::ResourceHandler::IResourceHandler* pResourceHandler= NULL ;
	if ( NULL == pResourceHandler)
	{
		jobject phandler = (jobject)JNIGlobal::executeLongMethod("Sec/Shp/Server/ResourceHandler/ResourceHandlerFactory", "createResourceHandler", "(I)J", m_resHandlerObj, resourceType);
		if(phandler == NULL)
		{
			return NULL ;
		}

		pResourceHandler = new SHPResourceHandler(context, phandler) ;
	}

	return pResourceHandler;
}

