/*
 * SHPSerializableDataFactory.cpp
 *
 *  Created on: Jul 3, 2013
 *      Author: kirtigupta
 */

#include "SHPSerializableDataFactory.h"


using namespace std ;

SHPSerializableDataFactory::SHPSerializableDataFactory(jobject dataFactoryObj)
{
	m_dataFactoryObj = JNIGlobal::getGlobleRef(dataFactoryObj) ;
}

SHPSerializableDataFactory::~SHPSerializableDataFactory() {
	JNIGlobal::executeVoidMethod("Sec/Shp/Serialization/SerializableDataFactory", "onNativeDelete", "()V", m_dataFactoryObj);
	JNIGlobal::releaseGlobleRef(m_dataFactoryObj) ;
}

bool
SHPSerializableDataFactory::createRequestSerializable( int resourceType, std::string& methodId, Sec::Shp::Serialization::ISerializable** pp_output )
{
	jstring jstrMethodId = JNIGlobal::convertToJString(methodId) ;

//	jlong lSerializable = JNIGlobal::executeLongMethod("Sec/Shp/Serialization/SerializableDataFactory", "getRequestSerializable", "(ILjava/lang/String;)J", m_dataFactoryObj, resourceType, jstrMethodId);
//	*pp_output = (Sec::Shp::Serialization::ISerializable*)lSerializable ;

	jobject pSerializable = JNIGlobal::executeObjectMethod("Sec/Shp/Serialization/SerializableDataFactory","createRequestSerializable","(ILjava/lang/String;)LSec/Shp/Serialization/ISerializable;",m_dataFactoryObj, resourceType, jstrMethodId);

	if (NULL != pSerializable)
	{
		jlong lSerializable = JNIGlobal::executeLongMethod("Sec/Shp/Serialization/ISerializable", "getNativeHandle", "()J", pSerializable) ;

		*pp_output = (Sec::Shp::Serialization::ISerializable*)lSerializable ;

#ifdef __ANDROID__
		JNIGlobal::releaseLocalRef(pSerializable);
#endif

	}
	else
	{
		*pp_output = NULL ;
	}

	JNIGlobal::releaseLocalRef(jstrMethodId) ;
	return true ;
}

bool
SHPSerializableDataFactory::createResponseSerializable( int resourceType, std::string& methodId, Sec::Shp::Serialization::ISerializable** pp_output )
{
	jstring jstrMethodId = JNIGlobal::convertToJString(methodId) ;

//	jlong lSerializable = JNIGlobal::executeLongMethod("Sec/Shp/Serialization/SerializableDataFactory", "getResponseSerializable", "(ILjava/lang/String;)J", m_dataFactoryObj, resourceType, jstrMethodId);
//	*pp_output = (Sec::Shp::Serialization::ISerializable*)lSerializable ;

	jobject pSerializable =  JNIGlobal::executeObjectMethod( "Sec/Shp/Serialization/SerializableDataFactory","createResponseSerializable","(ILjava/lang/String;)LSec/Shp/Serialization/ISerializable;", m_dataFactoryObj, resourceType, jstrMethodId );
	if (NULL != pSerializable)
	{
		jlong lSerializable = JNIGlobal::executeLongMethod( "Sec/Shp/Serialization/ISerializable", "getNativeHandle", "()J", pSerializable ) ;
		*pp_output = (Sec::Shp::Serialization::ISerializable*)lSerializable ;

#ifdef __ANDROID__
		JNIGlobal::releaseLocalRef(pSerializable);
#endif

	}
	else
	{
		*pp_output = NULL ;
	}

	JNIGlobal::releaseLocalRef(jstrMethodId) ;
	return true ;
}


bool
SHPSerializableDataFactory::createMethodSerializables( int resourceType, std::string& methodId,
															Sec::Shp::Serialization::ISerializable** pp_request,
															Sec::Shp::Serialization::ISerializable** pp_response )
{
	bool bRet = false ;

	if (false == bRet)
	{
		bRet = this->createRequestSerializable(resourceType, methodId, pp_request) ;

		if (bRet == true)
		{
			bRet = this->createResponseSerializable(resourceType, methodId, pp_response) ;
		}
	}

	return bRet ;
}

bool
SHPSerializableDataFactory::createSerializable( std::string& elementType, Sec::Shp::Serialization::ISerializable** pp_output )
{
	jstring jstrElementType = JNIGlobal::convertToJString( elementType ) ;

//	jlong lSerializable = JNIGlobal::executeLongMethod( "Sec/Shp/Serialization/SerializableDataFactory", "getSerializable", "(Ljava/lang/String;)J",m_dataFactoryObj, jstrElementType);
//	*pp_output = (Sec::Shp::Serialization::ISerializable*)lSerializable ;

	jobject pSerializable = JNIGlobal::executeObjectMethod("Sec/Shp/Serialization/SerializableDataFactory", "createSerializable", "(Ljava/lang/String;)LSec/Shp/Serialization/ISerializable;", m_dataFactoryObj, jstrElementType);
	if ( NULL != pSerializable )
	{
		jlong lSerializable = JNIGlobal::executeLongMethod( "Sec/Shp/Serialization/ISerializable", "getNativeHandle", "()J", pSerializable ) ;
		*pp_output = (Sec::Shp::Serialization::ISerializable*)lSerializable ;

#ifdef __ANDROID__
		JNIGlobal::releaseLocalRef(pSerializable);
#endif

	}
	else
	{
		*pp_output = NULL ;
	}

	JNIGlobal::releaseLocalRef(jstrElementType) ;
	return true;
}
