var app = angular.module("SmartThings", ['toaster', 'ngSanitize', 'angular-svg-round-progress']);
var myScope;
var WASHERSCREENS = {
    HOME: 1,
    DETAILPAGE: 2,
    SETTINGS: 3,
    OPTIONS: 4,
    SMARTCARE: 5,
    ALARMSCREEN: 6,
    CYCLEFINISH: 7,
    ERRORTEXT: 8,
    ENERGYMONITOR: 9,
    SMARTCAREERROR: 10,
    ADDWASHPAGE: 11,
    LAUNDRYOUTPAGE: 12,
    TUTORIALPAGE: 13,
    DETAILEDTUTORIALPAGE: 14,
    MYFAVORITE: 15,
    ADDFAVORITE: 16,
    CYCLEMYFAVORITE: 17,
    KOREANCOMBOSETTINGPAGE: 18
};

var WASHER_DEVICEINFO = {
    WasherKor: "0121", //Drum Washer:Korea							
    DryerElecEng: "0132", //Dryer:US	
    DryerGasEng: "0142", //Dryer - Gas:US
    WasherDrumKor: "0151", //Drum Washer:Korea	
    DryerElecUs: "0152", //Dryer:US
    DryerGasUs: "0153", //GasDryer:US	
    WasherDrumUs: "0154", //DrumWasher:US
    DryerEu: "0155", //Dryer:Erope			
    DryerGasEu: "0156", //Dryer:GAS - Erope
    /**			
     * DrumWasher:Erope <br/>			
     * 중소형 Non LED:F900E			
     */
    WasherDrumEu: "0157",
    DryerAu: "0158", //Dryer:Austrailia
    DryerGasAu: "0159", //Dryer:GAS-Austrailia	
    WasherAu: "0160", //DrumWasher:Austrailia
    WasherSmallKor: "0161", //Medium size Drum Washer:Korea	
    DryerSmallEng: "0162", //Medium size Drum Dryer:America	
    WasherSmallGasEng: "0163", //Medium size Drum:Gas Washer:America
    WasherSmallEng: "0164", //Medium size Drum Washer:America	
    DryerSmallEu: "0165", //Medium size Drum Dryer:Europe	
    DryerSmallGasEu: "0166", //Medium size Drum:Gas Dryer:Europe
    WasherSmallEu: "0167", //Medium size Drum Washer:Europe	
    DryerSmallAu: "0168", //Medium size Drum Dryer:Australia
    DryerSmallGasAu: "0169", //Medium size Drum Dryer:Australia
    WasherSmallAu: "0170", //Medium size Drum Washer:Australia		
    Unknown: "01FF", //Unknown
    TopLoadUS: "0145" //TopLoader Washer:US
};

var WASHER_DEVICEMODES = {
    'Notused': '00',
    'Normal': '01',
    'PowerBubble': '02',
    'Sanitize': '03',
    'Bedding': '04',
    'BubbleEco': '05',
    'WoolLingerie': '06',
    'QuickWash': '07',
    'BabyCare': '08',
    'BubbleSports': '09',
    'NightWash': '0A',
    'AirRefresh': '0B',
    'AirSanitize': '0C',
    'AirBeddingCare': '0D',
    'HeavyDuty': '0E',
    'BeddingPLUS': '0F',
    'ecoCold': '10',
    'Wool': '11',
    'Nursery': '12',
    'DEEPSTEAM': '13',
    'StainAway': '14',
    'PermPress': '15',
    'ActiveWear': '16',
    'DelicatesHandWash': '17',
    'PureCycle': '18',
    'RinseSpin': '19',
    'SpinOnly': '1A',
    'DiningKitchenwork': '1B',
    'GardeningNMachinery': '1C',
    'PicnicCamping': '1D',
    'Kidswear': '1E',
    'DeskOffice': '1F',
    'GarageMachinery': '20',
    'Towel': '21',
    'EcoNormal': '22',
    'Delicates': '23',
    'TimeDry': '24',
    'QuickDry': '25',
    'AirFluff': '26',
    'Refresh': '27',
    'WrinkleAway': '28',
    'OneStopBubble': '29',
    'Soak': '2A',
    'SportsBubble': '2B',
    'Synthetics': '2C',
    'WaterSaving': '2D',
    'DryOnly': '2E',
    'Cotton': '2F',
    'Denim': '30',
    'DarkGarment': '31',
    'DailyWash': '32',
    'EcoDrumClean': '33',
    'SuperEcoWash': '34',
    'OutdoorCare': '35',
    'HandWash': '36',
    'BabyBubble': '37',
    'EcoBubble': '38',
    'DryDrum': '39',
    'Bedding2': '3A',
    'Spin': '3B',
    'SmartWashTM': '3E',
    'CottonEco': '3F',
    'GoretexRefresh': '40',
    'Gardening': '41',
    'ActiveSports': '42',
    'HygieneCare': '43',
    'IntensiveCold': '44',
    'DrumClean': '45',
    'ECotton': '46',
    'SuperSpeed': '47',
    'Delicates2': '48',
    'Cooking': '49',
    'Everyday': '4A',
    'Sportswear': '4B',
    'KidsWear2': '4C',
    'Shirts': '4D',
    'Deodorization': '4E',
    'Sanitization': '4F',
    'CottonDry': '50',
    'SyntheticsDry': '51',
    'OutdoorWaterCare': '52',
    'PaddingCare': '53',
    'Allergen': '54',
    'Whites': '55',
    'Towels': '56',
    'SelfClean': '57',
    'WashandWear': '58',
    'BeddingCare': '59',
    'NotSupported': 'FD',
    'Unknown': 'FE',
    'NULL': 'FF',
    'Cotton1': '5B',
    'Superspeed1': '5C',
    'SuperEcoWash1': '5D',
    'Delicates1': '5E',
    'BabyCare1': '5F',
    'OutdoorCare1': '60',
    'DarkGarment1': '61',
    'SpecialityCare': '62',
    'EcoDrumClean1': '63',
    'RinseSpin1': '64',
    'Wool1': '65',
    'Bedding1': '66',
    'Synthetics1': '67',
    'ECotton1': '68',
    'IntensiveCold1': '69',
    'DOWNJACKET': '6A',
    'Spin1': '6B',
    'Denim1': '6C',
    'DrumClean1': '6D',
    'ECotton2': '6E',
    'SteamSanitize_US': '6F',
    'HeavyDuty_US': '70',
    'Bedding_US': '71',
    'Sanitize_US': '72',
    'RinseSpin_US': '73',
    'ActiveWear_US': '74',
    'Delicates_US': '75',
    'Wool_US': '76',
    'PremPress_US': '77',
    'QuickWash_US': '78',
    'EcoCold_US': '79',
    'DeepSteam_US': '7A',
    'StainAway_US': '7B',
    'WrinkleAway_US': '7C',
    'Refresh_US': '7D',
    'AirFluff_US': '7E',
    'TimeDry_US': '7F',
    'QuickDry_US': '80',
    'EcoNormal_US': '81',
    'SuperSpeed_US': '8C',
    'DeepWash_US': '8D',
    'BrilliantWhites_US': '8E',
    'BeddingWaterProof_US': '8F',
    'Spin_US': '90',
    'SelfClean_US': '91',
    'AirWash_US': '92',
    'IronDry_US': '93',
    'Towels_US': '94',
    'Time_Dry_US': '95',
    'CoolAir_US': '96',
    'WarmAir_US': '97',
    'QuickDry35_US': '98',
    'Mix_US': '99',
    'Cotton_US': '9A',
    'Steam_Sanitize_US': '9B',
    'Heavy_Duty_US': '9C',
    'Rinse+Spin_US': '9D',
    'Perm_Press_US': '9E',
    'Quick_Wash_US': '9F',
    'Air_Fluff_US': 'A0',
    'Wrinkle_Away_US': 'A1',
    'Delicates_17_US': 'A2',
    'Active_Wear_US': 'A3',
    'Time_Dry_17_US': 'A4',
    'Bedding_17_US': 'A5',
    'Quick_Dry_US': 'A6',
    'Sanitize_17_US': 'A9',
    'Whites_17_US': 'AA',
    'EcoCold_17_US': 'AB',
    'Normal_17': 'AC',
    'ShirtBlouse_17_US': 'AD',
    'Undergarment_17_US': 'AE',
    'Sweater_17_US': 'AF',
    'Accessory_17_US': 'B0',
    'SelfClean_17_US': 'B1',
    'AirRefreshSanitize_17': 'B2',
    'OutdoorCare_17_EUROPE': 'B4',
    'Wool_17_EUROPE': 'B5',
    'Synthetics_17_EUROPE': 'B6',
    'SelfClean_17_FLEXGLOBAL': 'B7',
    'Drying_UAE_17_FLEXGLOBAL': 'B8',
    'RinseSpin_17_FLEXGLOBAL': 'B9',
    'PermPress_17_FLEXGLOBAL': 'BA',
    'QuickWash_17_FLEXGLOBAL': 'BB',
    'Delicates_17_FLEXGLOBAL': 'BC',
    'SteamSanitize_17_FLEXGLOBAL': 'BD',
    'Cotton_17_FLEXGLOBAL': 'BE',
    'Wool_17_FLEXGLOBAL': 'BF',
    'WashWear_17_FLEXGLOBAL': 'C0',
    'PowerBubble_17_FLEXGLOBAL': 'C1',
    'BabyCare_17_FLEXGLOBAL': 'C2',
    'Outdoor_17_FLEXGLOBAL': 'C3',
    'EcoTubClean_17_FLEXGLOBAL': 'C4',
    'AirBeddingCare_17_FLEXGLOBAL': 'C5',
    'DryingDrum_17_FLEXGLOBAL': 'C6',
    'EcoDrumClean_17_FLEXGLOBAL': 'C7',
    'TubClean_17_FLEXGLOBAL': 'C8',
    '59WashDry_17_EUROPE': 'C9',
    'AirWash_17_EUROPE': 'CA',
    '15QuickWash_17_EUROPE': 'CB',
    'BabyCare_17_EUROPE': 'CC',
    'OutdoorCare17_EUROPE': 'CD',
    'Bedding_17_FLEXGLOBAL': 'CE',
    'Drying_17_FLEXGLOBAL': 'CF'

};

var WASHERTOUPDATE = {
    NONE: 0,
    SINGLEWASHER: 1,
    MAINWASHER: 2,
    SUBWASHER: 3
};

var WASHERCURRENTSEL = {
    NONE: 0,
    SUB_SELECTED: 1,
    MAIN_SELECTED: 2
};

var WASHER_TEMP = {
    "TAPCOLD": "WEBMOB_device_washer_option_temp_tapcold",
    "COLD": "WEBMOB_device_washer_option_temp_cold",
    "COOL": "WEBMOB_device_washer_option_temp_cool",
    "EcoWarm": "WEBMOB_device_washer_option_temp_ecowarm",
    "Warm": "WEBMOB_device_washer_option_temp_warm",
    "Hot": "WEBMOB_device_washer_option_temp_hot",
    "ExtraHot": "WEBMOB_device_washer_option_temp_extrahot",
    "ExtraLow": "WEBMOB_device_washer_option_temp_extralow",
    "Low": "WEBMOB_device_washer_option_temp_low",
    "MediumLow": "WEBMOB_device_washer_option_temp_mediumlow",
    "Medium": "WEBMOB_device_washer_option_temp_medium",
    "High": "WEBMOB_device_washer_option_temp_high",
    "T20": "WEBMOB_device_washer_option_temp_20",
    "T30": "WEBMOB_device_washer_option_temp_30",
    "T40": "WEBMOB_device_washer_option_temp_40",
    "T50": "WEBMOB_device_washer_option_temp_50",
    "T60": "WEBMOB_device_washer_option_temp_60",
    "T65": "WEBMOB_device_washer_option_temp_65",
    "T70": "WEBMOB_device_washer_option_temp_70",
    "T75": "WEBMOB_device_washer_option_temp_75",
    "T80": "WEBMOB_device_washer_option_temp_80",
    "T90": "WEBMOB_device_washer_option_temp_90",
    "T95": "WEBMOB_device_washer_option_temp_95",
    "None": "-"
};

var WASHER_SPIN = {
    None: "WEBMOB_device_washer_option_spin_none",
    NoSpin: "WEBMOB_device_washer_option_spin_no",
    Low: "WEBMOB_device_washer_option_spin_low",
    Medium: "WEBMOB_device_washer_option_spin_medium",
    High: "WEBMOB_device_washer_option_spin_high",
    ExtraHigh: "WEBMOB_device_washer_option_spin_extrahigh",
    RinseHold: "WEBMOB_device_washer_option_spin_none",
    S200: "WEBMOB_device_washer_option_spin_200",
    S400: "WEBMOB_device_washer_option_spin_400",
    S600: "WEBMOB_device_washer_option_spin_600",
    S800: "WEBMOB_device_washer_option_spin_800",
    S1000: "WEBMOB_device_washer_option_spin_1000",
    S1200: "WEBMOB_device_washer_option_spin_1200",
    S1400: "WEBMOB_device_washer_option_spin_1400",
    S1600: "WEBMOB_device_washer_option_spin_1600"
};

var WASHER_RINSE = {
    R0: "WEBMOB_device_washer_option_rinse_no",
    R1: "WEBMOB_device_washer_option_rinse_1",
    R2: "WEBMOB_device_washer_option_rinse_2",
    R3: "WEBMOB_device_washer_option_rinse_3",
    R4: "WEBMOB_device_washer_option_rinse_4",
    R5: "WEBMOB_device_washer_option_rinse_5"
};

var WASHER_SOIL = {
    "ExtraHeavy": "WEBMOB_device_washer_option_soil_extraheavy",
    "Heavy": "WEBMOB_device_washer_option_soil_heavy",
    "Normal": "WEBMOB_device_washer_option_soil_normal",
    "Light": "WEBMOB_device_washer_option_soil_light",
    "ExtraLight": "WEBMOB_device_washer_option_soil_extralight",
    "Up": "WEBMOB_device_washer_option_soil_up",
    "Down": "WEBMOB_device_washer_option_soil_down",
    "None": "-"
};

var WASHER_COMMANDS = {
    "getDevices": "getDevices",
    "startWasher": "startWasher",
    "pauseWasher": "pauseWasher",
    "cancelWasher": "cancelWasher",
    "autoDetergent": "autoDetergent",
    "autosoftener": "autosoftener",
    "laundry": "laundry",
    "wrinklePrevent": "wrinklePrevent",
    "diagnosis": "diagnosis",
    "PARSE_MODULEINFO": "PARSE_MODULEINFO",
    "DB_RESET": "UsagesDB_reset",
    "ADD_WASH": "add_wash",
    "STATUS_204": 204,
    "syncTime": "syncTime",
    "PARSE_CONFIGURATION": "PARSE_CONFIGURATION",
    "mixedLoadBell": "mixedLoadBell"
};

var WASHER_DETERGENT = {
    "Normal": 1,
    "Less": 2,
    "Empty": 3
};

var WASHER_SOFTNER = {
    "Normal": 1,
    "Less": 2,
    "Empty": 3
};

var WASHER_PROGRESSDISPLAY = {
    delaywash: "Delaywash", //:"WMMOB_delay_end",
    Weightsensing: "Weightsensing", //:"WMMOB_progressing_01",
    Prewash: "Prewash", //"WMMOB_progressing_02",
    Wash: "Wash", //"WMMOB_progressing_03",
    Rinse: "Rinse", //"WMMOB_progressing_04",
    Spin: "Spin", //"WMMOB_progressing_05",
    Sud: "Sud", //"WMMOB_progressing_06",
    Drying: "Drying", //"WMMOB_progressing_07",
    Airwash: "Airwash", //"WMMOB_progressing_08",
    Cooling: "Cooling", //"WMMOB_progressing_09",
    Wrinkleprevent: "Wrinkleprevent", //"WMMOB_progressing_10",
    Finish: "Finish", //"WMMOB_progressing_11",
    Waitend: "Waitend", //"WMMOB_progressing_12",
    Pause: "Paused.", //"WMMOB_pause_state"
    None: "None"
};

var DRYERSCREEN = {
    HOME: 1,
    SETTINGS: 2,
    OPTIONS: 3,
    SMARTCARE: 4,
    LAUNDRYOUTPAGE: 5
};

var DRYERALERT = {
    NONE: 0,
    CANCEL: 1,
    WRINKLE: 2,
    CYCLEFINISHED: 3,
    POWEROFF: 4,
    AUTODETERGENT: 5,
    ALARMSERVICE: 6,
    VENT: 7,
    CONNECTION_FAILURE: 8,
    DISPENSER_OPEN: 9,
    RESETENERGY: 10,
    DELETE_MYFAVORITES: 11
};

var DRYER_TEMP = {
    "ExtraLow": "WEBMOB_device_washer_option_drytemp_extralow",
    "Low": "WEBMOB_device_washer_option_drytemp_low",
    "MediumLow": "WEBMOB_device_washer_option_drytemp_mediumlow",
    "Medium": "WEBMOB_device_washer_option_drytemp_medium",
    "High": "WEBMOB_device_washer_option_drytemp_high"
};

var DRYER_TIME = {
    "T00": "-",
    "T150": "WEBMOB_device_washer_option_drytime_150min",
    "T120": "WEBMOB_device_washer_option_drytime_120min",
    "T100": "100",
    "T90": "WEBMOB_device_washer_option_drytime_90min",
    "T80": "WEBMOB_device_washer_option_drytime_EPA_1",
    "T70": "WEBMOB_device_washer_option_drytime_EPA_2",
    "T60": "WEBMOB_device_washer_option_drytime_1",
    "T50": "WEBMOB_device_washer_option_drytime_2",
    "T40": "WEBMOB_device_washer_option_drytime_3",
    "T30": "WEBMOB_device_washer_option_drytime_4",
    "T20": "WEBMOB_device_washer_option_drytime_5"
};

var DRYER_DRYLEVEL = {
    "Damp": "WEBMOB_device_washer_option_drylevel_damp",
    "Less": "WEBMOB_device_washer_option_drylevel_less",
    "Normal": "WEBMOB_device_washer_option_drylevel_normal",
    "More": "WEBMOB_device_washer_option_drylevel_more",
    "Very": "WEBMOB_device_washer_option_drylevel_very",
    "DL1": "WEBMOB_device_washer_option_drylevel_1",
    "DL2": "WEBMOB_device_washer_option_drylevel_2",
    "DL3": "WEBMOB_device_washer_option_drylevel_3",
    "DL4": "WEBMOB_device_washer_option_drylevel_4",
    "DL5": "WEBMOB_device_washer_option_drylevel_5",
    "None": "-"
};

var VENTLEVEL_0 = 0;
var VENTLEVEL_1 = 1;
var VENTLEVEL_2 = 2;
var VENTLEVEL_3 = 3;
var VENTLEVEL_4 = 4;
var VENTLEVEL_5 = 5;
var VENTLEVEL_6 = 6;
var VENTLEVEL_7 = 7;

// To avoid initial loading effects from Jquery-mobile
angular.element(document).ready(function () {
    jQuery.mobile.autoInitializePage = false;
});

app.controller("WSController", function ($scope, SHPService, $timeout, CourseParseService, EnergyService, STCONST, toaster) {
    var chekLaundry, currentLaundryVal, currentLaundryValMain, currentLaundryValSub, tempLaundryVal, tempLaundryValMain, tempLaundryValSub,
            promise, deviceCurrentMode, rackDry, dryType_epa, clearTime, reqParamCountrySelection, data, convert,
            remoteControlEnabledPrevValue, remoteControlEnabledPrevValueMain, remoteControlEnabledPrevValueSub, stringDisplay, stringDisplayMain,
            stringDisplaySub, currentRunItem, currentRunItemMain, currentRunItemSub, previousScreenAtSelfCheck;

    var debugMode = false, errorDemoPage = false, chatErrorPage = false, clickedDiagnosis = false, firstParse = true,
            disableSpecialDryTime = false, firstConfigCheck = true, initialDataParsed = false, firstConfigCheckDualTop = true,
            firstConfigCheckDualFront = true, favPopUpChanged = false, cancelCommandFromFav = false, powerOffPopUp = false;

    var deviceSetDryTime = -1, deviceSetDryTimeMain = -1, deviceSetDryTimeSub = -1, deviceSetTemp = -1, deviceSetTempMain = -1, deviceSetTempSub = -1,
            deviceSetDryLevel = -1, deviceSetDryLevelMain = -1, deviceSetDryLevelSub = -1, devicedryTimeValue = -1,
            dryLevelSelectedIndex = -1, dryLevelSelectedIndexMyFav = -1, demoModeVersionClickCount = 0,isCallFromReset = 1;
            startCommandFromFavIndex = -1;
    var Debug_tag = 'WD : ';
    var cHeight = 0, cWidth = 0, base = 0;
    //    var LANG = "DEFAULT";
    var langArr = Object.keys(LANGUAGE_FILE.language);
    if (langArr.indexOf(LANG.toUpperCase()) !== -1) {
        data = LANGUAGE_FILE["language"][LANG.toUpperCase()];
    } else if (langArr.indexOf(LANG.toUpperCase().substring(0, 2)) !== -1) {
        data = LANGUAGE_FILE["language"][LANG.toUpperCase().substring(0, 2)];
    } else {
        data = LANGUAGE_FILE["language"]["DEFAULT"];
    }
    myScope = angular.element(document.getElementById("bodyTag")).scope();
    $scope.currentWasherSelected = WASHERCURRENTSEL.NONE;
    var scroll_middle_area = document.getElementById("scrollSettings");
    $scope.circleWidth = document.getElementById("circularProgress").offsetWidth;
    $scope.circleHeight = document.getElementById("circularProgress").offsetHeight;
    $scope.circleWidthMain = document.getElementById("circularProgressMain").offsetWidth;
    $scope.circleHeightMain = document.getElementById("circularProgressMain").offsetHeight;
    $scope.circleHeightSub = document.getElementById("circularProgressSub").offsetHeight;
    $scope.circleWidthSub = document.getElementById("circularProgressSub").offsetWidth;

    $scope.radiusMain = $scope.circleHeightMain / 2;
    $scope.strokeMain = Math.ceil($scope.circleHeightMain / 20);

    $scope.radiusSub = $scope.circleHeightSub / 2;
    $scope.strokeSub = Math.ceil($scope.circleHeightSub / 20);
    if ($scope.applePhone) {
        $scope.diameterMain = $scope.radiusMain * 2 + 2;
        $scope.diameterSub = $scope.radiusSub * 2 + 2;
    } else {
        $scope.diameterMain = $scope.radiusMain * 2;
        $scope.diameterSub = $scope.radiusSub * 2;
    }

    $scope.radius = $scope.circleHeight / 2;
    $scope.stroke = Math.ceil($scope.circleHeight / 20);
    if ($scope.applePhone) {
        $scope.diameter = $scope.radius * 2 + 2;
    } else {
        $scope.diameter = $scope.radius * 2;
    }
    $scope.FavID = null;
    $scope.translation = data;
    $scope.popupName;
    $scope.gradient = true;
    $scope.syncTime = true;
    $scope.homePage = true;
    $scope.clockwise = true;
    $scope.cycFinish = false;
    $scope.detailPage = false;
    $scope.isGasDryer = false;
    $scope.isErrorSub = false;
    $scope.isDualDryer = false;
    $scope.isErrorMain = false;
    $scope.bOptionPopUp = false;
    $scope.cycFinishSub = false;
    $scope.isGasDryerSub = false;
    $scope.cycFinishMain = false;
    $scope.isGasDryerMain = false;
    $scope.kidsLockByPass = false;
    $scope.laundrySwitchSub = false;
    $scope.kidsLockByPassSub = false;
    $scope.laundrySwitchMain = false;
    $scope.mixedLoadBellValue = true;
    $scope.samrtControlPopup = false;
    $scope.showDemoErrorList = false;
    $scope.kidsLockByPassMain = false;
    $scope.dryerCancelPressed = false;
    $scope.cancelButtonPressed = false;
    $scope.showSeamLessControl = false;
    $scope.seamLessControlValue = false;
    $scope.confirmButtonPressed = false;
    $scope.serviceButtonPressed = false;
    $scope.remoteControlEnabled = false;
    $scope.wrinklePreventdisable = false;
    $scope.wrinklePreventStarted = false;
    $scope.showSeamLessControlSub = false;
    $scope.remoteControlEnabledSub = true;
    $scope.showSeamLessControlMain = false;
    $scope.seamLessControlValueSub = false;
    $scope.remoteControlEnabledMain = true;
    $scope.seamLessControlValueMain = false;
    $scope.countrySelectionPopupVisible = false;

    $scope.topLoaderModelArray = ['0144', '0145'];
    $scope.washerToUpdate = WASHERTOUPDATE.NONE;
    $scope.previousScreenError = WASHERSCREENS.DETAILPAGE;

    $scope.switchON = 'I';
    $scope.switchOff = 'O';
    $scope.rounded = "true";
    $scope.bgColor = '#FAFAFA00';
    $scope.BottomPopupDivCls = '';
    $scope.currentColor = '#45ccce';
    $scope.deviceStatusSub = 'Ready';
    $scope.deviceStatusMain = 'Ready';
    $scope.containSubCl = "containSub";
    $scope.ModeSelectionPopupDivCls = '';
    $scope.BottomPopupDimBackgroundDiv = '';
    $scope.currentAnimation = 'easeOutCubic';
    $scope.currentCourseEnum = 'WEBMOB_device_washer_course_01_dry';
    $scope.currentCourseEnumMain = 'WEBMOB_device_washer_course_01_dry';
    $scope.currentCourseEnumSub = 'WEBMOB_device_washer_course_01_dry';
    $scope.laundryOnOffTextSub = $scope.translation.WEBMOB_device_washer_comm_off_CL;
    $scope.laundryOnOffTextMain = $scope.translation.WEBMOB_device_washer_comm_off_CL;
    $scope.smartControlOnOffText = $scope.translation.WEBMOB_device_washer_comm_on_CL;
    $scope.laundryDescText = $scope.translation.WEBMOB_device_washer_laundryout_desc_dryer;

    $scope.FavID = null;
    $scope.max = 100;
    $scope.timer = 35;
    $scope.iterations = 50;
    $scope.wrinkleDisable = 80;
    $scope.callServiceIndex = 0;
    $scope.dialCallNumLength = 1;
    $scope.incrementProgress = 0.1;
    $scope.countrySelectedIndex = 0;
    $scope.koreanComboIndex = 0;
    $scope.koreanComboSubIndex = 0;

    $scope.getYAxisValue = EnergyService.getYAxisValue;
    $scope.errorList = [];
    $scope.dialCallNum = [];
    $scope.checkResponse = [];
    $scope.countryToSelect = [];
    $scope.erroTextArray = [
        "WEBMOB_device_washer_error_title_tc2",
        "WEBMOB_device_washer_error_title_9c1",
        "WEBMOB_device_washer_error_title_dc_dry",
        "WEBMOB_device_washer_error_title_df",
        "WEBMOB_device_washer_error_title_efe",
        "WEBMOB_device_washer_error_title_hc_dry",
        "WEBMOB_device_washer_error_title_5e_dry"
    ];
    $scope.optionsMenu = [{
            id: 0,
            title: $scope.translation.WEBMOB_common_settings
        }, {
            id: 1,
            title: $scope.translation.WEBMOB_common_about_device
        }, {
            id: 2,
            title: $scope.translation.WEBMOB_common_energy_monitor_reset_history
        }, {
            id: 3,
            title: $scope.translation.WEBMOB_device_washer_comm_delete
        }];

    $scope.koreanComboOptions = [{
            id: 0,
            title: 'First option'
        }, {
            id: 1,
            title: 'Second option'
        }, {
            id: 2,
            title: 'Third option'
        }, {
            id: 3,
            title: 'Fourth option'
        }, {
            id: 4,
            title: 'Fifth option'
        }, {
            id: 5,
            title: 'Sixth option'
        }];

    $scope.koreanComboSubOptions = [{
            id: 0,
            title: 'First Suboption'
        }, {
            id: 1,
            title: 'Second Suboption'
        }, {
            id: 2,
            title: 'Third Suboption'
        }, {
            id: 3,
            title: 'Fourth Suboption'
        }, {
            id: 4,
            title: 'Fifth Suboption'
        }, {
            id: 5,
            title: 'Sixth Suboption'
        }];

    $scope.countryToSelect.push({'Country': 'Belgium'});
    $scope.countryToSelect.push({'Country': 'Belgium(France)'});

    $timeout(function () {
        cHeight = window.screen.availHeight;
        cWidth = window.screen.availWidth;
        if (cHeight === 0 || cHeight === undefined) {
            cHeight = document.body.clientHeight;
        }
        if (cWidth === 0 || cWidth === undefined) {
            cWidth = document.body.clientWidth;
        }
        base = ((80 * cWidth) / 1440);
        $scope.screenAreaHeight = (cHeight / base);
    }, 10);

    $scope.options = options;
    $scope.closeApp = closeApp;
    $scope.getColor = getColor;
    $scope.settings = settings;
    $scope.isChecked = isChecked;
    $scope.showAlert = showAlert;
    $scope.callCenter = callCenter;
    $scope.closepopup = closepopup;
    $scope.selectIndex = selectIndex;
    $scope.onOkClicked = onOkClicked;
    $scope.clickWrinkle = clickWrinkle;
    $scope.alarmService = alarmService;
    $scope.retUpperCase = retUpperCase;
    $scope.alarmConfirm = alarmConfirm;
    $scope.checkEPATime = checkEPATime;
    $scope.colsePopOver = colsePopOver;
    $scope.pauseCommand = pauseCommand;
    $scope.changeScreen = changeScreen;
    $scope.cycleConfirm = cycleConfirm;
    $scope.showHelpIcon = showHelpIcon;
    $scope.onBackPressed = onBackPressed;
    $scope.callGetDevice = callGetDevice;
    $scope.startProgress = startProgress;
    $scope.onAboutAction = onAboutAction;
    $scope.isEnergyReset = isEnergyReset;
    $scope.cancelCommand = cancelCommand;
    $scope.cancelWashing = cancelWashing;
    $scope.showDailyData = showDailyData;
    $scope.startFavorite = startFavorite;
    $scope.closeAllPopups = closeAllPopups;
    $scope.editMyFavorite = editMyFavorite;
    $scope.getCurrentTime = getCurrentTime;
    $scope.showDetailPage = showDetailPage;
    $scope.showcustDialog = showcustDialog;
    $scope.cancelProgress = cancelProgress;
    $scope.doAlarmService = doAlarmService;
    $scope.doAlarmConfirm = doAlarmConfirm;
    $scope.getTempDisable = getTempDisable;
    $scope.isTempSelected = isTempSelected;
    $scope.showWeeklyData = showWeeklyData;
    $scope.showMyFavorite = showMyFavorite;
    $scope.showYearlyData = showYearlyData;
    $scope.showAddFavorite = showAddFavorite;
    $scope.isSpinnerActive = isSpinnerActive;
    $scope.versionTouchEnd = versionTouchEnd;
    $scope.openPopovermode = openPopovermode;
    $scope.openPopoverTemp = openPopoverTemp;
    $scope.parseStaticData = parseStaticData;
    $scope.gettempConstant = gettempConstant;
    $scope.getTimeConstant = getTimeConstant;
    $scope.callTutorialURL = callTutorialURL;
    $scope.onLaundrySwitch = onLaundrySwitch;
    $scope.getmodeSelected = getmodeSelected;
    $scope.selectIndexTemp = selectIndexTemp;
    $scope.doCancelWashing = doCancelWashing;
    $scope.showMonthlyData = showMonthlyData;
    $scope.showOptionPopUp = showOptionPopUp;
    $scope.onMixedLoadBell = onMixedLoadBell;
    $scope.toggleCheckList = toggleCheckList;
    $scope.showNextDaysData = showNextDaysData;
    $scope.sendResetCommand = sendResetCommand;
    $scope.closeOptionPopUp = closeOptionPopUp;
    $scope.onCloseTempPopup = onCloseTempPopup;
    $scope.updateDeviceData = updateDeviceData;
    $scope.onSettingsUpdate = onSettingsUpdate;
    $scope.gettempStringFav = gettempStringFav;
    $scope.returnOnOffValue = returnOnOffValue;
    $scope.parseNotification = parseNotification;
    $scope.getDryTimeDisable = getDryTimeDisable;
    $scope.versionTouchStart = versionTouchStart;
    $scope.goToEnergyMonitor = goToEnergyMonitor;
    $scope.fetchDBfromDevice = fetchDBfromDevice;
    $scope.showUsageHelpPage = showUsageHelpPage;
    $scope.onCountrySelected = onCountrySelected;
    $scope.numOfCheckedItems = numOfCheckedItems;
    $scope.openPopoverTempFav = openPopoverTempFav;
    $scope.gettempConstantFav = gettempConstantFav;
    $scope.cancelSaveFavorite = cancelSaveFavorite;
    $scope.openErrorTextArray = openErrorTextArray;
    $scope.closeUsageHelpPage = closeUsageHelpPage;
    $scope.parseConfiguration = parseConfiguration;
    $scope.requestFailHandler = requestFailHandler;
    $scope.openLaundryOutPage = openLaundryOutPage;
    $scope.selectIndexDryTime = selectIndexDryTime;
    $scope.openPopoverDryTime = openPopoverDryTime;
    $scope.getDryLevelDisable = getDryLevelDisable;
    $scope.getDryTimeSelected = getDryTimeSelected;
    $scope.saveButtonFavorite = saveButtonFavorite;
    $scope.getTempDisableMyFav = getTempDisableMyFav;
    $scope.getTimeStringForFav = getTimeStringForFav;
    $scope.getmixLoadBellPopUp = getmixLoadBellPopUp;
    $scope.isMixedLoadDisabled = isMixedLoadDisabled;
    $scope.selectIndexDryLevel = selectIndexDryLevel;
    $scope.getDryLevelSelected = getDryLevelSelected;
    $scope.openPopoverDryLevel = openPopoverDryLevel;
    $scope.onAlertButton2Click = onAlertButton2Click;
    $scope.getDryLevelConstant = getDryLevelConstant;
    $scope.laundryItemSelected = laundryItemSelected;
    $scope.smartcareerrorcheck = smartcareerrorcheck;
    $scope.onAlertButton1Click = onAlertButton1Click;
    $scope.onCloseDryTimePopup = onCloseDryTimePopup;
    $scope.alarmServicePayload = alarmServicePayload;
    $scope.okClickedAtPowerOff = okClickedAtPowerOff;
    $scope.getDryLevelStringFav = getDryLevelStringFav;
    $scope.getTempSelectedPopup = getTempSelectedPopup;
    $scope.cancelWashingPressed = cancelWashingPressed;
    $scope.parseRequestAccepted = parseRequestAccepted;
    $scope.parseRequestResponse = parseRequestResponse;
    $scope.showPreviousDaysData = showPreviousDaysData;
    $scope.parseEnergyUsageData = parseEnergyUsageData;
    $scope.onCloseDryLevelPopup = onCloseDryLevelPopup;
    $scope.selectMyFavoriteCycle = selectMyFavoriteCycle;
    $scope.openPopoverDryTimeFav = openPopoverDryTimeFav;
    $scope.openPopoverWrinkleFav = openPopoverWrinkleFav;
    $scope.changeSeamLessControl = changeSeamLessControl;
    $scope.isEnergyResetDisabled = isEnergyResetDisabled;
    $scope.getfavpopupforTempTop = getfavpopupforTempTop;
    $scope.getDryTimeDisableMyFav = getDryTimeDisableMyFav;
    $scope.selectIndexForFavorite = selectIndexForFavorite;
    $scope.openPopoverDryLevelFav = openPopoverDryLevelFav;
    $scope.showOptionItemsVisible = showOptionItemsVisible;
    $scope.parseModuleInformation = parseModuleInformation;
    $scope.hideSmartControlOption = hideSmartControlOption;
    $scope.selectTempFromSettings = selectTempFromSettings;
    $scope.getWrinklePreventPopUp = getWrinklePreventPopUp;
    $scope.getDryLevelDisableMyFav = getDryLevelDisableMyFav;
    $scope.getDryTimeSelectedPopUp = getDryTimeSelectedPopUp;
    $scope.openPopoverMixedBellFav = openPopoverMixedBellFav;
    $scope.isMixedLoadDisabledMyFav = isMixedLoadDisabledMyFav;
    $scope.removeItemFromMyFavorite = removeItemFromMyFavorite;
    $scope.callServiceIndexSelected = callServiceIndexSelected;
    $scope.toggleSmartControlButton = toggleSmartControlButton;
    $scope.getDryLevelSelectedPopUp = getDryLevelSelectedPopUp;
    $scope.getfavpopupforDryTimeTop = getfavpopupforDryTimeTop;
    $scope.selectDryTimeFromSettings = selectDryTimeFromSettings;
    $scope.selectWrinkleFromSettings = selectWrinkleFromSettings;
    $scope.selectIndexFromOptionMenu = selectIndexFromOptionMenu;
    $scope.handleEnergyMonitorErrors = handleEnergyMonitorErrors;
    $scope.getfavpopupforDryLevelTop = getfavpopupforDryLevelTop;
    $scope.openKoreanComboSettingPage = openKoreanComboSettingPage;
    $scope.showConnectionFailurePopup = showConnectionFailurePopup;
    $scope.onCountrySelectedOkClicked = onCountrySelectedOkClicked;
    $scope.closeCountrySelectionPopup = closeCountrySelectionPopup;
    $scope.selectDryLevelFromSettings = selectDryLevelFromSettings;
    $scope.getfavpopupforMiexedBellTop = getfavpopupforMiexedBellTop;
    $scope.selectMixedBellFromSettings = selectMixedBellFromSettings;
    $scope.toggleSelectAllListCheckBox = toggleSelectAllListCheckBox;
    $scope.deleteItemsFromFavoriteList = deleteItemsFromFavoriteList;
    $scope.showcustCountrySelectionPopup = showcustCountrySelectionPopup;
    $scope.getfavpopupforwrinklepreventTop = getfavpopupforwrinklepreventTop;
    $scope.getMixedLoadBellValueFromMyFav = getMixedLoadBellValueFromMyFav;
    $scope.onKoreanComboOptionsSelected = onKoreanComboOptionsSelected;
    $scope.selectIndexKoreanComboSubOption = selectIndexKoreanComboSubOption;
    $scope.longPressOnItemFromFavoritePage = longPressOnItemFromFavoritePage;
    $scope.onCloseKoreanComboSubOptionPopup = onCloseKoreanComboSubOptionPopup;
    $scope.cancelButtonPressedFromMultiSelect = cancelButtonPressedFromMultiSelect;
    
    function showHelpIcon() {
        if ($scope.detailPage) {
            if ($scope.cycFinish) {
                return false;
            }
            return true;
        }
        if ($scope.homePage) {
            if ($scope.cycFinishMain && $scope.cycFinishSub) {
                return false;
            }
            if ($scope.mainDryerData.Operation.power !== "On" && $scope.cycFinishSub) {
                return false;
            }
            if ($scope.cycFinishMain && $scope.subDryerData.Operation.power !== "On") {
                return false;
            }
            if ($scope.mainDryerData.Operation.power !== "On" && $scope.subDryerData.Operation.power !== "On") {
                return false;
            }
            return true;
        }
    }

    function returnOnOffValue(val) {
        if (val === "On") {
            return $scope.translation.WEBMOB_device_washer_comm_on_CL;
        } else {
            return $scope.translation.WEBMOB_device_washer_comm_off_CL;
            ;
        }
    }

    function getMixedLoadBellValueFromMyFav(item) {
        if (item.optionMixedLoadBellFavIsEnable) {
            if (item.optionMixedLoadBellFav === "On") {
                return $scope.translation.WEBMOB_device_washer_comm_on_CL;
            } else {
                return $scope.translation.WEBMOB_device_washer_comm_off_CL;
            }
        } else {
            return $scope.translation.WEBMOB_device_washer_comm_off_CL;
        }
    }

    function editMyFavorite(itemToEdit) {
        $scope.FavID = itemToEdit.favItemId;
        $scope.currentCourseEnumfavorite = itemToEdit.courseEnum;
        $scope.setDryLevelFav = itemToEdit.optiondryLevel;
        $scope.setDryTimeFav = itemToEdit.optionDryTime;
        $scope.setTempFav = itemToEdit.optiontemp;
        $scope.isDryTimeFav = itemToEdit.optionIsDryTime;
        $scope.isTempFav = itemToEdit.optionIsDryTemp;
        $scope.isDrylevelFav = itemToEdit.optionIsDryLevel;
        $scope.currentTempListFav = itemToEdit.optionTempList;
        $scope.currentDryLevelListFav = itemToEdit.optionDryLevelList;
        $scope.currentDryTimeListFav = itemToEdit.optionDryTimeList;
        $scope.disabledrylevelContentsFav = itemToEdit.optionDisabledrylevelContents;
        $scope.disabledrytimeContentsFav = itemToEdit.optionDisabledrytimeContents;
        $scope.disabletempContentsFav = itemToEdit.optionDisabletempContents;
        $scope.wrinklePreventFavorite = itemToEdit.optionWrinklepreventFav;
        $scope.mixLoadBellFavorite = itemToEdit.optionMixedLoadBellFav;
        //$scope.mixLoadBellFavoriteIsEnable = itemToEdit.optionMixedLoadBellFavIsEnable;
        $scope.currentRecipeName = itemToEdit.title;
        dryLevelSelectedIndexMyFav = getIndexOfDryLevelMyFav($scope.setDryLevelFav);
        $scope.currentScreen = WASHERSCREENS.ADDFAVORITE;
        changeScreen();
    }

    function getIndexOfDryLevelMyFav(drylevelVal) {
        return $scope.currentDryLevelListFav.indexOf(drylevelVal) + 1;
    }
    function getIndexOfDryLevel(drylevelVal) {
        return $scope.currentDryLevelList.indexOf(drylevelVal) + 1;
    }

    function selectMixedBellFromSettings(item) {
        $scope.mixLoadBellFavorite = item;
        $scope.favMixedBell = false;
    }

    function selectWrinkleFromSettings(item) {
        $scope.wrinklePreventFavorite = item;
//        if (item === "On") {
//            $scope.wrinkleOn = true;
//        }
//        if (item === "Off") {
//            $scope.wrinkleOn = false;
//        }
        $scope.favWrinkle = false;
    }

    function selectDryTimeFromSettings(item) {
        if (getDryTimeDisableMyFav(item)) {
            return;
        }
        $scope.setDryTimeFav = item;
        $scope.favDryTime = false;
    }

    function selectDryLevelFromSettings(item, index) {
        if (getDryLevelDisableMyFav(item)) {
            return;
        }
        $scope.setDryLevelFav = item;
        dryLevelSelectedIndexMyFav = index;
        closeAllPopups();
    }

    function selectTempFromSettings(item) {
        if (getTempDisableMyFav(item)) {
            return;
        }
        $scope.setTempFav = item;
        $scope.favTemp = false;
    }

    function openPopoverDryLevelFav() {
        closeAllPopups();
        if ($scope.disabledrylevelContentsFav || favPopUpChanged) {
            return;
        }
        if ($scope.currentDryLevelListFav.length > 0) {
            $scope.favDryLevel = true;
        } else {
            $scope.favDryLevel = false;
        }
        var elemPosition = getPositionElement('myFavCycle');
        var forthElementFromCycleCycle = (elemPosition.top + (2 * (3.7)) + (3.7) / 2);
        var elementPosition = getPositionElement('commonPopupFavDryLevel');
        var elementPositionFromCycle = elementPosition.top;
        if (elementPositionFromCycle > forthElementFromCycleCycle) {
            var elementToApply = document.getElementById('dryLevelSpin');
            elementToApply.style.top = (-Math.min(($scope.listItemsDryLevel.length * 2.7), 10.8) + 170 / 80) + "rem";
        }
        changePopUpClass($scope.favDryLevel);
        var topCalculated = elementPosition.top + 170 / 80 + Math.min(($scope.listItemsDryLevel.length * 2.7), 10.8);
        if (topCalculated > $scope.screenAreaHeight) {
            var scrolElem = document.getElementById('scrollSettings');
            scrolElem.style.overflowY = 'scroll';
        }
    }

    function openPopoverDryTimeFav() {
        closeAllPopups();
        if ($scope.disabledrytimeContentsFav || favPopUpChanged) {
            return;
        }
        if ($scope.currentDryTimeListFav.length > 0) {
            $scope.favDryTime = true;
        } else {
            $scope.favDryTime = false;
        }
        var elemPosition = getPositionElement('myFavCycle');
        var forthElementFromCycleCycle = (elemPosition.top + (2 * (3.7)) + (3.7) / 2);
        var elementPosition = getPositionElement('commonPopupFavTime');
        var elementPositionFromCycle = elementPosition.top;
        if (elementPositionFromCycle > forthElementFromCycleCycle) {
            var elementToApply = document.getElementById('dryTimeSpin');
            elementToApply.style.top = (-Math.min(($scope.listItemsDryTime.length * 2.7), 10.8) + 170 / 80) + "rem";
        }
        changePopUpClass($scope.favDryTime);
        var topCalculated = elementPosition.top + 170 / 80 + Math.min(($scope.listItemsDryTime.length * 2.7), 10.8);
        if (topCalculated > $scope.screenAreaHeight) {
            var scrolElem = document.getElementById('scrollSettings');
            scrolElem.style.overflowY = 'scroll';
        }
    }

    function openPopoverTempFav() {
        closeAllPopups();
        if ($scope.disabletempContentsFav || favPopUpChanged) {
            return;
        }
        if ($scope.currentTempListFav.length > 0) {
            $scope.favTemp = true;
        } else {
            $scope.favTemp = false;
        }
        var elemPosition = getPositionElement('myFavCycle');
        var forthElementFromCycleCycle = (elemPosition.top + (2 * (3.7)) + (3.7) / 2);
        var elementPosition = getPositionElement('commonPopupFavTemp');
        var elementPositionFromCycle = elementPosition.top;
        if (elementPositionFromCycle > forthElementFromCycleCycle) {
            var elementToApply = document.getElementById('dryTempSpin');
            elementToApply.style.top = (-Math.min(($scope.listItemsTemp.length * 2.7), 10.8) + 170 / 80) + "rem";
        }
        changePopUpClass($scope.favTemp);
        var topCalculated = elementPosition.top + 170 / 80 + Math.min(($scope.listItemsTemp.length * 2.7), 10.8);
        if (topCalculated > $scope.screenAreaHeight) {
            var scrolElem = document.getElementById('scrollSettings');
            scrolElem.style.overflowY = 'scroll';
        }
    }

    function openPopoverWrinkleFav() {
        closeAllPopups();
        if (favPopUpChanged) {
            return;
        }
        $scope.favWrinkle = true;
        $scope.favWrinkleList = ["Off", "On"];
        var elemPosition = getPositionElement('myFavCycle');
        var forthElementFromCycleCycle = (elemPosition.top + (2 * (3.7)) + (3.7) / 2);
        var elementPosition = getPositionElement('commonPopupFavWrinkle');
        var elementPositionFromCycle = elementPosition.top;
        if (elementPositionFromCycle > forthElementFromCycleCycle) {
            var elementToApply = document.getElementById('WrinkleFavSpin');
            elementToApply.style.top = (-Math.min(($scope.favWrinkleList.length * 2.7), 10.8) + 170 / 80) + "rem";
        }
        changePopUpClass(true);
        var topCalculated = elementPosition.top + 170 / 80 + Math.min(($scope.favWrinkleList.length * 2.7), 10.8);
        if (topCalculated > $scope.screenAreaHeight) {
            var scrolElem = document.getElementById('scrollSettings');
            scrolElem.style.overflowY = 'scroll';
        }
    }

    function openPopoverMixedBellFav() {
        closeAllPopups();
        if (isMixedLoadDisabledMyFav() || favPopUpChanged) {
            return;
        }
        $scope.favMixedBell = true;
        $scope.favMixedBellList = ["Off", "On"];
        var elemPosition = getPositionElement('myFavCycle');
        var forthElementFromCycleCycle = (elemPosition.top + (2 * (3.7)) + (3.7) / 2);
        var elementPosition = getPositionElement('commonPopupFavMixedBell');
        var elementPositionFromCycle = elementPosition.top;
        if (elementPositionFromCycle > forthElementFromCycleCycle) {
            var elementToApply = document.getElementById('mixedBellspin');
            elementToApply.style.top = (-Math.min(($scope.favMixedBellList.length * 2.7), 10.8) + 170 / 80) + "rem";
        }
        changePopUpClass(true);
        var topCalculated = elementPosition.top + 170 / 80 + Math.min(($scope.favMixedBellList.length * 2.7), 10.8);
        if (topCalculated > $scope.screenAreaHeight) {
            var scrolElem = document.getElementById('scrollSettings');
            scrolElem.style.overflowY = 'scroll';
        }
    }


    function getPositionElement(id) {
        var el = document.getElementById(id);
        var position = {left: 0, top: 0};
        for (position.left = 0, position.top = 0;
                el !== null;
                position.left += el.offsetLeft, position.top += el.offsetTop, el = el.offsetParent)
            ;
        var cWidth = document.body.clientWidth || window.innerWidth;
        var baseFontSize = (80 * cWidth) / 1440;
        position.left = position.left / baseFontSize;
        position.top = position.top / baseFontSize;
        return position;
    }


    function selectIndexForFavorite(selectedItem) {
        dryLevelSelectedIndexMyFav = -1;
        $scope.currentCourseEnumfavorite = selectedItem.CourseEnum;
        $scope.currentCourseHexFav = selectedItem.courseNameHex;
        $scope.setTempFav = selectedItem.defaultTemp;
        $scope.setDryLevelFav = selectedItem.defaultDryLevel;
        $scope.setDryTimeFav = selectedItem.defaultDryTime;
        $scope.isTempFav = selectedItem.isTempEnabled;
        $scope.isDrylevelFav = selectedItem.isDryLevelEnabled;
        $scope.isDryTimeFav = selectedItem.isDryTimeEnabled;
        $scope.currentTempListFav = selectedItem.optionTempList;
        $scope.currentDryLevelListFav = selectedItem.optionDryLevelList;
        $scope.currentDryTimeListFav = selectedItem.optionDryTimeList;
        if ($scope.currentTempListFav !== undefined && ($scope.currentTempListFav.length === 0 || $scope.currentTempListFav.length < 2)) {
            $scope.disabletempContentsFav = true;
        } else {
            $scope.disabletempContentsFav = false;
        }
        if ($scope.currentDryLevelListFav !== undefined && ($scope.currentDryLevelListFav.length === 0 || $scope.currentDryLevelListFav.length < 2)) {
            $scope.disabledrylevelContentsFav = true;
        } else {
            $scope.disabledrylevelContentsFav = false;
        }
        if ($scope.currentDryTimeListFav !== undefined && ($scope.currentDryTimeListFav.length === 0 || $scope.currentDryTimeListFav.length < 2)) {
            $scope.disabledrytimeContentsFav = true;
        } else {
            $scope.disabledrytimeContentsFav = false;
        }
        dryLevelSelectedIndexMyFav = getIndexOfDryLevelMyFav($scope.setDryLevelFav);
        //$scope.mixLoadBellFavoriteIsEnable = !isMixedLoadDisabledMyFav();
        $scope.currentScreen = WASHERSCREENS.ADDFAVORITE;
        changeScreen();
    }

    function selectMyFavoriteCycle() {
        closeAllPopups();
        $scope.currentScreen = WASHERSCREENS.CYCLEMYFAVORITE;
        changeScreen();
    }


    function showToast(txt) {
        $timeout(function () {
            document.activeElement.blur();
            toaster.success({title: "", body: txt, bodyOutputType: 'trustedHtml'});
        }, 200);
    }

    function startFavorite(index) {
        if ($scope.isStatic) {
            return;
        }
        var washerId = 0;
        var errormsgHotWarning = $scope.translation.WEBMOB_device_washer_alarm_device_control_error_msg;
        if ($scope.currentWasherSelected === WASHERCURRENTSEL.MAIN_SELECTED) {
            errormsgHotWarning = '[' + $scope.translation.WEBMOB_device_washer_comm_front_loader_dryer + ']<br>' + errormsgHotWarning;
        } else if ($scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
            washerId = 1;
            errormsgHotWarning = '[' + $scope.translation.WEBMOB_device_washer_comm_top_loader_dryer + ']<br>' + errormsgHotWarning;
        } else {
            ;//Nothing
        }

        if ($scope.hotwarning) {

            $scope.errorList.push({
                title: $scope.translation.WEBMOB_device_washer_alarm_device_control_error_title,
                msg: errormsgHotWarning,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }

        startCommandFromFavIndex = index;

        //cancelCommandFromFav = true;
        //$scope.checkResponse.push(WASHER_COMMANDS.cancelWasher);
        SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.cancelCommand(), "/" + $scope.peerId + "/devices/" + washerId + "/operation");
        startFavoriteAfterCancelCommand();
        //SHPService.sendSHPCommand(CONSTANTS.PUT, getStartCommandMyFav(selectedFavourite.courseHex, 'Run', selectedFavourite.optionIsDryLevel, selectedFavourite.optiondryLevel, selectedFavourite.optionIsDryTemp, selectedFavourite.optiontemp, selectedFavourite.optionIsDryTime, selectedFavourite.optionDryTime, selectedFavourite.optionWrinklepreventFav, selectedFavourite.optionMixedLoadBellFavIsEnable, selectedFavourite.optionMixedLoadBellFav), "/" + $scope.peerId + "/devices/" + washerId); 
        //goToDetailPage();
    }

    function startFavoriteAfterCancelCommand() {
        if ($scope.isStatic) {
            return;
        }

        var selectedFavourite = $scope.myFavoriteList[startCommandFromFavIndex];
        var washerId = 0;
        if ($scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
            washerId = 1;
        }

        $scope.checkResponse.push(WASHER_COMMANDS.startWasher);
        if ($scope.syncTime && !$scope.showSyncTime) {
            $scope.checkResponse.push(WASHER_COMMANDS.syncTime);
            SHPService.sendSHPCommand(CONSTANTS.PUT, syncTimerCommand(), "/" + $scope.peerId + "/devices/" + washerId + "/configuration/time");
        }

        SHPService.sendSHPCommand(CONSTANTS.PUT, getStartCommandMyFav(selectedFavourite.courseHex, 'Run', selectedFavourite.optionIsDryLevel, selectedFavourite.optiondryLevel, selectedFavourite.optionIsDryTemp, selectedFavourite.optiontemp, selectedFavourite.optionIsDryTime, selectedFavourite.optionDryTime, (selectedFavourite.optionWrinklepreventFav === "On" ? true : false), selectedFavourite.optionMixedLoadBellFavIsEnable, selectedFavourite.optionMixedLoadBellFav), "/" + $scope.peerId + "/devices/" + washerId);
        goToDetailPage();
    }

    function deleteItemsFromFavoriteList() {
        $scope.alertState = DRYERALERT.DELETE_MYFAVORITES;
        $scope.errorList.push({
            msg: $scope.translation.WEBMOB_device_washer_alarm_my_favorite_delete_msg,
            btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_delete_CL,
            btnOkHandler: function () {
                $scope.onOkClicked(true);
            },
            btnCancelTxt: $scope.translation.WEBMOB_common_cancel_capital,
            btnCancelHandler: function () {
                $scope.onOkClicked(false);
                cancelButtonPressedFromMultiSelect();
            },
            closeDialog: !true
        });
        changePopUpClass(true);
    }

    function deletAllFromFavorites() {
        //var numberOfItemDeleted = $scope.myFavoriteList.length;
        $scope.myFavoriteList = [];
        setLocalStorageForMyFavorite($scope.myFavoriteList);
        $scope.bAllListSelected = false;
        $scope.isMultiSelectMode = false;
        showMyFavorite();
        showToast($scope.translation.WEBMOB_device_washer_alarm_my_favorite_toast_delete);
        //showToast( numberOfItemDeleted +" "+$scope.translation.WEBMOB_device_washer_alarm_my_favorite_toast_delete);
    }

    function deleteSelectedItemFromFavorites() {
        //var numberOfItemDeleted=0;
        for (var i = 0; i < $scope.myFavoriteList.length; i++) {
            if ($scope.myFavoriteList[i].isChecked) {
                var index = i;
                if (index > -1) {
                    $scope.myFavoriteList.splice(index, 1);
                    --i;
                    //numberOfItemDeleted=numberOfItemDeleted+1;
                }
            }
        }
        setLocalStorageForMyFavorite($scope.myFavoriteList);
        $scope.isMultiSelectMode = false;
        showMyFavorite();
        showToast($scope.translation.WEBMOB_device_washer_alarm_my_favorite_toast_delete);
        //showToast( numberOfItemDeleted +" "+$scope.translation.WEBMOB_device_washer_alarm_my_favorite_toast_delete);
    }

    function numOfCheckedItems() {
        var numOfCheckedItem = 0;
        for (var i = 0; i < $scope.myFavoriteList.length; i++) {
            if ($scope.myFavoriteList[i].isChecked) {
                numOfCheckedItem++;
            }
        }
        return numOfCheckedItem;
    }

    function toggleCheckList(item, index) {
        //$scope.indexSelected = index;
        debugMessage("toggleCheckList called");
        for (var i = 0; i < $scope.myFavoriteList.length; i++) {
            if ($scope.myFavoriteList[i].title === item.title) {
                $scope.myFavoriteList[i].isChecked = !$scope.myFavoriteList[i].isChecked;
            }
        }
        isAllCheckBoxSelected();
        isAnyCheckedItem();
    }

    function isAllCheckBoxSelected() {
        for (var i = 0; i < $scope.myFavoriteList.length; i++) {
            if ($scope.myFavoriteList[i].isChecked === false) {
                $scope.bAllListSelected = false;
                return;
            }
        }
        $scope.bAllListSelected = true;
    }

    function toggleSelectAllListCheckBox() {
        if ($scope.isAnyCheckedItem) {
            $scope.isAnyCheckedItem = !$scope.isAnyCheckedItem;
        }
        $scope.bAllListSelected = !$scope.bAllListSelected;
        if ($scope.bAllListSelected) {
            for (var i = 0; i < $scope.myFavoriteList.length; i++) {
                $scope.myFavoriteList[i].isChecked = true;
            }
        } else {
            for (var i = 0; i < $scope.myFavoriteList.length; i++) {
                $scope.myFavoriteList[i].isChecked = false;
            }
        }
    }

    function cancelButtonPressedFromMultiSelect() {
        if ($scope.isMultiSelectMode) {
            $scope.isMultiSelectMode = !$scope.isMultiSelectMode;
        }
        if ($scope.isAnyCheckedItem) {
            $scope.isAnyCheckedItem = !$scope.isAnyCheckedItem;
        }
        if ($scope.bAllListSelected) {
            $scope.bAllListSelected = !$scope.bAllListSelected;
        }
        showMyFavorite();
    }

    function isChecked(currentListInfo, index) {
        for (var i = 0; i < $scope.myFavoriteList.length; i++) {
            if ($scope.myFavoriteList[i].title === currentListInfo.title) {
                return $scope.myFavoriteList[i].isChecked;
            }
        }
        return false;
    }

    function isAnyCheckedItem() {
        for (var i = 0; i < $scope.myFavoriteList.length; i++) {
            if ($scope.myFavoriteList[i].isChecked) {
                $scope.isAnyCheckedItem = true;
                return;
            }
        }
        $scope.isAnyCheckedItem = false;
    }

    function longPressOnItemFromFavoritePage() {
        $scope.isMultiSelectMode = true;
        $scope.bAllListSelected = false;
    }

    function cancelSaveFavorite() {
        closeAllPopups();
        if (favPopUpChanged) {
            return;
        }
        initAddFavoriteSettingsOptions();
        $scope.FavID = null;
        showMyFavorite();
    }

    function showMyFavorite() {
        $scope.myFavoriteList = [];
        var singleDryerList = [];
        var mainDryerList = [];
        var subDryerList = [];
        var favList = getLocalStorageForMyFavorite($scope.Device.uuid + 'myFavorite');

        if (favList.length !== 0) {
            document.getElementById("scrollSettings").scrollTop = 0;
            favList = JSON.parse(getLocalStorageForMyFavorite($scope.Device.uuid + 'myFavorite'));
            for (var i = 0; i < favList.length; i++) {
                if (favList[i].optionDryerToSelect === WASHERCURRENTSEL.MAIN_SELECTED) {
                    mainDryerList.push(favList[i]);
                } else if (favList[i].optionDryerToSelect === WASHERCURRENTSEL.SUB_SELECTED) {
                    subDryerList.push(favList[i]);
                } else {
                    singleDryerList.push(favList[i]);
                }
            }
            $scope.myFavoriteList = singleDryerList;
            if ($scope.isDualDryer) {
                if ($scope.currentWasherSelected === WASHERCURRENTSEL.MAIN_SELECTED) {
                    $scope.myFavoriteList = mainDryerList;
                } else if ($scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
                    $scope.myFavoriteList = subDryerList;
                }
            }
        }
        $scope.currentScreen = WASHERSCREENS.MYFAVORITE;
        changeScreen();
    }

    function showAddFavorite() {
        if ($scope.myFavoriteList.length >= 20) {  //To Do
            showToast($scope.translation.WEBMOB_device_washer_alarm_my_favorite_toast_max_list);
            return;
        }
        if ($scope.bAllListSelected) {
            $scope.bAllListSelected = !$scope.bAllListSelected;
        }
        if ($scope.isMultiSelectMode) {
            $scope.isMultiSelectMode = !$scope.isMultiSelectMode;
        }
        if ($scope.isAnyCheckedItem) {
            $scope.isAnyCheckedItem = !$scope.isAnyCheckedItem;
        }
        $scope.currentRecipeName = getMyFavoriteName();
        $scope.currentCourseEnumfavorite = $scope.listItemsModes[0].CourseEnum;
        $scope.currentCourseHexFav = $scope.listItemsModes[0].courseNameHex;
        $scope.setDryLevelFav = $scope.listItemsModes[0].defaultDryLevel;
        $scope.setDryTimeFav = $scope.listItemsModes[0].defaultDryTime;
        $scope.setTempFav = $scope.listItemsModes[0].defaultTemp;
        $scope.isDrylevelFav = $scope.listItemsModes[0].isDryLevelEnabled;
        $scope.isDryTimeFav = $scope.listItemsModes[0].isDryTimeEnabled;
        $scope.isTempFav = $scope.listItemsModes[0].isTempEnabled;
        $scope.currentDryTimeListFav = $scope.listItemsModes[0].optionDryTimeList;
        $scope.currentDryLevelListFav = $scope.listItemsModes[0].optionDryLevelList;
        $scope.currentTempListFav = $scope.listItemsModes[0].optionTempList;

        if ($scope.currentTempListFav !== undefined && ($scope.currentTempListFav.length === 0 || $scope.currentTempListFav.length < 2)) {
            $scope.disabletempContentsFav = true;
        } else {
            $scope.disabletempContentsFav = false;
        }
        if ($scope.currentDryLevelListFav !== undefined && ($scope.currentDryLevelListFav.length === 0 || $scope.currentDryLevelListFav.length < 2)) {
            $scope.disabledrylevelContentsFav = true;
        } else {
            $scope.disabledrylevelContentsFav = false;
        }
        if ($scope.currentDryTimeListFav !== undefined && ($scope.currentDryTimeListFav.length === 0 || $scope.currentDryTimeListFav.length < 2)) {
            $scope.disabledrytimeContentsFav = true;
        } else {
            $scope.disabledrytimeContentsFav = false;
        }
        $scope.wrinklePreventFavorite = "Off";
        $scope.mixLoadBellFavorite = "Off";
        dryLevelSelectedIndexMyFav = getIndexOfDryLevelMyFav($scope.setDryLevelFav);
        //$scope.mixLoadBellFavoriteIsEnable = !isMixedLoadDisabledMyFav();
        $scope.currentScreen = WASHERSCREENS.ADDFAVORITE;
        changeScreen();
    }

    function showUsageHelpPage() {
        setTimeout(function () {
            scroll_middle_area.scrollTop = 0;
        }, 10);
        if ($scope.homePage) {
            setLocalStorageData('firstTimeLaunchHomePage', true);
        } else if ($scope.detailPage && $scope.Device.id === "1") {
            setLocalStorageData('firstTimeLaunchDetailPageTopLoad', true);
        } else if ($scope.detailPage && $scope.Device.id === "0") {
            setLocalStorageData('firstTimeLaunchDetailPageFrontLoad', true);
        } else {
            ;//Nothing
        }
        $scope.bUsageHelpPage = true;
        changePopUpClass(true);
    }

    function closeUsageHelpPage() {
        $scope.bUsageHelpPage = false;
        changePopUpClass(false);
    }

    function debugMessage(message) {
        if (debugMode) {
            console.log(Debug_tag + message);
        }
    }

    if (LANG.toUpperCase().indexOf('EN') !== -1) {
        $scope.switchON = 'ON';
        $scope.switchOff = 'OFF';
    }

    if (window.navigator.platform === 'iPhone' || window.navigator.platform === 'iPad') {
        $scope.applePhone = true;
    } else {
        $scope.applePhone = false;
    }

    // Toggle class for body
    function toggleAnimClass() {
        if ($scope.containSubCl === "containSub") {
            $scope.containSubCl = "";
        } else {
            $scope.containSubCl = "containSub";
        }
    }

    // Toggle class for Mode drop down
    function changePopUpClass(closemultiDialogPopUp) {
        if (closemultiDialogPopUp) {
            $scope.ModeSelectionPopupDivCls = "ModeSelectionPopupDiv";
            scroll_middle_area.style.overflowY = "hidden";
        } else {
            if ($scope.bUsageHelpPage) {    // this check used as for first launch help screen is visible and overflow should not be overlay
                return;
            }
            $scope.ModeSelectionPopupDivCls = "ModeSelectionPopOutDiv";
            scroll_middle_area.style.overflowY = "overlay";
        }
    }

    function dismissLoadingBar(value) {
        if ($scope.checkResponse.indexOf(value) !== -1) {
            $scope.checkResponse.splice($scope.checkResponse.indexOf(value), 1);
            if ($scope.checkResponse.length === 0) {
                $scope.loadingBar = false;
            }
        }
    }

    // Toggle class for Mode drop down
    function toggleBottomPopUpClass(popupName) {
        if (popupName) {
            $scope.BottomPopupDimBackgroundDiv = "BottomPopupDimBackgroundDivIn";
            $scope.BottomPopupDivCls = "BottomPopupBGIn";
            scroll_middle_area.style.overflowY = "hidden";
        } else {
            $scope.BottomPopupDimBackgroundDiv = "BottomPopupDimBackgroundDivOut";
            $scope.BottomPopupDivCls = "BottomPopupBGOut";
            scroll_middle_area.style.overflowY = "overlay";
        }
    }

    function onCloseTempPopup() {
        $scope.tempPopup = false;
        toggleBottomPopUpClass($scope.tempPopup);
    }

    function onCloseDryLevelPopup() {
        $scope.dryLevelPopup = false;
        toggleBottomPopUpClass($scope.dryLevelPopup);
    }

    function onCloseDryTimePopup() {
        $scope.dryTimePopup = false;
        toggleBottomPopUpClass($scope.dryTimePopup);
    }

    function onCloseKoreanComboSubOptionPopup() {
        $scope.isKoreanComboSubOption = false;
        toggleBottomPopUpClass($scope.isKoreanComboSubOption);
        changePopUpClass($scope.isKoreanComboSubOption);
    }

    function init(response) {
        $scope.Device = {
            "Alarms": [],
            "ConfigurationLink": {
                "href": ""
            },
            "Diagnosis": {
                "diagnosisStart": ""
            },
            "EnergyConsumption": {
                "saveLocation": ""
            },
            "InformationLink": {
                "href": ""
            },
            "Mode": {
                "options": [],
                "supportedOptions": []
            },
            "Operation": {
                "kidsLock": "",
                "power": "",
                "progress": "",
                "progressPercentage": 1,
                "remainingTime": "",
                "state": "",
                "supportedProgress": []
            },
            "Washer": {
            },
            "connected": true,
            "description": "",
            "id": "",
            "name": "",
            "resources": [],
            "type": "",
            "uuid": ""
        };

        $scope.mainDryerData = {
            "Alarms": [],
            "ConfigurationLink": {
                "href": ""
            },
            "Diagnosis": {
                "diagnosisStart": ""
            },
            "EnergyConsumption": {
                "saveLocation": ""
            },
            "InformationLink": {
                "href": ""
            },
            "Mode": {
                "options": [],
                "supportedOptions": []
            },
            "Operation": {
                "kidsLock": "",
                "power": "",
                "progress": "",
                "progressPercentage": 1,
                "remainingTime": "",
                "state": "",
                "supportedProgress": []
            },
            "Washer": {
            },
            "connected": true,
            "description": "",
            "id": "",
            "name": "",
            "resources": [],
            "type": "",
            "uuid": ""
        };

        $scope.subDryerData = {
            "Alarms": [],
            "ConfigurationLink": {
                "href": ""
            },
            "Diagnosis": {
                "diagnosisStart": ""
            },
            "EnergyConsumption": {
                "saveLocation": ""
            },
            "InformationLink": {
                "href": ""
            },
            "Mode": {
                "options": [],
                "supportedOptions": []
            },
            "Operation": {
                "kidsLock": "",
                "power": "",
                "progress": "",
                "progressPercentage": 1,
                "remainingTime": "",
                "state": "",
                "supportedProgress": []
            },
            "Washer": {
            },
            "connected": true,
            "description": "",
            "id": "",
            "name": "",
            "resources": [],
            "type": "",
            "uuid": ""
        };

        $scope.current = 0;
        $scope.currentMain = 0;
        $scope.currentSub = 0;
        $scope.isErrorSub = false;
        $scope.isErrorMain = false;
        $scope.progresshead = false;
        $scope.progressStart = false;
        $scope.progressheadSub = false;
        $scope.progressStartSub = false;
        $scope.progressheadMain = false;
        $scope.progressStartMain = false;
        $scope.cycFinish = false;
        $scope.cycFinishMain = false;
        $scope.cycFinishSub = false;
        $scope.isLaundryEnabled = false;
        $scope.isLaundryEnabledMain = false;
        $scope.isLaundryEnabledSub = false;
        $scope.showMixedLoadBell = false;
        $scope.showMixedLoadBellMain = false;
        $scope.showMixedLoadBellSub = false;
        $scope.mixedLoadBellValue = false;
        $scope.mixedLoadBellValueMain = false;
        $scope.mixedLoadBellValueSub = false;
        $scope.showEnergyLevelSet = false;
        $scope.showEnergyLevelSetMain = false;
        $scope.showEnergyLevelSetSub = false;
        $scope.wrinklePreventStarted = false;
        $scope.wrinklePreventStartedMain = false;
        $scope.wrinklePreventStartedSub = false;
        $scope.wrinklePreventdisable = false;
        $scope.wrinklePreventdisableMain = false;
        $scope.wrinklePreventdisableSub = false;
        $scope.disableLaundry = false;
        $scope.disableLaundryMain = false;
        $scope.disableLaundrySub = false;
        $scope.wrinkleOn = false;
        $scope.wrinkleOnMain = false;
        $scope.wrinkleOnSub = false;
        $scope.setWrinkleOn = false;
        $scope.wrinklePreventState = false;
        $scope.wrinklePreventStateMain = false;
        $scope.wrinklePreventStateSub = false;
        $scope.setWrinkleOnMain = false;
        $scope.setWrinkleOnSub = false;
        $scope.mixedLoadBellSetValue = false;
        $scope.mixedLoadBellSetValueMain = false;
        $scope.mixedLoadBellSetValueSub = false;
        $scope.notiParsingInProress = false;
        if ($scope.alertState === DRYERALERT.CONNECTION_FAILURE) {
            resetAllData();
        }
        if (!$scope.isStatic) {
            if ($scope.checkResponse.indexOf(WASHER_COMMANDS.PARSE_CONFIGURATION) === -1) {
                $scope.checkResponse.push(WASHER_COMMANDS.PARSE_CONFIGURATION);
            }
            SHPService.sendSHPCommand(CONSTANTS.GET, "/" + $scope.peerId + "/devices/0/configuration");
            if (response && response.length === 2) {
                SHPService.sendSHPCommand(CONSTANTS.GET, "/" + $scope.peerId + "/devices/1/configuration");
            }
        }
    }

    function resetAllData() {
        for (var i = 0; i < $scope.errorList.length; i++) {
            $scope.errorList.pop();
        }
        $scope.alertState = DRYERALERT.NONE;
        if ($scope.isDualDryer) {
            $scope.currentScreen = WASHERSCREENS.HOME;
        } else {
            $scope.currentScreen = WASHERSCREENS.DETAILPAGE;
        }
        changeScreen();
    }

    function updateDeviceData(data) {
        SHPService.updateDeviceData($scope, data);
    }

    function parseConfiguration(configura, deviceId) {
        debugMessage("deviceId............. " + deviceId);
        dismissLoadingBar(WASHER_COMMANDS.PARSE_CONFIGURATION);
        $scope.hideSmartControlOption();
        if (angular.isDefined(configura["remoteControlEnabled"])) {
            if (isDeviceUpdateRequired(deviceId)) {
                $scope.remoteControlEnabled = configura["remoteControlEnabled"];
                $scope.smartControlOnOffText = $scope.remoteControlEnabled ? $scope.translation.WEBMOB_device_washer_comm_on_CL : $scope.translation.WEBMOB_device_washer_comm_off_CL;
                debugMessage("$scope.remoteControlEnabled" + $scope.remoteControlEnabled);
                closeAllPopups();
            }
        }
        if (angular.isDefined($scope.demoErrorCode)) {
            $scope.currentErrorCode = $scope.demoErrorCode;
            $scope.openErrorTextArray($scope.currentErrorCode);
            $scope.mainLoadingScreen = true;
            $scope.pageLoaded = true;
            return;
        }
        if (angular.isDefined(configura["region"])) {
            $scope.region = configura["region"];
        }
        if (!$scope.isDualDryer) {
            if ((remoteControlEnabledPrevValue === true && $scope.remoteControlEnabled === false)
                    || (firstConfigCheck && !$scope.remoteControlEnabled && !$scope.isGasDryer)) {
                $timeout(function () {
                    $scope.errorList.push({
                        title: $scope.translation.WEBMOB_device_washer_alarm_smart_control_off,
                        msg: $scope.translation.WEBMOB_device_washer_alarm_smart_control_off_washer_msg,
                        btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                        btnOkHandler: function () {
                            onOkClicked(true);
                        },
                        closeDialog: !true
                    });
                    changePopUpClass(true);
                }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
            }
            remoteControlEnabledPrevValue = $scope.remoteControlEnabled;
            firstConfigCheck = false;
        }
        if ($scope.isDualDryer && deviceId === 0) {
            if (angular.isDefined(configura["remoteControlEnabled"])) {
                if (firstConfigCheck) {
                    remoteControlEnabledPrevValueMain = configura["remoteControlEnabled"];
                }
                $scope.remoteControlEnabledMain = configura["remoteControlEnabled"];
                if ($scope.currentWasherSelected === WASHERCURRENTSEL.MAIN_SELECTED) {
                    $scope.smartControlOnOffText = $scope.remoteControlEnabledMain ? $scope.translation.WEBMOB_device_washer_comm_on_CL : $scope.translation.WEBMOB_device_washer_comm_off_CL;
                }
                if (!firstConfigCheck) {
                    if ($scope.remoteControlEnabledMain) {
                        closeAllPopups();
                    } else {
                        $timeout(function () {
                            $scope.errorList.push({
                                title: $scope.translation.WEBMOB_device_washer_alarm_smart_control_off,
                                msg: '[' + $scope.translation.WEBMOB_device_washer_comm_front_loader_dryer + ']<br>' + $scope.translation.WEBMOB_device_washer_alarm_smart_control_off_washer_msg,
                                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                                btnOkHandler: function () {
                                    onOkClicked(true);
                                },
                                closeDialog: !true
                            });
                            changePopUpClass(true);
                        }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
                    }
                }
                firstConfigCheckDualFront = false;
            }
            if (angular.isDefined(configura["region"])) {
                $scope.regionMain = configura["region"];
            }
        } else if ($scope.isDualDryer && deviceId === 1) {
            if (angular.isDefined(configura["remoteControlEnabled"])) {
                if (firstConfigCheck) {
                    remoteControlEnabledPrevValueSub = configura["remoteControlEnabled"];
                }
                $scope.remoteControlEnabledSub = configura["remoteControlEnabled"];
                if ($scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
                    $scope.smartControlOnOffText = $scope.remoteControlEnabledSub ? $scope.translation.WEBMOB_device_washer_comm_on_CL : $scope.translation.WEBMOB_device_washer_comm_off_CL;
                }
                if (!firstConfigCheck) {
                    if ($scope.remoteControlEnabledSub) {
                        closeAllPopups();
                    } else {
                        $timeout(function () {
                            $scope.errorList.push({
                                title: $scope.translation.WEBMOB_device_washer_alarm_smart_control_off,
                                msg: '[' + $scope.translation.WEBMOB_device_washer_comm_top_loader_dryer + ']<br>' + $scope.translation.WEBMOB_device_washer_alarm_smart_control_off_washer_msg,
                                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                                btnOkHandler: function () {
                                    onOkClicked(true);
                                },
                                closeDialog: !true
                            });
                            changePopUpClass(true);
                        }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
                    }
                }
                firstConfigCheckDualTop = false;
            }
            if (angular.isDefined(configura["region"])) {
                $scope.regionSub = configura["region"];
            }
        } else {
            ;//NOthing
        }

        if ($scope.isDualDryer && firstConfigCheck && !firstConfigCheckDualTop && !firstConfigCheckDualFront && !$scope.isGasDryer) {
            if (!remoteControlEnabledPrevValueMain && !remoteControlEnabledPrevValueSub && $scope.mainDryerData.Operation.power === 'On' && $scope.subDryerData.Operation.power === 'On') {
                $timeout(function () {
                    $scope.errorList.push({
                        title: $scope.translation.WEBMOB_device_washer_alarm_smart_control_off,
                        msg: '[' + $scope.translation.WEBMOB_device_washer_comm_top_loader_dryer + ', ' + $scope.translation.WEBMOB_device_washer_comm_front_loader_dryer + ']<br>' + $scope.translation.WEBMOB_device_washer_alarm_smart_control_off_washer_msg,
                        btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                        btnOkHandler: function () {
                            onOkClicked(true);
                        },
                        closeDialog: !true
                    });
                    changePopUpClass(true);
                }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
            } else if (!remoteControlEnabledPrevValueMain && $scope.mainDryerData.Operation.power === 'On') {
                $timeout(function () {
                    $scope.errorList.push({
                        title: $scope.translation.WEBMOB_device_washer_alarm_smart_control_off,
                        msg: '[' + $scope.translation.WEBMOB_device_washer_comm_front_loader_dryer + ']<br>' + $scope.translation.WEBMOB_device_washer_alarm_smart_control_off_washer_msg,
                        btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                        btnOkHandler: function () {
                            onOkClicked(true);
                        },
                        closeDialog: !true
                    });
                    changePopUpClass(true);
                }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
            } else if (!remoteControlEnabledPrevValueSub && $scope.subDryerData.Operation.power === 'On') {
                $timeout(function () {
                    $scope.errorList.push({
                        title: $scope.translation.WEBMOB_device_washer_alarm_smart_control_off,
                        msg: '[' + $scope.translation.WEBMOB_device_washer_comm_top_loader_dryer + ']<br>' + $scope.translation.WEBMOB_device_washer_alarm_smart_control_off_washer_msg,
                        btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                        btnOkHandler: function () {
                            onOkClicked(true);
                        },
                        closeDialog: !true
                    });
                    changePopUpClass(true);
                }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
            } else {
                ;//Nothing
            }
        }

        if ($scope.isDualDryer && !firstConfigCheckDualTop && !firstConfigCheckDualFront) {
            firstConfigCheck = false;
        }
    }

    function requestFailHandler(response) {
        debugMessage("Fail Handler respose is::" + response);
        $scope.loadingBar = false;
        $scope.checkResponse = [];
    }

    function parseRequestResponse(response) {
        $scope.getDeviceInProgress = true;
        $scope.NoEnergyKW_396 === true;
        $scope.NoEnergyKW_396Main === true;
        $scope.NoEnergyKW_396Sub === true;
        var deviceId = -1;
        if (response["resourceURL"] && response["resourceURL"].indexOf('/devices/') !== -1) {
            deviceId = parseInt(response["resourceURL"].split("/")[3], 10);
            debugMessage("deviceId :: " + deviceId);
        }
        if (angular.isDefined(response["status"]) && response["status"] === STCONST.STATUS_99000) {
            showConnectionFailurePopup();
        }
        if (angular.isDefined(response["data"])) {
            if (angular.isDefined(response["data"]["Configuration"])) {
                parseConfiguration(response["data"]["Configuration"], deviceId);
            }
            if (angular.isDefined(response["data"]["Devices"])) {
                init(response.data.Devices);
                parseDeviceData(response.data.Devices, deviceId);
                if (!!!$scope.loadingBar) { // No loading bar means request handled properly. So, clear array.
                    SHPService.clearStopVarArray();
                }
                return;
            }
        }
        if (angular.isDefined(response["data"]["Information"])) {
            parseModuleInformation(response["data"]["Information"]);
        }
        if (angular.isDefined(response["resourceURL"])) {
            if (response["resourceURL"].indexOf("files") !== -1) {
                $scope.isDBDownloaded = true;
                if (isCallFromReset === 2) {
                    $scope.loadingBar = false;
                    isCallFromReset = 1;
                    energyResetDone = true;
                    $scope.goToEnergyMonitor();
                }
            }
        }

        if (response.status >= 200 && response.status < 300) { //<300 is succes only. Refer http://www.w3.org/Protocols/rfc2616/rfc2616-sec10.html for status code definitions.
            handleStatusCode(response.status, response, deviceId);
        }
        $scope.getDeviceInProgress = false;
    }

    function parseDeviceData(devices) {
        debugMessage("deviceUuid from app.js is :" + $scope.deviceUuid);
        dismissLoadingBar(WASHER_COMMANDS.getDevices);
        initialDataParsed = false;
        debugMessage(JSON.stringify(devices));
        $scope.washerToUpdate = WASHERTOUPDATE.NONE;

        $scope.isDualDryer = devices.length === 2 ? true : false;

        if (!$scope.isDualDryer) {
            $scope.Device = devices[0];
            $scope.washerToUpdate = WASHERTOUPDATE.SINGLEWASHER;
            parseDryerData(devices[0]);
            $scope.washerToUpdate = WASHERTOUPDATE.NONE;
        } else {
            if (devices instanceof Array) { //Added a check to avoid error in case "devices" is not array 
                devices.forEach(function (value) {
                    if (value["id"] === '0') {
                        $scope.mainDryerData = value;
                        $scope.washerToUpdate = WASHERTOUPDATE.MAINWASHER;
                        if ($scope.homePage || $scope.currentWasherSelected === WASHERCURRENTSEL.MAIN_SELECTED) {
                            parseDryerData(value);
                        } else {
                            updateMainDryerData(value);
                        }
                        $scope.washerToUpdate = WASHERTOUPDATE.NONE;
                    }
                    if (value["id"] === '1') {
                        $scope.subDryerData = value;
                        $scope.washerToUpdate = WASHERTOUPDATE.SUBWASHER;
                        if ($scope.homePage || $scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
                            parseDryerData(value);
                        } else {
                            updateSubDryerData(value);
                        }
                        $scope.washerToUpdate = WASHERTOUPDATE.NONE;
                    }                    
                });
            }
        }
        
        //Logic to request usage DB download
        if (angular.isDefined(devices[0]["Mode"].options)) {
            devices[0]["Mode"].options.forEach(function (item) {
                if (item.indexOf("UsagesDB_ok") !== -1) {
                    // get DB request
                    if ($scope.isCallFromEnergyReset && isCallFromReset === 1 && $scope.currentScreen === WASHERSCREENS.ENERGYMONITOR) {
                        isCallFromReset = 2;
                        $scope.isCallFromEnergyReset = false;
                    }
                    $scope.isDBDownloaded = false;
                    $scope.fetchDBfromDevice();
                }
            });
        }
        
        initialDataParsed = true;
        $scope.mainLoadingScreen = true;
        $scope.pageLoaded = true;
        if ($scope.isDualDryer && $scope.homePage) {
            goToHome();
        }
    }

    function callGetDevice() {
        SHPService.getDevices($scope);
    }

    function parseRequestAccepted(response) {
        if (angular.isDefined(response["data"]) && angular.isDefined(response["data"]["energyData"])) {
            $scope.parseEnergyUsageData(response["data"]);
        } else if (angular.isDefined(response["isSuccess"])) {    // todo : need to check whether is being used.
            parseDeviceData(response);
        }
    }

    function parseNotification(response) {
        var deviceId = -1;
        if (angular.isDefined(response["data"])) {
            if (angular.isDefined(response["data"]["mobileTimeChanged"])) {
                return;
            }
            if (response["data"] === "backPressed") {
                //if loding bar visible, don't handle back key
                if (!!!$scope.loadingBar) {
                    onBackPressed();
                }
                return;
            }
            if (angular.isDefined(response["data"].isApplicationActive) && !$scope.isStatic) {
                $scope.appAlive = true;
                callGetDevice();
                return;
            }
            if (angular.isDefined(response["data"][0]) && angular.isDefined(response["data"][0]["Device"]) && angular.isDefined(response["data"][0]["Device"]["scsConnectionState"])) {
                checkCycleCompleteScreen(response["data"][0]["Device"]["scsConnectionState"]);   //device ID TODO amit
                if (!response["data"][0]["Device"]["scsConnectionState"]) {
                    showConnectionFailurePopup();
                } else if (response["data"][0]["Device"]["scsConnectionState"]) {
                    closeConnectionFailurePopup();
                    callGetDevice();
                }
                return;
            }
            $scope.notiParsingInProress = true;
            if (response["data"] instanceof Array) {
                response["data"].forEach(function (value) {
                    if (value["resourceURI"].indexOf('/devices/') !== -1) {
                        deviceId = parseInt(value["resourceURI"].split("/")[2], 10);
                    }
                    parseNotificationData(value, deviceId);
                });
            } else {
                deviceId = parseInt(response["data"][0]["resourceURI"].split("/")[2], 10);
                parseNotificationData(response["data"], deviceId);
            }
            $scope.notiParsingInProress = false;
        }
    }

    function parseNotificationData(devices, deviceId) {
        if (!initialDataParsed) {
            return;
        }

        if (!$scope.isDualDryer) {
            updateSingleDryerData(devices);
            $scope.washerToUpdate = WASHERTOUPDATE.SINGLEWASHER;
            parseDryerData(devices);
            $scope.washerToUpdate = WASHERTOUPDATE.NONE;
        } else {
            if (devices["id"] === '0' || deviceId === 0) {
                $scope.washerToUpdate = WASHERTOUPDATE.MAINWASHER;
                updateMainDryerData(devices);
                $scope.washerToUpdate = WASHERTOUPDATE.NONE;
            }
            if (devices["id"] === '1' || deviceId === 1) {
                $scope.washerToUpdate = WASHERTOUPDATE.SUBWASHER;
                updateSubDryerData(devices);
                $scope.washerToUpdate = WASHERTOUPDATE.NONE;
            }
        }
    }

    function updateMainDryerData(device) {

        if (angular.isDefined(device["Configuration"])) {
            parseConfiguration(device["Configuration"], 0);
        }

        if (angular.isDefined(device["description"])) {
            $scope.mainDryerData.description = device["description"];
            updateDeviceName(device["description"]);
        }

        if (angular.isDefined(device["id"])) {
            $scope.mainDryerData.id = device["id"];
        }

        if (angular.isDefined(device["Alarms"])) {
            $scope.mainDryerData.Alarms = device["Alarms"];
            checkAlarms(device);
        }

        if (angular.isDefined(device["ConfigurationLink"]) && angular.isDefined(device["ConfigurationLink"]["href"])) {
            $scope.mainDryerData.ConfigurationLink.href = device["ConfigurationLink"]["href"];
        }

        if (angular.isDefined(device["Diagnosis"]) && angular.isDefined(device["Diagnosis"]["diagnosisStart"])) {
            $scope.mainDryerData.Diagnosis.diagnosisStart = device["Diagnosis"]["diagnosisStart"];
            showDiagnosisPage(device["Diagnosis"]);
        }

        if (angular.isDefined(device["EnergyConsumption"]) && angular.isDefined(device["EnergyConsumption"].saveLocation)) {
            $scope.mainDryerData.EnergyConsumption.saveLocation = device["EnergyConsumption"]["saveLocation"];
            $scope.energyMonitorLocation = device["EnergyConsumption"].saveLocation;
            $scope.showEnergyMonitorOption = true;
            $scope.optionCodeValue = "OptionCode_16384";   // hardcoded for native processing
        }

        if (angular.isDefined(device["InformationLink"]) && angular.isDefined(device["InformationLink"]["href"])) {
            $scope.mainDryerData.InformationLink.href = device["InformationLink"]["href"];
        }

        if (angular.isDefined(device["type"])) {
            $scope.mainDryerData.type = device["type"];
            if (isDeviceUpdateRequired($scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED ? 1 : 0)) {
                $scope.deviceType = device["type"];
            }
            $scope.deviceTypeMain = device["type"];
        }

        if (angular.isDefined(device["Mode"]) && angular.isDefined(device["Mode"]["supportedOptions"])) {
            $scope.mainDryerData.Mode.supportedOptions = device["Mode"]["supportedOptions"];
            if (!$scope.cycFinishMain) {
                if (angular.isDefined(device["Mode"].supportedOptions)) {
                    parseCourseOptions(device["Mode"].supportedOptions[0], false);
                }
            }
        }

        if (angular.isDefined(device["Mode"]) && angular.isDefined(device["Mode"]["options"])) {
            $scope.mainDryerData.Mode.options = device["Mode"]["options"];
            if (!$scope.cycFinishMain || ($scope.cycFinishMain && $scope.isLaundryEnabledMain)) {
                updateDeviceModel(device["Mode"].options);
            }
        }

        if (angular.isDefined(device["Operation"])) {
            if (angular.isDefined(device["Operation"]["kidsLock"])) {
                $scope.mainDryerData.Operation.kidsLock = device["Operation"]["kidsLock"];
            }
            if (angular.isDefined(device["Operation"]["power"])) {
                $scope.mainDryerData.Operation.power = device["Operation"]["power"];
                if ($scope.mainDryerData.Operation.power === "Off") {
                    if ($scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
                        $scope.cycFinishMain = false;
                    }
                    powerOffPopUp = true;
                    $scope.errorList.push({
                        title: '',
                        msg: '[' + $scope.translation.WEBMOB_device_washer_comm_front_loader_dryer + ']<br>' + $scope.translation.WEBMOB_device_washer_alarm_power_off_msg_dryer,
                        btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                        btnOkHandler: function () {
                            $scope.okClickedAtPowerOff(true, 0);
                        },
                        closeDialog: false
                    });
                    changePopUpClass(true);
                }
                if ($scope.mainDryerData.Operation.power === "On") {
                    okClickedAtPowerOff();
                    if ($scope.cycFinishMain) {
                        callGetDevice();
                        return;
                    }
                }
            }
            if (angular.isDefined(device["Operation"]["progress"])) {
                $scope.mainDryerData.Operation.progress = device["Operation"]["progress"];
            }
            if (angular.isDefined(device["Operation"]["progressPercentage"])) {
                $scope.mainDryerData.Operation.progressPercentage = device["Operation"]["progressPercentage"];
            }
            if (angular.isDefined(device["Operation"]["remainingTime"])) {
                $scope.mainDryerData.Operation.remainingTime = device["Operation"]["remainingTime"];
            }
            if (angular.isDefined(device["Operation"]["state"])) {
                $scope.mainDryerData.Operation.state = device["Operation"]["state"];
            }
            if (angular.isDefined(device["Operation"]["supportedProgress"])) {
                $scope.mainDryerData.Operation.supportedProgress = device["Operation"]["supportedProgress"];
            }
            if (!$scope.cycFinishMain) {
                updateOperation(device["Operation"]);
            } else {
                if (device["Operation"]["state"] === "Ready" && $scope.seamLessControlValueMain) {
                    dismissLoadingBar(WASHER_COMMANDS.cancelWasher);
                    callGetDevice();
                }
            }
        }

        if (angular.isDefined(device["Washer"])) {
            if (angular.isDefined(device["Washer"]["dryLevel"])) {
                $scope.mainDryerData.Washer.dryLevel = device["Washer"]["dryLevel"];
            }
            if (angular.isDefined(device["Washer"]["dryTime"])) {
                $scope.mainDryerData.Washer.dryTime = device["Washer"]["dryTime"];
            }
            if (angular.isDefined(device["Washer"]["dryerType"])) {
                $scope.mainDryerData.Washer.dryerType = device["Washer"]["dryerType"];
            }
            if (angular.isDefined(device["Washer"]["supportedDryLevel"])) {
                $scope.mainDryerData.Washer.supportedDryLevel = device["Washer"]["supportedDryLevel"];
            }
            if (angular.isDefined(device["Washer"]["supportedDryTime"])) {
                $scope.mainDryerData.Washer.supportedDryTime = device["Washer"]["supportedDryTime"];
            }
            if (angular.isDefined(device["Washer"]["supportedWaterTemperature"])) {
                $scope.mainDryerData.Washer.supportedWaterTemperature = device["Washer"]["supportedWaterTemperature"];
            }
            if (angular.isDefined(device["Washer"]["waterTemperature"])) {
                $scope.mainDryerData.Washer.waterTemperature = device["Washer"]["waterTemperature"];
            }
            if (angular.isDefined(device["Washer"]["wrinklePrevent"])) {
                $scope.mainDryerData.Washer.wrinklePrevent = device["Washer"]["wrinklePrevent"];
            }
            if (!$scope.cycFinishMain) {
                parseDefaultOptionValues(device["Washer"], false);
            }
        }
        if (angular.isDefined(device["connected"])) {
            $scope.mainDryerData.connected = device["connected"];
        }
        if (angular.isDefined(device["name"])) {
            $scope.mainDryerData.name = device["name"];
        }
        if (angular.isDefined(device["uuid"])) {
            $scope.mainDryerData.uuid = device["uuid"];
        }
        if (angular.isDefined(device["resources"])) {
            $scope.mainDryerData.resources = device["resources"];
            showSmartCheck(device["resources"]);
        }
    }

    function updateSubDryerData(device) {

        if (angular.isDefined(device["Configuration"])) {
            parseConfiguration(device["Configuration"], 1);
        }

        if (angular.isDefined(device["description"])) {
            $scope.subDryerData.description = device["description"];
            updateDeviceName(device["description"]);
        }

        if (angular.isDefined(device["id"])) {
            $scope.subDryerData.id = device["id"];
        }

        if (angular.isDefined(device["Alarms"])) {
            $scope.subDryerData.Alarms = device["Alarms"];
            checkAlarms(device);
        }

        if (angular.isDefined(device["ConfigurationLink"]) && angular.isDefined(device["ConfigurationLink"]["href"])) {
            $scope.subDryerData.ConfigurationLink.href = device["ConfigurationLink"]["href"];
        }

        if (angular.isDefined(device["Diagnosis"]) && angular.isDefined(device["Diagnosis"]["diagnosisStart"])) {
            $scope.subDryerData.Diagnosis.diagnosisStart = device["Diagnosis"]["diagnosisStart"];
            showDiagnosisPage(device["Diagnosis"]);
        }

        if (angular.isDefined(device["EnergyConsumption"]) && angular.isDefined(device["EnergyConsumption"]["saveLocation"])) {
            $scope.subDryerData.EnergyConsumption.saveLocation = device["EnergyConsumption"]["saveLocation"];
            $scope.energyMonitorLocation = device["EnergyConsumption"].saveLocation;
            $scope.showEnergyMonitorOption = true;
            $scope.optionCodeValue = "OptionCode_16384";   // hardcoded for native processing
        }

        if (angular.isDefined(device["InformationLink"]) && angular.isDefined(device["InformationLink"]["href"])) {
            $scope.subDryerData.InformationLink.href = device["InformationLink"]["href"];
        }

        if (angular.isDefined(device["type"])) {
            $scope.subDryerData.type = device["type"];
            if (isDeviceUpdateRequired($scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED ? 1 : 0)) {
                $scope.deviceType = device["type"];
            }
            $scope.deviceTypeSub = device["type"];
        }

        if (angular.isDefined(device["Mode"]) && angular.isDefined(device["Mode"]["supportedOptions"])) {
            $scope.subDryerData.Mode.supportedOptions = device["Mode"]["supportedOptions"];
            if (!$scope.cycFinishSub) {
                parseCourseOptions(device["Mode"].supportedOptions[0], false);
            }
        }

        if (angular.isDefined(device["Mode"]) && angular.isDefined(device["Mode"]["options"])) {
            $scope.subDryerData.Mode.options = device["Mode"]["options"];
            if (!$scope.cycFinishSub || ($scope.cycFinishSub && $scope.isLaundryEnabledSub)) {
                updateDeviceModel(device["Mode"].options);
            }
        }

        if (angular.isDefined(device["Operation"])) {
            if (angular.isDefined(device["Operation"]["kidsLock"])) {
                $scope.subDryerData.Operation.kidsLock = device["Operation"]["kidsLock"];
            }
            if (angular.isDefined(device["Operation"]["power"])) {
                $scope.subDryerData.Operation.power = device["Operation"]["power"];
                if ($scope.subDryerData.Operation.power === "Off") {
                    if ($scope.currentWasherSelected === WASHERCURRENTSEL.MAIN_SELECTED) {
                        $scope.cycFinishSub = false;
                    }
                    powerOffPopUp = true;
                    $scope.errorList.push({
                        title: '',
                        msg: '[' + $scope.translation.WEBMOB_device_washer_comm_top_loader_dryer + ']<br>' + $scope.translation.WEBMOB_device_washer_alarm_power_off_msg_dryer,
                        btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                        btnOkHandler: function () {
                            $scope.okClickedAtPowerOff(true, 1);
                        },
                        closeDialog: false
                    });
                    changePopUpClass(true);
                }
                if ($scope.subDryerData.Operation.power === "On") {
                    okClickedAtPowerOff();
                    if ($scope.cycFinishSub) {
                        callGetDevice();
                        return;
                    }
                }
            }
            if (angular.isDefined(device["Operation"]["progress"])) {
                $scope.subDryerData.Operation.progress = device["Operation"]["progress"];
            }
            if (angular.isDefined(device["Operation"]["progressPercentage"])) {
                $scope.subDryerData.Operation.progressPercentage = device["Operation"]["progressPercentage"];
            }
            if (angular.isDefined(device["Operation"]["remainingTime"])) {
                $scope.subDryerData.Operation.remainingTime = device["Operation"]["remainingTime"];
            }
            if (angular.isDefined(device["Operation"]["state"])) {
                $scope.subDryerData.Operation.state = device["Operation"]["state"];
            }
            if (angular.isDefined(device["Operation"]["supportedProgress"])) {
                $scope.subDryerData.Operation.supportedProgress = device["Operation"]["supportedProgress"];
            }
            if (!$scope.cycFinishSub) {
                updateOperation(device["Operation"]);
            } else if ((device["Operation"]["state"] === "Ready" || device["Operation"]["state"] === "Run") && $scope.seamLessControlValueSub) {
                dismissLoadingBar(WASHER_COMMANDS.cancelWasher);
                callGetDevice();
            }
        }

        if (angular.isDefined(device["Washer"])) {
            if (angular.isDefined(device["Washer"]["dryLevel"])) {
                $scope.subDryerData.Washer.dryLevel = device["Washer"]["dryLevel"];
            }
            if (angular.isDefined(device["Washer"]["dryTime"])) {
                $scope.subDryerData.Washer.dryTime = device["Washer"]["dryTime"];
            }
            if (angular.isDefined(device["Washer"]["dryerType"])) {
                $scope.subDryerData.Washer.dryerType = device["Washer"]["dryerType"];
            }
            if (angular.isDefined(device["Washer"]["supportedDryLevel"])) {
                $scope.subDryerData.Washer.supportedDryLevel = device["Washer"]["supportedDryLevel"];
            }
            if (angular.isDefined(device["Washer"]["supportedDryTime"])) {
                $scope.subDryerData.Washer.supportedDryTime = device["Washer"]["supportedDryTime"];
            }
            if (angular.isDefined(device["Washer"]["supportedWaterTemperature"])) {
                $scope.subDryerData.Washer.supportedWaterTemperature = device["Washer"]["supportedWaterTemperature"];
            }
            if (angular.isDefined(device["Washer"]["waterTemperature"])) {
                $scope.subDryerData.Washer.waterTemperature = device["Washer"]["waterTemperature"];
            }
            if (angular.isDefined(device["Washer"]["wrinklePrevent"])) {
                $scope.subDryerData.Washer.wrinklePrevent = device["Washer"]["wrinklePrevent"];
            }
            if (!$scope.cycFinishSub) {
                parseDefaultOptionValues(device["Washer"], false);
            }
        }
        if (angular.isDefined(device["connected"])) {
            $scope.subDryerData.connected = device["connected"];
        }
        if (angular.isDefined(device["name"])) {
            $scope.subDryerData.name = device["name"];
        }
        if (angular.isDefined(device["uuid"])) {
            $scope.subDryerData.uuid = device["uuid"];
        }
        if (angular.isDefined(device["resources"])) {
            $scope.subDryerData.resources = device["resources"];
            showSmartCheck(device["resources"]);
        }
    }

    function updateSingleDryerData(device) {
        if (angular.isDefined(device["description"])) {
            $scope.Device.description = device["description"];
        }

        if (angular.isDefined(device["id"])) {
            $scope.Device.id = device["id"];
        }

        if (angular.isDefined(device["Alarms"])) {
            $scope.Device.Alarms = device["Alarms"];
        }

        if (angular.isDefined(device["ConfigurationLink"]) && angular.isDefined(device["ConfigurationLink"]["href"])) {
            $scope.Device.ConfigurationLink.href = device["ConfigurationLink"]["href"];
        }

        if (angular.isDefined(device["Diagnosis"]) && angular.isDefined(device["Diagnosis"]["diagnosisStart"])) {
            $scope.Device.Diagnosis.diagnosisStart = device["Diagnosis"]["diagnosisStart"];
        }

        if (angular.isDefined(device["EnergyConsumption"]) && angular.isDefined(device["EnergyConsumption"]["saveLocation"])) {
            $scope.Device.EnergyConsumption.saveLocation = device["EnergyConsumption"]["saveLocation"];
        }

        if (angular.isDefined(device["InformationLink"]) && angular.isDefined(device["InformationLink"]["href"])) {
            $scope.Device.InformationLink.href = device["InformationLink"]["href"];
        }

        if (angular.isDefined(device["type"])) {
            $scope.Device.type = device["type"];
        }

        if (angular.isDefined(device["Mode"]) && angular.isDefined(device["Mode"]["options"])) {
            $scope.Device.Mode.options = device["Mode"]["options"];
        }

        if (angular.isDefined(device["Mode"]) && angular.isDefined(device["Mode"]["supportedOptions"])) {
            $scope.Device.Mode.supportedOptions = device["Mode"]["supportedOptions"];
        }

        if (angular.isDefined(device["Operation"])) {
            if (angular.isDefined(device["Operation"]["kidsLock"])) {
                $scope.Device.Operation.kidsLock = device["Operation"]["kidsLock"];
            }
            if (angular.isDefined(device["Operation"]["power"])) {
                $scope.Device.Operation.power = device["Operation"]["power"];
            }
            if (angular.isDefined(device["Operation"]["progress"])) {
                $scope.Device.Operation.progress = device["Operation"]["progress"];
            }
            if (angular.isDefined(device["Operation"]["progressPercentage"])) {
                $scope.Device.Operation.progressPercentage = device["Operation"]["progressPercentage"];
            }
            if (angular.isDefined(device["Operation"]["remainingTime"])) {
                $scope.Device.Operation.remainingTime = device["Operation"]["remainingTime"];
            }
            if (angular.isDefined(device["Operation"]["state"])) {
                $scope.Device.Operation.state = device["Operation"]["state"];
            }
            if (angular.isDefined(device["Operation"]["supportedProgress"])) {
                $scope.Device.Operation.supportedProgress = device["Operation"]["supportedProgress"];
            }
        }

        if (angular.isDefined(device["Washer"])) {
            if (angular.isDefined(device["Washer"]["dryLevel"])) {
                $scope.Device.Washer.dryLevel = device["Washer"]["dryLevel"];
            }
            if (angular.isDefined(device["Washer"]["dryTime"])) {
                $scope.Device.Washer.dryTime = device["Washer"]["dryTime"];
            }
            if (angular.isDefined(device["Washer"]["dryerType"])) {
                $scope.Device.Washer.dryerType = device["Washer"]["dryerType"];
            }
            if (angular.isDefined(device["Washer"]["supportedDryLevel"])) {
                $scope.Device.Washer.supportedDryLevel = device["Washer"]["supportedDryLevel"];
            }
            if (angular.isDefined(device["Washer"]["supportedDryTime"])) {
                $scope.Device.Washer.supportedDryTime = device["Washer"]["supportedDryTime"];
            }
            if (angular.isDefined(device["Washer"]["supportedWaterTemperature"])) {
                $scope.Device.Washer.supportedWaterTemperature = device["Washer"]["supportedWaterTemperature"];
            }
            if (angular.isDefined(device["Washer"]["waterTemperature"])) {
                $scope.Device.Washer.waterTemperature = device["Washer"]["waterTemperature"];
            }
            if (angular.isDefined(device["Washer"]["wrinklePrevent"])) {
                $scope.Device.Washer.wrinklePrevent = device["Washer"]["wrinklePrevent"];
            }
        }
        if (angular.isDefined(device["connected"])) {
            $scope.Device.connected = device["connected"];
        }
        if (angular.isDefined(device["name"])) {
            $scope.Device.name = device["name"];
        }
        if (angular.isDefined(device["uuid"])) {
            $scope.Device.uuid = device["uuid"];
        }
        if (angular.isDefined(device["resources"])) {
            $scope.Device.resources = device["resources"];
        }
    }

    function parseDryerData(device, isDualMainSubObject) {

        if (angular.isDefined(device["Configuration"])) {
            parseConfiguration(device["Configuration"]);
        }

        if (angular.isDefined($scope.demoErrorCode)) {
            if (isDeviceUpdateRequired($scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED ? 1 : 0)) {
                $scope.currentErrorCode = $scope.demoErrorCode;
                openErrorTextArray($scope.currentErrorCode);
            }
            if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                $scope.currentErrorCodeMain = $scope.demoErrorCode;
                openErrorTextArray($scope.currentErrorCodeMain);
            } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                $scope.currentErrorCodeSub = $scope.demoErrorCode;
                openErrorTextArray($scope.currentErrorCodeSub);
            } else {
                ;//Nothing
            }
            $scope.mainLoadingScreen = true;
            $scope.pageLoaded = true;
            return;
        }

        if (firstParse) {
            if (angular.isDefined(device["Mode"]) && angular.isDefined(device["Mode"].supportedOptions)) {
                firstParse = false;
            } else {
                return;
            }
        }

        if (angular.isDefined(device["type"])) {
            if (isDeviceUpdateRequired($scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED ? 1 : 0)) {
                $scope.deviceType = device["type"];
            }
            if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                $scope.deviceTypeMain = device["type"];
            } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                $scope.deviceTypeSub = device["type"];
            } else {
                ;//Nothing
            }
        }

        if (angular.isDefined(device["description"])) {
            updateDeviceName(device["description"]);
        }

        if (angular.isDefined(device["EnergyConsumption"]) && angular.isDefined(device["EnergyConsumption"].saveLocation)) {
            $scope.energyMonitorLocation = device["EnergyConsumption"].saveLocation;
            $scope.showEnergyMonitorOption = true;
            $scope.optionCodeValue = "OptionCode_16384";   // hardcoded for native processing
        }

        if (angular.isDefined(device["resources"])) {
            showSmartCheck(device["resources"]);
        }

        if (angular.isDefined(device["Mode"])) {
            if (angular.isDefined(device["Mode"].supportedOptions)) {
                if (!$scope.isDualDryer && ($scope.homePage || $scope.detailPage)) {
                    goToHome();
                }
                parseCourseOptions(device["Mode"].supportedOptions[0], isDualMainSubObject);
            }
            if (angular.isDefined(device["Mode"].options)) {
                if (!$scope.cycFinish || ($scope.cycFinish && $scope.isLaundryEnabled)) {
                    updateDeviceModel(device["Mode"].options, isDualMainSubObject);
                }
            }
        }
        if (angular.isDefined(device["Washer"]) && !$scope.cycFinish) {
            parseDefaultOptionValues(device["Washer"], isDualMainSubObject);
        }
        if (angular.isDefined(device["Operation"]) && (!$scope.isDualDryer || ($scope.isDualDryer && !$scope.cycFinish))) {
            updateOperation(device["Operation"]);
        }
        if (angular.isDefined(device["Alarms"])) {
            checkAlarms(device, isDualMainSubObject);
        }
        if (angular.isDefined(device["Diagnosis"])) {
            showDiagnosisPage(device["Diagnosis"]);
        }
    }

    function closeConnectionFailurePopup() {
        if ($scope.errorList.length > 0) {
            $scope.errorList.pop();
        }
    }

    function showSmartCheck(resourcevalue) {
        resourcevalue.forEach(function (value) {
            if (value.indexOf("Diagnosis") !== -1) {
                $scope.showSmartCare = true;
            }
        });
    }

    function checkAlarms(alarmString, isDualMainSubObject) {
        if (isDualMainSubObject || alarmString["Alarms"][0] === undefined) {
            return;
        }
        if (angular.isDefined(alarmString["Alarms"][0].code)) {
            if (alarmString["Alarms"][0].code === "HotWarning") {
                if (!angular.isDefined(alarmString.event) || alarmString.event === "Created") {
                    if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                        $scope.hotwarning = true;
                    }
                    if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                        $scope.hotwarningMain = true;
                    } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                        $scope.hotwarningSub = true;
                    } else {
                        ;//Nothing
                    }
                } else if (alarmString.event === "Deleted") {
                    if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                        $scope.hotwarning = false;
                    }
                    if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                        $scope.hotwarningMain = false;
                    } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                        $scope.hotwarningSub = false;
                    } else {
                        ;//Nothing
                    }
                } else {
                    ;//Nothing
                }
            } else if (alarmString["Alarms"][0].code.indexOf("Vent_") !== -1) {
                if (alarmString.event === "Created") {
                    $scope.alertState = DRYERALERT.VENT;
                    var tempSectionInfo = '';
                    if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                        tempSectionInfo = '[' + $scope.translation.WEBMOB_device_washer_comm_front_loader_dryer + ']<br>';
                    } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                        tempSectionInfo = '[' + $scope.translation.WEBMOB_device_washer_comm_top_loader_dryer + ']<br>';
                    } else {
                        ;//Nothing
                    }
                    if (alarmString["Alarms"][0].code === "Vent_Lev1") {
                        $scope.errorList.push({
                            title: '',
                            msg: tempSectionInfo + $scope.translation.WEBMOB_device_washer_alarm_vent_level_1_msg,
                            btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                            btnOkHandler: function () {
                                $scope.onOkClicked(true);
                            },
                            closeDialog: false
                        });
                        changePopUpClass(true);
                    } else if (alarmString["Alarms"][0].code === "Vent_Lev2") {
                        $scope.errorList.push({
                            title: '',
                            msg: tempSectionInfo + $scope.translation.WEBMOB_device_washer_alarm_vent_level_2_msg,
                            btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                            btnOkHandler: function () {
                                $scope.onOkClicked(true);
                            },
                            closeDialog: false
                        });
                        changePopUpClass(true);
                    } else {
                        //Nothing
                    }
                } else if (alarmString.event === "Deleted") {
                    //Nothing
                } else {
                    // Nothing
                }
            } else if (alarmString["Alarms"][0].code !== "ErrorChecking") {
                debugMessage("Alarm function");
                if (!angular.isDefined(alarmString.event) || alarmString.event === "Created") { //!angular.isDefined(alarmString.event) || 

                    if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                        $scope.isErrorMain = true;
                    } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                        $scope.isErrorSub = true;
                    } else {
                        ;//Nothing
                    }

                    var alarmtxt = alarmString["Alarms"][0].code;
                    alarmtxt = alarmtxt.split("_")[1];
                    if (alarmtxt === undefined) {
                        return;
                    }
                    alarmtxt = alarmtxt.toLowerCase();
                    debugMessage("alarm text is ::" + alarmtxt);
                    if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                        $scope.errorTitle = getErrorTitle(alarmtxt);
                        $scope.errorResult = getErrorMessage(alarmtxt);
                        $scope.errorAction = getErrorAction(alarmtxt);
                    }
                    if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                        $scope.errorTitleMain = getErrorTitle(alarmtxt);
                        $scope.errorResultMain = getErrorMessage(alarmtxt);
                        $scope.errorActionMain = getErrorAction(alarmtxt);
                    } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                        $scope.errorTitleSub = getErrorTitle(alarmtxt);
                        $scope.errorResultSub = getErrorMessage(alarmtxt);
                        $scope.errorActionSub = getErrorAction(alarmtxt);
                    } else {
                        ;//Nothing
                    }
                    if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                        //if (!$scope.isDualDryer || ($scope.isDualDryer && ($scope.currentWasherSelected === WASHERCURRENTSEL.MAIN_SELECTED || $scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED))) {

                        if ($scope.currentScreen !== WASHERSCREENS.ALARMSCREEN) {
                            $scope.previousScreenError = $scope.currentScreen;
                        }
                        if (!$scope.homePage) {
                            $scope.currentScreen = WASHERSCREENS.ALARMSCREEN;
                            $scope.changeScreen();
                        }
                    }
                    return;
                } else if (alarmString.event === "Deleted") {
                    if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                        $scope.isErrorMain = false;
                    } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                        $scope.isErrorSub = false;
                    } else {
                        ;//Nothing
                    }
                    if ($scope.custDialogpopup) {
                        $scope.custDialogpopup = false;
                    }
                    if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                        //if (!$scope.isDualDryer || ($scope.isDualDryer && ($scope.currentWasherSelected === WASHERCURRENTSEL.MAIN_SELECTED || $scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED))) {
                        //if (!$scope.homePage) {
                        if (angular.isDefined($scope.previousScreenError) && $scope.previousScreenError !== WASHERSCREENS.HOME && $scope.previousScreenError !== WASHERSCREENS.DETAILPAGE) {
                            $scope.currentScreen = $scope.previousScreenError;
                        } else if ($scope.currentScreen === WASHERSCREENS.ALARMSCREEN) {
                            $scope.currentScreen = WASHERSCREENS.DETAILPAGE;
                        } else {
                            ;//Nothing
                        }
                        $scope.changeScreen();
                        //}
                    }
                } else {
                    ;// Nothing
                }
            } else {
                ;// Nothing
            }
        }
    }

    function updateDeviceName(deviceModelName) {
        dmName = deviceModelName.indexOf('(') > -1 ? deviceModelName.split("(")[0] : deviceModelName;
        if (dmName.indexOf("TP6X") > -1 || dmName.indexOf("DONGLE") > -1) {
            if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                $scope.showSyncTime = true;
            }
            if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                $scope.showSyncTimeMain = true;
            } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                $scope.showSyncTimeSub = true;
            } else {
                ;//Nothing
            }
        }
    }

    function closeApp() {
        nativeInterface.runOnNative("closeWebApp", "");
    }

    function doAlarmConfirm() {
        $scope.confirmButtonPressed = true;
        $scope.alarmConfirm();
    }

    function alarmConfirm() {
        $timeout(function () {
            closeApp();
            $scope.confirmButtonPressed = false;
        }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
    }

    function doAlarmService() {
        $scope.serviceButtonPressed = true;
        $scope.alarmService();
    }

    function alarmService() {
        $timeout(function () {
            $scope.alertState = DRYERALERT.ALARMSERVICE;
            $scope.callServiceIndex = 0;
            $scope.showcustDialog($scope.translation.WEBMOB_device_washer_comm_service_call, $scope.translation.WEBMOB_device_washer_alarm_service_call, true, true);
            $scope.serviceButtonPressed = false;
        }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
    }

    function alarmServicePayload(callNumb) {
        return '{"selectedCountry" : "' + $scope.selectedCountry + '","selectedDial" :"' + callNumb + '"}';
    }

    function updateDeviceModel(deviceModelMode, isDualMainSubObject) {
        deviceModelMode.forEach(function (value) {
            if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                if ((value.indexOf("Course_") !== -1) && (!$scope.cycFinish)) {
                    $scope.deviceMode = value.split("_")[1];
                    deviceCurrentMode = $scope.deviceMode;
                    // this condition added as in gasDryer only modechange coming and no operation data coming, so status not updated to ready
//                    if ($scope.isGasDryer && $scope.detailPage && $scope.Device.Operation.state === "Ready") {
//                        if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
//                            console.log("status updated to Ready");
//                            $scope.statusDisplay = true;
//                            $scope.dispStatus = $scope.translation.WEBMOB_device_washer_progressing_ready;
//                        }
//                        if ($scope.isDualDryer && $scope.isGasDryerMain && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
//                            $scope.statusDisplayMain = true;
//                            $scope.dispStatusMain = $scope.translation.WEBMOB_device_washer_progressing_ready;
//                        } else if ($scope.isDualDryer && $scope.isGasDryerSub && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
//                            $scope.statusDisplaySub = true;
//                            $scope.dispStatusSub = $scope.translation.WEBMOB_device_washer_progressing_ready;
//                        } else {
//                            ;//Nothing
//                        }
//                    }

                    $scope.mixedLoadBellValue = false;
                    $scope.mixedLoadBellSetValue = false;
                    closeAllPopups();
                    showModeDefault();
                    debugMessage("The vale of mode is ::mode name is::" + $scope.deviceMode);
                }
            }
            if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                if ((value.indexOf("Course_") !== -1) && (!$scope.cycFinishMain)) {
                    $scope.deviceModeMain = value.split("_")[1];
                    deviceCurrentMode = $scope.deviceModeMain;
                    $scope.mixedLoadBellValueMain = false;
                    $scope.mixedLoadBellSetValueMain = false;
                    closeAllPopups();
                    showModeDefault();
                    debugMessage("The vale of mode is ::mode name is::" + $scope.deviceMode);
                }
            } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                if ((value.indexOf("Course_") !== -1) && (!$scope.cycFinishSub)) {
                    $scope.deviceModeSub = value.split("_")[1];
                    deviceCurrentMode = $scope.deviceModeSub;
                    $scope.mixedLoadBellValueSub = false;
                    $scope.mixedLoadBellSetValueSub = false;
                    closeAllPopups();
                    showModeDefault();
                    debugMessage("The vale of mode is ::mode name is::" + $scope.deviceMode);
                }
            } else {
                ;//Nothing
            }
            if (value.indexOf("DeviceType") !== -1) {
                $scope.deviceModel = value;
                debugMessage("Device model name is::" + $scope.deviceModel);
            }
            if (value.indexOf("Drytime") !== -1) {
                $scope.specialDryTime = value.slice(-2);
                if ($scope.specialDryTime.indexOf("_") !== -1) {
                    $scope.specialDryTime = $scope.specialDryTime.slice(-1);
                }
                devicedryTimeValue = $scope.specialDryTime;
                debugMessage("specialDryTime is::" + $scope.specialDryTime);
                if ($scope.specialDryTime === "0") {
                    $scope.specialDryTime = -1;
                    devicedryTimeValue = -1;
                } else {
                    specialCaseDryer();
                }
                updateOptionsGUI();
            }
//            else {
//                $scope.specialDryTime = -1;
//            }
            if (value.indexOf("RackDry") !== -1) {
                if (value === "RackDry_Enable") {
                    rackDry = true;
                } else {
                    rackDry = false;
                }
                specialCaseRack();
            }            
            if (value.indexOf("LaundryOutTime") !== -1) {
                dismissLoadingBar(WASHER_COMMANDS.laundry);

                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    $scope.isLaundryEnabled = true;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    $scope.isLaundryEnabledMain = true;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    $scope.isLaundryEnabledSub = true;
                } else {
                    ;//Nothing
                }

                var laundryVal = value.split("_")[1];
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    $scope.laundryOpt2 = false;
                    $scope.laundryOpt3 = false;
                    $scope.laundryOpt4 = false;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    $scope.laundryOpt2Main = false;
                    $scope.laundryOpt3Main = false;
                    $scope.laundryOpt4Main = false;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    $scope.laundryOpt2Sub = false;
                    $scope.laundryOpt3Sub = false;
                    $scope.laundryOpt4Sub = false;
                } else {
                    ;//Nothing
                }

                if (laundryVal === "0") {
                    if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                        $scope.laundrySwitch = false;
                        $scope.laundryOnOffText = $scope.translation.WEBMOB_device_washer_comm_off_CL;
                        currentLaundryVal = 0;
                    }
                    if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                        $scope.laundrySwitchMain = false;
                        $scope.laundryOnOffTextMain = $scope.translation.WEBMOB_device_washer_comm_off_CL;
                        currentLaundryValMain = 0;
                    } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                        $scope.laundrySwitchSub = false;
                        $scope.laundryOnOffTextSub = $scope.translation.WEBMOB_device_washer_comm_off_CL;
                        currentLaundryValSub = 0;
                    } else {
                        ;//Nothing
                    }
                } else if (laundryVal === "30") {
                    if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                        currentLaundryVal = 2;
                        $scope.laundryOpt2 = true;
                        $scope.laundrySwitch = true;
                    }
                    if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                        currentLaundryValMain = 2;
                        $scope.laundryOpt2Main = true;
                        $scope.laundrySwitchMain = true;
                    } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                        currentLaundryValSub = 2;
                        $scope.laundryOpt2Sub = true;
                        $scope.laundrySwitchSub = true;
                    } else {
                        ;//Nothing
                    }
                } else if (laundryVal === "60") {
                    if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                        currentLaundryVal = 3;
                        $scope.laundryOpt3 = true;
                        $scope.laundrySwitch = true;
                    }
                    if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                        currentLaundryValMain = 3;
                        $scope.laundryOpt3Main = true;
                        $scope.laundrySwitchMain = true;
                    } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                        currentLaundryValSub = 3;
                        $scope.laundryOpt3Sub = true;
                        $scope.laundrySwitchSub = true;
                    } else {
                        ;//Nothing
                    }
                } else if (laundryVal === "90") {
                    if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                        currentLaundryVal = 4;
                        $scope.laundryOpt4 = true;
                        $scope.laundrySwitch = true;
                    }
                    if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                        currentLaundryValMain = 4;
                        $scope.laundryOpt4Main = true;
                        $scope.laundrySwitchMain = true;
                    } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                        currentLaundryValSub = 4;
                        $scope.laundryOpt4Sub = true;
                        $scope.laundrySwitchSub = true;
                    } else {
                        ;//Nothing
                    }
                } else {
                    ;//Nothing
                }
                if (laundryVal === "0") {
                    if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0) && $scope.cycFinish) {
                        $scope.disableLaundry = true;
                    }
                    if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER && $scope.cycFinishMain) {
                        $scope.disableLaundryMain = true;
                    } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER && $scope.cycFinishSub) {
                        $scope.disableLaundrySub = true;
                    } else {
                        ;//Nothing
                    }
                }

                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    tempLaundryVal = currentLaundryVal;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    tempLaundryValMain = currentLaundryVal;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    tempLaundryValSub = currentLaundryVal;
                } else {
                    ;//Nothing
                }
                updateLaundryStatusText();
                debugMessage("Device model name is::" + $scope.deviceModel);
            }
            if (value.indexOf("LaundryOut_Notice") !== -1 && isDualMainSubObject !== true) {
                var notiMsg = $scope.translation.WEBMOB_device_washer_alarm_remaining_laundry_msg_dryer;
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    notiMsg = '[' + $scope.translation.WEBMOB_device_washer_comm_front_loader_dryer + ']<br>' + $scope.translation.WEBMOB_device_washer_alarm_remaining_laundry_msg_dryer;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    notiMsg = '[' + $scope.translation.WEBMOB_device_washer_comm_top_loader_dryer + ']<br>' + $scope.translation.WEBMOB_device_washer_alarm_remaining_laundry_msg_dryer;
                } else {
                    ;//Nothing
                }
                $scope.errorList.push({
                    title: $scope.translation.WEBMOB_device_washer_settings_remaining_laundry,
                    msg: notiMsg,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                    btnOkHandler: function () {
                        $scope.onOkClicked(true);
                    },
                    closeDialog: !true
                });
                changePopUpClass(true);
            }

            if (value.indexOf("MixedLoadBell_Enable") !== -1) {
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    $scope.mixedLoadBellValue = true;
                    $scope.mixedLoadBellSetValue = true;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    $scope.mixedLoadBellValueMain = true;
                    $scope.mixedLoadBellSetValueMain = true;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    $scope.mixedLoadBellValueSub = true;
                    $scope.mixedLoadBellSetValueSub = true;
                } else {
                    ;//Nothing
                }
            }
            if (value.indexOf("MixedLoadBell_Disable") !== -1) {
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    $scope.mixedLoadBellValue = false;
                    $scope.mixedLoadBellSetValue = false;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    $scope.mixedLoadBellValueMain = false;
                    $scope.mixedLoadBellSetValueMain = false;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    $scope.mixedLoadBellValueSub = false;
                    $scope.mixedLoadBellSetValueSub = false;
                } else {
                    ;//Nothing
                }
            }
            if (value.indexOf("MixedLoadBellSet_") !== -1) {
                dismissLoadingBar(WASHER_COMMANDS.mixedLoadBell);
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    $scope.showMixedLoadBell = true;
                    updateDisableMixedLoadStateForModes(value.split('_')[1], WASHERTOUPDATE.SINGLEWASHER);
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    $scope.showMixedLoadBellMain = true;
                    updateDisableMixedLoadStateForModes(value.split('_')[1], WASHERTOUPDATE.MAINWASHER);
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    $scope.showMixedLoadBellSub = true;
                    updateDisableMixedLoadStateForModes(value.split('_')[1], WASHERTOUPDATE.SUBWASHER);
                } else {
                    ;//Nothing
                }
            }

            if (value.indexOf("EnergyLevelSet_") !== -1) {
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    $scope.showEnergyLevelSet = true;
                    updateEnergyLevelSet(value.split('_')[1], WASHERTOUPDATE.SINGLEWASHER);
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    $scope.showEnergyLevelSetMain = true;
                    updateEnergyLevelSet(value.split('_')[1], WASHERTOUPDATE.MAINWASHER);
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    $scope.showEnergyLevelSetSub = true;
                    updateEnergyLevelSet(value.split('_')[1], WASHERTOUPDATE.SUBWASHER);
                } else {
                    ;//Nothing
                }
            }
            if (value.indexOf("MixedLoadBell_Notice") !== -1 && isDualMainSubObject !== true) {
                var notiMsg = $scope.translation.WEBMOB_device_washer_alarm_mixed_load_bell_msg;
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    notiMsg = '[' + $scope.translation.WEBMOB_device_washer_comm_front_loader_dryer + ']<br>' + $scope.translation.WEBMOB_device_washer_alarm_mixed_load_bell_msg;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    notiMsg = '[' + $scope.translation.WEBMOB_device_washer_comm_top_loader_dryer + ']<br>' + $scope.translation.WEBMOB_device_washer_alarm_mixed_load_bell_msg;
                } else {
                    ;//Nothing
                }
                $scope.errorList.push({
                    title: $scope.translation.WEBMOB_device_washer_alarm_mixed_load_bell_msg,
                    msg: notiMsg,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                    btnOkHandler: function () {
                        onOkClicked(true);
                    },
                    closeDialog: !true
                });
                changePopUpClass(true);
                return;
            }

            if (value.indexOf("SeamlessControl") !== -1) {
                dismissLoadingBar(WASHER_COMMANDS.SAEMLESS_CONTROL);
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    $scope.showSeamLessControl = true;
                    if (value.split("_")[1] === "Enable") {
                        $scope.seamLessControlValue = true;
                    } else {
                        $scope.seamLessControlValue = false;
                        if ($scope.cycFinish && !$scope.isDualDryer) {
                            callGetDevice();
                            return;
                        }
                    }
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    $scope.showSeamLessControlMain = true;
                    if (value.split("_")[1] === "Enable") {
                        $scope.seamLessControlValueMain = true;
                    } else {
                        $scope.seamLessControlValueMain = false;
                        if ($scope.cycFinishMain && !isDualMainSubObject) {
                            callGetDevice();
                            return;
                        }
                    }
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    $scope.showSeamLessControlSub = true;
                    if (value.split("_")[1] === "Enable") {
                        $scope.seamLessControlValueSub = true;
                    } else {
                        $scope.seamLessControlValueSub = false;
                        if ($scope.cycFinishSub && !isDualMainSubObject) {
                            callGetDevice();
                            return;
                        }
                    }
                } else {
                    ;//Nothing
                }
            }

            if (value.indexOf("KidsLockBypass") !== -1) {
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    $scope.kidsLockByPass = true;
                    $scope.kidsLock = false;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    $scope.kidsLockByPassMain = true;
                    $scope.kidsLockSub = false;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    $scope.kidsLockByPassSub = true;
                    $scope.kidsLockSub = false;
                } else {
                    ;//Nothing
                }
            }
            if ($scope.getDeviceInProgress === true && value.indexOf("EnergyKW_396") !== -1 ) {
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    $scope.NoEnergyKW_396 = false;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    $scope.NoEnergyKW_396Main = false;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    $scope.NoEnergyKW_396Sub = false;
                } else {
                    ;//Nothing
                }

            }
        });
    }

    function showModeDefault() {
        var tempDeviceMode = $scope.deviceMode;

        if ($scope.deviceMode !== undefined) {
            var listModes = $scope.listItemsModes;

            if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                listModes = $scope.listItemsModesMain;
                tempDeviceMode = $scope.deviceModeMain;
            } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                listModes = $scope.listItemsModesSub;
                tempDeviceMode = $scope.deviceModeSub;
            } else {
                ;//Nothing
            }

            for (var index = 0; index < listModes.length; index++) {
                if (listModes[index].courseNameHex == tempDeviceMode) {  //=== fails here
                    break;
                }
            }
            if (index === listModes.length) {
                console.log("mode not found ::" + $scope.deviceMode);
                return;
            }
            updateLandingpage(listModes[index]);
        } else {
            $scope.selectIndex(listModes[0]);
        }
    }

    function parseCourseOptions(courseData, isDualMainSubObject) {
        var tempModeArray = [];
        debugMessage("Dryer: In the washer parsing course method");
        if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
            $scope.Device['CourseData'] = [];
        }
        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
            $scope.Device['CourseData'] = [];
            $scope.mainDryerData['CourseData'] = [];
        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
            $scope.Device['CourseData'] = [];
            $scope.subDryerData['CourseData'] = [];
        } else {
            ; //Nothing
        }

        CourseParseService.getCourseParsed(courseData, $scope, $scope.washerToUpdate);
        //debugMessage($scope.Device['CourseData']);

        if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
            if (isDualMainSubObject) {
                tempModeArray = [];
                tempModeArray = jQuery.extend(true, {}, $scope.listItemsModes);
            }
            $scope.listItemsModes = $scope.Device['CourseData'];
            if (isDualMainSubObject) {
                for (var i = 0; i < $scope.listItemsModes.length; i++) {
                    if (angular.isDefined(tempModeArray[i].energyLevelValue)) {
                        $scope.listItemsModes[i].energyLevelValue = tempModeArray[i].energyLevelValue;
                    }
                    if (angular.isDefined(tempModeArray[i].LevelValue)) {
                        $scope.listItemsModes[i].LevelValue = tempModeArray[i].LevelValue;
                    }
                }
            }
        }
        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
            if (isDualMainSubObject) {
                tempModeArray = [];
                tempModeArray = jQuery.extend(true, {}, $scope.listItemsModesMain);
            }
            $scope.listItemsModesMain = $scope.mainDryerData['CourseData'];
            if ($scope.currentWasherSelected === WASHERCURRENTSEL.MAIN_SELECTED) {
                $scope.listItemsModes = $scope.mainDryerData['CourseData'];
            }
            if (isDualMainSubObject) {
                for (var i = 0; i < $scope.listItemsModesMain.length; i++) {
                    if (angular.isDefined(tempModeArray[i].energyLevelValue)) {
                        $scope.listItemsModesMain[i].energyLevelValue = tempModeArray[i].energyLevelValue;
                    }
                    if (angular.isDefined(tempModeArray[i].LevelValue)) {
                        $scope.listItemsModesMain[i].LevelValue = tempModeArray[i].LevelValue;
                    }
                }
            }
        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
            if (isDualMainSubObject) {
                tempModeArray = [];
                tempModeArray = jQuery.extend(true, {}, $scope.listItemsModesSub);
            }
            $scope.listItemsModesSub = $scope.subDryerData['CourseData'];
            if ($scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
                $scope.listItemsModes = $scope.subDryerData['CourseData'];
            }
            if (isDualMainSubObject) {
                for (var i = 0; i < $scope.listItemsModesSub.length; i++) {
                    if (angular.isDefined(tempModeArray[i].energyLevelValue)) {
                        $scope.listItemsModesSub[i].energyLevelValue = tempModeArray[i].energyLevelValue;
                    }
                    if (angular.isDefined(tempModeArray[i].LevelValue)) {
                        $scope.listItemsModesSub[i].LevelValue = tempModeArray[i].LevelValue;
                    }
                }
            }
        } else {
            ;//Nothing
        }

        if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
            if ($scope.cycFinish && !isDualMainSubObject) {
                $scope.cycFinish = false;
            }
        }
        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER && $scope.cycFinishMain) {
            if ($scope.cycFinishMain && !isDualMainSubObject) {
                $scope.cycFinishMain = false;
            }
        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER && $scope.cycFinishSub) {
            if ($scope.cycFinishSub && !isDualMainSubObject) {
                $scope.cycFinishSub = false;
            }
        } else {
            ;//Nothing
        }
        var timeVal = JSON.parse(getLocalStorageData('DRYERsyncTime'));
        if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
            $scope.syncTime = timeVal;
        }
        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
            var timeValMain = JSON.parse(getLocalStorageData('DRYERsyncTimeMain'));
            $scope.syncTimeMain = timeValMain;
        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
            var timeValSub = JSON.parse(getLocalStorageData('DRYERsyncTimeSub'));
            $scope.syncTimeSub = timeValSub;
        } else {
            ;//Nothing
        }
    }

    function parseDefaultOptionValues(defaultSetValues, isDualMainSubObject) {
        if (angular.isDefined(defaultSetValues.dryerType)) {
            if (defaultSetValues.dryerType === "Gas") {
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    $scope.isGasDryer = true;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    $scope.isGasDryerMain = true;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    $scope.isGasDryerSub = true;
                } else {
                    ;//Nothing
                }
            } else if (defaultSetValues.dryerType === "EPA") {
                dryType_epa = true;
            } else if (defaultSetValues.dryerType === "Electricity") {
                dryType_epa = false;
            } else {
                ;//Nothing
            }
        }
        if (angular.isDefined(defaultSetValues.supportedWaterTemperature) && !isDualMainSubObject) {
            if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                $scope.listItemsTemp = defaultSetValues.supportedWaterTemperature.slice();
                $scope.listItemsTemp.reverse();
                $scope.listItemsTemp.pop();
            }
            if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                $scope.listItemsTempMain = defaultSetValues.supportedWaterTemperature.slice();
                $scope.listItemsTempMain.reverse();
                $scope.listItemsTempMain.pop();
            } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                $scope.listItemsTempSub = defaultSetValues.supportedWaterTemperature.slice();
                $scope.listItemsTempSub.reverse();
                $scope.listItemsTempSub.pop();
            } else {
                ;//Nothing
            }
        }
        if (angular.isDefined(defaultSetValues.supportedDryTime) && !isDualMainSubObject) {
            if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                $scope.listItemsDryTime = defaultSetValues.supportedDryTime.slice();
                $scope.listItemsDryTime.reverse();
                $scope.listItemsDryTime.pop();
            }
            if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                $scope.listItemsDryTimeMain = defaultSetValues.supportedDryTime.slice();
                $scope.listItemsDryTimeMain.reverse();
                $scope.listItemsDryTimeMain.pop();
            } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                $scope.listItemsDryTimeSub = defaultSetValues.supportedDryTime.slice();
                $scope.listItemsDryTimeSub.reverse();
                $scope.listItemsDryTimeSub.pop();
            } else {
                ;//Nothing
            }
        }
        if (angular.isDefined(defaultSetValues.supportedDryLevel) && !isDualMainSubObject) {
            if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                $scope.listItemsDryLevel = defaultSetValues.supportedDryLevel.slice();
                $scope.listItemsDryLevel.reverse();
                $scope.listItemsDryLevel.pop();
            }
            if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                $scope.listItemsDryLevelMain = defaultSetValues.supportedDryLevel.slice();
                $scope.listItemsDryLevelMain.reverse();
                $scope.listItemsDryLevelMain.pop();
            } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                $scope.listItemsDryLevelSub = defaultSetValues.supportedDryLevel.slice();
                $scope.listItemsDryLevelSub.reverse();
                $scope.listItemsDryLevelSub.pop();
            } else {
                ;//Nothing
            }
        }
        if (angular.isDefined(defaultSetValues.waterTemperature)) {
            if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                $scope.setTemp = defaultSetValues.waterTemperature;
                deviceSetTemp = $scope.setTemp;
            }
            if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                $scope.setTempMain = defaultSetValues.waterTemperature;
                deviceSetTempMain = $scope.setTempMain;
            } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                $scope.setTempSub = defaultSetValues.waterTemperature;
                deviceSetTempSub = $scope.setTempSub;
            } else {
                ;//Nothing
            }
        }
        if (angular.isDefined(defaultSetValues.dryTime)) {

            if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                $scope.setDryTime = defaultSetValues.dryTime;
                deviceSetDryTime = $scope.setDryTime;
                if ($scope.setDryTime !== '00:00:00') {
                    $scope.specialDryTime = -1;
                }
            }
            if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                $scope.setDryTimeMain = defaultSetValues.dryTime;
                deviceSetDryTimeMain = $scope.setDryTimeMain;
                if ($scope.setDryTimeMain !== '00:00:00') {
                    $scope.specialDryTimeMain = -1;
                }
            } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                $scope.setDryTimeSub = defaultSetValues.dryTime;
                deviceSetDryTimeSub = $scope.setDryTimeSub;
                if ($scope.setDryTimeSub !== '00:00:00') {
                    $scope.setDryTimeSub = -1;
                }
            } else {
                ;//Nothing
            }
        }
        if (angular.isDefined(defaultSetValues.dryLevel)) {
            if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                $scope.setDryLevel = defaultSetValues.dryLevel;
                deviceSetDryLevel = $scope.setDryLevel;
                switch ($scope.setDryLevel) {
                    case 'None':
                        dryLevelSelectedIndex = 0;
                        break;
                    case 'Damp':
                        dryLevelSelectedIndex = 1;
                        break;
                    case 'Less':
                        dryLevelSelectedIndex = 2;
                        break;
                    case 'Normal':
                        dryLevelSelectedIndex = 3;
                        break;
                    case 'More':
                        dryLevelSelectedIndex = 4;
                        break;
                    case 'Very':
                        dryLevelSelectedIndex = 5;
                        break;
                    default:
                        break;
                }

            }
            if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                $scope.setDryLevelMain = defaultSetValues.dryLevel;
                deviceSetDryLevelMain = $scope.setDryLevelMain;
            } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                $scope.setDryLevelSub = defaultSetValues.dryLevel;
                deviceSetDryLevelSub = $scope.setDryLevelSub;
            } else {
                ;//Nothing
            }
        }
        if (angular.isDefined(defaultSetValues.wrinklePrevent)) {
            if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                $scope.Device.Washer.wrinklePrevent = defaultSetValues.wrinklePrevent;
            }
            if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                $scope.mainDryerData.Washer.wrinklePrevent = defaultSetValues.wrinklePrevent;
            } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                $scope.subDryerData.Washer.wrinklePrevent = defaultSetValues.wrinklePrevent;
            } else {
                ;//Nothing
            }
            if (defaultSetValues.wrinklePrevent === "On") {
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    $scope.wrinkleOn = true;
                    $scope.setWrinkleOn = true;
                    $scope.wrinklePreventState = true;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    $scope.wrinkleOnMain = true;
                    $scope.setWrinkleOnMain = true;
                    $scope.wrinklePreventStateMain = true;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    $scope.wrinkleOnSub = true;
                    $scope.setWrinkleOnSub = true;
                    $scope.wrinklePreventStateSub = true;
                } else {
                    ;//Nothing
                }
            } else {
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    $scope.wrinkleOn = false;
                    $scope.setWrinkleOn = false;
                    $scope.wrinklePreventState = false;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    $scope.wrinkleOnMain = false;
                    $scope.setWrinkleOnMain = false;
                    $scope.wrinklePreventStateMain = false;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    $scope.wrinkleOnSub = false;
                    $scope.setWrinkleOnSub = true;
                    $scope.wrinklePreventStateSub = false;
                } else {
                    ;//Nothing
                }
            }

            if ($scope.checkResponse.indexOf(WASHER_COMMANDS.wrinklePrevent) !== -1) {
                var notiMsg = $scope.translation.WEBMOB_device_washer_alarm_wrinkle_prevent_disable_msg;
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    notiMsg = '[' + $scope.translation.WEBMOB_device_washer_comm_front_loader_dryer + ']<br>' + $scope.translation.WEBMOB_device_washer_alarm_wrinkle_prevent_disable_msg;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    notiMsg = '[' + $scope.translation.WEBMOB_device_washer_comm_top_loader_dryer + ']<br>' + $scope.translation.WEBMOB_device_washer_alarm_wrinkle_prevent_disable_msg;
                } else {
                    ;//Nothing
                }
                $scope.errorList.push({
                    title: $scope.translation.WEBMOB_device_washer_comm_wrinkle_prevent,
                    msg: notiMsg,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                    btnOkHandler: function () {
                        $scope.onOkClicked(true);
                    },
                    closeDialog: !true
                });
                changePopUpClass(true);
            }
            dismissLoadingBar(WASHER_COMMANDS.wrinklePrevent);
        }
        showModeDefault();
        specialCaseDryer();
    }

    function checkCycleCompleteScreen(checkOn) {
        if ($scope.cycFinish && !$scope.appAlive) {
            if (checkOn) {
                $scope.alertState = -1;
                $scope.disableLaundry = false;
            } else {
                if (!$scope.laundrySwitch) {
                    $scope.disableLaundry = true;
                }
            }
        }
    }

    function updateOperation(operationValues) {
        debugMessage("power value is::" + operationValues.power);
        if (!$scope.isDualDryer && operationValues.power === "off") {
            powerOffPopUp = true;
            $scope.errorList.push({
                title: '',
                msg: $scope.translation.WEBMOB_device_washer_alarm_power_off_msg_dryer,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    $scope.okClickedAtPowerOff();
                },
                closeDialog: false
            });
            changePopUpClass(true);
        }
        if (!$scope.isDualDryer && operationValues.power === "On") {
            okClickedAtPowerOff();
        }
        if (angular.isDefined(operationValues.kidsLock)) {
            if (operationValues.kidsLock.indexOf("Ready") === -1) {
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    if ($scope.kidsLockByPass) {
                        $scope.kidsLock = false;
                    } else {
                        $scope.kidsLock = true;
                        if (!$scope.isDualWasher && $scope.notiParsingInProress) {
                            $timeout(function () {
                                $scope.errorList.push({
                                    title: $scope.translation.WEBMOB_device_washer_alarm_smart_control_off,
                                    msg: $scope.translation.WEBMOB_device_washer_alarm_child_lock_msg_dryer,
                                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                                    btnOkHandler: function () {
                                        onOkClicked(true);
                                    },
                                    closeDialog: !true
                                });
                                changePopUpClass(true);
                            }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
                        }
                    }
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    if ($scope.kidsLockByPassMain) {
                        $scope.kidsLockMain = false;
                    } else {
                        $scope.kidsLockMain = true;
                        if ($scope.notiParsingInProress) {
                            $timeout(function () {
                                $scope.errorList.push({
                                    title: $scope.translation.WEBMOB_device_washer_alarm_smart_control_off,
                                    msg: '[' + $scope.translation.WEBMOB_device_washer_comm_front_loader_dryer + ']<br>' + $scope.translation.WEBMOB_device_washer_alarm_child_lock_msg_dryer,
                                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                                    btnOkHandler: function () {
                                        onOkClicked(true);
                                    },
                                    closeDialog: !true
                                });
                                changePopUpClass(true);
                            }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
                        }
                    }
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    if ($scope.kidsLockByPassSub) {
                        $scope.kidsLockSub = false;
                    } else {
                        $scope.kidsLockSub = true;
                        if ($scope.notiParsingInProress) {
                            $timeout(function () {
                                $scope.errorList.push({
                                    title: $scope.translation.WEBMOB_device_washer_alarm_smart_control_off,
                                    msg: '[' + $scope.translation.WEBMOB_device_washer_comm_top_loader_dryer + ']<br>' + $scope.translation.WEBMOB_device_washer_alarm_child_lock_msg_dryer,
                                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                                    btnOkHandler: function () {
                                        onOkClicked(true);
                                    },
                                    closeDialog: !true
                                });
                                changePopUpClass(true);
                            }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
                        }
                    }
                } else {
                    ;//Nothing
                }
            } else {
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    $scope.kidsLock = false;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    $scope.kidsLockMain = false;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    $scope.kidsLockSub = false;
                } else {
                    ;//Nothing
                }
            }
        }

        if (angular.isDefined(operationValues.state)) {
            if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                $scope.deviceStatus = operationValues.state;
                $scope.Device.Operation.state = operationValues.state;
            }
            if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                $scope.deviceStatusMain = operationValues.state;
            } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                $scope.deviceStatusSub = operationValues.state;
            } else {
                ;//Nothing
            }
        }
        updateStatus(operationValues.progress, operationValues.power);

        if ((operationValues.state === "Ready")) {
            if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                $scope.wrinklePreventdisable = false;
                if (!$scope.cycFinish) {
                    updateCancelProgres();
                } else {
                    if (!$scope.isDualDryer && $scope.seamLessControlValue) {
                        dismissLoadingBar(WASHER_COMMANDS.cancelWasher);
                        callGetDevice();
                        return;
                    }
                }
            }
            if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                if (!$scope.cycFinishMain) {
                    updateCancelProgres();
                }
                $scope.wrinklePreventdisableMain = false;
            } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                if (!$scope.cycFinishSub) {
                    updateCancelProgres();
                }
                $scope.wrinklePreventdisableSub = false;
            } else {
                ;//Nothing
            }

            if ($scope.isGasDryer && isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                $scope.statusDisplay = true;
                $scope.dispStatus = $scope.translation.WEBMOB_device_washer_progressing_ready;
            }
            if ($scope.isDualDryer && $scope.isGasDryerMain && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                $scope.statusDisplayMain = true;
                $scope.dispStatusMain = $scope.translation.WEBMOB_device_washer_progressing_ready;
            } else if ($scope.isDualDryer && $scope.isGasDryerSub && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                $scope.statusDisplaySub = true;
                $scope.dispStatusSub = $scope.translation.WEBMOB_device_washer_progressing_ready;
            } else {
                ;//Nothing
            }
        } else if ((operationValues.state === "Run")) {
            if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                if (!$scope.homePage && currentRunItem !== undefined) {
                    $scope.wrinkleOn = $scope.setWrinkleOn;
                    $scope.mixedLoadBellValue = $scope.mixedLoadBellSetValue;
                    updateLandingpage(currentRunItem);
                }
            } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                if (currentRunItemMain !== undefined) {
                    $scope.wrinkleOnMain = $scope.setWrinkleOnMain;
                    $scope.mixedLoadBellValueMain = $scope.mixedLoadBellSetValueMain;
                    updateLandingpage(currentRunItemMain);
                }
            } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                if (currentRunItemSub !== undefined) {
                    $scope.wrinkleOnSub = $scope.setWrinkleOnSub;
                    $scope.mixedLoadBellValueSub = $scope.mixedLoadBellSetValueSub;
                    updateLandingpage(currentRunItemSub);
                }
            } else {
                ;//Nothing
            }
            if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                $scope.onPause = false;
                $scope.textDisplay = true;
                $scope.statusDisplay = true;
                $scope.wrinklePreventdisable = true;
            }
            if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                $scope.onPauseMain = false;
                $scope.textDisplayMain = true;
                $scope.statusDisplayMain = true;
                $scope.wrinklePreventdisableMain = true;
            } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                $scope.onPauseSub = false;
                $scope.textDisplaySub = true;
                $scope.statusDisplaySub = true;
                $scope.wrinklePreventdisableSub = true;
            } else {
                ;//Nothing
            }

            closeAllPopups();
            dismissLoadingBar(WASHER_COMMANDS.startWasher);
        } else if ((operationValues.state === "Pause")) {
            if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                $scope.onPause = true;
                $scope.textDisplay = true;
                $scope.statusDisplay = true;
                $scope.wrinklePreventdisable = false;
                $scope.dispStatus = $scope.translation.WEBMOB_device_washer_progressing_paused;
            }
            if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                $scope.onPauseMain = true;
                $scope.textDisplayMain = true;
                $scope.statusDisplayMain = true;
                $scope.wrinklePreventdisableMain = false;
                $scope.dispStatusMain = $scope.translation.WEBMOB_device_washer_progressing_paused;
            } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                $scope.onPauseSub = true;
                $scope.textDisplaySub = true;
                $scope.statusDisplaySub = true;
                $scope.wrinklePreventdisableSub = false;
                $scope.dispStatusSub = $scope.translation.WEBMOB_device_washer_progressing_paused;
            } else {
                ;//Nothing
            }

            dismissLoadingBar(WASHER_COMMANDS.pauseWasher);

        } else {
            ;// Nothing
        }

        updateProgressPercentage(operationValues);
        updateProgress();
    }

    function updateStatus(progressString, power) {
        if ($scope.cycFinish || power === "Off") {
            return;
        }
        switch (progressString) {
            case "Delaywash":
                if (dmName === "DV457") {
                    if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                        stringDisplay = $scope.translation.WEBMOB_device_washer_progressing_delay_start;
                    }
                    if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                        stringDisplayMain = $scope.translation.WEBMOB_device_washer_progressing_delay_start;
                    } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                        stringDisplaySub = $scope.translation.WEBMOB_device_washer_progressing_delay_start;
                    } else {
                        ;//Nothing
                    }
                } else {
                    if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                        stringDisplay = $scope.translation.WEBMOB_device_washer_progressing_delay_end;
                    }
                    if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                        stringDisplayMain = $scope.translation.WEBMOB_device_washer_progressing_delay_end;
                    } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                        stringDisplaySub = $scope.translation.WEBMOB_device_washer_progressing_delay_end;
                    } else {
                        ;//Nothing
                    }
                }
                break;
            case "Weightsensing":
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    stringDisplay = $scope.translation.WEBMOB_device_washer_progressing_load_sensing;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    stringDisplayMain = $scope.translation.WEBMOB_device_washer_progressing_load_sensing;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    stringDisplaySub = $scope.translation.WEBMOB_device_washer_progressing_load_sensing;
                } else {
                    ;//Nothing
                }
                break;
            case "Prewash":
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    stringDisplay = $scope.translation.WEBMOB_device_washer_progressing_prewashing;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    stringDisplayMain = $scope.translation.WEBMOB_device_washer_progressing_prewashing;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    stringDisplaySub = $scope.translation.WEBMOB_device_washer_progressing_prewashing;
                } else {
                    ;//Nothing
                }
                break;
            case "Wash":
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    stringDisplay = $scope.translation.WEBMOB_device_washer_progressing_washing;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    stringDisplayMain = $scope.translation.WEBMOB_device_washer_progressing_washing;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    stringDisplaySub = $scope.translation.WEBMOB_device_washer_progressing_washing;
                } else {
                    ;//Nothing
                }
                break;
            case "Rinse":
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    stringDisplay = $scope.translation.WEBMOB_device_washer_progressing_rinsing;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    stringDisplayMain = $scope.translation.WEBMOB_device_washer_progressing_rinsing;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    stringDisplaySub = $scope.translation.WEBMOB_device_washer_progressing_rinsing;
                } else {
                    ;//Nothing
                }
                break;
            case "Spin":
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    stringDisplay = $scope.translation.WEBMOB_device_washer_progressing_spin;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    stringDisplayMain = $scope.translation.WEBMOB_device_washer_progressing_spin;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    stringDisplaySub = $scope.translation.WEBMOB_device_washer_progressing_spin;
                } else {
                    ;//Nothing
                }
                break;
            case "Sud":
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    stringDisplay = $scope.translation.WEBMOB_device_washer_progressing_sud;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    stringDisplayMain = $scope.translation.WEBMOB_device_washer_progressing_sud;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    stringDisplaySub = $scope.translation.WEBMOB_device_washer_progressing_sud;
                } else {
                    ;//Nothing
                }
                break;
            case "Drying":
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    stringDisplay = $scope.translation.WEBMOB_device_washer_progressing_drying;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    stringDisplayMain = $scope.translation.WEBMOB_device_washer_progressing_drying;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    stringDisplaySub = $scope.translation.WEBMOB_device_washer_progressing_drying;
                } else {
                    ;//Nothing
                }
                break;
            case "Airwash":
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    stringDisplay = $scope.translation.WEBMOB_device_washer_progressing_airwashing;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    stringDisplayMain = $scope.translation.WEBMOB_device_washer_progressing_airwashing;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    stringDisplaySub = $scope.translation.WEBMOB_device_washer_progressing_airwashing;
                } else {
                    ;//Nothing
                }
                break;
            case "Cooling":
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    stringDisplay = $scope.translation.WEBMOB_device_washer_progressing_cooling;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    stringDisplayMain = $scope.translation.WEBMOB_device_washer_progressing_cooling;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    stringDisplaySub = $scope.translation.WEBMOB_device_washer_progressing_cooling;
                } else {
                    ;//Nothing
                }
                break;
            case "Wrinkleprevent":
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    $scope.current = 100;
                    $scope.wrinklePreventdisable = true;
                    stringDisplay = $scope.translation.WEBMOB_device_washer_progressing_wrinkle_preventing;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    $scope.currentMain = 100;
                    $scope.wrinklePreventdisableMain = true;
                    stringDisplayMain = $scope.translation.WEBMOB_device_washer_progressing_wrinkle_preventing;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    $scope.currentSub = 100;
                    $scope.wrinklePreventdisableSub = true;
                    stringDisplaySub = $scope.translation.WEBMOB_device_washer_progressing_wrinkle_preventing;
                } else {
                    ;//Nothing
                }

                wrinkleStart();
                break;
            case "Finish":
                //$scope.currentScreen = WASHERSCREENS.CYCLEFINISH;
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    $scope.cycFinish = true;
                    stringDisplay = $scope.translation.WEBMOB_device_washer_alarm_cycle_complete_dryer;
                    if (!$scope.laundrySwitch) {
                        $scope.disableLaundry = true;
                    }
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    $scope.cycFinishMain = true;
                    stringDisplayMain = $scope.translation.WEBMOB_device_washer_alarm_cycle_complete_dryer;
                    if (!$scope.laundrySwitchMain) {
                        $scope.disableLaundryMain = true;
                    }
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    $scope.cycFinishSub = true;
                    stringDisplaySub = $scope.translation.WEBMOB_device_washer_alarm_cycle_complete_dryer;
                    if (!$scope.laundrySwitchSub) {
                        $scope.disableLaundrySub = true;
                    }
                } else {
                    ;//Nothing
                }
                break;
            case "Waitend":
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    stringDisplay = $scope.translation.WEBMOB_device_washer_progressing_waitending;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    stringDisplayMain = $scope.translation.WEBMOB_device_washer_progressing_waitending;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    stringDisplaySub = $scope.translation.WEBMOB_device_washer_progressing_waitending;
                } else {
                    ;//Nothing
                }
                break;
            case "None":
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    stringDisplay = "";
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    stringDisplayMain = "";
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    stringDisplaySub = "";
                } else {
                    ;//Nothing
                }
                break;
            default:
                break;
        }
        if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
            if ($scope.isGasDryer && $scope.detailPage && stringDisplay === "") {
                console.log("skipped");
                ;// dont update status
            } else {
                $scope.dispStatus = stringDisplay;
            }
        }
        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
            if ($scope.isGasDryerMain && $scope.detailPage && stringDisplayMain === "") {
                console.log("skippedMain");
                ; //dont update
            } else {
                $scope.dispStatusMain = stringDisplayMain;
            }
        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
            if ($scope.isGasDryerSub && $scope.detailPage && stringDisplaySub === "") {
                console.log("skippedMain");
                ; //dont update
            } else {
                $scope.dispStatusSub = stringDisplaySub;
            }
        } else {
            ;//Nothing
        }
    }

    $scope.$watch(function () {
        return $scope.setTemp;
    }, function () {
        if (angular.isDefined($scope.setTemp)) {
            $scope.gettempConstant($scope.setTemp, 0);
        }
    });

    function gettempConstant(tmpDefault, value) {
        var tempString;
        var tempImageID;
        switch (tmpDefault) {
            case "Cold":
                tempString = $scope.translation[WASHER_TEMP.COLD];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_cold.svg#Layer_1";
                break;
            case "Cool":
                tempString = $scope.translation[WASHER_TEMP.COOL];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_cold.svg#Layer_1";
                break;
            case "EcoWarm":
                tempString = $scope.translation[WASHER_TEMP.EcoWarm];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_eco_warm.svg#Layer_1";
                break;
            case "Warm":
                tempString = $scope.translation[WASHER_TEMP.Warm];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_warm.svg#Layer_1";
                break;
            case "Hot":
                tempString = $scope.translation[WASHER_TEMP.Hot];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_hot.svg#Layer_1";
                break;
            case "ExtraHot":
                tempString = $scope.translation[WASHER_TEMP.ExtraHot];
                $scope.tempImageID = "Dryer/assets/img/main_list_ic_temp_extra_hot.svg#Layer_1";
                break;
            case "ExtraLow":
                tempString = $scope.translation[DRYER_TEMP.ExtraLow];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_extra_low.svg#Layer_1";
                break;
            case "Low":
                tempString = $scope.translation[DRYER_TEMP.Low];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_low.svg#Layer_1";
                break;
            case "MediumLow":
                tempString = $scope.translation[DRYER_TEMP.MediumLow];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_medium_low.svg#Layer_1";
                break;
            case "Medium":
                tempString = $scope.translation[DRYER_TEMP.Medium];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_medium.svg#Layer_1";
                break;
            case "High":
                tempString = $scope.translation[DRYER_TEMP.High];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_high.svg#Layer_1";
                break;
            case "20":
                tempString = $scope.translation[WASHER_TEMP.T20];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_20.svg#Layer_1";
                break;
            case "30":
                tempString = $scope.translation[WASHER_TEMP.T30];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_30.svg#Layer_1";
                break;
            case "40":
                tempString = $scope.translation[WASHER_TEMP.T40];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_40.svg#Layer_1";
                break;
            case "50":
                tempString = $scope.translation[WASHER_TEMP.T50];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_50.svg#Layer_1";
                break;
            case "60":
                tempString = $scope.translation[WASHER_TEMP.T60];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_60.svg#Layer_1";
                break;
            case "65":
                tempString = $scope.translation[WASHER_TEMP.T65];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_65.svg#Layer_1";
                break;
            case "70":
                tempString = $scope.translation[WASHER_TEMP.T70];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_70.svg#Layer_1";
                break;
            case "75":
                tempString = $scope.translation[WASHER_TEMP.T75];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_75.svg#Layer_1";
                break;
            case "80":
                tempString = $scope.translation[WASHER_TEMP.T80];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_80.svg#Layer_1";
                break;
            case "90":
                tempString = $scope.translation[WASHER_TEMP.T90];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_90.svg#Layer_1";
                break;
            case "95":
                tempString = $scope.translation[WASHER_TEMP.T95];
                tempImageID = "Dryer/assets/img/main_list_ic_temp_95.svg#Layer_1";
                break;
            case "None":
                tempString = WASHER_TEMP.None;
                tempImageID = "Dryer/assets/img/main_list_ic_temp_20.svg#Layer_1";
                break;
            default:
                break;
        }
        if (value === 0) {
            var svg = document.getElementById('tempSVG');
            SHPService.loadSVG(tempImageID, svg);
        } else {
            return tempString;
        }
    }

    function gettempStringFav(tmpDefault) {
        var tempString;
        switch (tmpDefault) {
            case "Cold":
                tempString = $scope.translation[WASHER_TEMP.COLD];
                break;
            case "Cool":
                tempString = $scope.translation[WASHER_TEMP.COOL];
                break;
            case "EcoWarm":
                tempString = $scope.translation[WASHER_TEMP.EcoWarm];
                break;
            case "Warm":
                tempString = $scope.translation[WASHER_TEMP.Warm];
                break;
            case "Hot":
                tempString = $scope.translation[WASHER_TEMP.Hot];
                break;
            case "ExtraHot":
                tempString = $scope.translation[WASHER_TEMP.ExtraHot];
                break;
            case "ExtraLow":
                tempString = $scope.translation[DRYER_TEMP.ExtraLow];
                break;
            case "Low":
                tempString = $scope.translation[DRYER_TEMP.Low];
                break;
            case "MediumLow":
                tempString = $scope.translation[DRYER_TEMP.MediumLow];
                break;
            case "Medium":
                tempString = $scope.translation[DRYER_TEMP.Medium];
                break;
            case "High":
                tempString = $scope.translation[DRYER_TEMP.High];
                break;
            case "20":
                tempString = $scope.translation[WASHER_TEMP.T20];
                break;
            case "30":
                tempString = $scope.translation[WASHER_TEMP.T30];
                break;
            case "40":
                tempString = $scope.translation[WASHER_TEMP.T40];
                break;
            case "50":
                tempString = $scope.translation[WASHER_TEMP.T50];
                break;
            case "60":
                tempString = $scope.translation[WASHER_TEMP.T60];
                break;
            case "65":
                tempString = $scope.translation[WASHER_TEMP.T65];
                break;
            case "70":
                tempString = $scope.translation[WASHER_TEMP.T70];
                break;
            case "75":
                tempString = $scope.translation[WASHER_TEMP.T75];
                break;
            case "80":
                tempString = $scope.translation[WASHER_TEMP.T80];
                break;
            case "90":
                tempString = $scope.translation[WASHER_TEMP.T90];
                break;
            case "95":
                tempString = $scope.translation[WASHER_TEMP.T95];
                break;
            case "None":
                tempString = WASHER_TEMP.None;
                break;
            default:
                break;
        }
        return tempString;
    }

    function gettempConstantFav(tmpDefault) {
        var tempImageID;
        switch (tmpDefault) {
            case "Cold":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_cold.svg#Layer_1";
                break;
            case "Cool":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_cold.svg#Layer_1";
                break;
            case "EcoWarm":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_eco_warm.svg#Layer_1";
                break;
            case "Warm":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_warm.svg#Layer_1";
                break;
            case "Hot":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_hot.svg#Layer_1";
                break;
            case "ExtraHot":
                $scope.tempImageID = "Dryer/assets/img/main_list_ic_temp_extra_hot.svg#Layer_1";
                break;
            case "ExtraLow":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_extra_low.svg#Layer_1";
                break;
            case "Low":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_low.svg#Layer_1";
                break;
            case "MediumLow":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_medium_low.svg#Layer_1";
                break;
            case "Medium":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_medium.svg#Layer_1";
                break;
            case "High":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_high.svg#Layer_1";
                break;
            case "20":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_20.svg#Layer_1";
                break;
            case "30":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_30.svg#Layer_1";
                break;
            case "40":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_40.svg#Layer_1";
                break;
            case "50":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_50.svg#Layer_1";
                break;
            case "60":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_60.svg#Layer_1";
                break;
            case "65":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_65.svg#Layer_1";
                break;
            case "70":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_70.svg#Layer_1";
                break;
            case "75":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_75.svg#Layer_1";
                break;
            case "80":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_80.svg#Layer_1";
                break;
            case "90":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_90.svg#Layer_1";
                break;
            case "95":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_95.svg#Layer_1";
                break;
            case "None":
                tempImageID = "Dryer/assets/img/main_list_ic_temp_20.svg#Layer_1";
                break;
            default:
                break;
        }
        return tempImageID;
    }

    $scope.$watch(function () {
        return $scope.setDryTime;
    }, function () {
        if (angular.isDefined($scope.setDryTime)) {
            $scope.getTimeConstant($scope.setDryTime, 0);
        }
    });

    function getTimeConstant(timeDefault, value) {
        if (dryType_epa && ($scope.deviceMode === WASHER_DEVICEMODES.TimeDry ||
                $scope.deviceMode === WASHER_DEVICEMODES.Normal)) {
            return $scope.checkEPATime(timeDefault, value);
        }
        var timeString;
        var timeImageID;
        switch (timeDefault) {
            case"01:00:00" :
                timeString = $scope.translation[DRYER_TIME.T60];
                timeImageID = "Dryer/assets/img/main_list_ic_time_60.svg#Layer_1";
                break;
            case"00:50:00" :
                timeString = $scope.translation[DRYER_TIME.T50];
                timeImageID = "Dryer/assets/img/main_list_ic_time_50.svg#Layer_1";
                break;
            case"00:40:00" :
                timeString = $scope.translation[DRYER_TIME.T40];
                timeImageID = "Dryer/assets/img/main_list_ic_time_40.svg#Layer_1";
                break;
            case"00:30:00" :
                timeString = $scope.translation[DRYER_TIME.T30];
                timeImageID = "Dryer/assets/img/main_list_ic_time_30.svg#Layer_1";
                break;
            case"00:20:00" :
                timeString = $scope.translation[DRYER_TIME.T20];
                timeImageID = "Dryer/assets/img/main_list_ic_time_20.svg#Layer_1";
                break;
            case"00:80:00" :
                timeString = $scope.translation[DRYER_TIME.T80];
                timeImageID = "Dryer/assets/img/main_list_ic_time_20.svg#Layer_1";
                break;
            case"00:70:00" :
                timeString = $scope.translation[DRYER_TIME.T70];
                timeImageID = "Dryer/assets/img/main_list_ic_time_20.svg#Layer_1";
                break;
            case"00:90:00" :
            case"01:30:00" :
                timeString = $scope.translation[DRYER_TIME.T90];
                timeImageID = "Dryer/assets/img/main_list_ic_time_20.svg#Layer_1";
                break;
            case"00:100:00" :
                timeString = DRYER_TIME.T100;
                timeImageID = "Dryer/assets/img/main_list_ic_time_20.svg#Layer_1";
                break;
            case"02:00:00" :
                timeString = $scope.translation[DRYER_TIME.T120];
                timeImageID = "Dryer/assets/img/main_list_ic_time_20.svg#Layer_1";
                break;
            case"02:30:00" :
                timeString = $scope.translation[DRYER_TIME.T150];
                timeImageID = "Dryer/assets/img/main_list_ic_time_20.svg#Layer_1";
                break;
            case"00:00:00" :
                timeString = DRYER_TIME.T00;
                timeImageID = "Dryer/assets/img/main_list_ic_time_20.svg#Layer_1";
                break;
            default:
                timeString = timeDefault;
                timeImageID = "Dryer/assets/img/main_list_ic_time_automatic.svg#Layer_1";
                break;
        }
        if (value === 0) {
            var svg = document.getElementById('timeSVG');
            SHPService.loadSVG(timeImageID, svg);
        } else {
            if (timeString !== '-') {
                return timeString + $scope.translation.WEBMOB_device_washer_comm_min;
            } else {
                return timeString;
            }
        }
    }

    function getTimeConstantFav(timeDefault) {
        var timeImageID;
        switch (timeDefault) {
            case"01:00:00" :
                timeImageID = "Dryer/assets/img/main_list_ic_time_60.svg#Layer_1";
                break;
            case"00:50:00" :
                timeImageID = "Dryer/assets/img/main_list_ic_time_50.svg#Layer_1";
                break;
            case"00:40:00" :
                timeImageID = "Dryer/assets/img/main_list_ic_time_40.svg#Layer_1";
                break;
            case"00:30:00" :
                timeImageID = "Dryer/assets/img/main_list_ic_time_30.svg#Layer_1";
                break;
            case"00:20:00" :
                timeImageID = "Dryer/assets/img/main_list_ic_time_20.svg#Layer_1";
                break;
            case"00:80:00" :
                timeImageID = "Dryer/assets/img/main_list_ic_time_20.svg#Layer_1";
                break;
            case"00:70:00" :
                timeImageID = "Dryer/assets/img/main_list_ic_time_20.svg#Layer_1";
                break;
            case"00:90:00" :
            case"01:30:00" :
                timeImageID = "Dryer/assets/img/main_list_ic_time_20.svg#Layer_1";
                break;
            case"00:100:00" :
                timeImageID = "Dryer/assets/img/main_list_ic_time_20.svg#Layer_1";
                break;
            case"02:00:00" :
                timeImageID = "Dryer/assets/img/main_list_ic_time_20.svg#Layer_1";
                break;
            case"02:30:00" :
                timeImageID = "Dryer/assets/img/main_list_ic_time_20.svg#Layer_1";
                break;
            case"00:00:00" :
                timeImageID = "Dryer/assets/img/main_list_ic_time_20.svg#Layer_1";
                break;
            default:
                timeImageID = "Dryer/assets/img/main_list_ic_time_automatic.svg#Layer_1";
                break;
        }
        return timeImageID;
    }

    function getTimeStringForFav(timeDefault) {
        var timeString;
        switch (timeDefault) {
            case"01:00:00" :
                timeString = $scope.translation[DRYER_TIME.T60];
                break;
            case"00:50:00" :
                timeString = $scope.translation[DRYER_TIME.T50];
                break;
            case"00:40:00" :
                timeString = $scope.translation[DRYER_TIME.T40];
                break;
            case"00:30:00" :
                timeString = $scope.translation[DRYER_TIME.T30];
                break;
            case"00:20:00" :
                timeString = $scope.translation[DRYER_TIME.T20];
                break;
            case"00:80:00" :
                timeString = $scope.translation[DRYER_TIME.T80];
                break;
            case"00:70:00" :
                timeString = $scope.translation[DRYER_TIME.T70];
                break;
            case"00:90:00" :
            case"01:30:00" :
                timeString = $scope.translation[DRYER_TIME.T90];
                break;
            case"00:100:00" :
                timeString = DRYER_TIME.T100;
                break;
            case"02:00:00" :
                timeString = $scope.translation[DRYER_TIME.T120];
                break;
            case"02:30:00" :
                timeString = $scope.translation[DRYER_TIME.T150];
                break;
            case"00:00:00" :
                timeString = DRYER_TIME.T00;
                break;
            default:
                timeString = timeDefault;
                break;
        }
        if (timeString !== '-') {
            return timeString + $scope.translation.WEBMOB_device_washer_comm_min;
        } else {
            return timeString;
        }
    }

    $scope.$watch(function () {
        return $scope.setDryLevel;
    }, function () {
        if (angular.isDefined($scope.setDryLevel)) {
            $scope.getDryLevelConstant($scope.setDryLevel, 0);
        }
    });

    function getDryLevelConstant(drylevelDefault, value) {
        var drylevelString;
        var dryImageID;
        switch (drylevelDefault) {
            case "Damp":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.Damp];
                dryImageID = "Dryer/assets/img/main_list_ic_drylevel_damp_dry.svg#Layer_1";
                break;
            case "Less":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.Less];
                dryImageID = "Dryer/assets/img/main_list_ic_drylevel_less_dry.svg#Layer_1";
                break;
            case "Normal":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.Normal];
                dryImageID = "Dryer/assets/img/main_list_ic_drylevel_normal_dry.svg#Layer_1";
                break;
            case "More":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.More];
                dryImageID = "Dryer/assets/img/main_list_ic_drylevel_more_dry.svg#Layer_1";
                break;
            case "Very":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.Very];
                dryImageID = "Dryer/assets/img/main_list_ic_drylevel_very_dry.svg#Layer_1";
                break;
            case "1":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.DL1];
                dryImageID = "Dryer/assets/img/main_list_ic_dry_level_01.svg#Layer_1";
                break;
            case "2":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.DL2];
                dryImageID = "Dryer/assets/img/main_list_ic_dry_level_02.svg#Layer_1";
                break;
            case "3":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.DL3];
                dryImageID = "Dryer/assets/img/main_list_ic_dry_level_03.svg#Layer_1";
                break;
            case "4":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.DL4];
                dryImageID = "Dryer/assets/img/main_list_ic_drylevel_more_dry.svg#Layer_1";
                break;
            case "5":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.DL5];
                dryImageID = "Dryer/assets/img/main_list_ic_drylevel_very_dry.svg#Layer_1";
                break;

            case "None":
                drylevelString = DRYER_DRYLEVEL.None;
                dryImageID = "Dryer/assets/img/main_list_ic_drylevel_normal_dry.svg#Layer_1";
                break;
            default:
                break;
        }
        if (value === 0) {
            var svg = document.getElementById('drySVG');
            SHPService.loadSVG(dryImageID, svg);
        } else {
            return drylevelString;
        }
    }

    function getDryLevelStringFav(drylevelDefault) {
        var drylevelString;
        switch (drylevelDefault) {
            case "Damp":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.Damp];
                break;
            case "Less":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.Less];
                break;
            case "Normal":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.Normal];
                break;
            case "More":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.More];
                break;
            case "Very":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.Very];
                break;
            case "1":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.DL1];
                break;
            case "2":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.DL2];
                break;
            case "3":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.DL3];
                break;
            case "4":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.DL4];
                break;
            case "5":
                drylevelString = $scope.translation[DRYER_DRYLEVEL.DL5];
                break;

            case "None":
                drylevelString = DRYER_DRYLEVEL.None;
                break;
            default:
                break;
        }
        return drylevelString;
    }

    function getDryLevelConstantFav(drylevelDefault) {
        var dryImageID;
        switch (drylevelDefault) {
            case "Damp":
                dryImageID = "Dryer/assets/img/main_list_ic_drylevel_damp_dry.svg#Layer_1";
                break;
            case "Less":
                dryImageID = "Dryer/assets/img/main_list_ic_drylevel_less_dry.svg#Layer_1";
                break;
            case "Normal":
                dryImageID = "Dryer/assets/img/main_list_ic_drylevel_normal_dry.svg#Layer_1";
                break;
            case "More":
                dryImageID = "Dryer/assets/img/main_list_ic_drylevel_more_dry.svg#Layer_1";
                break;
            case "Very":
                dryImageID = "Dryer/assets/img/main_list_ic_drylevel_very_dry.svg#Layer_1";
                break;
            case "1":
                dryImageID = "Dryer/assets/img/main_list_ic_dry_level_01.svg#Layer_1";
                break;
            case "2":
                dryImageID = "Dryer/assets/img/main_list_ic_dry_level_02.svg#Layer_1";
                break;
            case "3":
                dryImageID = "Dryer/assets/img/main_list_ic_dry_level_03.svg#Layer_1";
                break;
            case "4":
                dryImageID = "Dryer/assets/img/main_list_ic_drylevel_more_dry.svg#Layer_1";
                break;
            case "5":
                dryImageID = "Dryer/assets/img/main_list_ic_drylevel_very_dry.svg#Layer_1";
                break;

            case "None":
                dryImageID = "Dryer/assets/img/main_list_ic_drylevel_normal_dry.svg#Layer_1";
                break;
            default:
                break;
        }
        return dryImageID;
    }

    function updateProgressPercentage(timeProgressUpdate) {

        if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
            if (angular.isDefined(timeProgressUpdate.remainingTime)) {
                $scope.remainingTime = timeProgressUpdate.remainingTime;
                $scope.remHrs = parseInt($scope.remainingTime.substring(0, 2), 10);
                $scope.remMin = parseInt($scope.remainingTime.substring(3, 5), 10);

                var strRemHrs = $scope.remHrs;
                var strRemMin = $scope.remMin;
                if ($scope.remHrs < 10) {
                    strRemHrs = "0" + $scope.remHrs;
                }
                if ($scope.remMin < 10) {
                    strRemMin = "0" + $scope.remMin;
                }
                $scope.remainingTime = strRemHrs + "hr " + strRemMin + "min";
                updateClock();
            }
            if (angular.isDefined(timeProgressUpdate.progressPercentage)) {
                $scope.progresshead = true;
                if ($scope.current < $scope.max) {
                    $scope.current = timeProgressUpdate.progressPercentage;
                }
//            removed the code as we get wrinkle start notification through operation progress
                //if (timeProgressUpdate.progressPercentage === $scope.max && $scope.wrinkleOn) {
                //    $scope.wrinkleStart();
                //}
            }
        }

        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
            if (angular.isDefined(timeProgressUpdate.remainingTime)) {
                $scope.remainingTimeMain = timeProgressUpdate.remainingTime;
                $scope.remHrsMain = parseInt($scope.remainingTimeMain.substring(0, 2), 10);
                $scope.remMinMain = parseInt($scope.remainingTimeMain.substring(3, 5), 10);

                var strRemHrs = $scope.remHrsMain;
                var strRemMin = $scope.remMinMain;
                if ($scope.remHrsMain < 10) {
                    strRemHrs = "0" + $scope.remHrsMain;
                }
                if ($scope.remMinMain < 10) {
                    strRemMin = "0" + $scope.remMinMain;
                }
                $scope.remainingTimeMain = strRemHrs + "hr " + strRemMin + "min";
                updateClock();
            }
            if (angular.isDefined(timeProgressUpdate.progressPercentage)) {
                $scope.progressheadMain = true;
                if ($scope.currentMain < $scope.max) {
                    $scope.currentMain = timeProgressUpdate.progressPercentage;
                }
            }
        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
            if (angular.isDefined(timeProgressUpdate.remainingTime)) {
                $scope.remainingTimeSub = timeProgressUpdate.remainingTime;
                $scope.remHrsSub = parseInt($scope.remainingTimeSub.substring(0, 2), 10);
                $scope.remMinSub = parseInt($scope.remainingTimeSub.substring(3, 5), 10);

                var strRemHrs = $scope.remHrsSub;
                var strRemMin = $scope.remMinSub;
                if ($scope.remHrsSub < 10) {
                    strRemHrs = "0" + $scope.remHrsSub;
                }
                if ($scope.remMinSub < 10) {
                    strRemMin = "0" + $scope.remMinSub;
                }
                $scope.remainingTimeSub = strRemHrs + "hr " + strRemMin + "min";
                updateClock();
            }
            if (angular.isDefined(timeProgressUpdate.progressPercentage)) {
                $scope.progressheadSub = true;
                if ($scope.currentSub < $scope.max) {
                    $scope.currentSub = timeProgressUpdate.progressPercentage;
                }
            }
        } else {
            ;//Nothing
        }
    }

    function startProgress(washerId) {
        if (!$scope.isDualDryer) {
            washerId = 0;
        }
        if (!$scope.isStatic) {
            if ($scope.isDualDryer) {
                if ($scope.homePage) {
                    if ((washerId === 0 && $scope.hotwarningMain) || (washerId === 1 && $scope.hotwarningSub)) {
                        $scope.errorList.push({
                            title: $scope.translation.WEBMOB_device_washer_alarm_device_control_error_title,
                            msg: $scope.translation.WEBMOB_device_washer_alarm_device_control_error_msg,
                            btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                            btnOkHandler: function () {
                                onOkClicked(true);
                            },
                            closeDialog: !true
                        });
                        changePopUpClass(true);
                        return;
                    }
                    var tempDeviceStatus = washerId === 0 ? $scope.deviceStatusMain : $scope.deviceStatusSub;
                    if ((tempDeviceStatus === "Run")) {
                        $scope.checkResponse.push(WASHER_COMMANDS.pauseWasher);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, pauseCommand(), "/" + $scope.peerId + "/devices/" + washerId + "/operation");
                    } else if ((tempDeviceStatus === "Ready") || (tempDeviceStatus === "Pause")) {
                        $scope.checkResponse.push(WASHER_COMMANDS.startWasher);
                        if (washerId === 0 && $scope.syncTimeMain && !$scope.showSyncTimeMain) {
                            $scope.checkResponse.push(WASHER_COMMANDS.syncTime);
                            SHPService.sendSHPCommand(CONSTANTS.PUT, syncTimerCommand(), "/" + $scope.peerId + "/devices/" + washerId + "/configuration/time");
                        } else if (washerId === 1 && $scope.syncTimeSub && !$scope.showSyncTimeSub) {
                            $scope.checkResponse.push(WASHER_COMMANDS.syncTime);
                            SHPService.sendSHPCommand(CONSTANTS.PUT, syncTimerCommand(), "/" + $scope.peerId + "/devices/" + washerId + "/configuration/time");
                        }

                        if (washerId === 0) {
                            SHPService.sendSHPCommand(CONSTANTS.PUT, getStartCommand($scope.currentCourseHexMain, 'Run', $scope.isDrylevelMain, $scope.isTempMain, $scope.isDryTimeMain, $scope.wrinkleOnMain, WASHERTOUPDATE.MAINWASHER), "/" + $scope.peerId + "/devices/" + washerId);
                        } else {
                            SHPService.sendSHPCommand(CONSTANTS.PUT, getStartCommand($scope.currentCourseHexSub, 'Run', $scope.isDrylevelSub, $scope.isTempSub, $scope.isDryTimeSub, $scope.wrinkleOnSub, WASHERTOUPDATE.SUBWASHER), "/" + $scope.peerId + "/devices/" + washerId);
                        }
                    } else {
                        // Nothing
                    }
                    debugMessage("sending the command to washer");
                } else {
                    if ($scope.hotwarning) {
                        $scope.errorList.push({
                            title: $scope.translation.WEBMOB_device_washer_alarm_device_control_error_title,
                            msg: $scope.translation.WEBMOB_device_washer_alarm_device_control_error_msg,
                            btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                            btnOkHandler: function () {
                                onOkClicked(true);
                            },
                            closeDialog: !true
                        });
                        changePopUpClass(true);
                        return;
                    }
                    if ($scope.kidsLock) {
                        $scope.errorList.push({
                            title: $scope.translation.WEBMOB_device_washer_alarm_child_lock_title,
                            msg: $scope.translation.WEBMOB_device_washer_alarm_child_lock_message,
                            btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                            btnOkHandler: function () {
                                $scope.onOkClicked(true);
                            },
                            closeDialog: !true
                        });
                        changePopUpClass(true);
                        return;
                    }
                    if (!$scope.remoteControlEnabled) {
                        $scope.errorList.push({
                            title: $scope.translation.WEBMOB_device_washer_alarm_smart_control,
                            msg: $scope.translation.WEBMOB_device_washer_alarm_smart_control_dryer_msg,
                            btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                            btnOkHandler: function () {
                                $scope.onOkClicked(true);
                            },
                            closeDialog: !true
                        });
                        changePopUpClass(true);
                        return;
                    }

                    washerId = $scope.currentWasherSelected === WASHERCURRENTSEL.MAIN_SELECTED ? 0 : 1;
                    if (($scope.deviceStatus === "Run")) {
                        $scope.checkResponse.push(WASHER_COMMANDS.pauseWasher);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, pauseCommand(), "/" + $scope.peerId + "/devices/" + washerId + "/operation");
                    } else if (($scope.deviceStatus === "Ready") || ($scope.deviceStatus === "Pause")) {
                        $scope.checkResponse.push(WASHER_COMMANDS.startWasher);
                        if ($scope.syncTime && !$scope.showSyncTime) {
                            $scope.checkResponse.push(WASHER_COMMANDS.syncTime);
                            SHPService.sendSHPCommand(CONSTANTS.PUT, syncTimerCommand(), "/" + $scope.peerId + "/devices/" + washerId + "/configuration/time");
                        }
                        SHPService.sendSHPCommand(CONSTANTS.PUT, getStartCommand($scope.currentCourseHex, 'Run', $scope.isDrylevel, $scope.isTemp, $scope.isDryTime, $scope.wrinkleOn, WASHERTOUPDATE.SINGLEWASHER), "/" + $scope.peerId + "/devices/" + washerId);
                    } else {
                        ;//Nothing
                    }
                }
            } else {
                if ($scope.hotwarning) {
                    $scope.errorList.push({
                        title: $scope.translation.WEBMOB_device_washer_alarm_device_control_error_title,
                        msg: $scope.translation.WEBMOB_device_washer_alarm_device_control_error_msg,
                        btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                        btnOkHandler: function () {
                            onOkClicked(true);
                        },
                        closeDialog: !true
                    });
                    changePopUpClass(true);
                    return;
                }
                if ($scope.kidsLock) {
                    $scope.errorList.push({
                        title: $scope.translation.WEBMOB_device_washer_alarm_child_lock_title,
                        msg: $scope.translation.WEBMOB_device_washer_alarm_child_lock_message,
                        btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                        btnOkHandler: function () {
                            $scope.onOkClicked(true);
                        },
                        closeDialog: !true
                    });
                    changePopUpClass(true);
                    return;
                }
                if (!$scope.remoteControlEnabled) {
                    $scope.errorList.push({
                        title: $scope.translation.WEBMOB_device_washer_alarm_smart_control,
                        msg: $scope.translation.WEBMOB_device_washer_alarm_smart_control_dryer_msg,
                        btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                        btnOkHandler: function () {
                            $scope.onOkClicked(true);
                        },
                        closeDialog: !true
                    });
                    changePopUpClass(true);
                    return;
                }
                if ($scope.deviceStatus === "Run") {
                    $scope.checkResponse.push(WASHER_COMMANDS.pauseWasher);
                    SHPService.sendSHPCommand(CONSTANTS.PUT, pauseCommand(), "/" + $scope.peerId + "/devices/" + washerId + "/operation");
                } else if (($scope.deviceStatus === "Ready") || ($scope.deviceStatus === "Pause")) {
                    $scope.checkResponse.push(WASHER_COMMANDS.startWasher);
                    if ($scope.syncTime && !$scope.showSyncTime) {
                        $scope.checkResponse.push(WASHER_COMMANDS.syncTime);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, syncTimerCommand(), "/" + $scope.peerId + "/devices/" + washerId + "/configuration/time");
                    }
                    SHPService.sendSHPCommand(CONSTANTS.PUT, getStartCommand($scope.currentCourseHex, 'Run', $scope.isDrylevel, $scope.isTemp, $scope.isDryTime, $scope.wrinkleOn, WASHERTOUPDATE.SINGLEWASHER), "/" + $scope.peerId + "/devices/" + washerId);
                } else {
                    ;//Nothing
                }
            }

        } else {
            if (washerId === 0 && $scope.homePage) {
                $scope.onPauseMain = !$scope.onPauseMain;
                if ($scope.onPauseMain) {
                    $scope.dispStatusMain = $scope.translation.WEBMOB_device_washer_progressing_paused;
                }
                if (!$scope.onPauseMain) {
                    $scope.dispStatusMain = $scope.translation.WEBMOB_device_washer_progressing_washing;
                }
                if (!$scope.textDisplayMain) {
                    $scope.dispStatusMain = $scope.translation.WEBMOB_device_washer_progressing_ready;
                }
            } else if (washerId === 1 && $scope.homePage) {
                $scope.onPauseSub = !$scope.onPauseSub;
                if ($scope.onPauseSub) {
                    $scope.dispStatusSub = $scope.translation.WEBMOB_device_washer_progressing_paused;
                }
                if (!$scope.onPauseSub) {
                    $scope.dispStatusSub = $scope.translation.WEBMOB_device_washer_progressing_washing;
                }
                if (!$scope.textDisplaySub) {
                    $scope.dispStatusSub = $scope.translation.WEBMOB_device_washer_progressing_ready;
                }
            } else {
                if ($scope.onPause) {
                    $scope.textDisplay = true;
                    document.getElementById("circularProgress").style.visibility = 'visible';
                    $scope.dispStatus = $scope.translation.WEBMOB_device_washer_progressing_drying;
                    $scope.current = 99;
                    $scope.wrinklePreventdisable = true;
                    $scope.estimationTime = " 1:30";
                    $scope.progressStart = true;
                    $scope.progresshead = true;
                    $scope.statusDisplay = true;
                    updateStatus("Finish");
                }
                $scope.onPause = !$scope.onPause;
            }
        }
    }

    function updateProgress() {
        if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
            if (($scope.deviceStatus === "Run") || ($scope.deviceStatus === "Pause")) {
                updateClock();
                $scope.progressStart = true;
                $scope.disableContents = true;
                $scope.disabledrylevelContents = true;
                $scope.disabletempContents = true;
                $scope.disabledrytimeContents = true;
                document.getElementById("circularProgress").style.visibility = 'visible';
            } else if ($scope.deviceStatus === "Ready") {
                if ($scope.cycFinish) {
                    document.getElementById("circularProgress").style.visibility = 'hidden';
                }
                $timeout.cancel(clearTime);
            } else {
                //Nothing
            }
        }
        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
            if (($scope.deviceStatusMain === "Run") || ($scope.deviceStatusMain === "Pause")) {
                updateClock();
                $scope.progressStartMain = true;
                $scope.disableContentsMain = true;
                $scope.disabledrylevelContentsMain = true;
                $scope.disabletempContentsMain = true;
                $scope.disabledrytimeContentsMain = true;
                if ($scope.currentWasherSelected === WASHERCURRENTSEL.MAIN_SELECTED) {
                    document.getElementById("circularProgress").style.visibility = 'visible';
                }
            } else if ($scope.deviceStatusMain === "Ready") {
                if ($scope.cycFinishMain) {
                    if ($scope.currentWasherSelected === WASHERCURRENTSEL.MAIN_SELECTED) {
                        document.getElementById("circularProgress").style.visibility = 'hidden';
                    }
                }
                $timeout.cancel(clearTime);
            } else {
                ;//Nothing
            }
        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
            if (($scope.deviceStatusSub === "Run") || ($scope.deviceStatusSub === "Pause")) {
                updateClock();
                $scope.progressStartSub = true;
                $scope.disableContentsSub = true;
                $scope.disabledrylevelContentsSub = true;
                $scope.disabletempContentsSub = true;
                $scope.disabledrytimeContentsSub = true;
                if ($scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
                    document.getElementById("circularProgress").style.visibility = 'visible';
                }
            } else if ($scope.deviceStatusSub === "Ready") {
                if ($scope.cycFinishSub) {
                    if ($scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
                        document.getElementById("circularProgress").style.visibility = 'hidden';
                    }
                }
                $timeout.cancel(clearTime);
            } else {
                ;//Nothing
            }
        } else {
            ;//Nothing
        }
    }

    function cancelProgress() {

        if ($scope.kidsLock) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_device_washer_alarm_child_lock_title,
                msg: $scope.translation.WEBMOB_device_washer_alarm_child_lock_message,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }
        if (!$scope.remoteControlEnabled) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_device_washer_alarm_smart_control,
                msg: $scope.translation.WEBMOB_device_washer_alarm_smart_control_washer_msg,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }
        if (!$scope.isStatic) {
            var washerId = 0;
            if ($scope.isDualDryer && $scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
                washerId = 1;
            }
            $scope.checkResponse.push(WASHER_COMMANDS.cancelWasher);
            SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.cancelCommand(), "/" + $scope.peerId + "/devices/" + washerId + "/operation");
            debugMessage("sending cancel command to washer");
        } else {
            if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                $scope.deviceStatus = "Ready";
            }
            if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                $scope.deviceStatusMain = "Ready";
            } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                $scope.deviceStatusSub = "Ready";
            } else {
                ;//Nothing
            }
            updateCancelProgres();
        }
    }

    function updateCancelProgres() {
        if (cancelCommandFromFav) {
            dismissLoadingBar(WASHER_COMMANDS.cancelWasher);
            cancelCommandFromFav = false;
            startFavoriteAfterCancelCommand();
            return;
        }
        //$scope.current = 0;
        closeAllPopups();
        if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
            $scope.current = 0;
            $scope.onPause = true;
            $scope.textDisplay = false;
            $scope.progressStart = false;
            $scope.progresshead = false;
            $scope.disableContents = false;
            $scope.disabletempContents = false;
            $scope.disabledrytimeContents = false;
            $scope.disabledrylevelContents = false;
            $scope.statusDisplay = false;
            $scope.wrinklePreventStarted = false;
            $scope.wrinklePreventdisable = !true;
            if (document.getElementById("circularProgress")) {
                document.getElementById("circularProgress").style.visibility = 'hidden';
            }
            if (document.getElementById("innercirclebutton")) {
                document.getElementById("innercirclebutton").style.display = "initial";
            }
        }
        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
            $scope.currentMain = 0;
            $scope.onPauseMain = true;
            $scope.textDisplayMain = false;
            $scope.progressStartMain = false;
            $scope.progressheadMain = false;
            $scope.disableContentsMain = false;
            $scope.disabletempContentsMain = false;
            $scope.disabledrytimeContentsMain = false;
            $scope.disabledrylevelContentsMain = false;
            $scope.statusDisplayMain = false;
            $scope.wrinklePreventStartedMain = false;
            $scope.wrinklePreventdisableMain = !true;
            if ($scope.currentWasherSelected === WASHERCURRENTSEL.MAIN_SELECTED) {
                if (document.getElementById("circularProgress")) {
                    document.getElementById("circularProgress").style.visibility = 'hidden';
                }
                if (document.getElementById("innercirclebutton")) {
                    document.getElementById("innercirclebutton").style.display = "initial";
                }
            }
        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
            $scope.currentSub = 0;
            $scope.onPauseSub = true;
            $scope.textDisplaySub = false;
            $scope.progressStartSub = false;
            $scope.progressheadSub = false;
            $scope.disableContentsSub = false;
            $scope.disabletempContentsSub = false;
            $scope.disabledrytimeContentsSub = false;
            $scope.disabledrylevelContentsSub = false;
            $scope.statusDisplaySub = false;
            $scope.wrinklePreventStartedSub = false;
            $scope.wrinklePreventdisableSub = !true;
            if ($scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
                if (document.getElementById("circularProgress")) {
                    document.getElementById("circularProgress").style.visibility = 'hidden';
                }
                if (document.getElementById("innercirclebutton")) {
                    document.getElementById("innercirclebutton").style.display = "initial";
                }
            }
        } else {
            ;//Nothing
        }

        $timeout.cancel(clearTime);
        updateOptionsGUI();
        dismissLoadingBar(WASHER_COMMANDS.cancelWasher);

        if ($scope.isDualDryer === undefined || $scope.isDualDryer === false || ($scope.isDualDryer && !$scope.homePage)) {
            if ($scope.wrinkleOn === true && $scope.wrinklePreventState !== $scope.wrinkleOn) {
                $timeout(function () {
                    setWrinklePrevent(false, false);
                }, 0);
            }
        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
            if ($scope.wrinkleOnMain === true && $scope.wrinklePreventStateMain !== $scope.wrinkleOnMain) {
                $timeout(function () {
                    setWrinklePreventMain(false, false);
                }, 0);
            }
        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
            if ($scope.wrinkleOnSub === true && $scope.wrinklePreventStateSub !== $scope.wrinkleOnSub) {
                $timeout(function () {
                    setWrinklePreventSub(false, false);
                }, 0);
            }
        } else {
            ;//Nothing
        }
    }

    function aboutCommand(cmdstring, changedCode) {
        if (changedCode) {
            return '{"service" : "' + cmdstring + '","selectedCountry" : "' + $scope.selectedCountry + '_FR"}';
        } else {
            return '{"service" : "' + cmdstring + '","selectedCountry" : "' + $scope.selectedCountry + '"}';
        }
    }

    function onAboutAction(reqParam) {
        if (reqParam === 'version') {
            demoModeVersionClickCount++;
            if (demoModeVersionClickCount === 1) {
                $timeout(function () {
                    demoModeVersionClickCount = 0;
                }, 15000);
            }
            if (demoModeVersionClickCount === 20) {
                $scope.showDemoErrorList = false;
            }
            return;
        }
        if (reqParam === "smartcare") {
            $scope.currentScreen = WASHERSCREENS.SMARTCARE;
            $scope.changeScreen();
            return;
        }
        if (reqParam === "errorpage") {
            $scope.currentScreen = WASHERSCREENS.ERRORTEXT;
            $scope.changeScreen();
            return;
        }
        if (reqParam === 'tutorial' || reqParam === 'manual' || reqParam === 'helpdesk') {
            var selectedLang1 = "";
            var selectedLang2 = "";
            if ($scope.selectedCountry === "BE") {
                $scope.countryToSelect = [];
                selectedLang1 = $scope.translation.WEBMOB_common_tutorial_belgium;
                selectedLang2 = $scope.translation.WEBMOB_common_tutorial_belgium_french;
                $scope.countryToSelect.push({'Country': selectedLang1});
                $scope.countryToSelect.push({'Country': selectedLang2});
                reqParamCountrySelection = reqParam;
                $scope.showcustCountrySelectionPopup();
            } else if ($scope.selectedCountry === "CA") {
                $scope.countryToSelect = [];
                selectedLang1 = $scope.translation.WEBMOB_common_tutorial_canada;
                selectedLang2 = $scope.translation.WEBMOB_common_tutorial_canada_french;
                $scope.countryToSelect.push({'Country': selectedLang1});
                $scope.countryToSelect.push({'Country': selectedLang2});
                reqParamCountrySelection = reqParam;
                $scope.showcustCountrySelectionPopup();
            } else if ($scope.selectedCountry === "CH") {
                $scope.countryToSelect = [];
                selectedLang1 = $scope.translation.WEBMOB_common_tutorial_switzerland;
                selectedLang2 = $scope.translation.WEBMOB_common_tutorial_switzerland_french;
                $scope.countryToSelect.push({'Country': selectedLang1});
                $scope.countryToSelect.push({'Country': selectedLang2});
                reqParamCountrySelection = reqParam;
                $scope.showcustCountrySelectionPopup();
            } else {
                $timeout(function () {
                    nativeInterface.runOnNative("customerService", aboutCommand(reqParam));
                }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
            }
        } else {
            $timeout(function () {
                nativeInterface.runOnNative("customerService", aboutCommand(reqParam));
            }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
        }
    }

    function updateClock() {
        if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
            var currentTime = new Date();
            var crhours = currentTime.getHours();
            var crminutes = currentTime.getMinutes();
            if ($scope.remainingTime !== undefined) {
                var estHrs = $scope.remHrs + crhours;
                var estMin = $scope.remMin + crminutes;
                var newdate = new Date();
                newdate.setHours(estHrs, estMin, 0);
                var hours = newdate.getHours();
                var minutes = newdate.getMinutes();
                $scope.ampm = hours >= 12 ? ' PM' : ' AM';
                hours = hours % 12;
                hours = hours ? hours : 12;
                minutes = minutes < 10 ? '0' + minutes : minutes;
                $scope.estimationTime = " " + hours + ":" + minutes;
                clearTime = $timeout($scope.updateClock, 1000 * 60);
            }
        }
        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
            var currentTime = new Date();
            var crhours = currentTime.getHours();
            var crminutes = currentTime.getMinutes();
            if ($scope.remainingTimeMain !== undefined) {
                var estHrs = $scope.remHrsMain + crhours;
                var estMin = $scope.remMinMain + crminutes;
                var newdate = new Date();
                newdate.setHours(estHrs, estMin, 0);
                var hours = newdate.getHours();
                var minutes = newdate.getMinutes();
                $scope.ampmMain = hours >= 12 ? ' PM' : ' AM';
                hours = hours % 12;
                hours = hours ? hours : 12;
                minutes = minutes < 10 ? '0' + minutes : minutes;
                $scope.estimationTimeMain = " " + hours + ":" + minutes;
                clearTime = $timeout($scope.updateClock, 1000 * 60);
            }
        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
            var currentTime = new Date();
            var crhours = currentTime.getHours();
            var crminutes = currentTime.getMinutes();
            if ($scope.remainingTimeSub !== undefined) {
                var estHrs = $scope.remHrsSub + crhours;
                var estMin = $scope.remMinSub + crminutes;
                var newdate = new Date();
                newdate.setHours(estHrs, estMin, 0);
                var hours = newdate.getHours();
                var minutes = newdate.getMinutes();
                $scope.ampmSub = hours >= 12 ? ' PM' : ' AM';
                hours = hours % 12;
                hours = hours ? hours : 12;
                minutes = minutes < 10 ? '0' + minutes : minutes;
                $scope.estimationTimeSub = " " + hours + ":" + minutes;
                clearTime = $timeout($scope.updateClock, 1000 * 60);
            }
        } else {
            ;//Nothing
        }
    }

    function diagnosisCommand() {
        return '{"Diagnosis": {"diagnosisStart": "Run"}}';
    }

    function smartcareerrorcheck() {

        if ($scope.isGasDryer) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_common_device_dryer,
                msg: $scope.translation.WEBMOB_device_washer_alarm_dry_only_monitoring,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    $scope.onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }
        if ($scope.kidsLock) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_device_washer_alarm_child_lock_title,
                msg: $scope.translation.WEBMOB_device_washer_alarm_child_lock_message,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    $scope.onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }
        if (!$scope.remoteControlEnabled) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_device_washer_alarm_smart_control,
                msg: $scope.translation.WEBMOB_device_washer_alarm_smart_control_dryer_msg,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    $scope.onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }
        if (!$scope.isStatic) {
            var washerId = 0;
            if ($scope.isDualDryer && $scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
                washerId = 1;
            }
            clickedDiagnosis = true;
            $scope.checkResponse.push(WASHER_COMMANDS.diagnosis);
            SHPService.sendSHPCommand(CONSTANTS.PUT, diagnosisCommand(), "/" + $scope.peerId + "/devices/" + washerId + "/diagnosis");
        } else {
            $scope.currentScreen = WASHERSCREENS.SMARTCAREERROR;
            $scope.changeScreen();
        }
    }

    function showDiagnosisPage(diagnosisVal) {
        if (angular.isDefined(diagnosisVal.diagnosisStart)) {
            $scope.diagnosisState = diagnosisVal.diagnosisStart;
            if (diagnosisVal.diagnosisStart === "Ready") {
                if (clickedDiagnosis) {
                    clickedDiagnosis = false;
                    dismissLoadingBar(WASHER_COMMANDS.diagnosis);
                    if ($scope.currentScreen === WASHERSCREENS.ALARMSCREEN) {
                        debugMessage("return showDiagnosisPage " + $scope.currentScreen + " && " + $scope.diagnosisState);
                        return;
                    }
                    $scope.currentScreen = WASHERSCREENS.SMARTCAREERROR;
                    $scope.changeScreen();
                }
            } else if (diagnosisVal.diagnosisStart === "Run") {
                clickedDiagnosis = true;
                if ($scope.currentScreen === WASHERSCREENS.ALARMSCREEN) {
                    debugMessage("return showDiagnosisPage " + $scope.currentScreen + " && " + $scope.diagnosisState);
                    return;
                }
                // If we get diagnosis run notification because user has sent request from another mobile, then show loading bar
                if ($scope.checkResponse.indexOf(WASHER_COMMANDS.diagnosis) === -1) {
                    $scope.checkResponse.push(WASHER_COMMANDS.diagnosis);
                }
                $scope.loadingBar = true;
                previousScreenAtSelfCheck = $scope.currentScreen;
                $scope.currentScreen = WASHERSCREENS.SMARTCARE;
                $scope.changeScreen();
            } else {
                ;//Nothing
            }
        }
    }

    function getStartCommand(courseValue, deviceStatus, isDryLevelSupported, isTempSupported, isDryTimeSupported, isWrinklePrevent, washerSection) {
        var tempDryLevel, tempTemp, tempDryTime;
        var tempWrinklePrevent = (isWrinklePrevent) ? "On" : "Off";
        var enableString = ($scope.mixedLoadBellValue === true) ? 'Enable' : 'Disable';
        var wrinklePrevent = true;
        var mixeLoadBellSupported = true;
        switch (washerSection) {
            case WASHERTOUPDATE.SINGLEWASHER:
                tempDryLevel = $scope.setDryLevel;
                tempTemp = $scope.setTemp;
                tempDryTime = $scope.setDryTime;
                enableString = ($scope.mixedLoadBellValue === true) ? 'Enable' : 'Disable';
                if ($scope.Device.Washer.wrinklePrevent === undefined) {
                    wrinklePrevent = false;
                }
                if (!$scope.showMixedLoadBell) {
                    mixeLoadBellSupported = false;
                }
                break;
            case WASHERTOUPDATE.MAINWASHER:
                tempDryLevel = $scope.setDryLevelMain;
                tempTemp = $scope.setTempMain;
                tempDryTime = $scope.setDryTimeMain;
                enableString = ($scope.mixedLoadBellValueMain === true) ? 'Enable' : 'Disable';
                if ($scope.mainDryerData.Washer.wrinklePrevent === undefined) {
                    wrinklePrevent = false;
                }
                if (!$scope.showMixedLoadBellMain) {
                    mixeLoadBellSupported = false;
                }
                break;
            case WASHERTOUPDATE.SUBWASHER:
                tempDryLevel = $scope.setDryLevelSub;
                tempTemp = $scope.setTempSub;
                tempDryTime = $scope.setDryTimeSub;
                enableString = ($scope.mixedLoadBellValueSub === true) ? 'Enable' : 'Disable';
                if ($scope.subDryerData.Washer.wrinklePrevent === undefined) {
                    wrinklePrevent = false;
                }
                if (!$scope.showMixedLoadBellSub) {
                    mixeLoadBellSupported = false;
                }
                break;
            default:
                tempDryLevel = $scope.setDryLevel;
                tempTemp = $scope.setTemp;
                tempDryTime = $scope.setDryTime;
                break;
        }
        if (mixeLoadBellSupported) {
            var command = '{"Device":{"Mode":{"options":["Course_' + courseValue + '","MixedLoadBell_' + enableString + '"]},"Operation":{"state":"' + deviceStatus + '"}';
        } else {
            var command = '{"Device":{"Mode":{"options":["Course_' + courseValue + '"]},"Operation":{"state":"' + deviceStatus + '"}';
        }
        if (isDryLevelSupported || isTempSupported || isDryTimeSupported || wrinklePrevent) {
            command = command + ',"Washer":{';
            var count = 0;
            if (isDryLevelSupported) {
                command = command + '"dryLevel":"' + tempDryLevel + '"';
                count++;
            }
            if (isTempSupported) {
                if (count > 0) {
                    command = command + ',';
                }
                command = command + '"waterTemperature":"' + tempTemp + '"';
                count++;
            }
            if (isDryTimeSupported) {
                if (count > 0) {
                    command = command + ',';
                }
                command = command + '"dryTime":"' + tempDryTime + '"';
                count++;
            }

            if (wrinklePrevent) {
                if (count > 0) {
                    command = command + ',';
                }
                command = command + '"wrinklePrevent":"' + tempWrinklePrevent + '"';
            }
            command = command + '}}}';
        } else {
            command = command + '}}';
        }
        console.log("commandmain :: " + command);
        return command;
    }

    function getStartCommandMyFav(courseValue, deviceStatus, isDryLevelSupported, dryLevelValue, isTempSupported, dryTempValue, isDryTimeSupported, dryTimeValue, isWrinklePrevent, isMixedLoadBellEnable, mixedLoadBellValue) {
        var enableString = 'Disable';
        if (isMixedLoadBellEnable) {
            enableString = (mixedLoadBellValue === 'On') ? 'Enable' : 'Disable';
        }
        var tempWrinklePrevent = (isWrinklePrevent) ? "On" : "Off";

        var command = '{"Device":{"Mode":{"options":["Course_' + courseValue + '","MixedLoadBell_' + enableString + '"]},"Operation":{"state":"' + deviceStatus + '"},"Washer":{';
        var count = 0;
        if (isDryLevelSupported) {
            command = command + '"dryLevel":"' + dryLevelValue + '"';
            count++;
        }
        if (isTempSupported) {
            if (count > 0) {
                command = command + ',';
            }
            command = command + '"waterTemperature":"' + dryTempValue + '"';
            count++;
        }
        if (isDryTimeSupported) {
            if (count > 0) {
                command = command + ',';
            }
            command = command + '"dryTime":"' + dryTimeValue + '"';
            count++;
        }
        if (count > 0) {
            command = command + ',';
        }
        command = command + '"wrinklePrevent":"' + tempWrinklePrevent + '"';
        command = command + '}}}';
        console.log("commandfav :: " + command);
        return command;
    }

    function cancelCommand() {
        return '{"Operation":{"state":"Ready"}}';
    }

    function pauseCommand() {
        return '{"Operation":{"state":"Pause"}}';
    }

    function syncTimerCommand() {
        var dateValue = $scope.getCurrentTime();
        return '{"Time":{"currentTime":"' + dateValue + '"}}';
    }

    function mixedLoadBellCommand() {
        var enableString = $scope.mixedLoadBellValue;
        enableString = (enableString === true) ? 'Disable' : 'Enable';
        return '{"Device":{"Mode":{"options":["MixedLoadBell_' + enableString + '"]}}}';
    }

    function getCurrentTime() {
        var local = new Date();
        var currentdate = new Date(local);
        currentdate.setMinutes(local.getMinutes() - local.getTimezoneOffset());
        return currentdate.toJSON().slice(0, 19);
    }

    function parseStaticData() {
        $scope.isStatic = true;
        init();
        $scope.serviceCenterNumber = '000-213-516-000,000-213-517-000';
        $scope.showManualErrorPage = true;
        $scope.showMixedLoadBell = true;
        $scope.mixedLoadBellValue = true;
        $scope.isKORComboEnabled = false;
        if ($scope.isStatic) {
            var deviceResponseDryer = '{"Devices":[{"Alarms":[],"ConfigurationLink":{"href":"/devices/0/configuration"},"InformationLink":{"href":"/devices/0/information"},"EnergyConsumption":{"saveLocation":"/files/power_usage.db"},"Mode":{"options":["Course_25","LaundryOutTime_0","DeviceType_0152","RackDry_Not_Used","EnergyLevelSet_050303020102030302010203030205"],"supportedOptions":["3228308D33EE00001853ED33EE0000E853ED33EE00015830ED33EE000238102D33EE000168410D308E0000F8520D33EE000038520D520E000118204D308E00024853ED000E33E258520D000E23E268000D000E13E278520D000E000288520D000E13E"]},"Operation":{"kidsLock":"Ready","power":"On","progress":"None","progressPercentage":0,"remainingTime":"00:30:00","state":"Ready","supportedProgress":["None","Delaywash","Weightsensing","Drying","Cooling","Wrinkleprevent","Finish"]},"Washer":{"dryLevel":"None","dryTime":"00:30:00","dryerType":"Electricity","supportedDryLevel":["None","Damp","Less","Normal","More","Very"],"supportedDryTime":["00:00:00","00:20:00","00:30:00","00:40:00","00:50:00","01:00:00"],"supportedWaterTemperature":["None","ExtraLow","Low","MediumLow","Medium","High"],"waterTemperature":"High","wrinklePrevent":"On"},"connected":true,"description":"DV457(6002b46b08b9)","id":"0","name":"Dryer","resources":["Alarms","Configuration","Diagnosis","Information","Mode","Operation","Washer"],"type":"Dryer","uuid":"6002b46b-08b9-0000-0000-000000000000"}]}';
            //var deviceResponseDualDryer = '{"Devices":[{"Alarms":[],"ConfigurationLink":{"href":"/devices/0/configuration"},"InformationLink":{"href":"/devices/0/information"},"EnergyConsumption":{"saveLocation":"/files/power_usage.db"},"Mode":{"options":["Course_25","LaundryOutTime_0","DeviceType_0152","RackDry_Not_Used"],"supportedOptions":["3228308D33EE00001853ED33EE0000E853ED33EE00015830ED33EE000238102D33EE000168410D308E0000F8520D33EE000038520D520E000118204D308E00024853ED000E33E258520D000E23E268000D000E13E278520D000E000288520D000E13E"]},"Operation":{"kidsLock":"Ready","power":"On","progress":"None","progressPercentage":0,"remainingTime":"00:30:00","state":"Ready","supportedProgress":["None","Delaywash","Weightsensing","Drying","Cooling","Wrinkleprevent","Finish"]},"Washer":{"dryLevel":"None","dryTime":"00:30:00","dryerType":"Electricity","supportedDryLevel":["None","Damp","Less","Normal","More","Very"],"supportedDryTime":["00:00:00","00:20:00","00:30:00","00:40:00","00:50:00","01:00:00"],"supportedWaterTemperature":["None","ExtraLow","Low","MediumLow","Medium","High"],"waterTemperature":"High","wrinklePrevent":"On"},"connected":true,"description":"DV457(6002b46b08b9)","id":"0","name":"Dryer","resources":["Alarms","Configuration","Diagnosis","Information","Mode","Operation","Washer"],"type":"Dryer","uuid":"6002b46b-08b9-0000-0000-000000000000"}, {"Alarms":[],"ConfigurationLink":{"href":"/devices/0/configuration"},"InformationLink":{"href":"/devices/0/information"},"EnergyConsumption":{"saveLocation":"/files/power_usage.db"},"Mode":{"options":["Course_25","LaundryOutTime_0","DeviceType_0152","RackDry_Not_Used"],"supportedOptions":["3228308D33EE00001853ED33EE0000E853ED33EE00015830ED33EE000238102D33EE000168410D308E0000F8520D33EE000038520D520E000118204D308E00024853ED000E33E258520D000E23E268000D000E13E278520D000E000288520D000E13E"]},"Operation":{"kidsLock":"Ready","power":"On","progress":"Drying","progressPercentage":30,"remainingTime":"01:30:45","state":"Run","supportedProgress":["None","Delaywash","Weightsensing","Drying","Cooling","Wrinkleprevent","Finish"]},"Washer":{"dryLevel":"None","dryTime":"00:30:00","dryerType":"Electricity","supportedDryLevel":["None","Damp","Less","Normal","More","Very"],"supportedDryTime":["00:00:00","00:20:00","00:30:00","00:40:00","00:50:00","01:00:00"],"supportedWaterTemperature":["None","ExtraLow","Low","MediumLow","Medium","High"],"waterTemperature":"High","wrinklePrevent":"On"},"connected":true,"description":"DV457(6002b46b08b9)","id":"1","name":"Dryer","resources":["Alarms","Configuration","Diagnosis","Information","Mode","Operation","Washer"],"type":"Dryer","uuid":"6002b46b-08b9-0000-0000-000000000000"}]}';
            var device = JSON.parse(deviceResponseDryer);
            $scope.isDBDownloaded = true;
            $scope.remoteControlEnabled = true;
            parseDeviceData(device.Devices);
//            $scope.isAppV2 = true;
//            $scope.wrinklePreventStarted = true;
//            $scope.textDisplay = true;
//            $scope.isGasDryer = true;
//            $scope.cycFinish = true;
//            $scope.statusDisplay = true;
//            $scope.dispStatus = $scope.translation.WEBMOB_device_washer_progressing_ready;
        }
    }

    function getColor(sectionValue) {
        var gradientDiv = 'url(#gradient)';
        switch (sectionValue) {
            case 0:
                gradientDiv = 'url(#gradient)';
                break;
            case 1:
                gradientDiv = 'url(#gradientMain)';
                break;
            case 2:
                gradientDiv = 'url(#gradientSub)';
                break;
            default:
                gradientDiv = 'url(#gradient)';
                break;
        }
        return gradientDiv;
    }

    function cancelWashingPressed() {
        $scope.cancelButtonPressed = true;
    }

    function onSettingsUpdate(id) {
        $timeout(function () {
            var washerId = 0;
            if ($scope.isDualDryer && $scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
                washerId = 1;
            }
            if ($scope.kidsLock) {
                $scope.errorList.push({
                    title: $scope.translation.WEBMOB_device_washer_alarm_child_lock_title,
                    msg: $scope.translation.WEBMOB_device_washer_alarm_child_lock_message,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                    btnOkHandler: function () {
                        $scope.onOkClicked(true);
                    },
                    closeDialog: !true
                });
                changePopUpClass(true);
                return;
            }
            if (!$scope.remoteControlEnabled) {
                $scope.errorList.push({
                    title: $scope.translation.WEBMOB_device_washer_alarm_smart_control,
                    msg: $scope.translation.WEBMOB_device_washer_alarm_smart_control_washer_msg,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                    btnOkHandler: function () {
                        onOkClicked(true);
                    },
                    closeDialog: !true
                });
                changePopUpClass(true);
                return;
            }
            switch (id) {
                case "syncTime":
                    if ($scope.isGasDryer) {
                        $scope.errorList.push({
                            title: $scope.translation.WEBMOB_common_device_dryer,
                            msg: $scope.translation.WEBMOB_device_washer_alarm_dry_only_monitoring,
                            btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                            btnOkHandler: function () {
                                $scope.onOkClicked(true);
                            },
                            closeDialog: !true
                        });
                        changePopUpClass(true);
                        return;
                    }

                    if ($scope.isStatic) {
                        $scope.syncTime = !$scope.syncTime;
                        if ($scope.isDualDryer && $scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
                            $scope.syncTimeSub = !$scope.syncTimeSub;
                        } else if ($scope.isDualDryer && $scope.currentWasherSelected === WASHERCURRENTSEL.MAIN_SELECTED) {
                            $scope.syncTimeMain = !$scope.syncTimeMain;
                        } else {
                            ;//Nothing
                        }
                    }
                    if (!$scope.isStatic && !$scope.syncTime) {
                        $scope.checkResponse.push(WASHER_COMMANDS.syncTime);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, syncTimerCommand(), "/" + $scope.peerId + "/devices/" + washerId + "/configuration/time");
                    }
                    if ($scope.syncTime && !$scope.isStatic) {
                        $scope.syncTime = !$scope.syncTime;
                        setLocalStorageData('DRYERsyncTime', JSON.stringify($scope.syncTime));
                        if ($scope.isDualDryer && $scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
                            $scope.syncTimeSub = !$scope.syncTimeSub;
                            setLocalStorageData('DRYERsyncTimeSub', JSON.stringify($scope.syncTimeSub));
                        } else if ($scope.isDualDryer && $scope.currentWasherSelected === WASHERCURRENTSEL.MAIN_SELECTED) {
                            $scope.syncTimeMain = !$scope.syncTimeMain;
                            setLocalStorageData('DRYERsyncTimeMain', JSON.stringify($scope.syncTimeMain));
                        } else {
                            ;//Nothing
                        }
                    }
                    break;
                default:
                    break;
            }
            debugMessage(id);
        }, MATERIAL_DESIGN.TOGGLE_TIME);
    }

    function settings() {
        if ($scope.cycFinish) {
            return;
        }
        toggleAnimClass();
        $timeout(function () {
            toggleAnimClass();
            $scope.currentScreen = WASHERSCREENS.SETTINGS;
            $scope.changeScreen();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }

    function goToHome() {
        if ($scope.isDualDryer) {
            $scope.currentScreen = WASHERSCREENS.HOME;
            changeScreen();
            var hasLaunchedBefore = getLocalStorageForFirstLaunch('firstTimeLaunchHomePage');
            if (!hasLaunchedBefore) {
                showUsageHelpPage();
            }
        } else {
            if ($scope.isTopLoader) {
                showDetailPage(1);
            } else {
                showDetailPage(0);
            }
        }
    }

    function options() {
        if ($scope.cycFinish) {
            return;
        }
        toggleAnimClass();
        $timeout(function () {
            toggleAnimClass();
            $scope.currentScreen = WASHERSCREENS.OPTIONS;
            $scope.changeScreen();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }

    function changeScreen() {
        $scope.homePage = false;
        $scope.detailPage = false;
        $scope.errormesaeg = false;
        $scope.settingPage = false;
        $scope.aboutPage = false;
        $scope.errorTextpage = false;
        $scope.energyMonitorPage = false;
        $scope.laundryOutPage = false;
        $scope.smartcarepage = false;
        $scope.smartcareerror = false;
        $scope.laundryPageOut = false;
        $scope.myFavoritePage = false;
        $scope.addFavoritePage = false;
        $scope.korComboSettingPage = false;
        $scope.selectCycleForFavoritePage = false;
        var scrollAreaClass;
        if ($scope.isAppV2) {
            scrollAreaClass = 'scrollable_area_others scrollable_area_others_V2';
        } else {
            scrollAreaClass = 'scrollable_area_others';
        }
        switch ($scope.currentScreen) {
            case WASHERSCREENS.HOME:
                $scope.backText = $scope.translation.WEBMOB_device_washer_comm_dual_dryer;
                $scope.homePage = true;
                break;
            case WASHERSCREENS.DETAILPAGE:
                if ($scope.isAppV2) {
                    scrollAreaClass = 'scrollable_area scrollable_area_V2';
                } else {
                    scrollAreaClass = 'scrollable_area';
                }
                if ($scope.isDualDryer) {
                    $scope.backText = $scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED ? $scope.translation.WEBMOB_device_washer_comm_top_loader_dryer : $scope.translation.WEBMOB_device_washer_comm_front_loader_dryer;
                } else {
                    $scope.backText = $scope.translation.WEBMOB_common_device_dryer;
                }
                $scope.detailPage = true;
                break;
            case WASHERSCREENS.SETTINGS:
                $scope.backText = $scope.translation.WEBMOB_common_settings;
                $scope.settingPage = true;
                break;
            case WASHERSCREENS.OPTIONS:
                $scope.backText = $scope.translation.WEBMOB_common_about_device;
                $scope.aboutPage = true;
                break;
                //case WASHERSCREENS.CYCLEFINISH:
                //    break;
            case WASHERSCREENS.ENERGYMONITOR:
                $scope.backText = $scope.translation.WEBMOB_common_energy_monitor_title;
                $scope.energyMonitorPage = true;
                break;
            case WASHERSCREENS.LAUNDRYOUTPAGE:
                $scope.backText = $scope.translation.WEBMOB_device_washer_settings_remaining_laundry;
                $scope.laundryOutPage = true;
                break;
            case WASHERSCREENS.SMARTCARE:
                $scope.backText = $scope.translation.WEBMOB_common_self_diagnosis;
                $scope.smartcarepage = true;
                break;
            case WASHERSCREENS.SMARTCAREERROR:
                $scope.backText = $scope.translation.WEBMOB_common_self_diagnosis;
                $scope.smartcareerror = true;
                break;
            case WASHERSCREENS.ERRORTEXT:
                $scope.backText = "Error List";
                $scope.errorTextpage = true;
                break;
            case WASHERSCREENS.ALARMSCREEN:
                if ($scope.serviceCenterNumber !== undefined) {
                    if ($scope.serviceCenterNumber.indexOf(',') !== -1) {
                        $scope.dialCallNum = $scope.serviceCenterNumber.split(",");
                    } else {
                        $scope.dialCallNum[0] = $scope.serviceCenterNumber;
                    }
                    $scope.dialCallNumLength = $scope.dialCallNum.length;
                }
                $scope.backText = $scope.translation.WEBMOB_common_device_dryer;
                if ($scope.isDualDryer) {
                    $scope.backText = $scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED ? $scope.translation.WEBMOB_device_washer_comm_top_loader_dryer : $scope.translation.WEBMOB_device_washer_comm_front_loader_dryer;
                }
                $scope.errormesaeg = true;
                break;
            case WASHERSCREENS.MYFAVORITE:
                $scope.backText = $scope.translation.WEBMOB_device_washer_settings_my_favorite;
                $scope.myFavoritePage = true;
                break;
            case WASHERSCREENS.ADDFAVORITE:
                $scope.addFavoritePage = true;
                break;
            case WASHERSCREENS.CYCLEMYFAVORITE:
                $scope.backText = $scope.translation.WEBMOB_device_washer_comm_cycle;
                $scope.selectCycleForFavoritePage = true;
                break;
            case WASHERSCREENS.KOREANCOMBOSETTINGPAGE:
                $scope.korComboSettingPage = true;
                $scope.backText = $scope.translation.WEBMOB_device_washer_option_dry_combo;
                break;
            default:
                break;
        }
        document.getElementById("scrollSettings").className = scrollAreaClass;
    }

    function onBackPressed() {
        $timeout(function () {
            if ($scope.alertState === DRYERALERT.CONNECTION_FAILURE) {
                if (!$scope.cycFinish) {
                    closeApp();
                }
//                if ($scope.currentScreen !== WASHERSCREENS.CYCLEFINISH) {
//                    closeApp();
//                    return;
//                }
            }
            toggleBottomPopUpClass(false);
            changePopUpClass(false);
            if ($scope.custDialogpopup) {
                $scope.custDialogpopup = false;
                return;
            }
            if ($scope.samrtControlPopup) {
                $scope.samrtControlPopup = false;
                return;
            }
            if ($scope.errorList.length > 0) {
                $scope.errorList.pop();
                return;
            }
            if ($scope.modePopup) {
                $scope.modePopup = false;
                return;
            }
            if ($scope.tempPopup) {
                $scope.tempPopup = false;
                return;
            }
            if ($scope.dryLevelPopup) {
                $scope.dryLevelPopup = false;
                return;
            }
            if ($scope.dryTimePopup) {
                $scope.dryTimePopup = false;
                return;
            }
            if ($scope.countrySelectionPopupVisible) {
                $scope.countrySelectionPopupVisible = false;
                return;
            }
            if ($scope.isKoreanComboSubOption) {
                $scope.isKoreanComboSubOption = false;
                return;
            }
            if ($scope.bOptionPopUp) {
                $scope.bOptionPopUp = false;
                return;
            }
            if ($scope.bUsageHelpPage) {
                $scope.bUsageHelpPage = false;
                return;
            }
            closeMyFavPopUps();
            if (favPopUpChanged) {
                return;
            }
            if ($scope.isMultiSelectMode) {
                $scope.isMultiSelectMode = false;
                $scope.bAllListSelected = false;
                $scope.isAnyCheckedItem = false;
            }
            switch ($scope.currentScreen) {
                case WASHERSCREENS.MYFAVORITE:
                case WASHERSCREENS.SETTINGS:
                case WASHERSCREENS.OPTIONS:
                    $scope.showDemoErrorList = !true;
                    if ($scope.errorList.length > 0) {
                        $scope.errorList.pop();
                        return;
                    }
                    goToDetailPage();
                    break;
                case WASHERSCREENS.HOME:
                    closeApp();
                    break;
                case WASHERSCREENS.DETAILPAGE:
                    if (!$scope.isDualDryer) {
                        $scope.closeApp();
                        return;
                    }
                    updateHomePageDataForDualDryer();
                    goToHome();
                    break;
                case WASHERSCREENS.ERRORTEXT:
                    $scope.currentScreen = WASHERSCREENS.OPTIONS;
                    $scope.changeScreen();
                    break;
                case WASHERSCREENS.ALARMSCREEN:
                    if ($scope.custDialogpopup) {
                        $scope.custDialogpopup = false;
                        return;
                    }
                    if (errorDemoPage && !chatErrorPage) {
                        $scope.currentScreen = WASHERSCREENS.ERRORTEXT;
                        changeScreen();
                    } else {
                        if ($scope.isDualDryer) {
                            goToHome();
                        } else {
                            alarmConfirm();
                        }
                    }
                    break;
//                case WASHERSCREENS.CYCLEFINISH:
//                    if ($scope.isDualDryer) {
//                        goToHome();
//                    } else {
//                        $scope.alarmConfirm();
//                    }
//                    break;
                case WASHERSCREENS.ENERGYMONITOR:
                    $scope.currentScreen = WASHERSCREENS.SETTINGS;
                    $scope.changeScreen();
                    break;
                case WASHERSCREENS.LAUNDRYOUTPAGE:
                    if ((!$scope.isStatic) && (tempLaundryVal !== currentLaundryVal)) {
                        var washerId = 0;
                        if ($scope.isDualDryer && $scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
                            washerId = 1
                        }
                        $scope.checkResponse.push(WASHER_COMMANDS.laundry);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, laundryOut(), "/" + $scope.peerId + "/devices/" + washerId);
                        debugMessage("sending the autoSoftnerCommand command to washer");
                    }
                    laundryStatusText();
                    goToDetailPage();
                    break;
                case WASHERSCREENS.SMARTCARE:
                    $scope.currentScreen = WASHERSCREENS.OPTIONS;
                    if (previousScreenAtSelfCheck) {
                        $scope.currentScreen = previousScreenAtSelfCheck;
                        previousScreenAtSelfCheck = undefined;
                    }
                    $scope.changeScreen();
                    break;
                case WASHERSCREENS.SMARTCAREERROR:
                    $scope.currentScreen = WASHERSCREENS.OPTIONS;
                    if (previousScreenAtSelfCheck) {
                        $scope.currentScreen = previousScreenAtSelfCheck;
                        previousScreenAtSelfCheck = undefined;
                    }
                    $scope.changeScreen();
                    break;
                case WASHERSCREENS.CYCLEMYFAVORITE:
                    $scope.currentScreen = WASHERSCREENS.ADDFAVORITE;
                    $scope.changeScreen();
                    break;
                case WASHERSCREENS.ADDFAVORITE:
                    $scope.currentScreen = WASHERSCREENS.MYFAVORITE;
                    $scope.changeScreen();
                    break;
                case WASHERSCREENS.KOREANCOMBOSETTINGPAGE:
                    goToDetailPage();
                    break;
                default:
                    break;
            }
        }, MATERIAL_DESIGN.BACK_ANIMTION_TIMEOUT);
    }

    function callCenter(callNumb) {
        nativeInterface.runOnNative("callDial", $scope.alarmServicePayload($scope.dialCallNum[callNumb]));
    }

    function laundryOut() {
        var lText;
        if (!$scope.laundrySwitch) {
            lText = "LaundryOutTime_0";
        } else if ($scope.laundryOpt2) {
            lText = "LaundryOutTime_30";
        } else if ($scope.laundryOpt3) {
            lText = "LaundryOutTime_60";
        } else if ($scope.laundryOpt4) {
            lText = "LaundryOutTime_90";
        } else {
            ;//Do Nothing
        }
        return '{"Device":{"Mode":{"options":["' + lText + '"]}}}';
    }

    function laundryStatusText() {
        if (!$scope.laundrySwitch) {
            $scope.laundryOnOffText = $scope.translation.WEBMOB_device_washer_comm_off_CL;
        } else if ($scope.laundryOpt2) {
            $scope.laundryOnOffText = $scope.translation.WEBMOB_device_washer_laundryout_every_30min;
        } else if ($scope.laundryOpt3) {
            $scope.laundryOnOffText = $scope.translation.WEBMOB_device_washer_laundryout_every_60min;
        } else if ($scope.laundryOpt4) {
            $scope.laundryOnOffText = $scope.translation.WEBMOB_device_washer_laundryout_every_90min;
        } else {
            ;//Do Nothing
        }
    }

    function updateLaundryStatusText() {
        if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
            if (!$scope.laundrySwitch) {
                $scope.laundryOnOffText = $scope.translation.WEBMOB_device_washer_comm_off_CL;
            } else if ($scope.laundryOpt2) {
                $scope.laundryOnOffText = $scope.translation.WEBMOB_device_washer_laundryout_every_30min;
            } else if ($scope.laundryOpt3) {
                $scope.laundryOnOffText = $scope.translation.WEBMOB_device_washer_laundryout_every_60min;
            } else if ($scope.laundryOpt4) {
                $scope.laundryOnOffText = $scope.translation.WEBMOB_device_washer_laundryout_every_90min;
            } else {
                ;//Do Nothing
            }
        }
        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
            if (!$scope.laundrySwitchMain) {
                $scope.laundryOnOffTextMain = $scope.translation.WEBMOB_device_washer_comm_off_CL;
            } else if ($scope.laundryOpt2Main) {
                $scope.laundryOnOffTextMain = $scope.translation.WEBMOB_device_washer_laundryout_every_30min;
            } else if ($scope.laundryOpt3Main) {
                $scope.laundryOnOffTextMain = $scope.translation.WEBMOB_device_washer_laundryout_every_60min;
            } else if ($scope.laundryOpt4Main) {
                $scope.laundryOnOffTextMain = $scope.translation.WEBMOB_device_washer_laundryout_every_90min;
            } else {
                ;//Do Nothing
            }
        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
            if (!$scope.laundrySwitchSub) {
                $scope.laundryOnOffTextSub = $scope.translation.WEBMOB_device_washer_comm_off_CL;
            } else if ($scope.laundryOpt2Sub) {
                $scope.laundryOnOffTextSub = $scope.translation.WEBMOB_device_washer_laundryout_every_30min;
            } else if ($scope.laundryOpt3Sub) {
                $scope.laundryOnOffTextSub = $scope.translation.WEBMOB_device_washer_laundryout_every_60min;
            } else if ($scope.laundryOpt4Sub) {
                $scope.laundryOnOffTextSub = $scope.translation.WEBMOB_device_washer_laundryout_every_90min;
            } else {
                ;//Do Nothing
            }
        } else {
            ;//Nothing
        }
    }

    function openLaundryOutPage() {
        if ($scope.disableLaundry) {
            return;
        }
        if ($scope.isGasDryer) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_common_device_dryer,
                msg: $scope.translation.WEBMOB_device_washer_alarm_dry_only_monitoring,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    $scope.onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }
        if ($scope.hotwarning) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_device_washer_alarm_device_control_error_title,
                msg: $scope.translation.WEBMOB_device_washer_alarm_device_control_error_msg,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    $scope.onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }
        if ($scope.kidsLock) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_device_washer_alarm_child_lock_title,
                msg: $scope.translation.WEBMOB_device_washer_alarm_child_lock_message,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    $scope.onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }
        if (!$scope.remoteControlEnabled) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_device_washer_alarm_smart_control,
                msg: $scope.translation.WEBMOB_device_washer_alarm_smart_control_dryer_msg,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    $scope.onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }
        tempLaundryVal = currentLaundryVal;
        $scope.currentScreen = WASHERSCREENS.LAUNDRYOUTPAGE;
        $scope.changeScreen();
    }

    function onLaundrySwitch() {
        $scope.laundrySwitch = !$scope.laundrySwitch;
        if ($scope.laundrySwitch) {
            $scope.laundryOpt2 = true;
            tempLaundryVal = 1;
        } else {
            $scope.laundryOpt2 = false;
            $scope.laundryOpt3 = false;
            $scope.laundryOpt4 = false;
            tempLaundryVal = 0;
        }
    }

    function laundryItemSelected(indexVal) {
        if (!$scope.laundrySwitch) {
            return;
        }
        $scope.laundryOpt2 = false;
        $scope.laundryOpt3 = false;
        $scope.laundryOpt4 = false;
        switch (indexVal) {
            case "2":
                $scope.laundryOpt2 = !$scope.laundryOpt2;
                tempLaundryVal = 2;
                break;
            case "3":
                $scope.laundryOpt3 = !$scope.laundryOpt3;
                tempLaundryVal = 3;
                break;
            case "4":
                $scope.laundryOpt4 = !$scope.laundryOpt4;
                tempLaundryVal = 4;
                break;
            default:
                break;
        }
        $scope.laundrySwitch = true;
    }

    function openKoreanComboSubOptionPopOver() {
        $timeout(function () {
            $scope.isKoreanComboSubOption = true;
            toggleBottomPopUpClass($scope.isKoreanComboSubOption);
            changePopUpClass($scope.isKoreanComboSubOption);
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }

    function openKoreanComboSettingPage() {
        if (!$scope.isKORComboEnabled) {
            return;
        }
        if ($scope.hotwarning) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_device_washer_alarm_device_control_error_title,
                msg: $scope.translation.WEBMOB_device_washer_alarm_device_control_error_msg,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }
        if ($scope.kidsLock) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_device_washer_alarm_child_lock_title,
                msg: $scope.translation.WEBMOB_device_washer_alarm_child_lock_message,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }

        $scope.currentScreen = WASHERSCREENS.KOREANCOMBOSETTINGPAGE;
        changeScreen();
    }

    function versionTouchStart() {
        if (!promise) {
            promise = $timeout(function () {
                if (!$scope.isStatic) {
                    var washerId = 0;
                    if ($scope.isDualDryer && $scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
                        washerId = 1
                    }
                    $scope.checkResponse.push(WASHER_COMMANDS.PARSE_MODULEINFO);
                    SHPService.sendSHPCommand(CONSTANTS.GET, "/" + $scope.peerId + "/devices/" + washerId + "/information");
                }
            }, 5000);
        }
    }

    function versionTouchEnd() {
        if (promise) {
            $timeout.cancel(promise);
            promise = null;
        }
    }

    function parseModuleInformation(moduleInfo) {
        if (angular.isDefined(moduleInfo.Versions) && moduleInfo.Versions.length > 0) {
            var moduleInfoText = "Software Ver : " + moduleInfo.Versions[0].number + " <br> Firmware Ver : " + moduleInfo.Versions[1].number;
            dismissLoadingBar(WASHER_COMMANDS.PARSE_MODULEINFO);
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_common_version_info,
                msg: moduleInfoText,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    $scope.onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
        }
    }

    function openPopovermode() {
        if ($scope.disableContents || $scope.isGasDryer || !$scope.remoteControlEnabled || $scope.kidsLock) {
            return;
        }
        $scope.modePopup = true;
        changePopUpClass(true);
    }

    function openPopoverTemp() {
        $timeout(function () {
            if ($scope.currentTempList.length <= 1) {
                return;
            }
            if (rackDry) {
                return;
            }
            if ($scope.isGasDryer) {
                $scope.errorList.push({
                    title: $scope.translation.WEBMOB_common_device_dryer,
                    msg: $scope.translation.WEBMOB_device_washer_alarm_dry_only_monitoring,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                    btnOkHandler: function () {
                        $scope.onOkClicked(true);
                    },
                    closeDialog: !true
                });
                changePopUpClass(true);
                return;
            }
            if ($scope.kidsLock) {
                $scope.errorList.push({
                    title: $scope.translation.WEBMOB_device_washer_alarm_child_lock_title,
                    msg: $scope.translation.WEBMOB_device_washer_alarm_child_lock_message,
                    btnOkTxt: $scope.translation.WEBMOB_cWEBMOB_device_washer_comm_ok_CLommon_ok,
                    btnOkHandler: function () {
                        $scope.onOkClicked(true);
                    },
                    closeDialog: !true
                });
                changePopUpClass(true);
                return;
            }
            if (!$scope.remoteControlEnabled) {
                $scope.errorList.push({
                    title: $scope.translation.WEBMOB_device_washer_alarm_smart_control,
                    msg: $scope.translation.WEBMOB_device_washer_alarm_smart_control_dryer_msg,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                    btnOkHandler: function () {
                        $scope.onOkClicked(true);
                    },
                    closeDialog: !true
                });
                changePopUpClass(true);
                return;
            }
            if ($scope.disableContents) {
                return;
            }
            $scope.tempPopup = true;
            toggleBottomPopUpClass($scope.tempPopup);
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }

    function openPopoverDryLevel() {
        $timeout(function () {
            if ($scope.currentDryLevelList.length <= 1) {
                return;
            }
            if ($scope.isGasDryer) {
                $scope.errorList.push({
                    title: $scope.translation.WEBMOB_common_device_dryer,
                    msg: $scope.translation.WEBMOB_device_washer_alarm_dry_only_monitoring,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                    btnOkHandler: function () {
                        $scope.onOkClicked(true);
                    },
                    closeDialog: !true
                });
                changePopUpClass(true);
                return;
            }
            if ($scope.kidsLock) {
                $scope.errorList.push({
                    title: $scope.translation.WEBMOB_device_washer_alarm_child_lock_title,
                    msg: $scope.translation.WEBMOB_device_washer_alarm_child_lock_message,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                    btnOkHandler: function () {
                        $scope.onOkClicked(true);
                    },
                    closeDialog: !true
                });
                changePopUpClass(true);
                return;
            }
            if (!$scope.remoteControlEnabled) {
                $scope.errorList.push({
                    title: $scope.translation.WEBMOB_device_washer_alarm_smart_control,
                    msg: $scope.translation.WEBMOB_device_washer_alarm_smart_control_dryer_msg,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                    btnOkHandler: function () {
                        $scope.onOkClicked(true);
                    },
                    closeDialog: !true
                });
                changePopUpClass(true);
                return;
            }
            if ($scope.disableContents) {
                return;
            }
            $scope.dryLevelPopup = true;
            toggleBottomPopUpClass($scope.dryLevelPopup);
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }

    function openPopoverDryTime() {
        $timeout(function () {
            if ($scope.currentDryTimeList.length <= 1) {
                return;
            }
            if ($scope.isGasDryer) {
                $scope.errorList.push({
                    title: $scope.translation.WEBMOB_common_device_dryer,
                    msg: $scope.translation.WEBMOB_device_washer_alarm_dry_only_monitoring,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                    btnOkHandler: function () {
                        $scope.onOkClicked(true);
                    },
                    closeDialog: !true
                });
                changePopUpClass(true);
                return;
            }
            if ($scope.kidsLock) {
                $scope.errorList.push({
                    title: $scope.translation.WEBMOB_device_washer_alarm_child_lock_title,
                    msg: $scope.translation.WEBMOB_device_washer_alarm_child_lock_message,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                    btnOkHandler: function () {
                        $scope.onOkClicked(true);
                    },
                    closeDialog: !true
                });
                changePopUpClass(true);
                return;
            }
            if (!$scope.remoteControlEnabled) {
                $scope.errorList.push({
                    title: $scope.translation.WEBMOB_device_washer_alarm_smart_control,
                    msg: $scope.translation.WEBMOB_device_washer_alarm_smart_control_dryer_msg,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                    btnOkHandler: function () {
                        $scope.onOkClicked(true);
                    },
                    closeDialog: !true
                });
                changePopUpClass(true);
                return;
            }
            if (disableSpecialDryTime || $scope.disabledrytimeContents) {
                return;
            }
            $scope.dryTimePopup = true;
            toggleBottomPopUpClass($scope.dryTimePopup);
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }

    function getTempDisable(selectedItem) {
        if ($scope.currentTempList === undefined) {
            return;
        }
        if ($scope.currentTempList.indexOf(selectedItem) > -1) {
            return false;
        } else {
            return true;
        }
    }

    function getTempDisableMyFav(selectedItem) {
        if ($scope.currentTempListFav === undefined) {
            return;
        }
        if ($scope.currentTempListFav.indexOf(selectedItem) > -1) {
            return false;
        } else {
            return true;
        }
    }

    function getDryLevelDisable(selectedItem) {
        if ($scope.currentDryLevelList === undefined) {
            return;
        }
        if ($scope.currentDryLevelList.indexOf(selectedItem) > -1) {
            return false;
        } else {
            return true;
        }
    }

    function getDryLevelDisableMyFav(selectedItem) {
        if ($scope.currentDryLevelListFav === undefined) {
            return;
        }
        if ($scope.currentDryLevelListFav.indexOf(selectedItem) > -1) {
            return false;
        } else {
            return true;
        }
    }

    function getDryTimeDisable(selectedItem) {
        if ($scope.currentDryTimeList === undefined) {
            return;
        }
        if ($scope.currentDryTimeList.indexOf(selectedItem) > -1) {
            return false;
        } else {
            return true;
        }
    }

    function getDryTimeDisableMyFav(selectedItem) {
        if ($scope.currentDryTimeListFav === undefined) {
            return;
        }
        if ($scope.currentDryTimeListFav.indexOf(selectedItem) > -1) {
            return false;
        } else {
            return true;
        }
    }

    function getmodeSelected(selectedItem) {
        if (deviceCurrentMode === selectedItem.courseNameHex) {
            return true;
        } else {
            return false;
        }
    }


    function isTempSelected(selectedItem) {
        if (selectedItem === $scope.setTemp) {
            return true;
        } else {
            return false;
        }
    }

    function getDryLevelSelected(selectedItem) {
        if ($scope.setDryLevel === selectedItem) {
            return true;
        } else {
            return false;
        }
    }

    function getDryLevelSelectedPopUp(selectedItem) {
        if ($scope.setDryLevelFav === selectedItem) {
            return true;
        } else {
            return false;
        }
    }

    function getDryTimeSelected(selectedItem) {
        if ($scope.setDryTime === selectedItem) {
            return true;
        } else {
            return false;
        }
    }
    function getDryTimeSelectedPopUp(selectedItem) {
        if ($scope.setDryTimeFav === selectedItem) {
            return true;
        } else {
            return false;
        }
    }

    function getTempSelectedPopup(selectedItem) {
        if ($scope.setTempFav === selectedItem) {
            return true;
        } else {
            return false;
        }
    }
    function getWrinklePreventPopUp(selectedItem) {
        if ($scope.wrinklePreventFavorite === selectedItem) {
            return true;
        } else {
            return false;
        }
    }
    function getmixLoadBellPopUp(selectedItem) {
        if ($scope.mixLoadBellFavorite === selectedItem) {
            return true;
        } else {
            return false;
        }
    }

    function updateOptionsGUI() {
        if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
            var disableOptions = (angular.isDefined($scope.deviceStatus) && (($scope.deviceStatus === "Run") || ($scope.deviceStatus === "Pause")));
            if (disableOptions || rackDry || $scope.currentTempList !== undefined && $scope.currentTempList.length < 2) {
                $scope.disabletempContents = true;
            } else {
                $scope.disabletempContents = false;
            }
            if (disableOptions || $scope.currentDryLevelList !== undefined && $scope.currentDryLevelList.length < 2) {
                $scope.disabledrylevelContents = true;
            } else {
                $scope.disabledrylevelContents = false;
            }
            if (disableOptions || disableSpecialDryTime || $scope.currentDryTimeList !== undefined && $scope.currentDryTimeList.length < 2) {
                $scope.disabledrytimeContents = true;
            } else {
                $scope.disabledrytimeContents = false;
            }
        }
        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
            var disableOptions = (angular.isDefined($scope.deviceStatusMain) && (($scope.deviceStatusMain === "Run") || ($scope.deviceStatusMain === "Pause")));
            if (disableOptions || rackDry || $scope.currentTempListMain !== undefined && $scope.currentTempListMain.length < 2) {
                $scope.disabletempContentsMain = true;
            } else {
                $scope.disabletempContentsMain = false;
            }
            if (disableOptions || $scope.currentDryLevelListMain !== undefined && $scope.currentDryLevelListMain.length < 2) {
                $scope.disabledrylevelContentsMain = true;
            } else {
                $scope.disabledrylevelContentsMain = false;
            }
            if (disableOptions || disableSpecialDryTime || $scope.currentDryTimeListMain !== undefined && $scope.currentDryTimeListMain.length < 2) {
                $scope.disabledrytimeContentsMain = true;
            } else {
                $scope.disabledrytimeContentsMain = false;
            }
        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
            var disableOptions = (angular.isDefined($scope.deviceStatus) && (($scope.deviceStatus === "Run") || ($scope.deviceStatus === "Pause")));
            if (disableOptions || rackDry || $scope.currentTempListSub !== undefined && $scope.currentTempListSub.length < 2) {
                $scope.disabletempContentsSub = true;
            } else {
                $scope.disabletempContentsSub = false;
            }
            if (disableOptions || $scope.currentDryLevelListSub !== undefined && $scope.currentDryLevelListSub.length < 2) {
                $scope.disabledrylevelContentsSub = true;
            } else {
                $scope.disabledrylevelContentsSub = false;
            }
            if (disableOptions || disableSpecialDryTime || $scope.currentDryTimeListSub !== undefined && $scope.currentDryTimeListSub.length < 2) {
                $scope.disabledrytimeContentsSub = true;
            } else {
                $scope.disabledrytimeContentsSub = false;
            }
        } else {
            ;//Nothing
        }
    }

    function selectIndex(selectedItem) {
        $scope.modePopup = false;
        if ($scope.isGasDryer) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_common_device_dryer,
                msg: $scope.translation.WEBMOB_device_washer_alarm_dry_only_monitoring,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    $scope.onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }
        if ($scope.kidsLock) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_device_washer_alarm_child_lock_title,
                msg: $scope.translation.WEBMOB_device_washer_alarm_child_lock_message,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    $scope.onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }
        if (!$scope.remoteControlEnabled) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_device_washer_alarm_smart_control,
                msg: $scope.translation.WEBMOB_device_washer_alarm_smart_control_dryer_msg,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    $scope.onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }
        changePopUpClass(false);
        setCommonValuesFromSelectIndex(selectedItem);
        $timeout(function () {
            if (selectedItem.courseNameHex.indexOf($scope.deviceMode) !== -1) {
                $scope.mixedLoadBellValue = $scope.mixedLoadBellSetValue;
            } else {
                $scope.mixedLoadBellValue = false;
            }
            dryLevelSelectedIndex = -1;
            var wrinklePrevent = (deviceCurrentMode === selectedItem.courseNameHex && $scope.wrinklePreventState);
            setWrinklePrevent(wrinklePrevent, false);
            if (deviceCurrentMode !== selectedItem.courseNameHex) {
                $scope.setTemp = selectedItem.defaultTemp;
                $scope.setDryLevel = selectedItem.defaultDryLevel;
                $scope.setDryTime = selectedItem.defaultDryTime;
                $scope.specialDryTime = -1;
            } else {
                $scope.setTemp = deviceSetTemp;
                $scope.setDryLevel = deviceSetDryLevel;
                $scope.setDryTime = deviceSetDryTime;
                SyncValueWithDevice();
            }
            specialCaseDryer();
            updateOptionsGUI();
            dryLevelSelectedIndex = getIndexOfDryLevel($scope.setDryLevel);
        }, 0);
    }

    function setCommonValuesFromSelectIndex(selectedItem) {
        $scope.currentCourseEnum = selectedItem.CourseEnum;
        $scope.currentCourseHex = selectedItem.courseNameHex;
        $scope.setTemp = deviceSetTemp;
        $scope.setDryLevel = deviceSetDryLevel;
        $scope.setDryTime = deviceSetDryTime;
        $scope.isTemp = selectedItem.isTempEnabled;
        $scope.isDrylevel = selectedItem.isDryLevelEnabled;
        $scope.isDryTime = selectedItem.isDryTimeEnabled;
        $scope.currentTempList = selectedItem.optionTempList;
        $scope.currentDryLevelList = selectedItem.optionDryLevelList;
        $scope.currentDryTimeList = selectedItem.optionDryTimeList;
    }

    function setCommonValues(selectedItem) {
        if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
            $scope.currentCourseEnum = selectedItem.CourseEnum;
            $scope.currentCourseHex = selectedItem.courseNameHex;
            $scope.setTemp = deviceSetTemp;
            $scope.setDryLevel = deviceSetDryLevel;
            $scope.setDryTime = deviceSetDryTime;
            $scope.isTemp = selectedItem.isTempEnabled;
            $scope.isDrylevel = selectedItem.isDryLevelEnabled;
            $scope.isDryTime = selectedItem.isDryTimeEnabled;
            $scope.currentTempList = selectedItem.optionTempList;
            $scope.currentDryLevelList = selectedItem.optionDryLevelList;
            $scope.currentDryTimeList = selectedItem.optionDryTimeList;
        }

        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
            $scope.currentCourseEnumMain = selectedItem.CourseEnum;
            $scope.currentCourseHexMain = selectedItem.courseNameHex;
            $scope.setTempMain = deviceSetTempMain;
            $scope.setDryLevelMain = deviceSetDryLevelMain;
            $scope.setDryTimeMain = deviceSetDryTimeMain;
            $scope.isTempMain = selectedItem.isTempEnabled;
            $scope.isDrylevelMain = selectedItem.isDryLevelEnabled;
            $scope.isDryTimeMain = selectedItem.isDryTimeEnabled;
            $scope.currentTempListMain = selectedItem.optionTempList;
            $scope.currentDryLevelListMain = selectedItem.optionDryLevelList;
            $scope.currentDryTimeListMain = selectedItem.optionDryTimeList;
        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
            $scope.currentCourseEnumSub = selectedItem.CourseEnum;
            $scope.currentCourseHexSub = selectedItem.courseNameHex;
            $scope.setTempSub = deviceSetTempSub;
            $scope.setDryLevelSub = deviceSetDryLevelSub;
            $scope.setDryTimeSub = deviceSetDryTimeSub;
            $scope.isTempSub = selectedItem.isTempEnabled;
            $scope.isDrylevelSub = selectedItem.isDryLevelEnabled;
            $scope.isDryTimeSub = selectedItem.isDryTimeEnabled;
            $scope.currentTempListSub = selectedItem.optionTempList;
            $scope.currentDryLevelListSub = selectedItem.optionDryLevelList;
            $scope.currentDryTimeListSub = selectedItem.optionDryTimeList;
        } else {
            ;//Nothing
        }
    }

    function updateLandingpage(selectedItem) {
        if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
            currentRunItem = selectedItem;
        }
        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
            currentRunItemMain = selectedItem;
        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
            currentRunItemSub = selectedItem;
        } else {
            ;//Nothing
        }
        setCommonValues(selectedItem);
        specialCaseDryer();
        if ($scope.currentCourseHex === WASHER_DEVICEMODES.TimeDry || $scope.currentCourseHex === WASHER_DEVICEMODES.TimeDry_US) {
            if (rackDry) {
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    $scope.setTemp = "ExtraLow";
                    $scope.disabletempContents = true;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    $scope.setTempMain = "ExtraLow";
                    $scope.disabletempContentsMain = true;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    $scope.setTempSub = "ExtraLow";
                    $scope.disabletempContentsSub = true;
                } else {
                    ;//Nothing
                }
            }
        }
        updateOptionsGUI();
    }

    function SyncValueWithDevice() {
        debugMessage('SyncValueWithDevice ' + deviceCurrentMode);
        if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
            if (deviceSetTemp !== -1) {
                $scope.setTemp = deviceSetTemp;
            }
            if (deviceSetDryLevel !== -1) {
                $scope.setDryLevel = deviceSetDryLevel;
            }
            if (deviceSetDryTime !== -1) {
                $scope.setDryTime = deviceSetDryTime;
            }
            if (devicedryTimeValue !== '0' && devicedryTimeValue !== -1) {
                $scope.specialDryTime = devicedryTimeValue;
                $scope.setDryTime = devicedryTimeValue;
            }
        }
        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
            if (deviceSetTempMain !== -1) {
                $scope.setTempMain = deviceSetTempMain;
            }
            if (deviceSetDryLevelMain !== -1) {
                $scope.setDryLevelMain = deviceSetDryLevelMain;
            }
            if (deviceSetDryTimeMain !== -1) {
                $scope.setDryTimeMain = deviceSetDryTimeMain;
            }
            if (devicedryTimeValue !== '0' && devicedryTimeValue !== -1) {
                $scope.specialDryTime = devicedryTimeValue;
                $scope.setDryTime = devicedryTimeValue;
            }
        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
            if (deviceSetTempSub !== -1) {
                $scope.setTempSub = deviceSetTempSub;
            }
            if (deviceSetDryLevelSub !== -1) {
                $scope.setDryLevelSub = deviceSetDryLevelSub;
            }
            if (deviceSetDryTimeSub !== -1) {
                $scope.setDryTimeSub = deviceSetDryTimeSub;
            }
            if (devicedryTimeValue !== '0' && devicedryTimeValue !== -1) {
                $scope.specialDryTime = devicedryTimeValue;
                $scope.setDryTime = devicedryTimeValue;
            }
        } else {
            ;//Nothing
        }

    }

    function specialCaseDryer() {
        if ($scope.deviceMode === WASHER_DEVICEMODES.TimeDry ||
                $scope.deviceMode === WASHER_DEVICEMODES.QuickDry ||
                $scope.deviceMode === WASHER_DEVICEMODES.AirFluff ||
                $scope.deviceMode === WASHER_DEVICEMODES.WrinkleAway ||
                $scope.deviceMode === WASHER_DEVICEMODES.TimeDry_US ||
                $scope.deviceMode === WASHER_DEVICEMODES.QuickDry_US ||
                $scope.deviceMode === WASHER_DEVICEMODES.AirFluff_US ||
                $scope.deviceMode === WASHER_DEVICEMODES.WrinkleAway_US ||
                $scope.deviceMode === WASHER_DEVICEMODES.Air_Fluff_US ||
                $scope.deviceMode === WASHER_DEVICEMODES.Wrinkle_Away_US ||
                $scope.deviceMode === WASHER_DEVICEMODES.Time_Dry_17_US ||
                $scope.deviceMode === WASHER_DEVICEMODES.Quick_Dry_US) {
            if ($scope.specialDryTime !== -1 && $scope.specialDryTime !== undefined) {
                disableSpecialDryTime = true;
                if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
                    $scope.setDryTime = $scope.specialDryTime;
                    $scope.disabledrytimeContents = true;
                }
                if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                    $scope.setDryTimeMain = $scope.specialDryTime;
                    $scope.disabledrytimeContentsMain = true;
                } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                    $scope.setDryTimeSub = $scope.specialDryTime;
                    $scope.disabledrytimeContentsSub = true;
                } else {
                    ;//Nothing
                }
            } else {
                disableSpecialDryTime = false;
            }
        }
    }

    function checkEPATime(epaTime, value) {
        if (dryType_epa) {
            if (rackDry) {
                convert = false;
            } else {
                convert = true;
            }
        } else {
            convert = false;
        }
        var epaTimeString;
        var timeImageID;
        switch (epaTime) {
            case "00:20:00":
                if (convert) {
                    epaTimeString = $scope.translation[DRYER_TIME.T40];
                } else {
                    epaTimeString = $scope.translation[DRYER_TIME.T20];
                }
                timeImageID = "Dryer/assets/img/main_list_ic_time_20.svg#Layer_1";
                break;
            case "00:30:00":
                if (convert) {
                    epaTimeString = $scope.translation[DRYER_TIME.T50];
                } else {
                    epaTimeString = $scope.translation[DRYER_TIME.T30];
                }
                timeImageID = "Dryer/assets/img/main_list_ic_time_30.svg#Layer_1";
                break;
            case "00:40:00":
                if (convert) {
                    epaTimeString = $scope.translation[DRYER_TIME.T60];
                } else {
                    epaTimeString = $scope.translation[DRYER_TIME.T40];
                }
                timeImageID = "Dryer/assets/img/main_list_ic_time_40.svg#Layer_1";
                break;
            case "00:50:00":
                if (convert) {
                    epaTimeString = $scope.translation[DRYER_TIME.T70];
                } else {
                    epaTimeString = $scope.translation[DRYER_TIME.T50];
                }
                timeImageID = "Dryer/assets/img/main_list_ic_time_50.svg#Layer_1";
                break;
            case "01:00:00":
                if (convert) {
                    epaTimeString = $scope.translation[DRYER_TIME.T80];
                } else {
                    epaTimeString = $scope.translation[DRYER_TIME.T60];
                }
                timeImageID = "Dryer/assets/img/main_list_ic_time_60.svg#Layer_1";
                break;
            case "00:70:00":
                if (convert) {
                    epaTimeString = $scope.translation[DRYER_TIME.T90];
                } else {
                    epaTimeString = $scope.translation[DRYER_TIME.T70];
                }
                timeImageID = "Dryer/assets/img/main_list_ic_time_70.svg#Layer_1";
                break;
            case "00:80:00":
                if (convert) {
                    epaTimeString = $scope.translation[DRYER_TIME.T100];
                } else {
                    epaTimeString = $scope.translation[DRYER_TIME.T80];
                }
                timeImageID = "Dryer/assets/img/main_list_ic_time_80.svg#Layer_1";
                break;
            case "00:00:00":
                if (convert) {
                    epaTimeString = DRYER_TIME.T00;
                } else {
                    epaTimeString = DRYER_TIME.T00;
                }
                timeImageID = "Dryer/assets/img/main_list_ic_time_60.svg#Layer_1";
                break;
            default:
                epaTimeString = epaTime;
                timeImageID = "Dryer/assets/img/main_list_ic_time_20.svg#Layer_1";
                break;
        }
        if (value === 0) {
            var svg = document.getElementById('timeSVG');
            SHPService.loadSVG(timeImageID, svg);
        } else {
            return epaTimeString;
        }
    }

    function specialCaseRack() {
        if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
            if (rackDry) {
                if ($scope.deviceMode === WASHER_DEVICEMODES.TimeDry || $scope.deviceMode === WASHER_DEVICEMODES.TimeDry_US) {
                    $scope.setTemp = "ExtraLow";
                }
            }
        }
        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
            if (rackDry) {
                if ($scope.deviceMode === WASHER_DEVICEMODES.TimeDry || $scope.deviceMode === WASHER_DEVICEMODES.TimeDry_US) {
                    $scope.setTempMain = "ExtraLow";
                }
            }
        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
            if (rackDry) {
                if ($scope.deviceMode === WASHER_DEVICEMODES.TimeDry || $scope.deviceMode === WASHER_DEVICEMODES.TimeDry_US) {
                    $scope.setTempSub = "ExtraLow";
                }
            }
        } else {
            ;//Nothing
        }

        updateOptionsGUI();
    }

    function selectIndexTemp(selectedItem) {
        if ($scope.currentTempList.indexOf(selectedItem) < 0) {
            return;
        }
        $scope.tempPopup = false;
        toggleBottomPopUpClass($scope.tempPopup);
        $scope.setTemp = selectedItem;
    }

    function selectIndexDryLevel(selectedItem, index) {
        if ($scope.currentDryLevelList === undefined || $scope.currentDryLevelList.indexOf(selectedItem) < 0) {
            return;
        }
        dryLevelSelectedIndex = index;
        $scope.dryLevelPopup = false;
        toggleBottomPopUpClass($scope.dryLevelPopup);
        $scope.setDryLevel = selectedItem;
    }

    function selectIndexDryTime(selectedItem) {
        if ($scope.currentDryTimeList === undefined || $scope.currentDryTimeList.indexOf(selectedItem) < 0) {
            return;
        }
        $scope.dryTimePopup = false;
        toggleBottomPopUpClass($scope.dryTimePopup);
        $scope.setDryTime = selectedItem;
        deviceSetDryTime = selectedItem;
    }

    function selectIndexKoreanComboSubOption(index) {
        $scope.isKoreanComboSubOption = false;
        toggleBottomPopUpClass($scope.isKoreanComboSubOption);
        changePopUpClass($scope.isKoreanComboSubOption);
        $scope.koreanComboSubIndex = index;
    }

    function colsePopOver() {
        $scope.tempPopup = false;
        toggleBottomPopUpClass($scope.tempPopup);
    }

    function doCancelWashing() {
        $scope.cancelButtonPressed = false;
        $scope.dryerCancelPressed = true;
        $scope.cancelWashing();
    }

    function cancelWashing() {
        $timeout(function () {
            if ($scope.isGasDryer) {
                $scope.errorList.push({
                    title: $scope.translation.WEBMOB_common_device_dryer,
                    msg: $scope.translation.WEBMOB_device_washer_alarm_dry_only_monitoring,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                    btnOkHandler: function () {
                        $scope.onOkClicked(true);
                    },
                    closeDialog: !true
                });
                changePopUpClass(true);
                return;
            }
            if ($scope.kidsLock) {
                $scope.errorList.push({
                    title: $scope.translation.WEBMOB_device_washer_alarm_child_lock_title,
                    msg: $scope.translation.WEBMOB_device_washer_alarm_child_lock_message,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                    btnOkHandler: function () {
                        $scope.onOkClicked(true);
                    },
                    closeDialog: !true
                });
                changePopUpClass(true);
                return;
            }
            if (!$scope.remoteControlEnabled) {
                $scope.errorList.push({
                    title: $scope.translation.WEBMOB_device_washer_alarm_smart_control,
                    msg: $scope.translation.WEBMOB_device_washer_alarm_smart_control_dryer_msg,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                    btnOkHandler: function () {
                        $scope.onOkClicked(true);
                    },
                    closeDialog: !true
                });
                changePopUpClass(true);
                return;
            }
            $scope.alertState = DRYERALERT.CANCEL;
            $scope.errorList.push({
                msg: $scope.translation.WEBMOB_device_washer_alarm_confirm_course_cancel_dryer,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_yes_CL,
                btnOkHandler: function () {
                    $scope.onOkClicked(true);
                },
                btnCancelTxt: $scope.translation.WEBMOB_device_washer_comm_no_CL,
                btnCancelHandler: function () {
                    $scope.onOkClicked(false);
                },
                closeDialog: !true
            });
            $scope.dryerCancelPressed = false;
            changePopUpClass(true);
        }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
    }

    function clickWrinkle() {
        if ($scope.wrinklePreventdisable || $scope.cycFinish || !$scope.remoteControlEnabled || $scope.kidsLock) {
            return;
        }
        if ($scope.isGasDryer) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_common_device_dryer,
                msg: $scope.translation.WEBMOB_device_washer_alarm_dry_only_monitoring,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    $scope.onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }
        if ($scope.kidsLock) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_device_washer_alarm_child_lock_title,
                msg: $scope.translation.WEBMOB_device_washer_alarm_child_lock_message,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    $scope.onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }
        if (!$scope.remoteControlEnabled) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_device_washer_alarm_smart_control,
                msg: $scope.translation.WEBMOB_device_washer_alarm_smart_control_dryer_msg,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    $scope.onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }
        if ($scope.deviceStatus === 'Ready') {
            setWrinklePrevent(!$scope.wrinkleOn, true);
        }
        if ($scope.deviceStatus === 'Pause') {
            $scope.wrinkleOn = !$scope.wrinkleOn;
        }
    }

    function setWrinklePrevent(value, showPopup) {
        if ($scope.wrinkleOn !== value) {
            $scope.wrinkleOn = value;
            setTimeout(function () {
                showPopup && $scope.errorList.push({
                    title: $scope.translation.WEBMOB_device_washer_comm_wrinkle_prevent,
                    msg: $scope.translation.WEBMOB_device_washer_alarm_wrinkle_prevent_disable_msg,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                    btnOkHandler: function () {
                        $scope.onOkClicked(true);
                    },
                    closeDialog: !true
                });
            }, 0);
            if (showPopup)
                changePopUpClass(true);
        }
    }

    function setWrinklePreventMain(value, showPopup) {
        if ($scope.wrinkleOnMain !== value) {
            $scope.wrinkleOnMain = value;
            setTimeout(function () {
                showPopup && $scope.errorList.push({
                    title: $scope.translation.WEBMOB_device_washer_comm_wrinkle_prevent,
                    msg: $scope.translation.WEBMOB_device_washer_alarm_wrinkle_prevent_disable_msg,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                    btnOkHandler: function () {
                        $scope.onOkClicked(true);
                    },
                    closeDialog: !true
                });
            }, 0);
            changePopUpClass(true);
        }
    }

    function setWrinklePreventSub(value, showPopup) {
        if ($scope.wrinkleOnSub !== value) {
            $scope.wrinkleOnSub = value;
            setTimeout(function () {
                showPopup && $scope.errorList.push({
                    title: $scope.translation.WEBMOB_device_washer_comm_wrinkle_prevent,
                    msg: $scope.translation.WEBMOB_device_washer_alarm_wrinkle_prevent_disable_msg,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                    btnOkHandler: function () {
                        $scope.onOkClicked(true);
                    },
                    closeDialog: !true
                });
            }, 0);
            changePopUpClass(true);
        }
    }

    function wrinkleStart() {
        if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
            if ($scope.wrinkleOn) {
                $scope.wrinklePreventStarted = true;
                $scope.statusDisplay = true;
                document.getElementById("innercirclebutton").style.display = "none";
            }
        }
        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
            if ($scope.wrinkleOnMain) {
                $scope.wrinklePreventStartedMain = true;
                $scope.statusDisplayMain = true;
                document.getElementById("innercirclebutton").style.display = "none";
            }
        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
            if ($scope.wrinkleOnSub) {
                $scope.wrinklePreventStartedSub = true;
                $scope.statusDisplaySub = true;
                document.getElementById("innercirclebutton").style.display = "none";
            }
        } else {
            ;//Nothing
        }
        debugMessage("Cycle Finished when wrinkle is on");
    }

    function cycleConfirm() {
        $scope.alarmConfirm();
    }

    function showAlert(msgHeader, msgContent, txtButton2, txtButton1) {
        $scope.alertPopUp.show();
        document.getElementById("txtMessageHeader").innerHTML = msgHeader;
        document.getElementById("txtMessageContent").innerHTML = msgContent;
        if (txtButton1 === "") {
            document.getElementById("txtButton1").style.display = "none";
        } else {
            document.getElementById("txtButton1").style.display = "initial";
            document.getElementById("txtButton1").innerHTML = txtButton1;
        }
        document.getElementById("txtButton2").innerHTML = txtButton2;
    }

    function onAlertButton1Click() {
        $scope.alertPopUp.hide();
    }

    function onAlertButton2Click() {
        if ($scope.alertState === DRYERALERT.CANCEL || $scope.alertState === DRYERALERT.CYCLEFINISHED) {
            $scope.cancelProgress();
            $scope.alertPopUp.hide();
        } else if ($scope.alertState === DRYERALERT.WRINKLE) {
            ;// Nothing
        } else {
            ;// Nothing
        }
        $scope.alertPopUp.hide();
    }

    function getLocalStorageData(item) {
        if (typeof (Storage) !== "undefined") {
            var locVal = localStorage.getItem(item);
            if (locVal === null) {
                setLocalStorageData('DRYERsyncTime', JSON.stringify(true));
                return true;
            }
            return locVal;
        }
    }

    function getLocalStorageForFirstLaunch(item) {
        if (typeof (Storage) !== "undefined") {
            var locVal = localStorage.getItem(item);
            if (locVal === null) {
                return false;
            }
            return locVal;
        }
    }

    function getLocalStorageForMyFavorite(item) {
        if (typeof (Storage) !== "undefined") {
            var locVal = localStorage.getItem(item);
            if (locVal === null) {
                locVal = [];
            }
            return locVal;
        }
    }

    function setLocalStorageForMyFavorite(item) {
        setLocalStorageData($scope.Device.uuid + 'myFavorite', JSON.stringify(item));
    }

    function saveButtonFavorite() {
        closeAllPopups();
        if (favPopUpChanged) {
            return;
        }
        initAddFavoriteSettingsOptions();
        if (!toUpdateFavItem()) {
            saveMyFav();
        }
    }
    function getfavpopupforDryLevelTop() {
        var height = 14.725;
        if ($scope.isAppV2 === true)
            height = height + 1.2;
        return height;
    }
    function getfavpopupforTempTop() {
        var height = 14.725;
        if ($scope.isAppV2 === true)
            height = height + 1.2;
        if ($scope.isDrylevelFav === true)
            height = height + 3.7;
        return height;
    }
    function getfavpopupforDryTimeTop() {
        var height = 14.725;
        if ($scope.isAppV2 === true)
            height = height + 1.2;
        if ($scope.isDrylevelFav === true)
            height = height + 3.7;
        if ($scope.isTempFav === true)
            height = height + 3.7;
        return height;
    }

    function getfavpopupforwrinklepreventTop() {
        var height = 14.725;
        if ($scope.isAppV2 === true)
            height = height + 1.2;
        if ($scope.isDrylevelFav === true)
            height = height + 3.7;
        if ($scope.isTempFav === true)
            height = height + 3.7;
        if ($scope.isDryTimeFav === true)
            height = height + 3.7;
        return height;
    }
    function getfavpopupforMiexedBellTop() {
        var height = 14.725;
        if ($scope.isAppV2 === true)
            height = height + 1.2;
        if ($scope.isDrylevelFav === true)
            height = height + 3.7;
        if ($scope.isTempFav === true)
            height = height + 3.7;
        if ($scope.isDryTimeFav === true)
            height = height + 3.7;
        height = height + 3.7;
        return height;
    }
    function toUpdateFavItem() { //TODO EDIT wash
        debugMessage('toUpdateFavItem');
        if ($scope.currentScreen !== WASHERSCREENS.ADDFAVORITE) {
            return false;
        }
        var newLocalStorage = JSON.parse(getLocalStorageData($scope.Device.uuid + 'myFavorite'));
        if (newLocalStorage === null || newLocalStorage.length === 0) {
            return false;
        }
        for (var k = 0; k < newLocalStorage.length; k++) {
            if ($scope.FavID === newLocalStorage[k]['favItemId']) {
                debugMessage('updated old  ' + newLocalStorage[k]);
                var inputName = document.getElementById("inputMFName").value;
                $scope.currentRecipeName = newLocalStorage[k].title;
                if (newLocalStorage[k].title !== inputName) {
                    if (inputName !== undefined && inputName.trim() === '') {
                        inputName = $scope.currentRecipeName;
                    } else {
                        if (!validateName(inputName)) {
                            return true;
                        }
                    }
                }
                newLocalStorage[k].favItemId = $scope.FavID;
                newLocalStorage[k].title = inputName;
                newLocalStorage[k].courseEnum = $scope.currentCourseEnumfavorite;
                newLocalStorage[k].course = $scope.translation[$scope.currentCourseEnumfavorite];
                newLocalStorage[k].courseHex = $scope.currentCourseHexFav;
                newLocalStorage[k].optiontemp = $scope.setTempFav;
                newLocalStorage[k].optiondryLevel = $scope.setDryLevelFav;
                newLocalStorage[k].optionDryTime = $scope.setDryTimeFav;
                newLocalStorage[k].isChecked = false;
                newLocalStorage[k].optionIsDryTime = $scope.isDryTimeFav;
                newLocalStorage[k].optionIsDryTemp = $scope.isTempFav;
                newLocalStorage[k].optionIsDryLevel = $scope.isDrylevelFav;
                newLocalStorage[k].optionDisabledrylevelContents = $scope.disabledrylevelContentsFav;
                newLocalStorage[k].optionDisabledrytimeContents = $scope.disabledrytimeContentsFav;
                newLocalStorage[k].optionDisabletempContents = $scope.disabletempContentsFav;
                newLocalStorage[k].optionWrinklepreventFav = $scope.wrinklePreventFavorite;
                newLocalStorage[k].optionMixedLoadBellFav = $scope.mixLoadBellFavorite;
                newLocalStorage[k].optionMixedLoadBellFavIsEnable = !isMixedLoadDisabledMyFav();//$scope.mixLoadBellFavoriteIsEnable;
                newLocalStorage[k].optionTempList = $scope.currentTempListFav;
                newLocalStorage[k].optionDryLevelList = $scope.currentDryLevelListFav;
                newLocalStorage[k].optionDryTimeList = $scope.currentDryTimeListFav;
                newLocalStorage[k].optionDryLevelImage = getDryLevelConstantFav($scope.setDryLevelFav);
                newLocalStorage[k].optionDryTimeImage = getTimeConstantFav($scope.setDryTimeFav);
                newLocalStorage[k].optionTempImage = gettempConstantFav($scope.setTempFav);
                debugMessage('updated new ' + newLocalStorage[k]);
                removeLocalStorageData($scope.Device.uuid + 'myFavorite');
                setLocalStorageForMyFavorite(newLocalStorage);
                showMyFavorite();
                showToast($scope.translation.WEBMOB_device_washer_alarm_my_favorite_toast_save_change);
                $scope.FavID = null;
                return true;
            }
        }
        return false;
    }

    function saveMyFav() {
        var name = document.getElementById('inputMFName').value;
        if (name !== undefined && name.trim() === '') {
            document.getElementById('inputMFName').value = getMyFavoriteName();
            $scope.currentRecipeName = getMyFavoriteName();

        } else {
            if (!validateName(name)) {
                return;
            }
        }
        $scope.myFavoriteList = [];
        var favList = getLocalStorageForMyFavorite($scope.Device.uuid + 'myFavorite');
        if (favList.length !== 0)
            $scope.myFavoriteList = JSON.parse(getLocalStorageForMyFavorite($scope.Device.uuid + 'myFavorite'));
        var itemToPush = {
            favItemId: Math.random(),
            title: document.getElementById('inputMFName').value,
            courseEnum: $scope.currentCourseEnumfavorite,
            course: $scope.translation[$scope.currentCourseEnumfavorite],
            courseHex: $scope.currentCourseHexFav,
            optiontemp: $scope.setTempFav,
            optiondryLevel: $scope.setDryLevelFav,
            optionDryTime: $scope.setDryTimeFav,
            isChecked: false,
            optionIsDryTime: $scope.isDryTimeFav,
            optionIsDryTemp: $scope.isTempFav,
            optionIsDryLevel: $scope.isDrylevelFav,
            optionDisabledrylevelContents: $scope.disabledrylevelContentsFav,
            optionDisabledrytimeContents: $scope.disabledrytimeContentsFav,
            optionDisabletempContents: $scope.disabletempContentsFav,
            optionWrinklepreventFav: $scope.wrinklePreventFavorite,
            optionMixedLoadBellFav: $scope.mixLoadBellFavorite,
            optionTempList: $scope.currentTempListFav,
            optionDryLevelList: $scope.currentDryLevelListFav,
            optionDryTimeList: $scope.currentDryTimeListFav,
            optionMixedLoadBellFavIsEnable: !isMixedLoadDisabledMyFav(), //$scope.mixLoadBellFavoriteIsEnable,
            optionDryLevelImage: getDryLevelConstantFav($scope.setDryLevelFav),
            optionDryTimeImage: getTimeConstantFav($scope.setDryTimeFav),
            optionTempImage: gettempConstantFav($scope.setTempFav),
            optionDryerToSelect: $scope.currentWasherSelected
        };
        $scope.myFavoriteList.unshift(itemToPush);
        setLocalStorageForMyFavorite($scope.myFavoriteList);
        showMyFavorite();
        showToast($scope.translation.WEBMOB_device_washer_alarm_my_favorite_toast_save_new);
    }

    function getMyFavoriteName() {
        var defaultRecipeName = $scope.translation.WEBMOB_device_washer_settings_my_favorite, j = 1;
        var list = getLocalStorageForMyFavorite($scope.Device.uuid + 'myFavorite');
        if (list.length === 0) {
            return defaultRecipeName + ' 1';
        }
        var newLocalStorage = JSON.parse(getLocalStorageForMyFavorite($scope.Device.uuid + 'myFavorite'));

        while (true) {
            var uniqueNameFound = true;
            defaultRecipeName = $scope.translation.WEBMOB_device_washer_settings_my_favorite + ' ' + j;
            for (var i = 0; i < newLocalStorage.length; i++) {
                if (newLocalStorage[i]["title"] !== undefined && newLocalStorage[i]["title"].trim() === (defaultRecipeName).trim()) {
                    uniqueNameFound = false;
                    break;
                }
            }
            if (uniqueNameFound) {
                break;
            }
            j++;
        }

        return defaultRecipeName;
    }

    function initAddFavoriteSettingsOptions() {
        $scope.favDryLevel = false;
        $scope.favDryTime = false;
        $scope.favTemp = false;
        $scope.favWrinkle = false;
        $scope.favMixedBell = false;
    }

    function validateName(title) {
        debugMessage('validation for  name ' + title);
        var list = getLocalStorageForMyFavorite($scope.Device.uuid + 'myFavorite');
        if (list.length !== 0) {
            list = JSON.parse(getLocalStorageForMyFavorite($scope.Device.uuid + 'myFavorite'));
            var len = list.length;
            for (var i = 0; i < len; i++) {
                var obj = (list[i]);
                if (obj.title === title) {
                    $scope.errorList.push({
                        title: '',
                        msg: $scope.translation.WEBMOB_device_washer_alarm_my_favorite_same_name_msg,
                        btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                        btnOkHandler: function () {
                            onOkClicked(true);
                        },
                        closeDialog: !true
                    });
                    changePopUpClass(true);
                    return false;
                }
            }
        }
        return true;
    }

    function removeItemFromMyFavorite(index) {
        $scope.alertState = DRYERALERT.DELETE_MYFAVORITES;
        $scope.errorList.push({
            msg: $scope.translation.WEBMOB_device_washer_alarm_my_favorite_delete_msg,
            btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_delete_CL,
            btnOkHandler: function () {
                //$scope.deleteFavoriteItem = true;
                $scope.myFavoriteList.splice(index, 1);
                setLocalStorageForMyFavorite($scope.myFavoriteList);
                showToast($scope.translation.WEBMOB_device_washer_alarm_my_favorite_toast_delete);
                showMyFavorite();
                $scope.onOkClicked(true);

            },
            btnCancelTxt: $scope.translation.WEBMOB_common_cancel_capital,
            btnCancelHandler: function () {
                $scope.onOkClicked(false);
            },
            closeDialog: !true
        });
        changePopUpClass(true);
    }

    function closeAllPopups() {
        if ($scope.custDialogpopup && ($scope.alertState !== DRYERALERT.CONNECTION_FAILURE || $scope.alertState !== DRYERALERT.ALARMSERVICE)) {
            $scope.custDialogpopup = false;
        }
        if ($scope.errorList.length > 0 && $scope.alertState !== DRYERALERT.CONNECTION_FAILURE && $scope.alertState !== DRYERALERT.ALARMSERVICE && !powerOffPopUp) {
            for (var i = 0; i < $scope.errorList.length; i++) {
                $scope.errorList.pop();
            }
        }
        if ($scope.modePopup) {
            $scope.modePopup = false;
        }
        if ($scope.tempPopup) {
            $scope.tempPopup = false;
        }
        if ($scope.dryLevelPopup) {
            $scope.dryLevelPopup = false;
        }
        if ($scope.dryTimePopup) {
            $scope.dryTimePopup = false;
        }
        if ($scope.serviceButtonPressed) {
            $scope.serviceButtonPressed = false;
        }
        if ($scope.isKoreanComboSubOption) {
            $scope.isKoreanComboSubOption = false;
        }
        closeMyFavPopUps();
        changePopUpClass(false);
    }

    function closeMyFavPopUps() {
        favPopUpChanged = false;
        if ($scope.favTemp || $scope.favDryTime || $scope.favDryLevel || $scope.favWrinkle || $scope.favMixedBell) {
            $scope.favTemp = false;
            $scope.favDryTime = false;
            $scope.favDryLevel = false;
            $scope.favWrinkle = false;
            $scope.favMixedBell = false;
            favPopUpChanged = true;
        }
    }

    function handleStatusCode(status, response) {
        if (status === WASHER_COMMANDS.STATUS_204) {
            if ($scope.checkResponse.indexOf(WASHER_COMMANDS.syncTime) > -1) {
                $scope.syncTime = true;
                setLocalStorageData('DRYERsyncTime', JSON.stringify($scope.syncTime));
                dismissLoadingBar(WASHER_COMMANDS.syncTime);
            }
        }
    }

    function showConnectionFailurePopup() {
        $scope.loadingBar = false;
        $scope.custDialogpopup = false;
        if ($scope.modePopup) {
            $scope.modePopup = false;
            changePopUpClass($scope.modePopup);
        }
        //if ($scope.currentScreen !== WASHERSCREENS.CYCLEFINISH || !$scope.laundrySwitch) {
        if (!$scope.cycFinish || !$scope.laundrySwitch) {
            $scope.alertState = DRYERALERT.CONNECTION_FAILURE;
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_device_washer_alarm_connection_end_title,
                msg: $scope.translation.WEBMOB_device_washer_alarm_connection_end_msg,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    $scope.onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
        }
    }

    function showcustCountrySelectionPopup() {
        $scope.countrySelectionPopupVisible = true;
        document.getElementById('selectLanguageID').innerHTML = $scope.translation.WEBMOB_common_tutorial_select_language; //"Select Language";
        document.getElementById('okButtonID').innerHTML = $scope.translation.WEBMOB_device_washer_comm_ok_CL;
        document.getElementById('cancelButtonID').innerHTML = $scope.translation.WEBMOB_device_washer_comm_cancel_CL;
    }

    function onCountrySelected(countryIndex) {
        $scope.countrySelectedIndex = countryIndex;
    }

    function onKoreanComboOptionsSelected(Index) {
        $scope.koreanComboIndex = Index;
        if (Index === $scope.koreanComboOptions.length - 1) {
            openKoreanComboSubOptionPopOver();
        }
    }

    function onCountrySelectedOkClicked(isCountrySelected) {
        if (isCountrySelected) {
            if ($scope.countrySelectedIndex === 0) {
                $timeout(function () {
                    nativeInterface.runOnNative("customerService", aboutCommand(reqParamCountrySelection));
                }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
            } else {
                $timeout(function () {
                    nativeInterface.runOnNative("customerService", aboutCommand(reqParamCountrySelection, true));
                }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
            }
        }
        $scope.closeCountrySelectionPopup();
    }

    function showcustDialog(msgheader, popuptext, showCancel, showok) {
        $scope.custDialogpopup = true;
        document.getElementById("custpopupheadertext").innerHTML = msgheader;
        $scope.popupTextDisplay = popuptext;
        if (showok) {
            document.getElementById("popupok").style.visibility = "visible";
        } else {
            document.getElementById("popupok").style.visibility = "hidden";
        }
        if (showCancel) {
            document.getElementById("popupcancel").style.visibility = "visible";
        } else {
            document.getElementById("popupcancel").style.visibility = "hidden";
        }
    }

    function onOkClicked(checkok) {
        if (checkok) {
            if ($scope.alertState === DRYERALERT.CANCEL) {
                $scope.cancelProgress();
            } else if ($scope.alertState === DRYERALERT.CYCLEFINISHED) {
                updateCancelProgres();
            } else if ($scope.alertState === DRYERALERT.CONNECTION_FAILURE) {
                //if ($scope.currentScreen === WASHERSCREENS.CYCLEFINISH || ($scope.currentScreen === WASHERSCREENS.DETAILPAGE && $scope.cycFinish)) {
                if ($scope.cycFinish && !$scope.homePage) {
                    ;// do nothing
                } else {
                    closeApp();
                }
            } else if ($scope.alertState === DRYERALERT.ALARMSERVICE) {
                //nativeInterface.runOnNative("callDial", $scope.alarmServicePayload());
                $scope.callCenter($scope.callServiceIndex);
            } else if ($scope.alertState === DRYERALERT.RESETENERGY) {
                $scope.isCallFromEnergyReset = true;
                sendResetCommand();
            } else if ($scope.alertState === DRYERALERT.DELETE_MYFAVORITES) {
                if ($scope.bAllListSelected) {
                    deletAllFromFavorites();
                } else if (!$scope.bAllListSelected && $scope.isAnyCheckedItem) {
                    deleteSelectedItemFromFavorites();
                } else {
                    ; //nothing
                }
            } else {
                ;//Nothing
            }
        }
        $scope.custDialogpopup = false;
        $scope.alertState = -1;
        if ($scope.errorList.length > 0) {
            $scope.errorList.pop();
        }
        changePopUpClass(false);
    }

    function okClickedAtPowerOff(moveToHome, id) {
        powerOffPopUp = false;
        if ($scope.isDualDryer && $scope.detailPage && !$scope.cycFinish && moveToHome) {
            if ((id === 0 && $scope.currentWasherSelected === WASHERCURRENTSEL.MAIN_SELECTED) || (id === 1 && $scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED)) {
                goToHome();
            }
        }
        $scope.custDialogpopup = false;
        $scope.alertState = -1;
        if ($scope.errorList.length > 0) {
            $scope.errorList.pop();
        }
        changePopUpClass(false);
    }

    function closepopup() {
        changePopUpClass(false);
        return;
    }

    function closeCountrySelectionPopup() {
        $scope.countrySelectionPopupVisible = false;
        changePopUpClass(false);
    }

    function getErrorTitle(errorEnum) {
        debugMessage("Error code is:::::::::::::::::::::" + errorEnum);
        errorEnum = errorEnum.toUpperCase();
        switch (errorEnum) {
            case "1E":
                return $scope.translation.WEBMOB_device_washer_error_title_1e;
            case "tE":
                return $scope.translation.WEBMOB_device_washer_error_title_te1;
            case "tE1":
                return $scope.translation.WEBMOB_device_washer_error_title_te1;
            case "TE":
                return $scope.translation.WEBMOB_device_washer_error_title_te1;
            case "TE1":
                return $scope.translation.WEBMOB_device_washer_error_title_te1;
            case "TE2":
                return $scope.translation.WEBMOB_device_washer_error_title_te2;
            case "TE3":
                return $scope.translation.WEBMOB_device_washer_error_title_te3;
            case "3E":
                return $scope.translation.WEBMOB_device_washer_error_title_3e1;
            case "3E1":
                return $scope.translation.WEBMOB_device_washer_error_title_3e1;
            case "3E2":
                return $scope.translation.WEBMOB_device_washer_error_title_3e2;
            case "3E3":
                return $scope.translation.WEBMOB_device_washer_error_title_3e3;
            case "3E4":
                return $scope.translation.WEBMOB_device_washer_error_title_3e4;
            case "BE":
                return $scope.translation.WEBMOB_device_washer_error_title_be;
            case "2E":
                return $scope.translation.WEBMOB_device_washer_error_title_9e1;
            case "UC":
                return $scope.translation.WEBMOB_device_washer_error_title_9e1;
            case "9E1":
                return $scope.translation.WEBMOB_device_washer_error_title_9e1;
            case "9E2":
                return $scope.translation.WEBMOB_device_washer_error_title_9e2;
            case "E2":
                return $scope.translation.WEBMOB_device_washer_error_title_be2;
            case "BE2":
                return $scope.translation.WEBMOB_device_washer_error_title_be2;
            case "bE2":
                return $scope.translation.WEBMOB_device_washer_error_title_be2;
            case "dS":
                return $scope.translation.WEBMOB_device_washer_error_title_de;
            case "DS":
                return $scope.translation.WEBMOB_device_washer_error_title_de;
            case "dE":
                return $scope.translation.WEBMOB_device_washer_error_title_de;
            case "DE":
                return $scope.translation.WEBMOB_device_washer_error_title_de;
            case "LO":
                return $scope.translation.WEBMOB_device_washer_error_title_de1;
            case "dE1":
                return $scope.translation.WEBMOB_device_washer_error_title_de1;
            case "DE1":
                return $scope.translation.WEBMOB_device_washer_error_title_de1;
            case "dE2":
                return $scope.translation.WEBMOB_device_washer_error_title_de2;
            case "dF":
            case "dF2":
            case "DE2":
                return $scope.translation.WEBMOB_device_washer_error_title_de2;
            case "DF":
                return $scope.translation.WEBMOB_device_washer_error_title_df;
            case "AE":
                return $scope.translation.WEBMOB_device_washer_error_title_ae;
            case "LE":
                return $scope.translation.WEBMOB_device_washer_error_title_le;
            case "FE":
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_title_efe;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_title_fe;
                }
                break;
            case "4E":
                return $scope.translation.WEBMOB_device_washer_error_title_4e;
            case "4E2":
                return $scope.translation.WEBMOB_device_washer_error_title_4e2;
            case "5E":
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_title_5e_dry;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_title_5e;
                }
                break;
            case "nd":
                return $scope.translation.WEBMOB_device_washer_error_title_5e;
            case "Hr":
                return $scope.translation.WEBMOB_device_washer_error_title_he;
            case "HE":
                return $scope.translation.WEBMOB_device_washer_error_title_he;
            case "HE1":
                return $scope.translation.WEBMOB_device_washer_error_title_he1;
            case "HE2":
                return $scope.translation.WEBMOB_device_washer_error_title_he2;
            case "CE":
                return $scope.translation.WEBMOB_device_washer_error_title_ce;
            case "UE":
                return $scope.translation.WEBMOB_device_washer_error_title_ue;
            case "dc":
                return $scope.translation.WEBMOB_device_washer_error_title_ue;
            case "8E":
                return $scope.translation.WEBMOB_device_washer_error_title_8e;
            case "PE":
                return $scope.translation.WEBMOB_device_washer_error_title_pe;
            case "NF":
                return $scope.translation.WEBMOB_device_washer_error_title_4e; //추가
            case "NF1":
                return $scope.translation.WEBMOB_device_washer_error_title_4e2; //추가
            case "OE":
                return $scope.translation.WEBMOB_device_washer_error_title_oe;
            case "oF":
                return $scope.translation.WEBMOB_device_washer_error_title_oe;
            case "4E1":
                return $scope.translation.WEBMOB_device_washer_error_title_4e;
            case "8E1":
                return $scope.translation.WEBMOB_device_washer_error_title_8e;
            case "8E2":
                return $scope.translation.WEBMOB_device_washer_error_title_8e;
            case "OF":
                return $scope.translation.WEBMOB_device_washer_error_title_oe;
            case "SDE":
                return $scope.translation.WEBMOB_device_washer_error_title_sde;
            case "tE2":
                return $scope.translation.WEBMOB_device_washer_error_title_te2;
            case "6E":
                return $scope.translation.WEBMOB_device_washer_error_title_6e;
            case 'AE3':
                return $scope.translation.WEBMOB_device_washer_error_title_ae3;
            case "AE4":
                return $scope.translation.WEBMOB_device_washer_error_title_ae4;
            case "AE5":
                return $scope.translation.WEBMOB_device_washer_error_title_ae5;
            case "AE6":
                return $scope.translation.WEBMOB_device_washer_error_title_ae6;
            case "TE4":
                return $scope.translation.WEBMOB_device_washer_error_title_te4;
            case "4E3":
                return $scope.translation.WEBMOB_device_washer_error_title_4e3;
            case "FL":
                return $scope.translation.WEBMOB_device_washer_error_title_de1;
            case "LE1":
                return $scope.translation.WEBMOB_device_washer_error_title_le1;
            case "TE5":
            case "TC5":     //'17K dryer added.
                return $scope.translation.WEBMOB_device_washer_error_title_te5;
                //New added from 15K
            case "1C":
                return $scope.translation.WEBMOB_device_washer_error_title_1c;
            case "tC":
                return $scope.translation.WEBMOB_device_washer_error_title_tc1;
            case "tC1":
                return $scope.translation.WEBMOB_device_washer_error_title_tc1;
            case "TC":
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_title_tc2;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_title_tc1;
                }
                break;
            case "TC1":
                return $scope.translation.WEBMOB_device_washer_error_title_tc1;
            case "TC2":
                return $scope.translation.WEBMOB_device_washer_error_title_tc2;
            case "TC3":
                return $scope.translation.WEBMOB_device_washer_error_title_tc3;
            case "3C":
            case "3C1":
            case "3C2":
            case "3C3":
            case "3C4":
            case "3C5":
            case "3C6":
            case "3C7":
            case "3C8":
            case "BC":
            case "3C9":
                return $scope.translation.WEBMOB_device_washer_error_title_3c1;
            case "2C":
            case "9C1":
                return $scope.translation.WEBMOB_device_washer_error_title_9c1;
            case "9C2":
                return $scope.translation.WEBMOB_device_washer_error_title_9c2;
            case "C2":
            case "BC2":
                return $scope.translation.WEBMOB_device_washer_error_title_bc2;
            case "dC":
                return $scope.translation.WEBMOB_device_washer_error_title_dc;
            case "DC":
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_title_dc_dry;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_title_dc;
                }
                break;
            case "dC1":
                return $scope.translation.WEBMOB_device_washer_error_title_dc1;
            case "DC1":
                return $scope.translation.WEBMOB_device_washer_error_title_dc1;
            case "dC2":
                return $scope.translation.WEBMOB_device_washer_error_title_dc2;
            case "DC2":
                return $scope.translation.WEBMOB_device_washer_error_title_dc2;
            case "AC":
                return $scope.translation.WEBMOB_device_washer_error_title_ac;
            case "LC":
                return $scope.translation.WEBMOB_device_washer_error_title_lc;
            case "LC1":
                return $scope.translation.WEBMOB_device_washer_error_title_lc1;
            case "FC":
            case "FC3":
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_title_efe;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_title_fc;
                }
                break;
            case "4C":
            case "4C1":
                return $scope.translation.WEBMOB_device_washer_error_title_4c;
            case "4C2":
                return $scope.translation.WEBMOB_device_washer_error_title_4c2;
            case "5C":
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_title_5e_dry;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_title_5c;
                }
                break;
            case "HC":
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_title_hc_dry;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_title_hc;
                }
                break;
            case "HC1":
                return $scope.translation.WEBMOB_device_washer_error_title_hc1;
            case "HC2":
                return $scope.translation.WEBMOB_device_washer_error_title_hc2;
            case "CC":
                return $scope.translation.WEBMOB_device_washer_error_title_cc;
            case "UB":
                return $scope.translation.WEBMOB_device_washer_error_title_ub;
            case "8C":
                return $scope.translation.WEBMOB_device_washer_error_title_8c;
            case "PC":
                return $scope.translation.WEBMOB_device_washer_error_title_pc;
            case "OC":
                return $scope.translation.WEBMOB_device_washer_error_title_oc;
            case "6C":
            case "6C1":
            case "6C2":
            case "6C3":
            case "6C4":
            case "6C5":
            case "6C6":
            case "6C7":
                return $scope.translation.WEBMOB_device_washer_error_title_6c;
            case "8C1":
                return $scope.translation.WEBMOB_device_washer_error_title_8c;
            case "8C2":
                return $scope.translation.WEBMOB_device_washer_error_title_8c;
            case "SDC":
                return $scope.translation.WEBMOB_device_washer_error_title_sdc;
            case "AC3":
                return $scope.translation.WEBMOB_device_washer_error_title_ac3;
            case "AC4":
                return $scope.translation.WEBMOB_device_washer_error_title_ac4;
            case "AC5":
                return $scope.translation.WEBMOB_device_washer_error_title_ac5;
            case "AC6":
                return $scope.translation.WEBMOB_device_washer_error_title_ac6;
            case "TC4":
                return $scope.translation.WEBMOB_device_washer_error_title_tc4;
            case "4C3":
                return $scope.translation.WEBMOB_device_washer_error_title_4c3;
            case "DDC":
                return $scope.translation.WEBMOB_device_washer_error_title_ddc;
            case "DC3":
                return $scope.translation.WEBMOB_device_washer_error_title_dc3;
            case "AC7":
                return $scope.translation.WEBMOB_device_washer_error_title_ac7;
            case "DC4":
                return $scope.translation.WEBMOB_device_washer_error_title_dc4;
            default:
                break;
        }
        return "Unknown";
    }

    function getErrorMessage(errorEnum) {
        debugMessage("Error code is 11111111111:::::::::::::::::::::" + errorEnum);
        errorEnum = errorEnum.toUpperCase();
        switch (errorEnum) {
            case '1E':
                return $scope.translation.WEBMOB_device_washer_error_message_1e_result;
            case 'tE':
                return $scope.translation.WEBMOB_device_washer_error_message_te1_result;
            case 'tE1':
                return $scope.translation.WEBMOB_device_washer_error_message_te1_result;
            case 'TE':
                return $scope.translation.WEBMOB_device_washer_error_message_te1_result;
            case 'TE1':
                return $scope.translation.WEBMOB_device_washer_error_message_te1_result;
            case 'TE2':
                return $scope.translation.WEBMOB_device_washer_error_message_te2_result;
            case 'TE3':
                return $scope.translation.WEBMOB_device_washer_error_message_te3_result;
            case '3E':
                return $scope.translation.WEBMOB_device_washer_error_message_3e1_result;
            case '3E1':
                return $scope.translation.WEBMOB_device_washer_error_message_3e1_result;
            case '3E2':
                return $scope.translation.WEBMOB_device_washer_error_message_3e2_result;
            case '3E3':
                return $scope.translation.WEBMOB_device_washer_error_message_3e3_result;
            case '3E4':
                return $scope.translation.WEBMOB_device_washer_error_message_3e4_result;
            case 'BE':
                return $scope.translation.WEBMOB_device_washer_error_message_be_result;
            case '2E':
                return $scope.translation.WEBMOB_device_washer_error_message_9e1_result;
            case 'UC':
                return $scope.translation.WEBMOB_device_washer_error_message_9e1_result;
            case '9E1':
                return $scope.translation.WEBMOB_device_washer_error_message_9e1_result;
            case '9E2':
                return $scope.translation.WEBMOB_device_washer_error_message_9e2_result;
            case 'E2':
                return $scope.translation.WEBMOB_device_washer_error_message_be2_result;
            case 'BE2':
                return $scope.translation.WEBMOB_device_washer_error_message_be2_result;
            case 'bE2':
                return $scope.translation.WEBMOB_device_washer_error_message_be2_result;
            case 'dS':
                return $scope.translation.WEBMOB_device_washer_error_message_de_result;
            case 'DS':
                return $scope.translation.WEBMOB_device_washer_error_message_de_result;
            case 'dE':
                return $scope.translation.WEBMOB_device_washer_error_message_de_result;
            case 'LO':
                return $scope.translation.WEBMOB_device_washer_error_message_de1_result;
            case 'DE':
                return $scope.translation.WEBMOB_device_washer_error_message_de_result;
            case 'dE1':
                return $scope.translation.WEBMOB_device_washer_error_message_de1_result;
            case 'DE1':
                return $scope.translation.WEBMOB_device_washer_error_message_de1_result;
            case 'dE2':
                return $scope.translation.WEBMOB_device_washer_error_message_de2_result;
            case 'dF':
            case 'dF2':
            case 'DE2':
                return $scope.translation.WEBMOB_device_washer_error_message_de2_result;
            case 'DF':
                return $scope.translation.WEBMOB_device_washer_error_message_df_result;
            case 'AE':
                return $scope.translation.WEBMOB_device_washer_error_message_ae_result;
            case 'LE':
                return $scope.translation.WEBMOB_device_washer_error_message_le_result;
            case 'FE':
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_message_efe_result;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_message_fe_result;
                }
                break;
            case '4E':
                return $scope.translation.WEBMOB_device_washer_error_message_4e_result;
            case '4E2':
                return $scope.translation.WEBMOB_device_washer_error_message_4e2_result;
            case '5E':
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_message_5e_dry_result;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_message_5e_result;
                }
                break;
            case 'nd':
                return $scope.translation.WEBMOB_device_washer_error_message_5e_result;
            case 'Hr':
                return $scope.translation.WEBMOB_device_washer_error_message_he_result;
            case 'HE':
                return $scope.translation.WEBMOB_device_washer_error_message_he_result;
            case 'HE1':
                return $scope.translation.WEBMOB_device_washer_error_message_he1_result;
            case 'HE2':
                return $scope.translation.WEBMOB_device_washer_error_message_he2_result;
            case 'CE':
                return $scope.translation.WEBMOB_device_washer_error_message_ce_result;
            case 'UE':
                return $scope.translation.WEBMOB_device_washer_error_message_ue_result;
            case 'dc':
                return $scope.translation.WEBMOB_device_washer_error_message_ue_result;
            case '8E':
                return $scope.translation.WEBMOB_device_washer_error_message_8e_result;
            case 'PE':
                return $scope.translation.WEBMOB_device_washer_error_message_pe_result;
            case 'NF':
                return $scope.translation.WEBMOB_device_washer_error_message_4e_result;
            case 'NF1':
                return $scope.translation.WEBMOB_device_washer_error_message_4e2_result;
            case 'OE':
                return $scope.translation.WEBMOB_device_washer_error_message_oe_result;
            case 'oF':
                return $scope.translation.WEBMOB_device_washer_error_message_oe_result;
            case '4E1':
                return $scope.translation.WEBMOB_device_washer_error_message_4e_result;
            case '8E1':
                return $scope.translation.WEBMOB_device_washer_error_message_8e_result;
            case '8E2':
                return $scope.translation.WEBMOB_device_washer_error_message_8e_result;
            case 'OF':
                return $scope.translation.WEBMOB_device_washer_error_message_oe_result;
            case 'SDE':
                return $scope.translation.WEBMOB_device_washer_error_message_sde_result;
            case 'tE2':
                return $scope.translation.WEBMOB_device_washer_error_message_te2_result;
            case '6E':
                return $scope.translation.WEBMOB_device_washer_error_message_6e_result;
            case 'AE3':
                return $scope.translation.WEBMOB_device_washer_error_message_ae3_result;
            case 'AE4':
                return $scope.translation.WEBMOB_device_washer_error_message_ae4_result;
            case 'AE5':
                return $scope.translation.WEBMOB_device_washer_error_message_ae5_result;
            case 'AE6':
                return $scope.translation.WEBMOB_device_washer_error_message_ae6_result;
            case 'TE4':
                return $scope.translation.WEBMOB_device_washer_error_message_te4_result;
            case '4E3':
                return $scope.translation.WEBMOB_device_washer_error_message_4e3_result;
            case 'FL':
                return $scope.translation.WEBMOB_device_washer_error_message_de1_result;
            case 'LE1':
                return $scope.translation.WEBMOB_device_washer_error_message_le1_result;
            case 'TE5':
            case 'TC5':
                return $scope.translation.WEBMOB_device_washer_error_message_te5_result;
            case '1C':
                return $scope.translation.WEBMOB_device_washer_error_message_1c_result;
            case 'tC':
                return $scope.translation.WEBMOB_device_washer_error_message_tc1_result;
            case 'tC1':
                return $scope.translation.WEBMOB_device_washer_error_message_tc1_result;
            case 'TC':
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_message_tc2_result;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_message_tc1_result;
                }
                break;
            case 'TC1':
                return $scope.translation.WEBMOB_device_washer_error_message_tc1_result;
            case 'TC2':
                return $scope.translation.WEBMOB_device_washer_error_message_tc2_result;
            case 'TC3':
                return $scope.translation.WEBMOB_device_washer_error_message_tc3_result;
            case '3C':
            case '3C1':
                return $scope.translation.WEBMOB_device_washer_error_message_3c1_result;
            case '3C2':
                return $scope.translation.WEBMOB_device_washer_error_message_3c2_result;
            case '3C3':
                return $scope.translation.WEBMOB_device_washer_error_message_3c3_result;
            case '3C4':
                return $scope.translation.WEBMOB_device_washer_error_message_3c4_result;
            case '3C5':
            case '3C6':
            case '3C7':
            case '3C8':
            case '3C9':
                return $scope.translation.WEBMOB_device_washer_error_message_3c1_result;
            case 'BC':
                return $scope.translation.WEBMOB_device_washer_error_message_bc_result;
            case '9C1':
            case '2C':
                return $scope.translation.WEBMOB_device_washer_error_message_9c1_result;
            case '9C2':
                return $scope.translation.WEBMOB_device_washer_error_message_9c2_result;
            case 'C2':
            case 'BC2':
                return $scope.translation.WEBMOB_device_washer_error_message_bc2_result;
            case 'dC':
                return $scope.translation.WEBMOB_device_washer_error_message_dc_result;
            case 'DC':
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_message_dc_dry_result;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_message_dc_result;
                }
                break;
            case 'dC1':
                return $scope.translation.WEBMOB_device_washer_error_message_dc1_result;
            case 'DC1':
                return $scope.translation.WEBMOB_device_washer_error_message_dc1_result;
            case 'dC2':
                return $scope.translation.WEBMOB_device_washer_error_message_dc2_result;
            case 'DC2':
                return $scope.translation.WEBMOB_device_washer_error_message_dc2_result;
            case 'AC':
                return $scope.translation.WEBMOB_device_washer_error_message_ac_result;
            case 'LC':
                return $scope.translation.WEBMOB_device_washer_error_message_lc_result;
            case 'LC1':
                return $scope.translation.WEBMOB_device_washer_error_message_lc1_result;
            case 'FC':
            case 'FC3':
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_message_efe_result;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_message_fc_result;
                }
                break;
            case '4C':
            case '4C1':
                return $scope.translation.WEBMOB_device_washer_error_message_4c_result;
            case '4C2':
                return $scope.translation.WEBMOB_device_washer_error_message_4c2_result;
            case '5C':
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_message_5e_dry_result;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_message_5c_result;
                }
                break;
            case 'HC':
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_message_hc_dry_result;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_message_hc_result;
                }
                break;
            case 'HC1':
                return $scope.translation.WEBMOB_device_washer_error_message_hc1_result;
            case 'HC2':
                return $scope.translation.WEBMOB_device_washer_error_message_hc2_result;
            case 'CC':
                return $scope.translation.WEBMOB_device_washer_error_message_cc_result;
            case 'UB':
                return $scope.translation.WEBMOB_device_washer_error_message_ub_result;
            case '8C':
                return $scope.translation.WEBMOB_device_washer_error_message_8c_result;
            case 'PC':
                return $scope.translation.WEBMOB_device_washer_error_message_pc_result;
            case 'OC':
                return $scope.translation.WEBMOB_device_washer_error_message_oc_result;
            case '6C':
            case '6C1':
            case '6C2':
            case '6C3':
            case '6C4':
            case '6C5':
            case '6C6':
            case '6C7':
                return $scope.translation.WEBMOB_device_washer_error_message_6c_result;
            case '8C1':
                return $scope.translation.WEBMOB_device_washer_error_message_8c_result;
            case '8C2':
                return $scope.translation.WEBMOB_device_washer_error_message_8c_result;
            case 'SDC':
                return $scope.translation.WEBMOB_device_washer_error_message_sdc_result;
            case 'AC3':
                return $scope.translation.WEBMOB_device_washer_error_message_ac3_result;
            case 'AC4':
                return $scope.translation.WEBMOB_device_washer_error_message_ac4_result;
            case 'AC5':
                return $scope.translation.WEBMOB_device_washer_error_message_ac5_result;
            case 'AC6':
                return $scope.translation.WEBMOB_device_washer_error_message_ac6_result;
            case 'TC4':
                return $scope.translation.WEBMOB_device_washer_error_message_tc4_result;
            case '4C3':
                return $scope.translation.WEBMOB_device_washer_error_message_4c3_result;
            case 'DDC':
                return $scope.translation.WEBMOB_device_washer_error_message_ddc_result;
            case 'DC3':
                return $scope.translation.WEBMOB_device_washer_error_message_dc3_result;
            case "AC7":
                return $scope.translation.WEBMOB_device_washer_error_message_ac7_result;
            case "DC4":
                return $scope.translation.WEBMOB_device_washer_error_message_dc4_result;
            default:
                break;
        }
        return "Unknown";
    }

    function getErrorAction(errorEnum) {
        debugMessage("Error code is 2222222222:::::::::::::::::::::" + errorEnum);
        errorEnum = errorEnum.toUpperCase();
        switch (errorEnum) {
            case '1E':
                return $scope.translation.WEBMOB_device_washer_error_message_1e_action;
            case 'tE':
                return $scope.translation.WEBMOB_device_washer_error_message_te1_action;
            case 'tE1':
                return $scope.translation.WEBMOB_device_washer_error_message_te1_action;
            case 'TE':
                return $scope.translation.WEBMOB_device_washer_error_message_te1_action;
            case 'TE1':
                return $scope.translation.WEBMOB_device_washer_error_message_te1_action;
            case 'TE2':
                return $scope.translation.WEBMOB_device_washer_error_message_te2_action;
            case 'TE3':
                return $scope.translation.WEBMOB_device_washer_error_message_te3_action;
            case '3E':
                return $scope.translation.WEBMOB_device_washer_error_message_3e1_action;
            case '3E1':
                return $scope.translation.WEBMOB_device_washer_error_message_3e1_action;
            case '3E2':
                return $scope.translation.WEBMOB_device_washer_error_message_3e2_action;
            case '3E3':
                return $scope.translation.WEBMOB_device_washer_error_message_3e3_action;
            case '3E4':
                return $scope.translation.WEBMOB_device_washer_error_message_3e4_action;
            case 'BE':
                return $scope.translation.WEBMOB_device_washer_error_message_be_action;
            case '2E':
                return $scope.translation.WEBMOB_device_washer_error_message_9e1_action;
            case 'UC':
                return $scope.translation.WEBMOB_device_washer_error_message_9e1_action;
            case '9E1':
                return $scope.translation.WEBMOB_device_washer_error_message_9e1_action;
            case '9E2':
                return $scope.translation.WEBMOB_device_washer_error_message_9e2_action;
            case 'E2':
                return $scope.translation.WEBMOB_device_washer_error_message_be2_action;
            case 'BE2':
                return $scope.translation.WEBMOB_device_washer_error_message_be2_action;
            case 'bE2':
                return $scope.translation.WEBMOB_device_washer_error_message_be2_action;
            case 'dS':
                return $scope.translation.WEBMOB_device_washer_error_message_de_action;
            case 'DS':
                return $scope.translation.WEBMOB_device_washer_error_message_de_action;
            case 'dE':
                return $scope.translation.WEBMOB_device_washer_error_message_de_action;
            case 'LO':
                return $scope.translation.WEBMOB_device_washer_error_message_de1_action;
            case 'DE':
                return $scope.translation.WEBMOB_device_washer_error_message_de_action;
            case 'dE1':
                return $scope.translation.WEBMOB_device_washer_error_message_de1_action;
            case 'DE1':
                return $scope.translation.WEBMOB_device_washer_error_message_de1_action;
            case 'dE2':
                return $scope.translation.WEBMOB_device_washer_error_message_de2_action;
            case 'dF':
            case 'dF2':
            case 'DE2':
                return $scope.translation.WEBMOB_device_washer_error_message_de2_action;
            case 'DF':
                return $scope.translation.WEBMOB_device_washer_error_message_df_action;
            case 'AE':
                return $scope.translation.WEBMOB_device_washer_error_message_ae_action;
            case 'LE':
                return $scope.translation.WEBMOB_device_washer_error_message_le_action;
            case 'FE':
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_message_efe_action;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_message_fe_action;
                }
                break;
            case '4E':
                return $scope.translation.WEBMOB_device_washer_error_message_4e_action;
            case '4E2':
                return $scope.translation.WEBMOB_device_washer_error_message_4e2_action;
            case '5E':
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_message_5e_dry_action;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_message_5e_action;
                }
                break;
            case 'nd':
                return $scope.translation.WEBMOB_device_washer_error_message_5e_action;
            case 'Hr':
                return $scope.translation.WEBMOB_device_washer_error_message_he_action;
            case 'HE':
                return $scope.translation.WEBMOB_device_washer_error_message_he_action;
            case 'HE1':
                return $scope.translation.WEBMOB_device_washer_error_message_he1_action;
            case 'HE2':
                return $scope.translation.WEBMOB_device_washer_error_message_he2_action;
            case 'CE':
                return $scope.translation.WEBMOB_device_washer_error_message_ce_action;
            case 'UE':
                return $scope.translation.WEBMOB_device_washer_error_message_ue_action;
            case 'dc':
                return $scope.translation.WEBMOB_device_washer_error_message_ue_action;
            case '8E':
                return $scope.translation.WEBMOB_device_washer_error_message_8e_action;
            case 'PE':
                return $scope.translation.WEBMOB_device_washer_error_message_pe_action;
            case 'NF':
                return $scope.translation.WEBMOB_device_washer_error_message_4e_action;
            case 'NF1':
                return $scope.translation.WEBMOB_device_washer_error_message_4e2_action;
            case 'OE':
                return $scope.translation.WEBMOB_device_washer_error_message_oe_action;
            case 'oF':
                return $scope.translation.WEBMOB_device_washer_error_message_oe_action;
            case '4E1':
                return $scope.translation.WEBMOB_device_washer_error_message_4e_action;
            case '8E1':
                return $scope.translation.WEBMOB_device_washer_error_message_8e_action;
            case '8E2':
                return $scope.translation.WEBMOB_device_washer_error_message_8e_action;
            case 'OF':
                return $scope.translation.WEBMOB_device_washer_error_message_oe_action;
            case 'SDE':
                return $scope.translation.WEBMOB_device_washer_error_message_sde_action;
            case 'tE2':
                return $scope.translation.WEBMOB_device_washer_error_message_te2_action;
            case '6E':
                return $scope.translation.WEBMOB_device_washer_error_message_6e_action;
            case 'AE3':
                return $scope.translation.WEBMOB_device_washer_error_message_ae3_action;
            case 'AE4':
                return $scope.translation.WEBMOB_device_washer_error_message_ae4_action;
            case 'AE5':
                return $scope.translation.WEBMOB_device_washer_error_message_ae5_action;
            case 'AE6':
                return $scope.translation.WEBMOB_device_washer_error_message_ae6_action;
            case 'TE4':
                return $scope.translation.WEBMOB_device_washer_error_message_te4_action;
            case '4E3':
                return $scope.translation.WEBMOB_device_washer_error_message_4e3_action;
            case 'FL':
                return $scope.translation.WEBMOB_device_washer_error_message_de1_action;
            case 'LE1':
                return $scope.translation.WEBMOB_device_washer_error_message_le1_action;
            case 'TE5':
            case 'TC5':
                return $scope.translation.WEBMOB_device_washer_error_message_te5_action;
            case '1C':
                return $scope.translation.WEBMOB_device_washer_error_message_1e_action;
            case 'tC':
                return $scope.translation.WEBMOB_device_washer_error_message_te1_action;
            case 'tC1':
                return $scope.translation.WEBMOB_device_washer_error_message_te1_action;
            case 'TC':
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_message_te2_action;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_message_te1_action;
                }
                break;
            case 'TC1':
                return $scope.translation.WEBMOB_device_washer_error_message_te1_action;
            case 'TC2':
                return $scope.translation.WEBMOB_device_washer_error_message_te2_action;
            case 'TC3':
                return $scope.translation.WEBMOB_device_washer_error_message_te3_action;
            case '3C':
            case '3C1':
            case '3C2':
            case '3C3':
            case '3C4':
            case '3C5':
            case '3C6':
            case '3C7':
            case '3C8':
            case '3C9':
                return $scope.translation.WEBMOB_device_washer_error_message_3c1_action;
            case 'BC':
                return $scope.translation.WEBMOB_device_washer_error_message_bc_action;
            case '9C1':
            case '2C':
                return $scope.translation.WEBMOB_device_washer_error_message_9e1_action;
            case '9C2':
                return $scope.translation.WEBMOB_device_washer_error_message_9e2_action;
            case 'BC2':
            case 'C2':
                return $scope.translation.WEBMOB_device_washer_error_message_be2_action;
            case 'dC':
                return $scope.translation.WEBMOB_device_washer_error_message_de_action;
            case 'DC':
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_message_dc_dry_action;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_message_de_action;
                }
                break;
            case 'dC1':
                return $scope.translation.WEBMOB_device_washer_error_message_de1_action;
            case 'DC1':
                return $scope.translation.WEBMOB_device_washer_error_message_de1_action;
            case 'dC2':
                return $scope.translation.WEBMOB_device_washer_error_message_de2_action;
            case 'DC2':
                return $scope.translation.WEBMOB_device_washer_error_message_de2_action;
            case 'AC':
                return $scope.translation.WEBMOB_device_washer_error_message_ae_action;
            case 'LC':
                return $scope.translation.WEBMOB_device_washer_error_message_lc_action;
            case 'LC1':
                return $scope.translation.WEBMOB_device_washer_error_message_lc1_action;
            case 'FC':
            case 'FC3':
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_message_efe_action;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_message_fe_action;
                }
                break;
            case '4C':
            case '4C1':
                return $scope.translation.WEBMOB_device_washer_error_message_4e_action;
            case '4C2':
                return $scope.translation.WEBMOB_device_washer_error_message_4e2_action;
            case '5C':
            	if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_message_5e_dry_action;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_message_5e_action;
                }
                break;
            case 'HC':
                if ($scope.deviceType === "Dryer") {
                    return $scope.translation.WEBMOB_device_washer_error_message_hc_dry_action;
                } else {
                    return $scope.translation.WEBMOB_device_washer_error_message_hc_action;
                }
                break;
            case 'HC1':
                return $scope.translation.WEBMOB_device_washer_error_message_he1_action;
            case 'HC2':
                return $scope.translation.WEBMOB_device_washer_error_message_he2_action;
            case 'CC':
                return $scope.translation.WEBMOB_device_washer_error_message_ce_action;
            case 'UB':
                return $scope.translation.WEBMOB_device_washer_error_message_ue_action;
            case '8C':
                return $scope.translation.WEBMOB_device_washer_error_message_8e_action;
            case 'PC':
                return $scope.translation.WEBMOB_device_washer_error_message_pe_action;
            case 'OC':
                return $scope.translation.WEBMOB_device_washer_error_message_oe_action;
            case '6C':
            case '6C1':
            case '6C2':
            case '6C3':
            case '6C4':
            case '6C5':
            case '6C6':
            case '6C7':
                return $scope.translation.WEBMOB_device_washer_error_message_6c_action;
            case '8C1':
                return $scope.translation.WEBMOB_device_washer_error_message_8e_action;
            case '8C2':
                return $scope.translation.WEBMOB_device_washer_error_message_8e_action;
            case 'SDC':
                return $scope.translation.WEBMOB_device_washer_error_message_sde_action;
            case 'AC3':
                return $scope.translation.WEBMOB_device_washer_error_message_ae3_action;
            case 'AC4':
                return $scope.translation.WEBMOB_device_washer_error_message_ae4_action;
            case 'AC5':
                return $scope.translation.WEBMOB_device_washer_error_message_ae5_action;
            case 'AC6':
                return $scope.translation.WEBMOB_device_washer_error_message_ac6_action;
            case 'TC4':
                return $scope.translation.WEBMOB_device_washer_error_message_te4_action;
            case '4C3':
                return $scope.translation.WEBMOB_device_washer_error_message_4c3_action;
            case 'DDC':
                return $scope.translation.WEBMOB_device_washer_error_message_ddc_action;
            case 'DC3':
                return $scope.translation.WEBMOB_device_washer_error_message_dc3_action;
            case "AC7":
                return $scope.translation.WEBMOB_device_washer_error_message_ac7_action;
            case "DC4":
                return $scope.translation.WEBMOB_device_washer_error_message_dc4_action;
            default:
                break;
        }
        return "Unknown";
    }

    function openErrorTextArray(errordemoString) {
        var alarmtxt = errordemoString;
        $scope.serviceCenterNumber = "123456789";
        if (alarmtxt.indexOf("_") > -1) {
            alarmtxt = alarmtxt.split("_");
            alarmtxt = alarmtxt[5].toLowerCase();
            if (alarmtxt === 'efe') {
                alarmtxt = 'fc';
            }
            errorDemoPage = true;
        } else {
            chatErrorPage = true;
        }
        debugMessage("alarm text is ::" + alarmtxt);
        debugMessage("alarm text is ::" + getErrorTitle(alarmtxt) + ":::" + getErrorMessage(alarmtxt) + ":::" + getErrorAction(alarmtxt));
        if (isDeviceUpdateRequired($scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER ? 1 : 0)) {
            $scope.errorTitle = getErrorTitle(alarmtxt);
        }
        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
            $scope.errorTitleMain = getErrorTitle(alarmtxt);
        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
            $scope.errorTitleSub = getErrorTitle(alarmtxt);
        } else {
            ;//Nothing
        }
        $scope.errorResult = getErrorMessage(alarmtxt);
        $scope.errorAction = getErrorAction(alarmtxt);
        if (!$scope.isDualDryer) {
            $scope.currentScreen = WASHERSCREENS.ALARMSCREEN;
            $scope.changeScreen();
        }

    }

    function goToEnergyMonitor() {
        if ((!$scope.isStatic) && (!$scope.isDBDownloaded)) {
            return;
        }
        EnergyService.goToEnergyMonitor($scope);
        toggleAnimClass();
        $timeout(function () {
            toggleAnimClass();
            $scope.currentScreen = WASHERSCREENS.ENERGYMONITOR;
            $scope.changeScreen();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }

    function showDailyData() {
        EnergyService.showDailyData($scope);
    }

    function showWeeklyData() {
        EnergyService.showWeeklyData($scope);
    }

    function showMonthlyData() {
        EnergyService.showMonthlyData($scope);
    }

    function showYearlyData() {
        EnergyService.showYearlyData($scope);
    }

    function showNextDaysData() {
        EnergyService.showNextDaysData($scope);
    }

    function showPreviousDaysData() {
        EnergyService.showPreviousDaysData($scope);
    }

    function fetchDBfromDevice() {
        if (!$scope.isStatic) {
            nativeInterface.getResourceUrl("/" + $scope.peerId + $scope.energyMonitorLocation);
        }
    }

    function isEnergyReset() {
        return true;
    }

    function isEnergyResetDisabled() {
        return (!$scope.remoteControlEnabled || $scope.kidsLock);
    }

    function parseEnergyUsageData(energyResponse) {
        EnergyService.parseEnergyUsageData($scope, energyResponse);
    }

    function handleEnergyMonitorErrors() {
        debugMessage("No data in energy usage::");
    }

    function sendResetCommand() {
        if ($scope.isGasDryer) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_common_device_dryer,
                msg: $scope.translation.WEBMOB_device_washer_alarm_dry_only_monitoring,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    $scope.onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }
        if ($scope.kidsLock) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_device_washer_alarm_child_lock_title,
                msg: $scope.translation.WEBMOB_device_washer_alarm_child_lock_message,
                btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_ok_CL,
                btnOkHandler: function () {
                    $scope.onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }
        if (!$scope.remoteControlEnabled) {
            $scope.errorList.push({
                title: $scope.translation.WEBMOB_device_washer_alarm_smart_control,
                msg: $scope.translation.WEBMOB_device_washer_alarm_smart_control_dryer_msg,
                btnOkTxt: $scope.translation.WEBMOB_commWEBMOB_device_washer_comm_ok_CLon_ok,
                btnOkHandler: function () {
                    $scope.onOkClicked(true);
                },
                closeDialog: !true
            });
            changePopUpClass(true);
            return;
        }
        if (!$scope.isStatic) {
            var washerId = 0;
            if ($scope.isDualDryer && $scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
                washerId = 1
            }
            SHPService.sendSHPCommand(CONSTANTS.PUT, getResetCommand(), "/" + $scope.peerId + "/devices/" + washerId);
        }
    }

    function getResetCommand() {
        return '{"Device":{"Mode":{"options":["UsagesDB_reset"]}}}';
    }

    function showOptionPopUp() {
        $scope.bOptionPopUp = true;
    }

    function closeOptionPopUp() {
        $scope.bOptionPopUp = false;
        changePopUpClass($scope.bOptionPopUp);
    }

    function selectIndexFromOptionMenu(optionMenuindex) {
        switch (optionMenuindex) {
            case 0:
                settings();
                break;
            case 1:
                options();
                break;
            case 2:
                $scope.alertState = DRYERALERT.RESETENERGY;
                $scope.errorList.push({
                    msg: $scope.translation.WEBMOB_common_energy_monitor_reset_history_confirm,
                    btnOkTxt: $scope.translation.WEBMOB_device_washer_comm_yes_CL,
                    btnOkHandler: function () {
                        onOkClicked(true);
                    },
                    btnCancelTxt: $scope.translation.WEBMOB_device_washer_comm_no_CL,
                    btnCancelHandler: function () {
                        onOkClicked(false);
                    },
                    closeDialog: !true
                });
                changePopUpClass(true);
                $scope.cancelButtonPressed = false;
                break;
            case 3:
                $scope.isMultiSelectMode = true;
                $scope.bAllListSelected = false;
                break;
            default:
                break;
        }
        closeOptionPopUp();
    }

    function toggleSmartControlButton() {
//        if ($scope.cycFinish) {
//            return;
//        }

        if ($scope.remoteControlEnabled) {
            $scope.smartControlTitle = $scope.translation.WEBMOB_device_washer_alarm_smart_control_on;
            if ($scope.kidsLockByPass)
                $scope.smartControlDesc = $scope.translation.WEBMOB_device_washer_alarm_smart_control_on_17kidslock_msg;
            else
                $scope.smartControlDesc = $scope.translation.WEBMOB_device_washer_alarm_smart_control_on_washer_msg;
        } else {
            $scope.smartControlTitle = $scope.translation.WEBMOB_device_washer_alarm_smart_control_off;
            $scope.smartControlDesc = $scope.translation.WEBMOB_device_washer_alarm_smart_control_off_washer_msg;
        }
        $scope.samrtControlPopup = true;
        toggleBottomPopUpClass($scope.samrtControlPopup);
        changePopUpClass($scope.samrtControlPopup);
        hideInputBoxFocus();
    }

    function hideSmartControlOption() {
        debugMessage('hideSmartControlOption');
        $scope.samrtControlPopup = false;
        changePopUpClass($scope.samrtControlPopup);
    }

    function hideInputBoxFocus() {
        stopLongPressEvent();
    }

    function stopLongPressEvent() {
        if (!!promise) {
            $interval.cancel(promise);
            promise = undefined;
        }
        if ($scope.longPress) {
            $scope.longPress = false;
            clearInterval($scope.timer);
            return;
        }
    }

    function showDetailPage(val) {
        if (val === 0) {
            $scope.showFavOnDeviceStatus = $scope.deviceStatus;
            if ($scope.isDualDryer) {
                dualDeviceId = 0;   // For Energy monitor
                $scope.currentWasherSelected = WASHERCURRENTSEL.MAIN_SELECTED;
                $scope.Device = jQuery.extend(true, {}, $scope.mainDryerData);
                $scope.cycFinish = $scope.cycFinishMain;
                $scope.isLaundryEnabled = $scope.isLaundryEnabledMain;
                $scope.listItemsModes = $scope.listItemsModesMain;
                $scope.washerToUpdate = WASHERTOUPDATE.MAINWASHER;
                parseDryerData($scope.mainDryerData, true);
                $scope.washerToUpdate = WASHERTOUPDATE.NONE;
                $scope.ampm = $scope.ampmMain;
                $scope.remHrs = $scope.remHrsMain;
                $scope.remMin = $scope.remMinMain;
                $scope.isTemp = $scope.isTempMain;
                $scope.onPause = $scope.onPauseMain;
                $scope.laundry = $scope.laundryMain;
                $scope.setTemp = $scope.setTempMain;
                $scope.current = $scope.currentMain;
                $scope.kidsLock = $scope.kidsLockMain;
                $scope.isDryTime = $scope.isDryTimeMain;
                $scope.wrinkleOn = $scope.wrinkleOnMain;
                $scope.isGasDryer = $scope.isGasDryerMain;
                $scope.hotwarning = $scope.hotwarningMain;
                $scope.isDrylevel = $scope.isDrylevelMain;
                $scope.setDryTime = $scope.setDryTimeMain;
                $scope.deviceMode = $scope.deviceModeMain;
                $scope.dispStatus = $scope.dispStatusMain;
                $scope.errorTitle = $scope.errorTitleMain;
                $scope.errorResult = $scope.errorResultMain;
                $scope.errorAction = $scope.errorActionMain;
                $scope.setDryLevel = $scope.setDryLevelMain;
                $scope.textDisplay = $scope.textDisplayMain;
                $scope.laundryOpt2 = $scope.laundryOpt2Main;
                $scope.laundryOpt3 = $scope.laundryOpt3Main;
                $scope.laundryOpt4 = $scope.laundryOpt4Main;
                $scope.progresshead = $scope.progressheadMain;
                $scope.setWrinkleOn = $scope.setWrinkleOnMain;
                $scope.deviceStatus = $scope.deviceStatusMain;
                $scope.statusDisplay = $scope.statusDisplayMain;
                $scope.progressStart = $scope.progressStartMain;
                $scope.remainingTime = $scope.remainingTimeMain;
                $scope.listItemsTemp = $scope.listItemsTempMain;
                $scope.laundrySwitch = $scope.laundrySwitchMain;
                $scope.estimationTime = $scope.estimationTimeMain;
                $scope.kidsLockByPass = $scope.kidsLockByPassMain;
                $scope.NoEnergyKW_396 = $scope.NoEnergyKW_396Main;
                $scope.disableContents = $scope.disableContentsMain;
                $scope.currentTempList = $scope.currentTempListMain;
                $scope.laundryOnOffText = $scope.laundryOnOffTextMain;
                $scope.listItemsDryTime = $scope.listItemsDryTimeMain;
                $scope.currentCourseEnum = $scope.currentCourseEnumMain;
                $scope.showFavOnDeviceStatus = $scope.deviceStatusMain;
                $scope.listItemsDryLevel = $scope.listItemsDryLevelMain;
                $scope.showMixedLoadBell = $scope.showMixedLoadBellMain;
                $scope.mixedLoadBellValue = $scope.mixedLoadBellValueMain;
                $scope.currentDryTimeList = $scope.currentDryTimeListMain;
                $scope.showEnergyLevelSet = $scope.showEnergyLevelSetMain;
                $scope.disabletempContents = $scope.disabletempContentsMain;
                $scope.currentDryLevelList = $scope.currentDryLevelListMain;
                $scope.wrinklePreventState = $scope.wrinklePreventStateMain;
                $scope.showSeamLessControl = $scope.showSeamLessControlMain;
                $scope.wrinklePreventdisable = $scope.wrinklePreventdisableMain;
                $scope.remoteControlEnabled = $scope.remoteControlEnabledMain;
                $scope.seamLessControlValue = $scope.seamLessControlValueMain;
                $scope.wrinklePreventStarted = $scope.wrinklePreventStartedMain;
                $scope.disabledrylevelContents = $scope.disabledrylevelContentsMain;
                $scope.smartControlOnOffText = $scope.remoteControlEnabled ? $scope.translation.WEBMOB_device_washer_comm_on_CL : $scope.translation.WEBMOB_device_washer_comm_off_CL;
                $scope.laundryDescText = $scope.translation.WEBMOB_device_washer_laundryout_desc_dryer;

                tempLaundryVal = tempLaundryValMain;
                currentLaundryVal = currentLaundryValMain;
                currentRunItem = currentRunItemMain;
                deviceSetTemp = deviceSetTempMain;
                deviceSetDryLevel = deviceSetDryLevelMain;
                $scope.mixedLoadBellSetValue = $scope.mixedLoadBellSetValueMain;

                if (!$scope.wrinklePreventStarted) {
                    document.getElementById("innercirclebutton").style.display = "initial";
                } else {
                    document.getElementById("innercirclebutton").style.display = "none";
                }
                $scope.disableLaundry = $scope.disableLaundryMain;
                if ($scope.mainDryerData.Operation.state === 'Ready') {
                    $scope.disableLaundry = false;
                    $scope.disableLaundryMain = false;
                }
                if ($scope.isErrorMain) {
//                    if ($scope.currentScreen !== WASHERSCREENS.ALARMSCREEN) {
//                        $scope.previousScreenError = $scope.currentScreen;
//                    }
                    $scope.currentScreen = WASHERSCREENS.ALARMSCREEN;
                    changeScreen();
                    return;
                }
            }
        } else {
            $scope.showFavOnDeviceStatus = $scope.deviceStatus;
            if ($scope.isDualDryer) {
                dualDeviceId = 1;   // For Energy monitor
                $scope.currentWasherSelected = WASHERCURRENTSEL.SUB_SELECTED;
                $scope.Device = jQuery.extend(true, {}, $scope.subDryerData);
                $scope.cycFinish = $scope.cycFinishSub;
                $scope.isLaundryEnabled = $scope.isLaundryEnabledSub;
                $scope.listItemsModes = $scope.listItemsModesSub;
                $scope.washerToUpdate = WASHERTOUPDATE.SUBWASHER;
                parseDryerData($scope.subDryerData, true);
                $scope.washerToUpdate = WASHERTOUPDATE.NONE;
                $scope.ampm = $scope.ampmSub;
                $scope.isTemp = $scope.isTempSub;
                $scope.remHrs = $scope.remHrsSub;
                $scope.remMin = $scope.remMinSub;
                $scope.onPause = $scope.onPauseSub;
                $scope.setTemp = $scope.setTempSub;
                $scope.laundry = $scope.laundrySub;
                $scope.current = $scope.currentSub;
                $scope.kidsLock = $scope.kidsLockSub;
                $scope.isDryTime = $scope.isDryTimeSub;
                $scope.wrinkleOn = $scope.wrinkleOnSub;
                $scope.dispStatus = $scope.dispStatusSub;
                $scope.isDrylevel = $scope.isDrylevelSub;
                $scope.setDryTime = $scope.setDryTimeSub;
                $scope.isGasDryer = $scope.isGasDryerSub;
                $scope.hotwarning = $scope.hotwarningSub;
                $scope.deviceMode = $scope.deviceModeSub;
                $scope.errorTitle = $scope.errorTitleSub;
                $scope.errorResult = $scope.errorResultSub;
                $scope.errorAction = $scope.errorActionSub;
                $scope.textDisplay = $scope.textDisplaySub;
                $scope.setDryLevel = $scope.setDryLevelSub;
                $scope.laundryOpt2 = $scope.laundryOpt2Sub;
                $scope.laundryOpt3 = $scope.laundryOpt3Sub;
                $scope.laundryOpt4 = $scope.laundryOpt4Sub;
                $scope.deviceStatus = $scope.deviceStatusSub;
                $scope.progresshead = $scope.progressheadSub;
                $scope.setWrinkleOn = $scope.setWrinkleOnSub;
                $scope.statusDisplay = $scope.statusDisplaySub;
                $scope.listItemsTemp = $scope.listItemsTempSub;
                $scope.progressStart = $scope.progressStartSub;
                $scope.laundrySwitch = $scope.laundrySwitchSub;
                $scope.remainingTime = $scope.remainingTimeSub;
                $scope.estimationTime = $scope.estimationTimeSub;
                $scope.kidsLockByPass = $scope.kidsLockByPassSub;
                $scope.NoEnergyKW_396 = $scope.NoEnergyKW_396Sub;
                $scope.disableContents = $scope.disableContentsSub;
                $scope.currentTempList = $scope.currentTempListSub;
                $scope.laundryOnOffText = $scope.laundryOnOffTextSub;
                $scope.listItemsDryTime = $scope.listItemsDryTimeSub;
                $scope.showFavOnDeviceStatus = $scope.deviceStatusSub;
                $scope.listItemsDryLevel = $scope.listItemsDryLevelSub;
                $scope.showMixedLoadBell = $scope.showMixedLoadBellSub;
                $scope.currentCourseEnum = $scope.currentCourseEnumSub;
                $scope.currentDryTimeList = $scope.currentDryTimeListSub;
                $scope.showEnergyLevelSet = $scope.showEnergyLevelSetSub;
                $scope.mixedLoadBellValue = $scope.mixedLoadBellValueSub;
                $scope.disabletempContents = $scope.disabletempContentsSub;
                $scope.currentDryLevelList = $scope.currentDryLevelListSub;
                $scope.showSeamLessControl = $scope.showSeamLessControlSub;
                $scope.wrinklePreventState = $scope.wrinklePreventStateSub;
                $scope.seamLessControlValue = $scope.seamLessControlValueSub;
                $scope.wrinklePreventdisable = $scope.wrinklePreventdisableSub;
                $scope.remoteControlEnabled = $scope.remoteControlEnabledSub;
                $scope.wrinklePreventStarted = $scope.wrinklePreventStartedSub;
                $scope.disabledrylevelContents = $scope.disabledrylevelContentsSub;
                $scope.smartControlOnOffText = $scope.remoteControlEnabled ? $scope.translation.WEBMOB_device_washer_comm_on_CL : $scope.translation.WEBMOB_device_washer_comm_off_CL;
                $scope.laundryDescText = $scope.translation.WEBMOB_device_washer_laundryout_desc_top_loader;

                tempLaundryVal = tempLaundryValSub;
                currentLaundryVal = currentLaundryValSub;
                currentRunItem = currentRunItemSub;
                deviceSetTemp = deviceSetTempSub;
                deviceSetDryLevel = deviceSetDryLevelSub;
                $scope.mixedLoadBellSetValue = $scope.mixedLoadBellSetValueSub;

                if (!$scope.wrinklePreventStarted) {
                    document.getElementById("innercirclebutton").style.display = "initial";
                } else {
                    document.getElementById("innercirclebutton").style.display = "none";
                }
                $scope.disableLaundry = $scope.disableLaundrySub;
                if ($scope.subDryerData.Operation.state === 'Ready') {
                    $scope.disableLaundry = false;
                    $scope.disableLaundrySub = false;
                }
                if ($scope.isErrorSub) {
//                    if ($scope.currentScreen !== WASHERSCREENS.ALARMSCREEN) {
//                        $scope.previousScreenError = $scope.currentScreen;
//                    }
                    $scope.currentScreen = WASHERSCREENS.ALARMSCREEN;
                    changeScreen();
                    return;
                }
            }
        }
        goToDetailPage();
    }

    function goToDetailPage() {
        $scope.currentScreen = WASHERSCREENS.DETAILPAGE;
        changeScreen();
        if ($scope.Device.id === "1") {
            var hasLaunchedBefore = getLocalStorageForFirstLaunch('firstTimeLaunchDetailPageTopLoad');
            if (!hasLaunchedBefore) {
                showUsageHelpPage();
            }
        } else if ($scope.Device.id === "0") {
            var hasLaunchedBefore = getLocalStorageForFirstLaunch('firstTimeLaunchDetailPageFrontLoad');
            if (!hasLaunchedBefore) {
                showUsageHelpPage();
            }
        } else {
            ;//Nothing
        }
    }

    function callTutorialURL() {
        $scope.onAboutAction('tutorial');
    }

    function retUpperCase(val) {
        return val.toUpperCase();
    }

    function callServiceIndexSelected(index) {
        $scope.callServiceIndex = index;
    }

    function isSpinnerActive() {
        if ($scope.disableContents || !$scope.remoteControlEnabled || $scope.kidsLock || $scope.cycFinish || $scope.isGasDryer) {
            return false;
        }
        return true;
    }

    function showOptionItemsVisible(index) {
        if ((($scope.homePage || $scope.detailPage) && index < 1) && ($scope.showSyncTime && (!$scope.showEnergyMonitorOption || $scope.isGasDryer))) {
            return false;
        }
        if (($scope.homePage || $scope.detailPage) && index < 2) {
            return true;
        }
        if (($scope.energyMonitorPage) && index === 2) {
            return true;
        }
        if (($scope.myFavoritePage) && index === 3) {
            return true;
        }
        return false;
    }

    function updateHomePageDataForDualDryer() {
        if ($scope.currentWasherSelected === WASHERCURRENTSEL.MAIN_SELECTED) {
            $scope.deviceStatusMain = $scope.deviceStatus;
            $scope.textDisplayMain = $scope.textDisplay;
            if ($scope.mainDryerData.Operation.state === 'Run' || $scope.mainDryerData.Operation.state === 'Pause') {
                $scope.currentCourseEnumMain = $scope.currentCourseEnum;
            }
            $scope.remoteControlEnabledMain = $scope.remoteControlEnabled;
            $scope.dispStatusMain = $scope.dispStatus;
            $scope.remHrsMain = $scope.remHrs;
            $scope.remMinMain = $scope.remMin;
            $scope.onPauseMain = $scope.onPause;
            $scope.progressStartMain = $scope.progressStart;
            $scope.progressheadMain = $scope.progresshead;
            $scope.statusDisplayMain = $scope.statusDisplay;
            $scope.isGasDryerMain = $scope.isGasDryer;
            $scope.currentMain = $scope.current;
            $scope.laundrySwitchMain = $scope.laundrySwitch;
            $scope.laundryOnOffTextMain = $scope.laundryOnOffText;
            $scope.laundryOpt2Main = $scope.laundryOpt2;
            $scope.laundryOpt3Main = $scope.laundryOpt3;
            $scope.laundryOpt4Main = $scope.laundryOpt4;
            $scope.wrinkleOnMain = $scope.wrinkleOn;
            $scope.wrinklePreventStateMain = $scope.wrinklePreventState;
            $scope.disableContentsMain = $scope.disableContents;
            $scope.setTempMain = $scope.setTemp;

            tempLaundryValMain = tempLaundryVal;
            currentLaundryValMain = currentLaundryVal;
        } else if ($scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
            $scope.deviceStatusSub = $scope.deviceStatus;
            $scope.textDisplaySub = $scope.textDisplay;
            if ($scope.subDryerData.Operation.state === 'Run' || $scope.subDryerData.Operation.state === 'Pause') {
                $scope.currentCourseEnumSub = $scope.currentCourseEnum;
            }
            $scope.remoteControlEnabledSub = $scope.remoteControlEnabled;
            $scope.dispStatusSub = $scope.dispStatus;
            $scope.remHrsSub = $scope.remHrs;
            $scope.remMinSub = $scope.remMin;
            $scope.onPauseSub = $scope.onPause;
            $scope.progressStartSub = $scope.progressStart;
            $scope.progressheadSub = $scope.progresshead;
            $scope.statusDisplaySub = $scope.statusDisplay;
            $scope.isGasDryerSub = $scope.isGasDryer;
            $scope.currentSub = $scope.current;
            $scope.laundrySwitchSub = $scope.laundrySwitch;
            $scope.laundryOnOffTextSub = $scope.laundryOnOffText;
            $scope.laundryOpt2Sub = $scope.laundryOpt2;
            $scope.laundryOpt3Sub = $scope.laundryOpt3;
            $scope.laundryOpt4Sub = $scope.laundryOpt4;
            $scope.wrinkleOnSub = $scope.wrinkleOn;
            $scope.wrinklePreventStateSub = $scope.wrinklePreventState;
            $scope.disableContentsSub = $scope.disableContents;
            $scope.setTempSub = $scope.setTemp;

            tempLaundryValSub = tempLaundryVal;
            currentLaundryValSub = currentLaundryVal;
        } else {
            ;//Nothing
        }
    }

    function isDeviceUpdateRequired(washerId) {
        if ($scope.isDualDryer === undefined || $scope.isDualDryer === false) {
            return true;
        }
        if ($scope.isDualDryer === true && $scope.homePage) {
            return true;
        }
        if ($scope.isDualDryer === true && !$scope.homePage && washerId === 0 && $scope.currentWasherSelected === WASHERCURRENTSEL.MAIN_SELECTED) {
            return true;
        }
        if ($scope.isDualDryer === true && !$scope.homePage && washerId === 1 && $scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
            return true;
        }
        return false;
    }

    function onMixedLoadBell() {
        if (!$scope.remoteControlEnabled || $scope.kidsLock || $scope.Device.Operation.state === 'Run' || $scope.Device.Operation.state === 'Pause') {
            return;
        }

        if (isMixedLoadDisabled()) {
            return;
        }
        $scope.mixedLoadBellValue = !$scope.mixedLoadBellValue;
//        var washerId = 0;
//        if ($scope.isDualDryer && $scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
//            washerId = 1
//        }
//        $scope.checkResponse.push(WASHER_COMMANDS.mixedLoadBell);
//        SHPService.sendSHPCommand(CONSTANTS.PUT, mixedLoadBellCommand(), "/" + $scope.peerId + "/devices/" + washerId);
    }

    function updateDisableMixedLoadStateForModes(MixedLoadBellSetData, washerSection) {
        //MixedLoadBellSetData = '03FF030303030303FFFFFFFF03FF';
        var len = MixedLoadBellSetData.length / 2;

        for (var i = 0; i < len; i++) {
            switch (washerSection) {
                case WASHERTOUPDATE.SINGLEWASHER:
                    $scope.listItemsModes[i].LevelValue = parseInt(MixedLoadBellSetData[i * 2 + 1], 16);
                    break;
                case WASHERTOUPDATE.MAINWASHER:
                    $scope.listItemsModesMain[i].LevelValue = parseInt(MixedLoadBellSetData[i * 2 + 1], 16);
                    break;
                case WASHERTOUPDATE.SUBWASHER:
                    $scope.listItemsModesSub[i].LevelValue = parseInt(MixedLoadBellSetData[i * 2 + 1], 16);
                    break;
                default:
                    $scope.listItemsModes[i].LevelValue = parseInt(MixedLoadBellSetData[i * 2 + 1], 16);
                    break;
            }
        }
    }

    function updateEnergyLevelSet(energyLevelSetData, washerSection) {
        //energyLevelSetData = '050303020102030302010203030201';
        var maxValue = parseInt(energyLevelSetData.substring(0, 2), 16);
        energyLevelSetData = energyLevelSetData.substring(2, energyLevelSetData.length);
        var len = energyLevelSetData.length / 2;

        for (var i = 0; i < len; i++) {
            switch (washerSection) {
                case WASHERTOUPDATE.SINGLEWASHER:
                    $scope.listItemsModes[i].energyLevelValue = [];
                    $scope.listItemsModes[i].maxEnergyLevelValue = maxValue;
                    var eLevel = parseInt(energyLevelSetData.substring(i * 2, i * 2 + 2), 16);
                    for (var j = 0; j < $scope.listItemsModes[i].maxEnergyLevelValue; j++) {
                        if (j <= eLevel - 1) {
                            $scope.listItemsModes[i].energyLevelValue.push({'enLevelValue': true});
                        } else {
                            $scope.listItemsModes[i].energyLevelValue.push({'enLevelValue': false});
                        }
                    }
                    break;
                case WASHERTOUPDATE.MAINWASHER:
                    $scope.listItemsModesMain[i].energyLevelValue = [];
                    $scope.listItemsModesMain[i].maxEnergyLevelValue = maxValue;
                    var eLevel = parseInt(energyLevelSetData.substring(i * 2, i * 2 + 2), 16);
                    for (var j = 0; j < $scope.listItemsModesMain[i].maxEnergyLevelValue; j++) {
                        if (j <= eLevel - 1) {
                            $scope.listItemsModesMain[i].energyLevelValue.push({'enLevelValue': true});
                        } else {
                            $scope.listItemsModesMain[i].energyLevelValue.push({'enLevelValue': false});
                        }
                    }
                    break;
                case WASHERTOUPDATE.SUBWASHER:
                    $scope.listItemsModesSub[i].energyLevelValue = [];
                    $scope.listItemsModesSub[i].maxEnergyLevelValue = maxValue;
                    var eLevel = parseInt(energyLevelSetData.substring(i * 2, i * 2 + 2), 16);
                    for (var j = 0; j < $scope.listItemsModesSub[i].maxEnergyLevelValue; j++) {
                        if (j <= eLevel - 1) {
                            $scope.listItemsModesSub[i].energyLevelValue.push({'enLevelValue': true});
                        } else {
                            $scope.listItemsModesSub[i].energyLevelValue.push({'enLevelValue': false});
                        }
                    }
                    break;
                default:
                    $scope.listItemsModes[i].energyLevelValue = [];
                    $scope.listItemsModes[i].maxEnergyLevelValue = maxValue;
                    var eLevel = parseInt(energyLevelSetData.substring(i * 2, i * 2 + 2), 16);
                    for (var j = 0; j < $scope.listItemsModes[i].maxEnergyLevelValue; j++) {
                        if (j <= eLevel - 1) {
                            $scope.listItemsModes[i].energyLevelValue.push({'enLevelValue': true});
                        } else {
                            $scope.listItemsModes[i].energyLevelValue.push({'enLevelValue': false});
                        }
                    }
                    break;
            }
        }
    }

    function isMixedLoadDisabled() {
        if (!$scope.listItemsModes || $scope.listItemsModes.length === 0) {
            return false;
        }
        if ($scope.remoteControlEnabled && !$scope.kidsLock && $scope.Device.Operation.state !== 'Run' && $scope.Device.Operation.state !== 'Pause') {
            var index = -1;
            for (var i = 0; i < $scope.listItemsModes.length; i++) {
                if ($scope.listItemsModes[i].CourseEnum === $scope.currentCourseEnum) {
                    index = i;
                    break;
                }
            }
            if (index === -1) {
                return false;
            }
            if ($scope.listItemsModes[index].LevelValue === 15) {
                $scope.mixedLoadBellValue = false;
                return true;
            }
            if ($scope.listItemsModes[index].LevelValue > parseInt($scope.listItemsModes[index].defaultDryLevel, 10)) {
                $scope.mixedLoadBellValue = false;
                return true;
            }
            if ($scope.listItemsModes[index].LevelValue > parseInt($scope.setDryLevel, 10)) {
                $scope.mixedLoadBellValue = false;
                return true;
            }
            if (dryLevelSelectedIndex === -1) {
                return false;
            }
            dryLevelSelectedIndex = getIndexOfDryLevel($scope.setDryLevel);
            if (dryLevelSelectedIndex >= $scope.listItemsModes[index].LevelValue) {
                return false;
            } else {
                $scope.mixedLoadBellValue = false;
            }
        }
        //$scope.mixedLoadBellValue = false;
        return true;
    }

    function isMixedLoadDisabledMyFav() {
        if (!$scope.listItemsModes || $scope.listItemsModes.length === 0) {
            return false;
        }
        var index = -1;
        for (var i = 0; i < $scope.listItemsModes.length; i++) {
            if ($scope.listItemsModes[i].CourseEnum === $scope.currentCourseEnumfavorite) {
                index = i;
                break;
            }
        }
        if (index === -1) {
            return false;
        }
        if ($scope.listItemsModes[index].LevelValue === 15) {
            $scope.mixLoadBellFavorite = "Off";
            return true;
        }
        if ($scope.listItemsModes[index].LevelValue > parseInt($scope.listItemsModes[index].defaultDryLevel, 10)) {
            $scope.mixLoadBellFavorite = "Off";
            return true;
        }
        if ($scope.listItemsModes[index].LevelValue > parseInt($scope.setDryLevelFav, 10)) {
            //$scope.mixedLoadBellValueFav = false;
            $scope.mixLoadBellFavorite = "Off";
            return true;
        }
        if (dryLevelSelectedIndexMyFav === -1) {
            return false;
        }
        if (dryLevelSelectedIndexMyFav >= $scope.listItemsModes[index].LevelValue) {
            return false;
        }
        $scope.mixLoadBellFavorite = "Off";
        return true;
    }

    function changeSeamLessControl() {
        if (!$scope.remoteControlEnabled || $scope.kidsLock) {
            return;
        }
        if ($scope.isStatic) {
            $scope.seamLessControlValue = !$scope.seamLessControlValue;
            return;
        }
        $scope.checkResponse.push(WASHER_COMMANDS.SAEMLESS_CONTROL);
        var washerId = 0;
        if ($scope.currentWasherSelected === WASHERCURRENTSEL.SUB_SELECTED) {
            washerId = 1;
        }
        SHPService.sendSHPCommand(CONSTANTS.PUT, getseamLessControlCommand(), "/" + $scope.peerId + "/devices/" + washerId);
    }

    function getseamLessControlCommand() {
        var txt = $scope.seamLessControlValue ? "Disable" : "Enable";
        return '{"Device":{"Mode":{"options":["SeamlessControl_' + txt + '"]}}}';
    }

});

var CourseEnumData = {
    '00': ['Notused', ''],
    '01': ['WEBMOB_device_washer_course_01', 'Dryer/assets/img/main_drop_list_ic_normal_laundry.svg#Layer_1'],
    '02': ['WEBMOB_device_washer_course_02', 'Dryer/assets/img/main_drop_list_ic_power_bubble_shot.svg#Layer_1'],
    '03': ['WEBMOB_device_washer_course_03', 'Dryer/assets/img/main_drop_list_ic_sanitize.svg#Layer_1'],
    '04': ['WEBMOB_device_washer_course_04', 'Dryer/assets/img/main_drop_list_ic_bedding.svg#Layer_1'],
    '05': ['WEBMOB_device_washer_course_05', 'Dryer/assets/img/main_drop_list_ic_bubble_eco.svg#Layer_1'],
    '06': ['WEBMOB_device_washer_course_06', 'Dryer/assets/img/main_drop_list_ic_wool.svg#Layer_1'],
    '07': ['WEBMOB_device_washer_course_07', 'Dryer/assets/img/main_drop_list_ic_quick_wash.svg#Layer_1'],
    '08': ['WEBMOB_device_washer_course_08', 'Dryer/assets/img/main_drop_list_ic_baby_care.svg#Layer_1'],
    '09': ['WEBMOB_device_washer_course_09', 'Dryer/assets/img/main_drop_list_ic_bubble_sports.svg#Layer_1'],
    '0A': ['WEBMOB_device_washer_course_0a', 'Dryer/assets/img/main_drop_list_ic_night_wash.svg#Layer_1'],
    '0B': ['WEBMOB_device_washer_course_0b', 'Dryer/assets/img/main_drop_list_ic_air_refresh.svg#Layer_1'],
    '0C': ['WEBMOB_device_washer_course_0c', 'Dryer/assets/img/main_drop_list_ic_air_sanitize.svg#Layer_1'],
    '0D': ['WEBMOB_device_washer_course_0d', 'Dryer/assets/img/main_drop_list_ic_bedding_care.svg#Layer_1'],
    '0E': ['WEBMOB_device_washer_course_0e', 'Dryer/assets/img/main_drop_list_ic_heavy_duty.svg#Layer_1'],
    '0F': ['WEBMOB_device_washer_course_0f', 'Dryer/assets/img/main_drop_list_ic_bedding.svg#Layer_1'],
    '10': ['WEBMOB_device_washer_course_10', 'Dryer/assets/img/main_drop_list_ic_eco_cold.svg#Layer_1'],
    '11': ['WEBMOB_device_washer_course_11', 'Dryer/assets/img/main_drop_list_ic_wool.svg#Layer_1'],
    '12': ['WEBMOB_device_washer_course_12', 'Dryer/assets/img/main_drop_list_ic_baby_care.svg#Layer_1'],
    '13': ['WEBMOB_device_washer_course_13', 'Dryer/assets/img/main_drop_list_ic_deep_steam.svg#Layer_1'],
    '14': ['WEBMOB_device_washer_course_14', 'Dryer/assets/img/main_drop_list_ic_stain_away.svg#Layer_1'],
    '15': ['WEBMOB_device_washer_course_15', 'Dryer/assets/img/main_drop_list_ic_perm_press.svg#Layer_1'],
    '16': ['WEBMOB_device_washer_course_16', 'Dryer/assets/img/main_drop_list_ic_active_wear.svg#Layer_1'],
    '17': ['WEBMOB_device_washer_course_17', 'Dryer/assets/img/main_drop_list_ic_delicates.svg#Layer_1'],
    '18': ['WEBMOB_device_washer_course_18', 'Dryer/assets/img/main_drop_list_ic_pure_cycle.svg#Layer_1'],
    '19': ['WEBMOB_device_washer_course_19', 'Dryer/assets/img/main_drop_list_ic_rinse_spin_selected.svg#Layer_1'],
    '1A': ['WEBMOB_device_washer_course_1a', 'Dryer/assets/img/main_drop_list_ic_spin.svg#Layer_1'],
    '1B': ['WEBMOB_device_washer_course_1b', 'Dryer/assets/img/main_drop_list_ic_dining.svg#Layer_1'],
    '1C': ['WEBMOB_device_washer_course_1c', 'Dryer/assets/img/main_drop_list_ic_gardening.svg#Layer_1'],
    '1D': ['WEBMOB_device_washer_course_1d', 'Dryer/assets/img/main_drop_list_ic_active_wear.svg#Layer_1'],
    '1E': ['WEBMOB_device_washer_course_1e', 'Dryer/assets/img/main_drop_list_ic_active_kids.svg#Layer_1'],
    '1F': ['WEBMOB_device_washer_course_1f', 'Dryer/assets/img/main_drop_list_ic_shirts.svg#Layer_1'],
    '20': ['WEBMOB_device_washer_course_20', 'Dryer/assets/img/main_drop_list_ic_intensive.svg#Layer_1'],
    '21': ['WEBMOB_device_washer_course_21', 'Dryer/assets/img/main_drop_list_ic_towels.svg#Layer_1'],
    '22': ['WEBMOB_device_washer_course_22', 'Dryer/assets/img/main_drop_list_ic_eco_normal.svg#Layer_1'],
    '23': ['WEBMOB_device_washer_course_23', 'Dryer/assets/img/main_drop_list_ic_delicates.svg#Layer_1'],
    '24': ['WEBMOB_device_washer_course_24', 'Dryer/assets/img/main_drop_list_ic_time_dry.svg#Layer_1'],
    '25': ['WEBMOB_device_washer_course_25', 'Dryer/assets/img/main_drop_list_ic_quickdry.svg#Layer_1'],
    '26': ['WEBMOB_device_washer_course_26', 'Dryer/assets/img/main_drop_list_ic_air_fluff.svg#Layer_1'],
    '27': ['WEBMOB_device_washer_course_27', 'Dryer/assets/img/main_drop_list_ic_refresh.svg#Layer_1'],
    '28': ['WEBMOB_device_washer_course_28', 'Dryer/assets/img/main_drop_list_ic_wrinkle_away.svg#Layer_1'],
    '29': ['WEBMOB_device_washer_course_29', 'Dryer/assets/img/main_drop_list_ic_one_stop_bubble.svg#Layer_1'],
    '2A': ['WEBMOB_device_washer_course_2a', 'Dryer/assets/img/main_drop_list_ic_soaking.svg#Layer_1'],
    '2B': ['WEBMOB_device_washer_course_2b', 'Dryer/assets/img/main_drop_list_ic_active_wear.svg#Layer_1'],
    '2C': ['WEBMOB_device_washer_course_2c', 'Dryer/assets/img/main_drop_list_ic_perm_press.svg#Layer_1'],
    '2D': ['WEBMOB_device_washer_course_2d', 'Dryer/assets/img/main_drop_list_ic_water_saving.svg#Layer_1'],
    '2E': ['WEBMOB_device_washer_course_2e', 'Dryer/assets/img/main_drop_list_ic_drying_only.svg#Layer_1'],
    '2F': ['WEBMOB_device_washer_course_2f', 'Dryer/assets/img/main_drop_list_ic_cotton.svg#Layer_1'],
    '30': ['WEBMOB_device_washer_course_30', 'Dryer/assets/img/main_drop_list_ic_jeans.svg#Layer_1'],
    '31': ['WEBMOB_device_washer_course_31', 'Dryer/assets/img/main_drop_list_ic_colors_darks.svg#Layer_1'],
    '32': ['WEBMOB_device_washer_course_32', 'Dryer/assets/img/main_drop_list_ic_daily_wash.svg#Layer_1'],
    '33': ['WEBMOB_device_washer_course_33', 'Dryer/assets/img/main_drop_list_ic_pure_cycle.svg#Layer_1'],
    '34': ['WEBMOB_device_washer_course_34', 'Dryer/assets/img/main_drop_list_ic_super_eco_wash.svg#Layer_1'],
    '35': ['WEBMOB_device_washer_course_35', 'Dryer/assets/img/main_drop_list_ic_active_wear.svg#Layer_1'],
    '36': ['WEBMOB_device_washer_course_36', 'Dryer/assets/img/main_drop_list_ic_delicates.svg#Layer_1'], //hand wasj
    '37': ['WEBMOB_device_washer_course_37', 'Dryer/assets/img/main_drop_list_ic_baby_care.svg#Layer_1'],
    '38': ['WEBMOB_device_washer_course_38', 'Dryer/assets/img/main_drop_list_ic_bubble_eco.svg#Layer_1'], //eco bubble
    '39': ['WEBMOB_device_washer_course_39', 'Dryer/assets/img/main_drop_list_ic_pure_cycle.svg#Layer_1'],
    '3A': ['WEBMOB_device_washer_course_3a', 'Dryer/assets/img/main_drop_list_ic_bedding.svg#Layer_1'],
    '3B': ['WEBMOB_device_washer_course_3b', 'Dryer/assets/img/main_drop_list_ic_spin.svg#Layer_1'],
    '3C': ['WEBMOB_device_washer_course_3c', 'Dryer/assets/img/main_drop_list_ic_eco_normal.svg#Layer_1'],
    '3D': ['WEBMOB_device_washer_course_3d', 'Dryer/assets/img/main_drop_list_ic_air_sanitize.svg#Layer_1'],
    '3E': ['WEBMOB_device_washer_course_3e', 'Dryer/assets/img/main_drop_list_ic_auto_optimal_wash.svg#Layer_1'], //Auto Optimal WashTM
    '3F': ['WEBMOB_device_washer_course_3f', 'Dryer/assets/img/main_drop_list_ic_e_cotton.svg#Layer_1'],
    '40': ['WEBMOB_device_washer_course_40', 'Dryer/assets/img/main_drop_list_ic_goretex_refresh.svg#Layer_1'],
    '41': ['WEBMOB_device_washer_course_41', 'Dryer/assets/img/main_drop_list_ic_gardening.svg#Layer_1'],
    '42': ['WEBMOB_device_washer_course_42', 'Dryer/assets/img/main_drop_list_ic_active_sports.svg#Layer_1'],
    '43': ['WEBMOB_device_washer_course_43', 'Dryer/assets/img/main_drop_list_ic_hygiene_care.svg#Layer_1'],
    '44': ['WEBMOB_device_washer_course_44', 'Dryer/assets/img/main_drop_list_ic_eco_cold.svg#Layer_1'],
    '45': ['WEBMOB_device_washer_course_45', 'Dryer/assets/img/main_drop_list_ic_pure_cycle.svg#Layer_1'],
    '46': ['WEBMOB_device_washer_course_46', 'Dryer/assets/img/main_drop_list_ic_cotton.svg#Layer_1'],
    '47': ['WEBMOB_device_washer_course_47', 'Dryer/assets/img/main_drop_list_ic_quick_wash.svg#Layer_1'],
    '48': ['WEBMOB_device_washer_course_48', 'Dryer/assets/img/main_drop_list_ic_delicates.svg#Layer_1'],
    '49': ['WEBMOB_device_washer_course_49', 'Dryer/assets/img/main_drop_list_ic_dining.svg#Layer_1'],
    '4A': ['WEBMOB_device_washer_course_4a', 'Dryer/assets/img/main_drop_list_ic_shirts.svg#Layer_1'],
    '4B': ['WEBMOB_device_washer_course_4b', 'Dryer/assets/img/main_drop_list_ic_active_sports.svg#Layer_1'],
    '4C': ['WEBMOB_device_washer_course_4c', 'Dryer/assets/img/main_drop_list_ic_active_kids.svg#Layer_1'],
    '4D': ['WEBMOB_device_washer_course_4d', 'Dryer/assets/img/main_drop_list_ic_shirts.svg#Layer_1'],
    '4E': ['WEBMOB_device_washer_course_4e', 'Dryer/assets/img/main_drop_list_ic_air_refresh.svg#Layer_1'],
    '4F': ['WEBMOB_device_washer_course_4f', 'Dryer/assets/img/main_drop_list_ic_sanitize.svg#Layer_1'],
    '50': ['WEBMOB_device_washer_course_50', 'Dryer/assets/img/main_drop_list_ic_cotton_dry.svg#Layer_1'],
    '51': ['WEBMOB_device_washer_course_51', 'Dryer/assets/img/main_drop_list_ic_synthetics_dry.svg#Layer_1'],
    '52': ['WEBMOB_device_washer_course_52', 'Dryer/assets/img/main_drop_list_ic_active_wear.svg#Layer_1'],
    '53': ['WEBMOB_device_washer_course_53', 'Dryer/assets/img/main_drop_list_ic_padding.svg#Layer_1'],
    'FD': ['NotSupported', 'common/img/main_drop_list_ic_bedding.svg#Layer_1'],
    'FE': ['Unknown', 'common/img/main_drop_list_ic_bedding.svg#Layer_1'],
    'FF': ['NULL', 'NULL'],
    '54': ['WEBMOB_device_washer_course_54', 'Dryer/assets/img/main_drop_list_ic_allergen.svg#Layer_1'],
    '55': ['WEBMOB_device_washer_course_55', 'Dryer/assets/img/main_drop_list_ic_white.svg#Layer_1'],
    '56': ['WEBMOB_device_washer_course_56', 'Dryer/assets/img/main_drop_list_ic_towels.svg#Layer_1'],
    '57': ['WEBMOB_device_washer_course_57', 'Dryer/assets/img/main_drop_list_ic_pure_cycle.svg#Layer_1'],
    '58': ['WEBMOB_device_washer_course_58', 'Dryer/assets/img/main_drop_list_ic_one_stop_bubble.svg#Layer_1'],
    '59': ['WEBMOB_device_washer_course_59', 'Dryer/assets/img/main_drop_list_ic_bedding.svg#Layer_1'],
    '5A': ['WEBMOB_device_washer_course_5a', 'Dryer/assets/img/main_drop_list_ic_pure_cycle.svg#Layer_1'],
    '5B': ['WEBMOB_device_washer_course_5b', 'Dryer/assets/img/main_drop_list_ic_cotton.svg#Layer_1'],
    '5C': ['WEBMOB_device_washer_course_5c', 'Dryer/assets/img/main_drop_list_ic_quick_wash.svg#Layer_1'],
    '5D': ['WEBMOB_device_washer_course_5d', 'Dryer/assets/img/main_drop_list_ic_super_eco_wash.svg#Layer_1'],
    '5E': ['WEBMOB_device_washer_course_5e', 'Dryer/assets/img/main_drop_list_ic_delicates.svg#Layer_1'],
    '5F': ['WEBMOB_device_washer_course_5f', 'Dryer/assets/img/main_drop_list_ic_baby_care.svg#Layer_1'],
    '60': ['WEBMOB_device_washer_course_60', 'Dryer/assets/img/main_drop_list_ic_active_wear.svg#Layer_1'],
    '61': ['WEBMOB_device_washer_course_61', 'Dryer/assets/img/main_drop_list_ic_colors_darks.svg#Layer_1'],
    '62': ['WEBMOB_device_washer_course_62', 'Dryer/assets/img/main_drop_list_ic_bedding.svg#Layer_1'],
    '63': ['WEBMOB_device_washer_course_63', 'Dryer/assets/img/main_drop_list_ic_pure_cycle.svg#Layer_1'],
    '64': ['WEBMOB_device_washer_course_64', 'Dryer/assets/img/main_drop_list_ic_rinse_spin_selected.svg#Layer_1'],
    '65': ['WEBMOB_device_washer_course_65', 'Dryer/assets/img/main_drop_list_ic_wool.svg#Layer_1'],
    '66': ['WEBMOB_device_washer_course_66', 'Dryer/assets/img/main_drop_list_ic_bedding.svg#Layer_1'],
    '67': ['WEBMOB_device_washer_course_67', 'Dryer/assets/img/main_drop_list_ic_perm_press.svg#Layer_1'],
    '68': ['WEBMOB_device_washer_course_68', 'Dryer/assets/img/main_drop_list_ic_e_cotton.svg#Layer_1'],
    '69': ['WEBMOB_device_washer_course_69', 'Dryer/assets/img/main_drop_list_ic_eco_cold.svg#Layer_1'],
    '6A': ['WEBMOB_device_washer_course_6a', 'Dryer/assets/img/main_drop_list_ic_downjumper.svg#Layer_1'], //use downjumper for down jacket
    '6B': ['WEBMOB_device_washer_course_6b', 'Dryer/assets/img/main_drop_list_ic_spin.svg#Layer_1'],
    '6C': ['WEBMOB_device_washer_course_6c', 'Dryer/assets/img/main_drop_list_ic_jeans.svg#Layer_1'],
    '6D': ['WEBMOB_device_washer_course_6d', 'Dryer/assets/img/main_drop_list_ic_pure_cycle.svg#Layer_1'],
    '6E': ['WEBMOB_device_washer_course_6e', 'Dryer/assets/img/main_drop_list_ic_cotton.svg#Layer_1'],
    '6F': ['WEBMOB_device_washer_course_6f', 'Dryer/assets/img/main_drop_list_ic_steam_sanitize.svg#Layer_1'], //US
    '70': ['WEBMOB_device_washer_course_70', 'Dryer/assets/img/main_drop_list_ic_heavy_duty.svg#Layer_1'], //US
    '71': ['WEBMOB_device_washer_course_71', 'Dryer/assets/img/main_drop_list_ic_bedding.svg#Layer_1'], //US
    '72': ['WEBMOB_device_washer_course_72', 'Dryer/assets/img/main_drop_list_ic_sanitize.svg#Layer_1'], //US
    '73': ['WEBMOB_device_washer_course_73', 'Dryer/assets/img/main_drop_list_ic_rinse_spin_selected.svg#Layer_1'], //US
    '74': ['WEBMOB_device_washer_course_74', 'Dryer/assets/img/main_drop_list_ic_active_wear.svg#Layer_1'], //US
    '75': ['WEBMOB_device_washer_course_75', 'Dryer/assets/img/main_drop_list_ic_delicates.svg#Layer_1'], //US
    '76': ['WEBMOB_device_washer_course_76', 'Dryer/assets/img/main_drop_list_ic_wool.svg#Layer_1'], //US
    '77': ['WEBMOB_device_washer_course_77', 'Dryer/assets/img/main_drop_list_ic_perm_press.svg#Layer_1'], //US
    '78': ['WEBMOB_device_washer_course_78', 'Dryer/assets/img/main_drop_list_ic_quick_wash.svg#Layer_1'], //US
    '79': ['WEBMOB_device_washer_course_79', 'Dryer/assets/img/main_drop_list_ic_eco_cold.svg#Layer_1'], //US
    '7A': ['WEBMOB_device_washer_course_7a', 'Dryer/assets/img/main_drop_list_ic_deep_steam.svg#Layer_1'], //US
    '7B': ['WEBMOB_device_washer_course_7b', 'Dryer/assets/img/main_drop_list_ic_stain_away.svg#Layer_1'], //US
    '7C': ['WEBMOB_device_washer_course_7c', 'Dryer/assets/img/main_drop_list_ic_wrinkle_away.svg#Layer_1'], //US
    '7D': ['WEBMOB_device_washer_course_7d', 'Dryer/assets/img/main_drop_list_ic_refresh.svg#Layer_1'], //US
    '7E': ['WEBMOB_device_washer_course_7e', 'Dryer/assets/img/main_drop_list_ic_air_fluff.svg#Layer_1'], //US
    '7F': ['WEBMOB_device_washer_course_7f', 'Dryer/assets/img/main_drop_list_ic_time_dry.svg#Layer_1'], //US
    '80': ['WEBMOB_device_washer_course_80', 'Dryer/assets/img/main_drop_list_ic_quickdry.svg#Layer_1'], //US
    '81': ['WEBMOB_device_washer_course_81', 'Dryer/assets/img/main_drop_list_ic_eco_normal.svg#Layer_1'], //US
    '8C': ['WEBMOB_device_washer_course_8c', 'Dryer/assets/img/main_drop_list_ic_quick_wash.svg#Layer_1'], //US
    '8D': ['WEBMOB_device_washer_course_8d', 'Dryer/assets/img/main_drop_list_ic_deep_wash.svg#Layer_1'], //US
    '8E': ['WEBMOB_device_washer_course_8e', 'Dryer/assets/img/main_drop_list_ic_white.svg#Layer_1'], //US
    '8F': ['WEBMOB_device_washer_course_8f', 'Dryer/assets/img/main_drop_list_ic_bedding.svg#Layer_1'], //US
    '90': ['WEBMOB_device_washer_course_90', 'Dryer/assets/img/main_drop_list_ic_spin.svg#Layer_1'], //US
    '91': ['WEBMOB_device_washer_course_91', 'Dryer/assets/img/main_drop_list_ic_pure_cycle.svg#Layer_1'], //US
    '92': ['WEBMOB_device_washer_course_92', 'Dryer/assets/img/main_drop_list_ic_air_wash.svg#Layer_1'], //US
    '93': ['WEBMOB_device_washer_course_93', 'Dryer/assets/img/main_drop_list_ic_iron_dry.svg#Layer_1'], //US
    '94': ['WEBMOB_device_washer_course_94', 'Dryer/assets/img/main_drop_list_ic_towels.svg#Layer_1'], //US
    '95': ['WEBMOB_device_washer_course_95', 'Dryer/assets/img/main_drop_list_ic_time_dry.svg#Layer_1'], //US
    '96': ['WEBMOB_device_washer_course_96', 'Dryer/assets/img/main_drop_list_ic_cool_air.svg#Layer_1'], //US
    '97': ['WEBMOB_device_washer_course_97', 'Dryer/assets/img/main_drop_list_ic_warm_air.svg#Layer_1'], //US
    '98': ['WEBMOB_device_washer_course_98', 'Dryer/assets/img/main_drop_list_ic_quickdry.svg#Layer_1'], //US
    '99': ['WEBMOB_device_washer_course_99', 'Dryer/assets/img/main_drop_list_ic_mixed_load.svg#Layer_1'], //US
    '9A': ['WEBMOB_device_washer_course_9a', 'Dryer/assets/img/main_drop_list_ic_e_cotton.svg#Layer_1'], //US
    '9B': ['WEBMOB_device_washer_course_9b', 'Dryer/assets/img/main_drop_list_ic_steam_sanitize.svg#Layer_1'], //US
    '9C': ['WEBMOB_device_washer_course_9c', 'Dryer/assets/img/main_drop_list_ic_heavy_duty.svg#Layer_1'], //US
    '9D': ['WEBMOB_device_washer_course_9d', 'Dryer/assets/img/main_drop_list_ic_rinse_spin_selected.svg#Layer_1'], //US
    '9E': ['WEBMOB_device_washer_course_9e', 'Dryer/assets/img/main_drop_list_ic_perm_press.svg#Layer_1'], //US
    '9F': ['WEBMOB_device_washer_course_9f', 'Dryer/assets/img/main_drop_list_ic_quick_wash.svg#Layer_1'], //US
    'A0': ['WEBMOB_device_washer_course_a0', 'Dryer/assets/img/main_drop_list_ic_air_fluff.svg#Layer_1'], //US
    'A1': ['WEBMOB_device_washer_course_a1', 'Dryer/assets/img/main_drop_list_ic_wrinkle_away.svg#Layer_1'], //US
    'A2': ['WEBMOB_device_washer_course_a2', 'Dryer/assets/img/main_drop_list_ic_delicates.svg#Layer_1'], //US
    'A3': ['WEBMOB_device_washer_course_a3', 'Dryer/assets/img/main_drop_list_ic_active_wear.svg#Layer_1'], //US
    'A4': ['WEBMOB_device_washer_course_a4', 'Dryer/assets/img/main_drop_list_ic_time_dry.svg#Layer_1'], //US
    'A5': ['WEBMOB_device_washer_course_a5', 'Dryer/assets/img/main_drop_list_ic_bedding.svg#Layer_1'], //US
    'A6': ['WEBMOB_device_washer_course_a6', 'Dryer/assets/img/main_drop_list_ic_quickdry.svg#Layer_1'], //US
    'A9': ['WEBMOB_device_washer_course_a9', 'Dryer/assets/img/main_drop_list_ic_sanitize.svg#Layer_1'], //Dual
    'AA': ['WEBMOB_device_washer_course_aa', 'Dryer/assets/img/main_drop_list_ic_white.svg#Layer_1'], //Dual
    'AB': ['WEBMOB_device_washer_course_ab', 'Dryer/assets/img/main_drop_list_ic_eco_cold.svg#Layer_1'], //Dual
    'AC': ['WEBMOB_device_washer_course_ac', 'Dryer/assets/img/main_drop_list_ic_normal_laundry.svg#Layer_1'], //Dual combo
    'AD': ['WEBMOB_device_washer_course_ad', 'Dryer/assets/img/main_drop_list_ic_shirts.svg#Layer_1'], //Dual
    'AE': ['WEBMOB_device_washer_course_ae', 'Dryer/assets/img/main_drop_list_ic_lingerie.svg#Layer_1'], //Dual
    'AF': ['WEBMOB_device_washer_course_af', 'Dryer/assets/img/main_drop_list_ic_sweater.svg#Layer_1'], //Dual
    'B0': ['WEBMOB_device_washer_course_b0', 'Dryer/assets/img/main_drop_list_ic_accessory.svg#Layer_1'], //Dual
    'B1': ['WEBMOB_device_washer_course_b1', 'Dryer/assets/img/main_drop_list_ic_pure_cycle.svg#Layer_1'], //Dual
    'B2': ['WEBMOB_device_washer_course_b2', 'Dryer/assets/img/main_drop_list_ic_air_refresh.svg#Layer_1'], //Dual combo
    'B4': ['WEBMOB_device_washer_course_b4', 'Dryer/assets/img/main_drop_list_ic_active_wear.svg#Layer_1'], //Europe dryer
    'B5': ['WEBMOB_device_washer_course_b5', 'Dryer/assets/img/main_drop_list_ic_wool.svg#Layer_1'], //Europe dryer
    'B6': ['WEBMOB_device_washer_course_b6', 'Dryer/assets/img/main_drop_list_ic_perm_press.svg#Layer_1'], //Europe dryer
    'B7': ['WEBMOB_device_washer_course_b7', 'Dryer/assets/img/main_drop_list_ic_pure_cycle.svg#Layer_1'], //Flex global
    'B8': ['WEBMOB_device_washer_course_b8', 'Dryer/assets/img/main_drop_list_ic_drying_only.svg#Layer_1'], //Flex global_UAE
    'B9': ['WEBMOB_device_washer_course_b9', 'Dryer/assets/img/main_drop_list_ic_rinse_spin_selected.svg#Layer_1'], //Flex global
    'BA': ['WEBMOB_device_washer_course_ba', 'Dryer/assets/img/main_drop_list_ic_perm_press.svg#Layer_1'], //Flex global
    'BB': ['WEBMOB_device_washer_course_bb', 'Dryer/assets/img/main_drop_list_ic_quick_wash.svg#Layer_1'], //Flex global
    'BC': ['WEBMOB_device_washer_course_bc', 'Dryer/assets/img/main_drop_list_ic_delicates.svg#Layer_1'], //Flex global
    'BD': ['WEBMOB_device_washer_course_bd', 'Dryer/assets/img/main_drop_list_ic_steam_sanitize.svg#Layer_1'], //Flex global
    'BE': ['WEBMOB_device_washer_course_be', 'Dryer/assets/img/main_drop_list_ic_cotton.svg#Layer_1'], //Flex global
    'BF': ['WEBMOB_device_washer_course_bf', 'Dryer/assets/img/main_drop_list_ic_wool.svg#Layer_1'], //Flex global
    'C0': ['WEBMOB_device_washer_course_c0', 'Dryer/assets/img/main_drop_list_ic_quickdry.svg#Layer_1'], //Flex global
    'C1': ['WEBMOB_device_washer_course_c1', 'Dryer/assets/img/main_drop_list_ic_power_bubble_shot.svg#Layer_1'], //Flex global
    'C2': ['WEBMOB_device_washer_course_c2', 'Dryer/assets/img/main_drop_list_ic_baby_care.svg#Layer_1'], //Flex global
    'C3': ['WEBMOB_device_washer_course_c3', 'Dryer/assets/img/main_drop_list_ic_active_wear.svg#Layer_1'], //Flex global
    'C4': ['WEBMOB_device_washer_course_c4', 'Dryer/assets/img/main_drop_list_ic_pure_cycle.svg#Layer_1'], //Flex global
    'C5': ['WEBMOB_device_washer_course_c5', 'Dryer/assets/img/main_drop_list_ic_bedding_care.svg#Layer_1'], //Flex global
    'C6': ['WEBMOB_device_washer_course_c6', 'Dryer/assets/img/main_drop_list_ic_pure_cycle.svg#Layer_1'], //Flex global
    'C7': ['WEBMOB_device_washer_course_c7', 'Dryer/assets/img/main_drop_list_ic_pure_cycle.svg#Layer_1'], //Flex global
    'C8': ['WEBMOB_device_washer_course_c8', 'Dryer/assets/img/main_drop_list_ic_pure_cycle.svg#Layer_1'], //Flex global
    'C9': ['WEBMOB_device_washer_course_c9', 'Dryer/assets/img/main_drop_list_ic_59_wash_dry_selected.svg#Layer_1'], //Europe washer
    'CA': ['WEBMOB_device_washer_course_ca', 'Dryer/assets/img/main_drop_list_ic_air_wash.svg#Layer_1'], //Europe washer
    'CB': ['WEBMOB_device_washer_course_cb', 'Dryer/assets/img/main_drop_list_ic_15_quick_wash.svg#Layer_1'], //Europe washer
    'CC': ['WEBMOB_device_washer_course_cc', 'Dryer/assets/img/main_drop_list_ic_baby_care.svg#Layer_1'], //Europe washer
    'CD': ['WEBMOB_device_washer_course_cd', 'Dryer/assets/img/main_drop_list_ic_active_wear.svg#Layer_1'], //Europe washer
    'CE': ['WEBMOB_device_washer_course_ce', 'Dryer/assets/img/main_drop_list_ic_bedding.svg#Layer_1'], //Flex global
    'CF': ['WEBMOB_device_washer_course_cf', 'Dryer/assets/img/main_drop_list_ic_drying_only.svg#Layer_1'] //Flex global
};

var TempEnum = {
    "12": "Cold",
    "14": "Cool",
    "16": "EcoWarm",
    "1A": "Warm",
    "22": "Hot",
    "26": "ExtraHot",
    "E2": "ExtraLow",
    "E6": "Low",
    "EA": "MediumLow",
    "F2": "Medium",
    "F4": "High",
    "27": "냉수",
    "5E": "I20",
    "28": "I30",
    "30": "I40",
    "38": "I50",
    "40": "I60",
    "44": "I65",
    "48": "I70",
    "4C": "I75",
    "50": "I80",
    "58": "I90",
    "5C": "I95",
    "FE": "NotSupported",
    "FF": "None",
    "G0": "DoNotDisplay"
};

var OptionTypeEnum = {
    "8": "Temp",
    "9": "Rinse",
    "A": "Spin",
    "B": "DryCombo",
    "C": "Soil",
    "D": "DryLevel",
    "E": "DryTime",
    "F": "Soak"
};

app.service('CourseParseService', function () {
    var list, list_rin, list_sp, list_drc, list_sll, list_drl, list_drt;
    this.getCourseParsed = function (courseOptionList, $scope, washerType) {

        var firstString = courseOptionList.substring(0, 1);
        var optionNumber = parseInt(firstString, 10);
        var lengthCourseString = 2 + (optionNumber * 4);
        var courseLen = courseOptionList.length;
        if ((courseLen - 1) % lengthCourseString !== 0) {
            debugMessage("Not a correct course data string!");
            return null;
        }

        for (var i = 1; i < courseLen; i += lengthCourseString) {
            var CourseData = {serialVersionUID: '', courseNameHex: '', courseIcon: '', CourseEnum: '', defaultTemp: '',
                optionTempList: [], defaultRinse: '', optionRinseList: [], defaultSpin: '', optionSpinList: [], defaultSoil: '',
                optionSoilList: [], defaultDryLevel: '', optionDryLevelList: [], defaultDryTime: '', optionDryTimeList: [],
                defaultDryCombo: '', optionDryComboList: [], deviceType: '', isTempEnabled: false, isRinseEnabled: false,
                isSpinEnabled: false, isDryComboEnabled: false, isSoilLevelEnabled: false, isDryLevelEnabled: false,
                isDryTimeEnabled: false, isSoakEnabled: false, optionTypes: [], optionNumber: 0
            };
            var dataString = courseOptionList.substring(i, i + lengthCourseString);
            CourseData.courseNameHex = dataString.substring(0, 2);
            CourseData.CourseEnum = CourseEnumData[CourseData.courseNameHex][0];
            CourseData.courseIcon = CourseEnumData[CourseData.courseNameHex][1];

            for (var j = 2; j < dataString.length; j += 4) {

                // Hex to int converter
                var optionString = dataString.substring(j, j + 4);
                var option = parseInt(optionString, 16);
                // [0] Option Type - 4bit(15-12 bit)
                var type = (option >> 12) & 0x0000000F;
                // [1] Defaults - 4bit(11-8 bit) => Index values
                var defaultValue = (option >> 8) & 0x0000000F;
                // [2] Available options - 8bit(7-0 bit) => Bit per available options
                var avail = option & 0x000000FF;
                if (type === 0x8) {
                    //Temp
                    CourseData.isTempEnabled = true;
                    if (!$scope.isDualDryer) {
                        list = $scope.Device["Washer"].supportedWaterTemperature;
                    } else {
                        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                            list = $scope.mainDryerData["Washer"].supportedWaterTemperature;
                        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                            list = $scope.subDryerData["Washer"].supportedWaterTemperature;
                        } else {
                            ; //Nothing
                        }
                    }
                    if (list !== undefined) {
                        CourseData.defaultTemp = list[defaultValue];
                        var len = list.length;
                        for (var k = 0; k < len; k++) {
                            if ((((avail >> k) & 0x00000001) === 0x00000001) && (CourseData.optionTempList.indexOf(list[k]) === -1)) {
                                CourseData.optionTempList.push(list[k]);
                            }
                        }
                    }
                    if (CourseData.optionTypes.indexOf("8") === -1) {
                        CourseData.optionTypes.push("8");
                    }

                } else if (type === 0x9) {
                    //Rinse
                    CourseData.isRinseEnabled = true;
                    if (!$scope.isDualDryer) {
                        list_rin = $scope.Device["Washer"].supportedRinseCycles;
                    } else {
                        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                            list_rin = $scope.mainDryerData["Washer"].supportedRinseCycles;
                        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                            list_rin = $scope.subDryerData["Washer"].supportedRinseCycles;
                        } else {
                            ; //Nothing
                        }
                    }
                    if (list_rin !== undefined) {
                        CourseData.defaultRinse = list_rin[defaultValue];
                        for (var ri = 0; ri < list_rin.length; ri++) {
                            if ((((avail >> ri) & 0x00000001) === 0x00000001) && (CourseData.optionRinseList.indexOf(list_rin[ri]) === -1)) {
                                CourseData.optionRinseList.push(list_rin[ri]);
                            }
                        }
                    }
                    CourseData.optionTypes.push("9");
                } else if (type === 0xA) {
                    // Spin
                    CourseData.isSpinEnabled = true;
                    if (!$scope.isDualDryer) {
                        list_sp = $scope.Device["Washer"].supportedSpinLevel;
                    } else {
                        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                            list_sp = $scope.mainDryerData["Washer"].supportedSpinLevel;
                        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                            list_sp = $scope.subDryerData["Washer"].supportedSpinLevel;
                        } else {
                            ; //nothing
                        }
                    }
                    if (list_sp !== undefined) {
                        CourseData.defaultSpin = list_sp[defaultValue];
                        for (var spi = 0; spi < list_sp.length; spi++) {
                            if (((avail >> spi) & 0x00000001) === 0x00000001) {
                                CourseData.optionSpinList.push(list_sp[spi]);
                            }
                        }
                    }
                    CourseData.optionTypes.push("A");
                } else if (type === 0xB) {
                    // DryCombo
                    CourseData.isDryComboEnabled = true;
                    if (!$scope.isDualDryer) {
                        list_drc = $scope.Device["Washer"].supportedDryCombo;
                    } else {
                        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                            list_drc = $scope.mainDryerData["Washer"].supportedDryCombo;
                        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                            list_drc = $scope.subDryerData["Washer"].supportedDryCombo;
                        } else {
                            ; //nothing
                        }
                    }
                    if (list_drc !== undefined) {
                        CourseData.defaultDryCombo = list_drc[defaultValue];
                        for (var dri = 0; dri < list_drc.length; dri++) {
                            if (((avail >> dri) & 0x00000001) === 0x00000001) {
                                CourseData.optionDryComboList.push(list_drc[dri]);
                            }
                        }
                    }
                    CourseData.optionTypes.push("B");
                } else if (type === 0xC) {
                    // 오염�?�(SoilLevel)
                    CourseData.isSoilLevelEnabled = true;
                    if (!$scope.isDualDryer) {
                        list_sll = $scope.Device["Washer"].supportedSoilLevel;
                    } else {
                        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                            list_sll = $scope.mainDryerData["Washer"].supportedSoilLevel;
                        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                            list_sll = $scope.subDryerData["Washer"].supportedSoilLevel;
                        } else {
                            ; //nothing
                        }
                    }
                    if (list_sll !== undefined) {
                        CourseData.defaultSoil = list_sll[defaultValue];
                        for (var soi = 0; soi < list_sll.length; soi++) {
                            if (((avail >> soi) & 0x00000001) === 0x00000001) {
                                CourseData.optionSoilList.push(list_sll[soi]);
                            }
                        }
                    }
                    CourseData.optionTypes.push("C");
                } else if (type === 0xD) {
                    // DryLevel
                    CourseData.isDryLevelEnabled = true;
                    if (!$scope.isDualDryer) {
                        list_drl = $scope.Device["Washer"].supportedDryLevel;
                    } else {
                        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                            list_drl = $scope.mainDryerData["Washer"].supportedDryLevel;
                        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                            list_drl = $scope.subDryerData["Washer"].supportedDryLevel;
                        } else {
                            ; //nothing
                        }
                    }
                    if (list_drl !== undefined) {
                        CourseData.defaultDryLevel = list_drl[defaultValue];
                        for (var dli = 0; dli < list_drl.length; dli++) {
                            if (((avail >> dli) & 0x00000001) === 0x00000001) {
                                CourseData.optionDryLevelList.push(list_drl[dli]);
                            }
                        }
                    }
                    CourseData.optionTypes.push("D");
                } else if (type === 0xE) {
                    // DryTime
                    CourseData.isDryTimeEnabled = true;
                    if (!$scope.isDualDryer) {
                        list_drt = $scope.Device["Washer"].supportedDryTime;
                    } else {
                        if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.MAINWASHER) {
                            list_drt = $scope.mainDryerData["Washer"].supportedDryTime;
                        } else if ($scope.isDualDryer && $scope.washerToUpdate === WASHERTOUPDATE.SUBWASHER) {
                            list_drt = $scope.subDryerData["Washer"].supportedDryTime;
                        } else {
                            ; //nothing
                        }
                    }
                    if (list_drt !== undefined) {
                        CourseData.defaultDryTime = list_drt[defaultValue];
                        for (var dti = 0; dti < list_drt.length; dti++) {
                            if (((avail >> dti) & 0x00000001) === 0x00000001) {
                                CourseData.optionDryTimeList.push(list_drt[dti]);
                            }
                        }
                    }
                    CourseData.optionTypes.push("E");
                } else if (type === 0xF) {
                    // Soak
                    CourseData.isSoakEnabled = true;
                    CourseData.optionTypes.push("F");
                } else {
                    //Sonar Issue
                }
            }

            switch (washerType) {
                case 0:
                case 1:
                    $scope.Device['CourseData'].push(CourseData);
                    break;
                case 2:
                    $scope.mainDryerData['CourseData'].push(CourseData);
                    $scope.Device['CourseData'].push(CourseData);
                    break;
                case 3:
                    $scope.subDryerData['CourseData'].push(CourseData);
                    $scope.Device['CourseData'].push(CourseData);
                    break;
                default:
                    $scope.Device['CourseData'].push(CourseData);
                    break;
            }
        }
    };
});
