var app = angular.module("SmartThings", ['toaster', 'ngSanitize', 'angularRangeSlider']);
var myScope;
app.controller("FACController", function ($scope, SHPService, toaster, AIRCON_SETTING_REGION, WeatherService, $timeout, EnergyService, ScheduleService, $sce, $interval, UtilityService, homeMultiService, STCONST) {
    
    //Local variable declaration.
    var noRegionSelected,
            promise,
            THREE_VENT_MODEL = 3,
            TWO_VENT_MODEL = 2,
            modelInfo,
            FACCONST = {
                VENT: "VENT",
                TEMPCHANGE: "TEMPCHANGE",
                OPERATION_SOLO: "OPERATION_SOLO",
                COMODE: "COMODE",
                AI: "AI",
                AIRDATA: "AIRDATA",
                WEATHERDATA: "WEATHERDATA",
                SCHEDULEDATA: "SCHEDULEDATA",
                MODECHANGE: "MODECHANGE",
                WINDSTRENGTH_CHANGE: "WINDSTRENGTH_CHANGE",
                WINDDIRECTION_CHANGE: "WINDDIRECTION_CHANGE",
                POWEROPERATION: "POWEROPERATION",
                GETDEVICES: "getDevices",
                POWERCONSUMPTION: "GET_POWERCONSUMPTION",
                RELAXMODE: "RELAXMODE",
                VOLUMECHANGE: "VOLUMECHANGE",
                LIGHTING: "LIGHTING",
                AUTOCLEAN: "AUTOCLEAN",
                PANEL: "PANEL",
                HUMIDIFY: "HUMIDIFY",
                STERILIZATION: "STERILIZATION",
                WATTNOTICE: "WATT_NOTICE_ON",
                WINDCOMMAND: "WINDCOMMAND",
                PARSE_CONFIG: "PARSE_CONFIG",
                PARSE_MODULEINFO: "PARSE_MODULEINFO",
                DIAGNOSIS: "DIAGNOSIS",
                STATUS_204: 204,
                STATUS_201: 201,
                STATUS_200: 200,
                MYWIND_KEY: "FACMyWindList",
                MYWIND_KEY_DEMO: "FACMyWindListDemo",
                AIR_MONITORING: "AIR_MONITORING",
                AIWORKSTATUS_ON: "On",
                AIWORKSTATUS_OFF: "Off",
                AIWORKSTATUS_ING: "Ing"
                },
            FACSCREENS = {
                HOME: 1,
                OPTIONS: 2,
                SCHEDULELIST: 3,
                POWERCONSUMPTION: 4,
                ADDSCHEDULE: 5,
                WEATHERINFO: 6,
                WEATHERINFOSETTINGS: 7,
                SETTINGS: 8,
                ABOUT: 9,
                ERRORPAGE: 10,
                MYWINDLIST: 11,
                ADDWIND: 12,
                SMARTCARE: 13,
                SMARTCAREERROR: 14,
                AIRPURITY: 15,
                LIGHTING: 16,
                VOICESELECTION: 17,
                FILTERPAGE: 18,
                AICOOLLEARNING: 19
            },
            MODELS = {
                NONE : 0,
                _14K_MEMORY_M1 : 1, //used '_' b'coz first character cannot be a number.
                _14K_MEMORY_M2 : 2,
                _15K_MEMORY_M1 : 3,
                _15K_MEMORY_M2 : 4,
                _16K_BORA_VENT2 : 5,
                _16K_BORA_VENT3 : 6, 
                _16K_MEMORY_VENT3 : 7,
                _16K_MEMORY_VENT2 : 8
            },
            ALERT_STATE = {
                SERVICE_CALL: 1,
                SERVICE_CENTER_SELECTION: 2
            },
            increaseTempConinous = false,
            decreaseTempConinous = false,
            getAirData = "getAirData",
            currentWindKey,
            reqParamCountrySelection,
            userClosedWeathRecommMode = false,
            tempFilterStatusShow,
            event,
            lastDayOfMonth = 31;

    myScope = angular.element(document.getElementById("bodyTag")).scope();

    // Scope function declaration.
    $scope.getYAxisValue = EnergyService.getYAxisValue;
    $scope.setIncreaseTempOnTouchStart = setIncreaseTempOnTouchStart;
    $scope.setDecreaseTempOnTouchStart = setDecreaseTempOnTouchStart;
    $scope.is16KModel = is16KModel;
    $scope.is17KModel = is17KModel;
    $scope.initSearchText = initSearchText;
    $scope.sendSensorRequest = homeMultiService.sendSensorRequest;   //Lokesh 11Nov15_1542 -> function to refresh air purity data.
    $scope.isPopupOpen = isPopupOpen;
    $scope.increaseTemp = increaseTemp;
    $scope.decreaseTemp = decreaseTemp;
    $scope.showUsageHelpPage = showUsageHelpPage;
    $scope.closeUsageHelpPage = closeUsageHelpPage;
    $scope.showOptionPopUp = showOptionPopUp;
    $scope.closeOptionPopUp = closeOptionPopUp;
    $scope.selectIndexFromOptionMenu = selectIndexFromOptionMenu;
    $scope.getScrollableAreaClass = getScrollableAreaClass;
    $scope.addSchedule = addSchedule;
    $scope.addWind = addWind;
    $scope.toggleAlarmInfoArea = toggleAlarmInfoArea;
    $scope.closeWeathRecommMode = closeWeathRecommMode;
    $scope.scheduleList = scheduleList;
    $scope.parseRequestResponse = parseRequestResponse;    
    $scope.parseNotification = parseNotification;
    $scope.parseRequestAccepted = parseRequestAccepted;
    $scope.callGetDevice = callGetDevice;
    $scope.showConnectionFailurePopup = showConnectionFailurePopup;
    $scope.onBackPressed = onBackPressed;
    $scope.openPopup = openPopup;
    $scope.popupBtnClicked = popupBtnClicked;
    $scope.onRadioBtnSelected = onRadioBtnSelected;
    $scope.gotoLighting = gotoLighting;    
    $scope.selectLightingMode = selectLightingMode;
    $scope.getLightingModeText = getLightingModeText;
    $scope.gotoVoiceSelection = gotoVoiceSelection;
    $scope.selectVoiceSelectionMode = selectVoiceSelectionMode;
    $scope.getVoiceSelectionModeText = getVoiceSelectionModeText;
    $scope.onAddWindPuritySetting = onAddWindPuritySetting;
    $scope.getFilterStatusVisibility = getFilterStatusVisibility;
    $scope.isShow_aiConnectionFailPanel = isShow_aiConnectionFailPanel;
    $scope.filterNotificationClose = filterNotificationClose;
    $scope.getModeSelectionPopupClass = getModeSelectionPopupClass;
    $scope.getModeCompleteText = getModeCompleteText;
    $scope.isNonAirPurifierModel = isNonAirPurifierModel;
    $scope.increaseGoodSleepHr = increaseGoodSleepHr;
    $scope.increaseGoodSleepMin = increaseGoodSleepMin;
    $scope.getHumidityText = getHumidityText;
    $scope.showMeterDateSettingPopup = showMeterDateSettingPopup;
    $scope.increaseMeterDate = increaseMeterDate;
    $scope.onMeterDateUpdate = onMeterDateUpdate;
    $scope.getMeterDateText = getMeterDateText;
    $scope.increaseMeterDateContinuously = increaseMeterDateContinuously;
    $scope.decreaseMeterDateContinuously = decreaseMeterDateContinuously;
    $scope.gotoFilterPage = gotoFilterPage;
    $scope.isAIStatusOn = isAIStatusOn;
    $scope.isAIStatusIng = isAIStatusIng;
    $scope.getAIGuideText = getAIGuideText;
    $scope.isAICoolLearningEnable = isAICoolLearningEnable;

    var min_yAxes = 15;
    var max_yAxes = 30;
    var min_xAxes = 16;
    var max_xAxes = 38;
    $scope.myChart;
    $scope.ctxGraph = document.getElementById("aiChart");
    // For testing AI. To remove later when correct data coming from set
    $scope.trainingHistoryData=[
        {
            "date":"2017-03-18",
            "timeInUTC":"2017-03-22T11:00:13",
            "cpCurrentT":"32",
            "currentT":"24",
            "desiredT":"24.0"
        },
        {
            "date":"2017-03-19",
            "timeInUTC":"2017-03-23T11:00:13",
            "cpCurrentT":"36",
            "currentT":"26",
            "desiredT":"26.0"
        },
        {
            "date":"2017-03-20",
            "timeInUTC":"2017-03-28T11:00:13",
            "cpCurrentT":"",
            "currentT":"22",
            "desiredT":"24.0"
        },
        {
            "date":"2017-03-21",
            "timeInUTC":"2017-03-29T11:00:13",
            "cpCurrentT":"38",
            "currentT":"26",
            "desiredT":"26.0"
        },
        {
            "date":"2017-03-22",
            "timeInUTC":"2017-03-23T11:00:13",
            "cpCurrentT":"36",
            "currentT":"26",
            "desiredT":"26.0"
        },
        {
            "date":"2017-03-23",
            "timeInUTC":"2017-03-28T11:00:13",
            "cpCurrentT":"31",
            "currentT":"22",
            "desiredT":"24.0"
        },
        {
            "date":"2017-03-24",
            "timeInUTC":"2017-03-29T11:00:13",
            "cpCurrentT":"38",
            "currentT":"26",
            "desiredT":"26.0"
        }
    ];


    var langArr = Object.keys(LANGUAGE_FILE.language);
    if (langArr.indexOf(LANG.toUpperCase())!== -1){
        $scope.translation = LANGUAGE_FILE["language"][LANG.toUpperCase()];
    } else if(langArr.indexOf(LANG.toUpperCase().substring(0,2))!== -1){
        $scope.translation = LANGUAGE_FILE["language"][LANG.toUpperCase().substring(0,2)];
    } else {
        $scope.translation = LANGUAGE_FILE["language"]["DEFAULT"];
    }
    $scope.selectedLanguage = LANG;
    
    // Set text on toggle switch
    $scope.switchON = 'I';
    $scope.switchOff = 'O';
    if (LANG.toUpperCase().indexOf('EN') !== -1) {
        $scope.switchON = 'ON';
        $scope.switchOff = 'OFF';
    }
    
    //Scope variable declaration.
    $scope.checkResponse = [];
    $scope.deviceType = "FAC";    
    $scope.countrySelectionPopupVisible = false;
    $scope.countrySelectedIndex = 0;
    $scope.countryToSelect = [];
    $scope.countryToSelect.push({'Country': 'Belgium'});
    $scope.countryToSelect.push({'Country': 'Belgium(F)'});
    $scope.containSubCl = "containSub"; //initially the class should be present.
    $scope.BottomPopupDivCls = '';// Initially no class should be applicable.
    $scope.BottomPopupDimBackgroundDiv = '';// Initially no class should be applicable.
    $scope.volumePopupBakgroundDivCls = '';// Initially no class should be applicable.
    $scope.volumePopupBGCls = '';// Initially no class should be applicable.
    $scope.dialogPopup = false;
    $scope.alertState = -1;
    $scope.isRadioSelection = false;
    $scope.showServiceCenterText = false;
    $scope.popupTitle = '';
    $scope.popupMessage = '';
    $scope.popupOkBtn = '';
    $scope.popupCancelBtn = '';
    $scope.DehumidificationValue = '-';
    $scope.autoCleanProgressValue = 0;
    $scope.outdoorTemp = '-';
    $scope.currentScreen = FACSCREENS.HOME;
    $scope.previousScreen = FACSCREENS.HOME;
    $scope.lighting = null;
    $scope.supportedModes = [];
    $scope.supportedModesIcon = [];
    $scope.supportedWindDirection = [];    
    $scope.Actions = [{id: '0', 'Actuators': [{Operation: {power: ''}, deviceIDs: []}], dayOfWeek: [], disposable: false, enabled: true, startTime: ''}];
    $scope.selectedSchedule = {id: '', power: 'On', dayOfWeek: [], disposable: true, hours: 0, minutes: 0, amPm: 0, keypadOn: false};
    $scope.ScheduleText = $scope.translation.WEBMOB_common_none;
    $scope.HOADisplayValue = 2;
    $scope.aiSupported = false;
    $scope.aiEnabled = false;
    $scope.aiActive = '';
    $scope.aiGuideText = '';
    $scope.aiFavorTemp = 0;
    $scope.is_aiConnectionFail = false;
    $scope.aiConnectionFailTimerOn = false;
    $scope.ai401ErrorCount = 0;

    if (window.navigator.platform === 'iPhone' || window.navigator.platform === 'iPad') {
        $scope.isAppleDevice = true;
    } else {
        $scope.isAppleDevice = false;
    }
    
    function parseRequestResponse(response) {
        if (angular.isDefined(response["status"]) && response["status"] === STCONST.STATUS_99000) {
            showConnectionFailurePopup();
        }
        
        if (angular.isDefined(response["data"])) {
            // For home multi specific code
            var device;
            if (angular.isDefined(response["data"]["Devices"])) {
                response["data"]["Devices"].forEach(function (value) {
                    if (value["uuid"] === $scope.deviceUuid) {
                        device = value;
                    }
                });
                if (angular.isDefined(device)) {
                    init();
                    parseDeviceData(device, response.resourceURL);
                } else {
                    showConnectionFailurePopup();
                }
                if (!!!$scope.loadingBar) { // No loading bar means request handled properly. So, clear array.
                    SHPService.clearStopVarArray();
                }
                return;
            }        
            if (angular.isDefined(response["data"]["Configuration"])) {
                parseConfiguration(response["data"]["Configuration"]);
                if(!$scope.isStatic && $scope.aiSupported) {
                    getTrainingAIInfo();
                }

            }
            if (angular.isDefined(response["data"]["EnergyConsumption"]) && (angular.isDefined(response["data"]["EnergyConsumption"]["cumulativeConsumption"])
                    || angular.isDefined(response["data"]["EnergyConsumption"]["usageThreshold"]) || angular.isDefined(response["data"]["EnergyConsumption"]["monthlyConsumption"]))) {
                parsePowerConsumption(response["data"]["EnergyConsumption"]);
            }
            if (angular.isDefined(response["data"]["Actions"])) {
                parseActionData(response["data"]["Actions"]);
            }
            if (angular.isDefined(response["data"]["weatherData"])) {
                updateWeatherData(response);
            }
            if (angular.isDefined(response["data"]["airData"])) {
                outDoorPuirtyData(response["data"]["airData"]);
            }
            if (angular.isDefined(response["data"]["Information"])) {
                parseModuleInformation(response["data"]["Information"]);
            }
            if (angular.isDefined(response["data"]["getTrainingDate"])) {
                if (angular.isDefined(response["status"]) && response["status"] >= 200 && response["status"] <= 300) {
                    parseGetTrainingDate(response["data"]["getTrainingDate"]);
                } else {
                    //show 'Server connection Failed.' notification.
                    parseGetTrainingDate(response["data"]["getTrainingDate"]);
                    if(angular.isDefined(response["status"]) && response["status"] == 401){
                        $scope.ai401ErrorCount++;
                    }
                    if($scope.ai401ErrorCount == 2){
                        console.log("retry for 401 error");
                        getTrainingAIInfo();
                    }
                    else if($scope.ai401ErrorCount > 2 || $scope.ai401ErrorCount == 0){
                        if (!$scope.is_aiConnectionFail) {
                            console.log("show error");
                            $scope.is_aiConnectionFail = true;
                            $scope.aiConnectionFailTimerOn = true;
                            $timeout(function () {
                                $scope.aiConnectionFailTimerOn = false;
                            }, 3000);
                        }
                    }
                }
            }
            if (angular.isDefined(response["data"]["getTrainingRate"])) {
                parseGetTrainingRate(response["data"]["getTrainingRate"]);
            }
            if (angular.isDefined(response["data"]["resetTrainingRate"])) {
                parseResetTrainingRate(response["data"]["resetTrainingRate"]);
            }
        }
        if (angular.isDefined(response["resourceURL"])) {
            if (response["resourceURL"].indexOf("files") != -1) {
                $scope.isDBDownloaded = true;
                isDBDownloadedJS = true;                
            }
            if (angular.isDefined(response["data"])) {
                if (!angular.isDefined(response["data"]["Actions"]) && (response["resourceURL"].indexOf("/actions/") !== -1 || response["resourceURL"].indexOf("/actions") !== -1)) {
                    if (angular.isDefined(response["status"]) && response["status"] === STCONST.STATUS_99000) {
                        // Nothing
                    } else {
                        scheduleList(true);
                    }                    
                }                    
            } else {
                if (response["resourceURL"].indexOf("/undefined/") !== -1 || response["resourceURL"].indexOf("/undefined") !== -1) {
                    return;
                }
                if (response["resourceURL"].indexOf("/actions/") !== -1 || response["resourceURL"].indexOf("/actions") !== -1) {
                    if (angular.isDefined(response["status"]) && response["status"] === STCONST.STATUS_99000) {
                        // Nothing
                    } else {
                        scheduleList(true);
                    }                    
                }
            }
        }
        if (response.status >= 200 && response.status < 300) { //<300 is succes only. Refer http://www.w3.org/Protocols/rfc2616/rfc2616-sec10.html for status code definitions.
            handleStatusCode(response.status, response);
        }
    }
    
    function parseNotification(response) {
        if (angular.isDefined(response["softKeypadVisibility"])) {
            onKeypadShown(false);
        }
        if (angular.isDefined(response["data"])) {
            if (response["data"] === "backPressed") {
                //if loding bar visible, don't handle back key
                if (!!!$scope.loadingBar) {
                    onBackPressed();
                }
                return;
            }
            if (angular.isDefined(response["data"]["mobileTimeChanged"])){
                return;
            }
            if (angular.isDefined(response["data"].isApplicationActive) && !$scope.isStatic) {
                handleAppAtForeground();
                callGetDevice();
                return;
            }
            if (angular.isDefined(response["data"][0]) && angular.isDefined(response["data"][0]["Device"]) && angular.isDefined(response["data"][0]["Device"]["scsConnectionState"])) {
                if (!response["data"][0]["Device"]["scsConnectionState"]) {
                    showConnectionFailurePopup();
                } else if (response["data"][0]["Device"]["scsConnectionState"]) {
                    closeConnectionFailurePopup();                        
                    callGetDevice();
                }
                return;
            }
            if (angular.isDefined(response["data"][0]) && (angular.isDefined(response["data"][0]["Configuration"]))) {
                $scope.parseConfiguration(response["data"][0]["Configuration"]);
                return;
            }
            if(response["data"] instanceof Array) {
                response["data"].forEach(function (value) {
                    parseDeviceData(value);
                });
            } else {
                parseDeviceData(response["data"]);
            }
        }
    }

    $scope.aiGraphData = {};
    function parseGetTrainingDate(trainingDate) {
        console.log("parseGetTrainingDate", trainingDate);
        $scope.trainingHistoryData = [];
        $scope.predictionData = undefined;

        var mode = trainingDate["mode"];//.toLowerCase();
        if (angular.isDefined(mode)) {
            $scope.aiGraphData[mode] = trainingDate;
        } else {
            //error data
            if (angular.isUndefined($scope.aiGraphData["error"]))
                $scope.aiGraphData["error"] = [];
            $scope.aiGraphData["error"].push(trainingDate);
        }
        dismissLoadingBar("getTrainingDate");


        if (angular.isDefined(trainingDate.historyData)) {
            $scope.trainingHistoryData = trainingDate.historyData;
        }
        if (angular.isDefined(trainingDate.predictionData)) {
            $scope.predictionData = trainingDate.predictionData;
        }

        $scope.createNewChart();
    }
    
    function parseGetTrainingRate(trainingRate) {
        console.log("parseGetTrainingRate");
        if (angular.isDefined(trainingRate.totalDataCnt)) {
            $scope.totalDataCnt = trainingRate.totalDataCnt;
        }
        if (angular.isDefined(trainingRate.oldModelPercentage)) {
            $scope.oldModelPercentage = trainingRate.oldModelPercentage;
        }
        if (angular.isDefined(trainingRate.newModelPercentage)) {
            $scope.newModelPercentage = trainingRate.newModelPercentage;
        }
    }
    
    function parseResetTrainingRate(trainingRate) {
        console.log("parseResetTrainingRate");
        if (angular.isDefined(trainingRate.result)) {
            $scope.resetTrainingRate = trainingRate.result;
        }
    }
    
    function parseRequestAccepted(response){
        if (angular.isDefined(response["data"]) && angular.isDefined(response["data"]["energyData"])) {
            $scope.parseEnergyUsageData(response["data"]);
        }
    }
    
    function callGetDevice() {
        SHPService.getDevices($scope);
    }
    
    // Toggle class for body
    function toggleAnimClass() {
        if ($scope.containSubCl === "containSub") {
            $scope.containSubCl = "";
        } else {
            $scope.containSubCl = "containSub";
        }
    }
    
    $scope.ModeSelectionPopupDivCls = '';// Initially no class should be applicable.
    // Toggle class for Mode drop down
    function changePopUpClass() {
        if ($scope.showModeSelectionPopup) {
            $scope.ModeSelectionPopupDivCls = "ModeSelectionPopupDiv";
        } else {
            $scope.ModeSelectionPopupDivCls = "ModeSelectionPopOutDiv";
        }
    }

    function toggleVentPopUpClass(popupName) {
        if (popupName) {
            $scope.BottomPopupDimBackgroundDiv = "BottomPopupDimBackgroundDivIn";
            $scope.BottomPopupDivCls = "ventBgIn";
        } else {
            $scope.BottomPopupDimBackgroundDiv = "BottomPopupDimBackgroundDivOut";
            $scope.BottomPopupDivCls = "ventBgOut";
        }
    }

    function toggleBottomPopUpClass(popupName) {
        if (popupName) {
            $scope.BottomPopupDimBackgroundDiv = "BottomPopupDimBackgroundDivIn";
            $scope.BottomPopupDivCls = "BottomPopupBGIn";
        } else {
            $scope.BottomPopupDimBackgroundDiv = "BottomPopupDimBackgroundDivOut";
            $scope.BottomPopupDivCls = "BottomPopupBGOut";
        }
    }
    
    function togglePowerOffPopUpClass(popupName) {
        if (popupName) {
            $scope.BottomPopupDimBackgroundDiv = "BottomPopupDimBackgroundDivIn";
        } else {
            $scope.BottomPopupDimBackgroundDiv = "BottomPopupDimBackgroundDivOut";
        }
    }

    // Toggle class for Mode drop down
     function toggleVolumePopUpClass() {
        var OkCanceldialogPopup = document.getElementById("volumeControlPopup");
        if ($scope.showVolumePopup) {
            $scope.volumePopupBakgroundDivCls = "volumePopupDivIn";
            OkCanceldialogPopup.style.display = "block";
            $scope.volumePopupBGCls = "volumePopupBGIn";

        } else {
            $scope.volumePopupBakgroundDivCls = "volumePopupDivOut";
            $scope.volumePopupBGCls = "volumePopupBGOut";
            setTimeout(function () {
                OkCanceldialogPopup.style.display = "none";
            }, 0);
        }
    };

    $scope.onBottonPopupClose = function () {
        $scope.showVentSelectionPopup = false;
        toggleVentPopUpClass($scope.showVentSelectionPopup);
    };

    $scope.closeWindStrengthPopup = function () {
        $scope.showWindStrengthPopup = false;
        toggleBottomPopUpClass($scope.showWindStrengthPopup);
    };

    $scope.closeWindDirectionPopup = function () {
        $scope.showWindDirectionPopup = false;
        toggleBottomPopUpClass($scope.showWindDirectionPopup);
    };

    $scope.closeRelaxModePopup = function () {
        $scope.showRelaxModePopup = false;
        toggleBottomPopUpClass($scope.showRelaxModePopup);
    };
    $scope.closeAddWindModeSelectionPopup = function () {
        $scope.showAddWindModeSelectionPopup = false;
        toggleBottomPopUpClass($scope.showAddWindModeSelectionPopup);
    };

    $scope.$watch(function () {
        return $scope.currentWindStrength;
    }, function (newVal, oldVal) {
        if (newVal !== oldVal && angular.isDefined($scope.currentWindStrength)) {
            $scope.getWindStrengthImage($scope.currentWindStrength);
        }
    });   

    $scope.$watch(function () {
        return $scope.currentWindDirection;
    }, function (newVal, oldVal) {
        if (newVal !== oldVal && angular.isDefined($scope.currentWindDirection)) {
            $scope.getWindDirectionImage($scope.currentWindDirection);
        }
    });

    $scope.$watch(function () {
        return $scope.currentVentLevel;
    }, function (newVal, oldVal) {
        if (newVal !== oldVal && angular.isDefined($scope.currentVentLevel)) {
            $scope.getVentImageClass($scope.currentVentLevel);
        }
    });

    $scope.$watch(function () {
        return $scope.isDBDownloaded;
    }, function () {
        if (angular.isDefined($scope.isDBDownloaded)) {
            pcDisableCheck();
        }
    });

    $scope.$watch(function () {
        return $scope.weatherCurrentData;
    }, function () {
        if (angular.isDefined($scope.weatherCurrentData) && angular.isDefined($scope.weatherCurrentData.reCondition)) {
            $scope.getWeatherIcon($scope.weatherCurrentData.reCondition);
        }
    });

    // Control hours value in add schedule screen
    $scope.$watch(function () {
        return $scope.selectedSchedule.hours;
    }, function (newVal, oldVal) {
        if (newVal > 12) {
            $scope.selectedSchedule.hours = oldVal;
        }
        if (newVal === undefined) {
            $scope.selectedSchedule.hours = oldVal;
        }
    });

    // Control minutes value in add schedule screen
    $scope.$watch(function () {
        return $scope.selectedSchedule.minutes;
    }, function (newVal, oldVal) {
        if (newVal > 59) {
            $scope.selectedSchedule.minutes = oldVal;
        }
        if (newVal === undefined) {
            $scope.selectedSchedule.minutes = oldVal;
        }
    });
    
    $scope.onHoursLostFocus = function () {
        $scope.inputFocusHoursMin = false;
        if ($scope.selectedSchedule.hours === "0" || $scope.selectedSchedule.hours === "00") {
            $scope.selectedSchedule.hours = 12;
        }
        if ($scope.selectedSchedule.hours === "") {
            $scope.selectedSchedule.hours = $scope.oldValueHours;
        }
        $scope.selectedSchedule.hours = Number($scope.selectedSchedule.hours);
        $scope.selectedSchedule.hours = ($scope.selectedSchedule.hours < 10) ? ('0' + $scope.selectedSchedule.hours) : $scope.selectedSchedule.hours;
    };

    $scope.onMinsLostFocus = function () {
        $scope.inputFocusHoursMin = false;
        if ($scope.selectedSchedule.minutes === "") {
            $scope.selectedSchedule.minutes = $scope.oldValueMins;
        }
        $scope.selectedSchedule.minutes = Number($scope.selectedSchedule.minutes);
        $scope.selectedSchedule.minutes = ($scope.selectedSchedule.minutes < 10) ? ('0' + $scope.selectedSchedule.minutes) : $scope.selectedSchedule.minutes;
    };

    $scope.onHoursMinsFocusGain = function () {
        $scope.oldValueHours = $scope.selectedSchedule.hours;
        $scope.oldValueMins = $scope.selectedSchedule.minutes;        
        if (!$scope.isAppleDevice) {
            $scope.inputFocusHoursMin = true;
            setTimeout(function() {
                document.activeElement.scrollIntoView();
            }, 10);
        }
    };

    // Array items for all popups    
    var listOfModes =
            [{
                    id: 1,
                    imageID: 'FAC/assets/img/main_drop_list_ic_cool.svg#Layer_1',
                    modeName: "Cool",
                    textToDisplay: "ACMOB_mode_cool"
                }, {
                    id: 2,
                    imageID: 'FAC/assets/img/main_drop_list_ic_dry.svg#Layer_1',
                    modeName: "Dry",
                    textToDisplay: "ACMOB_mode_dry"
                }, {
                    id: 3,
                    imageID: 'FAC/assets/img/main_drop_list_ic_purifiy.svg#Layer_1',
                    modeName: "Wind",
                    textToDisplay: "WEBMOB_device_fac_mode_purify"
                }, {
                    id: 5,
                    imageID: 'FAC/assets/img/main_drop_list_ic_cool_purify_selected.svg#Layer_1',
                    modeName: "CoolClean",
                    textToDisplay: "WEBMOB_device_fac_mode_cool_purify"
                }, {
                    id: 6,
                    imageID: 'FAC/assets/img/main_drop_list_ic_dry_purify_selected.svg#Layer_1',
                    modeName: "DryClean",
                    textToDisplay: "WEBMOB_device_fac_mode_dry_purify"
                }, {
                    id: 0,
                    imageID: 'FAC/assets/img/main_drop_list_ic_auto.svg#Layer_1',
                    modeName: "Auto",
                    textToDisplay: "ACMOB_mode_auto"
                }, {
                    id: 4,
                    imageID: 'FAC/assets/img/main_drop_list_ic_heat.svg#Layer_1',
                    modeName: "Heat",
                    textToDisplay: "ACMOB_mode_heat"
                }, {
                    id: 7,
                    imageID: 'FAC/assets/img/main_drop_list_ic_heat_purify_selected.svg#Layer_1',
                    modeName: "HeatClean",
                    textToDisplay: "WEBMOB_device_fac_mode_heat_purify"
                }],
    listWindStrength =
            [{
                    id: 0,
                    imageID: 'FAC/assets/img/main_list_ic_wind_auto.svg#Layer_1',
                    modeName: "Auto",
                    textToDisplay: "ACMOB_wind_level_auto"
                }, {
                    id: 1,
                    imageID: 'FAC/assets/img/main_list_ic_wind_low.svg#Layer_1',
                    modeName: "Low",
                    textToDisplay: "ACMOB_wind_level_low"
                }, {
                    id: 2,
                    imageID: 'FAC/assets/img/main_list_ic_wind_medium.svg#Layer_1',
                    modeName: "Mid",
                    textToDisplay: "ACMOB_wind_level_mid"
                }, {
                    id: 3,
                    imageID: 'FAC/assets/img/main_list_ic_wind_high.svg#Layer_1',
                    modeName: "High",
                    textToDisplay: "ACMOB_wind_level_high"
                }, {
                    id: 4,
                    imageID: 'FAC/assets/img/main_list_ic_wind_turbo.svg#Layer_1',
                    modeName: "Turbo",
                    textToDisplay: "ACMOB_wind_level_turbo"
                }],
    listWindDirection =
            [{
                    id: 1,
                    imageID: 'FAC/assets/img/main_list_ic_off.svg#Layer_1',
                    modeName: "Off",
                    textToDisplay: "ACMOB_wind_option_no_direction"
                }, {
                    id: 2,
                    imageID: 'FAC/assets/img/main_list_ic_wide.svg#Layer_1',
                    modeName: "Wide",
                    textToDisplay: "ACMOB_wind_direction_wide"
                }, {
                    id: 3,
                    imageID: 'FAC/assets/img/main_list_ic_center.svg#Layer_1',
                    modeName: "Center",
                    textToDisplay: "ACMOB_wind_direction_center"
                }, {
                    id: 4,
                    imageID: 'FAC/assets/img/main_list_ic_direct.svg#Layer_1',
                    modeName: "Direct",
                    textToDisplay: "ACMOB_wind_option_direct"
                }, {
                    id: 5,
                    imageID: 'FAC/assets/img/main_list_ic_indirect.svg#Layer_1',
                    modeName: "Indirect",
                    textToDisplay: "ACMOB_wind_option_indirect"
                }, {
                    id: 6,
                    imageID: 'FAC/assets/img/main_list_ic_long.svg#Layer_1',
                    modeName: "Long",
                    textToDisplay: "ACMOB_wind_direction_long"
                }];
    // List of relax data
    $scope.ListOfRelaxModes =
            [{
                    modeName: "Off",
                    textToDisplay: "ACMOB_rest_wind_off"
                }, {
                    modeName: "Forest",
                    textToDisplay: "WEBMOB_fac_options_relex_forest"
                }, {
                    modeName: "Wave",
                    textToDisplay: "WEBMOB_fac_options_relex_Wave"
                }, {
                    modeName: "ValleyWater",
                    textToDisplay: "WEBMOB_fac_options_relex_valley_water"
                }];
    // List of default data
    $scope.defaultConfig = {
        "Auto": {
            "configTempLow": 18,
            "configTempHigh": 30,
            "configTempDefault": 23,
            "configWindStrength": 0,
            "configWindDirection": "Off"
        },
        "Cool": {
            "configTempLow": 18,
            "configTempHigh": 30,
            "configTempDefault": 18,
            "configWindStrength": 3,
            "configWindDirection": "Center"
        },
        "Dry": {
            "configTempLow": 18,
            "configTempHigh": 30,
            "configTempDefault": 24,
            "configWindStrength": 0,
            "configWindDirection": "Center"
        },
        "Wind": {
            "configTempLow": 18,
            "configTempHigh": 30,
            "configTempDefault": 23,
            "configWindStrength": 0,
            "configWindDirection": "Center"
        },
        "Heat": {
            "configTempLow": 16,
            "configTempHigh": 30,
            "configTempDefault": 24,
            "configWindStrength": 0,
            "configWindDirection": "Center"
        },
        "CoolClean": {
            "configTempLow": 18,
            "configTempHigh": 30,
            "configTempDefault": 18,
            "configWindStrength": 3,
            "configWindDirection": "Center"
        },
        "HeatClean": {
            "configTempLow": 16,
            "configTempHigh": 30,
            "configTempDefault": 24,
            "configWindStrength": 0,
            "configWindDirection": "Center"
        },
        "DryClean": {
            "configTempLow": 18,
            "configTempHigh": 30,
            "configTempDefault": 24,
            "configWindStrength": 0,
            "configWindDirection": "Center"
        }
    };
    $scope.optionsMenu = [{
        id: 0,
        title: $scope.translation.WEBMOB_common_settings
    }, {
        id: 1,
        title: $scope.translation.WEBMOB_common_about_device
    }];
    $scope.DeviceOptions = {
        inDoorData: {
            pm10: {
                value: -1,
                purity: -1,
                purityText: '',
                colorClass: ''
            },
            pm25: {
                value: -1,
                purity: -1,
                purityText: '',
                colorClass: ''
            },
            odor: {
                purity: -1,
                purityText: '',
                colorClass: ''
            },
            freshness: {
                purity: -1,
                purityText: '',
                colorClass: '',
                iconClass: 'purity-level-off'
            }
        },
        outDoorData: {
            pm10: {
                value: -1,
                purity: -1,
                purityText: '',
                colorClass: ''
            },
            SO2: {
                value: -1,
                purity: -1,
                purityText: '',
                colorClass: ''
            },
            O3: {
                value: -1,
                purity: -1,
                purityText: '',
                colorClass: ''
            },
            CO: {
                value: -1,
                purity: -1,
                purityText: '',
                colorClass: ''
            },
            N2O2: {
                value: -1,
                purity: -1,
                purityText: '',
                colorClass: ''
            },
            KHAI: {
                value: -1,
                purity: -1,
                purityText: '',
                colorClass: '',
                iconClass: 'purity-level-off'
            }
        },
        outdoorInfoText: ''
    };
    $scope.Device = {
        Sensors: [],
        Alarms: [{
                alarmType: '',
                code: '',
                id: '',
                triggeredTime: ''
            }],
        Humidity: {
            current: -1
        }
    };
    $scope.LightingModes = [{
        modeName: "Small",
        textToDisplay: $scope.translation.WEBMOB_device_fac_lighting_weak
    }, {
        modeName: "On",
        textToDisplay: $scope.translation.WEBMOB_device_fac_lighting_medium
    }, {
        modeName: "Huge",
        textToDisplay: $scope.translation.WEBMOB_device_fac_lighting_maximum
    }, {
        modeName: "Off",
        textToDisplay: $scope.translation.WEBMOB_device_fac_lighting_Off
    }];
    $scope.VoiceSelectionModes = [{
        modeName: "33",
        textToDisplay: $scope.translation.WEBMOB_device_fac_voice_min
    }, {
        modeName: "66",
        textToDisplay: $scope.translation.WEBMOB_device_fac_voice_default
    }, {
        modeName: "100",
        textToDisplay: $scope.translation.WEBMOB_device_fac_voice_max
    }, {
        modeName: "Melody",
        textToDisplay: $scope.translation.WEBMOB_device_fac_voice_sound
    }, {
        modeName: "Mute",
        textToDisplay: $scope.translation.WEBMOB_device_fac_voice_mute
    }];
    
    
    //power button
    $scope.powerOnOff = function (fromVent) {
        if (!$scope.isStatic) {
            $scope.checkResponse.push(FACCONST.POWEROPERATION);
            if ($scope.powerOperation) {
                SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getPowerCommand($scope.powerOperation, fromVent), "/" + $scope.peerId + "/devices/0");
            } else {
                SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getPowerCommand($scope.powerOperation, fromVent), "/" + $scope.peerId + "/devices/0/operation");
            }
        } else {
            $scope.powerOperation = !$scope.powerOperation;
        }
    };
    
    // Temperature controller start here
    function increaseTemp() {
        canIncreaseTemp($scope.desiredTemp) && updateTemp($scope.desiredTemp + 1);
    }
    
    function decreaseTemp() {
        canDecreaseTemp($scope.desiredTemp) && updateTemp($scope.desiredTemp - 1);
    }
    
    function canIncreaseTemp(temp, diff) {
        return (!$scope.disableTempControl && (+temp - (diff || 0)) < $scope.defaultConfig[$scope.currentMode].configTempHigh);
    }
    
    function canDecreaseTemp(temp, diff) {
        return (!$scope.disableTempControl && (+temp + (diff || 0)) > $scope.defaultConfig[$scope.currentMode].configTempLow);
    }
    
    function changeTempOnTouch(isIncreasing) {
        var elem = document.getElementById("tempDisp");
        if (isIncreasing && canIncreaseTemp($scope.desiredTemp)) {
            $scope.desiredTemp = +$scope.desiredTemp + 1;
            $scope.desiredTemp = ($scope.desiredTemp < 10 ? '0' : '') + $scope.desiredTemp;
            elem.innerHTML = $scope.desiredTemp;
        } else if (!isIncreasing && canDecreaseTemp($scope.desiredTemp)){
            $scope.desiredTemp = +$scope.desiredTemp - 1;
            $scope.desiredTemp = ($scope.desiredTemp < 10 ? '0' : '') + $scope.desiredTemp;
            elem.innerHTML = $scope.desiredTemp;            
        }
    }
    
    function updateTemp(temp) {
        if (!$scope.isStatic) {
            $scope.checkResponse.push(FACCONST.TEMPCHANGE);
            SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getTempCommand($scope.currentMode, temp, 0), "/" + $scope.peerId + "/devices/0");
            $scope.defaultConfig[$scope.currentMode].configTempDefault = temp;
            
            // For 17K model, we need to maintain same default temperature for Cool & Cool,Purify modes (same applicable for Dry & Heat modes)
            if (is17KModel()) {
                if ($scope.currentMode === "Cool" || $scope.currentMode === "CoolClean") {
                    $scope.defaultConfig["Cool"].configTempDefault = temp;
                    $scope.defaultConfig["CoolClean"].configTempDefault = temp;
                }
                if ($scope.currentMode === "Dry" || $scope.currentMode === "DryClean") {
                    $scope.defaultConfig["Dry"].configTempDefault = temp;
                    $scope.defaultConfig["DryClean"].configTempDefault = temp;
                }
                if ($scope.currentMode === "Heat" || $scope.currentMode === "HeatClean") {
                    $scope.defaultConfig["Heat"].configTempDefault = temp;
                    $scope.defaultConfig["HeatClean"].configTempDefault = temp;
                }
            }
        } else {
            $scope.desiredTemp = temp;
        }
    }
    
    function setIncreaseTempOnTouchStart() {
        if (!!!promise) {
            promise = $interval(function () {
                if (canIncreaseTemp($scope.desiredTemp)) {
                    increaseTempConinous = true;
                    changeTempOnTouch(true);
                }
            }, 300);
        }
    }
    
    function setDecreaseTempOnTouchStart() {
        if (!!!promise) {
            promise = $interval(function () {
                if (canDecreaseTemp($scope.desiredTemp)) {
                    decreaseTempConinous = true;
                    changeTempOnTouch(false);
                }
            }, 300);
        }
    }
    // Temperature controller end here
    
    // Device commands start
    $scope.getModeCommand = function (mode, c_direction, c_speedlevel, c_defaultTemp, isFromPurify) {
        if (is14KModel() || is15KModel()) {
            return '{"Device":{"Mode":{"modes":["' + mode + '"],"options":["Comode_Off"]},"Wind":{"direction":"' + c_direction + '","speedLevel":' + c_speedlevel + '},"Temperatures":[{"id":"0","desired":' + c_defaultTemp + '}]}}';
        } else if (is16KModel() || is17KModel()) {
            if (c_direction === "Long") {
                c_direction = "Center";
            }
            
            // If we change Dry <-> Dry Purify mode, then we should not send temperatures, same applies to Cool and Heat modes as well (only for 17k FAC)
            var temperatureArray = isFromPurify ? "" : ',"Temperatures":[{"id":"0","desired":' + c_defaultTemp + '}]';
            
            if ($scope.nanoWind && mode !== "Auto") {
                if ((mode === "Cool" || mode === "CoolClean") && $scope.goodSleep) {
                    return '{"Device":{"Mode":{"modes":["' + mode + '"]},"Wind":{"direction":"Off","speedLevel":0}' + temperatureArray + '}}';
                }
                return '{"Device":{"Mode":{"modes":["' + mode + '"],"options":["Comode_Nano"]},"Wind":{"direction":"Off","speedLevel":0}' + temperatureArray + '}}';
            } else {
                if ((mode === "Cool" || mode === "CoolClean") && $scope.goodSleep) {
                    return '{"Device":{"Mode":{"modes":["' + mode + '"]},"Wind":{"direction":"' + c_direction + '","speedLevel":' + c_speedlevel + '}' + temperatureArray + '}}';
                }
                // note : We should send modes only while switching purify On/Off option in 17K FAC
                var tempComodeOption = isFromPurify ? "}}}" : ',"options":["Comode_Off"]}, "Wind":{"direction":"' + c_direction + '", "speedLevel":' + c_speedlevel + '}' + temperatureArray + '}}';
                return '{"Device":{"Mode":{"modes":["' + mode + '"]' + tempComodeOption;
            }
        } else {
            // Nothing
        }
    };
    $scope.getTempCommand = function (mode, tempValue, tempId) {
        return '{"Device":{"Mode":{"modes":["' + mode + '"]},"Temperatures":[{"id":"' + tempId + '","desired":' + tempValue + '}]}}';
    };
    $scope.getPowerCommand = function (status, fromVent) {
         if (status) {
            if (fromVent) {
                return '{"Device":{"Mode":{"options":["Comode_Off", "Blooming_0"]},"Operation":{"power":"Off"}}}';
            } else {
                return '{"Device":{"Mode":{"options":["Comode_Off"]},"Operation":{"power":"Off"}}}';
            }            
        } else {
            return '{"Operation": {"power": "On"}}';
        }
    };
    $scope.getWindStrengthCommand = function (speedLevel) {
        if($scope.quiet) {
             return '{"Device":{"Mode":{"options":["Comode_Off"]},"Wind":{"speedLevel":' + speedLevel + '}}}';
         } else {
            return '{"Device":{"Wind":{"speedLevel":' + speedLevel + '}}}';
         }
    };
    $scope.getWindDirectionCommand = function (windDirection) {
        if (windDirection === "Long") {
            if (is16KModel() || is17KModel()) {
                return '{"Device":{"Mode":{"options":["Comode_Off"]},"Wind":{"direction" : "Long","speedLevel" : 0}}}';
            } else {
                return '{"Device":{"Wind":{"direction" : "Long","speedLevel" : 0}}}';
            }
        }
        return '{"Device":{"Wind":{"direction" : "' + windDirection + '"}}}';
    };
    $scope.getVentSelectionCommand = function (bloomLevel) {
        if ($scope.powerOperation) {
            if (is16KModel() || is17KModel()) {
                if (bloomLevel === 1 || bloomLevel === 2 || bloomLevel === 4) {
                    return '{"Device":{"Mode":{"options":["Comode_Off","Blooming_' + bloomLevel + '"]},"Wind":{"speedLevel":0}}}';
                } else {
                    return '{"Device":{"Mode":{"options":["Comode_Off","Blooming_' + bloomLevel + '"]}}}';
                }
            } else {
                if (bloomLevel === 1 || bloomLevel === 2 || bloomLevel === 4) {
                    if ($scope.goodSleep) {
                        return '{"Device":{"Mode":{"options":["Comode_Off","Blooming_' + bloomLevel + '"]},"Wind":{"speedLevel":0}}}';
                    } else {
                        return '{"Device":{"Mode":{"options":["Blooming_' + bloomLevel + '"]},"Wind":{"speedLevel":0}}}';
                    }                    
                } else {
                    if ($scope.goodSleep) {
                        return '{"Device":{"Mode":{"options":["Comode_Off","Blooming_' + bloomLevel + '"]}}}';
                    } else {
                        return '{"Device":{"Mode":{"options":["Blooming_' + bloomLevel + '"]}}}';
                    }
                }
            }
        } else {
            return '{"Device":{"Mode":{"modes":["Cool"],"options":["Blooming_' + bloomLevel + '"]},"Operation":{"power":"On"},"Wind":{"direction":"Off","speedLevel":0},"Temperatures":[{"id":"0","desired":18}]}}';
        }
    };
    $scope.getSmartSensorCommand = function (smartOperation) {
        if (smartOperation) {
            return '{"Device":{"Mode":{"options":["Comode_Off","Blooming_0"]}}}';
        } else {
            if ($scope.goodSleep) {
                return '{"Device":{"Mode":{"modes":["Cool"],"options":["Comode_Smart","Blooming_0"]}}}';
            } else {
                return '{"Device":{"Mode":{"options":["Comode_Smart","Blooming_0"]}}}';
            }
        }
    };

    $scope.getAICommand = function (aiEnabled) {
        if (aiEnabled) {
            return '{"Device":{"Mode":{"options":["AI_Disable"]}}}';
        } else {
            return '{"Device":{"Mode":{"options":["AI_Enable"]}}}';
        }
    };

    $scope.getTurboCommand = function (turboOperation) {
        if(is16KModel() || is17KModel()) {
            if (turboOperation) {
                return '{"Device":{"Mode":{"options":["Comode_Off","Blooming_0"]},"Wind":{"direction":"Center","speedLevel":0}}}';
            } else {
                if ($scope.goodSleep) {
                    return '{"Device":{"Mode":{"modes":["Cool"],"options":["Comode_Speed","Blooming_0","Operation_Family"]},"Wind":{"direction":"Center","speedLevel":0}}}';
                } else {
                    return '{"Device":{"Mode":{"options":["Comode_Speed","Blooming_0","Operation_Family"]},"Wind":{"direction":"Center","speedLevel":0}}}';
                }
            }
        } else {
            if (turboOperation) {
                return '{"Device":{"Mode":{"options":["Comode_Off","Blooming_0"]},"Wind":{"direction":"Off","speedLevel":0}}}';
            } else {
                if ($scope.goodSleep) {
                    return '{"Device":{"Mode":{"modes":["Cool"],"options":["Comode_Speed","Blooming_0","Operation_Family"]},"Wind":{"direction":"Off","speedLevel":0}}}';
                } else {
                    return '{"Device":{"Mode":{"options":["Comode_Speed","Blooming_0","Operation_Family"]},"Wind":{"direction":"Off","speedLevel":0}}}';
                }
            }
        }
    };
    $scope.getOperationSoloCommand = function (operationSolo) {
        if (operationSolo) {
            return '{"Device":{"Mode":{"options":["Blooming_0","Operation_Family"]}}}';
        } else {
            if ($scope.goodSleep) {
                return '{"Device":{"Mode":{"modes":["Cool"],"options":["Comode_Off","Blooming_0","Operation_Solo"]}}}';
            } else {
                return '{"Device":{"Mode":{"options":["Blooming_0","Operation_Solo"]}}}';
            }
        }
    };
    $scope.getQuietCommand = function (quietOperation) {
        if(is16KModel() || is17KModel()) {
            if (quietOperation) {
                return '{"Device":{"Mode":{"options":["Comode_Off","Blooming_0"]},"Wind":{"speedLevel":0,"direction":"Center"}}}';
            } else {
                if ($scope.goodSleep) {
                    return '{"Device":{"Mode":{"modes":["Cool"],"options":["Comode_Quiet","Blooming_0","Operation_Family"]},"Wind":{"speedLevel":0,"direction":"Center"}}}';
                } else {
                    return '{"Device":{"Mode":{"options":["Comode_Quiet","Blooming_0","Operation_Family"]},"Wind":{"speedLevel":0,"direction":"Center"}}}';
                }
            }
        } else {
             if (quietOperation) {
                return '{"Device":{"Mode":{"options":["Comode_Off","Blooming_0"]},"Wind":{"speedLevel":0}}}';
            } else {
                if ($scope.goodSleep) {
                    return '{"Device":{"Mode":{"modes":["Cool"],"options":["Comode_Quiet","Blooming_0","Operation_Family"]},"Wind":{"speedLevel":0}}}';
                } else {
                    return '{"Device":{"Mode":{"options":["Comode_Quiet","Blooming_0","Operation_Family"]},"Wind":{"speedLevel":0}}}';
                }
            }
        }
    };
    $scope.getNanoWindCommand = function (bool) {
        var command;
        if (bool) {
            var comode = "Comode_Off";
            if (is17KModel() && $scope.goodSleep) {
                comode = "Comode_Sleep";
            }
            command = '{"Device":{"Mode":{"options":["' + comode + '"]},"Wind":{"direction":"Center"}}}';            
        } else {
            var comode = "Comode_Nano";
            if (is17KModel() && $scope.goodSleep) {
                comode = "Comode_NanoSleep";
            }
            command = '{"Device":{"Mode":{"options":["' + comode + '","Operation_Family"]},"Wind":{"direction":"Center","speedLevel":0}}}';
        }
        return command;
    };
    $scope.getGoodSleepCommand = function (sleepTime) {
        var goodSleepCommand;
        if (!!sleepTime) {
            var comode = "Comode_Sleep";
            if (is17KModel() && $scope.nanoWind) {
                comode = "Comode_NanoSleep";
            }
            goodSleepCommand = '{"Device": {"Mode": {"modes": ["CoolClean"], "options": ["' + comode + '", "Sleep_' + sleepTime + '", "Blooming_0","Operation_Family"]}, "Wind": {"direction": "Center"}}}';
        } else {
            var comode = "Comode_Off";
            if (is17KModel() && $scope.nanoWind) {
                comode = "Comode_Nano";
            }
            if(is16KModel() || is17KModel()) {
                goodSleepCommand = '{"Device": {"Mode": {"modes": ["Cool"], "options": ["' + comode + '", "Blooming_0"]},"Wind": {"direction": "Center"}}}';
            } else {
                goodSleepCommand = '{"Device": {"Mode": {"modes": ["Cool"], "options": ["' + comode + '", "Blooming_0"]}}}';
            }
        }
        return goodSleepCommand;
    };
    $scope.getRelaxCommand = function (relaxMode) {
        return '{"Device":{"Mode":{"options":["RestWind_' + relaxMode + '"]}}}';
    };
    $scope.getLightCommand = function (light) {
        if (light) {
            return '{"Device":{"Mode":{"options":["Light_Off"]}}}';
        } else {
            return '{"Device":{"Mode":{"options":["Light_On"]}}}';
        }
    };
    function getLightModeCommand(mode) {
        return '{"Device":{"Mode":{"options":["Light_' + mode + '"]}}}';
    }
    $scope.getAutoCleanCommand = function (autoClean) {
        if (autoClean) {
            return '{"Device":{"Mode":{"options":["Autoclean_Off"]}}}';
        } else {
            return '{"Device":{"Mode":{"options":["Autoclean_On"]}}}';
        }
    };
    $scope.getPanelCommand = function (panel) {
        if (panel) {
            return '{"Device":{"Mode":{"options":["Panel_Close"]}}}';
        } else {
            return '{"Device":{"Mode":{"options":["Panel_Open"]}}}';
        }
    };
    $scope.getHumidityCommand = function (humidity) {
        if (humidity) {
            return '{"Device":{"Mode":{"options":["Humidi_Off"]}}}';
        } else {
            return '{"Device":{"Mode":{"options":["Humidi_On"]}}}';
        }
    };
    $scope.getSterilizeCommand = function (sterilize) {
        if (sterilize) {
            return '{"Device":{"Mode":{"options":["Sterilize_Off"]}}}';
        } else {
            return '{"Device":{"Mode":{"options":["Sterilize_On"]}}}';
        }
    };
    function getVolumeCommand(value) {
        return '{"Device":{"Mode":{"options":["Volume_' + value + '"]}}}';
    }
    $scope.getTargetUsageCommand = function (value) {
        return '{"EnergyConsumption":{"usageThreshold":' + value + '}}';
    };
    $scope.getPCVolumeCommand = function () {
        return '{"Device":{"Mode":{"options":["WattNotice_On"]}}}';
    };
    $scope.getConfigCommand = function (value) {
        return '{"Configuration" : {"region" : "' + value + '"}}';
    };
    function getDiagnosisCommand() {
        return '{"Diagnosis": {"diagnosisStart": "Run"}}';
    }
    function serviceCallCommand(centerNumber){
        var payload = '{"selectedCountry" : "' + $scope.selectedCountry + '","selectedDial" :"'+centerNumber+'"}';
        nativeInterface.runOnNative("callDial", payload);
    }
    function getAirMonitoringCommand(bool) {
         if (bool) {
            return '{"Device":{"Mode":{"options":["AirMonitoring_Off"]}}}';
        } else {
            return '{"Device":{"Mode":{"options":["AirMonitoring_On"]}}}';
        }
    }
    // Device command end

    $scope.onAIEnable = function(){
        if (!$scope.isStatic) {
            $scope.checkResponse.push(FACCONST.AI);
            SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getAICommand($scope.aiEnabled), "/" + $scope.peerId + "/devices/0");
        } else {
            $scope.aiEnabled = !$scope.aiEnabled;
        }
    }

    // Options start
    $scope.onOptionsUpdate = function (id) {
        $timeout(function () {
            switch (id) {
                case "smartSensor":
                    if (!$scope.isStatic) {
                        $scope.checkResponse.push(FACCONST.COMODE);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getSmartSensorCommand($scope.smartSensor), "/" + $scope.peerId + "/devices/0");
                    } else {
                        $scope.smartSensor = !$scope.smartSensor;
                    }
                    break;
                case "quiet":
                    if (!$scope.isStatic) {
                        if (!$scope.disableQuietOperation) {
                            $scope.checkResponse.push(FACCONST.COMODE);
                            SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getQuietCommand($scope.quiet), "/" + $scope.peerId + "/devices/0");
                        }
                    } else {
                        $scope.quiet = !$scope.quiet;
                    }
                    break;
                case "solo":
                    if (!$scope.isStatic) {
                        $scope.checkResponse.push(FACCONST.OPERATION_SOLO);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getOperationSoloCommand($scope.solo), "/" + $scope.peerId + "/devices/0");
                    } else {
                        $scope.solo = !$scope.solo;
                    }
                    break;
                case "turbo":
                    if (!$scope.isStatic) {
                        $scope.checkResponse.push(FACCONST.COMODE);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getTurboCommand($scope.turbo), "/" + $scope.peerId + "/devices/0");
                    } else {
                        $scope.turbo = !$scope.turbo;
                    }
                    break;
                case "nanoWind":
                    if(!$scope.disableNanoWindOption) {
                        if (!$scope.isStatic) {
                            $scope.checkResponse.push(FACCONST.COMODE);
                            SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getNanoWindCommand($scope.nanoWind), "/" + $scope.peerId + "/devices/0");
                        } else {
                            $scope.nanoWind = !$scope.nanoWind;
                        }
                    }
                    break;
                case "purify":
                    if (!$scope.isStatic) {
                        var obj = {modeName: ""};
                        obj.modeName = $scope.purify ? $scope.currentMode.split("Clean")[0] : $scope.currentMode + "Clean";
                        $scope.selectMode(obj, true);
                    } else {
                        $scope.purify = !$scope.purify;
                    }
                    break;
                case "long":
                    var obj = {modeName: ""};
                    obj.modeName = ($scope.currentWindDirection === 'Long') ? 'Off' : 'Long';
                    $scope.selectWindDirection(obj);
                    break;
                default:
                    break;
            }

        }, MATERIAL_DESIGN.TOGGLE_TIME);
    };

    var arrayGoodSleep = ["0:00", "0:30", "1:00", "1:30", "2:00", "2:30", "3:00", "4:00", "5:00", "6:00", "7:00", "8:00", "9:00", "10:00", "11:00", "12:00"];
    var arrayDeviceTime = [0, 1, 2, 3, 4, 5, 6, 8, 10, 12, 14, 16, 18, 20, 22, 24];
    var arrayIndexGS;
    $scope.$watch(function () {
        return $scope.tempGoodSleepHr;
    }, function () {
        if ($scope.tempGoodSleepHr > 2) {
            $scope.disableGoodSleepMin = true;
        } else {
            $scope.disableGoodSleepMin = false;
        }
    });
    $scope.openGoodSleepPopup = function () {
        $scope.showGoodSleepPopup = true;
        toggleBottomPopUpClass($scope.showGoodSleepPopup);
        if ($scope.sleep !== 0) {
            arrayDeviceTime.forEach(function (value, index) {
                if (value === $scope.sleep) {
                    arrayIndexGS = index;
                }
            });
        } else {
                arrayIndexGS = getLocalStorageData('goodSleepTime#' + $scope.deviceUuid) === null ? 11 : getLocalStorageData('goodSleepTime#' + $scope.deviceUuid);   
            }            
        $scope.tempGoodSleepHr = parseInt(arrayGoodSleep[arrayIndexGS].split(":")[0], 10);
        $scope.tempGoodSleepMin = arrayGoodSleep[arrayIndexGS].split(":")[1];
    };
    function increaseGoodSleepHr(bool) {
        if (bool) { // increase
            if ($scope.tempGoodSleepMin === "30" && $scope.tempGoodSleepHr === 2) {
                showToast("", $scope.translation.WEBMOB_device_fac_good_sleep_guide_exception);
                return;
            }            
            if ($scope.tempGoodSleepHr !== 12) {
                $scope.tempGoodSleepHr++;
            } else {
                $scope.tempGoodSleepHr = 0;
            }
        } else { // decrease
            if ($scope.tempGoodSleepMin === "30" && $scope.tempGoodSleepHr === 0) {
                showToast("", $scope.translation.WEBMOB_device_fac_good_sleep_guide_exception);
                return;
            }
            if ($scope.tempGoodSleepHr > 0) {
                $scope.tempGoodSleepHr--;
            } else {
                $scope.tempGoodSleepHr = 12;
            }
        }
    }
    function increaseGoodSleepMin() {
        $scope.tempGoodSleepMin = $scope.tempGoodSleepMin === "00" ? "30" : "00";
    }
    $scope.onGoodSleepUpdate = function (bool) {        
        if (bool) { // Yes
            // If it is not correct time, then display toast message and change time to 8:00
            if ($scope.tempGoodSleepHr > 2 && $scope.tempGoodSleepMin === "30") {
                arrayIndexGS = 11;
                $scope.tempGoodSleepHr = parseInt(arrayGoodSleep[arrayIndexGS].split(":")[0], 10);
                $scope.tempGoodSleepMin = arrayGoodSleep[arrayIndexGS].split(":")[1];
                showToast("", $scope.translation.WEBMOB_device_fac_good_sleep_guide_exception);
                return;
            }
            var tempSleepCalc = $scope.tempGoodSleepHr + ":" + $scope.tempGoodSleepMin;
            arrayGoodSleep.forEach(function (value, index) {
                if (value === tempSleepCalc) {
                    arrayIndexGS = index;
                }
            });
            if (!$scope.isStatic) {
                if ($scope.sleep !== arrayDeviceTime[arrayIndexGS]) {
                    $scope.checkResponse.push(FACCONST.COMODE);
                    SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getGoodSleepCommand(arrayDeviceTime[arrayIndexGS]), "/" + $scope.peerId + "/devices/0");
                    if (arrayIndexGS !== 0 && arrayIndexGS !== undefined){
                        setLocalStorageData('goodSleepTime#' + $scope.deviceUuid, arrayIndexGS);
                    }
                }
            } else {
                $scope.sleep = arrayDeviceTime[arrayIndexGS];
            }
        }
        $scope.showGoodSleepPopup = false;
        toggleBottomPopUpClass($scope.showGoodSleepPopup);
    };
    $scope.checkGoodSleepOnOff = function () {
        return $scope.translation[!!$scope.sleep ? 'WEBMOB_common_on' : 'WEBMOB_common_off'];
    };    
    // Options end

    // Settings start
    $scope.onSettingsUpdate = function (id) {
        $timeout(function () {
            switch (id) {
                case "lighting":
                    if ($scope.powerOperation) {
                        if (!$scope.isStatic) {
                            $scope.checkResponse.push(FACCONST.LIGHTING);
                            SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getLightCommand($scope.lighting), "/" + $scope.peerId + "/devices/0");
                        } else {
                            $scope.lighting = !$scope.lighting;
                        }
                    }
                    break;
                case "autoClean":
                    if (!$scope.disableAutoClean) {
                        if (!$scope.isStatic) {
                            $scope.checkResponse.push(FACCONST.AUTOCLEAN);
                            SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getAutoCleanCommand($scope.autoClean), "/" + $scope.peerId + "/devices/0");
                        } else {
                            $scope.autoClean = !$scope.autoClean;
                        }
                    }
                    break;
                case "panel":
                    if (!$scope.disablePanel) {
                        if (!$scope.isStatic) {
                            $scope.checkResponse.push(FACCONST.PANEL);
                            SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getPanelCommand($scope.panel), "/" + $scope.peerId + "/devices/0");
                        } else {
                            $scope.panel = !$scope.panel;
                        }
                    }
                    break;
                case "bacteriostasis":
                    if (!$scope.disableBacteriostasis) {
                        if (!$scope.isStatic) {
                            $scope.checkResponse.push(FACCONST.HUMIDIFY);
                            SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getHumidityCommand($scope.bacteriostasis), "/" + $scope.peerId + "/devices/0");
                        } else {
                            $scope.bacteriostasis = !$scope.bacteriostasis;
                        }
                    }
                    break;
                case "sterilization":
                    if (!$scope.disableSterilize) {
                        if (!$scope.isStatic) {
                            $scope.checkResponse.push(FACCONST.STERILIZATION);
                            SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getSterilizeCommand($scope.sterilization), "/" + $scope.peerId + "/devices/0");
                        } else {
                            $scope.sterilization = !$scope.sterilization;
                        }
                    }
                    break;
                default:
                    break;
            }
        }, MATERIAL_DESIGN.TOGGLE_TIME);
    };
    // Settings end

    // Go to ai cool learning page
    $scope.aiCoolLearningScreen = function () {
        setTimeout(function(){
            document.getElementById("scrollable_area_id").scrollTop = 0;
        }, 10);
        $scope.currentScreen = FACSCREENS.AICOOLLEARNING;
        $scope.changeScreen();
        setTimeout(function(){
            $scope.createNewChart();
        }, 10);
    };

    $scope.aiCoolLearningOnSubTitle = function () {
        var displayMode = "";
        if ($scope.currentMode === 'Auto') {
            displayMode = $scope.translation.WEBMOB_device_fac_mode_auto_16k;
        } else if ($scope.sleep) {
            displayMode = $scope.translation.WEBMOB_fac_options_good_sleep;
        }

        return $scope.translation.WEBMOB_device_fac_ai_learning_graph + '(' + displayMode + ')';
    };

    $scope.aiCooLearningDescription = function() {
        return $scope.translation.WEBMOB_device_fac_ai_good_sleep_on_message.replace("00", $scope.aiFavorTemp);
    };

    $scope.aiTab = {
        INDOOR: 'indoor',
        OUTDOOR: 'outdoor'
    };
    $scope.current_aiTab = $scope.aiTab.INDOOR;
    $scope.onClick_aiTab = function (tab) {
        console.log("onClick_aiTab::: tab = ", tab);
        $scope.current_aiTab = tab;
        $scope.createNewChart();
    };

    $scope.isOutdoor_ai = function(tab) {
        return (angular.isDefined(tab) && tab === $scope.aiTab.OUTDOOR);
    };

    $scope.isIndoor_ai = function(tab) {
        return (angular.isDefined(tab) && tab === $scope.aiTab.INDOOR);
    };

    $scope.aiDataDays = function() {
        var mode = ai_check_currentMode();
        if (angular.isDefined($scope.aiGraphData[mode]) && angular.isDefined($scope.aiGraphData[mode]['dataStartDate']) && angular.isDefined($scope.aiGraphData[mode]['dataEndDate'])) {
            var startDate = new Date($scope.aiGraphData[mode]['dataStartDate']);
            var endDate = new Date($scope.aiGraphData[mode]['dataEndDate']);

            return '(' + (startDate.getMonth() + 1) + '.' + startDate.getDate() + '~' + (endDate.getMonth() + 1) + '.' + endDate.getDate() + ')';
        }
        return '';
    };

    function ai_check_currentMode() {
        if ($scope.currentMode === 'Auto') {
            return 'auto';
        } else if ($scope.sleep) {
            return 'sleep';
        }
        return '';
    }

    function getBubbleCurrentTemp(){
        var bubbleCurrentTemp = [];
        var bubbleRadius = 0.225 * parseInt(document.getElementById("htmlTag").style.fontSize);

        var mode = ai_check_currentMode();

        if ($scope.isStatic) {
            bubbleCurrentTemp.push({x: 21, y: 21, r: bubbleRadius});
            bubbleCurrentTemp.push({x: 21, y: 19, r: bubbleRadius});
        }
        else if (angular.isDefined($scope.aiGraphData[mode]) && angular.isDefined($scope.aiGraphData[mode]["currentTData"])) {
            $scope.aiGraphData[mode]["currentTData"].forEach(function(dot) {
                if (angular.isDefined(dot.weight) && dot.weight === "0")
                    bubbleRadius = 0.15 * parseInt(document.getElementById("htmlTag").style.fontSize);
                else
                    bubbleRadius = 0.225 * parseInt(document.getElementById("htmlTag").style.fontSize);

                var x = parseInt(dot.currentT);
                var y = parseInt(dot.desiredT);
                if (min_xAxes <= x && x <= max_xAxes && min_yAxes <= y && y <= max_yAxes)
                    bubbleCurrentTemp.push({x: x, y: y, r: bubbleRadius});
            });
        }

        console.log("bubbleCurrentTemp = ", bubbleCurrentTemp);
        return bubbleCurrentTemp;
    }

    function getBubble_cpCurrentTemp(){
        var bubble_cpCurrentTemp = [];
        var bubbleRadius = 0.225 * parseInt(document.getElementById("htmlTag").style.fontSize);

        var mode = ai_check_currentMode();

        if ($scope.isStatic) {
            bubble_cpCurrentTemp.push({x: 21, y: 21, r: bubbleRadius});
            bubble_cpCurrentTemp.push({x: 21, y: 19, r: bubbleRadius});
        }
        else if (angular.isDefined($scope.aiGraphData[mode]) && angular.isDefined($scope.aiGraphData[mode]["cpCurrentTData"])) {
            $scope.aiGraphData[mode]["cpCurrentTData"].forEach(function(dot) {
                if (angular.isDefined(dot.weight) && dot.weight === "0")
                    bubbleRadius = 0.15 * parseInt(document.getElementById("htmlTag").style.fontSize);
                else
                    bubbleRadius = 0.225 * parseInt(document.getElementById("htmlTag").style.fontSize);

                var x = parseInt(dot.cpCurrentT);
                var y = parseInt(dot.desiredT);
                if (min_xAxes <= x && x <= max_xAxes && min_yAxes <= y && y <= max_yAxes)
                    bubble_cpCurrentTemp.push({x: x, y: y, r: bubbleRadius});
            });
        }

        console.log("bubble_cpCurrentTemp = ", bubble_cpCurrentTemp);
        return bubble_cpCurrentTemp;
    }

    function getBubblePredictedTemp(){
        var bubblePredictedTemp = [];
        var bubbleRadius = 0.225 * parseInt(document.getElementById("htmlTag").style.fontSize);

        var mode = ai_check_currentMode();

        if ($scope.isStatic) {
            bubblePredictedTemp.push({x: 21, y: 20, r: bubbleRadius});
            bubblePredictedTemp.push({x: 22, y: 21, r: bubbleRadius});
            bubblePredictedTemp.push({x: 23, y: 22, r: bubbleRadius});
            bubblePredictedTemp.push({x: 24, y: 22, r: bubbleRadius});
        }
        else if (angular.isDefined($scope.aiGraphData[mode]) && angular.isDefined($scope.aiGraphData[mode]["currentTPrediction"])) {
            $scope.aiGraphData[mode]["currentTPrediction"].forEach(function(dot) {
                var x = parseInt(dot.currentT);
                var y = parseInt(dot.predictedT);
                if (min_xAxes <= x && x <= max_xAxes && min_yAxes <= y && y <= max_yAxes)
                    bubblePredictedTemp.push({x: x, y: y, r: bubbleRadius});
            });
        }

        console.log("bubblePredictedTemp = ", bubblePredictedTemp);
        return bubblePredictedTemp;
    }

    function getBubble_cpPredictedTemp(){
        var bubble_cpPredictedTemp = [];
        var bubbleRadius = 0.225 * parseInt(document.getElementById("htmlTag").style.fontSize);

        var mode = ai_check_currentMode();

        if ($scope.isStatic) {
            bubble_cpPredictedTemp.push({x: 21, y: 20, r: bubbleRadius});
            bubble_cpPredictedTemp.push({x: 22, y: 21, r: bubbleRadius});
            bubble_cpPredictedTemp.push({x: 23, y: 22, r: bubbleRadius});
            bubble_cpPredictedTemp.push({x: 24, y: 22, r: bubbleRadius});
        }
        else if (angular.isDefined($scope.aiGraphData[mode]) && angular.isDefined($scope.aiGraphData[mode]["cpCurrentTPrediction"])) {
            $scope.aiGraphData[mode]["cpCurrentTPrediction"].forEach(function(dot) {
                var x = parseInt(dot.cpCurrentT);
                var y = parseInt(dot.predictedT);
                if (min_xAxes <= x && x <= max_xAxes && min_yAxes <= y && y <= max_yAxes)
                    bubble_cpPredictedTemp.push({x: x, y: y, r: bubbleRadius});
            });
        }

        console.log("bubble_cpPredictedTemp = ", bubble_cpPredictedTemp);
        return bubble_cpPredictedTemp;
    }

    function getBubbleGraphData(){
        var graphData = [];

        //tab 별로 그래프 분기
        if ($scope.current_aiTab === $scope.aiTab.INDOOR) {
            var bubblePredictedTemp = getBubblePredictedTemp();
            var bubbleCurrentTemp = getBubbleCurrentTemp();
            var cpBubblePredictedTemp = getBubble_cpPredictedTemp();
            var cpBubbleCurrentTemp = getBubble_cpCurrentTemp();

            if(bubblePredictedTemp.length == 0 && bubbleCurrentTemp.length == 0){
                $scope.is_aiIndoorDataNone = true;
            }
            else{
                $scope.is_aiIndoorDataNone = false;
            }
            if(cpBubblePredictedTemp.length == 0 && cpBubbleCurrentTemp.length == 0){
                $scope.is_aiOutdoorDataNone = true;
            }
            else{
                $scope.is_aiOutdoorDataNone = false;
            }

            if($scope.is_aiIndoorDataNone || $scope.is_aiOutdoorDataNone){
                bubblePredictedTemp = [];
                bubbleCurrentTemp = [];
            }

            graphData.push({
                data: bubblePredictedTemp,
                label: $scope.translation.WEBMOB_device_fac_ai_graph_indoor_temp,
                borderWidth: 0,
                borderColor:'rgba(85,175,229,1)',
                backgroundColor:"rgba(85,175,229,1)",
                // set below not to be changed when tapping dot. or else after tapping dot, dot will be bigger.
                hoverBorderWidth:0,
                hoverRadius:0,
                hoverBackgroundColor:'rgba(85,175,229,1)'
            });

            graphData.push({
                data: bubbleCurrentTemp,
                label:$scope.translation.WEBMOB_device_fac_ai_graph_target_temp,
                borderWidth: 0,
                borderColor:'rgba(172,210,115,1)',
                backgroundColor:'rgba(172,210,115,1)',
                // set below not to be changed when tapping dot. or else after tapping dot, dot will be bigger.
                hoverBorderWidth:0,
                hoverRadius:0,
                hoverBackgroundColor:'rgba(172,210,115,1)'
            });
        } else if($scope.current_aiTab === $scope.aiTab.OUTDOOR) {
            var bubblePredictedTemp = getBubblePredictedTemp();
            var bubbleCurrentTemp = getBubbleCurrentTemp();
            var cpBubblePredictedTemp = getBubble_cpPredictedTemp();
            var cpBubbleCurrentTemp = getBubble_cpCurrentTemp();

            if(bubblePredictedTemp.length == 0 && bubbleCurrentTemp.length == 0){
                $scope.is_aiIndoorDataNone = true;
            }
            else{
                $scope.is_aiIndoorDataNone = false;
            }
            if(cpBubblePredictedTemp.length == 0 && cpBubbleCurrentTemp.length == 0){
                $scope.is_aiOutdoorDataNone = true;
            }
            else{
                $scope.is_aiOutdoorDataNone = false;
            }

            if($scope.is_aiIndoorDataNone || $scope.is_aiOutdoorDataNone){
                cpBubblePredictedTemp = [];
                cpBubbleCurrentTemp = [];
            }

            graphData.push({
                data: cpBubblePredictedTemp,
                label: $scope.translation.WEBMOB_device_fac_ai_graph_outdoor_temp,
                borderWidth: 0,
                borderColor:'rgba(85,175,229,1)',
                backgroundColor:"rgba(85,175,229,1)",
                // set below not to be changed when tapping dot. or else after tapping dot, dot will be bigger.
                hoverBorderWidth:0,
                hoverRadius:0,
                hoverBackgroundColor:'rgba(85,175,229,1)'
            });
            graphData.push({
                data: cpBubbleCurrentTemp,
                label:$scope.translation.WEBMOB_device_fac_ai_graph_target_temp,
                borderWidth: 0,
                borderColor:'rgba(172,210,115,1)',
                backgroundColor:'rgba(172,210,115,1)',
                // set below not to be changed when tapping dot. or else after tapping dot, dot will be bigger.
                hoverBorderWidth:0,
                hoverRadius:0,
                hoverBackgroundColor:'rgba(172,210,115,1)'
            });
        }
        return graphData;
    }

    $scope.createNewChart = function() {
        $scope.myChart = null;
        $scope.ctxGraph = null;
        $scope.ctxGraph = document.getElementById("aiChart");

        $scope.myChart = new Chart($scope.ctxGraph, {
            type: 'bubble',
            data: {
                datasets: getBubbleGraphData()
            },
            options: {
                responsive: true,
                maintainAspectRatio: false,
                layout: {
                    padding: {
                        left: 0,
                        right: 0,
                        top: 0,
                        bottom: 0
                    }
                },
                legend: {   // 볌례
                    display: false
                },
                scales: {
                    yAxes: [{
                            ticks: {
                                min: min_yAxes,
                                max: max_yAxes,
                                stepSize: 3,
                                fontColor: 'rgb(137, 137, 137)',
                                fontFamily: 'Sans-serif","HelveticaNeue" ,"AppleSDGothicNeo-Regular',
                                fontSize: parseInt(document.getElementById("htmlTag").style.fontSize) * 0.75,
                                fontStyle: 'normal',
                                padding: parseInt(document.getElementById("htmlTag").style.fontSize) * 0.5,
                                backdropPaddingX: parseInt(document.getElementById("htmlTag").style.fontSize) * 0.5
                            },
                            gridLines: {
                                display: true,
                                lineWidth: parseInt(document.getElementById("htmlTag").style.fontSize) * 0.025,
                                zeroLineWidth: parseInt(document.getElementById("htmlTag").style.fontSize) * 0.025,
                                color: 'rgba(206, 208, 210, 0.6)',
                                zeroLineColor: 'rgba(206, 208, 210, 0.6)',
                                drawTicks: false,
                                drawOnChartArea: true,
                                drawBorder: true
                            },
                            scaleLabel:{
                                display: false,
                                labelString : "(°C)"
                            }
                        }],
                    xAxes: [{
                            ticks: {
                                min: min_xAxes,
                                max: max_xAxes,
                                stepSize: 4,
                                fontColor: 'rgb(137, 137, 137)',
                                fontFamily: 'Sans-serif","HelveticaNeue" ,"AppleSDGothicNeo-Regular',
                                fontSize: parseInt(document.getElementById("htmlTag").style.fontSize) * 0.75,
                                fontStyle: 'normal',
                                padding: parseInt(document.getElementById("htmlTag").style.fontSize) * 0.35,
                                backdropPaddingY: parseInt(document.getElementById("htmlTag").style.fontSize) * 0.35
                            },
                            gridLines: {
                                display: false
                            },
                            scaleLabel:{
                                display: false,
                                labelString : "(°C)"
                            }
                        }]
                },
                tooltips:{
                    enabled: false
                }
            }
        });
    };
    
    function getGraphLabels() {
        var gLabel = [];
        for(var i=0; i<$scope.trainingHistoryData.length; i++) {
            gLabel.push($scope.trainingHistoryData[i].date.split("-")[1]+ "/" + $scope.trainingHistoryData[i].date.split("-")[2]);
        }
        // note : predictionData always comes last
        if(angular.isDefined($scope.predictionData)){
            gLabel.push($scope.predictionData.date.split("-")[1]+ "/" + $scope.predictionData.date.split("-")[2]);
        }
        return gLabel;
    }
    
    function getCurrentTemp() {
        var currentT = [];
        for(var i=0; i<$scope.trainingHistoryData.length; i++) {
            currentT.push($scope.trainingHistoryData[i].currentT);
        }
        // note : predictionData always comes last
        if(angular.isDefined($scope.predictionData)){
            currentT.push($scope.predictionData.currentT);
        }
        return currentT;
    }
    
    function getDesiredTemp() {
        var desiredT = [];
        for(var i=0; i<$scope.trainingHistoryData.length; i++) {
            desiredT.push($scope.trainingHistoryData[i].desiredT);
        }
        // note : predictionData always comes last
        if(angular.isDefined($scope.predictionData)){
            desiredT.push($scope.predictionData.predictedT);
        }
        return desiredT;
    }
    
    function getCPCurrentTemp() {
        var CPcurrentT = [];
        for(var i=0; i<$scope.trainingHistoryData.length; i++) {
            if($scope.trainingHistoryData[i].cpCurrentT === ""){
                CPcurrentT.push(undefined);
            }
            else{
                CPcurrentT.push($scope.trainingHistoryData[i].cpCurrentT);
            }
        }
        // note : predictionData always comes last
        if(angular.isDefined($scope.predictionData)){
            CPcurrentT.push($scope.predictionData.cpCurrentT);
        }
        return CPcurrentT;
    }
       
    function getGraphData() {
        var graphData = [];
        graphData.push({
                        data: getCurrentTemp(),
                        label:'Indoor temp.',
                        fill:false,
                        lineTension:0.1,
                        borderWidth: 2,
                        backgroundColor:"rgba(54,149,221,0.3)",
                        borderColor:"rgba(54,149,221,1)",
                        pointBackgroundColor:"rgba(54,149,221,1)",
                        borderCapStyle:'butt',
                        borderDash:[],
                        borderDashOffset:0.0,
                        borderJoinStyle:'miter',
                        // pointBorderColor:"rgba(54,149,221,1)",
                        // pointBackgroundColor:"rgba(54,149,221,1)",
                        // pointBorderWidth:0.5,
                        // pointHoverRadius:10,
                        // pointHoverBackgroundColor:"rgba(75,192,192,1)",
                        // pointHoverBorderColor:"rgba(220,220,220,1)",
                        // pointHoverBorderWidth:2,
                        // pointRadius:3,
                        // pointHitRadius:10,
                        spanGaps:false,
                        });
        graphData.push({
                        data: getDesiredTemp(),
                        label:'Set temp. of user',
                        fill:false,
                        lineTension:0.1,
                        borderWidth: 2,
                        backgroundColor:'rgba(54,149,54,0.3)',
                        borderColor:'rgba(54,149,54,1)',
                        pointBackgroundColor:'rgba(54,149,54,1)',
                        borderCapStyle:'butt',
                        borderDash:[],
                        borderDashOffset:0.0,
                        borderJoinStyle:'miter',
                        // pointBorderColor:'rgba(54,149,54,1)',
                        // pointBackgroundColor:'rgba(54,149,54,1)',
                        // pointBorderWidth:0.5,
                        // pointHoverRadius:10,
                        // pointHoverBackgroundColor:"rgba(255,0,0,1)",
                        // pointHoverBorderColor:"rgba(255,0,0,1)",
                        // pointHoverBorderWidth:2,
                        // pointRadius:3,
                        // pointHitRadius:10,
                        spanGaps:false,
    });
        graphData.push({
                        data: getCPCurrentTemp(),
                        label:'Outdoor temp.',
                        fill:false,
                        lineTension:0.1,
                        borderWidth: 2,
                        backgroundColor:'rgba(255,0,0,0.3)',
                        borderColor:'rgba(255,0,0,1)',
                        pointBackgroundColor:'rgba(255,0,0,1)',
                        borderCapStyle:'butt',
                        borderDash:[],
                        borderDashOffset:0.0,
                        borderJoinStyle:'miter',
                        // pointBorderColor:'rgba(255,0,0,1)',
                        // pointBackgroundColor:'rgba(255,0,0,1)',
                        // pointBorderWidth:0.5,
                        // pointHoverRadius:10,
                        // pointHoverBackgroundColor:'rgba(54,149,221,1)',
                        // pointHoverBorderColor:'rgba(54,149,221,1)',
                        // pointHoverBorderWidth:2,
                        // pointRadius:3,
                        // pointHitRadius:10,
                        spanGaps:false,

    });
                    
        return graphData;
    }

    // Go to options page
    $scope.optionsScreen = function () {
        if (!$scope.disableOptions) {
            toggleAnimClass();
            $timeout(function () {
                toggleAnimClass();
                $scope.currentScreen = FACSCREENS.OPTIONS;
                $scope.changeScreen();
            }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
        }
    };
    // Go to schedule list screen
    function scheduleList() {
        //if no schedule available, open add schedule screen
        if($scope.Actions.length === 0 && $scope.currentScreen === FACSCREENS.HOME) {
            addSchedule(-1);
            return;
        }
        
        toggleAnimClass();
        $timeout(function () {
            toggleAnimClass();
            getSchedules();
            $scope.currentScreen = FACSCREENS.SCHEDULELIST;
            $scope.changeScreen();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }

    function getSchedules(noLoadingBar) {
        if ($scope.isStatic) {
            var actData = [{"id": "1", "Actuators": [{"Operation": {"power": "Off"}, "deviceIDs": ["0"]}], "dayOfWeek": ["Thu", "Sat"], "disposable": true, "enabled": true, "startTime": "0000-00-00T04:17:00"}, {"id": "1", "Actuators": [{"Operation": {"power": "Off"}, "deviceIDs": ["0"]}], "dayOfWeek": ["Thu", "Sat"], "disposable": true, "enabled": true, "startTime": "0000-00-00T04:17:00"}, {"id": "2", "Actuators": [{"Operation": {"power": "Off"}, "deviceIDs": ["0"]}], "dayOfWeek": ["Sun", "Tue", "Wed"], "disposable": true, "enabled": true, "startTime": "0000-00-00T14:17:00"}, {"id": "3", "Actuators": [{"Operation": {"power": "On"}, "deviceIDs": ["0"]}], "dayOfWeek": ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], "disposable": false, "enabled": true, "repeatPeriod": "Daily", "startTime": "0000-00-00T10:53:00"}, {"id": "4", "Actuators": [{"Operation": {"power": "Off"}, "deviceIDs": ["0"]}], "dayOfWeek": ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], "disposable": false, "enabled": true, "repeatPeriod": "Daily", "startTime": "0000-00-00T11:53:00"}, {"id": "5", "Actuators": [{"Operation": {"power": "Off"}, "deviceIDs": ["0"]}], "dayOfWeek": ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"], "disposable": false, "enabled": true, "repeatPeriod": "Daily", "startTime": "0000-00-00T16:53:00"}, {"id": "0", "Actuators": [{"Operation": {"power": "On"}, "deviceIDs": ["0"]}], "dayOfWeek": ["Wed", "Fri"], "disposable": false, "enabled": true, "repeatPeriod": "Weekly", "startTime": "0000-00-00T08:16:00"}];
            parseActionData(actData);
        } else {
            if(!!!noLoadingBar) {
                $scope.checkResponse.push(FACCONST.SCHEDULEDATA);
            }
            SHPService.sendSHPCommand(CONSTANTS.GET, "/" + $scope.peerId + "/actions", '', !noLoadingBar);
        }
    }

    // Go to power consumption
    $scope.powerConsumption = function () {
        if (!$scope.disablePowerConsumption) {
            toggleAnimClass();
            $timeout(function () {
                toggleAnimClass();
                $scope.currentScreen = FACSCREENS.POWERCONSUMPTION;
                $scope.changeScreen();                
            }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
        }
    };
    // Go to add schedule screen
    $scope.gotoAddSchedule = function () {
        toggleAnimClass();
        $timeout(function () {
            toggleAnimClass();
            $scope.currentScreen = FACSCREENS.ADDSCHEDULE;
            $scope.changeScreen();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };
    // Go to weather info
    $scope.weatherDescriptionPage = function () {
        $scope.currentScreen = FACSCREENS.WEATHERINFO;
        $scope.changeScreen();
        if ($scope.isStatic) {
            updateWeatherData();
        } else {
            $scope.checkResponse.push(FACCONST.WEATHERDATA);
            SHPService.sendSHPCommand(CONSTANTS.RUNONNATIVE, "getWeatherData", '{ "regionCode": "' + $scope.selectedWeatherLocationCode + '" }');
        }
    };
    // Go to Air Purity level
    $scope.airPurityLevelPage = function () {
        if ($scope.DeviceOptions.inDoorData.pm10.purity === 0) {
            $scope.checkResponse.push(FACCONST.AIR_MONITORING);
            SHPService.sendSHPCommand(CONSTANTS.PUT, getAirMonitoringCommand(false), "/" + $scope.peerId + "/devices/0");
        } else {
            if (!$scope.airPurityDisable) {
                $scope.currentScreen = FACSCREENS.AIRPURITY;
                $scope.changeScreen();
            }
        }                
    };
    // Go to Settings page
    function goToSettings() {
        toggleAnimClass();
        $timeout(function () {
            toggleAnimClass();
            $scope.currentScreen = FACSCREENS.SETTINGS;
            $scope.changeScreen();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
        // Get configuration every time for region code change
        if (!$scope.isStatic) {
            $scope.checkResponse.push(FACCONST.PARSE_CONFIG);
            SHPService.sendSHPCommand(CONSTANTS.GET, "/" + $scope.peerId + "/devices/0/configuration");
        }
    }
    // Go to About screen
    function goToAbout() {
        toggleAnimClass();
        $timeout(function () {
            toggleAnimClass();
            $scope.currentScreen = FACSCREENS.ABOUT;
            $scope.changeScreen();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }
    // Go to weather info settings screen
    $scope.gotoWeatherInfoSettings = function () {
        toggleAnimClass();
        $timeout(function () {
            toggleAnimClass();
            $scope.currentScreen = FACSCREENS.WEATHERINFOSETTINGS;
            $scope.changeScreen();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };
    // Go to error page
    $scope.gotoErrorPage = function () {
        $scope.currentScreen = FACSCREENS.ERRORPAGE;
        $scope.changeScreen();
    };
    // Go to filter page
    function gotoFilterPage() {
        $scope.currentScreen = FACSCREENS.FILTERPAGE;
        $scope.changeScreen();
    }

    function sortWindList() {
        $scope.windList.sort(function (left, right) {
            return left.name.split(" ")[2] - right.name.split(" ")[2];
        });
    }

    // Go to my wind list screen
    $scope.gotoMyWindList = function () {
        //if no wind is available, open add wind screen
        if($scope.windList.length === 0) {
            addWind(-1);
            return;
        }
        
        sortWindList();
        toggleAnimClass();
        $timeout(function () {
            toggleAnimClass();
            $scope.currentScreen = FACSCREENS.MYWINDLIST;
            $scope.changeScreen();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };
    // Go to add schedule screen
    $scope.gotoAddMyWind = function () {
        toggleAnimClass();
        $timeout(function () {
            toggleAnimClass();
            $scope.currentScreen = FACSCREENS.ADDWIND;
            $scope.changeScreen();
            updateWindStrengthList($scope.currentMode);
            updateWindDirectionList($scope.currentMode);
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };
    
    function gotoLighting() {
        $scope.currentScreen = FACSCREENS.LIGHTING;
        $scope.changeScreen();
    }
    
    function gotoVoiceSelection() {
        $scope.currentScreen = FACSCREENS.VOICESELECTION;
        $scope.changeScreen();
    }

    // Change screen
    $scope.changeScreen = function () {
        $scope.homePage = false;
        $scope.optionsPage = false;
        $scope.scheduleListPage = false;
        $scope.powerConsumptionPage = false;
        $scope.weatherInfoPage = false;
        $scope.airPurityPage = false;
        $scope.weatherInfoSettings = false;
        $scope.addSchedulePage = false;
        $scope.settingsPage = false;
        $scope.aboutPage = false;
        $scope.showErrorPage = false;
        $scope.myWindListPage = false;
        $scope.addWindPage = false;
        $scope.energyMonitorPage = false;
        $scope.smartcarepage = false;
        $scope.smartcareerror = false;
        $scope.showPrsentPC = false;
        $scope.showHistoryPC = false;
        $scope.showLightingPage = false;
        $scope.showVoiceSelectionPage = false;
        $scope.showFilterPage = false;
        $scope.showAICoolLearning = false;
        switch ($scope.currentScreen) {
            case FACSCREENS.HOME:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_common_device_fac;
                updateWindStrengthList($scope.currentMode);
                updateWindDirectionList($scope.currentMode);
                $scope.homePage = true;
                break;
            case FACSCREENS.OPTIONS:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_common_options;
                $scope.optionsPage = true;
                break;
            case FACSCREENS.SCHEDULELIST:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_common_schedule_schedule;
                $scope.scheduleListPage = true;
                break;
            case FACSCREENS.POWERCONSUMPTION:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_fac_energy_monitor_title;
                $scope.powerConsumptionPage = true;
                if ($scope.powerOperation) {
                    $scope.showPrsentPC = true;
                    $scope.getPowerConsumption();
                } else {
                    $scope.showHistoryPC = true;
                    goToEnergyMonitor();
                }
                break;
            case FACSCREENS.ADDSCHEDULE:
                $scope.addSchedulePage = true;
                break;
            case FACSCREENS.WEATHERINFO:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_device_fac_weather_info;
                $scope.weatherInfoPage = true;
                break;
            case FACSCREENS.AIRPURITY:
                $scope.subHeaderTitle = $scope.translation.ACMOB_airfreshness;
                $scope.airPurityPage = true;
                homeMultiService.sendSensorRequest();
                break;
            case FACSCREENS.WEATHERINFOSETTINGS:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_device_fac_settings_region_setting;
                $scope.weatherInfoSettings = true;
                break;
            case FACSCREENS.SETTINGS:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_common_settings;
                $scope.settingsPage = true;
                break;
            case FACSCREENS.ABOUT:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_common_about_device;
                $scope.aboutPage = true;
                break;
            case FACSCREENS.MYWINDLIST:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_device_fac_mywind_title;
                $scope.myWindListPage = true;
                break;
            case FACSCREENS.ADDWIND:
                $scope.addWindPage = true;
                break;
            case FACSCREENS.ERRORPAGE:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_common_error_notification;
                $scope.showErrorPage = true;
                dismissAllPopups();
                break;
            case FACSCREENS.SMARTCARE:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_common_self_diagnosis;
                $scope.smartcarepage = true;
                break;
            case FACSCREENS.SMARTCAREERROR:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_common_self_diagnosis;
                $scope.smartcareerror = true;
                break;
            case FACSCREENS.LIGHTING:
                $scope.subHeaderTitle = $scope.translation.ACMOB_dialog_title_brightness_lighting;
                $scope.showLightingPage = true;
                break;
            case FACSCREENS.VOICESELECTION:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_device_fac_voice;
                $scope.showVoiceSelectionPage = true;
                break;
            case FACSCREENS.FILTERPAGE:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_fac_setting_filter;
                $scope.showFilterPage = true;
                break;
            case FACSCREENS.AICOOLLEARNING:
                $scope.subHeaderTitle = $scope.translation.WEBMOB_device_fac_ai_comfort_cooling;
                $scope.showAICoolLearning = true;
                break;
            default:
                break;
        }
    };
    // On back key pressed
    function onBackPressed() {
        if ($scope.diagnosisStart === "Run") {
            return;
        }

        if ($scope.powerOffPopup) {
            $scope.onPowerOffUpdate(false);
            return;
        } else {
            if (dismissAllPopups()) {
                return;
            }
        }

        switch ($scope.currentScreen) {
            case FACSCREENS.WEATHERINFO:
            case FACSCREENS.AIRPURITY:            
            case FACSCREENS.OPTIONS:
            case FACSCREENS.SETTINGS:
            case FACSCREENS.ABOUT:
                $scope.currentScreen = FACSCREENS.HOME;
                $scope.changeScreen();
                break;
            case FACSCREENS.AICOOLLEARNING:
                $scope.currentScreen = FACSCREENS.HOME;
                $scope.changeScreen();
                setTimeout(function(){
                    document.getElementById("scrollable_area_id").scrollTop = 0;
                }, 10);
                break;
            case FACSCREENS.SCHEDULELIST:
                $scope.currentScreen = FACSCREENS.HOME;
                $scope.changeScreen();
                getSchedules();
                break;
            case FACSCREENS.ADDSCHEDULE:
                if($scope.Actions.length !== 0) {
                    scheduleList();
                } else {
                    $scope.currentScreen = FACSCREENS.HOME;
                    $scope.changeScreen();
                    getSchedules();
                }
                break;
            case FACSCREENS.ADDWIND:
                if($scope.windList.length !== 0) {
                    $scope.currentScreen = FACSCREENS.MYWINDLIST;
                    $scope.changeScreen();
                    return;
                } else {
                    $scope.currentScreen = FACSCREENS.SETTINGS;
                    $scope.changeScreen();
                }
                break;
            case FACSCREENS.WEATHERINFOSETTINGS:
                if (noRegionSelected) {
                    $scope.closeApp();
                } else {
                    $scope.currentScreen = FACSCREENS.SETTINGS;
                    $scope.changeScreen();
                    $scope.locationToBeSearched = "";
                    $scope.searchValues = mOrginialValues;
                }
                break;
            case FACSCREENS.MYWINDLIST:
            case FACSCREENS.POWERCONSUMPTION:
            case FACSCREENS.LIGHTING:
            case FACSCREENS.VOICESELECTION:
            case FACSCREENS.FILTERPAGE:
                $scope.currentScreen = FACSCREENS.SETTINGS;
                $scope.changeScreen();
                break;
            case FACSCREENS.HOME:
                $scope.closeApp();
                break;
            case FACSCREENS.ERRORPAGE:
                if ($scope.previousScreen === FACSCREENS.SMARTCARE || $scope.previousScreen === FACSCREENS.SMARTCAREERROR) {
                    $scope.currentScreen = FACSCREENS.HOME;
                } else {
                    $scope.currentScreen = $scope.previousScreen;
                }
                $scope.changeScreen();
                break;
            case FACSCREENS.SMARTCARE:
                $scope.currentScreen = FACSCREENS.ABOUT;
                $scope.changeScreen();
                break;
            case FACSCREENS.SMARTCAREERROR:
                $scope.currentScreen = FACSCREENS.HOME;
                $scope.changeScreen();
                break;
            default:
                break;
        }
    }
    // To display static data
    $scope.parseStaticData = function () {
        $scope.isStatic = true;
        $scope.selectedCountry = "KR";
        $scope.selectedWeatherLocation = $scope.translation.WEBMOB_common_region_korea_41;
        init();
        var FACResponse = '{"Device":{"description":"FAC_BORA_17K","id":"0","Alarms":[{"id":"0","alarmType":"Device","code":"FilterAlarm_OFF","triggeredTime":"2015-07-18T10:13:31"}],"ConfigurationLink":{"href":"/devices/0/configuration"},"EnergyConsumption":{"cumulativeConsumption":100},"InformationLink":{"href":"/devices/0/information"},"Mode":{"modes":["Cool"],"options":["EnergySaveIcon_On","Dehumidification_2","Operation_Family","Comode_Off","Function_15","Sleep_0","RestWind_Off","Autoclean_Off","Sterilize_Off","FilterCleanAlarm_0","Humidi_Off","Panel_Close","Light_On","Smarton_LockOff","Weather_Off","Volume_66","VoiceSet_Disable","OptionCode_190","UpdateAllow_NotAllowed","WattNotice_0","RacInfo_First","ModelInfo_14K_MEMORY_M1","ReadyForCam_Ready","Blooming_7","AI_Enable","ArtificialWork_On"],"supportedModes":["Cool","Dry","Wind","CoolClean","DryClean","Auto","Heat","HeatClean"]},"Humidity":{"current":75,"unit":"Percentage"},"Operation":{"power":"On"},"Sensors":[{"id": "0","type": "CleanLevel","values": [4]},{"id": "1","type": "Odor","values": [4]},{"id": "2","type": "Dust","values": [888,4]},{"id": "3","type": "FineDust","values": [888,4]}],"Wind":{"direction":"Center","speedLevel":3},"connected":true,"name":"Stand Air Conditioner","resources":["Alarms","Configuration","EnergyConsumption","Information","Mode","Operation","Sensors","Temperatures","Wind"],"type":"Air_Conditioner","uuid":"F8042E7A-BC15-0000-0000-000000000000","Temperatures":[{"id":"0","current":24,"desired":25,"unit":"Celsius"}]}}';
        var device = JSON.parse(FACResponse);
        parseDeviceData(device.Device);
        startApp();
        updateWeatherData();
        $scope.DeviceOptions.outDoorData.KHAI.colorClass = 'airpurity_disabledText';
    };
    // init function    
    function init() {
        if(!!$scope.appAtForeground) {
            return;
        }
        if (!$scope.isStatic) {
            $scope.checkResponse.push(FACCONST.PARSE_CONFIG);
            SHPService.sendSHPCommand(CONSTANTS.GET, "/" + $scope.peerId + "/devices/0/configuration");
        }
        $scope.windList = [];
        currentWindKey = $scope.isStatic ? FACCONST.MYWIND_KEY_DEMO : FACCONST.MYWIND_KEY;
        var tempWindList = JSON.parse(getLocalStorageData(currentWindKey));
        if (tempWindList !== null) {
            $scope.windList = tempWindList;
        }
        $scope.currentMeterDate = getLocalStorageData('meterDate#' + $scope.deviceUuid) === null ? 1 : getLocalStorageData('meterDate#' + $scope.deviceUuid);
    }
    
    function handleAppAtForeground() {
        //Lokesh 08Dec15_1436 -> For iOS, flag to track if app came back to foreground. 
        //A getDevice() call is made which should not be treated as call at start of application.
        //To achieve such a scenario, added this flag.
        $scope.appAtForeground = true;
        dismissAllPopups();  //dismiss all popups before sending get device request.
    }
    
    // Call back from native
    $scope.updateDeviceData = function (data) {
        SHPService.updateDeviceData($scope, data);
    };

    // Parse configuration for region
    function parseConfiguration(configuration) {
        dismissLoadingBar(FACCONST.PARSE_CONFIG);
        if (angular.isDefined(configuration["region"])) {
            for (var i = 0; i < $scope.searchValues.length; i++) {
                if (WeatherService.setRegionCode($scope.searchValues[i]) === configuration["region"]) {
                    $scope.selectedWeatherLocation = $scope.searchValues[i];
                    if ($scope.selectedWeatherLocation !== null && $scope.selectedWeatherLocation !== undefined) {
                        if ($scope.selectedWeatherLocationCode !== WeatherService.setRegionCode($scope.selectedWeatherLocation)) {
                            $scope.selectedWeatherLocationCode = WeatherService.setRegionCode($scope.selectedWeatherLocation);
                            $scope.getWeatherAirData();
                        }
                    }
                    break;
                }
            }
        }
        
        //Lokesh 08Dec15_1436 -> Avoid calling startApp(), whenever app came back to foreground in iOS.
        if(!!!$scope.appAtForeground) {
            startApp();
        } else {
            //make flag fase otherwise to avoid further unwanted calls.
            $scope.appAtForeground = false;
        }
    }

    // One parsing is done start the app
    function startApp() {
        $scope.pageLoaded = true;
        $scope.mainLoadingScreen = true;

        if (!$scope.isStatic && ($scope.selectedWeatherLocation === null || $scope.selectedWeatherLocation === undefined)) {
            $scope.currentScreen = FACSCREENS.WEATHERINFOSETTINGS;
            noRegionSelected = true;
        }
        $scope.changeScreen();        
        checkForFUG();        
    }

    // Close the app
    $scope.closeApp = function () {
        nativeInterface.runOnNative("closeWebApp", "");
    };

    $scope.smartLockOk = function () {
        $scope.closeApp();
    };

    // About page start
    $scope.onAboutAction = function (reqParam) {
        if (reqParam === "smartcare") {
            $scope.currentScreen = FACSCREENS.SMARTCARE;
            $scope.changeScreen();
            return;
        }
        if(reqParam === 'tutorial' || reqParam === 'manual' || reqParam === 'helpdesk') {
            if($scope.selectedCountry === "BE") {
                $scope.countryToSelect = [];
                $scope.countryToSelect.push({'Country': 'Belgium'});
                $scope.countryToSelect.push({'Country': 'Belgium(French)'});
                reqParamCountrySelection = reqParam;
                $scope.showcustCountrySelectionPopup();
            } else if($scope.selectedCountry === "CA") {
                $scope.countryToSelect = [];
                $scope.countryToSelect.push({'Country': 'Canada'});
                $scope.countryToSelect.push({'Country': 'Canada(French)'});
                reqParamCountrySelection = reqParam;
                $scope.showcustCountrySelectionPopup();
            } else if($scope.selectedCountry === "CH") {
                $scope.countryToSelect = [];
                $scope.countryToSelect.push({'Country': 'Switzerland'});
                $scope.countryToSelect.push({'Country': 'Switzerland(French)'});
                reqParamCountrySelection = reqParam;
                $scope.showcustCountrySelectionPopup();
            } else {
                /*if($scope.isStatic) {
                    $scope.selectedCountry = "BE";
                    $scope.showcustCountrySelectionPopup();
                    return;
                }*/
                $timeout(function () {
                    nativeInterface.runOnNative("customerService", aboutCommand(reqParam));
                }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
            }
        } else {
            $timeout(function () {
                nativeInterface.runOnNative("customerService", aboutCommand(reqParam));
            }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
        }
    };
    
    function aboutCommand(cmdstring, changedCode) {
        if(changedCode) {
            return '{"service" : "' + cmdstring + '","selectedCountry" : "' + $scope.selectedCountry + '_FR"}';
        } else {
            return '{"service" : "' + cmdstring + '","selectedCountry" : "' + $scope.selectedCountry + '"}';
        }
    }
    
    $scope.showcustCountrySelectionPopup = function() {
        //debugMessage("showcustCountrySelectionPopup :: "+countryName[0]);
        $scope.countrySelectionPopupVisible = true;
    };
    
    $scope.onCountrySelected = function (countryIndex) {
        console.log("country selected is "+countryIndex);
        $scope.countrySelectedIndex = countryIndex;
    };
    
    $scope.onCountrySelectedOkClicked = function (isCountrySelected) {
        if(isCountrySelected) {
            if($scope.countrySelectedIndex === 0){
                $timeout(function () {
                    nativeInterface.runOnNative("customerService", aboutCommand(reqParamCountrySelection));
                }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
            } else {
                $timeout(function () {
                    nativeInterface.runOnNative("customerService", aboutCommand(reqParamCountrySelection, true));
                }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
            }
        }
        $scope.closeCountrySelectionPopup();
    };
    
    $scope.closeCountrySelectionPopup = function () {
        $scope.countrySelectionPopupVisible = false;
    };

    $scope.smartcareerrorcheck = function () {
        $scope.checkResponse.push(FACCONST.DIAGNOSIS);
        if(!$scope.isStatic) {
            SHPService.sendSHPCommand(CONSTANTS.PUT, getDiagnosisCommand(), "/" + $scope.peerId + "/devices/0/diagnosis", true, 300000);    //Lokesh 16Nov15_1421 -> fall back time for smart care is 5 minutes (300000 ms).
        } else {
            $scope.loadingBar = true;
            
            //Lokesh 19Nov15_1436 -> Error check simulation.
//            $timeout(function() {
//                //send alarms object to show error
//                $scope.parseDeviceData(JSON.parse('{"data":[{"uuid":"F8042E4A-FC78-0000-0000-000000000000","eventTime":"2015-11-17T10:41:38","resourceURI":"/devices/0/alarms","event":"Created","Alarms":[{"id":"0","triggeredTime":"2015-11-17T10:41:38","code":"ErrorCode_E101"}]}],"type":"notification","status":200}').data[0]);
//                $timeout(function() {
//                    //send diagnosis->'Ready' to complete smart care.
//                    $scope.parseDeviceData(JSON.parse('{"data":[{"uuid":"F8042E4A-FC78-0000-0000-000000000000","eventTime":"2015-11-17T10:46:17","Diagnosis":{"diagnosisStart":"Ready"},"resourceURI":"/devices/0/diagnosis","event":"Notified"}],"type":"notification","status":200}').data[0]);
//
//                    $timeout(function(){
//                        //send alarms object -> "ErrorCode" to clear error.
//                        $scope.parseDeviceData(JSON.parse('{"data":[{"uuid":"F8042E4A-FC78-0000-0000-000000000000","eventTime":"2015-11-17T10:41:38","resourceURI":"/devices/0/alarms","event":"Created","Alarms":[{"id":"0","triggeredTime":"2015-11-17T10:41:38","code":"ErrorCode"}]}],"type":"notification","status":200}').data[0]);
//                    }, 10000);
//                }, 10000);
//            }, 10000);
        }
    };

    $scope.versionTouchStart = function () {
        if (!promise) {
            promise = $timeout(function () {
                if (!$scope.isStatic) {
                    $scope.checkResponse.push(FACCONST.PARSE_MODULEINFO);
                    SHPService.sendSHPCommand(CONSTANTS.GET, "/" + $scope.peerId + "/devices/0/information");
                }
            }, 5000);
        }
    };

    $scope.versionTouchEnd = function () {
        if (promise) {
            $timeout.cancel(promise);
            promise = null;
        }
    };

    function parseModuleInformation(moduleInfo) {
        if (angular.isDefined(moduleInfo.Versions) && moduleInfo.Versions.length > 0) {
            $scope.moduleInfoText = "Software Ver : " + moduleInfo.Versions[0].number + " <br> Firmware Ver : " + moduleInfo.Versions[1].number;
            dismissLoadingBar(FACCONST.PARSE_MODULEINFO);
            document.getElementById("moduleInfoCancelID").style.visibility = 'hidden';
            $scope.showModuleInfoPopup = true;
            toggleBottomPopUpClass($scope.showModuleInfoPopup);
        }
    }
    $scope.moduleInfoOk = function () {
        $scope.showModuleInfoPopup = false;
        toggleBottomPopUpClass($scope.showModuleInfoPopup);
    };
    // About page end

    $scope.getWeatherAirData = function () {
        if (!$scope.isStatic) {
            $scope.checkResponse.push(FACCONST.AIRDATA);
            $scope.checkResponse.push(FACCONST.WEATHERDATA);
            SHPService.sendSHPCommand(CONSTANTS.RUNONNATIVE, getAirData, '{ "regionCode": "' + $scope.selectedWeatherLocationCode + '" }');
            SHPService.sendSHPCommand(CONSTANTS.RUNONNATIVE, "getWeatherData", '{ "regionCode": "' + $scope.selectedWeatherLocationCode + '" }');
        }
    };

    // Parse device, notification data
    function parseDeviceData(device, resourceURL) {
        // Checking Uuid
        if (angular.isDefined(device["uuid"]) && device["uuid"] !== $scope.deviceUuid && !$scope.isStatic) {
            return;
        }
        // Device ID
        if (angular.isDefined(device["id"])) {
            $scope.deviceID = parseInt(device["id"], 10);
        }
        // Model
        if (angular.isDefined(device["description"])) {
            $scope.currentModel = device["description"];            
        }
	
	//update model info before doing anything else.
	updateModelInfo(device);
	
        if (!!device.Operation && !!device.Operation.power) {
            $scope.powerOperation = device["Operation"].power === "On";
            
            if (!$scope.powerOperation) {
                dismissAllPopups();
            }
            //Lokesh 26Nov15_2328 -> As per Mr. Kim, since Air purifier not sending list of actions, we've to make separate request to get list of schedules silently.
            getSchedules(true);
            dismissLoadingBar(FACCONST.POWEROPERATION);
        }

        // Current mode
        if (angular.isDefined(device["Mode"]) && angular.isDefined(device["Mode"].modes)) {
            //Lokesh 29Dec15_1845 -> Some times, wind direction is received from set. 
            //In such case, update default wind direction for current mode.
            //Preserve wind direction for old mode before applying new mode.
            if(device.Wind && device.Wind.direction) {
                setConfigWindDirection();
            }

            $scope.currentMode = device["Mode"].modes[0];
            
            // Add purify option for 17K model and link it with clean modes
            if (is17KModel() && device["Mode"].modes[0] && ~device["Mode"].modes[0].indexOf("Clean")) {
                $scope.purify = true;
            } else {
                $scope.purify = false;
            }
            
            //Lokesh 08Dec15_1436 -> If app is coming foreground in iOS, then don't close pop-over.
            if(!!!$scope.appAtForeground) {
                $scope.closePopoverMode();
            }
            dismissLoadingBar(FACCONST.MODECHANGE);
        }
        // Wind direction
        if (angular.isDefined(device["Wind"]) && angular.isDefined(device["Wind"].direction)) {
            //Lokesh 29Dec15_1845 -> Some times, wind direction is received from set. 
            //In such case, update default wind direction for current mode.
            //Preserve old wind direction only when mode is not changed this time.
            //This makes sure that only wind direction was changed and it needs to be preserved.
            if(!(device.Mode && device.Mode.modes && device.Mode.modes[0])) {
                setConfigWindDirection();
            }
            $scope.currentWindDirection = device["Wind"].direction;
            dismissLoadingBar(FACCONST.WINDDIRECTION_CHANGE);
        }
        /* Sampath_28/3/2017 - If we get wind direction first and mode response later, then this code gets failed.
         * else if(device.Mode && device.Mode.modes && device.Mode.modes[0]) { //Lokesh_30Nov15_2347 ->AC0600065242 ->When mode is changed and no data coming, set it to previous value.
            $scope.currentWindDirection = $scope.defaultConfig[$scope.currentMode].configWindDirection;
        }*/
        if ($scope.currentWindDirection === "Off" && $scope.currentMode !== "Auto") {
            $scope.currentWindDirection = "Center";
        }

        // Wind strength
        if (angular.isDefined(device["Wind"]) && angular.isDefined(device["Wind"].speedLevel)) {
            $scope.currentWindStrength = device["Wind"].speedLevel;
            dismissLoadingBar(FACCONST.WINDSTRENGTH_CHANGE);
        } 
        //Sampath_6/1/2016 AC0600065970 -> If wind strength is same for current mode to next changed mode then we don't get notification, so we should not assign from defaultConfig object
        /*else if(device.Mode && device.Mode.modes && device.Mode.modes[0]) { //Lokesh_30Nov15_2347 ->AC0600065242 ->When mode is changed and no data coming, set it to previous value.
            $scope.currentWindStrength = $scope.defaultConfig[$scope.currentMode].configWindStrength;
        }*/
        // Options
        if (angular.isDefined(device["Mode"]) && angular.isDefined(device["Mode"]["options"])) {
            $scope.options = device["Mode"]["options"];
            $scope.options.forEach(function (value) {
                if (value.indexOf("Operation") !== -1) {
                    $scope.solo = value.indexOf("Operation_Solo") !== -1;
                    dismissLoadingBar(FACCONST.OPERATION_SOLO);
                }
                if (value.indexOf("UsagesDB_ok") !== -1) {
                    isDBDownloadedJS = false;   //Lokesh 16Nov15_2124 -> Reset the flag to avoid unexpected calls to energy monitor page.
                    
                    // get DB request
                    $scope.fetchDBfromDevice();
                }
                if(value.indexOf("AI") !== -1){
                    dismissLoadingBar(FACCONST.AI);
                    $scope.aiSupported = true;
                    $scope.aiEnabled = value.indexOf("AI_Enable") !== -1;
                }

                if(value.indexOf("ArtificialWork") !== -1){
                    $scope.aiActive = value.split("_")[1];
                }

                if (value.indexOf("Comode") !== -1) {
                    $scope.quiet = value.indexOf("Comode_Quiet") !== -1;
                    $scope.turbo = value.indexOf("Comode_Speed") !== -1;
                    $scope.goodSleep = value.indexOf("Comode_Sleep") !== -1;
                    $scope.comodeOff = value.indexOf("Comode_Off") !== -1;
                    $scope.smartSensor = value.indexOf("Comode_Smart") !== -1;
                    $scope.nanoWind = value.indexOf("Comode_Nano") !== -1;
                    if (value.indexOf("Comode_NanoSleep") !== -1) { // 17K model Nano Wind and Good Sleep both ON is possible
                        $scope.nanoWind = $scope.goodSleep = true;
                    }
                    dismissLoadingBar(FACCONST.COMODE);
                }
                if (value.indexOf("RestWind") !== -1) {
                    $scope.restWind = value.split("_")[1];
                    dismissLoadingBar(FACCONST.RELAXMODE);
                }
                if (value.indexOf("Sleep_") !== -1) {
                    $scope.sleep = parseInt(value.split("_")[1], 10);
                    if($scope.sleep < 0){
                        $scope.sleep = 0;
                    }
                    else if($scope.sleep > 24){
                        $scope.sleep = 24;
                    }
                    else if($scope.sleep === undefined || isNaN($scope.sleep)){
                        $scope.sleep = 16;
                    }
                    dismissLoadingBar(FACCONST.COMODE);
                }
                if (value.indexOf("Light_") !== -1) {
                    if (is17KModel()) {
                        $scope.lighting = value.split("_")[1];
                    } else {
                        $scope.lighting = value.indexOf("Light_On") !== -1;
                    }
                    dismissLoadingBar(FACCONST.LIGHTING);
                }
                if (value.indexOf("Volume_") !== -1) {
                    $scope.volume = value.split("_")[1];
                    dismissLoadingBar(FACCONST.VOLUMECHANGE);
                    $scope.updateVolumeSlider();
                }
                if (value.indexOf("Autoclean_") !== -1) {
                    $scope.autoClean = value.indexOf("Autoclean_On") !== -1;
                    dismissLoadingBar(FACCONST.AUTOCLEAN);
                }                
                if (value.indexOf("AutocleanProgress_") !== -1) {
                    $scope.autoCleanProgressValue = parseInt(value.split("_")[1], 10);                    
                }
                if (value.indexOf("Panel_") !== -1) {
                    $scope.panel = value.indexOf("Panel_Open") !== -1;
                    dismissLoadingBar(FACCONST.PANEL);
                }
                if (value.indexOf("Humidi_") !== -1) {
                    $scope.bacteriostasis = value.indexOf("Humidi_On") !== -1;
                    dismissLoadingBar(FACCONST.HUMIDIFY);
                }
                if (value.indexOf("Sterilize_") !== -1) {
                    $scope.sterilization = value.indexOf("Sterilize_On") !== -1;
                    dismissLoadingBar(FACCONST.STERILIZATION);
                }
                if (value.indexOf("Blooming_") !== -1) {
                    $scope.tempVentLevel = $scope.currentVentLevel = parseInt(value.slice(-1), 10);
                    dismissLoadingBar(FACCONST.VENT);
                    $scope.decodeVentLevel($scope.currentVentLevel);
                }
                if (value.indexOf("OptionCode_") !== -1) {
                    $scope.optionCode = UtilityService.pad(parseInt(value.split("_")[1], 10).toString(2), 16); //pad the number to 16 bits.
                    $scope.optionCodeValue = "OptionCode_16384";   // hardcoded for native processing
                }
                if (value.indexOf("Smarton_") !== -1) {
                    $scope.SmartonLockOff = value.indexOf("Smarton_LockOff") !== -1;
                    if (!$scope.SmartonLockOff) {
                        document.getElementById("popupcancel_smartlock").style.visibility = "hidden";
                        $scope.showSmartLockPopup = true;
                        toggleBottomPopUpClass($scope.showSmartLockPopup);
                    }
                }
                if (value.indexOf("EnergySaveIcon_") !== -1) {
                    $scope.EnergySaveIcon = value.indexOf("EnergySaveIcon_On") !== -1;
                }
                if (value.indexOf("Dehumidification_") !== -1) {
                    if (value === "Dehumidification_NotSupported") {
                        $scope.DehumidificationValue = "-";
                    } else {
                        var temp = parseInt(value.split("_")[1], 10)/10; // Divide by 10
                        $scope.DehumidificationValue = (temp === 0) ? "-" : temp;
                    }                    
                }
            });
        }
        // Temperatures
        if (angular.isDefined(device["Temperatures"])) {
            if (angular.isDefined(device["Temperatures"][0]["current"])) {
                $scope.homeTemp = device["Temperatures"][0]["current"];
            }
            if (angular.isDefined(device["Temperatures"][0]["desired"])) {
                $scope.desiredTemp = device["Temperatures"][0]["desired"];
                if ((angular.isDefined(device["id"]) && parseInt(device["id"], 10) === 0) ||
                    (angular.isDefined(device["resourceURI"]) && device["resourceURI"] === '/devices/0/temperatures')) {
                    console.log('aiFavorTemp = ', $scope.aiFavorTemp);
                    $scope.aiFavorTemp = $scope.desiredTemp;
                }
                dismissLoadingBar(FACCONST.TEMPCHANGE);
            }
        }
        // Supported modes
        if (angular.isDefined(device["Mode"]) && angular.isDefined(device["Mode"].supportedModes)) {
            $scope.supportedModes = device["Mode"].supportedModes;
            $scope.updateSupportedModesArray();
            updateSupportedModesWithIcon();
        }
        // Handling of notification of energy consumption
        if (angular.isDefined(device["EnergyConsumption"])) {
            parsePowerConsumption(device["EnergyConsumption"]);
        }

        if (angular.isDefined(device["EnergyConsumption"]) && angular.isDefined(device["EnergyConsumption"]["saveLocation"])) {
            $scope.energyMonitorLocation = device["EnergyConsumption"].saveLocation;
            if (!$scope.isStatic) {
                nativeInterface.getResourceUrl("/" + $scope.peerId + $scope.energyMonitorLocation);
            }
        }
        
        if (angular.isDefined(device["Humidity"])) {
            $scope.Device.Humidity.current = device["Humidity"]["current"];
            dismissLoadingBar(FACCONST.AIR_MONITORING);
            if ($scope.Device.Humidity.current === 0 && $scope.indoorHumidityPopup) { 
                // When it is 0, it means OFF state in 17K model then dismiss indoorHumidity popup if it is opened
                $scope.indoorHumidityPopup = false;
            }
        }

        // Smart care
        if (angular.isDefined(device["Diagnosis"])) {
            $scope.showSmartCare = true;
            $scope.diagnosisStart = device["Diagnosis"].diagnosisStart;
            if(!$scope.appAtForeground) {
            if ($scope.diagnosisStart === "Ready") {
                //Lokesh 17Nov15_2050 -> Should dismiss loading bar as soon as getting 'Ready' for diagnosis.
                //As per Jihee Jang, after 'Run', we get ready only when diagnosis is completed.
                dismissLoadingBar(FACCONST.DIAGNOSIS);
                if ($scope.currentScreen === FACSCREENS.SMARTCARE || $scope.currentScreen === FACSCREENS.SMARTCAREERROR) {
                    $scope.currentScreen = FACSCREENS.SMARTCAREERROR;
                    $scope.changeScreen();
                }
            } else {//Lokesh 19Nov15_1452 -> We should check if we are getting 'Run' and current screen is not smart care screen. Putting code in default else block may pose issues.
                $scope.currentScreen = FACSCREENS.SMARTCARE;
                $scope.changeScreen();
            }
        }
        }
        
        if (angular.isDefined(device["Sensors"]) && device["Sensors"].length > 0) {
            dismissLoadingBar(FACCONST.AIR_MONITORING);
            for (var i = 0; i < device["Sensors"].length; i++) {
                if ($scope.Device.Sensors[i] === undefined) {
                    $scope.Device.Sensors[i] = {id: '', type: '', values: ''};
                }
                if (angular.isDefined(device["Sensors"][i].id)) {
                    $scope.Device.Sensors[i].id = device["Sensors"][i].id;
                }
                if (angular.isDefined(device["Sensors"][i].type)) {
                    $scope.Device.Sensors[i].type = device["Sensors"][i].type;
                }
                if (angular.isDefined(device["Sensors"][i].values)) {
                    $scope.Device.Sensors[i].values = device["Sensors"][i].values;
                }

                switch ($scope.Device["Sensors"][i].id) {
                    case '0':
                        $scope.DeviceOptions.inDoorData.freshness.purity = parseInt($scope.Device["Sensors"][i].values[0], 10);
                        $scope.DeviceOptions.inDoorData.freshness.purityText = $scope.getPurityText(parseInt($scope.Device["Sensors"][i].values[0], 10));
                        $scope.DeviceOptions.inDoorData.freshness.colorClass = $scope.getAirPurityColor(parseInt($scope.Device["Sensors"][i].values[0], 10));
                        $scope.DeviceOptions.inDoorData.freshness.iconClass = getAirPurityImage(parseInt($scope.Device["Sensors"][i].values[0], 10));
                        break;
                    case '1':
                        $scope.DeviceOptions.inDoorData.odor.purity = parseInt($scope.Device["Sensors"][i].values[0], 10);
                        $scope.DeviceOptions.inDoorData.odor.purityText = $scope.getPurityText(parseInt($scope.Device["Sensors"][i].values[0], 10));
                        $scope.DeviceOptions.inDoorData.odor.colorClass = $scope.getAirPurityColor(parseInt($scope.Device["Sensors"][i].values[0], 10));
                        break;

                    case '2':
                        $scope.DeviceOptions.inDoorData.pm10.value = parseInt($scope.Device["Sensors"][i].values[0]);
                        $scope.DeviceOptions.inDoorData.pm10.purity = parseInt($scope.Device["Sensors"][i].values[1]);
                        $scope.DeviceOptions.inDoorData.pm10.purityText = $scope.getPurityText(parseInt($scope.Device["Sensors"][i].values[1], 10));
                        $scope.DeviceOptions.inDoorData.pm10.colorClass = $scope.getAirPurityColor(parseInt($scope.Device["Sensors"][i].values[1], 10));
                        break;
                    case '3':
                        $scope.DeviceOptions.inDoorData.pm25.value = parseInt($scope.Device["Sensors"][i].values[0], 10);
                        $scope.DeviceOptions.inDoorData.pm25.purity = parseInt($scope.Device["Sensors"][i].values[1], 10);
                        $scope.DeviceOptions.inDoorData.pm25.purityText = $scope.getPurityText(parseInt($scope.Device["Sensors"][i].values[1], 10));
                        $scope.DeviceOptions.inDoorData.pm25.colorClass = $scope.getAirPurityColor(parseInt($scope.Device["Sensors"][i].values[1], 10));
                        break;
                    default:
                        break;                    
                }
            }
        }

        // Handle events for filter alarm as of now
        if (!!device.event) {
            event = device.event.toLowerCase();
        }

        // Alarms parsing
        if (!!device.Alarms && device.Alarms.length) {
            //copy alarms object.
            $scope.Device.Alarms = angular.copy(device.Alarms);

            //Lokesh 19Nov15_0948 -> Handle alarms only when they are received.
            homeMultiService.handleAlarms($scope.Device.Alarms, "ErrorCode_", "ErrorCode_E", "ACMOB_ac_e_", "", FACSCREENS.ERRORPAGE)
            
            // Check for filter notification
            filterNotificationCheck($scope.Device.Alarms);
        }
        
        // If user is not on 'Add Wind' Screen then only update list with current mode
        if ($scope.currentScreen !== FACSCREENS.ADDWIND) {
            updateWindStrengthList($scope.currentMode);
            updateWindDirectionList($scope.currentMode);
        }
        updateDeviceOffScreen();
        updateBottomOptionList();
        updateOptionsList();
        updateSettingsList();
        updateHOADisplay();
        disableItems();
        dismissLoadingBar(FACCONST.GETDEVICES);
        
        if(!!resourceURL && (resourceURL.endsWith("/devices") || resourceURL.endsWith("/device"))) {//make sure this is getDevice response only.
            $scope.appAtForeground = false; //Lokesh 11Dec15_1957 -> Once getDevice()'s parsing is over mark appAtForeground as false. We don't need this flag anymore. Keeping this flag on beyond this point will have it's own cost which we do not want to bear.
        }
    };
    
    function getTrainingAIInfo() {
        // console.log("request to native to retrive TrainingDate");
        //STG: http://stg-dataapi.cspserver.net/ai/devices/{uuid}/trainData
        //PRD: https://dataapi.cspserver.net/ai/devices/{uuid}/trainData

        var region;
        if (angular.isDefined($scope.selectedWeatherLocationCode))
            region = $scope.selectedWeatherLocationCode;
        else
            region = "000";

        var requestForAuto = {
            uuid : $scope.deviceUuid,
            tempType : "Celsius",
            timeZone: "UTC+09:00",
            mode : "Auto",
            acType : "singleFac",
            region : region
        };

        var requestForSleep = {
            uuid : $scope.deviceUuid,
            tempType : "Celsius",
            timeZone: "UTC+09:00",
            mode : "Sleep",
            acType : "singleFac",
            region : region
        };


        $scope.checkResponse.push("getTrainingDate");
        SHPService.sendSHPCommand(CONSTANTS.RUNONNATIVE, "getTrainingDate", JSON.stringify(requestForAuto));
        $scope.checkResponse.push("getTrainingDate");
        SHPService.sendSHPCommand(CONSTANTS.RUNONNATIVE, "getTrainingDate", JSON.stringify(requestForSleep));
    }

    // function getModeStringForAI(){
    //     if($scope.currentMode === "Auto"){
    //         return "Auto";
    //     }
    //     else if(!!$scope.sleep){
    //         return "Sleep";
    //     }
    // }

    /**
     * @function updates Model information based on device object received from set.
     * @param {Object} device device object received from set
     * @author: Lokesh Sharma
     * @date: 15Dec15_1752
     * @description: As per mail from Mr. Kyungnam Kim on 15-Dec-15, Model info will come in following way:
     * ---------------------|------------------|--------------------------------
     *  Model               | Description      |    ModelInfo (one of these)
     *  --------------------|------------------|--------------------------------
     *  14K Memory          | 14K Memory FAC   |    ModelInfo_14K_MEMORY_M1,
     *                      |                  |    ModelInfo_14K_MEMORY_M2
     *  --------------------|------------------|--------------------------------                    
     *  15K Memory          | 15K Memory FAC   |    ModelInfo_14K_MEMORY_M1,
     *                      |                  |    ModelInfo_14K_MEMORY_M2
     *  --------------------|------------------|--------------------------------
     *  16K Bora            | FAC_BORA_16K     |    ModelInfo_16K_BORA_VENT3,
     *                      |                  |    ModelInfo_16K_BORA_VENT2
     *  --------------------|------------------|--------------------------------
     *  16K Memory (Dongle) | DONGLE_FAC_16K   |    ModelInfo_16K_MEMORY_VENT3, 
     *                      |                  |    ModelInfo_16K_MEMORY_VENT2
     *  --------------------|------------------|--------------------------------
     *  16K Bora (Dongle)   | DONGLE_FAC_16K   |    ModelInfo_16K_BORA_VENT3, 
     *                      |                  |    ModelInfo_16K_BORA_VENT2
     *  --------------------|------------------|--------------------------------
     *  17K Bora            | FAC_BORA_17K     |    ModelInfo_16K_BORA_VENT3, 
     *                      |                  |    ModelInfo_16K_BORA_VENT2
     *  --------------------|------------------|--------------------------------
     */
    function updateModelInfo(device) {
        if (!!device.Mode && !!device.Mode.options) {
            device.Mode.options.forEach(function (value) {
                if (value.indexOf("ModelInfo_") !== -1) {
                    modelInfo = MODELS[value.substr(9, value.length)] || MODELS.NONE; //start substr from 9th character because we need to include '_'. A number cannot be a first character of key.
                    if (modelInfo === MODELS._14K_MEMORY_M2 || modelInfo === MODELS._16K_BORA_VENT2 || modelInfo === MODELS._16K_MEMORY_VENT2) {
                        $scope.ventModel = 2;
                    } else {    //_14K_MEMORY_M1, _16K_BORA_VENT3, _16K_MEMORY_VENT3
                        $scope.ventModel = 3;
                    }
                    updateModeStringsBasedOnModel();
                }
            });
        }
    }
    
    function is14KModel() {
        //Lokesh 15Dec15_1738 -> use description, because model info is not unique.
        return ($scope.currentModel && ~$scope.currentModel.indexOf("14K"));
    }
    
    function is15KModel() {
        //Lokesh 15Dec15_1738 -> use description, because model info is not unique.
        return ($scope.currentModel && ~$scope.currentModel.indexOf("15K"));
    }
    
    function is16KModel() {
        //Lokesh 15Dec15_1738 -> use description. It is sufficient to identify model year.
        return ($scope.currentModel && ~$scope.currentModel.indexOf("16K"));
    }
    
    function is17KModel() {
        //Lokesh 15Dec15_1738 -> use description. It is sufficient to identify model year.
        return ($scope.currentModel && ~$scope.currentModel.indexOf("17K"));
    }
    
    //For both dongle and non-dongle BORA, model info is same and unique.
    function is16KBora() {
        return (!!modelInfo && (modelInfo === MODELS._16K_BORA_VENT2 || modelInfo === MODELS._16K_BORA_VENT3));
    }
    
    function is17KBora() {
        return (is17KModel() && !!modelInfo && (modelInfo === MODELS._16K_BORA_VENT2 || modelInfo === MODELS._16K_BORA_VENT3));
    }
    
    function is16KMemory() {
        //Lokesh 15Dec15_1738 -> No need to use description, because model info is unique.
        return (!!modelInfo && (modelInfo === MODELS._16K_MEMORY_VENT3 || modelInfo === MODELS._16K_MEMORY_VENT2));
    }
    
    //Though not used, keep this function for future use.
    function is16KBoraNonDongle() {
        //Lokesh 15Dec15_1738 -> use description because model info for normal BORA and Dongle BORA are same.
        //it's 'not' dongle and model info is _16K_BORA_VENT2 or _16K_BORA_VENT3
        return (!is16KDongle() && (!!modelInfo && (modelInfo === MODELS._16K_BORA_VENT2 || modelInfo === MODELS._16K_BORA_VENT3)));
    }
    
    function is16KBoraDongle() {
        //Lokesh 15Dec15_1738 -> use description because model info for normal BORA and Dongle BORA are same.
        //it's dongle and model info is _16K_BORA_VENT2 or _16K_BORA_VENT3
        return (is16KDongle() && (!!modelInfo && (modelInfo === MODELS._16K_BORA_VENT2 || modelInfo === MODELS._16K_BORA_VENT3)));
    }
    
    function is16KDongle() {
        return ~$scope.currentModel.indexOf("DONGLE_FAC_16K");
    }
    
    function isNonAirPurifierModel() { //only for 17K model
        return !!$scope.optionCode && $scope.optionCode[7] === '0'; // In binary, 8th bit - PM sensor - 0 No, 1 Yes
    }
    
    function updateDeviceOffScreen() {
        if ($scope.autoClean) {
            $scope.deviceOffText2 = $scope.translation.WEBMOB_device_auto_cleaning;
        } else {
            $scope.deviceOffText2 = "";
        }
    }

    /* HOADisplayValue description,
     * '2' - Home & Outdoor
     * '3-A' - Home, Outdoor & Air Purity
     * '3-B' - Home, Outdoor & Humidity
     * '4' - Home, Outdoor, Air Purity, Humidity
     */

    function updateHOADisplay() {
        // Display Home, Outdoor & Air purity depends upon condition
        if ($scope.DeviceOptions.inDoorData.pm10.purity === 0) {
            $scope.HOADisplayValue = is17KModel() ? getHOADCategory() : '2';
            $scope.showLoadingAnimAirPurity = false;
            $scope.airPurityDisable = false;
            if ($scope.currentScreen === FACSCREENS.AIRPURITY) {
                $scope.currentScreen = FACSCREENS.HOME;
                $scope.changeScreen();
            }
        } else if ($scope.DeviceOptions.inDoorData.pm10.purity > 0 && $scope.DeviceOptions.inDoorData.pm10.purity < 5) {
            $scope.showLoadingAnimAirPurity = false;
            $scope.airPurityDisable = false;
            $scope.HOADisplayValue = is17KModel() ? getHOADCategory() : '3_A';
        } else if ($scope.DeviceOptions.inDoorData.pm10.purity === 10) {
            $scope.HOADisplayValue = is17KModel() ? getHOADCategory() : '3_A';
            if ($scope.currentScreen === FACSCREENS.AIRPURITY) {
                resetAirPurityDetails();
            } else {
                $scope.airPurityDisable = true;
                $scope.showLoadingAnimAirPurity = true;
            }
        } else {
            // Nothing
        }
        // 16K Model - Display Humidity in Dry & DryPurify Modes, if we get Humidity info from getDevice
        // 17K Model - Display for all modes and value Humidity 0 means OFF
        if (is16KModel() && $scope.Device.Humidity.current !== -1) {
            if ($scope.currentMode === 'Dry') {
                $scope.HOADisplayValue = '3_B';
            }
            if ($scope.currentMode === 'DryClean') {
                $scope.HOADisplayValue = '4';
            }
        }
        
        // Set display category again, because above conditions will not work if we don't get data
        if (is17KModel()) {
            $scope.HOADisplayValue = getHOADCategory();
        }        
    }
    
    // To get (2, 3_A, 3_B, 4) category based on model
    function getHOADCategory() {
        var temp;
        if (isNonAirPurifierModel()) {
            temp = '3_B';
        } else {
            temp = '4';
        }
        return temp;
    }

    // Set default values while initialization
    function resetAirPurityDetails() {
        $scope.DeviceOptions.inDoorData.pm10.value = 9;
        $scope.DeviceOptions.inDoorData.pm10.purityText = $scope.getPurityText(1);
        $scope.DeviceOptions.inDoorData.pm10.colorClass = $scope.getAirPurityColor(1);

        $scope.DeviceOptions.inDoorData.pm25.value = 9;
        $scope.DeviceOptions.inDoorData.pm25.purityText = $scope.getPurityText(1);
        $scope.DeviceOptions.inDoorData.pm25.colorClass = $scope.getAirPurityColor(1);

        $scope.DeviceOptions.inDoorData.freshness.purity = 1;
        $scope.DeviceOptions.inDoorData.freshness.purityText = $scope.getPurityText(1);
        $scope.DeviceOptions.inDoorData.freshness.colorClass = $scope.getAirPurityColor(1);
    }

    // Update bottom options list on home screen based on model
    function updateBottomOptionList() {
        (is16KModel() || is17KModel()) && ($scope.showEnergyMonitorOption = true);

        // 16K model -> If DB is not downloaded and power state is off disable power consumption
        pcDisableCheck();
    }

    function pcDisableCheck() {
        if (!$scope.isStatic) {
            if (is16KModel() || is17KModel()) {
                if ($scope.isDBDownloaded) {
                    $scope.disablePowerConsumption = false;
                } else {
                    $scope.disablePowerConsumption = true;
                }
            } else {
                if ($scope.powerOperation) {
                    $scope.disablePowerConsumption = false;
                } else {
                    $scope.disablePowerConsumption = true;
                }
            }
        } else {
            $scope.disablePowerConsumption = false;
        }

        // If user is on power consumption page -> power off (old model) / power off & current selected tab is preset (16k and later) -> move screen to settings screen
        if (($scope.disablePowerConsumption || (!$scope.powerOperation && $scope.showPrsentPC)) && $scope.currentScreen === FACSCREENS.POWERCONSUMPTION) {
            onBackPressed();
        }
    }

    // Update options page based on mode
    function updateOptionsList() {
        switch ($scope.currentMode) {
            case "Cool":
            case "CoolClean":
                $scope.showSmartSensorOption = true;
                $scope.showTurboOption = true;
                $scope.showSoloOption = true;
                $scope.showQuietOption = true;
                break;
            case "Dry":
            case "DryClean":
            case "Wind":
                $scope.showSmartSensorOption = false;
                $scope.showTurboOption = false;
                $scope.showSoloOption = true;
                $scope.showQuietOption = false;
                break;
            case "Auto":
                $scope.showSmartSensorOption = false;
                $scope.showTurboOption = false;
                $scope.showSoloOption = false;
                $scope.showQuietOption = false;
                break;
            case "Heat":
            case "HeatClean":
                $scope.showSmartSensorOption = false;
                $scope.showTurboOption = true;
                $scope.showSoloOption = true;
                $scope.showQuietOption = false;
                break;
            default:
                break;
        }
        
        // Good sleep enable/disable conditions
        $scope.enableGoodSleepOption = $scope.powerOperation && ($scope.currentMode === "Cool" || $scope.currentMode === "CoolClean");
        if (!$scope.enableGoodSleepOption && $scope.showGoodSleepPopup) { // When good sleep option is disabled and if good sleep popup opened then close it
            $scope.showGoodSleepPopup = false;
            toggleBottomPopUpClass($scope.showGoodSleepPopup);
        }

        // 16K model doesn't support smart sensor, solo and relax (rest wind)
        if (is16KModel() || is17KModel()) {
            if (is16KBora() || is17KBora()) {
                $scope.showNanoWindOption = true;
                if ($scope.powerOperation) {
                    $scope.disableNanoWindOption = ($scope.currentMode === "Auto" || $scope.currentMode === "Heat" || $scope.currentMode === "HeatClean") ? true : false;
                } else {
                    $scope.disableNanoWindOption = true;
                }
                $scope.showSoloOption = false; //Solo is supported in 16K_MEMORY but not in 16K_BORA
            } else {
                $scope.showNanoWindOption = false;
            }
            $scope.showSmartSensorOption = false;
            $scope.showRelaxOption = false;           
        } else {
            $scope.showNanoWindOption = false;
            $scope.showRelaxOption = true;
        }

        // If Nano Wind is ON and Quiet is displayed, then disable Quiet option
        if ($scope.nanoWind && $scope.showQuietOption) {
            $scope.disableQuietOperation = true;
        } else {
            $scope.disableQuietOperation = false;
        }
        
        // 17K model only support long option instead of wind direction & it supports only in Cool (+Purify) and Heat (+Purify) modes
        if (is17KModel() && ($scope.currentMode === "Cool" || $scope.currentMode === "CoolClean" ||
                $scope.currentMode === "Heat" || $scope.currentMode === "HeatClean")) {
            $scope.showLongOption = true;
        } else {
            $scope.showLongOption = false;
        }
    }
    /* 1) When power is ON then only enable auto clean, remaining three disable.
     * 2) When power is off then enable Bacteriostasis humidity, sterilization, auto clean and panel.
     * 3) When any of these 4 buttons is enable, disable rest all three buttons.*/
    // Update setttings list
    function updateSettingsList() {
        if ($scope.powerOperation) {
            $scope.disablePanel = true;
            $scope.disableBacteriostasis = true;
            $scope.disableSterilize = true;
            $scope.disableAutoClean = false;
        } else {
            $scope.disablePanel = false;
            $scope.disableBacteriostasis = false;
            $scope.disableSterilize = false;
            $scope.disableAutoClean = false;
            if ($scope.autoClean) {
                $scope.disablePanel = true;
                $scope.disableBacteriostasis = true;
                $scope.disableSterilize = true;
                $scope.disableAutoClean = false;
            } else if ($scope.panel) {
                $scope.disablePanel = false;
                $scope.disableBacteriostasis = true;
                $scope.disableSterilize = true;
                $scope.disableAutoClean = true;
            } else if ($scope.bacteriostasis) {
                $scope.disablePanel = true;
                $scope.disableBacteriostasis = false;
                $scope.disableSterilize = true;
                $scope.disableAutoClean = true;
            } else if ($scope.sterilization) {
                $scope.disablePanel = true;
                $scope.disableBacteriostasis = true;
                $scope.disableSterilize = false;
                $scope.disableAutoClean = true;
            } else {
                // Nothing
            }
        }

        // If we don't get Light option in options list then don't display it
        if ($scope.lighting === null) {
            $scope.showLightingSetting = false;
        } else {
            $scope.showLightingSetting = true;
        }

        // 16K model doesn't support Humidify and Sterilization option
        if (is16KModel() || is17KModel()) {
            $scope.showHumidifySetting = false;
            $scope.showSterilizationSetting = false;
            $scope.showMyWindOption = true;
        } else {
            $scope.showHumidifySetting = true;
            $scope.showSterilizationSetting = true;
            $scope.showMyWindOption = false;
        }        
    }
    // Disable items based on conditions
    function disableItems() {
        if ($scope.desiredTemp === $scope.defaultConfig[$scope.currentMode].configTempHigh) {
            $scope.disableTempInc = true;
            $scope.disableTempDec = false;
        } else if ($scope.desiredTemp === $scope.defaultConfig[$scope.currentMode].configTempLow) {
            $scope.disableTempDec = true;
            $scope.disableTempInc = false;
        } else {
            $scope.disableTempDec = false;
            $scope.disableTempInc = false;
        }

        if ($scope.turbo || $scope.currentMode === "Auto" || $scope.currentMode === "Wind" || !$scope.powerOperation) {
            $scope.disableTempControl = true;
        } else {
            $scope.disableTempControl = false;
        }

        if (!$scope.powerOperation || (is14KModel() && $scope.currentMode === "Wind" && $scope.currentWindDirection === "Long")) {
            $scope.disableWindStrength = true;
        } else {
            $scope.disableWindStrength = false;
        }
        
        if (is17KModel()) {
            if (!$scope.powerOperation || $scope.currentMode === "Auto" || $scope.currentMode === "Wind") {
                $scope.disablePurityOption = true;
            } else {
                $scope.disablePurityOption = false;
            }
        }

        if ($scope.powerOperation) {
            $scope.disableOptions = false;
        } else {
            $scope.disableOptions = true;
        }

        if ((is16KModel() || is17KModel()) && $scope.powerOperation) {
            if ($scope.currentMode === "Auto" || $scope.currentMode === "Dry" || $scope.currentMode === "DryClean" || $scope.currentMode === "Wind") {
                $scope.disableOptions = true;
            } else {
                $scope.disableOptions = false;
            }
        }
        
        // Exceptional flow
        if(is17KModel() && isNonAirPurifierModel() && $scope.powerOperation &&
            ($scope.currentMode === "Dry" || $scope.currentMode === "DryClean")) {
            $scope.disableOptions = false;
        }

        // If options item is disable, user is on Options screen then it should move to Home Screen
        if ($scope.disableOptions && $scope.currentScreen === FACSCREENS.OPTIONS) {
            onBackPressed();
        }

        //If AI Cool Learning is disable, user is on AI page screen then it should move to Home Screen
        if (!isAICoolLearningEnable() && $scope.currentScreen === FACSCREENS.AICOOLLEARNING) {
            onBackPressed();
        }
    }

    function updateModeStringsBasedOnModel() {
        if (is14KModel() || is15KModel() || is16KMemory()) {
            listOfModes[5].textToDisplay = "WEBMOB_device_fac_mode_auto_15k";
        } else if (is16KBora() || is16KBoraDongle() || is17KBora()) {
            listOfModes[5].textToDisplay = "WEBMOB_device_fac_mode_auto_16k";
        } else { // Show default string in case of other Sets.
            //Null
        }
    }

    // Mode updation start
    // If it is 14k or 15k model check option code for heat mode support
    $scope.updateSupportedModesArray = function () {
        if (is14KModel() || is15KModel()) {
            if ($scope.optionCode[15] === '0') {
                // Supports heat mode
            } else {
                if(~$scope.supportedModes.indexOf("Heat")) {
                    $scope.supportedModes.splice($scope.supportedModes.indexOf("Heat"), 1);
                }
                if(~$scope.supportedModes.indexOf("HeatClean")) {
                    $scope.supportedModes.splice($scope.supportedModes.indexOf("HeatClean"), 1);
                }
            }
        }        
        // For 17K Model, instead of displaying clean modes need to display mode + purify option. so, remove all clean modes
        if (is17KModel()) {
            if (~$scope.supportedModes.indexOf("CoolClean")) {
                $scope.supportedModes.splice($scope.supportedModes.indexOf("CoolClean"), 1);
            }
            if (~$scope.supportedModes.indexOf("DryClean")) {
                $scope.supportedModes.splice($scope.supportedModes.indexOf("DryClean"), 1);
            }
            if (~$scope.supportedModes.indexOf("HeatClean")) {
                $scope.supportedModes.splice($scope.supportedModes.indexOf("HeatClean"), 1);
            }
        } else {
            // 1stJan2016 - As per Kim, if heat is available and HeatClean is not available
            // in supported modes array then add HeatClean in FAC, Home Multi RAC for all models
            if (~$scope.supportedModes.indexOf("Heat") && !~$scope.supportedModes.indexOf("HeatClean")) {
                $scope.supportedModes.push("HeatClean");
            }
        }
        
    };
    function updateSupportedModesWithIcon() {
        $scope.supportedModesIcon = []; // clear items
        $scope.supportedModes.forEach(function (value) {
            updateImageIDInModes(value);
        });
        // Sorting the array based on requirement
        $scope.supportedModesIcon.sort(function (a, b) {
            return a.id - b.id;
        });
    }
    function updateImageIDInModes(mode) {
        listOfModes.forEach(function (value) {
            if (value.modeName === mode) {
                $scope.supportedModesIcon.push(value);
            }
        });
    }
    $scope.getModeText = function (mode) {
        // For 17K Model, instead of displaying clean modes need to display mode + purify option
        if (is17KModel() && mode && ~mode.indexOf("Clean")) {
            mode = mode.split("Clean")[0];
        }
        
        var temp;
        listOfModes.forEach(function (value) {
            if (value.modeName === mode) {
                temp = value.textToDisplay;
            }
        });
        return temp;
    };
    function getModeCompleteText(mode) {
        var temp;
        listOfModes.forEach(function (value) {
            if (value.modeName === mode) {
                temp = value.textToDisplay;
            }
        });
        return temp;
    }
    // Mode updation end

    // Wind strength start
    $scope.getWindStrengthText = function (speed) {
        var temp;
        listWindStrength.forEach(function (value) {
            if (value.id === speed) {
                temp = value.textToDisplay;
            }
        });
        return temp;
    };
    $scope.getWindStrengthImage = function (speed) {
        var temp;
        listWindStrength.forEach(function (value) {
            if (value.id === speed) {
                temp = value.imageID;
            }
        });
        var svg = document.getElementById('windSVG');
        SHPService.loadSVG(temp, svg);
        //return temp;
    };
    function getWindStrengthObj(mode) {
        var temp;
        listWindStrength.forEach(function (value) {
            if (value.modeName === mode) {
                temp = value;
            }
        });
        return temp;
    }
    function updateWindStrengthList(mode) {
        $scope.supportedWindStrength = [];
        if (is14KModel()) {
            switch (mode) {
                case "Auto":
                case "Dry":
                case "DryClean":
                    $scope.supportedWindStrength.push(getWindStrengthObj("Auto"));
                    break;
                case "Cool":
                case "CoolClean":
                case "Heat":
                case "HeatClean":
                    $scope.supportedWindStrength.push(getWindStrengthObj("Auto"));
                    $scope.supportedWindStrength.push(getWindStrengthObj("Mid"));
                    $scope.supportedWindStrength.push(getWindStrengthObj("High"));
                    $scope.supportedWindStrength.push(getWindStrengthObj("Turbo"));
                    break;
                case "Wind":
                    $scope.supportedWindStrength.push(getWindStrengthObj("Mid"));
                    $scope.supportedWindStrength.push(getWindStrengthObj("High"));
                    $scope.supportedWindStrength.push(getWindStrengthObj("Turbo"));
                    break;
                default:
                    break;
            }
        } else {
            switch (mode) {
                case "Auto":
                case "Dry":
                case "DryClean":
                    $scope.supportedWindStrength.push(getWindStrengthObj("Auto"));
                    break;
                case "Cool":
                case "CoolClean":
                case "Heat":
                case "HeatClean":
                case "Wind":
                    $scope.supportedWindStrength.push(getWindStrengthObj("Auto"));
                    $scope.supportedWindStrength.push(getWindStrengthObj("Mid"));
                    $scope.supportedWindStrength.push(getWindStrengthObj("High"));
                    $scope.supportedWindStrength.push(getWindStrengthObj("Turbo"));
                    break;
                default:
                    break;
            }
        }

        if ($scope.currentScreen !== FACSCREENS.ADDWIND) {
            /* Condition 1
             * 1. If only one vent is open then only auto can be selected 2. if wind
             * direction is long then only auto mode can be selected 3. if speed
             * mode is on then only auto mode can be selected. 4. if good sleep mode
             * then also only show auto mode
             */
            if (is14KModel() && $scope.currentMode === "Wind") {
                // 14K FAC: Wind mode not supported "Auto" Wind level
            } else {
                if ($scope.currentVentLevel === 1 || $scope.currentVentLevel === 2 || $scope.currentVentLevel === 4 || $scope.currentWindDirection === "Long" || $scope.turbo || $scope.goodSleep) {
                    $scope.supportedWindStrength = [];
                    $scope.supportedWindStrength.push(getWindStrengthObj("Auto"));
                }
            }
            // Condition 2
            if ((is14KModel() || is15KModel()) &&
                    $scope.restWind !== "Off" &&
                    ($scope.currentMode === "Cool" ||
                            $scope.currentMode === "CoolClean") &&
                    !!$scope.comodeOff &&
                    !!!$scope.solo) {
                $scope.supportedWindStrength = [];
                $scope.supportedWindStrength.push(getWindStrengthObj("Auto"));
            }
            // Condition 3
            if (is15KModel()&&
                    $scope.restWind !== "Off" &&
                    $scope.currentMode === "Wind" &&
                    !!!$scope.solo) {
                $scope.supportedWindStrength = [];
                $scope.supportedWindStrength.push(getWindStrengthObj("Auto"));
            }
            // Condition 4
            if ((is16KModel() || is17KModel()) &&
                    !!$scope.nanoWind) {
                $scope.supportedWindStrength = [];
                $scope.supportedWindStrength.push(getWindStrengthObj("Auto"));
            }
        } else if ($scope.currentScreen === FACSCREENS.ADDWIND && $scope.selectedWind.windDirection === "Long") {
            $scope.supportedWindStrength = [];
            $scope.supportedWindStrength.push(getWindStrengthObj("Auto"));
        }

    }
    // Wind strength end

    // Wind direction start
    $scope.getWindDirectionText = function (direction) {
        var temp;
        listWindDirection.forEach(function (value) {
            if (value.modeName === direction) {
                temp = value.textToDisplay;
            }
        });
        return temp;
    };
    
    $scope.getWindDirectionImage = function (direction) {
        var temp;
        if (angular.isDefined($scope.supportedWindDirection)) {
            listWindDirection.forEach(function (value) {
                if (value.modeName === direction) {
                    temp = value.imageID;
                }
            });
        }
        var svg = document.getElementById('windDirSVG');
        SHPService.loadSVG(temp, svg);
        //return temp;
    };
    
    function getWindDirectionObj(mode) {
        var temp;
        listWindDirection.forEach(function (value) {
            if (value.modeName === mode) {
                temp = value;
            }
        });
        return temp;
    }
    function updateWindDirectionList(mode) {
        $scope.supportedWindDirection = [];
        switch (mode) {
            case "Auto":
                $scope.supportedWindDirection.push(getWindDirectionObj("Off"));
                if((is16KModel() || is17KBora()) && $scope.currentScreen === FACSCREENS.HOME) { //Lokesh 26Nov15_1902 -> As per Mr. Kim, whenever auto mode is selected (for all models), wind direction should set to 'Off'.
                    // 16K model - Auto Mode - set Off by default
                    $scope.currentWindDirection = "Off";
                    // 16K model doesn't support Direct and Indirect
                } 
                
                //Direct and Indirect option not available only in 16K_BORA && 17K_BORA
                if(!is16KModel() && !is17KBora()) {
                    $scope.supportedWindDirection.push(getWindDirectionObj("Direct"));
                    $scope.supportedWindDirection.push(getWindDirectionObj("Indirect"));
                }
                break;
            case "Dry":
            case "DryClean":
            case "Cool":
            case "CoolClean":
            case "Heat":
            case "HeatClean":
            case "Wind":
                $scope.supportedWindDirection.push(getWindDirectionObj("Center"));
                
                //Wide option not available in 16K_BORA && 17K_BORA
                if(!is16KBora() && !is17KBora()) {
                    $scope.supportedWindDirection.push(getWindDirectionObj("Wide"));
                }
                
                //Long option not available in 16K_BORA && 17K_BORA for Purify, Dry and (Dry, Purify) modes.
                if((mode === "Dry" || mode === "DryClean" || mode === "Wind") && (is16KBora() || is17KBora())) {
                    $scope.currentWindDirection = "Center"; //Only center available as wind direction.
                } else {
                    $scope.supportedWindDirection.push(getWindDirectionObj("Long"));
                }
                break;
            default:
                break;
        }
        if ($scope.currentScreen !== FACSCREENS.ADDWIND) {
            /**
             * if good sleep mode is selected then show only direction center and
             * display nothing.
             * this is to show "center" only on winddirection menu of main screen below 17k model.
             */
            if (!is17KModel() && $scope.goodSleep) {
                $scope.supportedWindDirection = [];
                $scope.supportedWindDirection.push(getWindDirectionObj("Center"));
                $scope.currentWindDirection = "Center";
            }
        }
    };
    // Wind direction end
    
    function isPopupOpen () {
        if ($scope.showVentSelectionPopup || $scope.showModeSelectionPopup || $scope.showWindStrengthPopup || $scope.showWindDirectionPopup
                || $scope.showRelaxModePopup || $scope.showGoodSleepPopup || $scope.targetUsagePopup || $scope.showVolumePopup 
                || $scope.showAddWindModeSelectionPopup || $scope.powerOffPopup || $scope.showConnFailurePopup || $scope.showModuleInfoPopup 
                || $scope.loadingBar || $scope.bUsageHelpPage || $scope.bOptionPopUp || $scope.indoorHumidityPopup) {
            return true;
        }
        return false;
    }

    // Dismiss all popups
     function dismissAllPopups() {
        if ($scope.dialogPopup) {
            $scope.dialogPopup = false;
            $scope.isRadioSelection = false;
            $scope.showServiceCenterText = false;
            return true;
        }
        if ($scope.showVentSelectionPopup) {
            $scope.showVentSelectionPopup = false;
            return true;
        }
        if ($scope.showModeSelectionPopup) {
            $scope.showModeSelectionPopup = false;
            return true;
        }
        if ($scope.showWindStrengthPopup) {
            $scope.showWindStrengthPopup = false;
            return true;
        }
        if ($scope.showWindDirectionPopup) {
            $scope.showWindDirectionPopup = false;
            return true;
        }
        if ($scope.showRelaxModePopup) {
            $scope.showRelaxModePopup = false;
            return true;
        }
        if ($scope.showGoodSleepPopup) {
            $scope.showGoodSleepPopup = false;
            return true;
        }
        if ($scope.targetUsagePopup) {
            $scope.targetUsagePopup = false;
            return true;
        }
        if ($scope.showVolumePopup) {
            $scope.onVolumeCancel();
            return true;
        }
        if ($scope.showAddWindModeSelectionPopup) {
            $scope.showAddWindModeSelectionPopup = false;
            return true;
        }
        if ($scope.powerOffPopup) {
            $scope.powerOffPopup = false;
            return true;
        }
        if($scope.countrySelectionPopupVisible) {
            $scope.countrySelectionPopupVisible = false;
            return true;
        }
        if ($scope.bOptionPopUp) {
            $scope.bOptionPopUp = false;
            return true;
        }
        if ($scope.bUsageHelpPage) {
            $scope.bUsageHelpPage = false;
            return true;
        }
        if ($scope.showModuleInfoPopup) {
            $scope.showModuleInfoPopup = false;
            return true;
        }
        if ($scope.indoorHumidityPopup) {
            $scope.indoorHumidityPopup = false;
            return true;
        }
        if ($scope.showMeterDatePopup) {
            $scope.showMeterDatePopup = false;
            return true;
        }
        return false;
    }

    // Show popup
    $scope.openPopoverMode = function () {
        if ($scope.powerOperation) {
            $scope.showModeSelectionPopup = true;
            changePopUpClass();
        }
    };

    // close popovermode
    $scope.closePopoverMode = function () {
        $scope.showModeSelectionPopup = false;
        changePopUpClass();
    };

    $scope.openPopoverWindStrength = function () {
        $timeout(function () {
            if (!$scope.disableWindStrength) {
                $scope.showWindStrengthPopup = true;
                toggleBottomPopUpClass($scope.showWindStrengthPopup);
            }
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };
    $scope.openPopoverWindDirection = function () {
        $timeout(function () {
            if ($scope.powerOperation) {
                $scope.showWindDirectionPopup = true;
                toggleBottomPopUpClass($scope.showWindDirectionPopup);
            }
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };
    $scope.openPopoverRelaxModes = function () {
        $timeout(function () {
            $scope.showRelaxModePopup = true;
            toggleBottomPopUpClass($scope.showRelaxModePopup);
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };
    $scope.openPopoverVentSelection = function () {
        $timeout(function () {
            $scope.updateVentCheckBoxes();
            $scope.tempVentLevel = $scope.currentVentLevel;
            $scope.showVentSelectionPopup = true;
            toggleVentPopUpClass($scope.showVentSelectionPopup);
            $scope.decodeVentLevel($scope.currentVentLevel);
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };

    // My wind popups
    $scope.openMyWindModeSelection = function () {
        $timeout(function () {
            $scope.showAddWindModeSelectionPopup = true;
            toggleBottomPopUpClass($scope.showAddWindModeSelectionPopup);
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };
    $scope.openMyWindWindStrength = function () {
        $timeout(function () {
            $scope.showWindStrengthPopup = true;
            toggleBottomPopUpClass($scope.showWindStrengthPopup);
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };
    $scope.openMyWindWindDirection = function () {
        $timeout(function () {
            $scope.showWindDirectionPopup = true;
            toggleBottomPopUpClass($scope.showWindDirectionPopup);
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };

    // Volume slider popup start
    $scope.tempVolume = 0;
    $scope.openPopoverVolumeSelection = function () {
            $scope.showVolumePopup = true;
            toggleVolumePopUpClass();
            $scope.updateVolumeSlider();
    };
    // If volume popup is shown then update the progress bar and icon
    $scope.updateVolumeSlider = function () {
        if ($scope.showVolumePopup) {
            $scope.tempVolume = $scope.getVolumeLevelNum($scope.volume);
        }
    };
    $scope.onVolumeSave = function (newVolume) {
        $scope.showVolumePopup = false;
        toggleVolumePopUpClass();
        if (!$scope.isStatic) {
            if ($scope.volume !== $scope.getVolumeLevelBig(newVolume)) {
                $scope.checkResponse.push(FACCONST.VOLUMECHANGE);
                SHPService.sendSHPCommand(CONSTANTS.PUT, getVolumeCommand($scope.getVolumeLevelBig(newVolume)), "/" + $scope.peerId + "/devices/0");
            }
        } else {
            $scope.volume = newVolume;
        }
    };
    $scope.onVolumeCancel = function () {
        $scope.showVolumePopup = false;
        toggleVolumePopUpClass();
    };

    var volumeObj = {
        0: "Mute",
        1: 33,
        2: 66,
        3: 100
    };

    $scope.getVolumeLevelText = function (volume) {
        if (volume == '0' || volume == "Mute") {
            return $scope.translation.ACMOB_dialog_title_sound_mute_rac;
        } else if (volume == '1' || volume == '33') {
            return $scope.translation.ACMOB_wind_level_low;
        } else if (volume == '2' || volume == '66') {
            return $scope.translation.ACMOB_wind_level_mid;
        } else if (volume == '3' || volume == '100') {
            return $scope.translation.ACMOB_wind_level_high;
        } else {
            return "";
        }
    };

    $scope.getVolumeLevelNum = function (volume) {
        var returnVal = UtilityService.findKeyByValue(volumeObj, volume) || volume;
        return returnVal;
    };
    
    $scope.getVolumeLevelBig = function (volume) {
        var returnVal = volumeObj[volume] || volume;
        return returnVal;
    };
    // Volume slider popup end
    
    function setConfigWindDirection(windDirection) {
        if(!!$scope.currentMode) {
            $scope.defaultConfig[$scope.currentMode].configWindDirection = windDirection || $scope.currentWindDirection;
        }
    }
    
    function setConfigWindStrength(windStrength) {
        if(!!$scope.currentMode) {
            $scope.defaultConfig[$scope.currentMode].configWindStrength = windStrength || $scope.currentWindStrength;
        }
    }
    
    // Volume slider popup end
    // Start popup realted
    $scope.selectMode = function (selectedItem, isFromPurify) {
        if ($scope.currentScreen === FACSCREENS.HOME || $scope.currentScreen === FACSCREENS.OPTIONS) {
            $scope.showModeSelectionPopup = false;
            changePopUpClass();
             //$scope.currentMode can be Cool/CoolClean(if purity is on), but for both the cases selectedItem.modeName will always be Cool
            //So using startsWith STRING method instead of direct equality check  
            if ((is17KModel() && ((!isFromPurify && $scope.currentMode.indexOf(selectedItem.modeName) !== 0) || (isFromPurify && $scope.currentMode !== selectedItem.modeName))) 
                    || (!is17KModel() && ($scope.currentMode !== selectedItem.modeName))) {
                if (!$scope.isStatic) {
                    var tempMode = selectedItem.modeName;
                    // If purify option is already applied, then it should apply when we are applying new mode (only for 17K model only)
                    if (!isFromPurify && is17KModel() && ~$scope.currentMode.indexOf('Clean') && tempMode !== 'Wind' && tempMode !== 'Auto') {
                        tempMode += 'Clean';
                    }
                    //Lokesh_30Nov15_2347 ->AC0600065242 ->save previous values for future use. 
                    setConfigWindStrength();
                    setConfigWindDirection();
                    $scope.checkResponse.push(FACCONST.MODECHANGE);
                    
                    //Lokesh 30Nov15_1735 -> CQ ID - AC0600065242 -> As per Mr. Kim, whenever 'Auto' mode is set, wind direction should be set to 'Off'. This feature could not be tested on 15K Memory because of device unavailability.
                    SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getModeCommand(tempMode, $scope.defaultConfig[tempMode].configWindDirection, $scope.defaultConfig[tempMode].configWindStrength, $scope.defaultConfig[tempMode].configTempDefault, isFromPurify), "/" + $scope.peerId + "/devices/0");
                } else {
                    $scope.currentMode = selectedItem.modeName;
                    updateWindDirectionList($scope.currentMode); //update wind direction for better simulation.
                }
            }
        } else if ($scope.currentScreen === FACSCREENS.ADDWIND) {
            $scope.showAddWindModeSelectionPopup = false;
            toggleBottomPopUpClass($scope.showAddWindModeSelectionPopup);                            
            $scope.selectedWind.mode = selectedItem.modeName;
            updateWindStrengthList($scope.selectedWind.mode);
            updateWindDirectionList($scope.selectedWind.mode);
            $scope.selectedWind.temp = $scope.defaultConfig[$scope.selectedWind.mode].configTempDefault;
            $scope.selectedWind.windStrength = $scope.defaultConfig[$scope.selectedWind.mode].configWindStrength;
            $scope.selectedWind.windDirection = $scope.defaultConfig[$scope.selectedWind.mode].configWindDirection;
            if ($scope.selectedWind.windDirection === "Off" && $scope.selectedWind.mode !== "Auto") {
                $scope.selectedWind.windDirection = "Center";
            }
            $scope.selectedWind.purify = false;
        } else {
            // Nothing
        }
    };
    $scope.isModeSelected = function (selectedItem) {                
        // For 17K Model, instead of displaying clean modes need to display mode + purify option
        if ($scope.currentScreen === FACSCREENS.HOME) {
            var homeTempMode = $scope.currentMode;            
            if (is17KModel() && homeTempMode && ~homeTempMode.indexOf("Clean")) {
                homeTempMode = homeTempMode.split("Clean")[0];
            }
        }
        if ($scope.currentScreen === FACSCREENS.ADDWIND) {
            var myWindTempMode = $scope.selectedWind.mode;
            if (is17KModel() && myWindTempMode && ~myWindTempMode.indexOf("Clean")) {
                myWindTempMode = myWindTempMode.split("Clean")[0];
            }
        }                
        return ($scope.currentScreen === FACSCREENS.HOME && homeTempMode === selectedItem.modeName) || ($scope.currentScreen === FACSCREENS.ADDWIND && myWindTempMode === selectedItem.modeName);
    };
    $scope.selectWindStrenth = function (selectedItem) {
        $scope.showWindStrengthPopup = false;
        toggleBottomPopUpClass($scope.showWindStrengthPopup);
        if ($scope.currentScreen === FACSCREENS.HOME) {
            if ($scope.currentWindStrength !== selectedItem.id) {
                if (!$scope.isStatic) {
                    $scope.checkResponse.push(FACCONST.WINDSTRENGTH_CHANGE);
                    setConfigWindStrength(selectedItem.id);
                    SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getWindStrengthCommand(selectedItem.id), "/" + $scope.peerId + "/devices/0");
                } else {
                    $scope.currentWindStrength = selectedItem.id;
                }
            }
        } else if ($scope.currentScreen === FACSCREENS.ADDWIND) {
            $scope.selectedWind.windStrength = selectedItem.id;
        } else {
            // Nothing
        }
    };
    $scope.isWindStrengthSelected = function (selectedItem) {
        return ($scope.currentScreen === FACSCREENS.HOME && $scope.currentWindStrength === selectedItem.id) || ($scope.currentScreen === FACSCREENS.ADDWIND && $scope.selectedWind.windStrength === selectedItem.id);
    };
    $scope.selectWindDirection = function (selectedItem) {
        $scope.showWindDirectionPopup = false;
        toggleBottomPopUpClass($scope.showWindDirectionPopup);
        if ($scope.currentScreen === FACSCREENS.HOME || $scope.currentScreen === FACSCREENS.OPTIONS) {
            if ($scope.currentWindDirection !== selectedItem.modeName) {
                if (!$scope.isStatic) {
                    $scope.checkResponse.push(FACCONST.WINDDIRECTION_CHANGE);
                    setConfigWindDirection(selectedItem.modeName);
                    SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getWindDirectionCommand(selectedItem.modeName), "/" + $scope.peerId + "/devices/0");
                } else {
                    $scope.currentWindDirection = selectedItem.modeName;
                }
            }
        } else if ($scope.currentScreen === FACSCREENS.ADDWIND) {
            $scope.selectedWind.windDirection = selectedItem.modeName;
            if ($scope.selectedWind.windDirection === "Long") {
                $scope.selectedWind.windStrength = 0;
            }
            updateWindStrengthList($scope.selectedWind.mode);
        } else {
            // Nothing
        }
    };
    $scope.isWindDirectionSelected = function (selectedItem) {
        return ($scope.currentScreen === FACSCREENS.HOME && $scope.currentWindDirection === selectedItem.modeName) || ($scope.currentScreen === FACSCREENS.ADDWIND && $scope.selectedWind.windDirection === selectedItem.modeName);
    };
    $scope.selectRelaxMode = function (selectedItem) {
        $scope.showRelaxModePopup = false;
        toggleBottomPopUpClass($scope.showRelaxModePopup);
        if ($scope.restWind !== selectedItem.modeName) {
            if (!$scope.isStatic) {
                $scope.checkResponse.push(FACCONST.RELAXMODE);
                SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getRelaxCommand(selectedItem.modeName), "/" + $scope.peerId + "/devices/0");
            } else {
                $scope.restWind = selectedItem.modeName;
            }
        }
    };
    $scope.isRelaxModeSelected = function (selectedItem) {
        if ($scope.restWind === selectedItem.modeName) {
            return true;
        } else {
            return false;
        }
    };
    $scope.getRelaxModeText = function (mode) {
        var temp;
        $scope.ListOfRelaxModes.forEach(function (value) {
            if (value.modeName === mode) {
                temp = value.textToDisplay;
            }
        });
        return temp;
    };    
    // End popup related
    
    // Lighting page start
    function selectLightingMode(selectedItem) {
        if ($scope.lighting !== selectedItem.modeName) {
            if (!$scope.isStatic) {
                $scope.checkResponse.push(FACCONST.LIGHTING);
                SHPService.sendSHPCommand(CONSTANTS.PUT, getLightModeCommand(selectedItem.modeName), "/" + $scope.peerId + "/devices/0");
            } else {
                $scope.lighting = selectedItem.modeName;
            }
        }
    }
    function getLightingModeText(mode) {
        var temp;
        $scope.LightingModes.forEach(function (value) {
            if (value.modeName === mode) {
                temp = value.textToDisplay;
            }
        });
        return temp;
    }
    // Lighting page end
    
    // Voice selection page start
    function selectVoiceSelectionMode(selectedItem) {
        if ($scope.volume !== selectedItem.modeName) {
            if (!$scope.isStatic) {
                $scope.checkResponse.push(FACCONST.VOLUMECHANGE);
                SHPService.sendSHPCommand(CONSTANTS.PUT, getVolumeCommand(selectedItem.modeName), "/" + $scope.peerId + "/devices/0");
            } else {
                $scope.volume = selectedItem.modeName;
            }
        }
    }
    function getVoiceSelectionModeText(mode) {
        var temp;
        $scope.VoiceSelectionModes.forEach(function (value) {
            if (value.modeName === mode) {
                temp = value.textToDisplay;
            }
        });
        return temp;
    }
    // Voice selection page end

    // Vent selection start
    $scope.selectVent = function (id, evnt) {
        $scope.tempVentLevel = getVentLevel(id);
        if ($scope.tempVentLevel === 0) {
            if ($scope.powerOperation) {
                $scope.powerOffPopup = true;
                togglePowerOffPopUpClass($scope.powerOffPopup);
            }
        } else {
            sendVentSelectionReq();
        }
        if($scope.isStatic) {
            $scope.decodeVentLevel($scope.tempVentLevel);
        }
    };
    $scope.updateVentImage = function (ventlevel) {
        if ($scope.ventModel === THREE_VENT_MODEL) {
            switch (ventlevel) {
                case VENTLEVEL_0:
                    document.getElementById("ventImage").src = "FAC/assets/img/main_img_air_3_00.png";
                    break;
                case VENTLEVEL_1:
                    document.getElementById("ventImage").src = "FAC/assets/img/main_img_air_3_01.png";
                    break;
                case VENTLEVEL_2:
                    document.getElementById("ventImage").src = "FAC/assets/img/main_img_air_3_02.png";
                    break;
                case VENTLEVEL_3:
                    document.getElementById("ventImage").src = "FAC/assets/img/main_img_air_3_04.png";
                    break;
                case VENTLEVEL_4:
                    document.getElementById("ventImage").src = "FAC/assets/img/main_img_air_3_03.png";
                    break;
                case VENTLEVEL_5:
                    document.getElementById("ventImage").src = "FAC/assets/img/main_img_air_3_06.png";
                    break;
                case VENTLEVEL_6:
                    document.getElementById("ventImage").src = "FAC/assets/img/main_img_air_3_05.png";
                    break;
                case VENTLEVEL_7:
                    document.getElementById("ventImage").src = "FAC/assets/img/main_img_air_3_07.png";
                    break;
                default:
                    break;
            }
        } else if ($scope.ventModel === TWO_VENT_MODEL) {
            switch (ventlevel) {
                case VENTLEVEL_0:
                    document.getElementById("ventImage").src = "FAC/assets/img/main_img_air_2_00.png";
                    break;
                case VENTLEVEL_1:
                    document.getElementById("ventImage").src = "FAC/assets/img/main_img_air_2_01.png";
                    break;
                case VENTLEVEL_2:
                    document.getElementById("ventImage").src = "FAC/assets/img/main_img_air_2_02.png";
                    break;
                case VENTLEVEL_3:
                    document.getElementById("ventImage").src = "FAC/assets/img/main_img_air_2_03.png";
                    break;
                default:
                    break;
            }
        } else {
            // Nothing
        }
    };

    $scope.getVentImageClass = function (ventlevel) {
        var temp;
        if ($scope.ventModel === THREE_VENT_MODEL) {
            switch (ventlevel) {
                case VENTLEVEL_0:
                    temp = "FAC/assets/img/main_list_ic_vent_3_none.svg#Layer_1";
                    break;
                case VENTLEVEL_1:
                    temp = "FAC/assets/img/main_list_ic_vent_3_upper.svg#Layer_1";
                    break;
                case VENTLEVEL_2:
                    temp = "FAC/assets/img/main_list_ic_vent_3_middle.svg#Layer_1";
                    break;
                case VENTLEVEL_3:
                    temp = "FAC/assets/img/main_list_ic_vent_3_upper_middle.svg#Layer_1";
                    break;
                case VENTLEVEL_4:
                    temp = "FAC/assets/img/main_list_ic_vent_3_lower.svg#Layer_1";
                    break;
                case VENTLEVEL_5:
                    temp = "FAC/assets/img/main_list_ic_vent_3_upper_lower.svg#Layer_1";
                    break;
                case VENTLEVEL_6:
                    temp = "FAC/assets/img/main_list_ic_vent_3_middle_lower.svg#Layer_1";
                    break;
                case VENTLEVEL_7:
                    temp = "FAC/assets/img/main_list_ic_vent_3_upper_middle_lower.svg#Layer_1";
                    break;
                default:
                    break;
            }
        } else if ($scope.ventModel === TWO_VENT_MODEL) {
            switch (ventlevel) {
                case VENTLEVEL_0:
                    temp = "FAC/assets/img/main_list_ic_vent_2_none.svg#Layer_1";
                    break;
                case VENTLEVEL_1:
                    temp = "FAC/assets/img/main_list_ic_vent_2_upper.svg#Layer_1";
                    break;
                case VENTLEVEL_2:
                    temp = "FAC/assets/img/main_list_ic_vent_2_lower.svg#Layer_1";
                    break;
                case VENTLEVEL_3:
                    temp = "FAC/assets/img/main_list_ic_vent_2_upper_lower.svg#Layer_1";
                    break;
                default:
                    break;
            }
        } else {
            // Nothing
        }
        var svg = document.getElementById('ventSVG');
        SHPService.loadSVG(temp, svg);
    };

    function getVentLevel(id) {
        var temp,
            ventUpper = $scope.ventUpper,
            ventMiddle = $scope.ventMiddle,
            ventLower = $scope.ventLower;
    
        switch (id) {
            case "ventUpper":
                ventUpper = !ventUpper;
                break;
            case "ventMiddle":
                ventMiddle = !ventMiddle;
                break;
            case "ventLower":
                ventLower = !ventLower;
                break;
            default:
                break;
        }
        if ($scope.ventModel === THREE_VENT_MODEL) {
            temp = (ventLower === true ? 1 : 0) + "" + (ventMiddle === true ? 1 : 0) + "" + (ventUpper === true ? 1 : 0);
        } else if ($scope.ventModel === TWO_VENT_MODEL) {
            temp = (ventLower === true ? 1 : 0) + "" + (ventUpper === true ? 1 : 0);
        } else {
            // Nothing
        }
        return parseInt(temp, 2);
    };
    $scope.getVentText = function (ventlevel) {
        if ($scope.ventModel === THREE_VENT_MODEL) {
            switch (ventlevel) {
                case VENTLEVEL_0:
                    return $scope.translation.WEBMOB_common_none;
                case VENTLEVEL_1:
                    return $scope.translation.WEBMOB_device_fac_vent_upper;
                case VENTLEVEL_2:
                    return $scope.translation.WEBMOB_device_fac_vent_middle;
                case VENTLEVEL_3:
                    return $scope.translation.WEBMOB_device_fac_vent_upper + ", " + $scope.translation.WEBMOB_device_fac_vent_middle;
                case VENTLEVEL_4:
                    return $scope.translation.WEBMOB_device_fac_vent_lower;
                case VENTLEVEL_5:
                    return $scope.translation.WEBMOB_device_fac_vent_upper + ", " + $scope.translation.WEBMOB_device_fac_vent_lower;
                case VENTLEVEL_6:
                    return  $scope.translation.WEBMOB_device_fac_vent_middle + ", " + $scope.translation.WEBMOB_device_fac_vent_lower;
                case VENTLEVEL_7:
                    return $scope.translation.WEBMOB_device_fac_vent_upper + ", " + $scope.translation.WEBMOB_device_fac_vent_middle + ", " + $scope.translation.WEBMOB_device_fac_vent_lower;
                default:
                    break;
            }
        } else if ($scope.ventModel === TWO_VENT_MODEL) {
            switch (ventlevel) {
                case VENTLEVEL_0:
                    return $scope.translation.WEBMOB_common_none;
                case VENTLEVEL_1:
                    return $scope.translation.WEBMOB_device_fac_vent_upper;
                case VENTLEVEL_2:
                    return $scope.translation.WEBMOB_device_fac_vent_lower;
                case VENTLEVEL_3:
                    return  $scope.translation.WEBMOB_device_fac_vent_upper + ", " + $scope.translation.WEBMOB_device_fac_vent_lower;
                default:
                    break;
            }
        } else {
            // Nothing
        }
    };
    $scope.decodeVentLevel = function (ventlevel) {
        var temp;
        if ($scope.ventModel === THREE_VENT_MODEL) {
            temp = "00" + ventlevel.toString(2);
            temp = temp.substr(-3);
            $scope.ventLower = parseInt(temp.charAt(0), 10) === 1;
            $scope.ventMiddle = parseInt(temp.charAt(1), 10) === 1;
            $scope.ventUpper = parseInt(temp.charAt(2), 10) === 1;
        } else if ($scope.ventModel === TWO_VENT_MODEL) {
            temp = "0" + ventlevel.toString(2);
            temp = temp.substr(-2);
            $scope.ventLower = parseInt(temp.charAt(0), 10) === 1;
            $scope.ventUpper = parseInt(temp.charAt(1), 10) === 1;
        } else {
            // Nothing
        }
        if ($scope.showVentSelectionPopup) {
            $scope.updateVentImage(ventlevel);
        }
    };
    
    function sendVentSelectionReq() {
        if ($scope.currentVentLevel !== $scope.tempVentLevel) {
            if (!$scope.isStatic) {
                $scope.checkResponse.push(FACCONST.VENT);
                SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getVentSelectionCommand($scope.tempVentLevel), "/" + $scope.peerId + "/devices/0");
            } else {
                $scope.currentVentLevel = $scope.tempVentLevel;
            }
        }
    }
    
    $scope.hideVentPopUp = function() {
        $scope.showVentSelectionPopup = false;
        toggleVentPopUpClass($scope.showVentSelectionPopup);
    };
    
    $scope.onPowerOffUpdate = function (powerOff) {
        $scope.powerOffPopup = false;
        toggleBottomPopUpClass($scope.powerOffPopup);
        if (powerOff) {
            $scope.powerOnOff(true);
            $scope.showVentSelectionPopup = false;
            toggleVentPopUpClass($scope.showVentSelectionPopup);
        } else {
            $scope.showVentSelectionPopup = true;
            toggleVentPopUpClass($scope.showVentSelectionPopup);
        }
    };
    $scope.updateVentCheckBoxes = function () {
        if ($scope.ventModel === THREE_VENT_MODEL) {
            $scope.showVentMiddleDiv = true;
        } else if ($scope.ventModel === TWO_VENT_MODEL) {
            $scope.showVentMiddleDiv = false;
        } else {
            // Nothing
        }
    };
    // Vent selection end

    // Weather info settings screen start
    $scope.weatherLocations = AIRCON_SETTING_REGION;
    $scope.searchTxtWithSpaces = "       " + $scope.translation.WEBMOB_common_search;

    var mOrginialValues = [];
    $scope.weatherLocations.forEach(function (value) {
        mOrginialValues.push($scope.translation[value]);
    });

    initSearchText();

    $scope.selectLocation = function (location) {
        $scope.selectedWeatherLocation = location;
        $scope.selectedWeatherLocationCode = WeatherService.setRegionCode(location);

        if (!$scope.isStatic) {
            nativeInterface.putDataOnResourceUrl($scope.getConfigCommand($scope.selectedWeatherLocationCode), "/" + $scope.peerId + "/devices/0/configuration");
        }

        if (noRegionSelected) {
            noRegionSelected = false;
            $scope.currentScreen = FACSCREENS.HOME;
            $scope.changeScreen();
            initSearchText();
            checkForFUG();            
        }
        $scope.getWeatherAirData();
        userClosedWeathRecommMode = false;
    };
    // Weather info settings screen end

    //weather description page start
    var myJSONDay = '{"current":{"RECORD":[{"time":"2015-07-24 13:00:00","region":"105","condition":"4","temperature":"23.8","degree":"c","humidity":"92","direction":"north","velocity":"0.4"},{"time":"2015-07-24 13:00:00","region":"259","condition":"18","temperature":"26.1","degree":"c","humidity":"92","direction":"south","velocity":"4.1"},{"time":"2015-07-24 13:00:00","region":"201","condition":"4","temperature":"24.2","degree":"c","humidity":"84","direction":"southsoutheast","velocity":"0.9"},{"time":"2015-07-24 13:00:00","region":"294","condition":"4","temperature":"26.3","degree":"c","humidity":"80","direction":"northnortheast","velocity":"2.5"},{"time":"2015-07-24 13:00:00","region":"284","condition":"4","temperature":"27.7","degree":"c","humidity":"93","direction":"southsouthwest","velocity":"1.6"},{"time":"2015-07-24 13:00:00","region":"283","condition":"3","temperature":"28.3","degree":"c","humidity":"75","direction":"south","velocity":"3.8"},{"time":"2015-07-24 13:00:00","region":"185","condition":"9","temperature":"25.2","degree":"c","humidity":"97","direction":"southsoutheast","velocity":"8.4"},{"time":"2015-07-24 13:00:00","region":"172","condition":"18","temperature":"25.5","degree":"c","humidity":"98","direction":"southwest","velocity":"3.0"},{"time":"2015-07-24 13:00:00","region":"251","condition":"18","temperature":"26.1","degree":"c","humidity":"93","direction":"southsoutheast","velocity":"3.3"},{"time":"2015-07-24 13:00:00","region":"262","condition":"3","temperature":"26.4","degree":"c","humidity":"94","direction":"southsoutheast","velocity":"3.3"},{"time":"2015-07-24 13:00:00","region":"266","condition":"3","temperature":"27.3","degree":"c","humidity":"90","direction":"southwest","velocity":"1.9"},{"time":"2015-07-24 13:00:00","region":"156","condition":"4","temperature":"25.3","degree":"c","humidity":"99","direction":"southsouthwest","velocity":"3.5"},{"time":"2015-07-24 13:00:00","region":"279","condition":"3","temperature":"28.9","degree":"c","humidity":"79","direction":"southwest","velocity":"1.4"},{"time":"2015-07-24 13:00:00","region":"140","condition":"3","temperature":"25.8","degree":"c","humidity":"99","direction":"south","velocity":"4.4"},{"time":"2015-07-24 13:00:00","region":"238","condition":"3","temperature":"27.2","degree":"c","humidity":"92","direction":"southsoutheast","velocity":"2.8"},{"time":"2015-07-24 13:00:00","region":"253","condition":"3","temperature":"26.1","degree":"c","humidity":"98","direction":"southsoutheast","velocity":"3.0"},{"time":"2015-07-24 13:00:00","region":"247","condition":"3","temperature":"25.9","degree":"c","humidity":"78","direction":"southsoutheast","velocity":"4.8"},{"time":"2015-07-24 13:00:00","region":"295","condition":"4","temperature":"26.6","degree":"c","humidity":"87","direction":"southwest","velocity":"1.4"},{"time":"2015-07-24 13:00:00","region":"100","condition":"4","temperature":"22.6","degree":"c","humidity":"95","direction":"westnorthwest","velocity":"3.2"},{"time":"2015-07-24 13:00:00","region":"143","condition":"3","temperature":"29.3","degree":"c","humidity":"66","direction":"southsouthwest","velocity":"2.9"},{"time":"2015-07-24 13:00:00","region":"133","condition":"3","temperature":"26.2","degree":"c","humidity":"96","direction":"southwest","velocity":"1.2"},{"time":"2015-07-24 13:00:00","region":"98","condition":"4","temperature":"24.1","degree":"c","humidity":"86","direction":"northwest","velocity":"1.2"},{"time":"2015-07-24 13:00:00","region":"106","condition":"4","temperature":"23.6","degree":"c","humidity":"87","direction":"north","velocity":"2.5"},{"time":"2015-07-24 13:00:00","region":"165","condition":"3","temperature":"25.3","degree":"c","humidity":"90","direction":"south","velocity":"4.2"},{"time":"2015-07-24 13:00:00","region":"273","condition":"18","temperature":"24.7","degree":"c","humidity":"89","direction":"east","velocity":"1.6"},{"time":"2015-07-24 13:00:00","region":"288","condition":"3","temperature":"28.7","degree":"c","humidity":"72","direction":"south","velocity":"3.2"},{"time":"2015-07-24 13:00:00","region":"102","condition":"3","temperature":"23.8","degree":"c","humidity":"89","direction":"southsouthwest","velocity":"2.1"},{"time":"2015-07-24 13:00:00","region":"235","condition":"18","temperature":"24.3","degree":"c","humidity":"99","direction":"southsouthwest","velocity":"5.4"},{"time":"2015-07-24 13:00:00","region":"258","condition":"4","temperature":"27.7","degree":"c","humidity":"76","direction":"southsouthwest","velocity":"4.1"},{"time":"2015-07-24 13:00:00","region":"226","condition":"4","temperature":"25.7","degree":"c","humidity":"100","direction":"southeast","velocity":"0.6"},{"time":"2015-07-24 13:00:00","region":"271","condition":"18","temperature":"24.7","degree":"c","humidity":"98","direction":"southwest","velocity":"1.9"},{"time":"2015-07-24 13:00:00","region":"159","condition":"3","temperature":"26.0","degree":"c","humidity":"93","direction":"southwest","velocity":"7.8"},{"time":"2015-07-24 13:00:00","region":"243","condition":"18","temperature":"26.8","degree":"c","humidity":"83","direction":"southsouthwest","velocity":"4.9"},{"time":"2015-07-24 13:00:00","region":"236","condition":"18","temperature":"25.4","degree":"c","humidity":"97","direction":"southwest","velocity":"4.1"},{"time":"2015-07-24 13:00:00","region":"104","condition":"4","temperature":"23.0","degree":"c","humidity":"90","direction":"north","velocity":"0.6"},{"time":"2015-07-24 13:00:00","region":"255","condition":"4","temperature":"26.4","degree":"c","humidity":"89","direction":"southsouthwest","velocity":"3.7"},{"time":"2015-07-24 13:00:00","region":"289","condition":"4","temperature":"26.4","degree":"c","humidity":"79","direction":"eastnortheast","velocity":"2.8"},{"time":"2015-07-24 13:00:00","region":"137","condition":"18","temperature":"27.3","degree":"c","humidity":"87","direction":"southwest","velocity":"1.2"},{"time":"2015-07-24 13:00:00","region":"189","condition":"3","temperature":"25.0","degree":"c","humidity":"97","direction":"southsouthwest","velocity":"2.9"},{"time":"2015-07-24 13:00:00","region":"129","condition":"4","temperature":"23.9","degree":"c","humidity":"97","direction":"southsouthwest","velocity":"3.0"},{"time":"2015-07-24 13:00:00","region":"108","condition":"4","temperature":"24.2","degree":"c","humidity":"95","direction":"southwest","velocity":"0.9"},{"time":"2015-07-24 13:00:00","region":"188","condition":"3","temperature":"26.4","degree":"c","humidity":"90","direction":"south","velocity":"6.2"},{"time":"2015-07-24 13:00:00","region":"90","condition":"4","temperature":"25.0","degree":"c","humidity":"100","direction":"northnortheast","velocity":"0.6"},{"time":"2015-07-24 13:00:00","region":"119","condition":"4","temperature":"23.9","degree":"c","humidity":"100","direction":"north","velocity":"0.0"},{"time":"2015-07-24 13:00:00","region":"254","condition":"18","temperature":"26.1","degree":"c","humidity":"91","direction":"westsouthwest","velocity":"0.8"},{"time":"2015-07-24 13:00:00","region":"174","condition":"4","temperature":"25.6","degree":"c","humidity":"87","direction":"southsoutheast","velocity":"2.1"},{"time":"2015-07-24 13:00:00","region":"136","condition":"18","temperature":"29.2","degree":"c","humidity":"70","direction":"southwest","velocity":"2.6"},{"time":"2015-07-24 13:00:00","region":"257","condition":"3","temperature":"25.9","degree":"c","humidity":"87","direction":"southwest","velocity":"5.4"},{"time":"2015-07-24 13:00:00","region":"202","condition":"4","temperature":"25.0","degree":"c","humidity":"92","direction":"northwest","velocity":"2.6"},{"time":"2015-07-24 13:00:00","region":"168","condition":"3","temperature":"24.9","degree":"c","humidity":"86","direction":"southwest","velocity":"5.3"},{"time":"2015-07-24 13:00:00","region":"252","condition":"4","temperature":"26.0","degree":"c","humidity":"88","direction":"southwest","velocity":"4.7"},{"time":"2015-07-24 13:00:00","region":"277","condition":"3","temperature":"30.4","degree":"c","humidity":"59","direction":"southsouthwest","velocity":"4.1"},{"time":"2015-07-24 13:00:00","region":"121","condition":"4","temperature":"23.9","degree":"c","humidity":"99","direction":"northwest","velocity":"1.9"},{"time":"2015-07-24 13:00:00","region":"272","condition":"18","temperature":"25.5","degree":"c","humidity":"94","direction":"south","velocity":"3.3"},{"time":"2015-07-24 13:00:00","region":"281","condition":"3","temperature":"28.9","degree":"c","humidity":"69","direction":"westsouthwest","velocity":"3.1"},{"time":"2015-07-24 13:00:00","region":"170","condition":"18","temperature":"26.7","degree":"c","humidity":"80","direction":"south","velocity":"4.6"},{"time":"2015-07-24 13:00:00","region":"115","condition":"9","temperature":"22.5","degree":"c","humidity":"97","direction":"southwest","velocity":"9.2"},{"time":"2015-07-24 13:00:00","region":"152","condition":"3","temperature":"29.1","degree":"c","humidity":"76","direction":"westsouthwest","velocity":"5.5"},{"time":"2015-07-24 13:00:00","region":"130","condition":"3","temperature":"23.7","degree":"c","humidity":"88","direction":"southsouthwest","velocity":"3.6"},{"time":"2015-07-24 13:00:00","region":"114","condition":"3","temperature":"26.1","degree":"c","humidity":"93","direction":"southwest","velocity":"1.3"},{"time":"2015-07-24 13:00:00","region":"263","condition":"4","temperature":"26.1","degree":"c","humidity":"92","direction":"south","velocity":"3.1"},{"time":"2015-07-24 13:00:00","region":"278","condition":"18","temperature":"31.1","degree":"c","humidity":"63","direction":"southwest","velocity":"4.2"},{"time":"2015-07-24 13:00:00","region":"203","condition":"4","temperature":"25.0","degree":"c","humidity":"89","direction":"southwest","velocity":"2.7"},{"time":"2015-07-24 13:00:00","region":"211","condition":"4","temperature":"23.0","degree":"c","humidity":"94","direction":"southsoutheast","velocity":"2.1"},{"time":"2015-07-24 13:00:00","region":"112","condition":"4","temperature":"23.5","degree":"c","humidity":"99","direction":"southeast","velocity":"1.7"},{"time":"2015-07-24 13:00:00","region":"244","condition":"3","temperature":"25.3","degree":"c","humidity":"87","direction":"southsouthwest","velocity":"3.7"},{"time":"2015-07-24 13:00:00","region":"248","condition":"3","temperature":"24.4","degree":"c","humidity":"87","direction":"south","velocity":"3.1"},{"time":"2015-07-24 13:00:00","region":"260","condition":"18","temperature":"26.4","degree":"c","humidity":"100","direction":"southsouthwest","velocity":"0.8"},{"time":"2015-07-24 13:00:00","region":"146","condition":"3","temperature":"27.8","degree":"c","humidity":"87","direction":"south","velocity":"1.6"},{"time":"2015-07-24 13:00:00","region":"217","condition":"4","temperature":"23.7","degree":"c","humidity":"100","direction":"westnorthwest","velocity":"1.7"},{"time":"2015-07-24 13:00:00","region":"245","condition":"18","temperature":"27.7","degree":"c","humidity":"91","direction":"southwest","velocity":"4.0"},{"time":"2015-07-24 13:00:00","region":"184","condition":"3","temperature":"31.4","degree":"c","humidity":"64","direction":"southwest","velocity":"4.9"},{"time":"2015-07-24 13:00:00","region":"221","condition":"4","temperature":"23.9","degree":"c","humidity":"92","direction":"southwest","velocity":"1.7"},{"time":"2015-07-24 13:00:00","region":"175","condition":"4","temperature":"22.1","degree":"c","humidity":"100","direction":"southsouthwest","velocity":"4.9"},{"time":"2015-07-24 13:00:00","region":"268","condition":"4","temperature":"25.1","degree":"c","humidity":"100","direction":"southwest","velocity":"4.1"},{"time":"2015-07-24 13:00:00","region":"192","condition":"4","temperature":"26.0","degree":"c","humidity":"79","direction":"south","velocity":"2.7"},{"time":"2015-07-24 13:00:00","region":"155","condition":"4","temperature":"25.2","degree":"c","humidity":"92","direction":"southsoutheast","velocity":"3.3"},{"time":"2015-07-24 13:00:00","region":"232","condition":"4","temperature":"25.4","degree":"c","humidity":"95","direction":"west","velocity":"1.4"},{"time":"2015-07-24 13:00:00","region":"95","condition":"4","temperature":"23.3","degree":"c","humidity":"89","direction":"westsouthwest","velocity":"1.2"},{"time":"2015-07-24 13:00:00","region":"276","condition":"18","temperature":"30.0","degree":"c","humidity":"66","direction":"southeast","velocity":"2.1"},{"time":"2015-07-24 13:00:00","region":"131","condition":"4","temperature":"25.4","degree":"c","humidity":"94","direction":"southwest","velocity":"2.3"},{"time":"2015-07-24 13:00:00","region":"135","condition":"4","temperature":"27.2","degree":"c","humidity":"79","direction":"southeast","velocity":"0.6"},{"time":"2015-07-24 13:00:00","region":"101","condition":"4","temperature":"24.0","degree":"c","humidity":"94","direction":"south","velocity":"0.8"},{"time":"2015-07-24 13:00:00","region":"127","condition":"4","temperature":"24.6","degree":"c","humidity":"97","direction":"northnortheast","velocity":"0.6"},{"time":"2015-07-24 13:00:00","region":"216","condition":"3","temperature":"25.4","degree":"c","humidity":"81","direction":"southwest","velocity":"5.2"},{"time":"2015-07-24 13:00:00","region":"162","condition":"4","temperature":"26.1","degree":"c","humidity":"90","direction":"south","velocity":"7.1"},{"time":"2015-07-24 13:00:00","region":"99","condition":"4","temperature":"23.7","degree":"c","humidity":"87","direction":"north","velocity":"1.5"},{"time":"2015-07-24 13:00:00","region":"138","condition":"3","temperature":"30.4","degree":"c","humidity":"66","direction":"southsouthwest","velocity":"4.3"},{"time":"2015-07-24 13:00:00","region":"264","condition":"4","temperature":"30.1","degree":"c","humidity":"77","direction":"north","velocity":"0.3"},{"time":"2015-07-24 13:00:00","region":"285","condition":"4","temperature":"28.5","degree":"c","humidity":"72","direction":"southsouthwest","velocity":"4.0"},{"time":"2015-07-24 13:00:00","region":"261","condition":"18","temperature":"26.0","degree":"c","humidity":"94","direction":"southsouthwest","velocity":"2.5"},{"time":"2015-07-24 13:00:00","region":"212","condition":"4","temperature":"23.8","degree":"c","humidity":"100","direction":"northwest","velocity":"1.4"},{"time":"2015-07-24 13:00:00","region":"169","condition":"16","temperature":"21.8","degree":"c","humidity":"99","direction":"south","velocity":"6.6"}]}}';
    var myJSONWeek = '{"forecast":{"RECORD":[{"region":"11B20404","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20404","date":"2015-07-25","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11B20404","date":"2015-07-26","condition":"3","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20404","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20404","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20404","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20404","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20404","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20501","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"22","amrainrate":"80","pmrainrate":"70"},{"region":"11D20501","date":"2015-07-25","condition":"18","maxtemp":"31","mintemp":"24","amrainrate":"60","pmrainrate":"20"},{"region":"11D20501","date":"2015-07-26","condition":"11","maxtemp":"33","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11D20501","date":"2015-07-27","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20501","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20501","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20501","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20501","date":"2015-07-31","condition":"3","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20303","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"70"},{"region":"11F20303","date":"2015-07-25","condition":"16","maxtemp":"30","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F20303","date":"2015-07-26","condition":"4","maxtemp":"30","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11F20303","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20303","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20303","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20303","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20303","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20101","date":"2015-07-24","condition":"4","maxtemp":"26","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20101","date":"2015-07-25","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11B20101","date":"2015-07-26","condition":"3","maxtemp":"29","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20101","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20101","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20101","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20101","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20101","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20403","date":"2015-07-24","condition":"18","maxtemp":"28","mintemp":"24","amrainrate":"70","pmrainrate":"30"},{"region":"11H20403","date":"2015-07-25","condition":"16","maxtemp":"28","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H20403","date":"2015-07-26","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20403","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20403","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20403","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20403","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20403","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20502","date":"2015-07-24","condition":"4","maxtemp":"29","mintemp":"23","amrainrate":"70","pmrainrate":"70"},{"region":"11H20502","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11H20502","date":"2015-07-26","condition":"4","maxtemp":"30","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11H20502","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20502","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20502","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20502","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20502","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10703","date":"2015-07-24","condition":"4","maxtemp":"32","mintemp":"25","amrainrate":"70","pmrainrate":"60"},{"region":"11H10703","date":"2015-07-25","condition":"16","maxtemp":"33","mintemp":"25","amrainrate":"20","pmrainrate":"10"},{"region":"11H10703","date":"2015-07-26","condition":"4","maxtemp":"32","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11H10703","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10703","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10703","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10703","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10703","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10202","date":"2015-07-24","condition":"4","maxtemp":"30","mintemp":"23","amrainrate":"60","pmrainrate":"60"},{"region":"11H10202","date":"2015-07-25","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"10","pmrainrate":"10"},{"region":"11H10202","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10202","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10202","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10202","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10202","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10202","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20403","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"80","pmrainrate":"80"},{"region":"11C20403","date":"2015-07-25","condition":"18","maxtemp":"31","mintemp":"23","amrainrate":"60","pmrainrate":"20"},{"region":"11C20403","date":"2015-07-26","condition":"11","maxtemp":"33","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20403","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20403","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20403","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20403","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20403","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10604","date":"2015-07-24","condition":"4","maxtemp":"30","mintemp":"24","amrainrate":"70","pmrainrate":"60"},{"region":"11H10604","date":"2015-07-25","condition":"16","maxtemp":"33","mintemp":"25","amrainrate":"20","pmrainrate":"10"},{"region":"11H10604","date":"2015-07-26","condition":"4","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11H10604","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10604","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10604","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10604","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10604","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11G00501","date":"2015-07-24","condition":"3","maxtemp":"28","mintemp":"24","amrainrate":"20","pmrainrate":"20"},{"region":"11G00501","date":"2015-07-25","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"20","pmrainrate":"20"},{"region":"11G00501","date":"2015-07-26","condition":"4","maxtemp":"26","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11G00501","date":"2015-07-27","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11G00501","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11G00501","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11G00501","date":"2015-07-30","condition":"2","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11G00501","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11D20402","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"21","amrainrate":"90","pmrainrate":"70"},{"region":"11D20402","date":"2015-07-25","condition":"18","maxtemp":"29","mintemp":"22","amrainrate":"80","pmrainrate":"20"},{"region":"11D20402","date":"2015-07-26","condition":"11","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20402","date":"2015-07-27","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20402","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20402","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20402","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20402","date":"2015-07-31","condition":"3","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20404","date":"2015-07-24","condition":"18","maxtemp":"28","mintemp":"24","amrainrate":"70","pmrainrate":"30"},{"region":"11H20404","date":"2015-07-25","condition":"16","maxtemp":"29","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H20404","date":"2015-07-26","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20404","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20404","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20404","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20404","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20404","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20302","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20302","date":"2015-07-25","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11B20302","date":"2015-07-26","condition":"3","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20302","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20302","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20302","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20302","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20302","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10103","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"25","amrainrate":"80","pmrainrate":"60"},{"region":"11F10103","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F10103","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10103","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10103","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10103","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10103","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10103","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20403","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"70"},{"region":"11F20403","date":"2015-07-25","condition":"16","maxtemp":"30","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F20403","date":"2015-07-26","condition":"4","maxtemp":"30","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11F20403","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20403","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20403","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20403","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20403","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20602","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"90","pmrainrate":"70"},{"region":"11F20602","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11F20602","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11F20602","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20602","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20602","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20602","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20602","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20402","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"80"},{"region":"11C20402","date":"2015-07-25","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"60","pmrainrate":"20"},{"region":"11C20402","date":"2015-07-26","condition":"11","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20402","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20402","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20402","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20402","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20402","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B10102","date":"2015-07-24","condition":"4","maxtemp":"26","mintemp":"22","amrainrate":"90","pmrainrate":"70"},{"region":"11B10102","date":"2015-07-25","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"80","pmrainrate":"60"},{"region":"11B10102","date":"2015-07-26","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B10102","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B10102","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B10102","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B10102","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B10102","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B10103","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B10103","date":"2015-07-25","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"80","pmrainrate":"60"},{"region":"11B10103","date":"2015-07-26","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B10103","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B10103","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B10103","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B10103","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B10103","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20402","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"70"},{"region":"11F20402","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F20402","date":"2015-07-26","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20402","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20402","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20402","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20402","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20402","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20702","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20702","date":"2015-07-25","condition":"18","maxtemp":"29","mintemp":"23","amrainrate":"80","pmrainrate":"30"},{"region":"11B20702","date":"2015-07-26","condition":"3","maxtemp":"31","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20702","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20702","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20702","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20702","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20702","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20501","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"70"},{"region":"11F20501","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F20501","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20501","date":"2015-07-27","condition":"18","maxtemp":"28","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20501","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20501","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20501","date":"2015-07-30","condition":"2","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11F20501","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11C10303","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"80","pmrainrate":"70"},{"region":"11C10303","date":"2015-07-25","condition":"3","maxtemp":"30","mintemp":"23","amrainrate":"30","pmrainrate":"20"},{"region":"11C10303","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10303","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10303","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10303","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10303","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10303","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20601","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"70"},{"region":"11F20601","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11F20601","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11F20601","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20601","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20601","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20601","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20601","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20501","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20501","date":"2015-07-25","condition":"4","maxtemp":"29","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11B20501","date":"2015-07-26","condition":"3","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20501","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20501","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20501","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20501","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20501","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10602","date":"2015-07-24","condition":"4","maxtemp":"30","mintemp":"24","amrainrate":"60","pmrainrate":"60"},{"region":"11H10602","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H10602","date":"2015-07-26","condition":"4","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11H10602","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10602","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10602","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10602","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10602","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10101","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"25","amrainrate":"80","pmrainrate":"60"},{"region":"11F10101","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F10101","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10101","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10101","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10101","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10101","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10101","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10603","date":"2015-07-24","condition":"4","maxtemp":"30","mintemp":"23","amrainrate":"60","pmrainrate":"60"},{"region":"11H10603","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H10603","date":"2015-07-26","condition":"4","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11H10603","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10603","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10603","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10603","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10603","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20610","date":"2015-07-24","condition":"4","maxtemp":"26","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20610","date":"2015-07-25","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"80","pmrainrate":"60"},{"region":"11B20610","date":"2015-07-26","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20610","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20610","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20610","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20610","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20610","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20601","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"80"},{"region":"11C20601","date":"2015-07-25","condition":"3","maxtemp":"32","mintemp":"23","amrainrate":"30","pmrainrate":"20"},{"region":"11C20601","date":"2015-07-26","condition":"11","maxtemp":"33","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20601","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20601","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20601","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20601","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20601","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10601","date":"2015-07-24","condition":"4","maxtemp":"30","mintemp":"23","amrainrate":"70","pmrainrate":"60"},{"region":"11H10601","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H10601","date":"2015-07-26","condition":"4","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11H10601","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10601","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10601","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10601","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10601","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20102","date":"2015-07-24","condition":"4","maxtemp":"26","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20102","date":"2015-07-25","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11B20102","date":"2015-07-26","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20102","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20102","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20102","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20102","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20102","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20304","date":"2015-07-24","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"70","pmrainrate":"30"},{"region":"11H20304","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H20304","date":"2015-07-26","condition":"4","maxtemp":"30","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20304","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20304","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20304","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20304","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20304","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20503","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"25","amrainrate":"80","pmrainrate":"70"},{"region":"11F20503","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F20503","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20503","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20503","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20503","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20503","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20503","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20502","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20502","date":"2015-07-25","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11B20502","date":"2015-07-26","condition":"3","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20502","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20502","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20502","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20502","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20502","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10401","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"24","amrainrate":"80","pmrainrate":"60"},{"region":"11F10401","date":"2015-07-25","condition":"16","maxtemp":"30","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11F10401","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11F10401","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10401","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10401","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10401","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10401","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20405","date":"2015-07-24","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"70","pmrainrate":"30"},{"region":"11H20405","date":"2015-07-25","condition":"16","maxtemp":"29","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H20405","date":"2015-07-26","condition":"4","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20405","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20405","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20405","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20405","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20405","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20602","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"80","pmrainrate":"80"},{"region":"11C20602","date":"2015-07-25","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"60","pmrainrate":"20"},{"region":"11C20602","date":"2015-07-26","condition":"11","maxtemp":"33","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20602","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20602","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20602","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20602","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20602","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10202","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11C10202","date":"2015-07-25","condition":"18","maxtemp":"30","mintemp":"23","amrainrate":"60","pmrainrate":"20"},{"region":"11C10202","date":"2015-07-26","condition":"11","maxtemp":"31","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11C10202","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10202","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10202","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10202","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10202","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10706","date":"2015-07-24","condition":"4","maxtemp":"31","mintemp":"24","amrainrate":"70","pmrainrate":"60"},{"region":"11H10706","date":"2015-07-25","condition":"16","maxtemp":"33","mintemp":"25","amrainrate":"20","pmrainrate":"10"},{"region":"11H10706","date":"2015-07-26","condition":"4","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10706","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10706","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10706","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10706","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10706","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20504","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11F20504","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F20504","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20504","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20504","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20504","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20504","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20504","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20103","date":"2015-07-24","condition":"18","maxtemp":"27","mintemp":"23","amrainrate":"80","pmrainrate":"30"},{"region":"11C20103","date":"2015-07-25","condition":"18","maxtemp":"30","mintemp":"24","amrainrate":"60","pmrainrate":"20"},{"region":"11C20103","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20103","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20103","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20103","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20103","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20103","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20201","date":"2015-07-24","condition":"4","maxtemp":"25","mintemp":"21","amrainrate":"80","pmrainrate":"70"},{"region":"11D20201","date":"2015-07-25","condition":"18","maxtemp":"28","mintemp":"21","amrainrate":"70","pmrainrate":"20"},{"region":"11D20201","date":"2015-07-26","condition":"11","maxtemp":"28","mintemp":"20","amrainrate":"","pmrainrate":""},{"region":"11D20201","date":"2015-07-27","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20201","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20201","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20201","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20201","date":"2015-07-31","condition":"3","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10701","date":"2015-07-24","condition":"4","maxtemp":"31","mintemp":"24","amrainrate":"70","pmrainrate":"60"},{"region":"11H10701","date":"2015-07-25","condition":"16","maxtemp":"33","mintemp":"25","amrainrate":"20","pmrainrate":"10"},{"region":"11H10701","date":"2015-07-26","condition":"4","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10701","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10701","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10701","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10701","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10701","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20401","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"80"},{"region":"11C20401","date":"2015-07-25","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"60","pmrainrate":"20"},{"region":"11C20401","date":"2015-07-26","condition":"11","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20401","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20401","date":"2015-07-28","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20401","date":"2015-07-29","condition":"3","maxtemp":"31","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20401","date":"2015-07-30","condition":"3","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20401","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11E00102","date":"2015-07-24","condition":"3","maxtemp":"25","mintemp":"22","amrainrate":"30","pmrainrate":"20"},{"region":"11E00102","date":"2015-07-25","condition":"2","maxtemp":"26","mintemp":"23","amrainrate":"10","pmrainrate":"10"},{"region":"11E00102","date":"2015-07-26","condition":"11","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11E00102","date":"2015-07-27","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11E00102","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11E00102","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11E00102","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11E00102","date":"2015-07-31","condition":"3","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20401","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20401","date":"2015-07-25","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11B20401","date":"2015-07-26","condition":"3","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20401","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20401","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20401","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20401","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20401","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20601","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"22","amrainrate":"80","pmrainrate":"70"},{"region":"11D20601","date":"2015-07-25","condition":"3","maxtemp":"31","mintemp":"23","amrainrate":"30","pmrainrate":"20"},{"region":"11D20601","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11D20601","date":"2015-07-27","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20601","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20601","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20601","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20601","date":"2015-07-31","condition":"3","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20302","date":"2015-07-24","condition":"18","maxtemp":"28","mintemp":"24","amrainrate":"70","pmrainrate":"30"},{"region":"11H20302","date":"2015-07-25","condition":"16","maxtemp":"29","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H20302","date":"2015-07-26","condition":"4","maxtemp":"30","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20302","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20302","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20302","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20302","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20302","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20201","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"70"},{"region":"11F20201","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F20201","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20201","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20201","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20201","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20201","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20201","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20101","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"70"},{"region":"11F20101","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F20101","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20101","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20101","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20101","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20101","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20101","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10302","date":"2015-07-24","condition":"4","maxtemp":"29","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11F10302","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11F10302","date":"2015-07-26","condition":"11","maxtemp":"29","mintemp":"21","amrainrate":"","pmrainrate":""},{"region":"11F10302","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10302","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10302","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10302","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10302","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10301","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"80"},{"region":"11H10301","date":"2015-07-25","condition":"3","maxtemp":"31","mintemp":"23","amrainrate":"30","pmrainrate":"20"},{"region":"11H10301","date":"2015-07-26","condition":"4","maxtemp":"32","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11H10301","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10301","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10301","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10301","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10301","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20305","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20305","date":"2015-07-25","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11B20305","date":"2015-07-26","condition":"3","maxtemp":"30","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20305","date":"2015-07-27","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20305","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20305","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20305","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20305","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11H20601","date":"2015-07-24","condition":"4","maxtemp":"30","mintemp":"24","amrainrate":"70","pmrainrate":"60"},{"region":"11H20601","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11H20601","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11H20601","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20601","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20601","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20601","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20601","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11A00101","date":"2015-07-24","condition":"3","maxtemp":"25","mintemp":"20","amrainrate":"30","pmrainrate":"30"},{"region":"11A00101","date":"2015-07-25","condition":"18","maxtemp":"24","mintemp":"20","amrainrate":"70","pmrainrate":"30"},{"region":"11A00101","date":"2015-07-26","condition":"3","maxtemp":"27","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11A00101","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11A00101","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11A00101","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11A00101","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11A00101","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20201","date":"2015-07-24","condition":"18","maxtemp":"27","mintemp":"23","amrainrate":"80","pmrainrate":"30"},{"region":"11C20201","date":"2015-07-25","condition":"18","maxtemp":"30","mintemp":"24","amrainrate":"60","pmrainrate":"20"},{"region":"11C20201","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20201","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20201","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20201","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20201","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20201","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20404","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"80","pmrainrate":"70"},{"region":"11F20404","date":"2015-07-25","condition":"16","maxtemp":"29","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F20404","date":"2015-07-26","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20404","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20404","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20404","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20404","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20404","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10302","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11C10302","date":"2015-07-25","condition":"3","maxtemp":"31","mintemp":"23","amrainrate":"30","pmrainrate":"20"},{"region":"11C10302","date":"2015-07-26","condition":"11","maxtemp":"31","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11C10302","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10302","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10302","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10302","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10302","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10402","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"22","amrainrate":"80","pmrainrate":"80"},{"region":"11H10402","date":"2015-07-25","condition":"16","maxtemp":"30","mintemp":"22","amrainrate":"30","pmrainrate":"10"},{"region":"11H10402","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"20","amrainrate":"","pmrainrate":""},{"region":"11H10402","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10402","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10402","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10402","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10402","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20201","date":"2015-07-24","condition":"18","maxtemp":"28","mintemp":"23","amrainrate":"70","pmrainrate":"30"},{"region":"11H20201","date":"2015-07-25","condition":"16","maxtemp":"29","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11H20201","date":"2015-07-26","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20201","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20201","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20201","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20201","date":"2015-07-30","condition":"2","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20201","date":"2015-07-31","condition":"2","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10104","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"25","amrainrate":"80","pmrainrate":"60"},{"region":"11F10104","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F10104","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10104","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10104","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10104","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10104","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10104","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20501","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11C20501","date":"2015-07-25","condition":"18","maxtemp":"31","mintemp":"24","amrainrate":"60","pmrainrate":"20"},{"region":"11C20501","date":"2015-07-26","condition":"11","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20501","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20501","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20501","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20501","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20501","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20204","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20204","date":"2015-07-25","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"80","pmrainrate":"60"},{"region":"11B20204","date":"2015-07-26","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20204","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20204","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20204","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20204","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20204","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20402","date":"2015-07-24","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"70","pmrainrate":"30"},{"region":"11H20402","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11H20402","date":"2015-07-26","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20402","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20402","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20402","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20402","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20402","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20703","date":"2015-07-24","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"70","pmrainrate":"70"},{"region":"11H20703","date":"2015-07-25","condition":"16","maxtemp":"30","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11H20703","date":"2015-07-26","condition":"4","maxtemp":"30","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11H20703","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20703","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20703","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20703","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20703","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20602","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"22","amrainrate":"80","pmrainrate":"70"},{"region":"11D20602","date":"2015-07-25","condition":"3","maxtemp":"31","mintemp":"23","amrainrate":"30","pmrainrate":"20"},{"region":"11D20602","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11D20602","date":"2015-07-27","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20602","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20602","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20602","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20602","date":"2015-07-31","condition":"3","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10302","date":"2015-07-24","condition":"4","maxtemp":"29","mintemp":"23","amrainrate":"80","pmrainrate":"80"},{"region":"11H10302","date":"2015-07-25","condition":"3","maxtemp":"32","mintemp":"23","amrainrate":"20","pmrainrate":"20"},{"region":"11H10302","date":"2015-07-26","condition":"4","maxtemp":"33","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11H10302","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10302","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10302","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10302","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10302","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11G00401","date":"2015-07-24","condition":"3","maxtemp":"28","mintemp":"24","amrainrate":"20","pmrainrate":"20"},{"region":"11G00401","date":"2015-07-25","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"20","pmrainrate":"20"},{"region":"11G00401","date":"2015-07-26","condition":"4","maxtemp":"28","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11G00401","date":"2015-07-27","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11G00401","date":"2015-07-28","condition":"3","maxtemp":"31","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11G00401","date":"2015-07-29","condition":"3","maxtemp":"31","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11G00401","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11G00401","date":"2015-07-31","condition":"2","maxtemp":"31","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11C20101","date":"2015-07-24","condition":"18","maxtemp":"27","mintemp":"23","amrainrate":"80","pmrainrate":"30"},{"region":"11C20101","date":"2015-07-25","condition":"18","maxtemp":"30","mintemp":"23","amrainrate":"60","pmrainrate":"20"},{"region":"11C20101","date":"2015-07-26","condition":"11","maxtemp":"31","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20101","date":"2015-07-27","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20101","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20101","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20101","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20101","date":"2015-07-31","condition":"3","maxtemp":"29","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B10101","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B10101","date":"2015-07-25","condition":"4","maxtemp":"29","mintemp":"23","amrainrate":"80","pmrainrate":"70"},{"region":"11B10101","date":"2015-07-26","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B10101","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B10101","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B10101","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B10101","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B10101","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20202","date":"2015-07-24","condition":"18","maxtemp":"27","mintemp":"24","amrainrate":"80","pmrainrate":"30"},{"region":"11C20202","date":"2015-07-25","condition":"18","maxtemp":"30","mintemp":"23","amrainrate":"60","pmrainrate":"20"},{"region":"11C20202","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20202","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20202","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20202","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20202","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20202","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20605","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20605","date":"2015-07-25","condition":"4","maxtemp":"30","mintemp":"24","amrainrate":"80","pmrainrate":"60"},{"region":"11B20605","date":"2015-07-26","condition":"3","maxtemp":"31","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20605","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20605","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20605","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20605","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20605","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11G00101","date":"2015-07-24","condition":"3","maxtemp":"27","mintemp":"24","amrainrate":"20","pmrainrate":"20"},{"region":"11G00101","date":"2015-07-25","condition":"3","maxtemp":"28","mintemp":"24","amrainrate":"20","pmrainrate":"20"},{"region":"11G00101","date":"2015-07-26","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11G00101","date":"2015-07-27","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11G00101","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11G00101","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11G00101","date":"2015-07-30","condition":"2","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11G00101","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10605","date":"2015-07-24","condition":"4","maxtemp":"30","mintemp":"24","amrainrate":"70","pmrainrate":"60"},{"region":"11H10605","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H10605","date":"2015-07-26","condition":"4","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11H10605","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10605","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10605","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10605","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10605","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11G00302","date":"2015-07-24","condition":"18","maxtemp":"24","mintemp":"20","amrainrate":"60","pmrainrate":"20"},{"region":"11G00302","date":"2015-07-25","condition":"3","maxtemp":"25","mintemp":"20","amrainrate":"20","pmrainrate":"20"},{"region":"11G00302","date":"2015-07-26","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11G00302","date":"2015-07-27","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11G00302","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11G00302","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11G00302","date":"2015-07-30","condition":"2","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11G00302","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11C20404","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"80"},{"region":"11C20404","date":"2015-07-25","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"60","pmrainrate":"20"},{"region":"11C20404","date":"2015-07-26","condition":"11","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20404","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20404","date":"2015-07-28","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20404","date":"2015-07-29","condition":"3","maxtemp":"31","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20404","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20404","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20401","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"22","amrainrate":"90","pmrainrate":"70"},{"region":"11D20401","date":"2015-07-25","condition":"18","maxtemp":"29","mintemp":"23","amrainrate":"80","pmrainrate":"20"},{"region":"11D20401","date":"2015-07-26","condition":"11","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20401","date":"2015-07-27","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20401","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20401","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20401","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20401","date":"2015-07-31","condition":"3","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20601","date":"2015-07-24","condition":"4","maxtemp":"26","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20601","date":"2015-07-25","condition":"18","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"20"},{"region":"11B20601","date":"2015-07-26","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20601","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20601","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20601","date":"2015-07-29","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20601","date":"2015-07-30","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20601","date":"2015-07-31","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10403","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"60"},{"region":"11F10403","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11F10403","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11F10403","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10403","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10403","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10403","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10403","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20405","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"70"},{"region":"11F20405","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F20405","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11F20405","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20405","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20405","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20405","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20405","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20603","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"70"},{"region":"11F20603","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F20603","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11F20603","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20603","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20603","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20603","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20603","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20202","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20202","date":"2015-07-25","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"80","pmrainrate":"60"},{"region":"11B20202","date":"2015-07-26","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20202","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20202","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20202","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20202","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20202","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20302","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11C20302","date":"2015-07-25","condition":"18","maxtemp":"31","mintemp":"24","amrainrate":"60","pmrainrate":"20"},{"region":"11C20302","date":"2015-07-26","condition":"11","maxtemp":"33","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20302","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20302","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20302","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20302","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20302","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10501","date":"2015-07-24","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"70","pmrainrate":"60"},{"region":"11H10501","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H10501","date":"2015-07-26","condition":"4","maxtemp":"33","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11H10501","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11H10501","date":"2015-07-28","condition":"3","maxtemp":"31","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11H10501","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11H10501","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11H10501","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20203","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20203","date":"2015-07-25","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"80","pmrainrate":"60"},{"region":"11B20203","date":"2015-07-26","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20203","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20203","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20203","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20203","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20203","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20611","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"70"},{"region":"11B20611","date":"2015-07-25","condition":"18","maxtemp":"30","mintemp":"24","amrainrate":"80","pmrainrate":"20"},{"region":"11B20611","date":"2015-07-26","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20611","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20611","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20611","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20611","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20611","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20602","date":"2015-07-24","condition":"4","maxtemp":"26","mintemp":"22","amrainrate":"90","pmrainrate":"70"},{"region":"11B20602","date":"2015-07-25","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"80","pmrainrate":"60"},{"region":"11B20602","date":"2015-07-26","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20602","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20602","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20602","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20602","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20602","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10202","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11D10202","date":"2015-07-25","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11D10202","date":"2015-07-26","condition":"11","maxtemp":"31","mintemp":"21","amrainrate":"","pmrainrate":""},{"region":"11D10202","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10202","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10202","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10202","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10202","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20102","date":"2015-07-24","condition":"18","maxtemp":"30","mintemp":"24","amrainrate":"70","pmrainrate":"30"},{"region":"11H20102","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H20102","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11H20102","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20102","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20102","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20102","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20102","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20403","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"22","amrainrate":"90","pmrainrate":"70"},{"region":"11D20403","date":"2015-07-25","condition":"18","maxtemp":"29","mintemp":"23","amrainrate":"80","pmrainrate":"20"},{"region":"11D20403","date":"2015-07-26","condition":"11","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20403","date":"2015-07-27","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20403","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20403","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20403","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20403","date":"2015-07-31","condition":"3","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20304","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20304","date":"2015-07-25","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11B20304","date":"2015-07-26","condition":"3","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20304","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20304","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20304","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20304","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20304","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20503","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20503","date":"2015-07-25","condition":"18","maxtemp":"29","mintemp":"23","amrainrate":"80","pmrainrate":"30"},{"region":"11B20503","date":"2015-07-26","condition":"3","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20503","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20503","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20503","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20503","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20503","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20401","date":"2015-07-24","condition":"4","maxtemp":"26","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11F20401","date":"2015-07-25","condition":"16","maxtemp":"28","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F20401","date":"2015-07-26","condition":"4","maxtemp":"27","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20401","date":"2015-07-27","condition":"18","maxtemp":"26","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11F20401","date":"2015-07-28","condition":"3","maxtemp":"28","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11F20401","date":"2015-07-29","condition":"3","maxtemp":"29","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11F20401","date":"2015-07-30","condition":"2","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20401","date":"2015-07-31","condition":"2","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20703","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20703","date":"2015-07-25","condition":"18","maxtemp":"29","mintemp":"23","amrainrate":"80","pmrainrate":"20"},{"region":"11B20703","date":"2015-07-26","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20703","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20703","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20703","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20703","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20703","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20402","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20402","date":"2015-07-25","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11B20402","date":"2015-07-26","condition":"3","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20402","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20402","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20402","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20402","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20402","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20103","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"70"},{"region":"11F20103","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F20103","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20103","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20103","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20103","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20103","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20103","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10102","date":"2015-07-24","condition":"3","maxtemp":"31","mintemp":"23","amrainrate":"30","pmrainrate":"30"},{"region":"11H10102","date":"2015-07-25","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"10","pmrainrate":"10"},{"region":"11H10102","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11H10102","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10102","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10102","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10102","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10102","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10402","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"70","pmrainrate":"60"},{"region":"11C10402","date":"2015-07-25","condition":"3","maxtemp":"31","mintemp":"22","amrainrate":"30","pmrainrate":"20"},{"region":"11C10402","date":"2015-07-26","condition":"11","maxtemp":"31","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11C10402","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10402","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10402","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10402","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10402","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10403","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"70","pmrainrate":"60"},{"region":"11H10403","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11H10403","date":"2015-07-26","condition":"4","maxtemp":"32","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11H10403","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10403","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10403","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10403","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10403","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10501","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"70"},{"region":"11D10501","date":"2015-07-25","condition":"18","maxtemp":"32","mintemp":"23","amrainrate":"80","pmrainrate":"20"},{"region":"11D10501","date":"2015-07-26","condition":"11","maxtemp":"31","mintemp":"21","amrainrate":"","pmrainrate":""},{"region":"11D10501","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10501","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10501","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10501","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10501","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10401","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"80"},{"region":"11H10401","date":"2015-07-25","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"30","pmrainrate":"20"},{"region":"11H10401","date":"2015-07-26","condition":"4","maxtemp":"32","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11H10401","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10401","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10401","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10401","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10401","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10702","date":"2015-07-24","condition":"4","maxtemp":"31","mintemp":"24","amrainrate":"70","pmrainrate":"60"},{"region":"11H10702","date":"2015-07-25","condition":"16","maxtemp":"33","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H10702","date":"2015-07-26","condition":"4","maxtemp":"32","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11H10702","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10702","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10702","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10702","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10702","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20303","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11C20303","date":"2015-07-25","condition":"18","maxtemp":"31","mintemp":"24","amrainrate":"60","pmrainrate":"20"},{"region":"11C20303","date":"2015-07-26","condition":"11","maxtemp":"33","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20303","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20303","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20303","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20303","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20303","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10303","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"80"},{"region":"11H10303","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H10303","date":"2015-07-26","condition":"4","maxtemp":"32","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11H10303","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10303","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10303","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10303","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10303","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20603","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20603","date":"2015-07-25","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"80","pmrainrate":"60"},{"region":"11B20603","date":"2015-07-26","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20603","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20603","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20603","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20603","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20603","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10403","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11C10403","date":"2015-07-25","condition":"3","maxtemp":"31","mintemp":"23","amrainrate":"30","pmrainrate":"20"},{"region":"11C10403","date":"2015-07-26","condition":"11","maxtemp":"31","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11C10403","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10403","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10403","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10403","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10403","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20301","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"70"},{"region":"11F20301","date":"2015-07-25","condition":"16","maxtemp":"30","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F20301","date":"2015-07-26","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11F20301","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20301","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20301","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20301","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20301","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10204","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"25","amrainrate":"80","pmrainrate":"60"},{"region":"11F10204","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F10204","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10204","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10204","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10204","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10204","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10204","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20612","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"80","pmrainrate":"70"},{"region":"11B20612","date":"2015-07-25","condition":"18","maxtemp":"29","mintemp":"23","amrainrate":"80","pmrainrate":"20"},{"region":"11B20612","date":"2015-07-26","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20612","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20612","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20612","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20612","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20612","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11E00101","date":"2015-07-24","condition":"18","maxtemp":"26","mintemp":"22","amrainrate":"60","pmrainrate":"20"},{"region":"11E00101","date":"2015-07-25","condition":"2","maxtemp":"28","mintemp":"24","amrainrate":"10","pmrainrate":"10"},{"region":"11E00101","date":"2015-07-26","condition":"11","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11E00101","date":"2015-07-27","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11E00101","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11E00101","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11E00101","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11E00101","date":"2015-07-31","condition":"3","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20101","date":"2015-07-24","condition":"18","maxtemp":"30","mintemp":"24","amrainrate":"70","pmrainrate":"30"},{"region":"11H20101","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H20101","date":"2015-07-26","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20101","date":"2015-07-27","condition":"18","maxtemp":"31","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20101","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20101","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20101","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20101","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10101","date":"2015-07-24","condition":"18","maxtemp":"28","mintemp":"22","amrainrate":"60","pmrainrate":"30"},{"region":"11H10101","date":"2015-07-25","condition":"2","maxtemp":"30","mintemp":"23","amrainrate":"10","pmrainrate":"10"},{"region":"11H10101","date":"2015-07-26","condition":"4","maxtemp":"29","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11H10101","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10101","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10101","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10101","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10101","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10401","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"70"},{"region":"11D10401","date":"2015-07-25","condition":"18","maxtemp":"31","mintemp":"24","amrainrate":"80","pmrainrate":"20"},{"region":"11D10401","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11D10401","date":"2015-07-27","condition":"4","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10401","date":"2015-07-28","condition":"18","maxtemp":"30","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11D10401","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11D10401","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10401","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10103","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11C10103","date":"2015-07-25","condition":"18","maxtemp":"30","mintemp":"23","amrainrate":"60","pmrainrate":"20"},{"region":"11C10103","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C10103","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10103","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10103","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10103","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10103","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20602","date":"2015-07-24","condition":"4","maxtemp":"29","mintemp":"23","amrainrate":"70","pmrainrate":"60"},{"region":"11H20602","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11H20602","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11H20602","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20602","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20602","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20602","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20602","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10502","date":"2015-07-24","condition":"4","maxtemp":"30","mintemp":"24","amrainrate":"70","pmrainrate":"60"},{"region":"11H10502","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H10502","date":"2015-07-26","condition":"4","maxtemp":"33","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11H10502","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10502","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10502","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10502","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10502","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20609","date":"2015-07-24","condition":"4","maxtemp":"26","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20609","date":"2015-07-25","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"60"},{"region":"11B20609","date":"2015-07-26","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20609","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20609","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20609","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20609","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20609","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20301","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20301","date":"2015-07-25","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11B20301","date":"2015-07-26","condition":"3","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20301","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20301","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20301","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20301","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20301","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11G00601","date":"2015-07-24","condition":"3","maxtemp":"27","mintemp":"24","amrainrate":"20","pmrainrate":"20"},{"region":"11G00601","date":"2015-07-25","condition":"3","maxtemp":"27","mintemp":"24","amrainrate":"20","pmrainrate":"20"},{"region":"11G00601","date":"2015-07-26","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11G00601","date":"2015-07-27","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11G00601","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11G00601","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11G00601","date":"2015-07-30","condition":"2","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11G00601","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11B20701","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"70"},{"region":"11B20701","date":"2015-07-25","condition":"18","maxtemp":"30","mintemp":"23","amrainrate":"70","pmrainrate":"20"},{"region":"11B20701","date":"2015-07-26","condition":"3","maxtemp":"31","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20701","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20701","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20701","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20701","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20701","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10202","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"60"},{"region":"11F10202","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F10202","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10202","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10202","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10202","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10202","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10202","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10201","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"22","amrainrate":"90","pmrainrate":"70"},{"region":"11D10201","date":"2015-07-25","condition":"18","maxtemp":"26","mintemp":"22","amrainrate":"80","pmrainrate":"20"},{"region":"11D10201","date":"2015-07-26","condition":"11","maxtemp":"31","mintemp":"21","amrainrate":"","pmrainrate":""},{"region":"11D10201","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10201","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10201","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10201","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10201","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20201","date":"2015-07-24","condition":"4","maxtemp":"26","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20201","date":"2015-07-25","condition":"4","maxtemp":"27","mintemp":"24","amrainrate":"80","pmrainrate":"60"},{"region":"11B20201","date":"2015-07-26","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20201","date":"2015-07-27","condition":"4","maxtemp":"27","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20201","date":"2015-07-28","condition":"18","maxtemp":"27","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20201","date":"2015-07-29","condition":"3","maxtemp":"28","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20201","date":"2015-07-30","condition":"3","maxtemp":"28","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20201","date":"2015-07-31","condition":"3","maxtemp":"27","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10402","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11F10402","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11F10402","date":"2015-07-26","condition":"11","maxtemp":"30","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11F10402","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10402","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10402","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10402","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10402","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20502","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"90","pmrainrate":"70"},{"region":"11F20502","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F20502","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20502","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20502","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20502","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20502","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20502","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10301","date":"2015-07-24","condition":"4","maxtemp":"26","mintemp":"22","amrainrate":"80","pmrainrate":"60"},{"region":"11F10301","date":"2015-07-25","condition":"16","maxtemp":"29","mintemp":"22","amrainrate":"20","pmrainrate":"10"},{"region":"11F10301","date":"2015-07-26","condition":"11","maxtemp":"29","mintemp":"21","amrainrate":"","pmrainrate":""},{"region":"11F10301","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10301","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10301","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10301","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10301","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20304","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"70"},{"region":"11F20304","date":"2015-07-25","condition":"16","maxtemp":"30","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F20304","date":"2015-07-26","condition":"4","maxtemp":"30","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11F20304","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20304","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20304","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20304","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20304","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10201","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"25","amrainrate":"80","pmrainrate":"60"},{"region":"11F10201","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F10201","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10201","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10201","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10201","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10201","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10201","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10502","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"22","amrainrate":"80","pmrainrate":"70"},{"region":"11D10502","date":"2015-07-25","condition":"18","maxtemp":"30","mintemp":"22","amrainrate":"80","pmrainrate":"20"},{"region":"11D10502","date":"2015-07-26","condition":"11","maxtemp":"31","mintemp":"21","amrainrate":"","pmrainrate":""},{"region":"11D10502","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10502","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10502","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10502","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10502","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10203","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"25","amrainrate":"80","pmrainrate":"60"},{"region":"11F10203","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F10203","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11F10203","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10203","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10203","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10203","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10203","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11G00201","date":"2015-07-24","condition":"3","maxtemp":"33","mintemp":"26","amrainrate":"20","pmrainrate":"20"},{"region":"11G00201","date":"2015-07-25","condition":"3","maxtemp":"31","mintemp":"25","amrainrate":"20","pmrainrate":"20"},{"region":"11G00201","date":"2015-07-26","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11G00201","date":"2015-07-27","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11G00201","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11G00201","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11G00201","date":"2015-07-30","condition":"2","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11G00201","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11C10201","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11C10201","date":"2015-07-25","condition":"18","maxtemp":"30","mintemp":"22","amrainrate":"60","pmrainrate":"20"},{"region":"11C10201","date":"2015-07-26","condition":"11","maxtemp":"31","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11C10201","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10201","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10201","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10201","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10201","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10304","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"70"},{"region":"11C10304","date":"2015-07-25","condition":"18","maxtemp":"31","mintemp":"24","amrainrate":"60","pmrainrate":"20"},{"region":"11C10304","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10304","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10304","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10304","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10304","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10304","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20204","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"70"},{"region":"11F20204","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F20204","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20204","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20204","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20204","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20204","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20204","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10303","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11F10303","date":"2015-07-25","condition":"16","maxtemp":"30","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11F10303","date":"2015-07-26","condition":"11","maxtemp":"29","mintemp":"21","amrainrate":"","pmrainrate":""},{"region":"11F10303","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10303","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10303","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10303","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F10303","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20701","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"70","pmrainrate":"70"},{"region":"11H20701","date":"2015-07-25","condition":"16","maxtemp":"29","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11H20701","date":"2015-07-26","condition":"4","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20701","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20701","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20701","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20701","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20701","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10102","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"70"},{"region":"11C10102","date":"2015-07-25","condition":"18","maxtemp":"30","mintemp":"23","amrainrate":"60","pmrainrate":"20"},{"region":"11C10102","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C10102","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10102","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10102","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10102","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10102","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20303","date":"2015-07-24","condition":"18","maxtemp":"28","mintemp":"24","amrainrate":"70","pmrainrate":"30"},{"region":"11H20303","date":"2015-07-25","condition":"16","maxtemp":"29","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H20303","date":"2015-07-26","condition":"4","maxtemp":"30","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20303","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20303","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20303","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20303","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20303","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20604","date":"2015-07-24","condition":"4","maxtemp":"30","mintemp":"24","amrainrate":"70","pmrainrate":"60"},{"region":"11H20604","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H20604","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11H20604","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20604","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20604","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20604","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20604","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20301","date":"2015-07-24","condition":"18","maxtemp":"28","mintemp":"24","amrainrate":"70","pmrainrate":"30"},{"region":"11H20301","date":"2015-07-25","condition":"16","maxtemp":"29","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H20301","date":"2015-07-26","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20301","date":"2015-07-27","condition":"18","maxtemp":"30","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20301","date":"2015-07-28","condition":"3","maxtemp":"31","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20301","date":"2015-07-29","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20301","date":"2015-07-30","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20301","date":"2015-07-31","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20301","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11C20301","date":"2015-07-25","condition":"18","maxtemp":"31","mintemp":"24","amrainrate":"60","pmrainrate":"20"},{"region":"11C20301","date":"2015-07-26","condition":"11","maxtemp":"33","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20301","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20301","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20301","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20301","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20301","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10101","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11D10101","date":"2015-07-25","condition":"4","maxtemp":"26","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11D10101","date":"2015-07-26","condition":"11","maxtemp":"31","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11D10101","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10101","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10101","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10101","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10101","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10704","date":"2015-07-24","condition":"4","maxtemp":"31","mintemp":"24","amrainrate":"70","pmrainrate":"60"},{"region":"11H10704","date":"2015-07-25","condition":"16","maxtemp":"33","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H10704","date":"2015-07-26","condition":"4","maxtemp":"32","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11H10704","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10704","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10704","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10704","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10704","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10503","date":"2015-07-24","condition":"4","maxtemp":"29","mintemp":"23","amrainrate":"70","pmrainrate":"60"},{"region":"11H10503","date":"2015-07-25","condition":"16","maxtemp":"31","mintemp":"22","amrainrate":"20","pmrainrate":"10"},{"region":"11H10503","date":"2015-07-26","condition":"4","maxtemp":"32","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11H10503","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10503","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10503","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10503","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10503","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20502","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11C20502","date":"2015-07-25","condition":"18","maxtemp":"30","mintemp":"23","amrainrate":"60","pmrainrate":"20"},{"region":"11C20502","date":"2015-07-26","condition":"11","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20502","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20502","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20502","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20502","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20502","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10305","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"70"},{"region":"11C10305","date":"2015-07-25","condition":"18","maxtemp":"31","mintemp":"24","amrainrate":"60","pmrainrate":"20"},{"region":"11C10305","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10305","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10305","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10305","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10305","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10305","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10301","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"70"},{"region":"11C10301","date":"2015-07-25","condition":"18","maxtemp":"31","mintemp":"24","amrainrate":"60","pmrainrate":"20"},{"region":"11C10301","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10301","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10301","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10301","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10301","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10301","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10401","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"70","pmrainrate":"60"},{"region":"11C10401","date":"2015-07-25","condition":"3","maxtemp":"31","mintemp":"22","amrainrate":"30","pmrainrate":"20"},{"region":"11C10401","date":"2015-07-26","condition":"11","maxtemp":"31","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11C10401","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10401","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10401","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10401","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10401","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10301","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"24","amrainrate":"90","pmrainrate":"70"},{"region":"11D10301","date":"2015-07-25","condition":"18","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"20"},{"region":"11D10301","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11D10301","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11D10301","date":"2015-07-28","condition":"18","maxtemp":"30","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11D10301","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11D10301","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11D10301","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C10101","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"90","pmrainrate":"70"},{"region":"11C10101","date":"2015-07-25","condition":"18","maxtemp":"30","mintemp":"23","amrainrate":"60","pmrainrate":"20"},{"region":"11C10101","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C10101","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10101","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10101","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10101","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C10101","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10705","date":"2015-07-24","condition":"4","maxtemp":"30","mintemp":"24","amrainrate":"60","pmrainrate":"60"},{"region":"11H10705","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H10705","date":"2015-07-26","condition":"4","maxtemp":"32","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11H10705","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10705","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10705","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10705","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10705","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20301","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"21","amrainrate":"80","pmrainrate":"70"},{"region":"11D20301","date":"2015-07-25","condition":"3","maxtemp":"29","mintemp":"22","amrainrate":"30","pmrainrate":"20"},{"region":"11D20301","date":"2015-07-26","condition":"11","maxtemp":"30","mintemp":"21","amrainrate":"","pmrainrate":""},{"region":"11D20301","date":"2015-07-27","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20301","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20301","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20301","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D20301","date":"2015-07-31","condition":"3","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20102","date":"2015-07-24","condition":"18","maxtemp":"27","mintemp":"23","amrainrate":"80","pmrainrate":"30"},{"region":"11C20102","date":"2015-07-25","condition":"18","maxtemp":"30","mintemp":"23","amrainrate":"60","pmrainrate":"20"},{"region":"11C20102","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20102","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20102","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20102","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20102","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20102","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20401","date":"2015-07-24","condition":"18","maxtemp":"27","mintemp":"23","amrainrate":"70","pmrainrate":"30"},{"region":"11H20401","date":"2015-07-25","condition":"16","maxtemp":"28","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11H20401","date":"2015-07-26","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20401","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20401","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20401","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20401","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20401","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20303","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20303","date":"2015-07-25","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11B20303","date":"2015-07-26","condition":"3","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20303","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20303","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20303","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20303","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20303","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10503","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"22","amrainrate":"80","pmrainrate":"70"},{"region":"11D10503","date":"2015-07-25","condition":"18","maxtemp":"29","mintemp":"22","amrainrate":"80","pmrainrate":"20"},{"region":"11D10503","date":"2015-07-26","condition":"11","maxtemp":"31","mintemp":"21","amrainrate":"","pmrainrate":""},{"region":"11D10503","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10503","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10503","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10503","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10503","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20606","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"70"},{"region":"11B20606","date":"2015-07-25","condition":"18","maxtemp":"30","mintemp":"24","amrainrate":"80","pmrainrate":"20"},{"region":"11B20606","date":"2015-07-26","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20606","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20606","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20606","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20606","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20606","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20403","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20403","date":"2015-07-25","condition":"4","maxtemp":"28","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11B20403","date":"2015-07-26","condition":"3","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11B20403","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20403","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20403","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20403","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20403","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10201","date":"2015-07-24","condition":"4","maxtemp":"31","mintemp":"23","amrainrate":"30","pmrainrate":"60"},{"region":"11H10201","date":"2015-07-25","condition":"2","maxtemp":"33","mintemp":"25","amrainrate":"10","pmrainrate":"10"},{"region":"11H10201","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10201","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10201","date":"2015-07-28","condition":"3","maxtemp":"31","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10201","date":"2015-07-29","condition":"3","maxtemp":"31","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H10201","date":"2015-07-30","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H10201","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20504","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20504","date":"2015-07-25","condition":"4","maxtemp":"29","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11B20504","date":"2015-07-26","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20504","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20504","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20504","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20504","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20504","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20704","date":"2015-07-24","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"70","pmrainrate":"70"},{"region":"11H20704","date":"2015-07-25","condition":"16","maxtemp":"30","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11H20704","date":"2015-07-26","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20704","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20704","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20704","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20704","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20704","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20603","date":"2015-07-24","condition":"4","maxtemp":"30","mintemp":"24","amrainrate":"70","pmrainrate":"60"},{"region":"11H20603","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11H20603","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11H20603","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20603","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20603","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20603","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20603","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20501","date":"2015-07-24","condition":"4","maxtemp":"30","mintemp":"23","amrainrate":"70","pmrainrate":"70"},{"region":"11H20501","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11H20501","date":"2015-07-26","condition":"4","maxtemp":"30","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11H20501","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20501","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20501","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20501","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20501","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20503","date":"2015-07-24","condition":"4","maxtemp":"30","mintemp":"23","amrainrate":"70","pmrainrate":"70"},{"region":"11H20503","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11H20503","date":"2015-07-26","condition":"4","maxtemp":"30","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11H20503","date":"2015-07-27","condition":"18","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20503","date":"2015-07-28","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20503","date":"2015-07-29","condition":"3","maxtemp":"32","mintemp":"25","amrainrate":"","pmrainrate":""},{"region":"11H20503","date":"2015-07-30","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11H20503","date":"2015-07-31","condition":"2","maxtemp":"33","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20302","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"24","amrainrate":"80","pmrainrate":"70"},{"region":"11F20302","date":"2015-07-25","condition":"16","maxtemp":"30","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F20302","date":"2015-07-26","condition":"4","maxtemp":"30","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11F20302","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20302","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20302","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20302","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20302","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20104","date":"2015-07-24","condition":"18","maxtemp":"27","mintemp":"24","amrainrate":"80","pmrainrate":"30"},{"region":"11C20104","date":"2015-07-25","condition":"18","maxtemp":"31","mintemp":"23","amrainrate":"60","pmrainrate":"20"},{"region":"11C20104","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11C20104","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20104","date":"2015-07-28","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20104","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20104","date":"2015-07-30","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11C20104","date":"2015-07-31","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10302","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11D10302","date":"2015-07-25","condition":"18","maxtemp":"29","mintemp":"23","amrainrate":"80","pmrainrate":"20"},{"region":"11D10302","date":"2015-07-26","condition":"11","maxtemp":"33","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11D10302","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10302","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10302","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10302","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10302","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20604","date":"2015-07-24","condition":"4","maxtemp":"26","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11B20604","date":"2015-07-25","condition":"4","maxtemp":"29","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11B20604","date":"2015-07-26","condition":"3","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20604","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20604","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20604","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20604","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11B20604","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20505","date":"2015-07-24","condition":"4","maxtemp":"28","mintemp":"25","amrainrate":"80","pmrainrate":"70"},{"region":"11F20505","date":"2015-07-25","condition":"16","maxtemp":"32","mintemp":"24","amrainrate":"20","pmrainrate":"10"},{"region":"11F20505","date":"2015-07-26","condition":"4","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20505","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20505","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20505","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20505","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20505","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10102","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"23","amrainrate":"90","pmrainrate":"70"},{"region":"11D10102","date":"2015-07-25","condition":"4","maxtemp":"26","mintemp":"23","amrainrate":"80","pmrainrate":"60"},{"region":"11D10102","date":"2015-07-26","condition":"11","maxtemp":"31","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11D10102","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10102","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10102","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10102","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10102","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10402","date":"2015-07-24","condition":"4","maxtemp":"27","mintemp":"24","amrainrate":"80","pmrainrate":"70"},{"region":"11D10402","date":"2015-07-25","condition":"18","maxtemp":"30","mintemp":"23","amrainrate":"80","pmrainrate":"20"},{"region":"11D10402","date":"2015-07-26","condition":"11","maxtemp":"32","mintemp":"23","amrainrate":"","pmrainrate":""},{"region":"11D10402","date":"2015-07-27","condition":"4","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10402","date":"2015-07-28","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10402","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10402","date":"2015-07-30","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11D10402","date":"2015-07-31","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20701","date":"2015-07-24","condition":"18","maxtemp":"25","mintemp":"23","amrainrate":"80","pmrainrate":"30"},{"region":"11F20701","date":"2015-07-25","condition":"16","maxtemp":"26","mintemp":"23","amrainrate":"20","pmrainrate":"10"},{"region":"11F20701","date":"2015-07-26","condition":"4","maxtemp":"28","mintemp":"22","amrainrate":"","pmrainrate":""},{"region":"11F20701","date":"2015-07-27","condition":"18","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20701","date":"2015-07-28","condition":"3","maxtemp":"29","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20701","date":"2015-07-29","condition":"3","maxtemp":"30","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20701","date":"2015-07-30","condition":"2","maxtemp":"31","mintemp":"24","amrainrate":"","pmrainrate":""},{"region":"11F20701","date":"2015-07-31","condition":"2","maxtemp":"32","mintemp":"24","amrainrate":"","pmrainrate":""}]}}';
    var x2js = new X2JS();

    //give weather day list in local language.
    $scope.getWeatherDayList = ScheduleService.getWeatherDayList;

    function updateWeatherData(response) {
        if ($scope.isStatic) {
            $scope.weatherWeeklyData = WeatherService.getWeekData(JSON.parse(myJSONWeek), $scope, $scope.selectedWeatherLocation);
            $scope.weatherCurrentData = WeatherService.getCurrentData(JSON.parse(myJSONDay), $scope, $scope.selectedWeatherLocation);
            $scope.yellowDust = true;
        } else {
            var tempweekData = decodeURIComponent(response["data"]["weatherData"]["weekData"]);
            tempweekData = tempweekData.replace(/[+]/g, ' ');
            var weekData = x2js.xml_str2json(tempweekData);
            $scope.weatherWeeklyData = WeatherService.getWeekData(weekData, $scope, $scope.selectedWeatherLocation);

            var tempCurrentData = decodeURIComponent(response["data"]["weatherData"]["currentData"]);
            tempCurrentData = tempCurrentData.replace(/[+]/g, ' ');
            var currentData = x2js.xml_str2json(tempCurrentData);
            $scope.weatherCurrentData = WeatherService.getCurrentData(currentData, $scope, $scope.selectedWeatherLocation);

            $scope.yellowDust = UtilityService.parseBoolean(response["data"]["weatherData"]["yellowDust"]);            
        }
        if (angular.isDefined($scope.weatherCurrentData) && angular.isDefined($scope.weatherCurrentData.temperature)) {
            $scope.outdoorTemp = $scope.weatherCurrentData.temperature.split(".")[0];
            if ($scope.outdoorTemp === '-0') {
                $scope.outdoorTemp = '0';
            }            
        }
        // If we get weather data display it otherwise display no weather data screen
        if (angular.isDefined($scope.weatherCurrentData) && angular.isDefined($scope.weatherWeeklyData)
                && angular.isDefined($scope.weatherCurrentData.temperature)) {
            $scope.gotWeatherData = true;
            getWeathRecommendationMode();
        } else {
            $scope.gotWeatherData = false;
        }
        dismissLoadingBar(FACCONST.WEATHERDATA);
    }

    function getWeathRecommendationMode() {
        var khaiPurity = +$scope.DeviceOptions.outDoorData.KHAI.purity,
                outDoorTemp = +$scope.outdoorTemp,
                homeTemp = +$scope.homeTemp;
        debugMessage("khaiPurity: " + khaiPurity);
        debugMessage("yellowDust: " + $scope.yellowDust);
        debugMessage("Condition: " + $scope.weatherCurrentData.reCondition);
        debugMessage("OutdoorTemp: " + $scope.outdoorTemp);
        debugMessage("homeTemp: " + $scope.homeTemp);
        if (outDoorTemp <= 14) {
            if (homeTemp <= 24) {
                weathRecommCondition1();
            } else if (homeTemp >= 25) {
                weathRecommCondition2();
            }
        } else if (outDoorTemp >= 15) {
            if (homeTemp <= 22) {
               weathRecommCondition1();
            } else if (homeTemp === 23 || homeTemp === 24) {
                weathRecommCondition2();
            } else if (homeTemp >= 25) {
                if ($scope.yellowDust) {
                    $scope.weathRecommendedMode = "CoolClean";
                    $scope.weathRecommendedModeText = "WEBMOB_fac_weather_recommend_coolpurify";
                } else {
                    if (khaiPurity === 3 || khaiPurity === 4) {
                        $scope.weathRecommendedMode = "CoolClean";
                        $scope.weathRecommendedModeText = "WEBMOB_fac_weather_recommend_coolpurify_poor"; // "Cool / Purify mode is recommended for hot weather with poor air quality."
                    } else if (khaiPurity === 1 || khaiPurity === 2) {
                        $scope.weathRecommendedMode = "Cool";
                        $scope.weathRecommendedModeText = "WEBMOB_fac_weather_recommend_cool";
                    }
                }
            }
        }
        if (!userClosedWeathRecommMode) {
            $scope.showWeathRecommendation = true;
        }
    }
    
    function weathRecommCondition1() {
        var khaiPurity = +$scope.DeviceOptions.outDoorData.KHAI.purity,
            reCondition = +$scope.weatherCurrentData.reCondition;
        if ($scope.yellowDust) {
            $scope.weathRecommendedMode = "Wind";
            $scope.weathRecommendedModeText = "WEBMOB_fac_weather_recommend_purify";
        } else {
            if (khaiPurity === 3 || khaiPurity === 4) {
                $scope.weathRecommendedMode = "Wind";
                $scope.weathRecommendedModeText = "WEBMOB_fac_weather_recommend_purify_poor"; // "Purify mode is recommended for poor air quality."
            } else if (khaiPurity === 1 || khaiPurity === 2) {
                $scope.weathRecommendedMode = "None";
                if (reCondition === 1) {
                    $scope.weathRecommendedModeText = "WEBMOB_fac_weather_recommend_sunny";
                } else if (reCondition === 2) {
                    $scope.weathRecommendedModeText = "WEBMOB_fac_weather_recommend_rainysnowy";
                } else if (reCondition === 3) {
                    $scope.weathRecommendedModeText = "WEBMOB_fac_weather_recommend_snowy";
                } else if (reCondition === 4) {
                    $scope.weathRecommendedModeText = "WEBMOB_fac_weather_recommend_cloudy";
                } else if (reCondition === 5) {
                    $scope.weathRecommendedModeText = "WEBMOB_fac_weather_recommend_rainy";
                }
            }
        }
    }
    
    function weathRecommCondition2() {
        var khaiPurity = +$scope.DeviceOptions.outDoorData.KHAI.purity,
            reCondition = +$scope.weatherCurrentData.reCondition;
        if ($scope.yellowDust) {
            if (reCondition === 1 || reCondition === 4) {
                $scope.weathRecommendedMode = "Wind";
                $scope.weathRecommendedModeText = "WEBMOB_fac_weather_recommend_purify";
            } else if (reCondition === 2 || reCondition === 3 || reCondition === 5) {
                $scope.weathRecommendedMode = "DryClean";
                $scope.weathRecommendedModeText = "WEBMOB_fac_weather_recommend_drypurify";
            }
        } else {
            if (reCondition === 1 || reCondition === 4) {
                if (khaiPurity === 3 || khaiPurity === 4) {
                    $scope.weathRecommendedMode = "Wind";
                    $scope.weathRecommendedModeText = "WEBMOB_fac_weather_recommend_purify_poor"; // "Purify mode is recommended for poor air quality."
                }
            }
            if (reCondition === 1) {
                if (khaiPurity === 1 || khaiPurity === 2) {
                    $scope.weathRecommendedMode = "None";
                    $scope.weathRecommendedModeText = "WEBMOB_fac_weather_recommend_sunny";
                }
            }
            if (reCondition === 4) {
                if (khaiPurity === 1 || khaiPurity === 2) {
                    $scope.weathRecommendedMode = "None";
                    $scope.weathRecommendedModeText = "WEBMOB_fac_weather_recommend_cloudy";
                }
            }
            if (reCondition === 2 || reCondition === 3 || reCondition === 5) {
                if (khaiPurity === 3 || khaiPurity === 4) {
                    $scope.weathRecommendedMode = "DryClean";
                    $scope.weathRecommendedModeText = "WEBMOB_fac_weather_recommend_drypurify_poor"; // "Dry / Purify mode is recommended for humid weather with poor air quality."
                } else if (khaiPurity === 1 || khaiPurity === 2) {
                    $scope.weathRecommendedMode = "Dry";
                    $scope.weathRecommendedModeText = "WEBMOB_fac_weather_recommend_dry";
                }
            }
        }
    }

    $scope.setWeathRecommMode = function () {
        if ($scope.isStatic) {
            $scope.currentMode = $scope.weathRecommendedMode;
            showToast("",  $scope.translation[getModeCompleteText($scope.weathRecommendedMode)] + " " + $scope.translation.WEBMOB_fac_recommend_mode_applied);
        } else {
            if (!$scope.powerOperation) {
                $scope.checkResponse.push(FACCONST.POWEROPERATION);
                SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getPowerCommand($scope.powerOperation), "/" + $scope.peerId + "/devices/0/operation");
            }
            if ($scope.currentMode !== $scope.weathRecommendedMode) {
                $scope.checkResponse.push(FACCONST.MODECHANGE);
                SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getModeCommand($scope.weathRecommendedMode, $scope.defaultConfig[$scope.weathRecommendedMode].configWindDirection, $scope.defaultConfig[$scope.weathRecommendedMode].configWindStrength, $scope.defaultConfig[$scope.weathRecommendedMode].configTempDefault), "/" + $scope.peerId + "/devices/0");
                showToast("",  $scope.translation[getModeCompleteText($scope.weathRecommendedMode)] + " " + $scope.translation.WEBMOB_fac_recommend_mode_applied);
            }
        }
    };
    
    function closeWeathRecommMode() {
        $scope.alarmExpanded = false;
        $scope.showWeathRecommendation = false;
        userClosedWeathRecommMode = true;
    }

    /* 1 - main_ac_weather_ic_day_clear.svg, 2 - main_ac_weather_ic_day_snow_rain.svg
     3 - main_ac_weather_ic_day_snow.svg, 4 - main_ac_weather_ic_day_cloud.svg
     5 - main_ac_weather_ic_day_rain
     */
    $scope.getWeatherIcon = function (value) {
        var temp;
        switch (value) {
            case 1:
                temp = "FAC/assets/img/main_ac_weather_ic_day_clear.svg#Layer_1";
                break;
            case 2:
                temp = "FAC/assets/img/main_ac_weather_ic_day_snow_rain.svg#Layer_1";
                break;
            case 3:
                temp = "FAC/assets/img/main_ac_weather_ic_day_snow.svg#Layer_1";
                break;
            case 4:
                temp = "FAC/assets/img/main_ac_weather_ic_day_cloud.svg#Layer_1";
                break;
            case 5:
                temp = "FAC/assets/img/main_ac_weather_ic_day_rain.svg#Layer_1";
                break;
            default:
                break;
        }
        var svg = document.getElementById('weatherSVG');
        SHPService.loadSVG(temp, svg);
    };
    $scope.getWeatherSmallIcon = function (value) {
        var temp;
        switch (value) {
            case 1:
                temp = "FAC/assets/img/main_ac_weather_ic_day_clear.svg#Layer_1";
                break;
            case 2:
                temp = "FAC/assets/img/main_ac_weather_ic_day_snow_rain.svg#Layer_1";
                break;
            case 3:
                temp = "FAC/assets/img/main_ac_weather_ic_day_snow.svg#Layer_1";
                break;
            case 4:
                temp = "FAC/assets/img/main_ac_weather_ic_day_cloud.svg#Layer_1";
                break;
            case 5:
                temp = "FAC/assets/img/main_ac_weather_ic_day_rain.svg#Layer_1";
                break;
            default:
                break;
        }
        return temp;
    };

    // Converting month, date, text into required format
    $scope.convertMonthDate = function (value) {
        var date = new Date(Date.parse(value));
        var dayText = ScheduleService.getWeatherDayText($scope.translation, date.getDay());
        var splitDate = value.split("-")[1] + "." + value.split("-")[2];
        return splitDate + " (" + dayText + ")";
    };

    //weather description page end

    // Air purity page start
    function outDoorPuirtyData (data) {
        var xmlString = decodeURIComponent(data["currentData"]);
        xmlString = xmlString.replace(/[+]/g, ' ');

        var x2js = new X2JS();
        var currentDataJson = x2js.xml_str2json(xmlString);        
        var gotAirData = false;
        
        if (getAirData === "getAirDataNew") {
            if (angular.isDefined(currentDataJson["PM10"]) && angular.isDefined(currentDataJson["PM10"]["RECORD"])) {
                var aRecords = currentDataJson["PM10"]["RECORD"];
                for (var a = 0; a < aRecords.length; a++) {
                    if (aRecords[a].region === $scope.selectedWeatherLocationCode) {
                        gotAirData = true;
                        $scope.DeviceOptions.outDoorData.pm10.value = parseInt(aRecords[a]["PM10"], 10);
                        $scope.DeviceOptions.outDoorData.pm10.purity = aRecords[a]["PM10_grade"];
                        $scope.DeviceOptions.outDoorData.pm10.purityText = $scope.getPurityText(aRecords[a]["PM10_grade"]);
                        $scope.DeviceOptions.outDoorData.pm10.colorClass = $scope.getAirPurityColor(aRecords[a]["PM10_grade"]);

                        $scope.DeviceOptions.outDoorData.SO2.value = aRecords[a]["so2"];
                        $scope.DeviceOptions.outDoorData.SO2.purity = aRecords[a]["so2_grade"];
                        $scope.DeviceOptions.outDoorData.SO2.purityText = $scope.getPurityText(aRecords[a]["so2_grade"]);
                        $scope.DeviceOptions.outDoorData.SO2.colorClass = $scope.getAirPurityColor(aRecords[a]["so2_grade"]);

                        $scope.DeviceOptions.outDoorData.O3.value = aRecords[a]["o3"];
                        $scope.DeviceOptions.outDoorData.O3.purity = aRecords[a]["o3_grade"];
                        $scope.DeviceOptions.outDoorData.O3.purityText = $scope.getPurityText(aRecords[a]["o3_grade"]);
                        $scope.DeviceOptions.outDoorData.O3.colorClass = $scope.getAirPurityColor(aRecords[a]["o3_grade"]);

                        $scope.DeviceOptions.outDoorData.CO.value = aRecords[a]["co"];
                        $scope.DeviceOptions.outDoorData.CO.purity = aRecords[a]["co_grade"];
                        $scope.DeviceOptions.outDoorData.CO.purityText = $scope.getPurityText(aRecords[a]["co_grade"]);
                        $scope.DeviceOptions.outDoorData.CO.colorClass = $scope.getAirPurityColor(aRecords[a]["co_grade"]);

                        $scope.DeviceOptions.outDoorData.N2O2.value = aRecords[a]["no2"];
                        $scope.DeviceOptions.outDoorData.N2O2.purity = aRecords[a]["no2_grade"];
                        $scope.DeviceOptions.outDoorData.N2O2.purityText = $scope.getPurityText(aRecords[a]["no2_grade"]);
                        $scope.DeviceOptions.outDoorData.N2O2.colorClass = $scope.getAirPurityColor(aRecords[a]["no2_grade"]);

                        $scope.DeviceOptions.outDoorData.KHAI.value = aRecords[a]["khai"];
                        $scope.DeviceOptions.outDoorData.KHAI.purity = aRecords[a]["khai_grade"];
                        $scope.DeviceOptions.outDoorData.KHAI.purityText = $scope.getPurityText(aRecords[a]["khai_grade"]);
                        $scope.DeviceOptions.outDoorData.KHAI.colorClass = $scope.getAirPurityColor(aRecords[a]["khai_grade"]);
                        $scope.DeviceOptions.outDoorData.KHAI.iconClass = getAirPurityImage(parseInt(aRecords[a]["khai_grade"]));
                        break;
                    }
                }
            }            
        } else {
            if (angular.isDefined(currentDataJson["response"]["body"]["items"]["item"])) {
                gotAirData = true;
                $scope.DeviceOptions.outDoorData.pm10.value = currentDataJson["response"]["body"]["items"]["item"]["pm10Value"];
                $scope.DeviceOptions.outDoorData.pm10.purity = currentDataJson["response"]["body"]["items"]["item"]["pm10Grade"];
                $scope.DeviceOptions.outDoorData.pm10.purityText = $scope.getPurityText(currentDataJson["response"]["body"]["items"]["item"]["pm10Grade"]);
                $scope.DeviceOptions.outDoorData.pm10.colorClass = $scope.getAirPurityColor(currentDataJson["response"]["body"]["items"]["item"]["pm10Grade"]);

                $scope.DeviceOptions.outDoorData.SO2.value = currentDataJson["response"]["body"]["items"]["item"]["so2Value"];
                $scope.DeviceOptions.outDoorData.SO2.purity = currentDataJson["response"]["body"]["items"]["item"]["so2Grade"];
                $scope.DeviceOptions.outDoorData.SO2.purityText = $scope.getPurityText(currentDataJson["response"]["body"]["items"]["item"]["so2Grade"]);
                $scope.DeviceOptions.outDoorData.SO2.colorClass = $scope.getAirPurityColor(currentDataJson["response"]["body"]["items"]["item"]["so2Grade"]);

                $scope.DeviceOptions.outDoorData.O3.value = currentDataJson["response"]["body"]["items"]["item"]["o3Value"];
                $scope.DeviceOptions.outDoorData.O3.purity = currentDataJson["response"]["body"]["items"]["item"]["o3Grade"];
                $scope.DeviceOptions.outDoorData.O3.purityText = $scope.getPurityText(currentDataJson["response"]["body"]["items"]["item"]["o3Grade"]);
                $scope.DeviceOptions.outDoorData.O3.colorClass = $scope.getAirPurityColor(currentDataJson["response"]["body"]["items"]["item"]["o3Grade"]);

                $scope.DeviceOptions.outDoorData.CO.value = currentDataJson["response"]["body"]["items"]["item"]["coValue"];
                $scope.DeviceOptions.outDoorData.CO.purity = currentDataJson["response"]["body"]["items"]["item"]["coGrade"];
                $scope.DeviceOptions.outDoorData.CO.purityText = $scope.getPurityText(currentDataJson["response"]["body"]["items"]["item"]["coGrade"]);
                $scope.DeviceOptions.outDoorData.CO.colorClass = $scope.getAirPurityColor(currentDataJson["response"]["body"]["items"]["item"]["coGrade"]);

                $scope.DeviceOptions.outDoorData.N2O2.value = currentDataJson["response"]["body"]["items"]["item"]["no2Value"];
                $scope.DeviceOptions.outDoorData.N2O2.purity = currentDataJson["response"]["body"]["items"]["item"]["no2Grade"];
                $scope.DeviceOptions.outDoorData.N2O2.purityText = $scope.getPurityText(currentDataJson["response"]["body"]["items"]["item"]["no2Grade"]);
                $scope.DeviceOptions.outDoorData.N2O2.colorClass = $scope.getAirPurityColor(currentDataJson["response"]["body"]["items"]["item"]["no2Grade"]);

                $scope.DeviceOptions.outDoorData.KHAI.value = currentDataJson["response"]["body"]["items"]["item"]["khaiValue"];                
                $scope.DeviceOptions.outDoorData.KHAI.purity = currentDataJson["response"]["body"]["items"]["item"]["khaiGrade"];
                $scope.DeviceOptions.outDoorData.KHAI.purityText = $scope.getPurityText(currentDataJson["response"]["body"]["items"]["item"]["khaiGrade"]);
                $scope.DeviceOptions.outDoorData.KHAI.colorClass = $scope.getAirPurityColor(currentDataJson["response"]["body"]["items"]["item"]["khaiGrade"]);
                $scope.DeviceOptions.outDoorData.KHAI.iconClass = getAirPurityImage(parseInt(currentDataJson["response"]["body"]["items"]["item"]["khaiGrade"]));
            }
        }
        if (!gotAirData) {
            $scope.DeviceOptions.outDoorData.KHAI.purity = -1;
            $scope.DeviceOptions.outDoorData.KHAI.colorClass = $scope.getAirPurityColor($scope.DeviceOptions.outDoorData.KHAI.purity);
            $scope.DeviceOptions.outDoorData.pm10.value = -1;
        }
        dismissLoadingBar(FACCONST.AIRDATA);
    }
    $scope.getAirPurityColor = function (value) {
        value = parseInt(value, 10);
        switch (value) {
            case 1:
                return 'airpurity_goodColor';
            case 2:
                return 'airpurity_normalColor';
            case 3:
                return 'airpurity_badColor';
            case 4:
                return 'airpurity_veryBadColor';
            default:
                return 'airpurity_disabledText';                
                break;
        }
    };
    $scope.getPurityText = function (value) {
        value = parseInt(value, 10);
        switch (value) {
            case -1:
                return '';
            case 1:
                return 'ACMOB_airfreshness_good';
            case 2:
                return 'ACMOB_airfreshness_average';
            case 3:
                return 'ACMOB_airfreshness_bad';
            case 4:
                return 'ACMOB_airfreshness_very_bad';
            default:
                break;
        }
    };
    function getAirPurityImage (value) {
        switch (value) {
            case 1:
                return 'purity-level-good';
            case 2:
                return 'purity-level-normal';
            case 3:
                return 'purity-level-bad';
            case 4:
                return 'purity-level-verybad';
            default:
                return 'purity-level-off';
        }
    }
    // Air purity page end

    // Power consumption start
    $scope.targetUsagePopup = false;
    toggleBottomPopUpClass($scope.targetUsagePopup);
    $scope.currentTargetUsage = 5;
    $scope.tempTargetUsage;
    $scope.PC_usageLimit;
    $scope.cumulativeConsumption = 0.1;
    $scope.getPowerConsumption = function () {
        if (!$scope.isStatic) {
            $scope.checkResponse.push(FACCONST.POWERCONSUMPTION);
            SHPService.sendSHPCommand(CONSTANTS.GET, "/" + $scope.peerId + "/devices/0/energyconsumption");
        }
    };
    function parsePowerConsumption(powerConsumption) {
        if (angular.isDefined(powerConsumption["cumulativeConsumption"])) {
            $scope.cumulativeConsumption = powerConsumption["cumulativeConsumption"] / 1000;
            debugMessage("cumulativeConsumption: " + $scope.cumulativeConsumption);
        }
        if (angular.isDefined(powerConsumption["usageThreshold"])) {
            $scope.currentTargetUsage = powerConsumption["usageThreshold"] / 1000;
            debugMessage("currentTargetUsage: " + $scope.currentTargetUsage);
        }
        if ($scope.currentTargetUsage < 5) {
            $scope.disableTargetUsage = true;
            $scope.PC_usageLimit = false;
            $scope.PC_SmallDivCenter = false;
        } else {
            $scope.disableTargetUsage = false;
            $scope.PC_usageLimit = true;
            $scope.PC_SmallDivCenter = true;
        }
        // set progress bar max value and value
        var progressBar = document.getElementById("PC_ProgressID");
        progressBar.value = $scope.cumulativeConsumption;
        progressBar.max = $scope.currentTargetUsage;
        dismissLoadingBar(FACCONST.POWERCONSUMPTION);
    }
    $scope.showTargetUsagepopup = function () {
        $timeout(function () {
            if (!$scope.disableTargetUsage) {
                $scope.targetUsagePopup = true;
                toggleBottomPopUpClass($scope.targetUsagePopup);
                $scope.tempTargetUsage = $scope.currentTargetUsage;
            }
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    };

    $scope.onUsageLimitSettings = function () {
        $timeout(function () {
            if (!$scope.isStatic) {
                $scope.checkResponse.push(FACCONST.POWERCONSUMPTION);
                if (!$scope.PC_usageLimit) {
                    SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getTargetUsageCommand(5000.0), "/" + $scope.peerId + "/devices/0/energyconsumption");
                } else {
                    SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getTargetUsageCommand(1.0), "/" + $scope.peerId + "/devices/0/energyconsumption");
                }
            } else {
                $scope.PC_usageLimit = !$scope.PC_usageLimit;
            }
        }, MATERIAL_DESIGN.TOGGLE_TIME);
    };
    // 1) Usage input unit can be increased in 5 kwh from range of 5 kwh to 30kwh
    // 2) Abvoe 30kWh, usage value can be increased in 10kWh
    $scope.increaseTargetUsage = function (bool) {
        if (bool) { // increase
            if ($scope.tempTargetUsage < 30) {
                $scope.tempTargetUsage += 5;
            } else if ($scope.tempTargetUsage < 90) {
                $scope.tempTargetUsage += 10;
            } else if ($scope.tempTargetUsage === 90) {
                $scope.tempTargetUsage += 9;
            } else {
                // Nothing
            }
        } else { // decrease
            if ($scope.tempTargetUsage <= 30 && $scope.tempTargetUsage >= 10) {
                $scope.tempTargetUsage -= 5;
            } else if ($scope.tempTargetUsage > 30 && $scope.tempTargetUsage <= 90) {
                $scope.tempTargetUsage -= 10;
            } else if ($scope.tempTargetUsage === 99) {
                $scope.tempTargetUsage -= 9;
            } else {
                // Nothing
            }
        }
    };
    $scope.onTargeUsageUpdate = function (bool) {
        $scope.targetUsagePopup = false;
        toggleBottomPopUpClass($scope.targetUsagePopup);
        if (bool) { // Yes
            if (!$scope.isStatic) {
                if ($scope.currentTargetUsage !== $scope.tempTargetUsage) {
                    $scope.checkResponse.push(FACCONST.POWERCONSUMPTION);
                    SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getTargetUsageCommand($scope.tempTargetUsage * 1000), "/" + $scope.peerId + "/devices/0/energyconsumption");
                }
            } else {
                $scope.currentTargetUsage = $scope.tempTargetUsage;
            }
        }
    };
    var myPCVOlumeCommand = false;
    $scope.sendPCVolumeCommand = function () {
        if (!$scope.isStatic) {
            $scope.checkResponse.push(FACCONST.WATTNOTICE);
            SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getPCVolumeCommand(), "/" + $scope.peerId + "/devices/0");
            myPCVOlumeCommand = true;
        }
    };

    $scope.PCTabClick = function (tab) {
        if (tab === 0) {
            if ($scope.showPrsentPC) { //If it is already selected, return.
                return;
            }
            $scope.showPrsentPC = true;
            $scope.showHistoryPC = false;
            $scope.energyMonitorPage = false;
            $scope.getPowerConsumption();
        } else {
            if ($scope.showHistoryPC) { //If it is already selected, return.
                return;
            }
            $scope.showHistoryPC = true;
            goToEnergyMonitor();
            $scope.showPrsentPC = false;
        }
    };
    // Power consumption end

    // Schedule logic start (schedule list, add/edit/remove schedule)
    function checkForScheduleDataAvailable(length) {
        if (length === 0) {
            $scope.scheduleDataAvailable = false;
        } else {
            $scope.scheduleDataAvailable = true;
        }
    }

    function parseActionData (actData) {
        var len,
                cnt1,
                cnt2,
                tempSch1,
                tempSch2;
        checkForScheduleDataAvailable(actData.length);

        if (actData.length > 0) {
            // Remove the items if device ID is not matching
            for (var k = actData.length - 1; k >= 0; k--) {
                if (angular.isDefined(actData[k].Actuators) && actData[k].Actuators[0].deviceIDs[0] !== $scope.deviceID.toString()) {
                    actData.splice(k, 1);
                } else {
                    // Do Nothing
                }
            }
            checkForScheduleDataAvailable(actData.length);

            //Lokesh -> patch for deleting duplicate schedule.
            //Hope once FAC hardware starts working fine, we will not need this code.
            len = actData.length;
            for (cnt1 = 0; cnt1 < len; ++cnt1) {
                for (cnt2 = cnt1 + 1; cnt2 < len; ++cnt2) {
                    tempSch1 = angular.copy(actData[cnt1]); //avoid refernce assignment. Copy whole object.
                    tempSch2 = angular.copy(actData[cnt2]); //avoid refernce assignment. Copy whole object.
                    tempSch1.id = tempSch2.id = ''; //Ids can be different. So, ignore them.

                    if (JSON.stringify(tempSch1) === JSON.stringify(tempSch2)) {
                        actData.splice(cnt2, 1);
                        --len;
                        --cnt2;
                    }
                }
            }

            for (var i = 0; i < actData.length; i++) {
                if ($scope.Actions[i] === undefined) {
                    $scope.Actions[i] = {id: '', 'Actuators': [{Operation: {power: ''}, deviceIDs: []}], dayOfWeek: [], disposable: false, enabled: true, startTime: ''};
                }
                if (angular.isDefined(actData[i].id)) {
                    $scope.Actions[i].id = actData[i].id;
                }
                if (angular.isDefined(actData[i].Actuators) && actData[i].Actuators.length > 0) {
                    var Actuators = actData[i].Actuators;
                    for (var j = 0; j < Actuators.length; j++) {
                        if ($scope.Actions[i].Actuators[j] === undefined) {
                            $scope.Actions[i].Actuators[j] = {Operation: {power: ''}, deviceIDs: []};
                        }
                        if (angular.isDefined(Actuators[j].Operation) && angular.isDefined(Actuators[j].Operation.power)) {
                            $scope.Actions[i].Actuators[j].Operation.power = Actuators[j].Operation.power;
                        }
                        if (angular.isDefined(Actuators[j].deviceIDs)) {
                            $scope.Actions[i].Actuators[j].deviceIDs = Actuators[j].deviceIDs;
                        }
                    }

                }
                if (!!actData[i].dayOfWeek && !!actData[i].startTime) {
                    $scope.Actions[i].dayOfWeek = ScheduleService.getAdjustedWeekDays(actData[i].dayOfWeek, actData[i].startTime);
                }
                if (angular.isDefined(actData[i].disposable)) {
                    $scope.Actions[i].disposable = actData[i].disposable;
                }
                if (angular.isDefined(actData[i].enabled)) {
                    $scope.Actions[i].enabled = actData[i].enabled;
                }
                if (angular.isDefined(actData[i].startTime)) {
                    $scope.Actions[i].startTime = actData[i].startTime;
                    var gmt = ScheduleService.setTimeInGMT(actData[i].startTime);

                    $scope.Actions[i].newStartTime = gmt[0] + ':' + gmt[1];
                    $scope.Actions[i].timeConvention = gmt[2];
                }
            }
        }
        for (var m = actData.length; m < $scope.Actions.length; m++) {
            $scope.Actions.splice(m, 1);
        }
        if ($scope.Actions.length === 0) {
            $scope.ScheduleText = $scope.translation.WEBMOB_common_none;
        } else {
            ScheduleService.calculateUpcomingSchedule($scope);
        }
        dismissLoadingBar(FACCONST.SCHEDULEDATA);
    }

    function addSchedule(act) {
        ScheduleService.addSchedule($scope, act);
    }

    $scope.asTabSelected = function (bool) {
        ScheduleService.asTabSelected($scope, bool);
    };
    $scope.increaseHours = function () {
        ScheduleService.increaseHours($scope);
    };
    $scope.decreaseHours = function () {
        ScheduleService.decreaseHours($scope);
    };

    $scope.onAsRepeatWeakly = function () {
        ScheduleService.onAsRepeatWeakly($scope);
    };
    $scope.increaseMinutes = function () {
        ScheduleService.increaseMinutes($scope);
    };

    $scope.decreaseMinutes = function () {
        ScheduleService.decreaseMinutes($scope);
    };
    $scope.changeMeridian = function () {
        ScheduleService.changeMeridian($scope);
    };

    $scope.saveSchedule = function () {
        ScheduleService.saveSchedule($scope);
    };


    //This code will be required later. please don't delete it.
    $scope.keypadClicked = function () {
        ScheduleService.keypadClicked();
    };

    $scope.daySelected = function (dayValue) {
        ScheduleService.daySelected($scope, dayValue);
    };

    $scope.dayColorSelected = function (dayValue) {
        return ScheduleService.dayColorSelected($scope, dayValue);
    };

    $scope.removeItemFromSchedule = function (schedule) {
        ScheduleService.removeItemFromSchedule($scope, schedule, FACCONST.SCHEDULEDATA);
    };
    // Schedue logic end

    // Wind logic start here
    function addWind(item) {
        if (item === -1) {
            if ($scope.windList.length === 10) {
                $timeout(function () {
                    toaster.success({title: "", body: $scope.translation.WEBMOB_device_fac_mywind_wind_list_max_10_noti, bodyOutputType: 'trustedHtml'});
                }, 500);
                return;
            }
            $scope.isEditWindMode = false;
            $scope.selectedWind = {};
            $scope.selectedWind.id = $scope.generateWindID();
            $scope.selectedWind.name = $scope.generateWindName();
            $scope.selectedWind.mode = $scope.currentMode;
            $scope.selectedWind.temp = $scope.desiredTemp;
            $scope.selectedWind.windStrength = $scope.currentWindStrength;
            $scope.selectedWind.windDirection = $scope.currentWindDirection;
            $scope.selectedWind.purify = ~$scope.selectedWind.mode.indexOf("Clean") ? true : false;
        } else {
            $scope.isEditWindMode = true;
            $scope.selectedWind = Object.create(item);
        }
        updateWindStrengthList($scope.selectedWind.mode);
        $scope.gotoAddMyWind();
    }

    $scope.saveWind = function () {
        var duplicateNameExist = false,
                cnt;
        updateWindNameFromInputField();
        if (!$scope.selectedWind.name.length) {
            showToast("", $scope.translation.WEBMOB_device_fac_mywind_wind_require_name);
        } else {
            for(cnt = 0; cnt < $scope.windList.length; cnt++) {
                if ($scope.windList[cnt].name === $scope.selectedWind.name && $scope.windList[cnt].id !== $scope.selectedWind.id) {
                    duplicateNameExist = true;
                    showToast("", $scope.translation.WEBMOB_common_duplicate_name);
                    break;
                }
            }

            if (!duplicateNameExist) {
                if (!$scope.isEditWindMode) {
                    $scope.windList.push($scope.selectedWind);
                } 
                else {
                    for (cnt = 0; cnt < $scope.windList.length; cnt++) {
                        if ($scope.windList[cnt].id === $scope.selectedWind.id) {
                            angular.merge($scope.windList[cnt], $scope.selectedWind);
                            break;
                        }
                    }
                }
                setLocalStorageData(currentWindKey, JSON.stringify($scope.windList));
                $scope.gotoMyWindList();
                showToast("", $scope.translation.WEBMOB_common_mywind_saved);
            }
        }
    };
    
    // Model is not getting the latest value of input field by itself when predictive text is enabled on mobile.
    // Hence, we've to give the latest inputs to the model explicitly.
    function updateWindNameFromInputField() {
        $scope.selectedWind.name = document.getElementById("addWindNameID").value;
    }

    function showToast(title, body) {
        $timeout(function () {
            toaster.success({title: title, body: body, bodyOutputType: 'trustedHtml'});
        }, 500);
    }
    
    $scope.removeItemFromWind = function (item) {
        $scope.windList.forEach(function (value, index) {
            if (value.id === item.id) {
                $scope.windList.splice(index, 1);
            }
        });
        setLocalStorageData(currentWindKey, JSON.stringify($scope.windList));
        toaster.success({title: "", body: $scope.translation.WEBMOB_common_schedule_delete_success, bodyOutputType: 'trustedHtml'});
    };
    $scope.windItemToggleUpdate = function (item) {
        item.enabled = !item.enabled;
        $scope.windList.forEach(function (value) {
            if (value.id !== item.id) {
                value.enabled = false;
            }
        });
    };
    var myWindCommandFlag = false;
    $scope.sendMyWindCommand = function (item) {
        if (!$scope.isStatic) {
            if (!$scope.powerOperation) {
                SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getPowerCommand($scope.powerOperation), "/" + $scope.peerId + "/devices/0/operation");
            }
            $scope.checkResponse.push(FACCONST.WINDCOMMAND);
            SHPService.sendSHPCommand(CONSTANTS.PUT, $scope.getModeCommand(item.mode, item.windDirection, item.windStrength, item.temp), "/" + $scope.peerId + "/devices/0");
            myWindCommandFlag = true;
        }
    };

    // Findout maxium ID value and add plus one to generate new ID
    $scope.generateWindID = function () {
        var max = 0;
        $scope.windList.forEach(function (item) {
            if (item.id > max) {
                max = item.id;
            }
        });
        return max + 1;
    };
    // Find out missing wind ID from 1 to 10 to generate new wind name
    $scope.generateWindName = function () {
        if ($scope.windList.length === 0) {
            return "My Wind 1";
        }
        var tempWindName;
        var windNameNotAvailable = false;
        for (var i = 1; i <= 10; i++) {
            tempWindName = "My Wind " + i;
            for (var j = 0; j < $scope.windList.length; j++) {
                if ($scope.windList[j].name === tempWindName) {
                    windNameNotAvailable = false;
                    break;
                } else {
                    windNameNotAvailable = true;
                }
            }
            if (windNameNotAvailable) {
                break;
            }
        }
        return tempWindName;
    };
    function onAddWindPuritySetting() {
        if ($scope.selectedWind.purify) {
            $scope.selectedWind.mode = $scope.selectedWind.mode.split("Clean")[0];
        } else {
            $scope.selectedWind.mode = $scope.selectedWind.mode + "Clean";
        }
        $scope.selectedWind.purify = !$scope.selectedWind.purify;
    }    
    // Wind logic end here

    // Request fail handler
    $scope.requestFailHandler = function (response) {
        // When requestFailed occurs, dismiss loading bar
        $scope.checkResponse = [];
        $scope.loadingBar = false;

        var msg;
        if (angular.isDefined(response["resourceURL"]) && response["resourceURL"].indexOf("/actions") !== -1 && response["resourceURL"].indexOf("/actions/") === -1) {
            $timeout(function () {
                toaster.success({title: "", body: $scope.translation.WEBMOB_common_schedule_save_failed});
            }, 500);

            scheduleList();

        } else if (angular.isDefined(response["resourceURL"]) && response["resourceURL"].indexOf("/actions/") !== -1) {
            if (response.data.message.indexOf('InvokeDelScheduleFunc') !== -1) {
                msg = $scope.translation.WEBMOB_common_schedule_delele_fail_reservation;
            } else if (response.data.message.indexOf('InvokeSetScheduleFunc') !== -1) {
                msg = $scope.translation.WEBMOB_common_schedule_save_failed;
            } else {
                // Nothing
            }
            if (angular.isDefined(msg)) {
                $timeout(function () {
                    toaster.success({title: "", body: msg});
                }, 500);
            }
            scheduleList();
        } else {
            // Nothing
        }
    };

    // Connection failure handling
    function showConnectionFailurePopup() {
        dismissAllPopups();
        document.getElementById("connFailCancel").style.visibility = 'hidden';
        $scope.showConnFailurePopup = true;
        toggleBottomPopUpClass($scope.showConnFailurePopup);
    }
    
    function closeConnectionFailurePopup() {
        $scope.showConnFailurePopup = false;
        toggleBottomPopUpClass($scope.showConnFailurePopup);
    }

    $scope.connFailureAction = function () {
        $scope.closeApp();
    };

    function handleStatusCode(status, response) {
        //handle schedule list in later section
        if (status === FACCONST.STATUS_204 && $scope.currentScreen !== FACSCREENS.SCHEDULELIST) {
            if (myPCVOlumeCommand) {
                myPCVOlumeCommand = false;
                dismissLoadingBar(FACCONST.WATTNOTICE);
            }
            if (myWindCommandFlag) {
                myWindCommandFlag = false;
                dismissLoadingBar(FACCONST.WINDCOMMAND);
            } else {
                //None.
            }
        } else if ($scope.currentScreen === FACSCREENS.SCHEDULELIST && !!!response.data && status === FACCONST.STATUS_200) {  //if status = 200, current screen is schedule list and no data object in response then this is response of schedule delete.
            //schedule deleted successfully. Show toast.
            toaster.success({title: "", body: $scope.translation.WEBMOB_common_schedule_delete_success, bodyOutputType: 'trustedHtml'});
            dismissLoadingBar(FACCONST.SCHEDULEDATA);
        } else if (($scope.currentScreen === FACSCREENS.SCHEDULELIST || $scope.currentScreen === FACSCREENS.ADDSCHEDULE) && status === FACCONST.STATUS_201) {
            //if status = 201, current screen is schedule list then this is response of add schedule.
            toaster.success({title: "", body: $scope.translation.WEBMOB_common_schedule_save_successful, bodyOutputType: 'trustedHtml'});
            dismissLoadingBar(FACCONST.SCHEDULEDATA);
        }
        //dismiss loading bar anonymously for all success responses.
        else if ($scope.checkResponse.length > 0) {   //on a positive side, check for fony success response.
            dismissLoadingBar($scope.checkResponse[$scope.checkResponse.length - 1]);
        } else {
            //None.
        }
    }

    // Go to energy moitor screen
    function goToEnergyMonitor() {
        if ((!$scope.isStatic)) {
            if (!isDBDownloadedJS)
            {
                return;
            }
        }
        EnergyService.goToEnergyMonitor($scope);
        $scope.energyMonitorPage = true;
    }

    $scope.showDailyData = function () {
        EnergyService.showDailyData($scope);
    };

    $scope.showWeeklyData = function () {
        EnergyService.showWeeklyData($scope);
    };

    $scope.showMonthlyData = function () {
        EnergyService.showMonthlyData($scope);
    };

    $scope.showNextDaysData = function () {
        EnergyService.showNextDaysData($scope);
    };

    $scope.showPreviousDaysData = function () {
        EnergyService.showPreviousDaysData($scope);
    };

    $scope.fetchDBfromDevice = function () {
        if (!$scope.isStatic) {
            nativeInterface.getResourceUrl("/" + $scope.peerId + $scope.energyMonitorLocation);
        }
    };
    $scope.parseEnergyUsageData = function (energyResponse) {
        EnergyService.parseEnergyUsageData($scope, energyResponse);
    };
    $scope.handleEnergyMonitorErrors = function () {
        toaster.success({title: "", body: $scope.translation.WEBMOB_common_no_data, bodyOutputType: 'trustedHtml'});
    };
    $scope.isEnergyReset = function () {
        return false;
    };

    function dismissLoadingBar(value) {
        if ($scope.checkResponse.indexOf(value) !== -1) {
            $scope.checkResponse.splice($scope.checkResponse.indexOf(value), 1);
            if ($scope.checkResponse.length === 0) {
                $scope.loadingBar = false;
            }
        }
    }
    
    $scope.stopLongPressEvent = function () {
        if (!!promise) {
            //check if promise exist. Then call cancel.
            $interval.cancel(promise);
            promise = undefined;
        }
        if ($scope.longPress) {
            $scope.longPress = false;
            clearInterval($scope.timer);
           }
        if (increaseTempConinous) {
            increaseTempConinous = false;
            updateTemp($scope.desiredTemp);
        }
        if (decreaseTempConinous) {
            decreaseTempConinous = false;
            updateTemp($scope.desiredTemp);
        }
    };

    /*$scope.handleLongPress = handleLongPress;
     function handleLongPress(fun, maxCnt) {
     if (!!!promise) {
     //It has been observed that touchend event is not fired every time. 
     //Hence, limit the $interval to a number of executions. 
     //Here this number is 14 = intervals required to reach maximum from minimum value.
     promise = $interval(function () {
     fun();
     }, 400, maxCnt);
     }
     }*/

    $scope.increaseHrContinuously = function () {
        if (!!!promise) {
            //It has been observed that touchend event is not fired every time. 
            //Hence, limit the $interval to a number of executions. 
            //Here this number is 14 = intervals required to reach maximum from minimum value.
            promise = $interval(function () {
                increaseHrTime();
            }, 200);
        }
    };

    $scope.decreaseHrContinuously = function () {
        if (!!!promise) {
            //It has been observed that touchend event is not fired every time. 
            //Hence, limit the $interval to a number of executions. 
            //Here this number is 14 = intervals required to reach maximum from minimum value.
            promise = $interval(function () {
                decreaseHrTime();
            }, 200);
        }
    };

    $scope.increaseMinContinuously = function () {
        if (!!!promise) {
            //It has been observed that touchend event is not fired every time. 
            //Hence, limit the $interval to a number of executions. 
            //Here this number is 14 = intervals required to reach maximum from minimum value.
            promise = $interval(function () {
                increaseMinTime();
            }, 200);
        }
    };

    $scope.decreaseMinContinuously = function () {
        if (!!!promise) {
            //It has been observed that touchend event is not fired every time. 
            //Hence, limit the $interval to a number of executions. 
            //Here this number is 14 = intervals required to reach maximum from minimum value.
            promise = $interval(function () {
                decreaseMinTime();
            }, 200);
        }
    };

    $scope.increaseTargetTempContinuously = function () {
        //increase temperature immediately at first.
//        increaseTargetTemp();

        //$interval should be called only once. Hence, check for promise.
        if (!!!promise) {
            //It has been observed that touchend event is not fired every time. 
            //Hence, limit the $interval to a number of executions. 
            //Here this number is 14 = intervals required to reach maximum from minimum value.
            promise = $interval(function () {
                increaseTargetTemp();
            }, 200, 14);    //14 -> number of maximum calls in case touchend event could not be fired.
        }
    };

    $scope.decreaseTargetTempContinuously = function () {
        //decrease temperature immediately at first.
//        decreaseTargetTemp();

        //$interval should be called only once. Hence, check for promise.
        if (!!!promise) {
            //It has been observed that touchend event is not fired every time. 
            //Hence, limit the $interval to a number of executions. 
            //Here this number is 14 = intervals required to reach minimum from maximum value.
            promise = $interval(function () {
                decreaseTargetTemp();
            }, 200, 14);    //14 -> number of maximum calls in case touchend event could not be fired.
        }
    };

    function increaseHrTime() {
        $scope.selectedSchedule.hours = Number($scope.selectedSchedule.hours);
        if ($scope.selectedSchedule.hours !== 12) {
            $scope.selectedSchedule.hours += 1;
        } else {
            $scope.selectedSchedule.hours = 1;
        }
        $scope.selectedSchedule.hours = ($scope.selectedSchedule.hours < 10) ? ('0' + $scope.selectedSchedule.hours) : $scope.selectedSchedule.hours;

        document.getElementById("asHoursID").value = $scope.selectedSchedule.hours;
    }

    function decreaseHrTime() {
        $scope.selectedSchedule.hours = Number($scope.selectedSchedule.hours);
        if ($scope.selectedSchedule.hours > 1) {
            $scope.selectedSchedule.hours -= 1;
        } else {
            $scope.selectedSchedule.hours = 12;
        }
        $scope.selectedSchedule.hours = ($scope.selectedSchedule.hours < 10) ? ('0' + $scope.selectedSchedule.hours) : $scope.selectedSchedule.hours;

        document.getElementById("asHoursID").value = $scope.selectedSchedule.hours;
    }

    function increaseMinTime() {
        $scope.selectedSchedule.minutes = Number($scope.selectedSchedule.minutes);
        // defined steps as 1
        var step = 1;
        if ($scope.selectedSchedule.minutes !== (60 - step)) {
            $scope.selectedSchedule.minutes += step;
        } else {
            $scope.selectedSchedule.minutes = 0;
        }
        $scope.selectedSchedule.minutes = ($scope.selectedSchedule.minutes < 10) ? ('0' + $scope.selectedSchedule.minutes) : $scope.selectedSchedule.minutes;

        document.getElementById("asMinutesID").value = $scope.selectedSchedule.minutes;
    }

    function decreaseMinTime() {
        $scope.selectedSchedule.minutes = Number($scope.selectedSchedule.minutes);
        var step = 1;
        if ($scope.selectedSchedule.minutes !== 0) {
            $scope.selectedSchedule.minutes -= step;
        } else {
            $scope.selectedSchedule.minutes = 60 - step;
        }
        $scope.selectedSchedule.minutes = ($scope.selectedSchedule.minutes < 10) ? ('0' + $scope.selectedSchedule.minutes) : $scope.selectedSchedule.minutes;

        document.getElementById("asMinutesID").value = $scope.selectedSchedule.minutes;
    }

    function increaseTargetTemp() {
        if ($scope.tempTargetUsage < 30) {
            $scope.tempTargetUsage += 5;
        } else if ($scope.tempTargetUsage < 90) {
            $scope.tempTargetUsage += 10;
        } else if ($scope.tempTargetUsage === 90) {
            $scope.tempTargetUsage += 9;
        } else {
            // Nothing
        }
//        document.getElementById("targetTempUses").value = $scope.tempTargetUsage;
    }

    function decreaseTargetTemp() {
        if ($scope.tempTargetUsage <= 30 && $scope.tempTargetUsage >= 10) {
            $scope.tempTargetUsage -= 5;
        } else if ($scope.tempTargetUsage > 30 && $scope.tempTargetUsage <= 90) {
            $scope.tempTargetUsage -= 10;
        } else if ($scope.tempTargetUsage === 99) {
            $scope.tempTargetUsage -= 9;
        } else {
            // Nothing
        }
    }

    $scope.hightlightSearchText = function (text, phrase) {
        if (phrase) {
            text = text.replace(new RegExp('(' + phrase + ')', 'i'), '<span class="highlighted">$1</span>');
        }
        return $sce.trustAsHtml(text);
    };

    //Lokesh -> Angular not getting the latest value of input field by itself. 
    //Hence, we've to give the latest inputs to the model explicitly.
    //Need to find why this is happening. But as of now, this will suffice.
    $scope.searchValueUpdated = function () {
        $scope.locationToBeSearched = document.getElementById("facSearchID").value;

        //calling change function here itself instead of creating ng-change attribute. 
        //If parent function is removed, put this function call in ng-change.
        $scope.searchValues = performSearchOperation($scope.locationToBeSearched, mOrginialValues);
    };

    function initSearchText() {
        $scope.locationToBeSearched = '';
        $scope.searchValues = mOrginialValues;
    }
    
    // First use guide starts here
    function showUsageHelpPage() {
        setTimeout(function(){
            document.getElementById("scrollable_area_id").scrollTop = 0;
        }, 10);
        $scope.bUsageHelpPage = true;
        tempFilterStatusShow = $scope.isFilterStatusShow;
        $scope.isFilterStatusShow = false;
    }

    function closeUsageHelpPage() {
        $scope.isFilterStatusShow = tempFilterStatusShow;
        $scope.bUsageHelpPage = false;        
    }
    // First use guide ends here
    
    // Option popup starts here
    function showOptionPopUp() {
        $scope.bOptionPopUp = true;
    }
     
    function closeOptionPopUp() {
       $scope.bOptionPopUp = false;
    }
    
    function selectIndexFromOptionMenu(optionMenuIndex) {
        switch (optionMenuIndex) {
            case 0:
                goToSettings();
                break;
            case 1:
                goToAbout();
                break;
            default:
                break;
        }
        closeOptionPopUp();
    }
    // Option popup end here
    
    function toggleAlarmInfoArea() {
        $scope.alarmExpanded = !$scope.alarmExpanded;
    }
    
    function getScrollableAreaClass() {
        var scrollClass = "";
        if (isPopupOpen()) {
            scrollClass += "noscroll";
        }
        if ($scope.addSchedulePage || $scope.addWindPage) {
            if ($scope.isAppV2) {
                scrollClass += " scrollable_area_no_header scrollable_area_no_header_V2";
            } else {
                scrollClass += " scrollable_area_no_header";
            }
        } else if ($scope.homePage) {            
            if ($scope.isAppV2) {
                if(getFilterStatusVisibility()) {
                    scrollClass += " scrollable_area scrollable_area_in_app_noti_V2";
                } else {
                    scrollClass += " scrollable_area scrollable_area_V2";
                }
            } else {
                if(getFilterStatusVisibility()) {
                    scrollClass += " scrollable_area scrollable_area_in_app_noti";
                } else {
                    scrollClass += " scrollable_area";
                }                    
            }
        } else if ($scope.powerConsumptionPage && $scope.showEnergyMonitorOption) {
            if ($scope.isAppV2) {
                scrollClass += " scrollable_area_others TopMarginForNoTabPage_V2";
            } else {
                scrollClass += " scrollable_area_others TopMarginForNoTabPage";
            } 
        } else if (!$scope.homePage) {
            if ($scope.isAppV2) {
                scrollClass += " scrollable_area_others scrollable_area_others_V2";
            } else {
                scrollClass += " scrollable_area_others";
            }
        }
        return scrollClass;
    }
    
    function getModeSelectionPopupClass() {
        var modeClass = ""; 
        if(getFilterStatusVisibility()) {
            if ($scope.isAppV2) {
                modeClass += " ModeSelectionPopupConInAppNoti_V2";
            } else {
                modeClass += " ModeSelectionPopupConInAppNoti";
            }
        } else {
            if ($scope.isAppV2) {
                modeClass += " ModeSelectionPopupCon_V2";
            }
        }
        return modeClass;
    }
    
    function openPopup(popupName) {
        debugMessage("openPopup >>>>>> name >>>>> " + popupName);
        switch(popupName) {
            case "serviceCenter": //Display service center numbers
                if ($scope.serviceCenterNumber !== undefined) {
                    $scope.radioBtnToSelect = [];
                    $scope.radioBtnSelectedIndex = 0;
                    if ($scope.serviceCenterNumber.indexOf(',') !== -1) {
                        $scope.isRadioSelection = true;
                        $scope.showServiceCenterText = true;
                        $scope.radioBtnToSelect = $scope.serviceCenterNumber.split(",");
                        showDialog(ALERT_STATE.SERVICE_CENTER_SELECTION, $scope.translation.WEBMOB_common_service_center, $scope.translation.WEBMOB_common_connect_service_call, $scope.translation.WEBMOB_common_cancel_capital, $scope.translation.WEBMOB_common_ok);
                    } else {
                        $scope.radioBtnToSelect[0] = $scope.serviceCenterNumber;
                        var msg = ($scope.translation.WEBMOB_common_connect_service_call) + "<br>" + ($scope.serviceCenterNumber || "");
                        showDialog(ALERT_STATE.SERVICE_CALL, $scope.translation.WEBMOB_common_service_center, msg, $scope.translation.WEBMOB_common_cancel_capital, $scope.translation.WEBMOB_common_ok);
                    }
                }
                break;            
            case "indoorHumidity":
                // For 17K Model, Humidity 0 means OFF state
                if (is17KModel() && $scope.Device.Humidity.current === 0) {
                    if (!isNonAirPurifierModel()) { // If it doesn't support air purity, don't request for air monitoring
                        $scope.checkResponse.push(FACCONST.AIR_MONITORING);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, getAirMonitoringCommand(false), "/" + $scope.peerId + "/devices/0");
                    }
                } else {
                    $scope.indoorHumidityPopup = true;
                    toggleBottomPopUpClass(true);
                }                
                break;
            default:
                //Do nothing
                break;
        }
    }
    
    function showDialog(state, title, message,cancelBtn, okBtn) {
        debugMessage("showDialog", title);
        dismissAllPopups();
        $scope.alertState = state;        
        $scope.popupTitle = title;
        $scope.popupMessage = message;
        $scope.popupOkBtn = okBtn;
        $scope.popupCancelBtn = cancelBtn;
        $scope.dialogPopup = true;
        toggleBottomPopUpClass(true);
    }
    
    function popupBtnClicked(state) {
        debugMessage("popupBtnClick >>> State >>> " +state);
        if (state === 1) { //OK Click
            switch ($scope.alertState) {
                case ALERT_STATE.SERVICE_CENTER_SELECTION:
                    if ($scope.supportCalling) {
                        serviceCallCommand($scope.radioBtnToSelect[$scope.radioBtnSelectedIndex]);
                    }
                    break;
                 case ALERT_STATE.SERVICE_CALL:
                    if ($scope.supportCalling) {
                        serviceCallCommand($scope.radioBtnToSelect[0]);
                    }
                    break;
                default:
                    break;
            }
        } else if (state === 2) { //Cancel Click
            switch ($scope.alertState) {
                case ALERT_STATE.SERVICE_CENTER_SELECTION:
                    debugMessage("User canceled service center selection popup");
                    break;
                case ALERT_STATE.SERVICE_CALL:
                    debugMessage("User canceled service call popup");
                    break;    
                default:
                    break;
            }
        } else {
            //nothing
        }
        
        $scope.dialogPopup = false;
        $scope.alertState = -1;
        $scope.isRadioSelection = false;
        $scope.showServiceCenterText = false;
        $scope.indoorHumidityPopup = false;
        toggleBottomPopUpClass(false);
    }
    
    function onRadioBtnSelected (selectedIndex) {
        debugMessage("selected index is " + selectedIndex);
        $scope.radioBtnSelectedIndex = selectedIndex;
    }   
    
    // In-App panel starts here
    function getFilterStatusVisibility() {
        if ($scope.isFilterStatusShow && $scope.homePage) {
            return true;
        }
        return false;
    }
    function filterNotificationCheck(alarms) {
        alarms.forEach(function (value) {
            if (value.code === "FilterAlarm") {
                if (event === 'deleted') {
                    // To dismiss in-app panel popup notification on home page
                    $scope.isFilterStatusShow = false;
                } else {
                    // To display in-app panel popup notification on home page
                    $scope.isFilterStatusShow = true;
                    $scope.inAppPanelPopupText = $scope.translation.WEBMOB_device_fac_filteralarm;
                }
            }
        });
    }
    function filterNotificationClose() {
        $scope.isFilterStatusShow = false;
    }

    function isShow_aiConnectionFailPanel() {
        return ($scope.is_aiConnectionFail && $scope.aiConnectionFailTimerOn && $scope.homePage);
    }
    // In-App panel ends here
    
    function getHumidityText(value) {
        var text = '';
        if (value >= 30 && value <= 90) {
            text = value + '%';
        } else if (value < 30) {
            text = $scope.translation.WEBMOB_device_fac_humidity_under_30;
        } else if (value > 90) {
            text = $scope.translation.WEBMOB_device_fac_humidity_over_90;
        }
        return text;
    }
    
    function onKeypadShown(boolean) {
        if (!boolean && !$scope.isAppleDevice && $scope.inputFocusHoursMin) {
            document.activeElement.blur();
            $scope.inputFocusHoursMin = false;
        }
    }
    
    // Show help screen on launch for the first time
    function checkForFUG() {        
        if (getLocalStorageData('FacFUGLaunch') === null && !noRegionSelected) {
            showUsageHelpPage();
            setLocalStorageData('FacFUGLaunch', true);
        }
    }
    
    // Meter date setting popup starts here
    function showMeterDateSettingPopup() {
        $scope.tempMeterDate = $scope.currentMeterDate;
        $scope.showMeterDatePopup = true;
        toggleBottomPopUpClass($scope.showMeterDatePopup);        
    }
    function increaseMeterDate(bool) {
        if (bool) { // increase
            if ($scope.tempMeterDate < lastDayOfMonth) {
                $scope.tempMeterDate++;
            } else {
                $scope.tempMeterDate = 1;
            }
        } else { // decrease
            if ($scope.tempMeterDate > 1) {
                $scope.tempMeterDate--;
            } else {
                $scope.tempMeterDate = lastDayOfMonth;
            }
        }
    }
    function onMeterDateUpdate(bool) {
        $scope.showMeterDatePopup = false;
        toggleBottomPopUpClass($scope.showMeterDatePopup);
        if (bool) { // Yes
            if (!$scope.isStatic) {
                if ($scope.currentMeterDate !== $scope.tempMeterDate) {
                    $scope.currentMeterDate = $scope.tempMeterDate;
                    isMonthAlreadyClicked = false;
                    $scope.showMonthlyData();
                }
            } else {
                $scope.currentMeterDate = $scope.tempMeterDate;
            }
            setLocalStorageData('meterDate#' + $scope.deviceUuid, $scope.currentMeterDate);
        }
    }
    function increaseMeterDateContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                increaseMeterDate(true);
            }, 200);
        }
    }

    function decreaseMeterDateContinuously() {
        if (!!!promise) {            
            promise = $interval(function () {
                increaseMeterDate(false);
            }, 200);
        }
    }
    function getMeterDateText() {
        var temp;
        var today = new Date();
        var tempLastDayOfMonth = new Date(today.getFullYear(), today.getMonth(), 0).getDate();
        var tempDate =  $scope.currentMeterDate > tempLastDayOfMonth ? tempLastDayOfMonth : $scope.currentMeterDate;
        if ($scope.currentMeterDate <= new Date().getDate()) {
            temp = ordinal_suffix_of(tempDate) + $scope.translation.WEBMOB_fac_options_energy_until_today;
        } else {
            temp = $scope.translation.WEBMOB_fac_options_energy_last_month + ordinal_suffix_of(tempDate) + $scope.translation.WEBMOB_fac_options_energy_until_today;
        }
        return temp;
    }
    
    function ordinal_suffix_of(i) {
        if (LANG.toUpperCase().substring(0,2) === "KO") {
            return i + $scope.translation.WEBMOB_common_energy_monitor_day;
        } else {
            var j = i % 10,
                k = i % 100;
            if (j === 1 && k !== 11) {
                return i + "st";
            }
            if (j === 2 && k !== 12) {
                return i + "nd";
            }
            if (j === 3 && k !== 13) {
                return i + "rd";
            }
            return i + "th";
        }
    }

    function isAIStatusOn(){
        return $scope.aiActive === FACCONST.AIWORKSTATUS_ON;
    }

    function isAIStatusIng(){
        return $scope.aiActive === FACCONST.AIWORKSTATUS_ING;
    }

    function isAIStatusOff(){
        return $scope.aiActive === FACCONST.AIWORKSTATUS_OFF;
    }
    
    function getAIGuideText(){
       var tempAIString = $scope.translation.WEBMOB_common_ai_status_text_on.replace('00', $scope.aiFavorTemp);
       return (isAIStatusIng())? $scope.translation.WEBMOB_common_ai_status_text_ing:(isAIStatusOn())?tempAIString:'';
    }
    
    function isAICoolLearningEnable(){
        return ($scope.powerOperation && (($scope.currentMode === 'Auto') || $scope.sleep));
        //return $scope.powerOperation;
        //return true;
    }
    // Meter date setting popup ends here
});

app.directive('weatherListItemLoaded', function ($timeout) {
    return {        
        restrict: 'A',
        link: function (scope, element) {      
            $(element).hide();
            $timeout(function(){
                 $(element).show();
                $(element).addClass('force-render-region-list');
            }, 300);
        }
    };
});
