/* 
 * Range.js
 * 
 * Copyright ( c ) 2015 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung.
 *
 * Created on : Fri Jul 24 00:06:30 KST 2015
 * Owner      : SRI
 * Author     : namit.bansal@samsung.com
 */

var app = angular.module("SmartThings", ['toaster', 'ngSanitize', 'ui.router']);

app.config(['$stateProvider', function ($stateProvider) {
        var ReadyPage = {
            name: 'ReadyPage',
            url: '/',
            templateUrl: 'RANGE/views/ReadyScreen.html'
        },
        functionList = {
            name: 'functionList',
            url: '/functionList',
            parent: ReadyPage,
            templateUrl: 'ReadyScreen.functionList.html'
        },
        ProgressPage = {
            name: 'ProgressPage',
            url: '/',
            templateUrl: 'RANGE/views/ProgressScreen.html'
        },
        CookTopPage = {
            name: 'CookTopPage',
            url: '/',
            templateUrl: 'RANGE/views/CookTopScreen.html'
        },
        SendConfirmationPage = {
            name: 'SendConfirmationPage',
            url: '/',
            templateUrl: 'RANGE/views/SendConfirmationScreen.html'
        },
        CleaningPage = {
            name: 'CleaningPage',
            url: '/',
            templateUrl: 'RANGE/views/CleaningScreen.html'
        },
        ErrorPage = {
            name: 'ErrorPage',
            url: '/',
            templateUrl: 'RANGE/views/ErrorScreen.html'
        },
        AutoCookPage = {
            name: 'AutoCookPage',
            url: '/',
            templateUrl: 'RANGE/views/AutocookScreen.html'
        },
        AutoCookDetailPage = {
            name: 'AutoCookDetailPage',
            url: '/',
            templateUrl: 'RANGE/views/AutocookDetailScreen.html'
        },
        EditMyCookingPage = {
            name: 'EditMyCookingPage',
            url: '/',
            templateUrl: 'RANGE/views/EditMyCookingScreen.html'
        },
        AddMyCookingPage = {
            name: 'AddMyCookingPage',
            url: '/',
            templateUrl: 'RANGE/views/AddMyCookingScreen.html'
        },
        MainLoadingPage = {
            name: 'MainLoadingPage',
            url: '/',
            templateUrl: 'common/views/splash.html'
        },
        SettingPage = {
            name: 'SettingPage',
            url: '/',
            templateUrl: 'RANGE/views/SettingScreen.html'
        },
        SettingTempAdjustPage = {
            name: 'SettingTempAdjustPage',
            url: '/',
            templateUrl: 'RANGE/views/SettingTempAdjustScreen.html'
        },
        SettingTempUnitPage = {
            name: 'SettingTempUnitPage',
            url: '/',
            templateUrl: 'RANGE/views/SettingTempUnitScreen.html'
        },
        OperationCompletePage = {
            name: 'OperationCompletePage',
            url: '/',
            templateUrl: 'RANGE/views/OperationCompleteScreen.html'
        },
        SmartCarePage = {
            name: 'SmartCarePage',
            url: '/',
            templateUrl: 'RANGE/views/SmartCareScreen.html'
        },
        SmartCareNoErrorPage = {
            name: 'SmartCareNoErrorPage',
            url: '/',
            templateUrl: 'RANGE/views/SmartCareNoErrorScreen.html'
        },
        ProbeDividerErrorPage = {
            name: 'ProbeDividerErrorPage',
            url: '/',
            templateUrl: 'RANGE/views/ProbeDividerErrorScreen.html'
        },
        AboutPage = {
            name: 'AboutPage',
            url: '/',
            templateUrl: 'RANGE/views/AboutScreen.html'
        };

        $stateProvider.state(MainLoadingPage);
        $stateProvider.state(ReadyPage);
        $stateProvider.state(CookTopPage);
        $stateProvider.state(functionList);
        $stateProvider.state(SendConfirmationPage);
        $stateProvider.state(ProgressPage);
        $stateProvider.state(AutoCookPage);
        $stateProvider.state(EditMyCookingPage);
        $stateProvider.state(AddMyCookingPage);
        $stateProvider.state(AutoCookDetailPage);
        $stateProvider.state(CleaningPage);
        $stateProvider.state(ErrorPage);
        $stateProvider.state(SettingPage);
        $stateProvider.state(SettingTempAdjustPage);
        $stateProvider.state(SettingTempUnitPage);
        $stateProvider.state(OperationCompletePage);
        $stateProvider.state(SmartCarePage);
        $stateProvider.state(SmartCareNoErrorPage);
        $stateProvider.state(ProbeDividerErrorPage);
        $stateProvider.state(AboutPage);
    }]);

app.run(['$state', function ($state) {
        $state.transitionTo('MainLoadingPage');
    }]);

app.controller("rangeAppController", function ($scope, $state, SHPService, toaster, $timeout, DBService, $interval) {

    var DBFilePath = "RANGE/assets/db/smartoven_recipe_us.db", db, showCookTop = false, EditMode = 'UPPER', errorRemoved = true, changeSmartCarePage = false, configCall = false,
            deviceMode = 'Bake', deviceAMCMode = 'Bake', doNotChangeScreen = false, justFirstTime = true, countterU = 1, countterL = 1, Debug_tag = 'RA : ',
            langArr = Object.keys(LANGUAGE_FILE.language), readyToDelete = false, recipeDataValidated = true, snoozUpper = false, IDforCancelCooking = 0, AMCInfo,
            deviceSingleMode = 'Bake', deviceUpperMode = 'UpperConvectionBake', deviceLowerMode = 'LowerBake', changeUpperRecipe = true, changeLowerRecipe = true,
            myRecipeID = 0, myCookingModeTrue = false, snoozLower = false, OperationScreen = false, cancelUpper = false, cancelLower = false, changSingleRecipe = true,
            userPreferneceSingleUpper = {}, userPreferneceDualLower = {}, userPreferneceSingleSinlge = {}, promise, autoCallTime = 20000, editModeTimeUpdate = false,
            setDefaultModeSingle = false, setDefaultModeUpper = false, setDefaultModeLower = false, loadProgress = true,
            scroll_middle_area = document.getElementById("scrollable_area_others");
    if (langArr.indexOf(LANG.toUpperCase()) !== -1) {
        $scope.translation = LANGUAGE_FILE["language"][LANG.toUpperCase()];
    } else if (langArr.indexOf(LANG.toUpperCase().substring(0, 2)) !== -1) {
        $scope.translation = LANGUAGE_FILE["language"][LANG.toUpperCase().substring(0, 2)];
    } else {
        $scope.translation = LANGUAGE_FILE["language"]["DEFAULT"];
    }

    loadVariables();

    function isTextInput(node) {
        return ['INPUT', 'TEXTAREA'].indexOf(node.nodeName) !== -1;
    }

    document.addEventListener('touchstart', function (e) {
        if (!isTextInput(e.target) && isTextInput(document.activeElement)) {
            document.activeElement.blur();
            e.preventDefault();
            e.stopPropagation();
        }
    }, false);

    function loadVariables() {
        $scope.isStatic = false;
        $scope.isAppV2 = false;
        $scope.alertOn = false;
        $scope.autoCall = true;
        $scope.editMode = false;
        $scope.DoorOpen = false;
        $scope.langCheck = false;
        $scope.loadingBar = false;
        $scope.bFahrenheit = true;
        $scope.modeSupport = false;
        $scope.parseConfig = false;
        $scope.upperPreheat = false;
        $scope.lowerPreheat = false;
        $scope.UpperMoniter = false;
        $scope.warmingCenter = true;
        $scope.showSmartCare = false;
        $scope.focuseRemoved = false;
        $scope.refreshButton = false;
        $scope.bStandByMoniter = true;
        $scope.RunningUpperOven = true;
        $scope.appAtForeground = false;
        $scope.dividerConnected = false;
        $scope.RunningLowerOven = false;
        $scope.headerBarVisible = false;
        $scope.bCookingFinished = false;
        $scope.AMCFnMenuVisible = false;
        $scope.isFrenchLanguage = false;
        $scope.showRenameOption = false;
        $scope.inputDialogPopUp = false;
        $scope.mainLoadingScreen = false;
        $scope.bCookingCancelled = false;
        $scope.bCleaningFinished = false;
        $scope.TabsVisibleAtPage = false;
        $scope.isSpanishLanguage = false;
        $scope.meatProbeConnected = false;
        $scope.bCleaningCancelled = false;
        $scope.AboutOptionVisible = false;
        $scope.ProgressPreheatMode = true;
        $scope.setTimenTempClicked = false;
        $scope.showFullScreenPopup = false;
        $scope.remoteControlEnabled = false;
        $scope.SettingOptionVisible = false;
        $scope.nextPageAutoCookDetail = true;
        $scope.operationCompleteUpper = false;
        $scope.operationCompleteLower = false;
        $scope.bProgressCompletdNormal = false;
        $scope.ProgressPreheatModeUpper = true;
        $scope.ProgressPreheatModeLower = true;
        $scope.rangeFunctionMenuExpandList = false;
        $scope.sendConfermationApplyButton = false;
        $scope.renamedRecipe = null;
        $scope.msgText = '';
        $scope.TempUnit = 'F';
        $scope.cookTopType = '1';
        $scope.BroilTemp = "High";
        $scope.errorCode = "E-83";
        $scope.deviceName = "";
        $scope.SingleOvenState = '';
        $scope.SlowCookTemp = 'High';
        $scope.screenState = 'Ready';
        $scope.desiredAMCTemp = '500';
        $scope.equipment = "Equipment";
        $scope.screenStateUpper = 'Ready';
        $scope.screenStateLower = 'Ready';
        $scope.ovenAutoCookRecipeID = '0';
        $scope.operationStateState = 'Ready';
        $scope.ModeSelectionPopupDivCls = '';
        $scope.DeviceModelName = 'NX9000KW/AA0';
        $scope.mainIngredients = 'Main ingredients';
        $scope.low = 'WEBMOB_device_range_comm_low_CL';
        $scope.validateSendRecipeInfoOperationHrs = '0';
        $scope.cookTopValues = ['1', '1', '0', '1', '1'];
        $scope.high = 'WEBMOB_device_range_comm_high_CL';
        $scope.validateSendRecipeInfoDesiredTemp = '350';
        $scope.Start = 'WEBMOB_device_range_comm_start_CL';
        $scope.validateSendRecipeInfoOperationMints = '30';
        $scope.validateSendRecipeInfoDesiredProbeTemp = '150';
        $scope.ImageUrl = "RANGE/assets/img/main_rg_btn_ic_start.png";
        $scope.currentMode = 'WEBMOB_device_range_oven_function_bake';
        $scope.desiredAMCMode = 'WEBMOB_device_range_oven_function_bake';
        $scope.RangeSendText = 'WEBMOB_device_range_comm_send_to_oven_CL';
        $scope.oneMinutesRemainText = 'WEBMOB_device_range_cuisine_ready';
        $scope.currentModeLower = 'WEBMOB_device_range_oven_function_bake';
        $scope.ProgressDescription = "WEBMOB_device_range_cooking_in_progress";
        $scope.recipeDescription = 'WEBMOB_device_range_oven_function_bake_desc';
        $scope.editMyCookingText = 'WEBMOB_device_range_mycooking_edit_mycooking';
        $scope.autocookDetailScreenTrayImage = 'RANGE/assets/img/main_rg_img_tray_02.png';
        $scope.currentModeUpper = 'WEBMOB_device_range_oven_function_convection_bake';
        $scope.desiredEditProgressDescription = "WEBMOB_device_range_cooking_in_progress";
        $scope.desiredEditcurrentMode = 'WEBMOB_device_range_oven_function_convection_bake';
        $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cooking_finish_message";
        $scope.validateSendRecipeInfoMode = 'WEBMOB_device_range_oven_function_convection_bake';
        $scope.recipeDescriptionUpper = 'WEBMOB_device_range_oven_function_convection_bake_desc';
        $scope.recipeDescriptionLower = 'WEBMOB_device_range_oven_function_convection_bake_desc';
        $scope.autocookDetailScreenImage = 'RANGE/assets/img/main_rg_foodimg_roasting_chicken_thighs.png';
        $scope.currentScreen = RANGESCREENS.RANGE_MAIN_LOADING_PAGE;
        $scope.parseNotiLength = 0;
        $scope.minTemp = 175;
        $scope.maxTemp = 550;
        $scope.AdjustTemp = 0;
        $scope.desiredAMCHr = 1;
        $scope.desiredHours = 0;
        $scope.TempIncrement = 1;
        $scope.desiredTemp = 350;
        $scope.currentTemp = 0;
        $scope.minProbeTemp = 100;
        $scope.maxProbeTemp = 200;
        $scope.desiredAMCMin = 30;
        $scope.maxAdjustTemp = 35;
        $scope.desiredMinutes = 30;
        $scope.minAdjustTemp = -35;
        $scope.desiredEditTemp = 350;
        $scope.desiredEditHours = 0;
        $scope.TempIncrementProbe = 1;
        $scope.currentProbeTemp = 100;
        $scope.desiredProbeTemp = 150;
        $scope.desiredEditMinutes = 30;
        $scope.desiredEditProbeTemp = 150;
        $scope.RangeMainPageCurrentTab = 0;
        $scope.rangeCurrentMenuSelected = 0;
        $scope.desiredEditSlowCookTemp = 61441;
        $scope.selectedOpenedMenuHeaderIndex = -1;
        $scope.rangeUpperMoniterVisibleHeight = 445;
        $scope.checkResponse = [];
        $scope.menuIconImageCls = [];
        $scope.CookTopBurnerStatus = [];
        $scope.editMyCookingListItems = [];
        $scope.myCookingSelectedListItems = [];
        $scope.editMyCookingSelectedListItems = [];
        $scope.editMyCookingSelectedDeleteItems = [];

        $scope.singleReadySendButton = false;

        /* scope Methods */
        $scope.onBackPressedEvent = onBackPressedEvent;
        $scope.onBackPressed = onBackPressed;
        $scope.goToAbout = goToAbout;
        $scope.goToSettings = goToSettings;
        $scope.closeApp = closeApp;
        $scope.openPopoverMode = openPopoverMode;
        $scope.openAMCMenu = openAMCMenu;
        $scope.selectedTabPageTab = selectedTabPageTab;
        $scope.RangeTabClick = RangeTabClick;
        $scope.slowCookTempValue = slowCookTempValue;
        $scope.slowCookEditTempValue = slowCookEditTempValue;
        $scope.handleStatusCode = handleStatusCode;
        $scope.sendButtonClicked = sendButtonClicked;
        $scope.increaseRangeTemp = increaseRangeTemp;
        $scope.decreaseRangeTemp = decreaseRangeTemp;
        $scope.increaseProbeTemp = increaseProbeTemp;
        $scope.decreaseProbeTemp = decreaseProbeTemp;
        $scope.increaseRangeHour = increaseRangeHour;
        $scope.decreaseRangeHour = decreaseRangeHour;
        $scope.increaseRangeMinute = increaseRangeMinute;
        $scope.decreaseRangeMinute = decreaseRangeMinute;
        $scope.increaseRangeAMCTemp = increaseRangeAMCTemp;
        $scope.decreaseRangeAMCTemp = decreaseRangeAMCTemp;
        $scope.increaseRangeAMCHour = increaseRangeAMCHour;
        $scope.decreaseRangeAMCHour = decreaseRangeAMCHour;
        $scope.increaseRangeAMCMinute = increaseRangeAMCMinute;
        $scope.decreaseRangeAMCMinute = decreaseRangeAMCMinute;
        $scope.increaseRangeEditTemp = increaseRangeEditTemp;
        $scope.decreaseRangeEditTemp = decreaseRangeEditTemp;
        $scope.increaseProbeEditTemp = increaseProbeEditTemp;
        $scope.decreaseProbeEditTemp = decreaseProbeEditTemp;
        $scope.increaseRangeEditHour = increaseRangeEditHour;
        $scope.decreaseRangeEditHour = decreaseRangeEditHour;
        $scope.increaseRangeEditMinute = increaseRangeEditMinute;
        $scope.decreaseRangeEditMinute = decreaseRangeEditMinute;
        $scope.increaseAdjustSettingTemp = increaseAdjustSettingTemp;
        $scope.decreaseAdjustSettingTemp = decreaseAdjustSettingTemp;

        $scope.increaseDesiredHours = increaseDesiredHours;
        $scope.decreaseDesiredHours = decreaseDesiredHours;
        $scope.increaseDesiredMinutes = increaseDesiredMinutes;
        $scope.decreaseDesiredMinutes = decreaseDesiredMinutes;

        $scope.doValidationForTemp = doValidationForTemp;
        $scope.doValidationForHour = doValidationForHour;
        $scope.doValidationForMinute = doValidationForMinute;
        $scope.doValidationForProbeTemp = doValidationForProbeTemp;
        $scope.doValidationForAMCTemp = doValidationForAMCTemp;
        $scope.doValidationForAMCHour = doValidationForAMCHour;
        $scope.doValidationForAMCMinute = doValidationForAMCMinute;
        $scope.doValidationForEditTemp = doValidationForEditTemp;
        $scope.doValidationForEditHour = doValidationForEditHour;
        $scope.doValidationForEditMinute = doValidationForEditMinute;
        $scope.doValidationForEditProbeTemp = doValidationForEditProbeTemp;

        $scope.inputKeyDown = inputKeyDown;
        $scope.stopLongPressEvent = stopLongPressEvent;

        $scope.increaseTemp = increaseTemp;
        $scope.decreaseTemp = decreaseTemp;
        $scope.increaseTempContinuously = increaseTempContinuously;
        $scope.decreaseTempContinuously = decreaseTempContinuously;
        $scope.increaseEditTempContinuously = increaseEditTempContinuously;
        $scope.decreaseEditTempContinuously = decreaseEditTempContinuously;
        $scope.increaseEditProbeTempContinuously = increaseEditProbeTempContinuously;
        $scope.decreaseEditProbeTempContinuously = decreaseEditProbeTempContinuously;
        $scope.increaseEditHoursContinuously = increaseEditHoursContinuously;
        $scope.decreaseEditHoursContinuously = decreaseEditHoursContinuously;
        $scope.increaseEditMinutesContinuously = increaseEditMinutesContinuously;
        $scope.decreaseEditMinutesContinuously = decreaseEditMinutesContinuously;
        $scope.increaseDesiredHoursContinuously = increaseDesiredHoursContinuously;
        $scope.decreaseDesiredHoursContinuously = decreaseDesiredHoursContinuously;
        $scope.increaseMeatprobeTempContinuously = increaseMeatprobeTempContinuously;
        $scope.decreaseMeatprobeTempContinuously = decreaseMeatprobeTempContinuously;
        $scope.increaseDesiredMinutesContinuously = increaseDesiredMinutesContinuously;
        $scope.decreaseDesiredMinutesContinuously = decreaseDesiredMinutesContinuously;
        $scope.increaseTempAMCContinuously = increaseTempAMCContinuously;
        $scope.decreaseTempAMCContinuously = decreaseTempAMCContinuously;
        $scope.increaseAMCHoursContinuously = increaseAMCHoursContinuously;
        $scope.decreaseAMCHoursContinuously = decreaseAMCHoursContinuously;
        $scope.increaseAMCMinutesContinuously = increaseAMCMinutesContinuously;
        $scope.decreaseAMCMinutesContinuously = decreaseAMCMinutesContinuously;

        $scope.increaseAdjustSettingTempContinuously = increaseAdjustSettingTempContinuously;
        $scope.decreaseAdjustSettingTempContinuously = decreaseAdjustSettingTempContinuously;

        $scope.selectedCookOptions = selectedCookOptions;
        $scope.onClickCookingOptionsFromMenu = onClickCookingOptionsFromMenu;
        $scope.expandListItemClickHandler = expandListItemClickHandler;
        $scope.onAlertButton1Click = onAlertButton1Click;
        $scope.onAlertButton2Click = onAlertButton2Click;
        $scope.onCancelProgress = onCancelProgress;
        $scope.onAboutAction = onAboutAction;
        $scope.hideOptionMenu = hideOptionMenu;
        $scope.parseStaticData = parseStaticData;
        $scope.parseDeviceData = parseDeviceData;
        $scope.parseConfiguration = parseConfiguration;
        $scope.parseNotificationData = parseNotificationData;
        $scope.parseNotification = parseNotification;
        $scope.callGetDevice = callGetDevice;
        $scope.parseRequestAccepted = parseRequestAccepted;
        $scope.parseRequestResponse = parseRequestResponse;
        $scope.parseModuleInformation = parseModuleInformation;
        $scope.requestFailHandler = requestFailHandler;
        $scope.init = init;
        $scope.isDelay = isDelay;
        $scope.isZeroTemp = isZeroTemp;
        $scope.isNegativeTemp = isNegativeTemp;
        $scope.upperMoniterClick = upperMoniterClick;
        $scope.lowerMoniterClick = lowerMoniterClick;
        $scope.showConnectionFailurePopup = showConnectionFailurePopup;
        $scope.closeConnectionFailurePopup = closeConnectionFailurePopup;
        $scope.onSettingsToggleUpdate = onSettingsToggleUpdate;
        $scope.showAutoCookDetailsScreen = showAutoCookDetailsScreen;
        $scope.changeTempUnit = changeTempUnit;
        $scope.sendButtonClickedFromAutoCookDetailPage = sendButtonClickedFromAutoCookDetailPage;
        $scope.autoCookRangeIcon = autoCookRangeIcon;
        $scope.rangeModelMenu = rangeModelMenu;
        $scope.updateDeviceData = updateDeviceData;
        $scope.autoGetDeviceCall = autoGetDeviceCall;
        $scope.refreshGetDevice = refreshGetDevice;
        $scope.autoCookNextPage = autoCookNextPage;
        $scope.autoCookPreviousPage = autoCookPreviousPage;
        $scope.okOperationComplete = okOperationComplete;
        $scope.operationComplete = operationComplete;
        $scope.okOperationCompleteUpper = okOperationCompleteUpper;
        $scope.okOperationCompleteLower = okOperationCompleteLower;
        $scope.okOperationCompleteDual = okOperationCompleteDual;
        $scope.addToMyCooking = addToMyCooking;
        $scope.onClickModeOptionAMC = onClickModeOptionAMC;
        $scope.saveButtonClickedFromAMCState = saveButtonClickedFromAMCState;
        $scope.editMyCookingItemClick = editMyCookingItemClick;
        $scope.deleteMyCookings = deleteMyCookings;
        $scope.isSelectedToDelete = isSelectedToDelete;
        $scope.sendMoniterClicked = sendMoniterClicked;
        $scope.sendAdjustTemp = sendAdjustTemp;
        $scope.editRunningMode = editRunningMode;
        $scope.cancleEditMode = cancleEditMode;
        $scope.applyEditMode = applyEditMode;
        $scope.startConfirmationOK = startConfirmationOK;
        $scope.startConfirmationCancel = startConfirmationCancel;
        $scope.onRenameClick = onRenameClick;
        $scope.TopMarginForList = TopMarginForList;
        $scope.versionTouchStart = versionTouchStart;
        $scope.versionTouchEnd = versionTouchEnd;
        $scope.listUpDownIconId = listUpDownIconId;
        $scope.smartcareerrorcheck = smartcareerrorcheck;
        $scope.doOnServiceCallPopup = doOnServiceCallPopup;
        $scope.noScroll = noScroll;
        $scope.showDummyInbox = showDummyInbox;
        $scope.hideDummyInbox = hideDummyInbox;


        $scope.RangeMenuListItems = [{
                id: 1,
                title: 'WEBMOB_device_range_oven_function'
            }, {
                id: 2,
                title: 'WEBMOB_device_range_my_cooking'
            }, {
                id: 3,
                title: 'WEBMOB_device_range_healthy_cook'
            }, {
                id: 4,
                title: 'WEBMOB_device_range_easy_cook'
            }, {
                id: 5,
                title: 'WEBMOB_device_range_auto_cook'
            }];
        $scope.RangeCookTopBurnerStatus = [{
                id: 1,
                title: 'left front burner is on'
            }, {
                id: 2,
                title: 'left rear burner is on'
            }, {
                id: 3,
                title: 'warming center is on'
            }, {
                id: 4,
                title: 'right rear burner is on'
            }, {
                id: 5,
                title: 'right front burner is on'
            }];
        $scope.AutoCook = [{
                id: 0,
                rackPositon: 3,
                yield: $scope.translation.WEBMOB_device_range_auto_cook_roasting_chicken_yield,
                cookingTime: '40mins',
                mainIngrediant: $scope.translation.WEBMOB_device_range_auto_cook_roasting_chicken_main_ingredient,
                equipment: $scope.translation.WEBMOB_device_range_auto_cook_equip_baking_pan,
                wireRackDesc: $scope.translation.WEBMOB_device_range_auto_cook_roast_chicken_desc_wire,
                image: 'RANGE/assets/img/main_rg_foodimg_roasting_chicken_thighs.png'
            }, {
                id: 1,
                rackPositon: 2,
                yield: $scope.translation.WEBMOB_device_range_auto_cook_roasting_beef_yield,
                cookingTime: '1hr 10mins',
                mainIngrediant: $scope.translation.WEBMOB_device_range_auto_cook_roasting_beef_main_ingredient,
                equipment: $scope.translation.WEBMOB_device_range_auto_cook_equip_roasting_pan_and_rack,
                wireRackDesc: $scope.translation.WEBMOB_device_range_auto_cook_roast_beef_desc_wire,
                image: 'RANGE/assets/img/main_rg_foodimg_roasting_beef.png'
            }, {
                id: 2,
                rackPositon: 3,
                yield: $scope.translation.WEBMOB_device_range_auto_cook_banana_nut_bread_yield,
                cookingTime: '60mins',
                mainIngrediant: $scope.translation.WEBMOB_device_range_auto_cook_banana_nut_bread_main_ingredient,
                equipment: $scope.translation.WEBMOB_device_range_auto_cook_equip_2_loaf_pans,
                wireRackDesc: $scope.translation.WEBMOB_device_range_auto_cook_banana_nut_bread_desc_wire,
                image: 'RANGE/assets/img/main_rg_foodimg_banana_nut_bread.png'
            }, {
                id: 3,
                rackPositon: 3,
                yield: $scope.translation.WEBMOB_device_range_auto_cook_lasagna_yield,
                cookingTime: '35mins',
                mainIngrediant: $scope.translation.WEBMOB_device_range_auto_cook_lasagna_main_ingredient,
                equipment: $scope.translation.WEBMOB_device_range_auto_cook_equip_glass_baking_dish,
                wireRackDesc: $scope.translation.WEBMOB_device_range_auto_cook_lasagna_desc_wire,
                image: 'RANGE/assets/img/main_rg_foodimg_lasagna.png'
            }, {
                id: 4,
                rackPositon: 3,
                yield: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_yield,
                cookingTime: '50mins',
                mainIngrediant: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_main_ingredient,
                equipment: $scope.translation.WEBMOB_device_range_auto_cook_equip_2_deep_dish_pizza_pans,
                wireRackDesc: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_desc_wire,
                image: 'RANGE/assets/img/main_rg_foodimg_chicago_pizza.png'
            }];
    }

    function init() {
        debugMessage("init");
        $scope.deviceSingleUpperInfo = {
            description: "TP6X_OV_16K",
            id: "0",
            Alarms: [{
                    id: "0",
                    alarmType: "Device",
                    code: "O",
                    triggeredTime: "2015-11-18T11:03:25"
                }],
            ConfigurationLink: {
                href: "/devices/0/configuration"
            },
            Diagnosis: {
                diagnosisStart: "Ready"
            },
            EnergyConsumption: {
                saveLocation: "/files/usage.db"
            },
            InformationLink: {
                href: "/devices/0/information"
            },
            Mode: {
                modes: ["UpperConvectionBake"],
                options: [{
                        Sabbath: "Off",
                        DeviceType: "NX9006M-/AA0",
                        Sound: "Off",
                        RecipeConversion: "Off",
                        EnergySaving: "On",
                        WarmingCenter: "Off",
                        WarmingDrawer: "Off",
                        Cooktop: "0",
                        VirtualFlame: "254",
                        AdjustingTemp: "0",
                        SettingPossible: "7",
                        TimeSyncSupported : '',
                        meatprobe: "disconnected"
                    }],
                supportedModes: ["ConvectionBake,ConvectionRoast,Bake,Broil,Healthycook1,Healthycook2,Healthycook3,Healthycook4,Healthycook5,Healthycook6,KeepWarm,SteamClean,SelfClean,NULL,UpperConvectionBake,UpperConvectionRoast,UpperBroil,UpperHealthycook1,UpperHealthycook2,UpperHealthycook3,UpperHealthycook4,UpperHealthycook5,ConvectionBake,Autocook,Healthycook1,Healthycook2,Healthycook3,Healthycook4,Healthycook5"]
            },
            Operation: {
                operationTime: "00:00:00",
                remainingTime: "00:00:00",
                state: "Ready",
                power: "On",
                progressPercentage: 1,
                kidsLock: "Ready"
            },
            Oven: {
                CustomRecipesLink: {
                    href: "/devices/0/oven/customrecipes"
                },
                recipe: "0",
                state: "Ready"
            },
            connected: false,
            name: "NX9000K",
            resources: ["Alarms",
                "Configuration",
                "Diagnosis",
                "Doors",
                "Information",
                "Mode",
                "Operation",
                "Oven",
                "Temperatures"],
            type: "Oven",
            uuid: "F8042E7A-BCDB-0000-0000-000000000000",
            Temperatures: [{
                    id: "0",
                    current: 0,
                    desired: 0,
                    maximum: 0,
                    minimum: 0,
                    unit: "Fahrenheit"
                },
                {
                    id: "1",
                    current: 0,
                    desired: 0,
                    maximum: 0,
                    minimum: 0,
                    unit: "Fahrenheit"
                }],
            Doors: [{
                    id: "0",
                    openState: "Close"
                }]
        };
        $scope.deviceDualLowerInfo = {
            description: "TP6X_OV_16K",
            id: "1",
            Alarms: [{
                    id: "0",
                    alarmType: "Device",
                    code: "O",
                    triggeredTime: "2015-09-14T03:07:03"
                }],
            ConfigurationLink: {
                href: "/devices/1/configuration"
            },
            Diagnosis: {
                diagnosisStart: "Ready"
            },
            InformationLink: {
                href: "/devices/1/information"
            },
            Mode: {
                modes: ["LowerConvectionBake"],
                options: [{
                        Sabbath: "Off",
                        DeviceType: "NE9000KW/AA0",
                        Sound: "On",
                        RecipeConversion: "Off",
                        EnergySaving: "On",
                        WarmingCenter: "Off",
                        WarmingDrawer: "Off",
                        Cooktop: "0",
                        VirtualFlame: "On",
                        AdjustingTemp: "0",
                        SettingPossible: "3",
                        meatprobe: "disconnected"
                    }],
                supportedModes: []
            },
            Operation: {
                operationTime: "00:20:00",
                remainingTime: "00:16:59",
                state: "Run",
                power: "On",
                progressPercentage: 18
            },
            Oven: {
                CustomRecipesLink: {
                    href: "/devices/1/oven/customrecipes"
                },
                recipe: "00000000000000",
                state: "Preheat"
            },
            connected: true,
            name: "NX9000K",
            resources: ["Alarms",
                "Configuration",
                "Diagnosis",
                "Doors",
                "Information",
                "Mode",
                "Operation",
                "Oven",
                "Temperatures"],
            type: "Oven",
            uuid: "F8042E7A-BCDB-0000-0000-000000000001",
            Temperatures: [{
                    id: "0",
                    current: 175,
                    desired: 350,
                    maximum: 480,
                    minimum: 175,
                    unit: "Fahrenheit"
                }],
            Doors: [{
                    id: "0",
                    openState: "Close"
                }]
        };

    }

    DBService.readDB(DBFilePath).then(function (data) {
        db = data;
        debugMessage("inside readDB. Data read = ", db);

        /*Set ready screen data*/
        $scope.ovenFunctionContentsSingle = db.exec("SELECT * FROM MODE_TABLE WHERE TYPE = 'BASIC' AND SINGLE = 'YES'");
        $scope.ovenFunctionContentsUpper = db.exec("SELECT * FROM MODE_TABLE WHERE TYPE = 'BASIC' AND UPPER = 'YES'");
        $scope.ovenFunctionContentsLower = db.exec("SELECT * FROM MODE_TABLE WHERE TYPE = 'BASIC' AND LOWER = 'YES'");
        $scope.healthyCookContentsSingle = db.exec("SELECT * FROM HEALTHY_COOK WHERE SINGLE = 'TRUE'");
        $scope.healthyCookContentsUpper = db.exec("SELECT * FROM HEALTHY_COOK WHERE UPPER = 'TRUE'");
        $scope.healthyCookContentsLower = db.exec("SELECT * FROM HEALTHY_COOK WHERE LOWER = 'TRUE'");
        $scope.easyCookContentsSingle = db.exec("SELECT * FROM EASY_COOK WHERE SINGLE = 'TRUE'");
        $scope.easyCookContentsUpper = db.exec("SELECT * FROM EASY_COOK WHERE UPPER = 'TRUE'");
        $scope.easyCookContentsLower = db.exec("SELECT * FROM EASY_COOK WHERE LOWER = 'TRUE'");
        $scope.readyStateContentsSingle = db.exec("SELECT * FROM MODE_TABLE WHERE MODE = 'Bake'");
        $scope.readyStateContentsDualUpper = db.exec("SELECT * FROM MODE_TABLE WHERE MODE = 'UpperConvectionBake'");
        $scope.readyStateContentsDualLower = db.exec("SELECT * FROM MODE_TABLE WHERE MODE = 'LowerBake'");
        $scope.ovenFunctionContents = $scope.ovenFunctionContentsSingle;
        $scope.healthyCookContents = $scope.healthyCookContentsSingle;
        $scope.easyCookContents = $scope.easyCookContentsSingle;

        $scope.autoCookContents = db.exec("SELECT * FROM AUTO_COOK");
        $scope.autoCookCategories = db.exec("SELECT DISTINCT MENU FROM AUTO_COOK");

        debugMessage('Current Mode  : ' + JSON.stringify($scope.ovenFunctionContents[0].values[0][13]));
        updateMyCookingList();
        getValueForSingleMode();
        getValueForDualUpperMode();
        getValueForDualLowerMode();
        var lan = LANG.toUpperCase().substring(0, 2);
        $scope.langCheck = lan === "ES" || lan === "FR";
        $scope.isFrenchLanguage = lan === "FR";
        $scope.isSpanishLanguage = lan === "ES";

        //clearLocalStorage(); //clear DB
        if (window.navigator.platform === 'iPhone' || window.navigator.platform === 'iPad') {
            $timeout(function () {
                disableDummyInbox();
            }, 500);
        }
        if ($scope.isStatic) {
            parseStaticData();
        }
    });

    function debugMessage(msg) {
        if (false) {
            console.log(Debug_tag + " : " + msg);
        }
    }

    function initializeScreen() {
        $scope.DeviceModelName = $scope.deviceSingleUpperInfo.Mode.options[0].DeviceType;
        debugMessage('DeviceModelName ' + ($scope.DeviceModelName));
        $scope.ElectricModel = $scope.DeviceModelName === 'NE9000KW/AA0' || $scope.DeviceModelName === 'NE9900H-/AA0' || $scope.DeviceModelName === 'NE6000MW/AA0';
        $scope.RangeSendText = $scope.ElectricModel ? "WEBMOB_device_range_comm_start_CL" : "WEBMOB_device_range_comm_send_to_oven_CL";
        settingPageOptionsValidation();
        if ($scope.DeviceModelName === 'NX9000KW/AA0' && !$scope.dividerConnected) {
            $scope.healthyCookContentsSingle = db.exec("SELECT * FROM HEALTHY_COOK WHERE SINGLE = 'TRUE' AND MODE != 'Healthycook3'");
        }
        if (loadProgress) { // just to upload all main view to avoide blank screen need to find best approch
            loadProgress = false;
            debugMessage('just one time');
            $state.transitionTo('SettingPage');
            $state.transitionTo('AboutPage');
            $state.transitionTo('CleaningPage');
            $state.transitionTo('CookTopPage');
            $state.transitionTo('ProgressPage');
            $state.transitionTo('ReadyPage');
        }
    }

    function parseStaticData() {
        debugMessage("parseStaticData ");
        init();
        $scope.deviceSingleUpperInfo.connected = true;
        $scope.dividerConnected = true;
        $scope.remoteControlEnabled = true;
        $scope.showSmartCare = true;
        initializeScreen();
        showCurrentScreen();
    }

    function updateDeviceData(data) {
        SHPService.updateDeviceData($scope, data);
    }

    function callGetDevice() {
        debugMessage("callGetDevice ");
        SHPService.getDevices($scope);
    }

    function autoGetDeviceCall() {
        debugMessage("autoGetDeviceCall ");
        $scope.autoCall = false;
        setInterval(function () {
            if (!showCookTop) {
                return;
            }
            debugMessage("autoGetDeviceCall Interval call");
            getDeviceCall();
        }, autoCallTime);
    }

    function getDeviceCall() {
        if (!$scope.isStatic) {
            debugMessage("Call getDevice");
            $scope.appAtForeground = true;
            configCall = true;
            SHPService.sendSHPCommand("GET", "/" + $scope.peerId + "/devices", "", false);
        }
    }

    function configurationCall() {
        debugMessage("configurationCall");
        setInterval(function () {
            if (showCookTop) {
                return;
            }
            debugMessage("configurationCall Interval call");
            nativeInterface.getResourceUrl("/" + $scope.peerId + "/devices/0/configuration");
        }, autoCallTime);
    }

    function refreshGetDevice() {
        debugMessage("refreshGetDevice ");
        $scope.appAtForeground = true;
        configCall = true;
        $scope.autoCall = false;
        SHPService.callGetDevice($scope);
    }

    function getValueForSingleMode() {
        debugMessage("getValueForSingleMode");
        $scope.currentModeSingle = getDeviceDataMode($scope.readyStateContentsSingle[0].values[0][12]);
        $scope.recipeDescriptionSingle = $scope.readyStateContentsSingle[0].values[0][9];

        if ($scope.TempUnit === "F") {
            if ($scope.readyStateContentsSingle[0].values[0][14] === null || $scope.readyStateContentsSingle[0].values[0][14] === undefined) {
                $scope.desiredTempSingle = 350;
            } else {
                $scope.desiredTempSingle = $scope.readyStateContentsSingle[0].values[0][14];
            }
            updateModelBasedData($scope.readyStateContentsSingle);
            if ($scope.readyStateContentsSingle[0].values[0][15] === null || $scope.readyStateContentsSingle[0].values[0][15] === undefined) {
                $scope.minTempSingle = 175;
            } else {
                $scope.minTempSingle = $scope.readyStateContentsSingle[0].values[0][15];
            }
            if ($scope.readyStateContentsSingle[0].values[0][16] === null || $scope.readyStateContentsSingle[0].values[0][16] === undefined) {
                $scope.maxTempSingle = 550;
            } else {
                $scope.maxTempSingle = $scope.readyStateContentsSingle[0].values[0][16];
            }
        } else {
            if ($scope.readyStateContentsSingle[0].values[0][24] === null || $scope.readyStateContentsSingle[0].values[0][24] === undefined) {
                $scope.desiredTempSingle = 175;
            } else {
                $scope.desiredTempSingle = $scope.readyStateContentsSingle[0].values[0][24];
            }
            updateModelBasedData($scope.readyStateContentsSingle);
            if ($scope.readyStateContentsSingle[0].values[0][25] === null || $scope.readyStateContentsSingle[0].values[0][25] === undefined) {
                $scope.minTempSingle = 80;
            } else {
                $scope.minTempSingle = $scope.readyStateContentsSingle[0].values[0][25];
            }
            if ($scope.readyStateContentsSingle[0].values[0][26] === null || $scope.readyStateContentsSingle[0].values[0][26] === undefined) {
                $scope.maxTempSingle = 285;
            } else {
                $scope.maxTempSingle = $scope.readyStateContentsSingle[0].values[0][26];
            }
        }

        if ($scope.readyStateContentsSingle[0].values[0][17] === null || $scope.readyStateContentsSingle[0].values[0][17] === undefined) {
            $scope.desiredHoursSingle = 0;
            $scope.desiredMinutesSingle = 30;
        } else {
            var newdate = new Date();
            newdate.setHours(0, $scope.readyStateContentsSingle[0].values[0][17], 0);
            $scope.desiredHoursSingle = newdate.getHours();
            $scope.desiredMinutesSingle = newdate.getMinutes();
            $scope.desiredMinutesSingle = ($scope.desiredMinutesSingle < 10) ? ($scope.desiredMinutesSingle) : $scope.desiredMinutesSingle;
        }
        if ($scope.TempUnit === "F") {
            $scope.minProbeTemp = 100;
            $scope.desiredProbeTemp = 150;
            $scope.maxProbeTemp = 200;
        } else {
            $scope.minProbeTemp = 40;
            $scope.desiredProbeTemp = 65;
            $scope.maxProbeTemp = 90;
        }

    }

    function getValueForDualUpperMode() {
        debugMessage("getValueForDualUpperMode");
        $scope.currentModeUpper = getDeviceDataMode($scope.readyStateContentsDualUpper[0].values[0][12]);
        $scope.recipeDescriptionUpper = $scope.readyStateContentsDualUpper[0].values[0][9];

        if ($scope.TempUnit === "F") {
            if ($scope.readyStateContentsDualUpper[0].values[0][14] === null || $scope.readyStateContentsDualUpper[0].values[0][14] === undefined) {
                $scope.desiredTempUpper = 350;
            } else {
                $scope.desiredTempUpper = $scope.readyStateContentsDualUpper[0].values[0][14];
            }
            if ($scope.readyStateContentsDualUpper[0].values[0][15] === null || $scope.readyStateContentsDualUpper[0].values[0][15] === undefined) {
                $scope.minTempUpper = 175;
            } else {
                $scope.minTempUpper = $scope.readyStateContentsDualUpper[0].values[0][15];
            }
            if ($scope.readyStateContentsDualUpper[0].values[0][16] === null || $scope.readyStateContentsDualUpper[0].values[0][16] === undefined) {
                $scope.maxTempUpper = 550;
            } else {
                $scope.maxTempUpper = $scope.readyStateContentsDualUpper[0].values[0][16];
            }
        } else {
            if ($scope.readyStateContentsDualUpper[0].values[0][24] === null || $scope.readyStateContentsDualUpper[0].values[0][24] === undefined) {
                $scope.desiredTempUpper = 175;
            } else {
                $scope.desiredTempUpper = $scope.readyStateContentsDualUpper[0].values[0][24];
            }
            if ($scope.readyStateContentsDualUpper[0].values[0][25] === null || $scope.readyStateContentsDualUpper[0].values[0][25] === undefined) {
                $scope.minTempUpper = 80;
            } else {
                $scope.minTempUpper = $scope.readyStateContentsDualUpper[0].values[0][25];
            }
            if ($scope.readyStateContentsDualUpper[0].values[0][26] === null || $scope.readyStateContentsDualUpper[0].values[0][26] === undefined) {
                $scope.maxTempUpper = 285;
            } else {
                $scope.maxTempUpper = $scope.readyStateContentsDualUpper[0].values[0][26];
            }
        }

        if ($scope.readyStateContentsDualUpper[0].values[0][17] === null || $scope.readyStateContentsDualUpper[0].values[0][17] === undefined) {
            $scope.desiredHoursUpper = 0;
            $scope.desiredMinutesUpper = 30;
        } else {
            var newdate = new Date();
            newdate.setHours(0, $scope.readyStateContentsDualUpper[0].values[0][17], 0);
            $scope.desiredHoursUpper = newdate.getHours();
            $scope.desiredMinutesUpper = newdate.getMinutes();
            $scope.desiredMinutesUpper = ($scope.desiredMinutesUpper < 10) ? ($scope.desiredMinutesUpper) : $scope.desiredMinutesUpper;
        }
        $scope.remainingTimeUpper = $scope.desiredHoursUpper + ':' + $scope.desiredMinutesUpper;
    }

    function getValueForDualLowerMode() {
        debugMessage("getValueForDualLowerMode");
        $scope.currentModeLower = getDeviceDataMode($scope.readyStateContentsDualLower[0].values[0][12]);
        $scope.recipeDescriptionLower = $scope.readyStateContentsDualLower[0].values[0][9];


        if ($scope.TempUnit === "F") {
            if ($scope.readyStateContentsDualLower[0].values[0][14] === null || $scope.readyStateContentsDualLower[0].values[0][14] === undefined) {
                $scope.desiredTempLower = 350;
            } else {
                $scope.desiredTempLower = $scope.readyStateContentsDualLower[0].values[0][14];
            }
            if ($scope.readyStateContentsDualLower[0].values[0][15] === null || $scope.readyStateContentsDualLower[0].values[0][15] === undefined) {
                $scope.minTempLower = 175;
            } else {
                $scope.minTempLower = $scope.readyStateContentsDualLower[0].values[0][15];
            }
            if ($scope.readyStateContentsDualLower[0].values[0][16] === null || $scope.readyStateContentsDualLower[0].values[0][16] === undefined) {
                $scope.maxTempLower = 550;
            } else {
                $scope.maxTempLower = $scope.readyStateContentsDualLower[0].values[0][16];
            }
        } else {
            if ($scope.readyStateContentsDualLower[0].values[0][24] === null || $scope.readyStateContentsDualLower[0].values[0][24] === undefined) {
                $scope.desiredTempLower = 175;
            } else {
                $scope.desiredTempLower = $scope.readyStateContentsDualLower[0].values[0][24];
            }
            if ($scope.readyStateContentsDualLower[0].values[0][25] === null || $scope.readyStateContentsDualLower[0].values[0][25] === undefined) {
                $scope.minTempLower = 80;
            } else {
                $scope.minTempLower = $scope.readyStateContentsDualLower[0].values[0][25];
            }
            if ($scope.readyStateContentsDualLower[0].values[0][26] === null || $scope.readyStateContentsDualLower[0].values[0][26] === undefined) {
                $scope.maxTempLower = 250;
            } else {
                $scope.maxTempLower = $scope.readyStateContentsDualLower[0].values[0][26];
            }

        }

        if ($scope.readyStateContentsDualLower[0].values[0][17] === null || $scope.readyStateContentsDualLower[0].values[0][17] === undefined) {
            $scope.desiredHoursLower = 0;
            $scope.desiredMinutesLower = 30;
        } else {
            var newdate = new Date();
            newdate.setHours(0, $scope.readyStateContentsDualLower[0].values[0][17], 0);
            $scope.desiredHoursLower = newdate.getHours();
            $scope.desiredMinutesLower = newdate.getMinutes();
            $scope.desiredMinutesLower = ($scope.desiredMinutesLower < 10) ? ($scope.desiredMinutesLower) : $scope.desiredMinutesLower;
        }
        $scope.remainingTimeLower = $scope.desiredHoursLower + ':' + $scope.desiredMinutesLower;
    }

    function updateModelBasedData(dbData) {
        if ($scope.DeviceModelName === 'NX9000KW/AA0') {
            var modeName = dbData[0].values[0][12];
            if (modeName === 'Healthycook2' || modeName === 'Healthycook4') {
                if ($scope.TempUnit === "F") {
                    $scope.desiredTempSingle = $scope.desiredTempSingle + 25;
                } else {
                    $scope.desiredTempSingle = $scope.desiredTempSingle + 15;
                }
                debugMessage("change default temp to " + $scope.desiredTempSingle + " for model NX9000KW/AA0 for " + modeName + " single mode");
            }
        }
    }

    function parseRequestAccepted(response) {
        debugMessage("parseRequestAccepted : " + JSON.stringify(response));
    }

    function parseRequestResponse(response) {
        debugMessage("parseRequestResponse");
        if (angular.isDefined(response["status"]) && response["status"] === 99000) {
            showConnectionFailurePopup();
        }
        if (angular.isDefined(response["status"]) && (response["status"] >= 200 || response.status < 300)) {
            $scope.handleStatusCode(response.status, response);
        }
        if (angular.isDefined(response["data"]["Configuration"])) {
            parseConfiguration(response["data"]["Configuration"], response.resourceURL);
        }
        if (angular.isDefined(response["data"]["Information"])) {
            parseModuleInformation(response["data"]["Information"]);
        }
        if (angular.isDefined(response["data"][0]) && angular.isDefined(response["data"][0]["Device"]) && angular.isDefined(response["data"][0]["Device"]["scsConnectionState"])) {
            if (!response["data"][0]["Device"]["scsConnectionState"]) {
                showConnectionFailurePopup();
            } else if (response["data"][0]["Device"]["scsConnectionState"]) {
                $scope.closeConnectionFailurePopup();
                $scope.autoCall = true;
                $scope.appAtForeground = true;
                callGetDevice();
            }
            return;
        }

        if (angular.isDefined(response["data"]["Devices"])) {
            init();
            parseDeviceData(response.data.Devices);
            if (!!!$scope.loadingBar) { // No loading bar means request handled properly. So, clear array.
                SHPService.clearStopVarArray();
            }
        }
    }

    function parseDeviceData(devices) {

        debugMessage("deviceUuid from app.js is :" + $scope.deviceUuid);
        if (angular.isDefined(devices) && angular.isDefined(devices[0]) && angular.isDefined(devices[0]["uuid"])) {
            if ($scope.deviceUuid !== devices[0]["uuid"] && $scope.deviceUuid !== devices[1]["uuid"]) {
                debugMessage("return due to missmatch UUID");
                return;
            }
        }
        debugMessage(JSON.stringify(devices));

        if (devices instanceof Array) { //Added a check to avoid error in case "devices" is not array 
            devices.forEach(function (value) {
                if (value["id"] === '0') {
                    parseSingleUpperData(value);
                }
                if (value["id"] === '1') {
                    parseDoubleLowerData(value);
                }
            });
        } else if (angular.isDefined(devices['Operation']) && devices['Operation'] === '') {
            // sometimes set is sending  devices as {"Operation":""}, added the condition just to avoid any issue that it can cause
            return;
        } else {
            //do nothing
        }

        if (justFirstTime) {
            if (!$scope.isStatic) {
                nativeInterface.getResourceUrl("/" + $scope.peerId + "/devices/0/configuration");
            }
            configurationCall();
            //Create local Storage DB name based on connected device UUID
            RANGELOCALSTORAGE.FAVDB = "RANGE_FAV_DB_" + $scope.deviceUuid;
            return;
        }
        if (!justFirstTime) {
            dismissLoadingBar(RANGE_COMMANDS.getDevices);
            initializeScreen();
            showCurrentScreen();
        }
    }

    function parseConfiguration(configInfo) {
        debugMessage("parseConfiguration configInfo : " + JSON.stringify(configInfo));
        $scope.parseConfig = true;
        if (configCall) {
            configCall = false;
            dismissLoadingBar(RANGE_COMMANDS.getDevices);
        }
        if (angular.isDefined(configInfo["remoteControlEnabled"])) {
            $scope.remoteControlEnabled = configInfo["remoteControlEnabled"];
        }
        if (angular.isDefined(configInfo["region"])) {
            $scope.region = configInfo["region"];
        }
        if (justFirstTime) {
            dismissLoadingBar(RANGE_COMMANDS.getDevices);
            initializeScreen();
            showCurrentScreen();
        }
    }

    function parseNotification(response) {
        debugMessage("parseNotification ");
        if (angular.isDefined(response["softKeypadVisibility"])) {
            hideInputBoxFocus();
        }
        if (!angular.isDefined(response["data"])) {
            return;
        }
        if (response["data"] === "backPressed") {
            //if loding bar visible, don't handle back key
            if (!!!$scope.loadingBar) {
                onBackPressed();
            }
            return;
        }
        if (angular.isDefined(response["data"]["mobileTimeChanged"])) {
            return;
        }
        if (angular.isDefined(response["data"][0]) && angular.isDefined(response["data"][0]["Device"]) && angular.isDefined(response["data"][0]["Device"]["scsConnectionState"])) {
            if (!response["data"][0]["Device"]["scsConnectionState"]) {
                showConnectionFailurePopup();
            } else if (response["data"][0]["Device"]["scsConnectionState"]) {
                $scope.closeConnectionFailurePopup();
                $scope.autoCall = true;
                $scope.appAtForeground = true;
                callGetDevice();
            }
            return;
        }
        if (angular.isDefined(response["data"]["isApplicationActive"]) && !$scope.isStatic) {
            $scope.autoCall = true;
            $scope.appAtForeground = true;
            callGetDevice();
            return;
        } else {
            if (response["data"] instanceof Array) {
                $scope.parseNotiLength = response["data"].length;
                response["data"].forEach(function (value) {
                    $scope.parseNotiLength--;
                    parseNotificationData(value);
                });
            } else {
                parseNotificationData(response["data"]);
            }
        }
    }

    function parseNotificationData(notification) {
        debugMessage("parseNotificationData : " + JSON.stringify(notification));
        if ($scope.checkResponse.indexOf(RANGE_COMMANDS.getDevices) !== -1) {
            debugMessage("ignore notification ig getDevice requested ");
            return;
        }
        if (angular.isDefined(notification["uuid"])) {
            if ($scope.deviceSingleUpperInfo !== undefined && notification["uuid"] === $scope.deviceSingleUpperInfo.uuid) {
                if (angular.isDefined(notification["Configuration"])) {
                    parseConfiguration(notification["Configuration"], '');
                    if ($scope.parseNotiLength === 0) {
                        $scope.appAtForeground = false;
                    }
                } else {
                    parseSingleUpperData(notification);
                    if ($scope.parseNotiLength === 0) {
                        $scope.appAtForeground = false;
                        showCurrentScreen();
                    }
                }
            } else if ($scope.deviceDualLowerInfo !== undefined && notification["uuid"] === $scope.deviceDualLowerInfo.uuid) {
                parseDoubleLowerData(notification);
                if ($scope.parseNotiLength === 0) {
                    $scope.appAtForeground = false;
                    showCurrentScreen();
                }
            } else {
                debugMessage("parseNotificationData(notification) uuid not matched notification uuid " + notification["uuid"]);
                $scope.appAtForeground = true;
                SHPService.sendSHPCommand("GET", "/" + $scope.peerId + "/devices", "", false);
            }
        }
    }

    function parseModuleInformation(moduleInfo) {
        debugMessage("parseModuleInformation " + JSON.stringify(moduleInfo));
        if (angular.isDefined(moduleInfo.Versions) && moduleInfo.Versions.length > 0) {
            $scope.moduleInfoText = "Software Ver : " + moduleInfo.Versions[0].number + " <br> Firmware Ver : " + moduleInfo.Versions[1].number;
            dismissLoadingBar(RANGE_COMMANDS.showModuleVersion);
            debugMessage("Infotext : " + $scope.moduleInfoText);
            showcustDialog(RANGE_ALERT_STATE.ALERT_DEVELOPER_INFO, $scope.translation.WEBMOB_common_version_info, $scope.moduleInfoText, $scope.translation.WEBMOB_common_ok, '');
        }
    }

    function parseSingleUpperData(deviceData) {
        debugMessage("parseSingleUpperData ");
        if (angular.isDefined(deviceData["Configuration"])) {
            parseConfiguration(deviceData["Configuration"]);
        }
        if (angular.isDefined(deviceData["description"])) {
            $scope.deviceSingleUpperInfo.description = deviceData["description"];
        }
        if (angular.isDefined(deviceData["id"])) {
            $scope.deviceSingleUpperInfo.id = deviceData["id"];
        }
        if (angular.isDefined(deviceData["Alarms"])) {
            if (angular.isDefined(deviceData["Alarms"][0])) {
                if (angular.isDefined(deviceData["Alarms"][0]["id"])) {
                    $scope.deviceSingleUpperInfo.Alarms[0].id = deviceData["Alarms"][0]["id"];
                }
                if (angular.isDefined(deviceData["Alarms"][0]["code"])) {
                    $scope.deviceSingleUpperInfo.Alarms[0].code = deviceData["Alarms"][0]["code"];
                    if ($scope.deviceSingleUpperInfo.Alarms[0].code.indexOf("RG_E") !== -1) {
                        $scope.errorCode = getErrorCode($scope.deviceSingleUpperInfo.Alarms[0].code);
                        if ($scope.errorCode !== '') {
                            debugMessage('idZero errorRemoved false');
                            errorRemoved = false;
                            validateCurrentScreen('ErrorPage');
                        }
                    }
                }
                if (angular.isDefined(deviceData["Alarms"][0]["alarmType"])) {
                    $scope.deviceSingleUpperInfo.Alarms[0].alarmType = deviceData["Alarms"][0]["alarmType"];
                }
                if (angular.isDefined(deviceData["Alarms"][0]["triggeredTime"])) {
                    $scope.deviceSingleUpperInfo.Alarms[0].triggeredTime = deviceData["Alarms"][0]["triggeredTime"];
                }
            }
        }
        if (angular.isDefined(deviceData["ConfigurationLink"])) {
            $scope.deviceSingleUpperInfo.ConfigurationLink = deviceData["ConfigurationLink"];
        }
        if (angular.isDefined(deviceData["Diagnosis"])) {
            if (angular.isDefined(deviceData["Diagnosis"]["diagnosisStart"])) {
                $scope.deviceSingleUpperInfo.Diagnosis.diagnosisStart = deviceData["Diagnosis"]["diagnosisStart"];
            }
            if ($scope.deviceSingleUpperInfo.Diagnosis.diagnosisStart === "Ready") {
                if (!$scope.appAtForeground && ($scope.currentScreen === RANGESCREENS.RANGE_SMART_CARE_PAGE || $scope.currentScreen === RANGESCREENS.RANGE_SMART_CARE_NO_ERROR_PAGE)) {
                    dismissLoadingBar(RANGE_COMMANDS.smartCareDiagnosis);
                    $scope.currentScreen = RANGESCREENS.RANGE_SMART_CARE_NO_ERROR_PAGE;
                    validateCurrentScreen('SmartCareNoErrorPage');
                }
            } else {
                $scope.currentScreen = RANGESCREENS.RANGE_SMART_CARE_PAGE;
                validateCurrentScreen('SmartCarePage');
            }
        }
        if (angular.isDefined(deviceData["EnergyConsumption"])) {
            $scope.deviceSingleUpperInfo.EnergyConsumption = deviceData["EnergyConsumption"];
        }
        if (angular.isDefined(deviceData["InformationLink"])) {
            $scope.deviceSingleUpperInfo.InformationLink = deviceData["InformationLink"];
        }
        if (angular.isDefined(deviceData["Mode"])) {
            if (angular.isDefined(deviceData["Mode"]["modes"])) {
                $scope.deviceSingleUpperInfo.Mode.modes = deviceData["Mode"]["modes"];
                if (!recipeDataValidated) {
                    if ($scope.deviceSingleUpperInfo.Mode.modes[0] === 'NoOperation' && $scope.deviceDualLowerInfo.Mode.modes[0] === 'NoOperation') {
                        recipeDataValidated = true;
                    }
                }
            }
            if (angular.isDefined(deviceData["Mode"]["options"])) {
                parseDataDeviceSingleUpperModeOptions(deviceData["Mode"]["options"]);
            }
            if (angular.isDefined(deviceData["Mode"]["supportedModes"])) {
                $scope.deviceSingleUpperInfo.Mode.supportedModes = deviceData["Mode"]["supportedModes"];
            }
        }
        if (angular.isDefined(deviceData["Operation"])) {
            if (angular.isDefined(deviceData["Operation"]["operationTime"])) {
                $scope.deviceSingleUpperInfo.Operation.operationTime = deviceData["Operation"]["operationTime"];
                dismissLoadingBar(RANGE_COMMANDS.snoozeCookingTime);
            }
            if (angular.isDefined(deviceData["Operation"]["remainingTime"])) {
                $scope.deviceSingleUpperInfo.Operation.remainingTime = deviceData["Operation"]["remainingTime"];
            }
            if (angular.isDefined(deviceData["Operation"]["state"])) {
                $scope.deviceSingleUpperInfo.Operation.state = deviceData["Operation"]["state"];
                dismissLoadingBar(RANGE_COMMANDS.cancelCooking);
                dismissLoadingBar(RANGE_COMMANDS.sendRecipetoOven);
                if (deviceData["Operation"]["state"] === 'Run') {
                    dismissLoadingBar(RANGE_COMMANDS.sendRecipetoOven);
                    dismissLoadingBar(RANGE_COMMANDS.startConfirmationOK);
                    setDefaultModeSingle = true;
                    setDefaultModeUpper = true;
                    changSingleRecipe = true;
                    userPreferneceSingleSinlge = {};
                    deviceSingleMode = 'Bake';
                    changeUpperRecipe = true;
                    userPreferneceSingleUpper = {};
                    deviceUpperMode = 'UpperConvectionBake';
                }
            }
            if (angular.isDefined(deviceData["Operation"]["kidsLock"])) {
                $scope.deviceSingleUpperInfo.Operation.kidsLock = deviceData["Operation"]["kidsLock"];
            }
            if (angular.isDefined(deviceData["Operation"]["power"])) {
                $scope.deviceSingleUpperInfo.Operation.power = deviceData["Operation"]["power"];
            }
            if (angular.isDefined(deviceData["Operation"]["progressPercentage"])) {
                $scope.deviceSingleUpperInfo.Operation.progressPercentage = deviceData["Operation"]["progressPercentage"];
            }
        }
        if (angular.isDefined(deviceData["Oven"])) {
            if (angular.isDefined(deviceData["Oven"]["CustomRecipesLink"])) {
                $scope.deviceSingleUpperInfo.Oven.CustomRecipesLink = deviceData["Oven"]["CustomRecipesLink"];
            }
            if (angular.isDefined(deviceData["Oven"]["state"])) {
                $scope.deviceSingleUpperInfo.Oven.state = deviceData["Oven"]["state"];
                if ($scope.bCookingFinished && $scope.operationCompleteUpper && !configCall) {
                    $scope.operationCompleteUpper = false;
                }
            }
            if (angular.isDefined(deviceData["Oven"]["recipe"])) {
                $scope.deviceSingleUpperInfo.Oven.recipe = deviceData["Oven"]["recipe"];
            }
        }
        if (angular.isDefined(deviceData["connected"])) {
            $scope.deviceSingleUpperInfo.connected = deviceData["connected"];
            checkForDivider();
            hideInputBoxFocus();
            if (!justFirstTime && !configCall) {
                refreshValue();
                changeUpperRecipe = true;
                changeLowerRecipe = true;
                changSingleRecipe = true;
            }
            if (deviceData["connected"] && $scope.deviceSingleUpperInfo.Mode.options[0].meatprobe === "connected") {
                validateCurrentScreen('ProbeDividerErrorPage');
            }
        }
        if (angular.isDefined(deviceData["Device"])) {
            if ((angular.isDefined(deviceData["Device"]["connected"]))) {
                $scope.deviceSingleUpperInfo.connected = deviceData["Device"]["connected"];
                checkForDivider();
                hideInputBoxFocus();
                if (!justFirstTime && !configCall) {
                    refreshValue();
                    changeUpperRecipe = true;
                    changeLowerRecipe = true;
                    changSingleRecipe = true;
                }
                if (deviceData["Device"]["connected"] && $scope.deviceSingleUpperInfo.Mode.options[0].meatprobe === "connected") {
                    validateCurrentScreen('ProbeDividerErrorPage');
                }
            }
        }
        if (angular.isDefined(deviceData["name"])) {
            $scope.deviceSingleUpperInfo.name = deviceData["name"];
        }
        if (angular.isDefined(deviceData["resources"])) {
            $scope.deviceSingleUpperInfo.resources = deviceData["resources"];
            deviceData["resources"].forEach(function (value) {
                if (value.indexOf("Diagnosis") !== -1) {
                    $scope.showSmartCare = true;
                }
            });
        }
        if (angular.isDefined(deviceData["type"])) {
            $scope.deviceSingleUpperInfo.type = deviceData["type"];
            if (!justFirstTime && !configCall) {
                changeUpperRecipe = false;
                changeLowerRecipe = false;
                changSingleRecipe = false;
            }
        }
        if (angular.isDefined(deviceData["uuid"])) {
            $scope.deviceSingleUpperInfo.uuid = deviceData["uuid"];
        }
        if (angular.isDefined(deviceData["Temperatures"])) {
            if (angular.isDefined(deviceData["Temperatures"][0])) {
                if (deviceData["Temperatures"][0]["id"] === '0') {
                    if (angular.isDefined(deviceData["Temperatures"][0]["id"])) {
                        $scope.deviceSingleUpperInfo.Temperatures[0].id = deviceData["Temperatures"][0]["id"];
                    }
                    if (angular.isDefined(deviceData["Temperatures"][0]["current"])) {
                        $scope.deviceSingleUpperInfo.Temperatures[0].current = deviceData["Temperatures"][0]["current"];
                    }
                    if (angular.isDefined(deviceData["Temperatures"][0]["desired"])) {
                        $scope.deviceSingleUpperInfo.Temperatures[0].desired = deviceData["Temperatures"][0]["desired"];
                        if ($scope.deviceDualLowerInfo !== undefined && $scope.deviceDualLowerInfo.Operation.state === 'Ready' && $scope.deviceSingleUpperInfo.Operation.state === 'Run') {
                            $scope.desiredTempLower = $scope.deviceSingleUpperInfo.Temperatures[0].desired !== 0 ? $scope.deviceSingleUpperInfo.Temperatures[0].desired : $scope.desiredTempLower;
                            if ($scope.desiredTempLower === 61441) {
                                $scope.desiredTempLower = $scope.bFahrenheit ? 480 : 248;
                            }
                            if ($scope.desiredTempLower === 61442) {
                                $scope.desiredTempLower = $scope.bFahrenheit ? 400 : 204;
                            }
                            $scope.desiredTemp = $scope.desiredTempLower;
                        }
                        if (!justFirstTime && !$scope.appAtForeground && !configCall
                                && $scope.currentScreen === RANGESCREENS.RANGE_SEND_CONFERMATION_PAGE) {
                            updateSendRecipeValues(0);
                        }
                    }
                    if (angular.isDefined(deviceData["Temperatures"][0]["unit"])) {
                        $scope.deviceSingleUpperInfo.Temperatures[0].unit = deviceData["Temperatures"][0]["unit"];
                        setTempUnit($scope.deviceSingleUpperInfo.Operation.state);
                        settingPageOptionsValidation();
                        dismissLoadingBar(RANGE_COMMANDS.changeTempUnit);
                    }
                } else if (deviceData["Temperatures"][0]["id"] === '1') {
                    if (angular.isDefined(deviceData["Temperatures"][0]["id"])) {
                        $scope.deviceSingleUpperInfo.Temperatures[1].id = deviceData["Temperatures"][0]["id"];
                    }
                    if (angular.isDefined(deviceData["Temperatures"][0]["current"])) {
                        $scope.deviceSingleUpperInfo.Temperatures[1].current = deviceData["Temperatures"][0]["current"];
                    }
                    if (angular.isDefined(deviceData["Temperatures"][0]["desired"])) {
                        $scope.deviceSingleUpperInfo.Temperatures[1].desired = deviceData["Temperatures"][0]["desired"];
                        if (!justFirstTime && !$scope.appAtForeground && !configCall
                                && $scope.currentScreen === RANGESCREENS.RANGE_SEND_CONFERMATION_PAGE) {
                            updateSendRecipeValues(0);
                        }
                    }
                    if (angular.isDefined(deviceData["Temperatures"][0]["unit"])) {
                        $scope.deviceSingleUpperInfo.Temperatures[1].unit = deviceData["Temperatures"][0]["unit"];
                    }
                }
            }
            if (angular.isDefined(deviceData["Temperatures"][1])) {
                if (angular.isDefined(deviceData["Temperatures"][1]["id"])) {
                    $scope.deviceSingleUpperInfo.Temperatures[1].id = deviceData["Temperatures"][1]["id"];
                }
                if (angular.isDefined(deviceData["Temperatures"][1]["current"])) {
                    $scope.deviceSingleUpperInfo.Temperatures[1].current = deviceData["Temperatures"][1]["current"];
                }
                if (angular.isDefined(deviceData["Temperatures"][1]["desired"])) {
                    $scope.deviceSingleUpperInfo.Temperatures[1].desired = deviceData["Temperatures"][1]["desired"];
                    if (!justFirstTime && !$scope.appAtForeground && !configCall
                            && $scope.currentScreen === RANGESCREENS.RANGE_SEND_CONFERMATION_PAGE) {
                        updateSendRecipeValues(0);
                    }
                }
                if (angular.isDefined(deviceData["Temperatures"][1]["unit"])) {
                    $scope.deviceSingleUpperInfo.Temperatures[1].unit = deviceData["Temperatures"][1]["unit"];
                    setTempUnit($scope.deviceSingleUpperInfo.Operation.state);
                    settingPageOptionsValidation();
                    dismissLoadingBar(RANGE_COMMANDS.changeTempUnit);
                }
            }
        }
        if (angular.isDefined(deviceData["Doors"])) {
            $scope.deviceSingleUpperInfo.Door = deviceData["Doors"];
            if (angular.isDefined(deviceData["Doors"][0]) && angular.isDefined(deviceData["Doors"][0]["openState"])) {
                $scope.deviceSingleUpperInfo.Doors[0].openState = deviceData["Doors"][0]["openState"];
                $scope.DoorOpen = $scope.deviceSingleUpperInfo.Doors[0].openState === "Open" ? true : false;
                if ($scope.DoorOpen && !$scope.appAtForeground) {
                    showcustDialog(RANGE_ALERT_STATE.ALERT_DOOR_OPEN, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_door_open, '', $scope.translation.WEBMOB_common_ok);
                } else if ($scope.showFullScreenPopup && $scope.alertState === RANGE_ALERT_STATE.ALERT_DOOR_OPEN) {
                    $scope.showFullScreenPopup = false;
                }
            }
        }
    }

    function parseDoubleLowerData(deviceData) {
        debugMessage("parseDoubleLowerData ");
        if (angular.isDefined(deviceData["description"])) {
            $scope.deviceDualLowerInfo.description = deviceData["description"];
        }
        if (angular.isDefined(deviceData["id"])) {
            $scope.deviceDualLowerInfo.id = deviceData["id"];
        }
        if (angular.isDefined(deviceData["Alarms"])) {
            if (angular.isDefined(deviceData["Alarms"][0])) {
                if (angular.isDefined(deviceData["Alarms"][0]["id"])) {
                    $scope.deviceDualLowerInfo.Alarms[0].id = deviceData["Alarms"][0]["id"];
                }
                if (angular.isDefined(deviceData["Alarms"][0]["code"])) {
                    $scope.deviceDualLowerInfo.Alarms[0].code = deviceData["Alarms"][0]["code"];
                    if ($scope.deviceDualLowerInfo.Alarms[0].code.indexOf("RG_E") !== -1) {
                        $scope.errorCode = getErrorCode($scope.deviceDualLowerInfo.Alarms[0].code);
                        if ($scope.errorCode !== '') {
                            debugMessage('idOne errorRemoved false');
                            errorRemoved = false;
                            validateCurrentScreen('ErrorPage');
                        }
                    }
                }
                if (angular.isDefined(deviceData["Alarms"][0]["alarmType"])) {
                    $scope.deviceDualLowerInfo.Alarms[0].alarmType = deviceData["Alarms"][0]["alarmType"];
                }
                if (angular.isDefined(deviceData["Alarms"][0]["triggeredTime"])) {
                    $scope.deviceDualLowerInfo.Alarms[0].triggeredTime = deviceData["Alarms"][0]["triggeredTime"];
                }
            }
        }
        if (angular.isDefined(deviceData["ConfigurationLink"])) {
            $scope.deviceDualLowerInfo.ConfigurationLink = deviceData["ConfigurationLink"];
        }
        if (angular.isDefined(deviceData["EnergyConsumption"])) {
            $scope.deviceDualLowerInfo.EnergyConsumption = deviceData["EnergyConsumption"];
        }
        if (angular.isDefined(deviceData["InformationLink"])) {
            $scope.deviceDualLowerInfo.InformationLink = deviceData["InformationLink"];
        }
        if (angular.isDefined(deviceData["Mode"])) {
            if (angular.isDefined(deviceData["Mode"]["modes"])) {
                $scope.deviceDualLowerInfo.Mode.modes = deviceData["Mode"]["modes"];
                if (!recipeDataValidated) {
                    if ($scope.deviceSingleUpperInfo.Mode.modes[0] === 'NoOperation' && $scope.deviceDualLowerInfo.Mode.modes[0] === 'NoOperation') {
                        recipeDataValidated = true;
                    }
                }
            }
            if (angular.isDefined(deviceData["Mode"]["options"])) {
                parseDataDeviceDualLowerModeOptions(deviceData["Mode"]["options"]);
            }
        }
        if (angular.isDefined(deviceData["Operation"])) {
            if (angular.isDefined(deviceData["Operation"]["operationTime"])) {
                $scope.deviceDualLowerInfo.Operation.operationTime = deviceData["Operation"]["operationTime"];
                dismissLoadingBar(RANGE_COMMANDS.snoozeCookingTime);
            }
            if (angular.isDefined(deviceData["Operation"]["remainingTime"])) {
                $scope.deviceDualLowerInfo.Operation.remainingTime = deviceData["Operation"]["remainingTime"];
            }
            if (angular.isDefined(deviceData["Operation"]["state"])) {
                $scope.deviceDualLowerInfo.Operation.state = deviceData["Operation"]["state"];
                dismissLoadingBar(RANGE_COMMANDS.cancelCooking);
                dismissLoadingBar(RANGE_COMMANDS.sendRecipetoOven);
                if (deviceData["Operation"]["state"] === 'Run') {
                    dismissLoadingBar(RANGE_COMMANDS.sendRecipetoOven);
                    dismissLoadingBar(RANGE_COMMANDS.startConfirmationOK);
                    setDefaultModeLower = true;
                    changeLowerRecipe = true;
                    userPreferneceDualLower = {};
                    deviceLowerMode = 'LowerBake';
                }
            }
            if (angular.isDefined(deviceData["Operation"]["kidsLock"])) {
                $scope.deviceDualLowerInfo.Operation.kidsLock = deviceData["Operation"]["kidsLock"];
            }
            if (angular.isDefined(deviceData["Operation"]["power"])) {
                $scope.deviceDualLowerInfo.Operation.power = deviceData["Operation"]["power"];
            }
            if (angular.isDefined(deviceData["Operation"]["progressPercentage"])) {
                $scope.deviceDualLowerInfo.Operation.progressPercentage = deviceData["Operation"]["progressPercentage"];
            }
        }
        if (angular.isDefined(deviceData["Oven"])) {
            if (angular.isDefined(deviceData["Oven"]["CustomRecipesLink"])) {
                $scope.deviceDualLowerInfo.Oven.CustomRecipesLink = deviceData["Oven"]["CustomRecipesLink"];
            }
            if (angular.isDefined(deviceData["Oven"]["state"])) {
                $scope.deviceDualLowerInfo.Oven.state = deviceData["Oven"]["state"];
                if ($scope.bCookingFinished && $scope.operationCompleteLower && !configCall) {
                    $scope.operationCompleteLower = false;
                }
            }
            if (angular.isDefined(deviceData["Oven"]["recipe"])) {
                $scope.deviceDualLowerInfo.Oven.recipe = deviceData["Oven"]["recipe"];
            }
        }
        if (angular.isDefined(deviceData["connected"])) {
            $scope.deviceDualLowerInfo.connected = deviceData["connected"];
        }
        if (angular.isDefined(deviceData["Device"])) {
            if (angular.isDefined(deviceData["Device"]["connected"])) {
                $scope.deviceDualLowerInfo.connected = deviceData["Device"]["connected"];
            }
        }
        if (angular.isDefined(deviceData["name"])) {
            $scope.deviceDualLowerInfo.name = deviceData["name"];
        }
        if (angular.isDefined(deviceData["resources"])) {
            $scope.deviceDualLowerInfo.resources = deviceData["resources"];
        }
        if (angular.isDefined(deviceData["type"])) {
            $scope.deviceDualLowerInfo.type = deviceData["type"];
        }
        if (angular.isDefined(deviceData["uuid"])) {
            $scope.deviceDualLowerInfo.uuid = deviceData["uuid"];
        }
        if (angular.isDefined(deviceData["Temperatures"])) {
            if (angular.isDefined(deviceData["Temperatures"][0])) {
                if (angular.isDefined(deviceData["Temperatures"][0]["id"])) {
                    $scope.deviceDualLowerInfo.Temperatures[0].id = deviceData["Temperatures"][0]["id"];
                }
                if (angular.isDefined(deviceData["Temperatures"][0]["current"])) {
                    $scope.deviceDualLowerInfo.Temperatures[0].current = deviceData["Temperatures"][0]["current"];
                }
                if (angular.isDefined(deviceData["Temperatures"][0]["desired"])) {
                    $scope.deviceDualLowerInfo.Temperatures[0].desired = deviceData["Temperatures"][0]["desired"];
                    if ($scope.deviceSingleUpperInfo !== undefined && $scope.deviceSingleUpperInfo.Operation.state === 'Ready' && $scope.deviceDualLowerInfo.Operation.state === 'Run') {
                        $scope.desiredTempUpper = $scope.deviceDualLowerInfo.Temperatures[0].desired !== 0 ? $scope.deviceDualLowerInfo.Temperatures[0].desired : $scope.desiredTempUpper;
                        $scope.desiredTemp = $scope.desiredTempUpper;
                    }
                    if (!justFirstTime && !$scope.appAtForeground && !configCall
                            && $scope.currentScreen === RANGESCREENS.RANGE_SEND_CONFERMATION_PAGE) {
                        updateSendRecipeValues(1);
                    }
                }
                if (angular.isDefined(deviceData["Temperatures"][0]["unit"])) {
                    $scope.deviceDualLowerInfo.Temperatures[0].unit = deviceData["Temperatures"][0]["unit"];
                    setTempUnit($scope.deviceDualLowerInfo.Operation.state);
                    settingPageOptionsValidation();
                    dismissLoadingBar(RANGE_COMMANDS.changeTempUnit);
                }
            }
        }
        if (angular.isDefined(deviceData["Doors"])) {
            $scope.deviceDualLowerInfo.Door = deviceData["Doors"];
            if (angular.isDefined(deviceData["Doors"][0]) && angular.isDefined(deviceData["Doors"][0]["openState"])) {
                $scope.deviceDualLowerInfo.Doors[0].openState = deviceData["Doors"][0]["openState"];
                $scope.DoorOpen = $scope.deviceDualLowerInfo.Doors[0].openState === "Open" ? true : false;
                if ($scope.DoorOpen && !$scope.appAtForeground) {
                    showcustDialog(RANGE_ALERT_STATE.ALERT_DOOR_OPEN, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_door_open, '', $scope.translation.WEBMOB_common_ok);
                } else if ($scope.showFullScreenPopup && $scope.alertState === RANGE_ALERT_STATE.ALERT_DOOR_OPEN) {
                    $scope.showFullScreenPopup = false;
                }
            }
        }
    }

    function parseDataDeviceSingleUpperModeOptions(deviceModeOption) {
        deviceModeOption.forEach(function (value) {
            if (value.indexOf("meatprobe") !== -1) {
                if (!justFirstTime && !configCall
                        && $scope.deviceSingleUpperInfo.Mode.options[0] !== undefined
                        && $scope.deviceSingleUpperInfo.Mode.options[0].meatprobe !== value.split("_")[1]) {
                    $timeout(function () {
                        if (value.split("_")[1] === "connected") {
                            toaster.success({title: "", body: $scope.translation.WEBMOB_device_range_ready_temp_probe_inserted});
                        } else {
                            toaster.success({title: "", body: $scope.translation.WEBMOB_device_range_ready_temp_probe_removed});
                        }
                    }, 500);
                }
                $scope.deviceSingleUpperInfo.Mode.options[0].meatprobe = value.split("_")[1];
                checkForDivider();
                checkForMeatProbe();
                if (value.split("_")[1] === "connected" && $scope.deviceSingleUpperInfo.connected) {
                    validateCurrentScreen('ProbeDividerErrorPage');
                }
            }
            if (value.indexOf("Sabbath") !== -1) {
                $scope.deviceSingleUpperInfo.Mode.options[0].Sabbath = value.split("_")[1];
            }
            if (value.indexOf("DeviceType") !== -1) {
                $scope.deviceSingleUpperInfo.Mode.options[0].DeviceType = value.split("_")[1];
            }
            if (value.indexOf("Sound") !== -1) {
                $scope.deviceSingleUpperInfo.Mode.options[0].Sound = value.split("_")[1];
            }
            if (value.indexOf("RecipeConversion") !== -1) {
                $scope.deviceSingleUpperInfo.Mode.options[0].RecipeConversion = value.split("_")[1];
            }
            if (value.indexOf("EnergySaving") !== -1) {
                $scope.deviceSingleUpperInfo.Mode.options[0].EnergySaving = value.split("_")[1];
            }
            if (value.indexOf("WarmingCenter") !== -1) {
                $scope.deviceSingleUpperInfo.Mode.options[0].WarmingCenter = value.split("_")[1];
            }
            if (value.indexOf("WarmingDrawer") !== -1) {
                $scope.deviceSingleUpperInfo.Mode.options[0].WarmingDrawer = value.split("_")[1];
            }
            if (value.indexOf("Cooktop") !== -1) {
                $scope.deviceSingleUpperInfo.Mode.options[0].Cooktop = value.split("_")[1];
            }
            if (value.indexOf("VirtualFlame") !== -1) {
                $scope.deviceSingleUpperInfo.Mode.options[0].VirtualFlame = value.split("_")[1];
            }
            if (value.indexOf("AdjustingTemp") !== -1) {
                $scope.deviceSingleUpperInfo.Mode.options[0].AdjustingTemp = value.split("_")[1];
            }
            if (value.indexOf("SettingPossible") !== -1) {
                $scope.deviceSingleUpperInfo.Mode.options[0].SettingPossible = value.split("_")[1];
            }
	    if (value.indexOf("TimeSyncSupported") !== -1) {
                $scope.deviceSingleUpperInfo.Mode.options[0].TimeSyncSupported = value.split("_")[1];
            }
            settingPageOptionsValidation();
        });
        dismissLoadingBar(RANGE_COMMANDS.SettingOptions);
    }

    function parseDataDeviceDualLowerModeOptions(deviceModeOption) {
        deviceModeOption.forEach(function (value) {
            if (value.indexOf("meatprobe") !== -1) {
                $scope.deviceDualLowerInfo.Mode.options[0].meatprobe = value.split("_")[1];
            }
            if (value.indexOf("Sabbath") !== -1) {
                $scope.deviceDualLowerInfo.Mode.options[0].Sabbath = value.split("_")[1];
            }
            if (value.indexOf("DeviceType") !== -1) {
                $scope.deviceDualLowerInfo.Mode.options[0].DeviceType = value.split("_")[1];
            }
            if (value.indexOf("Sound") !== -1) {
                $scope.deviceDualLowerInfo.Mode.options[0].Sound = value.split("_")[1];
            }
            if (value.indexOf("RecipeConversion") !== -1) {
                $scope.deviceDualLowerInfo.Mode.options[0].RecipeConversion = value.split("_")[1];
            }
            if (value.indexOf("EnergySaving") !== -1) {
                $scope.deviceDualLowerInfo.Mode.options[0].EnergySaving = value.split("_")[1];
            }
            if (value.indexOf("WarmingCenter") !== -1) {
                $scope.deviceDualLowerInfo.Mode.options[0].WarmingCenter = value.split("_")[1];
            }
            if (value.indexOf("WarmingDrawer") !== -1) {
                $scope.deviceDualLowerInfo.Mode.options[0].WarmingDrawer = value.split("_")[1];
            }
            if (value.indexOf("Cooktop") !== -1) {
                $scope.deviceDualLowerInfo.Mode.options[0].Cooktop = value.split("_")[1];
            }
            if (value.indexOf("VirtualFlame") !== -1) {
                $scope.deviceDualLowerInfo.Mode.options[0].VirtualFlame = value.split("_")[1];
            }
            if (value.indexOf("AdjustingTemp") !== -1) {
                $scope.deviceDualLowerInfo.Mode.options[0].AdjustingTemp = value.split("_")[1];
            }
            if (value.indexOf("SettingPossible") !== -1) {
                $scope.deviceDualLowerInfo.Mode.options[0].SettingPossible = value.split("_")[1];
            }
        });
        dismissLoadingBar(RANGE_COMMANDS.SettingOptions);
    }

    function setDataCurrentScreen() {
        debugMessage("setDataCurrentScreen :");
        if (showCookTop) {
            $scope.cookTopType = getCookTopModetType($scope.DeviceModelName);
            $scope.cookTopValues = readCooktopValue($scope.deviceDualLowerInfo.Mode.options[0].Cooktop, 5);
            $scope.warmingCenter = readWarmingCenterValue($scope.deviceDualLowerInfo.Mode.options[0].WarmingCenter);
            debugMessage("showCookTop : visible");
        }
        if ($scope.dividerConnected) {
            setDataCurrentDualUpperScreen();
            setDataCurrentDualLowerScreen();
            if ($scope.RunningUpperOven) {
                setDataCurrentDualUpperScreen();
            } else if ($scope.RunningLowerOven) {
                setDataCurrentDualLowerScreen();
            }
            changeUpperRecipe = false;
            changeLowerRecipe = false;
        } else {
            setDataCurrentSingleScreen();
            changSingleRecipe = false;
        }
    }

    function setDataCurrentSingleScreen() {
        debugMessage("setDataCurrentSingleScreen :");

        if ($scope.deviceSingleUpperInfo.Operation.state === 'Run') {
            deviceSingleMode = ($scope.deviceSingleUpperInfo.Mode.modes[0] !== 'NoOperation'
                    && $scope.deviceSingleUpperInfo.Mode.modes[0] !== '')
                    ? $scope.deviceSingleUpperInfo.Mode.modes[0] : deviceSingleMode;
        }
        if ($scope.deviceSingleUpperInfo.Operation.state === 'Ready' && setDefaultModeSingle) {
            userPreferneceSingleSinlge = {};
            setDefaultModeSingle = false;
            deviceSingleMode = "Bake";
        }
        if (!myCookingModeTrue && deviceSingleMode !== "Autocook") {
            $scope.readyStateContentsSingle = db.exec("SELECT * FROM " + setTableName(deviceSingleMode) + " WHERE MODE = '" + deviceSingleMode + "'");
        }
        getValueForSingleMode();

        deviceMode = deviceSingleMode;
        userPreferneceSingleUpper = {};
        userPreferneceDualLower = {};
        $scope.ovenFunctionContents = $scope.ovenFunctionContentsSingle;
        $scope.myCookingSelectedListItems = $scope.myCookingListItemsSingle;
        $scope.editMyCookingSelectedListItems = $scope.editMyCookingListItemsSingle;
        $scope.healthyCookContents = $scope.healthyCookContentsSingle;
        $scope.easyCookContents = $scope.easyCookContentsSingle;
        $scope.currentMode = $scope.currentModeSingle;
        $scope.currentRunningMode = getDeviceDataMode($scope.deviceSingleUpperInfo.Mode.modes[0]);
        $scope.recipeDescription = $scope.recipeDescriptionSingle;
        $scope.desiredTemp = $scope.bFahrenheit ? $scope.desiredTempSingle : FtoC($scope.desiredTempSingle);
        $scope.currentTemp = $scope.deviceSingleUpperInfo.Temperatures[0].current;
        $scope.currentProbeTemp = $scope.deviceSingleUpperInfo.Temperatures[1].current !== 0 ? $scope.deviceSingleUpperInfo.Temperatures[1].current : $scope.bFahrenheit ? 150 : 60;
        $scope.desiredProbeTemp = $scope.deviceSingleUpperInfo.Temperatures[1].desired !== 0 ? $scope.deviceSingleUpperInfo.Temperatures[1].desired : $scope.bFahrenheit ? 150 : 60;
        $scope.minTemp = $scope.bFahrenheit ? $scope.minTempSingle : FtoC($scope.minTempSingle);
        $scope.maxTemp = $scope.bFahrenheit ? $scope.maxTempSingle : FtoC($scope.maxTempSingle);
        $scope.desiredHours = $scope.desiredHoursSingle;
        $scope.desiredMinutes = $scope.desiredMinutesSingle;
        $scope.operationTotalTime = $scope.deviceSingleUpperInfo.Operation.operationTime;
        $scope.remainingTime = convertTimeHMMformat($scope.deviceSingleUpperInfo.Operation.remainingTime);
        $scope.operationTime = convertTimeHMMformat($scope.deviceSingleUpperInfo.Operation.operationTime);
        $scope.timeLeft = claculateLeftTime($scope.deviceSingleUpperInfo.Operation.remainingTime);
        $scope.progressBarPercentage = $scope.deviceSingleUpperInfo.Operation.progressPercentage;
        $scope.screenState = $scope.deviceSingleUpperInfo.Oven.state;
        $scope.screenStateSingle = $scope.screenState;
        $scope.operationStateState = $scope.deviceSingleUpperInfo.Operation.state;
        //loadAMCData($scope.readyStateContentsSingle[0].values[0]);
        $scope.desiredEditTemp = $scope.desiredTemp;
        $scope.desiredEditProbeTemp = $scope.desiredProbeTemp;
        $scope.desiredEditHours = $scope.desiredHours;
        $scope.desiredEditMinutes = $scope.desiredMinutes;
        $scope.desiredEditcurrentMode = $scope.currentModeSingle;
        $scope.oneMinutesRemainingTimeSingle = oneMinReadyMode(0, $scope.operationTime, $scope.remainingTime);
        $scope.oneMinutesRemainingTime = $scope.oneMinutesRemainingTimeSingle;

        if ($scope.deviceSingleUpperInfo.Mode.options[0].meatprobe !== "disconnected") {
            $scope.readyStateMeatProbeSupport = db.exec("SELECT * FROM " + setTableName(deviceMode) + " WHERE MODE = '" + deviceMode + "'");
            $scope.modeSupport = $scope.readyStateMeatProbeSupport[0].values[0][5] === 'TRUE';
            checkForDivider();
            checkForMeatProbe();
        } else {
            $scope.modeSupport = false;
        }

        if ($scope.deviceSingleUpperInfo.Operation.state === 'Ready') {
            if (!userPreferneceSingleSinlge.preferneceMode) {
                saveUserValueSingleSingle($scope.currentModeSingle, $scope.desiredTempSingle, $scope.desiredProbeTemp, $scope.desiredHoursSingle, $scope.desiredMinutesSingle);
            } else {
                getUserPreferencedValue(userPreferneceSingleSinlge);
            }
        }
        if ($scope.deviceSingleUpperInfo.Operation.state === "Run") {
            userPreferneceSingleSinlge = {};
            idZeroOperationState();
            $scope.desiredTemp = $scope.deviceSingleUpperInfo.Temperatures[0].desired;
            $scope.desiredEditTemp = $scope.deviceSingleUpperInfo.Temperatures[0].desired;
            $scope.desiredProbeTemp = $scope.deviceSingleUpperInfo.Temperatures[1].desired;
            $scope.desiredEditProbeTemp = $scope.deviceSingleUpperInfo.Temperatures[1].desired;
            $scope.desiredEditSlowCookTemp = $scope.deviceSingleUpperInfo.Temperatures[0].desired;
            $scope.desiredEditHours = Number($scope.remainingTime.split(':')[0]);
            $scope.desiredEditMinutes = Number($scope.remainingTime.split(':')[0]) === 0 && Number($scope.remainingTime.split(':')[1]) === 0 ? 1 : Number($scope.remainingTime.split(':')[1]);

            if ($scope.deviceSingleUpperInfo.Oven.state === "Preheat") {
                $scope.ProgressPreheatMode = true;
                $scope.ProgressDescription = "WEBMOB_device_range_cooking_preheating";
            } else if ($scope.deviceSingleUpperInfo.Oven.state === "Cooking") {
                $scope.ProgressPreheatMode = false;
                $scope.ProgressDescription = "WEBMOB_device_range_cooking_in_progress";
            } else if ($scope.deviceSingleUpperInfo.Oven.state === "Cleaning") {
                $scope.ProgressPreheatMode = false;
                $scope.ProgressDescription = "OVENMOB_LCD_cleaning_in_progress";
            } else if ($scope.deviceSingleUpperInfo.Oven.state === "Finish") {
                closeOperationState();
                $scope.operationCompleteUpper = true;
                if (deviceSingleMode.indexOf('Clean') !== -1) {
                    $scope.bCleaningFinished = true;
                    $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cleaning_completed";
                } else {
                    $scope.bCookingFinished = true;
                    $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cooking_finish_message";
                }
                validateOperationCompletionStateScreen();
                return;
            } else if ($scope.deviceSingleUpperInfo.Oven.state === "Delay") {
                $scope.ProgressPreheatMode = false;
                $scope.ProgressDescription = "WEBMOB_device_range_delay_in_progress";
            } else {
                $scope.ProgressDescription = "WEBMOB_device_range_cooking_in_progress";
            }
            $scope.desiredEditProgressDescription = $scope.ProgressDescription;

            if ($scope.currentRunningMode === 'WEBMOB_device_range_keep_warm' || $scope.deviceSingleUpperInfo.Oven.state === "Warming") {
                $scope.ProgressDescription = "WEBMOB_device_range_warming_in_progress";
                debugMessage(deviceSingleMode + " and text : " + $scope.ProgressDescription);
            }

            if (deviceSingleMode === "Broil" || deviceSingleMode === "easycook1") {
                debugMessage(deviceSingleMode + " and temp : " + $scope.deviceSingleUpperInfo.Temperatures[0].desired);
                $scope.BroilTemp = Number($scope.deviceSingleUpperInfo.Temperatures[0].desired) === 61442 ? 'Low' : 'High';
            }

            if (deviceSingleMode === "easycook1") {
                debugMessage("SlowCook Mode and temp : " + $scope.deviceSingleUpperInfo.Temperatures[0].desired);
                $scope.SlowCookTemp = Number($scope.deviceSingleUpperInfo.Temperatures[0].desired) === 61442 ? 'Low' : 'High';
            }

            if (Number($scope.deviceSingleUpperInfo.Temperatures[0].desired) === 61442) {
                $scope.BroilTemp = 'Low';
                $scope.SlowCookTemp = 'Low';
            } else {
                $scope.BroilTemp = 'High';
                $scope.SlowCookTemp = 'High';
            }
        }

        if (deviceSingleMode === "Autocook") {
            debugMessage("show Autocooking with recipe id : " + $scope.deviceSingleUpperInfo.Oven.recipe);
            $scope.ovenAutoCookRecipeID = ($scope.deviceSingleUpperInfo.Oven.recipe).substring(2, 8);
            if ($scope.ovenAutoCookRecipeID !== '000000') {
                $scope.autoCookMenuDetail = db.exec("SELECT * FROM AUTO_COOK WHERE ID ='" + $scope.ovenAutoCookRecipeID + "'");
                $scope.currentRunningMode = $scope.autoCookMenuDetail[0].values[0][2];
                debugMessage("show Autocooking with recipe id : " + $scope.ovenAutoCookRecipeID + " && name : " + $scope.autoCookMenuDetail[0].values[0][2]);
            }
        }
    }

    function setDataCurrentDualUpperScreen() {
        debugMessage("setDataCurrentDualUpperScreen :");

        if ($scope.deviceSingleUpperInfo.Operation.state === 'Run') {
            deviceUpperMode = ($scope.deviceSingleUpperInfo.Mode.modes[0] !== 'NoOperation'
                    && $scope.deviceSingleUpperInfo.Mode.modes[0] !== '')
                    ? $scope.deviceSingleUpperInfo.Mode.modes[0] : deviceUpperMode;
        }
        if ($scope.deviceSingleUpperInfo.Operation.state === 'Ready' && setDefaultModeUpper) {
            userPreferneceSingleUpper = {};
            setDefaultModeUpper = false;
            deviceUpperMode = "UpperConvectionBake";
        }
        if (!myCookingModeTrue) {
            $scope.readyStateContentsDualUpper = db.exec("SELECT * FROM " + setTableName(deviceUpperMode) + " WHERE MODE = '" + deviceUpperMode + "'");
        }
        getValueForDualUpperMode();

        deviceMode = deviceUpperMode;
        userPreferneceSingleSinlge = {};
        $scope.modeSupport = false;
        $scope.ovenFunctionContents = $scope.ovenFunctionContentsUpper;
        $scope.myCookingSelectedListItems = $scope.myCookingListItemsUpper;
        $scope.editMyCookingSelectedListItems = $scope.editMyCookingListItemsUpper;
        $scope.healthyCookContents = $scope.healthyCookContentsUpper;
        $scope.easyCookContents = $scope.easyCookContentsUpper;
        $scope.currentRunningModeUpper = getDeviceDataMode($scope.deviceSingleUpperInfo.Mode.modes[0]);
        $scope.currentMode = $scope.currentModeUpper;
        $scope.recipeDescription = $scope.recipeDescriptionUpper;
        $scope.desiredTemp = $scope.bFahrenheit ? $scope.desiredTempUpper : FtoC($scope.desiredTempUpper);
        $scope.minTemp = $scope.bFahrenheit ? $scope.minTempUpper : FtoC($scope.minTempUpper);
        $scope.maxTemp = $scope.bFahrenheit ? $scope.maxTempUpper : FtoC($scope.maxTempUpper);
        $scope.desiredHours = $scope.desiredHoursUpper;
        $scope.desiredMinutes = $scope.desiredMinutesUpper;
        $scope.currentTemp = $scope.deviceSingleUpperInfo.Temperatures[0].current;
        $scope.currentTempUpper = $scope.deviceSingleUpperInfo.Temperatures[0].current;
        $scope.remainingTime = convertTimeHMMformat($scope.deviceSingleUpperInfo.Operation.remainingTime);
        $scope.operationTime = convertTimeHMMformat($scope.deviceSingleUpperInfo.Operation.operationTime);
        $scope.operationTimeUpper = $scope.operationTime;
        $scope.timeLeftUpper = claculateLeftTime($scope.deviceSingleUpperInfo.Operation.remainingTime);
        $scope.progressBarPercentageUpper = $scope.deviceSingleUpperInfo.Operation.progressPercentage;
        $scope.progressBarPercentage = $scope.deviceSingleUpperInfo.Operation.progressPercentage;
        $scope.screenStateUpper = $scope.deviceSingleUpperInfo.Oven.state;
        $scope.screenState = $scope.deviceSingleUpperInfo.Oven.state;
        $scope.operationStateStateUpper = $scope.deviceSingleUpperInfo.Operation.state;
        $scope.operationStateState = $scope.operationStateStateUpper;
        $scope.timeLeft = $scope.timeLeftUpper;
        //loadAMCData($scope.readyStateContentsDualUpper[0].values[0]);
        $scope.remainingTimeUpper = $scope.desiredHoursUpper + ':' + $scope.desiredMinutesUpper;
        $scope.oneMinutesRemainingTimeUpper = oneMinReadyMode(0, $scope.operationTime, $scope.remainingTime);
        $scope.oneMinutesRemainingTime = $scope.oneMinutesRemainingTimeUpper;

        if ($scope.deviceSingleUpperInfo.Operation.state === 'Ready') {
            if (!userPreferneceSingleUpper.preferneceMode) {
                saveUserValueSingleUpper($scope.currentModeUpper, $scope.desiredTempUpper, $scope.desiredHoursUpper, $scope.desiredMinutesUpper);
            } else {
                getUserPreferencedValue(userPreferneceSingleUpper);
                $scope.desiredTempUpper = $scope.desiredTemp;
                $scope.remainingTimeUpper = $scope.desiredHours + ':' + $scope.desiredMinutes;
            }
        }

        if ($scope.deviceDualLowerInfo !== undefined && $scope.deviceDualLowerInfo.Operation.state === 'Run') {
            $scope.desiredTempUpper = $scope.deviceDualLowerInfo.Temperatures[0].desired !== 0 ? $scope.deviceDualLowerInfo.Temperatures[0].desired : $scope.desiredTempUpper;
            $scope.desiredTemp = $scope.desiredTempUpper;
            $scope.minTempUpper = setMinTempValue($scope.desiredTempUpper);
            $scope.maxTempUpper = setMaxTempValue($scope.desiredTempUpper);
            $scope.minTemp = $scope.minTempUpper;
            $scope.maxTemp = $scope.maxTempUpper;
        }

        if ($scope.deviceSingleUpperInfo.Operation.state === 'Run') {
            userPreferneceSingleUpper = {};
            $scope.currentModeUpper = $scope.currentRunningModeUpper;
            $scope.currentMode = $scope.currentModeUpper;
            $scope.remainingTimeUpper = convertTimeHMMformat($scope.deviceSingleUpperInfo.Operation.remainingTime);
            $scope.desiredTemp = $scope.deviceSingleUpperInfo.Temperatures[0].desired;
            $scope.desiredTempUpper = $scope.deviceSingleUpperInfo.Temperatures[0].desired;
            $scope.desiredEditTempUpper = $scope.deviceSingleUpperInfo.Temperatures[0].desired;
            $scope.desiredEditHoursUpper = Number($scope.remainingTime.split(':')[0]);
            $scope.desiredEditMinutesUpper = Number($scope.remainingTime.split(':')[0]) === 0 && Number($scope.remainingTime.split(':')[1]) === 0 ? 1 : Number($scope.remainingTime.split(':')[1]);

            if ($scope.deviceSingleUpperInfo.Oven.state === "Preheat") {
                $scope.ProgressPreheatMode = true;
                $scope.ProgressPreheatModeUpper = true;
                $scope.ProgressDescription = "WEBMOB_device_range_cooking_preheating";
            } else if ($scope.deviceSingleUpperInfo.Oven.state === "Cooking") {
                $scope.ProgressPreheatMode = false;
                $scope.ProgressPreheatModeUpper = false;
                $scope.ProgressDescription = "WEBMOB_device_range_cooking_in_progress";
            } else if (deviceUpperMode.indexOf('Clean') === -1 && $scope.deviceSingleUpperInfo.Oven.state === "Finish") {
                snoozUpper = false;
                closeOperationState();
                $scope.bCookingFinished = true;
                $scope.operationCompleteUpper = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cooking_finish_message";
                validateOperationCompletionStateScreen();
                return;
            } else if ($scope.deviceSingleUpperInfo.Oven.state === "Delay") {
                $scope.ProgressPreheatMode = false;
                $scope.ProgressPreheatModeUpper = false;
                $scope.ProgressDescription = "WEBMOB_device_range_delay_in_progress";
            } else {
                $scope.ProgressDescription = "WEBMOB_device_range_cooking_in_progress";
            }
            $scope.ProgressDescriptionUpper = $scope.ProgressDescription;

            if (deviceUpperMode === "UpperBroil") {
                debugMessage("Broil Mode and temp : " + $scope.deviceSingleUpperInfo.Temperatures[0].desired);
                $scope.BroilTemp = Number($scope.deviceSingleUpperInfo.Temperatures[0].desired) === 61442 ? 'Low' : 'High';
            }

            if (Number($scope.deviceSingleUpperInfo.Temperatures[0].desired) === 61442) {
                $scope.BroilTemp = 'Low';
                $scope.SlowCookTemp = 'Low';
            } else {
                $scope.BroilTemp = 'High';
                $scope.SlowCookTemp = 'High';
            }

            if ($scope.editMode && EditMode === 'UPPER') {
                debugMessage("reset edit mode value for " + EditMode);
                $scope.desiredEditProgressDescription = $scope.ProgressDescription;
                $scope.desiredEditTemp = $scope.desiredEditTempUpper;
                $scope.desiredEditHours = $scope.desiredEditHoursUpper;
                $scope.desiredEditMinutes = $scope.desiredEditMinutesUpper;
                $scope.desiredEditcurrentMode = $scope.currentModeUpper;
            }
        }
    }

    function setDataCurrentDualLowerScreen() {
        debugMessage("setDataCurrentDualLowerScreen :");

        if ($scope.deviceDualLowerInfo.Operation.state === 'Run') {
            deviceLowerMode = ($scope.deviceDualLowerInfo.Mode.modes[0] !== 'NoOperation'
                    && $scope.deviceDualLowerInfo.Mode.modes[0] !== '')
                    ? $scope.deviceDualLowerInfo.Mode.modes[0] : deviceLowerMode;
        }
        if ($scope.deviceDualLowerInfo.Operation.state === 'Ready' && setDefaultModeLower) {
            userPreferneceDualLower = {};
            setDefaultModeLower = false;
            deviceLowerMode = 'LowerBake';
        }
        if (!myCookingModeTrue) {
            $scope.readyStateContentsDualLower = db.exec("SELECT * FROM " + setTableName(deviceLowerMode) + " WHERE MODE = '" + deviceLowerMode + "'");
        }
        getValueForDualLowerMode();

        deviceMode = deviceLowerMode;
        userPreferneceSingleSinlge = {};
        $scope.modeSupport = false;
        $scope.ovenFunctionContents = $scope.ovenFunctionContentsLower;
        $scope.myCookingSelectedListItems = $scope.myCookingListItemsLower;
        $scope.editMyCookingSelectedListItems = $scope.editMyCookingListItemsLower;
        $scope.healthyCookContents = $scope.healthyCookContentsLower;
        $scope.easyCookContents = $scope.easyCookContentsLower;
        $scope.currentRunningModeLower = getDeviceDataMode($scope.deviceDualLowerInfo.Mode.modes[0]);
        $scope.currentMode = $scope.currentModeLower;
        $scope.recipeDescription = $scope.recipeDescriptionLower;
        $scope.desiredTemp = $scope.bFahrenheit ? $scope.desiredTempLower : FtoC($scope.desiredTempLower);
        $scope.minTemp = $scope.bFahrenheit ? $scope.minTempLower : FtoC($scope.minTempLower);
        $scope.maxTemp = $scope.bFahrenheit ? $scope.maxTempLower : FtoC($scope.maxTempLower);
        $scope.desiredHours = $scope.desiredHoursLower;
        $scope.desiredMinutes = $scope.desiredMinutesLower;
        $scope.currentTemp = $scope.deviceDualLowerInfo.Temperatures[0].current;
        $scope.currentTempLower = $scope.deviceDualLowerInfo.Temperatures[0].current;
        $scope.remainingTime = convertTimeHMMformat($scope.deviceDualLowerInfo.Operation.remainingTime);
        $scope.timeLeftLower = claculateLeftTime($scope.deviceDualLowerInfo.Operation.remainingTime);
        $scope.progressBarPercentageLower = $scope.deviceDualLowerInfo.Operation.progressPercentage;
        $scope.progressBarPercentage = $scope.deviceDualLowerInfo.Operation.progressPercentage;
        $scope.screenState = $scope.deviceDualLowerInfo.Oven.state;
        $scope.screenStateLower = $scope.deviceDualLowerInfo.Oven.state;
        $scope.operationStateStateLower = $scope.deviceDualLowerInfo.Operation.state;
        $scope.operationStateState = $scope.operationStateStateLower;
        $scope.timeLeft = $scope.timeLeftLower;
        //loadAMCData($scope.readyStateContentsDualLower[0].values[0]);
        $scope.remainingTimeLower = $scope.desiredHoursLower + ':' + $scope.desiredMinutesLower;
        $scope.operationTime = convertTimeHMMformat($scope.deviceDualLowerInfo.Operation.operationTime);
        $scope.operationTimeLower = $scope.operationTime;
        $scope.oneMinutesRemainingTimeLower = oneMinReadyMode(1, $scope.operationTime, $scope.remainingTime);
        $scope.oneMinutesRemainingTime = $scope.oneMinutesRemainingTimeLower;

        if ($scope.deviceDualLowerInfo.Operation.state === 'Ready') {
            if (!userPreferneceDualLower.preferneceMode) {
                saveUserValueDualLower($scope.currentModeLower, $scope.desiredTempLower, $scope.desiredHoursLower, $scope.desiredMinutesLower);
            } else {
                getUserPreferencedValue(userPreferneceDualLower);
                $scope.desiredTempLower = $scope.desiredTemp;
                $scope.remainingTimeLower = $scope.desiredHours + ':' + $scope.desiredMinutes;
            }
        }

        if ($scope.deviceSingleUpperInfo !== undefined && $scope.deviceSingleUpperInfo.Operation.state === 'Run') {
            $scope.desiredTempLower = $scope.deviceSingleUpperInfo.Temperatures[0].desired !== 0 ? $scope.deviceSingleUpperInfo.Temperatures[0].desired : $scope.desiredTempLower;
            if ($scope.desiredTempLower === 61441) {
                $scope.desiredTempLower = $scope.bFahrenheit ? 480 : 248;
            }
            if ($scope.desiredTempLower === 61442) {
                $scope.desiredTempLower = $scope.bFahrenheit ? 400 : 204;
            }
            $scope.desiredTemp = $scope.desiredTempLower;
            $scope.minTempLower = setMinTempValue($scope.desiredTempLower);
            $scope.maxTempLower = setMaxTempValue($scope.desiredTempLower);
            $scope.minTemp = $scope.minTempLower;
            $scope.maxTemp = $scope.maxTempLower;
        }

        if ($scope.deviceDualLowerInfo.Operation.state === "Run") {
            userPreferneceDualLower = {};
            $scope.currentModeLower = $scope.currentRunningModeLower;
            $scope.currentLower = $scope.currentModeLower;
            $scope.remainingTimeLower = convertTimeHMMformat($scope.deviceDualLowerInfo.Operation.remainingTime);
            $scope.desiredTemp = $scope.deviceDualLowerInfo.Temperatures[0].desired;
            $scope.desiredTempLower = $scope.deviceDualLowerInfo.Temperatures[0].desired;
            $scope.desiredEditTempLower = $scope.deviceDualLowerInfo.Temperatures[0].desired;
            $scope.desiredEditHoursLower = Number($scope.remainingTime.split(':')[0]);
            $scope.desiredEditMinutesLower = Number($scope.remainingTime.split(':')[0]) === 0 && Number($scope.remainingTime.split(':')[1]) === 0 ? 1 : Number($scope.remainingTime.split(':')[1]);

            if ($scope.deviceDualLowerInfo.Oven.state === "Preheat") {
                $scope.ProgressDescription = "WEBMOB_device_range_cooking_preheating";
                $scope.ProgressPreheatMode = true;
                $scope.ProgressPreheatModeLower = true;
            } else if ($scope.deviceDualLowerInfo.Oven.state === "Cooking") {
                $scope.ProgressDescription = "WEBMOB_device_range_cooking_in_progress";
                $scope.ProgressPreheatMode = false;
                $scope.ProgressPreheatModeLower = false;
            } else if (deviceLowerMode.indexOf('Clean') === -1 && $scope.deviceDualLowerInfo.Oven.state === "Finish") {
                snoozLower = false;
                closeOperationState();
                $scope.bCookingFinished = true;
                $scope.operationCompleteLower = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cooking_finish_message";
                validateOperationCompletionStateScreen();
                return;
            } else if ($scope.deviceDualLowerInfo.Oven.state === "Delay") {
                $scope.ProgressPreheatMode = false;
                $scope.ProgressPreheatModeLower = false;
                $scope.ProgressDescription = "WEBMOB_device_range_delay_in_progress";
            } else {
                $scope.ProgressDescription = "WEBMOB_device_range_cooking_in_progress";
            }
            $scope.ProgressDescriptionLower = $scope.ProgressDescription;
            if ($scope.editMode && EditMode === 'LOWER') {
                debugMessage("reset edit mode value for " + EditMode);
                $scope.desiredEditProgressDescription = $scope.ProgressDescription;
                $scope.desiredEditTemp = $scope.desiredEditTempLower;
                $scope.desiredEditHours = $scope.desiredEditHoursLower;
                $scope.desiredEditMinutes = $scope.desiredEditMinutesLower;
                $scope.desiredEditcurrentMode = $scope.currentModeLower;
            }
        }
    }

    function idZeroOperationState() {
        var idZeroOperationState = '';
        if ($scope.deviceSingleUpperInfo.Oven.state === 'Preheat' || $scope.deviceSingleUpperInfo.Oven.state === 'Cooking') {
            if ($scope.meatProbeConnected) {
                idZeroOperationState = 'CookingNormalProbe';
            } else {
                if ($scope.deviceSingleUpperInfo.Mode.modes[0] === '') {
                    idZeroOperationState = 'Cooking--'; //Mode Check
                } else if ($scope.deviceSingleUpperInfo.Mode.modes[0] === 'Broil' || $scope.deviceSingleUpperInfo.Mode.modes[0].indexOf("ealthycook3") !== -1 && $scope.DeviceModelName === 'NX9000KW/AA0') {
                    idZeroOperationState = 'CookingBroil';
                } else if ($scope.deviceSingleUpperInfo.Mode.modes[0].indexOf("asycook1") !== -1) {
                    idZeroOperationState = 'CookingSlowCook';
                } else if ($scope.deviceSingleUpperInfo.Mode.modes[0].indexOf("asycook3") !== -1 || $scope.deviceSingleUpperInfo.Mode.modes[0].indexOf("ealthycook6") !== -1) {
                    idZeroOperationState = 'CookingBreadProof';
                } else if ($scope.deviceSingleUpperInfo.Mode.modes[0] === 'KeepWarm') {
                    idZeroOperationState = 'CookingKeepWarm';
                } else {
                    idZeroOperationState = 'CookingNormal';
                }
            }
            if ($scope.operationTime !== '0:00' && $scope.remainingTime === '0:00') {
                idZeroOperationState = 'OneMinuteRemain';
            }
        } else if ($scope.deviceSingleUpperInfo.Oven.state === 'Delay') {
            if ($scope.meatProbeConnected) {
                idZeroOperationState = 'CookingDelayProbe';
            } else if ($scope.deviceSingleUpperInfo.Mode.modes[0].indexOf("asycook1") !== -1) {
                idZeroOperationState = 'CookingSlowCookDelay';
            } else {
                idZeroOperationState = 'CookingDelay';
            }
        } else if ($scope.deviceSingleUpperInfo.Oven.state === 'Finish') {
            idZeroOperationState = 'Finish';
        } else if ($scope.deviceSingleUpperInfo.Oven.state === 'Cleaning') {
            idZeroOperationState = 'CookingSelfClean';
        } else if ($scope.deviceSingleUpperInfo.Oven.state === 'Warming') {
            idZeroOperationState = 'CookingKeepWarm';
        }
        debugMessage('Display idZeroOperationState with screen > ' + idZeroOperationState);
        $scope.SingleOvenState = idZeroOperationState;
    }

    function preValidateSendRecipeDataCheck() {
        if (recipeDataValidated === false && $scope.currentScreen === RANGESCREENS.RANGE_SEND_CONFERMATION_PAGE) {
            if (($scope.validateSendRecipeInfo.UpperState !== ''
                    && $scope.validateSendRecipeInfo.UpperState !== $scope.deviceSingleUpperInfo.Operation.state)
                    || ($scope.validateSendRecipeInfo.LowerState !== ''
                            && $scope.validateSendRecipeInfo.LowerState !== $scope.deviceDualLowerInfo.Operation.state)) {
                recipeDataValidated = true;
            }
        }
    }

    function validateSendRecipeData() {
        if (($scope.validateSendRecipeInfo.Mode === $scope.deviceSingleUpperInfo.Mode.modes[0]
                || ($scope.validateSendRecipeInfo.Mode === $scope.deviceDualLowerInfo.Mode.modes[0]))
                && (($scope.validateSendRecipeInfo.OperationTime === $scope.deviceSingleUpperInfo.Operation.operationTime
                        || $scope.validateSendRecipeInfo.OperationTime === $scope.deviceDualLowerInfo.Operation.operationTime)
                        || (parseInt($scope.validateSendRecipeInfo.DesiredProbeTemp, 10) === $scope.deviceSingleUpperInfo.Temperatures[1].desired))
                && ((parseInt($scope.validateSendRecipeInfo.DesiredTemp, 10) === $scope.deviceSingleUpperInfo.Temperatures[0].desired
                        || parseInt($scope.validateSendRecipeInfo.SlowCookTemp, 10) === $scope.deviceSingleUpperInfo.Temperatures[0].desired)
                        || parseInt($scope.validateSendRecipeInfo.DesiredTemp, 10) === $scope.deviceDualLowerInfo.Temperatures[0].desired)) {

            if ($scope.ElectricModel) {
                var deviceId;
                if ($scope.dividerConnected && $scope.RunningUpperOven) {
                    deviceId = 0;
                } else if ($scope.dividerConnected && $scope.RunningLowerOven) {
                    deviceId = 1;
                } else {
                    deviceId = 0;
                }
                debugMessage("Direct Start For ELectric model");
                recipeDataValidated = true;
                startConfirmationOK(deviceId);
            } else {
                if (($scope.validateSendRecipeInfo.UpperState !== ''
                        && $scope.validateSendRecipeInfo.UpperState !== $scope.deviceSingleUpperInfo.Operation.state)
                        || ($scope.validateSendRecipeInfo.LowerState !== ''
                                && $scope.validateSendRecipeInfo.LowerState !== $scope.deviceDualLowerInfo.Operation.state)) {
                    recipeDataValidated = true;
                }
                dismissLoadingBar(RANGE_COMMANDS.sendRecipetoOven);
                $scope.sendConfermationApplyButton = $scope.DeviceModelName.indexOf('NE') !== -1;
                validateCurrentScreen('SendConfirmationPage');
            }
        }
    }

    function getErrorCode(errorEnum) {
        switch (errorEnum) {
            case 'RG_E_C-d0':
                return "C-d0";
            case 'RG_E_C-20': //FALL-THROUGH
                return "C-20";
            case 'RG_E_C-21': //FALL-THROUGH
                return "C-21";
            case 'RG_E_C-23':
                return "C-23";
            case 'RG_E_C-d1':
                return "C-d1";
            case 'RG_E_-dC-':
                return "-dC-";
            case 'RG_E_C-F0': //FALL-THROUGH
                return "C-F0";
            case 'RG_E_007A':
                return "C-72";
            case 'RG_E_C-F2':
                return "C-F2";
            case 'RG_E_C-A2':
                return "C-A2";
            case 'RG_E_C-30':
                return "C-30";
            case 'RG_E_C-31':
                return "C-31";
            case 'RG_E_fff': //FALL-THROUGH
            case 'Undefined':
            default:
                return "";
        }
    }

    function getAlarmStatusUpper() {
        if ($scope.deviceSingleUpperInfo.Alarms[0] !== undefined && $scope.deviceSingleUpperInfo.Alarms[0] !== null && $scope.deviceSingleUpperInfo.Alarms[0].code !== '-1') {
            debugMessage('Check for alarm status 0 :' + $scope.deviceSingleUpperInfo.Alarms[0].code);

            if ($scope.deviceSingleUpperInfo.Alarms[0].code === 'RG_E') {
                if (snoozUpper) {
                    debugMessage('snoozUpper available');
                    return;
                }
                emptyAlarm();
                errorRemoved = true;
                if (!justFirstTime && !$scope.appAtForeground && !configCall) {
                    emptyValuesFreshLaunch();
                }
                return false;
            }
            if (!errorRemoved) {
                debugMessage('Check error status');
                return;
            }

            if ($scope.deviceSingleUpperInfo.Alarms[0].code.indexOf("RG_E") !== -1) {
                $scope.errorCode = getErrorCode($scope.deviceSingleUpperInfo.Alarms[0].code);
                if ($scope.errorCode !== '') {
                    errorRemoved = false;
                    validateCurrentScreen('ErrorPage');
                    return true;
                } else {
                    return false;
                }
            } else if ($scope.deviceSingleUpperInfo.Alarms[0].code === "RG_T_0001") {
                $scope.upperPreheat = true;
                $scope.lowerPreheat = false;
                showcustDialog(RANGE_ALERT_STATE.ALERT_PREHEATCOMPLETE, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_alarm_finish_preheating, $scope.translation.WEBMOB_common_ok, '');
                $scope.deviceSingleUpperInfo.Alarms[0].code = '-1';
                return true;
            } else if ($scope.deviceSingleUpperInfo.Alarms[0].code === "RG_T_0003") {
                snoozUpper = false;
                closeOperationState();
                $scope.bCookingFinished = true;
                $scope.operationCompleteUpper = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cooking_finish_message";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.deviceSingleUpperInfo.Alarms[0].code === "RG_T_0004") {
                snoozUpper = true;
                showcustDialog(RANGE_ALERT_STATE.ALERT_COOKING_SNOOZE, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_alarm_finish_snooze, $scope.translation.WEBMOB_common_cancel, $scope.translation.WEBMOB_device_range_comm_finish_snooze_min);
                $scope.deviceSingleUpperInfo.Alarms[0].code = '-1';
                return true;
            } else if ($scope.deviceSingleUpperInfo.Alarms[0].code === "RG_T_0005") { // TODO EXTRA
                closeOperationState();
                $scope.bProgressCompletdNormal = true;
                $scope.operationCompleteUpper = true;
                $scope.operationCompletedorCanceledMSG = "OVENMOB_LCD_CookingFinishAlarm";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.deviceSingleUpperInfo.Alarms[0].code === "RG_T_0006") {
                snoozUpper = false;
                closeOperationState();
                if ($scope.dividerConnected) {
                    okOperationCompleteUpper();
                } else {
                    okOperationComplete();
                }
                return !true;
                $scope.bCookingCancelled = true;
                $scope.operationCompleteUpper = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cooking_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.deviceSingleUpperInfo.Alarms[0].code === "RG_T_0007" || $scope.deviceSingleUpperInfo.Alarms[0].code === "RG_T_0011") {
                snoozUpper = false;
                closeOperationState();
                $scope.bCleaningFinished = true;
                $scope.operationCompleteUpper = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cleaning_completed";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.deviceSingleUpperInfo.Alarms[0].code === "RG_T_0008" || $scope.deviceSingleUpperInfo.Alarms[0].code === "RG_T_0012") {
                snoozUpper = false;
                closeOperationState();
                if ($scope.dividerConnected) {
                    okOperationCompleteUpper();
                } else {
                    okOperationComplete();
                }
                return !true;
                $scope.bCleaningCancelled = true;
                $scope.operationCompleteUpper = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cleaning_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.deviceSingleUpperInfo.Alarms[0].code === "RG_T_0040") {
                snoozUpper = false;
                closeOperationState();
                if ($scope.dividerConnected) {
                    okOperationCompleteUpper();
                } else {
                    okOperationComplete();
                }
                return !true;
                $scope.bCookingCancelled = true;
                $scope.operationCompleteUpper = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_warming_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else {
                return false;
            }
        }
        return false;
    }

    function getAlarmStatusLower() {
        if ($scope.deviceDualLowerInfo.Alarms[0] !== undefined && $scope.deviceDualLowerInfo.Alarms[0] !== null && $scope.deviceDualLowerInfo.Alarms[0].code !== '-1') {
            debugMessage('Check for alarm status 1 :' + $scope.deviceDualLowerInfo.Alarms[0].code);

            if ($scope.deviceDualLowerInfo.Alarms[0].code.indexOf("RG_E") !== -1) {
                $scope.errorCode = getErrorCode($scope.deviceDualLowerInfo.Alarms[0].code);
                if ($scope.errorCode !== '') {
                    validateCurrentScreen('ErrorPage');
                    return true;
                } else {
                    return false;
                }
            } else if ($scope.deviceDualLowerInfo.Alarms[0].code === "RG_T_1001") {
                $scope.upperPreheat = false;
                $scope.lowerPreheat = true;
                showcustDialog(RANGE_ALERT_STATE.ALERT_PREHEATCOMPLETE, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_alarm_finish_preheating, $scope.translation.WEBMOB_common_ok, '');
                $scope.deviceDualLowerInfo.Alarms[0].code = '-1';
                return true;
            } else if ($scope.deviceDualLowerInfo.Alarms[0].code === "RG_T_1003") {
                snoozLower = false;
                closeOperationState();
                $scope.bCookingFinished = true;
                $scope.operationCompleteLower = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cooking_finish_message";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.deviceDualLowerInfo.Alarms[0].code === "RG_T_1004") {
                snoozLower = true;
                showcustDialog(RANGE_ALERT_STATE.ALERT_COOKING_SNOOZE, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_alarm_finish_snooze, $scope.translation.WEBMOB_common_cancel, $scope.translation.WEBMOB_device_range_comm_finish_snooze_min);
                $scope.deviceDualLowerInfo.Alarms[0].code = '-1';
                return true;
            } else if ($scope.deviceDualLowerInfo.Alarms[0].code === "RG_T_1005") { // TODO EXTRA
                closeOperationState();
                $scope.bProgressCompletdNormal = true;
                $scope.operationCompleteLower = true;
                $scope.operationCompletedorCanceledMSG = "OVENMOB_LCD_CookingFinishAlarm";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.deviceDualLowerInfo.Alarms[0].code === "RG_T_1006") {
                snoozLower = false;
                closeOperationState();
                okOperationCompleteLower();
                return !true;
                $scope.bCookingCancelled = true;
                $scope.operationCompleteLower = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cooking_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.deviceDualLowerInfo.Alarms[0].code === "RG_T_1007") {
                snoozLower = false;
                closeOperationState();
                $scope.bCleaningFinished = true;
                $scope.operationCompleteLower = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cleaning_completed";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.deviceDualLowerInfo.Alarms[0].code === "RG_T_1008") {
                snoozLower = false;
                closeOperationState();
                okOperationCompleteLower();
                return !true;
                $scope.bCleaningCancelled = true;
                $scope.operationCompleteLower = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cleaning_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.deviceDualLowerInfo.Alarms[0].code === "RG_T_0040") {
                snoozUpper = false;
                closeOperationState();
                okOperationCompleteLower();
                return !true;
                $scope.bCookingCancelled = true;
                $scope.operationCompleteLower = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_warming_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else {
                return false;
            }
        }
        return false;
    }

    function getProbeDividerError() {
        if ($scope.deviceSingleUpperInfo.Mode.options[0].meatprobe === "connected" && $scope.deviceSingleUpperInfo.connected) {
            return true;
        }
        return false;
    }

    function dismissSendCommand() {
        if ($scope.checkResponse.indexOf(RANGE_COMMANDS.sendRecipetoOven) !== -1) {
            dismissLoadingBar(RANGE_COMMANDS.sendRecipetoOven);
        }
    }

    function dismissOKCommand() {
        if ($scope.checkResponse.indexOf(RANGE_COMMANDS.startConfirmationOK) !== -1) {
            dismissLoadingBar(RANGE_COMMANDS.startConfirmationOK);
        }
    }

    function dismissCancelCookingCommand() {
        if ($scope.checkResponse.indexOf(RANGE_COMMANDS.cancelCooking) !== -1) {
            dismissLoadingBar(RANGE_COMMANDS.cancelCooking);
        }
    }

    function loadingValues() {
        dismissLoadingBar(RANGE_COMMANDS.getDevices);
        dismissLoadingBar(RANGE_COMMANDS.runOnNative);
        if ($scope.deviceSingleUpperInfo !== undefined && $scope.deviceSingleUpperInfo.Operation.state === 'Run'
                || $scope.deviceDualLowerInfo !== undefined && $scope.deviceDualLowerInfo.Operation.state === 'Run') {
            if ($scope.checkResponse.indexOf(RANGE_COMMANDS.sendRecipetoOven) !== -1) {
                $timeout(function () {
                    dismissSendCommand();
                }, 20000);
            }
            if ($scope.checkResponse.indexOf(RANGE_COMMANDS.startConfirmationOK) !== -1) {
                $timeout(function () {
                    dismissOKCommand();
                }, 20000);
            }
        }
        if ($scope.deviceSingleUpperInfo !== undefined && $scope.deviceSingleUpperInfo.Operation.state === 'Ready'
                || $scope.deviceDualLowerInfo !== undefined && $scope.deviceDualLowerInfo.Operation.state === 'Ready') {
            if ($scope.checkResponse.indexOf(RANGE_COMMANDS.cancelCooking) !== -1) {
                $timeout(function () {
                    dismissCancelCookingCommand();
                }, 20000);
            }
        }
    }

    function showCurrentScreen() {
        debugMessage("showCurrentScreen called");

        if ($scope.deviceSingleUpperInfo === undefined) {
            debugMessage("deviceSingleUpperInfo is undefined");
            return;
        }

        if ($scope.deviceDualLowerInfo === undefined) {
            debugMessage("deviceDualLowerInfo is undefined");
            return;
        }

        preValidateSendRecipeDataCheck();

        if (!recipeDataValidated && !showCookTop) {
            validateSendRecipeData();
            debugMessage('return due to recipeDataValidated');
            return;
        }
        loadingValues();

        if ($scope.alertOn || $scope.setTimenTempClicked) {
            return;
        }

        if (getAlarmStatusUpper()) {
            if ($scope.operationCompleteUpper) {
                debugMessage('operationCompleteUpper Upper/Single alarms screen');
                setDataCurrentScreen();
                if ($scope.dividerConnected) {
                    validateCurrentScreen('ReadyPage');
                } else {
                    if (doNotChangeScreen) {
                        okOperationComplete();
                        debugMessage('return due to doNotChangeScreen from getAlarmStatusUpper()');
                        return;
                    }
                    validateCurrentScreen('OperationCompletePage');
                    return;
                }
            } else {
                debugMessage('return due to Upper/Single alarms');
                return;
            }
        }

        if (!errorRemoved) {
            debugMessage("return due to error not removed");
            validateCurrentScreen('ErrorPage');
            return;
        }

        if (getAlarmStatusLower()) {
            if ($scope.operationCompleteLower) {
                debugMessage('operationCompleteLower Lower alarms screen');
                setDataCurrentScreen();
                validateCurrentScreen('ReadyPage');
            } else {
                debugMessage('return due to Lower alarms');
                return;
            }
        }

        if (getProbeDividerError()) {
            validateCurrentScreen('ProbeDividerErrorPage');
            debugMessage('return due to probe divider error screen');
            return;
        }

        if (showCookTop) {
            $scope.cookTopType = getCookTopModetType($scope.DeviceModelName);
            $scope.cookTopValues = readCooktopValue($scope.deviceDualLowerInfo.Mode.options[0].Cooktop, 5);
            $scope.warmingCenter = readWarmingCenterValue($scope.deviceDualLowerInfo.Mode.options[0].WarmingCenter);
            $scope.SettingOptionVisible = false;
            $scope.AboutOptionVisible = false;
            validateCurrentScreen('CookTopPage');
            return;
        }

        if ($scope.editMode) {
            if ($scope.deviceSingleUpperInfo.Operation.state !== "Run"
                    && $scope.deviceDualLowerInfo.Operation.state !== "Run") {
                $scope.editMode = false;
                editModeTimeUpdate = false;
                debugMessage('editMode = false both mode is in Ready state ');
            }
            if ($scope.dividerConnected && ($scope.deviceSingleUpperInfo.Operation.state === "Run") && (EditMode === 'LOWER' || $scope.RunningLowerOven)) {
                setDataCurrentDualUpperScreen();
            } else if ($scope.dividerConnected && ($scope.deviceDualLowerInfo.Operation.state === "Run") && (EditMode === 'UPPER' || $scope.RunningUpperOven)) {
                setDataCurrentDualLowerScreen();
            }
            setDualStateMaxMinTemp();
            return;
        }

        if (cancelUpper) {
            if ($scope.deviceSingleUpperInfo.Operation.state === 'Ready' && $scope.deviceSingleUpperInfo.Operation.operationTime === '00:00:00') {
                cancelUpper = false;
            } else {
                debugMessage('return due to cancelUpper');
                return;
            }
        }

        if (cancelLower) {
            if ($scope.deviceDualLowerInfo.Operation.state === 'Ready' && $scope.deviceDualLowerInfo.Operation.operationTime === '00:00:00') {
                cancelLower = false;
            } else {
                debugMessage('return due to cancelLower');
                return;
            }
        }

        if (OperationScreen) {
            debugMessage('return due to OperationScreen');
            validateCurrentScreen('OperationCompletePage');
            return;
        }

        if (changeSmartCarePage && ($scope.currentScreen === RANGESCREENS.RANGE_SMART_CARE_PAGE || $scope.currentScreen === RANGESCREENS.RANGE_SMART_CARE_NO_ERROR_PAGE)) {
            if ($scope.currentScreen === RANGESCREENS.RANGE_SMART_CARE_PAGE) {
                validateCurrentScreen('SmartCarePage');
            } else if ($scope.currentScreen === RANGESCREENS.RANGE_SMART_CARE_NO_ERROR_PAGE) {
                validateCurrentScreen('SmartCareNoErrorPage');
            }
            debugMessage('return due to Smart Care');
            return;
        }

        if ($scope.currentScreen === RANGESCREENS.RANGE_PROBE_DIVIDER_ERROR_PAGE) {
            if ($scope.deviceSingleUpperInfo.Mode.options[0].meatprobe === "connected" && $scope.deviceSingleUpperInfo.connected) {
                debugMessage('return due to probe divider error screen');
                return;
            }
        }

        if ($scope.currentScreen === RANGESCREENS.RANGE_ADD_MY_COOKING_PAGE) {
            debugMessage('return due to add my Cooking with updated data');
            return;
        }

        if ($scope.currentScreen === RANGESCREENS.RANGE_EDIT_MY_COOKING_PAGE) {
            debugMessage('return due to edit my Cooking page');
            return;
        }

        if ($scope.dividerConnected && $scope.RunningUpperOven && $scope.deviceSingleUpperInfo.Operation.state === 'Ready' && !changeUpperRecipe) {
            saveUserValueSingleUpper($scope.currentMode, $scope.desiredTemp, $scope.desiredHours, $scope.desiredMinutes);
        }

        if ($scope.dividerConnected && $scope.RunningLowerOven && $scope.deviceDualLowerInfo.Operation.state === 'Ready' && !changeLowerRecipe) {
            saveUserValueDualLower($scope.currentMode, $scope.desiredTemp, $scope.desiredHours, $scope.desiredMinutes);
        }

        if (!$scope.dividerConnected && $scope.deviceSingleUpperInfo.Operation.state === 'Ready' && !changSingleRecipe) {
            saveUserValueSingleSingle($scope.currentMode, $scope.desiredTemp, $scope.desiredProbeTemp, $scope.desiredHours, $scope.desiredMinutes);
        }

        setDataCurrentScreen();

        if ($scope.editMode) {
            setDualStateMaxMinTemp();
        }

        if ($scope.currentScreen === RANGESCREENS.RANGE_AUTO_COOK_PAGE) {
            if (!$scope.dividerConnected) {
                debugMessage('return due to autocook screen');
                return;
            }
        }

        if ($scope.currentScreen === RANGESCREENS.RANGE_AUTO_COOK_DETAIL_PAGE) {
            if (!$scope.dividerConnected) {
                if ($scope.deviceSingleUpperInfo.Operation.state === 'Ready' && !$scope.isStatic) {
                    if ($scope.AutoCookSendRecipeId === $scope.deviceSingleUpperInfo.Oven.recipe) {
                        $scope.checkResponse.push(RANGE_COMMANDS.startConfirmationOK);
                        debugMessage(getstartConfirmationOKCommand() + "/" + $scope.peerId + "/devices/0/operation");
                        SHPService.sendSHPCommand(CONSTANTS.PUT, getstartConfirmationOKCommand(), "/" + $scope.peerId + "/devices/0/operation");
                    }
                    debugMessage('return due to autocook screen detail ');
                    return;
                }
            }
        }

        if (doNotChangeScreen) {
            debugMessage('return due to doNotChangeScreen');
            return;
        }

        if (justFirstTime && $scope.dividerConnected && $scope.deviceSingleUpperInfo.Operation.state !== "Run"
                && $scope.deviceDualLowerInfo.Operation.state === "Run") {
            lowerMoniterClick();
            debugMessage('Show lower running part');
        }
        justFirstTime = false;
        showScreen();
        debugMessage("after showScreen called checkResponse values " + $scope.checkResponse);
    }

    function showScreen() {
        if (doNotChangeScreen) {
            debugMessage('return due to doNotChangeScreen from showScreen');
            return;
        }
        debugMessage("showScreen called");
        if (!showCookTop) {
            if ((!$scope.dividerConnected && $scope.deviceSingleUpperInfo.Operation.state === "Ready")
                    || ($scope.dividerConnected && ($scope.deviceSingleUpperInfo.Operation.state === "Ready"
                            || $scope.deviceDualLowerInfo.Operation.state === "Ready"))) {
                validateCurrentScreen('ReadyPage');
                debugMessage("showCurrentScreen ReadyPage called ");
            } else {
                showDesiredScreen();
            }
        } else {
            validateCurrentScreen('CookTopPage');
        }
    }

    function showDesiredScreen() {
        debugMessage("showDesiredScreen called");
        if (!$scope.editMode) {
            if ($scope.deviceSingleUpperInfo.Oven.state === "Cleaning"
                    || $scope.ovenAutoCookRecipeID !== '0' && deviceSingleMode === 'Autocook' || $scope.deviceSingleUpperInfo.Mode.modes[0] === "Autocook"
                    || $scope.currentRunningMode === "WEBMOB_device_range_cleaning_self_clean" && $scope.deviceSingleUpperInfo.Oven.state !== "Finish") {
                validateCurrentScreen('CleaningPage');
            } else if (!$scope.dividerConnected && $scope.deviceSingleUpperInfo.Oven.state === "Finish") {
                validateCurrentScreen('OperationCompletePage');
            } else if ($scope.dividerConnected && ($scope.deviceSingleUpperInfo.Oven.state === "Finish" || $scope.deviceDualLowerInfo.Oven.state === "Finish")) {
                validateCurrentScreen('ReadyPage');
            } else if ($scope.dividerConnected && operationCompleteDualRun() && $scope.deviceSingleUpperInfo.Operation.state === "Run" && $scope.deviceDualLowerInfo.Operation.state === "Run") {
                validateCurrentScreen('ReadyPage');
            } else {
                validateCurrentScreen('ProgressPage');
            }
        } else {
            validateCurrentScreen('ReadyPage');
        }
    }

    function dismissLoadingBar(value) {
        debugMessage("dismissLoadingBar " + $scope.checkResponse + " value " + value);
        if ($scope.checkResponse.indexOf(value) !== -1) {
            $scope.checkResponse.splice($scope.checkResponse.indexOf(value), 1);
            dismissLoadingBar(value);
            if ($scope.checkResponse.length === 0) {
                $scope.loadingBar = false;
            }
        }
    }

    function requestFailHandler(response) {
        debugMessage(response);
        $scope.loadingBar = false;
        $scope.checkResponse = [];
    }

    function showConnectionFailurePopup() {
        showcustDialog(RANGE_ALERT_STATE.ALERT_CONNECTION_ERROR, $scope.translation.WEBMOB_device_range_alarm_connection_failure_title, $scope.translation.WEBMOB_common_check_power_and_network, '', $scope.translation.WEBMOB_common_ok);
    }

    function closeConnectionFailurePopup() {
        $scope.showFullScreenPopup = false;
    }

    function closeOperationState() {
        debugMessage("closeOperationState ");
        if (!snoozUpper && !snoozLower) {
            $scope.showFullScreenPopup = false;
        }
        $scope.upperPreheat = false;
        $scope.lowerPreheat = false;
        $scope.bCleaningCancelled = false;
        $scope.bCleaningFinished = false;
        $scope.bCookingCancelled = false;
        $scope.bCookingFinished = false;
        $scope.bProgressCompletdNormal = false;
    }

    function okOperationComplete() {
        debugMessage("okOperationComplete ");
        OperationScreen = false;
        deviceSingleMode = 'Bake';
        deviceUpperMode = 'UpperConvectionBake';
        deviceLowerMode = 'LowerBake';
        changSingleRecipe = true;
        myCookingModeTrue = false;
        emptyAlarm();
        userPreferneceDualLower = {};
        userPreferneceSingleUpper = {};
        userPreferneceSingleSinlge = {};
        if ($scope.deviceSingleUpperInfo.Oven.state === 'Finish') {
            IDforCancelCooking = 0;
            onCancelProgressConfirmed();
        } else {
            $scope.operationCompleteUpper = false;
            showCurrentScreen();
        }
    }

    function okOperationCompleteUpper() {
        debugMessage("okOperationCompleteUpper ");
        deviceUpperMode = 'UpperConvectionBake';
        changeUpperRecipe = true;
        changeLowerRecipe = true;
        myCookingModeTrue = false;
        countterU = 1;
        if ($scope.deviceSingleUpperInfo.Alarms[0].code !== "-1") {
            $scope.deviceSingleUpperInfo.Alarms[0].id = '-1';
            $scope.deviceSingleUpperInfo.Alarms[0].code = '-1';
            $scope.deviceSingleUpperInfo.Alarms[0].alarmType = '-1';
            $scope.deviceSingleUpperInfo.Alarms[0].triggeredTime = '-1';
            snoozUpper = false;
        }
        userPreferneceSingleUpper = {};
        userPreferneceSingleSinlge = {};
        if ($scope.deviceSingleUpperInfo.Oven.state === 'Finish') {
            IDforCancelCooking = 0;
            onCancelProgressConfirmed();
        } else {
            $scope.operationCompleteUpper = false;
            showCurrentScreen();
        }
    }

    function okOperationCompleteLower() {
        debugMessage("okOperationCompleteLower ");
        deviceLowerMode = 'LowerBake';
        changeUpperRecipe = true;
        changeLowerRecipe = true;
        myCookingModeTrue = false;
        countterL = 1;
        if ($scope.deviceDualLowerInfo.Alarms[0].code !== "-1") {
            $scope.deviceDualLowerInfo.Alarms[0].id = '-1';
            $scope.deviceDualLowerInfo.Alarms[0].code = '-1';
            $scope.deviceDualLowerInfo.Alarms[0].alarmType = '-1';
            $scope.deviceDualLowerInfo.Alarms[0].triggeredTime = '-1';
            snoozLower = false;
        }
        userPreferneceDualLower = {};
        userPreferneceSingleSinlge = {};
        if ($scope.deviceDualLowerInfo.Oven.state === 'Finish') {
            IDforCancelCooking = 1;
            onCancelProgressConfirmed();
        } else {
            $scope.operationCompleteLower = false;
            showCurrentScreen();
        }
    }

    function okOperationCompleteDual() {
        debugMessage("okOperationCompleteDual ");
        if ($scope.dividerConnected) {
            if ($scope.RunningUpperOven) {
                okOperationCompleteUpper();
            } else if ($scope.RunningLowerOven) {
                okOperationCompleteLower();
            }
        }
    }

    function operationComplete() {
        if ($scope.dividerConnected && $scope.RunningUpperOven) {
            return $scope.operationCompleteUpper || $scope.deviceSingleUpperInfo.Oven.state === "Finish";
        } else if ($scope.dividerConnected && $scope.RunningLowerOven) {
            return $scope.operationCompleteLower || $scope.deviceDualLowerInfo.Oven.state === "Finish";
        }
        return false;
    }

    function operationCompleteDualRun() {
        if ($scope.dividerConnected) {
            return ($scope.operationCompleteUpper || $scope.deviceSingleUpperInfo.Oven.state === "Finish") ||
                    ($scope.operationCompleteLower || $scope.deviceDualLowerInfo.Oven.state === "Finish");
        }
        return false;
    }

    function hideOptionMenu() {
        scroll_middle_area.style.overflowY = "overlay";
        scroll_middle_area.style.position = "absolute";
        $scope.rangeFunctionMenuExpandList = false;
        $scope.AMCFnMenuVisible = false;
        $scope.rangeCurrentMenuSelected = null;
        initializeMenuIconImages();
    }

    function initializeMenuIconImages() {
        var cnt, len = $scope.RangeMenuListItems.length;
        for (cnt = 0; cnt < len && cnt < 4; ++cnt) {
            $scope.menuIconImageCls[cnt] = 'arrow-down-withoutAnim';
        }
        $scope.selectedOpenedMenuHeaderIndex = -1;
    }

    function changeMenuIconImageCls(index) {
        if (index > 3) {
            initializeMenuIconImages();
            return;
        }
        if ($scope.menuIconImageCls[index] === 'arrow-down-withoutAnim' || $scope.menuIconImageCls[index] === 'arrow-up-withAnimation') {
            $scope.menuIconImageCls[index] = 'arrow-down-withAnim';
        } else {
            $scope.menuIconImageCls[index] = 'arrow-up-withAnimation';
        }
        if ($scope.selectedOpenedMenuHeaderIndex !== -1 && $scope.selectedOpenedMenuHeaderIndex !== index) {
            $scope.menuIconImageCls[$scope.selectedOpenedMenuHeaderIndex] = 'arrow-up-withAnimation';
        }
        $scope.selectedOpenedMenuHeaderIndex = index;

    }

    function checkForDivider() {
        if ($scope.deviceSingleUpperInfo !== undefined || $scope.deviceDualLowerInfo !== undefined) {
            debugMessage("Dual Mode is : " + ($scope.deviceSingleUpperInfo.connected && $scope.deviceDualLowerInfo.connected));
            return $scope.dividerConnected = $scope.deviceSingleUpperInfo.connected && $scope.deviceDualLowerInfo.connected;
        }
    }

    function isNegativeTemp() {
        //debugMessage("isNegativeTemp " + $scope.minTemp +" && " +$scope.maxTemp);
        return $scope.minTemp === -1 || $scope.maxTemp === -1 || $scope.desiredTemp === -1;
    }

    function isZeroTemp() {
        if ($scope.currentRunningMode !== undefined) {
            //debugMessage("isZeroTemp " + ($scope.currentRunningMode === 'WEBMOB_device_range_keep_warm' || $scope.currentRunningMode.indexOf('_bread_proof') !== -1));
            return ($scope.currentRunningMode === 'WEBMOB_device_range_keep_warm' || $scope.currentRunningMode.indexOf('_bread_proof') !== -1);
        }
    }

    function isDelay() {
        if ($scope.deviceSingleUpperInfo !== undefined && $scope.deviceDualLowerInfo !== undefined) {
            //debugMessage("isDelay " + ($scope.deviceSingleUpperInfo.Oven.state === 'Delay' || $scope.deviceDualLowerInfo.Oven.state === 'Delay));
            return ($scope.deviceSingleUpperInfo.Oven.state === 'Delay' || $scope.deviceDualLowerInfo.Oven.state === 'Delay');
        }
    }

    function checkForMeatProbe() {
        if ($scope.deviceSingleUpperInfo !== undefined) {
            //debugMessage("MeatProbe Connected : " + ($scope.deviceSingleUpperInfo.Mode.options[0].meatprobe !== "disconnected"));
            return $scope.meatProbeConnected = (!$scope.dividerConnected && $scope.deviceSingleUpperInfo.Mode.options[0].meatprobe !== "disconnected" && $scope.modeSupport);
        }
        return false;
    }

    function oneMinReadyMode(id, operationTime, remainingTime) {
        //debugMessage("oneMinReadyMode " + id + " operationTime " + operationTime + " remainingTime " + remainingTime + " && " + (operationTime !== '0:00' && remainingTime === '0:00'));
        if (id === 0 && $scope.deviceSingleUpperInfo.Oven.state === 'Finish') {
            return false;
        }
        if (id === 1 && $scope.deviceDualLowerInfo.Oven.state === 'Finish') {
            return false;
        }
        return operationTime !== '0:00' && remainingTime === '0:00';
    }

    function lowerMoniterClick() {
        debugMessage("lowerMoniterClick");
        $scope.UpperMoniter = true;
        $scope.RunningUpperOven = false;
        $scope.RunningLowerOven = true;
        $scope.editMode = false;
        editModeTimeUpdate = false;
        EditMode = '';
        countterU = 0;
        if ($scope.deviceSingleUpperInfo.Operation.state === 'Ready') {
            saveUserValueSingleUpper($scope.currentMode, $scope.desiredTemp, $scope.desiredHours, $scope.desiredMinutes);
        }
        setDataCurrentScreen();
    }

    function upperMoniterClick() {
        debugMessage("upperMoniterClick");
        $scope.UpperMoniter = false;
        $scope.RunningUpperOven = true;
        $scope.RunningLowerOven = false;
        $scope.editMode = false;
        editModeTimeUpdate = false;
        EditMode = '';
        countterL = 0;
        if ($scope.deviceDualLowerInfo.Operation.state === 'Ready') {
            saveUserValueDualLower($scope.currentMode, $scope.desiredTemp, $scope.desiredHours, $scope.desiredMinutes);
        }
        setDataCurrentScreen();
    }

    function autoCookNextPage() {
        $scope.nextPageAutoCookDetail = false;
        $scope.previousPageAutoCookDetail = true;
    }

    function autoCookPreviousPage() {
        $scope.nextPageAutoCookDetail = true;
        $scope.previousPageAutoCookDetail = false;
    }

    function preConditionValidation(screen) {
        $scope.AMCFnMenuVisible = false;
        $scope.refreshButton = false;
        $scope.SettingOptionVisible = false;
        $scope.AboutOptionVisible = false;
        doNotChangeScreen = false;
        if (angular.isDefined($state.current) && angular.isDefined($state.current) && screen !== $state.current.name) {
            setTimeout(function () {
                scroll_middle_area.scrollTop = 0;
            }, 10);
        }
        if ($scope.deviceSingleUpperInfo.Operation.state !== 'Run'
                && $scope.deviceDualLowerInfo.Operation.state !== 'Run') {
            $scope.rangeFunctionMenuExpandList = false;
            $scope.rangeCurrentMenuSelected = null;
        }
        if ($scope.rangeFunctionMenuExpandList) {
            scroll_middle_area.style.overflowY = "hidden";
            scroll_middle_area.style.position = "fixed";
        } else {
            scroll_middle_area.style.overflowY = "overlay";
            scroll_middle_area.style.position = "absolute";
        }
    }

    $scope.$on('$viewContentLoaded', function () {
        debugMessage("$viewContentLoaded " + $scope.currentScreen);
        if ($scope.currentScreen !== RANGESCREENS.RANGE_MAIN_LOADING_PAGE) {
            $scope.mainLoadingScreen = !false;
        }
        switch ($scope.currentScreen) {
            case RANGESCREENS.RANGE_MAIN_LOADING_PAGE:
                //$scope.deviceName = "";
                //$scope.TabsVisibleAtPage = false;
                //$scope.headerBarVisible = false;
                $scope.mainLoadingScreen = false;
                break;
            case RANGESCREENS.RANGE_READY_HOME_PAGE:
                $scope.deviceName = 'WEBMOB_common_device_range';
                $scope.TabsVisibleAtPage = true;
                $scope.SettingOptionVisible = true;
                $scope.AboutOptionVisible = true;
                $scope.headerBarVisible = true;
                $scope.refreshButton = true;
                break;
            case RANGESCREENS.RANGE_PROGRESS_RUNNUNG_PAGE:
                $scope.deviceName = 'WEBMOB_common_device_range';
                $scope.TabsVisibleAtPage = true;
                $scope.SettingOptionVisible = true;
                $scope.AboutOptionVisible = true;
                $scope.headerBarVisible = true;
                $scope.refreshButton = true;
                break;
            case RANGESCREENS.RANGE_SEND_CONFERMATION_PAGE:
                $scope.deviceName = 'WEBMOB_common_device_range';
                $scope.TabsVisibleAtPage = true;
                $scope.headerBarVisible = true;
                break;
            case RANGESCREENS.RANGE_COOKTOP_PAGE:
                $scope.deviceName = 'WEBMOB_common_device_range';
                $scope.TabsVisibleAtPage = true;
                $scope.SettingOptionVisible = !true;
                $scope.AboutOptionVisible = !true;
                $scope.headerBarVisible = true;
                $scope.refreshButton = true;
                break;
            case RANGESCREENS.RANGE_EDIT_MY_COOKING_PAGE:
                $scope.deviceName = 'WEBMOB_device_range_mycooking_edit_mycooking';
                $scope.TabsVisibleAtPage = false;
                $scope.headerBarVisible = true;
                $scope.multiselect = false;
                readyToDelete = false;
                $scope.renamedRecipe = null;
                $scope.showRenameOption = false;
                break;
            case RANGESCREENS.RANGE_ADD_MY_COOKING_PAGE:
                $scope.deviceName = 'WEBMOB_device_range_mycooking_add_mycooking';
                $scope.TabsVisibleAtPage = false;
                $scope.headerBarVisible = true;
                break;
            case RANGESCREENS.RANGE_ERROR_PAGE:
                $scope.deviceName = 'WEBMOB_common_device_range';
                $scope.TabsVisibleAtPage = false;
                $scope.headerBarVisible = true;
                $scope.editMode = false;
                editModeTimeUpdate = false;
                EditMode = '';
                changeSmartCarePage = true;
                closeOperationState();
                OperationScreen = false;
                $scope.refreshButton = true;
                $scope.operationCompleteLower = false;
                $scope.operationCompleteUpper = false;
                cancelUpper = false;
                cancelLower = false;
                deviceMode = 'Bake';
                deviceSingleMode = 'Bake';
                deviceUpperMode = 'UpperConvectionBake';
                deviceLowerMode = 'LowerBake';
                emptyAlarm();
                break;
            case RANGESCREENS.RANGE_AUTO_COOK_PAGE:
                $scope.deviceName = 'WEBMOB_device_range_auto_cook';
                $scope.TabsVisibleAtPage = false;
                $scope.headerBarVisible = true;
                $scope.nextPageAutoCookDetail = true;
                $scope.previousPageAutoCookDetail = false;
                break;
            case RANGESCREENS.RANGE_AUTO_COOK_DETAIL_PAGE:
                $scope.deviceName = $scope.autoCookMenuDetail[0].values[0][2];
                $scope.TabsVisibleAtPage = false;
                $scope.headerBarVisible = true;
                break;
            case RANGESCREENS.RANGE_SETTING_PAGE:
                $scope.deviceName = 'WEBMOB_common_settings';
                $scope.TabsVisibleAtPage = false;
                $scope.headerBarVisible = true;
                settingPageOptionsValidation();
                doNotChangeScreen = true;
                $scope.refreshButton = true;
                break;
            case RANGESCREENS.RANGE_OPERATION_COMPLETE_PAGE:
                OperationScreen = true;
                $scope.deviceName = 'WEBMOB_common_device_range';
                $scope.TabsVisibleAtPage = true;
                $scope.headerBarVisible = true;
                $scope.editMode = false;
                editModeTimeUpdate = false;
                EditMode = '';
                break;
            case RANGESCREENS.RANGE_ABOUT_PAGE:
                $scope.deviceName = 'WEBMOB_common_about_device';
                $scope.TabsVisibleAtPage = false;
                $scope.headerBarVisible = true;
                doNotChangeScreen = true;
                break;
            case RANGESCREENS.RANGE_SETTING_TEMP_ADJUDT_PAGE:
                $scope.deviceName = 'WEBMOB_device_range_settings_temp_adjust';
                $scope.TabsVisibleAtPage = false;
                $scope.headerBarVisible = true;
                doNotChangeScreen = true;
                break;
            case RANGESCREENS.RANGE_SETTING_TEMP_UNIT_PAGE:
                $scope.deviceName = 'WEBMOB_device_range_settings_temp_unit';
                $scope.TabsVisibleAtPage = false;
                $scope.headerBarVisible = true;
                doNotChangeScreen = true;
                break;
            case RANGESCREENS.RANGE_SMART_CARE_PAGE:
                $scope.deviceName = 'WEBMOB_common_self_diagnosis';
                $scope.TabsVisibleAtPage = false;
                $scope.headerBarVisible = true;
                changeSmartCarePage = true;
                doNotChangeScreen = true;
                break;
            case RANGESCREENS.RANGE_SMART_CARE_NO_ERROR_PAGE:
                $scope.deviceName = 'WEBMOB_common_self_diagnosis';
                $scope.TabsVisibleAtPage = false;
                $scope.headerBarVisible = true;
                changeSmartCarePage = true;
                break;
            case RANGESCREENS.RANGE_PROBE_DIVIDER_ERROR_PAGE:
                $scope.deviceName = 'WEBMOB_common_device_range';
                $scope.TabsVisibleAtPage = true;
                $scope.headerBarVisible = true;
                showCookTop = false;
                $scope.refreshButton = true;
                $scope.RangeMainPageCurrentTab = 0;
                break;
        }
    });

    function validateCurrentScreen(screen) {
        preConditionValidation(screen);
        debugMessage("validate screen : " + screen);
        switch (screen) {
            case 'MainLoadingPage':
                $scope.currentScreen = RANGESCREENS.RANGE_MAIN_LOADING_PAGE;
                $state.transitionTo('MainLoadingPage');
                break;
            case 'ReadyPage':
                $scope.currentScreen = RANGESCREENS.RANGE_READY_HOME_PAGE;
                $scope.SettingOptionVisible = true;
                $scope.AboutOptionVisible = true;
                $state.transitionTo('ReadyPage');
                break;
            case 'ProgressPage':
                $scope.currentScreen = RANGESCREENS.RANGE_PROGRESS_RUNNUNG_PAGE;
                $scope.SettingOptionVisible = true;
                $scope.AboutOptionVisible = true;
                $state.transitionTo('ProgressPage');
                break;
            case 'SendConfirmationPage':
                $scope.currentScreen = RANGESCREENS.RANGE_SEND_CONFERMATION_PAGE;
                $state.transitionTo('SendConfirmationPage');
                break;
            case 'CookTopPage':
                $scope.currentScreen = RANGESCREENS.RANGE_COOKTOP_PAGE;
                $state.transitionTo('CookTopPage');
                break;
            case 'CleaningPage':
                $scope.currentScreen = RANGESCREENS.RANGE_PROGRESS_RUNNUNG_PAGE;
                $scope.SettingOptionVisible = true;
                $scope.AboutOptionVisible = true;
                $state.transitionTo('CleaningPage');
                break;
            case 'EditMyCookingPage':
                $scope.currentScreen = RANGESCREENS.RANGE_EDIT_MY_COOKING_PAGE;
                $state.transitionTo('EditMyCookingPage');
                break;
            case 'AddMyCookingPage':
                $scope.currentScreen = RANGESCREENS.RANGE_ADD_MY_COOKING_PAGE;
                $state.transitionTo('AddMyCookingPage');
                break;
            case 'ErrorPage':
                $scope.currentScreen = RANGESCREENS.RANGE_ERROR_PAGE;
                $state.transitionTo('ErrorPage');
                break;
            case 'AutoCookPage':
                $scope.currentScreen = RANGESCREENS.RANGE_AUTO_COOK_PAGE;
                $state.transitionTo('AutoCookPage');
                break;
            case 'AutoCookDetailPage':
                $scope.currentScreen = RANGESCREENS.RANGE_AUTO_COOK_DETAIL_PAGE;
                $scope.deviceName = $scope.autoCookMenuDetail[0].values[0][2];
                $state.transitionTo('AutoCookDetailPage');
                break;
            case 'SettingPage':
                $scope.currentScreen = RANGESCREENS.RANGE_SETTING_PAGE;
                $state.transitionTo('SettingPage');
                break;
            case 'OperationCompletePage':
                debugMessage("validate screen : " + screen + ' && MSG is :' + $scope.operationCompletedorCanceledMSG);
                $scope.currentScreen = RANGESCREENS.RANGE_OPERATION_COMPLETE_PAGE;
                $state.transitionTo('OperationCompletePage');
                break;
            case 'AboutPage':
                $scope.currentScreen = RANGESCREENS.RANGE_ABOUT_PAGE;
                $state.transitionTo('AboutPage');
                break;
            case 'SettingTempAdjustPage':
                $scope.currentScreen = RANGESCREENS.RANGE_SETTING_TEMP_ADJUDT_PAGE;
                $state.transitionTo('SettingTempAdjustPage');
                break;
            case 'SettingTempUnitPage':
                $scope.currentScreen = RANGESCREENS.RANGE_SETTING_TEMP_UNIT_PAGE;
                $state.transitionTo('SettingTempUnitPage');
                break;
            case 'SmartCarePage':
                $scope.currentScreen = RANGESCREENS.RANGE_SMART_CARE_PAGE;
                $state.transitionTo('SmartCarePage');
                break;
            case 'SmartCareNoErrorPage':
                $scope.currentScreen = RANGESCREENS.RANGE_SMART_CARE_NO_ERROR_PAGE;
                $state.transitionTo('SmartCareNoErrorPage');
                break;
            case 'ProbeDividerErrorPage':
                $scope.currentScreen = RANGESCREENS.RANGE_PROBE_DIVIDER_ERROR_PAGE;
                $state.transitionTo('ProbeDividerErrorPage');
                break;
            default :
                debugMessage("validate screen else part: " + screen);
                break;
        }
    }

    function validateOperationCompletionStateScreen() {
        debugMessage("validateOperationCompletionStateScreen ");
        if ($scope.dividerConnected && $scope.operationCompleteUpper && !$scope.operationCompleteLower) {
            debugMessage("validate screen for Upper operation completion");
            if ($scope.UpperMoniter && countterU === 1) {
                countterU = 0;
                upperMoniterClick();
            }
//            showScreen();
            validateCurrentScreen('ReadyPage');
        } else if ($scope.dividerConnected && !$scope.operationCompleteUpper && $scope.operationCompleteLower) {
            debugMessage("validate screen for Lower operation completion");
            if (!$scope.UpperMoniter && countterL === 1) {
                countterL = 0;
                lowerMoniterClick();
            }
//            showScreen();
            validateCurrentScreen('ReadyPage');
        } else if ($scope.dividerConnected && $scope.operationCompleteUpper && $scope.operationCompleteLower) {
            debugMessage("validate screen for Upper/Lower both operation completion");
//            showScreen();
            validateCurrentScreen('ReadyPage');
        } else if (!$scope.dividerConnected && $scope.operationCompleteUpper) {
            debugMessage("validate screen for single operation completion");
            if (doNotChangeScreen) {
                debugMessage('return due to doNotChangeScreen from validateOperationCompletionStateScreen');
                return;
            }
            validateCurrentScreen('OperationCompletePage');
        }
    }

    function onBackPressedEvent(e) {
        if (angular.isDefined(e)) {
            e.stopPropagation();
        }
        onBackPressed();
    }

    function handleStatusCode(status) {
        if (status === 204) {
            loadingValues();
            if (!recipeDataValidated) {
                showCurrentScreen();
            }
        }
        if ($scope.checkResponse.indexOf(RANGE_COMMANDS.syncTime) > -1) {
            $scope.bSyncTime = true;
            setLocalStorageData('RangeiSyncTime', $scope.bSyncTime);
            dismissLoadingBar(RANGE_COMMANDS.syncTime);
        }
    }

    function onBackPressed() {
        refreshValue();
        if ($scope.showFullScreenPopup) {
                $scope.showFullScreenPopup = false;
                if ($scope.alertState === 11) {
                    closeApp();
                }
                return;
            }
        debugMessage("Back key pressed from : " + $scope.currentScreen);
        switch ($scope.currentScreen) {
            case RANGESCREENS.RANGE_MAIN_LOADING_PAGE:
            case RANGESCREENS.RANGE_READY_HOME_PAGE:
            case RANGESCREENS.RANGE_COOKTOP_PAGE:
            case RANGESCREENS.RANGE_PROGRESS_RUNNUNG_PAGE:
            case RANGESCREENS.RANGE_ERROR_PAGE:
            case RANGESCREENS.RANGE_PROBE_DIVIDER_ERROR_PAGE:
                closeApp();
                break;
            case RANGESCREENS.RANGE_SETTING_PAGE:
            case RANGESCREENS.RANGE_ABOUT_PAGE:
                doNotChangeScreen = false;
                showCurrentScreen();
                break;
            case RANGESCREENS.RANGE_SEND_CONFERMATION_PAGE:
                startConfirmationCancel();
                break;
            case RANGESCREENS.RANGE_AUTO_COOK_PAGE:
                showScreen();
                break;
            case RANGESCREENS.RANGE_EDIT_MY_COOKING_PAGE:
                if ($scope.multiselect) {
                    $scope.multiselect = false;
                    $scope.headerBarVisible = true;
                    readyToDelete = false;
                    $scope.editMyCookingSelectedDeleteItems = [];
                    return;
                }
                showCurrentScreen();
                setDataCurrentScreen();
                showScreen();
                break;
            case RANGESCREENS.RANGE_ADD_MY_COOKING_PAGE:
                validateCurrentScreen('EditMyCookingPage');
                break;
            case RANGESCREENS.RANGE_OPERATION_COMPLETE_PAGE:
                emptyAlarm();
                OperationScreen = false;
                closeApp();
                break;
            case RANGESCREENS.RANGE_SETTING_TEMP_ADJUDT_PAGE:
            case RANGESCREENS.RANGE_SETTING_TEMP_UNIT_PAGE:
                validateCurrentScreen('SettingPage');
                break;
            case RANGESCREENS.RANGE_AUTO_COOK_DETAIL_PAGE :
                if ($scope.previousPageAutoCookDetail) {
                    $scope.autoCookPreviousPage();
                    return;
                }
                validateCurrentScreen('AutoCookPage');
                break;
            case RANGESCREENS.RANGE_SMART_CARE_PAGE:
                validateCurrentScreen('AboutPage');
                break;
            case RANGESCREENS.RANGE_SMART_CARE_NO_ERROR_PAGE:
                validateCurrentScreen('AboutPage')
                break;
            default :
                debugMessage("Back key pressed from else " + $scope.currentScreen);
                //closeApp();
                break;
        }
    }

    function refreshValue() {
        debugMessage('All value reset');
        if (configCall) {
            debugMessage('return due to configCall');
            return;
        }
        deviceMode = 'Bake';
        if (!$scope.operationCompleteUpper) {
            deviceSingleMode = 'Bake';
            deviceUpperMode = 'UpperConvectionBake';
        }
        if (!$scope.operationCompleteLower) {
            deviceLowerMode = 'LowerBake';
        }

        $scope.SlowCookTemp = 'High';
        $scope.AMCFnMenuVisible = false;
        $scope.rangeCurrentMenuSelected = null;
        $scope.rangeFunctionMenuExpandList = false;
        scroll_middle_area.style.position = "absolute";
        scroll_middle_area.style.overflowY = "overlay";
        changeUpperRecipe = false;
        changeLowerRecipe = false;
        changSingleRecipe = false;
        myCookingModeTrue = false;
        recipeDataValidated = true;
        userPreferneceDualLower = {};
        userPreferneceSingleUpper = {};
        userPreferneceSingleSinlge = {};
        EditMode = '';
        $scope.editMode = false;
        editModeTimeUpdate = false;
        doNotChangeScreen = false;
        $scope.showFullScreenPopup = false;
        $scope.inputDialogPopUp = false;
    }

    function emptyValuesFreshLaunch() {
        debugMessage('All value empaty as fresh start');
        deviceMode = 'Bake';
        deviceSingleMode = 'Bake';
        deviceUpperMode = 'UpperConvectionBake';
        deviceLowerMode = 'LowerBake';
        $scope.SlowCookTemp = 'High';
        $scope.AMCFnMenuVisible = false;
        $scope.rangeCurrentMenuSelected = null;
        $scope.rangeFunctionMenuExpandList = false;
        scroll_middle_area.style.position = "absolute";
        scroll_middle_area.style.overflowY = "overlay";
        changeUpperRecipe = true;
        changeLowerRecipe = true;
        changSingleRecipe = true;
        userPreferneceDualLower = {};
        userPreferneceSingleUpper = {};
        userPreferneceSingleSinlge = {};
        EditMode = '';
        $scope.editMode = false;
        editModeTimeUpdate = false;
        doNotChangeScreen = false;
        $scope.showFullScreenPopup = false;
        $scope.inputDialogPopUp = false;
    }

    function emptyAlarm() {
        debugMessage("emptyAlarm : ");
        if ($scope.deviceSingleUpperInfo.Alarms[0].code !== "-1") {
            $scope.deviceSingleUpperInfo.Alarms[0].id = '-1';
            $scope.deviceSingleUpperInfo.Alarms[0].code = '-1';
            $scope.deviceSingleUpperInfo.Alarms[0].alarmType = '-1';
            $scope.deviceSingleUpperInfo.Alarms[0].triggeredTime = '-1';
            snoozUpper = false;
        }
        if ($scope.deviceDualLowerInfo.Alarms[0].code !== "-1") {
            $scope.deviceDualLowerInfo.Alarms[0].id = '-1';
            $scope.deviceDualLowerInfo.Alarms[0].code = '-1';
            $scope.deviceDualLowerInfo.Alarms[0].alarmType = '-1';
            $scope.deviceDualLowerInfo.Alarms[0].triggeredTime = '-1';
            snoozLower = false;
        }
    }

    function closeApp() {
        nativeInterface.runOnNative("closeWebApp", "");
    }

    function goToAbout() {
        validateCurrentScreen('AboutPage');
    }

    function goToSettings() {
        settingPageOptionsValidation();
        validateCurrentScreen('SettingPage');
    }

    function settingPageOptionsValidation() {
        $scope.bFahrenheit = $scope.deviceSingleUpperInfo.Temperatures[0].unit !== 'Celsius';
        $scope.TempUnit = $scope.deviceSingleUpperInfo.Temperatures[0].unit === 'Celsius' ? 'C' : 'F';
        $scope.bSound = $scope.deviceSingleUpperInfo.Mode.options[0].Sound === 'On';
        $scope.bSabbathMode = $scope.deviceSingleUpperInfo.Mode.options[0].Sabbath === 'On';
        $scope.bVirtualFlame = $scope.deviceSingleUpperInfo.Mode.options[0].VirtualFlame === 'On';
        $scope.bHrEnergySaving = $scope.deviceSingleUpperInfo.Mode.options[0].EnergySaving === 'On';
        $scope.bAutoConversion = $scope.deviceSingleUpperInfo.Mode.options[0].RecipeConversion === 'On';
        $scope.showTimeSync = $scope.deviceSingleUpperInfo.Mode.options[0].TimeSyncSupported === 'Supported';
        $scope.AdjustTemp = getAdjustTemp(parseInt($scope.deviceSingleUpperInfo.Mode.options[0].AdjustingTemp, 10));
        $scope.bSyncTime = getLocalStorageData('RangeiSyncTime');
        $scope.maxAdjustTemp = $scope.TempUnit === 'C' ? 19 : 35;
        $scope.minAdjustTemp = $scope.TempUnit === 'C' ? -19 : -35;
        $scope.TempIncrement = $scope.TempUnit === 'C' ? 1 : 1;
    }

    function openPopoverMode() {
        scroll_middle_area.style.overflowY = "hidden";
        var top = (document.getElementById("rangeUpperMoniter").getBoundingClientRect().top);
        if (window.navigator.platform === 'iPhone' || window.navigator.platform === 'iPad') {
            scroll_middle_area.style.position = "fixed";
            if (top > -20) {
                $scope.rangeUpperMoniterVisibleHeight = top + 55;
            } else {
                $scope.rangeUpperMoniterVisibleHeight = 55;
            }
        } else {
            top = 145 + top;
            if (top > 180) {
                $scope.rangeUpperMoniterVisibleHeight = top;
            } else {
                $scope.rangeUpperMoniterVisibleHeight = 180;
            }
        }
        $scope.rangeFunctionMenuExpandList = !$scope.rangeFunctionMenuExpandList;
    }

    function openAMCMenu() {
        $scope.AMCFnMenuVisible = !$scope.AMCFnMenuVisible;
    }

    function getsendRecipeCommandwithMeatProbe(curMode, operTime, recipeTemperature, meatProbeTemperature, unit) {
        return '{"Device" : {"Mode" : {"modes" : ["' + curMode + '"]},"Operation" : {"operationTime" : "' + operTime + '" },"Temperatures" : [{ "id" : "' + recipeTemperature.id + '", "current" : ' + recipeTemperature.current + ', "desired" : ' + recipeTemperature.desired + ', "maximum" : ' + recipeTemperature.maximum + ', "minimum" : ' + recipeTemperature.minimum + ',"unit" : "' + unit + '" }, { "id" : "' + meatProbeTemperature.id + '", "current" : ' + 0 + ', "desired" : ' + meatProbeTemperature.desired + ', "maximum" : ' + meatProbeTemperature.maximum + ', "minimum" : ' + meatProbeTemperature.minimum + ',"unit" : "' + unit + '" }]}}';
    }

    function getsendRecipeCommandwithoutMeatProbe(curMode, operTime, recipeTemperature, unit) {
        return '{"Device" : {"Mode" : {"modes" : ["' + curMode + '"]},"Operation" : {"operationTime" : "' + operTime + '" },"Temperatures" : [{ "id" : "' + recipeTemperature.id + '", "current" : ' + recipeTemperature.current + ', "desired" : ' + recipeTemperature.desired + ', "maximum" : ' + recipeTemperature.maximum + ', "minimum" : ' + recipeTemperature.minimum + ',"unit" : "' + unit + '" }]}}';
    }

    function getSendSnoozeCommand(operationTime) {
        return '{"Device" : {"Operation" : {"operationTime" : "' + operationTime + '"}}}';
    }

    function getsendRecipeCommandSlowCook(curMode, operTime, slowCookecipeTemperature, unit) {
        return '{"Device" : {"Mode" : {"modes" : ["' + curMode + '"]},"Operation" : {"operationTime" : "' + operTime + '" },"Temperatures" : [{ "id" : "' + slowCookecipeTemperature.id + '", "current" : ' + slowCookecipeTemperature.current + ', "desired" : ' + slowCookecipeTemperature.desired + ', "maximum" : ' + slowCookecipeTemperature.maximum + ', "minimum" : ' + slowCookecipeTemperature.minimum + ',"unit" : "' + unit + '" }]}}';
    }

    function sendButtonClicked() {
        debugMessage("sendButtonClicked ");
        $scope.singleReadySendButton = true;
        $timeout(function () {
            $scope.singleReadySendButton = false;
        }, 100);
        if (!$scope.ElectricModel) {
            sendButtonClickedConfirmed();
        } else {
            showcustDialog(RANGE_ALERT_STATE.ALERT_START_COOKING, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_alarm_start_cooking_now, $scope.translation.WEBMOB_common_cancel, $scope.translation.WEBMOB_common_ok);
        }
    }

    function sendButtonClickedConfirmed() {
        debugMessage("sendButtonClickedConfirmed ");

        if (KidsLockOn()) {
            debugMessage("return kids lock ");
            return;
        }
        if ($scope.ElectricModel) {
            if (!$scope.remoteControlEnabled) {
                debugMessage("return smart control");
                showcustDialog(RANGE_ALERT_STATE.ALERT_SMARTMONITOR_GUIDE, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_alarm_smart_control_on, $scope.translation.WEBMOB_common_ok, '');
                return;
            }
        }
        if ($scope.bSabbathMode) {
            debugMessage("return sabbath mode");
            showcustDialog(RANGE_ALERT_STATE.ALERT_SABBATH_MODE, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_alarm_settings_sabbath_turn_off, $scope.translation.WEBMOB_common_ok, '');
            return;
        }

        if ($scope.deviceSingleUpperInfo.Mode.options[0].meatprobe === "connected") {
            if (!$scope.modeSupport) {
                debugMessage("mode not support probe");
                showcustDialog(RANGE_ALERT_STATE.ALERT_AUTO_COOK_PROBE, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_alarm_selected_mode_not_support, $scope.translation.WEBMOB_common_ok, '');
                return;
            }
        }

        $scope.loadingBar = true;

        var hr, min, operTime, unit, slowCook;
        hr = Number($scope.desiredHours) < 10 ? '0' + Number($scope.desiredHours) : Number($scope.desiredHours);
        min = Number($scope.desiredMinutes) < 10 ? '0' + Number($scope.desiredMinutes) : Number($scope.desiredMinutes);
        operTime = hr + ':' + min + ':00';
        unit = $scope.TempUnit === 'C' ? 'Celsius' : 'Fahrenheit',
                slowCook = $scope.SlowCookTemp === 'High' ? 61441 : 61442;

        var recipeTemperature = {"id": "0",
            "current": $scope.currentTemp,
            "desired": $scope.desiredTemp,
            "maximum": $scope.maxTemp,
            "minimum": $scope.minTemp,
            "unit": unit};

        var slowCookecipeTemperature = {"id": "0",
            "current": 0,
            "desired": slowCook,
            "maximum": 61441,
            "minimum": 61442,
            "unit": unit};

        var recipeProbeTemperature = {"id": "1",
            "current": $scope.currentProbeTemp,
            "desired": $scope.desiredProbeTemp,
            "maximum": $scope.maxProbeTemp,
            "minimum": $scope.minProbeTemp,
            "unit": unit};

        $scope.validateSendRecipeInfo = {
            'UpperState': '',
            'LowerState': '',
            'Mode': deviceMode,
            'OperationTime': operTime,
            'DesiredTemp': recipeTemperature.desired,
            'SlowCookTemp': slowCookecipeTemperature.desired,
            'DesiredProbeTemp': recipeProbeTemperature.desired
        };
        $scope.validateSendRecipeInfoMode = getDeviceDataMode($scope.validateSendRecipeInfo.Mode);
        $scope.validateSendRecipeInfoDesiredTemp = $scope.validateSendRecipeInfo.DesiredTemp;
        $scope.validateSendRecipeInfoDesiredProbeTemp = $scope.validateSendRecipeInfo.DesiredProbeTemp;
        $scope.validateSendRecipeInfoOperationHrs = $scope.validateSendRecipeInfo.OperationTime.split(':')[0][1];
        $scope.validateSendRecipeInfoOperationMints = $scope.validateSendRecipeInfo.OperationTime.split(':')[1];
        var deviceId;
        if ($scope.dividerConnected && $scope.RunningUpperOven) {
            $scope.validateSendRecipeInfo.UpperState = 'Ready';
            deviceId = 0;
        } else if ($scope.dividerConnected && $scope.RunningLowerOven) {
            $scope.validateSendRecipeInfo.LowerState = 'Ready';
            deviceId = 1;
        } else {
            $scope.validateSendRecipeInfo.UpperState = 'Ready';
            deviceId = 0;
        }

        if (!$scope.isStatic) {
            recipeDataValidated = false;
            $scope.checkResponse.push(RANGE_COMMANDS.sendRecipetoOven);
            if ($scope.currentMode === 'WEBMOB_device_range_easy_cook_slow_cook') {
                debugMessage("sendSHPCommand : Slow Cook " + getsendRecipeCommandSlowCook(deviceMode, operTime, slowCookecipeTemperature, unit) + "/" + $scope.peerId + "/devices/" + deviceId);
                SHPService.sendSHPCommand(CONSTANTS.PUT, getsendRecipeCommandSlowCook(deviceMode, operTime, slowCookecipeTemperature, unit), "/" + $scope.peerId + "/devices/" + deviceId);
            } else {
                if ($scope.meatProbeConnected) {
                    debugMessage("sendSHPCommand meatProbeConnected : " + getsendRecipeCommandwithMeatProbe(deviceMode, operTime, recipeTemperature, recipeProbeTemperature, unit) + "/" + $scope.peerId + "/devices/0");
                    SHPService.sendSHPCommand(CONSTANTS.PUT, getsendRecipeCommandwithMeatProbe(deviceMode, operTime, recipeTemperature, recipeProbeTemperature, unit), "/" + $scope.peerId + "/devices/0");
                } else {
                    debugMessage("sendSHPCommand : " + getsendRecipeCommandwithoutMeatProbe(deviceMode, operTime, recipeTemperature, unit));
                    SHPService.sendSHPCommand(CONSTANTS.PUT, getsendRecipeCommandwithoutMeatProbe(deviceMode, operTime, recipeTemperature, unit), "/" + $scope.peerId + "/devices/" + deviceId);
                }
            }
        } else {
            $scope.loadingBar = false;
        }
    }

    function getCancelCommand() {
        return '{"Operation" : {"state" : "Ready"}}';
    }

    function onCancelProgress(id) {
        var deviceId;
        if (id === 1) {
            deviceId = 1;
        } else if (id === 0) {
            deviceId = 0;
        } else if ((id === undefined || id === null) && $scope.dividerConnected && $scope.RunningLowerOven) {
            deviceId = 1;
        } else {
            deviceId = 0;
        }
        IDforCancelCooking = deviceId;
        debugMessage("Cancel command for  /devices/" + IDforCancelCooking);
        if ($scope.deviceSingleUpperInfo.Oven.state === "Cleaning") {
            showcustDialog(RANGE_ALERT_STATE.ALERT_CANCEL_COOKING, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_alarm_cancel_cleaning_now, $scope.translation.WEBMOB_common_cancel, $scope.translation.WEBMOB_common_ok);
        } else {
            showcustDialog(RANGE_ALERT_STATE.ALERT_CANCEL_COOKING, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_cooking_cancel, $scope.translation.WEBMOB_common_cancel, $scope.translation.WEBMOB_common_ok);
        }
    }

    function onCancelProgressConfirmed() {
        debugMessage("Cancel command onCancelProgressConfirmed " + IDforCancelCooking);
        if ($scope.isStatic) {
            return;
        }
        if (IDforCancelCooking !== undefined && IDforCancelCooking === 1) {
            cancelLower = true;
        } else {
            IDforCancelCooking = 0;
            cancelUpper = true;
        }

        if ((IDforCancelCooking === 0 && $scope.deviceSingleUpperInfo.Operation.state === "Ready")
                || (IDforCancelCooking === 1 && $scope.deviceDualLowerInfo.Operation.state === "Ready")) {
            debugMessage("return due to already in Ready State");
            return;
        }

        if (!$scope.isStatic) {
            $scope.checkResponse.push(RANGE_COMMANDS.cancelCooking);
            debugMessage(getCancelCommand() + "/" + $scope.peerId + "/devices/" + IDforCancelCooking + "/operation");
            SHPService.sendSHPCommand(CONSTANTS.PUT, getCancelCommand(), "/" + $scope.peerId + "/devices/" + IDforCancelCooking + "/operation");
        }
    }

    function sendMoniterClicked(id) {
        var recipeDataToSendDB, recipeDataToSend, unit, operTime, deviceModeToSend;

        if (KidsLockOn()) {
            return;
        }

        if ($scope.dividerConnected && !$scope.RunningUpperOven) {
            deviceModeToSend = deviceUpperMode;
        } else if ($scope.dividerConnected && !$scope.RunningLowerOven) {
            deviceModeToSend = deviceLowerMode;
        } else {
            return;
        }
        recipeDataToSendDB = db.exec("SELECT * FROM MODE_TABLE WHERE TYPE = 'BASIC' AND MODE = '" + deviceModeToSend + "'");
        recipeDataToSend = recipeDataToSendDB[0].values[0];

        var newdate = new Date();
        newdate.setHours(0, recipeDataToSend[17], 0);

        var hr, min;
        hr = Number(newdate.getHours()) < 10 ? '0' + Number(newdate.getHours()) : Number(newdate.getHours());
        min = Number(newdate.getMinutes()) < 10 ? '0' + Number(newdate.getMinutes()) : Number(newdate.getMinutes());
        operTime = hr + ':' + min + ':00';
        unit = $scope.TempUnit === 'C' ? 'Celsius' : 'Fahrenheit';

        var recipeTemperature = {"id": "0",
            "current": 350,
            "desired": recipeDataToSend[14],
            "maximum": recipeDataToSend[16],
            "minimum": recipeDataToSend[15],
            "unit": unit};

        $scope.validateSendRecipeInfo = {
            'UpperState': '',
            'LowerState': '',
            'Mode': deviceModeToSend,
            'OperationTime': operTime,
            'DesiredTemp': recipeTemperature.desired
        };

        if ($scope.dividerConnected && $scope.RunningUpperOven) {
            $scope.validateSendRecipeInfo.UpperState = 'Ready';
        } else if ($scope.dividerConnected && $scope.RunningLowerOven) {
            $scope.validateSendRecipeInfo.LowerState = 'Ready';
        } else {
            $scope.validateSendRecipeInfo.UpperState = 'Ready';
        }

        $scope.checkResponse.push(RANGE_COMMANDS.sendRecipetoOven);

        if (!$scope.isStatic) {
            recipeDataValidated = false;
            debugMessage("sendSHPCommand : " + getsendRecipeCommandwithoutMeatProbe(deviceModeToSend, operTime, recipeTemperature, unit));
            SHPService.sendSHPCommand(CONSTANTS.PUT, getsendRecipeCommandwithoutMeatProbe(deviceModeToSend, operTime, recipeTemperature, unit), "/" + $scope.peerId + "/devices/" + id);

        }
    }

    function KidsLockOn() {
        if ($scope.deviceSingleUpperInfo.Operation.kidsLock === 'Run') {
            debugMessage("Kids Lock is ON");
            showcustDialog(RANGE_ALERT_STATE.ALERT_CHILD_LOCK, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_alarm_child_lock, $scope.translation.WEBMOB_common_ok, '');
            return true;
        }
        return false;
    }

    function onSettingsToggleUpdate(settingItem) {
        var value;
        debugMessage('Setting Option Clicked ' + settingItem);
        switch (settingItem) {
            case "tempAdjust":
                if ($scope.deviceSingleUpperInfo.Operation.state === "Run"
                        || $scope.deviceDualLowerInfo.Operation.state === "Run") {
                    settingOptionPreCondition();
                    return;
                }
                validateCurrentScreen('SettingTempAdjustPage');
                break;
            case "tempUnit":
                if ($scope.deviceSingleUpperInfo.Operation.state === "Run"
                        || $scope.deviceDualLowerInfo.Operation.state === "Run") {
                    settingOptionPreCondition();
                    return;
                }
                validateCurrentScreen('SettingTempUnitPage');
                break;
            case "autoConversion":
                if ($scope.deviceSingleUpperInfo.Operation.state === "Run"
                        || $scope.deviceDualLowerInfo.Operation.state === "Run") {
                    settingOptionPreCondition();
                    return;
                }
                $scope.bAutoConversion = !$scope.bAutoConversion;
                value = $scope.bAutoConversion ? 'RecipeConversion_On' : 'RecipeConversion_Off';
                sendSettingCommand(value);
                break;
            case "hrEnergySaving":
                if ($scope.deviceSingleUpperInfo.Operation.state === "Run"
                        || $scope.deviceDualLowerInfo.Operation.state === "Run") {
                    settingOptionPreCondition();
                    return;
                }
                $scope.bHrEnergySaving = !$scope.bHrEnergySaving;
                value = $scope.bHrEnergySaving ? 'EnergySaving_On' : 'EnergySaving_Off';
                sendSettingCommand(value);
                break;
            case "sound":
                if ($scope.deviceSingleUpperInfo.Operation.state === "Run"
                        || $scope.deviceDualLowerInfo.Operation.state === "Run") {
                    settingOptionPreCondition();
                    return;
                }
                $scope.bSound = !$scope.bSound;
                value = $scope.bSound ? 'Sound_On' : 'Sound_Off';
                sendSettingCommand(value);
                break;
            case "syncTime":
                if ($scope.bSyncTime || $scope.isStatic) {
                    $scope.bSyncTime = !$scope.bSyncTime;
                } else if (!$scope.isStatic && !$scope.bSyncTime) {
                    if ($scope.deviceSingleUpperInfo.Operation.state === "Run"
                            || $scope.deviceDualLowerInfo.Operation.state === "Run") {
                        settingOptionPreCondition();
                        return;
                    }
                    $scope.bSyncTime = !$scope.bSyncTime;
                    $scope.checkResponse.push(RANGE_COMMANDS.syncTime);
                    debugMessage("Sync Timer command " + syncTimerCommand() + "/" + $scope.peerId + "/devices/0/configuration/time");
                    SHPService.sendSHPCommand(CONSTANTS.PUT, syncTimerCommand(), "/" + $scope.peerId + "/devices/0/configuration/time");
                }
                setLocalStorageData('RangeiSyncTime', $scope.bSyncTime);
                break;
            case "virtualFlame":
                if ($scope.deviceSingleUpperInfo.Operation.state === "Run"
                        || $scope.deviceDualLowerInfo.Operation.state === "Run") {
                    settingOptionPreCondition();
                    return;
                }
                $scope.bVirtualFlame = !$scope.bVirtualFlame;
                value = $scope.bVirtualFlame ? 'VirtualFlame_On' : 'VirtualFlame_Off';
                sendSettingCommand(value);
                break;
            case "sabbathMode":
                if ($scope.bSabbathMode) {
                    $scope.bSabbathMode = !$scope.bSabbathMode;
                    value = $scope.bSabbathMode ? 'Sabbath_On' : 'Sabbath_Off';
                    sendSettingCommand(value);
                } else {
                    if ($scope.deviceSingleUpperInfo.Mode.modes[0] === 'Bake' && $scope.deviceSingleUpperInfo.Operation.state === 'Run') {
                        $scope.bSabbathMode = !$scope.bSabbathMode;
                        value = $scope.bSabbathMode ? 'Sabbath_On' : 'Sabbath_Off';
                        sendSettingCommand(value);
                    } else {
                        $timeout(function () {
                            toaster.success({title: "", body: $scope.translation.WEBMOB_device_range_alarm_only_change_on_baking_mode});
                        }, 500);
                    }
                }
                break;
            default:
                break;
        }
    }

    function settingOptionPreCondition() {
        debugMessage("Setting command operationStateState " + $scope.operationStateState);
        $timeout(function () {
            toaster.success({title: "", body: $scope.translation.WEBMOB_device_range_alarm_only_change_not_cooking});
        }, 500);
    }

    function versionTouchStart() {
        debugMessage("ABOUT command versionTouchStart ");
        if (!promise) {
            promise = $timeout(function () {
                if (!$scope.isStatic) {
                    $scope.checkResponse.push(RANGE_COMMANDS.showModuleVersion);
                    SHPService.sendSHPCommand(CONSTANTS.GET, "/" + $scope.peerId + "/devices/0/information");
                }
            }, 5000);
        }
    }

    function versionTouchEnd() {
        debugMessage("ABOUT command versionTouchEnd ");
        if (promise) {
            $timeout.cancel(promise);
            promise = null;
        }
    }

    function syncTimerCommand() {
        var dateValue = getCurrentTime();
        debugMessage("current date is > " + dateValue);
        return '{"Time":{"currentTime":"' + dateValue + '"}}';
    }

    function getCurrentTime() {
        var local = new Date();
        var currentdate = new Date(local);
        currentdate.setMinutes(local.getMinutes() - local.getTimezoneOffset());
        return currentdate.toJSON().slice(0, 19);
    }

    function increaseRangeTemp() {
        $scope.desiredTemp = parseInt($scope.desiredTemp, 10);
        if (($scope.desiredTemp) < $scope.maxTemp) {
            $scope.desiredTemp = $scope.desiredTemp + $scope.TempIncrement;
        } else {
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_alarm_maximum_temp;
                toast = toast.replace(/#1#/, $scope.maxTemp);
                toaster.success({title: "", body: toast});
            }, 500);
        }
    }

    function decreaseRangeTemp() {
        $scope.desiredTemp = parseInt($scope.desiredTemp, 10);
        if (($scope.desiredTemp) > $scope.minTemp) {
            $scope.desiredTemp = $scope.desiredTemp - $scope.TempIncrement;
        } else {
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_alarm_minimum_temp;
                toast = toast.replace(/#1#/, $scope.minTemp);
                toaster.success({title: "", body: toast});
            }, 500);
        }
    }

    function increaseProbeTemp() {
        $scope.desiredProbeTemp = parseInt($scope.desiredProbeTemp, 10);
        if (($scope.desiredProbeTemp) < $scope.maxProbeTemp) {
            $scope.desiredProbeTemp = $scope.desiredProbeTemp + 1;
        } else {
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_alarm_maximum_temp;
                toast = toast.replace(/#1#/, $scope.maxProbeTemp);
                toaster.success({title: "", body: toast});
            }, 500);
        }
    }

    function decreaseProbeTemp() {
        $scope.desiredProbeTemp = parseInt($scope.desiredProbeTemp, 10);
        if (($scope.desiredProbeTemp) > $scope.minProbeTemp) {
            $scope.desiredProbeTemp = $scope.desiredProbeTemp - 1;
        } else {
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_alarm_minimum_temp;
                toast = toast.replace(/#1#/, $scope.minProbeTemp);
                toaster.success({title: "", body: toast});
            }, 500);
        }
    }

    function increaseRangeHour() {
        $scope.desiredHours = parseInt($scope.desiredHours, 10);
        if ($scope.desiredHours < 9) {
            $scope.desiredHours += 1;
        } else {
            $scope.desiredHours = 0;
        }
        $scope.desiredHours = ($scope.desiredHours === 0 && $scope.desiredMinutes === 0) ? 1 : $scope.desiredHours;
        //$scope.desiredHour = ($scope.desiredHour < 10) ? ('0' + $scope.desiredHour) : $scope.desiredHour;
    }

    function decreaseRangeHour() {
        $scope.desiredHours = parseInt($scope.desiredHours, 10);
        if ($scope.desiredHours > 0) {
            $scope.desiredHours -= 1;
        } else {
            $scope.desiredHours = 9;
        }
        $scope.desiredHours = ($scope.desiredHours === 0 && $scope.desiredMinutes === 0) ? 9 : $scope.desiredHours;
        //$scope.desiredHour = ($scope.desiredHour < 10) ? ('0' + $scope.desiredHour) : $scope.desiredHour;
    }

    function increaseRangeMinute() {
        $scope.desiredMinutes = Number($scope.desiredMinutes);
        $scope.desiredHours = Number($scope.desiredHours);
        if ($scope.desiredMinutes !== (59)) {
            $scope.desiredMinutes += 1;
        } else {
            $scope.desiredMinutes = 0;
        }
        $scope.desiredMinutes = ($scope.desiredHours === 0 && $scope.desiredMinutes === 0) ? 1 : $scope.desiredMinutes;
        //$scope.desiredMinutes = ($scope.desiredMinutes < 10) ? ('0' + $scope.desiredMinutes) : $scope.desiredMinutes;
    }

    function decreaseRangeMinute() {
        $scope.desiredMinutes = Number($scope.desiredMinutes);
        if ($scope.desiredMinutes !== 0) {
            $scope.desiredMinutes -= 1;
        } else {
            $scope.desiredMinutes = 60 - 1;
        }
        $scope.desiredMinutes = ($scope.desiredHours === 0 && $scope.desiredMinutes === 0) ? 59 : $scope.desiredMinutes;
        //$scope.desiredMinutes = ($scope.desiredMinutes < 10) ? ('0' + $scope.desiredMinutes) : $scope.desiredMinutes;
    }

    function increaseRangeEditTemp() {
        $scope.desiredEditTemp = parseInt($scope.desiredEditTemp, 10);
        if (($scope.desiredEditTemp) < $scope.maxTemp) {
            $scope.desiredEditTemp = $scope.desiredEditTemp + $scope.TempIncrement;
        } else {
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_alarm_maximum_temp;
                toast = toast.replace(/#1#/, $scope.maxTemp);
                toaster.success({title: "", body: toast});
            }, 500);
        }
    }

    function decreaseRangeEditTemp() {
        $scope.desiredEditTemp = parseInt($scope.desiredEditTemp, 10);
        if (($scope.desiredEditTemp) > $scope.minTemp) {
            $scope.desiredEditTemp = $scope.desiredEditTemp - $scope.TempIncrement;
        } else {
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_alarm_minimum_temp;
                toast = toast.replace(/#1#/, $scope.minTemp);
                toaster.success({title: "", body: toast});
            }, 500);
        }
    }

    function increaseProbeEditTemp() {
        $scope.desiredEditProbeTemp = parseInt($scope.desiredEditProbeTemp, 10);
        if (($scope.desiredEditProbeTemp) < $scope.maxProbeTemp) {
            $scope.desiredEditProbeTemp = $scope.desiredEditProbeTemp + 1;
        } else {
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_alarm_maximum_temp;
                toast = toast.replace(/#1#/, $scope.maxProbeTemp);
                toaster.success({title: "", body: toast});
            }, 500);
        }
    }

    function decreaseProbeEditTemp() {
        $scope.desiredEditProbeTemp = parseInt($scope.desiredEditProbeTemp, 10);
        if (($scope.desiredEditProbeTemp) > $scope.minProbeTemp) {
            $scope.desiredEditProbeTemp = $scope.desiredEditProbeTemp - 1;
        } else {
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_alarm_minimum_temp;
                toast = toast.replace(/#1#/, $scope.minProbeTemp);
                toaster.success({title: "", body: toast});
            }, 500);
        }
    }

    function increaseRangeEditHour() {
        editModeTimeUpdate = true;
        $scope.desiredEditHours = Number($scope.desiredEditHours);
        if ($scope.desiredEditHours < 9) {
            $scope.desiredEditHours += 1;
        } else {
            $scope.desiredEditHours = 0;
        }
        $scope.desiredEditHours = ($scope.desiredEditHours === 0 && $scope.desiredEditMinutes === 0) ? 1 : $scope.desiredEditHours;
        //$scope.desiredHour = ($scope.desiredHour < 10) ? ('0' + $scope.desiredHour) : $scope.desiredHour;
    }

    function decreaseRangeEditHour() {
        editModeTimeUpdate = true;
        $scope.desiredEditHours = Number($scope.desiredEditHours);
        if ($scope.desiredEditHours > 0) {
            $scope.desiredEditHours -= 1;
        } else {
            $scope.desiredEditHours = 9;
        }
        $scope.desiredEditHours = ($scope.desiredEditHours === 0 && $scope.desiredEditMinutes === 0) ? 9 : $scope.desiredEditHours;
        //$scope.desiredHour = ($scope.desiredHour < 10) ? ('0' + $scope.desiredHour) : $scope.desiredHour;
    }

    function increaseRangeEditMinute() {
        editModeTimeUpdate = true;
        $scope.desiredEditHours = Number($scope.desiredEditHours);
        $scope.desiredEditMinutes = Number($scope.desiredEditMinutes);
        if ($scope.desiredEditMinutes !== (59)) {
            $scope.desiredEditMinutes += 1;
        } else {
            $scope.desiredEditMinutes = 0;
        }
        $scope.desiredEditMinutes = ($scope.desiredEditHours === 0 && $scope.desiredEditMinutes === 0) ? 1 : $scope.desiredEditMinutes;
        //$scope.desiredMinutes = ($scope.desiredMinutes < 10) ? ('0' + $scope.desiredMinutes) : $scope.desiredMinutes;
    }

    function decreaseRangeEditMinute() {
        editModeTimeUpdate = true;
        $scope.desiredEditHours = Number($scope.desiredEditHours);
        $scope.desiredEditMinutes = Number($scope.desiredEditMinutes);
        if ($scope.desiredEditMinutes !== 0) {
            $scope.desiredEditMinutes -= 1;
        } else {
            $scope.desiredEditMinutes = 60 - 1;
        }
        $scope.desiredEditMinutes = ($scope.desiredEditHours === 0 && $scope.desiredEditMinutes === 0) ? 59 : $scope.desiredEditMinutes;
        //$scope.desiredMinutes = ($scope.desiredMinutes < 10) ? ('0' + $scope.desiredMinutes) : $scope.desiredMinutes;
    }

    function increaseRangeAMCTemp() {
        $scope.desiredAMCTemp = parseInt($scope.desiredAMCTemp, 10);
        if (($scope.desiredAMCTemp) < $scope.maxTemp) {
            $scope.desiredAMCTemp = $scope.desiredAMCTemp + $scope.TempIncrement;
        } else {
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_alarm_maximum_temp;
                toast = toast.replace(/#1#/, $scope.maxTemp);
                toaster.success({title: "", body: toast});
            }, 500);
        }
    }

    function decreaseRangeAMCTemp() {
        $scope.desiredAMCTemp = parseInt($scope.desiredAMCTemp, 10);
        if (($scope.desiredAMCTemp) > $scope.minTemp) {
            $scope.desiredAMCTemp = $scope.desiredAMCTemp - $scope.TempIncrement;
        } else {
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_alarm_minimum_temp;
                toast = toast.replace(/#1#/, $scope.minTemp);
                toaster.success({title: "", body: toast});
            }, 500);
        }
    }

    function increaseRangeAMCHour() {
        $scope.desiredAMCHr = Number($scope.desiredAMCHr);
        if ($scope.desiredAMCHr < 9) {
            $scope.desiredAMCHr += 1;
        } else {
            $scope.desiredAMCHr = 0;
        }
        $scope.desiredAMCHr = ($scope.desiredAMCHr === 0 && $scope.desiredAMCMin === 0) ? 1 : $scope.desiredAMCHr;
        //$scope.desiredHour = ($scope.desiredHour < 10) ? ('0' + $scope.desiredHour) : $scope.desiredHour;
    }

    function decreaseRangeAMCHour() {
        $scope.desiredAMCHr = Number($scope.desiredAMCHr);
        if ($scope.desiredAMCHr > 0) {
            $scope.desiredAMCHr -= 1;
        } else {
            $scope.desiredAMCHr = 9;
        }
        $scope.desiredAMCHr = ($scope.desiredAMCHr === 0 && $scope.desiredAMCMin === 0) ? 9 : $scope.desiredAMCHr;
        //$scope.desiredHour = ($scope.desiredHour < 10) ? ('0' + $scope.desiredHour) : $scope.desiredHour;
    }

    function increaseRangeAMCMinute() {
        $scope.desiredAMCHr = Number($scope.desiredAMCHr);
        $scope.desiredAMCMin = Number($scope.desiredAMCMin);
        if ($scope.desiredAMCMin !== (59)) {
            $scope.desiredAMCMin += 1;
        } else {
            $scope.desiredAMCMin = 0;
        }
        $scope.desiredAMCMin = ($scope.desiredAMCHr === 0 && $scope.desiredAMCMin === 0) ? 1 : $scope.desiredAMCMin;
        //$scope.desiredMinutes = ($scope.desiredMinutes < 10) ? ('0' + $scope.desiredMinutes) : $scope.desiredMinutes;
    }

    function decreaseRangeAMCMinute() {
        $scope.desiredAMCHr = Number($scope.desiredAMCHr);
        $scope.desiredAMCMin = Number($scope.desiredAMCMin);
        if ($scope.desiredAMCMin !== 0) {
            $scope.desiredAMCMin -= 1;
        } else {
            $scope.desiredAMCMin = 60 - 1;
        }
        $scope.desiredAMCMin = ($scope.desiredAMCHr === 0 && $scope.desiredAMCMin === 0) ? 59 : $scope.desiredAMCMin;
        //$scope.desiredMinutes = ($scope.desiredMinutes < 10) ? ('0' + $scope.desiredMinutes) : $scope.desiredMinutes;
    }

    function increaseAdjustSettingTemp() {
        $scope.AdjustTemp = parseInt($scope.AdjustTemp, 10);
        if (($scope.AdjustTemp) < $scope.maxAdjustTemp) {
            $scope.AdjustTemp = $scope.AdjustTemp + 1;
        } else {
            $scope.AdjustTemp = $scope.maxAdjustTemp;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_alarm_maximum_temp;
                toast = toast.replace(/#1#/, $scope.maxAdjustTemp);
                toaster.success({title: "", body: toast});
            }, 500);
        }
    }

    function decreaseAdjustSettingTemp() {
        $scope.AdjustTemp = parseInt($scope.AdjustTemp, 10);
        if (($scope.AdjustTemp) > $scope.minAdjustTemp) {
            $scope.AdjustTemp = $scope.AdjustTemp - 1;
        } else {
            $scope.AdjustTemp = $scope.minAdjustTemp;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_alarm_minimum_temp;
                toast = toast.replace(/#1#/, $scope.minAdjustTemp);
                toaster.success({title: "", body: toast});
            }, 500);
        }
    }

    function doValidationForTemp() {
        if ($scope.focuseRemoved) {
            $scope.focuseRemoved = false;
            return;
        }
        $scope.desiredTemp = parseInt($scope.desiredTemp, 10);
        if ($scope.desiredTemp > $scope.maxTemp) {
            $scope.desiredTemp = $scope.maxTemp;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                toast = toast.replace(/#1#/, $scope.minTemp);
                toast = toast.replace(/#2#/, $scope.maxTemp);
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if ($scope.desiredTemp < $scope.minTemp) {
            $scope.desiredTemp = $scope.minTemp;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                toast = toast.replace(/#1#/, $scope.minTemp);
                toast = toast.replace(/#2#/, $scope.maxTemp);
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if (!($scope.desiredTemp)) {
            $scope.desiredTemp = $scope.minTemp;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                toast = toast.replace(/#1#/g, $scope.minTemp);
                toast = toast.replace(/#2#/g, $scope.maxTemp);
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if (($scope.desiredTemp) % $scope.TempIncrement !== 0 && ($scope.desiredTemp >= $scope.minTemp) && ($scope.desiredTemp <= $scope.maxTemp)) {
            $scope.desiredTemp = Math.ceil(parseInt($scope.desiredTemp, 10) / $scope.TempIncrement) * $scope.TempIncrement;
        }

    }

    function doValidationForHour() {
        if ($scope.focuseRemoved) {
            $scope.focuseRemoved = false;
            return;
        }
        var desiredHr = parseInt($scope.desiredHours, 10);
        if (!!!desiredHr && desiredHr !== 0) {
            $scope.desiredHours = parseInt(0, 10);
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }
        if (desiredHr < 0) {
            $scope.desiredHours = parseInt(0, 10);
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }
        if (desiredHr >= 10) {
            $scope.desiredHours = parseInt(9, 10);
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }
        if (parseInt($scope.desiredHours, 10) === 0 && parseInt($scope.desiredMinutes, 10) === 0) {
            $scope.desiredMinutes = 1;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }
    }

    function doValidationForMinute() {
        if ($scope.focuseRemoved) {
            $scope.focuseRemoved = false;
            return;
        }
        var desiredMin = parseInt($scope.desiredMinutes, 10);
        if (!!!desiredMin && desiredMin !== 0) {
            $scope.desiredMinutes = 0;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }
        if (desiredMin < 0) {
            $scope.desiredMinutes = 0;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }
        if (parseInt($scope.desiredHours, 10) === 0 && parseInt($scope.desiredMinutes, 10) === 0) {
            $scope.desiredMinutes = 01;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }
        if (desiredMin >= 60) {
            $scope.desiredMinutes = 59;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }
    }

    function doValidationForAMCTemp() {
        $scope.desiredAMCTemp = parseInt($scope.desiredAMCTemp, 10);
        if ($scope.desiredAMCTemp > $scope.maxTemp) {
            $scope.desiredAMCTemp = $scope.maxTemp;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                toast = toast.replace(/#1#/, $scope.minTemp);
                toast = toast.replace(/#2#/, $scope.maxTemp);
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);

        }

        if ($scope.desiredAMCTemp < $scope.minTemp) {
            $scope.desiredAMCTemp = $scope.minTemp;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                toast = toast.replace(/#1#/, $scope.minTemp);
                toast = toast.replace(/#2#/, $scope.maxTemp);
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if (!($scope.desiredAMCTemp)) {
            $scope.desiredAMCTemp = $scope.minTemp;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                toast = toast.replace(/#1#/, $scope.minTemp);
                toast = toast.replace(/#2#/, $scope.maxTemp);
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if (($scope.desiredAMCTemp) % $scope.TempIncrement !== 0 && ($scope.desiredAMCTemp >= $scope.minTemp) && ($scope.desiredAMCTemp <= $scope.maxTemp)) {
            $scope.desiredAMCTemp = Math.ceil(parseInt($scope.desiredAMCTemp, 10) / $scope.TempIncrement) * $scope.TempIncrement;
        }

    }

    function doValidationForAMCHour() {
        var desiredHr = parseInt($scope.desiredAMCHr, 10);
        if (!!!desiredHr && desiredHr !== 0) {
            $scope.desiredAMCHr = parseInt(0, 10);
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if (desiredHr < 0) {
            $scope.desiredAMCHr = parseInt(0, 10);
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }
        if (desiredHr >= 10) {
            $scope.desiredAMCHr = parseInt(9, 10);
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }
        if (parseInt($scope.desiredAMCHr, 10) === 0 && parseInt($scope.desiredAMCMin, 10) === 0) {
            $scope.desiredAMCMin = 1;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }
    }

    function doValidationForAMCMinute() {
        var desiredMin = parseInt($scope.desiredAMCMin, 10);
        if (!!!desiredMin && desiredMin !== 0)
        {
            $scope.desiredAMCMin = 0;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if (desiredMin < 0) {
            $scope.desiredAMCMin = 0;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if (parseInt($scope.desiredAMCHr, 10) === 0 && parseInt($scope.desiredAMCMin, 10) === 0) {
            $scope.desiredAMCMin = 01;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }
        if (desiredMin >= 60) {
            $scope.desiredAMCMin = 59;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }
    }

    function doValidationForProbeTemp() {
        if ($scope.focuseRemoved) {
            $scope.focuseRemoved = false;
            return;
        }
        $scope.desiredProbeTemp = parseInt($scope.desiredProbeTemp, 10);
        if ($scope.desiredProbeTemp > $scope.maxProbeTemp) {
            $scope.desiredProbeTemp = $scope.maxProbeTemp;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                toast = toast.replace(/#1#/, $scope.minProbeTemp);
                toast = toast.replace(/#2#/, $scope.maxProbeTemp);
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if ($scope.desiredProbeTemp < $scope.minProbeTemp) {
            $scope.desiredProbeTemp = $scope.minProbeTemp;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                toast = toast.replace(/#1#/, $scope.minProbeTemp);
                toast = toast.replace(/#2#/, $scope.maxProbeTemp);
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if (!($scope.desiredProbeTemp)) {
            $scope.desiredProbeTemp = $scope.minProbeTemp;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                toast = toast.replace(/#1#/, $scope.minProbeTemp);
                toast = toast.replace(/#2#/, $scope.maxProbeTemp);
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if (($scope.desiredProbeTemp) % $scope.TempIncrement !== 0 && ($scope.desiredProbeTemp >= $scope.minProbeTemp) && ($scope.desiredProbeTemp <= $scope.desiredProbeTemp)) {
            $scope.desiredProbeTemp = Math.ceil(parseInt($scope.desiredProbeTemp, 10) / $scope.TempIncrement) * $scope.TempIncrement;
        }
    }

    function doValidationForEditTemp() {
        if ($scope.focuseRemoved) {
            $scope.focuseRemoved = false;
            return;
        }
        $scope.desiredEditTemp = parseInt($scope.desiredEditTemp, 10);
        if ($scope.desiredEditTemp > $scope.maxTemp) {
            $scope.desiredEditTemp = $scope.maxTemp;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                toast = toast.replace(/#1#/, $scope.minTemp);
                toast = toast.replace(/#2#/, $scope.maxTemp);
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if ($scope.desiredEditTemp < $scope.minTemp) {
            $scope.desiredEditTemp = $scope.minTemp;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                toast = toast.replace(/#1#/, $scope.minTemp);
                toast = toast.replace(/#2#/, $scope.maxTemp);
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if (!($scope.desiredEditTemp)) {
            $scope.desiredEditTemp = $scope.minTemp;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                toast = toast.replace(/#1#/, $scope.minTemp);
                toast = toast.replace(/#2#/, $scope.maxTemp);
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if (($scope.desiredEditTemp) % $scope.TempIncrement !== 0 && ($scope.desiredEditTemp >= $scope.minTemp) && ($scope.desiredEditTemp <= $scope.maxTemp)) {
            $scope.desiredEditTemp = Math.ceil(parseInt($scope.desiredEditTemp, 10) / $scope.TempIncrement) * $scope.TempIncrement;
        }

    }

    function doValidationForEditHour() {
        if ($scope.focuseRemoved) {
            $scope.focuseRemoved = false;
            return;
        }
        editModeTimeUpdate = true;
        var desiredHr = parseInt($scope.desiredEditHours, 10);
        if (!!!desiredHr && desiredHr !== 0) {
            $scope.desiredEditHours = parseInt(0, 10);
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if (desiredHr < 0) {
            $scope.desiredEditHours = parseInt(0, 10);
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }
        if (desiredHr >= 10) {
            $scope.desiredEditHours = parseInt(9, 10);
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }
        if (parseInt($scope.desiredEditHours, 10) === 0 && parseInt($scope.desiredEditMinutes, 10) === 0) {
            $scope.desiredEditMinutes = 1;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }
    }

    function doValidationForEditMinute() {
        if ($scope.focuseRemoved) {
            $scope.focuseRemoved = false;
            return;
        }
        editModeTimeUpdate = true;
        var desiredMin = parseInt($scope.desiredEditMinutes, 10);
        if (!!!desiredMin && desiredMin !== 0)
        {
            $scope.desiredEditMinutes = 0;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if (desiredMin < 0) {
            $scope.desiredEditMinutes = 0;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if (parseInt($scope.desiredEditHours, 10) === 0 && parseInt($scope.desiredEditMinutes, 10) === 0) {
            $scope.desiredEditMinutes = 01;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }
        if (desiredMin >= 60) {
            $scope.desiredEditMinutes = 59;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                toast = toast.replace(/#1#/g, "0:01");
                toast = toast.replace(/#2#/g, "9:59");
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }
    }

    function doValidationForEditProbeTemp() {
        if ($scope.focuseRemoved) {
            $scope.focuseRemoved = false;
            return;
        }
        $scope.desiredEditProbeTemp = parseInt($scope.desiredEditProbeTemp, 10);
        if ($scope.desiredEditProbeTemp > $scope.maxProbeTemp) {
            $scope.desiredEditProbeTemp = $scope.maxProbeTemp;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                toast = toast.replace(/#1#/, $scope.minProbeTemp);
                toast = toast.replace(/#2#/, $scope.maxProbeTemp);
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if ($scope.desiredEditProbeTemp < $scope.minProbeTemp) {
            $scope.desiredEditProbeTemp = $scope.minProbeTemp;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                toast = toast.replace(/#1#/, $scope.minProbeTemp);
                toast = toast.replace(/#2#/, $scope.maxProbeTemp);
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if (!($scope.desiredEditProbeTemp)) {
            $scope.desiredEditProbeTemp = $scope.minProbeTemp;
            $timeout(function () {
                var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                toast = toast.replace(/#1#/, $scope.minProbeTemp);
                toast = toast.replace(/#2#/, $scope.maxProbeTemp);
                toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
            }, 500);
        }

        if (($scope.desiredEditProbeTemp) % $scope.TempIncrement !== 0 && ($scope.desiredEditProbeTemp >= $scope.minProbeTemp) && ($scope.desiredEditProbeTemp <= $scope.maxProbeTemp)) {
            $scope.desiredEditProbeTemp = Math.ceil(parseInt($scope.desiredEditProbeTemp, 10) / $scope.TempIncrement) * $scope.TempIncrement;
        }
    }

    function changePopUpClass() {
        if ($scope.ovenFnMenuVisible) {
            $scope.ModeSelectionPopupDivCls = "ModeSelectionPopupDiv";
        } else {
            $scope.ModeSelectionPopupDivCls = "ModeSelectionPopOutDiv";
        }
    }

    function TopMarginForList(condition) {
        if (condition) {
            return {
                paddingTop: $scope.rangeUpperMoniterVisibleHeight + 'px'
            };
        }
    }

    function selectedTabPageTab(RangeMainPageSelectedTab) {
        return RangeMainPageSelectedTab === $scope.RangeMainPageCurrentTab;
    }

    function RangeTabClick(RangeTabId) {
        $scope.RangeMainPageCurrentTab = RangeTabId;
        if (RangeTabId === 1) {
            $scope.cookTopType = getCookTopModetType($scope.DeviceModelName);
            $scope.cookTopValues = readCooktopValue($scope.deviceDualLowerInfo.Mode.options[0].Cooktop, 5);
            $scope.warmingCenter = readWarmingCenterValue($scope.deviceDualLowerInfo.Mode.options[0].WarmingCenter);
            showCookTop = true;
            validateCurrentScreen('CookTopPage');
            getDeviceCall();
            autoGetDeviceCall();
            debugMessage('$scope.DeviceModelName ' + $scope.DeviceModelName + ' && $scope.cookTopType ' + $scope.cookTopType + ' && ' + "$scope.cookTopValues " + $scope.cookTopValues);
        } else {
            showCookTop = false;
            $scope.editMode = false;
            showCurrentScreen();
        }
        $scope.SettingOptionVisible = !showCookTop;
        $scope.AboutOptionVisible = !showCookTop;
        hideOptionMenu();
    }

    function selectedCookOptions(SelectedTabId) {
        return parseInt(SelectedTabId, 10) === parseInt($scope.rangeCurrentMenuSelected, 10);
    }

    function expandListItemClickHandler(tabNumber, recipeInfo) {
        debugMessage(recipeInfo[12] + " menu Sub Item Selected with index " + tabNumber);
        scroll_middle_area.style.position = "absolute";
        scroll_middle_area.style.overflowY = "overlay";
        $timeout(function () {
            switch (tabNumber) {
                case 0:
                case 2:
                case 3:
                    debugMessage("Expandable list clicked Menu Item Mode : " + recipeInfo[12] + ' && Info :' + recipeInfo);
                    setClickedItemDate(recipeInfo);
                    $scope.rangeFunctionMenuExpandList = false;
                    $scope.rangeCurrentMenuSelected = null;
                    changePopUpClass();
                    showCurrentScreen();
                    break;
                case 1:
                    if (recipeInfo[13] === 'WEBMOB_device_range_mycooking_edit_mycooking') {
                        validateCurrentScreen('EditMyCookingPage');
                    } else {
                        myCookingModeTrue = true;
                        debugMessage('readyStateContents : ' + JSON.stringify(recipeInfo));
                        setClickedItemDate(recipeInfo);
                        showCurrentScreen();
                    }
                    $scope.rangeFunctionMenuExpandList = false;
                    break;
                default:
                    debugMessage("default");
                    break;

            }
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
        hideOptionMenu();
    }

    function onClickModeOptionAMC(recipeInfo) {
        //setClickedItemDate(recipeInfo);
        $scope.AMCFnMenuVisible = false;
        AMCInfo = recipeInfo;
        loadAMCData(recipeInfo);
        //showCurrentScreen();
    }

    function setClickedItemDate(recipeInfo) {
        if ($scope.dividerConnected && $scope.RunningUpperOven) {
            changeUpperRecipe = true;
            userPreferneceSingleUpper = {};
            userPreferneceSingleSinlge = {};
            deviceUpperMode = recipeInfo[12];
            $scope.readyStateContentsDualUpper[0].values[0] = recipeInfo;
        } else if ($scope.dividerConnected && $scope.RunningLowerOven) {
            changeLowerRecipe = true;
            userPreferneceDualLower = {};
            userPreferneceSingleSinlge = {};
            deviceLowerMode = recipeInfo[12];
            $scope.readyStateContentsDualLower[0].values[0] = recipeInfo;
        } else {
            changSingleRecipe = true;
            userPreferneceSingleUpper = {};
            userPreferneceDualLower = {};
            userPreferneceSingleSinlge = {};
            deviceSingleMode = recipeInfo[12];
            $scope.readyStateContentsSingle[0].values[0] = recipeInfo;
        }
    }

    function editMyCookingItemClick(recipeInfo) {
        debugMessage("inside editMyCookingItemClick : " + recipeInfo);
        if (!$scope.multiselect) {
            setClickedItemDate(recipeInfo);
            readyToDelete = false;
            myCookingModeTrue = true;
            AMCInfo = recipeInfo;
            loadAMCData(recipeInfo);
            if ($scope.currentScreen === RANGESCREENS.RANGE_EDIT_MY_COOKING_PAGE) {
                debugMessage('Show Add My Cooking Page ');
                $scope.showRenameOption = true;
                validateCurrentScreen('AddMyCookingPage');
                return;
            }
        } else {
            var index = $scope.editMyCookingSelectedDeleteItems.indexOf(recipeInfo[27]);
            if (index === -1) {
                $scope.editMyCookingSelectedDeleteItems.push(recipeInfo[27]);
            } else {
                $scope.editMyCookingSelectedDeleteItems.splice(index, 1);
            }
            readyToDelete = $scope.editMyCookingSelectedDeleteItems.length > 0;
            debugMessage("List of recipe to delete : " + $scope.editMyCookingSelectedDeleteItems);
        }
    }

    function deleteMyCookings() {
        debugMessage('deleteMyCookings : readyToDelete :' + readyToDelete + ' && multiselect : ' + $scope.multiselect);

        if (!readyToDelete) {
            $scope.editMyCookingSelectedDeleteItems = [];
            $scope.multiselect = !$scope.multiselect;
        }

        if ($scope.multiselect && readyToDelete) {
            debugMessage('deleteMyCookingsConfirmed ');
            deleteMyCookingsConfirmed();
        }
    }

    function deleteMyCookingsConfirmed() {
        var name;
        if ($scope.editMyCookingSelectedDeleteItems.length === 1) {
            name = $scope.editMyCookingSelectedDeleteItems[0] + " " + $scope.translation.WEBMOB_device_range_alarm_mycooking_delete_recipe;
        } else {
            name = $scope.editMyCookingSelectedDeleteItems.length + " " + $scope.translation.WEBMOB_device_range_alarm_mycooking_delete_recipe;
        }

        showcustDialog(RANGE_ALERT_STATE.ALERT_DELETE_MY_COOKING, $scope.translation.WEBMOB_common_delete, name, $scope.translation.WEBMOB_common_cancel, $scope.translation.WEBMOB_common_ok);
    }

    function listUpDownIconId(id) {
        return "RANGE/assets/img/main_ov_list_down.svg#Layer_1";
//        if (id === $scope.rangeCurrentMenuSelected) {
//            return "RANGE/assets/img/main_ov_list_up.svg#Layer_1";
//        } else {
//            return "RANGE/assets/img/main_ov_list_down.svg#Layer_1";
//        }
    }

    function onClickCookingOptionsFromMenu(TabsPagetab, index) {
        debugMessage("TabsPagetab.id " + TabsPagetab.id + " clicked");
        myCookingModeTrue = false;
        $scope.SlowCookTemp = 'High';
        changeMenuIconImageCls(index);
        switch (TabsPagetab.id) {
            case 1:
            case 2:
            case 3:
            case 4:
                if (TabsPagetab.id === 2) {
                    myCookingModeTrue = true;
                    updateMyCookingList();
                    updateAMCList();
                }
                if (selectedCookOptions(TabsPagetab.id)) {
                    $scope.rangeCurrentMenuSelected = null;
                } else {
                    $scope.rangeCurrentMenuSelected = TabsPagetab.id;
                }
                break;
            case 5:
                $scope.rangeFunctionMenuExpandList = false;
                validateCurrentScreen('AutoCookPage');
                break;
            default:
                break;
        }
    }

    function loadAMCData(readyContent) {
        debugMessage("loadAMCData info : " + readyContent);
        var newdate = new Date();
        var readyStateContent = angular.copy(readyContent);
        $scope.UpdateAMCData = angular.copy(readyStateContent);
        deviceAMCMode = readyStateContent[12];
        newdate.setHours(0, readyStateContent[17], 0);
        $scope.desiredAMCHr = newdate.getHours();
        $scope.desiredAMCMin = newdate.getMinutes();
        $scope.desiredAMCMode = getDeviceDataMode(deviceAMCMode);
        $scope.recipeDescription = readyStateContent[9];
        if (readyStateContent[27] !== undefined) {
            $scope.AMCName = readyStateContent[27];
        }
        if ($scope.TempUnit === 'F') {
            $scope.desiredAMCTemp = readyStateContent[14];
            $scope.minTemp = readyStateContent[15];
            $scope.maxTemp = readyStateContent[16];
        } else {
            $scope.desiredAMCTemp = readyStateContent[24];
            $scope.minTemp = readyStateContent[25];
            $scope.maxTemp = readyStateContent[26];

        }
    }

    function addToMyCooking(e) {
        $timeout(function () {
            //setDataCurrentScreen();
            //loadAMCData($scope.readyStateContentsSingle[0].values[0]);
            deviceMode = 'Bake';
            if ($scope.dividerConnected && $scope.RunningUpperOven) {
                deviceUpperMode = 'UpperConvectionBake';
                $scope.readyStateContentsDualUpper = db.exec("SELECT * FROM " + setTableName(deviceUpperMode) + " WHERE MODE = '" + deviceUpperMode + "'");
                AMCInfo = $scope.readyStateContentsDualUpper[0].values[0];
                loadAMCData($scope.readyStateContentsDualUpper[0].values[0]);
            } else if ($scope.dividerConnected && $scope.RunningLowerOven) {
                deviceLowerMode = 'LowerBake';
                $scope.readyStateContentsDualLower = db.exec("SELECT * FROM " + setTableName(deviceLowerMode) + " WHERE MODE = '" + deviceLowerMode + "'");
                AMCInfo = $scope.readyStateContentsDualLower[0].values[0];
                loadAMCData($scope.readyStateContentsDualLower[0].values[0]);
            } else {
                deviceSingleMode = 'Bake';
                $scope.readyStateContentsSingle = db.exec("SELECT * FROM " + setTableName(deviceSingleMode) + " WHERE MODE = '" + deviceSingleMode + "'");
                AMCInfo = $scope.readyStateContentsSingle[0].values[0];
                loadAMCData($scope.readyStateContentsSingle[0].values[0]);
            }
            validateCurrentScreen('AddMyCookingPage');
            if (angular.isDefined(e)) {
                e.stopPropagation();
            }
        }, 100);

    }

    function showcustDialog(myAlertState, msgHeader, popuptext, txtButton1, txtButton2) {
        //dialogPopUp.show();
        debugMessage("showcustDialog " + myAlertState + " " + msgHeader + " " + popuptext + " " + txtButton1 + " " + txtButton2);
        $scope.showFullScreenPopup = true;
        $scope.alertState = myAlertState;
        $scope.msgText = popuptext;
        hideInputBoxFocus();
        document.getElementById("fullScreenPopupId").style.zIndex = 999;
        document.getElementById("custPopupDivId").style.zIndex = 999;

        if (msgHeader === undefined || msgHeader === '') {
            msgHeader = $scope.translation.WEBMOB_common_device_range;
        }

        document.getElementById("custpopupheadertext").innerHTML = msgHeader;
        document.getElementById("custpopuptext").innerHTML = popuptext;

        if (txtButton1 !== undefined || txtButton1 !== '') {
            document.getElementById("alertbutton2").innerHTML = txtButton1;
            document.getElementById("alertbutton2").style.visibility = "visible";
        } else {
            document.getElementById("alertbutton2").style.visibility = "hidden";
        }

        if (txtButton2 !== undefined || txtButton2 !== '') {
            document.getElementById("alertbutton1").innerHTML = txtButton2;
            document.getElementById("alertbutton1").style.visibility = "visible";
        } else {
            document.getElementById("alertbutton1").style.visibility = "hidden";
        }
    }

    function onAlertButton1Click() {
        debugMessage("onAlertButton1Click Kidding");
        $scope.inputDialogPopUp = false;
        switch ($scope.alertState) {
            case RANGE_ALERT_STATE.ALERT_PREHEATCOMPLETE:
                if ($scope.deviceSingleUpperInfo.Alarms[0].code === "RG_T_0001") {
                    emptyAlarm();
                }

                if ($scope.deviceDualLowerInfo.Alarms[0].code === "RG_T_1001") {
                    emptyAlarm();
                }
                $scope.upperPreheat = false;
                $scope.lowerPreheat = false;
                break;
            case RANGE_ALERT_STATE.ALERT_START_COOKING:
                debugMessage("start cooking confirmed ok");
                $scope.showFullScreenPopup = false;
                sendButtonClickedConfirmed();
                break;
            case RANGE_ALERT_STATE.ALERT_START_ATUOCOOK_COOKING:
                debugMessage("start cooking Auto Cook confirmed ok");
                $scope.showFullScreenPopup = false;
                sendButtonClickedFromAutoCookDetailPageConfirmed();
                break;
            case RANGE_ALERT_STATE.ALERT_CANCEL_COOKING:
                debugMessage("cancel cooking confirmed ok");
                $scope.showFullScreenPopup = false;
                onCancelProgressConfirmed();
                break;
            case RANGE_ALERT_STATE.ALERT_COOKING_SNOOZE:
                if (!$scope.remoteControlEnabled) {
                    showcustDialog(RANGE_ALERT_STATE.ALERT_SMARTMONITOR_GUIDE, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_alarm_smart_control_on, $scope.translation.WEBMOB_common_ok, '');
                    return;
                }
                $scope.showFullScreenPopup = false;
                var deviceId = 0,
                        currentOpeationTime = $scope.deviceSingleUpperInfo.Operation.remainingTime;
                if (snoozUpper) {
                    deviceId = 0;
                    currentOpeationTime = $scope.deviceSingleUpperInfo.Operation.remainingTime;
                    snoozUpper = false;
                    debugMessage("current upper/single time : " + currentOpeationTime);
                } else if (snoozLower) {
                    snoozLower = false;
                    deviceId = 1;
                    currentOpeationTime = $scope.deviceDualLowerInfo.Operation.remainingTime;
                    debugMessage("current lower time : " + currentOpeationTime);
                }
                var hour = currentOpeationTime.split(':')[0],
                        minute = currentOpeationTime.split(':')[1],
                        totaltimeinMinutes = ((parseInt(hour, 10) * 60) + parseInt(minute, 10) + 5),
                        newHour, newMinute, newOperationTime;
                newHour = parseInt(totaltimeinMinutes / 60, 10);
                newMinute = totaltimeinMinutes % 60;
                if (newHour.toString().length === 1) {
                    newHour = "0" + newHour;
                }
                if (newMinute.toString().length === 1) {
                    newMinute = "0" + newMinute;
                }
                newOperationTime = newHour + ":" + newMinute + ":00";
                $scope.checkResponse.push(RANGE_COMMANDS.snoozeCookingTime);
                debugMessage(getSendSnoozeCommand(newOperationTime));
                SHPService.sendSHPCommand(CONSTANTS.PUT, getSendSnoozeCommand(newOperationTime), "/" + $scope.peerId + "/devices/" + deviceId);
                break;
            case RANGE_ALERT_STATE.ALERT_SAVEMYRECIPE:
                if (!$scope.isStatic) {
                    var hr, min, time = 30;
                    if (!validateRecipeName(document.getElementById("custpopupInputtext").value)) {
                        return;
                    }
                    myRecipeID++;
                    hr = $scope.desiredAMCHr;
                    min = $scope.desiredAMCMin;
                    time = hr * 60 + min;
                    insertDataIntoFavoriteTable(myRecipeID, deviceAMCMode, document.getElementById("custpopupInputtext").value, $scope.desiredAMCTemp, time, getSupportSingleMode(deviceAMCMode), getSupportUpperMode(deviceAMCMode), getSupportLowerMode(deviceAMCMode));
                    updateMyCookingList();
                    updateAMCList();
                }
                validateCurrentScreen('EditMyCookingPage');
                break;
            case RANGE_ALERT_STATE.ALERT_DELETE_MY_COOKING:
                $scope.showFullScreenPopup = false;
                debugMessage(' length for list main and selected  : ' + $scope.myCookingListItems.length + ' && ' + $scope.editMyCookingSelectedDeleteItems.length);
                if ($scope.myCookingListItems.length > 0 && $scope.editMyCookingSelectedDeleteItems.length > 0) {
                    for (var i = 0; i < $scope.editMyCookingSelectedDeleteItems.length; i++) {
                        for (var j = 0; j < $scope.myCookingListItems.length; j++) {
                            if ($scope.editMyCookingSelectedDeleteItems[i] === $scope.myCookingListItems[j][27]) {
                                debugMessage('delete item  : ' + $scope.myCookingListItems[j][27] + ' && ' + $scope.editMyCookingSelectedDeleteItems[i]);
                                $scope.myCookingListItems.splice(j, 1);
                            }
                        }
                    }
                }
                $scope.myCookingListItems.splice($scope.myCookingListItems.length - 1, 1);
                setLocalStorageData(RANGELOCALSTORAGE.FAVDB, JSON.stringify($scope.myCookingListItems));
                $scope.editMyCookingSelectedDeleteItems = [];
                $scope.multiselect = false;
                readyToDelete = false;
                updateMyCookingList();
                updateAMCList();
                break;
            case RANGE_ALERT_STATE.ALERT_CHILD_LOCK:
                debugMessage("child lock OK");
                break;
            case RANGE_ALERT_STATE.ALERT_SMARTMONITOR_GUIDE:
                debugMessage("smart control OK");
                break;
            case RANGE_ALERT_STATE.ALERT_DOOR_OPEN:
                debugMessage("cancel Door Open");
                $scope.showFullScreenPopup = false;
                break;
            case RANGE_ALERT_STATE.ALERT_SABBATH_MODE:
                debugMessage("sabbath mode OK");
                break;
            case RANGE_ALERT_STATE.ALERT_RENAMERECIPE:
                if (!validateRecipeName(document.getElementById("custpopupInputtext").value)) {
                    return;
                }
                $scope.renamedRecipe = document.getElementById("custpopupInputtext").value;
                break;
            case RANGE_ALERT_STATE.ALERT_CONNECTION_ERROR:
                closeApp();
                break;
            case RANGE_ALERT_STATE.ALERT_DEVELOPER_INFO:
                $scope.showFullScreenPopup = false;
                break;
            case RANGE_ALERT_STATE.ALERT_SERVICE_CALL:
                callServieCenter();
                break;
            case RANGE_ALERT_STATE.ALERT_AUTO_COOK_PROBE:
                $scope.showFullScreenPopup = true;
                debugMessage("auto cook probe connected cancel");
                break;
            default:
                break;
        }
    }

    function onAlertButton2Click() {
        $scope.showFullScreenPopup = false;
        $scope.inputDialogPopUp = false;

        switch ($scope.alertState) {
            case RANGE_ALERT_STATE.ALERT_TURNONOVEN:
                break;
            case RANGE_ALERT_STATE.ALERT_START_COOKING:
                debugMessage("start cooking confirmation popup cancel");
                break;
            case RANGE_ALERT_STATE.ALERT_START_ATUOCOOK_COOKING:
                debugMessage("start cooking Auto Cook confirmed cancel");
                break;
            case RANGE_ALERT_STATE.ALERT_CANCEL_COOKING:
                debugMessage("cancel cooking confirmation popup cancel");
                break;
            case RANGE_ALERT_STATE.ALERT_COOKING_SNOOZE:
                snoozUpper = false;
                snoozLower = false;
                debugMessage("5 minutes added to cooking");
                break;
            case RANGE_ALERT_STATE.ALERT_SAVEMYRECIPE:
                debugMessage("AMC save cancel button");
                break;
            case RANGE_ALERT_STATE.ALERT_DELETE_MY_COOKING:
                debugMessage("cancel deleting my cooking");
                break;
            case RANGE_ALERT_STATE.ALERT_CHILD_LOCK:
                debugMessage("child lock cancelled");
                break;
            case RANGE_ALERT_STATE.ALERT_SMARTMONITOR_GUIDE:
                debugMessage("smart control cancelled");
                break;
            case RANGE_ALERT_STATE.ALERT_DOOR_OPEN:
                debugMessage("cancel Door Open");
                $scope.showFullScreenPopup = false;
                break;
            case RANGE_ALERT_STATE.ALERT_SABBATH_MODE:
                debugMessage("sabbath mode cancelled");
                break;
            case RANGE_ALERT_STATE.ALERT_RENAMERECIPE:
                break;
            case RANGE_ALERT_STATE.ALERT_CONNECTION_ERROR:
                $scope.showFullScreenPopup = true;
                debugMessage("cancel connection pop up");
                break;
            case RANGE_ALERT_STATE.ALERT_SERVICE_CALL:
                debugMessage("cancel service center call");
                break;
            case RANGE_ALERT_STATE.ALERT_AUTO_COOK_PROBE:
                $scope.showFullScreenPopup = false;
                debugMessage("auto cook probe connected OK");
                break;
            default:
                break;
        }
        debugMessage("onAlertButton2Click");
    }

    function onAboutAction(reqParam) {
        if (reqParam === "smartcare") {
            $scope.currentScreen = RANGESCREENS.RANGE_SMART_CARE_PAGE;
            validateCurrentScreen('SmartCarePage');
            return;
        }
        nativeInterface.runOnNative("customerService", aboutCommand(reqParam));
    }

    function aboutCommand(cmdstring) {
        return '{"service" : "' + cmdstring + '","selectedCountry" : "' + $scope.selectedCountry + '"}';
    }

    function callServieCenter() {
        debugMessage("call service center");
        nativeInterface.runOnNative("callDial", '{"selectedCountry" : "' + $scope.selectedCountry + '"}');
    }

    function CtoF(c) {
        return  Math.round((c * 1.8) + 32);
    }

    function FtoC(f) {
//        return  Math.round((f - 32) / 1.8);
        return f;
    }

    function Cel2Fer(c, item) {
        var temp = Math.round((c * 1.8) + 32);
        if (temp < item[15]) {
            temp = item[15];
        } else if (temp > item[16]) {
            temp = $scope.item[16];
        }
        return temp;
    }

    function Fer2Cel(f, item) {
        var temp = Math.round((f - 32) / 1.8);
        if (temp < item[25]) {
            temp = item[25];
        } else if (temp > item[26]) {
            temp = item[26];
        }
        return temp;
    }

    function changeTempUnit(unit) {
//        if (unit === 'celsius') {
//            $scope.bFahrenheit = false;
//            $scope.TempUnit = 'C';
//        } else if (unit === 'fahrenheit') {
//            $scope.bFahrenheit = true;
//            $scope.TempUnit = 'F';
//        }

        if (unit === 'Fahrenheit' && $scope.TempUnit === 'F'
                || unit === 'Celsius' && $scope.TempUnit === 'C') {
            debugMessage(' return changeTempUnit same value');
            return;
        }
        if ($scope.deviceSingleUpperInfo.Operation.state === "Run"
                || $scope.deviceDualLowerInfo.Operation.state === "Run") {
            settingOptionPreCondition();
            return;
        }
        if (!$scope.isStatic) {
            $scope.checkResponse.push(RANGE_COMMANDS.changeTempUnit);
            debugMessage(getTempUnitCommand(unit) + "/" + $scope.peerId + "/devices/0");
            SHPService.sendSHPCommand(CONSTANTS.PUT, getTempUnitCommand(unit), "/" + $scope.peerId + "/devices/0/temperatures/0");
        }
    }

    function setTempUnit(state) {
        if (!justFirstTime && !$scope.appAtForeground && state === 'Ready' && !configCall) {
            refreshValue();
            changeUpperRecipe = true;
            changeLowerRecipe = true;
            changSingleRecipe = true;
            userPreferneceDualLower = {};
            userPreferneceSingleUpper = {};
            userPreferneceSingleSinlge = {};
            $scope.TempUnit = $scope.deviceSingleUpperInfo.Temperatures[0].unit === 'Celsius' ? 'C' : 'F';
            if ($scope.currentScreen === RANGESCREENS.RANGE_ADD_MY_COOKING_PAGE && AMCInfo !== undefined) {
                $scope.AMCFnMenuVisible = false;
                loadAMCData(AMCInfo);
            }

            if ($scope.currentScreen === RANGESCREENS.RANGE_SEND_CONFERMATION_PAGE) {
                var newDesired, newProbeDesired;
                if ($scope.TempUnit === 'C') {
                    newDesired = Math.round(($scope.validateSendRecipeInfo.DesiredTemp - 32) / 1.8);
                    newProbeDesired = Math.round(($scope.validateSendRecipeInfo.DesiredProbeTemp - 32) / 1.8);
                } else {
                    newDesired = Math.round(($scope.validateSendRecipeInfo.DesiredTemp * 1.8) + 32);
                    newProbeDesired = Math.round(($scope.validateSendRecipeInfo.DesiredProbeTemp * 1.8) + 32);
                }
                $scope.validateSendRecipeInfo.DesiredTemp = newDesired;
                $scope.validateSendRecipeInfo.DesiredProbeTemp = newProbeDesired;
                $scope.validateSendRecipeInfoDesiredTemp = newDesired;
                $scope.validateSendRecipeInfoDesiredProbeTemp = newProbeDesired;
            }
        }
    }

    function updateSendRecipeValues(id) {
        debugMessage("updateSendRecipeValues with cavity " + id);
        if (id === 1) {
            $scope.validateSendRecipeInfo.DesiredTemp = Number($scope.deviceDualLowerInfo.Temperatures[0].desired);
            $scope.validateSendRecipeInfoDesiredTemp = Number($scope.deviceDualLowerInfo.Temperatures[0].desired);
            $scope.validateSendRecipeInfo.OperationTime = $scope.deviceDualLowerInfo.Operation.operationTime;
            $scope.validateSendRecipeInfoOperationHrs = Number($scope.deviceDualLowerInfo.Operation.operationTime.split(':')[0][1]);
            $scope.validateSendRecipeInfoOperationMints = Number($scope.deviceDualLowerInfo.Operation.operationTime.split(':')[1]);

        } else {
            $scope.validateSendRecipeInfo.DesiredTemp = Number($scope.deviceSingleUpperInfo.Temperatures[0].desired);
            $scope.validateSendRecipeInfo.DesiredProbeTemp = Number($scope.deviceSingleUpperInfo.Temperatures[1].desired);
            $scope.validateSendRecipeInfo.SlowCookTemp = Number($scope.deviceSingleUpperInfo.Temperatures[0].desired);
            $scope.validateSendRecipeInfo.OperationTime = $scope.deviceSingleUpperInfo.Operation.operationTime;
            $scope.validateSendRecipeInfoDesiredTemp = Number($scope.deviceSingleUpperInfo.Temperatures[0].desired);
            $scope.validateSendRecipeInfoDesiredProbeTemp = Number($scope.deviceSingleUpperInfo.Temperatures[1].desired);
            $scope.validateSendRecipeInfoOperationHrs = Number($scope.deviceSingleUpperInfo.Operation.operationTime.split(':')[0][1]);
            $scope.validateSendRecipeInfoOperationMints = Number($scope.deviceSingleUpperInfo.Operation.operationTime.split(':')[1]);
        }
        setDataCurrentScreen();
    }

    function getTempUnitCommand(unit) {
        unit = unit === 'Celsius' ? 'Celsius' : 'Fahrenheit';
        return '{"Temperature" : {"unit" : "' + unit + '"}}';
    }

    function convertTimeHMMformat(time) {
        var h, m;
        h = Number(time.split(':')[0]);
        m = time.split(':')[1];
        return (h + ':' + m);
    }

    function claculateLeftTime(time) {
        var now, newDate, remHrs, remMin, crhours, crminutes, estHrs, estMin, h = 0, m = 0, meridiem = '';
        now = new Date();
        newDate = new Date();
        crhours = now.getHours();
        crminutes = now.getMinutes();
        if (time !== undefined) {
            remHrs = Number(time.split(":")[0]);
            remMin = Number(time.split(":")[1]);
            estHrs = remHrs + crhours;
            estMin = remMin + crminutes;
            newDate.setHours(estHrs, estMin, 0);
            h = newDate.getHours();
            m = newDate.getMinutes();
            if (!$scope.is24HourFormat) {
                meridiem = h >= 12 ? ' PM' : ' AM';
                h = h % 12;
                h = h ? h : 12;
            }
            m = m < 10 ? '0' + m : m;
            debugMessage("claculateLeftTime for is24HourFormat " + $scope.is24HourFormat + " time : " + time + " is :" + " " + h + ":" + m + meridiem);
            return " " + h + ":" + m + meridiem;
        }
        return " " + h + ":" + m + meridiem;
    }

    function getCookTopModetType(modelName) {
        if (modelName === 'NE9000KW/AA0') {
            return '1';
        } else if (modelName === 'NX7000KW/AA0' || modelName === 'NX9000KW/AA0' || modelName === 'NX9006M-/AA0') {
            return '2';
        } else if (modelName === 'NE9900H-/AA0') {
            return '3';
        } else if (modelName === 'NE6000MW/AA0') {
            return '4';
        } else {
            return '2';
        }
    }

    function readCooktopValue(value, length) {
        var binaryArray, getStrCopy = function (str, copies) {
            var newStr = str;
            copies = (copies > 0) ? copies : 1;
            while (--copies) {
                newStr += str;
            }
            return newStr;
        },
                convertDecToBase = function (dec, base, length, padding) {
                    padding = padding || '0';
                    var num = dec.toString(base);
                    length = length || num.length;
                    if (num.length !== length) {
                        if (num.length < length) {
                            num = getStrCopy(padding, (length - num.length)) + num;
                        }
                    }
                    return num;
                };
        return binaryArray = convertDecToBase(Number(value), 2, length).split('');
    }

    function readWarmingCenterValue(value) {
        if (value === 'Mid' || value === 'High' || value === 'Low') {
            return true;
        }
        return false;
    }

    function showAutoCookDetailsScreen(MenuItemName, id) {
        $scope.autoCookMenuDetail = db.exec("SELECT * FROM AUTO_COOK WHERE MENU ='" + MenuItemName + "'");
        $scope.autoCookCaterory = $scope.autoCookMenuDetail[0].values[0][2];
        $scope.autocookDetailScreenImage = $scope.AutoCook[id].image;
        $scope.autocookDetailScreenTrayImage = 'RANGE/assets/img/main_rg_img_tray_0' + $scope.AutoCook[id].rackPositon + '.png';
        $scope.autoCookYield = $scope.AutoCook[id].yield;
        $scope.autoCookCookingTime = $scope.AutoCook[id].cookingTime;
        $scope.autoCookMainIngrednt = $scope.AutoCook[id].mainIngrediant;
        $scope.autoCookEquipment = $scope.AutoCook[id].equipment;
        $scope.autoCookRackPosition = $scope.AutoCook[id].rackPositon;
        $scope.autoCookWireRackDesc = $scope.AutoCook[id].wireRackDesc;
        $scope.autoCookRecipeID = $scope.autoCookMenuDetail[0].values[0][1];
        validateCurrentScreen('AutoCookDetailPage');
    }

    function autoCookRangeIcon(value) {
        switch (value) {
            case 0:
                return "RANGE/assets/img/main_ov_ac_list_ic_pizza.svg#Layer_1";
            case 1:
                return "RANGE/assets/img/main_ov_ac_list_ic_pizza.svg#Layer_1";
            case 2:
                return "RANGE/assets/img/main_ov_ac_list_ic_pizza.svg#Layer_1";
            case 3:
                return "RANGE/assets/img/main_ov_ac_list_ic_pizza.svg#Layer_1";
            case 4:
                return "RANGE/assets/img/main_ov_ac_list_ic_pizza.svg#Layer_1";
            case 5:
                return "RANGE/assets/img/main_ov_ac_list_ic_pizza.svg#Layer_1";
            default:
                return "RANGE/assets/img/main_ov_ac_list_ic_pizza.svg#Layer_1";
        }
    }

    function getsendAutoCookRecipeCommand(recipeInfo) {
        return '{"Device" : {"Oven" : { "recipe" : "' + recipeInfo + '" }}}';
    }

    function sendButtonClickedFromAutoCookDetailPage() {
        debugMessage("send button clicked from Auto cook detail");
        showcustDialog(RANGE_ALERT_STATE.ALERT_START_ATUOCOOK_COOKING, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_alarm_start_cooking_now, $scope.translation.WEBMOB_common_cancel, $scope.translation.WEBMOB_common_ok);
    }

    function sendButtonClickedFromAutoCookDetailPageConfirmed() {
        if ($scope.isStatic) {
            debugMessage("send button clicked from Auto cook detail screen in isStatic mode");
            return;
        }

        if ($scope.meatProbeConnected) {
            showcustDialog(RANGE_ALERT_STATE.ALERT_AUTO_COOK_PROBE, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_alarm_selected_mode_not_support, $scope.translation.WEBMOB_common_ok, '');
            return;
        }

        if (KidsLockOn()) {
            return;
        }
        if (!$scope.remoteControlEnabled) {
            showcustDialog(RANGE_ALERT_STATE.ALERT_SMARTMONITOR_GUIDE, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_alarm_smart_control_on, $scope.translation.WEBMOB_common_ok, '');
            return;
        }
        if ($scope.bSabbathMode) {
            showcustDialog(RANGE_ALERT_STATE.ALERT_SABBATH_MODE, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_alarm_settings_sabbath_turn_off, $scope.translation.WEBMOB_common_ok, '');
            return;
        }

        var recipeInfo = '';
        if ($scope.autoCookMenuDetail[0].values[0][15] === 'SINGLE') {
            recipeInfo = '01';
        } else {
            recipeInfo = '02';
        }
        recipeInfo += $scope.autoCookMenuDetail[0].values[0][1];
        recipeInfo += '00'; // servings
        recipeInfo += '00'; // browning level
        recipeInfo += '00'; // options
        $scope.AutoCookSendRecipeId = recipeInfo;
        debugMessage("command : " + getsendAutoCookRecipeCommand(recipeInfo));
        $scope.checkResponse.push(RANGE_COMMANDS.sendRecipetoOven);
        SHPService.sendSHPCommand(CONSTANTS.PUT, getsendAutoCookRecipeCommand(recipeInfo), "/" + $scope.peerId + "/devices/0");
    }

    function inputKeyDown(e) {
        if (e === undefined) {
            return;
        }
        var inputElement = document.activeElement;
        $timeout(function () {
            if (inputElement.type === 'number') {
                var sanitized = $(inputElement).val().replace(/[^0-9]/g, '');
                // Update value
                $(inputElement).val("");
                $(inputElement).val(sanitized);
            }
        }, 0);

        if (e.keyCode === 9 && (e.currentTarget.id === "inputMins" || e.currentTarget.id === "inputEditMins" || e.currentTarget.id === "inputAMCMins")) {
            showDummyInbox()
        }
    }

    function stopLongPressEvent() {
        if (!!promise) {
            $interval.cancel(promise);
            promise = undefined;
        }
        if ($scope.longPress) {
            $scope.longPress = false;
            clearInterval($scope.timer);
            return;
        }
    }

    function increaseTemp() {
        $scope.desiredTemp = parseInt($scope.desiredTemp, 10);
        if ($scope.desiredTemp < $scope.maxTemp) {
            $scope.desiredTemp = $scope.desiredTemp + $scope.TempIncrement;
            document.getElementById("inputTempWithoutMeatProbe").value = $scope.desiredTemp;
        } else {
            $scope.desiredTemp = $scope.maxTemp;
        }
    }

    function decreaseTemp() {
        $scope.desiredTemp = parseInt($scope.desiredTemp, 10);
        if ($scope.desiredTemp > $scope.minTemp) {
            $scope.desiredTemp = $scope.desiredTemp - $scope.TempIncrement;
            document.getElementById("inputTempWithoutMeatProbe").value = $scope.desiredTemp;
        } else {
            $scope.desiredTemp = $scope.minTemp;
        }
    }

    function increaseAdjustTemp() {
        $scope.AdjustTemp = parseInt($scope.AdjustTemp, 10);
        if ($scope.AdjustTemp < $scope.maxAdjustTemp) {
            $scope.AdjustTemp = $scope.AdjustTemp + 1;
            document.getElementById("inputAdjustTemp").value = $scope.AdjustTemp;
        } else {
            $scope.AdjustTemp = $scope.maxAdjustTemp;
        }
    }

    function decreaseAdjustTemp() {
        $scope.AdjustTemp = parseInt($scope.AdjustTemp, 10);
        if ($scope.AdjustTemp > $scope.minAdjustTemp) {
            $scope.AdjustTemp = $scope.AdjustTemp - 1;
            document.getElementById("inputAdjustTemp").value = $scope.AdjustTemp;
        } else {
            $scope.AdjustTemp = $scope.minAdjustTemp;
        }
    }

    function increaseMeatProbeTemp() {
        $scope.desiredProbeTemp = parseInt($scope.desiredProbeTemp, 10);
        if (($scope.desiredProbeTemp + 1) < $scope.maxProbeTemp) {
            $scope.desiredProbeTemp = $scope.desiredProbeTemp + 1;
        } else {
            $scope.desiredProbeTemp = $scope.maxProbeTemp;
        }
        document.getElementById("inputTempMeatProbe").value = $scope.desiredProbeTemp;
    }

    function decreaseMeatProbeTemp() {
        $scope.desiredProbeTemp = parseInt($scope.desiredProbeTemp, 10);
        if ($scope.desiredProbeTemp > $scope.minProbeTemp) {
            $scope.desiredProbeTemp = $scope.desiredProbeTemp - 1;
        } else {
            $scope.desiredProbeTemp = $scope.minProbeTemp;
        }
        document.getElementById("inputTempMeatProbe").value = $scope.desiredProbeTemp;
    }

    function increaseTempContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                $scope.increaseTemp();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function decreaseTempContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                $scope.decreaseTemp();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function increaseMeatprobeTempContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                increaseMeatProbeTemp();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function decreaseMeatprobeTempContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                decreaseMeatProbeTemp();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function increaseAdjustSettingTempContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                increaseAdjustTemp();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function decreaseAdjustSettingTempContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                decreaseAdjustTemp();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function increaseDesiredHours() {
        $scope.desiredHours = parseInt($scope.desiredHours, 10);
        var minuteVal = parseInt($scope.desiredMinutes, 10);
        if ($scope.desiredHours < 9) {
            $scope.desiredHours = $scope.desiredHours + 1;
            if (minuteVal === 0 && $scope.desiredHours === 0) {
                $scope.desiredHours = 1;
            }
            document.getElementById("inputHrs").value = $scope.desiredHours;
        } else {
            $scope.desiredHours = 0;
            if (minuteVal === 0) {
                $scope.desiredHours = 1;
            }
        }
    }

    function decreaseDesiredHours() {
        $scope.desiredHours = parseInt($scope.desiredHours, 10);
        var minuteVal = parseInt($scope.desiredMinutes, 10);

        if ($scope.desiredHours > 0) {
            $scope.desiredHours = $scope.desiredHours - 1;
            if (minuteVal === 0 && $scope.desiredHours === 0) {
                $scope.desiredHours = 9;
            }
            document.getElementById("inputHrs").value = $scope.desiredHours;
        } else {
            $scope.desiredHours = 9;
            if (minuteVal === 0) {
                $scope.desiredHours = 9;
            }
        }
    }

    function increaseDesiredMinutes() {
        $scope.desiredMinutes = parseInt($scope.desiredMinutes, 10);
        var hourValue = parseInt($scope.desiredHours, 10);

        if ($scope.desiredMinutes !== 59) {
            $scope.desiredMinutes += 1;
            if (hourValue === 0 && $scope.desiredMinutes === 0) {
                $scope.desiredMinutes = 1;
            }
        } else {
            $scope.desiredMinutes = 0;
            if (hourValue === 0) {
                $scope.desiredMinutes = 1;
            }
        }
        document.getElementById("inputMins").value = $scope.desiredMinutes;
        //$scope.desiredMinutes = parseInt(($scope.desiredMinutes < 10) ? ('0' + $scope.desiredMinutes) : $scope.desiredMinutes,10);
    }

    function decreaseDesiredMinutes() {
        $scope.desiredMinutes = parseInt($scope.desiredMinutes, 10);
        var hourValue = parseInt($scope.desiredHours, 10);
        if ($scope.desiredMinutes !== 0) {
            $scope.desiredMinutes -= 1;
            if (hourValue === 0 && $scope.desiredMinutes === 0) {
                $scope.desiredMinutes = 59;
            }
            document.getElementById("inputMins").value = $scope.desiredMinutes;
        } else {
            $scope.desiredMinutes = 59;
            if ($scope.hourValue === 0) {
                $scope.desiredMinutes = 59;
            }
        }
        //$scope.desiredMinutes = parseInt(($scope.desiredMinutes < 10) ? ('0' + $scope.desiredMinutes) : $scope.desiredMinutes,10);
    }

    function increaseDesiredHoursContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                $scope.increaseDesiredHours();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function decreaseDesiredHoursContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                $scope.decreaseDesiredHours();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function increaseDesiredMinutesContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                $scope.increaseDesiredMinutes();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function decreaseDesiredMinutesContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                $scope.decreaseDesiredMinutes();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function increaseAMCTemp() {
        if ($scope.desiredAMCTemp < $scope.maxTemp) {
            $scope.desiredAMCTemp = $scope.desiredAMCTemp + $scope.TempIncrement;
            document.getElementById("inputAMCTemp").value = $scope.desiredAMCTemp;
        } else {
            $scope.desiredAMCTemp = $scope.maxTemp;
        }
    }

    function decreaseAMCTemp() {
        if ($scope.desiredAMCTemp > $scope.minTemp) {
            $scope.desiredAMCTemp = $scope.desiredAMCTemp - $scope.TempIncrement;
            document.getElementById("inputAMCTemp").value = $scope.desiredAMCTemp;
        } else {
            $scope.desiredAMCTemp = $scope.minTemp;
        }
    }

    function increaseDesiredAMCHours() {
        $scope.desiredAMCHr = parseInt($scope.desiredAMCHr, 10);
        var minuteVal = parseInt($scope.desiredAMCMin, 10);
        if ($scope.desiredAMCHr < 9) {
            $scope.desiredAMCHr = $scope.desiredAMCHr + 1;
            if (minuteVal === 0 && $scope.desiredAMCHr === 0) {
                $scope.desiredAMCHr = 1;
            }
            document.getElementById("inputAMCHrs").value = $scope.desiredAMCHr;
        } else {
            $scope.desiredAMCHr = 0;
            if (minuteVal === 0) {
                $scope.desiredAMCHr = 1;
            }
        }
    }

    function decreaseDesiredAMCHours() {
        $scope.desiredAMCHr = parseInt($scope.desiredAMCHr, 10);
        var minuteVal = parseInt($scope.desiredAMCMin, 10);

        if ($scope.desiredAMCHr > 0) {
            $scope.desiredAMCHr = $scope.desiredAMCHr - 1;
            if (minuteVal === 0 && $scope.desiredAMCHr === 0) {
                $scope.desiredAMCHr = 9;
            }
            document.getElementById("inputAMCHrs").value = $scope.desiredAMCHr;
        } else {
            $scope.desiredAMCHr = 9;
            if (minuteVal === 0) {
                $scope.desiredAMCHr = 9;
            }
        }
    }

    function increaseDesiredAMCMinutes() {
        $scope.desiredAMCMin = parseInt($scope.desiredAMCMin, 10);
        var hourValue = parseInt($scope.desiredAMCHr, 10);

        var step = 1;
        if ($scope.desiredAMCMin !== (60 - step)) {
            $scope.desiredAMCMin += step;
            if (hourValue === 0 && $scope.desiredAMCMin === 0) {
                $scope.desiredAMCMin = 1;
            }
        } else {
            $scope.desiredAMCMin = 0;
            if (hourValue === 0) {
                $scope.desiredAMCMin = 1;
            }
        }
        document.getElementById("inputAMCMins").value = $scope.desiredAMCMin;
        //$scope.desiredMinutes = parseInt(($scope.desiredMinutes < 10) ? ('0' + $scope.desiredMinutes) : $scope.desiredMinutes,10);
    }

    function decreaseDesiredAMCMinutes() {
        $scope.desiredAMCMin = parseInt($scope.desiredAMCMin, 10);
        var hourValue = parseInt($scope.desiredAMCHr, 10);
        var step = 1;
        if ($scope.desiredAMCMin !== 0) {
            $scope.desiredAMCMin -= step;
            if (hourValue === 0 && $scope.desiredAMCMin === 0) {
                $scope.desiredAMCMin = 59;
            }
            document.getElementById("inputAMCMins").value = $scope.desiredAMCMin;
        } else {
            $scope.desiredAMCMin = 60 - step;
            if ($scope.hourValue === 0) {
                $scope.desiredAMCMin = 59;
            }
        }
        //$scope.desiredMinutes = parseInt(($scope.desiredMinutes < 10) ? ('0' + $scope.desiredMinutes) : $scope.desiredMinutes,10);
    }

    function increaseTempAMCContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                increaseAMCTemp();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function decreaseTempAMCContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                decreaseAMCTemp();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function increaseAMCHoursContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                increaseDesiredAMCHours();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function decreaseAMCHoursContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                decreaseDesiredAMCHours();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function increaseAMCMinutesContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                increaseDesiredAMCMinutes();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function decreaseAMCMinutesContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                decreaseDesiredAMCMinutes();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function increaseEditTempContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                increaseEditTemp();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function decreaseEditTempContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                decreaseEditTemp();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function increaseEditProbeTempContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                increaseEditProbeTemp();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function decreaseEditProbeTempContinuously() {
        if (!!!promise) {
            promise = $interval(function () {
                decreaseEditProbeTemp();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function increaseEditProbeTemp() {
        $scope.desiredEditProbeTemp = parseInt($scope.desiredEditProbeTemp, 10);
        if ($scope.desiredEditProbeTemp < $scope.maxProbeTemp) {
            $scope.desiredEditProbeTemp = $scope.desiredEditProbeTemp + $scope.TempIncrement;
        } else {
            $scope.desiredEditProbeTemp = $scope.minProbeTemp;
        }
        document.getElementById("inputTempEditProbeTemp").value = $scope.desiredEditProbeTemp;
    }

    function decreaseEditProbeTemp() {
        $scope.desiredEditProbeTemp = parseInt($scope.desiredEditProbeTemp, 10);
        if ($scope.desiredEditProbeTemp > $scope.minProbeTemp) {
            $scope.desiredEditProbeTemp = $scope.desiredEditProbeTemp - $scope.TempIncrement;
        } else {
            $scope.desiredEditProbeTemp = $scope.maxProbeTemp;
        }
        document.getElementById("inputTempEditProbeTemp").value = $scope.desiredEditProbeTemp;
    }

    function increaseEditHoursContinuously() {
        editModeTimeUpdate = true;
        if (!!!promise) {
            promise = $interval(function () {
                increaseEditHours();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function decreaseEditHoursContinuously() {
        editModeTimeUpdate = true;
        if (!!!promise) {
            promise = $interval(function () {
                decreaseEditHours();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function increaseEditMinutesContinuously() {
        editModeTimeUpdate = true;
        if (!!!promise) {
            promise = $interval(function () {
                increaseEditMinutes();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function decreaseEditMinutesContinuously() {
        editModeTimeUpdate = true;
        if (!!!promise) {
            promise = $interval(function () {
                decreaseEditMinutes();
            }, RANGE_INC_DEC_LONGPRESS.TIME);
        }
    }

    function increaseEditTemp() {
        if ($scope.desiredEditTemp < $scope.maxTemp) {
            $scope.desiredEditTemp = $scope.desiredEditTemp + $scope.TempIncrement;
            document.getElementById("inputEditTemp").value = $scope.desiredEditTemp;
        } else {
            $scope.desiredEditTemp = $scope.maxTemp;
        }
    }

    function decreaseEditTemp() {
        if ($scope.desiredEditTemp > $scope.minTemp) {
            $scope.desiredEditTemp = $scope.desiredEditTemp - $scope.TempIncrement;
            document.getElementById("inputEditTemp").value = $scope.desiredEditTemp;
        } else {
            $scope.desiredEditTemp = $scope.minTemp;
        }
    }

    function increaseEditHours() {
        $scope.desiredEditHours = parseInt($scope.desiredEditHours, 10);
        var minuteVal = parseInt($scope.desiredEditMinutes, 10);
        if ($scope.desiredEditHours < 9) {
            $scope.desiredEditHours = $scope.desiredEditHours + 1;
            if (minuteVal === 0 && $scope.desiredEditHours === 0) {
                $scope.desiredEditHours = 1;
            }
            document.getElementById("inputEditHrs").value = $scope.desiredEditHours;
        } else {
            $scope.desiredEditHours = 0;
            if (minuteVal === 0) {
                $scope.desiredEditHours = 1;
            }
        }
    }

    function decreaseEditHours() {
        $scope.desiredEditHours = parseInt($scope.desiredEditHours, 10);
        var minuteVal = parseInt($scope.desiredEditMinutes, 10);

        if ($scope.desiredEditHours > 0) {
            $scope.desiredEditHours = $scope.desiredEditHours - 1;
            if (minuteVal === 0 && $scope.desiredEditHours === 0) {
                $scope.desiredEditHours = 9;
            }
            document.getElementById("inputEditHrs").value = $scope.desiredEditHours;
        } else {
            $scope.desiredEditHours = 9;
            if (minuteVal === 0) {
                $scope.desiredEditHours = 9;
            }
        }
    }

    function increaseEditMinutes() {
        $scope.desiredEditMinutes = parseInt($scope.desiredEditMinutes, 10);
        var hourValue = parseInt($scope.desiredEditHours, 10);

        var step = 1;
        if ($scope.desiredEditMinutes !== (60 - step)) {
            $scope.desiredEditMinutes += step;
            if (hourValue === 0 && $scope.desiredEditMinutes === 0) {
                $scope.desiredEditMinutes = 1;
            }
        } else {
            $scope.desiredEditMinutes = 0;
            if (hourValue === 0) {
                $scope.desiredEditMinutes = 1;
            }
        }
        document.getElementById("inputEditMins").value = $scope.desiredEditMinutes;
        //$scope.desiredMinutes = parseInt(($scope.desiredMinutes < 10) ? ('0' + $scope.desiredMinutes) : $scope.desiredMinutes,10);
    }

    function decreaseEditMinutes() {
        $scope.desiredEditMinutes = parseInt($scope.desiredEditMinutes, 10);
        var hourValue = parseInt($scope.desiredEditHours, 10);
        var step = 1;
        if ($scope.desiredEditMinutes !== 0) {
            $scope.desiredEditMinutes -= step;
            if (hourValue === 0 && $scope.desiredEditMinutes === 0) {
                $scope.desiredEditMinutes = 59;
            }
            document.getElementById("inputEditMins").value = $scope.desiredEditMinutes;
        } else {
            $scope.desiredEditMinutes = 60 - step;
            if ($scope.hourValue === 0) {
                $scope.desiredEditMinutes = 59;
            }
        }
        //$scope.desiredMinutes = parseInt(($scope.desiredMinutes < 10) ? ('0' + $scope.desiredMinutes) : $scope.desiredMinutes,10);
    }

    function rangeModelMenu(tabName) {
        if (tabName === 'WEBMOB_device_range_healthy_cook') {
            if (!($scope.DeviceModelName === 'NE9000KW/AA0' || ($scope.DeviceModelName === 'NX9000KW/AA0' && !$scope.dividerConnected))) {
                return !true;
            }
        } else if (tabName === 'WEBMOB_device_range_easy_cook') {
            if (!(!$scope.dividerConnected && ($scope.DeviceModelName === 'NE9900H-/AA0' || $scope.DeviceModelName === 'NX7000KW/AA0' || $scope.DeviceModelName === 'NX9006M-/AA0' || $scope.DeviceModelName === 'NE6000MW/AA0'))) {
                return !true;
            }
        } else if (tabName === 'WEBMOB_device_range_auto_cook') {
            if (!(!$scope.dividerConnected && ($scope.DeviceModelName === 'NE9000KW/AA0' || $scope.DeviceModelName === 'NE9900H-/AA0'))) {
                return !true;
            }
        }
        return !false;
    }

    function getDeviceDataMode(deviceMode) {
        var TABLE_NAME = setTableName(deviceMode);
        //debugMessage("getDeviceDataMode deviceMode : " + deviceMode + " && table " + TABLE_NAME);
        if (deviceMode !== 'NoOperation' && deviceMode !== 'Autocook') {
            var text = db.exec("SELECT TEXT FROM " + TABLE_NAME + " WHERE MODE = '" + deviceMode + "'");
            // debugMessage("getDeviceDataMode mode : " + deviceMode + " TABLE_NAME : " + TABLE_NAME + " & text : " + text[0].values[0][0]);
            return text[0].values[0][0];
        }
    }

    function sendSettingCommand(Value) {
        var command;
        command = '{"Mode":{"options":["' + Value + '"]}}';
        debugMessage("Setting command " + command);
        $scope.checkResponse.push(RANGE_COMMANDS.SettingOptions);
        SHPService.sendSHPCommand(CONSTANTS.PUT, command, "/" + $scope.peerId + "/devices/0/mode");
    }

    function slowCookTempValue(id) {
        if (id === 1) {
            $scope.SlowCookTemp = 'Low';
        } else {
            $scope.SlowCookTemp = 'High';
        }
    }

    function slowCookEditTempValue(id) {
        if (id === 1) {
            $scope.desiredEditSlowCookTemp = 61442;
        } else {
            $scope.desiredEditSlowCookTemp = 61441;
        }
    }

    function getAdjustTemp(temp) {
        var valueArray, tem, num = '', i = 1;
        valueArray = readCooktopValue(temp, 7);
        for (i; i < valueArray.length; i++) {
            num = num + valueArray[i];
        }
        tem = parseInt(num, 2);
        if (valueArray[0] > 0) {
            tem = -tem;
        }
        return tem;
    }

    function sendAdjustTemp() {
        if ($scope.deviceSingleUpperInfo.Operation.state === "Run"
                || $scope.deviceDualLowerInfo.Operation.state === "Run") {
            settingOptionPreCondition();
            return;
        }
        var valueArray, tem, temp, value, num = '', i = 0;
        tem = $scope.AdjustTemp;
        temp = Math.abs(tem);
        valueArray = readCooktopValue(temp, 7);
        for (i; i < valueArray.length; i++) {
            num = num + valueArray[i];
        }
        if (tem < 0) {
            num = 1 + num;
        } else {
            num = 0 + num;
        }
        value = 'AdjustingTemp_' + parseInt(num, 2);
        sendSettingCommand(value);
        validateCurrentScreen('SettingPage');
    }

    function editRunningMode(id) {
        if ($scope.bSabbathMode && $scope.deviceSingleUpperInfo.Operation.state === 'Run') {
            return;
        }
        if (!$scope.editMode) {
            $scope.editMode = true;
        }

        if (id === 0) {
            EditMode = 'UPPER';
        } else if (id === 1) {
            EditMode = 'LOWER';
        } else if ((id === undefined || id === null) && $scope.dividerConnected && $scope.RunningLowerOven) {
            EditMode = 'LOWER';
        } else {
            EditMode = 'UPPER';
        }

        if ($scope.dividerConnected && EditMode === "UPPER" && $scope.operationStateStateUpper === 'Run') {
            $scope.UpperMoniter = false;
            $scope.RunningUpperOven = true;
            $scope.RunningLowerOven = false;
        } else if ($scope.dividerConnected && EditMode === "LOWER" && $scope.operationStateStateLower === 'Run') {
            $scope.UpperMoniter = true;
            $scope.RunningUpperOven = false;
            $scope.RunningLowerOven = true;
        }

        debugMessage("edit mode for id " + id + " && " + EditMode);
        setDataCurrentScreen();
        setDualStateMaxMinTemp();
        showScreen();
    }

    function cancleEditMode() {
        EditMode = '';
        $scope.editMode = false;
        editModeTimeUpdate = false;
        setDataCurrentScreen();
        showScreen();
    }

    function applyEditMode() {
        if (!$scope.remoteControlEnabled) {
            showcustDialog(RANGE_ALERT_STATE.ALERT_SMARTMONITOR_GUIDE, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_alarm_smart_control_on, $scope.translation.WEBMOB_common_ok, '');
            return;
        }
        var deviceId;
        if (EditMode === 'LOWER') {
            deviceId = 1;
        } else if (EditMode === 'UPPER') {
            deviceId = 0;
        } else {
            deviceId = 0;
        }
        debugMessage("finalString : " + getSendRunningPropertyChangeCommand() + " && id " + deviceId);
        $scope.checkResponse.push(RANGE_COMMANDS.runOnNative);
        SHPService.sendSHPCommand(CONSTANTS.PUT, getSendRunningPropertyChangeCommand(), "/" + $scope.peerId + "/devices/" + deviceId);
        $scope.editMode = false;
        editModeTimeUpdate = false;
        EditMode = '';
        showScreen();
    }

    function getSendRunningPropertyChangeCommand() {

        var hr, min, desiredtemp = 0, desiredmeatprobetemp = 0, operationTime = '', finalString = '', tempDesiredString = '', OperationoperationTimeString = '';

        desiredtemp = $scope.desiredEditTemp;
        if ($scope.meatProbeConnected) {
            desiredmeatprobetemp = $scope.desiredEditProbeTemp;
        }
        hr = Number($scope.desiredEditHours) < 10 ? '0' + Number($scope.desiredEditHours) : Number($scope.desiredEditHours);
        min = Number($scope.desiredEditMinutes) < 10 ? '0' + Number($scope.desiredEditMinutes) : Number($scope.desiredEditMinutes);
        operationTime = hr + ':' + min + ':00';
        OperationoperationTimeString = '"Operation" : {"operationTime" : "' + operationTime + '"},';

        var unit = $scope.TempUnit === 'C' ? 'Celsius' : 'Fahrenheit';

        if (!$scope.meatProbeConnected && $scope.currentMode !== 'WEBMOB_device_range_easy_cook_slow_cook') {
            tempDesiredString = '"Temperatures" : [{"id" : "0","current" : ' + $scope.currentTemp + ',"desired" : ' + desiredtemp + ',"maximum" : ' + $scope.maxTemp + ',"minimum" : ' + $scope.minTemp + ',"unit" : "' + unit + '"}]';
        }

        if ($scope.desiredEditcurrentMode === 'WEBMOB_device_range_easy_cook_slow_cook' && !$scope.meatProbeConnected) {
            tempDesiredString = '"Temperatures" : [{"id" : "0","current" : ' + $scope.currentTemp + ',"desired" : ' + $scope.desiredEditSlowCookTemp + ',"maximum" : ' + 61441 + ',"minimum" : ' + 61442 + ',"unit" : "' + unit + '"}]';
        }

        if ($scope.meatProbeConnected) {
            tempDesiredString = '"Temperatures" : [{"id" : "0","current" : ' + $scope.currentTemp + ',"desired" : ' + desiredtemp + ',"maximum" : ' + $scope.maxTemp + ',"minimum" : ' + $scope.minTemp + ',"unit" : "' + unit + '"}, {"id" : "1", "current" : ' + $scope.currentProbeTemp + ',"desired" : ' + desiredmeatprobetemp + ',"maximum" : ' + $scope.maxProbeTemp + ',"minimum" : ' + $scope.minProbeTemp + ',"unit" : "' + unit + '"}]';
        }

        if (editModeTimeUpdate) {
            finalString = '{"Device" : {' + OperationoperationTimeString + tempDesiredString + '}}';
        } else {
            finalString = '{"Device" : {' + tempDesiredString + '}}';
        }

        return finalString;
    }

    function startConfirmationOK(id) {
        if (!$scope.remoteControlEnabled) {
            showcustDialog(RANGE_ALERT_STATE.ALERT_SMARTMONITOR_GUIDE, $scope.translation.WEBMOB_common_device_range, $scope.translation.WEBMOB_device_range_alarm_smart_control_on, $scope.translation.WEBMOB_common_ok, '');
            return;
        }
        var deviceId;
        if (id === 1) {
            deviceId = 1;
        } else if (id === 0) {
            deviceId = 0;
        } else if ((id === undefined || id === null) && $scope.dividerConnected && $scope.RunningLowerOven) {
            deviceId = 1;
        } else {
            deviceId = 0;
        }
        recipeDataValidated = true;
        if (!$scope.isStatic) {
            if ($scope.bSyncTime === true) {
                debugMessage("Sync Timer command " + syncTimerCommand() + "/" + $scope.peerId + "/devices/0/configuration/time");
                SHPService.sendSHPCommand(CONSTANTS.PUT, syncTimerCommand(), "/" + $scope.peerId + "/devices/0/configuration/time");
            }
            $scope.checkResponse.push(RANGE_COMMANDS.startConfirmationOK);
            debugMessage(getstartConfirmationOKCommand() + "/" + $scope.peerId + "/devices/" + deviceId + "/operation");
            SHPService.sendSHPCommand(CONSTANTS.PUT, getstartConfirmationOKCommand(), "/" + $scope.peerId + "/devices/" + deviceId + "/operation");
        }
    }

    function getstartConfirmationOKCommand() {
        return '{"Operation" : {"state" : "Run"}}';
    }

    function startConfirmationCancel() {
        deviceMode = 'Bake';
        deviceSingleMode = 'Bake';
        deviceUpperMode = 'UpperConvectionBake';
        deviceLowerMode = 'LowerBake';
        recipeDataValidated = true;
        if ($scope.dividerConnected && $scope.RunningUpperOven) {
            setDefaultModeUpper = true;
            changeUpperRecipe = true;
        } else if ($scope.dividerConnected && $scope.RunningLowerOven) {
            setDefaultModeLower = true;
            changeLowerRecipe = true;
        } else {
            setDefaultModeSingle = true;
            changSingleRecipe = true;
        }
        showCurrentScreen();
    }

    function smartcareerrorcheck() {
        if (!$scope.isStatic) {
            $scope.checkResponse.push(RANGE_COMMANDS.smartCareDiagnosis);
            debugMessage("Send command for smartCareDiagnosis " + getDiagnosisCommand());
            SHPService.sendSHPCommand(CONSTANTS.PUT, getDiagnosisCommand(), "/" + $scope.peerId + "/devices/0/diagnosis");
        }
    }

    function getDiagnosisCommand() {
        return '{"Diagnosis": {"diagnosisStart": "Run"}}';
    }

    function doOnServiceCallPopup() {
        showcustDialog(RANGE_ALERT_STATE.ALERT_SERVICE_CALL, $scope.translation.WEBMOB_common_service_call, ($scope.translation.WEBMOB_common_connect_service_call) + "<br>" + $scope.serviceCenterNumber, $scope.translation.WEBMOB_common_cancel, $scope.translation.WEBMOB_common_ok);
    }

    function getLocalStorageData(item) {
        if (typeof (Storage) !== "undefined") {
            return localStorage.getItem(item);
        } else {
            ;//NULL
        }
    }

    function noScroll() {
        return $scope.showFullScreenPopup || $scope.loadingBar || $scope.rangeFunctionMenuExpandList || $scope.AMCFnMenuVisible || $scope.inputDialogPopUp || !$scope.mainLoadingScreen;
    }

    function showDummyInbox() {
        debugMessage("showDummyInbox");
        if (window.navigator.platform !== 'iPhone' || window.navigator.platform !== 'iPad') {
            $scope.isTempFocusOn = true;
        }
    }

    function hideDummyInbox() {
        debugMessage("hideDummyInbox");
        $scope.isTempFocusOn = false;
    }

    function disableDummyInbox() {
        debugMessage("disableDummyInbox");
        if (document.getElementById("dummyInputBox") !== null) {
            document.getElementById("dummyInputBox").disabled = true;
        }
    }

    function setLocalStorageData(item, value) {
        if (typeof (Storage) !== "undefined") {
            localStorage.setItem(item, value);
        } else {
            ;//NULL
        }
    }

    function clearLocalStorage() {
        localStorage.clear();
        setLocalStorageData('RangeiSyncTime', $scope.bSyncTime);
    }

    function saveButtonClickedFromAMCState() {
        $scope.saveButtonClickedFromAMC = true;
        $timeout(function () {
            if ($scope.showRenameOption === true) {
                updateMyRecipe();
                updateMyCookingList();
                updateAMCList();
                validateCurrentScreen('EditMyCookingPage');
            } else {
                if ($scope.myCookingSelectedListItems.length >= 11) {
                    $timeout(ShowMaximumCustomRecipeErrorToast, 500);
                    return;
                }
                showcustInputDialog(RANGE_ALERT_STATE.ALERT_SAVEMYRECIPE, $scope.translation.WEBMOB_device_range_mycooking_add_mycooking, getMyCookingRecipeName(), $scope.translation.WEBMOB_common_cancel, $scope.translation.WEBMOB_common_ok);
            }
            $scope.saveButtonClickedFromAMC = false;
        }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
    }

    function onRenameClick() {
        if ($scope.AMCName !== undefined) {
            showcustInputDialog(RANGE_ALERT_STATE.ALERT_RENAMERECIPE, $scope.translation.WEBMOB_common_rename, $scope.AMCName, $scope.translation.WEBMOB_common_cancel, $scope.translation.WEBMOB_common_ok);
        }
    }

    function updateMyRecipe() {
        var i = 0;
        var newDataToStore = JSON.parse(getLocalStorageData(RANGELOCALSTORAGE.FAVDB));
        for (i = 0; i < newDataToStore.length; i++) {
            if (newDataToStore[i][27] === $scope.AMCName && $scope.UpdateAMCData !== undefined) {
                newDataToStore[i] = angular.copy($scope.UpdateAMCData);
                newDataToStore[i][27] = $scope.AMCName;
                if ($scope.renamedRecipe) {
                    newDataToStore[i][27] = $scope.renamedRecipe;
                    $scope.AMCName = $scope.renamedRecipe;
                }
                if ($scope.TempUnit === 'F' && newDataToStore[i][14] !== $scope.desiredAMCTemp) {
                    newDataToStore[i][14] = $scope.desiredAMCTemp;
                    newDataToStore[i][24] = Fer2Cel($scope.desiredAMCTemp, newDataToStore[i]);
                } else if ($scope.TempUnit === 'C' && newDataToStore[i][24] !== $scope.desiredAMCTemp) {
                    newDataToStore[i][24] = $scope.desiredAMCTemp;
                    newDataToStore[i][14] = Cel2Fer($scope.desiredAMCTemp, newDataToStore[i]);
                }

                var newdate = new Date();
                newdate.setHours($scope.desiredAMCHr, $scope.desiredAMCMin, 0);
                newDataToStore[i][17] = newdate.getHours() * 60 + newdate.getMinutes();
                newDataToStore[i][12] = deviceAMCMode;
            }
        }
        setLocalStorageData(RANGELOCALSTORAGE.FAVDB, JSON.stringify(newDataToStore));
    }

    function setMinTempValue(desiredTemp) {
        if ($scope.TempUnit === 'F') {
            switch (true) {
                case (desiredTemp <= 199):
                    return 175;
                case (desiredTemp <= 224):
                    return 175;
                case (desiredTemp <= 249):
                    return 200;
                case (desiredTemp <= 274):
                    return 225;
                case (desiredTemp <= 299):
                    return 250;
                case (desiredTemp <= 324):
                    return 250;
                case (desiredTemp <= 349):
                    return 275;
                case (desiredTemp <= 374):
                    return 275;
                case (desiredTemp <= 399):
                    return 300;
                case (desiredTemp <= 424):
                    return 325;
                case (desiredTemp <= 449):
                    return 350;
                case (desiredTemp <= 474):
                    return 350;
                case (desiredTemp <= 999):
                    return 400;
            }
        } else if ($scope.TempUnit === 'C') {
            switch (true) {
                case (desiredTemp <= 93):
                    return 80;
                case (desiredTemp <= 107):
                    return 80;
                case (desiredTemp <= 121):
                    return 90;
                case (desiredTemp <= 134):
                    return 110;
                case (desiredTemp <= 148):
                    return 120;
                case (desiredTemp <= 162):
                    return 120;
                case (desiredTemp <= 174):
                    return 135;
                case (desiredTemp <= 190):
                    return 135;
                case (desiredTemp <= 204):
                    return 150;
                case (desiredTemp <= 218):
                    return 160;
                case (desiredTemp <= 232):
                    return 175;
                case (desiredTemp <= 246):
                    return 175;
                case (desiredTemp <= 999):
                    return 205;
            }
        }
    }

    function setMaxTempValue(desiredTemp) {
        if ($scope.TempUnit === 'F') {
            switch (true) {
                case desiredTemp <= 199:
                    return 200;
                case desiredTemp <= 224:
                    return 225;
                case desiredTemp <= 249:
                    return 250;
                case desiredTemp <= 274:
                    return 300;
                case desiredTemp <= 299:
                    return 350;
                case desiredTemp <= 324:
                    return 375;
                case desiredTemp <= 349:
                    return 400;
                case desiredTemp <= 374:
                    return 450;
                case desiredTemp <= 399:
                    return 450;
                case desiredTemp <= 424:
                    return 480;
                case desiredTemp <= 449:
                    return 480;
                case desiredTemp <= 474:
                    return 480;
                case desiredTemp <= 999:
                    return 480;
            }
        } else if ($scope.TempUnit === 'C') {
            switch (true) {
                case desiredTemp <= 93:
                    return 90;
                case desiredTemp <= 107:
                    return 110;
                case desiredTemp <= 121:
                    return 120;
                case desiredTemp <= 134:
                    return 150;
                case desiredTemp <= 148:
                    return 175;
                case desiredTemp <= 162:
                    return 190;
                case desiredTemp <= 174:
                    return 205;
                case desiredTemp <= 190:
                    return 230;
                case desiredTemp <= 204:
                    return 230;
                case desiredTemp <= 218:
                    return 250;
                case desiredTemp <= 232:
                    return 250;
                case desiredTemp <= 246:
                    return 250;
                case desiredTemp <= 999:
                    return 250;
            }
        }
    }

    function setDualStateMaxMinTemp() {
        if ($scope.dividerConnected && $scope.deviceSingleUpperInfo.Operation.state === "Run"
                && $scope.deviceDualLowerInfo.Operation.state === "Run") {
            var temp;
            debugMessage("setDualStateMaxMinTemp");
            if ($scope.RunningUpperOven) {
                if ($scope.deviceDualLowerInfo !== undefined && $scope.deviceDualLowerInfo.Operation.state === 'Run') {
                    temp = $scope.deviceDualLowerInfo.Temperatures[0].desired !== 0 ? $scope.deviceDualLowerInfo.Temperatures[0].desired : $scope.desiredTempUpper;
                    debugMessage("RunningUpperOven & lower temp " + temp);
                    $scope.minTemp = setMinTempValue(temp);
                    $scope.maxTemp = setMaxTempValue(temp);
                }
            } else if ($scope.RunningLowerOven) {
                if ($scope.deviceSingleUpperInfo !== undefined && $scope.deviceSingleUpperInfo.Operation.state === 'Run') {
                    temp = $scope.deviceSingleUpperInfo.Temperatures[0].desired !== 0 ? $scope.deviceSingleUpperInfo.Temperatures[0].desired : $scope.desiredTempLower;
                    debugMessage("RunningLowerOven & upper temp " + temp);
                    if (temp === 61441) {
                        temp = $scope.bFahrenheit ? 480 : 248;
                    }
                    if (temp === 61442) {
                        temp = $scope.bFahrenheit ? 400 : 204;
                    }
                    $scope.minTemp = setMinTempValue(temp);
                    $scope.maxTemp = setMaxTempValue(temp);
                }
            }
            debugMessage("final min max temp for dual running state edit ready screen " + $scope.minTemp + "  " + $scope.maxTemp);
        }
    }

    function validateRecipeName(newRecipeName) {
        if (newRecipeName !== undefined && newRecipeName.trim() === '') {
            $timeout(ShowBlankNameToast, 500);
            return false;
        }
        if ($scope.myCookingContentsLocalStorage === null) {
            return true;
        }
        for (var i = 0; i < $scope.myCookingContentsLocalStorage.length; i++) {
            if ($scope.myCookingListItems[i][27] !== undefined && $scope.myCookingListItems[i][27].trim() === newRecipeName.trim()) {
                $timeout(ShowDuplicateNameToast, 500);
                return false;
            }
        }
        return true;
    }

    function ShowDuplicateNameToast() {
        toaster.success({title: "", body: $scope.translation.WEBMOB_device_range_alarm_mycooking_name_duplicated, bodyOutputType: 'trustedHtml'});
    }

    function ShowBlankNameToast() {
        toaster.success({title: "", body: $scope.translation.WEBMOB_device_range_alarm_mycooking_enter_recipe_name, bodyOutputType: 'trustedHtml'});
    }

    function ShowMaximumCustomRecipeErrorToast() {
        toaster.success({title: "", body: $scope.translation.OVENMOB_LCD_please_delete_an_existing, bodyOutputType: 'trustedHtml'});
    }

    function updateMyCookingList() {
        var item = db.exec("SELECT * FROM MODE_TABLE WHERE TYPE = 'BASIC' AND MODE = 'Bake'");
        item[0].values[0][27] = $scope.translation.WEBMOB_device_range_mycooking_edit_mycooking;
        item[0].values[0][13] = 'WEBMOB_device_range_mycooking_edit_mycooking';
        item[0].values[0][21] = 'YES';
        item[0].values[0][22] = 'YES';
        item[0].values[0][23] = 'YES';
        $scope.multiselect = false;
        $scope.enableDelete = false;
        $scope.myCookingContentsLocalStorage = JSON.parse(getLocalStorageData(RANGELOCALSTORAGE.FAVDB));
        $scope.myCookingListItems = [];
        $scope.myCookingListItemsSingle = [];
        $scope.myCookingListItemsUpper = [];
        $scope.myCookingListItemsLower = [];
        $scope.editMyCookingListItems = [];
        $scope.editMyCookingListItemsSingle = [];
        $scope.editMyCookingListItemsUpper = [];
        $scope.editMyCookingListItemsLower = [];

        if ($scope.myCookingContentsLocalStorage === null || $scope.myCookingContentsLocalStorage.length === 0) {
            $scope.myCookingListItems.push(item[0].values[0]);
        } else {
            for (var i = 0; i < $scope.myCookingContentsLocalStorage.length; i++) {
                $scope.myCookingListItems.push($scope.myCookingContentsLocalStorage[i]);
                $scope.editMyCookingListItems.push($scope.myCookingContentsLocalStorage[i]);
            }
            $scope.myCookingListItems.push(item[0].values[0]);
        }

        for (var i = 0; i < $scope.myCookingListItems.length; i++) {
            if ($scope.myCookingListItems[i][21] === 'YES') {
                $scope.myCookingListItemsSingle.push($scope.myCookingListItems[i]);
                if ($scope.myCookingListItems[i][22] !== 'YES') {
                    $scope.editMyCookingListItemsSingle.push($scope.myCookingListItems[i]);
                }
            }
            if ($scope.myCookingListItems[i][22] === 'YES') {
                $scope.myCookingListItemsUpper.push($scope.myCookingListItems[i]);
                if ($scope.myCookingListItems[i][23] !== 'YES') {
                    $scope.editMyCookingListItemsUpper.push($scope.myCookingListItems[i]);
                }
            }
            if ($scope.myCookingListItems[i][23] === 'YES') {
                $scope.myCookingListItemsLower.push($scope.myCookingListItems[i]);
                if ($scope.myCookingListItems[i][21] !== 'YES') {
                    $scope.editMyCookingListItemsLower.push($scope.myCookingListItems[i]);
                }
            }
        }
    }

    function updateAMCList() {
        if ($scope.dividerConnected && $scope.RunningUpperOven) {
            $scope.myCookingSelectedListItems = $scope.myCookingListItemsUpper;
            $scope.editMyCookingSelectedListItems = $scope.editMyCookingListItemsUpper;
        } else if ($scope.dividerConnected && $scope.RunningLowerOven) {
            $scope.myCookingSelectedListItems = $scope.myCookingListItemsLower;
            $scope.editMyCookingSelectedListItems = $scope.editMyCookingListItemsLower;
        } else {
            $scope.myCookingSelectedListItems = $scope.myCookingListItemsSingle;
            $scope.editMyCookingSelectedListItems = $scope.editMyCookingListItemsSingle;
        }
        if ($scope.editMyCookingSelectedListItems.length > 0) {
            $scope.enableDelete = true;
        }
    }

    function isSelectedToDelete(item) {
        for (var i = 0; i < $scope.editMyCookingSelectedDeleteItems.length; i++) {
            if ($scope.editMyCookingSelectedDeleteItems[i] === item[27]) {
                return true;
            }
        }
        return false;
    }

    function insertDataIntoFavoriteTable(newId, recipeMode, recipeName, desiredAMCTemp, desiredAMCTime, SINGLE, UPPER, LOWER) {
        var myCooking_MODETABLE_Data = db.exec("SELECT * FROM MODE_TABLE WHERE MODE = '" + recipeMode + "'"),
                myCookingContants = myCooking_MODETABLE_Data[0].values[0],
                favoriteTableData = getLocalStorageData(RANGELOCALSTORAGE.FAVDB);
        desiredAMCTemp = desiredAMCTemp === null || desiredAMCTemp === undefined ? -1 : desiredAMCTemp;
        if (SINGLE === 'NO' && UPPER === 'NO' && LOWER === 'NO') {
            SINGLE === 'YES';
        }
        if (favoriteTableData === null) {
//            myCookingContants[10] = newId;
            myCookingContants[12] = recipeMode;
            myCookingContants[17] = desiredAMCTime;
            myCookingContants[21] = SINGLE;
            myCookingContants[22] = UPPER;
            myCookingContants[23] = LOWER;
            myCookingContants[27] = recipeName;
            if ($scope.TempUnit === 'F' && myCookingContants[14] !== desiredAMCTemp) {
                myCookingContants[14] = desiredAMCTemp;
                myCookingContants[24] = Fer2Cel(desiredAMCTemp, myCookingContants);
            } else if ($scope.TempUnit === 'C' && myCookingContants[24] !== desiredAMCTemp) {
                myCookingContants[24] = desiredAMCTemp;
                myCookingContants[14] = Cel2Fer(desiredAMCTemp, myCookingContants);
            }

            setLocalStorageData(RANGELOCALSTORAGE.FAVDB, JSON.stringify([myCookingContants]));
        } else {
            var newDataToStore = JSON.parse(getLocalStorageData(RANGELOCALSTORAGE.FAVDB));
//            myCookingContants[10] = newId;
            myCookingContants[12] = recipeMode;
            myCookingContants[17] = desiredAMCTime;
            myCookingContants[21] = SINGLE;
            myCookingContants[22] = UPPER;
            myCookingContants[23] = LOWER;
            myCookingContants[27] = recipeName;
            if ($scope.TempUnit === 'F' && myCookingContants[14] !== desiredAMCTemp) {
                myCookingContants[14] = desiredAMCTemp;
                myCookingContants[24] = Fer2Cel(desiredAMCTemp, myCookingContants);
            } else if ($scope.TempUnit === 'C' && myCookingContants[24] !== desiredAMCTemp) {
                myCookingContants[24] = desiredAMCTemp;
                myCookingContants[14] = Cel2Fer(desiredAMCTemp, myCookingContants);
            }
            newDataToStore.push(myCookingContants);
            setLocalStorageData(RANGELOCALSTORAGE.FAVDB, JSON.stringify(newDataToStore));
        }
        debugMessage("insertDataIntoFavoriteTable " + JSON.stringify(newDataToStore));
    }

    function getSupportUpperMode(mode) {
        if (mode.indexOf("Upper") !== -1) {
            return 'YES';
        }
        return 'NO';
    }

    function getSupportLowerMode(mode) {
        if (mode.indexOf("Lower") !== -1) {
            return 'YES';
        }
        return 'NO';
    }

    function getSupportSingleMode(mode) {
        if (mode.indexOf("Upper") === -1 && mode.indexOf("Lower") === -1) {
            return 'YES';
        }
        return 'NO';
    }

    function getMyCookingRecipeName() {
        var defaultRecipeName = 'My Cooking ', j = 1;
        if ($scope.myCookingContentsLocalStorage === null) {
            return defaultRecipeName + '1';
        }
        while (true) {
            var uniqueNameFound = true;
            defaultRecipeName = 'My Cooking ' + j;
            for (var i = 0; i < $scope.myCookingContentsLocalStorage.length; i++) {
                if ($scope.myCookingListItems[i][27] !== undefined && $scope.myCookingListItems[i][27].trim() === (defaultRecipeName).trim()) {
                    uniqueNameFound = false;
                    break;
                }
            }
            if (uniqueNameFound) {
                break;
            }
            j++;
        }

        return defaultRecipeName;
    }

    function setTableName(mode) {
        //debugMessage("setTableName for " + mode);
        var modeTable, healthTable, easyTable;
        modeTable = db.exec("SELECT DISTINCT MODE FROM MODE_TABLE");
        for (var i = 0; i < (modeTable[0].values).length; i++) {
            if (mode === modeTable[0].values[i][0]) {
                //debugMessage("setTableName MODE_TABLE for " + mode);
                return 'MODE_TABLE';
            }
        }
        healthTable = db.exec("SELECT DISTINCT MODE FROM HEALTHY_COOK");
        for (var i = 0; i < (healthTable[0].values).length; i++) {
            if (mode === healthTable[0].values[i][0]) {
                //debugMessage("setTableName HEALTHY_COOK for " + mode);
                return 'HEALTHY_COOK';
            }
        }
        easyTable = db.exec("SELECT DISTINCT MODE FROM EASY_COOK");
        for (var i = 0; i < (easyTable[0].values).length; i++) {
            if (mode === easyTable[0].values[i][0]) {
                //debugMessage("setTableName EASY_COOK for " + mode);
                return 'EASY_COOK';
            }
        }
        //debugMessage("setTableName MODE_TABLE for defaule");
        return 'MODE_TABLE';
    }

    function showcustInputDialog(myAlertState, msgHeader, popuptext, txtButton3, txtButton4) {
        //inputDialogPopUp.show();
        $scope.inputDialogPopUp = true;
        $scope.alertState = myAlertState;
        document.getElementById("fullScreenInputPopupId").style.zIndex = 999;
        document.getElementById("custInputPopupDivId").style.zIndex = 999;

        if (msgHeader === undefined || msgHeader === "") {
            msgHeader = $scope.translation.WEBMOB_device_range_mycooking_add_mycooking;
        }

        document.getElementById("custpopupheadertextinput").innerHTML = msgHeader;
        document.getElementById("custpopupInputtext").value = popuptext;

        if (txtButton3 !== undefined) {
            document.getElementById("alertbutton4").innerHTML = txtButton3;
            document.getElementById("alertbutton4").style.visibility = "visible";
        } else {
            document.getElementById("alertbutton4").style.visibility = "hidden";
        }

        if (txtButton4 !== undefined) {
            document.getElementById("alertbutton3").innerHTML = txtButton4;
            document.getElementById("alertbutton3").style.visibility = "visible";
        } else {
            document.getElementById("alertbutton3").style.visibility = "hidden";
        }
        setTimeout(function () {
            document.getElementById("custpopupInputtext").focus();
        }, 100);
    }

    function saveUserValueSingleUpper(mode, temp, hr, min) {
        debugMessage("saveUserValueSingleUpper");
        userPreferneceSingleUpper = {
            'preferneceMode': mode,
            'prefernecetemp': temp,
            'preferneceHR': hr,
            'preferneceMin': min
        };
    }

    function saveUserValueDualLower(mode, temp, hr, min) {
        debugMessage("saveUserValueDualLower");
        userPreferneceDualLower = {
            'preferneceMode': mode,
            'prefernecetemp': temp,
            'preferneceHR': hr,
            'preferneceMin': min
        };
    }

    function saveUserValueSingleSingle(mode, temp, probetemp, hr, min) {
        debugMessage("saveUserValueSingleSingle");
        userPreferneceSingleSinlge = {
            'preferneceMode': mode,
            'prefernecetemp': temp,
            'preferneceprobetemp': probetemp,
            'preferneceHR': hr,
            'preferneceMin': min
        };
    }

    function getUserPreferencedValue(preference) {
        if (preference !== undefined) {
            debugMessage("getUserPreferencedValue");
            if (preference.preferneceMode !== undefined && preference.preferneceMode !== '' && preference.preferneceMode !== 'NoOperation') {
                $scope.currentMode = preference.preferneceMode;
            }
            if (preference.prefernecetemp !== undefined && preference.prefernecetemp !== 0) {
                $scope.desiredTemp = preference.prefernecetemp;
            }
            if (preference.preferneceprobetemp !== undefined && preference.preferneceprobetemp !== 0) {
                $scope.desiredProbeTemp = preference.preferneceprobetemp;
            }
            if (preference.preferneceHR !== undefined) {
                $scope.desiredHours = preference.preferneceHR;
            }
            if (preference.preferneceMin !== undefined) {
                $scope.desiredMinutes = preference.preferneceMin;
            }
        }
    }

    function hideInputBoxFocus() {
        stopLongPressEvent();
        blurInputBox('inputTempWithoutMeatProbe');
        blurInputBox('inputHrs');
        blurInputBox('inputMins');
        blurInputBox('inputTempMeatProbe');
        blurInputBox('inputEditTemp');
        blurInputBox('inputEditHrs');
        blurInputBox('inputEditMins');
        blurInputBox('inputTempEditProbeTemp');
    }

    function blurInputBox(id) {
        if (document.getElementById(id) !== null && document.getElementById(id) !== undefined) {
//            $scope.focuseRemoved = true;
            document.getElementById(id).blur();
            if (isTextInput(document.activeElement)) {
                document.activeElement.blur();
            }
        }
    }

    initializeMenuIconImages();
});

app.directive('stPressEffect', function (UtilityService) {
    return {
        restrict: 'A',
        link: function ($scope, $elm, $attrs) {
            var mouseEvts = {
                'touchstart': touchStartFun,
                'touchend': touchEndFun,
                'touchleave': touchEndFun,
                'touchcancel': touchEndFun,
                'touchmove': touchMoveFun
            },
                    evnt;
            for (evnt in mouseEvts) {
                if (mouseEvts.hasOwnProperty(evnt) &&
                        UtilityService.isEventSupported(evnt)) {
                    $elm.bind(evnt, mouseEvts[evnt]);
                }
            }
            function touchStartFun() {
                $scope.$parent[$attrs.stPressEffect] = true;
                $scope.$apply();
            }
            function touchMoveFun(evt) {
                if (evt.touches !== undefined && evt.touches.length !== undefined && evt.touches[evt.touches.length - 1] !== undefined && evt.currentTarget !== undefined && evt.currentTarget.parentElement !== undefined) {
                    if (evt.touches[evt.touches.length - 1].clientY <= evt.currentTarget.parentElement.clientHeight || evt.touches[evt.touches.length - 1].clientX <= evt.currentTarget.parentElement.clientWidth) {
                        touchStartFun();
                    }
                } else {
                    touchEndFun();
                }
            }
            function touchEndFun() {
                $scope.$parent[$attrs.stPressEffect] = false;
                $scope.$apply();
            }
        }
    };
});
