
var app = angular.module("SmartThings", ['toaster', 'ngSanitize']);

app.controller("ovenAppController", function ($scope, SHPService, toaster, $timeout, DBService) {
    var db, reqParamCountrySelection, versionTouch, Debug_tag = 'OV : ', langArr = Object.keys(LANGUAGE_FILE.language), DBFilePath = "src/db/smartoven_recipe.db";
    LANG = LANG.toUpperCase();

    debugMessage("oven.js Loading starts");

    if (langArr.indexOf(LANG) !== -1) {
        $scope.translation = LANGUAGE_FILE["language"][LANG];
    } else if (langArr.indexOf(LANG.substring(0, 2)) !== -1) {
        $scope.translation = LANGUAGE_FILE["language"][LANG.substring(0, 2)];
    } else {
        $scope.translation = LANGUAGE_FILE["language"]["DEFAULT"];
    }
    
//    var myWidth, myHeight;
//    if (window.navigator.platform === 'iPhone' || window.navigator.platform === 'iPad') {
//        myWidth = window.screen.availWidth;
//        myHeight = window.screen.availHeight;
//
//    } else {
//        myWidth = document.body.clientWidth;
//        myHeight = document.body.clientHeight;
//    }
//    console.log("width :: "+myWidth+ " height :: "+myHeight);

    if (window.navigator.platform === 'iPhone' || window.navigator.platform === 'iPad') {
        $scope.androidPlatform = false;
        console.log("iphone build");
    } else {
        $scope.androidPlatform = true;
    }

    initData();

    function initData() {
        debugMessage("initData");
        $scope.ovenDeviceInfo;
        $scope.isStatic = !true;
        $scope.appLaunch = false;
        $scope.bCustomRecipeInfoReceived = false;
        $scope.bConfigurationInfoReceived = false;
        $scope.bDBSet = false;
        $scope.multiselect = false;
        $scope.enableDelete = false;
        $scope.myCookingItemSelected = false;
        $scope.setTimenTempClicked = false;
        $scope.loadingBar = true;
        $scope.bCrispOptionVisible = false;
        $scope.bFastPreheatOptionVisible = false;
        $scope.bFastPreheatSupportedonDevice = false;
        $scope.bMeatProbeConnectedonDevice = false;
        $scope.bVaporLevelOptionVisible = false;
        $scope.bAboutOptionVisible = false;
        $scope.isFromMyCooking = false;
        $scope.isFromRecipeSeletedFromEditMyCooking = false;
        $scope.sendButtonClickedFromCR = false;
        $scope.sendButtonClickFromAutoCookDetail = false;
        $scope.rippleCrispSwitch = false;
        $scope.cancelButtonPressed = false;
        $scope.recipeSentToOven = false;
        $scope.recipeSentToOvenFromReadyPage = false;
        $scope.AMCFnMenuVisible = false;
        $scope.autcookItemEditable = false;
        $scope.bCleaningFinished = false;
        $scope.bCleaningCancelled = false;
        $scope.bCookingFinished = false;
        $scope.bCookingCancelled = false;
        $scope.bProgressCompletdNormal = false;
        $scope.bSlowCook = false;
        $scope.showRenameOption = false;
        $scope.koreanModel = false;
        $scope.isPreHeatSelected = false;
        $scope.isCrispySelected = false;
        $scope.OvenIncreaseUpDisable = false;
        $scope.OvenIncreaseDownDisable = false;
        $scope.isBackKeyVisible = true;
        $scope.SubHeaderVisible = true;
        $scope.isDropDownOptionFromReadyStateVisible = true;
        $scope.bMoreOptionsVisible = true;
        $scope.bOvenScreenMainTabOvenFunction = true;
        $scope.okClickedFromOCS = false;
        $scope.progressBarVisible = true;
        $scope.bCrispy = true;
        $scope.bFastPreheat = false;
        $scope.chefRecipeRunning = false;
        $scope.bOvenMeatProbe = false;
        $scope.sendButtonPressed = false;
        $scope.notificationChange = false;
        $scope.saveButtonClickedFromAMC = false;
        $scope.applyButtonClicked = false;
        $scope.okClickedFromPSM = false;
        $scope.txtButton2Invisbile = false;
        $scope.inputPopUpVisible = false;
        $scope.popUpVisible = false;
        $scope.vaporPopUpVisible = false;
        $scope.showSmartCare = false;
        
        $scope.countrySelectedIndex = 0;
        $scope.countrySelectionPopupVisible = false;
        $scope.countryToSelect = [];
        $scope.countryToSelect.push({'Country': 'Belgium'});
        $scope.countryToSelect.push({'Country': 'Belgium(F)'});

        $scope.bOvenReadyRunningHeader = false;                 //0
        $scope.bOvenReadyContainer = false;                     //1
        $scope.bOvenErrorContainer = false;                     //3
        $scope.bOvenMainFunctionContainer = false;              //4
        $scope.bOvenSpecialFunctionContainer = false;           //5
        $scope.bOvenMyCookingContainer = false;                 //6
        $scope.bOvenAutoCookContainer = false;                  //7
        $scope.bOvenChefRecipeContainer = false;                //8
        $scope.bOvenShowRecipeContainer = false;                //9
        $scope.bOvenAutoCookDetailsContainer = false;           //10
        $scope.bOvenAddMyCookingContainer = false;              //11
        $scope.bPressStartOnOven = false;                      //12
        $scope.bOvenAboutContainer = false;                     //14
        $scope.bOvenCleaningInProgressContainer = false;        //15
        $scope.bOvenDrainingContainer = false;                  //16
        $scope.bOvenRinsingContainer = false;                   //17
        $scope.bOvenCoolingContainer = false;                   //18
        $scope.bOvenOperationCompletedContainer = false;        //19
        $scope.bPreheatnCookingContainer = false;               //20 and 21
        $scope.bPreheatingScreen = false;                       //20
        $scope.bOvenCookingInProgressContainer = false;         //21
        $scope.bOvenDrainNeedContainer = false;                 //22
        $scope.bOvenCheckingContainer = false;                  //23
        $scope.bOvenPopUpOnDeviceContainer = false;             //24
        $scope.bOvenAlarmOnDeviceContainer = false;              //25
        $scope.ovenChefRecipeDetailPage = false;                //26
        $scope.bCommonRunningModeTypeMonitoringContainer = false; //27
        $scope.bSmartCareStartNowContainer = false;             //28
        $scope.bSmartCareStartNowContainerNoError = false;      //29

        $scope.currentTabPageTab = -1;
        $scope.tabValue = 1;
        $scope.parseNotiLength = 0;
        $scope.recipeIdNo = 0;
        $scope.ChecRecipeIndex = 0;
        $scope.selectedOpenedMenuHeaderIndex = -1;
        $scope.selectedOpenedMenuIndexAutoCook = -1;
        $scope.currentTab = 1;
        $scope.currentPage = 1;
        $scope.temp = 0;
        $scope.AutoCookRecipeWeight = 0;
        $scope.AutoCookRecipeTrayLevel = 0;
        $scope.desiredMeatProbeTemp = 55;
        $scope.currentMeatProbeTemp = 40;
        $scope.minMeatProbeTemp = 30;
        $scope.maxMeatProbeTemp = 99;
        $scope.servingTime = 12;
        $scope.chefRecipeId = 1;
        $scope.index = 0;
        $scope.desiredAMCTemp = 150;
        $scope.minAMCTemp = 30;
        $scope.maxAMCTemp = 275;
        $scope.currentTemp = 20;
        $scope.desiredHours = 0;
        $scope.desiredMinutes = 0;
        $scope.selectedSubIndexMenu = '-1';
        $scope.selectedHeaderMenu = 0;

        $scope.addIcon = 'add';
        $scope.deleteIcon = 'delete';
        $scope.vapourCurrentLevel = "0";
        $scope.ModeSelectionPopupDivCls = '';
        $scope.autoCookCategoriesListClickedItem = "";
        $scope.chefRecipeDetailsTabHeader = "";
        $scope.progressCompletesAtTxt = "";
        $scope.commonRunningModeTypeMonitorValue = "";
        $scope.commonRunningModeTypeHeaderTxt = "";
        $scope.errorCode = "";
        $scope.operationCompletedorCanceledMSG = "";
        $scope.description1 = "";
        $scope.description2 = "";
        $scope.meridian = "AM";
        $scope.vapourCurrentLevelText = $scope.translation.OVENMOB_LCD_low;
        $scope.versionInfo = "NV.0.0.1";
        $scope.renamedRecipe = null;
        $scope.timer = null;
        $scope.ovenHeader = $scope.translation.WEBMOB_common_device_oven;

        $scope.alertState = OVEN_ALERT_STATE.ALERT_NONE;
        $scope.currentScreen = OVENSCREENS.OVEN_READY_SCREEN;
        $scope.prevScreen = OVENSCREENS.OVEN_READY_SCREEN;

        $scope.myCookingSelected = [];
        $scope.checkResponse = [];
        $scope.menuIconImageCls = [];
        $scope.myCookingListItems = [];
        $scope.editMyCookingListItems = [];
        $scope.arrowIconsForAutoCookDropDown = [];
        $scope.OvenScreenMainTabvenTabPageTabs = [{
                id: 1,
                title: 'OVENMOB_LCD_oven_function'
            }, {
                id: 2,
                title: 'WEBMOB_device_oven_special_function'
            }, {
                id: 3,
                title: 'OVENMOB_LCD_favourite'
            }, {
                id: 4,
                title: 'WEBMOB_device_oven_auto_cook'
            }, {
                id: 5,
                title: 'WEBMOB_device_oven_chef_recipe'
            }];

        $scope.ovenModeItems =
                [{
                        id: 1,
                        modeName: "Oven Functions"
                    }];

        $scope.doValidationForTemp = doValidationForTemp;
        $scope.doValidationForTempMeatProbe = doValidationForTempMeatProbe;
        $scope.doValidationForTempAMC = doValidationForTempAMC;
        $scope.onClickTabPageTab = onClickTabPageTab;
        $scope.hideOptionMenu = hideOptionMenu;
        $scope.onClickTab = onClickTab;
        $scope.changeAutoCookDropDownMenuArrowIcon = changeAutoCookDropDownMenuArrowIcon;
        $scope.autoCookCategoriesListItemClick = autoCookCategoriesListItemClick;
        $scope.decreaseWeight = decreaseWeight;
        $scope.increaseWeight = increaseWeight;
        $scope.autocookDetailLevelClick = autocookDetailLevelClick;
        $scope.TrayLevelCheck = TrayLevelCheck;
        $scope.onBackPressed = onBackPressed;
        $scope.showAutoCookDetailsScreen = showAutoCookDetailsScreen;
        $scope.showAboutScreen = showAboutScreen;
        $scope.sendButtonClickedFromReadyState = sendButtonClickedFromReadyState;
        $scope.sendButtonClickedFromChefRecipe = sendButtonClickedFromChefRecipe;
        $scope.sendButtonClickedFromAutoCookDetailPage = sendButtonClickedFromAutoCookDetailPage;
        $scope.increaseTemp = increaseTemp;
        $scope.increaseTempContinuously = increaseTempContinuously;
        $scope.decreaseTemp = decreaseTemp;
        $scope.decreaseTempContinuously = decreaseTempContinuously;
        $scope.increaseDesiredHours = increaseDesiredHours;
        $scope.increaseDesiredHoursContinuously = increaseDesiredHoursContinuously;
        $scope.decreaseDesiredHours = decreaseDesiredHours;
        $scope.decreaseDesiredHoursContinuously = decreaseDesiredHoursContinuously;
        $scope.increaseDesiredMinutes = increaseDesiredMinutes;
        $scope.increaseDesiredMinutesContinuously = increaseDesiredMinutesContinuously;
        $scope.decreaseDesiredMinutes = decreaseDesiredMinutes;
        $scope.decreaseDesiredMinutesContinuously = decreaseDesiredMinutesContinuously;
        $scope.increaseMeatProbeTemp = increaseMeatProbeTemp;
        $scope.increaseMeatprobeTempContinuously = increaseMeatprobeTempContinuously;
        $scope.decreaseMeatProbeTemp = decreaseMeatProbeTemp;
        $scope.decreaseMeatprobeTempContinuously = decreaseMeatprobeTempContinuously;
        $scope.increaseAMCTemp = increaseAMCTemp;
        $scope.increaseAMCTempContinuously = increaseAMCTempContinuously;
        $scope.decreaseAMCTemp = decreaseAMCTemp;
        $scope.decreaseAMCTempContinuously = decreaseAMCTempContinuously;
        $scope.increaseDesiredAMCHours = increaseDesiredAMCHours;
        $scope.increaseDesiredAMCHoursContinuously = increaseDesiredAMCHoursContinuously;
        $scope.decreaseDesiredAMCHours = decreaseDesiredAMCHours;
        $scope.decreaseDesiredAMCHoursContinuously = decreaseDesiredAMCHoursContinuously;
        $scope.increaseDesiredAMCMinutes = increaseDesiredAMCMinutes;
        $scope.increaseDesiredAMCMinutesContinuously = increaseDesiredAMCMinutesContinuously;
        $scope.decreaseDesiredAMCMinutes = decreaseDesiredAMCMinutes;
        $scope.decreaseDesiredAMCMinutesContinuously = decreaseDesiredAMCMinutesContinuously;
        $scope.showVaporLevelScreen = showVaporLevelScreen;
        $scope.VapourLevelSetButtonClicked = VapourLevelSetButtonClicked;
        $scope.onCancelProgress = onCancelProgress;
        $scope.onSettingsToggleUpdate = onSettingsToggleUpdate;
        $scope.selectedTabPageTab = selectedTabPageTab;
        $scope.onClickOvenFunctionsItem = onClickOvenFunctionsItem;
        $scope.onClickSpecialFunctionsItem = onClickSpecialFunctionsItem;
        $scope.onClickMyCookingItem = onClickMyCookingItem;
        $scope.openPopoverMode = openPopoverMode;
        $scope.movetoChefRecipeInfoPage = movetoChefRecipeInfoPage;
        $scope.onAlertButton1Click = onAlertButton1Click;
        $scope.onAlertButton2Click = onAlertButton2Click;
        $scope.onRecipeDetails = onRecipeDetails;
        $scope.AutoCookSubchildInfoClick = AutoCookSubchildInfoClick;
        $scope.okClickedFromOperationCompleteScreen = okClickedFromOperationCompleteScreen;
        $scope.updateDeviceData = updateDeviceData;
        $scope.requestFailHandler = requestFailHandler;
        $scope.parseConfiguration = parseConfiguration;
        $scope.parseCustomRecipeInfo = parseCustomRecipeInfo;
        $scope.onSwipe = onSwipe;
        $scope.expandListItemClickHandler = expandListItemClickHandler;
        $scope.handleMyCookingItemClick = handleMyCookingItemClick;
        $scope.editMyCookingItemClick = editMyCookingItemClick;
        $scope.addToMyCooking = addToMyCooking;
        $scope.deleteMyCookings = deleteMyCookings;
        $scope.saveButtonClickedFromAMCState = saveButtonClickedFromAMCState;
        $scope.applyButtonClickedFromRunningState = applyButtonClickedFromRunningState;
        $scope.stopLongPressEvent = stopLongPressEvent;
        $scope.okClickedFromPressStartMSG = okClickedFromPressStartMSG;
        $scope.editClickedFromPressStartMSG = editClickedFromPressStartMSG;
        $scope.onHoursMinsFocusGain = onHoursMinsFocusGain;
        $scope.onHoursLostFocus = onHoursLostFocus;
        $scope.onMinsLostFocus = onMinsLostFocus;
        $scope.onTempFocusGain = onTempFocusGain;
        $scope.onClickModeOptionAMC = onClickModeOptionAMC;
        $scope.onRenameClick = onRenameClick;
        $scope.closeApp = closeApp;
        $scope.setTimeorTempClickedFromRunningState = setTimeorTempClickedFromRunningState;
        $scope.onAboutAction = onAboutAction;
        $scope.showConnectionFailurePopup = showConnectionFailurePopup;
        $scope.closeConnectionFailurePopup = closeConnectionFailurePopup;
        $scope.connFailureAction = connFailureAction;
        $scope.commonRunningModeTypeHeader = commonRunningModeTypeHeader;
        $scope.autoCookIcon = autoCookIcon;
        $scope.specialFunctionIcon = specialFunctionIcon;
        $scope.ovenFunctionIcon = ovenFunctionIcon;
        $scope.FunctionForSVG = FunctionForSVG;
        $scope.parseStaticData = parseStaticData;
        $scope.versionTouchStart = versionTouchStart;
        $scope.versionTouchEnd = versionTouchEnd;
        $scope.parseModuleInformation = parseModuleInformation;
        $scope.smartcareerrorcheck = smartcareerrorcheck;
        $scope.addRipple = addRipple;
        $scope.showcustCountrySelectionPopup = showcustCountrySelectionPopup;
        $scope.closeCountrySelectionPopup = closeCountrySelectionPopup;
        $scope.onCountrySelected = onCountrySelected;
        $scope.onCountrySelectedOkClicked = onCountrySelectedOkClicked;

        $scope.myCookingContentsLocalStorage = JSON.parse(getLocalStorageData(OVENLOCALSTORAGE.FAVDB));
        $scope.noOfVisitInfoLocalStorage = JSON.parse(getLocalStorageData(OVENLOCALSTORAGE.NOOFVISIT));

        initOvenDeviceInfo();
        initChefRecipeData();
        initializeMenuIconImages();
        if ($scope.isStatic === true && !$scope.deviceUuid) {
            parseStaticData();
        }
    }

    function debugMessage(text) {
        if (!false)
            console.log(Debug_tag + text);
    }

    function initChefRecipeData() {
        debugMessage("initChefRecipeData");
        $scope.AutoCookMainListClickedItem = -1;
        $scope.ArrayofChefInfo = [{chefTitle: "OVENMOB_LCD_michel_name",
                chefSubTitle: "OVENMOB_LCD_michel_desc1",
                chefAward: "OVENMOB_LCD_michel_award",
                chefLocation2: "OVENMOB_LCD_michel_location2",
                chefLocation3: "OVENMOB_LCD_michel_location3"
            },
            {chefTitle: "OVENMOB_LCD_eric_name",
                chefSubTitle: "OVENMOB_LCD_eric_desc1",
                chefAward: "OVENMOB_LCD_eric_award",
                chefLocation2: "OVENMOB_LCD_eric_location2",
                chefLocation3: "OVENMOB_LCD_michel_location3"
            }];

        $scope.michelIngredientsCM = [
            {
                subtitle: $scope.translation.OVENMOB_LCD_main_ingredients,
                details: [$scope.translation.OVENMOB_LCD_amt_egg_white, $scope.translation.OVENMOB_LCD_amt_caster_sugar, $scope.translation.OVENMOB_LCD_amt_icing_sugar, $scope.translation.OVENMOB_LCD_amt_hazelnuts]
            },
            {
                subtitle: $scope.translation.OVENMOB_LCD_equipment_second,
                details: [$scope.translation.OVENMOB_LCD_stainless_steel_rings, $scope.translation.OVENMOB_LCD_amt_piping_bag, $scope.translation.OVENMOB_LCD_amt_plain_tip]
            }
        ];

        $scope.michelIPreperationCM = [
            {
                details: [$scope.translation.OVENMOB_LCD_michel_recipe1_preparation_tab_step1]
            },
            {
                details: [$scope.translation.OVENMOB_LCD_michel_recipe1_preparation_tab_step2]
            },
            {
                details: [$scope.translation.OVENMOB_LCD_cooking_tab]
            }
        ];

        $scope.michelFinishingCM = [
            {
                details: [$scope.translation.OVENMOB_LCD_michel_recipe1_finish_tab_step1]
            }
        ];

        $scope.michelIngredientsCOLBR = [
            {
                subtitle: $scope.translation.OVENMOB_LCD_main_ingredients,
                details: [$scope.translation.OVENMOB_LCD_amt_of_butter, $scope.translation.OVENMOB_LCD_amt_of_cream, $scope.translation.OVENMOB_LCD_amt_of_comte_cheese, $scope.translation.OVENMOB_LCD_amt_of_egg, $scope.translation.OVENMOB_LCD_amt_of_egg_yolk, $scope.translation.OVENMOB_LCD_amt_of_corn_flour, $scope.translation.OVENMOB_LCD_amt_of_egg_white]
            },
            {
                subtitle: $scope.translation.OVENMOB_LCD_equipment_second,
                details: [$scope.translation.OVENMOB_LCD_recipe2_equip_text1, $scope.translation.OVENMOB_LCD_recipe2_equip_text2]
            }
        ];

        $scope.michelIPreperationCOLBR = [
            {
                details: [$scope.translation.OVENMOB_LCD_michel_recipe2_preparation_tab_step1]
            },
            {
                details: [$scope.translation.OVENMOB_LCD_michel_recipe2_preparation_tab_step2]
            },
            {
                details: [$scope.translation.OVENMOB_LCD_michel_recipe2_preparation_tab_step3]
            },
            {
                details: [$scope.translation.OVENMOB_LCD_michel_recipe2_preparation_tab_step4]
            },
            {
                details: [$scope.translation.OVENMOB_LCD_michel_recipe2_preparation_tab_step5]
            },
            {
                details: [$scope.translation.OVENMOB_LCD_cooking_tab]
            }
        ];

        $scope.michelFinishingCOLBR = [
            {
                details: [$scope.translation.OVENMOB_LCD_michel_recipe2_finish_tab_step1]
            }
        ];

        $scope.ericIngredientsShortBread = [
            {
                subtitle: $scope.translation.OVENMOB_LCD_shortbrad_dough,
                details: [$scope.translation.OVENMOB_LCD_amt_egg_yolk, $scope.translation.OVENMOB_LCD_amt_sugar, $scope.translation.OVENMOB_LCD_amt_softned_butter, $scope.translation.OVENMOB_LCD_amt_sea_salt, $scope.translation.OVENMOB_LCD_amt_flour, $scope.translation.OVENMOB_LCD_amt_baking_powder, $scope.translation.OVENMOB_LCD_amt_powdered_ginger, $scope.translation.OVENMOB_LCD_amt_almond_powder]
            },
            {
                subtitle: $scope.translation.OVENMOB_LCD_grapefruit_cream,
                details: [$scope.translation.OVENMOB_LCD_amt_grapefruit_juice, $scope.translation.OVENMOB_LCD_amt_lemon_juice, $scope.translation.OVENMOB_LCD_amt_sugar, $scope.translation.OVENMOB_LCD_amt_eggs, $scope.translation.OVENMOB_LCD_amt_custard_powder_or_cornstarch, $scope.translation.OVENMOB_LCD_amt_gelatin, $scope.translation.OVENMOB_LCD_amt_butter]
            },
            {
                subtitle: $scope.translation.OVENMOB_LCD_grapefruit_syrup,
                details: [$scope.translation.OVENMOB_LCD_amt_pomelo, $scope.translation.OVENMOB_LCD_amt_mineral_water, $scope.translation.OVENMOB_LCD_amt_granulated_sugar, $scope.translation.OVENMOB_LCD_amt_lime]
            }
        ];

        $scope.ericFinishingShortBreadPointTitle1 = $scope.translation.OVENMOB_LCD_shortbread;
        $scope.ericFinishingShortBreadPoint1 = $scope.translation.OVENMOB_LCD_shortbread_recipe_preparation_tab_step1;
        $scope.ericFinishingShortBreadPoint2 = $scope.translation.OVENMOB_LCD_shortbread_recipe_preparation_tab_step2;
        $scope.ericFinishingShortBreadPoint3 = $scope.translation.OVENMOB_LCD_shortbread_recipe_preparation_tab_step3;
        $scope.ericFinishingShortBreadPoint4 = $scope.translation.OVENMOB_LCD_shortbread_recipe_preparation_tab_step4;
        $scope.ericFinishingShortBreadPoint5 = $scope.translation.OVENMOB_LCD_shortbread_recipe_preparation_tab_step5;
        $scope.ericFinishingShortBreadPoint6 = $scope.translation.OVENMOB_LCD_shortbread_recipe_preparation_tab_step6;

        $scope.ericFinishingShortBreadPointTitle2 = $scope.translation.OVENMOB_LCD_grapefruite_cream;
        $scope.ericFinishingShortBreadPoint21 = $scope.translation.OVENMOB_LCD_Grapefruit_cream_recipe_preparation_tab_step1;
        $scope.ericFinishingShortBreadPoint22 = $scope.translation.OVENMOB_LCD_Grapefruit_cream_recipe_preparation_tab_step2;
        $scope.ericFinishingShortBreadPoint23 = $scope.translation.OVENMOB_LCD_Grapefruit_cream_recipe_preparation_tab_step3;
        $scope.ericFinishingShortBreadPoint24 = $scope.translation.OVENMOB_LCD_Grapefruit_cream_recipe_preparation_tab_step4;
        $scope.ericFinishingShortBreadPoint25 = $scope.translation.OVENMOB_LCD_Grapefruit_cream_recipe_preparation_tab_step5;

        $scope.ericFinishingShortBreadPointTitle3 = $scope.translation.OVENMOB_LCD_pomelo;
        $scope.ericFinishingShortBreadPoint31 = $scope.translation.OVENMOB_LCD_Pomelo_recipe_preparation_tab_step1;

        $scope.ericFinishingShortBreadPointTitle4 = $scope.translation.OVENMOB_LCD_shortbread_recipe_cooking_grapefruit;
        $scope.ericFinishingShortBreadPoint41 = $scope.translation.OVENMOB_LCD_recipe1_cooking_step3;

        $scope.ericFinishingShortBreadPointTitle5 = $scope.translation.OVENMOB_LCD_shortbread_recipe_cooking_syrup;
        $scope.ericFinishingShortBreadPoint51 = $scope.translation.OVENMOB_LCD_recipe1_cooking_step4;
        $scope.ericFinishingShortBreadPoint52 = $scope.translation.OVENMOB_LCD_recipe1_cooking_step5;
        $scope.ericFinishingShortBreadPoint53 = $scope.translation.OVENMOB_LCD_recipe1_cooking_step6;

        $scope.ericFinishingShortBreadPointSend = $scope.translation.OVENMOB_LCD_cooking_tab;

        $scope.ericFinishingShortBread = [
            {
                details: [$scope.translation.OVENMOB_LCD_shortbread_recipe_finish_tab_step1]
            },
            {
                details: [$scope.translation.OVENMOB_LCD_shortbread_recipe_finish_tab_step2]
            },
            {
                details: [$scope.translation.OVENMOB_LCD_shortbread_recipe_finish_tab_step3]
            }
        ];

        $scope.ericFinishingShortBreadPoint = $scope.translation.OVENMOB_LCD_shortbread_recipe_finish_tab_step4;

        $scope.ericIngredientsBlackCod = [
            {
                subtitle: $scope.translation.OVENMOB_LCD_main_ingredients,
                details: [$scope.translation.OVENMOB_LCD_amt_cooked_white_beans, $scope.translation.OVENMOB_LCD_amt_red_bell_peppers, $scope.translation.OVENMOB_LCD_amt_yellow_bell_peppers, $scope.translation.OVENMOB_LCD_amt_chorizo, $scope.translation.OVENMOB_LCD_amt_thick_fillets, $scope.translation.OVENMOB_LCD_amt_clams_razor_clams]
            },
            {
                subtitle: $scope.translation.OVENMOB_LCD_others,
                details: [$scope.translation.OVENMOB_LCD_amt_butter_tablespoon, $scope.translation.OVENMOB_LCD_amt_olive_oil_tablespoon, $scope.translation.OVENMOB_LCD_amt_pinch_paprika, $scope.translation.OVENMOB_LCD_amt_cherry_tomatoes, $scope.translation.OVENMOB_LCD_amt_25g_butter_tablespoon, $scope.translation.OVENMOB_LCD_amt_liquid_cream, $scope.translation.OVENMOB_LCD_amt_cup_dry_white_wine, $scope.translation.OVENMOB_LCD_amt_creme_fraiche, $scope.translation.OVENMOB_LCD_amt_white_onion_finely_chopped, $scope.translation.OVENMOB_LCD_amt_chopped_parsley, $scope.translation.OVENMOB_LCD_fresh_herbs, $scope.translation.OVENMOB_LCD_salt_pepper]
            }
        ];

        $scope.ericFinishingBlackCodPoint1 = $scope.translation.OVENMOB_LCD_eric_recipe2_preparation_tab_step1;
        $scope.ericFinishingBlackCodPoint2 = $scope.translation.OVENMOB_LCD_eric_recipe2_preparation_tab_step2;
        $scope.ericFinishingBlackCodPoint3 = $scope.translation.OVENMOB_LCD_eric_recipe2_preparation_tab_step3;
        $scope.ericFinishingBlackCodPoint4 = $scope.translation.OVENMOB_LCD_eric_recipe2_preparation_tab_step4;
        $scope.ericFinishingBlackCodPoint5 = $scope.translation.OVENMOB_LCD_eric_recipe2_preparation_tab_step5;
        $scope.ericFinishingBlackCodPoint6 = $scope.translation.OVENMOB_LCD_eric_recipe2_preparation_tab_step6;
        $scope.ericFinishingBlackCodPoint7 = $scope.translation.OVENMOB_LCD_eric_recipe2_preparation_tab_step7;
        $scope.ericFinishingBlackCodPoint8 = $scope.translation.OVENMOB_LCD_eric_recipe2_preparation_tab_step8;
        $scope.ericFinishingBlackCodPoint9 = $scope.translation.OVENMOB_LCD_eric_recipe2_preparation_tab_step9;
        $scope.ericFinishingBlackCodPoint10 = $scope.translation.OVENMOB_LCD_eric_recipe2_preparation_tab_step10;

        $scope.ericFinishingBlackCodPointSend = $scope.translation.OVENMOB_LCD_cooking_tab;

        $scope.ericFinishingBlackCod = [
            {
                details: [$scope.translation.OVENMOB_LCD_black_cod_recipe_finish_tab_step1]
            },
            {
                details: [$scope.translation.OVENMOB_LCD_black_cod_recipe_finish_tab_step2]
            }
        ];

        $scope.ericFinishingBlackCodPoint = $scope.translation.OVENMOB_LCD_black_cod_recipe_finish_tab_step3;

        $scope.ericIngredientsVellRoll = [
            {
                subtitle: $scope.translation.OVENMOB_LCD_main_ingredients,
                details: [$scope.translation.OVENMOB_LCD_amt_thin_veal_scallops, $scope.translation.OVENMOB_LCD_green_vegetables, $scope.translation.OVENMOB_LCD_amt_25g_2_spoons_butter, $scope.translation.OVENMOB_LCD_amt_dried_apricots, $scope.translation.OVENMOB_LCD_amt_saffron_threads, $scope.translation.OVENMOB_LCD_amt_butternut_squash]
            },
            {
                subtitle: $scope.translation.OVENMOB_LCD_others,
                details: [$scope.translation.OVENMOB_LCD_amt_ground_veal, $scope.translation.OVENMOB_LCD_amt_thin_strips_larding_fat, $scope.translation.OVENMOB_LCD_amt_chopped_parsley, $scope.translation.OVENMOB_LCD_amt_whole_dried_apricots_garnish, $scope.translation.OVENMOB_LCD_amt_picked_lemons, $scope.translation.OVENMOB_LCD_amt_small_white_onions, $scope.translation.OVENMOB_LCD_amt_2_tablespoon_olive_oil, $scope.translation.OVENMOB_LCD_amt_veal_stock, $scope.translation.OVENMOB_LCD_amt_cherry_tomatoes, $scope.translation.OVENMOB_LCD_fresh_herbs, $scope.translation.OVENMOB_LCD_sea_salt_and_black_pepper]
            }
        ];

        $scope.ericFinishingVellRollPointTitle1 = $scope.translation.OVENMOB_LCD_for_the_veal_rolls;
        $scope.ericFinishingVellRollPoint1 = $scope.translation.OVENMOB_LCD_eric_recipe3_preparation_tab_step1;
        $scope.ericFinishingVellRollPoint2 = $scope.translation.OVENMOB_LCD_eric_recipe3_preparation_tab_step2;
        $scope.ericFinishingVellRollPoint3 = $scope.translation.OVENMOB_LCD_eric_recipe3_preparation_tab_step3;
        $scope.ericFinishingVellRollPoint4 = $scope.translation.OVENMOB_LCD_eric_recipe3_preparation_tab_step4;
        $scope.ericFinishingVellRollPoint5 = $scope.translation.OVENMOB_LCD_eric_recipe3_preparation_tab_step5;
        $scope.ericFinishingVellRollPoint6 = $scope.translation.OVENMOB_LCD_eric_recipe3_preparation_tab_step6;
        $scope.ericFinishingVellRollPoint7 = $scope.translation.OVENMOB_LCD_eric_recipe3_preparation_tab_step7;
        $scope.ericFinishingVellRollPoint8 = $scope.translation.OVENMOB_LCD_eric_recipe3_preparation_tab_step8;

        $scope.ericFinishingVellRollPointTitle2 = $scope.translation.OVENMOB_LCD_eric_recipe3_preparation_tab_butter_nut;
        $scope.ericFinishingVellRollPoint21 = $scope.translation.OVENMOB_LCD_eric_recipe3_preparation_tab_step1_butter_nut;
        $scope.ericFinishingVellRollPoint22 = $scope.translation.OVENMOB_LCD_eric_recipe3_preparation_tab_step2_butter_nut;
        $scope.ericFinishingVellRollPoint23 = $scope.translation.OVENMOB_LCD_eric_recipe3_preparation_tab_step3_butter_nut;
        $scope.ericFinishingVellRollPoint24 = $scope.translation.OVENMOB_LCD_eric_recipe3_preparation_tab_step4_butter_nut;

        $scope.ericFinishingVellRollPointSend = $scope.translation.OVENMOB_LCD_cooking_tab;

        $scope.ericFinishingVellRoll = [
            {
                details: [$scope.translation.OVENMOB_LCD_slow_cooked_recipe_finish_tab_step1]
            },
            {
                details: [$scope.translation.OVENMOB_LCD_slow_cooked_recipe_finish_tab_step2]
            },
            {
                details: [$scope.translation.OVENMOB_LCD_slow_cooked_recipe_finish_tab_step3]
            }
        ];

        $scope.ericFinishingVellRollPoint = $scope.translation.OVENMOB_LCD_slow_cooked_recipe_finish_tab_step4;

        $scope.ericIngredientsRoastedDuck = [
            {
                subtitle: $scope.translation.OVENMOB_LCD_main_ingredients,
                details: [$scope.translation.OVENMOB_LCD_amt_2_duck_breasts, $scope.translation.OVENMOB_LCD_amt_850g_carrots, $scope.translation.OVENMOB_LCD_amt_1_tablespoon_red_wine_vinegar, $scope.translation.OVENMOB_LCD_amt_1_tablespoon_sesame_oil, $scope.translation.OVENMOB_LCD_amt_teaspoon_cumin_seeds]
            },
            {
                subtitle: $scope.translation.OVENMOB_LCD_others,
                details: [$scope.translation.OVENMOB_LCD_amt_teaspoon_toasted_sesame_seeds, $scope.translation.OVENMOB_LCD_amt_3_tablespoons_honey, $scope.translation.OVENMOB_LCD_amt_1_teaspoon_sichuan_pepper, $scope.translation.OVENMOB_LCD_herbs_for_decoration, $scope.translation.OVENMOB_LCD_sea_salt_and_black_pepper, $scope.translation.OVENMOB_LCD_edible_yellow_flowers]
            }
        ];

        $scope.ericFinishingRoastedDuckPoint3 = $scope.translation.OVENMOB_LCD_preparation_tab_step_1;
        $scope.ericFinishingRoastedDuckPoint4 = $scope.translation.OVENMOB_LCD_preparation_tab_step_2;
        $scope.ericFinishingRoastedDuckPoint5 = $scope.translation.OVENMOB_LCD_preparation_tab_step_3;
        $scope.ericFinishingRoastedDuckPoint6 = $scope.translation.OVENMOB_LCD_preparation_tab_step_4;
        $scope.ericFinishingRoastedDuckPoint7 = $scope.translation.OVENMOB_LCD_preparation_tab_step_5;
        $scope.ericFinishingRoastedDuckPoint8 = $scope.translation.OVENMOB_LCD_preparation_tab_step_6;
        $scope.ericFinishingRoastedDuckPoint9 = $scope.translation.OVENMOB_LCD_preparation_tab_step_7;

        $scope.ericFinishingRoastedDuckSend = $scope.translation.OVENMOB_LCD_cooking_tab;

        $scope.ericFinishingRoastedDuck = [
            {
                details: [$scope.translation.OVENMOB_LCD_finishing_step_one]
            },
            {
                details: [$scope.translation.OVENMOB_LCD_finishing_step_two]
            }
        ];

        $scope.ericFinishingRoastedDuckPoint1 = $scope.translation.OVENMOB_LCD_finishing_step_three;
        $scope.ericFinishingRoastedDuckPoint2 = $scope.translation.OVENMOB_LCD_finishing_step_four;


        $scope.chefRecipeSummaryImageimageurl = "images/oven/chef_recipe_main_img_1440x1924_creamy_meringues.png";

        $scope.ovenTabs = [{
                id: 1,
                title: 'OVENMOB_LCD_ingredients',
                description: $scope.description1,
                imageUrl: ''
            }, {
                id: 2,
                title: 'OVENMOB_LCD_preparation',
                description: '',
                imageUrl: ''
            }, {
                id: 3,
                title: 'OVENMOB_LCD_finishing',
                description: '',
                imageUrl: ''
            }];
    }

    function getLocalStorageData(item) {
        debugMessage("getLocalStorageData");
        if (typeof (Storage) !== "undefined") {
            return localStorage.getItem(item);
        } else {
            ;//NULL
        }
    }

    function setLocalStorageData(item, value) {
        debugMessage("setLocalStorageData");
        if (typeof (Storage) !== "undefined") {
            localStorage.setItem(item, value);
        } else {
            ;//NULL
        }
    }

    function clearLocalStorage() {
        debugMessage("clearLocalStorage");
        localStorage.clear();
    }

    DBService.readDB(DBFilePath).then(function (data) {
        debugMessage("readDB");
        db = data;

        $scope.convectionContentsFromModeTable = db.exec("SELECT * FROM MODE_TABLE WHERE MODE='Convection'");
        $scope.categoriesFromAutoCookKorea = db.exec("SELECT DISTINCT CATEGORY FROM AUTO_COOK_KR");
        $scope.contentsFromAutoCookKorea = db.exec("SELECT * FROM AUTO_COOK_KR");
        $scope.categoriesFromAutoCook = db.exec("SELECT DISTINCT CATEGORY FROM AUTO_COOK_KR WHERE LOCALE='ALL'");
        $scope.contentsFromAutoCook = db.exec("SELECT * FROM AUTO_COOK_KR WHERE LOCALE='ALL'");

        $scope.ovenFunctionContents = db.exec("SELECT * FROM MODE_TABLE WHERE TYPE in ('BASIC', 'VAPOUR')");
        $scope.specialFunctionContents = db.exec("SELECT * FROM MODE_TABLE WHERE TYPE = 'SPECIAL'");
        if ($scope.koreanModel) {
            if (LANG === "KO-KR") {
                $scope.autoCookCategories = $scope.categoriesFromAutoCookKorea;
                $scope.autoCookContents = $scope.contentsFromAutoCookKorea;
            } else {
                $scope.autoCookCategories = $scope.categoriesFromAutoCook;
                $scope.autoCookContents = $scope.contentsFromAutoCook;
            }
        } else {
            $scope.autoCookCategories = db.exec("SELECT DISTINCT CATEGORY FROM AUTO_COOK");
            $scope.autoCookContents = db.exec("SELECT * FROM AUTO_COOK");
        }
        $scope.chefRecipesForMichelTroisgros = db.exec("SELECT * FROM CHEF_RECIPE WHERE Chef = 'OVENMOB_LCD_michel_name'");
        $scope.chefRecipesForEricTrochon = db.exec("SELECT * FROM CHEF_RECIPE WHERE Chef = 'OVENMOB_LCD_eric_name'");

        if ($scope.noOfVisitInfoLocalStorage === null) {
            $scope.readyStateContents = $scope.convectionContentsFromModeTable;
        } else {
            var localVar = $scope.noOfVisitInfoLocalStorage.sort(function (a, b) {
                return b.value - a.value || b.time - a.time;
            });
            $scope.readyStateContents = db.exec("SELECT * FROM MODE_TABLE WHERE MODE='" + localVar[0].mode + "'");
        }

        $scope.myCookingRecipeDefaultContents = $scope.convectionContentsFromModeTable;

        $scope.bDBSet = true;
        debugMessage("readDB ends");

        setReadyScreenDataFirstLaunch();
    });

    function setReadyScreenDataFirstLaunch() {
        debugMessage("setReadyScreenDataFirstLaunch");
        $scope.currentMode = OVEN_HEADER_MAPPING[$scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.MODE]];
        $scope.recipeDescription = $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.DESCRIPTION];

        if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.DEFAULT_TEMP] === null || $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.DEFAULT_TEMP] === undefined) {
            $scope.desiredTemp = 185;
        } else {
            $scope.desiredTemp = $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.DEFAULT_TEMP];
        }

        if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.MIN_TEMP] === null || $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.MIN_TEMP] === undefined) {
            $scope.minTemp = 30;
        } else {
            $scope.minTemp = $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.MIN_TEMP];
        }

        if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.MAX_TEMP] === null || $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.MAX_TEMP] === undefined) {
            $scope.maxTemp = 275;
        } else {
            $scope.maxTemp = $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.MAX_TEMP];
        }

        if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.DEFAULT_TIME] === null || $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.DEFAULT_TIME] === undefined) {
            $scope.desiredHours = 5;
            $scope.desiredMinutes = 35;
        } else {
            var newdate = new Date();
            newdate.setHours(0, $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.DEFAULT_TIME], 0);
            $scope.desiredHours = parseInt(newdate.getHours(), 10);
            $scope.desiredMinutes = parseInt(newdate.getMinutes(), 10);
        }

        if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.CRISPONTOP] === 'TRUE') {
            $scope.bCrispOptionVisible = true;
        } else {
            $scope.bCrispOptionVisible = false;
        }

        if ($scope.bFastPreheatSupportedonDevice) {
            if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.FAST_PREHEATING] === 'TRUE') {
                $scope.bFastPreheatOptionVisible = true;
            } else {
                $scope.bFastPreheatOptionVisible = false;
            }
        } else {
            $scope.bFastPreheatOptionVisible = false;
        }

        if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.VAPOUR] === 'TRUE') {
            $scope.bVaporLevelOptionVisible = true;
        } else {
            $scope.bVaporLevelOptionVisible = false;
        }

        if ($scope.myCookingContentsLocalStorage === null || $scope.myCookingContentsLocalStorage.length === 0) {
            $scope.myCookingListItems.push({title: "Edit My Cooking", mode: "EDIT_MY_COOKING"});
            $scope.maxMyCookingListId = 0;
        } else {
            $scope.maxMyCookingListId = $scope.myCookingContentsLocalStorage.length;
            for (var i = 0; i < $scope.myCookingContentsLocalStorage.length; i++) {
                $scope.myCookingListItems.push({title: $scope.myCookingContentsLocalStorage[i].FAV_NAME, mode: $scope.myCookingContentsLocalStorage[i].MODE});
                $scope.editMyCookingListItems.push({title: $scope.myCookingContentsLocalStorage[i].FAV_NAME, mode: $scope.myCookingContentsLocalStorage[i].MODE});
            }
            $scope.myCookingListItems.push({title: "Edit My Cooking", mode: "EDIT_MY_COOKING"});
            if ($scope.editMyCookingListItems.length > 0)
            {
                $scope.enableDelete = true;
            }
        }
    }

    function setReadyStateData() {
        debugMessage("setReadyStateData");
        if (!$scope.bDBSet) {
            return;
        }
        var newdate;
        if ($scope.isFromMyCooking) {
            $scope.isFromMyCooking = false;
            setReadyScreenDataFromMyCooking();
        } else {

            $scope.currentMode = OVEN_HEADER_MAPPING[$scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.MODE]];
            $scope.recipeDescription = $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.DESCRIPTION];

            if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.DEFAULT_TEMP] === null || $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.DEFAULT_TEMP] === undefined) {
                $scope.desiredTemp = 185;
            } else {
                $scope.desiredTemp = $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.DEFAULT_TEMP];
            }

            if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.DEFAULT_TIME] === null || $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.DEFAULT_TIME] === undefined) {
                $scope.desiredHours = 5;
                $scope.desiredMinutes = 35;
            } else {
                newdate = new Date();
                newdate.setHours(0, $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.DEFAULT_TIME], 0);
                $scope.desiredHours = parseInt(newdate.getHours(), 10);
                $scope.desiredMinutes = parseInt(newdate.getMinutes() < 10 ? '0' + newdate.getMinutes().toString() : newdate.getMinutes().toString(), 10);
            }

            if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.CRISPONTOP] === 'TRUE') {
                $scope.bCrispOptionVisible = true;
            } else {
                $scope.bCrispOptionVisible = false;
            }

            if ($scope.bFastPreheatSupportedonDevice) {
                if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.FAST_PREHEATING] === 'TRUE') {
                    $scope.bFastPreheatOptionVisible = true;
                } else {
                    $scope.bFastPreheatOptionVisible = false;
                }
            } else {
                $scope.bFastPreheatSupportedonDevice = false;
            }

            if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.VAPOUR] === 'TRUE') {
                $scope.bVaporLevelOptionVisible = true;
            } else {
                $scope.bVaporLevelOptionVisible = false;
            }
        }

        if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.MIN_TEMP] === null || $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.MIN_TEMP] === undefined) {
            $scope.minTemp = 30;
        } else {
            $scope.minTemp = $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.MIN_TEMP];
        }

        if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.MAX_TEMP] === null || $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.MAX_TEMP] === undefined) {
            $scope.maxTemp = 275;
        } else {
            $scope.maxTemp = $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.MAX_TEMP];
        }

    }

    function setReadyScreenDataFromMyCooking() {
        debugMessage("setReadyScreenDataFromMyCooking");

        var recipeContents = $scope.myCookingContentsLocalStorage[$scope.myCookIndex];

        debugMessage("db.exec 1 starts");
        $scope.readyStateContents = db.exec("SELECT * FROM MODE_TABLE WHERE MODE='" + $scope.myCookingContentsLocalStorage[$scope.myCookIndex].MODE + "'");
        debugMessage("db.exec 1 ends");

        if (recipeContents.FAV_TEMP === null || recipeContents.FAV_TEMP === undefined) {
            $scope.desiredTemp = 185;
        } else {
            $scope.desiredTemp = parseInt(recipeContents.FAV_TEMP, 10);
        }

        if (recipeContents.FAV_TIME === null || recipeContents.FAV_TIME === undefined) {
            $scope.desiredHours = 5;
            $scope.desiredMinutes = 35;
        } else {
            var newdate = new Date();
            newdate.setHours(0, parseInt(recipeContents.FAV_TIME, 10), 0);
            $scope.desiredHours = parseInt(newdate.getHours(), 10);
            $scope.desiredMinutes = parseInt(newdate.getMinutes() < 10 ? '0' + newdate.getMinutes().toString() : newdate.getMinutes().toString(), 10);
        }

        if (recipeContents.FASTPREHEAT === true) {
            $scope.bFastPreheat = true;
        } else {
            $scope.bFastPreheat = false;
        }

        if ($scope.bMeatProbeConnectedonDevice) {
            if (recipeContents.MEATPROBE === true) {
                $scope.bOvenMeatProbe = true;
            } else {
                $scope.bOvenMeatProbe = false;
            }
        } else {
            $scope.bOvenMeatProbe = false;
        }

        if (recipeContents.CRISPY === true) {
            $scope.bCrispy = true;
        } else {
            $scope.bCrispy = false;
        }

        if (recipeContents.VAPOR === "0") {
            $scope.bVaporLevelOptionVisible = false;
            $scope.vapourCurrentLevel = "0";
        } else if (recipeContents.VAPOR === "1") {
            $scope.bVaporLevelOptionVisible = true;
            $scope.vapourCurrentLevel = "1";
            $scope.vapourCurrentLevelText = $scope.translation.OVENMOB_LCD_low;
        } else if (recipeContents.VAPOR === "2") {
            $scope.bVaporLevelOptionVisible = true;
            $scope.vapourCurrentLevel = "2";
            $scope.vapourCurrentLevelText = $scope.translation.WEBMOB_device_oven_vapour_mid;
        } else if (recipeContents.VAPOR === "3") {
            $scope.bVaporLevelOptionVisible = true;
            $scope.vapourCurrentLevel = "3";
            $scope.vapourCurrentLevelText = $scope.translation.OVENMOB_LCD_high;
        } else {
            ;//NULL
        }

        if (recipeContents.FAV_MEAT_TEMP === null || recipeContents.FAV_MEAT_TEMP === undefined) {
            $scope.desiredMeatProbeTemp = 55;
        } else {
            $scope.desiredMeatProbeTemp = parseInt(recipeContents.FAV_MEAT_TEMP, 10);
        }
    }

    function setAddMyCookingDataifFromEditMyCooking() {
        debugMessage("setAddMyCookingDataifFromEditMyCooking");
        var newdate;
        debugMessage("db.exec 2 starts");
        $scope.myCookingRecipeDefaultContents = db.exec("SELECT * FROM MODE_TABLE WHERE MODE='" + $scope.myCookingRecipeContents.MODE + "'");
        debugMessage("db.exec 2 ends");
        $scope.desiredAMCTemp = parseInt($scope.myCookingRecipeContents.FAV_TEMP, 10);
        newdate = new Date();
        newdate.setHours(0, parseInt($scope.myCookingRecipeContents.FAV_TIME, 10), 0);
        $scope.desiredHours = parseInt(newdate.getHours(), 10);
        $scope.desiredMinutes = parseInt(newdate.getMinutes(), 10);

        if ($scope.myCookingRecipeContents.FASTPREHEAT === true) {
            $scope.bFastPreheat = true;
        } else {
            $scope.bFastPreheat = false;
        }

        if ($scope.myCookingRecipeContents.MEATPROBE === true) {
            $scope.bOvenMeatProbe = true;
        } else {
            $scope.bOvenMeatProbe = false;
        }

        if ($scope.myCookingRecipeContents.CRISPY === true) {
            $scope.bCrispy = true;
        } else {
            $scope.bCrispy = false;
        }

        if ($scope.myCookingRecipeContents.VAPOR === "0") {
            $scope.bVaporLevelOptionVisible = false;
            $scope.vapourValue = "0";
        } else if ($scope.myCookingRecipeContents.VAPOR === "1") {
            $scope.bVaporLevelOptionVisible = true;
            $scope.vapourValue = "1";
        } else if ($scope.myCookingRecipeContents.VAPOR === "2") {
            $scope.bVaporLevelOptionVisible = true;
            $scope.vapourValue = "2";
        } else if ($scope.myCookingRecipeContents.VAPOR === "3") {
            $scope.bVaporLevelOptionVisible = true;
            $scope.vapourValue = "3";
        } else {
            ;//NULL
        }

        $scope.desiredMeatProbeTemp = parseInt($scope.myCookingRecipeContents.FAV_MEAT_TEMP, 10);
        $scope.showRenameOption = true;
    }

    function setAddMyCookingDataifNotFromEditMyCooking() {
        debugMessage("setAddMyCookingDataifNotFromEditMyCooking");
        var newdate;
        if ($scope.myCookingRecipeDefaultContents[0].values[0][OVEN_MODE_TABLE.DEFAULT_TEMP] === null || $scope.myCookingRecipeDefaultContents[0].values[0][OVEN_MODE_TABLE.DEFAULT_TEMP] === undefined) {
            $scope.desiredAMCTemp = 185;
        } else {
            $scope.desiredAMCTemp = $scope.myCookingRecipeDefaultContents[0].values[0][OVEN_MODE_TABLE.DEFAULT_TEMP];
        }

        if ($scope.myCookingRecipeDefaultContents[0].values[0][OVEN_MODE_TABLE.DEFAULT_TIME] === null || $scope.myCookingRecipeDefaultContents[0].values[0][OVEN_MODE_TABLE.DEFAULT_TIME] === undefined) {
            $scope.desiredHours = 5;
            $scope.desiredMinutes = 35;
        } else {
            newdate = new Date();
            newdate.setHours(0, $scope.myCookingRecipeDefaultContents[0].values[0][OVEN_MODE_TABLE.DEFAULT_TIME], 0);
            $scope.desiredHours = parseInt(newdate.getHours(), 10);
            $scope.desiredMinutes = parseInt(newdate.getMinutes(), 10);
        }

        if ($scope.myCookingRecipeDefaultContents[0].values[0][OVEN_MODE_TABLE.CRISPONTOP] === 'TRUE') {
            $scope.bCrispy = true;
        } else {
            $scope.bCrispy = false;
        }

        if ($scope.myCookingRecipeDefaultContents[0].values[0][OVEN_MODE_TABLE.FAST_PREHEATING] === 'TRUE') {
            $scope.bFastPreheat = true;
        } else {
            $scope.bFastPreheat = false;
        }

        $scope.showRenameOption = false;
    }

    function setAddMyCookingData() {
        debugMessage("setAddMyCookingData");
        if ($scope.isFromRecipeSeletedFromEditMyCooking === true) {
            setAddMyCookingDataifFromEditMyCooking();
        } else {
            setAddMyCookingDataifNotFromEditMyCooking();
        }

        $scope.currentMode = $scope.myCookingRecipeDefaultContents[0].values[0][OVEN_MODE_TABLE.TEXT];

        if ($scope.myCookingRecipeDefaultContents[0].values[0][OVEN_MODE_TABLE.MIN_TEMP] === null || $scope.myCookingRecipeDefaultContents[0].values[0][OVEN_MODE_TABLE.MIN_TEMP] === undefined) {
            $scope.minAMCTemp = 30;
        } else {
            $scope.minAMCTemp = $scope.myCookingRecipeDefaultContents[0].values[0][OVEN_MODE_TABLE.MIN_TEMP];
        }

        if ($scope.myCookingRecipeDefaultContents[0].values[0][OVEN_MODE_TABLE.MAX_TEMP] === null || $scope.myCookingRecipeDefaultContents[0].values[0][OVEN_MODE_TABLE.MAX_TEMP] === undefined) {
            $scope.maxAMCTemp = 275;
        } else {
            $scope.maxAMCTemp = $scope.myCookingRecipeDefaultContents[0].values[0][OVEN_MODE_TABLE.MAX_TEMP];
        }

        $scope.isFromRecipeSeletedFromEditMyCooking = false;
    }

    function updateMyCookingList() {
        debugMessage("updateMyCookingList");
        $scope.multiselect = false;
        $scope.enableDelete = false;
        $scope.myCookingContentsLocalStorage = JSON.parse(getLocalStorageData(OVENLOCALSTORAGE.FAVDB));

        $scope.myCookingListItems = [];
        $scope.editMyCookingListItems = [];
        if ($scope.myCookingContentsLocalStorage === null || $scope.myCookingContentsLocalStorage.length === 0) {
            $scope.myCookingListItems.push({title: "Edit My Cooking", mode: "EDIT_MY_COOKING"});
        } else {
            $scope.maxMyCookingListId = $scope.myCookingContentsLocalStorage.length;
            for (var i = 0; i < $scope.myCookingContentsLocalStorage.length; i++) {
                $scope.myCookingListItems.push({title: $scope.myCookingContentsLocalStorage[i].FAV_NAME, mode: $scope.myCookingContentsLocalStorage[i].MODE});
                $scope.editMyCookingListItems.push({title: $scope.myCookingContentsLocalStorage[i].FAV_NAME, mode: $scope.myCookingContentsLocalStorage[i].MODE});
            }
            $scope.myCookingListItems.push({title: "Edit My Cooking", mode: "EDIT_MY_COOKING"});
            if ($scope.editMyCookingListItems.length > 0)
            {
                $scope.enableDelete = true;
            }
        }
    }

    function LoadAutoCookMenuDetail(MenuItemName) {
        debugMessage("LoadAutoCookMenuDetail");
        debugMessage("db.exec 3 starts");
        if ($scope.koreanModel) {
            if (LANG === "KO-KR") {
                $scope.autoCookMenuDetail = db.exec("SELECT * FROM AUTO_COOK_KR WHERE MENU ='" + MenuItemName + "'");
            } else {
                $scope.autoCookMenuDetail = db.exec("SELECT * FROM AUTO_COOK_KR WHERE MENU ='" + MenuItemName + "' AND LOCALE='ALL'");
            }
        } else {
            $scope.autoCookMenuDetail = db.exec("SELECT * FROM AUTO_COOK WHERE MENU ='" + MenuItemName + "'");
        }
        debugMessage("db.exec 3 ends");
        $scope.currentMode = $scope.autoCookMenuDetail[0].values[0][AUTO_COOK_TABLE.MENU];
        ;
        $scope.AutoCookRecipeWeight = $scope.autoCookMenuDetail[0].values[0][AUTO_COOK_TABLE.DEFAULT_WEIGHT];
        $scope.AutoCookRecipeTrayLevel = $scope.autoCookMenuDetail[0].values[0][AUTO_COOK_TABLE.TRAY_TYPE];
        if ($scope.autoCookMenuDetail[0].values[0][AUTO_COOK_TABLE.EDITABLE] === "FALSE") {
            $scope.AutoCookRecipeTrayLevel = 3;
        }
        if ($scope.autoCookMenuDetail[0].values[0][AUTO_COOK_TABLE.DEFAULT_WEIGHT] === $scope.autoCookMenuDetail[0].values[0][AUTO_COOK_TABLE.MAX_WEIGHT]) {
            $scope.OvenIncreaseUpDisable = true;
        } else if ($scope.autoCookMenuDetail[0].values[0][AUTO_COOK_TABLE.DEFAULT_WEIGHT] === $scope.autoCookMenuDetail[0].values[0][AUTO_COOK_TABLE.MIN_WEIGHT]) {
            $scope.OvenIncreaseDownDisable = true;
        } else {
            ;//NULL
        }

        if ($scope.autoCookMenuDetail[0].values[0][AUTO_COOK_TABLE.EDITABLE] === "FALSE") {
            $scope.autcookItemEditable = false;
        } else {
            $scope.autcookItemEditable = true;
        }

        $scope.autcookDetailScreenDescription = $scope.autoCookMenuDetail[0].values[0][AUTO_COOK_TABLE.GUIDE_FOR_STEP1];

        if ($scope.autoCookMenuDetail[0].values[0][AUTO_COOK_TABLE.LEVEL_TYPE] === "browning") {
            $scope.autcookDetailScreenAdjustlevelMainTxt = $scope.translation.OVENMOB_LCD_adjust_browne_level;
            $scope.autcookDetailScreenAdjustlevelLeftTxt = $scope.translation.OVENMOB_LCD_Lighter;
            $scope.autcookDetailScreenAdjustlevelRightTxt = $scope.translation.OVENMOB_LCD_darker;
        } else if ($scope.autoCookMenuDetail[0].values[0][AUTO_COOK_TABLE.LEVEL_TYPE] === "welldone") {
            $scope.autcookDetailScreenAdjustlevelMainTxt = $scope.translation.OVENMOB_LCD_adjust_well_done_level;
            $scope.autcookDetailScreenAdjustlevelLeftTxt = $scope.translation.OVENMOB_LCD_rare;
            $scope.autcookDetailScreenAdjustlevelRightTxt = $scope.translation.OVENMOB_LCD_well_done;
        } else {
            $scope.autcookDetailScreenAdjustlevelMainTxt = $scope.translation.OVENMOB_LCD_adjust_well_done_level;
            $scope.autcookDetailScreenAdjustlevelLeftTxt = $scope.translation.OVENMOB_LCD_soft;
            $scope.autcookDetailScreenAdjustlevelRightTxt = $scope.translation.OVENMOB_LCD_hard;
        }
    }

    function decreaseWeight() {
        debugMessage("decreaseWeight");
        if ($scope.OvenIncreaseDownDisable) {
            debugMessage("decreaseWeight return");
            return;
        }
        $scope.AutoCookRecipeWeight = Number((parseFloat($scope.AutoCookRecipeWeight)).toFixed(1));
        $scope.AutoCookRecipeWeight -= 0.1;
        $scope.AutoCookRecipeWeight = Number((parseFloat($scope.AutoCookRecipeWeight)).toFixed(1));

        if ($scope.AutoCookRecipeWeight === Number($scope.autoCookMenuDetail[0].values[0][6])) {
            $scope.OvenIncreaseDownDisable = true;
        }
        $scope.OvenIncreaseUpDisable = false;
    }

    function increaseWeight() {
        debugMessage("increaseWeight");
        if ($scope.OvenIncreaseUpDisable) {
            debugMessage("increaseWeight return");
            return;
        }
        $scope.AutoCookRecipeWeight = Number((parseFloat($scope.AutoCookRecipeWeight)).toFixed(1));
        $scope.AutoCookRecipeWeight += 0.1;
        $scope.AutoCookRecipeWeight = Number((parseFloat($scope.AutoCookRecipeWeight)).toFixed(1));

        if ($scope.AutoCookRecipeWeight === Number($scope.autoCookMenuDetail[0].values[0][7])) {
            $scope.OvenIncreaseUpDisable = true;
        }
        $scope.OvenIncreaseDownDisable = false;
    }

    function autocookDetailLevelClick(level) {
        debugMessage("autocookDetailLevelClick");
        /*ks.arun doneness animation only if devices supported*/
//        if ($scope.isAnimSupport === true) {
//            donenessAnimation(level);
//        }
        $scope.AutoCookRecipeTrayLevel = level;
    }

    /**
     * @function donenessAnimation
     * @description this method apply animation for the preheating done ness level 
     * @param {type} level
     * @returns {undefined}
     */
    function donenessAnimation(level) {
        return;
        debugMessage("donenessAnimation");
        var autoLevel = parseInt($scope.AutoCookRecipeTrayLevel);
        if (level != autoLevel) {
            if (level < autoLevel) {
                for (var i = level; i < autoLevel; i++) {
                    $($('.oven-perheating-done-ness-hidden')[2 * i]).removeClass("preload");
                    $($('.oven-perheating-done-ness-hidden')[2 * i + 1]).removeClass("preload");
                }
            } else {
                for (var i = autoLevel; i < level; i++) {
                    $($('.oven-perheating-done-ness-hidden')[2 * i]).removeClass("preload");
                    $($('.oven-perheating-done-ness-hidden')[2 * i + 1]).removeClass("preload");
                }
            }
        }
    }

    function TrayLevelCheck(level) {
        return level <= $scope.AutoCookRecipeTrayLevel;
    }

    function hideAllDivs() {
        debugMessage("hideAllDivs");
        $scope.bOvenReadyContainer = false;
        $scope.bPreheatingScreen = false;
        $scope.bOvenErrorContainer = false;
        $scope.bOvenMainFunctionContainer = false;
        $scope.bOvenSpecialFunctionContainer = false;
        $scope.bOvenMyCookingContainer = false;
        $scope.bOvenAutoCookContainer = false;
        $scope.bOvenChefRecipeContainer = false;

        $scope.bOvenShowRecipeContainer = false;
        $scope.bOvenAutoCookDetailsContainer = false;
        $scope.bOvenAddMyCookingContainer = false;
        $scope.bPressStartOnOven = false;
        $scope.bOvenAboutContainer = false;
        $scope.bOvenCleaningInProgressContainer = false;
        $scope.bOvenDrainingContainer = false;
        $scope.bOvenRinsingContainer = false;
        $scope.bOvenCoolingContainer = false;
        $scope.bOvenOperationCompletedContainer = false;
        $scope.bPreheatnCookingContainer = false;
        $scope.bOvenCookingInProgressContainer = false;
        $scope.bOvenDrainNeedContainer = false;
        $scope.bOvenCheckingContainer = false;
        $scope.bOvenPopUpOnDeviceContainer = false;
        $scope.bOvenAlarmOnDeviceContainer = false;
        $scope.bOvenEditMyCookingContainer = false;
        $scope.bCommonRunningModeTypeMonitoringContainer = false;
        $scope.bSmartCareStartNowContainer = false;
        $scope.bSmartCareStartNowContainerNoError = false;
    }

    function showDivs() {
        for (var i = 0; i < arguments.length; i++) {
            debugMessage("showDivs :: " + i);
            switch (arguments[i])
            {
                case 0:
                    $scope.bOvenReadyRunningHeader = true;
                    break;
                case 1:
                    $scope.bOvenReadyContainer = true;
                    break;
                case 2:
                    break;
                case 3:
                    $scope.bOvenErrorContainer = true;
                    break;
                case 4:
                    $scope.bOvenMainFunctionContainer = true;
                    break;
                case 5:
                    $scope.bOvenSpecialFunctionContainer = true;
                    break;
                case 6:
                    $scope.bOvenMyCookingContainer = true;
                    break;
                case 7:
                    $scope.bOvenAutoCookContainer = true;
                    break;
                case 8:
                    $scope.bOvenChefRecipeContainer = true;
                    break;
                case 9:
                    $scope.bOvenShowRecipeContainer = true;
                    break;
                case 10:
                    $scope.bOvenAutoCookDetailsContainer = true;
                    break;
                case 11:
                    $scope.bOvenAddMyCookingContainer = true;
                    break;
                case 12:
                    $scope.bPressStartOnOven = true;
                    break;
                case 13:
                    break;
                case 14:
                    $scope.bOvenAboutContainer = true;
                    break;
                case 15:
                    $scope.bOvenCleaningInProgressContainer = true;
                    break;
                case 16:
                    $scope.bOvenDrainingContainer = true;
                    break;
                case 17:
                    $scope.bOvenRinsingContainer = true;
                    break;
                case 18:
                    $scope.bOvenCoolingContainer = true;
                    break;
                case 19:
                    $scope.bOvenOperationCompletedContainer = true;
                    break;
                case 20:
                    $scope.bPreheatnCookingContainer = true;
                    $scope.bPreheatingScreen = true;
                    break;
                case 21:
                    $scope.bPreheatnCookingContainer = true;
                    $scope.bOvenCookingInProgressContainer = true;
                    break;
                case 22:
                    $scope.bOvenDrainNeedContainer = true;
                    break;
                case 23:
                    $scope.bOvenCheckingContainer = true;
                    break;
                case 24:
                    $scope.bOvenPopUpOnDeviceContainer = true;
                    break;
                case 25:
                    $scope.bOvenAlarmOnDeviceContainer = true;
                    break;
                case 26:
                    $scope.bOvenEditMyCookingContainer = true;
                    break;
                case 27:
                    $scope.bCommonRunningModeTypeMonitoringContainer = true;
                    break;
                case 28:
                    $scope.bSmartCareStartNowContainer = true;
                    break;
                case 29:
                    $scope.bSmartCareStartNowContainerNoError = true;
                    break;
                default:
                    break;
            }
        }
    }

    function changeView() {
        debugMessage("changeView");
        hideAllDivs();
        switch ($scope.currentScreen) {
            case OVENSCREENS.OVEN_READY_SCREEN:
                showDivs(1);
                break;
            case OVENSCREENS.OVEN_RUNNING_SCREEN:
                showDivs(2);
                break;
            case OVENSCREENS.OVEN_ERROR_SCREEN:
                showDivs(3);
                break;
            case OVENSCREENS.OVEN_MAIN_FUNCTION:
                showDivs(4);
                break;
            case OVENSCREENS.OVEN_SPECIAL_FUNCTION:
                showDivs(5);
                break;
            case OVENSCREENS.OVEN_MY_COOKING:
                showDivs(6);
                break;
            case OVENSCREENS.OVEN_AUTO_COOK:
                showDivs(7);
                break;
            case OVENSCREENS.OVEN_CHEF_RECIPE:
                showDivs(8);
                break;
            case OVENSCREENS.OVEN_SHOW_RECIPE:
                showDivs(9);
                break;
            case OVENSCREENS.OVEN_AUTOCOOK_DETAILS_CONTAINER:
                showDivs(10);
                break;
            case OVENSCREENS.OVEN_ADDMYCOOKING_CONTAINER:
                showDivs(11);
                break;
            case OVENSCREENS.OVEN_PRESS_START_ON_OVEN_CONTAINER:
                showDivs(12);
                break;
            case OVENSCREENS.OVEN_SETTINGS_CONTAINER:
                showDivs(13);
                break;
            case OVENSCREENS.OVEN_ABOUT_CONATAINER:
                showDivs(14);
                break;
            case OVENSCREENS.OVEN_CLEANINPROGRESS_CONTAINER:
                showDivs(15);
                break;
            case OVENSCREENS.OVEN_DRAINING_CONTAINER:
                showDivs(16);
                break;
            case OVENSCREENS.OVEN_RINSING_CONTAINER:
                showDivs(17);
                break;
            case OVENSCREENS.OVEN_COOLING_CONTAINER:
                showDivs(18);
                break;
            case OVENSCREENS.OVEN_OPERATION_COMPLETED:
                showDivs(19);
                break;
            case OVENSCREENS.OVEN_PREHEAT_CONTAINER:
                showDivs(20);
                break;
            case OVENSCREENS.OVEN_COOKING_CONTAINER:
                showDivs(21);
                break;
            case OVENSCREENS.OVEN_DRAINNEED_CONTAINER:
                showDivs(22);
                break;
            case OVENSCREENS.OVEN_CHECKING_CONTAINER:
                showDivs(23);
                break;
            case OVENSCREENS.OVEN_POPUP_ON_DEVICE_CONTAINER:
                showDivs(24);
                break;
            case OVENSCREENS.OVEN_ALARM_ON_DEVICE_CONTAINER:
                showDivs(25);
                break;
            case OVENSCREENS.OVEN_EDIT_MY_COOKING_CONTAINER:
                showDivs(26);
                break;
            case OVENSCREENS.OVEN_COMMON_RUNNING_MODE_TYPE_CONTAINER:
                showDivs(27);
                break;
            case OVENSCREENS.OVEN_SMARTCARE_STARTNOW_CONTAINER:
                showDivs(28);
                break;
            case OVENSCREENS.OVEN_SMARTCARE_STARTNOW_NOERROR_CONTAINER:
                showDivs(29);
                break;
            default:
                break;
        }
    }

    function onBackPressed() {
        debugMessage("onBackPressed");
//	if($scope.isAnimSupport === true){
//	        $('.menu-item-list-container').removeClass('selected'); 
//	        $('.menuExpndColapsList').removeClass('menuExpndColapsList-item-selected'); // Removig menu selected class for next time selection animation
//	        $('.commonListArrowIcon').attr('class','icon-up right commonListArrowIcon');
//	        $('.oven-perheating-done-ness-hidden').addClass("preload");
//	}
        if ($scope.popUpVisible || $scope.inputPopUpVisible || $scope.vaporPopUpVisible || $scope.countrySelectionPopupVisible) {
            closeAllPopUps();
            return;
        }
        if ($scope.AMCFnMenuVisible) {
            $scope.AMCFnMenuVisible = false;
            setAMCScreenScrollable();
            return;
        }
        if ($scope.ovenFnMenuVisible) {
            $scope.ovenFnMenuVisible = false;
            setReadyStateScreenScrollable();
            return;
        }

        $timeout(function () {
            switch ($scope.currentScreen) {
                case OVENSCREENS.OVEN_READY_SCREEN:
                case OVENSCREENS.OVEN_CLEANINPROGRESS_CONTAINER:
                case OVENSCREENS.OVEN_DRAINING_CONTAINER:
                case OVENSCREENS.OVEN_RINSING_CONTAINER:
                case OVENSCREENS.OVEN_COOLING_CONTAINER:
                case OVENSCREENS.OVEN_PREHEAT_CONTAINER:
                case OVENSCREENS.OVEN_COOKING_CONTAINER:
                case OVENSCREENS.OVEN_DRAINNEED_CONTAINER:
                case OVENSCREENS.OVEN_CHECKING_CONTAINER:
                case OVENSCREENS.OVEN_POPUP_ON_DEVICE_CONTAINER:
                case OVENSCREENS.OVEN_ALARM_ON_DEVICE_CONTAINER:
                case OVENSCREENS.OVEN_ERROR_SCREEN:
                case OVENSCREENS.OVEN_COMMON_RUNNING_MODE_TYPE_CONTAINER:
                    $scope.closeApp();
                    break;
                case OVENSCREENS.OVEN_ABOUT_CONATAINER:
                    $scope.ovenFnMenuVisible = false;
                    setReadyStateScreenScrollable();
                    showLandingPage();
                    break;
                case OVENSCREENS.OVEN_PRESS_START_ON_OVEN_CONTAINER:
                case OVENSCREENS.OVEN_OPERATION_COMPLETED:
                    $scope.bOvenOperationCompletedContainer = false;
                    $scope.bCleaningFinished = false;
                    $scope.bCleaningCancelled = false;
                    $scope.bCookingFinished = false;
                    $scope.bCookingCancelled = false;
                    $scope.bProgressCompletdNormal = false;
                    $scope.recipeSentToOven = false;
                    $scope.recipeSentToOvenFromReadyPage = false;
                    $scope.alertOn = false;
                    showLandingPage();
                    break;
                case OVENSCREENS.OVEN_MAIN_FUNCTION:
                case OVENSCREENS.OVEN_SPECIAL_FUNCTION:
                case OVENSCREENS.OVEN_MY_COOKING:
                case OVENSCREENS.OVEN_AUTO_COOK:
                    $scope.AMCFnMenuVisible = false;
                    setAMCScreenScrollable();
                    $scope.ovenFnMenuVisible = false;
                    setReadyStateScreenScrollable();
                    showOvenReadyScreen(true);
                    break;
                case OVENSCREENS.OVEN_AUTOCOOK_DETAILS_CONTAINER:
                    showAutoCookScreen();
                    break;
                case OVENSCREENS.OVEN_ADDMYCOOKING_CONTAINER:
                    showEditMyCookingScreen();
                    break;
                case OVENSCREENS.OVEN_EDIT_MY_COOKING_CONTAINER:
                    $scope.AMCFnMenuVisible = false;
                    setAMCScreenScrollable();
                    $scope.ovenFnMenuVisible = false;
                    setReadyStateScreenScrollable();
                    updateMyCookingList();
                    showOvenReadyScreen(true);
                    break;
                case OVENSCREENS.OVEN_CHEF_RECIPE:
                    if ($scope.ovenChefRecipeDetailPage === true) {
                        $scope.ovenChefRecipeDetailPage = false;
                        showChefRecipeScreen();
                    } else {
                        $scope.ovenFnMenuVisible = false;
                        setReadyStateScreenScrollable();
                        showOvenReadyScreen(true);
                    }
                    break;
                case OVENSCREENS.OVEN_SHOW_RECIPE:
                    showChefRecipeScreen();
                    break;
                case OVENSCREENS.OVEN_SMARTCARE_STARTNOW_CONTAINER:
                    $scope.bSmartCareStartNowContainer = false;
                    showAboutScreen();
                    break;
                case OVENSCREENS.OVEN_SMARTCARE_STARTNOW_NOERROR_CONTAINER:
                    $scope.bSmartCareStartNowContainerNoError = false;
                    showLandingPage();
                    break;
                default :
                    break;
            }
        }, MATERIAL_DESIGN.BACK_ANIMTION_TIMEOUT);
    }

    function showOvenReadyScreen(forced) {
        debugMessage("showOvenReadyScreen");

        if (!forced && ($scope.prevScreen === OVENSCREENS.OVEN_MAIN_FUNCTION ||
                $scope.prevScreen === OVENSCREENS.OVEN_MY_COOKING ||
                $scope.prevScreen === OVENSCREENS.OVEN_SPECIAL_FUNCTION ||
                $scope.prevScreen === OVENSCREENS.OVEN_AUTO_COOK ||
                $scope.prevScreen === OVENSCREENS.OVEN_CHEF_RECIPE ||
                $scope.prevScreen === OVENSCREENS.OVEN_SHOW_RECIPE ||
                $scope.prevScreen === OVENSCREENS.OVEN_AUTOCOOK_DETAILS_CONTAINER ||
                $scope.prevScreen === OVENSCREENS.OVEN_ADDMYCOOKING_CONTAINER ||
                $scope.prevScreen === OVENSCREENS.OVEN_EDIT_MY_COOKING_CONTAINER)) {
            debugMessage("showOvenReadyScreen return");
            return;
        }
        $scope.ovenChefRecipeDetailPage = false;
        $scope.isBackKeyVisible = true;
        $scope.bAboutOptionVisible = true;
        $scope.isDropDownOptionFromReadyStateVisible = true;
        $scope.SubHeaderVisible = true;
        $scope.ovenHeader = $scope.translation.WEBMOB_common_device_oven;
        setReadyStateData();
        $scope.currentScreen = OVENSCREENS.OVEN_READY_SCREEN;
        changeView();
    }

    function showOvenErrorScreen() {
        debugMessage("showOvenErrorScreen");
        $scope.currentMode = OVEN_HEADER_MAPPING["Oven"];
        $scope.isBackKeyVisible = true;
        $scope.isDropDownOptionFromReadyStateVisible = false;
        $scope.SubHeaderVisible = false;
        $scope.currentScreen = OVENSCREENS.OVEN_ERROR_SCREEN;
        changeView();
    }

    function showAutoCookScreen() {
        debugMessage("showAutoCookScreen");
        $scope.currentMode = OVEN_HEADER_MAPPING["AutoCook"];
        $scope.currentScreen = OVENSCREENS.OVEN_AUTO_COOK;
        $scope.SubHeaderVisible = false;
        $scope.ovenHeader = $scope.translation.WEBMOB_device_oven_auto_cook;
        initializeMenuIconForAutoCook();
        changeView();
    }

    function showChefRecipeScreen() {
        debugMessage("showChefRecipeScreen");
        if ($scope.ovenChefRecipeDetailPage !== true) {
            //$scope.currentMode = OVEN_HEADER_MAPPING["Oven"];
            $scope.ChecRecipeIndex = 0;
        } else {
            ;//NULL
        }
        $scope.SubHeaderVisible = false;
        $scope.ovenHeader = $scope.translation.WEBMOB_device_oven_chef_recipe;
        $scope.currentScreen = OVENSCREENS.OVEN_CHEF_RECIPE;
        changeView();
    }

    function showOvenShowRecipeScreen() {
        debugMessage("showOvenShowRecipeScreen");
        $scope.SubHeaderVisible = false;
        //$scope.ovenHeader = $scope.translation[$scope.chefRecipeContents[0].values[$scope.ChecRecipeIndex][3]];
        //$scope.currentMode = OVEN_HEADER_MAPPING["Oven"];
        $scope.currentScreen = OVENSCREENS.OVEN_SHOW_RECIPE;
        changeView();
    }

    function showAutoCookDetailsScreen(MenuItemName) {
        debugMessage("showAutoCookDetailsScreen");
        $timeout(function () {
            //$scope.currentMode = OVEN_HEADER_MAPPING["AutoCook"];
            $scope.ovenHeader = $scope.translation.WEBMOB_device_oven_auto_cook;
            $scope.SubHeaderVisible = true;
            LoadAutoCookMenuDetail(MenuItemName);
            $scope.currentScreen = OVENSCREENS.OVEN_AUTOCOOK_DETAILS_CONTAINER;
            changeView();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }

    function showAddMyCookingScreen() {
        debugMessage("showAddMyCookingScreen");
        setAddMyCookingData();
        $scope.isBackKeyVisible = true;
        $scope.isDropDownOptionFromReadyStateVisible = true;
        $scope.SubHeaderVisible = true;
        $scope.ovenHeader = $scope.translation.WEBMOB_device_oven_mycooking_addmycooking;
        $scope.currentScreen = OVENSCREENS.OVEN_ADDMYCOOKING_CONTAINER;
        if ($scope.editMyCookingListItems.length > 0) {
            $scope.enableDelete = true;
        }
        changeView();
        x = $scope.editMyCookingListItems;
    }

    function showPressStartOnOvenScreen() {
        debugMessage("showPressStartOnOvenScreen");
        $scope.isBackKeyVisible = true;
        $scope.SubHeaderVisible = true;
        $scope.currentMode = OVEN_HEADER_MAPPING[$scope.ovenDeviceInfo.Mode.modes[0]];
        $scope.ovenHeader = $scope.translation.WEBMOB_common_device_oven;
        $scope.isDropDownOptionFromReadyStateVisible = false;
        if($scope.recipeSentToOvenFromReadyPage) {
            $scope.bAboutOptionVisible = true;
        } else {
            $scope.bAboutOptionVisible = false;
        }
        dismissLoadingBar(OVEN_COMMANDS.sendRecipetoOven);
        $scope.currentScreen = OVENSCREENS.OVEN_PRESS_START_ON_OVEN_CONTAINER;
        changeView();
    }

    function showAboutScreen() {
        debugMessage("showAboutScreen");
        $timeout(function () {
            $scope.isBackKeyVisible = true;
            $scope.isDropDownOptionFromReadyStateVisible = false;
            $scope.SubHeaderVisible = false;
            $scope.ovenHeader = $scope.translation.WEBMOB_common_about_device;
            $scope.currentMode = OVEN_HEADER_MAPPING["About Device"];
            $scope.currentScreen = OVENSCREENS.OVEN_ABOUT_CONATAINER;
            changeView();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }

    function showSmartCareStartNowScreen() {
        debugMessage("showSmartCareStartNowScreen");
        $timeout(function () {
            $scope.isBackKeyVisible = true;
            $scope.isDropDownOptionFromReadyStateVisible = false;
            $scope.SubHeaderVisible = false;
            $scope.ovenHeader = "translation required";//$scope.translation.WEBMOB_common_self_diagnosis;
            $scope.currentScreen = OVENSCREENS.OVEN_SMARTCARE_STARTNOW_CONTAINER;
            changeView();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }

    function showSmartCareStartNowNoErrorScreen() {
        debugMessage("showSmartCareStartNowNoErrorScreen");
        $timeout(function () {
            $scope.isBackKeyVisible = true;
            $scope.isDropDownOptionFromReadyStateVisible = false;
            $scope.SubHeaderVisible = false;
            $scope.ovenHeader = "translation required";//$scope.translation.WEBMOB_common_self_diagnosis;
            $scope.currentScreen = OVENSCREENS.OVEN_SMARTCARE_STARTNOW_NOERROR_CONTAINER;
            changeView();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }

    function showCommonRunningModeTypeScreen() {
        debugMessage("showCommonRunningModeTypeScreen ::" + $scope.ovenDeviceInfo.Mode.modes[0]);
        $scope.bAboutOptionVisible = true;
        $scope.isBackKeyVisible = true;
        $scope.isDropDownOptionFromReadyStateVisible = false;
        if ($scope.chefRecipeRunning || $scope.currentMode === "AutoCook") {
            ;//null
        } else {
            $scope.commonRunningModeTypeHeaderTxt = OVEN_HEADER_MAPPING[$scope.ovenDeviceInfo.Mode.modes[0]];
        }

        if ($scope.ovenDeviceInfo.Operation.remainingTime === null || $scope.ovenDeviceInfo.Operation.remainingTime === undefined) {
            $scope.timeLeft = "00:00";
            $scope.timeLeftinRunningState = "0:00";
        } else {
            $scope.timeLeft = $scope.ovenDeviceInfo.Operation.remainingTime.substring(0, 5);
            $scope.timeLeftinRunningState = '';
            if ($scope.timeLeft.substring(0, 1) === '0') {
                $scope.timeLeftinRunningState = $scope.timeLeft.substring(1, 5);
            } else {
                $scope.timeLeftinRunningState = $scope.timeLeft.substring(0, 5);
            }
        }
        var hourToAdd = parseInt($scope.timeLeft.substring(0, 2), 10);
        var minToAdd = parseInt($scope.timeLeft.substring(3, 5), 10);
        var newdate = new Date();
        var currentHour = newdate.getHours();
        var currentMin = newdate.getMinutes();

        currentHour = currentHour + hourToAdd;
        currentMin = currentMin + minToAdd;

        if (currentMin > 60) {
            currentHour = currentHour + 1;
            if (currentHour > 23) {
                currentHour = currentHour - 24;
            }
            currentMin = currentMin - 60;
        }

        var isPM = false;
        if (currentHour > 11) {
            isPM = true;
        }
        if (currentHour > 12) {
            currentHour = currentHour - 12;
        }

        if (currentHour.toString().length === 1) {
            currentHour = "0" + currentHour;
        }
        if (currentMin.toString().length === 1) {
            currentMin = "0" + currentMin;
        }

        $scope.progressCompletesAtTxt;
        if (isPM) {
            $scope.progressCompletesAtTxt = currentHour + ":" + currentMin + "PM";
        } else {
            $scope.progressCompletesAtTxt = currentHour + ":" + currentMin + "AM";
        }

        $scope.currentScreen = OVENSCREENS.OVEN_COMMON_RUNNING_MODE_TYPE_CONTAINER;
        changeView();
    }

    function showCleaninProgressScreen() {
        debugMessage("showCleaninProgressScreen :: " + $scope.ovenDeviceInfo.Mode.modes[0]);
        $scope.bAboutOptionVisible = true;
        $scope.isBackKeyVisible = true;
        $scope.isDropDownOptionFromReadyStateVisible = false;
        $scope.currentMode = OVEN_HEADER_MAPPING[$scope.ovenDeviceInfo.Mode.modes[0]];
        if ($scope.ovenDeviceInfo.Operation.remainingTime === null || $scope.ovenDeviceInfo.Operation.remainingTime === undefined) {
            $scope.timeLeft = "00:00";
            $scope.timeLeftinRunningState = "0:00";
        } else {
            $scope.timeLeft = $scope.ovenDeviceInfo.Operation.remainingTime.substring(0, 5);
            $scope.timeLeftinRunningState = '';
            if ($scope.timeLeft.substring(0, 1) === '0') {
                $scope.timeLeftinRunningState = $scope.timeLeft.substring(1, 5);
            } else {
                $scope.timeLeftinRunningState = $scope.timeLeft.substring(0, 5);
            }
        }
        var hourToAdd = parseInt($scope.timeLeft.substring(0, 2), 10);
        var minToAdd = parseInt($scope.timeLeft.substring(3, 5), 10);
        var newdate = new Date();
        var currentHour = newdate.getHours();
        var currentMin = newdate.getMinutes();

        currentHour = currentHour + hourToAdd;
        currentMin = currentMin + minToAdd;

        if (currentMin > 60) {
            currentHour = currentHour + 1;
            if (currentHour > 23) {
                currentHour = currentHour - 24;
            }
            currentMin = currentMin - 60;
        }

        var isPM = false;
        if (currentHour > 11) {
            isPM = true;
        }
        if (currentHour > 12) {
            currentHour = currentHour - 12;
        }

        if (currentHour.toString().length === 1) {
            currentHour = "0" + currentHour;
        }

        if (currentMin.toString().length === 1) {
            currentMin = "0" + currentMin;
        }

        $scope.progressCompletesAtTxt;
        if (isPM) {
            $scope.progressCompletesAtTxt = currentHour + ":" + currentMin + "PM";
        } else {
            $scope.progressCompletesAtTxt = currentHour + ":" + currentMin + "AM";
        }

        $scope.currentScreen = OVENSCREENS.OVEN_CLEANINPROGRESS_CONTAINER;
        changeView();
    }

    function showOvenDrainingScreen() {
        debugMessage("showOvenDrainingScreen :: " + $scope.ovenDeviceInfo.Mode.modes[0]);
        $scope.isBackKeyVisible = true;
        $scope.isDropDownOptionFromReadyStateVisible = false;
        $scope.SubHeaderVisible = false;
        $scope.currentScreen = OVENSCREENS.OVEN_DRAINING_CONTAINER;
        changeView();
    }

    function showOvenRinsingScreen() {
        debugMessage("showOvenRinsingScreen :: " + $scope.ovenDeviceInfo.Mode.modes[0]);
        $scope.currentMode = OVEN_HEADER_MAPPING[$scope.ovenDeviceInfo.Mode.modes[0]];
        $scope.isBackKeyVisible = true;
        $scope.isDropDownOptionFromReadyStateVisible = false;
        $scope.currentScreen = OVENSCREENS.OVEN_RINSING_CONTAINER;
        changeView();
    }

    function showOvenCoolingScreen() {
        debugMessage("showOvenCoolingScreen :: " + $scope.ovenDeviceInfo.Mode.modes[0]);
        $scope.currentMode = OVEN_HEADER_MAPPING[$scope.ovenDeviceInfo.Mode.modes[0]];
        $scope.isBackKeyVisible = true;
        $scope.isDropDownOptionFromReadyStateVisible = false;
        $scope.currentScreen = OVENSCREENS.OVEN_COOLING_CONTAINER;
        changeView();
    }

    function showOperationCompletedScreen() {
        debugMessage("showOperationCompletedScreen");
        $scope.currentMode = OVEN_HEADER_MAPPING["Oven"];
        $scope.isBackKeyVisible = true;
        $scope.isDropDownOptionFromReadyStateVisible = false;
        $scope.SubHeaderVisible = false;
        $scope.currentScreen = OVENSCREENS.OVEN_OPERATION_COMPLETED;
        changeView();
    }

    function showEditMyCookingScreen() {
        debugMessage("showEditMyCookingScreen");
        $scope.currentMode = OVEN_HEADER_MAPPING["Edit My Cooking"];
        $scope.isBackKeyVisible = true;
        $scope.isDropDownOptionFromReadyStateVisible = false;
        $scope.renamedRecipe = null;
        $scope.SubHeaderVisible = false;
        $scope.ovenHeader = $scope.translation.WEBMOB_device_oven_mycooking_editmycooking;
        updateMyCookingList();
        $scope.currentScreen = OVENSCREENS.OVEN_EDIT_MY_COOKING_CONTAINER;
        changeView();
    }

    function showOvenPreheatScreen() {
        debugMessage("showOvenPreheatScreen :: " + $scope.ovenDeviceInfo.Mode.modes[0]);
        $scope.setTimenTempClicked = false;
        $scope.isBackKeyVisible = true;
        $scope.bAboutOptionVisible = false;
        $scope.currentMode = OVEN_HEADER_MAPPING[$scope.ovenDeviceInfo.Mode.modes[0]];
        if ($scope.ovenDeviceInfo.Operation.operationTime === "00:00:00") {
            $scope.progressBarVisible = false;
        } else {
            $scope.progressBarVisible = true;
        }
        if ($scope.ovenDeviceInfo.Operation.progressPercentage === null || $scope.ovenDeviceInfo.Operation.progressPercentage === undefined) {
            $scope.ovenDeviceInfo.Operation.progressPercentage = 0;
        }
        $scope.currentTemp = $scope.ovenDeviceInfo.Temperatures[0].current;
        $scope.desiredTemp = $scope.ovenDeviceInfo.Temperatures[0].desired;

        if ($scope.ovenDeviceInfo.Operation.remainingTime === null || $scope.ovenDeviceInfo.Operation.remainingTime === undefined) {
            $scope.timeLeft = "00:00";
            $scope.timeLeftinRunningState = "0:00";
        } else {
            $scope.timeLeft = $scope.ovenDeviceInfo.Operation.remainingTime.substring(0, 5);
            $scope.timeLeftinRunningState = '';
            if ($scope.timeLeft.substring(0, 1) === '0') {
                $scope.timeLeftinRunningState = $scope.timeLeft.substring(1, 5);
            } else {
                $scope.timeLeftinRunningState = $scope.timeLeft.substring(0, 5);
            }
        }
        var hourToAdd = parseInt($scope.timeLeft.substring(0, 2), 10);
        var minToAdd = parseInt($scope.timeLeft.substring(3, 5), 10);
        var newdate = new Date();
        var currentHour = newdate.getHours();
        var currentMin = newdate.getMinutes();

        currentHour = currentHour + hourToAdd;
        currentMin = currentMin + minToAdd;

        if (currentMin > 60) {
            currentHour = currentHour + 1;
            if (currentHour > 23) {
                currentHour = currentHour - 24;
            }
            currentMin = currentMin - 60;
        }

        var isPM = false;
        if (currentHour > 11) {
            isPM = true;
        }
        if (currentHour > 12) {
            currentHour = currentHour - 12;
        }

        if (currentHour.toString().length === 1) {
            currentHour = "0" + currentHour;
        }
        if (currentMin.toString().length === 1) {
            currentMin = "0" + currentMin;
        }

        $scope.progressCompletesAtTxt;
        if (isPM) {
            $scope.progressCompletesAtTxt = currentHour + ":" + currentMin + "PM";
        } else {
            $scope.progressCompletesAtTxt = currentHour + ":" + currentMin + "AM";
        }

        if ($scope.ovenDeviceInfo.Temperatures[1]) {
            $scope.currentMeatProbeTemp = $scope.ovenDeviceInfo.Temperatures[1].current;
            $scope.desiredMeatProbeTemp = $scope.ovenDeviceInfo.Temperatures[1].desired;
        }

        if ($scope.currentMode === "SlowCook" || $scope.currentMode === "OVENMOB_LCD_slow_cook") {
            $scope.bSlowCook = true;
        } else {
            $scope.bSlowCook = false;
        }

        $scope.currentScreen = OVENSCREENS.OVEN_PREHEAT_CONTAINER;
        changeView();
    }

    function showOvenCookingScreen() {
        debugMessage("showOvenCookingScreen");
        $scope.setTimenTempClicked = false;
        $scope.isBackKeyVisible = true;
        $scope.bAboutOptionVisible = false;
        $scope.currentMode = OVEN_HEADER_MAPPING[$scope.ovenDeviceInfo.Mode.modes[0]];
        if ($scope.ovenDeviceInfo.Operation.operationTime === "00:00:00") {
            $scope.progressBarVisible = false;
        } else {
            $scope.progressBarVisible = true;
        }

        if ($scope.ovenDeviceInfo.Operation.progressPercentage === null || $scope.ovenDeviceInfo.Operation.progressPercentage === undefined) {
            $scope.ovenDeviceInfo.Operation.progressPercentage = 0;
        }

        $scope.currentTemp = $scope.ovenDeviceInfo.Temperatures[0].current;
        $scope.desiredTemp = $scope.ovenDeviceInfo.Temperatures[0].desired;

        if ($scope.ovenDeviceInfo.Operation.remainingTime === null || $scope.ovenDeviceInfo.Operation.remainingTime === undefined) {
            $scope.timeLeft = "00:00";
            $scope.timeLeftinRunningState = "0:00";
        } else {
            $scope.timeLeft = $scope.ovenDeviceInfo.Operation.remainingTime.substring(0, 5);
            $scope.timeLeftinRunningState = '';
            if ($scope.timeLeft.substring(0, 1) === '0') {
                $scope.timeLeftinRunningState = $scope.timeLeft.substring(1, 5);
            } else {
                $scope.timeLeftinRunningState = $scope.timeLeft.substring(0, 5);
            }
        }

        var hourToAdd = parseInt($scope.timeLeft.substring(0, 2), 10);
        var minToAdd = parseInt($scope.timeLeft.substring(3, 5), 10);
        var newdate = new Date();
        var currentHour = newdate.getHours();
        var currentMin = newdate.getMinutes();

        currentHour = currentHour + hourToAdd;
        currentMin = currentMin + minToAdd;

        if (currentMin > 60) {
            currentHour = currentHour + 1;
            if (currentHour > 23) {
                currentHour = currentHour - 24;
            }
            currentMin = currentMin - 60;
        }

        var isPM = false;
        if (currentHour > 11) {
            isPM = true;
        }
        if (currentHour > 12) {
            currentHour = currentHour - 12;
        }

        if (currentHour.toString().length === 1) {
            currentHour = "0" + currentHour;
        }

        if (currentMin.toString().length === 1) {
            currentMin = "0" + currentMin;
        }

        $scope.progressCompletesAtTxt;
        if (isPM) {
            $scope.progressCompletesAtTxt = currentHour + ":" + currentMin + "PM";
        } else {
            $scope.progressCompletesAtTxt = currentHour + ":" + currentMin + "AM";
        }

        if ($scope.currentMode === "SlowCook" || $scope.currentMode === "OVENMOB_LCD_slow_cook") {
            $scope.bSlowCook = true;
        } else {
            $scope.bSlowCook = false;
        }
        $scope.currentScreen = OVENSCREENS.OVEN_COOKING_CONTAINER;
        changeView();
    }

    function showOvenDrainNeedScreen() {
        debugMessage("showOvenDrainNeedScreen");
        $scope.currentMode = OVEN_HEADER_MAPPING[$scope.ovenDeviceInfo.Mode.modes[0]];
        $scope.currentScreen = OVENSCREENS.OVEN_DRAINNEED_CONTAINER;
        changeView();
    }

    function showOvenCheckingScreen() {
        debugMessage("showOvenCheckingScreen");
        $scope.currentMode = OVEN_HEADER_MAPPING[$scope.ovenDeviceInfo.Mode.modes[0]];
        $scope.currentScreen = OVENSCREENS.OVEN_CHECKING_CONTAINER;
        changeView();
    }

    function showOvenPopUpOnDeviceScreen() {
        debugMessage("showOvenPopUpOnDeviceScreen");
        $scope.currentScreen = OVENSCREENS.OVEN_POPUP_ON_DEVICE_CONTAINER;
        $scope.isDropDownOptionFromReadyStateVisible = false;
        $scope.SubHeaderVisible = false;
        changeView();
    }

    function sendButtonClickedFromReadyState() {
        debugMessage("sendButtonClickedFromReadyState");
        $scope.sendButtonPressed = true;
        $timeout(function () {
            if ($scope.ovenDeviceInfo.Operation.power === "On") {
                if (!$scope.isStatic) {

                    var modeOptionsString = "";

                    if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.FAST_PREHEATING] === "TRUE") {
                        modeOptionsString = 'fastpreheat_Supported';
                        if ($scope.bFastPreheat === true) {
                            modeOptionsString = modeOptionsString + '","fastpreheat_on';
                        } else {
                            modeOptionsString = modeOptionsString + '","fastpreheat_off';
                        }
                    } else {
                        modeOptionsString = 'fastpreheat_Not_Supported';
                    }

                    if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.CRISPONTOP] === "TRUE") {
                        modeOptionsString += '","crispy_Supported';
                        if ($scope.bCrispy === true) {
                            modeOptionsString += '","crispy_on';
                        } else {
                            modeOptionsString += '","crispy_off';
                        }
                    } else {
                        modeOptionsString = '","crispy_Not_Supported';
                    }

                    if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.FAST_PREHEATING] === "FALSE") {
                        modeOptionsString += '","fastpreheat_Not_Supported';
                    }
                    var newdate = new Date();
                    newdate.setHours($scope.desiredHours, $scope.desiredMinutes, 0);
                    var hour = newdate.getHours();
                    if (hour.toString().length === 1) {
                        hour = hour;
                    }

                    var minute = newdate.getMinutes();
                    if (minute.toString().length === 1) {
                        minute = parseInt(("0" + minute), 10);
                    }

                    var operationTime = hour + ":" + minute + ":00";

                    var steamLevel = 0;
                    if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.VAPOUR] === "FALSE") {
                        steamLevel = 0;
                    } else {
                        steamLevel = $scope.vapourCurrentLevel;
                    }

                    var recipeTemperature = {"id": "0",
                        "current": $scope.currentTemp,
                        "desired": $scope.desiredTemp,
                        "maximum": $scope.minTemp,
                        "minimum": $scope.maxTemp,
                        "unit": "Celsius"};

                    if ($scope.bOvenMeatProbe) {
                        var bOvenMeatProbeTemperature = {"id": "1",
                            "current": $scope.currentTemp,
                            "desired": $scope.desiredMeatProbeTemp,
                            "maximum": $scope.maxMeatProbeTemp,
                            "minimum": $scope.minMeatProbeTemp,
                            "unit": "Celsius"};
                    }

                    if ($scope.bOvenMeatProbe) {
                        $scope.recipeSentToOvenFromReadyPage = true;
                        $scope.checkResponse.push(OVEN_COMMANDS.sendRecipetoOven);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, getsendRecipeCommandwithMeatProbe($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.MODE], modeOptionsString, steamLevel, recipeTemperature, bOvenMeatProbeTemperature), "/" + $scope.peerId + "/devices/0");
                        if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.TYPE] === 'BASIC' || $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.TYPE] === 'VAPOUR') {
                            updateNoOfVisit($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.MODE]);
                        }
                    } else {
                        $scope.recipeSentToOvenFromReadyPage = true;
                        $scope.checkResponse.push(OVEN_COMMANDS.sendRecipetoOven);
                        SHPService.sendSHPCommand(CONSTANTS.PUT, getsendRecipeCommandwithoutMeatProbe($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.MODE], modeOptionsString, operationTime, steamLevel, recipeTemperature), "/" + $scope.peerId + "/devices/0");
                        if ($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.TYPE] === 'BASIC' || $scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.TYPE] === 'VAPOUR') {
                            updateNoOfVisit($scope.readyStateContents[0].values[0][OVEN_MODE_TABLE.MODE]);
                        }
                    }
                } else {
                    showcustDialog(OVEN_ALERT_STATE.ALERT_TURNONOVEN, $scope.translation.WEBMOB_common_connection_failure, $scope.translation.OVENMOB_LCD_smartcontrol_guide_2, $scope.translation.WEBMOB_common_ok);
                }
            } else {
                showcustDialog(OVEN_ALERT_STATE.ALERT_TURNONOVEN, $scope.translation.WEBMOB_common_connection_failure, $scope.translation.OVENMOB_LCD_smartcontrol_guide_2, $scope.translation.WEBMOB_common_ok);
            }
            $scope.sendButtonPressed = false;
        }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
    }

    function sendButtonClickedFromChefRecipe(chefRecipeName) {
        debugMessage("sendButtonClickedFromChefRecipe");
        $scope.sendButtonClickedFromCR = true;
        $timeout(function () {
            if ($scope.ovenDeviceInfo.Operation.power === "On") {
                if (!$scope.isStatic) {
                    $scope.recipeSentToOven = true;
                    $scope.checkResponse.push(OVEN_COMMANDS.sendRecipetoOven);
                    SHPService.sendSHPCommand(CONSTANTS.PUT, getsendChefRecipeCommand($scope.chefRecipeContents[0].values[$scope.ChecRecipeIndex][CHEF_RECIPE_TABLE.ID], $scope.translation[chefRecipeName], $scope.chefRecipeContents[0].values[$scope.ChecRecipeIndex][CHEF_RECIPE_TABLE.STAGE_INFO]), "/" + $scope.peerId + "/devices/0/oven/customrecipes/0");
                } else {
                    showcustDialog(OVEN_ALERT_STATE.ALERT_TURNONOVEN, $scope.translation.WEBMOB_common_connection_failure, $scope.translation.OVENMOB_LCD_smartcontrol_guide_2, $scope.translation.WEBMOB_common_ok);
                }
            } else {
                showcustDialog(OVEN_ALERT_STATE.ALERT_TURNONOVEN, $scope.translation.WEBMOB_common_connection_failure, $scope.translation.OVENMOB_LCD_smartcontrol_guide_2, $scope.translation.WEBMOB_common_ok);
            }
            $scope.sendButtonClickedFromCR = false;
        }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
    }

    function sendButtonClickedFromAutoCookDetailPage() {
        debugMessage("sendButtonClickedFromAutoCookDetailPage");
        $scope.sendButtonClickFromAutoCookDetail = true;
        $timeout(function () {
            if ($scope.ovenDeviceInfo.Operation.power === "On") {
                if (!$scope.isStatic) {
                    var recipeInfo = $scope.autoCookMenuDetail[0].values[0][AUTO_COOK_TABLE.ID];
                    recipeInfo += ".";
                    recipeInfo += 1 + Math.abs((($scope.AutoCookRecipeWeight - $scope.autoCookMenuDetail[0].values[0][AUTO_COOK_TABLE.MIN_WEIGHT]) * 10) || 0);
                    recipeInfo += ".";
                    recipeInfo += $scope.AutoCookRecipeTrayLevel;
                    $scope.recipeSentToOven = true;
                    $scope.checkResponse.push(OVEN_COMMANDS.sendRecipetoOven);
                    SHPService.sendSHPCommand(CONSTANTS.PUT, getsendAutoCookRecipeCommand(recipeInfo), "/" + $scope.peerId + "/devices/0");
                } else {
                    showcustDialog(OVEN_ALERT_STATE.ALERT_TURNONOVEN, $scope.translation.WEBMOB_common_connection_failure, $scope.translation.OVENMOB_LCD_smartcontrol_guide_2, $scope.translation.WEBMOB_common_ok);
                }
            } else {
                showcustDialog(OVEN_ALERT_STATE.ALERT_TURNONOVEN, $scope.translation.WEBMOB_common_connection_failure, $scope.translation.OVENMOB_LCD_smartcontrol_guide_2, $scope.translation.WEBMOB_common_ok);
            }
            $scope.sendButtonClickFromAutoCookDetail = false;
        }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);

    }

    function increaseTemp() {
        if ($scope.desiredTemp < $scope.maxTemp) {
            $scope.desiredTemp = $scope.desiredTemp + 5;
            document.getElementById("inputTempWithoutMeatProbe").value = $scope.desiredTemp;
        } else {
            $scope.desiredTemp = $scope.minTemp;
        }
    }

    function increaseTempContinuously() {
        $scope.longPress = true;
        clearInterval($scope.timer);
        $scope.timer = setInterval(function () {
            $scope.increaseTemp();
        }, OVEN_INC_DEC_LONGPRESS.TIME);
    }

    function decreaseTemp() {

        if ($scope.desiredTemp > $scope.minTemp) {
            $scope.desiredTemp = $scope.desiredTemp - 5;
            document.getElementById("inputTempWithoutMeatProbe").value = $scope.desiredTemp;
        } else {
            $scope.desiredTemp = $scope.maxTemp;
        }
    }

    function decreaseTempContinuously() {
        $scope.longPress = true;
        clearInterval($scope.timer);
        $scope.timer = setInterval(function () {
            $scope.decreaseTemp();
        }, OVEN_INC_DEC_LONGPRESS.TIME);
    }

    function increaseDesiredHours() {
        $scope.desiredHours = parseInt($scope.desiredHours);
        var minuteVal = parseInt($scope.desiredMinutes);
        if ($scope.desiredHours < 23) {
            $scope.desiredHours = $scope.desiredHours + 1;
            if (minuteVal === 0 && $scope.desiredHours === 0) {
                $scope.desiredHours = 1;
            }
            document.getElementById("inputHrs").value = $scope.desiredHours;
        } else {
            $scope.desiredHours = 0;
            if (minuteVal === 0) {
                $scope.desiredHours = 1;
            }
        }
    }

    function increaseDesiredHoursContinuously() {
        $scope.longPress = true;
        clearInterval($scope.timer);
        $scope.timer = setInterval(function () {
            $scope.increaseDesiredHours();
        }, OVEN_INC_DEC_LONGPRESS.TIME);
    }

    function decreaseDesiredHours() {
        $scope.desiredHours = parseInt($scope.desiredHours);
        var minuteVal = parseInt($scope.desiredMinutes);

        if ($scope.desiredHours > 0) {
            $scope.desiredHours = $scope.desiredHours - 1;
            if (minuteVal === 0 && $scope.desiredHours === 0) {
                $scope.desiredHours = 23;
            }
            document.getElementById("inputHrs").value = $scope.desiredHours;
        } else {
            $scope.desiredHours = 23;
            if (minuteVal === 0) {
                $scope.desiredHours = 23;
            }
        }
    }

    function decreaseDesiredHoursContinuously() {
        $scope.longPress = true;
        clearInterval($scope.timer);
        $scope.timer = setInterval(function () {
            $scope.decreaseDesiredHours();
        }, OVEN_INC_DEC_LONGPRESS.TIME);
    }

    function increaseDesiredMinutes() {
        $scope.desiredMinutes = parseInt($scope.desiredMinutes);
        var hourValue = parseInt($scope.desiredHours);

        var step = 1;
        if ($scope.desiredMinutes !== (60 - step)) {
            $scope.desiredMinutes += step;
            if (hourValue === 0 && $scope.desiredMinutes === 0) {
                $scope.desiredMinutes = 1;
            }
            document.getElementById("inputHMins").value = $scope.desiredMinutes;
        } else {
            $scope.desiredMinutes = 0;
            if (hourValue === 0) {
                $scope.desiredMinutes = 1;
            }
        }
        $scope.desiredMinutes = ($scope.desiredMinutes < 10) ? ('0' + $scope.desiredMinutes) : $scope.desiredMinutes;
    }

    function increaseDesiredMinutesContinuously() {
        $scope.longPress = true;
        clearInterval($scope.timer);
        $scope.timer = setInterval(function () {
            $scope.increaseDesiredMinutes();
        }, OVEN_INC_DEC_LONGPRESS.TIME);
    }

    function decreaseDesiredMinutes() {
        $scope.desiredMinutes = parseInt($scope.desiredMinutes);
        var hourValue = parseInt($scope.desiredHours);
        var step = 1;
        if ($scope.desiredMinutes !== 0) {
            $scope.desiredMinutes -= step;
            if (hourValue === 0 && $scope.desiredMinutes === 0) {
                $scope.desiredMinutes = 59;
            }
            document.getElementById("inputHMins").value = $scope.desiredMinutes;
        } else {
            $scope.desiredMinutes = 60 - step;
            if ($scope.hourValue === 0) {
                $scope.desiredMinutes = 59;
            }
        }
        $scope.desiredMinutes = ($scope.desiredMinutes < 10) ? ('0' + $scope.desiredMinutes) : $scope.desiredMinutes;
    }

    function decreaseDesiredMinutesContinuously() {
        $scope.longPress = true;
        clearInterval($scope.timer);
        $scope.timer = setInterval(function () {
            $scope.decreaseDesiredMinutes();
        }, OVEN_INC_DEC_LONGPRESS.TIME);
    }

    function increaseDesiredAMCHours() {
        $scope.desiredHours = parseInt($scope.desiredHours);
        var minuteVal = parseInt($scope.desiredMinutes);
        if ($scope.desiredHours < 23) {
            $scope.desiredHours = $scope.desiredHours + 1;
            if (minuteVal === 0 && $scope.desiredHours === 0) {
                $scope.desiredHours = 1;
            }
            document.getElementById("inputAMCHrs").value = $scope.desiredHours;
        } else {
            $scope.desiredHours = 0;
            if (minuteVal === 0) {
                $scope.desiredHours = 1;
            }
        }
    }

    function increaseDesiredAMCHoursContinuously() {
        $scope.longPress = true;
        clearInterval($scope.timer);
        $scope.timer = setInterval(function () {
            $scope.increaseDesiredAMCHours();
        }, OVEN_INC_DEC_LONGPRESS.TIME);
    }

    function decreaseDesiredAMCHours() {
        $scope.desiredHours = parseInt($scope.desiredHours);
        var minuteVal = parseInt($scope.desiredMinutes);

        if ($scope.desiredHours > 0) {
            $scope.desiredHours = $scope.desiredHours - 1;
            if (minuteVal === 0 && $scope.desiredHours === 0) {
                $scope.desiredHours = 23;
            }
            document.getElementById("inputAMCHrs").value = $scope.desiredHours;
        } else {
            $scope.desiredHours = 23;
            if (minuteVal === 0) {
                $scope.desiredHours = 23;
            }
        }
    }

    function decreaseDesiredAMCHoursContinuously() {
        $scope.longPress = true;
        clearInterval($scope.timer);
        $scope.timer = setInterval(function () {
            $scope.decreaseDesiredAMCHours();
        }, OVEN_INC_DEC_LONGPRESS.TIME);
    }

    function increaseDesiredAMCMinutes() {
        $scope.desiredMinutes = parseInt($scope.desiredMinutes);
        var hourValue = parseInt($scope.desiredHours);

        var step = 1;
        if ($scope.desiredMinutes !== (60 - step)) {
            $scope.desiredMinutes += step;
            if (hourValue === 0 && $scope.desiredMinutes === 0) {
                $scope.desiredMinutes = 1;
            }
            document.getElementById("inputAMCHMins").value = $scope.desiredMinutes;
        } else {
            $scope.desiredMinutes = 0;
            if (hourValue === 0) {
                $scope.desiredMinutes = 1;
            }
        }
        $scope.desiredMinutes = ($scope.desiredMinutes < 10) ? ('0' + $scope.desiredMinutes) : $scope.desiredMinutes;
    }

    function increaseDesiredAMCMinutesContinuously() {
        $scope.longPress = true;
        clearInterval($scope.timer);
        $scope.timer = setInterval(function () {
            $scope.increaseDesiredAMCMinutes();
        }, OVEN_INC_DEC_LONGPRESS.TIME);
    }

    function decreaseDesiredAMCMinutes() {
        $scope.desiredMinutes = parseInt($scope.desiredMinutes);
        var hourValue = parseInt($scope.desiredHours);
        var step = 1;
        if ($scope.desiredMinutes !== 0) {
            $scope.desiredMinutes -= step;
            if (hourValue === 0 && $scope.desiredMinutes === 0) {
                $scope.desiredMinutes = 59;
            }
            document.getElementById("inputAMCHMins").value = $scope.desiredMinutes;
        } else {
            $scope.desiredMinutes = 60 - step;
            if ($scope.hourValue === 0) {
                $scope.desiredMinutes = 59;
            }
        }
        $scope.desiredMinutes = ($scope.desiredMinutes < 10) ? ('0' + $scope.desiredMinutes) : $scope.desiredMinutes;
    }

    function decreaseDesiredAMCMinutesContinuously() {
        $scope.longPress = true;
        clearInterval($scope.timer);
        $scope.timer = setInterval(function () {
            $scope.decreaseDesiredAMCMinutes();
        }, OVEN_INC_DEC_LONGPRESS.TIME);
    }

    function changeMeridian() {
        $scope.meridian = ($scope.meridian === "AM") ? "PM" : "AM";
    }

    function increaseMeatProbeTemp() {
        if (($scope.desiredMeatProbeTemp + 1) < $scope.maxMeatProbeTemp) {
            $scope.desiredMeatProbeTemp = $scope.desiredMeatProbeTemp + 1;
            document.getElementById("inputTempMeatProbe").value = $scope.desiredMeatProbeTemp;
        } else {
            $scope.desiredMeatProbeTemp = $scope.minMeatProbeTemp;
        }
    }

    function increaseMeatprobeTempContinuously() {
        $scope.longPress = true;
        clearInterval($scope.timer);
        $scope.timer = setInterval(function () {
            $scope.increaseMeatProbeTemp();
        }, OVEN_INC_DEC_LONGPRESS.TIME);
    }

    function decreaseMeatProbeTemp() {
        if ($scope.desiredMeatProbeTemp > $scope.minMeatProbeTemp) {
            $scope.desiredMeatProbeTemp = $scope.desiredMeatProbeTemp - 1;
            document.getElementById("inputTempMeatProbe").value = $scope.desiredMeatProbeTemp;
        } else {
            $scope.desiredMeatProbeTemp = $scope.maxMeatProbeTemp;
        }
    }

    function decreaseMeatprobeTempContinuously() {
        $scope.longPress = true;
        clearInterval($scope.timer);
        $scope.timer = setInterval(function () {
            $scope.decreaseMeatProbeTemp();
        }, OVEN_INC_DEC_LONGPRESS.TIME);
    }

    function increaseAMCTemp() {
        if ($scope.desiredAMCTemp < $scope.maxAMCTemp) {
            $scope.desiredAMCTemp = $scope.desiredAMCTemp + 5;
            document.getElementById("inputAMCTemp").value = $scope.desiredAMCTemp;
        } else {
            $scope.desiredAMCTemp = $scope.minAMCTemp;
        }
    }

    function increaseAMCTempContinuously() {
        $scope.longPress = true;
        clearInterval($scope.timer);
        $scope.timer = setInterval(function () {
            $scope.increaseAMCTemp();
        }, OVEN_INC_DEC_LONGPRESS.TIME);
    }

    function decreaseAMCTemp() {
        if ($scope.desiredAMCTemp > $scope.minAMCTemp) {
            $scope.desiredAMCTemp = $scope.desiredAMCTemp - 5;
            document.getElementById("inputAMCTemp").value = $scope.desiredAMCTemp;
        } else {
            $scope.desiredAMCTemp = $scope.maxAMCTemp;
        }
    }

    function decreaseAMCTempContinuously() {
        $scope.longPress = true;
        clearInterval($scope.timer);
        $scope.timer = setInterval(function () {
            $scope.decreaseAMCTemp();
        }, OVEN_INC_DEC_LONGPRESS.TIME);
    }

    function showVaporLevelScreen() {
        $scope.vaporPopUpVisible = true;
    }

    function VapourLevelSetButtonClicked(vapourLevelValue) {
        debugMessage("VapourLevelSetButtonClicked :: " + vapourLevelValue);
        if ($scope.currentScreen === OVENSCREENS.OVEN_PREHEAT_CONTAINER ||
                $scope.currentScreen === OVENSCREENS.OVEN_COOKING_CONTAINER) {
            $scope.setTimenTempClicked = true;
        }
        $scope.vapourCurrentLevel = vapourLevelValue;
        if (vapourLevelValue === 1) {
            $scope.vapourCurrentLevelText = $scope.translation.OVENMOB_LCD_low;
        } else if (vapourLevelValue === 2) {
            $scope.vapourCurrentLevelText = $scope.translation.WEBMOB_device_oven_vapour_mid;
        } else if (vapourLevelValue === 3) {
            $scope.vapourCurrentLevelText = $scope.translation.OVENMOB_LCD_high;
        } else {
            ;//NULL
        }
        closeAllPopUps();
    }

    function onCancelProgress() {
        debugMessage("onCancelProgress");
        $scope.cancelButtonPressed = true;
        $timeout(function () {
            if ($scope.setTimenTempClicked) {
                $scope.setTimenTempClicked = false;
                showLandingPage();
                $scope.cancelButtonPressed = false;
                return;
            }
            showcustDialog(OVEN_ALERT_STATE.ALERT_CANCEL_COOKING, $scope.translation.WEBMOB_common_device_oven, $scope.translation.WEBMOB_common_cancel, $scope.translation.WEBMOB_common_cancel_no, $scope.translation.WEBMOB_common_ok_yes);
            $scope.cancelButtonPressed = false;
        }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
    }

    function doToggleCrispSwitch(id) {
        debugMessage("doToggleCrispSwitch :: " + id);
        $timeout(function () {
            $scope.rippleCrispSwitch = false;
            if ($scope.currentScreen === OVENSCREENS.OVEN_PREHEAT_CONTAINER ||
                    $scope.currentScreen === OVENSCREENS.OVEN_COOKING_CONTAINER) {
                $scope.setTimenTempClicked = true;
                $scope.progressBarVisible = false;
            }
            switch (id) {
                case "crispy":
                    $scope.bCrispy = !$scope.bCrispy;
                    break;
                case "fastPreheat":
                    $scope.bFastPreheat = !$scope.bFastPreheat;
                    break;
                default:
                    break;
            }
        }, MATERIAL_DESIGN.TOGGLE_TIME);
    }

    function onSettingsToggleUpdate(id) {
        debugMessage("onSettingsToggleUpdate");
        $scope.rippleCrispSwitch = true;
        doToggleCrispSwitch(id);
    }

    function selectedTabPageTab(TabsPagetabId) {
        return TabsPagetabId === $scope.currentTabPageTab;
    }

    function onClickOvenFunctionsItem(Item) {
        debugMessage("onClickOvenFunctionsItem");
        $scope.currentMode = Item[OVEN_MODE_TABLE.MODE];
        $scope.bCrispOptionVisible = Item[OVEN_MODE_TABLE.CRISPONTOP];
        if ($scope.bFastPreheatSupportedonDevice) {
            $scope.bFastPreheatOptionVisible = Item[OVEN_MODE_TABLE.FAST_PREHEATING];
        } else {
            $scope.bFastPreheatOptionVisible = false;
        }
        $scope.bVaporLevelOptionVisible = Item[OVEN_MODE_TABLE.VAPOUR];
        $scope.recipeDescription = Item[OVEN_MODE_TABLE.DESCRIPTION];

        if (Item[OVEN_MODE_TABLE.DEFAULT_TEMP] === null || Item[OVEN_MODE_TABLE.DEFAULT_TEMP] === undefined) {
            ;//NULL for SONAR ISSUE
        } else {
            $scope.desiredTemp = Item[OVEN_MODE_TABLE.DEFAULT_TEMP];
        }
        if (Item[OVEN_MODE_TABLE.DEFAULT_TIME] === null || Item[OVEN_MODE_TABLE.DEFAULT_TIME] === undefined) {
            ;//NULL
        } else {
            var newdate = new Date();
            newdate.setHours(0, Item[OVEN_MODE_TABLE.DEFAULT_TIME], 0);
            $scope.desiredHours = parseInt(newdate.getHours(), 10);
            $scope.desiredMinutes = parseInt(newdate.getMinutes(), 10);
        }

        showOvenReadyScreen(true);
    }

    function onClickSpecialFunctionsItem(Item) {
        debugMessage("onClickSpecialFunctionsItem");
        $scope.currentMode = Item[OVEN_MODE_TABLE.MODE];
        $scope.bCrispOptionVisible = Item[OVEN_MODE_TABLE.CRISPONTOP];
        if ($scope.bFastPreheatSupportedonDevice) {
            $scope.bFastPreheatOptionVisible = Item[OVEN_MODE_TABLE.FAST_PREHEATING];
        } else {
            $scope.bFastPreheatOptionVisible = false;
        }
        $scope.bVaporLevelOptionVisible = Item[OVEN_MODE_TABLE.VAPOUR];
        $scope.recipeDescription = Item[OVEN_MODE_TABLE.DESCRIPTION];
        if (Item[OVEN_MODE_TABLE.DEFAULT_TEMP] === null || Item[OVEN_MODE_TABLE.DEFAULT_TEMP] === undefined) {
            ;//NULL
        } else {
            $scope.desiredTemp = Item[OVEN_MODE_TABLE.DEFAULT_TEMP];
        }
        if (Item[OVEN_MODE_TABLE.DEFAULT_TIME] === null || Item[OVEN_MODE_TABLE.DEFAULT_TIME] === undefined) {
            ;//NULL
        } else {
            var newdate = new Date();
            newdate.setHours(0, Item[OVEN_MODE_TABLE.DEFAULT_TIME], 0);
            $scope.desiredHours = parseInt(newdate.getHours(), 10);
            $scope.desiredMinutes = parseInt(newdate.getMinutes(), 10);
        }
        showOvenReadyScreen(true);
    }

    function onClickMyCookingItem(Item) {
        debugMessage("onClickMyCookingItem :: " + Item);
        $scope.currentMode = Item.title;
        showOvenReadyScreen(true);
    }

    function openPopoverMode() {
        debugMessage("openPopoverMode");
//        if ($scope.isAnimSupport === true) {
//            collapseListWithAnimation(); // Removing previously applied animation on list ks.arun
//        }
        if ($scope.currentScreen === OVENSCREENS.OVEN_ADDMYCOOKING_CONTAINER) {
            if ($scope.AMCFnMenuVisible === true) {
                $scope.AMCFnMenuVisible = false;
                setAMCScreenScrollable();
            } else {
                $scope.AMCFnMenuVisible = true;
                setAMCScreenUnScrollable();
            }
        } else {
            if ($scope.ovenFnMenuVisible === true) {
                $scope.ovenFnMenuVisible = false;
                setReadyStateScreenScrollable();
            } else if ($scope.isDropDownOptionFromReadyStateVisible === true) {
                $scope.ovenFnMenuVisible = true;
                setReadyStateScreenUnScrollable();
            } else {
                ;//NULL
            }
            changePopUpClass();
            initializeMenuIconImages();
        }
    }

    function changePopUpClass() {
        debugMessage("changePopUpClass");
        if ($scope.ovenFnMenuVisible) {
            $scope.ModeSelectionPopupDivCls = "ModeSelectionPopupDiv";
        } else {
            $scope.ModeSelectionPopupDivCls = "ModeSelectionPopOutDiv";
        }
    }

    function initializeMenuIconImages() {
        debugMessage("initializeMenuIconImages");
        var cnt, len = $scope.OvenScreenMainTabvenTabPageTabs.length;
        for (cnt = 0; cnt < len && cnt < 3; ++cnt) { //hard coded for only top 3.
            $scope.menuIconImageCls[cnt] = 'arrow-down-withoutAnim';
        }
        $scope.selectedOpenedMenuHeaderIndex = -1;
        $scope.currentTabPageTab = -1;
    }

    function onClickTabPageTab(TabsPagetab, index) {
        debugMessage("onClickTabPageTab");
        $scope.selectedOpenedMenuHeaderIndex = index;
        $scope.autoCookCategoriesListClickedItem = "";
        switch (TabsPagetab.id) {
            case 1: //FALL-THROUGH
            case 2: //FALL-THROUGH
            case 3:
//                if ($scope.isAnimSupport === true) {
//                    removeAnimation();
//                    expendListWithAnimation(TabsPagetab, index);
//                }

                if (selectedTabPageTab(TabsPagetab.id)) {
                    $scope.currentTabPageTab = -1;
                } else {
                    $scope.currentTabPageTab = TabsPagetab.id;
                }
                break;
            case 4:
                //$timeout(function () {
                    $scope.isBackKeyVisible = true;
                    $scope.ovenFnMenuVisible = false;
                    setReadyStateScreenScrollable();
                    changePopUpClass();
                    $scope.isDropDownOptionFromReadyStateVisible = false;
                    showAutoCookScreen();
                //}, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
                break;
            case 5:
                //$timeout(function () {

                    $scope.isBackKeyVisible = true;
                    $scope.ovenFnMenuVisible = false;
                    setReadyStateScreenScrollable();
                    changePopUpClass();
                    $scope.isDropDownOptionFromReadyStateVisible = false;
                    showChefRecipeScreen();
                //}, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
                break;
            default:
                break;
        }
    }

    /*ks.arun Expandible animation START*/

    function removeAnimation() {
        return;
        $('.menuExpndColapsList').addClass('oven-no-anim');
        $('.commonListArrowIcon').addClass('oven-no-anim');
        $('.menu-item-list-container').addClass('oven-no-anim');
    }

    function expendListWithAnimation(TabsPagetab, index) {
        return;
        var menuItem = $('.menuExpndColapsList');
        var menuArrow = $('.commonListArrowIcon');
        var menuContainer = $('#menu_container_' + index);
        if (menuContainer.hasClass('selected')) {
            menuContainer.removeClass('selected')
        } else {
            menuContainer.addClass('selected')
        }
        if (selectedTabPageTab(TabsPagetab.id)) {
            menuItem.removeClass('menuExpndColapsList-item-selected');
            if ($scope.isAnimSupport === false) {
                menuArrow.eq(index).attr('class', 'icon-up right commonListArrowIcon menuExpndColapsList-arrow-icon-normal-no-anim');
            } else {
                menuArrow.eq(index).attr('class', 'icon-up right commonListArrowIcon menuExpndColapsList-arrow-icon-normal');
            }
        } else {
            if ($scope.isAnimSupport === false) {
                $('.menuExpndColapsList-arrow-icon-normal-no-anim').attr('class', 'icon-up right commonListArrowIcon');
                menuArrow.eq(index).attr('class', $('.commonListArrowIcon').eq(index).attr('class') + ' ' + 'menuExpndColapsList-arrow-icon-rotate-no-anim');
            } else {
                $('.menuExpndColapsList-arrow-icon-normal').attr('class', 'icon-up right commonListArrowIcon');
                menuArrow.eq(index).attr('class', $('.commonListArrowIcon').eq(index).attr('class') + ' ' + 'menuExpndColapsList-arrow-icon-rotate');
            }
            menuItem.addClass('menuExpndColapsList-item-selected');
        }
    }

    function collapseListWithAnimation(TabsPagetab, index) {
        return;
        var menuItem = $('.menuExpndColapsList');
        var menuArrow = $('.commonListArrowIcon');
        $('.menu-item-list-container').removeClass('selected');
        if ($scope.isAnimSupport === false) {
            $('.menuExpndColapsList-arrow-icon-normal').attr('class', 'icon-up right commonListArrowIcon-no-anim');
        } else {
            $('.menuExpndColapsList-arrow-icon-normal').attr('class', 'icon-up right commonListArrowIcon');
        }
        menuItem.removeClass('menuExpndColapsList-item-selected');
        menuArrow.attr('class', 'icon-up right commonListArrowIcon');
    }
    /*ks.arun Expandible animation END*/

    function hideOptionMenu() {
        debugMessage("hideOptionMenu");
        $scope.ovenFnMenuVisible = false;
        setReadyStateScreenScrollable();
        changePopUpClass();
        $scope.currentTabPageTab = -1;
        initializeMenuIconImages();
//	if($scope.isAnimSupport === true){
//            $('.menu-item-list-container').removeClass('selected'); 
//	}
    }

    function autoCookCategoriesListItemClick(category, index) {
        debugMessage("autoCookCategoriesListItemClick");
        changeAutoCookDropDownMenuArrowIcon(index);
        debugMessage("db.exec 4 starts");
        if ($scope.koreanModel) {
            if (LANG === "KO-KR") {
                $scope.autoCookSubCategories = db.exec("SELECT DISTINCT SUB_CATEGORY FROM AUTO_COOK_KR WHERE CATEGORY ='" + category + "'");
                $scope.autoCookMenuSubCategories = db.exec("SELECT MENU,SUB_CATEGORY, GUIDE_FOR_STEP5 FROM AUTO_COOK_KR WHERE CATEGORY ='" + category + "'");
            } else {
                $scope.autoCookSubCategories = db.exec("SELECT DISTINCT SUB_CATEGORY FROM AUTO_COOK_KR WHERE CATEGORY ='" + category + "' AND LOCALE='ALL'");
                $scope.autoCookMenuSubCategories = db.exec("SELECT MENU,SUB_CATEGORY, GUIDE_FOR_STEP5 FROM AUTO_COOK_KR WHERE CATEGORY ='" + category + "' AND LOCALE='ALL'");
            }
        } else {
            $scope.autoCookSubCategories = db.exec("SELECT DISTINCT SUB_CATEGORY FROM AUTO_COOK WHERE CATEGORY ='" + category + "'");
            $scope.autoCookMenuSubCategories = db.exec("SELECT MENU,SUB_CATEGORY, GUIDE_FOR_STEP5 FROM AUTO_COOK WHERE CATEGORY ='" + category + "'");
        }
        debugMessage("db.exec 4 ends");

        if ($scope.autoCookCategoriesListClickedItem === category) {
            $scope.autoCookCategoriesListClickedItem = "";
        } else {
            $scope.autoCookCategoriesListClickedItem = category;
        }
    }

    function initializeMenuIconForAutoCook() {
        debugMessage("initializeMenuIconForAutoCook");
        var cnt, len = $scope.autoCookCategories[0].values.length;
        for (cnt = 0; cnt < len; ++cnt) { //hard coded for only top 3.
            $scope.arrowIconsForAutoCookDropDown[cnt] = 'arrow-down-withoutAnim';
        }
        $scope.selectedOpenedMenuIndexAutoCook = -1;
        $scope.autoCookCategoriesListClickedItem = "";
    }

    function changeAutoCookDropDownMenuArrowIcon(index) {
        debugMessage("changeAutoCookDropDownMenuArrowIcon");
        if ($scope.arrowIconsForAutoCookDropDown[index] === 'arrow-down-withoutAnim' || $scope.arrowIconsForAutoCookDropDown[index] === 'arrow-up-withAnimation') {
            $scope.arrowIconsForAutoCookDropDown[index] = 'arrow-down-withAnim';
        } else {
            $scope.arrowIconsForAutoCookDropDown[index] = 'arrow-up-withAnimation';
        }

        if ($scope.selectedOpenedMenuIndexAutoCook !== -1 && $scope.selectedOpenedMenuIndexAutoCook !== index) {
            $scope.arrowIconsForAutoCookDropDown[$scope.selectedOpenedMenuIndexAutoCook] = 'arrow-up-withAnimation';
        }
        $scope.selectedOpenedMenuIndexAutoCook = index;
    }

    function getErrorCode(errorEnum) {
        debugMessage("errorEnum :: " + errorEnum);
        switch (errorEnum) {
            case 'E_000E': //FALL-THROUGH
            case 'E_000F':
                return "C-d1";
            case 'E_0027': //FALL-THROUGH
            case 'E_0028': //FALL-THROUGH
            case 'E_0029': //FALL-THROUGH
            case 'E_002A':
                return "C-20";
            case 'E_002B': //FALL-THROUGH
            case 'E_002C':
                return "C-22";
            case 'E_002E':
                return "C-23";
            case 'E_0053':
                return "C-F1";
            case 'E_0071': //FALL-THROUGH
            case 'E_0072':
                return "C-70";
            case 'E_000A': //FALL-THROUGH
            case 'E_0073':
                return "C-21";
            case 'E_007A':
                return "C-72";
            case 'E_0083':
                return "C-F0";
            case 'E_00SE':
                return "C-d0";
            case 'E_00TE':
                return "C-F2";
            case 'E_0S01':
                return "S-01";
            case 'E_0000': //FALL-THROUGH
            case 'Undefined':
            default:
                return "";
        }
    }

    function setDataInsideShowLandingPage() {
        debugMessage("setDataInsideShowLandingPage");
        if ($scope.ovenDeviceInfo.Mode.options.indexOf("meatprobe_disconnected") !== -1) {
            $scope.bOvenMeatProbe = false;
            $scope.bMeatProbeConnectedonDevice = false;
        }

        if ($scope.ovenDeviceInfo.Mode.options.indexOf("meatprobe_connected") !== -1) {
            $scope.bOvenMeatProbe = true;
            $scope.bMeatProbeConnectedonDevice = true;
        }

        if ($scope.ovenDeviceInfo.Mode.options.indexOf("fastpreheat_Not_Supported") !== -1) {
            $scope.bFastPreheatOptionVisible = false;
            $scope.bFastPreheatSupportedonDevice = false;
        }

        if ($scope.ovenDeviceInfo.Mode.options.indexOf("fastpreheat_on") !== -1) {
            $scope.bFastPreheatOptionVisible = true;
            $scope.bFastPreheatSupportedonDevice = true;
            $scope.bFastPreheat = true;
        }

        if ($scope.ovenDeviceInfo.Mode.options.indexOf("fastpreheat_off") !== -1) {
            $scope.bFastPreheatOptionVisible = true;
            $scope.bFastPreheatSupportedonDevice = true;
            $scope.bFastPreheat = false;
        }

        if ($scope.ovenDeviceInfo.Mode.options.indexOf("crispy_Not_Supported") !== -1) {
            $scope.bCrispOptionVisible = false;
        }

        if ($scope.ovenDeviceInfo.Mode.options.indexOf("crispy_on") !== -1) {
            $scope.bCrispy = true;
        }

        if ($scope.ovenDeviceInfo.Mode.options.indexOf("crispy_off") !== -1) {
            $scope.bCrispy = false;
        }

        if ($scope.ovenDeviceInfo.Oven.powerLevel === "0") {
            $scope.vapourCurrentLevel = "0";
            $scope.bVaporLevelOptionVisible = false;
        } else if ($scope.ovenDeviceInfo.Oven.powerLevel === "1") {
            $scope.vapourCurrentLevel = "1";
            $scope.vapourCurrentLevelText = $scope.translation.OVENMOB_LCD_low;
            $scope.bVaporLevelOptionVisible = true;
        } else if ($scope.ovenDeviceInfo.Oven.powerLevel === "2") {
            $scope.vapourCurrentLevel = "2";
            $scope.vapourCurrentLevelText = $scope.translation.WEBMOB_device_oven_vapour_mid;
            $scope.bVaporLevelOptionVisible = true;
        } else if ($scope.ovenDeviceInfo.Oven.powerLevel === "3") {
            $scope.vapourCurrentLevel = "3";
            $scope.vapourCurrentLevelText = $scope.translation.OVENMOB_LCD_high;
            $scope.bVaporLevelOptionVisible = true;
        } else {
            ;//NULL
        }
    }

    function showLandingPage() {
        debugMessage("showLandingPage");

        if ($scope.alertOn || $scope.setTimenTempClicked) {
            return;
        }

        if ($scope.recipeSentToOven) {
            showPressStartOnOvenScreen();
            setTimeout(function () {
                $scope.recipeSentToOven = false;
            }, 1000);
            return;
        }
        
        if ($scope.recipeSentToOvenFromReadyPage) {
            showPressStartOnOvenScreen();
            return;
        }

        if ($scope.bOvenOperationCompletedContainer === true) {
            setTimeout(function () {
                $scope.bOvenOperationCompletedContainer = false;
            }, 1000);
            return;
        }

        $scope.ovenFnMenuVisible = false;
        setReadyStateScreenScrollable();
        $scope.isDropDownOptionFromReadyStateVisible = false;
        $scope.prevScreen = $scope.currentScreen;

        if ($scope.ovenDeviceInfo.Alarms[0] !== null && $scope.ovenDeviceInfo.Alarms[0] !== undefined) {
            if ($scope.ovenDeviceInfo.Alarms[0].code.indexOf("OV_E") !== -1) {
                if ($scope.ovenDeviceInfo.Alarms[0].code.indexOf("OV_E_0000") !== -1) {
                    $scope.ovenDeviceInfo.Operation.state = "Ready";
                    $scope.ovenDeviceInfo.Oven.state = "Ready";
                } else {
                    $scope.errorCode = getErrorCode($scope.ovenDeviceInfo.Alarms[0].code);
                    showOvenErrorScreen();
                    return;
                }
            } else if ($scope.ovenDeviceInfo.Alarms[0].code === "OV_T_0001") {
                showcustDialog(OVEN_ALERT_STATE.ALERT_PREHEATCOMPLETE, $scope.translation.WEBMOB_common_device_oven, $scope.translation.OVENMOB_LCD_PreheatingFinishAlarm, $scope.translation.WEBMOB_common_ok);
                return;
            } else if ($scope.ovenDeviceInfo.Alarms[0].code === "OV_T_0003") {
                if ($scope.chefRecipeRunning) {
                    $scope.chefRecipeRunning = false;
                }
                $scope.bCookingFinished = true;
                $scope.operationCompletedorCanceledMSG = "OVENMOB_LCD_finish_message";
                showOperationCompletedScreen();
                return;
            } else if ($scope.ovenDeviceInfo.Alarms[0].code === "OV_T_0004") {
                showcustDialog(OVEN_ALERT_STATE.ALERT_COOKING_SNOOZE, $scope.translation.OVENMOB_LCD_AlarmTile, $scope.translation.OVENMOB_LCD_CookingFinishForecastSnoozeAlarm, $scope.translation.WEBMOB_common_cancel_no, $scope.translation.OVENMOB_LCD_cooking_finish_snooze_alarm_min);
                return;
            } else if ($scope.ovenDeviceInfo.Alarms[0].code === "OV_T_0005") {
                if ($scope.chefRecipeRunning) {
                    $scope.chefRecipeRunning = false;
                }
                $scope.bProgressCompletdNormal = true;
                $scope.operationCompletedorCanceledMSG = "OVENMOB_LCD_CookingFinishAlarm";
                showOperationCompletedScreen();
                return;
            } else if ($scope.ovenDeviceInfo.Alarms[0].code === "OV_T_0006") {
                if ($scope.chefRecipeRunning) {
                    $scope.chefRecipeRunning = false;
                }
                $scope.bCookingCancelled = true;
                $scope.operationCompletedorCanceledMSG = "OVENMOB_LCD_cooking_cancelled";
                showOperationCompletedScreen();
                return;
            } else if ($scope.ovenDeviceInfo.Alarms[0].code === "OV_T_0007") {
                $scope.bCleaningFinished = true;
                $scope.operationCompletedorCanceledMSG = "OVENMOB_LCD_CleaningFinishAlarm";
                showOperationCompletedScreen();
                return;
            } else if ($scope.ovenDeviceInfo.Alarms[0].code === "OV_T_0008") {
                $scope.bCleaningCancelled = true;
                $scope.operationCompletedorCanceledMSG = "OVENMOB_LCD_cleaning_cancelled";
                showOperationCompletedScreen();
                return;
            } else {
                ;//NULL
            }
        }

        if ($scope.ovenDeviceInfo.Mode.options.indexOf("Popup_On") !== -1) {
            showOvenPopUpOnDeviceScreen();
            return;
        }
        if ($scope.ovenDeviceInfo.Mode.options.indexOf("DeviceType_07AA") !== -1) {
            $scope.koreanModel = true;
            debugMessage("db.exec 5 skip");
            if ($scope.bDBSet) {
                if (LANG === "KO-KR") {
                    $scope.autoCookCategories = $scope.categoriesFromAutoCookKorea;
                    $scope.autoCookContents = $scope.contentsFromAutoCookKorea;
                } else {
                    $scope.autoCookCategories = $scope.categoriesFromAutoCook;;
                    $scope.autoCookContents = $scope.contentsFromAutoCook;
                }
            }
        }

        setDataInsideShowLandingPage();

        if ($scope.ovenDeviceInfo.Operation.state === "Ready") {
            showLandingPageReadyMode();
        } else if ($scope.ovenDeviceInfo.Operation.state === "Run") {
            showLandingPageRunMode();
        } else {
            $scope.showOvenRunningScreen();
        }
    }

    function showLandingPageReadyMode() {
        debugMessage("showLandingPageReadyMode");
        $scope.SubHeaderVisible = true;
        if ($scope.ovenDeviceInfo.Oven.state === "Ready") {
            showOvenReadyScreen(false);
        } else if ($scope.ovenDeviceInfo.Oven.state === "Draining") {
            showOvenDrainingScreen();
        } else if ($scope.ovenDeviceInfo.Oven.state === "Cooling") {
            showOvenCoolingScreen();
        } else if ($scope.ovenDeviceInfo.Oven.state === "DrainNeed") {
            showOvenDrainNeedScreen();
        } else if ($scope.ovenDeviceInfo.Oven.state === "Checking") {
            showOvenCheckingScreen();
        } else {
            ;//NULL
        }
    }

    function showLandingPageRunMode() {
        debugMessage("showLandingPageRunMode");
        $scope.SubHeaderVisible = true;
        $scope.currentMode = $scope.ovenDeviceInfo.Mode.modes[0];
        if ($scope.chefRecipeRunning) {
            debugMessage("db.exec 6 starts");
            var recipeName = db.exec("SELECT MENU FROM CHEF_RECIPE WHERE ID='" + $scope.chefRecipeId + "'");
            debugMessage("db.exec 6 ends");
            $scope.commonRunningModeTypeHeaderTxt = recipeName[0].values[0][0];

            if ($scope.ovenDeviceInfo.Oven.state === "Preheat") {
                $scope.commonRunningModeTypeMonitorValue = "OVENMOB_LCD_preheating";
            } else if ($scope.ovenDeviceInfo.Oven.state === "Cooking") {
                $scope.commonRunningModeTypeMonitorValue = "OVENMOB_LCD_cooking_in_progress";
            } else {
                ;//NULL
            }
            showCommonRunningModeTypeScreen();
            return;
        }

        if (!$scope.isStatic) {
            showLandingPageRunModeOnDevice();
        } else {
            showLandingPageRunModeifStatic();
        }
    }

    function showLandingPageRunModeifStatic() {
        debugMessage("showLandingPageRunModeifStatic");
        if ($scope.ovenDeviceInfo.Oven.state === "Preheat") {
            showOvenPreheatScreen();
        } else if ($scope.ovenDeviceInfo.Oven.state === "Cooking") {
            showOvenCookingScreen();
        } else if ($scope.ovenDeviceInfo.Oven.state === "Rinsing") {
            showOvenRinsingScreen();
        } else if ($scope.ovenDeviceInfo.Oven.state === "Draining") {
            showOvenDrainingScreen();
        } else if ($scope.ovenDeviceInfo.Oven.state === "Cooling") {
            showOvenCoolingScreen();
        } else if ($scope.ovenDeviceInfo.Oven.state === "DrainNeed") {
            showOvenDrainNeedScreen();
        } else if ($scope.ovenDeviceInfo.Oven.state === "Checking") {
            showOvenCheckingScreen();
        } else if ($scope.ovenDeviceInfo.Oven.state === "Cleaning") {
            showCleaninProgressScreen();
        } else {
            showOvenReadyScreen(false);
        }
    }

    function showLandingPageRunModeOnDevice() {
        debugMessage("showLandingPageRunModeOnDevice");
        debugMessage("db.exec 7 starts");
        var type = db.exec("SELECT TYPE FROM MODE_TABLE WHERE MODE='" + $scope.currentMode + "'");
        debugMessage("db.exec 7 ends");

        if (type[0].values[0][0] === "MODE" && $scope.currentMode === "AutoCook") {
            var recipeName;
            debugMessage("db.exec 8 starts");
            if (LANG === "KO-KR") {
                recipeName = db.exec("SELECT MENU FROM AUTO_COOK_KR WHERE ID='" + Number(($scope.ovenDeviceInfo.Oven.recipe).split(".")[0]) + "'");
            } else {
                recipeName = db.exec("SELECT MENU FROM AUTO_COOK WHERE ID='" + Number(($scope.ovenDeviceInfo.Oven.recipe).split(".")[0]) + "'");
            }
            debugMessage("db.exec 8 ends");
            $scope.commonRunningModeTypeHeaderTxt = recipeName[0].values[0][0];
            if ($scope.ovenDeviceInfo.Oven.state === "Preheat") {
                $scope.commonRunningModeTypeMonitorValue = "OVENMOB_LCD_preheating";
            } else if ($scope.ovenDeviceInfo.Oven.state === "Cooking") {
                $scope.commonRunningModeTypeMonitorValue = "OVENMOB_LCD_cooking_in_progress";
            } else {
                ;//NULL
            }
            showCommonRunningModeTypeScreen();
        } else if (type[0].values[0][0] === "CLEANING") {
            if ($scope.ovenDeviceInfo.Oven.state === "Preheat") {
                $scope.commonRunningModeTypeMonitorValue = "OVENMOB_LCD_preheating";
            } else if ($scope.ovenDeviceInfo.Oven.state === "Cooking") {
                $scope.commonRunningModeTypeMonitorValue = "OVENMOB_LCD_cooking_in_progress";
            } else {
                ;//NULL
            }
            showCommonRunningModeTypeScreen();
        } else {
            if ($scope.ovenDeviceInfo.Oven.state === "Preheat") {
                showOvenPreheatScreen();
            } else if ($scope.ovenDeviceInfo.Oven.state === "Cooking") {
                showOvenCookingScreen();
            } else if ($scope.ovenDeviceInfo.Oven.state === "Rinsing") {
                showOvenRinsingScreen();
            } else if ($scope.ovenDeviceInfo.Oven.state === "Draining") {
                showOvenDrainingScreen();
            } else if ($scope.ovenDeviceInfo.Oven.state === "Cooling") {
                showOvenCoolingScreen();
            } else if ($scope.ovenDeviceInfo.Oven.state === "DrainNeed") {
                showOvenDrainNeedScreen();
            } else if ($scope.ovenDeviceInfo.Oven.state === "Checking") {
                showOvenCheckingScreen();
            } else if ($scope.ovenDeviceInfo.Oven.state === "Cleaning") {
                showCleaninProgressScreen();
            } else {
                showOvenReadyScreen(false);
            }
        }
    }

    function movetoChefRecipeInfoPage(chefName, chefSubTitle) {
        debugMessage("movetoChefRecipeInfoPage chefName :: " + chefName + " and chefSubTitle :: " + chefSubTitle);
        $scope.ovenChefRecipeDetailPage = true;
        createDataForChefRecipes(chefName, chefSubTitle);
    }

    function showcustDialog(myAlertState, msgHeader, popuptext, txtButton1, txtButton2) {
        debugMessage("showcustDialog");
        setAllScreenUnScrollable();
        if (txtButton2 === undefined) {
            $scope.txtButton2Invisbile = true;
        } else {
            $scope.txtButton2Invisbile = false;
        }
        $scope.popUpVisible = true;
        $scope.alertOn = true;
        $scope.alertState = myAlertState;

        document.getElementById("custpopupheadertext").innerHTML = msgHeader;
        document.getElementById("custpopuptext").innerHTML = popuptext;

        if (txtButton1 !== undefined) {
            document.getElementById("alertbutton2").innerHTML = txtButton1;
            document.getElementById("alertbutton2").style.visibility = "visible";
        } else {
            document.getElementById("alertbutton2").style.visibility = "hidden";
        }

        if (txtButton2 !== undefined) {
            document.getElementById("alertbutton1").innerHTML = txtButton2;
            document.getElementById("alertbutton1").style.visibility = "visible";
        } else {
            document.getElementById("alertbutton1").style.visibility = "hidden";
        }
    }

    function showcustInputDialog(myAlertState, msgHeader, popuptext, txtButton1, txtButton2) {
        debugMessage("showcustInputDialog");
        setAllScreenUnScrollable();
        if (txtButton2 === undefined) {
            $scope.txtButton2Invisbile = true;
        } else {
            $scope.txtButton2Invisbile = false;
        }
        $scope.alertOn = true;
        $scope.inputPopUpVisible = true;
        $scope.alertState = myAlertState;

        document.getElementById("custpopupheadertextinput").innerHTML = msgHeader;
        document.getElementById("custpopupInputtextinput").value = popuptext;

        if (txtButton1 !== undefined) {
            document.getElementById("alertbutton2input").innerHTML = txtButton1;
            document.getElementById("alertbutton2input").style.visibility = "visible";
        } else {
            document.getElementById("alertbutton2input").style.visibility = "hidden";
        }

        if (txtButton2 !== undefined) {
            document.getElementById("alertbutton1input").innerHTML = txtButton2;
            document.getElementById("alertbutton1input").style.visibility = "visible";
        } else {
            document.getElementById("alertbutton1input").style.visibility = "hidden";
        }
    }

    function onAlertButton1Click() {
        debugMessage("onAlertButton1Click");

        switch ($scope.alertState) {
            case OVEN_ALERT_STATE.ALERT_TURNONOVEN:
                break;
            case OVEN_ALERT_STATE.ALERT_CANCEL_COOKING:
                if (!$scope.isStatic) {
                    $scope.checkResponse.push(OVEN_COMMANDS.cancelCooking);
                    SHPService.sendSHPCommand(CONSTANTS.PUT, getCancelCommand(), "/" + $scope.peerId + "/devices/0/operation");
                }
                break;
            case OVEN_ALERT_STATE.ALERT_COOKING_SNOOZE:
                var currentOpeationTime = $scope.ovenDeviceInfo.Operation.operationTime;
                var hour = currentOpeationTime.substr(0, 2);
                var minute = currentOpeationTime.substr(3, 2);
                var totaltimeinMinutes = parseInt(minute, 10) + parseInt(hour, 10) * 60 + 4;
                var newdate = new Date();
                newdate.setHours(0, totaltimeinMinutes, 0);
                var newHour = newdate.getHours();
                if (newHour.toString().length === 1) {
                    newHour = "0" + newHour;
                }
                var newMinute = newdate.getMinutes();
                if (newMinute.toString().length === 1) {
                    newMinute = "0" + newMinute;
                }
                var newOperationTime = newHour + ":" + newMinute + ":00";
                if (!$scope.isStatic) {
                    $scope.checkResponse.push(OVEN_COMMANDS.snoozeCookingTime);
                    SHPService.sendSHPCommand(CONSTANTS.PUT, getSendSnoozeCommand(newOperationTime), "/" + $scope.peerId + "/devices/0");
                }
                break;
            case OVEN_ALERT_STATE.ALERT_SMARTMONITOR_GUIDE:
                showLandingPage();
                break;
            case OVEN_ALERT_STATE.ALERT_AUTOCOOK_INFO:
                break;
            case OVEN_ALERT_STATE.ALERT_SAVEMYRECIPE:
                if (!validateRecipeName(document.getElementById("custpopupInputtextinput").value)) {
                    return;
                }
                var id = parseInt($scope.maxMyCookingListId, 10);
                id++;
                var hr = parseInt(document.getElementById("inputAMCHrs").value, 10);
                var mn = parseInt(document.getElementById("inputAMCHMins").value, 10);
                var totalTime = hr * 60 + mn;
                insertDataIntoFavoriteTable(id, $scope.myCookingRecipeDefaultContents[0].values[0][OVEN_MODE_TABLE.MODE], document.getElementById("custpopupInputtextinput").value, $scope.desiredAMCTemp, totalTime, document.getElementById("custpopupInputtextinput").value, $scope.bFastPreheat, $scope.bOvenMeatProbe, $scope.bCrispy, $scope.vapourCurrentLevel, $scope.desiredMeatProbeTemp);
                updateMyCookingList();
                showEditMyCookingScreen();
                x = $scope.editMyCookingListItems;
                break;
            case OVEN_ALERT_STATE.ALERT_RENAMERECIPE:
                if (!validateRecipeName(document.getElementById("custpopupInputtextinput").value)) {
                    return;
                }
                $scope.renamedRecipe = document.getElementById("custpopupInputtextinput").value;
                break;
            case OVEN_ALERT_STATE.ALERT_PREHEATCOMPLETE:
                break;
            case OVEN_ALERT_STATE.ALERT_DELETERECIPE:
                var j = 0;
                var f;
                var len = $scope.myCookingSelected.length;
                for (var i = 0; i < len; i++) {
                    for (f = 0; f < $scope.editMyCookingListItems.length; f++) {
                        if ($scope.myCookingSelected[i - j] === $scope.editMyCookingListItems[f].title)
                        {
                            $scope.editMyCookingListItems.splice(f, 1);
                            deleteDataFromFavoriteTable($scope.myCookingSelected[i - j]);
                            $scope.myCookingSelected.splice(i - j, 1);
                        }
                    }
                    j++;
                }
                $scope.myCookingSelected = [];
                updateMyCookingList();
                showEditMyCookingScreen();
                x = $scope.editMyCookingListItems;
                break;
            case OVEN_ALERT_STATE.ALERT_DEVELOPER_INFO:
                break;
            case OVEN_ALERT_STATE.ALERT_CONNECTION_ERROR:
                closeApp();
                break;
            default:
                break;
        }
        closeAllPopUps();
    }

    function onAlertButton2Click() {
        debugMessage("onAlertButton2Click");

        switch ($scope.alertState) {
            case OVEN_ALERT_STATE.ALERT_TURNONOVEN:
                break;
            case OVEN_ALERT_STATE.ALERT_CANCEL_COOKING:
                break;
            case OVEN_ALERT_STATE.ALERT_COOKING_SNOOZE:
                break;
            case OVEN_ALERT_STATE.ALERT_SMARTMONITOR_GUIDE:
                showLandingPage();
                break;
            case OVEN_ALERT_STATE.ALERT_AUTOCOOK_INFO:
                break;
            case OVEN_ALERT_STATE.ALERT_SAVEMYRECIPE:
                break;
            case OVEN_ALERT_STATE.ALERT_RENAMERECIPE:
                break;
            case OVEN_ALERT_STATE.ALERT_PREHEATCOMPLETE:
                break;
            case OVEN_ALERT_STATE.ALERT_DELETERECIPE:
                break;
            case OVEN_ALERT_STATE.ALERT_DEVELOPER_INFO:
                break;
            case OVEN_ALERT_STATE.ALERT_CONNECTION_ERROR:
                closeApp();
                break;
            default:
                break;
        }
        closeAllPopUps();
    }

    function onRecipeDetails() {
        debugMessage("onRecipeDetails");
        $scope.chefRecipeDetailsTabHeader = "OVENMOB_LCD_ingredients";
        showOvenShowRecipeScreen();
    }

    function AutoCookSubchildInfoClick(recipe, info) {
        debugMessage("AutoCookSubchildInfoClick");
        $timeout(function () {
            showcustDialog(OVEN_ALERT_STATE.ALERT_AUTOCOOK_INFO, recipe, info, $scope.translation.WEBMOB_common_ok);
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);

    }

    function okClickedFromOperationCompleteScreen() {
        debugMessage("okClickedFromOperationCompleteScreen");
        $scope.okClickedFromOCS = true;
        $scope.bCleaningFinished = false;
        $scope.bCleaningCancelled = false;
        $scope.bCookingFinished = false;
        $scope.bCookingCancelled = false;
        $scope.bProgressCompletdNormal = false;
        $scope.bOvenOperationCompletedContainer = false;
        showLandingPage();
        $scope.okClickedFromOCS = false;
    }

    $scope.init = function () {
        debugMessage("init");
    };

    function initOvenDeviceInfo() {
        debugMessage("initOvenDeviceInfo");
        $scope.ovenDeviceInfo = {};
        $scope.ovenDeviceInfo.Alarms = [];
        $scope.ovenDeviceInfo.ConfigurationLink = {'href': '/devices/0/configuration'};
        $scope.ovenDeviceInfo.EnergyConsumption = {'cumulativeConsumption': 0.0,
            'saveLocation': '/devices/0/information'};
        $scope.ovenDeviceInfo.InformationLink = {'href': '/devices/0/information'};
        $scope.ovenDeviceInfo.Mode = {};
        $scope.ovenDeviceInfo.Mode.modes = ['Convection'];
        $scope.ovenDeviceInfo.Mode.options = ["DeviceType_07AA", "Popup_Off", "meatprobe_disconnected", "fastpreheat_Not_Supported", "crispy_off"];
        $scope.ovenDeviceInfo.Mode.supportedModes = ["AutoCook", "Convection", "Conventional", "LargeGrill", "EcoGrill", "FanGrill", "BottomHeat", "TopHeatPluseConvection", "BottomHeatPluseConvection", "EcoConvection", "ProRoasting", "IntensiveCook", "VaporConvection", "VaporTopHeatPluseConvection", "VaporBottomHeatPluseConvection", "KeepWarm", "PlateWarm", "Defrost", "ProveDough", "PizzaCook", "SlowCook", "Drying", "CleanAirPyro", "SteamClean", "Descale"];

        $scope.ovenDeviceInfo.Operation = {
            'operationTime': '00:00:00',
            'power': 'On',
            'remainingTime': '00:00:00',
            'state': 'Run'
        };

        $scope.ovenDeviceInfo.Oven = {
            'CustomRecipesLink': {'href': '/devices/0/oven/customrecipes'},
            'powerLevel': '0',
            'state': 'Ready',
            'steamLevel': '0',
            'supportedPowerLevels': ['0'],
            'supportedSteamLevels': ['0', '1', '2', '3']
        };

        $scope.ovenDeviceInfo.Temperatures = [{
                'current': 28.0,
                'desired': 0.0,
                'id': '0',
                'unit': 'Celsius'
            }, {
                'current': 28.0,
                'desired': 0.0,
                'id': '1',
                'unit': 'Celsius'
            }];

        $scope.ovenDeviceInfo.connected = true;
        $scope.ovenDeviceInfo.description = 'Oven';
        $scope.ovenDeviceInfo.id = '0';
        $scope.ovenDeviceInfo.name = 'Oven';
        $scope.ovenDeviceInfo.resources = ["Alarms", "Configuration", "EnergyConsumption", "Information", "Mode", "Operation", "Temperatures", "Oven"];
        $scope.ovenDeviceInfo.type = 'Oven';
        $scope.ovenDeviceInfo.uuid = '54880E3F-23DD-0000-0000-000000000000';
    }

    function updateDeviceData(data) {
        debugMessage("updateDeviceData");
        if (!$scope.isStatic) {
            SHPService.updateDeviceData($scope, data);
        }
    }

    function requestFailHandler() {
        debugMessage("requestFailHandler");
        $scope.loadingBar = false;
        $scope.checkResponse = [];
    }

    $scope.parseDeviceData = function () {
        debugMessage("parseDeviceData");
    };

    function parseAlarm(device) {
        if (angular.isDefined(device["Alarms"])) {
            $scope.ovenDeviceInfo.Alarms = device["Alarms"];
        } else {
            $scope.ovenDeviceInfo.Alarms[0] = null;
        }
    }

    function parseConfigurationLink(device) {
        if (angular.isDefined(device["ConfigurationLink"])) {
            $scope.ovenDeviceInfo.ConfigurationLink.href = device["ConfigurationLink"]["href"];
        }
    }

    function parseEnergyConsumption(device) {
        if (angular.isDefined(device["EnergyConsumption"])) {
            if (angular.isDefined(device["EnergyConsumption"]["cumulativeConsumption"])) {
                $scope.ovenDeviceInfo.EnergyConsumption.cumulativeConsumption = device["EnergyConsumption"]["cumulativeConsumption"];
            }
            if (angular.isDefined(device["EnergyConsumption"]["saveLocation"])) {
                $scope.ovenDeviceInfo.EnergyConsumption.cumulativeConsumption = device["EnergyConsumption"]["saveLocation"];
            }
        }
    }

    function parseInformationLink(device) {
        if (angular.isDefined(device["InformationLink"])) {
            $scope.ovenDeviceInfo.InformationLink.href = device["InformationLink"].href;
        }
    }

    function parseMode(device) {
        if (angular.isDefined(device["Mode"])) {
            if (angular.isDefined(device["Mode"]["modes"])) {
                $scope.ovenDeviceInfo.Mode.modes = device["Mode"]["modes"];
            }

            if (angular.isDefined(device["Mode"]["options"])) {
                $scope.ovenDeviceInfo.Mode.options = device["Mode"]["options"];
            }

            if (angular.isDefined(device["Mode"]["supportedModes"])) {
                $scope.ovenDeviceInfo.Mode.supportedModes = device["Mode"]["supportedModes"];
            }
        }
    }

    function parseOperation(device) {
        if (angular.isDefined(device["Operation"])) {
            if (angular.isDefined(device["Operation"]["operationTime"])) {
                $scope.ovenDeviceInfo.Operation.operationTime = device["Operation"]["operationTime"];
                dismissLoadingBar(RANGE_COMMANDS.snoozeCookingTime);
                dismissLoadingBar(OVEN_COMMANDS.changeRunningStateProperty);
            }
            if (angular.isDefined(device["Operation"]["power"])) {
                $scope.ovenDeviceInfo.Operation.power = device["Operation"]["power"];
            }
            if (angular.isDefined(device["Operation"]["remainingTime"])) {
                $scope.ovenDeviceInfo.Operation.remainingTime = device["Operation"]["remainingTime"];
            }
            if (angular.isDefined(device["Operation"]["state"])) {
                $scope.ovenDeviceInfo.Operation.state = device["Operation"]["state"];
                dismissLoadingBar(OVEN_COMMANDS.cancelCooking);
                dismissLoadingBar(OVEN_COMMANDS.sendRecipetoOven);
            }
            if (angular.isDefined(device["Operation"]["progressPercentage"])) {
                $scope.ovenDeviceInfo.Operation.progressPercentage = device["Operation"]["progressPercentage"];
            }
        }
    }

    function parseOven(device) {
        if (angular.isDefined(device["Oven"])) {
            if (angular.isDefined(device["Oven"]["CustomRecipesLink"]) && angular.isDefined(device["Oven"]["CustomRecipesLink"]["href"])) {
                $scope.ovenDeviceInfo.Oven.CustomRecipesLink.href = device["Oven"]["CustomRecipesLink"]["href"];
            }
            if (angular.isDefined(device["Oven"]["powerLevel"])) {
                $scope.ovenDeviceInfo.Oven.state = device["Oven"]["powerLevel"];
            }
            if (angular.isDefined(device["Oven"]["state"])) {
                $scope.ovenDeviceInfo.Oven.state = device["Oven"]["state"];
            }
            if (angular.isDefined(device["Oven"]["steamLevel"])) {
                $scope.ovenDeviceInfo.Oven.steamLevel = device["Oven"]["steamLevel"];
            }
            if (angular.isDefined(device["Oven"]["supportedPowerLevels"])) {
                $scope.ovenDeviceInfo.Oven.supportedPowerLevels = device["Oven"]["supportedPowerLevels"];
            }
            if (angular.isDefined(device["Oven"]["supportedSteamLevels"])) {
                $scope.ovenDeviceInfo.Oven.supportedSteamLevels = device["Oven"]["supportedSteamLevels"];
            }
            if (angular.isDefined(device["Oven"]["recipe"])) {
                $scope.ovenDeviceInfo.Oven.recipe = device["Oven"]["recipe"];
            }
        }
    }

    function parseTemperature(device) {
        if (angular.isDefined(device["Temperatures"])) {
            if (angular.isDefined(device["Temperatures"][0])) {
                if (device["Temperatures"][0].id === '0') {
                    if (angular.isDefined(device["Temperatures"][0].current)) {
                        $scope.ovenDeviceInfo.Temperatures[0].current = device["Temperatures"][0].current;
                    }
                    if (angular.isDefined(device["Temperatures"][0].desired)) {
                        $scope.ovenDeviceInfo.Temperatures[0].desired = device["Temperatures"][0].desired;
                        dismissLoadingBar(OVEN_COMMANDS.changeRunningStateProperty);
                    }
                } else if (device["Temperatures"][0].id === '1') {
                    if (angular.isDefined(device["Temperatures"][0].current)) {
                        $scope.ovenDeviceInfo.Temperatures[1].current = device["Temperatures"][0].current;
                    }
                    if (angular.isDefined(device["Temperatures"][0].desired)) {
                        $scope.ovenDeviceInfo.Temperatures[1].desired = device["Temperatures"][0].desired;
                        dismissLoadingBar(OVEN_COMMANDS.changeRunningStateProperty);
                    }
                } else {
                    ; //NULL
                }
            }
            if (angular.isDefined(device["Temperatures"][1])) {
                if (device["Temperatures"][1].id === '0') {
                    ;//NULL
                } else if (device["Temperatures"][1].id === '1') {
                    if (angular.isDefined(device["Temperatures"][1].current)) {
                        $scope.ovenDeviceInfo.Temperatures[1].current = device["Temperatures"][1].current;
                    }
                    if (angular.isDefined(device["Temperatures"][1].desired)) {
                        $scope.ovenDeviceInfo.Temperatures[1].desired = device["Temperatures"][1].desired;
                        dismissLoadingBar(OVEN_COMMANDS.changeRunningStateProperty);
                    }
                } else {
                    ; //NULL
                }
            }
        }
    }

    $scope.parseOvenDeviceData = function (device) {

        debugMessage("parseOvenDeviceData");

        if (angular.isDefined(device["uuid"]) && device["uuid"] !== $scope.deviceUuid) {
            debugMessage("parseOvenDeviceData uuid not matched");
            return;
        }

        parseAlarm(device);
        parseConfigurationLink(device);
        parseEnergyConsumption(device);
        parseInformationLink(device);
        parseMode(device);
        parseOperation(device);
        parseOven(device);
        parseTemperature(device);

        if (angular.isDefined(device["Diagnosis"])) {
            if (angular.isDefined(device["Diagnosis"]["diagnosisStart"])) {
                $scope.ovenDeviceInfo.diagnosisStart = device["Diagnosis"]["diagnosisStart"];
            }
            if ($scope.ovenDeviceInfo.diagnosisStart === "Ready") {
                if ($scope.currentScreen === OVENSCREENS.OVEN_SMARTCARE_STARTNOW_CONTAINER || $scope.currentScreen === OVENSCREENS.OVEN_SMARTCARE_STARTNOW_NOERROR_CONTAINER) {
                    dismissLoadingBar(OVEN_COMMANDS.smartCareDiagnosis);
                    showSmartCareStartNowNoErrorScreen();
                }
            } else {
                showSmartCareStartNowScreen();
            }
        }

        if (angular.isDefined(device["connected"])) {
            $scope.ovenDeviceInfo.connected = device["connected"];
        }

        if (angular.isDefined(device["description"])) {
            $scope.ovenDeviceInfo.description = device["description"];
        }

        if (angular.isDefined(device["id"])) {
            $scope.ovenDeviceInfo.id = device["id"];
        }

        if (angular.isDefined(device["name"])) {
            $scope.ovenDeviceInfo.name = device["name"];
        }

        if (angular.isDefined(device["resources"])) {
            $scope.ovenDeviceInfo.resources = device["resources"];
        }

        if ($scope.ovenDeviceInfo.resources.indexOf("Diagnosis") !== -1) {
            $scope.smartCare = true;
        }

        if (angular.isDefined(device["type"])) {
            $scope.ovenDeviceInfo.type = device["type"];
        }

        if ($scope.appLaunch && $scope.bCustomRecipeInfoReceived) {
            dismissLoadingBar(OVEN_COMMANDS.getDevices);
            showOvenScreen();
        }

        if (!$scope.appLaunch && !$scope.isStatic) {
            nativeInterface.getResourceUrl("/" + $scope.peerId + "/devices/0/oven/customrecipes");
            $scope.appLaunch = true;
        }
    }

    function parseConfiguration(configura) {
        debugMessage("parseInformationLink");
        $scope.bConfigurationInfoReceived = true;
        if (angular.isDefined(configura["remoteControlEnabled"])) {
            $scope.remoteControlEnabled = configura["remoteControlEnabled"];
        }
        if (angular.isDefined(configura["region"])) {
            $scope.region = configura["region"];
        }
    }

    function parseCustomRecipeInfo(recipeInfo) {
        debugMessage("parseCustomRecipeInfo");
        $scope.appLaunch = true;
        $scope.bCustomRecipeInfoReceived = true;
        if (angular.isDefined(recipeInfo[0]) && recipeInfo[0].recipe !== "0") {
            $scope.chefRecipeRunning = true;
            $scope.chefRecipeId = Number((recipeInfo[0].recipe).split("||")[0]);
        }
        if ($scope.appLaunch && $scope.bCustomRecipeInfoReceived) {
            dismissLoadingBar(OVEN_COMMANDS.getDevices);
            showOvenScreen();
        }
    }

    function showOvenScreen() {
        debugMessage("showOvenScreen");
        if ($scope.parseNotiLength !== 0) {
            return;
        }
        $scope.mainLoadingScreen = true;
        $scope.bAboutOptionVisible = false;
        showLandingPage();
        if (!$scope.bConfigurationInfoReceived && !$scope.isStatic) {
            nativeInterface.getResourceUrl("/" + $scope.peerId + "/devices/0/configuration");
        }
    }

    function parseStaticData() {
        debugMessage("parseStaticData");
        var device = JSON.parse(SHPService.getSHPData('Oven'));
        $scope.ovenDeviceInfo = device["Devices"][0];
        $scope.showSmartCare = false;
        $scope.loadingBar = false;
        showOvenScreen();
    }

    function onSwipe(gesture, chefName, index) {
        debugMessage("onSwipe chefName :: " + chefName + " and index :: " + index);
        $scope.ChecRecipeIndex = index;
        document.getElementById("tab0").checked = true;
        document.getElementById("tab1").checked = false;
        document.getElementById("tab2").checked = false;
        mySwipe.slide($scope.ChecRecipeIndex);
        changeChefRecipeSummaryImageimageurl($scope.ChecRecipeIndex, chefName);
    }

    function changeChefRecipeSummaryImageimageurl(indexofsunmmary, chefName) {
        debugMessage("changeChefRecipeSummaryImageimageurl indexofsunmmary :: " + indexofsunmmary + " and chefName :: " + chefName);
        onClickTab(1);
        switch (indexofsunmmary) {
            case 0:
                if (chefName === "OVENMOB_LCD_michel_name") {
                    $scope.recipeIdNo = 0;
                    $scope.chefRecipeSummaryImageimageurl = "images/oven/chef_recipe_main_img_1440x1924_creamy_meringues.png";
                } else {
                    $scope.recipeIdNo = 2;
                    $scope.chefRecipeSummaryImageimageurl = "images/oven/chef_recipe_main_img_1440x1924_short_bread.png";
                }
                break;
            case 1:
                if (chefName === "OVENMOB_LCD_michel_name") {
                    $scope.recipeIdNo = 1;
                    $scope.chefRecipeSummaryImageimageurl = "images/oven/chef_recipe_main_img_1440x1924_colombieres.png";
                } else {
                    $scope.recipeIdNo = 3;
                    $scope.chefRecipeSummaryImageimageurl = "images/oven/chef_recipe_main_img_1440x1924_black_cod.png";
                }
                break;
            case 2:
                $scope.recipeIdNo = 4;
                $scope.chefRecipeSummaryImageimageurl = "images/oven/chef_recipe_main_img_1440x1924_veal_rolls.png";
                break;
            case 3:
                $scope.recipeIdNo = 5;
                $scope.chefRecipeSummaryImageimageurl = "images/oven/chef_recipe_main_img_1440x1924_roasted.png";
                break;
            default :
                break;
        }
    }

    function createDataForChefRecipes(chefName, chefSubTitle) {
        debugMessage("createDataForChefRecipes");
        $scope.selectedChefName = chefName;
        $scope.selectedChefSubTitle = chefSubTitle;
        if (chefName === "OVENMOB_LCD_michel_name") {
            $scope.chefRecipeSummaryImageimageurl = "images/oven/chef_recipe_main_img_1440x1924_creamy_meringues.png";
            $scope.chefRecipeContents = $scope.chefRecipesForMichelTroisgros;

            $scope.chefRecipeAry = angular.copy([{
                    id: 0,
                    recipeTitle: $scope.chefRecipeContents[0].values[0][3],
                    recipeDesc: $scope.chefRecipeContents[0].values[0][16],
                    imageUrl: 'images/oven/chef_recipe_main_img_1440x1924_creamy_meringues.png'
                }, {
                    id: 1,
                    recipeTitle: $scope.chefRecipeContents[0].values[1][3],
                    recipeDesc: $scope.chefRecipeContents[0].values[1][16],
                    imageUrl: 'images/oven/chef_recipe_main_img_1440x1924_colombieres.png'
                }]);
        } else if (chefName === "OVENMOB_LCD_eric_name") {
            $scope.chefRecipeSummaryImageimageurl = "images/oven/chef_recipe_main_img_1440x1924_short_bread.png";
            $scope.chefRecipeContents = $scope.chefRecipesForEricTrochon;
            $scope.chefRecipeAry = angular.copy([{
                    id: 0,
                    recipeTitle: $scope.chefRecipeContents[0].values[0][3],
                    recipeDesc: $scope.chefRecipeContents[0].values[0][16],
                    imageUrl: 'images/oven/chef_recipe_main_img_1440x1924_short_bread.png'
                }, {
                    id: 1,
                    recipeTitle: $scope.chefRecipeContents[0].values[1][3],
                    recipeDesc: $scope.chefRecipeContents[0].values[1][16],
                    imageUrl: 'images/oven/chef_recipe_main_img_1440x1924_black_cod.png'
                }, {
                    id: 2,
                    recipeTitle: $scope.chefRecipeContents[0].values[2][3],
                    recipeDesc: $scope.chefRecipeContents[0].values[2][16],
                    imageUrl: 'images/oven/chef_recipe_main_img_1440x1924_veal_rolls.png'
                },
                {
                    id: 3,
                    recipeTitle: $scope.chefRecipeContents[0].values[3][3],
                    recipeDesc: $scope.chefRecipeContents[0].values[3][16],
                    imageUrl: 'images/oven/chef_recipe_main_img_1440x1924_roasted.png'
                }
            ]);
        } else {
            ;//NULL
        }
        if ($scope.chefRecipeAry.length === 2) {
            $scope.chefRecipeAry.push($scope.chefRecipeAry[0]);
            $scope.chefRecipeAry.push($scope.chefRecipeAry[1]);
        }
        $timeout(initSwipe, 500);
    }

    function expandListItemClickHandler(tabNumber, recipeInfo, index) {
        debugMessage("expandListItemClickHandler");
        $scope.selectedSubIndexMenu = index;
        $timeout(function () {
            switch (tabNumber) {
                case 0:
                    $scope.readyStateContents[0].values[0] = recipeInfo;
                    $scope.ovenFnMenuVisible = false;
                    setReadyStateScreenScrollable();
                    changePopUpClass();
                    $scope.currentTabPageTab = -1;
                    showLandingPage();
//                    if ($scope.isAnimSupport === true) {
//                        collapseListWithAnimation();// Removeing expand animation 
//                    }
                    break;
                case 1:
                    $scope.readyStateContents[0].values[0] = recipeInfo;
                    $scope.ovenFnMenuVisible = false;
                    setReadyStateScreenScrollable();
                    changePopUpClass();
                    $scope.currentTabPageTab = -1;
                    showLandingPage();
//                    if ($scope.isAnimSupport === true) {
//                        collapseListWithAnimation();// Removeing expand animation 
//                    }
                    break;
                default:
                    break;
            }
            $scope.selectedHeaderMenu = $scope.selectedOpenedMenuHeaderIndex;
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }

    function handleMyCookingItemClick(index, recipeInfo) {
        debugMessage("handleMyCookingItemClick");
        $scope.myCookIndex = index;
        $scope.ovenFnMenuVisible = false;
        setReadyStateScreenScrollable();
        $scope.currentTabPageTab = -1;
        if (recipeInfo.title === 'Edit My Cooking') {
            showEditMyCookingScreen();
        } else {
            $scope.isFromMyCooking = true;
            showOvenReadyScreen(true);
        }
    }

    function editMyCookingItemClick(indexOfItem, editListItem) {
        debugMessage("editMyCookingItemClick");
        if (!!!($scope.multiselect)) {
            if (editListItem.title === "Add My Cooking") {
                $scope.myCookingRecipeDefaultContents = $scope.convectionContentsFromModeTable;
                showAddMyCookingScreen();
                return;
            } else if (editListItem.title === "Delete") {
                return;
            } else {
                $scope.isFromRecipeSeletedFromEditMyCooking = true;
                for (var i = 0; i < $scope.myCookingContentsLocalStorage.length; i++) {
                    if ($scope.myCookingContentsLocalStorage[i].RECIPE_NAME === editListItem.title) {
                        break;
                    }
                }
                $scope.myCookingRecipeContents = $scope.myCookingContentsLocalStorage[i];
                showAddMyCookingScreen();
            }

            if ($scope.editMyCookingListItems.length > 0) {
                $scope.enableDelete = true;
            }
        } else {
            var index = $scope.myCookingSelected.indexOf(editListItem.title);
            if (index === -1) {
                $scope.myCookingSelected.push(editListItem.title);
            } else {
                $scope.myCookingSelected.splice(index, 1);
            }
        }
        y = $scope.myCookingSelected;
    }

    function addToMyCooking() {
        debugMessage("addToMyCooking");
        $timeout(function () {
            $scope.myCookingRecipeDefaultContents = $scope.convectionContentsFromModeTable;
            $scope.myCookingSelected = [];
            showAddMyCookingScreen();
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }

    function deleteMyCookingsConfirmed() {
        debugMessage("deleteMyCookingsConfirmed");
        showcustDialog(OVEN_ALERT_STATE.ALERT_DELETERECIPE, $scope.translation.WEBMOB_common_delete, $scope.translation.WEBMOB_common_delete_confirm_msg, $scope.translation.WEBMOB_common_cancel, $scope.translation.WEBMOB_common_ok);
    }

    function deleteMyCookings() {
        debugMessage("deleteMyCookings");
        $timeout(function () {

            if ($scope.myCookingSelected.length > 0) {
                $scope.myCookingItemSelected = true;
            } else {
                $scope.myCookingItemSelected = false;
            }

            if ($scope.multiselect && !($scope.myCookingItemSelected)) {
                $scope.multiselect = false;
            } else {
                $scope.multiselect = true;
            }

            if ($scope.editMyCookingListItems.length > 0 && $scope.myCookingSelected.length > 0) {
                deleteMyCookingsConfirmed();
            }
        }, MATERIAL_DESIGN.LIST_ANIMATION_TIME);
    }

    function saveButtonClickedFromAMCState() {
        debugMessage("saveButtonClickedFromAMCState");
        $scope.saveButtonClickedFromAMC = true;
        $timeout(function () {
            if ($scope.showRenameOption === true) {
                updateDataIntoFavoriteTable();
                updateMyCookingList();
                showEditMyCookingScreen();
            } else {
                showcustInputDialog(OVEN_ALERT_STATE.ALERT_SAVEMYRECIPE, $scope.translation.OVENMOB_LCD_finish_add_to_favourite, getMyCookingRecipeName(), $scope.translation.WEBMOB_common_cancel_no, $scope.translation.WEBMOB_common_ok_yes);
            }
            $scope.saveButtonClickedFromAMC = false;
        }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
    }

    function applyButtonClickedFromRunningState() {
        debugMessage("applyButtonClickedFromRunningState");
        $scope.applyButtonClicked = true;
        $timeout(function () {
            if (!($scope.remoteControlEnabled)) {
                $scope.applyButtonClicked = false;
                showcustDialog(OVEN_ALERT_STATE.ALERT_SMARTMONITOR_GUIDE, $scope.translation.WEBMOB_common_device_oven, $scope.translation.OVENMOB_LCD_smartcontrol_guide_2, $scope.translation.WEBMOB_common_ok);
                return;
            }

            var crispValue = null;
            var fastPreheatValue = null;
            var vapourValue = null;

            if ($scope.bCrispOptionVisible) {
                crispValue = $scope.bCrispy;
            }
            if ($scope.bFastPreheatOptionVisible) {
                fastPreheatValue = $scope.bFastPreheat;
            }
            if ($scope.bVaporLevelOptionVisible) {
                vapourValue = $scope.vapourCurrentLevel;
            }

            if (!$scope.isStatic) {
                $scope.checkResponse.push(OVEN_COMMANDS.changeRunningStateProperty);
                SHPService.sendSHPCommand(CONSTANTS.PUT, getSendRunningPropertyChangeCommand(crispValue, fastPreheatValue, vapourValue), "/" + $scope.peerId + "/devices/0");
            }
            $scope.applyButtonClicked = false;
            $scope.setTimenTempClicked = false;
        }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
    }

    function stopLongPressEvent() {
        $scope.longPress = false;
        clearInterval($scope.timer);
        return;
    }

    function okClickedFromPressStartMSG() {
        debugMessage("okClickedFromPressStartMSG");
        $scope.okClickedFromPSM = true;
        $timeout(function () {
            $scope.recipeSentToOven = false;
            showLandingPage();
            $scope.okClickedFromPSM = false;
        }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
    }
    
    function editClickedFromPressStartMSG() {
        debugMessage("editClickedFromPressStartMSG");
        $scope.okClickedFromPSM = true;
        $timeout(function () {
            $scope.recipeSentToOvenFromReadyPage = false;
            showLandingPage();
            $scope.okClickedFromPSM = false;
        }, MATERIAL_DESIGN.BTN_ANIMATION_TIME);
    }

    $scope.$watch(function () {
        return $scope.desiredHours;
    }, function (newVal, oldVal) {
        if (newVal > 23) {
            $scope.desiredHours = oldVal;
        }
        if (newVal === undefined) {
            $scope.desiredHours = oldVal;
        }
    });

    function onHoursMinsFocusGain() {
        $scope.oldValueHours = $scope.desiredHours;
        $scope.oldValueMins = $scope.desiredMinutes;
    }

    function onHoursLostFocus() {
        if ($scope.desiredHours === "") {
            $scope.desiredHours = $scope.oldValueHours;
        }
        var desiredHr = parseInt($scope.desiredHours, 10);
        if (!!!desiredHr) {
            $scope.desiredHours = parseInt(0, 10);
        }

        if (desiredHr < 0) {
            $scope.desiredHours = parseInt(0, 10);
        }
        if (desiredHr >= 24) {
            $scope.desiredHours = parseInt(23, 10);
        }
        $scope.desiredHours = Number($scope.desiredHours);
    }

    $scope.$watch(function () {
        return $scope.desiredMinutes;
    }, function (newVal, oldVal) {
        if (newVal > 59) {
            $scope.desiredMinutes = oldVal;
        }
        if (newVal === undefined) {
            $scope.desiredMinutes = oldVal;
        }
    });

    function onMinsLostFocus() {
        if ($scope.desiredMinutes === "") {
            $scope.desiredMinutes = $scope.oldValueMins;
        }
        $scope.desiredMinutes = Number($scope.desiredMinutes);
        var desiredMin = parseInt($scope.desiredMinutes, 10);
        if (!!!desiredMin)
        {
            $scope.desiredMinutes = 0;
        }

        if (desiredMin < 0) {
            $scope.desiredMinutes = 0;
        }

        if ($scope.desiredHours == 0 && $scope.desiredMinutes == 0)
        {
            $scope.desiredMinutes = 1;
        }
        if (desiredMin >= 60) {
            $scope.desiredMinutes = 59;
        }

        $scope.desiredMinutes = ($scope.desiredMinutes < 10) ? ('0' + $scope.desiredMinutes) : $scope.desiredMinutes;
    }

    document.getElementById('inputTempMeatProbe').onblur = function () {
        var data;
        data = this.value;

        if ((this.value) < $scope.minTemp) {
            this.value = $scope.minTemp;
            $scope.desiredMeatProbeTemp = $scope.minTemp;
        }
        if (!(this.value)) {
            this.value = $scope.minTemp;
            $scope.desiredMeatProbeTemp = $scope.minTemp;
        }

        if ((this.value) % 5 !== 0 && (data.length > 1) && (data.length < 4)) {
            this.value = Math.ceil(parseInt(this.value, 10) / 5) * 5;
            $scope.desiredMeatProbeTemp = this.value;
        }

        if ((this.value) >= 95) {
            this.value = 95;
            $scope.desiredMeatProbeTemp = 95;
        }
    };

    $scope.$watch(function () {
        return $scope.desiredTemp;
    }, function (newVal, oldVal) {
        if (newVal > 275) {
            $scope.desiredTemp = oldVal;
        }
        if (newVal === undefined) {
            $scope.desiredTemp = oldVal;
        }
    });

    function onTempFocusGain() {
        $scope.oldValueTemp = $scope.desiredTemp;
        $scope.oldValueTempMeatProbe = $scope.desiredMeatProbeTemp;
        $scope.oldValueAMCTemp = $scope.desiredAMCTemp;
    }

    function doValidationForTemp() {

        if ($scope.desiredTemp === "") {
            $scope.desiredTemp = $scope.oldValueTemp;
        }

        if ($scope.desiredTemp > $scope.maxTemp) {
            $scope.desiredTemp = $scope.maxTemp;
        }

        if ($scope.desiredTemp < $scope.minTemp) {
            $scope.desiredTemp = $scope.minTemp;
        }

        if (!($scope.desiredTemp)) {
            $scope.desiredTemp = $scope.minTemp;
        }

        if (($scope.desiredTemp) % 5 !== 0 && ($scope.desiredTemp >= $scope.minTemp) && ($scope.desiredTemp <= $scope.maxTemp)) {
            $scope.desiredTemp = Math.ceil(parseInt($scope.desiredTemp, 10) / 5) * 5;
        }
    }

    $scope.$watch(function () {
        return $scope.desiredMeatProbeTemp;
    }, function (newVal, oldVal) {
        if (newVal > 99) {
            $scope.desiredMeatProbeTemp = oldVal;
        }
        if (newVal === undefined) {
            $scope.desiredMeatProbeTemp = oldVal;
        }
    });

    function doValidationForTempMeatProbe() {
        if ($scope.desiredMeatProbeTemp === "") {
            $scope.desiredMeatProbeTemp = $scope.oldValueTempMeatProbe;
        }

        if ($scope.desiredMeatProbeTemp > $scope.maxMeatProbeTemp) {
            $scope.desiredMeatProbeTemp = $scope.maxMeatProbeTemp;
        }

        if ($scope.desiredMeatProbeTemp < $scope.minMeatProbeTemp) {
            $scope.desiredMeatProbeTemp = $scope.minMeatProbeTemp;
        }

        if (!($scope.desiredMeatProbeTemp)) {
            $scope.desiredMeatProbeTemp = $scope.minMeatProbeTemp;
        }

        if (($scope.desiredMeatProbeTemp) % 5 !== 0 && ($scope.desiredMeatProbeTemp >= $scope.minMeatProbeTemp) && ($scope.desiredMeatProbeTemp <= $scope.maxMeatProbeTemp)) {
            $scope.desiredMeatProbeTemp = Math.ceil(parseInt($scope.desiredMeatProbeTemp, 10) / 5) * 5;
        }
    }

    $scope.$watch(function () {
        return $scope.desiredAMCTemp;
    }, function (newVal, oldVal) {
        if (newVal > 275) {
            $scope.desiredAMCTemp = oldVal;
        }
        if (newVal === undefined) {
            $scope.desiredAMCTemp = oldVal;
        }
    });

    function doValidationForTempAMC() {
        if ($scope.desiredAMCTemp === "") {
            $scope.desiredAMCTemp = $scope.oldValueAMCTemp;
        }

        if ($scope.desiredAMCTemp > $scope.maxAMCTemp) {
            $scope.desiredAMCTemp = $scope.maxAMCTemp;
        }

        if ($scope.desiredAMCTemp < $scope.minAMCTemp) {
            $scope.desiredAMCTemp = $scope.minAMCTemp;
        }

        if (!($scope.desiredAMCTemp)) {
            $scope.desiredAMCTemp = $scope.minAMCTemp;
        }

        if (($scope.desiredAMCTemp) % 5 !== 0 && ($scope.desiredAMCTemp >= $scope.minAMCTemp) && ($scope.desiredAMCTemp <= $scope.maxAMCTemp)) {
            $scope.desiredAMCTemp = Math.ceil(parseInt($scope.desiredAMCTemp, 10) / 5) * 5;
        }
    }

    function onClickModeOptionAMC(recipeInfo) {
        $scope.AMCFnMenuVisible = false;
        setAMCScreenScrollable();
        $scope.myCookingRecipeDefaultContents[0].values[0] = recipeInfo;
        setAddMyCookingData();
    }

    function onRenameClick() {
        debugMessage("onRenameClick");
        showcustInputDialog(OVEN_ALERT_STATE.ALERT_RENAMERECIPE, $scope.translation.WEBMOB_common_rename, $scope.myCookingRecipeContents.RECIPE_NAME, $scope.translation.WEBMOB_common_cancel_no, $scope.translation.WEBMOB_common_ok_yes);
    }

    function closeApp() {
        debugMessage("closeApp");
        SHPService.sendSHPCommand(CONSTANTS.RUNONNATIVE, "closeWebApp", "");
    }

    function insertDataIntoFavoriteTable(newId, recipeMode, frecipeName, desiredAMCTemp, totalTime, recipeName, bFastPreheat, bOvenMeatProbe, bCrispy, vapourCurrentLevel, desiredMeatProbeTemp) {
        debugMessage("insertDataIntoFavoriteTable");
        var favoriteTableData = getLocalStorageData(OVENLOCALSTORAGE.FAVDB);
        if (favoriteTableData === null) {
            var dataToStore = [{'ID': newId, 'MODE': recipeMode, 'FAV_NAME': frecipeName, 'FAV_TEMP': desiredAMCTemp, 'FAV_TIME': totalTime, 'RECIPE_NAME': recipeName, 'FASTPREHEAT': bFastPreheat, 'MEATPROBE': bOvenMeatProbe, 'CRISPY': bCrispy, 'VAPOUR': vapourCurrentLevel, 'FAV_MEAT_TEMP': desiredMeatProbeTemp}];
            setLocalStorageData(OVENLOCALSTORAGE.FAVDB, JSON.stringify(dataToStore));
        } else {
            var newDataToStore = JSON.parse(getLocalStorageData(OVENLOCALSTORAGE.FAVDB));
            newDataToStore.push({'ID': newId, 'MODE': recipeMode, 'FAV_NAME': frecipeName, 'FAV_TEMP': desiredAMCTemp, 'FAV_TIME': totalTime, 'RECIPE_NAME': recipeName, 'FASTPREHEAT': bFastPreheat, 'MEATPROBE': bOvenMeatProbe, 'CRISPY': bCrispy, 'VAPOUR': vapourCurrentLevel, 'FAV_MEAT_TEMP': desiredMeatProbeTemp});
            setLocalStorageData(OVENLOCALSTORAGE.FAVDB, JSON.stringify(newDataToStore));
        }
    }

    function updateDataIntoFavoriteTable() {
        debugMessage("updateDataIntoFavoriteTable");
        var favoriteTableData = getLocalStorageData(OVENLOCALSTORAGE.FAVDB);
        if (favoriteTableData === null) {
            ;//NULL
        } else {
            var newDataToStore = JSON.parse(getLocalStorageData(OVENLOCALSTORAGE.FAVDB));
            for (var i = 0; i < newDataToStore.length; i++) {
                if (newDataToStore[i].RECIPE_NAME === $scope.myCookingRecipeContents.RECIPE_NAME) {
                    if ($scope.renamedRecipe) {
                        newDataToStore[i].RECIPE_NAME = $scope.renamedRecipe;
                        newDataToStore[i].FAV_NAME = $scope.renamedRecipe;
                    }
                    newDataToStore[i].MODE = $scope.myCookingRecipeDefaultContents[0].values[0][OVEN_MODE_TABLE.MODE];
                    newDataToStore[i].FAV_TEMP = $scope.desiredAMCTemp;
                    var hr = parseInt(document.getElementById("inputAMCHrs").value, 10);
                    var mn = parseInt(document.getElementById("inputAMCHMins").value, 10);
                    var totalTime = hr * 60 + mn;
                    newDataToStore[i].FAV_TIME = totalTime;
                    newDataToStore[i].FASTPREHEAT = $scope.bFastPreheat;
                    newDataToStore[i].MEATPROBE = $scope.bOvenMeatProbe;
                    newDataToStore[i].CRISPY = $scope.bCrispy;
                    newDataToStore[i].VAPOUR = $scope.vapourCurrentLevel;
                    newDataToStore[i].FAV_MEAT_TEMP = $scope.desiredMeatProbeTemp;
                }
            }
            setLocalStorageData(OVENLOCALSTORAGE.FAVDB, JSON.stringify(newDataToStore));
        }
    }

    function deleteDataFromFavoriteTable(recipeToDelete) {
        debugMessage("deleteDataFromFavoriteTable");
        var favoriteTableData = getLocalStorageData(OVENLOCALSTORAGE.FAVDB);
        if (favoriteTableData === null) {
            ;//NULL
        } else {
            var oldData = JSON.parse(getLocalStorageData(OVENLOCALSTORAGE.FAVDB));
            var newDataToStore = [];
            for (var i = 0; i < oldData.length; i++) {
                if (oldData[i].RECIPE_NAME === recipeToDelete) {
                    ;//NULL
                } else {
                    newDataToStore.push(oldData[i]);
                }
            }
            setLocalStorageData(OVENLOCALSTORAGE.FAVDB, JSON.stringify(newDataToStore));
        }
    }

    function updateNoOfVisit(currentMode) {
        debugMessage("updateNoOfVisit");
        var noOfVisitInfo = getLocalStorageData(OVENLOCALSTORAGE.NOOFVISIT);
        var dataToStore;
        if (noOfVisitInfo === null) {
            dataToStore = [{
                    mode: 'AutoCook',
                    value: 0,
                    time: 0
                }, {
                    mode: 'Conventional',
                    value: 0,
                    time: 0
                }, {
                    mode: 'Convection',
                    value: 0,
                    time: 0
                }, {
                    mode: 'EcoConvection',
                    value: 0,
                    time: 0
                }, {
                    mode: 'LargeGrill',
                    value: 0,
                    time: 0
                }, {
                    mode: 'EcoGrill',
                    value: 0,
                    time: 0
                }, {
                    mode: 'FanGrill',
                    value: 0,
                    time: 0
                }, {
                    mode: 'BottomHeatPluseConvection',
                    value: 0,
                    time: 0
                }, {
                    mode: 'TopHeatPluseConvection',
                    value: 0,
                    time: 0
                }, {
                    mode: 'BottomHeat',
                    value: 0,
                    time: 0
                }, {
                    mode: 'IntensiveCook',
                    value: 0,
                    time: 0
                }, {
                    mode: 'ProRoasting',
                    value: 0,
                    time: 0
                }, {
                    mode: 'AutoCook',
                    value: 0,
                    time: 0
                }, {
                    mode: 'KeepWarm',
                    value: 0,
                    time: 0
                }, {
                    mode: 'PlateWarm',
                    value: 0,
                    time: 0
                }, {
                    mode: 'Defrost',
                    value: 0,
                    time: 0
                }, {
                    mode: 'ProveDough',
                    value: 0,
                    time: 0
                }, {
                    mode: 'PizzaCook',
                    value: 0,
                    time: 0
                }, {
                    mode: 'SlowCook',
                    value: 0,
                    time: 0
                }, {
                    mode: 'Drying',
                    value: 0,
                    time: 0
                }, {
                    mode: 'VaporConvection',
                    value: 0,
                    time: 0
                }, {
                    mode: 'VaporTopHeatPluseConvection',
                    value: 0,
                    time: 0
                }, {
                    mode: 'VaporBottomHeatPluseConvection',
                    value: 0,
                    time: 0
                }, {
                    mode: 'CleanAirPyro',
                    value: 0,
                    time: 0
                }, {
                    mode: 'Descale',
                    value: 0,
                    time: 0
                }, {
                    mode: 'SteamClean',
                    value: 0,
                    time: 0
                }, {
                    mode: 'ChefRecipe',
                    value: 0,
                    time: 0
                }];

            for (var j = 0; j < dataToStore.length; j++) {
                if (dataToStore[j].mode === currentMode) {
                    break;
                }
            }
            dataToStore[j].value = 1;
            var newdate = new Date();
            dataToStore[j].time = newdate.getTime();
            setLocalStorageData(OVENLOCALSTORAGE.NOOFVISIT, JSON.stringify(dataToStore));
        } else {
            dataToStore = JSON.parse(getLocalStorageData(OVENLOCALSTORAGE.NOOFVISIT));

            for (var k = 0; k < dataToStore.length; k++) {
                if (dataToStore[k].mode === currentMode) {
                    break;
                }
            }
            var visitNo = parseInt(dataToStore[k].value, 10);
            dataToStore[k].value = visitNo + 1;
            var localnewdate = new Date();
            dataToStore[k].time = localnewdate.getTime();
            setLocalStorageData(OVENLOCALSTORAGE.NOOFVISIT, JSON.stringify(dataToStore));
        }
    }

    function setTimeorTempClickedFromRunningState() {
        debugMessage("setTimeorTempClickedFromRunningState");
        $scope.progressBarVisible = false;
        $scope.setTimenTempClicked = true;
        $scope.desiredMinutes = parseInt($scope.ovenDeviceInfo.Operation.remainingTime.split(":")[1], 10);
        $scope.desiredHours = parseInt($scope.ovenDeviceInfo.Operation.remainingTime.split(":")[0], 10);
    }

    // About page
    function onAboutAction(reqParam) {
        debugMessage("onAboutAction");
        if (reqParam === "smartcare") {
            showSmartCareStartNowScreen();
            return;
        } else if(reqParam === 'tutorial' || reqParam === 'manual' || reqParam === 'helpdesk') {
            if($scope.selectedCountry === "BE") {
                $scope.countryToSelect = [];
                $scope.countryToSelect.push({'Country': 'Belgium'});
                $scope.countryToSelect.push({'Country': 'Belgium(French)'});
                reqParamCountrySelection = reqParam;
                showcustCountrySelectionPopup();
            } else if($scope.selectedCountry === "CA") {
                $scope.countryToSelect = [];
                $scope.countryToSelect.push({'Country': 'Canada'});
                $scope.countryToSelect.push({'Country': 'Canada(French)'});
                reqParamCountrySelection = reqParam;
                showcustCountrySelectionPopup();
            } else if($scope.selectedCountry === "CH") {
                $scope.countryToSelect = [];
                $scope.countryToSelect.push({'Country': 'Switzerland'});
                $scope.countryToSelect.push({'Country': 'Switzerland(French)'});
                reqParamCountrySelection = reqParam;
                showcustCountrySelectionPopup();
            } else {
                if($scope.isStatic) {
                    $scope.selectedCountry = "BE";
                    showcustCountrySelectionPopup();
                    return;
                }
                nativeInterface.runOnNative("customerService", aboutCommand(reqParam));
            }
        } else {
            nativeInterface.runOnNative("customerService", aboutCommand(reqParam));
        }
    }
    
    function showcustCountrySelectionPopup() {
        $scope.countrySelectionPopupVisible = true;
        setAllScreenUnScrollable();
    }
    
    function closeCountrySelectionPopup(){
        closeAllPopUps();
    }

    function onCountrySelected (countryIndex) {
        $scope.countrySelectedIndex = countryIndex;
    }

    function onCountrySelectedOkClicked(isCountrySelected) {
        if(isCountrySelected && !$scope.isStatic) {
            if($scope.countrySelectedIndex === 0){
                nativeInterface.runOnNative("customerService", aboutCommand(reqParamCountrySelection));
            } else {
                nativeInterface.runOnNative("customerService", aboutCommand(reqParamCountrySelection, true));
            }
        }
        closeAllPopUps();
    }
    
    function aboutCommand(cmdstring, changedCode) {
        if(changedCode) {
            return '{"service" : "' + cmdstring + '","selectedCountry" : "' + $scope.selectedCountry + '_FR"}';
        } else {
            return '{"service" : "' + cmdstring + '","selectedCountry" : "' + $scope.selectedCountry + '"}';
        }
    }

    function showConnectionFailurePopup() {
        debugMessage("showConnectionFailurePopup");
        showcustDialog(OVEN_ALERT_STATE.ALERT_CONNECTION_ERROR, $scope.translation.WEBMOB_common_connection_failure, $scope.translation.WEBMOB_common_check_power_and_network, $scope.translation.WEBMOB_common_ok);
    }

    function closeConnectionFailurePopup() {
        debugMessage("closeConnectionFailurePopup");
        closeAllPopUps();
    }

    function connFailureAction() {
        debugMessage("connFailureAction");
        $scope.closeApp();
    }

    function commonRunningModeTypeHeader() {
        return $scope.currentScreen === OVENSCREENS.OVEN_COMMON_RUNNING_MODE_TYPE_CONTAINER;
    }

    function closeAllPopUps() {
        debugMessage("closeAllPopUps");
        setAllScreenScrollable();
        $scope.alertOn = false;
        $scope.popUpVisible = false;
        $scope.inputPopUpVisible = false;
        $scope.vaporPopUpVisible = false;
        $scope.countrySelectionPopupVisible = false;
    }

    function getsendAutoCookRecipeCommand(recipeInfo) {
        return '{"Device" : { "Mode" : { "modes" : ["Autocook"] }, "Oven" : { "recipe" : "' + recipeInfo + '" } }}';
    }

    function getsendChefRecipeCommand(recipeId, recipeName, recipeDetails) {
        return '{"CustomRecipe" : {"id" : "0", "name" : "' + recipeName + '", "recipe" : "' + recipeId + '||' + recipeName + '||' + recipeDetails + '"}}';
    }

    function getsendRecipeCommandwithMeatProbe(currentMode, modeOptionsString, steamLevel, recipeTemperature, meatProbeTemperature) {
        return '{"Device" : {"Mode" : {"modes" : ["' + currentMode + '"],"options" : ["' + modeOptionsString + '"]},"Operation" : {"operationTime" : "00:00:00" }, "Oven" : { "steamLevel" : "' + steamLevel + '" }, "Temperatures" : [{ "id" : "' + recipeTemperature.id + '", "current" : ' + recipeTemperature.current + ', "desired" : ' + recipeTemperature.desired + ', "maximum" : ' + recipeTemperature.maximum + ', "minimum" : ' + recipeTemperature.minimum + ',"unit" : "Celsius" }, { "id" : "' + meatProbeTemperature.id + '", "current" : ' + meatProbeTemperature.current + ', "desired" : ' + meatProbeTemperature.desired + ', "maximum" : ' + meatProbeTemperature.maximum + ', "minimum" : ' + meatProbeTemperature.minimum + ',"unit" : "Celsius" }]}}';
    }

    function getsendRecipeCommandwithoutMeatProbe(currentMode, modeOptionsString, operationTime, steamLevel, recipeTemperature) {
        return '{"Device" : {"Mode" : {"modes" : ["' + currentMode + '"],"options" : ["' + modeOptionsString + '"]},"Operation" : {"operationTime" : "' + operationTime + '" }, "Oven" : { "steamLevel" : "' + steamLevel + '" }, "Temperatures" : [{ "id" : "' + recipeTemperature.id + '", "current" : ' + recipeTemperature.current + ', "desired" : ' + recipeTemperature.desired + ', "maximum" : ' + recipeTemperature.maximum + ', "minimum" : ' + recipeTemperature.minimum + ',"unit" : "Celsius" }]}}';
    }

    function getSendSnoozeCommand(operationTime) {
        return '{"Device" : {"Operation" : {"operationTime" : "' + operationTime + '"}}}';
    }

    function getSendRunningPropertyChangeCommand(crispOption, fastPreheatOption, vapourLevelOption) {

        var desiredtemp = 0, desiredmeatprobetemp = 0, desiredhour = 0, desiredmin = 0, operationTime = '', finalString = '',
                ModeOptionString, modeOptionsTxt = '', OperationoperationTimeString = '', OvensupportedPowerLevelsString = '', tempDesiredString = '';

        if ($scope.setTimenTempClicked && $scope.bOvenMeatProbe) {
            desiredtemp = document.getElementById("inputTempWithoutMeatProbe").value;
            desiredmeatprobetemp = document.getElementById("inputTempMeatProbe").value;
        } else if ($scope.setTimenTempClicked && !$scope.bOvenMeatProbe) {
            desiredtemp = document.getElementById("inputTempWithoutMeatProbe").value;
            desiredhour = parseInt(document.getElementById("inputAMCHrs").value, 10);
            desiredmin = parseInt(document.getElementById("inputAMCHMins").value, 10);
            var newdate = new Date();
            newdate.setHours(desiredhour, desiredmin, 0);
            var hour = newdate.getHours();
            if (hour.toString().length === 1) {
                hour = "0" + hour;
            }
            var minute = newdate.getMinutes();
            if (minute.toString().length === 1) {
                minute = "0" + minute;
            }

            operationTime = hour + ":" + minute + ":00";
        } else {
            ;//NULL
        }


        if (crispOption !== null) {
            if (crispOption === true) {
                modeOptionsTxt = 'crispy_on';
            } else {
                modeOptionsTxt = 'crispy_off';
            }

            if (fastPreheatOption !== null) {
                if (fastPreheatOption === true) {
                    modeOptionsTxt += '","fastpreheat_on';
                } else {
                    modeOptionsTxt += '","fastpreheat_off';
                }
            }
        } else if (crispOption === null) {
            if (fastPreheatOption === true) {
                modeOptionsTxt = 'fastpreheat_on';
            } else {
                modeOptionsTxt = 'fastpreheat_off';
            }
        } else {
            ;//NULL
        }

        if (fastPreheatOption === null && crispOption === null) {
            ModeOptionString = "";
        } else {
            ModeOptionString = '"Mode" : {"options" : ["' + modeOptionsTxt + '"]},';
        }
        if ($scope.setTimenTempClicked && !$scope.bOvenMeatProbe) {
            OperationoperationTimeString = '"Operation" : {"operationTime" : "' + operationTime + '"},';
        }

        if (vapourLevelOption !== null) {
            OvensupportedPowerLevelsString = '"Oven" : {"supportedPowerLevels" : ["' + vapourLevelOption + '"]},';
        }

        if ($scope.setTimenTempClicked && !$scope.bOvenMeatProbe) {
            tempDesiredString = '"Temperatures" : [{"id" : "0","current" : ' + $scope.currentTemp + ',"desired" : ' + desiredtemp + ',"maximum" : ' + $scope.maxTemp + ',"minimum" : ' + $scope.minTemp + ',"unit" : "Celsius"}]';
        }

        if ($scope.setTimenTempClicked && $scope.bOvenMeatProbe) {
            tempDesiredString = '"Temperatures" : [{"id" : "0","current" : ' + $scope.currentTemp + ',"desired" : ' + desiredtemp + ',"maximum" : ' + $scope.maxTemp + ',"minimum" : ' + $scope.minTemp + ',"unit" : "Celsius"}, {"id" : "1","current" : ' + $scope.currentMeatProbeTemp + ',"desired" : ' + desiredmeatprobetemp + ',"maximum" : ' + $scope.maxMeatProbeTemp + ',"minimum" : ' + $scope.minMeatProbeTemp + ',"unit" : "Celsius"}]';
        }

        finalString = '{"Device" : {' + ModeOptionString + OperationoperationTimeString + OvensupportedPowerLevelsString + tempDesiredString + '}}';
        return finalString;
    }

    function getCancelCommand() {
        return '{"Operation" : {"state" : "Pause"}}';
    }

    function initSwipe() {
        debugMessage("initSwipe");
        var elem = document.getElementById('mySwipe'),
                mySwipeWrap,
                cnt,
                len,
                counter = $scope.chefRecipeAry.length;
        window.mySwipe = Swipe(elem, {
            continuous: true,
            disableScroll: false,
            stopPropagation: false,
        });
        mySwipeWrap = document.getElementById('mySwipe-wrap');
        len = mySwipeWrap.childNodes.length;
        for (cnt = 0; cnt < len; ++cnt) {
            if (!!mySwipeWrap.childNodes[cnt].className && mySwipeWrap.childNodes[cnt].className === "recipeSummary ng-scope") {
                if (counter <= 0) {
                    mySwipeWrap.removeChild(mySwipeWrap.childNodes[cnt]);
                    --cnt;
                    --len;
                } else {
                    --counter;
                }
            }
        }
        mySwipeWrap.style.width = screen.width * $scope.chefRecipeAry.length;
    }

    function onClickTab(tab) {
        debugMessage("onClickTab");
        $scope.currentTab = tab;
        $scope.chefRecipeDetailsTabHeader = $scope.ovenTabs[tab - 1];
        $scope.tabValue = tab;
    }

    function autoCookIcon(value) {
        switch (value) {
            case 0:
                return "images/oven/main_ov_ac_list_ic_pizza.svg#Layer_1";
            case 1:
                return "images/oven/main_ov_ac_list_ic_bake.svg#Layer_1";
            case 2:
                return "images/oven/main_ov_ac_list_ic_pie.svg#Layer_1";
            case 3:
                return "images/oven/main_ov_ac_list_ic_bread.svg#Layer_1";
            case 4:
                return "images/oven/main_ov_ac_list_ic_cake.svg#Layer_1";
            case 5:
                return "images/oven/main_ov_ac_list_ic_meat.svg#Layer_1";
            default:
                return "images/oven/main_ov_ac_list_ic_pizza.svg#Layer_1";
        }
    }

    function specialFunctionIcon(value) {

        switch (value)
        {
            case 0 :
                return "images/oven/main_ov_list_ic_keep_warm.svg#Layer_1";
            case 1 :
                return "images/oven/main_ov_list_ic_plate_warm.svg#Layer_1";
            case 2 :
                return "images/oven/main_ov_list_ic_defrost.svg#Layer_1";
            case 3 :
                return "images/oven/main_ov_list_ic_prove_dough.svg#Layer_1";
            case 4 :
                return "images/oven/main_ov_list_ic_pizza_cook.svg#Layer_1";
            case 5 :
                return "images/oven/main_ov_list_ic_slow_cook.svg#Layer_1";
            case 6 :
                return "images/oven/main_ov_list_ic_drying.svg#Layer_1";
            default:
                return "images/oven/main_ov_list_ic_keep_warm.svg#Layer_1";
        }
    }

    function ovenFunctionIcon(value) {

        switch (value) {
            case 0 :
                return "images/oven/main_ov_list_ic_conventional.svg#Layer_1";
            case 1 :
                return "images/oven/main_ov_list_ic_convection.svg#Layer_1";
            case 2 :
                return "images/oven/main_ov_list_ic_eco_convection.svg#Layer_1";
            case 3 :
                return "images/oven/main_ov_list_ic_large_grill.svg#Layer_1";
            case 4 :
                return "images/oven/main_ov_list_ic_eco_grill.svg#Layer_1";
            case 5 :
                return "images/oven/main_ov_list_ic_fan_grill.svg#Layer_1";
            case 6 :
                return "images/oven/main_ov_list_ic_bottom_heat_convection.svg#Layer_1";
            case 7 :
                return "images/oven/main_ov_list_ic_top_heat_convection.svg#Layer_1";
            case 8 :
                return "images/oven/main_ov_list_ic_bottom_heat.svg#Layer_1";
            case 9 :
                return "images/oven/main_ov_list_ic_intensive_cooking.svg#Layer_1";
            case 10 :
                return "images/oven/main_ov_list_ic_pro_roasting.svg#Layer_1";
            case 11 :
                return "images/oven/main_ov_list_ic_vapour_covection.svg#Layer_1";
            case 12 :
                return "images/oven/main_ov_list_ic_vapour_topheat_convection.svg#Layer_1";
            case 13 :
                return "images/oven/main_ov_list_ic_vapour_bottomheat_convection.svg#Layer_1";
            default:
                return "images/oven/main_ov_list_ic_conventional.svg#Layer_1";
        }
    }

    function FunctionForSVG(mode) {
        if (mode === 'Conventional' || mode === 0) {
            return "images/oven/main_ov_list_ic_conventional.svg#Layer_1";
        } else if (mode === 'Convection' || mode === 1) {
            return "images/oven/main_ov_list_ic_convection.svg#Layer_1";
        } else if (mode === 'EcoConvection' || mode === 2) {
            return "images/oven/main_ov_list_ic_eco_convection.svg#Layer_1";
        } else if (mode === 'LargeGrill' || mode === 3) {
            return "images/oven/main_ov_list_ic_large_grill.svg#Layer_1";
        } else if (mode === 'EcoGrill' || mode === 4) {
            return "images/oven/main_ov_list_ic_eco_grill.svg#Layer_1";
        } else if (mode === 'FanGrill' || mode === 5) {
            return "images/oven/main_ov_list_ic_fan_grill.svg#Layer_1";
        } else if (mode === 'BottomHeatPluseConvection' || mode === 6) {
            return "images/oven/main_ov_list_ic_bottom_heat_convection.svg#Layer_1";
        } else if (mode === 'TopHeatPluseConvection' || mode === 7) {
            return "images/oven/main_ov_list_ic_top_heat_convection.svg#Layer_1";
        } else if (mode === 'BottomHeat' || mode === 8) {
            return "images/oven/main_ov_list_ic_bottom_heat.svg#Layer_1";
        } else if (mode === 'IntensiveCook' || mode === 9) {
            return "images/oven/main_ov_list_ic_intensive_cooking.svg#Layer_1";
        } else if (mode === 'ProRoasting' || mode === 10) {
            return "images/oven/main_ov_list_ic_pro_roasting.svg#Layer_1";
        } else if (mode === 'VaporConvection' || mode === 11) {
            return "images/oven/main_ov_list_ic_vapour_covection.svg#Layer_1";
        } else if (mode === 'VaporTopHeatPluseConvection' || mode === 12) {
            return "images/oven/main_ov_list_ic_vapour_topheat_convection.svg#Layer_1";
        } else if (mode === 'VaporBottomHeatPluseConvection' || mode === 13) {
            return "images/oven/main_ov_list_ic_vapour_bottomheat_convection.svg#Layer_1";
        } else if (mode === 'EDIT_MY_COOKING') {
            return "images/oven/main_ov_list_ic_edit_my_cooking.svg#Layer_1";
        } else if (mode === 'delete') {
            return "images/oven/main_ov_list_ic_delete.svg#Layer_1";
        } else if (mode === 'add') {
            return "images/oven/main_ov_list_ic_add_my_cooking.svg#Layer_1";
        } else {
            return "images/oven/main_ov_list_ic_add_my_cooking.svg#Layer_1";
        }
    }

    function validateRecipeName(newRecipeName) {
        debugMessage("validateRecipeName");
        if (newRecipeName !== undefined && newRecipeName.trim() === '') {
            $timeout(ShowBlankNameToast, 500);
            return false;
        }
        if ($scope.myCookingContentsLocalStorage === null) {
            return true;
        }
        for (var i = 0; i < $scope.myCookingContentsLocalStorage.length; i++) {
            if ($scope.myCookingListItems[i].title.trim() === newRecipeName.trim()) {
                $timeout(ShowDuplicateNameToast, 500);
                return false;
            }
        }
        return true;
    }

    function ShowBlankNameToast() {
        debugMessage("ShowBlankNameToast");
        toaster.success({title: "", body: $scope.translation.WEBMOB_common_duplicate_name});
    }

    function ShowDuplicateNameToast() {
        debugMessage("ShowDuplicateNameToast");
        toaster.success({title: "", body: $scope.translation.WEBMOB_common_duplicate_name});
    }

    function getMyCookingRecipeName() {
        debugMessage("getMyCookingRecipeName");
        var defaultRecipeName = 'MyCooking', j = 1;
        if ($scope.myCookingContentsLocalStorage === null) {
            return defaultRecipeName + '1';
        }
        while (true) {
            var uniqueNameFound = true;
            defaultRecipeName = 'MyCooking' + j;
            for (var i = 0; i < $scope.myCookingContentsLocalStorage.length; i++) {
                if ($scope.myCookingListItems[i].title.trim() === (defaultRecipeName).trim()) {
                    uniqueNameFound = false;
                    break;
                }
            }
            if (uniqueNameFound) {
                break;
            }
            j++;
        }

        return defaultRecipeName;
    }

    function dismissLoadingBar(value) {
        if ($scope.checkResponse.indexOf(value) !== -1) {
            $scope.checkResponse.splice($scope.checkResponse.indexOf(value), 1);
            if ($scope.checkResponse.length === 0) {
                $scope.loadingBar = false;
            }
        }
    }

    function versionTouchStart() {
        debugMessage("versionTouchStart");
        if (!versionTouch) {
            versionTouch = $timeout(function () {
                if (!$scope.isStatic) {
                    $scope.checkResponse.push(OVEN_COMMANDS.showModuleVersion);
                    SHPService.sendSHPCommand(CONSTANTS.GET, "/" + $scope.peerId + "/devices/0/information");
                } else {
                    showcustDialog(OVEN_ALERT_STATE.ALERT_DEVELOPER_INFO, $scope.translation.WEBMOB_common_version_info, "$scope.moduleInfoText", $scope.translation.WEBMOB_common_ok);
                }
            }, 5000);
        }
    }

    function versionTouchEnd() {
        debugMessage("versionTouchEnd");
        if (versionTouch) {
            $timeout.cancel(versionTouch);
            versionTouch = null;
        }
    }

    function parseModuleInformation(moduleInfo) {
        debugMessage("parseModuleInformation");
        if (angular.isDefined(moduleInfo.Versions) && moduleInfo.Versions.length > 0) {
            $scope.moduleInfoText = "Software Ver : " + moduleInfo.Versions[0].number + " <br> Firmware Ver : " + moduleInfo.Versions[1].number;
            dismissLoadingBar(OVEN_COMMANDS.showModuleVersion);
            showcustDialog(OVEN_ALERT_STATE.ALERT_DEVELOPER_INFO, $scope.translation.WEBMOB_common_version_info, $scope.moduleInfoText, $scope.translation.WEBMOB_common_ok);
        }
    }

    function setReadyStateScreenScrollable() {
        debugMessage("setReadyStateScreenScrollable");
        document.getElementById("readyStateScreen").style.overflowY = "overlay";
    }

    function setReadyStateScreenUnScrollable() {
        debugMessage("setReadyStateScreenUnScrollable");
        document.getElementById("readyStateScreen").style.overflowY = "hidden";
    }

    function setAMCScreenScrollable() {
        debugMessage("setAMCScreenScrollable");
        document.getElementById("AMCScreen").style.overflowY = "overlay";
    }

    function setAMCScreenUnScrollable() {
        debugMessage("setAMCScreenUnScrollable");
        document.getElementById("AMCScreen").style.overflowY = "hidden";
    }

    function setAllScreenScrollable() {
        setReadyStateScreenScrollable();
        setAMCScreenScrollable();
    }

    function setAllScreenUnScrollable() {
        setReadyStateScreenUnScrollable();
        setAMCScreenUnScrollable();
    }

    function smartcareerrorcheck() {
        if (!$scope.isStatic) {
            $scope.checkResponse.push(OVEN_COMMANDS.smartCareDiagnosis);
            debugMessage("Send command for smartCareDiagnosis " + getDiagnosisCommand());
            SHPService.sendSHPCommand(CONSTANTS.PUT, getDiagnosisCommand(), "/" + $scope.peerId + "/devices/0/diagnosis");
        } else {
            showSmartCareStartNowNoErrorScreen();
        }
    }

    function getDiagnosisCommand() {
        return '{"Diagnosis": {"diagnosisStart": "Run"}}';
    }

    function addRipple() {
        debugMessage("addRipple");
    }

});