/* 
 * walloven.js
 * 
 * Copyright ( c ) 2016 by Samsung Electronics, Inc.,
 *
 * This software is the confidential and proprietary information
 * of Samsung Electronics, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Samsung.
 *
 * Created on : Wed Apr 24 11:12:54 KST 2016
 * Owner      : SRI
 * Author     : namit.bansal@samsung.com
 */

var app = angular.module("SmartThings", ['toaster', 'ngSanitize', 'ui.router']);

app.config(['$stateProvider', function ($stateProvider) {
        var MainLoadingPage = {
            name: 'MainLoadingPage',
            url: '/',
            templateUrl: 'MainLoadingScreen.html'
        },
        ReadyDetailPage = {
            name: 'ReadyDetailPage',
            url: '/',
            templateUrl: 'ReadyDetailScreen.html'
        },
        RunDetailPage = {
            name: 'RunDetailPage',
            url: '/',
            templateUrl: 'RunDetailScreen.html'
        },
        DividerConnectedPage = {
            name: 'DividerConnectedPage',
            url: '/',
            templateUrl: 'DividerConnectedScreen.html'
        },
        FlexConnectedPage = {
            name: 'FlexConnectedPage',
            url: '/',
            templateUrl: 'FlexConnectedScreen.html'
//            templateUrl: 'views/HomePageScreen.html'
        },
        SmartControlPage = {
            name: 'SmartControlPage',
            url: '/',
            templateUrl: 'SmartControlScreen.html'
        },
        AutoCookPage = {
            name: 'AutoCookPage',
            url: '/',
            templateUrl: 'AutoCookScreen.html'
        },
        AutoCookDetailPage = {
            name: 'AutoCookDetailPage',
            url: '/',
            templateUrl: 'AutoCookDetailScreen.html'
        },
        MyFavoritePage = {
            name: 'MyFavoritePage',
            url: '/',
            templateUrl: 'MyFavoriteScreen.html'
        },
        EditMyFavoriteDetailPage = {
            name: 'EditMyFavoriteDetailPage',
            url: '/',
            templateUrl: 'EditMyFavoriteDetailScreen.html'
        },
        MyFavoriteRecipeDetailPage = {
            name: 'MyFavoriteRecipeDetailPage',
            url: '/',
            templateUrl: 'MyFavoriteRecipeDetailScreen.html'
        },
        SendConfirmationPage = {
            name: 'SendConfirmationPage',
            url: '/',
            templateUrl: 'SendConfirmationScreen.html'
        },
        OperationCompletePage = {
            name: 'OperationCompletePage',
            url: '/',
            templateUrl: 'OperationCompleteScreen.html'
        },
        ErrorPage = {
            name: 'ErrorPage',
            url: '/',
            templateUrl: 'ErrorScreen.html'
        },
        SettingPage = {
            name: 'SettingPage',
            url: '/',
            templateUrl: 'SettingScreen.html'
        },
        SettingTempAdjustPage = {
            name: 'SettingTempAdjustPage',
            url: '/',
            templateUrl: 'SettingTempAdjustScreen.html'
        },
        SettingTempUnitPage = {
            name: 'SettingTempUnitPage',
            url: '/',
            templateUrl: 'SettingTempUnitScreen.html'
        },
        AboutPage = {
            name: 'AboutPage',
            url: '/',
            templateUrl: 'AboutScreen.html'
        },
        EditRunningPage = {
            name: 'EditRunningPage',
            url: '/',
            templateUrl: 'EditRunningScreen.html'
        },
        SmartCarePage = {
            name: 'SmartCarePage',
            url: '/',
            templateUrl: 'SmartCareScreen.html'
        },
        SmartCareNoErrorPage = {
            name: 'SmartCareNoErrorPage',
            url: '/',
            templateUrl: 'SmartCareNoErrorScreen.html'
        };

        $stateProvider.state(MainLoadingPage);
        $stateProvider.state(ReadyDetailPage);
        $stateProvider.state(RunDetailPage);
        $stateProvider.state(DividerConnectedPage);
        $stateProvider.state(FlexConnectedPage);
        $stateProvider.state(MyFavoritePage);
        $stateProvider.state(EditMyFavoriteDetailPage);
        $stateProvider.state(MyFavoriteRecipeDetailPage);
        $stateProvider.state(SmartControlPage);
        $stateProvider.state(AutoCookPage);
        $stateProvider.state(AutoCookDetailPage);
        $stateProvider.state(SendConfirmationPage);
        $stateProvider.state(OperationCompletePage);
        $stateProvider.state(ErrorPage);
        $stateProvider.state(SettingPage);
        $stateProvider.state(AboutPage);
        $stateProvider.state(SettingTempAdjustPage);
        $stateProvider.state(SettingTempUnitPage);
        $stateProvider.state(EditRunningPage);
        $stateProvider.state(SmartCarePage);
        $stateProvider.state(SmartCareNoErrorPage);
    }]);

app.run(['$state', function ($state) {
        $state.transitionTo('MainLoadingPage');
    }]);

app.controller('wallOvenAppController', ['$scope', '$state', 'SHPService', 'toaster', '$timeout', 'DBService', '$interval', wallOvenAppController]);

function wallOvenAppController($scope, $state, SHPService, toaster, $timeout, DBService, $interval) {

    var langArr = Object.keys(LANGUAGE_FILE.language), Debug_tag = 'WO : ', justFirstTime = true, WALLOVEN_LONGPRESS = 150, selectedCavity = '', promise, promiseAbout = null, configuration = true, updateZeroProgress = false, updateOneProgress = false, updateTwoProgress = false,
            wOvenSingleBaseMode = "Bake", wOvenDualUpperBaseMode = "ConvectionBake", wOvenDualLowerBaseMode = "Bake", wOvenDualFlexUpperBaseMode = "ConvectionBake", wOvenDualFlexLowerBaseMode = "Bake", deviceID = 0, AutocookSendId = 0,
            wOvenLowerFlexBaseMode = "Bake", userPreferneceSingle = {}, userPreferneceDualUpper = {}, userPreferneceDualLower = {}, userPreferneceDualFlexUpper = {}, userPreferneceDualFlexLower = {}, editTemp, editHr, editMin, editProbeTemp,
            recipeDataValidateSingle = false, recipeDataValidateDualUpper = false, recipeDataValidateDualLower = false, recipeDataValidateDualFlexUpper = false, recipeDataValidateDualFlexLower = false, recipeDataValidateLowerFlex = false,
            snoozIdZero = false, snoozIdOne = false, snoozIdTwo = false, errorRemoved = true, changeSmartCarePage = false, doNotChangeScreen = false, promise1, promise2, promise3, configTimer = null, Sec20Call = 20000,
            scroll_middle_area = document.getElementById("scrollable_area_others");

    var WALLOVEN_LOCALSTORAGE = {
        FAVDB: "WALLOVEN_FAV_DB"
    },
    WALLOVEN_SCREENS = {
        WALLOVEN_MAIN_LOADING_PAGE: 1,
        WALLOVEN_READY_DETAIL_PAGE: 2,
        WALLOVEN_RUN_DETAIL_PAGE: 3,
        WALLOVEN_DIVIDER_CONNECTED_PAGE: 4,
        WALLOVEN_FLEX_CONNECTED_PAGE: 5,
        WALLOVEN_MY_FAVORITE_PAGE: 6,
        WALLOVEN_SMART_CONTROL_PAGE: 7,
        WALLOVEN_AUTOCOOK_SCREEN: 8,
        WALLOVEN_AUTOCOOK_DETAIL_SCREEN: 9,
        WALLOVEN_SEND_CONFIRMATION_SCREEN: 10,
        WALLOVEN_OPERATION_COMPLETE_PAGE: 11,
        WALLOVEN_ERROR_PAGE: 12,
        WALLOVEN_SETTING_PAGE: 13,
        WALLOVEN_ABOUT_PAGE: 14,
        WALLOVEN_SETTING_TEMP_ADJUDT_PAGE: 15,
        WALLOVEN_SETTING_TEMP_UNIT_PAGE: 16,
        WALLOVEN_SMART_CARE_PAGE: 17,
        WALLOVEN_EDIT_RUNNING_COOKING: 18,
        WALLOVEN_EDIT_MY_FAVORITE_DETAIL_PAGE: 19,
        WALLOVEN_MY_FAVORITE_RECIPE_DETAIL_PAGE: 20,
        WALLOVEN_SMART_CARE_NO_ERROR_PAGE: 21,
        RANGE_PROBE_DIVIDER_ERROR_PAGE: 50
    },
    WALLOVEN_COMMANDS = {
        "getDevices": "getDevices",
        "runOnNative": "runOnNative",
        "SettingOptions": "SettingOptions",
        "sendRecipetoOven": "sendRecipetoOven",
        "cancelCooking": "cancelCooking",
        "snoozeCookingTime": "snoozeCookingTime",
        "changeTempUnit": "changeTempUnit",
        "startCooking": "startCooking",
        "showModuleVersion": "showModuleVersion",
        "smartCareDiagnosis": "smartCareDiagnosis",
        "runingCookingEdit": "runingCookingEdit"
    },
    WALLOVEN_ALERT_STATE = {
        ALERT_NONE: 0,
        ALERT_START_COOKING: 1,
        ALERT_CANCEL_COOKING: 2,
        ALERT_CONNECTION_ERROR: 3,
        ALERT_CHILD_LOCK: 4,
        ALERT_PREHEATCOMPLETE: 5,
        ALERT_COOKING_SNOOZE: 6,
        ALERT_SABBATH_MODE: 7,
        ALERT_SMARTMONITOR_GUIDE: 13,
        ALERT_AUTOCOOK_INFO: 14,
        ALERT_DELETE_MY_COOKING: 15,
        ALERT_DEVELOPER_INFO: 16,
        ALERT_SERVICE_CALL: 17,
        ALERT_AUTO_COOK_PROBE: 18,
        ALERT_START_ATUOCOOK_COOKING: 19,
        ALERT_UNSUPPORTED_PROBE_RECIPE: 20,
        ALERT_START_MF_COOKING: 21,
        ALERT_DOOR_OPEN: 22,
        ALERT_DESCALE_FAIL: 23,
        ALERT_GOURMET_RECIPE_ALARM_81_82: 24,
        ALERT_GOURMET_RECIPE_ALARM_83: 25
    };

    if (langArr.indexOf(LANG.toUpperCase()) !== -1) {
        $scope.translation = LANGUAGE_FILE["language"][LANG.toUpperCase()];
    } else if (langArr.indexOf(LANG.toUpperCase().substring(0, 2)) !== -1) {
        $scope.translation = LANGUAGE_FILE["language"][LANG.toUpperCase().substring(0, 2)];
    } else {
        $scope.translation = LANGUAGE_FILE["language"]["DEFAULT"];
    }

    $scope.isSpanishLanguage = LANG.toUpperCase().substring(0, 2) === "ES";
    $scope.isFrenchLanguage = LANG.toUpperCase().substring(0, 2) === "FR";
    $scope.switchON = 'I';
    $scope.switchOff = 'O';
    if (LANG.toUpperCase().indexOf('EN') !== -1) {
        $scope.switchON = 'ON';
        $scope.switchOff = 'OFF';
    }

    loadVariables();

    DBService.readDB('src/db/smartoven_recipe_wo.db').then(function (data) {
        $scope.WALLOVEN_TABEL = data.exec("SELECT * FROM WALLOVEN_TABLE");
        //debugMessage("inside readDB " + JSON.stringify($scope.WALLOVEN_TABEL ));
        $scope.WALLOVEN_TABEL = $scope.WALLOVEN_TABEL[0].values;
        initializeScreenDB();
    });

    function getTypeContent(type, index, value) {
        var row = [], length = $scope.WALLOVEN_TABEL.length;
        for (var i = 0; i < length; i++) {
            if ($scope.WALLOVEN_TABEL[i][3] === type) {
                if ($scope.WALLOVEN_TABEL[i][index] === value) {
                    row.push($scope.WALLOVEN_TABEL[i]);
                }
            }
        }
        return row;
    }

    function getSupportedContent(index, value) {
        var row = [], length = $scope.WALLOVEN_TABEL.length;
        for (var i = 0; i < length; i++) {
            if ($scope.WALLOVEN_TABEL[i][index] === value) {
                row.push($scope.WALLOVEN_TABEL[i]);
            }
        }
        return row;
    }

    function isTextInput(node) {
        return ['INPUT', 'TEXTAREA'].indexOf(node.nodeName) !== -1;
    }

    document.addEventListener('touchstart', function (e) {
        if (!isTextInput(e.target) && isTextInput(document.activeElement)) {
            document.activeElement.blur();
            e.preventDefault();
            e.stopPropagation();
        }
    }, false);

    function loadVariables() {
        $scope.isStatic = false;
        $scope.isAppV2 = false;
        $scope.DoorOpen = false;
        $scope.MFFocused = false;
        $scope.loadingBar = false;
        $scope.bNoPreheat = false;
        $scope.multiselect = false;
        $scope.enableSabbath = true;
        $scope.showSmartCare = false;
        $scope.drainRequired = false;
        $scope.steamRoastPopup = false;
        $scope.headerBarVisible = false;
        $scope.wallOvenModeMenu = false;
        $scope.deviceModeSupport = false;
        $scope.samrtControlPopup = false;
        $scope.mainLoadingScreen = false;
        $scope.moreOptionVisible = false;
        $scope.meatProbeConnected = false;
        $scope.AMCSaveButtonEnable = true;
        $scope.keepWarmReservation = false;
        $scope.nextPageAutoCookDetail = true;
        $scope.previousPageAutoCookDetail = false;

        $scope.checkResponse = [];
        $scope.editMyCookingSelectedDeleteItems = [];

        $scope.minTemp = 175;
        $scope.maxTemp = 550;
        $scope.descaleStep = 3;
        $scope.desiredHours = 0;
        $scope.currentTemp = 325;
        $scope.desiredTemp = 350;
        $scope.TempIncrement = 1;
        $scope.minProbeTemp = 100;
        $scope.maxProbeTemp = 200;
        $scope.parseNotiLength = 0;
        $scope.wOvenCurrentTab = 0;
        $scope.steamRoastLevel = 2; // Default value is Medium
        $scope.desiredMinutes = 30;
        $scope.autoCookRecipeId = 0;
        $scope.currentProbeTemp = 100;
        $scope.desiredProbeTemp = 150;
        $scope.progressBarPercentage = 60;

        $scope.TempUnit = 'F';
        $scope.errorCode = "";
        $scope.smartControl = 'ON';
        $scope.timeLeft = '1:05 PM';
        $scope.selectAllText = $scope.translation.WEBMOB_device_walloven_selected;
        $scope.operationTime = '01:30:00';
        $scope.remainingTime = '01:30:00';
        $scope.validateSendRecipeInfoMode = 'Bake';
        $scope.validateSendRecipeInfoOperationHrs = '0';
        $scope.validateSendRecipeInfoDesiredTemp = '350';
        $scope.validateSendRecipeInfoOperationMints = '30';
        $scope.validateSendRecipeInfoDesiredProbeTemp = '150';
        $scope.ProgressDescription = "WEBMOB_device_range_cooking_in_progress";
        $scope.currentMode = 'WEBMOB_device_range_oven_function_convection_bake';
        $scope.currentRunningMode = 'WEBMOB_device_range_oven_function_convection_bake';
        $scope.recipeDescription = 'WEBMOB_device_range_oven_function_convection_bake_desc';
        $scope.dividerScreenUpperMode = 'WEBMOB_device_range_oven_function_convection_bake';
        $scope.dividerScreenLowerMode = 'WEBMOB_device_range_oven_function_convection_bake';

        $scope.DisplayContents = ["WALLOVEN_09", "FALSE", 'WEBMOB_device_range_oven_function_convection_bake_desc', 'BASIC', "ConvectionBake", "WEBMOB_device_range_oven_function_convection_bake", "YES", "YES", "YES", "YES", "YES", "YES", "YES", 325, 175, 550, 175, 80, 285, 30, 1, 599];
        $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_MAIN_LOADING_PAGE;

        $scope.init = init;
        $scope.closeApp = closeApp;
        $scope.onBackPressed = onBackPressed;
        $scope.parseStaticData = parseStaticData;
        $scope.parseDeviceData = parseDeviceData;
        $scope.handleStatusCode = handleStatusCode;
        $scope.updateDeviceData = updateDeviceData;
        $scope.onBackPressedEvent = onBackPressedEvent;
        $scope.parseConfiguration = parseConfiguration;
        $scope.requestFailHandler = requestFailHandler;
        $scope.parseNotificationData = parseNotificationData;
        $scope.parseModuleInformation = parseModuleInformation;
        $scope.showConnectionFailurePopup = showConnectionFailurePopup;
        $scope.closeConnectionFailurePopup = closeConnectionFailurePopup;

        $scope.goToAbout = goToAbout;
        $scope.openMFMenu = openMFMenu;
        $scope.runEditMode = runEditMode;
        $scope.keyPadScroll = keyPadScroll;
        $scope.saveButtonMF = saveButtonMF;
        $scope.monitorClick = monitorClick;
        $scope.inputKeyDown = inputKeyDown;
        $scope.openModeMenu = openModeMenu;
        $scope.hideModeMenu = hideModeMenu;
        $scope.menuTabClick = menuTabClick;
        $scope.addMFCooking = addMFCooking;
        $scope.goToSettings = goToSettings;
        $scope.getMyFavTime = getMyFavTime;
        $scope.editMFCooking = editMFCooking;
        $scope.onAboutAction = onAboutAction;
        $scope.applyEditMode = applyEditMode;
        $scope.myFavListItem = myFavListItem;
        $scope.blurScreen = hideInputBoxFocus;
        $scope.showDummyInbox = showDummyInbox;
        $scope.hideDummyInbox = hideDummyInbox;
        $scope.starRecipeToMF = starRecipeToMF;
        $scope.gotoMyFavorite = gotoMyFavorite;
        $scope.changeTempUnit = changeTempUnit;
        $scope.showMenuOption = showMenuOption;
        $scope.sendAdjustTemp = sendAdjustTemp;
        $scope.hideMenuOption = hideMenuOption;
        $scope.cancleEditMode = cancleEditMode;
        $scope.modelBasedMenu = modelBasedMenu;
        $scope.maxLenghtCheck = maxLenghtCheck;
        $scope.deleteMFCooking = deleteMFCooking;
        $scope.menuMFItemClick = menuMFItemClick;
        $scope.versionTouchEnd = versionTouchEnd;
        $scope.sendButtonClick = sendButtonClick;
        $scope.cancelSaveRecipe = cancelSaveRecipe;
        $scope.deleteMyCookings = deleteMyCookings;
        $scope.autoCookNextPage = autoCookNextPage;
        $scope.menuTabItemClick = menuTabItemClick;
        $scope.gotoSmartControl = gotoSmartControl;
        $scope.sendMFButtonClick = sendMFButtonClick;
        $scope.versionTouchStart = versionTouchStart;
        $scope.cancleButtonClick = cancleButtonClick;
        $scope.adjustTempPkrLeft = adjustTempPkrLeft;
        $scope.isSelectedToDelete = isSelectedToDelete;
        $scope.autoCookSendButton = autoCookSendButton;
        $scope.stopLongPressEvent = stopLongPressEvent;
        $scope.smartcareerrorcheck = smartcareerrorcheck;
        $scope.onAlertButton1Click = onAlertButton1Click;
        $scope.onAlertButton2Click = onAlertButton2Click;
        $scope.startConfirmationOK = startConfirmationOK;
        $scope.hideStramRoastLevel = hideStramRoastLevel;
        $scope.gotoStramRoastLevel = gotoStramRoastLevel;
        $scope.checkOvenStartState = checkOvenStartState;
        $scope.doOnServiceCallPopup = doOnServiceCallPopup;
        $scope.autoCookPreviousPage = autoCookPreviousPage;
        $scope.steamRoastLevelClick = steamRoastLevelClick;
        $scope.hideSmartControlOption = hideSmartControlOption;
        $scope.onSettingsToggleUpdate = onSettingsToggleUpdate;
        $scope.operationCompleteButton = operationCompleteButton;
        $scope.startConfirmationCancel = startConfirmationCancel;
        $scope.selectAllDeleteMFCooking = selectAllDeleteMFCooking;
        $scope.showAutoCookDetailsScreen = showAutoCookDetailsScreen;

        $scope.increaseTemp = increaseTemp;
        $scope.decreaseTemp = decreaseTemp;
        $scope.increaseHours = increaseHours;
        $scope.decreaseHours = decreaseHours;
        $scope.increaseMinutes = increaseMinutes;
        $scope.decreaseMinutes = decreaseMinutes;
        $scope.increaseProbeTemp = increaseProbeTemp;
        $scope.decreaseProbeTemp = decreaseProbeTemp;
        $scope.doValidationForTemp = doValidationForTemp;
        $scope.doValidationForHour = doValidationForHour;
        $scope.doValidationForMinute = doValidationForMinute;
        $scope.doValidationForProbeTemp = doValidationForProbeTemp;
        $scope.increaseTempContinuously = increaseTempContinuously;
        $scope.decreaseTempContinuously = decreaseTempContinuously;
        $scope.increaseHoursContinuously = increaseHoursContinuously;
        $scope.decreaseHoursContinuously = decreaseHoursContinuously;
        $scope.increaseMinutesContinuously = increaseMinutesContinuously;
        $scope.decreaseMinutesContinuously = decreaseMinutesContinuously;
        $scope.increaseProbeTempContinuously = increaseProbeTempContinuously;
        $scope.decreaseProbeTempContinuously = decreaseProbeTempContinuously;

        $scope.wOvenMenuList = [{
                id: 1,
                title: 'WEBMOB_device_range_oven_function'
            }, {
                id: 3,
                title: 'WEBMOB_device_range_healthy_cook'
            }, {
                id: 4,
                title: 'WEBMOB_device_range_easy_cook'
            }/*, { //removing gourmet recipe from the menu - We just can monitor
             id: 5,
             title: 'WEBMOB_device_range_auto_cook'
             }*/];

        $scope.AutoCookData = [{
                id: 0,
                title: 'WEBMOB_device_walloven_auto_cook_garlic_prime_rib',
                recipeId: '01',
                rackPositon: 3,
                yield: $scope.translation.WEBMOB_device_range_auto_cook_roasting_chicken_yield,
                cookingTime: '40mins',
                mainIngrediant: $scope.translation.WEBMOB_device_range_auto_cook_roasting_chicken_main_ingredient,
                equipment: $scope.translation.WEBMOB_device_range_auto_cook_equip_baking_pan,
                wireRackDesc: $scope.translation.WEBMOB_device_range_auto_cook_roast_chicken_desc_wire,
                rackImage: 'images/walloven/main_rg_img_tray_00.png',
                image: 'images/range/main_rg_foodimg_roasting_chicken_thighs.png'
            }, {
                id: 1,
                title: 'WEBMOB_device_walloven_auto_cook_mustard_filet_mignon_steak',
                recipeId: '02',
                rackPositon: 2,
                yield: $scope.translation.WEBMOB_device_range_auto_cook_roasting_beef_yield,
                cookingTime: '1hr 10mins',
                mainIngrediant: $scope.translation.WEBMOB_device_range_auto_cook_roasting_beef_main_ingredient,
                equipment: $scope.translation.WEBMOB_device_range_auto_cook_equip_roasting_pan_and_rack,
                wireRackDesc: $scope.translation.WEBMOB_device_range_auto_cook_roast_beef_desc_wire,
                rackImage: 'images/walloven/main_rg_img_tray_00.png',
                image: 'images/range/main_rg_foodimg_roasting_beef.png'
            }, {
                id: 2,
                title: 'WEBMOB_device_walloven_auto_cook_roasting_chicken_thighs',
                recipeId: '03',
                rackPositon: 3,
                yield: $scope.translation.WEBMOB_device_range_auto_cook_lasagna_yield,
                cookingTime: '35mins',
                mainIngrediant: $scope.translation.WEBMOB_device_range_auto_cook_lasagna_main_ingredient,
                equipment: $scope.translation.WEBMOB_device_range_auto_cook_equip_glass_baking_dish,
                wireRackDesc: $scope.translation.WEBMOB_device_range_auto_cook_lasagna_desc_wire,
                rackImage: 'images/walloven/main_rg_img_tray_00.png',
                image: 'images/range/main_rg_foodimg_lasagna.png'
            }, {
                id: 3,
                title: 'WEBMOB_device_walloven_auto_cook_roasting_honey_mustard_chicken_breast',
                recipeId: '04',
                rackPositon: 3,
                yield: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_yield,
                cookingTime: '50mins',
                mainIngrediant: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_main_ingredient,
                equipment: $scope.translation.WEBMOB_device_range_auto_cook_equip_2_deep_dish_pizza_pans,
                wireRackDesc: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_desc_wire,
                rackImage: 'images/walloven/main_rg_img_tray_00.png',
                image: 'images/range/main_rg_foodimg_chicago_pizza.png'
            }, {
                id: 4,
                title: 'WEBMOB_device_walloven_auto_cook_grilled_shrimp_with_olive_oil_and_chopped_basil',
                recipeId: '05',
                rackPositon: 3,
                yield: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_yield,
                cookingTime: '50mins',
                mainIngrediant: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_main_ingredient,
                equipment: $scope.translation.WEBMOB_device_range_auto_cook_equip_2_deep_dish_pizza_pans,
                wireRackDesc: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_desc_wire,
                rackImage: 'images/walloven/main_rg_img_tray_00.png',
                image: 'images/range/main_rg_foodimg_chicago_pizza.png'
            }, {
                id: 5,
                title: 'WEBMOB_device_walloven_auto_cook_three_cheese_lasagna',
                recipeId: '09', //Updated ID as SET is sending 09
                rackPositon: 3,
                yield: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_yield,
                cookingTime: '50mins',
                mainIngrediant: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_main_ingredient,
                equipment: $scope.translation.WEBMOB_device_range_auto_cook_equip_2_deep_dish_pizza_pans,
                wireRackDesc: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_desc_wire,
                rackImage: 'images/walloven/main_rg_img_tray_00.png',
                image: 'images/range/main_rg_foodimg_chicago_pizza.png'
            }, {
                id: 6,
                title: 'WEBMOB_device_walloven_auto_cook_butter_milk_cornbread',
                recipeId: '07',
                rackPositon: 3,
                yield: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_yield,
                cookingTime: '50mins',
                mainIngrediant: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_main_ingredient,
                equipment: $scope.translation.WEBMOB_device_range_auto_cook_equip_2_deep_dish_pizza_pans,
                wireRackDesc: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_desc_wire,
                rackImage: 'images/walloven/main_rg_img_tray_00.png',
                image: 'images/range/main_rg_foodimg_chicago_pizza.png'
            }, {
                id: 7,
                title: 'WEBMOB_device_walloven_auto_cook_sweet_bread_pudding',
                recipeId: '08',
                rackPositon: 3,
                yield: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_yield,
                cookingTime: '50mins',
                mainIngrediant: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_main_ingredient,
                equipment: $scope.translation.WEBMOB_device_range_auto_cook_equip_2_deep_dish_pizza_pans,
                wireRackDesc: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_desc_wire,
                rackImage: 'images/walloven/main_rg_img_tray_00.png',
                image: 'images/range/main_rg_foodimg_chicago_pizza.png'
            }, {
                id: 8,
                title: 'WEBMOB_device_walloven_auto_cook_sweet_banana_nut_bread',
                recipeId: '06', //Updated ID as SET is sending 06
                rackPositon: 3,
                yield: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_yield,
                cookingTime: '50mins',
                mainIngrediant: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_main_ingredient,
                equipment: $scope.translation.WEBMOB_device_range_auto_cook_equip_2_deep_dish_pizza_pans,
                wireRackDesc: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_desc_wire,
                rackImage: 'images/walloven/main_rg_img_tray_00.png',
                image: 'images/range/main_rg_foodimg_chicago_pizza.png'
            }, {
                id: 9,
                title: 'WEBMOB_device_walloven_auto_cook_fresh_chicago_pizza',
                recipeId: '0A', //Updated ID as SET is sending 0A
                rackPositon: 3,
                yield: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_yield,
                cookingTime: '50mins',
                mainIngrediant: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_main_ingredient,
                equipment: $scope.translation.WEBMOB_device_range_auto_cook_equip_2_deep_dish_pizza_pans,
                wireRackDesc: $scope.translation.WEBMOB_device_range_auto_cook_chicago_pizza_desc_wire,
                rackImage: 'images/walloven/main_rg_img_tray_00.png',
                image: 'images/range/main_rg_foodimg_chicago_pizza.png'
            }];

        $scope.validateSendRecipeInfoSingle = {
            'State': '',
            'Mode': '',
            'OperationTime': '',
            'DesiredTemp': '',
            'HighLowTemp': '',
            'DesiredProbeTemp': ''
        };
        $scope.validateSendRecipeInfoDualUpper = {
            'State': '',
            'Mode': '',
            'OperationTime': '',
            'DesiredTemp': '',
            'HighLowTemp': '',
            'DesiredProbeTemp': ''
        };
        $scope.validateSendRecipeInfoDualLower = {
            'State': '',
            'Mode': '',
            'OperationTime': '',
            'DesiredTemp': ''
        };
        $scope.validateSendRecipeInfoDualFlexUpper = {
            'State': '',
            'Mode': '',
            'OperationTime': '',
            'DesiredTemp': '',
            'HighLowTemp': '',
            'DesiredProbeTemp': ''
        };
        $scope.validateSendRecipeInfoDualFlexLower = {
            'State': '',
            'Mode': '',
            'OperationTime': '',
            'DesiredTemp': '',
            'HighLowTemp': '',
            'DesiredProbeTemp': ''
        };
        $scope.validateSendRecipeInfoLowerFlex = {
            'State': '',
            'Mode': '',
            'OperationTime': '',
            'DesiredTemp': '',
            'HighLowTemp': '',
            'DesiredProbeTemp': ''
        };
        $scope.descaleSteps = [
            {id: 1}, {id: 2}, {id: 3}, {id: 4}, {id: 5}, {id: 6}
        ];
    }

    function debugMessage(msg) {
        if (false) {
            console.log(Debug_tag + ": " + msg + ' >> called from ' + arguments.callee.caller.name);
        }
    }

    function init() {
        debugMessage("init");
        justFirstTime = true;
        $scope.idZero = {
            Alarms: [{
                    alarmType: "Device",
                    code: "WO_E",
                    id: "0",
                    triggeredTime: "2016-03-31T07:01:24"
                }],
            ConfigurationLink: {
                href: "/devices/0/configuration"
            },
            Diagnosis: {
                diagnosisStart: "Ready"
            },
            Doors: [{
                    id: "0",
                    openState: "Open"
                }],
            InformationLink: {
                href: "/devices/0/information"
            },
            Mode: {
                modes: ["NoOperation"],
                options: [{
                        Sabbath: "Off",
                        NoPreheat: "Off",
                        steamAddLevel: 1,
                        descaleState: 'Standby',
                        DeviceType: "NW9000KW/AA0",
                        Sound: "On",
                        keepWarmReservation: "Off",
                        drainRequired: "",
                        RecipeConversion: "Off",
                        EnergySaving: "On",
                        AdjustingTemp: "163",
                        SettingPossible: "7",
                        meatprobe: "disconnected"}],
                supportedModes: ["ConvectionBake,ConvectionRoast,Bake,Broil,Healthycook1,Healthycook2,Healthycook3,Healthycook4,Healthycook5,Healthycook6,KeepWarm,SteamClean,SelfClean,NULL,UpperConvectionBake,UpperConvectionRoast,UpperBroil,UpperHealthycook1,UpperHealthycook2,UpperHealthycook3,UpperHealthycook4,UpperHealthycook5,LowerConvectionBake,LowerBake,LowerHealthycook1,LowerHealthycook2,LowerHealthycook3,LowerHealthycook4,LowerHealthycook5"]
            },
            Operation: {
                kidsLock: "Ready",
                operationTime: "00:00:00",
                power: "On",
                progressPercentage: 1,
                remainingTime: "00:00:00",
                state: "Ready"
            },
            Oven: {
                CustomRecipesLink: {
                    href: "/devices/0/oven/customrecipes"
                },
                recipe: "00000000000000",
                state: "Ready"
            },
            Temperatures: [{
                    current: 0.0,
                    desired: 0.0,
                    id: "0",
                    increment: 1,
                    unit: "Fahrenheit"
                }, {
                    current: 0.0,
                    desired: 0.0,
                    id: "1",
                    increment: 1,
                    unit: "Celsius"
                }],
            connected: false,
            description: "TP6X_OV_16K",
            id: "0",
            resources: ["Alarms",
                "Camera",
                "Captures",
                "Configuration",
                "Diagnosis",
                "Doors",
                "Information",
                "Mode",
                "Operation",
                "Oven",
                "Temperatures"],
            type: "Oven",
            uuid: "F8042EEA-6655-0000-0000-000000000000"
        };
        $scope.idOne = {
            Alarms: [{
                    alarmType: "Device",
                    code: "WO_E",
                    id: "0",
                    triggeredTime: "2016-03-31T07:01:24"
                }],
            ConfigurationLink: {
                href: "/devices/1/configuration"
            },
            Diagnosis: {
                diagnosisStart: "Ready"
            },
            Doors: [{
                    id: "0",
                    openState: "Open"
                }],
            InformationLink: {
                href: "/devices/1/information"
            },
            Mode: {
                modes: ["NoOperation"],
                options: [{
                        Sabbath: "Off",
                        NoPreheat: "Off",
                        steamAddLevel: 1,
                        descaleState: 'Standby',
                        DeviceType: "NW9000KW/AA0",
                        Sound: "On",
                        keepWarmReservation: "Off",
                        drainRequired: "",
                        RecipeConversion: "Off",
                        EnergySaving: "On",
                        AdjustingTemp: "0",
                        SettingPossible: "7",
                        meatprobe: "disconnected"}],
                supportedModes: ["ConvectionBake,ConvectionRoast,Bake,Broil,Healthycook1,Healthycook2,Healthycook3,Healthycook4,Healthycook5,Healthycook6,KeepWarm,SteamClean,SelfClean,NULL,UpperConvectionBake,UpperConvectionRoast,UpperBroil,UpperHealthycook1,UpperHealthycook2,UpperHealthycook3,UpperHealthycook4,UpperHealthycook5,LowerConvectionBake,LowerBake,LowerHealthycook1,LowerHealthycook2,LowerHealthycook3,LowerHealthycook4,LowerHealthycook5"]
            },
            Operation: {
                kidsLock: "Ready",
                operationTime: "00:00:00",
                power: "On",
                progressPercentage: 1,
                remainingTime: "00:00:00",
                state: "Ready"
            },
            Oven: {
                CustomRecipesLink: {
                    href: "/devices/1/oven/customrecipes"
                },
                recipe: "00000000000000",
                state: "Ready"
            },
            Temperatures: [{
                    current: 0.0,
                    desired: 0.0,
                    id: "0",
                    increment: 1,
                    unit: "Fahrenheit"
                }, {
                    current: 0.0,
                    desired: 0.0,
                    id: "1",
                    increment: 1,
                    unit: "Celsius"
                }],
            connected: false,
            description: "TP6X_OV_16K",
            id: "1",
            resources: ["Alarms",
                "Camera",
                "Captures",
                "Configuration",
                "Diagnosis",
                "Doors",
                "Information",
                "Mode",
                "Operation",
                "Oven",
                "Temperatures"],
            type: "Oven",
            uuid: "F8042EEA-6655-0000-0000-000000000001"
        };
        $scope.idTwo = {
            Alarms: [{
                    alarmType: "Device",
                    code: "WO_E",
                    id: "0",
                    triggeredTime: "2016-03-31T07:01:24"
                }],
            ConfigurationLink: {
                href: "/devices/2/configuration"
            },
            Diagnosis: {
                diagnosisStart: "Ready"
            },
            Doors: [{
                    id: "0",
                    openState: "Open"
                }],
            InformationLink: {
                href: "/devices/2/information"
            },
            Mode: {
                modes: ["Bake"],
                options: [{
                        Sabbath: "Off",
                        NoPreheat: "Off",
                        steamAddLevel: 1,
                        descaleState: 'Standby',
                        DeviceType: "NW9000KW/AA0",
                        Sound: "On",
                        keepWarmReservation: "Off",
                        drainRequired: "",
                        RecipeConversion: "Off",
                        EnergySaving: "On",
                        AdjustingTemp: "0",
                        SettingPossible: "7",
                        meatprobe: "disconnected"}],
                supportedModes: ["ConvectionBake,ConvectionRoast,Bake,Broil,Healthycook1,Healthycook2,Healthycook3,Healthycook4,Healthycook5,Healthycook6,KeepWarm,SteamClean,SelfClean,NULL,UpperConvectionBake,UpperConvectionRoast,UpperBroil,UpperHealthycook1,UpperHealthycook2,UpperHealthycook3,UpperHealthycook4,UpperHealthycook5,LowerConvectionBake,LowerBake,LowerHealthycook1,LowerHealthycook2,LowerHealthycook3,LowerHealthycook4,LowerHealthycook5"]
            },
            Operation: {
                kidsLock: "Ready",
                operationTime: "01:30:00",
                power: "On",
                progressPercentage: 1,
                remainingTime: "00:50:00",
                state: "Ready"
            },
            Oven: {
                CustomRecipesLink: {
                    href: "/devices/2/oven/customrecipes"
                },
                recipe: "00000000000000",
                state: "Cooking"
            },
            Temperatures: [{
                    current: 300.0,
                    desired: 350.0,
                    id: "0",
                    increment: 1,
                    unit: "Fahrenheit"
                }, {
                    current: 0.0,
                    desired: 0.0,
                    id: "1",
                    increment: 1,
                    unit: "Fahrenheit"
                }],
            connected: false,
            description: "TP6X_OV_16K_SUB",
            id: "2",
            resources: ["Alarms",
                "Camera",
                "Captures",
                "Configuration",
                "Diagnosis",
                "Doors",
                "Information",
                "Mode",
                "Operation",
                "Oven",
                "Temperatures"],
            type: "Oven",
            uuid: "F8042EEA-6655-0000-0000-000000000002"
        };
    }

    function initializeScreenDB() {
        debugMessage("initializeScreenDB");
        $scope.ovenFunctionContentsSingle = getTypeContent('BASIC', 6, 'YES');
        $scope.healthyFunctionContentsSingle = getTypeContent('HEALTHYCOOK', 6, 'YES');
        $scope.supportedModesSingle = getSupportedContent(6, 'YES');

        $scope.ovenFunctionContentsSingleUpperFlex = getTypeContent('BASIC', 7, 'YES');
        $scope.healthyFunctionContentsSingleUpperFlex = getTypeContent('HEALTHYCOOK', 7, 'YES');
        $scope.supportedModesSingleUpperFlex = getSupportedContent(7, 'YES');

        $scope.ovenFunctionContentsSingleLowerFlex = getTypeContent('BASIC', 8, 'YES');
        $scope.healthyFunctionContentsSingleLowerFlex = getTypeContent('HEALTHYCOOK', 8, 'YES');
        $scope.supportedModesSingleLowerFlex = getSupportedContent(8, 'YES');

        $scope.ovenFunctionContentsDualUpper = getTypeContent('BASIC', 9, 'YES');
        $scope.healthyFunctionContentsDualUpper = getTypeContent('HEALTHYCOOK', 9, 'YES');
        $scope.supportedModesDualUpper = getSupportedContent(9, 'YES');

        $scope.ovenFunctionContentsDualLower = getTypeContent('BASIC', 10, 'YES');
        $scope.healthyFunctionContentsDualLower = getTypeContent('HEALTHYCOOK', 10, 'YES');
        $scope.supportedModesDualLower = getSupportedContent(10, 'YES');

        $scope.ovenFunctionContentsDualUpperFlex = getTypeContent('BASIC', 11, 'YES');
        $scope.healthyFunctionContentsDualUpperFlex = getTypeContent('HEALTHYCOOK', 11, 'YES');
        $scope.supportedModesDualUpperFlex = getSupportedContent(11, 'YES');

        $scope.ovenFunctionContentsDualLowerFlex = getTypeContent('BASIC', 12, 'YES');
        $scope.healthyFunctionContentsDualLowerFlex = getTypeContent('HEALTHYCOOK', 12, 'YES');
        $scope.supportedModesDualLowerFlex = getSupportedContent(12, 'YES');
    }

    function updateDeviceData(data) {
        //debugMessage("updateDeviceData " + data);
        SHPService.updateDeviceData($scope, data);
    }

    function configurationCall() {
        if (!$scope.isStatic) {
            debugMessage("configurationCall");
            if (!!!configTimer) {
                configTimer = $interval(function () {
                    debugMessage("configurationCall Interval call");
                    nativeInterface.getResourceUrl("/" + $scope.peerId + "/devices/0/configuration");
                }, Sec20Call);
            }
        }
    }

    function lowerCavityConfigCall() {
        if (!$scope.isStatic) {
            debugMessage("configurationCall call for device id 2");
            nativeInterface.getResourceUrl("/" + $scope.peerId + "/devices/2/configuration");
        }
    }

    function parseStaticData() {
        debugMessage("parseStaticData");
        init();
        initializeScreen();
        $scope.showSmartCare = true;
        $scope.idTwo.Operation.state = "Run";
        $scope.idTwo.connected = true;
        $scope.idTwo.Operation.progressPercentage = 45;
        $timeout(function () {
            showCurrentScreen();
        }, 4000);
    }

    function parseDeviceData(devices) {
        debugMessage("deviceUuid from app.js is :" + $scope.deviceUuid);
        if (angular.isDefined(devices) && angular.isDefined(devices[0]) && angular.isDefined(devices[0]["uuid"])) {
            if ($scope.deviceUuid !== devices[0]["uuid"] && $scope.deviceUuid !== devices[1]["uuid"] && $scope.deviceUuid !== devices[2]["uuid"]) {
                debugMessage("return due to missmatch UUID");
                return;
            }
        }

        debugMessage(JSON.stringify(devices));

        if (devices instanceof Array) { //Added a check to avoid error in case "devices" is not array 
            devices.forEach(function (value) {
                if (value["id"] === '0') {
                    parseIdZeroData(value);
                }
                if (value["id"] === '1') {
                    parseIdOneData(value);
                }
                if (value["id"] === '2') {
                    parseIdTwoData(value);
                }
            });
        } else if (angular.isDefined(devices['Operation']) && devices['Operation'] === '') {
            // sometimes set is sending  devices as {"Operation":""}, added the condition just to avoid any issue that it can cause
            return;
        } else {
            //do nothing
        }

        if (justFirstTime) {
            if (!$scope.isStatic) {
                nativeInterface.getResourceUrl("/" + $scope.peerId + "/devices/0/configuration");
            }
            configurationCall();
            //Create local Storage DB name based on connected device UUID
            WALLOVEN_LOCALSTORAGE.FAVDB = "WALLOVEN_FAV_DB_" + $scope.deviceUuid;
            return;
        }
        if (!justFirstTime) {
            initializeScreen();
            showCurrentScreen();
        }
    }

    function parseConfiguration(configInfo, url) {
        debugMessage("parseConfiguration configInfo : " + JSON.stringify(configInfo) + " url : " + url);
        $scope.parseConfig = true;
        if (url !== undefined && url !== '') {
            url = url.split("/")[3];
        }
        if (url !== undefined && url !== '' && Number(url) === 2) {
            if (angular.isDefined(configInfo["remoteControlEnabled"])) {
                debugMessage("parseConfiguration configInfo for id 2");
                $scope.remoteControlEnabledIdTwo = configInfo["remoteControlEnabled"];
            }
        } else {
            if (angular.isDefined(configInfo["remoteControlEnabled"])) {
                $scope.remoteControlEnabled = configInfo["remoteControlEnabled"];
            }
        }
        if ((selectedCavity === 'DUALLOWER' || selectedCavity === 'LOWERFLEX')) {
            $scope.smartControl = $scope.remoteControlEnabledIdTwo ? 'ON' : 'OFF';
        } else {
            $scope.smartControl = $scope.remoteControlEnabled ? 'ON' : 'OFF';
        }
        if (angular.isDefined(configInfo["region"])) {
            $scope.region = configInfo["region"];
        }
        if (justFirstTime) {
            dismissLoadingBar(WALLOVEN_COMMANDS.getDevices);
            initializeScreen();
            showCurrentScreen();
        }
    }

    function parseNotificationData(notification) {
        debugMessage("parseNotificationData : " + JSON.stringify(notification));
        if (angular.isDefined(notification["uuid"])) {
            if ($scope.idZero !== undefined && notification["uuid"] === $scope.idZero.uuid) {
                if (angular.isDefined(notification["Configuration"])) {
                    parseConfiguration(notification["Configuration"], '');
                    if ($scope.parseNotiLength === 0) {
                        $scope.appAtForeground = false;
                    }
                } else {
                    parseIdZeroData(notification);
                    if ($scope.parseNotiLength === 0) {
                        $scope.appAtForeground = false;
                        showCurrentScreen();
                    }
                }
            } else if ($scope.idOne !== undefined && notification["uuid"] === $scope.idOne.uuid) {
                parseIdOneData(notification);
                if ($scope.parseNotiLength === 0) {
                    $scope.appAtForeground = false;
                    showCurrentScreen();
                }
            } else if ($scope.idTwo !== undefined && notification["uuid"] === $scope.idTwo.uuid) {
                if (angular.isDefined(notification["Configuration"])) {
                    parseConfiguration(notification["Configuration"], '_/_/_/2');
                    if ($scope.parseNotiLength === 0) {
                        $scope.appAtForeground = false;
                    }
                } else {
                    parseIdTwoData(notification);
                    if ($scope.parseNotiLength === 0) {
                        $scope.appAtForeground = false;
                        showCurrentScreen();
                    }
                }
            } else {
                debugMessage("parseNotificationData(notification) uuid not matched notification uuid " + notification["uuid"]);
                $scope.appAtForeground = true;
                SHPService.sendSHPCommand("GET", "/" + $scope.peerId + "/devices", "", false);
            }
        }
    }

    function parseDataDeviceidZeroModeOptions(deviceModeOption) {
        debugMessage('parseDataDeviceidZeroModeOptions');
        deviceModeOption.forEach(function (value) {
            if (value.indexOf("meatprobe") !== -1) {
                if (!justFirstTime
                        && $scope.idZero.Mode.options[0] !== undefined
                        && $scope.idZero.Mode.options[0].meatprobe !== value.split("_")[1]) {

                    if (value.split("_")[1] === "connected") {
                        showToast($scope.translation.WEBMOB_device_range_ready_temp_probe_inserted);
                        /**
                         * MW0600025594 - If oven is running and temp probe switched on then display message in case current mode does not support temp probe.
                         */
                        $scope.idZero.Mode.options[0].meatprobe = value.split("_")[1];
                        $scope.deviceModeSupport = getProbeSupportFromTabel($scope.idZero.Mode.modes[0]);
                        if (!$scope.deviceModeSupport && $scope.idZero.Operation.state === 'Run') {
                            debugMessage("Display meesage for non supported MeatProbe Recipe in state >> " + $scope.idZero.Operation.state + " >> Recipee data " + $scope.idZero.Mode.modes[0]);
                            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_AUTO_COOK_PROBE, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_range_alarm_selected_mode_not_support, $scope.translation.WEBMOB_common_ok, '');
                        }
                    } else {
                        showToast($scope.translation.WEBMOB_device_range_ready_temp_probe_removed);
                    }
                }

                $scope.idZero.Mode.options[0].meatprobe = value.split("_")[1];
                checkForMeatProbe();
                if (value.split("_")[1] === "connected" && $scope.idZero.connected) {
                    validateCurrentScreen('ProbeDividerErrorPage');
                }
                resetProbeTempToDefault();
            }
            if (value.indexOf("Sabbath") !== -1) {
                $scope.idZero.Mode.options[0].Sabbath = value.split("_")[1];
            }
            if (value.indexOf("NoPreheat") !== -1) {
                $scope.idZero.Mode.options[0].NoPreheat = value.split("_")[1];
            }
            if (value.indexOf("steamAddLevel") !== -1) {
                $scope.idZero.Mode.options[0].steamAddLevel = value.split("_")[1];
            }
            if (value.indexOf("descaleState") !== -1) {
                $scope.idZero.Mode.options[0].descaleState = value.split("_")[1];
            }
            if (value.indexOf("DeviceType") !== -1) {
                $scope.idZero.Mode.options[0].DeviceType = value.split("_")[1];
                $scope.DeviceModelName = $scope.idZero.Mode.options[0].DeviceType;
            }
            if (value.indexOf("Sound") !== -1) {
                $scope.idZero.Mode.options[0].Sound = value.split("_")[1];
            }
            if (value.indexOf("keepWarmReservation") !== -1) {
                $scope.idZero.Mode.options[0].keepWarmReservation = value.split("_")[1];
            }
            if (value.indexOf("drainRequired") !== -1) {
                $scope.idZero.Mode.options[0].drainRequired = value.split("_")[1];
            }
            if (value.indexOf("RecipeConversion") !== -1) {
                $scope.idZero.Mode.options[0].RecipeConversion = value.split("_")[1];
            }
            if (value.indexOf("EnergySaving") !== -1) {
                $scope.idZero.Mode.options[0].EnergySaving = value.split("_")[1];
            }
            if (value.indexOf("WarmingCenter") !== -1) {
                $scope.idZero.Mode.options[0].WarmingCenter = value.split("_")[1];
            }
            if (value.indexOf("WarmingDrawer") !== -1) {
                $scope.idZero.Mode.options[0].WarmingDrawer = value.split("_")[1];
            }
            if (value.indexOf("Cooktop") !== -1) {
                $scope.idZero.Mode.options[0].Cooktop = value.split("_")[1];
            }
            if (value.indexOf("VirtualFlame") !== -1) {
                $scope.idZero.Mode.options[0].VirtualFlame = value.split("_")[1];
            }
            if (value.indexOf("AdjustingTemp") !== -1) {
                $scope.idZero.Mode.options[0].AdjustingTemp = value.split("_")[1];
            }
            if (value.indexOf("SettingPossible") !== -1) {
                $scope.idZero.Mode.options[0].SettingPossible = value.split("_")[1];
            }
            if (value.indexOf("waterInlet") !== -1) {
                $scope.idZero.Mode.options[0].waterInlet = value.split("_")[1];
            }
            if (value.indexOf("waterTankInSwitch") !== -1) {
                $scope.idZero.Mode.options[0].waterTankInSwitch = value.split("_")[1];
            }
        });
        settingPageOptionsValidation();
        dismissLoadingBar(WALLOVEN_COMMANDS.SettingOptions);

    }

    function parseDataDeviceidOneModeOptions(deviceModeOption) {
        debugMessage('parseDataDeviceidOneModeOptions');
        deviceModeOption.forEach(function (value) {
            if (value.indexOf("meatprobe") !== -1) {
                $scope.idOne.Mode.options[0].meatprobe = value.split("_")[1];
            }
            if (value.indexOf("Sabbath") !== -1) {
                $scope.idOne.Mode.options[0].Sabbath = value.split("_")[1];
            }
            if (value.indexOf("NoPreheat") !== -1) {
                $scope.idOne.Mode.options[0].NoPreheat = value.split("_")[1];
            }
            if (value.indexOf("steamAddLevel") !== -1) {
                $scope.idOne.Mode.options[0].steamAddLevel = value.split("_")[1];
            }
            if (value.indexOf("descaleState") !== -1) {
                $scope.idOne.Mode.options[0].descaleState = value.split("_")[1];
            }
            if (value.indexOf("DeviceType") !== -1) {
                $scope.idOne.Mode.options[0].DeviceType = value.split("_")[1];
            }
            if (value.indexOf("Sound") !== -1) {
                $scope.idOne.Mode.options[0].Sound = value.split("_")[1];
            }
            if (value.indexOf("keepWarmReservation") !== -1) {
                $scope.idOne.Mode.options[0].keepWarmReservation = value.split("_")[1];
            }
            if (value.indexOf("RecipeConversion") !== -1) {
                $scope.idOne.Mode.options[0].RecipeConversion = value.split("_")[1];
            }
            if (value.indexOf("EnergySaving") !== -1) {
                $scope.idOne.Mode.options[0].EnergySaving = value.split("_")[1];
            }
            if (value.indexOf("WarmingCenter") !== -1) {
                $scope.idOne.Mode.options[0].WarmingCenter = value.split("_")[1];
            }
            if (value.indexOf("WarmingDrawer") !== -1) {
                $scope.idOne.Mode.options[0].WarmingDrawer = value.split("_")[1];
            }
            if (value.indexOf("Cooktop") !== -1) {
                $scope.idOne.Mode.options[0].Cooktop = value.split("_")[1];
            }
            if (value.indexOf("VirtualFlame") !== -1) {
                $scope.idOne.Mode.options[0].VirtualFlame = value.split("_")[1];
            }
            if (value.indexOf("AdjustingTemp") !== -1) {
                $scope.idOne.Mode.options[0].AdjustingTemp = value.split("_")[1];
            }
            if (value.indexOf("SettingPossible") !== -1) {
                $scope.idOne.Mode.options[0].SettingPossible = value.split("_")[1];
            }
            if (value.indexOf("waterInlet") !== -1) {
                $scope.idOne.Mode.options[0].waterInlet = value.split("_")[1];
            }
            if (value.indexOf("waterTankInSwitch") !== -1) {
                $scope.idOne.Mode.options[0].waterTankInSwitch = value.split("_")[1];
            }
        });
        settingPageOptionsValidation();
        dismissLoadingBar(WALLOVEN_COMMANDS.SettingOptions);

    }

    function parseDataDeviceidTwoModeOptions(deviceModeOption) {
        debugMessage('parseDataDeviceidTwoModeOptions');
        deviceModeOption.forEach(function (value) {
            if (value.indexOf("meatprobe") !== -1) {
                $scope.idTwo.Mode.options[0].meatprobe = value.split("_")[1];
            }
            if (value.indexOf("Sabbath") !== -1) {
                $scope.idTwo.Mode.options[0].Sabbath = value.split("_")[1];
            }
            if (value.indexOf("NoPreheat") !== -1) {
                $scope.idTwo.Mode.options[0].NoPreheat = value.split("_")[1];
            }
            if (value.indexOf("steamAddLevel") !== -1) {
                $scope.idTwo.Mode.options[0].steamAddLevel = value.split("_")[1];
            }
            if (value.indexOf("descaleState") !== -1) {
                $scope.idTwo.Mode.options[0].descaleState = value.split("_")[1];
            }
            if (value.indexOf("DeviceType") !== -1) {
                $scope.idTwo.Mode.options[0].DeviceType = value.split("_")[1];
            }
            if (value.indexOf("Sound") !== -1) {
                $scope.idTwo.Mode.options[0].Sound = value.split("_")[1];
            }
            if (value.indexOf("keepWarmReservation") !== -1) {
                $scope.idTwo.Mode.options[0].keepWarmReservation = value.split("_")[1];
            }
            if (value.indexOf("RecipeConversion") !== -1) {
                $scope.idTwo.Mode.options[0].RecipeConversion = value.split("_")[1];
            }
            if (value.indexOf("EnergySaving") !== -1) {
                $scope.idTwo.Mode.options[0].EnergySaving = value.split("_")[1];
            }
            if (value.indexOf("WarmingCenter") !== -1) {
                $scope.idTwo.Mode.options[0].WarmingCenter = value.split("_")[1];
            }
            if (value.indexOf("WarmingDrawer") !== -1) {
                $scope.idTwo.Mode.options[0].WarmingDrawer = value.split("_")[1];
            }
            if (value.indexOf("Cooktop") !== -1) {
                $scope.idTwo.Mode.options[0].Cooktop = value.split("_")[1];
            }
            if (value.indexOf("VirtualFlame") !== -1) {
                $scope.idTwo.Mode.options[0].VirtualFlame = value.split("_")[1];
            }
            if (value.indexOf("AdjustingTemp") !== -1) {
                $scope.idTwo.Mode.options[0].AdjustingTemp = value.split("_")[1];
            }
            if (value.indexOf("SettingPossible") !== -1) {
                $scope.idTwo.Mode.options[0].SettingPossible = value.split("_")[1];
            }
            if (value.indexOf("waterInlet") !== -1) {
                $scope.idTwo.Mode.options[0].waterInlet = value.split("_")[1];
            }
            if (value.indexOf("waterTankInSwitch") !== -1) {
                $scope.idTwo.Mode.options[0].waterTankInSwitch = value.split("_")[1];
            }
        });
        settingPageOptionsValidation();
        dismissLoadingBar(WALLOVEN_COMMANDS.SettingOptions);

    }

    function parseModuleInformation(moduleInfo) {
        debugMessage("parseModuleInformation " + JSON.stringify(moduleInfo));
        if (angular.isDefined(moduleInfo.Versions) && moduleInfo.Versions.length > 0) {
            $scope.moduleInfoText = "Software Ver : " + moduleInfo.Versions[0].number + " <br> Firmware Ver : " + moduleInfo.Versions[1].number;
            dismissLoadingBar(WALLOVEN_COMMANDS.showModuleVersion);
            debugMessage("Infotext : " + $scope.moduleInfoText);
            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_DEVELOPER_INFO, $scope.translation.WEBMOB_common_version_info, $scope.moduleInfoText, $scope.translation.WEBMOB_common_ok, '');
        }
    }

    function handleStatusCode(status) {
        if (status === 204) {
            loadingValues();
        }
        if (recipeDataValidateSingle || recipeDataValidateDualUpper || recipeDataValidateDualLower || recipeDataValidateDualFlexUpper || recipeDataValidateDualFlexLower || recipeDataValidateLowerFlex) {
            showCurrentScreen();
        }
    }

    function requestFailHandler(response) {
        debugMessage(JSON.stringify(response));
        $scope.loadingBar = false;
        $scope.checkResponse = [];
    }

    function showConnectionFailurePopup() {
        debugMessage("showConnectionFailurePopup");
        showcustDialog(WALLOVEN_ALERT_STATE.ALERT_CONNECTION_ERROR, $scope.translation.WEBMOB_device_range_alarm_connection_failure_title, $scope.translation.WEBMOB_common_check_power_and_network, '', $scope.translation.WEBMOB_common_ok);
    }

    function closeConnectionFailurePopup() {
        $scope.showFullScreenPopup = false;
        scrollScreen();
    }

    function parseIdZeroData(deviceData) {
        debugMessage("parseIdZeroData");
        if (angular.isDefined(deviceData["description"])) {
            $scope.idZero.description = deviceData["description"];
        }
        if (angular.isDefined(deviceData["id"])) {
            $scope.idZero.id = deviceData["id"];
        }
        if (angular.isDefined(deviceData["Alarms"])) {
            if (angular.isDefined(deviceData["Alarms"][0])) {
                if (angular.isDefined(deviceData["Alarms"][0]["id"])) {
                    $scope.idZero.Alarms[0].id = deviceData["Alarms"][0]["id"];
                }
                if (angular.isDefined(deviceData["Alarms"][0]["code"])) {
                    $scope.idZero.Alarms[0].code = deviceData["Alarms"][0]["code"];
                    if ($scope.idZero.Alarms[0].code.indexOf("WO_E") !== -1) {
                        $scope.errorCode = getErrorCode($scope.idZero.Alarms[0].code);
                        if ($scope.errorCode !== '') {
                            debugMessage('idZero errorRemoved false');
                            errorRemoved = false;
                        }
                    }
                }
                if (angular.isDefined(deviceData["Alarms"][0]["alarmType"])) {
                    $scope.idZero.Alarms[0].alarmType = deviceData["Alarms"][0]["alarmType"];
                }
                if (angular.isDefined(deviceData["Alarms"][0]["triggeredTime"])) {
                    $scope.idZero.Alarms[0].triggeredTime = deviceData["Alarms"][0]["triggeredTime"];
                }
            }
        }
        if (angular.isDefined(deviceData["ConfigurationLink"])) {
            $scope.idZero.ConfigurationLink = deviceData["ConfigurationLink"];
        }
        if (angular.isDefined(deviceData["Diagnosis"])) {
            if (angular.isDefined(deviceData["Diagnosis"]["diagnosisStart"])) {
                $scope.idZero.Diagnosis.diagnosisStart = deviceData["Diagnosis"]["diagnosisStart"];
            }
            if ($scope.idZero.Diagnosis.diagnosisStart === "Ready") {
                if ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_SMART_CARE_PAGE || $scope.currentScreen === WALLOVEN_SCREENS.WALLOVENWALLOVEN_SMART_CARE_NO_ERROR_PAGESMART_CARE_PAGE) {
                    dismissLoadingBar(WALLOVEN_COMMANDS.smartCareDiagnosis);
                    $scope.currentScreen = WALLOVEN_SCREENS.WALLOVENWALLOVEN_SMART_CARE_NO_ERROR_PAGESMART_CARE_PAGE;
                    validateCurrentScreen('SmartCareNoErrorPage');
                }
            } else {
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_SMART_CARE_PAGE;
                validateCurrentScreen('SmartCarePage');
            }
        }
        if (angular.isDefined(deviceData["EnergyConsumption"])) {
            $scope.idZero.EnergyConsumption = deviceData["EnergyConsumption"];
        }
        if (angular.isDefined(deviceData["InformationLink"])) {
            $scope.idZero.InformationLink = deviceData["InformationLink"];
        }
        if (angular.isDefined(deviceData["Mode"])) {
            if (angular.isDefined(deviceData["Mode"]["modes"])) {
                $scope.idZero.Mode.modes = getSplitedMode(deviceData["Mode"]["modes"]);
            }
            if (angular.isDefined(deviceData["Mode"]["options"])) {
                parseDataDeviceidZeroModeOptions(deviceData["Mode"]["options"]);
            }
            if (angular.isDefined(deviceData["Mode"]["supportedModes"])) {
                $scope.idZero.Mode.supportedModes = deviceData["Mode"]["supportedModes"];
            }
        }
        if (angular.isDefined(deviceData["Operation"])) {
            if (angular.isDefined(deviceData["Operation"]["operationTime"])) {
                $scope.idZero.Operation.operationTime = deviceData["Operation"]["operationTime"];
                updateZeroProgress = true;
                dismissLoadingBar(WALLOVEN_COMMANDS.snoozeCookingTime);
                if ($scope.showFullScreenPopup) {
                    if ($scope.alertState === WALLOVEN_ALERT_STATE.ALERT_COOKING_SNOOZE) {
                        debugMessage("close snooze popup");
                        $scope.showFullScreenPopup = false;
                    }
                }
            }
            if (angular.isDefined(deviceData["Operation"]["remainingTime"])) {
                $scope.idZero.Operation.remainingTime = deviceData["Operation"]["remainingTime"];
            }
            if (angular.isDefined(deviceData["Operation"]["state"])) {
                if ($scope.samrtControlPopup || $scope.showMenuOptionPopup) {
                    if ($scope.idZero.Operation.state !== deviceData["Operation"]["state"]) {
                        $scope.samrtControlPopup = false;
                        $scope.showMenuOptionPopup = false;
                    }
                }
                $scope.idZero.Operation.state = deviceData["Operation"]["state"];
                if (deviceData["Operation"]["state"] === 'Ready') {
                    if ($scope.checkResponse.indexOf(WALLOVEN_COMMANDS.cancelCooking) !== -1) {
                        refreshDateAfterDone();
                        dismissLoadingBar(WALLOVEN_COMMANDS.cancelCooking);
                    }
                }
                if (deviceData["Operation"]["state"] === 'Run') {
                    dismissLoadingBar(WALLOVEN_COMMANDS.startCooking);
                    if ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_AUTOCOOK_DETAIL_SCREEN) {
                        setDataCurrentScreen();
                        showScreen();
                    }

                    /*
                     * If cooking starts from My favorite recipee detail page then go back to run page
                     */
                    if ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_MY_FAVORITE_RECIPE_DETAIL_PAGE) {
                        updateDisplayScreenData();
                        validateCurrentScreen('RunDetailPage');
                    }

                    //close menu popup if open in case of state RUN recieved from SET
                    $scope.wallOvenModeMenu && hideModeMenu();
                }
                dismissLoadingBar(WALLOVEN_COMMANDS.sendRecipetoOven);
                if ($scope.showFullScreenPopup) {
                    if ($scope.alertState === WALLOVEN_ALERT_STATE.ALERT_START_COOKING && deviceData["Operation"]["state"] === 'Run'
                            || $scope.alertState === WALLOVEN_ALERT_STATE.ALERT_CANCEL_COOKING && deviceData["Operation"]["state"] === 'Ready') {
                        debugMessage("close popup");
                        $scope.showFullScreenPopup = false;
                    }
                }

                //check for sabbath button enableon operation state notification
                $scope.enableSabbath = (($scope.idZero.Operation.state !== 'Run' || ($scope.idZero.Mode.modes[0] === 'Bake' && $scope.idZero.Operation.state === 'Run'))
                        && (($scope.idTwo.Mode.modes[0] === 'Bake' && $scope.idTwo.Operation.state === 'Run') || $scope.idTwo.Operation.state !== 'Run'));
            }
            if (angular.isDefined(deviceData["Operation"]["kidsLock"])) {
                $scope.idZero.Operation.kidsLock = deviceData["Operation"]["kidsLock"];
            }
            if (angular.isDefined(deviceData["Operation"]["power"])) {
                $scope.idZero.Operation.power = deviceData["Operation"]["power"];
            }
            if (angular.isDefined(deviceData["Operation"]["progressPercentage"])) {
                if ((deviceData["Operation"]["progressPercentage"] < $scope.idZero.Operation.progressPercentage || updateZeroProgress)
                        && $scope.idZero.Operation.progressPercentage < 99) {
                    if (updateZeroProgress) {
                        updateZeroProgress = false;
                        $scope.idZero.Operation.progressPercentage = deviceData["Operation"]["progressPercentage"];
                    }
                } else {
                    $scope.idZero.Operation.progressPercentage = deviceData["Operation"]["progressPercentage"];
                }
            }
            dismissLoadingBar(WALLOVEN_COMMANDS.runingCookingEdit);
        }
        if (angular.isDefined(deviceData["Oven"])) {
            if (angular.isDefined(deviceData["Oven"]["CustomRecipesLink"])) {
                $scope.idZero.Oven.CustomRecipesLink = deviceData["Oven"]["CustomRecipesLink"];
            }
            if (angular.isDefined(deviceData["Oven"]["state"])) {
                $scope.idZero.Oven.state = deviceData["Oven"]["state"];
                if ($scope.idZero.Oven.state !== 'Finish') {
                    if (($scope.bCookingFinished || $scope.bProgressCompletdNormal) && $scope.operationCompleteZero) {
                        $scope.operationCompleteZero = false;
                    }
                }
                if ($scope.idZero.Oven.state === 'Finish') {
                    if (selectedCavity === 'SINGLE' || selectedCavity === 'DUALUPPER' || selectedCavity === 'DUALFLEXUPPER') {
                        emptyValue();
                    }
                }
            }
            if (angular.isDefined(deviceData["Oven"]["recipe"])) {
                $scope.idZero.Oven.recipe = deviceData["Oven"]["recipe"];
            }
        }
        if (angular.isDefined(deviceData["connected"])) {
            $scope.idZero.connected = deviceData["connected"];
            hideInputBoxFocus();
            if (!justFirstTime && !$scope.appAtForeground) {
                refreshValue();
                //emptyValue();
            }
            if (deviceData["connected"] && $scope.idZero.Mode.options[0].meatprobe === "connected") {
                validateCurrentScreen('ProbeDividerErrorPage');
            }
        }
        if (angular.isDefined(deviceData["Device"])) {
            if ((angular.isDefined(deviceData["Device"]["connected"]))) {
                $scope.idZero.connected = deviceData["Device"]["connected"];
                hideInputBoxFocus();
                if (!justFirstTime && !$scope.appAtForeground) {
                    refreshValue();
                    //emptyValue();
                }
                if (deviceData["Device"]["connected"] && $scope.idZero.Mode.options[0].meatprobe === "connected") {
                    validateCurrentScreen('ProbeDividerErrorPage');
                }
            }
        }
        if (angular.isDefined(deviceData["name"])) {
            $scope.idZero.name = deviceData["name"];
        }
        if (angular.isDefined(deviceData["resources"])) {
            $scope.idZero.resources = deviceData["resources"];
            deviceData["resources"].forEach(function (value) {
                if (value.indexOf("Diagnosis") !== -1) {
                    $scope.showSmartCare = true;
                }
            });
        }
        if (angular.isDefined(deviceData["type"])) {
            $scope.idZero.type = deviceData["type"];
        }
        if (angular.isDefined(deviceData["uuid"])) {
            $scope.idZero.uuid = deviceData["uuid"];
        }
        if (angular.isDefined(deviceData["Temperatures"])) {
            if (angular.isDefined(deviceData["Temperatures"][0])) {
                if (deviceData["Temperatures"][0]["id"] === '0') {
                    if (angular.isDefined(deviceData["Temperatures"][0]["id"])) {
                        $scope.idZero.Temperatures[0].id = deviceData["Temperatures"][0]["id"];
                    }
                    if (angular.isDefined(deviceData["Temperatures"][0]["current"])) {
                        $scope.idZero.Temperatures[0].current = deviceData["Temperatures"][0]["current"];
                    }
                    if (angular.isDefined(deviceData["Temperatures"][0]["desired"])) {
                        $scope.idZero.Temperatures[0].desired = deviceData["Temperatures"][0]["desired"];
                        if ($scope.idOne.connected && $scope.idOne.Operation.state === 'Ready' && $scope.idZero.Operation.state === 'Run') {
                            $scope.dualFlexLowerDesiredTemp = Number($scope.idZero.Temperatures[0].desired) !== 0 ? Number($scope.idZero.Temperatures[0].desired) : $scope.dualFlexLowerDesiredTemp;
                            if ($scope.dualFlexLowerDesiredTemp === 0 || $scope.dualFlexLowerDesiredTemp === undefined) {
                                $scope.dualFlexLowerDesiredTemp = $scope.minTemp;
                            }
                            if ($scope.dualFlexLowerDesiredTemp === 61441) {
                                $scope.dualFlexLowerDesiredTemp = $scope.bFahrenheit ? 480 : 248;
                            }
                            if ($scope.dualFlexLowerDesiredTemp === 61442) {
                                $scope.dualFlexLowerDesiredTemp = $scope.bFahrenheit ? 400 : 204;
                            }
                            $scope.desiredTemp = $scope.dualFlexLowerDesiredTemp;
                            if (userPreferneceDualFlexLower.preferneceTemp) {
                                userPreferneceDualFlexLower.preferneceTemp = $scope.dualFlexLowerDesiredTemp;
                            }
                        }
                    }
                    if (angular.isDefined(deviceData["Temperatures"][0]["increment"])) {
                        $scope.idZero.Temperatures[0].increment = deviceData["Temperatures"][0]["increment"];
                    }
                    if (angular.isDefined(deviceData["Temperatures"][0]["unit"])) {
                        $scope.idZero.Temperatures[0].unit = deviceData["Temperatures"][0]["unit"];
                        setTempUnit($scope.idZero.Operation.state);
                        dismissLoadingBar(WALLOVEN_COMMANDS.changeTempUnit);
                    }
                }
                else if (deviceData["Temperatures"][0]["id"] === '1') {
                    if (angular.isDefined(deviceData["Temperatures"][0]["id"])) {
                        $scope.idZero.Temperatures[1].id = deviceData["Temperatures"][0]["id"];
                    }
                    if (angular.isDefined(deviceData["Temperatures"][0]["current"])) {
                        $scope.idZero.Temperatures[1].current = deviceData["Temperatures"][0]["current"];
                    }
                    if (angular.isDefined(deviceData["Temperatures"][0]["desired"])) {
                        $scope.idZero.Temperatures[1].desired = deviceData["Temperatures"][0]["desired"];
                    }
                    if (angular.isDefined(deviceData["Temperatures"][0]["increment"])) {
                        $scope.idZero.Temperatures[1].increment = deviceData["Temperatures"][0]["increment"];
                    }
                    if (angular.isDefined(deviceData["Temperatures"][0]["unit"])) {
                        $scope.idZero.Temperatures[1].unit = deviceData["Temperatures"][0]["unit"];
                    }
                }
            }
            if (angular.isDefined(deviceData["Temperatures"][1])) {
                if (angular.isDefined(deviceData["Temperatures"][1]["id"])) {
                    $scope.idZero.Temperatures[1].id = deviceData["Temperatures"][1]["id"];
                }
                if (angular.isDefined(deviceData["Temperatures"][1]["current"])) {
                    $scope.idZero.Temperatures[1].current = deviceData["Temperatures"][1]["current"];
                }
                if (angular.isDefined(deviceData["Temperatures"][1]["desired"])) {
                    $scope.idZero.Temperatures[1].desired = deviceData["Temperatures"][1]["desired"];
                }
                if (angular.isDefined(deviceData["Temperatures"][0]["increment"])) {
                    $scope.idZero.Temperatures[1].increment = deviceData["Temperatures"][0]["increment"];
                }
                if (angular.isDefined(deviceData["Temperatures"][1]["unit"])) {
                    $scope.idZero.Temperatures[1].unit = deviceData["Temperatures"][1]["unit"];
                    setTempUnit($scope.idZero.Operation.state);
                    dismissLoadingBar(WALLOVEN_COMMANDS.changeTempUnit);
                }
            }
            dismissLoadingBar(WALLOVEN_COMMANDS.runingCookingEdit);
        }
        if (angular.isDefined(deviceData["Doors"])) {
            if (angular.isDefined(deviceData["Doors"][0]) && angular.isDefined(deviceData["Doors"][0]["openState"])) {
                $scope.idZero.Doors[0].openState = deviceData["Doors"][0]["openState"];
                $scope.DoorOpen = $scope.idZero.Doors[0].openState === "Open" ? true : false;
                if ($scope.DoorOpen && !$scope.appAtForeground) {
                    showcustDialog(WALLOVEN_ALERT_STATE.ALERT_DOOR_OPEN, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_Walloven_door_open, '', $scope.translation.WEBMOB_common_ok);
                } else if ($scope.showFullScreenPopup && $scope.alertState === WALLOVEN_ALERT_STATE.ALERT_DOOR_OPEN) {
                    $scope.showFullScreenPopup = false;
                }
            }
        }
    }

    function parseIdOneData(deviceData) {
        debugMessage("parseIdOneData");
        if (angular.isDefined(deviceData["description"])) {
            $scope.idOne.description = deviceData["description"];
        }
        if (angular.isDefined(deviceData["id"])) {
            $scope.idOne.id = deviceData["id"];
        }
        if (angular.isDefined(deviceData["Alarms"])) {
            if (angular.isDefined(deviceData["Alarms"][0])) {
                if (angular.isDefined(deviceData["Alarms"][0]["id"])) {
                    $scope.idOne.Alarms[0].id = deviceData["Alarms"][0]["id"];
                }
                if (angular.isDefined(deviceData["Alarms"][0]["code"])) {
                    $scope.idOne.Alarms[0].code = deviceData["Alarms"][0]["code"];
                    if ($scope.idOne.Alarms[0].code.indexOf("WO_E") !== -1) {
                        $scope.errorCode = getErrorCode($scope.idOne.Alarms[0].code);
                        if ($scope.errorCode !== '') {
                            debugMessage('idOne errorRemoved false');
                            errorRemoved = false;
                        }
                    }
                }
                if (angular.isDefined(deviceData["Alarms"][0]["alarmType"])) {
                    $scope.idOne.Alarms[0].alarmType = deviceData["Alarms"][0]["alarmType"];
                }
                if (angular.isDefined(deviceData["Alarms"][0]["triggeredTime"])) {
                    $scope.idOne.Alarms[0].triggeredTime = deviceData["Alarms"][0]["triggeredTime"];
                }
            }
        }
        if (angular.isDefined(deviceData["ConfigurationLink"])) {
            $scope.idOne.ConfigurationLink = deviceData["ConfigurationLink"];
        }
        if (angular.isDefined(deviceData["EnergyConsumption"])) {
            $scope.idOne.EnergyConsumption = deviceData["EnergyConsumption"];
        }
        if (angular.isDefined(deviceData["InformationLink"])) {
            $scope.idOne.InformationLink = deviceData["InformationLink"];
        }
        if (angular.isDefined(deviceData["Mode"])) {
            if (angular.isDefined(deviceData["Mode"]["modes"])) {
                $scope.idOne.Mode.modes = getSplitedMode(deviceData["Mode"]["modes"]);
            }
            if (angular.isDefined(deviceData["Mode"]["options"])) {
                parseDataDeviceidOneModeOptions(deviceData["Mode"]["options"]);
            }
        }
        if (angular.isDefined(deviceData["Operation"])) {
            if (angular.isDefined(deviceData["Operation"]["operationTime"])) {
                $scope.idOne.Operation.operationTime = deviceData["Operation"]["operationTime"];
                updateOneProgress = true;
                dismissLoadingBar(WALLOVEN_COMMANDS.snoozeCookingTime);
                if ($scope.showFullScreenPopup) {
                    if ($scope.alertState === WALLOVEN_ALERT_STATE.ALERT_COOKING_SNOOZE) {
                        debugMessage("close snooze popup");
                        $scope.showFullScreenPopup = false;
                    }
                }
            }
            if (angular.isDefined(deviceData["Operation"]["remainingTime"])) {
                $scope.idOne.Operation.remainingTime = deviceData["Operation"]["remainingTime"];
            }
            if (angular.isDefined(deviceData["Operation"]["state"])) {
                if ($scope.samrtControlPopup || $scope.showMenuOptionPopup) {
                    if ($scope.idOne.Operation.state !== deviceData["Operation"]["state"]) {
                        $scope.samrtControlPopup = false;
                        $scope.showMenuOptionPopup = false;
                    }
                }
                $scope.idOne.Operation.state = deviceData["Operation"]["state"];
                if (deviceData["Operation"]["state"] === 'Ready') {
                    if ($scope.checkResponse.indexOf(WALLOVEN_COMMANDS.cancelCooking) !== -1) {
                        refreshDateAfterDone();
                        dismissLoadingBar(WALLOVEN_COMMANDS.cancelCooking);
                    }
                }
                if (deviceData["Operation"]["state"] === 'Run') {
                    dismissLoadingBar(WALLOVEN_COMMANDS.startCooking);
                    //close menu popup if open in case of state RUN recieved from SET
                    $scope.wallOvenModeMenu && hideModeMenu();

                    /*
                     * If cooking starts from My favorite recipee detail page then go back to run page
                     */
                    if ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_MY_FAVORITE_RECIPE_DETAIL_PAGE) {
                        updateDisplayScreenData();
                        validateCurrentScreen('RunDetailPage');
                    }
                }
                dismissLoadingBar(WALLOVEN_COMMANDS.sendRecipetoOven);
                if ($scope.showFullScreenPopup) {
                    if ($scope.alertState === WALLOVEN_ALERT_STATE.ALERT_START_COOKING && deviceData["Operation"]["state"] === 'Run'
                            || $scope.alertState === WALLOVEN_ALERT_STATE.ALERT_CANCEL_COOKING && deviceData["Operation"]["state"] === 'Ready') {
                        debugMessage("close popup");
                        $scope.showFullScreenPopup = false;
                    }
                }
            }
            if (angular.isDefined(deviceData["Operation"]["kidsLock"])) {
                $scope.idOne.Operation.kidsLock = deviceData["Operation"]["kidsLock"];
            }
            if (angular.isDefined(deviceData["Operation"]["power"])) {
                $scope.idOne.Operation.power = deviceData["Operation"]["power"];
            }
            if (angular.isDefined(deviceData["Operation"]["progressPercentage"])) {
                if ((deviceData["Operation"]["progressPercentage"] < $scope.idOne.Operation.progressPercentage || updateOneProgress)
                        && $scope.idOne.Operation.progressPercentage < 99) {
                    if (updateOneProgress) {
                        updateOneProgress = false;
                        $scope.idOne.Operation.progressPercentage = deviceData["Operation"]["progressPercentage"];
                    }
                } else {
                    $scope.idOne.Operation.progressPercentage = deviceData["Operation"]["progressPercentage"];
                }
            }
            dismissLoadingBar(WALLOVEN_COMMANDS.runingCookingEdit);
        }
        if (angular.isDefined(deviceData["Oven"])) {
            if (angular.isDefined(deviceData["Oven"]["CustomRecipesLink"])) {
                $scope.idOne.Oven.CustomRecipesLink = deviceData["Oven"]["CustomRecipesLink"];
            }
            if (angular.isDefined(deviceData["Oven"]["state"])) {
                $scope.idOne.Oven.state = deviceData["Oven"]["state"];
                if ($scope.idOne.Oven.state !== 'Finish') {
                    if (($scope.bCookingFinished || $scope.bProgressCompletdNormal) && $scope.operationCompleteOne) {
                        $scope.operationCompleteOne = false;
                    }
                }
                if ($scope.idOne.Oven.state === 'Finish') {
                    if (selectedCavity === 'DUALFLEXLOWER') {
                        emptyValue();
                    }
                }
            }
            if (angular.isDefined(deviceData["Oven"]["recipe"])) {
                $scope.idOne.Oven.recipe = deviceData["Oven"]["recipe"];
            }
        }
        if (angular.isDefined(deviceData["connected"])) {
            $scope.idOne.connected = deviceData["connected"];
            hideInputBoxFocus();
            if (!justFirstTime && !$scope.appAtForeground) {
                selectedCavity = '';
                emptyValue();
                refreshValue();
                userPreferneceDualUpper = {};
                userPreferneceDualFlexUpper = {};
                userPreferneceDualFlexLower = {};
                wOvenDualUpperBaseMode = "ConvectionBake";
                wOvenDualFlexUpperBaseMode = "ConvectionBake";
                wOvenDualFlexLowerBaseMode = "Bake";
                setValueForDualUpperMode();
                setValueForDualFlexUpperMode();
                setValueForDualFlexLowerMode();
            }
        }
        if (angular.isDefined(deviceData["Device"])) {
            if (angular.isDefined(deviceData["Device"]["connected"])) {
                $scope.idOne.connected = deviceData["Device"]["connected"];
                hideInputBoxFocus();
                if (!justFirstTime && !$scope.appAtForeground) {
                    selectedCavity = '';
                    emptyValue();
                    refreshValue();
                    userPreferneceDualUpper = {};
                    userPreferneceDualFlexUpper = {};
                    userPreferneceDualFlexLower = {};
                    wOvenDualUpperBaseMode = "ConvectionBake";
                    wOvenDualFlexUpperBaseMode = "ConvectionBake";
                    wOvenDualFlexLowerBaseMode = "Bake";
                    setValueForDualUpperMode();
                    setValueForDualFlexUpperMode();
                    setValueForDualFlexLowerMode();
                }
            }
        }
        if (angular.isDefined(deviceData["name"])) {
            $scope.idOne.name = deviceData["name"];
        }
        if (angular.isDefined(deviceData["resources"])) {
            $scope.idOne.resources = deviceData["resources"];
        }
        if (angular.isDefined(deviceData["type"])) {
            $scope.idOne.type = deviceData["type"];
        }
        if (angular.isDefined(deviceData["uuid"])) {
            $scope.idOne.uuid = deviceData["uuid"];
        }
        if (angular.isDefined(deviceData["Temperatures"])) {
            if (angular.isDefined(deviceData["Temperatures"][0])) {
                if (angular.isDefined(deviceData["Temperatures"][0]["id"])) {
                    $scope.idOne.Temperatures[0].id = deviceData["Temperatures"][0]["id"];
                }
                if (angular.isDefined(deviceData["Temperatures"][0]["current"])) {
                    $scope.idOne.Temperatures[0].current = deviceData["Temperatures"][0]["current"];
                }
                if (angular.isDefined(deviceData["Temperatures"][0]["desired"])) {
                    $scope.idOne.Temperatures[0].desired = deviceData["Temperatures"][0]["desired"];
                    if ($scope.idOne.connected && $scope.idZero.Operation.state === 'Ready' && $scope.idOne.Operation.state === 'Run') {
                        $scope.dualFlexUpperDesiredTemp = Number($scope.idOne.Temperatures[0].desired) !== 0 ? Number($scope.idOne.Temperatures[0].desired) : $scope.dualFlexUpperDesiredTemp;
                        if ($scope.dualFlexUpperDesiredTemp === 0 || $scope.dualFlexUpperDesiredTemp === undefined) {
                            $scope.dualFlexUpperDesiredTemp = $scope.minTemp;
                        }
                        if ($scope.dualFlexUpperDesiredTemp === 61441) {
                            $scope.dualFlexUpperDesiredTemp = $scope.bFahrenheit ? 480 : 248;
                        }
                        if ($scope.dualFlexUpperDesiredTemp === 61442) {
                            $scope.dualFlexUpperDesiredTemp = $scope.bFahrenheit ? 400 : 204;
                        }
                        $scope.desiredTemp = $scope.dualFlexUpperDesiredTemp;
                        if (userPreferneceDualFlexUpper.preferneceTemp) {
                            userPreferneceDualFlexUpper.preferneceTemp = $scope.dualFlexUpperDesiredTemp;
                        }
                    }
                }
                if (angular.isDefined(deviceData["Temperatures"][0]["increment"])) {
                    $scope.idOne.Temperatures[0].increment = deviceData["Temperatures"][0]["increment"];
                }
                if (angular.isDefined(deviceData["Temperatures"][0]["unit"])) {
                    $scope.idOne.Temperatures[0].unit = deviceData["Temperatures"][0]["unit"];
                    setTempUnit($scope.idOne.Operation.state);
                    dismissLoadingBar(WALLOVEN_COMMANDS.changeTempUnit);
                }
            }
            dismissLoadingBar(WALLOVEN_COMMANDS.runingCookingEdit);
        }
        if (angular.isDefined(deviceData["Doors"])) {
            if (angular.isDefined(deviceData["Doors"][0]) && angular.isDefined(deviceData["Doors"][0]["openState"])) {
                $scope.idOne.Doors[0].openState = deviceData["Doors"][0]["openState"];
                $scope.DoorOpen = $scope.idOne.Doors[0].openState === "Open" ? true : false;
                if ($scope.DoorOpen && !$scope.appAtForeground) {
                    showcustDialog(WALLOVEN_ALERT_STATE.ALERT_DOOR_OPEN, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_Walloven_door_open, '', $scope.translation.WEBMOB_common_ok);
                } else if ($scope.showFullScreenPopup && $scope.alertState === WALLOVEN_ALERT_STATE.ALERT_DOOR_OPEN) {
                    $scope.showFullScreenPopup = false;
                }
            }
        }

    }

    function parseIdTwoData(deviceData) {
        debugMessage("parseIdTwoData");
        if (angular.isDefined(deviceData["description"])) {
            $scope.idTwo.description = deviceData["description"];
        }
        if (angular.isDefined(deviceData["id"])) {
            $scope.idTwo.id = deviceData["id"];
        }
        if (angular.isDefined(deviceData["Alarms"])) {
            if (angular.isDefined(deviceData["Alarms"][0])) {
                if (angular.isDefined(deviceData["Alarms"][0]["id"])) {
                    $scope.idTwo.Alarms[0].id = deviceData["Alarms"][0]["id"];
                }
                if (angular.isDefined(deviceData["Alarms"][0]["code"])) {
                    $scope.idTwo.Alarms[0].code = deviceData["Alarms"][0]["code"];
                    if ($scope.idTwo.Alarms[0].code.indexOf("WO_E") !== -1) {
                        $scope.errorCode = getErrorCode($scope.idTwo.Alarms[0].code);
                        if ($scope.errorCode !== '') {
                            debugMessage('idTwo errorRemoved false');
                            errorRemoved = false;
                        }
                    }
                }
                if (angular.isDefined(deviceData["Alarms"][0]["alarmType"])) {
                    $scope.idTwo.Alarms[0].alarmType = deviceData["Alarms"][0]["alarmType"];
                }
                if (angular.isDefined(deviceData["Alarms"][0]["triggeredTime"])) {
                    $scope.idTwo.Alarms[0].triggeredTime = deviceData["Alarms"][0]["triggeredTime"];
                }
            }
        }
        if (angular.isDefined(deviceData["ConfigurationLink"])) {
            $scope.idTwo.ConfigurationLink = deviceData["ConfigurationLink"];
        }
        if (angular.isDefined(deviceData["EnergyConsumption"])) {
            $scope.idTwo.EnergyConsumption = deviceData["EnergyConsumption"];
        }
        if (angular.isDefined(deviceData["InformationLink"])) {
            $scope.idTwo.InformationLink = deviceData["InformationLink"];
        }
        if (angular.isDefined(deviceData["Mode"])) {
            if (angular.isDefined(deviceData["Mode"]["modes"])) {
                $scope.idTwo.Mode.modes = getSplitedMode(deviceData["Mode"]["modes"]);
            }
            if (angular.isDefined(deviceData["Mode"]["options"])) {
                parseDataDeviceidTwoModeOptions(deviceData["Mode"]["options"]);
            }
        }
        if (angular.isDefined(deviceData["Operation"])) {
            if (angular.isDefined(deviceData["Operation"]["operationTime"])) {
                $scope.idTwo.Operation.operationTime = deviceData["Operation"]["operationTime"];
                updateTwoProgress = true;
                dismissLoadingBar(WALLOVEN_COMMANDS.snoozeCookingTime);
                if ($scope.showFullScreenPopup) {
                    if ($scope.alertState === WALLOVEN_ALERT_STATE.ALERT_COOKING_SNOOZE) {
                        debugMessage("close snooze popup");
                        $scope.showFullScreenPopup = false;
                    }
                }
            }
            if (angular.isDefined(deviceData["Operation"]["remainingTime"])) {
                $scope.idTwo.Operation.remainingTime = deviceData["Operation"]["remainingTime"];
            }
            if (angular.isDefined(deviceData["Operation"]["state"])) {
                if ($scope.samrtControlPopup || $scope.showMenuOptionPopup) {
                    if ($scope.idTwo.Operation.state !== deviceData["Operation"]["state"]) {
                        $scope.samrtControlPopup = false;
                        $scope.showMenuOptionPopup = false;
                    }
                }
                $scope.idTwo.Operation.state = deviceData["Operation"]["state"];
                if (deviceData["Operation"]["state"] === 'Ready') {
                    if ($scope.checkResponse.indexOf(WALLOVEN_COMMANDS.cancelCooking) !== -1) {
                        refreshDateAfterDone();
                        dismissLoadingBar(WALLOVEN_COMMANDS.cancelCooking);
                    }
                }
                if (deviceData["Operation"]["state"] === 'Run') {
                    dismissLoadingBar(WALLOVEN_COMMANDS.startCooking);
                    if ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_AUTOCOOK_DETAIL_SCREEN) {
                        setDataCurrentScreen();
                        showScreen();
                    }
                    //close menu popup if open in case of state RUN recieved from SET
                    $scope.wallOvenModeMenu && hideModeMenu();

                    /*
                     * If cooking starts from My favorite recipee detail page then go back to run page
                     */
                    if ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_MY_FAVORITE_RECIPE_DETAIL_PAGE) {
                        updateDisplayScreenData();
                        validateCurrentScreen('RunDetailPage');
                    }
                }
                dismissLoadingBar(WALLOVEN_COMMANDS.sendRecipetoOven);
                if ($scope.showFullScreenPopup) {
                    if ($scope.alertState === WALLOVEN_ALERT_STATE.ALERT_START_COOKING && deviceData["Operation"]["state"] === 'Run'
                            || $scope.alertState === WALLOVEN_ALERT_STATE.ALERT_CANCEL_COOKING && deviceData["Operation"]["state"] === 'Ready') {
                        debugMessage("close popup");
                        $scope.showFullScreenPopup = false;
                    }
                }
                //check for sabbath button enable 
                $scope.enableSabbath = (($scope.idTwo.Operation.state !== 'Run' || ($scope.idTwo.Mode.modes[0] === 'Bake' && $scope.idTwo.Operation.state === 'Run'))
                        && (($scope.idZero.Mode.modes[0] === 'Bake' && $scope.idZero.Operation.state === 'Run') || $scope.idZero.Operation.state !== 'Run'));
            }
            if (angular.isDefined(deviceData["Operation"]["kidsLock"])) {
                $scope.idTwo.Operation.kidsLock = deviceData["Operation"]["kidsLock"];
            }
            if (angular.isDefined(deviceData["Operation"]["power"])) {
                $scope.idTwo.Operation.power = deviceData["Operation"]["power"];
            }
            if (angular.isDefined(deviceData["Operation"]["progressPercentage"])) {
                if ((deviceData["Operation"]["progressPercentage"] < $scope.idTwo.Operation.progressPercentage || updateTwoProgress)
                        && $scope.idTwo.Operation.progressPercentage < 99) {
                    if (updateTwoProgress) {
                        updateTwoProgress = false;
                        $scope.idTwo.Operation.progressPercentage = deviceData["Operation"]["progressPercentage"];
                    }
                } else {
                    $scope.idTwo.Operation.progressPercentage = deviceData["Operation"]["progressPercentage"];
                }
            }
            dismissLoadingBar(WALLOVEN_COMMANDS.runingCookingEdit);
        }
        if (angular.isDefined(deviceData["Oven"])) {
            if (angular.isDefined(deviceData["Oven"]["CustomRecipesLink"])) {
                $scope.idTwo.Oven.CustomRecipesLink = deviceData["Oven"]["CustomRecipesLink"];
            }
            if (angular.isDefined(deviceData["Oven"]["state"])) {
                $scope.idTwo.Oven.state = deviceData["Oven"]["state"];
                if ($scope.idTwo.Oven.state !== 'Finish') {
                    if (($scope.bCookingFinished || $scope.bProgressCompletdNormal) && $scope.operationCompleteTwo) {
                        $scope.operationCompleteTwo = false;
                    }
                }
                if ($scope.idTwo.Oven.state === 'Finish') {
                    if (selectedCavity === 'LOWERFLEX' || selectedCavity === 'DUALLOWER') {
                        emptyValue();
                    }
                }
            }
            if (angular.isDefined(deviceData["Oven"]["recipe"])) {
                $scope.idTwo.Oven.recipe = deviceData["Oven"]["recipe"];
            }
        }
        if (angular.isDefined(deviceData["connected"])) {
            $scope.idTwo.connected = deviceData["connected"];
            if ($scope.idTwo.connected) { //in case lower is connected then make configuration call
                lowerCavityConfigCall();
            }
        }
        if (angular.isDefined(deviceData["Device"])) {
            if (angular.isDefined(deviceData["Device"]["connected"])) {
                $scope.idTwo.connected = deviceData["Device"]["connected"];
                if ($scope.idTwo.connected) { //in case lower is connected then make configuration call
                    lowerCavityConfigCall();
                }
            }
        }

        if (angular.isDefined(deviceData["name"])) {
            $scope.idTwo.name = deviceData["name"];
        }
        if (angular.isDefined(deviceData["resources"])) {
            $scope.idTwo.resources = deviceData["resources"];
        }
        if (angular.isDefined(deviceData["type"])) {
            $scope.idTwo.type = deviceData["type"];
        }
        if (angular.isDefined(deviceData["uuid"])) {
            $scope.idTwo.uuid = deviceData["uuid"];
        }
        if (angular.isDefined(deviceData["Temperatures"])) {
            if (angular.isDefined(deviceData["Temperatures"][0])) {
                if (angular.isDefined(deviceData["Temperatures"][0]["id"])) {
                    $scope.idTwo.Temperatures[0].id = deviceData["Temperatures"][0]["id"];
                }
                if (angular.isDefined(deviceData["Temperatures"][0]["current"])) {
                    $scope.idTwo.Temperatures[0].current = deviceData["Temperatures"][0]["current"];
                }
                if (angular.isDefined(deviceData["Temperatures"][0]["desired"])) {
                    $scope.idTwo.Temperatures[0].desired = deviceData["Temperatures"][0]["desired"];
                }
                if (angular.isDefined(deviceData["Temperatures"][0]["increment"])) {
                    $scope.idTwo.Temperatures[0].increment = deviceData["Temperatures"][0]["increment"];
                }
                if (angular.isDefined(deviceData["Temperatures"][0]["unit"])) {
                    $scope.idTwo.Temperatures[0].unit = deviceData["Temperatures"][0]["unit"];
                    setTempUnit($scope.idTwo.Operation.state);
                    dismissLoadingBar(WALLOVEN_COMMANDS.changeTempUnit);
                }
            }
            dismissLoadingBar(WALLOVEN_COMMANDS.runingCookingEdit);
        }
        if (angular.isDefined(deviceData["Doors"])) {
            if (angular.isDefined(deviceData["Doors"][0]) && angular.isDefined(deviceData["Doors"][0]["openState"])) {
                $scope.idTwo.Doors[0].openState = deviceData["Doors"][0]["openState"];
                $scope.DoorOpen = $scope.idTwo.Doors[0].openState === "Open" ? true : false;
                if ($scope.DoorOpen && !$scope.appAtForeground) {
                    showcustDialog(WALLOVEN_ALERT_STATE.ALERT_DOOR_OPEN, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_Walloven_door_open, '', $scope.translation.WEBMOB_common_ok);
                } else if ($scope.showFullScreenPopup && $scope.alertState === WALLOVEN_ALERT_STATE.ALERT_DOOR_OPEN) {
                    $scope.showFullScreenPopup = false;
                }
            }
        }

    }

    function getErrorCode(errorEnum) {
        switch (errorEnum) {
            case 'WO_E_C-d0':
                return "C-d0";
            case 'WO_E_C-20': //FALL-THROUGH
                return "C-20";
            case 'WO_E_C-21': //FALL-THROUGH
                return "C-21";
            case 'WO_E_C-23':
                return "C-23";
            case 'WO_E_C-70':
                return "C-70";
            case 'WO_E_C-d1':
                return "C-d1";
            case 'WO_E_-dC-':
                return "-dC-";
            case 'WO_E_C-F0': //FALL-THROUGH
                return "C-F0";
            case 'WO_E_007A':
                return "C-72";
            case 'WO_E_C-F2':
                return "C-F2";
            case 'WO_E_C-A2':
                return "C-A2";
            case 'WO_E_C-30':
                return "C-30";
            case 'WO_E_C-31':
                return "C-31";
            case 'WO_E_fff': //FALL-THROUGH
            case 'undefined':
            default:
                return "";
        }
    }

    function getAlarmStatusIdZero() {
        if ($scope.idZero.Alarms[0] !== undefined && $scope.idZero.Alarms[0] !== null && $scope.idZero.Alarms[0].code !== '-1') {
            debugMessage('Check for alarm status 0 :' + $scope.idZero.Alarms[0].code);

            if ($scope.idZero.Alarms[0].code === 'WO_E') {
                if (snoozIdZero) {
                    debugMessage('snoozIdZero available');
                    return;
                }
                $scope.idZero.Alarms[0].code = '-1';
                errorRemoved = true;
                return false;
            }

            if (!errorRemoved) {
                debugMessage('Check error status');
                return;
            }

            if ($scope.idZero.Alarms[0].code.indexOf("WO_E") !== -1) {
                $scope.errorCode = getErrorCode($scope.idZero.Alarms[0].code);
                if ($scope.errorCode !== '') {
                    errorRemoved = false;
                    validateCurrentScreen('ErrorPage');
                    return true;
                } else {
                    return false;
                }
            } else if ($scope.idZero.Alarms[0].code === "WO_T_0001") {
                showcustDialog(WALLOVEN_ALERT_STATE.ALERT_PREHEATCOMPLETE, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_range_alarm_finish_preheating, $scope.translation.WEBMOB_common_ok, '');
                $scope.idZero.Alarms[0].code = '-1';
                setDataCurrentScreen();
                return true;
            } else if ($scope.idZero.Alarms[0].code === "WO_T_0003") {
                closeOperationState();
                $scope.bCookingFinished = true;
                $scope.showProgressBar = true;
                $scope.operationCompleteZero = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cooking_finish_message";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idZero.Alarms[0].code === "WO_T_0004") {
                snoozIdZero = true;
                showcustDialog(WALLOVEN_ALERT_STATE.ALERT_COOKING_SNOOZE, $scope.translation.WEBMOB_device_range_alarm_finish_snooze_title, $scope.translation.WEBMOB_device_range_alarm_finish_snooze, $scope.translation.WEBMOB_common_cancel, $scope.translation.WEBMOB_device_range_comm_finish_snooze_min);
                $scope.idZero.Alarms[0].code = '-1';
                return true;
            } else if ($scope.idZero.Alarms[0].code === "WO_T_0005") { // TODO EXTRA
                closeOperationState();
                $scope.bProgressCompletdNormal = true;
                $scope.operationCompleteZero = true;
                $scope.operationCompletedorCanceledMSG = "OVENMOB_LCD_CookingFinishAlarm";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idZero.Alarms[0].code === "WO_T_0006") {
                closeOperationState();
                $scope.bCookingCancelled = true;
                $scope.operationCompleteZero = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cooking_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idZero.Alarms[0].code === "WO_T_0007" || $scope.idZero.Alarms[0].code === "WO_T_0011") {
                closeOperationState();
                $scope.bCleaningFinished = true;
                $scope.operationCompleteZero = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cleaning_completed";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idZero.Alarms[0].code === "WO_T_0008" || $scope.idZero.Alarms[0].code === "WO_T_0012") {
                closeOperationState();
                $scope.bCleaningCancelled = true;
                $scope.operationCompleteZero = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cleaning_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idZero.Alarms[0].code === "WO_T_0014") {
                closeOperationState();
                $scope.bCleaningCancelled = true;
                $scope.operationCompleteZero = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cleaning_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idZero.Alarms[0].code === "WO_T_0040") {
                closeOperationState();
                $scope.bCookingCancelled = true;
                $scope.operationCompleteZero = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_warming_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idZero.Alarms[0].code === "WO_T_0050") {
                closeOperationState();
                $scope.bProgressCompletdNormal = true;
                $scope.operationCompleteZero = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_walloven_descale_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idZero.Alarms[0].code === "WO_T_0015") {
                closeOperationState();
                $scope.specialFinish = true;
                $scope.secondLevelText = true;
                $scope.bCookingFinished = true;
                $scope.operationCompleteZero = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_walloven_descale_seventh_descale_complete_text";
                $scope.operationCompletedorCanceledSecondMSG = "WEBMOB_device_Walloven_descale_complete_guide";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idZero.Alarms[0].code === "WO_T_0016") {
                closeOperationState();
                $scope.specialFinish = true;
                $scope.secondLevelText = true;
                $scope.bCookingFinished = true;
                $scope.operationCompleteZero = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_Walloven_hydro_easy_clean_complete";
                $scope.operationCompletedorCanceledSecondMSG = "WEBMOB_device_Walloven_hydro_easy_clean_complete_guide";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idZero.Alarms[0].code === "WO_T_0017") {
                closeOperationState();
                $scope.specialFinish = true;
                $scope.bCookingFinished = true;
                $scope.operationCompleteZero = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_walloven_drain_finish";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idZero.Alarms[0].code === "WO_T_0060") {
                closeOperationState();
                $scope.bProgressCompletdNormal = true;
                $scope.operationCompleteZero = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_walloven_pyro_free_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idZero.Alarms[0].code === "WO_T_0070") {
                closeOperationState();
                $scope.bProgressCompletdNormal = true;
                $scope.operationCompleteZero = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_walloven_drain_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idZero.Alarms[0].code === "WO_T_0081" || $scope.idZero.Alarms[0].code === "WO_T_0082") {
                showcustDialog(WALLOVEN_ALERT_STATE.ALERT_GOURMET_RECIPE_ALARM_81_82, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_walloven_gourmet_popup_81_82, $scope.translation.WEBMOB_common_ok, '');
                $scope.idZero.Alarms[0].code = '-1';
                setDataCurrentScreen();
                return true;
            } else if ($scope.idZero.Alarms[0].code === "WO_T_0083") {
                showcustDialog(WALLOVEN_ALERT_STATE.ALERT_GOURMET_RECIPE_ALARM_83, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_walloven_gourmet_popup_83, $scope.translation.WEBMOB_common_ok, '');
                $scope.idZero.Alarms[0].code = '-1';
                setDataCurrentScreen();
                return true;
            } else {
                return false;
            }
        }
        return false;
    }

    function getAlarmStatusIdOne() {
        if ($scope.idOne.Alarms[0] !== undefined && $scope.idOne.Alarms[0] !== null && $scope.idOne.Alarms[0].code !== '-1') {
            debugMessage('Check for alarm status 1 :' + $scope.idOne.Alarms[0].code);

            if ($scope.idOne.Alarms[0].code === 'WO_E') {
                if (snoozIdOne) {
                    debugMessage('snoozIdOne available');
                    return;
                }
                $scope.idOne.Alarms[0].code = '-1';
                errorRemoved = true;
                return false;
            }

            if (!errorRemoved) {
                debugMessage('Check error status');
                return;
            }

            if ($scope.idOne.Alarms[0].code.indexOf("WO_E") !== -1) {
                $scope.errorCode = getErrorCode($scope.idOne.Alarms[0].code);
                if ($scope.errorCode !== '') {
                    errorRemoved = false;
                    validateCurrentScreen('ErrorPage');
                    return true;
                } else {
                    return false;
                }
            } else if ($scope.idOne.Alarms[0].code === "WO_T_0001") {
                showcustDialog(WALLOVEN_ALERT_STATE.ALERT_PREHEATCOMPLETE, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_range_alarm_finish_preheating, $scope.translation.WEBMOB_common_ok, '');
                $scope.idOne.Alarms[0].code = '-1';
                setDataCurrentScreen();
                return true;
            } else if ($scope.idOne.Alarms[0].code === "WO_T_0003") {
                closeOperationState();
                $scope.bCookingFinished = true;
                $scope.showProgressBar = true;
                $scope.operationCompleteOne = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cooking_finish_message";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idOne.Alarms[0].code === "WO_T_0004") {
                snoozIdOne = true;
                showcustDialog(WALLOVEN_ALERT_STATE.ALERT_COOKING_SNOOZE, $scope.translation.WEBMOB_device_range_alarm_finish_snooze_title, $scope.translation.WEBMOB_device_range_alarm_finish_snooze, $scope.translation.WEBMOB_common_cancel, $scope.translation.WEBMOB_device_range_comm_finish_snooze_min);
                $scope.idOne.Alarms[0].code = '-1';
                return true;
            } else if ($scope.idOne.Alarms[0].code === "WO_T_0005") { // TODO EXTRA
                closeOperationState();
                $scope.bProgressCompletdNormal = true;
                $scope.operationCompleteOne = true;
                $scope.operationCompletedorCanceledMSG = "OVENMOB_LCD_CookingFinishAlarm";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idOne.Alarms[0].code === "WO_T_0006") {
                closeOperationState();
                $scope.bCookingCancelled = true;
                $scope.operationCompleteOne = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cooking_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idOne.Alarms[0].code === "WO_T_0007") {
                closeOperationState();
                $scope.bCleaningFinished = true;
                $scope.operationCompleteLower = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cleaning_completed";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idOne.Alarms[0].code === "WO_T_0008") {
                closeOperationState();
                $scope.bCleaningCancelled = true;
                $scope.operationCompleteOne = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cleaning_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idOne.Alarms[0].code === "WO_T_0014") {
                closeOperationState();
                $scope.bCleaningCancelled = true;
                $scope.operationCompleteOne = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cleaning_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idOne.Alarms[0].code === "WO_T_0040") {
                closeOperationState();
                $scope.bCookingCancelled = true;
                $scope.operationCompleteOne = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_warming_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idOne.Alarms[0].code === "WO_T_0050") {
                closeOperationState();
                $scope.bProgressCompletdNormal = true;
                $scope.operationCompleteOne = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_walloven_descale_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idOne.Alarms[0].code === "WO_T_0015") {
                closeOperationState();
                $scope.specialFinish = true;
                $scope.secondLevelText = true;
                $scope.bCookingFinished = true;
                $scope.operationCompleteOne = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_walloven_descale_seventh_descale_complete_text";
                $scope.operationCompletedorCanceledSecondMSG = "WEBMOB_device_Walloven_descale_complete_guide";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idOne.Alarms[0].code === "WO_T_0016") {
                closeOperationState();
                $scope.specialFinish = true;
                $scope.secondLevelText = true;
                $scope.bCookingFinished = true;
                $scope.operationCompleteOne = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_Walloven_hydro_easy_clean_complete";
                $scope.operationCompletedorCanceledSecondMSG = "WEBMOB_device_Walloven_hydro_easy_clean_complete_guide";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idOne.Alarms[0].code === "WO_T_0017") {
                closeOperationState();
                $scope.specialFinish = true;
                $scope.bCookingFinished = true;
                $scope.operationCompleteOne = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_walloven_drain_finish";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idOne.Alarms[0].code === "WO_T_0060") {
                closeOperationState();
                $scope.bProgressCompletdNormal = true;
                $scope.operationCompleteOne = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_walloven_pyro_free_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idOne.Alarms[0].code === "WO_T_0070") {
                closeOperationState();
                $scope.bProgressCompletdNormal = true;
                $scope.operationCompleteOne = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_walloven_drain_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else {
                return false;
            }
        }
        return false;
    }

    function getAlarmStatusIdTwo() {
        if ($scope.idTwo.Alarms[0] !== undefined && $scope.idTwo.Alarms[0] !== null && $scope.idTwo.Alarms[0].code !== '-1') {
            debugMessage('Check for alarm status 2 :' + $scope.idTwo.Alarms[0].code);

            if ($scope.idTwo.Alarms[0].code === 'WO_E') {
                if (snoozIdTwo) {
                    debugMessage('snoozIdTwo available');
                    return;
                }
                $scope.idTwo.Alarms[0].code = '-1';
                errorRemoved = true;
                return false;
            }

            if (!errorRemoved) {
                debugMessage('Check error status');
                return;
            }

            if ($scope.idTwo.Alarms[0].code.indexOf("WO_E") !== -1) {
                $scope.errorCode = getErrorCode($scope.idTwo.Alarms[0].code);
                if ($scope.errorCode !== '') {
                    errorRemoved = false;
                    validateCurrentScreen('ErrorPage');
                    return true;
                } else {
                    return false;
                }
            } else if ($scope.idTwo.Alarms[0].code === "WO_T_0001") {
                $scope.upperPreheat = false;
                $scope.lowerPreheat = true;
                showcustDialog(WALLOVEN_ALERT_STATE.ALERT_PREHEATCOMPLETE, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_range_alarm_finish_preheating, $scope.translation.WEBMOB_common_ok, '');
                $scope.idTwo.Alarms[0].code = '-1';
                setDataCurrentScreen();
                return true;
            } else if ($scope.idTwo.Alarms[0].code === "WO_T_0003") {
                closeOperationState();
                $scope.bCookingFinished = true;
                $scope.showProgressBar = true;
                $scope.operationCompleteTwo = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cooking_finish_message";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idTwo.Alarms[0].code === "WO_T_0004") {
                snoozIdTwo = true;
                showcustDialog(WALLOVEN_ALERT_STATE.ALERT_COOKING_SNOOZE, $scope.translation.WEBMOB_device_range_alarm_finish_snooze_title, $scope.translation.WEBMOB_device_range_alarm_finish_snooze, $scope.translation.WEBMOB_common_cancel, $scope.translation.WEBMOB_device_range_comm_finish_snooze_min);
                $scope.idTwo.Alarms[0].code = '-1';
                return true;
            } else if ($scope.idTwo.Alarms[0].code === "WO_T_0005") { // TODO EXTRA
                closeOperationState();
                $scope.bProgressCompletdNormal = true;
                $scope.operationCompleteTwo = true;
                $scope.operationCompletedorCanceledMSG = "OVENMOB_LCD_CookingFinishAlarm";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idTwo.Alarms[0].code === "WO_T_0006") {
                closeOperationState();
                $scope.bCookingCancelled = true;
                $scope.operationCompleteTwo = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cooking_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idTwo.Alarms[0].code === "WO_T_0007") {
                closeOperationState();
                $scope.bCleaningFinished = true;
                $scope.operationCompleteTwo = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cleaning_completed";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idTwo.Alarms[0].code === "WO_T_0008") {
                closeOperationState();
                $scope.bCleaningCancelled = true;
                $scope.operationCompleteTwo = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cleaning_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idTwo.Alarms[0].code === "WO_T_0014") {
                closeOperationState();
                $scope.bCleaningCancelled = true;
                $scope.operationCompleteTwo = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_cleaning_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idTwo.Alarms[0].code === "WO_T_0040") {
                closeOperationState();
                $scope.bCookingCancelled = true;
                $scope.operationCompleteTwo = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_range_warming_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idOne.Alarms[0].code === "WO_T_0050") {
                closeOperationState();
                $scope.bProgressCompletdNormal = true;
                $scope.operationCompleteTwo = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_walloven_descale_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idTwo.Alarms[0].code === "WO_T_0015") {
                closeOperationState();
                $scope.specialFinish = true;
                $scope.secondLevelText = true;
                $scope.bCookingFinished = true;
                $scope.operationCompleteTwo = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_walloven_descale_seventh_descale_complete_text";
                $scope.operationCompletedorCanceledSecondMSG = "WEBMOB_device_Walloven_descale_complete_guide";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idTwo.Alarms[0].code === "WO_T_0016") {
                closeOperationState();
                $scope.specialFinish = true;
                $scope.secondLevelText = true;
                $scope.bCookingFinished = true;
                $scope.operationCompleteTwo = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_Walloven_hydro_easy_clean_complete";
                $scope.operationCompletedorCanceledSecondMSG = "WEBMOB_device_Walloven_hydro_easy_clean_complete_guide";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idTwo.Alarms[0].code === "WO_T_0017") {
                closeOperationState();
                $scope.specialFinish = true;
                $scope.bCookingFinished = true;
                $scope.operationCompleteTwo = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_walloven_drain_finish";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idTwo.Alarms[0].code === "WO_T_0060") {
                closeOperationState();
                $scope.bProgressCompletdNormal = true;
                $scope.operationCompleteTwo = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_walloven_pyro_free_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idTwo.Alarms[0].code === "WO_T_0070") {
                closeOperationState();
                $scope.bProgressCompletdNormal = true;
                $scope.operationCompleteTwo = true;
                $scope.operationCompletedorCanceledMSG = "WEBMOB_device_walloven_drain_canceled";
                validateOperationCompletionStateScreen();
                return true;
            } else if ($scope.idTwo.Alarms[0].code === "WO_T_0081" || $scope.idTwo.Alarms[0].code === "WO_T_0082") {
                showcustDialog(WALLOVEN_ALERT_STATE.ALERT_GOURMET_RECIPE_ALARM_81_82, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_walloven_gourmet_popup_81_82, $scope.translation.WEBMOB_common_ok, '');
                $scope.idTwo.Alarms[0].code = '-1';
                setDataCurrentScreen();
                return true;
            } else if ($scope.idTwo.Alarms[0].code === "WO_T_0083") {
                showcustDialog(WALLOVEN_ALERT_STATE.ALERT_GOURMET_RECIPE_ALARM_83, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_walloven_gourmet_popup_83, $scope.translation.WEBMOB_common_ok, '');
                $scope.idTwo.Alarms[0].code = '-1';
                setDataCurrentScreen();
                return true;
            } else {
                return false;
            }
        }
        return false;
    }

    function closeOperationState() {
        debugMessage("closeOperationState");
        if (snoozIdZero) {
            $scope.showFullScreenPopup = false;
        }
        if (snoozIdTwo) {
            $scope.showFullScreenPopup = false;
        }
        if (snoozIdOne) {
            $scope.showFullScreenPopup = false;
        }
        $scope.upperPreheat = false;
        $scope.lowerPreheat = false;
        $scope.specialFinish = false;
        $scope.secondLevelText = false;
        $scope.bCleaningCancelled = false;
        $scope.bCleaningFinished = false;
        $scope.bCookingCancelled = false;
        $scope.bCookingFinished = false;
        $scope.bProgressCompletdNormal = false;
        $scope.bWarmingCancelled = false;
        $scope.showProgressBar = false;
    }

    function validateOperationCompletionStateScreen() {
        debugMessage("validateOperationCompletionStateScreen");
        if (selectedCavity === '') {// assign one cavity
            if ($scope.idZero.Alarms[0].code !== "-1") {
                if ($scope.idOne.connected) {
                    selectedCavity = 'DUALFLEXUPPER';
                } else if ($scope.idTwo.connected && !$scope.idOne.connected) {
                    selectedCavity = 'DUALUPPER';
                } else {
                    selectedCavity = 'SINGLE';
                }
            } else if ($scope.idTwo.Alarms[0].code !== "-1") {
                if ($scope.idOne.connected) {
                    selectedCavity = 'LOWERFLEX';
                } else {
                    selectedCavity = 'DUALLOWER';
                }

            } else if ($scope.idOne.Alarms[0].code !== "-1") {
                selectedCavity = 'DUALFLEXLOWER';
            }
        }

        validateCurrentScreen('OperationCompletePage');
    }

    function operationCompleteButton() {
        debugMessage("operationCompleteButton");
        if (selectedCavity === 'SINGLE' && $scope.idZero.Oven.state === 'Finish') {
            cancelCookingConfirmed(0);
            userPreferneceSingle = {};
            wOvenSingleBaseMode = "Bake";
            $scope.DisplayContents = getModeRowValue($scope.supportedModesSingle, wOvenSingleBaseMode);
            getValueForSingleMode();
            updateDisplayScreenData();
            $scope.idZero.Alarms[0].code = '-1';
            if ($scope.idZero.Operation.state !== "Ready") {
                return;
            }
        } else if (selectedCavity === 'DUALUPPER' && $scope.idZero.Oven.state === 'Finish') {
            cancelCookingConfirmed(0);
            userPreferneceDualUpper = {};
            wOvenDualUpperBaseMode = "ConvectionBake";
            $scope.DisplayContents = getModeRowValue($scope.supportedModesDualUpper, wOvenDualUpperBaseMode);
            getValueForDualUpperMode();
            updateDisplayScreenData();
            $scope.idZero.Alarms[0].code = '-1';
            if ($scope.idZero.Operation.state !== "Ready") {
                return;
            }
        } else if (selectedCavity === 'DUALLOWER' && $scope.idTwo.Oven.state === 'Finish') {
            cancelCookingConfirmed(2);
            userPreferneceDualLower = {};
            debugMessage("refreshDateAfterDone " + userPreferneceDualLower);
            wOvenDualLowerBaseMode = "Bake";
            $scope.DisplayContents = getModeRowValue($scope.supportedModesDualLower, wOvenDualLowerBaseMode);
            getValueForDualLowerMode();
            updateDisplayScreenData();
            $scope.idTwo.Alarms[0].code = '-1';
            if ($scope.idTwo.Operation.state !== "Ready") {
                return;
            }
        } else if (selectedCavity === 'DUALFLEXUPPER' && $scope.idZero.Oven.state === 'Finish') {
            cancelCookingConfirmed(0);
            userPreferneceDualFlexUpper = {};
            debugMessage("refreshDateAfterDone " + userPreferneceDualFlexUpper);
            wOvenDualFlexUpperBaseMode = "ConvectionBake";
            $scope.DisplayContents = getModeRowValue($scope.supportedModesDualUpperFlex, wOvenDualFlexUpperBaseMode);
            getValueForDualFlexUpperMode();
            updateDisplayScreenData();
            $scope.idZero.Alarms[0].code = '-1';
            if ($scope.idZero.Operation.state !== "Ready") {
                return;
            }
        } else if (selectedCavity === 'DUALFLEXLOWER' && $scope.idOne.Oven.state === 'Finish') {
            cancelCookingConfirmed(1);
            userPreferneceDualFlexLower = {};
            debugMessage("refreshDateAfterDone " + userPreferneceDualFlexLower);
            wOvenDualFlexLowerBaseMode = "Bake";
            $scope.DisplayContents = getModeRowValue($scope.supportedModesDualLowerFlex, wOvenDualFlexLowerBaseMode);
            getValueForDualFlexLowerMode();
            updateDisplayScreenData();
            $scope.idOne.Alarms[0].code = '-1';
            if ($scope.idOne.Operation.state !== "Ready") {
                return;
            }
        } else if (selectedCavity === 'LOWERFLEX' && $scope.idTwo.Oven.state === 'Finish') {
            cancelCookingConfirmed(2);
            userPreferneceDualLower = {};
            debugMessage("refreshDateAfterDone " + userPreferneceDualLower);
            wOvenDualLowerBaseMode = "Bake";
            $scope.DisplayContents = getModeRowValue($scope.supportedModesDualLower, wOvenDualLowerBaseMode);
            getValueForDualLowerMode();
            updateDisplayScreenData();
            $scope.idTwo.Alarms[0].code = '-1';
            if ($scope.idTwo.Operation.state !== "Ready") {
                return;
            }
        } else {
            //TODO
        }
        emptyAlarm();
        showCurrentScreen();
        refreshDateAfterDone();
        updateDisplayScreenData();
        showScreen();
    }

    function emptyValue() {
        $scope.displayReadyMode = '';//preference.preferneceMode;
        $scope.desiredTemp = 0;//preference.preferneceTemp;
        $scope.desiredProbeTemp = 0;//preference.preferneceProbeTemp;
        $scope.desiredHours = '';//preference.preferneceHR;
        $scope.desiredMinutes = '';//preference.preferneceMin;
    }

    function getProbeDividerError() {
        return false;
    }

    function getValueForSingleMode(mode) {
        $scope.singleCavityFunction = getModeRowValue($scope.supportedModesSingle, wOvenSingleBaseMode);
        debugMessage("getValueForSingleMode " + $scope.ovenFunctionContentsSingle);
        $scope.singleMode = $scope.singleCavityFunction[4];
        $scope.singleModeText = $scope.singleCavityFunction[5];
        $scope.singleModeSupport = $scope.singleCavityFunction[1] === 'TRUE' && $scope.idZero.Mode.options[0].meatprobe === "connected";
        $scope.singleReadyRecipeDescription = $scope.singleCavityFunction[2];
        var newdate = new Date();
        newdate.setHours(0, $scope.singleCavityFunction[19], 0);
        $scope.singleDesiredHours = Number(newdate.getHours());
        $scope.singleDesiredMinutes = Number(newdate.getMinutes());
        if ($scope.TempUnit === "F") {
            $scope.singleDesiredTemp = $scope.singleCavityFunction[13];
            $scope.singleMinTemp = $scope.singleCavityFunction[14];
            $scope.singleMaxTemp = $scope.singleCavityFunction[15];
            $scope.singleDesiredProbeTemp = 150;
            $scope.singleMinProbeTemp = 100;
            $scope.singleMaxProbeTemp = 200;
        } else {
            $scope.singleDesiredTemp = $scope.singleCavityFunction[16];
            $scope.singleMinTemp = $scope.singleCavityFunction[17];
            $scope.singleMaxTemp = $scope.singleCavityFunction[18];
            $scope.singleDesiredProbeTemp = 65;
            $scope.singleMinProbeTemp = 40;
            $scope.singleMaxProbeTemp = 90;
        }
        if (!userPreferneceSingle.preferneceMode) {
            saveUserValueSingle($scope.singleMode, $scope.singleDesiredTemp, $scope.singleDesiredProbeTemp, $scope.singleDesiredHours, $scope.singleDesiredMinutes, false);
        } else {
            $scope.singleMode = userPreferneceSingle.preferneceMode;
            $scope.singleDesiredTemp = userPreferneceSingle.preferneceTemp;
            $scope.singleDesiredProbeTemp = userPreferneceSingle.preferneceProbeTemp;
            $scope.singleDesiredHours = userPreferneceSingle.preferneceHR;
            $scope.singleDesiredMinutes = userPreferneceSingle.preferneceMin;
        }
    }

    function getValueForDualUpperMode(mode) {
        $scope.dualUpperCavityFunction = getModeRowValue($scope.supportedModesDualUpper, wOvenDualUpperBaseMode);
        debugMessage("getValueForDualUpperMode " + $scope.dualUpperCavityFunction);
        $scope.dualUpperMode = $scope.dualUpperCavityFunction[4];
        $scope.dualUpperModeText = $scope.dualUpperCavityFunction[5];
        $scope.dualUpperModeSupport = $scope.dualUpperCavityFunction[1] === 'TRUE' && $scope.idZero.Mode.options[0].meatprobe === "connected";
        $scope.dualUpperReadyRecipeDescription = $scope.dualUpperCavityFunction[2];
        var newdate = new Date();
        newdate.setHours(0, $scope.dualUpperCavityFunction[19], 0);
        $scope.dualUpperDesiredHours = Number(newdate.getHours());
        $scope.dualUpperDesiredMinutes = Number(newdate.getMinutes());
        if ($scope.TempUnit === "F") {
            $scope.dualUpperDesiredTemp = $scope.dualUpperCavityFunction[13];
            $scope.dualUpperMinTemp = $scope.dualUpperCavityFunction[14];
            $scope.dualUpperMaxTemp = $scope.dualUpperCavityFunction[15];
            $scope.dualUpperDesiredProbeTemp = 150;
            $scope.dualUpperMinProbeTemp = 100;
            $scope.dualUpperMaxProbeTemp = 200;
        } else {
            $scope.dualUpperDesiredTemp = $scope.dualUpperCavityFunction[16];
            $scope.dualUpperMinTemp = $scope.dualUpperCavityFunction[17];
            $scope.dualUpperMaxTemp = $scope.dualUpperCavityFunction[18];
            $scope.dualUpperDesiredProbeTemp = 65;
            $scope.dualUpperMinProbeTemp = 40;
            $scope.dualUpperMaxProbeTemp = 90;
        }
        if (!userPreferneceDualUpper.preferneceMode) {
            saveUserValueDualUpper($scope.dualUpperMode, $scope.dualUpperDesiredTemp, $scope.dualUpperDesiredProbeTemp, $scope.dualUpperDesiredHours, $scope.dualUpperDesiredMinutes, false);
        } else {
            $scope.dualUpperMode = userPreferneceDualUpper.preferneceMode;
            $scope.dualUpperDesiredTemp = userPreferneceDualUpper.preferneceTemp;
            $scope.dualUpperDesiredProbeTemp = userPreferneceDualUpper.preferneceProbeTemp;
            $scope.dualUpperDesiredHours = userPreferneceDualUpper.preferneceHR;
            $scope.dualUpperDesiredMinutes = userPreferneceDualUpper.preferneceMin;
        }
    }

    function getValueForDualLowerMode(mode) {
        $scope.dualLowerCavityFunction = getModeRowValue($scope.supportedModesDualLower, wOvenDualLowerBaseMode);
        debugMessage("getValueForDualLowerMode " + $scope.dualLowerCavityFunction);
        $scope.dualLowerMode = $scope.dualLowerCavityFunction[4];
        $scope.dualLowerModeText = $scope.dualLowerCavityFunction[5];
        $scope.dualLowerReadyRecipeDescription = $scope.dualLowerCavityFunction[2];
        var newdate = new Date();
        newdate.setHours(0, $scope.dualLowerCavityFunction[19], 0);
        $scope.dualLowerDesiredHours = Number(newdate.getHours());
        $scope.dualLowerDesiredMinutes = Number(newdate.getMinutes());
        if ($scope.TempUnit === "F") {
            $scope.dualLowerDesiredTemp = $scope.dualLowerCavityFunction[13];
            $scope.dualLowerMinTemp = $scope.dualLowerCavityFunction[14];
            $scope.dualLowerMaxTemp = $scope.dualLowerCavityFunction[15];
            $scope.dualLowerDesiredProbeTemp = 150;
            $scope.dualLowerMinProbeTemp = 100;
            $scope.dualLowerMaxProbeTemp = 200;
        } else {
            $scope.dualLowerDesiredTemp = $scope.dualLowerCavityFunction[16];
            $scope.dualLowerMinTemp = $scope.dualLowerCavityFunction[17];
            $scope.dualLowerMaxTemp = $scope.dualLowerCavityFunction[18];
            $scope.dualLowerDesiredProbeTemp = 65;
            $scope.dualLowerMinProbeTemp = 40;
            $scope.dualLowerMaxProbeTemp = 90;
        }
        if (!userPreferneceDualLower.preferneceMode) {
            saveUserValueDualLower($scope.dualLowerMode, $scope.dualLowerDesiredTemp, $scope.dualLowerDesiredProbeTemp, $scope.dualLowerDesiredHours, $scope.dualLowerDesiredMinutes, false);
        } else {
            $scope.dualLowerMode = userPreferneceDualLower.preferneceMode;
            $scope.dualLowerDesiredTemp = userPreferneceDualLower.preferneceTemp;
            $scope.dualLowerDesiredProbeTemp = userPreferneceDualLower.preferneceProbeTemp;
            $scope.dualLowerDesiredHours = userPreferneceDualLower.preferneceHR;
            $scope.dualLowerDesiredMinutes = userPreferneceDualLower.preferneceMin;
        }
    }

    function getValueForDualFlexUpperMode(mode) {
        $scope.dualFlexUpperCavityFunction = getModeRowValue($scope.supportedModesDualUpperFlex, wOvenDualFlexUpperBaseMode);
        debugMessage("getValueForDualFlexUpperMode " + $scope.dualFlexUpperCavityFunction);
        $scope.dualFlexUpperMode = $scope.dualFlexUpperCavityFunction[4];
        $scope.dualFlexUpperModeText = $scope.dualFlexUpperCavityFunction[5];
        $scope.dualFlexUodeSupport = $scope.dualFlexUpperCavityFunction[1] === 'TRUE' && $scope.idZero.Mode.options[0].meatprobe === "connected";
        $scope.dualFlexUpperReadyRecipeDescription = $scope.dualFlexUpperCavityFunction[2];
        var newdate = new Date();
        newdate.setHours(0, $scope.dualFlexUpperCavityFunction[19], 0);
        $scope.dualFlexUpperDesiredHours = Number(newdate.getHours());
        $scope.dualFlexUpperDesiredMinutes = Number(newdate.getMinutes());
        if ($scope.TempUnit === "F") {
            $scope.dualFlexUpperDesiredTemp = $scope.dualFlexUpperCavityFunction[13];
            $scope.dualFlexUpperMinTemp = $scope.dualFlexUpperCavityFunction[14];
            $scope.dualFlexUpperMaxTemp = $scope.dualFlexUpperCavityFunction[15];
            $scope.dualFlexUpperDesiredProbeTemp = 150;
            $scope.dualFlexUpperMinProbeTemp = 100;
            $scope.dualFlexUpperMaxProbeTemp = 200;
        } else {
            $scope.dualFlexUpperDesiredTemp = $scope.dualFlexUpperCavityFunction[16];
            $scope.dualFlexUpperMinTemp = $scope.dualFlexUpperCavityFunction[17];
            $scope.dualFlexUpperMaxTemp = $scope.dualFlexUpperCavityFunction[18];
            $scope.dualFlexUpperDesiredProbeTemp = 65;
            $scope.dualFlexUpperMinProbeTemp = 40;
            $scope.dualFlexUpperMaxProbeTemp = 90;
        }
        if ($scope.idOne.Operation.state === 'Run' && $scope.idZero.Operation.state === 'Ready') {
            $scope.dualFlexUpperMinTemp = setMinTempValue($scope.idOne.Temperatures[0].desired);
            $scope.dualFlexUpperMaxTemp = setMaxTempValue($scope.idOne.Temperatures[0].desired);
            //if ($scope.dualFlexUpperDesiredTemp > $scope.dualFlexUpperMaxTemp || $scope.dualFlexUpperDesiredTemp < $scope.dualFlexUpperMinTemp) {
            $scope.dualFlexUpperDesiredTemp = Number($scope.idOne.Temperatures[0].desired) !== 0 ? Number($scope.idOne.Temperatures[0].desired) : $scope.dualFlexUpperDesiredTemp;
            userPreferneceDualFlexUpper.preferneceTemp = $scope.dualFlexUpperDesiredTemp;
            //}
            if ($scope.dualFlexUpperDesiredTemp === 0 || $scope.dualFlexUpperDesiredTemp === undefined) {
                $scope.dualFlexUpperDesiredTemp = $scope.minTemp;
            }
            if ($scope.dualFlexUpperDesiredTemp === 61441) {
                $scope.dualFlexUpperDesiredTemp = $scope.bFahrenheit ? 480 : 248;
            }
            if ($scope.dualFlexUpperDesiredTemp === 61442) {
                $scope.dualFlexUpperDesiredTemp = $scope.bFahrenheit ? 400 : 204;
            }
        }
        if (!userPreferneceDualFlexUpper.preferneceMode) {
            saveUserValueDualFlexUpper($scope.dualFlexUpperMode, $scope.dualFlexUpperDesiredTemp, $scope.dualFlexUpperDesiredProbeTemp, $scope.dualFlexUpperDesiredHours, $scope.dualFlexUpperDesiredMinutes, false);
        } else {
            $scope.dualFlexUpperMode = userPreferneceDualFlexUpper.preferneceMode;
            $scope.dualFlexUpperDesiredTemp = userPreferneceDualFlexUpper.preferneceTemp;
            $scope.dualFlexUpperDesiredProbeTemp = userPreferneceDualFlexUpper.preferneceProbeTemp;
            $scope.dualFlexUpperDesiredHours = userPreferneceDualFlexUpper.preferneceHR;
            $scope.dualFlexUpperDesiredMinutes = userPreferneceDualFlexUpper.preferneceMin;
        }
    }

    function getValueForDualFlexLowerMode(mode) {
        $scope.dualFlexLowerCavityFunction = getModeRowValue($scope.supportedModesDualLowerFlex, wOvenDualFlexLowerBaseMode);
        debugMessage("getValueForDualFlexLowerMode " + $scope.dualFlexLowerCavityFunction);
        $scope.dualFlexLowerMode = $scope.dualFlexLowerCavityFunction[4];
        $scope.dualFlexLowerModeText = $scope.dualFlexLowerCavityFunction[5];
        $scope.dualFlexLowerReadyRecipeDescription = $scope.dualFlexLowerCavityFunction[2];
        var newdate = new Date();
        newdate.setHours(0, $scope.dualFlexLowerCavityFunction[19], 0);
        $scope.dualFlexLowerDesiredHours = Number(newdate.getHours());
        $scope.dualFlexLowerDesiredMinutes = Number(newdate.getMinutes());
        if ($scope.TempUnit === "F") {
            $scope.dualFlexLowerDesiredTemp = $scope.dualFlexLowerCavityFunction[13];
            $scope.dualFlexLowerMinTemp = $scope.dualFlexLowerCavityFunction[14];
            $scope.dualFlexLowerMaxTemp = $scope.dualFlexLowerCavityFunction[15];
            $scope.dualFlexLowerDesiredProbeTemp = 150;
            $scope.dualFlexLowerMinProbeTemp = 100;
            $scope.dualFlexLowerMaxProbeTemp = 200;
        } else {
            $scope.dualFlexLowerDesiredTemp = $scope.dualFlexLowerCavityFunction[16];
            $scope.dualFlexLowerMinTemp = $scope.dualFlexLowerCavityFunction[17];
            $scope.dualFlexLowerMaxTemp = $scope.dualFlexLowerCavityFunction[18];
            $scope.dualFlexLowerDesiredProbeTemp = 65;
            $scope.dualFlexLowerMinProbeTemp = 40;
            $scope.dualFlexLowerMaxProbeTemp = 90;
        }
        if ($scope.idOne.Operation.state === 'Ready' && $scope.idZero.Operation.state === 'Run') {
            $scope.dualFlexLowerMinTemp = setMinTempValue($scope.idZero.Temperatures[0].desired);
            $scope.dualFlexLowerMaxTemp = setMaxTempValue($scope.idZero.Temperatures[0].desired);
            //if ($scope.dualFlexLowerDesiredTemp > $scope.dualFlexLowerMaxTemp || $scope.dualFlexLowerDesiredTemp < $scope.dualFlexLowerMinTemp) {
            $scope.dualFlexLowerDesiredTemp = Number($scope.idZero.Temperatures[0].desired) !== 0 ? Number($scope.idZero.Temperatures[0].desired) : $scope.dualFlexLowerDesiredTemp;
            //}
            if ($scope.dualFlexLowerDesiredTemp === 0 || $scope.dualFlexLowerDesiredTemp === undefined) {
                $scope.dualFlexLowerDesiredTemp = $scope.minTemp;
            }
            if ($scope.dualFlexLowerDesiredTemp === 61441) {
                $scope.dualFlexLowerDesiredTemp = $scope.bFahrenheit ? 480 : 248;
            }
            if ($scope.dualFlexLowerDesiredTemp === 61442) {
                $scope.dualFlexLowerDesiredTemp = $scope.bFahrenheit ? 400 : 204;
            }
        }
        if (!userPreferneceDualFlexLower.preferneceMode) {
            saveUserValueDualFlexLower($scope.dualFlexLowerMode, $scope.dualFlexLowerDesiredTemp, $scope.dualFlexLowerDesiredProbeTemp, $scope.dualFlexLowerDesiredHours, $scope.dualFlexLowerDesiredMinutes, false);
        } else {
            $scope.dualFlexLowerMode = userPreferneceDualFlexLower.preferneceMode;
            $scope.dualFlexLowerDesiredTemp = userPreferneceDualFlexLower.preferneceTemp;
            $scope.dualFlexLowerDesiredProbeTemp = userPreferneceDualFlexLower.preferneceProbeTemp;
            $scope.dualFlexLowerDesiredHours = userPreferneceDualFlexLower.preferneceHR;
            $scope.dualFlexLowerDesiredMinutes = userPreferneceDualFlexLower.preferneceMin;
        }
    }

    function getSplitedMode(mode) {
        if (mode[0].indexOf('Upper') !== -1 || mode[0].indexOf('Lower') !== -1) {
            return  [mode[0].substring(5)];
        }
        return mode;
    }

    function getModeRowValue(list, mode) {
        if (list === undefined || list.length === 0) {
            list = $scope.WALLOVEN_TABEL;
        }
        for (var i = 0; i < list.length; i++) {
            if (list[i][4] === mode) {
                return list[i];
            }
        }
    }

    function getModeTextFromTabel(mode, id) {
        if (mode === 'NoOperation' || mode === '') {
            mode = 'ConvectionBake';
        }
        if (mode === 'Autocook') {
            return getAutoCookModeText(id);
        }
        for (var i = 0; i < $scope.WALLOVEN_TABEL.length; i++) {
            if ($scope.WALLOVEN_TABEL[i][4] === mode) {
                debugMessage("getModeTextFromTabel text " + $scope.WALLOVEN_TABEL[i][5]);
                return $scope.WALLOVEN_TABEL[i][5];
            }
        }
    }

    function getProbeSupportFromTabel(mode) {
        for (var i = 0; i < $scope.WALLOVEN_TABEL.length; i++) {
            if ($scope.WALLOVEN_TABEL[i][4] === $scope.idZero.Mode.modes[0]) {
                debugMessage("mode " + mode + "supports probe " + $scope.WALLOVEN_TABEL[i][1] === 'TRUE');
                return ($scope.WALLOVEN_TABEL[i][1] === 'TRUE') && $scope.idZero.Mode.options[0].meatprobe === "connected";
            }
        }
    }

    function getAutoCookModeText(id) {
        var recipeId = id === 2 ? (($scope.idTwo.Oven.recipe).substring(4, 6)) : (($scope.idZero.Oven.recipe).substring(4, 6));
        for (var i = 0; i < $scope.AutoCookData.length; i++) {
            if ($scope.AutoCookData[i].recipeId === recipeId) {
                return $scope.AutoCookData[i].title;
            }
        }
        return 'WEBMOB_device_range_auto_cook';
    }

    function getDescaleLevelStep(descaleState) {
        debugMessage("getDescaleLevelStep " + descaleState);
        if (descaleState === 'Standby' || descaleState === 'SupplyLimeWater') {
            return 1;
        } else if (descaleState === 'WaitFirstDescaleTime' || descaleState === 'DrainAndResupplyLimeWater' || descaleState === 'WaitSecondDescaleTime') {
            return 2;
        } else if (descaleState === 'DrainLimeWater') {
            return 3;
        } else if (descaleState === 'WaitDrawLimeTank' || descaleState === 'WaitInsertLimeTank') {
            return 4;
        } else if (descaleState === 'SupplyCleanWater' || descaleState === 'DrainCleanWate' || descaleState === 'FailCleanWaterSensing') {
            return 5;
        } else if (descaleState === 'WaitDrawCleanTank') {
            return 6;
        } else if (descaleState === 'End') {
            return 7;
        } else if (descaleState === 'FailWaterSensing') {
            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_DESCALE_FAIL, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_walloven_descale_more_water_popup_text, $scope.translation.WEBMOB_common_ok, '');
            return 1;
        } else {
            return 2;
        }
    }

    function getSupportedModeList() {
        switch (selectedCavity) {
            case 'SINGLE' ://SINGLE
                return $scope.supportedModesSingle;
                break;
            case 'DUALUPPER' ://DUAL UPPER
                return $scope.supportedModesDualUpper;
                break;
            case 'DUALLOWER' ://DUAL LOWER
                return $scope.supportedModesDualLower;
                break;
            case 'DUALFLEXUPPER' ://FLEX UPPER
                return $scope.supportedModesDualUpperFlex;
                break;
            case 'DUALFLEXLOWER' ://FLEX LOWER
                return $scope.supportedModesDualLowerFlex;
                break;
            case 'LOWERFLEX' ://LOWER FLEX
                return $scope.supportedModesDualLower;
                break;
            default :
                return $scope.WALLOVEN_TABEL;
                break;
        }
    }

    function getDefaultMode() {
        var defaultMode = "ConvectionBake";
        switch (selectedCavity) {
            case 'SINGLE' ://SINGLE
            case 'DUALLOWER' ://DUAL LOWER 
            case 'DUALFLEXLOWER' ://FLEX LOWER
            case 'LOWERFLEX' ://LOWER FLEX    
                defaultMode = "Bake";
                break;
            case 'DUALUPPER' ://DUAL UPPER
            case 'DUALFLEXUPPER' ://FLEX UPPER
                defaultMode = "ConvectionBake";
                break;
            default :
                break;
        }
        return defaultMode;
    }

    function setValueForSingleMode() {
        debugMessage("setValueForSingleMode");
        if ($scope.idZero.Operation.state !== 'Run') {
            getValueForSingleMode(wOvenSingleBaseMode);
            $scope.singleRunOperationState = $scope.idZero.Operation.state;
        } else {
            $scope.singleMode = $scope.idZero.Mode.modes[0];
            $scope.singleModeText = getModeTextFromTabel($scope.idZero.Mode.modes[0], 0);
            $scope.singleModeSupport = getProbeSupportFromTabel($scope.idZero.Mode.modes[0]);
            $scope.singleRunOvenState = $scope.idZero.Oven.state;
            $scope.singleRunOperationState = $scope.idZero.Operation.state;
            $scope.singleRunProgressDescription = $scope.idZero.Oven.state;
            $scope.singleRunCurrentTemp = $scope.idZero.Temperatures[0].current;
            $scope.singleRunDesiredTemp = $scope.idZero.Temperatures[0].desired;
            $scope.singleRunProbeCurrentTemp = $scope.idZero.Temperatures[1].current;
            $scope.singleRunProbeDesiredTemp = $scope.idZero.Temperatures[1].desired;
            $scope.singleRunDesiredRemainingHr = Number(($scope.idZero.Operation.remainingTime).split(':')[0]);
            $scope.singleRunDesiredRemainingMin = Number(($scope.idZero.Operation.remainingTime).split(':')[1]);
            $scope.singleRunOpetaionTime = convertTimeHMMformat($scope.idZero.Operation.operationTime);
            $scope.singleRunRemainingTime = convertTimeHMMformat($scope.idZero.Operation.remainingTime);
            $scope.singleRunOneMinute = $scope.singleRunOpetaionTime !== '0:00' && $scope.singleRunRemainingTime === '0:00';
            $scope.singleRunLeftTime = claculateLeftTime($scope.idZero.Operation.remainingTime);
            $scope.singleRunProgressBarPercentage = $scope.idZero.Operation.progressPercentage;
            if ($scope.singleRunProbeDesiredTemp === 0) {
                $scope.singleRunProbeDesiredTemp = $scope.desiredProbeTemp;
            }
            if (Number($scope.singleRunDesiredTemp) > 61440) {
                $scope.singleRunDesiredTemp = Number($scope.singleRunDesiredTemp) === 61442 ? $scope.translation.WEBMOB_device_range_low : $scope.translation.WEBMOB_device_range_high;
            }
            if ($scope.singleMode.indexOf("asycook3") !== -1) {
                $scope.singleMode = $scope.translation.WEBMOB_device_range_easy_cook_bread_proof;
            }
        }
        idZeroOperationState();
    }

    function setValueForDualUpperMode() {
        debugMessage("setValueForDualUpperMode");
        if ($scope.idZero.Operation.state !== 'Run') {
            getValueForDualUpperMode(wOvenDualUpperBaseMode);
            $scope.dualUpperRunOperationState = $scope.idZero.Operation.state;
        } else {
            $scope.dualUpperMode = $scope.idZero.Mode.modes[0];
            $scope.dualUpperModeText = getModeTextFromTabel($scope.idZero.Mode.modes[0], 0);
            $scope.dualUpperModeSupport = getProbeSupportFromTabel($scope.idZero.Mode.modes[0]);
            $scope.dualUpperRunOvenState = $scope.idZero.Oven.state;
            $scope.dualUpperRunOperationState = $scope.idZero.Operation.state;
            $scope.dualUpperRunProgressDescription = $scope.idZero.Oven.state;
            $scope.dualUpperRunCurrentTemp = $scope.idZero.Temperatures[0].current;
            $scope.dualUpperRunDesiredTemp = $scope.idZero.Temperatures[0].desired;
            $scope.dualUpperRunProbeCurrentTemp = $scope.idZero.Temperatures[1].current;
            $scope.dualUpperRunProbeDesiredTemp = $scope.idZero.Temperatures[1].desired;
            $scope.dualUpperRunDesiredRemainingHr = Number(($scope.idZero.Operation.remainingTime).split(':')[0]);
            $scope.dualUpperRunDesiredRemainingMin = Number(($scope.idZero.Operation.remainingTime).split(':')[1]);
            $scope.dualUpperRunOpetaionTime = convertTimeHMMformat($scope.idZero.Operation.operationTime);
            $scope.dualUpperRunRemainingTime = convertTimeHMMformat($scope.idZero.Operation.remainingTime);
            $scope.dualUpperRunOneMinute = $scope.dualUpperRunOpetaionTime !== '0:00' && $scope.dualUpperRunRemainingTime === '0:00';
            $scope.dualUpperRunLeftTime = claculateLeftTime($scope.idZero.Operation.remainingTime);
            $scope.dualUpperRunProgressBarPercentage = $scope.idZero.Operation.progressPercentage;
            if ($scope.dualUpperRunProbeDesiredTemp === 0) {
                $scope.dualUpperRunProbeDesiredTemp = $scope.desiredProbeTemp;
            }
            if (Number($scope.dualUpperRunDesiredTemp) > 61440) {
                $scope.dualUpperRunDesiredTemp = Number($scope.dualUpperRunDesiredTemp) === 61442 ? $scope.translation.WEBMOB_device_range_low : $scope.translation.WEBMOB_device_range_high;
            }
            if ($scope.dualUpperMode.indexOf("asycook3") !== -1) {
                $scope.dualUpperMode = $scope.translation.WEBMOB_device_range_easy_cook_bread_proof;
            }
        }
        idZeroOperationState();
    }

    function setValueForDualLowerMode() {
        debugMessage("setValueForDualLowerMode");
        if ($scope.idTwo.Operation.state !== 'Run') {
            getValueForDualLowerMode(wOvenDualLowerBaseMode);
            $scope.dualLowerRunOperationState = $scope.idTwo.Operation.state;
        } else {
            $scope.dualLowerMode = $scope.idTwo.Mode.modes[0];
            $scope.dualLowerModeText = getModeTextFromTabel($scope.idTwo.Mode.modes[0], 2);
            $scope.dualLowerRunOvenState = $scope.idTwo.Oven.state;
            $scope.dualLowerRunOperationState = $scope.idTwo.Operation.state;
            $scope.dualLowerRunProgressDescription = $scope.idTwo.Oven.state;
            $scope.dualLowerRunCurrentTemp = $scope.idTwo.Temperatures[0].current;
            $scope.dualLowerRunDesiredTemp = $scope.idTwo.Temperatures[0].desired;
            $scope.dualLowerRunProbeCurrentTemp = $scope.idTwo.Temperatures[1].current;
            $scope.dualLowerRunProbeDesiredTemp = $scope.idTwo.Temperatures[1].desired;
            $scope.dualLowerRunDesiredRemainingHr = Number(($scope.idTwo.Operation.remainingTime).split(':')[0]);
            $scope.dualLowerRunDesiredRemainingMin = Number(($scope.idTwo.Operation.remainingTime).split(':')[1]);
            $scope.dualLowerRunOpetaionTime = convertTimeHMMformat($scope.idTwo.Operation.operationTime);
            $scope.dualLowerRunRemainingTime = convertTimeHMMformat($scope.idTwo.Operation.remainingTime);
            $scope.dualLowerRunOneMinute = $scope.dualLowerRunOpetaionTime !== '0:00' && $scope.dualLowerRunRemainingTime === '0:00';
            $scope.dualLowerRunLeftTime = claculateLeftTime($scope.idTwo.Operation.remainingTime);
            $scope.dualLowerRunProgressBarPercentage = $scope.idTwo.Operation.progressPercentage;
            if ($scope.dualLowerRunProbeDesiredTemp === 0) {
                $scope.dualLowerRunProbeDesiredTemp = $scope.desiredProbeTemp;
            }
            if (Number($scope.dualLowerRunDesiredTemp) > 61440) {
                $scope.dualLowerRunDesiredTemp = Number($scope.dualLowerRunDesiredTemp) === 61442 ? $scope.translation.WEBMOB_device_range_low : $scope.translation.WEBMOB_device_range_high;
            }
            if ($scope.dualLowerMode.indexOf("asycook3") !== -1) {
                $scope.dualLowerMode = $scope.translation.WEBMOB_device_range_easy_cook_bread_proof;
            }
        }
        idTwoOperationState();
    }

    function setValueForDualFlexUpperMode() {
        debugMessage("setValueForDualFlexUpperMode");
        if ($scope.idZero.Operation.state !== 'Run') {
            getValueForDualFlexUpperMode(wOvenDualFlexUpperBaseMode);
            $scope.dualFlexUpperRunOperationState = $scope.idZero.Operation.state;
        } else {
            $scope.dualFlexUpperMode = $scope.idZero.Mode.modes[0];
            $scope.dualFlexUpperModeText = getModeTextFromTabel($scope.idZero.Mode.modes[0], 0);
            $scope.dualFlexUpperRunOvenState = $scope.idZero.Oven.state;
            $scope.dualFlexUpperModeSupport = getProbeSupportFromTabel($scope.idZero.Mode.modes[0]);
            $scope.dualFlexUpperRunOperationState = $scope.idZero.Operation.state;
            $scope.dualFlexUpperRunProgressDescription = $scope.idZero.Oven.state;
            $scope.dualFlexUpperRunCurrentTemp = $scope.idZero.Temperatures[0].current;
            $scope.dualFlexUpperRunDesiredTemp = $scope.idZero.Temperatures[0].desired;
            $scope.dualFlexUpperRunProbeCurrentTemp = $scope.idZero.Temperatures[1].current;
            $scope.dualFlexUpperRunProbeDesiredTemp = $scope.idZero.Temperatures[1].desired;
            $scope.dualFlexUpperRunDesiredRemainingHr = Number(($scope.idZero.Operation.remainingTime).split(':')[0]);
            $scope.dualFlexUpperRunDesiredRemainingMin = Number(($scope.idZero.Operation.remainingTime).split(':')[1]);
            $scope.dualFlexUpperRunOpetaionTime = convertTimeHMMformat($scope.idZero.Operation.operationTime);
            $scope.dualFlexUpperRunRemainingTime = convertTimeHMMformat($scope.idZero.Operation.remainingTime);
            $scope.dualFlexUpperRunOneMinute = $scope.dualFlexUpperRunOpetaionTime !== '0:00' && $scope.dualFlexUpperRunRemainingTime === '0:00';
            $scope.dualFlexUpperRunLeftTime = claculateLeftTime($scope.idZero.Operation.remainingTime);
            $scope.dualFlexUpperRunProgressBarPercentage = $scope.idZero.Operation.progressPercentage;
            if ($scope.dualFlexUpperRunProbeDesiredTemp === 0) {
                $scope.dualFlexUpperRunProbeDesiredTemp = $scope.desiredProbeTemp;
            }
            if (Number($scope.dualFlexUpperRunDesiredTemp) > 61440) {
                $scope.dualFlexUpperRunDesiredTemp = Number($scope.dualFlexUpperRunDesiredTemp) === 61442 ? $scope.translation.WEBMOB_device_range_low : $scope.translation.WEBMOB_device_range_high;
            }
            if ($scope.dualFlexUpperMode.indexOf("asycook3") !== -1) {
                $scope.dualFlexUpperMode = $scope.translation.WEBMOB_device_range_easy_cook_bread_proof;
            }
        }
        idZeroOperationState();
    }

    function setValueForDualFlexLowerMode() {
        debugMessage("setValueForDualFlexLowerMode");
        if ($scope.idOne.Operation.state !== 'Run') {
            getValueForDualFlexLowerMode(wOvenDualFlexLowerBaseMode);
            $scope.dualFlexLowerRunOperationState = $scope.idOne.Operation.state;
        } else {
            $scope.dualFlexLowerMode = $scope.idOne.Mode.modes[0];
            $scope.dualFlexLowerModeText = getModeTextFromTabel($scope.idOne.Mode.modes[0], 1);
            $scope.dualFlexLowerRunOvenState = $scope.idOne.Oven.state;
            $scope.dualFlexLowerRunOperationState = $scope.idOne.Operation.state;
            $scope.dualFlexLowerRunProgressDescription = $scope.idOne.Oven.state;
            $scope.dualFlexLowerRunCurrentTemp = $scope.idOne.Temperatures[0].current;
            $scope.dualFlexLowerRunDesiredTemp = $scope.idOne.Temperatures[0].desired;
            $scope.dualFlexLowerRunProbeCurrentTemp = $scope.idOne.Temperatures[1].current;
            $scope.dualFlexLowerRunProbeDesiredTemp = $scope.idOne.Temperatures[1].desired;
            $scope.dualFlexLowerRunDesiredRemainingHr = Number(($scope.idOne.Operation.remainingTime).split(':')[0]);
            $scope.dualFlexLowerRunDesiredRemainingMin = Number(($scope.idOne.Operation.remainingTime).split(':')[1]);
            $scope.dualFlexLowerRunOpetaionTime = convertTimeHMMformat($scope.idOne.Operation.operationTime);
            $scope.dualFlexLowerRunRemainingTime = convertTimeHMMformat($scope.idOne.Operation.remainingTime);
            $scope.dualFlexLowerRunOneMinute = $scope.dualFlexLowerRunOpetaionTime !== '0:00' && $scope.dualFlexLowerRunRemainingTime === '0:00';
            $scope.dualFlexLowerRunLeftTime = claculateLeftTime($scope.idOne.Operation.remainingTime);
            $scope.dualFlexLowerRunProgressBarPercentage = $scope.idOne.Operation.progressPercentage;
            if ($scope.dualFlexLowerRunProbeDesiredTemp === 0) {
                $scope.dualFlexLowerRunProbeDesiredTemp = $scope.desiredProbeTemp;
            }
            if (Number($scope.dualFlexLowerRunDesiredTemp) > 61440) {
                $scope.dualFlexLowerRunDesiredTemp = Number($scope.dualFlexLowerRunDesiredTemp) === 61442 ? $scope.translation.WEBMOB_device_range_low : $scope.translation.WEBMOB_device_range_high;
            }
            if ($scope.dualFlexLowerMode.indexOf("asycook3") !== -1) {
                $scope.dualFlexLowerMode = $scope.translation.WEBMOB_device_range_easy_cook_bread_proof;
            }
        }
        idOneOperationState();
    }

    function updateDisplayScreenData() {
        debugMessage("updateDisplayScreenData for selectedCavity > " + selectedCavity); //update all showing values
        var data = $scope.idZero;
        if (selectedCavity === 'SINGLE' || selectedCavity === 'DUALUPPER' || selectedCavity === 'DUALFLEXUPPER') {
            data = $scope.idZero;
            deviceID = 0;
        } else if (selectedCavity === 'DUALLOWER' || selectedCavity === 'LOWERFLEX') {
            data = $scope.idTwo;
            deviceID = 2;
        } else if (selectedCavity === 'DUALFLEXLOWER') {
            data = $scope.idOne;
            deviceID = 1;
        } else {
            data = $scope.idZero;
            deviceID = 0;
        }
        if ((selectedCavity === 'DUALLOWER' || selectedCavity === 'LOWERFLEX')) {
            $scope.smartControl = $scope.remoteControlEnabledIdTwo ? 'ON' : 'OFF';
        } else {
            $scope.smartControl = $scope.remoteControlEnabled ? 'ON' : 'OFF';
        }
        if (data.Operation.state === 'Run') {
            $scope.DisplayContents = getModeRowValue(getSupportedModeList(), data.Mode.modes[0]);
            $scope.displayRunRunningMode = data.Mode.modes[0];
            $scope.displayRunRunningModeText = getModeTextFromTabel(data.Mode.modes[0], deviceID);
            $scope.deviceModeSupport = getProbeSupportFromTabel(data.Mode.modes[0]);
            $scope.displayRunProgressDescription = data.Oven.state;
            $scope.displayRunOvenState = data.Oven.state;
            $scope.displayRunOperationState = data.Operation.state;
            $scope.displayRunProgressDescription = data.Oven.state;
            $scope.displayRunCurrentTemp = Number(data.Temperatures[0].current);
            $scope.displayRunDesiredTemp = Number(data.Temperatures[0].desired);
            $scope.displayRunProbeCurrentTemp = Number(data.Temperatures[1].current);
            $scope.displayRunProbeDesiredTemp = Number(data.Temperatures[1].desired);
            $scope.displayRunDesiredRemainingHr = Number((data.Operation.remainingTime).split(':')[0]);
            $scope.displayRunDesiredRemainingMin = Number((data.Operation.remainingTime).split(':')[1]);
            $scope.displayRunOpetaionTime = convertTimeHMMformat(data.Operation.operationTime);
            $scope.displayRunRemainingTime = convertTimeHMMformat(data.Operation.remainingTime);
            $scope.displayRunLeftTime = claculateLeftTime(data.Operation.remainingTime);
            $scope.displayRunProgressBarPercentage = data.Operation.progressPercentage;
            $scope.TempIncrement = Number(data.Temperatures[0].increment);
            $scope.bNoPreheat = data.Mode.options[0].NoPreheat === 'On' ? true : false;
            $scope.steamRoastLevel = Number(data.Mode.options[0].steamAddLevel);
            $scope.keepWarmReservation = data.Mode.options[0].keepWarmReservation === 'On';

            if (Number($scope.displayRunDesiredTemp) > 61440) {
                $scope.displayRunDesiredTemp = Number($scope.displayRunDesiredTemp) === 61442 ? $scope.translation.WEBMOB_device_range_low : $scope.translation.WEBMOB_device_range_high;
            }
            if ($scope.displayRunRunningMode === 'Autocook') {
                if ($scope.displayRunRunningModeText === 'WEBMOB_device_walloven_auto_cook_garlic_prime_rib') {
                    $scope.displayOperationState = 'CookingGalricPrimeAutocook';
                } else {
                    $scope.displayOperationState = 'CookingAutocook';
                }
            } else if (($scope.displayRunOvenState === 'Preheat' || $scope.displayRunOvenState === 'Cooking' || $scope.displayRunOvenState === 'Delay') && $scope.displayRunRunningMode.indexOf("SelfClean") === -1) {
                if ($scope.displayRunRunningMode === '') {
                    $scope.displayOperationState = 'Cooking--'; //Mode Check
                } else if ($scope.displayRunRunningMode === 'Broil' || $scope.displayRunRunningMode === 'BroilConvection') {
                    $scope.displayOperationState = 'CookingBroil';
                } else if ($scope.displayRunRunningMode.indexOf("asycook3") !== -1 || $scope.displayRunRunningMode.indexOf("ealthycook6") !== -1) {
                    $scope.displayOperationState = 'CookingBreadProof';
                } else if ($scope.displayRunOpetaionTime !== '0:00' && $scope.displayRunRemainingTime === '0:00') {
                    $scope.displayOperationState = 'OneMinuteRemain';
                } else {
                    $scope.displayOperationState = 'CookingNormal';
                }
            } else if ($scope.displayRunOvenState === 'Finish') {
                $scope.displayOperationState = 'CookingFinish';
            } else if ($scope.displayRunOvenState === 'Cleaning' || $scope.displayRunRunningMode.indexOf("SelfClean") !== -1) {
                $scope.displayOperationState = 'CookingSelfClean';
            } else if ($scope.displayRunOvenState === 'Warming') {
                $scope.displayOperationState = 'CookingKeepWarm';
            } else if ($scope.displayRunOvenState === 'Draining' || $scope.displayRunRunningMode.indexOf("Drain") !== -1) {
                $scope.displayOperationState = 'CookingDraining';
            }
            if ($scope.displayRunRunningMode.indexOf("asycook3") !== -1) {
                $scope.displayRunRunningMode = $scope.translation.WEBMOB_device_range_easy_cook_bread_proof;
            }
            if (selectedCavity === 'SINGLE' || selectedCavity === 'DUALUPPER') {
                $scope.deviceModeSupport = getProbeSupportFromTabel(data.Mode.modes[0]) && $scope.idZero.Mode.options[0].meatprobe === "connected";
                checkForMeatProbe();
            } else {
                $scope.deviceModeSupport = false;
                $scope.meatProbeConnected = false;
            }
            if ($scope.displayRunRunningMode.indexOf("Descale") !== -1) {
                $scope.displayOperationState = 'CookingDescale';
                $scope.descaleStep = getDescaleLevelStep(data.Mode.options[0].descaleState);
            }
            debugMessage('Display detail Screen in Run Mode with ' + $scope.displayOperationState);
        } else if (data.Operation.state === 'Ready' || data.Operation.state === 'NoOperation') {
            debugMessage('Display detail Screen in Ready Mode with ' + $scope.DisplayContents);
            $scope.DisplayContents = (angular.isDefined($scope.DisplayContents)) ? $scope.DisplayContents : getModeRowValue(getSupportedModeList(), getDefaultMode());
            $scope.displayReadyId = $scope.DisplayContents[0];
            $scope.deviceMode = $scope.DisplayContents[4];
            $scope.displayReadyMode = $scope.DisplayContents[4];
            $scope.displayReadyModeText = $scope.DisplayContents[5];
            $scope.displayReadyRecipeDescription = $scope.DisplayContents[2];
            $scope.desiredTemp = $scope.TempUnit === 'F' ? $scope.DisplayContents[13] : $scope.DisplayContents[16];
            $scope.minTemp = $scope.TempUnit === 'F' ? $scope.DisplayContents[14] : $scope.DisplayContents[17];
            $scope.maxTemp = $scope.TempUnit === 'F' ? $scope.DisplayContents[15] : $scope.DisplayContents[18];
            $scope.desiredProbeTemp = $scope.TempUnit === 'F' ? 150 : 65;
            $scope.minProbeTemp = $scope.TempUnit === 'F' ? 100 : 40;
            $scope.maxProbeTemp = $scope.TempUnit === 'F' ? 200 : 90;
            $scope.TempIncrement = Number(data.Temperatures[0].increment);
            var newdate = new Date();
            newdate.setHours(0, $scope.DisplayContents[19], 0);
            $scope.desiredHours = Number(newdate.getHours());
            $scope.desiredMinutes = Number(newdate.getMinutes());
            $scope.keepWarmReservation = false;
            $scope.drainRequired = deviceID === 0 && data.Mode.options[0].drainRequired === '02';

            if (selectedCavity === 'SINGLE' || selectedCavity === 'DUALUPPER') {
                $scope.deviceModeSupport = $scope.DisplayContents[1] === 'TRUE' && $scope.idZero.Mode.options[0].meatprobe === "connected";
                checkForMeatProbe();
            } else {
                $scope.deviceModeSupport = false;
                $scope.meatProbeConnected = false;
            }
            if (Number($scope.desiredTemp) > 61440) {
                $scope.highLowTemp = Number($scope.desiredTemp) === 61442 ? $scope.translation.WEBMOB_device_range_low : $scope.translation.WEBMOB_device_range_high;
            }
            if (selectedCavity === 'DUALFLEXLOWER' && $scope.idZero.Operation.state === 'Run') {
                $scope.minTemp = setMinTempValue($scope.idZero.Temperatures[0].desired);
                $scope.maxTemp = setMaxTempValue($scope.idZero.Temperatures[0].desired);
                if ($scope.desiredTemp > $scope.maxTemp || $scope.desiredTemp < $scope.minTemp) {
                    $scope.desiredTemp = $scope.dualFlexUpperDesiredTemp;
                }
            }
            if (selectedCavity === 'DUALFLEXUPPER' && $scope.idOne.Operation.state === 'Run') {
                $scope.minTemp = setMinTempValue($scope.idOne.Temperatures[0].desired);
                $scope.maxTemp = setMaxTempValue($scope.idOne.Temperatures[0].desired);
                if ($scope.desiredTemp > $scope.maxTemp || $scope.desiredTemp < $scope.minTemp) {
                    $scope.desiredTemp = $scope.dualFlexLowerDesiredTemp;
                }
            }
            switch (selectedCavity) {
                case 'SINGLE' ://SINGLE
                    getUserPreferencedValue(userPreferneceSingle);
                    break;
                case 'DUALUPPER' ://DUAL UPPER
                    getUserPreferencedValue(userPreferneceDualUpper);
                    break;
                case 'DUALLOWER' ://DUAL LOWER
                    getUserPreferencedValue(userPreferneceDualLower);
                    break;
                case 'DUALFLEXUPPER' ://FLEX UPPER
                    getUserPreferencedValue(userPreferneceDualFlexUpper);
                    break;
                case 'DUALFLEXLOWER' ://FLEX LOWER
                    getUserPreferencedValue(userPreferneceDualFlexLower);
                    break;
                case 'LOWERFLEX' ://LOWER FLEX
                    getUserPreferencedValue(userPreferneceDualLower);
                    break;
                default :
                    break;
            }
        }
    }

    function updateDualModeScreenData() {
        debugMessage("updateDualModeScreenData called");
        setValueForDualUpperMode();
        setValueForDualLowerMode();
    }

    function updateFlexModeScreenData() {
        debugMessage("updateFlexModeScreenData called");
        setValueForDualFlexUpperMode();
        setValueForDualFlexLowerMode();
        setValueForDualLowerMode();
    }

    function idZeroOperationState() {
        var idZeroOperationState = '';
        if ($scope.idZero.Operation.state === 'Run') {
            if (($scope.idZero.Oven.state === 'Preheat' || $scope.idZero.Oven.state === 'Cooking' || $scope.idZero.Oven.state === 'Delay') && $scope.idZero.Mode.modes[0].indexOf("SelfClean") === -1) {
                if ($scope.idZero.Mode.modes[0] === '') {
                    idZeroOperationState = 'Cooking--'; //Mode Check
                } else if ($scope.idZero.Mode.modes[0] === 'Broil') {
                    idZeroOperationState = 'CookingBroil';
                } else if ($scope.idZero.Mode.modes[0].indexOf("asycook3") !== -1 || $scope.idZero.Mode.modes[0].indexOf("ealthycook6") !== -1) {
                    idZeroOperationState = 'CookingBreadProof';
                } else if (convertTimeHMMformat($scope.idZero.Operation.operationTime) !== '0:00' && convertTimeHMMformat($scope.idZero.Operation.remainingTime) === '0:00') {
                    idZeroOperationState = 'OneMinuteRemain';
                } else {
                    idZeroOperationState = 'CookingNormal';
                }
            } else if ($scope.idZero.Oven.state === 'Finish') {
                idZeroOperationState = 'Finish';
            } else if ($scope.idZero.Oven.state === 'Cleaning' || $scope.idZero.Mode.modes[0].indexOf("SelfClean") !== -1) {
                idZeroOperationState = 'CookingSelfClean';
            } else if ($scope.idZero.Oven.state === 'Warming') {
                idZeroOperationState = 'CookingKeepWarm';
            }
            if ($scope.idZero.Mode.modes[0].indexOf("Descale") !== -1 || $scope.idZero.Oven.state === 'Draining' || $scope.idZero.Mode.modes[0].indexOf("Drain") !== -1) {//TODO
                idZeroOperationState = 'CookingSelfClean';
            }
        } else if ($scope.idZero.Operation.state === 'Ready' || $scope.idZero.Operation.state === 'NoOperation') {
            idZeroOperationState = 'Ready';
        }
        debugMessage('Display idZeroOperationState with screen > ' + idZeroOperationState);
        $scope.SingleOvenState = idZeroOperationState;
        $scope.dividerUpperState = idZeroOperationState;
        $scope.dualFlexUpperState = idZeroOperationState;
    }

    function idOneOperationState() {
        if ($scope.idOne.Operation.state === 'Run') {
            if (($scope.idOne.Oven.state === 'Preheat' || $scope.idOne.Oven.state === 'Cooking' || $scope.idOne.Oven.state === 'Delay') && $scope.idOne.Mode.modes[0].indexOf("SelfClean") === -1) {
                if ($scope.idOne.Mode.modes[0] === '') {
                    $scope.dualFlexLowerState = 'Cooking--'; //Mode Check
                } else if ($scope.idOne.Mode.modes[0] === 'Broil') {
                    $scope.dualFlexLowerState = 'CookingBroil';
                } else if ($scope.idOne.Mode.modes[0].indexOf("asycook3") !== -1 || $scope.idOne.Mode.modes[0].indexOf("ealthycook6") !== -1) {
                    $scope.dualFlexLowerState = 'CookingBreadProof';
                } else if (convertTimeHMMformat($scope.idOne.Operation.operationTime) !== '0:00' && convertTimeHMMformat($scope.idOne.Operation.remainingTime) === '0:00') {
                    $scope.dualFlexLowerState = 'OneMinuteRemain';
                } else {
                    $scope.dualFlexLowerState = 'CookingNormal';
                }
            } else if ($scope.idOne.Oven.state === 'Finish') {
                $scope.dualFlexLowerState = 'Finish';
            } else if ($scope.idOne.Oven.state === 'Cleaning' || $scope.idOne.Mode.modes[0].indexOf("SelfClean") !== -1) {
                $scope.dualFlexLowerState = 'CookingSelfClean';
            } else if ($scope.idOne.Oven.state === 'Warming') {
                $scope.dualFlexLowerState = 'CookingKeepWarm';
            }
            if ($scope.idOne.Mode.modes[0].indexOf("Descale") !== -1 || $scope.idOne.Oven.state === 'Draining' || $scope.idOne.Mode.modes[0].indexOf("Drain") !== -1) {//TODO
                $scope.dualFlexLowerState = 'CookingSelfClean';
            }
            debugMessage('Display $scope.dualFlexLowerState with screen > ' + $scope.dualFlexLowerState);
        } else if ($scope.idOne.Operation.state === 'Ready' || $scope.idOne.Operation.state === 'NoOperation') {
            $scope.dualFlexLowerState = 'Ready';
        }
    }

    function idTwoOperationState() {
        var idTwoOperationState = '';
        if ($scope.idTwo.Operation.state === 'Run') {
            if (($scope.idTwo.Oven.state === 'Preheat' || $scope.idTwo.Oven.state === 'Cooking' || $scope.idTwo.Oven.state === 'Delay') && $scope.idTwo.Mode.modes[0].indexOf("SelfClean") === -1) {
                if ($scope.idTwo.Mode.modes[0] === '') {
                    idTwoOperationState = 'Cooking--'; //Mode Check
                } else if ($scope.idTwo.Mode.modes[0] === 'Broil') {
                    idTwoOperationState = 'CookingBroil';
                } else if ($scope.idTwo.Mode.modes[0].indexOf("asycook3") !== -1 || $scope.idTwo.Mode.modes[0].indexOf("ealthycook6") !== -1) {
                    idTwoOperationState = 'CookingBreadProof';
                } else if (convertTimeHMMformat($scope.idTwo.Operation.operationTime) !== '0:00' && convertTimeHMMformat($scope.idTwo.Operation.remainingTime) === '0:00') {
                    idTwoOperationState = 'OneMinuteRemain';
                } else {
                    idTwoOperationState = 'CookingNormal';
                }
            } else if ($scope.idTwo.Oven.state === 'Finish') {
                idTwoOperationState = 'Finish';
            } else if ($scope.idTwo.Oven.state === 'Cleaning' || $scope.idTwo.Mode.modes[0].indexOf("SelfClean") !== -1) {
                idTwoOperationState = 'CookingSelfClean';
            } else if ($scope.idTwo.Oven.state === 'Warming') {
                idTwoOperationState = 'CookingKeepWarm';
            }
            if ($scope.idTwo.Mode.modes[0].indexOf("Descale") !== -1 || $scope.idTwo.Oven.state === 'Draining' || $scope.idTwo.Mode.modes[0].indexOf("Drain") !== -1) {//TODO
                idTwoOperationState = 'CookingSelfClean';
            }
            debugMessage('Display idTwoOperationState with screen > ' + idTwoOperationState);
        } else if ($scope.idTwo.Operation.state === 'Ready' || $scope.idTwo.Operation.state === 'NoOperation') {
            idTwoOperationState = 'Ready';
        }
        $scope.dividerLowerState = idTwoOperationState;
        $scope.LowerFlexState = idTwoOperationState;

    }

    function modelBasedMenu(tabName) {
        if (tabName === 'WEBMOB_device_range_oven_function') {
            if ($scope.isLCDModel || !$scope.isLCDModel) {
                return true;
            }
        } else if (tabName === 'WEBMOB_device_range_healthy_cook') {
            if ($scope.isLCDModel) {
                return true;
            }
        } else if (tabName === 'WEBMOB_device_range_easy_cook') {
            if ($scope.DeviceModelName === '' || $scope.DeviceModelName === '') {
                return true;
            }
        } else if (tabName === 'WEBMOB_device_range_auto_cook') {
            if ($scope.isLCDModel && !$scope.idOne.connected) {
                return true;
            }
        }
        return false;
    }

    function initializeScreen() {
        debugMessage('initializeScreen  and all model check');
        if ($scope.idZero === undefined) {
            return;
        }
        $scope.DeviceModelName = $scope.idZero.Mode.options[0].DeviceType;
        $scope.isLCDModel = $scope.DeviceModelName === 'NW9000KW/AA0' || $scope.DeviceModelName === 'NW9000KD/AA0';
        //$scope.isLEDModel = $scope.DeviceModelName === 'NW9000KS/AA0' || $scope.DeviceModelName === 'NW9000KD/AA1';
        if ($scope.isLCDModel) { //MW0600025198 - LCD Spec - for dualUpper just display Conv. Bake, ConvectionRoast and steam bake
            if ($scope.ovenFunctionContentsDualUpperFlex instanceof Array && $scope.ovenFunctionContentsDualUpperFlex.length > 0) {
                $scope.ovenFunctionContentsDualUpperFlex = $scope.ovenFunctionContentsDualUpperFlex.filter(function (item) {
                    return (item[4] !== "Bake" && item[4] !== "SteamRoast"); // Filter out the appropriate one
                });
            }
        }
        debugMessage('DeviceModelName ' + $scope.DeviceModelName + ' & isLCDModel : ' + $scope.isLCDModel);
        $scope.mainLoadingScreen = true;
        if (window.navigator.platform === 'iPhone' || window.navigator.platform === 'iPad') {
            $timeout(function () {
                disableDummyInbox();
            }, 500);
        }
        $scope.RangeSendText = $scope.isLCDModel ? "WEBMOB_device_range_comm_start_CL" : "WEBMOB_device_range_comm_send_to_oven_CL";
        settingPageOptionsValidation();
        $scope.TempIncrement = Number($scope.idZero.Temperatures[0].increment);
        $scope.desiredProbeTemp = $scope.TempUnit === 'F' ? 150 : 65;
        $scope.dualFlexUpperDesiredTemp = $scope.TempUnit === 'F' ? 325 : 170;
        $scope.dualFlexLowerDesiredTemp = $scope.TempUnit === 'F' ? 350 : 175;
    }

    function showCurrentScreen() {
        debugMessage("showCurrentScreen called");

        if ($scope.idZero === undefined) {
            debugMessage("idZero is undefined");
            return;
        }

        if ($scope.idOne === undefined) {
            debugMessage("idOne is undefined");
            return;
        }

        if ($scope.idTwo === undefined) {
            debugMessage("idTwo is undefined");
            return;
        }

        //loadingValues();

        debugMessage("divider 0 : " + $scope.idZero.connected + " && alarm " + $scope.idZero.Alarms[0].code);
        debugMessage("divider 1 : " + $scope.idOne.connected + " && alarm " + $scope.idOne.Alarms[0].code);
        debugMessage("divider 2 : " + $scope.idTwo.connected + " && alarm " + $scope.idTwo.Alarms[0].code);

        if (selectedCavity !== '' && (recipeDataValidateSingle || recipeDataValidateDualUpper || recipeDataValidateDualLower || recipeDataValidateDualFlexUpper || recipeDataValidateDualFlexLower || recipeDataValidateLowerFlex)) {
            preValidateSendRecipeDataCheck();
            validateSendRecipeData();
            debugMessage('return due to recipe Data validation proper response');
            return;
        }

        if (getAlarmStatusIdZero()) {
            if ($scope.operationCompleteZero) {
                debugMessage('operationCompleteZero alarms screen');
                setDataCurrentScreen();
                validateCurrentScreen('OperationCompletePage');
            } else {
                debugMessage('return operationCompleteZero alarms screen');
            }
            return;
        }

        if (getAlarmStatusIdOne()) {
            if ($scope.operationCompleteOne) {
                debugMessage('operationCompleteOne alarms screen');
                setDataCurrentScreen();
                validateCurrentScreen('OperationCompletePage');
            } else {
                debugMessage('return operationCompleteOne alarms screen');
            }
            return;
        }

        if (getAlarmStatusIdTwo()) {
            if ($scope.operationCompleteTwo) {
                debugMessage('operationCompleteTwo alarms screen');
                setDataCurrentScreen();
                validateCurrentScreen('OperationCompletePage');
            } else {
                debugMessage('return operationCompleteTwo alarms screen');
            }
            return;
        }

        if (!errorRemoved
                || $scope.idZero.Alarms[0] !== undefined && $scope.idZero.Alarms[0] !== null && $scope.idZero.Alarms[0].code.indexOf("WO_E") !== -1
                || $scope.idOne.Alarms[0] !== undefined && $scope.idOne.Alarms[0] !== null && $scope.idOne.Alarms[0].code.indexOf("WO_E") !== -1
                || $scope.idTwo.Alarms[0] !== undefined && $scope.idTwo.Alarms[0] !== null && $scope.idTwo.Alarms[0].code.indexOf("WO_E") !== -1) {
            debugMessage("return due to error not removed ");
            validateCurrentScreen('ErrorPage');
            return;
        }

        if (getProbeDividerError()) {
            validateCurrentScreen('ProbeDividerErrorPage');
            debugMessage('return due to probe divider error screen');
            return;
        }

        if ($scope.operationCompleteZero && (selectedCavity === 'SINGLE' || selectedCavity === 'DUALUPPER' || selectedCavity === 'DUALFLEXUPPER')) {
            debugMessage('return due to idZero alarms > ' + selectedCavity);
            setDataCurrentScreen();
            validateCurrentScreen('OperationCompletePage');
            return;
        }
        if ($scope.operationCompleteOne && selectedCavity === 'DUALFLEXLOWER') {
            debugMessage('return due to idOne alarms > ' + selectedCavity);
            setDataCurrentScreen();
            validateCurrentScreen('OperationCompletePage');
            return;
        }
        if ($scope.operationCompleteTwo && (selectedCavity === 'DUALLOWER' || selectedCavity === 'LOWERFLEX')) {
            debugMessage('return due to idTwo alarms > ' + selectedCavity);
            setDataCurrentScreen();
            validateCurrentScreen('OperationCompletePage');
            return;
        }

        if ($scope.editMode) {
            if ($scope.idZero.Operation.state !== "Run"
                    && $scope.idOne.Operation.state !== "Run"
                    && $scope.idTwo.Operation.state !== "Run") {
                $scope.editMode = false;
                $scope.editModeTimeUpdate = false;
                $scope.editModeTempUpdate = false;
                debugMessage('editMode = false both mode is in Ready state');
            }
            if ($scope.idOne.connected) {
                updateFlexModeScreenData();
            } else if ($scope.idTwo.connected && !$scope.idOne.connected) {
                updateDualModeScreenData();
            } else {
                //monitorClick(0);
                updateDisplayScreenData();
            }
            setDualStateMaxMinTemp();
            return;
        }

        if (changeSmartCarePage && ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_SMART_CARE_NO_ERROR_PAGE || $scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_SMART_CARE_PAGE)) {
            debugMessage('return due to Smart Care');
            return;
        }

        if ($scope.currentScreen === WALLOVEN_SCREENS.RANGE_PROBE_DIVIDER_ERROR_PAGE) {
            if ($scope.idZero.Mode.options[0].meatprobe === "connected" && $scope.idZero.connected) {
                debugMessage('return due to probe divider error screen');
                return;
            }
        }

        if ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_AUTOCOOK_SCREEN) {
            debugMessage('return due to autocook screen');
            return;
        }

        if ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_AUTOCOOK_DETAIL_SCREEN) {
            if (!$scope.isStatic) {
                if ($scope.idZero.Operation.state === 'Ready' && AutocookSendId === $scope.idZero.Oven.recipe
                        || $scope.idTwo.Operation.state === 'Ready' && AutocookSendId === $scope.idTwo.Oven.recipe) {
                    AutocookSendId = 0;
                    $scope.checkResponse.push(WALLOVEN_COMMANDS.startCooking);
                    debugMessage(getStartCommand() + "/" + $scope.peerId + "/devices/" + deviceID + "/operation");
                    SHPService.sendSHPCommand(CONSTANTS.PUT, getStartCommand(), "/" + $scope.peerId + "/devices/" + deviceID + "/operation");
                }
                debugMessage('return due to autocook screen detail');
                return;
            }
        }

        if (selectedCavity === '') {
            if (!justFirstTime && $scope.idZero.Operation.state !== 'Run') {
                saveUserValueSingle($scope.singleMode, $scope.singleDesiredTemp, $scope.singleDesiredProbeTemp, $scope.singleDesiredHours, $scope.singleDesiredMinutes, $scope.bNoPreheat);
            }

            if (!justFirstTime && $scope.idZero.Operation.state !== 'Run') {
                saveUserValueDualUpper($scope.dualUpperMode, $scope.dualUpperDesiredTemp, $scope.dualUpperDesiredProbeTemp, $scope.dualUpperDesiredHours, $scope.dualUpperDesiredMinutes, $scope.bNoPreheat);
            }

            if (!justFirstTime && $scope.idTwo.Operation.state !== 'Run') {
                saveUserValueDualLower($scope.dualLowerMode, $scope.dualLowerDesiredTemp, $scope.dualLowerDesiredProbeTemp, $scope.dualLowerDesiredHours, $scope.dualLowerDesiredMinutes, $scope.bNoPreheat);
            }

            if (!justFirstTime && $scope.idZero.Operation.state !== 'Run') {
                saveUserValueDualFlexUpper($scope.dualFlexUpperMode, $scope.dualFlexUpperDesiredTemp, $scope.dualFlexUpperDesiredProbeTemp, $scope.dualFlexUpperDesiredHours, $scope.dualFlexUpperDesiredMinutes, $scope.bNoPreheat);
            }

            if (!justFirstTime && $scope.idOne.Operation.state !== 'Run') {
                saveUserValueDualFlexLower($scope.dualFlexLowerMode, $scope.dualFlexLowerDesiredTemp, $scope.dualFlexLowerDesiredProbeTemp, $scope.dualFlexLowerDesiredHours, $scope.dualFlexLowerDesiredMinutes, $scope.bNoPreheat);
            }
        } else {
            saveUserValue();
        }

        setDataCurrentScreen();

        if ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_MY_FAVORITE_PAGE) {
            debugMessage('return due to add my Cooking with updated data');
            return;
        }

        if ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_MY_FAVORITE_RECIPE_DETAIL_PAGE) {
            var state = 'Ready';
            if (selectedCavity === 'SINGLE' || selectedCavity === 'DUALUPPER' || selectedCavity === 'DUALFLEXUPPER') {
                state = $scope.idZero.Operation.state;
            } else if (selectedCavity === 'DUALLOWER' || selectedCavity === 'LOWERFLEX') {
                state = $scope.idTwo.Operation.state;
            } else if (selectedCavity === 'DUALFLEXLOWER') {
                state = $scope.idOne.Operation.state;
            } else {
                state = $scope.idZero.Operation.state;
            }

            //PRMS Defect: 0000070216
            //don't go to home page on recieving remaining time notification if in favorite details page as its causing an side effect
//            if (state === 'Run') {
//                validateCurrentScreen('RunDetailPage');
//                debugMessage('my cooking start go to run page');
//            }
            debugMessage('return due to detail screen my Cooking with updated data state ' + state);

            //CQ - MW0600025125 Update MF temperature and min max values
            if ($scope.TempUnit === "F") {
                $scope.desiredMFTemp = Number($scope.MFContents[13]);
                $scope.MFMin = $scope.MFContents[14];
                $scope.MFMax = $scope.MFContents[15];
            } else {
                $scope.desiredMFTemp = Number($scope.MFContents[16]);
                $scope.MFMin = $scope.MFContents[17];
                $scope.MFMax = $scope.MFContents[18];

            }
            return;
        }

        if ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_EDIT_MY_FAVORITE_DETAIL_PAGE) {
            debugMessage('return due to edit my Cooking page');

            //CQ - MW0600025125 Update MF temperature and min max values
            if ($scope.TempUnit === "F") {
                $scope.desiredMFTemp = Number($scope.MFContents[13]);
                $scope.MFMin = $scope.MFContents[14];
                $scope.MFMax = $scope.MFContents[15];
            } else {
                $scope.desiredMFTemp = Number($scope.MFContents[16]);
                $scope.MFMin = $scope.MFContents[17];
                $scope.MFMax = $scope.MFContents[18];

            }
            return;
        }

        if ($scope.showFullScreenPopup && $scope.alertState === WALLOVEN_ALERT_STATE.ALERT_COOKING_SNOOZE) {
            debugMessage('Update snooze time');
            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_COOKING_SNOOZE, $scope.translation.WEBMOB_device_range_alarm_finish_snooze_title, $scope.translation.WEBMOB_device_range_alarm_finish_snooze, $scope.translation.WEBMOB_common_cancel, $scope.translation.WEBMOB_device_range_comm_finish_snooze_min);
        }

        if ($scope.editMode) {
            setDualStateMaxMinTemp();
        }

        if (doNotChangeScreen) {
            debugMessage('return due to doNotChangeScreen');
            return;
        }
        showScreen();
        /*
         * make sure if any full screen popups or menu is open fix the screen so that it wont scroll (for iOS)
         * required in case menu or popup is open and some notification comes from the SET that time screen starts to scroll
         * MW0600025194 - [Temp probe on off notification and screen scroll on iOS] 
         */
        if ($scope.wallOvenModeMenu || $scope.showFullScreenPopup || $scope.showMenuOptionPopup || $scope.steamRoastPopup || $scope.samrtControlPopup) {
            fixScreen();
        } else {
            scrollScreen();
        }
        justFirstTime = false;
        debugMessage("Screen Loading finish and checkResponse values " + $scope.checkResponse);
    }

    function showScreen() {
        debugMessage("showScreen called");
        if (selectedCavity === '') {
            if ($scope.idOne.connected) {
                debugMessage("showCurrentScreen FlexPage called");
                validateCurrentScreen('FlexConnectedPage');
            } else if ($scope.idTwo.connected && !$scope.idOne.connected) {
                debugMessage("showCurrentScreen DualPage called");
                validateCurrentScreen('DividerConnectedPage');
            } else if (!$scope.idTwo.connected && !$scope.idOne.connected) {
                debugMessage("showCurrentScreen SinglePage called");
                if ($scope.idZero.Operation.state === 'Run') {
                    if ($scope.editMode) {
                        validateCurrentScreen('EditRunningPage');
                    } else {
                        validateCurrentScreen('RunDetailPage');
                    }
                } else {
                    validateCurrentScreen('ReadyDetailPage');
                }
            }
        } else {
            showDesiredScreen();
        }
    }

    function showDesiredScreen() {
        debugMessage("showDesiredScreen called for selectedCavity > " + selectedCavity);
        if (selectedCavity === '') {
            debugMessage("check logic");
            return;
        }
        if ($scope.editMode) {
            validateCurrentScreen('EditRunningPage');
        } else if ($scope.operationCompleteZero || $scope.operationCompleteOne || $scope.operationCompleteTwo) {
            validateCurrentScreen('OperationCompletePage');
        } /*else if (checkForSendConfirmationScreen()) { //check for send Recipe for selected Cavity 
         // MW0600025083 - Commented due to CQ issue, Need to check with Namit later
         showRecipeConfirmationScreen();
         }*/ else {
            showMonitorReadyRunScreen();
        }
    }

    function showMonitorReadyRunScreen() {
        debugMessage("showMonitorReadyRunScreen with selectedCavity > " + selectedCavity);
        if (selectedCavity === 'SINGLE' || selectedCavity === 'DUALUPPER' || selectedCavity === 'DUALFLEXUPPER') {
            if ($scope.idZero.Operation.state === 'Run') {
                validateCurrentScreen('RunDetailPage');
            } else {
                validateCurrentScreen('ReadyDetailPage');
            }
        } else if (selectedCavity === 'DUALLOWER' || selectedCavity === 'LOWERFLEX') {
            if ($scope.idTwo.Operation.state === 'Run') {
                validateCurrentScreen('RunDetailPage');
            } else {
                validateCurrentScreen('ReadyDetailPage');
            }
        } else if (selectedCavity === 'DUALFLEXLOWER') {
            if ($scope.idOne.Operation.state === 'Run') {
                validateCurrentScreen('RunDetailPage');
            } else {
                validateCurrentScreen('ReadyDetailPage');
            }
        }
    }

    function setDataCurrentScreen() {
        debugMessage("setDataCurrentScreen called");
        if (selectedCavity === '') {
            if ($scope.idOne.connected) {
                updateFlexModeScreenData();
            } else if ($scope.idTwo.connected && !$scope.idOne.connected) {
                updateDualModeScreenData();
            } else if (!$scope.idTwo.connected && !$scope.idOne.connected) {
                monitorClick(0);
            }
        } else {
            updateDisplayScreenData();
        }
    }

    function preValidateSendRecipeDataCheck() {
        debugMessage("preValidateSendRecipeDataCheck for " + " Single " + recipeDataValidateSingle + " DualUpper " + recipeDataValidateDualUpper + " DualLower " + recipeDataValidateDualLower + " DualFlexUpper " + recipeDataValidateDualFlexUpper + " DualFlexLower " + recipeDataValidateDualFlexLower + " LowerFlex " + recipeDataValidateLowerFlex);
        if (recipeDataValidateSingle && ($scope.validateSendRecipeInfoSingle.State !== ''
                && $scope.validateSendRecipeInfoSingle.State !== $scope.idZero.Operation.state)) {
            recipeDataValidateSingle = false;
        }
        if (recipeDataValidateDualUpper && ($scope.validateSendRecipeInfoDualUpper.State !== ''
                && $scope.validateSendRecipeInfoDualUpper.State !== $scope.idZero.Operation.state)) {
            recipeDataValidateDualUpper = false;
        }
        if (recipeDataValidateDualLower && ($scope.validateSendRecipeInfoDualLower.State !== ''
                && $scope.validateSendRecipeInfoDualLower.State !== $scope.idTwo.Operation.state)) {
            recipeDataValidateDualLower = false;
        }
        if (recipeDataValidateDualFlexUpper && ($scope.validateSendRecipeInfoDualFlexUpper.State !== ''
                && $scope.validateSendRecipeInfoDualFlexUpper.State !== $scope.idZero.Operation.state)) {
            recipeDataValidateDualFlexUpper = false;
        }
        if (recipeDataValidateDualFlexLower && ($scope.validateSendRecipeInfoDualFlexLower.State !== ''
                && $scope.validateSendRecipeInfoDualFlexLower.State !== $scope.idOne.Operation.state)) {
            recipeDataValidateDualFlexLower = false;
        }
        if (recipeDataValidateLowerFlex && ($scope.validateSendRecipeInfoLowerFlex.State !== ''
                && $scope.validateSendRecipeInfoLowerFlex.State !== $scope.idTwo.Operation.state)) {
            recipeDataValidateLowerFlex = false;
        }
    }

    function validateSendRecipeData() {
        debugMessage("validateSendRecipeData for " + " Single " + recipeDataValidateSingle + " DualUpper " + recipeDataValidateDualUpper + " DualLower " + recipeDataValidateDualLower + " DualFlexUpper " + recipeDataValidateDualFlexUpper + " DualFlexLower " + recipeDataValidateDualFlexLower + " LowerFlex " + recipeDataValidateLowerFlex + " cavity : " + selectedCavity);

        if (recipeDataValidateSingle && selectedCavity === 'SINGLE') {
            debugMessage("Test Values " + $scope.validateSendRecipeInfoSingle.Mode + " : " + $scope.idZero.Mode.modes[0] + ", " + $scope.validateSendRecipeInfoSingle.OperationTime + " : " + $scope.idZero.Operation.operationTime + ", " + (parseInt($scope.validateSendRecipeInfoSingle.DesiredTemp, 10)) + " : " + $scope.idZero.Temperatures[0].desired);
            if ($scope.validateSendRecipeInfoSingle.Mode === $scope.idZero.Mode.modes[0]
                    && $scope.validateSendRecipeInfoSingle.OperationTime === $scope.idZero.Operation.operationTime
                    && (parseInt($scope.validateSendRecipeInfoSingle.DesiredTemp, 10) === $scope.idZero.Temperatures[0].desired
                            || parseInt($scope.validateSendRecipeInfoSingle.HighLowTemp, 10) === $scope.idZero.Temperatures[0].desired)
                    && (($scope.meatProbeConnected && (parseInt($scope.validateSendRecipeInfoSingle.DesiredProbeTemp, 10) === $scope.idZero.Temperatures[1].desired))
                            || !$scope.meatProbeConnected)) {
                debugMessage("validateSendRecipeData for single mode and data is " + JSON.stringify($scope.validateSendRecipeInfoSingle));
                validateRecipeResult();
            }
        }

        if (recipeDataValidateDualUpper && selectedCavity === 'DUALUPPER') {
            debugMessage("Test Values " + $scope.validateSendRecipeInfoDualUpper.Mode + " : " + $scope.idZero.Mode.modes[0] + ", " + $scope.validateSendRecipeInfoDualUpper.OperationTime + " : " + $scope.idZero.Operation.operationTime + ", " + (parseInt($scope.validateSendRecipeInfoDualUpper.DesiredTemp, 10)) + " : " + $scope.idZero.Temperatures[0].desired);
            if ($scope.validateSendRecipeInfoDualUpper.Mode === $scope.idZero.Mode.modes[0]
                    && $scope.validateSendRecipeInfoDualUpper.OperationTime === $scope.idZero.Operation.operationTime
                    && (parseInt($scope.validateSendRecipeInfoDualUpper.DesiredTemp, 10) === $scope.idZero.Temperatures[0].desired
                            || parseInt($scope.validateSendRecipeInfoDualUpper.HighLowTemp, 10) === $scope.idZero.Temperatures[0].desired)
                    && (($scope.meatProbeConnected && (parseInt($scope.validateSendRecipeInfoDualUpper.DesiredProbeTemp, 10) === $scope.idZero.Temperatures[1].desired))
                            || !$scope.meatProbeConnected)) {
                debugMessage("validateSendRecipeData for dual Upper mode and data is " + JSON.stringify($scope.validateSendRecipeInfoDualUpper));
                validateRecipeResult();
            }
        }

        if (recipeDataValidateDualLower && selectedCavity === 'DUALLOWER') {
            debugMessage("Test Values " + $scope.validateSendRecipeInfoDualLower.Mode + " : " + $scope.idTwo.Mode.modes[0] + ", " + $scope.validateSendRecipeInfoDualLower.OperationTime + " : " + $scope.idTwo.Operation.operationTime + ", " + (parseInt($scope.validateSendRecipeInfoDualLower.DesiredTemp, 10)) + " : " + $scope.idTwo.Temperatures[0].desired);
            if ($scope.validateSendRecipeInfoDualLower.Mode === $scope.idTwo.Mode.modes[0]
                    && $scope.validateSendRecipeInfoDualLower.OperationTime === $scope.idTwo.Operation.operationTime
                    && (parseInt($scope.validateSendRecipeInfoDualLower.DesiredTemp, 10) === $scope.idTwo.Temperatures[0].desired
                            || parseInt($scope.validateSendRecipeInfoDualLower.HighLowTemp, 10) === $scope.idTwo.Temperatures[0].desired)
                    && (($scope.meatProbeConnected && (parseInt($scope.validateSendRecipeInfoDualLower.DesiredProbeTemp, 10) === $scope.idTwo.Temperatures[1].desired))
                            || !$scope.meatProbeConnected)) {
                debugMessage("validateSendRecipeData for dual lower mode and data is " + JSON.stringify($scope.validateSendRecipeInfoDualLower));
                validateRecipeResult();
            }
        }

        if (recipeDataValidateDualFlexUpper && selectedCavity === 'DUALFLEXUPPER') {
            debugMessage("Test Values " + $scope.validateSendRecipeInfoDualFlexUpper.Mode + " : " + $scope.idZero.Mode.modes[0] + ", " + $scope.validateSendRecipeInfoDualFlexUpper.OperationTime + " : " + $scope.idZero.Operation.operationTime + ", " + (parseInt($scope.validateSendRecipeInfoDualFlexUpper.DesiredTemp, 10)) + " " + $scope.idZero.Temperatures[0].desired);
            if ($scope.validateSendRecipeInfoDualFlexUpper.Mode === $scope.idZero.Mode.modes[0]
                    && $scope.validateSendRecipeInfoDualFlexUpper.OperationTime === $scope.idZero.Operation.operationTime
                    && (parseInt($scope.validateSendRecipeInfoDualFlexUpper.DesiredTemp, 10) === $scope.idZero.Temperatures[0].desired
                            || parseInt($scope.validateSendRecipeInfoDualFlexUpper.HighLowTemp, 10) === $scope.idZero.Temperatures[0].desired)
                    && (($scope.meatProbeConnected && (parseInt($scope.validateSendRecipeInfoDualFlexUpper.DesiredProbeTemp, 10) === $scope.idZero.Temperatures[1].desired))
                            || !$scope.meatProbeConnected)) {
                debugMessage("validateSendRecipeData for flex upper mode and data is " + JSON.stringify($scope.validateSendRecipeInfoDualFlexUpper));
                validateRecipeResult();
            }
        }

        if (recipeDataValidateDualFlexLower && selectedCavity === 'DUALFLEXLOWER') {
            debugMessage("Test Values " + $scope.validateSendRecipeInfoDualFlexLower.Mode + " : " + $scope.idOne.Mode.modes[0] + ", " + $scope.validateSendRecipeInfoDualFlexLower.OperationTime + " : " + $scope.idOne.Operation.operationTime + ", " + (parseInt($scope.validateSendRecipeInfoDualFlexLower.DesiredTemp, 10)) + " " + $scope.idOne.Temperatures[0].desired);
            if ($scope.validateSendRecipeInfoDualFlexLower.Mode === $scope.idOne.Mode.modes[0]
                    && $scope.validateSendRecipeInfoDualFlexLower.OperationTime === $scope.idOne.Operation.operationTime
                    && (parseInt($scope.validateSendRecipeInfoDualFlexLower.DesiredTemp, 10) === $scope.idOne.Temperatures[0].desired
                            || parseInt($scope.validateSendRecipeInfoDualFlexLower.HighLowTemp, 10) === $scope.idOne.Temperatures[0].desired)
                    && (($scope.meatProbeConnected && (parseInt($scope.validateSendRecipeInfoDualFlexLower.DesiredProbeTemp, 10) === $scope.idOne.Temperatures[1].desired))
                            || !$scope.meatProbeConnected)) {
                debugMessage("validateSendRecipeData for flex lower mode and data is " + JSON.stringify($scope.validateSendRecipeInfoDualFlexLower));
                validateRecipeResult();
            }
        }

        if (recipeDataValidateLowerFlex && selectedCavity === 'LOWERFLEX') {
            debugMessage("Test Values " + $scope.validateSendRecipeInfoLowerFlex.Mode + " : " + $scope.idTwo.Mode.modes[0] + ", " + $scope.validateSendRecipeInfoLowerFlex.OperationTime + " : " + $scope.idTwo.Operation.operationTime + ", " + (parseInt($scope.validateSendRecipeInfoLowerFlex.DesiredTemp, 10)) + " " + $scope.idTwo.Temperatures[0].desired);
            if ($scope.validateSendRecipeInfoLowerFlex.Mode === $scope.idTwo.Mode.modes[0]
                    && $scope.validateSendRecipeInfoLowerFlex.OperationTime === $scope.idTwo.Operation.operationTime
                    && (parseInt($scope.validateSendRecipeInfoLowerFlex.DesiredTemp, 10) === $scope.idTwo.Temperatures[0].desired
                            || parseInt($scope.validateSendRecipeInfoLowerFlex.HighLowTemp, 10) === $scope.idTwo.Temperatures[0].desired)
                    && (($scope.meatProbeConnected && (parseInt($scope.validateSendRecipeInfoLowerFlex.DesiredProbeTemp, 10) === $scope.idTwo.Temperatures[1].desired))
                            || !$scope.meatProbeConnected)) {
                debugMessage("validateSendRecipeData for lower flex mode and data is " + JSON.stringify($scope.validateSendRecipeInfoLowerFlex));
                validateRecipeResult();
            }
        }
    }

    function validateRecipeResult() {
        if (true) { //check for Direct Start cooking
            autoStartRecipe();
        } else {
            showRecipeConfirmationScreen();
        }
    }

    function autoStartRecipe() {
        debugMessage("Direct Start For ELectric model for");
        if (selectedCavity === 'SINGLE') {
            recipeDataValidateSingle = false;
            startCooking(0);
        } else if (selectedCavity === 'DUALUPPER') {
            recipeDataValidateDualUpper = false;
            startCooking(0);
        } else if (selectedCavity === 'DUALLOWER') {
            recipeDataValidateDualLower = false;
            startCooking(2);
        } else if (selectedCavity === 'DUALFLEXUPPER') {
            recipeDataValidateDualFlexUpper = false;
            startCooking(0);
        } else if (selectedCavity === 'DUALFLEXLOWER') {
            recipeDataValidateDualFlexLower = false;
            startCooking(1);
        } else if (selectedCavity === 'LOWERFLEX') {
            recipeDataValidateLowerFlex = false;
            startCooking(2);
        } else if (selectedCavity === '') {
            //TODO
        }
    }

    function showRecipeConfirmationScreen() {
        debugMessage("showRecipeConfirmationScreen");
        if (selectedCavity === 'SINGLE') {
            updateValidateSendRecipeInfo($scope.validateSendRecipeInfoSingle);
        } else if (selectedCavity === 'DUALUPPER') {
            updateValidateSendRecipeInfo($scope.validateSendRecipeInfoDualUpper);
        } else if (selectedCavity === 'DUALLOWER') {
            updateValidateSendRecipeInfo($scope.validateSendRecipeInfoDualLower);
        } else if (selectedCavity === 'DUALFLEXUPPER') {
            updateValidateSendRecipeInfo($scope.validateSendRecipeInfoDualFlexUpper);
        } else if (selectedCavity === 'DUALFLEXLOWER') {
            updateValidateSendRecipeInfo($scope.validateSendRecipeInfoDualFlexLower);
        } else if (selectedCavity === 'LOWERFLEX') {
            updateValidateSendRecipeInfo($scope.validateSendRecipeInfoLowerFlex);
        } else if (selectedCavity === '') {
            //TODO
        }
        validateCurrentScreen('SendConfirmationPage');
        return;
    }

    function checkForSendConfirmationScreen() {
        if (recipeDataValidateSingle && selectedCavity === 'SINGLE') {
            debugMessage("show send recipe for recipeDataValidateSingle");
            return true;
        } else if (recipeDataValidateDualUpper && selectedCavity === 'DUALUPPER') {
            debugMessage("show send recipe for recipeDataValidateDualUpper");
            return true;
        } else if (recipeDataValidateDualLower && selectedCavity === 'DUALLOWER') {
            debugMessage("show send recipe for recipeDataValidateDualLower");
            return true;
        } else if (recipeDataValidateDualFlexUpper && selectedCavity === 'DUALFLEXUPPER') {
            debugMessage("show send recipe for recipeDataValidateDualFlexUpper");
            return true;
        } else if (recipeDataValidateDualFlexLower && selectedCavity === 'DUALFLEXLOWER') {
            debugMessage("show send recipe for recipeDataValidateDualFlexLower");
            return true;
        } else if (recipeDataValidateLowerFlex && selectedCavity === 'LOWERFLEX') {
            debugMessage("show send recipe for recipeDataValidateLowerFlex");
            return true;
        }
        return false;
    }

    function loadingValues() {
        dismissLoadingBar(WALLOVEN_COMMANDS.getDevices);
        if ($scope.idZero !== undefined && $scope.idZero.Operation.state === 'Run'
                || $scope.idOne !== undefined && $scope.idOne.Operation.state === 'Run'
                || $scope.idTwo !== undefined && $scope.idTwo.Operation.state === 'Run') {
            if ($scope.checkResponse.indexOf(WALLOVEN_COMMANDS.sendRecipetoOven) !== -1) {
                if (!!!promise1) {
                    promise1 = $timeout(function () {
                        dismissSendCommand();
                    }, Sec20Call);
                }
            }
            if ($scope.checkResponse.indexOf(WALLOVEN_COMMANDS.startCooking) !== -1) {
                if (!!!promise2) {
                    promise2 = $timeout(function () {
                        dismissStartCommand();
                    }, Sec20Call);
                }
            }
        }
        if ($scope.idZero !== undefined && $scope.idZero.Operation.state === 'Ready'
                || $scope.idOne !== undefined && $scope.idOne.Operation.idOne === 'Ready'
                || $scope.idTwo !== undefined && $scope.idTwo.Operation.state === 'Ready') {
            if ($scope.checkResponse.indexOf(WALLOVEN_COMMANDS.cancelCooking) !== -1) {
                if (!!!promise3) {
                    promise3 = $timeout(function () {
                        dismissCancelCookingCommand();
                    }, Sec20Call);
                }
            }
        }

    }

    function dismissSendCommand() {
        if (!!promise1) {
            $timeout.cancel(promise1);
            promise1 = null;
        }
        if ($scope.checkResponse.indexOf(WALLOVEN_COMMANDS.sendRecipetoOven) !== -1) {
            dismissLoadingBar(WALLOVEN_COMMANDS.sendRecipetoOven);
        }
    }

    function dismissStartCommand() {
        if (!!promise2) {
            $timeout.cancel(promise2);
            promise2 = null;
        }
        if ($scope.checkResponse.indexOf(WALLOVEN_COMMANDS.startCooking) !== -1) {
            dismissLoadingBar(WALLOVEN_COMMANDS.startCooking);
        }
    }

    function dismissCancelCookingCommand() {
        if (!!promise3) {
            $timeout.cancel(promise3);
            promise3 = null;
        }
        if ($scope.checkResponse.indexOf(WALLOVEN_COMMANDS.cancelCooking) !== -1) {
            dismissLoadingBar(WALLOVEN_COMMANDS.cancelCooking);
        }
    }

    function settingPageOptionsValidation() {
        $scope.bFahrenheit = $scope.idZero.Temperatures[0].unit !== 'Celsius';
        $scope.TempUnit = $scope.idZero.Temperatures[0].unit === 'Celsius' ? 'C' : 'F';
        $scope.bSound = $scope.idZero.Mode.options[0].Sound === 'On';
        $scope.bSabbathMode = $scope.idZero.Mode.options[0].Sabbath === 'On';
        $scope.bVirtualFlame = $scope.idZero.Mode.options[0].VirtualFlame === 'On';
        $scope.bHrEnergySaving = $scope.idZero.Mode.options[0].EnergySaving === 'On';
        $scope.bAutoConversion = $scope.idZero.Mode.options[0].RecipeConversion === 'On';
        $scope.AdjustTemp = getAdjustTemp(parseInt($scope.idZero.Mode.options[0].AdjustingTemp, 10));
        $scope.maxAdjustTemp = $scope.TempUnit === 'C' ? 19 : 35;
        $scope.minAdjustTemp = $scope.TempUnit === 'C' ? -19 : -35;
        $scope.TempIncrement = $scope.TempUnit === 'C' ? 1 : 1;
    }

    function fixScreen() {
        scroll_middle_area.style.overflowY = "hidden";
        scroll_middle_area.style.position = "fixed";
        hideInputBoxFocus();
    }

    function scrollScreen() {
        //document.getElementById("bodyTag").style.pointerEvents = 'auto';
        scroll_middle_area.style.position = "absolute";
        scroll_middle_area.style.overflowY = "overlay";
    }

    function preConditionValidation(screen) {
        debugMessage('preConditionValidation ' + screen);
        $scope.headerBarVisible = true;
        $scope.mainLoadingScreen = true;
        $scope.moreOptionVisible = false;
        $scope.multiselect = false;
        $scope.settingOption = true;
        $scope.aboutOption = true;
        $scope.deleteOption = false;
        $scope.editOption = false;
        $scope.floatingButton = false;
        doNotChangeScreen = false;
        checkForMeatProbe();
        if ($scope.wallOvenModeMenu && $scope.currentScreen !== WALLOVEN_SCREENS.WALLOVEN_READY_DETAIL_PAGE) {
            $scope.wallOvenModeMenu = false;
            $scope.wOvenCurrentTab = null;
        }
        if (angular.isDefined($state.current) && angular.isDefined($state.current) && screen !== $state.current.name) {
            $scope.recipeStarted = false;
            if ($scope.samrtControlPopup || $scope.showMenuOptionPopup) {
                $scope.samrtControlPopup = false;
                $scope.showMenuOptionPopup = false;
            }
        }
        if ($scope.wallOvenModeMenu || $scope.showFullScreenPopup || $scope.showMenuOptionPopup || $scope.steamRoastPopup || $scope.samrtControlPopup) {
            fixScreen();
        } else {
            scrollScreen();
        }
    }

    function validateCurrentScreen(screen) {
        preConditionValidation(screen);
        switch (screen) {
            case 'MainLoadingPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_MAIN_LOADING_PAGE;
                $scope.deviceName = "";
                $scope.headerBarVisible = false;
                $scope.mainLoadingScreen = false;
                $state.transitionTo('MainLoadingPage');
                break;
            case 'ReadyDetailPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_READY_DETAIL_PAGE;
                $scope.deviceName = getTitlt();//'WEBMOB_common_device_oven';
                if (!$scope.idTwo.connected && !$scope.idOne.connected) {
                    $scope.moreOptionVisible = true;
                }
                //fixScreen();
                scrollScreen();
                $state.transitionTo('ReadyDetailPage');
                break;
            case 'RunDetailPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_RUN_DETAIL_PAGE;
                $scope.deviceName = getTitlt();//'WEBMOB_common_device_oven';
                if (!$scope.idTwo.connected && !$scope.idOne.connected) {
                    $scope.moreOptionVisible = true;
                }
                //fixScreen();
                scrollScreen();
                $state.transitionTo('RunDetailPage');
                break;
            case 'DividerConnectedPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_DIVIDER_CONNECTED_PAGE;
                $scope.deviceName = $scope.translation.WEBMOB_common_device_oven;
                $scope.moreOptionVisible = true;
                selectedCavity = '';
                $state.transitionTo('DividerConnectedPage');
                break;
            case 'FlexConnectedPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_FLEX_CONNECTED_PAGE;
                $scope.deviceName = $scope.translation.WEBMOB_common_device_oven;
                $scope.moreOptionVisible = true;
                selectedCavity = '';
                $state.transitionTo('FlexConnectedPage');
                break;
            case 'MyFavoritePage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_MY_FAVORITE_PAGE;
                $scope.deviceName = $scope.translation.WEBMOB_device_walloven_myfavorite;
                $scope.headerBarVisible = true;
                $scope.moreOptionVisible = true;
                $scope.settingOption = false;
                $scope.aboutOption = false;
                $scope.deleteOption = true;
                $scope.floatingButton = true;
                $scope.currentRecipeName = '';
                $scope.desiredMFRecipeName = '';
                $scope.MFRandomID = '';
                updateMyFavItems();
                $state.transitionTo('MyFavoritePage');
                break;
            case 'EditMyFavoriteDetailPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_EDIT_MY_FAVORITE_DETAIL_PAGE;
                $scope.deviceName = $scope.translation.WEBMOB_device_walloven_myfavorite;
                $scope.headerBarVisible = false;
                $state.transitionTo('EditMyFavoriteDetailPage');
                break;
            case 'MyFavoriteRecipeDetailPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_MY_FAVORITE_RECIPE_DETAIL_PAGE;
                $scope.deviceName = $scope.desiredMFRecipeName;
                $scope.headerBarVisible = true;
                $scope.moreOptionVisible = true;
                $scope.editOption = true;
                $scope.settingOption = false;
                $scope.aboutOption = false;
                $scope.deleteOption = true;
                $state.transitionTo('MyFavoriteRecipeDetailPage');
                fixScreen();
                break;
            case 'SmartControlPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_SMART_CONTROL_PAGE;
                $scope.deviceName = $scope.translation.WEBMOB_device_walloven_smartcontrol_title;
                doNotChangeScreen = true;
                $state.transitionTo('SmartControlPage');
                break;
            case 'AutoCookPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_AUTOCOOK_SCREEN;
                $scope.deviceName = $scope.translation.WEBMOB_device_range_auto_cook;
                $state.transitionTo('AutoCookPage');
                break;
            case 'AutoCookDetailPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_AUTOCOOK_DETAIL_SCREEN;
                $scope.deviceName = $scope.translation[$scope.AutoCookData[$scope.autoCookRecipeId].title];//'WEBMOB_device_range_auto_cook';
                $state.transitionTo('AutoCookDetailPage');
                break;
            case 'SendConfirmationPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_SEND_CONFIRMATION_SCREEN;
                $scope.deviceName = $scope.translation.WEBMOB_common_device_oven;
                $state.transitionTo('SendConfirmationPage');
                break;
            case 'OperationCompletePage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_OPERATION_COMPLETE_PAGE;
                $scope.deviceName = getOperationTitlt();
                checkForClosePopup();
                $state.transitionTo('OperationCompletePage');
                break;
            case 'ErrorPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_ERROR_PAGE;
                $scope.deviceName = $scope.translation.WEBMOB_device_range_comm_error;
                $scope.samrtControlPopup = false;
                $scope.showMenuOptionPopup = false;
                $scope.showFullScreenPopup = false;
                $state.transitionTo('ErrorPage');
                break;
            case 'SettingPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_SETTING_PAGE;
                $scope.deviceName = $scope.translation.WEBMOB_common_settings;
                settingPageOptionsValidation();
                doNotChangeScreen = true;
                $state.transitionTo('SettingPage');
                break;
            case 'AboutPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_ABOUT_PAGE;
                $scope.deviceName = $scope.translation.WEBMOB_common_about_device;
                doNotChangeScreen = true;
                $state.transitionTo('AboutPage');
                break;
            case 'SettingTempAdjustPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_SETTING_TEMP_ADJUDT_PAGE;
                $scope.deviceName = $scope.translation.WEBMOB_device_range_settings_temp_adjust;
                $scope.tempAdjustButtonChange = false;
                doNotChangeScreen = true;
                $state.transitionTo('SettingTempAdjustPage');
                break;
            case 'SettingTempUnitPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_SETTING_TEMP_UNIT_PAGE;
                $scope.deviceName = $scope.translation.WEBMOB_device_range_settings_temp_unit;
                doNotChangeScreen = true;
                $state.transitionTo('SettingTempUnitPage');
                break;
            case 'EditRunningPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_EDIT_RUNNING_COOKING;
                $scope.deviceName = getTitlt();
                $state.transitionTo('EditRunningPage');
                $scope.editMode = true;
                break;
            case 'SmartCarePage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_SMART_CARE_PAGE;
                $scope.deviceName = $scope.translation.WEBMOB_common_self_diagnosis;
                $scope.TabsVisibleAtPage = false;
                $scope.headerBarVisible = true;
                changeSmartCarePage = true;
                $state.transitionTo('SmartCarePage');
                break;
            case 'SmartCareNoErrorPage':
                debugMessage("validate screen : " + screen);
                $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_SMART_CARE_NO_ERROR_PAGE;
                $scope.deviceName = $scope.translation.WEBMOB_common_self_diagnosis;
                $scope.TabsVisibleAtPage = false;
                $scope.headerBarVisible = true;
                changeSmartCarePage = true;
                $state.transitionTo('SmartCareNoErrorPage');
                break;

            default :
                debugMessage("validate screen else part: " + screen);
                break;
        }
    }

    function getTitlt() {
        debugMessage('set title based on Cavity');

        if (selectedCavity === 'SINGLE') {
            return $scope.translation.WEBMOB_common_device_oven;
        } else if (selectedCavity === 'DUALUPPER') {
            return $scope.translation.WEBMOB_device_walloven_title_upper;
        } else if (selectedCavity === 'DUALLOWER') {
            return $scope.translation.WEBMOB_device_walloven_title_lower;
        } else if (selectedCavity === 'DUALFLEXUPPER') {
            return $scope.translation.WEBMOB_device_walloven_title_flexupper;
        } else if (selectedCavity === 'DUALFLEXLOWER') {
            return $scope.translation.WEBMOB_device_walloven_title_flexlower;
        } else if (selectedCavity === 'LOWERFLEX') {
            return $scope.translation.WEBMOB_device_walloven_title_lower;
        } else {
        }
    }

    function getOperationTitlt() {
        if ($scope.operationCompleteZero && !$scope.idTwo.connected && !$scope.idOne.connected) {
            return $scope.translation.WEBMOB_common_device_oven;
        } else if ($scope.operationCompleteZero && $scope.idTwo.connected && !$scope.idOne.connected) {
            return $scope.translation.WEBMOB_device_walloven_title_upper;
        } else if ($scope.operationCompleteTwo && $scope.idTwo.connected && !$scope.idOne.connected) {
            return $scope.translation.WEBMOB_device_walloven_title_lower;
        } else if ($scope.operationCompleteZero && !$scope.idTwo.connected && $scope.idOne.connected) {
            return $scope.translation.WEBMOB_device_walloven_title_flexupper;
        } else if ($scope.operationCompleteOne && !$scope.idTwo.connected && $scope.idOne.connected) {
            return $scope.translation.WEBMOB_device_walloven_title_flexlower;
        } else if ($scope.operationCompleteTwo && !$scope.idTwo.connected && $scope.idOne.connected) {
            return $scope.translation.WEBMOB_device_walloven_title_lower;
        } else {
            return $scope.translation.WEBMOB_common_device_oven;
        }
    }

    function checkForClosePopup() {
        //Close all the popups in case "cancel cooking" notification, Currently the method is being called only once, 
        // we can add cases to it in future if required
        if ($scope.showFullScreenPopup) {
            //if ($scope.alertState === WALLOVEN_ALERT_STATE.ALERT_PREHEATCOMPLETE) {
            $scope.showFullScreenPopup = false;
            //}
        }

        //close menu popup if open in case of state RUN recieved from SET
        ($scope.wallOvenModeMenu || $scope.MFMenuVisible) && hideModeMenu();
    }

    function onBackPressedEvent(e) {
        //e.stopPropagation();
        onBackPressed();
    }

    function resetProbeTempToDefault() {
        debugMessage('resetProbeTempToDefault');
        if (!userPreferneceSingle.preferneceProbeTemp) {
            userPreferneceSingle.preferneceProbeTemp = 0;
        }
        if (!userPreferneceDualUpper.preferneceProbeTemp) {
            userPreferneceDualUpper.preferneceProbeTemp = 0;
        }
        if (!userPreferneceDualFlexUpper.preferneceProbeTemp) {
            userPreferneceDualFlexUpper.preferneceProbeTemp = 0;
        }
        $scope.desiredProbeTemp = 0;
        $scope.editDesiredProbeTemp = 0;
    }

    function refreshValue() {
        debugMessage('All value reset');
        scrollScreen();
        $scope.editMode = false;
        doNotChangeScreen = false;
        $scope.MFMenuVisible = false;
        $scope.wOvenCurrentTab = null;
        $scope.wallOvenModeMenu = false;
        $scope.showFullScreenPopup = false;
        $scope.steamRoastPopup = false;
        $scope.samrtControlPopup = false;
    }

    function onBackPressed() {
        debugMessage("Back key pressed from : " + $scope.currentScreen);
        refreshValue();
        switch ($scope.currentScreen) {
            case WALLOVEN_SCREENS.WALLOVEN_MAIN_LOADING_PAGE:
            case WALLOVEN_SCREENS.WALLOVEN_DIVIDER_CONNECTED_PAGE:
            case WALLOVEN_SCREENS.WALLOVEN_FLEX_CONNECTED_PAGE:
            case WALLOVEN_SCREENS.WALLOVEN_ERROR_PAGE:
                closeApp();
                break;
            case WALLOVEN_SCREENS.WALLOVEN_AUTOCOOK_SCREEN:
                $scope.autoCookRecipeId = 0;
            case WALLOVEN_SCREENS.WALLOVEN_SMART_CONTROL_PAGE:
                doNotChangeScreen = false;
                validateCurrentScreen('ReadyDetailPage');
                break;
            case WALLOVEN_SCREENS.WALLOVEN_AUTOCOOK_DETAIL_SCREEN:
                $scope.autoCookRecipeId = 0;
                validateCurrentScreen('AutoCookPage');
                break;
            case WALLOVEN_SCREENS.WALLOVEN_SETTING_PAGE:
            case WALLOVEN_SCREENS.WALLOVEN_ABOUT_PAGE:
                doNotChangeScreen = false;
                showCurrentScreen();
                break;
            case WALLOVEN_SCREENS.WALLOVEN_EDIT_MY_FAVORITE_DETAIL_PAGE:
                validateCurrentScreen('MyFavoritePage');
                break;
            case WALLOVEN_SCREENS.WALLOVEN_MY_FAVORITE_RECIPE_DETAIL_PAGE:
                scrollScreen();
                validateCurrentScreen('MyFavoritePage');
                break;
            case WALLOVEN_SCREENS.WALLOVEN_SETTING_TEMP_ADJUDT_PAGE:
            case WALLOVEN_SCREENS.WALLOVEN_SETTING_TEMP_UNIT_PAGE:
                $scope.tempAdjustButtonChange = false;
                validateCurrentScreen('SettingPage');
                break;
            case WALLOVEN_SCREENS.WALLOVEN_EDIT_RUNNING_COOKING:
                $scope.editMode = false;
                $scope.editModeTimeUpdate = false;
                $scope.editModeTempUpdate = false;
                validateCurrentScreen('RunDetailPage');
                break;
            case WALLOVEN_SCREENS.WALLOVEN_MY_FAVORITE_PAGE:
                if ($scope.multiselect) {
                    $scope.editMyCookingSelectedDeleteItems = [];
                    $scope.headerBarVisible = true;
                    $scope.multiselect = false;
                    updateMyFavItems();
                } else {
                    saveUserValue();
                    setDataCurrentScreen();
                    showScreen();
                }
                break;
            case WALLOVEN_SCREENS.WALLOVEN_OPERATION_COMPLETE_PAGE:
                operationCompleteButton();
            case WALLOVEN_SCREENS.WALLOVEN_SEND_CONFIRMATION_SCREEN:
            case WALLOVEN_SCREENS.WALLOVEN_READY_DETAIL_PAGE:
            case WALLOVEN_SCREENS.WALLOVEN_RUN_DETAIL_PAGE:
                if (selectedCavity !== '' && selectedCavity !== 'SINGLE') {
                    saveUserValue();
                    selectedCavity = '';
                    setDataCurrentScreen();
                    showScreen();
                } else {
                    closeApp();
                }
                break;

            case WALLOVEN_SCREENS.WALLOVEN_SMART_CARE_PAGE:
                validateCurrentScreen('AboutPage');
                break;
            case WALLOVEN_SCREENS.WALLOVEN_SMART_CARE_NO_ERROR_PAGE:
                //changeSmartCarePage = false;
                //showCurrentScreen();
                //Go to about page from error page 
                validateCurrentScreen('AboutPage');
                break;
            default :
                debugMessage("Back key pressed from else " + $scope.currentScreen);
                //closeApp();
                break;
        }
    }

    function closeApp() {
        debugMessage('closeApp');
        nativeInterface.runOnNative("closeWebApp", "");
    }

    function dismissLoadingBar(value) {
        debugMessage("dismissLoadingBar " + $scope.checkResponse + " value " + value);
        if ($scope.checkResponse.indexOf(value) !== -1) {
            $scope.checkResponse.splice($scope.checkResponse.indexOf(value), 1);
            dismissLoadingBar(value);
            if ($scope.checkResponse.length === 0) {
                $scope.loadingBar = false;
            }
        }
    }

    function emptyAlarm() {
        debugMessage("emptyAlarm");
        if ($scope.idZero.Alarms[0].code !== "-1") {
            $scope.idZero.Alarms[0].id = '-1';
            $scope.idZero.Alarms[0].code = '-1';
            $scope.idZero.Alarms[0].alarmType = '-1';
            $scope.idZero.Alarms[0].triggeredTime = '-1';
            $scope.operationCompleteZero = false;
            return;
        }
        if ($scope.idOne.Alarms[0].code !== "-1") {
            $scope.idOne.Alarms[0].id = '-1';
            $scope.idOne.Alarms[0].code = '-1';
            $scope.idOne.Alarms[0].alarmType = '-1';
            $scope.idOne.Alarms[0].triggeredTime = '-1';
            $scope.operationCompleteOne = false;
            return;
        }
        if ($scope.idTwo.Alarms[0].code !== "-1") {
            $scope.idTwo.Alarms[0].id = '-1';
            $scope.idTwo.Alarms[0].code = '-1';
            $scope.idTwo.Alarms[0].alarmType = '-1';
            $scope.idTwo.Alarms[0].triggeredTime = '-1';
            $scope.operationCompleteTwo = false;
            return;
        }
        if ($scope.idZero.Alarms[0].code === "-1" && $scope.operationCompleteZero) {
            $scope.operationCompleteZero = false;
        }
        if ($scope.idOne.Alarms[0].code === "-1" && $scope.operationCompleteOne) {
            $scope.operationCompleteOne = false;
        }
        if ($scope.idTwo.Alarms[0].code === "-1" && $scope.operationCompleteTwo) {
            $scope.operationCompleteTwo = false;
        }
    }

    function refreshDateAfterDone() {
        debugMessage("refreshDateAfterDone " + selectedCavity);
        if (selectedCavity === 'SINGLE') {
            userPreferneceSingle = {};
            debugMessage("refreshDateAfterDone " + userPreferneceSingle);
            wOvenSingleBaseMode = "Bake";
            $scope.DisplayContents = getModeRowValue($scope.supportedModesSingle, wOvenSingleBaseMode);
            setValueForSingleMode();
        } else if (selectedCavity === 'DUALUPPER') {
            userPreferneceDualUpper = {};
            debugMessage("refreshDateAfterDone " + JSON.stringify(userPreferneceDualUpper));
            wOvenDualUpperBaseMode = "ConvectionBake";
            $scope.DisplayContents = getModeRowValue($scope.supportedModesDualUpper, wOvenDualUpperBaseMode);
            setValueForDualUpperMode();
        } else if (selectedCavity === 'DUALLOWER') {
            userPreferneceDualLower = {};
            debugMessage("refreshDateAfterDone " + userPreferneceDualLower);
            wOvenDualLowerBaseMode = "Bake";
            $scope.DisplayContents = getModeRowValue($scope.supportedModesDualLower, wOvenDualLowerBaseMode);
            setValueForDualLowerMode();
        } else if (selectedCavity === 'DUALFLEXUPPER') {
            userPreferneceDualFlexUpper = {};
            debugMessage("refreshDateAfterDone " + userPreferneceDualFlexUpper);
            wOvenDualFlexUpperBaseMode = "ConvectionBake";
            $scope.DisplayContents = getModeRowValue($scope.supportedModesDualUpperFlex, wOvenDualFlexUpperBaseMode);
            setValueForDualFlexUpperMode();
        } else if (selectedCavity === 'DUALFLEXLOWER') {
            userPreferneceDualFlexLower = {};
            debugMessage("refreshDateAfterDone " + userPreferneceDualFlexLower);
            wOvenDualFlexLowerBaseMode = "Bake";
            $scope.DisplayContents = getModeRowValue($scope.supportedModesDualLowerFlex, wOvenDualFlexLowerBaseMode);
            setValueForDualFlexLowerMode();
        } else if (selectedCavity === 'LOWERFLEX') {
            userPreferneceDualLower = {};
            debugMessage("refreshDateAfterDone " + userPreferneceDualLower);
            wOvenDualLowerBaseMode = "Bake";
            $scope.DisplayContents = getModeRowValue($scope.supportedModesDualLower, wOvenDualLowerBaseMode);
            setValueForDualLowerMode();
        } else if (selectedCavity === '') {
            //TODO
        }
    }

    function convertTimeHMMformat(time) {
        var h, m;
        h = Number(time.split(':')[0]);
        m = time.split(':')[1];
        return (h + ':' + m);
    }

    function convertTimeformat(time) {
        var h, m;
        h = Number(time.split(':')[0]);
        m = time.split(':')[1];

        if (h > 0) {
            return (h + $scope.translation.WEBMOB_device_range_comm_hr + " " + m + $scope.translation.WEBMOB_common_min);
        } else if (Number(m) > 0) {
            return (m + $scope.translation.WEBMOB_common_min);
        }
        return (h + ':' + m);
    }

    function getMyFavTime(time) {
        var h, m, newDate;
        newDate = new Date();
        newDate.setHours(0, time, 0);
        h = Number(newDate.getHours());
        m = Number(newDate.getMinutes());
        if (h > 0) {
            return (h + $scope.translation.WEBMOB_device_range_comm_hr + " " + m + $scope.translation.WEBMOB_common_min);
        } else if (Number(m) > 0) {
            return (m + $scope.translation.WEBMOB_common_min);
        }
        return '';
    }

    function claculateLeftTime(time) {
        var now, newDate, remHrs, remMin, crhours, crminutes, estHrs, estMin, h = 0, m = 0, meridiem = '';
        now = new Date();
        newDate = new Date();
        crhours = now.getHours();
        crminutes = now.getMinutes();
        if (time !== undefined) {
            remHrs = Number(time.split(":")[0]);
            remMin = Number(time.split(":")[1]);
            estHrs = remHrs + crhours;
            estMin = remMin + crminutes;
            newDate.setHours(estHrs, estMin, 0);
            h = newDate.getHours();
            m = newDate.getMinutes();
            if (!$scope.is24HourFormat) {
                meridiem = h >= 12 ? ' PM' : ' AM';
                h = h % 12;
                h = h ? h : 12;
            }
            m = m < 10 ? '0' + m : m;
            debugMessage("claculateLeftTime for is24HourFormat " + $scope.is24HourFormat + " time : " + time + " is :" + " " + h + ":" + m + meridiem);
            return " " + h + ":" + m + meridiem;
        }
        return " " + h + ":" + m + meridiem;
    }

    function setMinTempValue(desiredTemp) {
        if ($scope.TempUnit === 'F') {
            switch (true) {
                case (desiredTemp <= 199):
                    return 175;
                case (desiredTemp <= 224):
                    return 175;
                case (desiredTemp <= 249):
                    return 200;
                case (desiredTemp <= 274):
                    return 225;
                case (desiredTemp <= 299):
                    return 250;
                case (desiredTemp <= 324):
                    return 250;
                case (desiredTemp <= 349):
                    return 275;
                case (desiredTemp <= 374):
                    return 275;
                case (desiredTemp <= 399):
                    return 300;
                case (desiredTemp <= 424):
                    return 325;
                case (desiredTemp <= 449):
                    return 350;
                case (desiredTemp <= 474):
                    return 350;
                case (desiredTemp <= 999):
                    return 400;
            }
        } else if ($scope.TempUnit === 'C') {
            switch (true) {
                case (desiredTemp <= 93):
                    return 80;
                case (desiredTemp <= 107):
                    return 80;
                case (desiredTemp <= 121):
                    return 90;
                case (desiredTemp <= 134):
                    return 110;
                case (desiredTemp <= 148):
                    return 120;
                case (desiredTemp <= 162):
                    return 120;
                case (desiredTemp <= 174):
                    return 135;
                case (desiredTemp <= 190):
                    return 135;
                case (desiredTemp <= 204):
                    return 150;
                case (desiredTemp <= 218):
                    return 160;
                case (desiredTemp <= 232):
                    return 175;
                case (desiredTemp <= 246):
                    return 175;
                case (desiredTemp <= 999):
                    return 205;
            }
        }
    }

    function setMaxTempValue(desiredTemp) {
        if ($scope.TempUnit === 'F') {
            switch (true) {
                case desiredTemp <= 199:
                    return 200;
                case desiredTemp <= 224:
                    return 225;
                case desiredTemp <= 249:
                    return 250;
                case desiredTemp <= 274:
                    return 300;
                case desiredTemp <= 299:
                    return 350;
                case desiredTemp <= 324:
                    return 375;
                case desiredTemp <= 349:
                    return 400;
                case desiredTemp <= 374:
                    return 450;
                case desiredTemp <= 399:
                    return 450;
                case desiredTemp <= 424:
                    return 480;
                case desiredTemp <= 449:
                    return 480;
                case desiredTemp <= 474:
                    return 480;
                case desiredTemp <= 999:
                    return 480;
            }
        } else if ($scope.TempUnit === 'C') {
            switch (true) {
                case desiredTemp <= 93:
                    return 90;
                case desiredTemp <= 107:
                    return 110;
                case desiredTemp <= 121:
                    return 120;
                case desiredTemp <= 134:
                    return 150;
                case desiredTemp <= 148:
                    return 175;
                case desiredTemp <= 162:
                    return 190;
                case desiredTemp <= 174:
                    return 205;
                case desiredTemp <= 190:
                    return 230;
                case desiredTemp <= 204:
                    return 230;
                case desiredTemp <= 218:
                    return 250;
                case desiredTemp <= 232:
                    return 250;
                case desiredTemp <= 246:
                    return 250;
                case desiredTemp <= 999:
                    return 250;
            }
        }
    }

    function CtoF(c) {
        var temp = Math.round((c * 1.8) + 32);
        if (temp < $scope.MFContents[14]) {
            temp = $scope.MFContents[14];
        } else if (temp > $scope.MFContents[15]) {
            temp = $scope.MFContents[15];
        }
        return temp;
    }

    function FtoC(f) {
        var temp = Math.round((f - 32) / 1.8);
        if (temp < $scope.MFContents[17]) {
            temp = $scope.MFContents[17];
        } else if (temp > $scope.MFContents[18]) {
            temp = $scope.MFContents[18];
        }
        return temp;
    }

    function SmartControlCheck(id) {
        if (id === 2) {
            if ($scope.remoteControlEnabledIdTwo) {
                return  true;
            }
        } else {
            if ($scope.remoteControlEnabled) {
                return  true;
            }
        }
        return  false;
    }

    function sendButtonClick() {
        debugMessage("sendButtonClick for selectedCavity > " + selectedCavity);
        if (false) { //check for Direct Start pop up avoid
            startCookingConfirmed();
        } else {
            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_START_COOKING, '', $scope.translation.WEBMOB_device_range_alarm_start_cooking_now, $scope.translation.WEBMOB_device_range_comm_no, $scope.translation.WEBMOB_device_range_comm_yes);
        }
    }

    function sendMFButtonClick() {
        debugMessage("sendMFButtonClick for selectedCavity > " + selectedCavity);
        if (false) { //check for Direct Start pop up avoid
            startCookingConfirmed();
        } else {
            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_START_MF_COOKING, '', $scope.translation.WEBMOB_device_range_alarm_start_cooking_now, $scope.translation.WEBMOB_device_range_comm_no, $scope.translation.WEBMOB_device_range_comm_yes);
        }
    }

    function cancleButtonClick() {
        debugMessage("Cancel command for selectedCavity > " + selectedCavity);
        if ($scope.idZero.Oven.state === 'Finish' || $scope.idTwo.Oven.state === 'Finish' || $scope.idOne.Oven.state === 'Finish') {
            operationCompleteButton();
            return;
        }

        var state = '';
        if (selectedCavity === 'SINGLE' || selectedCavity === 'DUALUPPER' || selectedCavity === 'DUALFLEXUPPER') {
            state = $scope.idZero.Oven.state;
        } else if (selectedCavity === 'DUALLOWER' || selectedCavity === 'LOWERFLEX') {
            state = $scope.idTwo.Oven.state;
        } else if (selectedCavity === 'DUALFLEXLOWER') {
            state = $scope.idOne.Oven.state;
        }

        if (state === "Cleaning" || state === "Draining") {
            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_CANCEL_COOKING, '', $scope.translation.WEBMOB_device_range_alarm_cancel_cleaning_now, $scope.translation.WEBMOB_device_range_comm_no, $scope.translation.WEBMOB_device_range_comm_yes);
        } else if (state === "Warming") {
            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_CANCEL_COOKING, '', $scope.translation.WEBMOB_device_range_warming_cancel, $scope.translation.WEBMOB_device_range_comm_no, $scope.translation.WEBMOB_device_range_comm_yes);
        } else {
            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_CANCEL_COOKING, '', $scope.translation.WEBMOB_device_range_cooking_cancel, $scope.translation.WEBMOB_device_range_comm_no, $scope.translation.WEBMOB_device_range_comm_yes);
        }
    }

    function startCookingConfirmed() {
        debugMessage("startCookingConfirmed");
        if ($scope.idZero.Operation.kidsLock === 'Run') {
            debugMessage("return Kids Lock is ON");
            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_CHILD_LOCK, $scope.translation.WEBMOB_device_range_alarm_child_lock_title, $scope.translation.WEBMOB_device_cooktop_alarm_child_lock, $scope.translation.WEBMOB_common_ok, '');
            return;
        }

        var deviceId = 0;
        if (selectedCavity === 'SINGLE' || selectedCavity === 'DUALUPPER' || selectedCavity === 'DUALFLEXUPPER') {
            deviceId = 0;
        } else if (selectedCavity === 'DUALLOWER' || selectedCavity === 'LOWERFLEX') {
            deviceId = 2;
        } else if (selectedCavity === 'DUALFLEXLOWER') {
            deviceId = 1;
        }

        if (!SmartControlCheck(deviceId)) {
            debugMessage("return smart control OFF");
            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_SMARTMONITOR_GUIDE, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_range_alarm_smart_control_on, $scope.translation.WEBMOB_common_ok, '');
            return;
        }

        if ($scope.bSabbathMode) {
            debugMessage("return Sabbath mode ON");
            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_SABBATH_MODE, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_range_alarm_settings_sabbath_turn_off, $scope.translation.WEBMOB_common_ok, '');
            return;
        }

        if ($scope.idZero.Mode.options[0].meatprobe === "connected" && !$scope.deviceModeSupport && deviceId === 0) {
            debugMessage("return Non supported MeatProbe Recipe");
            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_AUTO_COOK_PROBE, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_range_alarm_selected_mode_not_support, $scope.translation.WEBMOB_common_ok, '');
            return;
        }

        if ($scope.isStatic) {
            debugMessage("return due to isStatic On");
            return;
        }

        $scope.loadingBar = true;

        var hr, min, operTime, unit, highLowTemp = 0;
        hr = Number($scope.desiredHours) < 10 ? '0' + Number($scope.desiredHours) : Number($scope.desiredHours);
        min = Number($scope.desiredMinutes) < 10 ? '0' + Number($scope.desiredMinutes) : Number($scope.desiredMinutes);
        operTime = hr + ':' + min + ':00';
        unit = $scope.TempUnit === 'C' ? 'Celsius' : 'Fahrenheit',
                highLowTemp = $scope.highLowTemp === $scope.translation.WEBMOB_device_range_low ? 61442 : 61441;

        var recipeTemperature = {"id": "0",
            "current": $scope.currentTemp,
            "desired": $scope.desiredTemp,
            "maximum": $scope.maxTemp,
            "minimum": $scope.minTemp,
            "unit": unit};

        var highLowTempTemperature = {"id": "0",
            "current": 0,
            "desired": highLowTemp,
            "maximum": 61441,
            "minimum": 61442,
            "unit": unit};

        var recipeProbeTemperature = {"id": "1",
            "current": $scope.currentProbeTemp,
            "desired": $scope.desiredProbeTemp,
            "maximum": $scope.maxProbeTemp,
            "minimum": $scope.minProbeTemp,
            "unit": unit};

        var mode = $scope.displayReadyMode;
        var noPreHeat = '', stramRoastLevel = '';
        if ((mode === 'ConvectionBake' || mode === 'ConvectionRoast') && !$scope.idOne.connected) {//New spec : if dvider is connected then donot send preheat info also make preheat switch diabled
            if ($scope.bNoPreheat) {
                noPreHeat = ',"options":["NoPreheat_On"]';
            } else {
                noPreHeat = ',"options":["NoPreheat_Off"]';
            }
        }

        if ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_MY_FAVORITE_RECIPE_DETAIL_PAGE) {
            mode = $scope.desiredMFMode;
            recipeTemperature.desired = $scope.desiredMFTemp;
            recipeTemperature.maximum = $scope.MFMax;
            recipeTemperature.minimum = $scope.MFMin;
            hr = Number($scope.desiredMFHr) < 10 ? '0' + Number($scope.desiredMFHr) : Number($scope.desiredMFHr);
            min = Number($scope.desiredMFMin) < 10 ? '0' + Number($scope.desiredMFMin) : Number($scope.desiredMFMin);
            operTime = hr + ':' + min + ':00';
        }
        if (mode === 'SteamRoast' || mode === 'SteamBake') {
            stramRoastLevel = ',"options":["steamAddLevel_' + $scope.steamRoastLevel + '"]';
        }

        if (selectedCavity === 'SINGLE') {
            deviceId = 0;
            $scope.validateSendRecipeInfoSingle.State = 'Ready';
            $scope.validateSendRecipeInfoSingle.Mode = mode;
            $scope.validateSendRecipeInfoSingle.OperationTime = operTime;
            $scope.validateSendRecipeInfoSingle.DesiredTemp = recipeTemperature.desired;
            $scope.validateSendRecipeInfoSingle.DesiredProbeTemp = recipeProbeTemperature.desired;
            $scope.validateSendRecipeInfoSingle.HighLowTemp = highLowTempTemperature.desired;
            updateValidateSendRecipeInfo($scope.validateSendRecipeInfoSingle);
            recipeDataValidateSingle = true;
        } else if (selectedCavity === 'DUALUPPER') {
            deviceId = 0;
            $scope.validateSendRecipeInfoDualUpper.State = 'Ready';
            $scope.validateSendRecipeInfoDualUpper.Mode = mode;
            $scope.validateSendRecipeInfoDualUpper.OperationTime = operTime;
            $scope.validateSendRecipeInfoDualUpper.DesiredTemp = recipeTemperature.desired;
            $scope.validateSendRecipeInfoDualUpper.DesiredProbeTemp = recipeProbeTemperature.desired;
            $scope.validateSendRecipeInfoDualUpper.HighLowTemp = highLowTempTemperature.desired;
            updateValidateSendRecipeInfo($scope.validateSendRecipeInfoDualUpper);
            recipeDataValidateDualUpper = true;
        } else if (selectedCavity === 'DUALLOWER') {
            deviceId = 2;
            $scope.validateSendRecipeInfoDualLower.State = 'Ready';
            $scope.validateSendRecipeInfoDualLower.Mode = mode;
            $scope.validateSendRecipeInfoDualLower.OperationTime = operTime;
            $scope.validateSendRecipeInfoDualLower.DesiredTemp = recipeTemperature.desired;
            $scope.validateSendRecipeInfoDualLower.DesiredProbeTemp = recipeProbeTemperature.desired;
            $scope.validateSendRecipeInfoDualLower.HighLowTemp = highLowTempTemperature.desired;
            updateValidateSendRecipeInfo($scope.validateSendRecipeInfoDualLower);
            recipeDataValidateDualLower = true;
        } else if (selectedCavity === 'DUALFLEXUPPER') {
            deviceId = 0;
            $scope.validateSendRecipeInfoDualFlexUpper.State = 'Ready';
            $scope.validateSendRecipeInfoDualFlexUpper.Mode = mode;
            $scope.validateSendRecipeInfoDualFlexUpper.OperationTime = operTime;
            $scope.validateSendRecipeInfoDualFlexUpper.DesiredTemp = recipeTemperature.desired;
            $scope.validateSendRecipeInfoDualFlexUpper.DesiredProbeTemp = recipeProbeTemperature.desired;
            $scope.validateSendRecipeInfoDualFlexUpper.HighLowTemp = highLowTempTemperature.desired;
            updateValidateSendRecipeInfo($scope.validateSendRecipeInfoDualFlexUpper);
            mode = 'Upper' + mode;
            recipeDataValidateDualFlexUpper = true;
        } else if (selectedCavity === 'DUALFLEXLOWER') {
            deviceId = 1;
            $scope.validateSendRecipeInfoDualFlexLower.State = 'Ready';
            $scope.validateSendRecipeInfoDualFlexLower.Mode = mode;
            $scope.validateSendRecipeInfoDualFlexLower.OperationTime = operTime;
            $scope.validateSendRecipeInfoDualFlexLower.DesiredTemp = recipeTemperature.desired;
            $scope.validateSendRecipeInfoDualFlexLower.DesiredProbeTemp = recipeProbeTemperature.desired;
            $scope.validateSendRecipeInfoDualFlexLower.HighLowTemp = highLowTempTemperature.desired;
            updateValidateSendRecipeInfo($scope.validateSendRecipeInfoDualFlexLower);
            mode = 'Lower' + mode;
            recipeDataValidateDualFlexLower = true;
        } else if (selectedCavity === 'LOWERFLEX') {
            deviceId = 2;
            $scope.validateSendRecipeInfoLowerFlex.State = 'Ready';
            $scope.validateSendRecipeInfoLowerFlex.Mode = mode;
            $scope.validateSendRecipeInfoLowerFlex.OperationTime = operTime;
            $scope.validateSendRecipeInfoLowerFlex.DesiredTemp = recipeTemperature.desired;
            $scope.validateSendRecipeInfoLowerFlex.DesiredProbeTemp = recipeProbeTemperature.desired;
            $scope.validateSendRecipeInfoLowerFlex.HighLowTemp = highLowTempTemperature.desired;
            updateValidateSendRecipeInfo($scope.validateSendRecipeInfoLowerFlex);
            recipeDataValidateLowerFlex = true;
        }

        $scope.checkResponse.push(WALLOVEN_COMMANDS.sendRecipetoOven);
        var commandValue = getSendRecipeCommand(mode, operTime, recipeTemperature, highLowTempTemperature, recipeProbeTemperature, unit, noPreHeat, stramRoastLevel);
        debugMessage("sendSHPCommand : " + commandValue + "/" + $scope.peerId + "/devices/" + deviceId);
        SHPService.sendSHPCommand(CONSTANTS.PUT, commandValue, "/" + $scope.peerId + "/devices/" + deviceId);
    }

    function startAutoCookingConfirmed() {
        debugMessage("startAutoCookingConfirmed");

        if ($scope.idZero.Operation.kidsLock === 'Run') {
            debugMessage("return Kids Lock is ON");
            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_CHILD_LOCK, $scope.translation.WEBMOB_device_range_alarm_child_lock_title, $scope.translation.WEBMOB_device_cooktop_alarm_child_lock, $scope.translation.WEBMOB_common_ok, '');
            return;
        }

        if (!SmartControlCheck(deviceID)) {
            debugMessage("return smart control OFF");
            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_SMARTMONITOR_GUIDE, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_range_alarm_smart_control_on, $scope.translation.WEBMOB_common_ok, '');
            return;
        }

        if ($scope.bSabbathMode) {
            debugMessage("return Sabbath mode ON");
            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_SABBATH_MODE, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_range_alarm_settings_sabbath_turn_off, $scope.translation.WEBMOB_common_ok, '');
            return;
        }

        if ($scope.idZero.Mode.options[0].meatprobe === "connected" && !$scope.deviceModeSupport && deviceID === 0) {
            debugMessage("return Non supported MeatProbe Recipe");
            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_AUTO_COOK_PROBE, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_range_alarm_selected_mode_not_support, $scope.translation.WEBMOB_common_ok, '');
            return;
        }

        if ($scope.isStatic) {
            debugMessage("return due to isStatic On");
            return;
        }

        $scope.loadingBar = true;

        var recipeId = '', deviceId = 0;
        if (selectedCavity === 'SINGLE') { // [Cavity Info] >> 01,02,04
            recipeId = '01';
            deviceId = 0;
        } else if (selectedCavity === 'DUALUPPER') {
            recipeId = '01';
            deviceId = 0;
        } else if (selectedCavity === 'DUALLOWER' || selectedCavity === 'LOWERFLEX') {
            recipeId = '01';
            deviceId = 2;
        } else {
            recipeId = '01';
            deviceId = 0;
        }
        recipeId += '01'; // [AutoCook type] >> 01
        recipeId += $scope.AutoCookData[$scope.autoCookRecipeId].recipeId; //[Category] >> 01~10
        recipeId += '00'; // [Item] >> 00
        recipeId += '00'; // [Serving] >> 00
        recipeId += '02'; // [Browing Level] >> 01~03 >> Low Mid High 
        recipeId += '00'; // [Option] >> 00
        AutocookSendId = recipeId;

        $scope.checkResponse.push(WALLOVEN_COMMANDS.sendRecipetoOven);
        var commandValue = '{"Device" : {"Oven" : { "recipe" : "' + recipeId + '" }}}';
        debugMessage("commandValue : " + commandValue + "/" + $scope.peerId + "/devices/" + deviceId);
        SHPService.sendSHPCommand(CONSTANTS.PUT, commandValue, "/" + $scope.peerId + "/devices/" + deviceId);
    }

    function startCooking(id) {
        if (id === undefined) {
            if (selectedCavity === 'SINGLE' || selectedCavity === 'DUALUPPER' || selectedCavity === 'DUALFLEXUPPER') {
                id = 0;
            } else if (selectedCavity === 'DUALLOWER' || selectedCavity === 'LOWERFLEX') {
                id = 2;
            } else if (selectedCavity === 'DUALFLEXLOWER') {
                id = 1;
            } else {
                id = 0;
            }
        }
        if (!$scope.isStatic) {
            $scope.checkResponse.push(WALLOVEN_COMMANDS.startCooking);
            var commandValue = getStartCommand();
            debugMessage(commandValue + "/" + $scope.peerId + "/devices/" + id + "/operation");
            SHPService.sendSHPCommand(CONSTANTS.PUT, commandValue, "/" + $scope.peerId + "/devices/" + id + "/operation");
        }
    }

    function cancelCookingConfirmed(deviceId) {
        if (deviceId === undefined) {
            if (selectedCavity === 'SINGLE' || selectedCavity === 'DUALUPPER' || selectedCavity === 'DUALFLEXUPPER') {
                deviceId = 0;
            } else if (selectedCavity === 'DUALLOWER' || selectedCavity === 'LOWERFLEX') {
                deviceId = 2;
            } else if (selectedCavity === 'DUALFLEXLOWER') {
                deviceId = 1;
            } else {
                deviceId = 0;
            }
        }

        debugMessage("Cancel confirmed command for  /devices/" + deviceId);

        if ($scope.isStatic) {
            return;
        }

        if ((deviceId === 0 && $scope.idZero.Operation.state === "Ready")
                || (deviceId === 1 && $scope.idOne.Operation.state === "Ready")
                || (deviceId === 2 && $scope.idTwo.Operation.state === "Ready")) {
            debugMessage("return due to already in Ready State");
            return;
        }

        $scope.checkResponse.push(WALLOVEN_COMMANDS.cancelCooking);
        var commandValue = getCancelCommand();
        debugMessage("sendSHPCommand : " + commandValue + "/" + $scope.peerId + "/devices/" + deviceId + "/operation");
        SHPService.sendSHPCommand(CONSTANTS.PUT, commandValue, "/" + $scope.peerId + "/devices/" + deviceId + "/operation");
    }

    function getSendRecipeCommand(deviceMode, operTime, recipeTemperature, highLowTempTemperature, recipeProbeTemperature, unit, noPreHeat, stramRoastLevel) {
        if (deviceMode.indexOf('Broil') !== -1) {
            return '{"Device" : {"Mode" : {"modes" : ["' + deviceMode + '"]},"Operation" : {"operationTime" : "' + operTime + '" },"Temperatures" : [{ "id" : "' + highLowTempTemperature.id + '", "desired" : ' + highLowTempTemperature.desired + ',"unit" : "' + unit + '" }]}}';
        } else {
            if (Number(recipeTemperature.desired) > 61440) {
                recipeTemperature.desired = $scope.TempUnit === 'F' ? $scope.DisplayContents[13] : $scope.DisplayContents[16];
            }
            if ($scope.meatProbeConnected) {
                return '{"Device" : {"Mode" : {"modes" : ["' + deviceMode + '"]' + noPreHeat + stramRoastLevel + '},"Operation" : {"operationTime" : "' + operTime + '" },"Temperatures" : [{ "id" : "' + recipeTemperature.id + '", "desired" : ' + recipeTemperature.desired + ',"unit" : "' + unit + '" }, { "id" : "' + recipeProbeTemperature.id + '", "desired" : ' + recipeProbeTemperature.desired + ',"unit" : "' + unit + '" }]}}';
            } else {
                return '{"Device" : {"Mode" : {"modes" : ["' + deviceMode + '"]' + noPreHeat + stramRoastLevel + '},"Operation" : {"operationTime" : "' + operTime + '" },"Temperatures" : [{ "id" : "' + recipeTemperature.id + '", "desired" : ' + recipeTemperature.desired + ',"unit" : "' + unit + '" }]}}';
            }
        }
        return '{"Device" : {"Mode" : {"modes" : ["' + deviceMode + '"]},"Operation" : {"operationTime" : "' + operTime + '" },"Temperatures" : [{ "id" : "' + recipeTemperature.id + '", "desired" : ' + recipeTemperature.desired + ',"unit" : "' + unit + '" }]}}';
    }

    function getStartCommand() {
        return '{"Operation" : {"state" : "Run"}}';
    }

    function getCancelCommand() {
        return '{"Operation" : {"state" : "Ready"}}';
    }

    function getDiagnosisCommand() {
        return '{"Diagnosis": {"diagnosisStart": "Run"}}';
    }

    function getSendSnoozeCommand(operationTime) {
        return '{"Device" : {"Operation" : {"operationTime" : "' + operationTime + '"}}}';
    }

    function getAdjustTemp(temp) {
        var valueArray, tem, num = '', i = 1;
        valueArray = readCooktopValue(temp, 7);
        for (i; i < valueArray.length; i++) {
            num = num + valueArray[i];
        }
        tem = parseInt(num, 2);
        if (valueArray[0] > 0) {
            tem = -tem;
        }
        return tem;
    }

    function readCooktopValue(value, length) {
        var binaryArray, getStrCopy = function (str, copies) {
            var newStr = str;
            copies = (copies > 0) ? copies : 1;
            while (--copies) {
                newStr += str;
            }
            return newStr;
        },
                convertDecToBase = function (dec, base, length, padding) {
                    padding = padding || '0';
                    var num = dec.toString(base);
                    length = length || num.length;
                    if (num.length !== length) {
                        if (num.length < length) {
                            num = getStrCopy(padding, (length - num.length)) + num;
                        }
                    }
                    return num;
                };
        return binaryArray = convertDecToBase(Number(value), 2, length).split('');
    }

    function updateValidateSendRecipeInfo(recipeItem) {
        debugMessage("updateValidateSendRecipeInfo " + JSON.stringify(recipeItem));
        if (recipeItem.State !== undefined && recipeItem.State !== '') {
            $scope.validateSendRecipeInfoState = recipeItem.State;
        }
        if (recipeItem.Mode !== undefined && recipeItem.Mode !== '') {
            $scope.validateSendRecipeInfoMode = recipeItem.Mode;
        }
        if (recipeItem.DesiredTemp !== undefined && recipeItem.DesiredTemp !== '') {
            $scope.validateSendRecipeInfoDesiredTemp = recipeItem.DesiredTemp;
        }
        if (recipeItem.DesiredProbeTemp !== undefined && recipeItem.DesiredProbeTemp !== '') {
            $scope.validateSendRecipeInfoDesiredProbeTemp = recipeItem.DesiredProbeTemp;
        }
        if (recipeItem.HighLowTemp !== undefined && recipeItem.HighLowTemp !== '') {
            $scope.validateSendRecipeInfoHighLowTemp = recipeItem.HighLowTemp;
        }
        if (recipeItem.OperationTime !== undefined && recipeItem.OperationTime !== '') {
            $scope.validateSendRecipeInfoOperationHrs = recipeItem.OperationTime.split(':')[0][1];
            $scope.validateSendRecipeInfoOperationMints = recipeItem.OperationTime.split(':')[1];
        }
    }

    function emptyValidateSendRecipeInfo(recipeItem) {
        if (recipeItem.State !== undefined) {
            recipeItem.State = '';
        }
        if (recipeItem.Mode !== undefined) {
            recipeItem.Mode = '';
        }
        if (recipeItem.DesiredTemp !== undefined) {
            recipeItem.DesiredTemp = '';
        }
        if (recipeItem.DesiredProbeTemp !== undefined) {
            recipeItem.DesiredProbeTemp = '';
        }
        if (recipeItem.HighLowTemp !== undefined) {
            recipeItem.HighLowTemp = '';
        }
        if (recipeItem.OperationTime !== undefined) {
            recipeItem.OperationTime = '';
        }
    }

    function snoozeRecipe() {
        $scope.showFullScreenPopup = false;
        var deviceId = 0,
                currentOpeationTime = $scope.idZero.Operation.remainingTime;
        if (snoozIdZero) {
            deviceId = 0;
            snoozIdZero = false;
            currentOpeationTime = $scope.idZero.Operation.remainingTime;
            debugMessage("current snoozIdZero time : " + currentOpeationTime);
        } else if (snoozIdOne) {
            snoozIdOne = false;
            deviceId = 1;
            currentOpeationTime = $scope.idOne.Operation.remainingTime;
            debugMessage("current snoozIdOne time : " + currentOpeationTime);
        } else if (snoozIdTwo) {
            snoozIdTwo = false;
            deviceId = 2;
            currentOpeationTime = $scope.idTwo.Operation.remainingTime;
            debugMessage("current snoozIdTwo time : " + currentOpeationTime);
        }

        if (!SmartControlCheck(deviceId)) {
            debugMessage("return smart control OFF");
            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_SMARTMONITOR_GUIDE, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_range_alarm_smart_control_on, $scope.translation.WEBMOB_common_ok, '');
            return;
        }
        var hour = currentOpeationTime.split(':')[0],
                minute = currentOpeationTime.split(':')[1],
                totaltimeinMinutes = ((parseInt(hour, 10) * 60) + parseInt(minute, 10) + 5),
                newHour, newMinute, newOperationTime;
        newHour = parseInt(totaltimeinMinutes / 60, 10);
        newMinute = totaltimeinMinutes % 60;
        if (newHour.toString().length === 1) {
            newHour = "0" + newHour;
        }
        if (newMinute.toString().length === 1) {
            newMinute = "0" + newMinute;
        }
        newOperationTime = newHour + ":" + newMinute + ":00";
        $scope.checkResponse.push(WALLOVEN_COMMANDS.snoozeCookingTime);
        debugMessage(getSendSnoozeCommand(newOperationTime));
        SHPService.sendSHPCommand(CONSTANTS.PUT, getSendSnoozeCommand(newOperationTime), "/" + $scope.peerId + "/devices/" + deviceId);
    }

    function startConfirmationOK() {
        debugMessage("startConfirmationOK");
        startCooking();
    }

    function startConfirmationCancel() {
        debugMessage("startConfirmationCancel");
        if (recipeDataValidateSingle && selectedCavity === 'SINGLE') {
            debugMessage("startConfirmation Cancel for recipeDataValidateSingle");
            recipeDataValidateSingle = false;
            emptyValidateSendRecipeInfo($scope.validateSendRecipeInfoSingle);
        }
        if (recipeDataValidateDualUpper && selectedCavity === 'DUALUPPER') {
            debugMessage("startConfirmation Cancel for recipeDataValidateDualUpper");
            recipeDataValidateDualUpper = false;
            emptyValidateSendRecipeInfo($scope.validateSendRecipeInfoDualUpper);
        }
        if (recipeDataValidateDualLower && selectedCavity === 'DUALLOWER') {
            debugMessage("startConfirmation Cancel for recipeDataValidateDualLower");
            recipeDataValidateDualLower = false;
            emptyValidateSendRecipeInfo($scope.validateSendRecipeInfoDualLower);
        }
        if (recipeDataValidateDualFlexUpper && selectedCavity === 'DUALFLEXUPPER') {
            debugMessage("startConfirmation Cancel for recipeDataValidateDualFlexUpper");
            recipeDataValidateDualFlexUpper = false;
            emptyValidateSendRecipeInfo($scope.validateSendRecipeInfoDualFlexUpper);
        }
        if (recipeDataValidateDualFlexLower && selectedCavity === 'DUALFLEXLOWER') {
            debugMessage("startConfirmation Cancel for recipeDataValidateDualFlexLower");
            recipeDataValidateDualFlexLower = false;
            emptyValidateSendRecipeInfo($scope.validateSendRecipeInfoDualFlexLower);
        }
        if (recipeDataValidateLowerFlex && selectedCavity === 'LOWERFLEX') {
            debugMessage("startConfirmation Cancel for recipeDataValidateLowerFlex");
            recipeDataValidateLowerFlex = false;
            emptyValidateSendRecipeInfo($scope.validateSendRecipeInfoLowerFlex);
        }
        showCurrentScreen();
    }

    function showcustDialog(myAlertState, msgHeader, popuptext, txtButton1, txtButton2) {
        debugMessage("showcustDialog " + myAlertState + " " + msgHeader + " " + popuptext + " " + txtButton1 + " " + txtButton2);
        $scope.alertState = myAlertState;
        $scope.custPopupTitle = true;
        $scope.custPopupOKBtton = true;
        $scope.showFullScreenPopup = true;
        $scope.custPopupCancelButton = true;
        $scope.custPopupTitleText = msgHeader;
        $scope.custPopupMessageText = popuptext;
        $scope.custPopupCancelOkText = txtButton1;
        $scope.custPopupCancelButtonText = txtButton2;

        $scope.MFMenuVisible = false;
        $scope.wOvenCurrentTab = null;
        $scope.wallOvenModeMenu = false;
        $scope.samrtControlPopup = false;
        $scope.showMenuOptionPopup = false;

        fixScreen();
        document.getElementById("fullScreenPopupId").style.zIndex = 999;
        document.getElementById("custPopupDivId").style.zIndex = 999;
        /*$timeout(function () {
         document.getElementById("bodyTag").style.pointerEvents = 'none';
         }, 200);*/
        $timeout(function () {
            var cHeight = 0, cWidth = 0, popupHeight = 0, base = 0, popupTop = 12;
            cHeight = window.screen.availHeight;
            cWidth = window.screen.availWidth;
            if (cHeight === 0 || cHeight === undefined) {
                cHeight = document.body.clientHeight;
            }
            if (cWidth === 0 || cWidth === undefined) {
                cWidth = document.body.clientWidth;
            }
            base = 2 * ((80 * cWidth) / 1440);
            popupHeight = document.getElementById("custPopupDivId").clientHeight;
            if (popupHeight !== 0 && popupHeight !== undefined && popupHeight !== '' && base > 0) {
                popupTop = (cHeight - popupHeight) / base;
            }
            document.getElementById("custPopupDivId").style.top = popupTop + 'rem';
        }, 10);


        if (msgHeader === undefined || msgHeader === '') {
            $scope.custPopupTitle = false;
        }
        if (txtButton1 === undefined || txtButton1 === '') {
            $scope.custPopupOKBtton = false;
        }
        if (txtButton2 === undefined || txtButton2 === '') {
            $scope.custPopupCancelButton = false;
        }

        if ($scope.alertState === WALLOVEN_ALERT_STATE.ALERT_COOKING_SNOOZE) {
            var remainTime = 0;
            if (snoozIdZero) {
                remainTime = Number(($scope.idZero.Operation.remainingTime).split(':')[1]);
            } else if (snoozIdOne) {
                remainTime = Number(($scope.idOne.Operation.remainingTime).split(':')[1]);
            } else if (snoozIdTwo) {
                remainTime = Number(($scope.idTwo.Operation.remainingTime).split(':')[1]);
            } else {
                remainTime = Number(($scope.idZero.Operation.remainingTime).split(':')[1]);
            }
            $scope.custPopupTitleText = $scope.custPopupTitleText.replace(/#1#/, 5);
            $scope.custPopupMessageText = $scope.custPopupMessageText.replace(/#1#/, Number(remainTime));
        }
    }

    function onAlertButton1Click() {
        debugMessage("onAlertButton1Click " + $scope.alertState);
        $scope.showFullScreenPopup = false;
        scrollScreen();
        $timeout(function () {
            switch ($scope.alertState) {
                case WALLOVEN_ALERT_STATE.ALERT_START_MF_COOKING:
                    if ($scope.idZero.Operation.state === "Run" && (selectedCavity === 'SINGLE' || selectedCavity === 'DUALUPPER' || selectedCavity === 'DUALFLEXUPPER')
                            || $scope.idOne.Operation.state === "Run" && selectedCavity === 'DUALFLEXLOWER'
                            || $scope.idTwo.Operation.state === "Run" && (selectedCavity === 'DUALLOWER' || selectedCavity === 'LOWERFLEX')) {
                        showToast($scope.translation.WEBMOB_device_walloven_cooking_alarm);
                        return;
                        break;
                    }
                case WALLOVEN_ALERT_STATE.ALERT_START_COOKING:
                    debugMessage("ok start cooking");
                    startCookingConfirmed();
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_START_ATUOCOOK_COOKING:
                    debugMessage("ok cancel cooking");
                    startAutoCookingConfirmed();
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_CANCEL_COOKING:
                    debugMessage("ok cancel cooking");
                    cancelCookingConfirmed();
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_CONNECTION_ERROR:
                    debugMessage("ok connection pop up");
                    closeApp();
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_SMARTMONITOR_GUIDE:
                    debugMessage("cancel smartControl pop up");
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_DEVELOPER_INFO:
                    debugMessage("cancel Developer info pop up");
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_DOOR_OPEN:
                    debugMessage("cancel Door Open");
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_COOKING_SNOOZE:
                    debugMessage("add time snoozeRecipe pop up");
                    snoozeRecipe();
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_DELETE_MY_COOKING:
                    var newLocalStorage = JSON.parse(getLocalStorageData(WALLOVEN_LOCALSTORAGE.FAVDB)), recipeName = '';
                    debugMessage(' length for list main and selected  : ' + newLocalStorage.length + ' && ' + $scope.editMyCookingSelectedDeleteItems.length);
                    if (newLocalStorage.length > 0 && $scope.editMyCookingSelectedDeleteItems.length > 0) {
                        for (var i = 0; i < $scope.editMyCookingSelectedDeleteItems.length; i++) {
                            for (var j = 0; j < newLocalStorage.length; j++) {
                                if ($scope.editMyCookingSelectedDeleteItems[i] === newLocalStorage[j][22]) {
                                    debugMessage('delete item  : ' + newLocalStorage[j][22] + ' && ' + $scope.editMyCookingSelectedDeleteItems[i]);
                                    recipeName = newLocalStorage[j][22];
                                    newLocalStorage.splice(j, 1);
                                }
                            }
                        }
                    }
                    //newLocalStorage.splice(newLocalStorage.length - 1, 1);
                    localStorage.clear();
                    setLocalStorageData(WALLOVEN_LOCALSTORAGE.FAVDB, JSON.stringify(newLocalStorage));
                    $scope.editMyCookingSelectedDeleteItems = [];
                    $scope.multiselect = false;
                    $scope.headerBarVisible = true;
                    if ($scope.recipeStarted) {
                        $scope.recipeStarted = false;
                        showToast(recipeName + " " + $scope.translation.WEBMOB_device_walloven_deleted);
                    }
                    updateMyFavItems();
                    if ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_MY_FAVORITE_RECIPE_DETAIL_PAGE) {
                        validateCurrentScreen('MyFavoritePage');
                    }
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_SERVICE_CALL:
                    callServieCenter();
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_GOURMET_RECIPE_ALARM_81_82:
                case WALLOVEN_ALERT_STATE.ALERT_GOURMET_RECIPE_ALARM_83:
                    debugMessage("gourmet recipe preheat alarm ok and update data now");
                case WALLOVEN_ALERT_STATE.ALERT_PREHEATCOMPLETE:
                    debugMessage("preheating complete and update data now");
                    setDataCurrentScreen();
                    showScreen();
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_NONE:
                case WALLOVEN_ALERT_STATE.ALERT_CHILD_LOCK:
                case WALLOVEN_ALERT_STATE.ALERT_SABBATH_MODE:
                case WALLOVEN_ALERT_STATE.ALERT_DESCALE_FAIL:
                    debugMessage("else state " + $scope.alertState);
                default:
                    break;
            }
        }, WALLOVEN_LONGPRESS);

    }

    function onAlertButton2Click() {
        debugMessage("onAlertButton2Click " + $scope.alertState);
        $scope.showFullScreenPopup = false;
        scrollScreen();
        $timeout(function () {
            switch ($scope.alertState) {
                case WALLOVEN_ALERT_STATE.ALERT_START_ATUOCOOK_COOKING:
                case WALLOVEN_ALERT_STATE.ALERT_START_MF_COOKING:
                case WALLOVEN_ALERT_STATE.ALERT_START_COOKING:
                    debugMessage("cancel start cooking");
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_CANCEL_COOKING:
                    debugMessage("cancel cancel cooking");
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_SERVICE_CALL:
                    debugMessage("cancel service center call");
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_CONNECTION_ERROR:
                    $scope.showFullScreenPopup = true;
                    debugMessage("cancel connection pop up");
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_DELETE_MY_COOKING:
                    debugMessage("cancel deleting my cooking");
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_DOOR_OPEN:
                    debugMessage("ok Door Open");
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_SMARTMONITOR_GUIDE:
                    debugMessage("ok smartControl pop up");
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_DEVELOPER_INFO:
                    debugMessage("ok Developer info pop up");
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_COOKING_SNOOZE:
                    debugMessage("cancel time snoozeRecipe pop up");
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_GOURMET_RECIPE_ALARM_81_82:
                case WALLOVEN_ALERT_STATE.ALERT_GOURMET_RECIPE_ALARM_83:
                    debugMessage("gourmet recipe preheat alarm cancel and update data now");
                case WALLOVEN_ALERT_STATE.ALERT_PREHEATCOMPLETE:
                    debugMessage("preheating complete and update data now");
                    setDataCurrentScreen();
                    showScreen();
                    break;
                case WALLOVEN_ALERT_STATE.ALERT_NONE:
                case WALLOVEN_ALERT_STATE.ALERT_CHILD_LOCK:
                case WALLOVEN_ALERT_STATE.ALERT_SABBATH_MODE:
                case WALLOVEN_ALERT_STATE.ALERT_DESCALE_FAIL:
                    debugMessage("else state " + $scope.alertState);
                default:
                    break;
            }
        }, WALLOVEN_LONGPRESS);
    }

    function showToast(txt) {
        debugMessage("showToast with txt " + txt);
        $timeout(function () {
            document.activeElement.blur();
            toaster.success({title: "", body: txt, bodyOutputType: 'trustedHtml'});
        }, 200);
    }

    function monitorClick(id) {
        debugMessage("monitorClick with id " + id);
        switch (id) {
            case 0 ://SINGLE
                selectedCavity = 'SINGLE';
                $scope.ovenFunctionContents = $scope.ovenFunctionContentsSingle;
                $scope.healthyFunctionContents = $scope.healthyFunctionContentsSingle;
                $scope.DisplayContents = getModeRowValue($scope.supportedModesSingle, wOvenSingleBaseMode);
                $scope.MFContents = $scope.DisplayContents;
                setValueForSingleMode();
                updateDisplayScreenData();
                showScreen();
                break;
            case 1 ://DUAL UPPER
                selectedCavity = 'DUALUPPER';
                $scope.ovenFunctionContents = $scope.ovenFunctionContentsDualUpper;
                $scope.healthyFunctionContents = $scope.healthyFunctionContentsDualUpper;
                $scope.DisplayContents = getModeRowValue($scope.supportedModesDualUpper, wOvenDualUpperBaseMode);
                $scope.MFContents = $scope.DisplayContents;
                setValueForDualUpperMode();
                updateDisplayScreenData();
                showScreen();
                break;
            case 2 ://DUAL LOWER
                selectedCavity = 'DUALLOWER';
                lowerCavityConfigCall();
                $scope.ovenFunctionContents = $scope.ovenFunctionContentsDualLower;
                $scope.healthyFunctionContents = $scope.healthyFunctionContentsDualLower;
                $scope.DisplayContents = getModeRowValue($scope.supportedModesDualLower, wOvenDualLowerBaseMode);
                $scope.MFContents = $scope.DisplayContents;
                setValueForDualLowerMode();
                updateDisplayScreenData();
                showScreen();
                break;
            case 3 ://FLEX UPPER
                selectedCavity = 'DUALFLEXUPPER';
                $scope.ovenFunctionContents = $scope.ovenFunctionContentsDualUpperFlex;
                $scope.healthyFunctionContents = $scope.healthyFunctionContentsDualUpperFlex;
                $scope.DisplayContents = getModeRowValue($scope.supportedModesDualUpperFlex, wOvenDualFlexUpperBaseMode);
                $scope.MFContents = $scope.DisplayContents;
                setValueForDualFlexUpperMode();
                updateDisplayScreenData();
                showScreen();
                break;
            case 4 ://FLEX LOWER
                selectedCavity = 'DUALFLEXLOWER';
                $scope.ovenFunctionContents = $scope.ovenFunctionContentsDualLowerFlex;
                $scope.healthyFunctionContents = $scope.healthyFunctionContentsDualLowerFlex;
                $scope.DisplayContents = getModeRowValue($scope.supportedModesDualLowerFlex, wOvenDualFlexLowerBaseMode);
                $scope.MFContents = $scope.DisplayContents;
                setValueForDualFlexLowerMode();
                updateDisplayScreenData();
                showScreen();
                break;
            case 5 ://LOWER FLEX
                selectedCavity = 'LOWERFLEX';
                lowerCavityConfigCall();
                $scope.ovenFunctionContents = $scope.ovenFunctionContentsDualLower;
                $scope.healthyFunctionContents = $scope.healthyFunctionContentsDualLower;
                $scope.DisplayContents = getModeRowValue($scope.supportedModesDualLower, wOvenDualLowerBaseMode);
                $scope.MFContents = $scope.DisplayContents;
                setValueForDualLowerMode();
                updateDisplayScreenData();
                showScreen();
                break;
            default ://TODO
                selectedCavity = '';
                updateDisplayScreenData();
                showScreen();
                break;
        }
    }

    function saveUserValueSingle(mode, temp, probetemp, hr, min, preheat) {
        debugMessage("saveUserValueSingle " + mode + temp + probetemp + hr + min + preheat);
        userPreferneceSingle = {
            'preferneceMode': mode,
            'preferneceTemp': temp,
            'preferneceProbeTemp': probetemp,
            'preferneceHR': hr,
            'preferneceMin': min,
            'prefernecePreheat': preheat
        };
    }

    function saveUserValueDualUpper(mode, temp, probetemp, hr, min, preheat) {
        debugMessage("saveUserValueDualUpper " + mode + temp + probetemp + hr + min + preheat);
        userPreferneceDualUpper = {
            'preferneceMode': mode,
            'preferneceTemp': temp,
            'preferneceProbeTemp': probetemp,
            'preferneceHR': hr,
            'preferneceMin': min,
            'prefernecePreheat': preheat
        };
    }

    function saveUserValueDualLower(mode, temp, probetemp, hr, min, preheat) {
        debugMessage("saveUserValueDualLower " + mode + temp + probetemp + hr + min + preheat);
        userPreferneceDualLower = {
            'preferneceMode': mode,
            'preferneceTemp': temp,
            'preferneceProbeTemp': probetemp,
            'preferneceHR': hr,
            'preferneceMin': min,
            'prefernecePreheat': preheat
        };
    }

    function saveUserValueDualFlexUpper(mode, temp, probetemp, hr, min, preheat) {
        debugMessage("saveUserValueDualFlexUpper " + mode + temp + probetemp + hr + min + preheat);
        userPreferneceDualFlexUpper = {
            'preferneceMode': mode,
            'preferneceTemp': temp,
            'preferneceProbeTemp': probetemp,
            'preferneceHR': hr,
            'preferneceMin': min,
            'prefernecePreheat': preheat
        };
    }

    function saveUserValueDualFlexLower(mode, temp, probetemp, hr, min, preheat) {
        debugMessage("saveUserValueDualFlexLower " + mode + temp + probetemp + hr + min + preheat);
        userPreferneceDualFlexLower = {
            'preferneceMode': mode,
            'preferneceTemp': temp,
            'preferneceProbeTemp': probetemp,
            'preferneceHR': hr,
            'preferneceMin': min,
            'prefernecePreheat': preheat
        };
    }

    function saveUserValue() {
        debugMessage("saveUserValue");
        switch (selectedCavity) {
            case 'SINGLE' ://SINGLE
                saveUserValueSingle($scope.displayReadyMode, $scope.desiredTemp, $scope.desiredProbeTemp, $scope.desiredHours, $scope.desiredMinutes, $scope.bNoPreheat);
                break;
            case 'DUALUPPER' ://DUAL UPPER
                saveUserValueDualUpper($scope.displayReadyMode, $scope.desiredTemp, $scope.desiredProbeTemp, $scope.desiredHours, $scope.desiredMinutes, $scope.bNoPreheat);
                break;
            case 'DUALLOWER' ://DUAL LOWER
                saveUserValueDualLower($scope.displayReadyMode, $scope.desiredTemp, $scope.desiredProbeTemp, $scope.desiredHours, $scope.desiredMinutes, $scope.bNoPreheat);
                break;
            case 'DUALFLEXUPPER' ://FLEX UPPER
                saveUserValueDualFlexUpper($scope.displayReadyMode, $scope.desiredTemp, $scope.desiredProbeTemp, $scope.desiredHours, $scope.desiredMinutes, $scope.bNoPreheat);
                break;
            case 'DUALFLEXLOWER' ://FLEX LOWER
                saveUserValueDualFlexLower($scope.displayReadyMode, $scope.desiredTemp, $scope.desiredProbeTemp, $scope.desiredHours, $scope.desiredMinutes, $scope.bNoPreheat);
                break;
            case 'LOWERFLEX' ://LOWER FLEX
                saveUserValueDualLower($scope.displayReadyMode, $scope.desiredTemp, $scope.desiredProbeTemp, $scope.desiredHours, $scope.desiredMinutes, $scope.bNoPreheat);
                break;
            default :
                break;
        }
    }

    function getUserPreferencedValue(preference) {
        if (preference !== undefined) {
            debugMessage("getUserPreferencedValue " + JSON.stringify(preference));
            if (preference.preferneceMode !== undefined && preference.preferneceMode !== '' && preference.preferneceMode !== 'NoOperation') {
                $scope.displayReadyMode = preference.preferneceMode;
            }
            if (preference.preferneceTemp !== undefined && preference.preferneceTemp !== 0) {
                $scope.desiredTemp = preference.preferneceTemp;
            }
            if (preference.preferneceProbeTemp !== undefined && preference.preferneceProbetemp !== 0) {
                $scope.desiredProbeTemp = preference.preferneceProbeTemp;
            }
            if (preference.preferneceHR !== undefined && preference.preferneceHR !== '') {
                $scope.desiredHours = preference.preferneceHR;
            }
            if (preference.prefernecePreheat !== undefined) {
                $scope.bNoPreheat = preference.prefernecePreheat;
            }
            if (preference.preferneceMin !== undefined && preference.preferneceMin !== '') {
                $scope.desiredMinutes = preference.preferneceMin;
            }
            if ($scope.displayReadyMode === undefined || $scope.displayReadyMode === '') {
                $scope.deviceMode = $scope.DisplayContents[4];
                $scope.displayReadyModeText = $scope.DisplayContents[5];
                $scope.displayReadyMode = $scope.DisplayContents[4];
            }
            if ($scope.desiredTemp === undefined || $scope.desiredTemp === 0) {
                $scope.desiredTemp = $scope.TempUnit === 'F' ? $scope.DisplayContents[13] : $scope.DisplayContents[16];
            }
            if ($scope.desiredProbeTemp === undefined || $scope.desiredProbeTemp === 0) {
                $scope.desiredProbeTemp = $scope.TempUnit === 'F' ? 150 : 65;
            }
            if ($scope.desiredHours === undefined || $scope.desiredHours === '') {
                var newdate = new Date();
                newdate.setHours(0, $scope.DisplayContents[19], 0);
                $scope.desiredHours = Number(newdate.getHours());
            }
            if ($scope.desiredMinutes === undefined || $scope.desiredMinutes === '') {
                var newdate = new Date();
                newdate.setHours(0, $scope.DisplayContents[19], 0);
                $scope.desiredMinutes = Number(newdate.getMinutes());
            }
        }
    }

    function inputKeyDown(e) {
        if (e === undefined) {
            return;
        }
        var inputElement = document.activeElement;
        $timeout(function () {
            if (inputElement.type === 'number') {
                var sanitized = $(inputElement).val().replace(/[^0-9]/g, '');
                // Update value
                $(inputElement).val("");
                $(inputElement).val(sanitized);
            }
        }, 0);

        if (e.keyCode === 9 && (e.currentTarget.id === "inputMins" || e.currentTarget.id === "inputEditMins" || e.currentTarget.id === "inputAMCMins")) {
            showDummyInbox();
        }
    }

    function maxLenghtCheck(e) {
        if (e.currentTarget.value.length >= 30 && e.keyCode !== 9 && e.keyCode !== 8 && e.keyCode !== 46) {
            e.currentTarget.blur();
            showToast($scope.translation.WEBMOB_device_walloven_name_input_limit);
            document.getElementById(e.currentTarget.id).value = e.currentTarget.value.slice(0, 30);
        }
    }

    function stopLongPressEvent() {
        if (!!promise) {
            $interval.cancel(promise);
            promise = undefined;
        }
        if ($scope.longPress) {
            $scope.longPress = false;
            clearInterval($scope.timer);
            return;
        }
    }

    function increaseTemp(id) {
        switch (id) {
            case 0 ://Normal
                $scope.recipeStarted = false;
                $scope.desiredTemp = parseInt($scope.desiredTemp, 10);
                if (($scope.desiredTemp) < $scope.maxTemp) {
                    $scope.desiredTemp = $scope.desiredTemp + $scope.TempIncrement;
                } else {
                    var toast = $scope.translation.WEBMOB_device_range_alarm_maximum_temp;
                    toast = toast.replace(/#1#/, $scope.maxTemp);
                    showToast(toast);
                }
                break;
            case 1 ://Edit Mode
                $scope.editDesiredTemp = parseInt($scope.editDesiredTemp, 10);
                if (($scope.editDesiredTemp) < $scope.maxTemp) {
                    $scope.editDesiredTemp = $scope.editDesiredTemp + $scope.TempIncrement;
                    $scope.editModeTempUpdate = true;
                } else {
                    var toast = $scope.translation.WEBMOB_device_range_alarm_maximum_temp;
                    toast = toast.replace(/#1#/, $scope.maxTemp);
                    showToast(toast);
                }
                break;
            case 2 ://AMC
                $scope.AMCSaveButtonEnable = true;
                $scope.desiredMFTemp = parseInt($scope.desiredMFTemp, 10);
                if (($scope.desiredMFTemp) < $scope.MFMax) {
                    $scope.desiredMFTemp = $scope.desiredMFTemp + $scope.TempIncrement;
                } else {
                    var toast = $scope.translation.WEBMOB_device_range_alarm_maximum_temp;
                    toast = toast.replace(/#1#/, $scope.MFMax);
                    showToast(toast);
                }
                break;
            case 3 ://Adjust Temp
                $scope.tempAdjustButtonChange = true;
                $scope.AdjustTemp = parseInt($scope.AdjustTemp, 10);
                if (($scope.AdjustTemp) < $scope.maxAdjustTemp) {
                    $scope.AdjustTemp = $scope.AdjustTemp + 1;
                } else {
                    $scope.AdjustTemp = $scope.maxAdjustTemp;
                    var toast = $scope.translation.WEBMOB_device_range_alarm_maximum_temp;
                    toast = toast.replace(/#1#/, $scope.maxAdjustTemp);
                    showToast(toast);
                }
                break;
            default :
                break;
        }
    }

    function decreaseTemp(id) {
        switch (id) {
            case 0 ://Normal
                $scope.recipeStarted = false;
                $scope.desiredTemp = parseInt($scope.desiredTemp, 10);
                if (($scope.desiredTemp) > $scope.minTemp) {
                    $scope.desiredTemp = $scope.desiredTemp - $scope.TempIncrement;
                } else {
                    var toast = $scope.translation.WEBMOB_device_range_alarm_minimum_temp;
                    toast = toast.replace(/#1#/, $scope.minTemp);
                    showToast(toast);
                }
                break;
            case 1 ://Edit Mode
                $scope.editDesiredTemp = parseInt($scope.editDesiredTemp, 10);
                if (($scope.editDesiredTemp) > $scope.minTemp) {
                    $scope.editDesiredTemp = $scope.editDesiredTemp - $scope.TempIncrement;
                    $scope.editModeTempUpdate = true;
                } else {
                    var toast = $scope.translation.WEBMOB_device_range_alarm_minimum_temp;
                    toast = toast.replace(/#1#/, $scope.minTemp);
                    showToast(toast);
                }
                break;
            case 2 ://AMC
                $scope.AMCSaveButtonEnable = true;
                $scope.desiredMFTemp = parseInt($scope.desiredMFTemp, 10);
                if (($scope.desiredMFTemp) > $scope.MFMin) {
                    $scope.desiredMFTemp = $scope.desiredMFTemp - $scope.TempIncrement;
                } else {
                    var toast = $scope.translation.WEBMOB_device_range_alarm_minimum_temp;
                    toast = toast.replace(/#1#/, $scope.MFMin);
                    showToast(toast);
                }
                break;
            case 3 ://Adjust Temp
                $scope.tempAdjustButtonChange = true;
                $scope.AdjustTemp = parseInt($scope.AdjustTemp, 10);
                if (($scope.AdjustTemp) > $scope.minAdjustTemp) {
                    $scope.AdjustTemp = $scope.AdjustTemp - 1;
                } else {
                    $scope.AdjustTemp = $scope.minAdjustTemp;
                    var toast = $scope.translation.WEBMOB_device_range_alarm_minimum_temp;
                    toast = toast.replace(/#1#/, $scope.minAdjustTemp);
                    showToast(toast);
                }
                break;
            default :
                break;
        }
    }

    function increaseHours(id) {
        switch (id) {
            case 0 ://Normal
                $scope.recipeStarted = false;
                $scope.desiredHours = parseInt($scope.desiredHours, 10);
                if ($scope.desiredHours < 9) {
                    $scope.desiredHours += 1;
                } else {
                    $scope.desiredHours = 0;
                }
                $scope.desiredHours = ($scope.desiredHours === 0 && $scope.desiredMinutes === 0) ? 1 : $scope.desiredHours;
                break;
            case 1 ://Edit Mode
                $scope.editModeTimeUpdate = true;
                $scope.editDesiredHr = Number($scope.editDesiredHr);
                if ($scope.editDesiredHr < 9) {
                    $scope.editDesiredHr += 1;
                } else {
                    $scope.editDesiredHr = 0;
                }
                $scope.editDesiredHr = ($scope.editDesiredHr === 0 && $scope.editDesiredMin === 0) ? 1 : $scope.editDesiredHr;
                break;
            case 2 ://AMC
                $scope.AMCSaveButtonEnable = true;
                $scope.desiredMFHr = Number($scope.desiredMFHr);
                if ($scope.desiredMFHr < 9) {
                    $scope.desiredMFHr += 1;
                } else {
                    $scope.desiredMFHr = 0;
                }
                $scope.desiredMFHr = ($scope.desiredMFHr === 0 && $scope.desiredMFMin === 0) ? 1 : $scope.desiredMFHr;

                break;
            default :
                break;
        }
    }

    function decreaseHours(id) {
        switch (id) {
            case 0 ://Normal
                $scope.recipeStarted = false;
                $scope.desiredHours = parseInt($scope.desiredHours, 10);
                if ($scope.desiredHours > 0) {
                    $scope.desiredHours -= 1;
                } else {
                    $scope.desiredHours = 9;
                }
                $scope.desiredHours = ($scope.desiredHours === 0 && $scope.desiredMinutes === 0) ? 9 : $scope.desiredHours;
                break;
            case 1 ://Edit Mode
                $scope.editModeTimeUpdate = true;
                $scope.editDesiredHr = Number($scope.editDesiredHr);
                if ($scope.editDesiredHr > 0) {
                    $scope.editDesiredHr -= 1;
                } else {
                    $scope.editDesiredHr = 9;
                }
                $scope.editDesiredHr = ($scope.editDesiredHr === 0 && $scope.editDesiredMin === 0) ? 9 : $scope.editDesiredHr;
                break;
            case 2 ://AMC
                $scope.AMCSaveButtonEnable = true;
                $scope.desiredMFHr = Number($scope.desiredMFHr);
                if ($scope.desiredMFHr > 0) {
                    $scope.desiredMFHr -= 1;
                } else {
                    $scope.desiredMFHr = 9;
                }
                $scope.desiredMFHr = ($scope.desiredMFHr === 0 && $scope.desiredMFMin === 0) ? 9 : $scope.desiredMFHr;

                break;
            default :
                break;
        }
    }

    function increaseMinutes(id) {
        switch (id) {
            case 0 ://Normal
                $scope.recipeStarted = false;
                $scope.desiredMinutes = Number($scope.desiredMinutes);
                $scope.desiredHours = Number($scope.desiredHours);
                if ($scope.desiredMinutes !== (59)) {
                    $scope.desiredMinutes += 1;
                } else {
                    $scope.desiredMinutes = 0;
                }
                $scope.desiredMinutes = ($scope.desiredHours === 0 && $scope.desiredMinutes === 0) ? 1 : $scope.desiredMinutes;
                break;
            case 1 ://Edit Mode
                $scope.editModeTimeUpdate = true;
                $scope.editDesiredHr = Number($scope.editDesiredHr);
                $scope.editDesiredMin = Number($scope.editDesiredMin);
                if ($scope.editDesiredMin !== (59)) {
                    $scope.editDesiredMin += 1;
                } else {
                    $scope.editDesiredMin = 0;
                }
                $scope.editDesiredMin = ($scope.editDesiredHr === 0 && $scope.editDesiredMin === 0) ? 1 : $scope.editDesiredMin;
                break;
            case 2 ://AMC
                $scope.AMCSaveButtonEnable = true;
                $scope.desiredMFHr = Number($scope.desiredMFHr);
                $scope.desiredMFMin = Number($scope.desiredMFMin);
                if ($scope.desiredMFMin !== (59)) {
                    $scope.desiredMFMin += 1;
                } else {
                    $scope.desiredMFMin = 0;
                }
                $scope.desiredMFMin = ($scope.desiredMFHr === 0 && $scope.desiredMFMin === 0) ? 1 : $scope.desiredMFMin;

                break;
            default :
                break;
        }
    }

    function decreaseMinutes(id) {
        switch (id) {
            case 0 ://Normal
                $scope.recipeStarted = false;
                $scope.desiredMinutes = Number($scope.desiredMinutes);
                if ($scope.desiredMinutes !== 0) {
                    $scope.desiredMinutes -= 1;
                } else {
                    $scope.desiredMinutes = 60 - 1;
                }
                $scope.desiredMinutes = ($scope.desiredHours === 0 && $scope.desiredMinutes === 0) ? 59 : $scope.desiredMinutes;
                break;
            case 1 ://Edit Mode
                $scope.editModeTimeUpdate = true;
                $scope.editDesiredHr = Number($scope.editDesiredHr);
                $scope.editDesiredMin = Number($scope.editDesiredMin);
                if ($scope.editDesiredMin !== 0) {
                    $scope.editDesiredMin -= 1;
                } else {
                    $scope.editDesiredMin = 60 - 1;
                }
                $scope.editDesiredMin = ($scope.editDesiredHr === 0 && $scope.editDesiredMin === 0) ? 59 : $scope.editDesiredMin;

                break;
            case 2 ://AMC
                $scope.AMCSaveButtonEnable = true;
                $scope.desiredMFHr = Number($scope.desiredMFHr);
                $scope.desiredMFMin = Number($scope.desiredMFMin);
                if ($scope.desiredMFMin !== 0) {
                    $scope.desiredMFMin -= 1;
                } else {
                    $scope.desiredMFMin = 60 - 1;
                }
                $scope.desiredMFMin = ($scope.desiredMFHr === 0 && $scope.desiredMFMin === 0) ? 59 : $scope.desiredMFMin;

                break;
            default :
                break;
        }
    }

    function increaseProbeTemp(id) {
        switch (id) {
            case 0 ://Normal
                $scope.desiredProbeTemp = parseInt($scope.desiredProbeTemp, 10);
                if (($scope.desiredProbeTemp) < $scope.maxProbeTemp) {
                    $scope.desiredProbeTemp = $scope.desiredProbeTemp + 1;
                } else {
                    var toast = $scope.translation.WEBMOB_device_range_alarm_maximum_temp;
                    toast = toast.replace(/#1#/, $scope.maxProbeTemp);
                    showToast(toast);
                }
                break;
            case 1 ://Edit Mode
                $scope.editModeTempUpdate = true;
                $scope.editDesiredProbeTemp = parseInt($scope.editDesiredProbeTemp, 10);
                if (($scope.editDesiredProbeTemp) < $scope.maxProbeTemp) {
                    $scope.editDesiredProbeTemp = $scope.editDesiredProbeTemp + 1;
                } else {
                    $timeout(function () {
                        var toast = $scope.translation.WEBMOB_device_range_alarm_maximum_temp;
                        toast = toast.replace(/#1#/, $scope.maxProbeTemp);
                        toaster.success({title: "", body: toast});
                    }, 500);
                }
                break;
            case 2 ://AMC
                break;
            default :
                break;
        }
    }

    function decreaseProbeTemp(id) {
        switch (id) {
            case 0 ://Normal
                $scope.desiredProbeTemp = parseInt($scope.desiredProbeTemp, 10);
                if (($scope.desiredProbeTemp) > $scope.minProbeTemp) {
                    $scope.desiredProbeTemp = $scope.desiredProbeTemp - 1;
                } else {
                    var toast = $scope.translation.WEBMOB_device_range_alarm_minimum_temp;
                    toast = toast.replace(/#1#/, $scope.minProbeTemp);
                    showToast(toast);
                }
                break;
            case 1 ://Edit Mode
                $scope.editModeTempUpdate = true;
                $scope.editDesiredProbeTemp = parseInt($scope.editDesiredProbeTemp, 10);
                if (($scope.editDesiredProbeTemp) > $scope.minProbeTemp) {
                    $scope.editDesiredProbeTemp = $scope.editDesiredProbeTemp - 1;
                } else {
                    $timeout(function () {
                        var toast = $scope.translation.WEBMOB_device_range_alarm_minimum_temp;
                        toast = toast.replace(/#1#/, $scope.minProbeTemp);
                        toaster.success({title: "", body: toast});
                    }, 500);
                }
                break;
            case 2 ://AMC
                break;
            default :
                break;
        }
    }

    function increaseTempContinuously(id) {
        if (!!!promise) {
            promise = $interval(function () {
                increaseTemp(id);
            }, WALLOVEN_LONGPRESS);
        }
    }

    function decreaseTempContinuously(id) {
        if (!!!promise) {
            promise = $interval(function () {
                decreaseTemp(id);
            }, WALLOVEN_LONGPRESS);
        }
    }

    function increaseHoursContinuously(id) {
        if (!!!promise) {
            promise = $interval(function () {
                increaseHours(id);
            }, WALLOVEN_LONGPRESS);
        }
    }

    function decreaseHoursContinuously(id) {
        if (!!!promise) {
            promise = $interval(function () {
                decreaseHours(id);
            }, WALLOVEN_LONGPRESS);
        }
    }

    function increaseMinutesContinuously(id) {
        if (!!!promise) {
            promise = $interval(function () {
                increaseMinutes(id);
            }, WALLOVEN_LONGPRESS);
        }
    }

    function decreaseMinutesContinuously(id) {
        if (!!!promise) {
            promise = $interval(function () {
                decreaseMinutes(id);
            }, WALLOVEN_LONGPRESS);
        }
    }

    function increaseProbeTempContinuously(id) {
        if (!!!promise) {
            promise = $interval(function () {
                increaseProbeTemp(id);
            }, WALLOVEN_LONGPRESS);
        }
    }

    function decreaseProbeTempContinuously(id) {
        if (!!!promise) {
            promise = $interval(function () {
                decreaseProbeTemp(id);
            }, WALLOVEN_LONGPRESS);
        }
    }

    function doValidationForTemp(id) {
        switch (id) {
            case 0 ://Normal
                $scope.recipeStarted = false;
                $scope.desiredTemp = parseInt($scope.desiredTemp, 10);
                if ($scope.desiredTemp > $scope.maxTemp) {
                    $scope.desiredTemp = $scope.maxTemp;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                    toast = toast.replace(/#1#/, $scope.minTemp);
                    toast = toast.replace(/#2#/, $scope.maxTemp);
                    showToast(toast);
                }

                if ($scope.desiredTemp < $scope.minTemp) {
                    $scope.desiredTemp = $scope.minTemp;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                    toast = toast.replace(/#1#/, $scope.minTemp);
                    toast = toast.replace(/#2#/, $scope.maxTemp);
                    showToast(toast);
                }

                if (!($scope.desiredTemp)) {
                    $scope.desiredTemp = $scope.minTemp;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                    toast = toast.replace(/#1#/g, $scope.minTemp);
                    toast = toast.replace(/#2#/g, $scope.maxTemp);
                    showToast(toast);
                }

                if (($scope.desiredTemp) % $scope.TempIncrement !== 0 && ($scope.desiredTemp >= $scope.minTemp) && ($scope.desiredTemp <= $scope.maxTemp)) {
                    $scope.desiredTemp = Math.round(parseInt($scope.desiredTemp, 10) / $scope.TempIncrement) * $scope.TempIncrement;
                }
                break;
            case 1 ://Edit Mode
                $scope.editDesiredTemp = parseInt($scope.editDesiredTemp, 10);
                if ($scope.editDesiredTemp > $scope.maxTemp) {
                    $scope.editDesiredTemp = $scope.maxTemp;
                    $scope.editModeTempUpdate = true;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                    toast = toast.replace(/#1#/, $scope.minTemp);
                    toast = toast.replace(/#2#/, $scope.maxTemp);
                    showToast(toast);
                }

                if ($scope.editDesiredTemp < $scope.minTemp) {
                    $scope.editDesiredTemp = $scope.minTemp;
                    $scope.editModeTempUpdate = true;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                    toast = toast.replace(/#1#/, $scope.minTemp);
                    toast = toast.replace(/#2#/, $scope.maxTemp);
                    showToast(toast);
                }

                if (!($scope.editDesiredTemp)) {
                    $scope.editDesiredTemp = $scope.minTemp;
                    $scope.editModeTempUpdate = true;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                    toast = toast.replace(/#1#/, $scope.minTemp);
                    toast = toast.replace(/#2#/, $scope.maxTemp);
                    showToast(toast);
                }

                if (($scope.editDesiredTemp) % $scope.TempIncrement !== 0 && ($scope.editDesiredTemp >= $scope.minTemp) && ($scope.editDesiredTemp <= $scope.maxTemp)) {
                    $scope.editDesiredTemp = Math.round(parseInt($scope.editDesiredTemp, 10) / $scope.TempIncrement) * $scope.TempIncrement;
                    $scope.editModeTempUpdate = true;
                }
                if (editTemp !== $scope.editDesiredTemp) {
                    $scope.editModeTempUpdate = true;
                }
                break;
            case 2 ://AMC
                $scope.AMCSaveButtonEnable = true;
                if (document.getElementById('MFPage') !== undefined) {
                    document.getElementById('MFPage').style.height = '100%';
                }
                $scope.desiredMFTemp = parseInt($scope.desiredMFTemp, 10);
                if ($scope.desiredMFTemp > $scope.MFMax) {
                    $scope.desiredMFTemp = $scope.MFMax;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                    toast = toast.replace(/#1#/, $scope.MFMin);
                    toast = toast.replace(/#2#/, $scope.MFMax);
                    showToast(toast);

                }

                if ($scope.desiredMFTemp < $scope.MFMin) {
                    $scope.desiredMFTemp = $scope.MFMin;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                    toast = toast.replace(/#1#/, $scope.MFMin);
                    toast = toast.replace(/#2#/, $scope.MFMax);
                    showToast(toast);
                }

                if (!($scope.desiredMFTemp)) {
                    $scope.desiredMFTemp = $scope.MFMin;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                    toast = toast.replace(/#1#/, $scope.MFMin);
                    toast = toast.replace(/#2#/, $scope.MFMax);
                    showToast(toast);
                }

                if (($scope.desiredMFTemp) % $scope.TempIncrement !== 0 && ($scope.desiredMFTemp >= $scope.MFMin) && ($scope.desiredMFTemp <= $scope.MFMax)) {
                    $scope.desiredMFTemp = Math.round(parseInt($scope.desiredMFTemp, 10) / $scope.TempIncrement) * $scope.TempIncrement;
                }
                $timeout(function () {
                    $scope.MFFocused = false;
                }, 500);
                break;
            default :
                break;
        }
    }

    function doValidationForHour(id) {
        switch (id) {
            case 0 ://Normal
                $scope.recipeStarted = false;
                var desiredHr = parseInt($scope.desiredHours, 10);
                if (!!!desiredHr && desiredHr !== 0) {
                    $scope.desiredHours = parseInt(0, 10);
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }
                if (desiredHr < 0) {
                    $scope.desiredHours = parseInt(0, 10);
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }
                if (desiredHr >= 10) {
                    $scope.desiredHours = parseInt(9, 10);
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }
                if (parseInt($scope.desiredHours, 10) === 0 && parseInt($scope.desiredMinutes, 10) === 0) {
                    $scope.desiredMinutes = 1;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }
                break;
            case 1 ://Edit Mode
                var desiredHr = parseInt($scope.editDesiredHr, 10);
                if (!!!desiredHr && desiredHr !== 0) {
                    $scope.editDesiredHr = parseInt(0, 10);
                    $scope.editModeTimeUpdate = true;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }

                if (desiredHr < 0) {
                    $scope.editDesiredHr = parseInt(0, 10);
                    $scope.editModeTimeUpdate = true;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }
                if (desiredHr >= 10) {
                    $scope.editDesiredHr = parseInt(9, 10);
                    $scope.editModeTimeUpdate = true;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }
                if (parseInt($scope.editDesiredHr, 10) === 0 && parseInt($scope.editDesiredMin, 10) === 0) {
                    $scope.editDesiredMin = 1;
                    $scope.editModeTimeUpdate = true;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }
                if (editHr !== $scope.editDesiredHr) {
                    $scope.editModeTimeUpdate = true;
                }
                break;
            case 2 ://AMC
                $scope.AMCSaveButtonEnable = true;
                if (document.getElementById('MFPage') !== undefined) {
                    document.getElementById('MFPage').style.height = '100%';
                }
                var desiredHr = parseInt($scope.desiredMFHr, 10);
                if (!!!desiredHr && desiredHr !== 0) {
                    $scope.desiredMFHr = parseInt(0, 10);
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }

                if (desiredHr < 0) {
                    $scope.desiredMFHr = parseInt(0, 10);
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }
                if (desiredHr >= 10) {
                    $scope.desiredMFHr = parseInt(9, 10);
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }
                if (parseInt($scope.desiredMFHr, 10) === 0 && parseInt($scope.desiredMFMin, 10) === 0) {
                    $scope.desiredMFMin = 1;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }
                $timeout(function () {
                    $scope.MFFocused = false;
                }, 500);
                break;
            default :
                break;
        }
    }

    function doValidationForMinute(id) {
        switch (id) {
            case 0 ://Normal
                $scope.recipeStarted = false;
                var desiredMin = parseInt($scope.desiredMinutes, 10);
                if (!!!desiredMin && desiredMin !== 0) {
                    $scope.desiredMinutes = 0;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }
                if (desiredMin < 0) {
                    $scope.desiredMinutes = 0;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }
                if (parseInt($scope.desiredHours, 10) === 0 && parseInt($scope.desiredMinutes, 10) === 0) {
                    $scope.desiredMinutes = 01;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }
                if (desiredMin >= 60) {
                    $scope.desiredMinutes = 59;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }
                break;
            case 1 ://Edit Mode
                var desiredMin = parseInt($scope.editDesiredMin, 10);
                if (!!!desiredMin && desiredMin !== 0) {
                    $scope.editDesiredMin = 0;
                    $scope.editModeTimeUpdate = true;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }

                if (desiredMin < 0) {
                    $scope.editDesiredMin = 0;
                    $scope.editModeTimeUpdate = true;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }

                if (parseInt($scope.editDesiredHr, 10) === 0 && parseInt($scope.editDesiredMin, 10) === 0) {
                    $scope.editDesiredMin = 01;
                    $scope.editModeTimeUpdate = true;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }
                if (desiredMin >= 60) {
                    $scope.editDesiredMin = 59;
                    $scope.editModeTimeUpdate = true;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }
                if (editMin !== $scope.editDesiredMin) {
                    $scope.editModeTimeUpdate = true;
                }
                break;
            case 2 ://AMC
                $scope.AMCSaveButtonEnable = true;
                if (document.getElementById('MFPage') !== undefined) {
                    document.getElementById('MFPage').style.height = '100%';
                }
                var desiredMin = parseInt($scope.desiredMFMin, 10);
                if (!!!desiredMin && desiredMin !== 0)
                {
                    $scope.desiredMFMin = 0;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }

                if (desiredMin < 0) {
                    $scope.desiredMFMin = 0;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }

                if (parseInt($scope.desiredMFHr, 10) === 0 && parseInt($scope.desiredMFMin, 10) === 0) {
                    $scope.desiredMFMin = 1;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }
                if (desiredMin >= 60) {
                    $scope.desiredMFMin = 59;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_time_range;
                    toast = toast.replace(/#1#/g, "0:01");
                    toast = toast.replace(/#2#/g, "9:59");
                    showToast(toast);
                }
                $timeout(function () {
                    $scope.MFFocused = false;
                }, 500);
                break;
            default :
                break;
        }
    }

    function doValidationForProbeTemp(id) {
        switch (id) {
            case 0 ://Normal
                $scope.recipeStarted = false;
                $scope.desiredProbeTemp = parseInt($scope.desiredProbeTemp, 10);
                if ($scope.desiredProbeTemp > $scope.maxProbeTemp) {
                    $scope.desiredProbeTemp = $scope.maxProbeTemp;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                    toast = toast.replace(/#1#/, $scope.minProbeTemp);
                    toast = toast.replace(/#2#/, $scope.maxProbeTemp);
                    showToast(toast);
                }

                if ($scope.desiredProbeTemp < $scope.minProbeTemp) {
                    $scope.desiredProbeTemp = $scope.minProbeTemp;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                    toast = toast.replace(/#1#/, $scope.minProbeTemp);
                    toast = toast.replace(/#2#/, $scope.maxProbeTemp);
                    showToast(toast);
                }

                if (!($scope.desiredProbeTemp)) {
                    $scope.desiredProbeTemp = $scope.minProbeTemp;
                    var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                    toast = toast.replace(/#1#/, $scope.minProbeTemp);
                    toast = toast.replace(/#2#/, $scope.maxProbeTemp);
                    showToast(toast);
                }

                if (($scope.desiredProbeTemp) % 1 !== 0 && ($scope.desiredProbeTemp >= $scope.minProbeTemp) && ($scope.desiredProbeTemp <= $scope.desiredProbeTemp)) {
                    $scope.desiredProbeTemp = Math.round(parseInt($scope.desiredProbeTemp, 10) / 1) * 1;
                }
                break;
            case 1 ://Edit Mode
                $scope.editDesiredProbeTemp = parseInt($scope.editDesiredProbeTemp, 10);
                if ($scope.editDesiredProbeTemp > $scope.maxProbeTemp) {
                    $scope.editDesiredProbeTemp = $scope.maxProbeTemp;
                    $scope.editModeTempUpdate = true;
                    $timeout(function () {
                        var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                        toast = toast.replace(/#1#/, $scope.minProbeTemp);
                        toast = toast.replace(/#2#/, $scope.maxProbeTemp);
                        toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
                    }, 500);
                }

                if ($scope.editDesiredProbeTemp < $scope.minProbeTemp) {
                    $scope.editDesiredProbeTemp = $scope.minProbeTemp;
                    $scope.editModeTempUpdate = true;
                    $timeout(function () {
                        var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                        toast = toast.replace(/#1#/, $scope.minProbeTemp);
                        toast = toast.replace(/#2#/, $scope.maxProbeTemp);
                        toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
                    }, 500);
                }

                if (!($scope.editDesiredProbeTemp)) {
                    $scope.editDesiredProbeTemp = $scope.minProbeTemp;
                    $scope.editModeTempUpdate = true;
                    $timeout(function () {
                        var toast = $scope.translation.WEBMOB_device_range_ready_adjust_temp_range;
                        toast = toast.replace(/#1#/, $scope.minProbeTemp);
                        toast = toast.replace(/#2#/, $scope.maxProbeTemp);
                        toaster.success({title: "", body: toast, bodyOutputType: 'trustedHtml'});
                    }, 500);
                }

                if (($scope.editDesiredProbeTemp) % 1 !== 0 && ($scope.editDesiredProbeTemp >= $scope.minProbeTemp) && ($scope.editDesiredProbeTemp <= $scope.maxProbeTemp)) {
                    $scope.editDesiredProbeTemp = Math.round(parseInt($scope.editDesiredProbeTemp, 10) / 1) * 1;
                    $scope.editModeTempUpdate = true;
                }
                if (editProbeTemp !== $scope.editDesiredProbeTemp) {
                    $scope.editModeTempUpdate = true;
                }
                break;
            case 2 ://AMC
                break;
            default :
                break;
        }
    }

    function hideInputBoxFocus() {
        stopLongPressEvent();
        blurInputBox('inputTemp');
        blurInputBox('inputHrs');
        blurInputBox('inputMins');
        blurInputBox('inputProbeTemp');
        blurInputBox('inputEditTemp');
        blurInputBox('inputEditHrs');
        blurInputBox('inputEditMins');
        blurInputBox('inputEditProbeTemp');
        blurInputBox('inputAMCTemp');
        blurInputBox('inputAMCHrs');
        blurInputBox('inputAMCMins');
        blurInputBox('inputAMCProbeTemp');
    }

    function blurInputBox(id) {
        if (document.getElementById(id) !== null && document.getElementById(id) !== undefined) {
            document.getElementById(id).blur();
            if (isTextInput(document.activeElement)) {
                document.activeElement.blur();
            }
        }
    }

    function gotoSmartControl() {
        debugMessage('gotoSmartControl');
        fixScreen();
        if ((selectedCavity === 'DUALLOWER' || selectedCavity === 'LOWERFLEX')) {
            $scope.smartControl = $scope.remoteControlEnabledIdTwo ? 'ON' : 'OFF';
        } else {
            $scope.smartControl = $scope.remoteControlEnabled ? 'ON' : 'OFF';
        }
        document.getElementById("showsmartControlfullScreenPopupId").style.zIndex = 999;
        document.getElementById("smartControlPopupDivId").style.zIndex = 999;
        $scope.samrtControlPopup = true;
        //validateCurrentScreen('SmartControlPage');
    }

    function gotoStramRoastLevel() {
        debugMessage('gotoStramRoastLevel');
        var deviceId = 0;
        if (selectedCavity === 'SINGLE' || selectedCavity === 'DUALUPPER' || selectedCavity === 'DUALFLEXUPPER') {
            deviceId = 0;
        } else if (selectedCavity === 'DUALLOWER' || selectedCavity === 'LOWERFLEX') {
            deviceId = 2;
        } else if (selectedCavity === 'DUALFLEXLOWER') {
            deviceId = 1;
        }

        if (!SmartControlCheck(deviceId)) {
            debugMessage("return smart control OFF");
            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_SMARTMONITOR_GUIDE, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_range_alarm_smart_control_on, $scope.translation.WEBMOB_common_ok, '');
            return;
        }

        fixScreen();
        document.getElementById("SteamRoastfullScreenPopupId").style.zIndex = 999;
        document.getElementById("SteamRoastPopupDivId").style.zIndex = 999;
        $scope.steamRoastPopup = true;
    }

    function goToSettings() {
        debugMessage('goToSettings');
        validateCurrentScreen('SettingPage');
    }

    function goToAbout() {
        debugMessage('goToAbout');
        validateCurrentScreen('AboutPage');
    }

    function gotoMyFavorite() {
        debugMessage('gotoMyFavorite');
        validateCurrentScreen('MyFavoritePage');
    }

    function showAutoCookDetailsScreen(id) {
        debugMessage('showAutoCookDetailsScreen');
        $scope.autoCookRecipeId = id;
        validateCurrentScreen('AutoCookDetailPage');
    }

    function autoCookNextPage() {
        debugMessage('autoCookNextPage');
        $scope.nextPageAutoCookDetail = false;
        $scope.previousPageAutoCookDetail = true;
    }

    function autoCookPreviousPage() {
        debugMessage('autoCookPreviousPage');
        $scope.nextPageAutoCookDetail = true;
        $scope.previousPageAutoCookDetail = false;
    }

    function autoCookSendButton() {
        debugMessage('autoCookSendButton');
        showcustDialog(WALLOVEN_ALERT_STATE.ALERT_START_ATUOCOOK_COOKING, '', $scope.translation.WEBMOB_device_range_alarm_start_cooking_now, $scope.translation.WEBMOB_device_range_comm_no, $scope.translation.WEBMOB_device_range_comm_yes);
    }

    function doOnServiceCallPopup() {
        showcustDialog(WALLOVEN_ALERT_STATE.ALERT_SERVICE_CALL, $scope.translation.WEBMOB_common_service_call, ($scope.translation.WEBMOB_common_connect_service_call) + "<br>" + $scope.serviceCenterNumber, $scope.translation.WEBMOB_common_cancel_capital, $scope.translation.WEBMOB_common_ok);
    }

    function showMenuOption() {
        debugMessage('showMenuOption');
        fixScreen();
        document.getElementById("showMenufullScreenPopupId").style.zIndex = 999;
        document.getElementById("showMenuPopupDivId").style.zIndex = 999;
        $scope.showMenuOptionPopup = true;
    }

    function hideMenuOption() {
        debugMessage('hideMenuOption');
        scrollScreen();
        $scope.showMenuOptionPopup = false;
        if ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_MY_FAVORITE_RECIPE_DETAIL_PAGE) {
            fixScreen();
        }
    }

    function hideSmartControlOption() {
        debugMessage('hideSmartControlOption');
        scrollScreen();
        $scope.samrtControlPopup = false;
    }

    function hideStramRoastLevel() {
        debugMessage('hideStramRoastLevel');
        scrollScreen();
        $scope.steamRoastPopup = false;
    }

    function adjustTempPkrLeft() {
        var left = '7.8rem';
        if ($scope.AdjustTemp < -9) {
            left = '7.2rem';
        } else if ($scope.AdjustTemp < 0) {
            left = '7.8rem';
        } else if ($scope.AdjustTemp < 10) {
            left = '8.3rem';
        } else {
            left = '7.8rem';
        }
        return {
            paddingLeft: left
        };
    }

    function steamRoastLevelClick(id) {
        debugMessage("steamRoastLevelClick " + id);
        $scope.steamRoastLevel = id;
        if (($scope.displayRunRunningMode === 'SteamRoast' || $scope.displayRunRunningMode === 'SteamBake') && $scope.idZero.Operation.state === 'Run' && deviceID === 0
                || ($scope.displayRunRunningMode === 'SteamRoast' || $scope.displayRunRunningMode === 'SteamBake') && $scope.idOne.Operation.state === 'Run' && deviceID === 1
                || ($scope.displayRunRunningMode === 'SteamRoast' || $scope.displayRunRunningMode === 'SteamBake') && $scope.idTwo.Operation.state === 'Run' && deviceID === 2) {
            $scope.steamRoastLevel = id;
            var value = 'steamAddLevel_' + id;
            sendSettingCommand(value, deviceID);
        }
        hideStramRoastLevel();
    }

    function changeTempUnit(unit) {
        if (unit === 'Fahrenheit' && $scope.TempUnit === 'F'
                || unit === 'Celsius' && $scope.TempUnit === 'C') {
            debugMessage(' return changeTempUnit same value');
            return;
        }
        unit = unit === 'Celsius' ? 'Celsius' : 'Fahrenheit';
        var command = '{"Temperature" : {"unit" : "' + unit + '"}}';
        if (!$scope.isStatic) {
            $scope.checkResponse.push(WALLOVEN_COMMANDS.changeTempUnit);
            debugMessage(command + "/" + $scope.peerId + "/devices/0");
            SHPService.sendSHPCommand(CONSTANTS.PUT, command, "/" + $scope.peerId + "/devices/0/temperatures/0");
        }
    }

    function sendAdjustTemp() {
        if (settingOptionPreCondition()) {
            return;
        }
        var valueArray, tem, temp, value, num = '', i = 0;
        tem = $scope.AdjustTemp;
        temp = Math.abs(tem);
        valueArray = readCooktopValue(temp, 7);
        for (i; i < valueArray.length; i++) {
            num = num + valueArray[i];
        }
        if (tem < 0) {
            num = 1 + num;
        } else {
            num = 0 + num;
        }
        value = 'AdjustingTemp_' + parseInt(num, 2);
        sendSettingCommand(value, 0);
        validateCurrentScreen('SettingPage');
    }

    function versionTouchStart() {
        debugMessage("ABOUT command versionTouchStart");
        if (!!!promiseAbout) {
            promiseAbout = $timeout(function () {
                promiseAbout = null;
                if (!$scope.isStatic) {
                    $scope.checkResponse.push(WALLOVEN_COMMANDS.showModuleVersion);
                    SHPService.sendSHPCommand(CONSTANTS.GET, "/" + $scope.peerId + "/devices/0/information");
                }
            }, 5000);
        }
    }

    function versionTouchEnd() {
        debugMessage("ABOUT command versionTouchEnd");
        if (!!promiseAbout) {
            $timeout.cancel(promiseAbout);
            promiseAbout = null;
        }
    }

    function onSettingsToggleUpdate(settingItem) {
        var value;
        debugMessage('Setting Option Clicked ' + settingItem);
        switch (settingItem) {
            case "tempAdjust":
                if (settingOptionPreCondition()) {
                    return;
                }
                validateCurrentScreen('SettingTempAdjustPage');
                break;
            case "tempUnit":
                if (settingOptionPreCondition()) {
                    return;
                }
                validateCurrentScreen('SettingTempUnitPage');
                break;
            case "autoConversion":
                if (settingOptionPreCondition()) {
                    return;
                }
                $scope.bAutoConversion = !$scope.bAutoConversion;
                value = $scope.bAutoConversion ? 'RecipeConversion_On' : 'RecipeConversion_Off';
                sendSettingCommand(value, 0);
                break;
            case "hrEnergySaving":
                if (settingOptionPreCondition()) {
                    return;
                }
                $scope.bHrEnergySaving = !$scope.bHrEnergySaving;
                value = $scope.bHrEnergySaving ? 'EnergySaving_On' : 'EnergySaving_Off';
                sendSettingCommand(value, 0);
                break;
            case "sound":
                if (settingOptionPreCondition()) {
                    return;
                }
                $scope.bSound = !$scope.bSound;
                value = $scope.bSound ? 'Sound_On' : 'Sound_Off';
                sendSettingCommand(value, 0);
                break;
            case "virtualFlame":
                if (settingOptionPreCondition()) {
                    return;
                }
                $scope.bVirtualFlame = !$scope.bVirtualFlame;
                value = $scope.bVirtualFlame ? 'VirtualFlame_On' : 'VirtualFlame_Off';
                sendSettingCommand(value, 0);
                break;
            case "noPreheat":
                if (($scope.displayReadyMode === 'ConvectionBake' || $scope.displayReadyMode === 'ConvectionRoast') && $scope.idZero.Operation.state !== 'Run' && deviceID === 0
                        || ($scope.displayReadyMode === 'ConvectionBake' || $scope.displayReadyMode === 'ConvectionRoast') && $scope.idOne.Operation.state !== 'Run' && deviceID === 1
                        || ($scope.displayReadyMode === 'ConvectionBake' || $scope.displayReadyMode === 'ConvectionRoast') && $scope.idTwo.Operation.state !== 'Run' && deviceID === 2) {
                    $scope.bNoPreheat = !$scope.bNoPreheat;
                    //value = $scope.bNoPreheat ? 'NoPreheat_On' : 'NoPreheat_Off';
                    //sendSettingCommand(value, deviceID);
                } else {
                    showToast($scope.translation.WEBMOB_device_walloven_no_preheat_popup);
                }
                break;
            case "sabbathMode":
                if ($scope.bSabbathMode) {
                    $scope.bSabbathMode = !$scope.bSabbathMode;
                    value = $scope.bSabbathMode ? 'Sabbath_On' : 'Sabbath_Off';
                    sendSettingCommand(value, deviceID);
                } else {
                    if ($scope.idZero.Mode.modes[0] === 'Bake' && $scope.idZero.Operation.state === 'Run'
                            || $scope.idOne.Mode.modes[0] === 'Bake' && $scope.idOne.Operation.state === 'Run'
                            || $scope.idTwo.Mode.modes[0] === 'Bake' && $scope.idTwo.Operation.state === 'Run') {
                        if ($scope.idZero.Mode.options[0].meatprobe === "connected" || $scope.idOne.connected) { // MW0600025101 - Sabbath mode when Temp probe is on or divider insert.
                            showToast($scope.translation.WEBMOB_device_range_oven_sabbath_mode_popup);
                        } else {
                            $scope.bSabbathMode = !$scope.bSabbathMode;
                            value = $scope.bSabbathMode ? 'Sabbath_On' : 'Sabbath_Off';
                            sendSettingCommand(value, deviceID);
                        }
                    } else {
                        showToast($scope.translation.WEBMOB_device_range_alarm_only_change_on_baking_mode);
                    }
                }
                break;
            default:
                break;
        }
    }

    function sendSettingCommand(Value, id) {
        var command;
        if (id === undefined) {
            if (selectedCavity === 'SINGLE' || selectedCavity === 'DUALUPPER' || selectedCavity === 'DUALFLEXUPPER') {
                id = 0;
            } else if (selectedCavity === 'DUALLOWER' || selectedCavity === 'LOWERFLEX') {
                id = 2;
            } else if (selectedCavity === 'DUALFLEXLOWER') {
                id = 1;
            } else {
                id = 0;
            }
        }
        command = '{"Mode":{"options":["' + Value + '"]}}';
        debugMessage("Setting command " + command);
        $scope.checkResponse.push(WALLOVEN_COMMANDS.SettingOptions);
        SHPService.sendSHPCommand(CONSTANTS.PUT, command, "/" + $scope.peerId + "/devices/" + id + "/mode");
    }

    function settingOptionPreCondition() {
        if ($scope.idZero.Operation.state === "Run"
                || $scope.idOne.Operation.state === "Run"
                || $scope.idTwo.Operation.state === "Run") {
            debugMessage("Setting command running state, 0: " + $scope.idZero.Operation.state + ", 1: " + $scope.idOne.Operation.state + ", 2: " + $scope.idTwo.Operation.state);
            showToast($scope.translation.WEBMOB_device_range_alarm_only_change_not_cooking);
            return true;
        }
        return false;
    }

    function onAboutAction(reqParam) {
        if (reqParam === "smartcare") {
            $scope.currentScreen = WALLOVEN_SCREENS.WALLOVEN_SMART_CARE_PAGE;
            validateCurrentScreen('SmartCarePage');
            return;
        }
        nativeInterface.runOnNative("customerService", aboutCommand(reqParam));
    }

    function aboutCommand(cmdstring) {
        return '{"service" : "' + cmdstring + '","selectedCountry" : "' + $scope.selectedCountry + '"}';
    }

    function callServieCenter() {
        debugMessage("call service center");
        nativeInterface.runOnNative("callDial", '{"selectedCountry" : "' + $scope.selectedCountry + '"}');
    }

    function openModeMenu() {
        debugMessage("openModeMenu");
        fixScreen();
        $scope.wallOvenModeMenu = true;
    }

    function openMFMenu() {
        if (!$scope.MFFocused) {
            debugMessage("openMFMenu");
            fixScreen();
            $scope.MFMenuVisible = true;
        }
    }

    function hideModeMenu() {
        debugMessage("hideModeMenu");
        scrollScreen();
        $scope.wallOvenModeMenu = false;
        $scope.wOvenCurrentTab = null;
        $scope.MFMenuVisible = false;
    }

    function menuTabClick(TabsPagetab) {
        debugMessage("menuTabClick : TabsPagetab.id " + TabsPagetab.id + " clicked");
        switch (TabsPagetab.id) {
            case 1:
                if ($scope.ovenFunctionContents === undefined || $scope.ovenFunctionContents.length <= 0) {
                    initializeScreenDB();
                    readDBValue();
                    setDataCurrentScreen();
                }
                if ($scope.wOvenCurrentTab === TabsPagetab.id) {
                    $scope.wOvenCurrentTab = null;
                } else {
                    $scope.wOvenCurrentTab = TabsPagetab.id;
                }
                break;
            case 3:
                if ($scope.healthyFunctionContents === undefined || $scope.healthyFunctionContents.length <= 0) {
                    initializeScreenDB();
                    readDBValue();
                    setDataCurrentScreen();
                }
                if ($scope.wOvenCurrentTab === TabsPagetab.id) {
                    $scope.wOvenCurrentTab = null;
                } else {
                    $scope.wOvenCurrentTab = TabsPagetab.id;
                }
                break;
            case 4:
                if ($scope.easyCookContents === undefined || $scope.easyCookContents.length <= 0) {
                    initializeScreenDB();
                    readDBValue();
                    setDataCurrentScreen();
                }
                if ($scope.wOvenCurrentTab === TabsPagetab.id) {
                    $scope.wOvenCurrentTab = null;
                } else {
                    $scope.wOvenCurrentTab = TabsPagetab.id;
                }
                break;
            case 5:
                $scope.wallOvenModeMenu = false;
                $scope.wOvenCurrentTab = null;
                hideModeMenu();
                validateCurrentScreen('AutoCookPage');
                break;
            default:
                break;
        }
    }

    function menuTabItemClick(tabNumber, recipeInfo) {
        if (!$scope.wallOvenModeMenu) {
            return;
        }
        $scope.deviceMode = recipeInfo[4];
        $scope.recipeStarted = false;
        $scope.bNoPreheat = false;
        $scope.steamRoastLevel = 2;
        debugMessage(recipeInfo[4] + " menu Sub Item Selected with index " + tabNumber);
        scrollScreen();
        $timeout(function () {
            switch (tabNumber) {
                case 0:
                case 1:
                case 2:
                    debugMessage("menuTabItemClick Item Mode : " + recipeInfo[4] + ' && Info :' + JSON.stringify(recipeInfo));
                    setClickedRecipeData(recipeInfo);
                    $scope.wallOvenModeMenu = false;
                    $scope.wOvenCurrentTab = null;
                    showCurrentScreen();
                    break;
                default:
                    debugMessage("unknown item clicked");
                    break;
            }
            hideModeMenu();
        }, 200);
    }

    function setClickedRecipeData(recipeInfo) {
        debugMessage("setClickedRecipeData");
        var mode, temp, hr, min, probeTemp, newdate = new Date();
        newdate.setHours(0, recipeInfo[19], 0);
        mode = recipeInfo[4];
        temp = $scope.TempUnit === 'F' ? recipeInfo[13] : recipeInfo[16];
        probeTemp = $scope.TempUnit === 'F' ? 150 : 65;
        hr = Number(newdate.getHours());
        min = Number(newdate.getMinutes());

        if (selectedCavity === 'SINGLE') {
            wOvenSingleBaseMode = recipeInfo[4];
            userPreferneceSingle = {};
            saveUserValueSingle(mode, temp, probeTemp, hr, min, false);
            setValueForSingleMode();
        } else if (selectedCavity === 'DUALUPPER') {
            wOvenDualUpperBaseMode = recipeInfo[4];
            userPreferneceDualUpper = {};
            saveUserValueDualUpper(mode, temp, probeTemp, hr, min, false);
            setValueForDualUpperMode();
        } else if (selectedCavity === 'DUALLOWER') {
            wOvenDualLowerBaseMode = recipeInfo[4];
            userPreferneceDualLower = {};
            saveUserValueDualLower(mode, temp, probeTemp, hr, min, false);
            setValueForDualLowerMode();
        } else if (selectedCavity === 'DUALFLEXUPPER') {
            wOvenDualFlexUpperBaseMode = recipeInfo[4];
            userPreferneceDualFlexUpper = {};
            if ($scope.idOne.Operation.state === 'Run' && $scope.idZero.Operation.state === 'Ready') {
                //if (temp > setMaxTempValue($scope.idOne.Temperatures[0].desired) || temp < setMinTempValue($scope.idOne.Temperatures[0].desired)) {
                temp = Number($scope.idOne.Temperatures[0].desired) !== 0 ? Number($scope.idOne.Temperatures[0].desired) : temp;
                //}
                if (temp === 0 || temp === undefined) {
                    temp = setMinTempValue($scope.idZero.Temperatures[0].desired);
                }
                if (temp === 61441) {
                    temp = $scope.bFahrenheit ? 480 : 248;
                }
                if (temp === 61442) {
                    temp = $scope.bFahrenheit ? 400 : 204;
                }
            }
            saveUserValueDualFlexUpper(mode, temp, probeTemp, hr, min, false);
            setValueForDualFlexUpperMode();
        } else if (selectedCavity === 'DUALFLEXLOWER') {
            wOvenDualFlexLowerBaseMode = recipeInfo[4];
            userPreferneceDualFlexLower = {};
            if ($scope.idOne.Operation.state === 'Ready' && $scope.idZero.Operation.state === 'Run') {
                //if (temp > setMaxTempValue($scope.idZero.Temperatures[0].desired) || temp < setMinTempValue($scope.idZero.Temperatures[0].desired)) {
                temp = Number($scope.idZero.Temperatures[0].desired) !== 0 ? Number($scope.idZero.Temperatures[0].desired) : temp;
                //}
                if (temp === 0 || temp === undefined) {
                    temp = setMinTempValue($scope.idZero.Temperatures[0].desired);
                }
                if (temp === 61441) {
                    temp = $scope.bFahrenheit ? 480 : 248;
                }
                if (temp === 61442) {
                    temp = $scope.bFahrenheit ? 400 : 204;
                }
            }
            saveUserValueDualFlexLower(mode, temp, probeTemp, hr, min, false);
            setValueForDualFlexLowerMode();
        } else if (selectedCavity === 'LOWERFLEX') {
            wOvenDualLowerBaseMode = recipeInfo[4];
            wOvenLowerFlexBaseMode = recipeInfo[4];
            userPreferneceDualLower = {};
            saveUserValueDualLower(mode, temp, probeTemp, hr, min, false);
            setValueForDualLowerMode();
        } else if (selectedCavity === '') {
            //TODO
        }
        $scope.DisplayContents = recipeInfo; //update displayContent with selected recipe
        updateDisplayScreenData();
    }

    function readDBValue() {
        debugMessage("readDBValue");
        if (selectedCavity === 'SINGLE') {
            $scope.ovenFunctionContents = $scope.ovenFunctionContentsSingle;
            $scope.healthyFunctionContents = $scope.healthyFunctionContentsSingle;
            $scope.DisplayContents = getModeRowValue($scope.supportedModesSingle, wOvenSingleBaseMode);
            $scope.MFContents = $scope.DisplayContents;
        } else if (selectedCavity === 'DUALUPPER') {
            $scope.ovenFunctionContents = $scope.ovenFunctionContentsDualUpper;
            $scope.healthyFunctionContents = $scope.healthyFunctionContentsDualUpper;
            $scope.DisplayContents = getModeRowValue($scope.supportedModesDualUpper, wOvenDualUpperBaseMode);
            $scope.MFContents = $scope.DisplayContents;
        } else if (selectedCavity === 'DUALLOWER') {
            $scope.ovenFunctionContents = $scope.ovenFunctionContentsDualLower;
            $scope.healthyFunctionContents = $scope.healthyFunctionContentsDualLower;
            $scope.DisplayContents = getModeRowValue($scope.supportedModesDualLower, wOvenDualLowerBaseMode);
            $scope.MFContents = $scope.DisplayContents;
        } else if (selectedCavity === 'DUALFLEXUPPER') {
            $scope.ovenFunctionContents = $scope.ovenFunctionContentsDualUpperFlex;
            $scope.healthyFunctionContents = $scope.healthyFunctionContentsDualUpperFlex;
            $scope.DisplayContents = getModeRowValue($scope.supportedModesDualUpperFlex, wOvenDualFlexUpperBaseMode);
            $scope.MFContents = $scope.DisplayContents;
        } else if (selectedCavity === 'DUALFLEXLOWER') {
            $scope.ovenFunctionContents = $scope.ovenFunctionContentsDualLowerFlex;
            $scope.healthyFunctionContents = $scope.healthyFunctionContentsDualLowerFlex;
            $scope.DisplayContents = getModeRowValue($scope.supportedModesDualLowerFlex, wOvenDualFlexLowerBaseMode);
            $scope.MFContents = $scope.DisplayContents;
        } else if (selectedCavity === 'LOWERFLEX') {
            $scope.ovenFunctionContents = $scope.ovenFunctionContentsDualLower;
            $scope.healthyFunctionContents = $scope.healthyFunctionContentsDualLower;
            $scope.DisplayContents = getModeRowValue($scope.supportedModesDualLower, wOvenLowerFlexBaseMode);
            $scope.MFContents = $scope.DisplayContents;
        } else if (selectedCavity === '') {
            //TODO
        }
    }

    function checkForMeatProbe() {
        if ($scope.idZero !== undefined) {
            //debugMessage("MeatProbe Connected : " + ($scope.idZero.Mode.options[0].meatprobe === "connected" + " && mode support " + $scope.deviceModeSupport));
            $scope.meatProbeConnected = ($scope.idZero.Mode.options[0].meatprobe === "connected" && $scope.deviceModeSupport);
        }
    }

    function setTempUnit(state) {
        if (!justFirstTime && !$scope.appAtForeground && state === 'Ready') {
            $scope.TempUnit = $scope.idZero.Temperatures[0].unit === 'Celsius' ? 'C' : 'F';
            userPreferneceSingle = {};
            userPreferneceDualUpper = {};
            userPreferneceDualLower = {};
            userPreferneceDualFlexUpper = {};
            userPreferneceDualFlexLower = {};
            settingPageOptionsValidation();
            setDataCurrentScreen();
            checkForMeatProbe();
        }
    }

    function runEditMode() {
        if ($scope.bSabbathMode && $scope.deviceSingleUpperInfo.Operation.state === 'Run') {
            return;
        }
        if (!$scope.editMode) {
            $scope.editMode = true;
        }

        debugMessage("edit mode for selectedCavity " + selectedCavity);
        updateRunEditScreen();
        setDataCurrentScreen();
        showScreen();
    }

    function setDualStateMaxMinTemp() {
        debugMessage(" Adjust Min/Max temp due to other cavity running");
    }

    function updateRunEditScreen() {
        $scope.editRunMode = $scope.displayRunRunningMode;
        $scope.editRunModeText = $scope.displayRunRunningModeText;
        $scope.editDesiredTemp = $scope.displayRunDesiredTemp;
        $scope.editDesiredProbeTemp = $scope.displayRunProbeDesiredTemp;
        $scope.editDesiredHr = Number($scope.displayRunDesiredRemainingHr);
        if ($scope.editDesiredProbeTemp <= 0) {
            $scope.editDesiredProbeTemp = $scope.TempUnit === 'F' ? 150 : 65;
        }
        /*
         * CQ issue - MW0600024976 - cooking mode's temperature setting range when before start and after start(temp. change screen).
         */
        if ((deviceID === 0 && ($scope.idOne.Operation.state === 'Run' || $scope.idTwo.Operation.state === 'Run'))
                || (deviceID === 1 && ($scope.idZero.Operation.state === 'Run' || $scope.idTwo.Operation.state === 'Run'))
                || (deviceID === 2 && ($scope.idZero.Operation.state === 'Run' || $scope.idOne.Operation.state === 'Run'))) {

            $scope.editMinTemp = setMinTempValue($scope.editDesiredTemp);//TODO Adjust Min/Max temp due to other cavity running
            $scope.editMaxTemp = setMaxTempValue($scope.editDesiredTemp);//TODO Adjust Min/Max temp due to other cavity running
        } else {// same as min and max taken from DB
            $scope.editMinTemp = $scope.TempUnit === 'F' ? $scope.DisplayContents[14] : $scope.DisplayContents[17];
            $scope.editMaxTemp = $scope.TempUnit === 'F' ? $scope.DisplayContents[15] : $scope.DisplayContents[18];
        }

        $scope.editDesiredMin = Number($scope.displayRunDesiredRemainingMin);
        editTemp = $scope.editDesiredTemp;
        editHr = $scope.editDesiredHr;
        editMin = $scope.editDesiredMin;
        editProbeTemp = $scope.editDesiredProbeTemp;
    }

    function cancleEditMode() {
        $scope.editMode = false;
        $scope.editModeTimeUpdate = false;
        $scope.editModeTempUpdate = false;
        showCurrentScreen();
    }

    function applyEditMode() {
        debugMessage("applyEditMode");
        var deviceId = 0;
        if (selectedCavity === 'SINGLE' || selectedCavity === 'DUALUPPER' || selectedCavity === 'DUALFLEXUPPER') {
            deviceId = 0;
        } else if (selectedCavity === 'DUALLOWER' || selectedCavity === 'LOWERFLEX') {
            deviceId = 2;
        } else if (selectedCavity === 'DUALFLEXLOWER') {
            deviceId = 1;
        }

        if (!SmartControlCheck(deviceId)) {
            debugMessage("return smart control OFF");
            showcustDialog(WALLOVEN_ALERT_STATE.ALERT_SMARTMONITOR_GUIDE, $scope.translation.WEBMOB_device_walloven_popup_title, $scope.translation.WEBMOB_device_range_alarm_smart_control_on, $scope.translation.WEBMOB_common_ok, '');
            return;
        }
        debugMessage("finalString : " + getSendRunningPropertyChangeCommand() + " && id " + deviceId);
        $scope.checkResponse.push(WALLOVEN_COMMANDS.runingCookingEdit);
        SHPService.sendSHPCommand(CONSTANTS.PUT, getSendRunningPropertyChangeCommand(), "/" + $scope.peerId + "/devices/" + deviceId);
        $scope.editMode = false;
        $scope.editModeTimeUpdate = false;
        $scope.editModeTempUpdate = false;
        showCurrentScreen();
    }

    function getSendRunningPropertyChangeCommand() {
        debugMessage("getSendRunningPropertyChangeCommand");
        var hr, min, unit, desiredtemp = 0, operationTime = '', finalString = '', tempDesiredString = '', OperationoperationTimeString = '';
        desiredtemp = $scope.editDesiredTemp;
        hr = Number($scope.editDesiredHr) < 10 ? '0' + Number($scope.editDesiredHr) : Number($scope.editDesiredHr);
        min = Number($scope.editDesiredMin) < 10 ? '0' + Number($scope.editDesiredMin) : Number($scope.editDesiredMin);
        operationTime = hr + ':' + min + ':00';
        OperationoperationTimeString = '"Operation" : {"operationTime" : "' + operationTime + '"},';
        unit = $scope.TempUnit === 'C' ? 'Celsius' : 'Fahrenheit';
        tempDesiredString = '"Temperatures" : [{"id" : "0","desired" : ' + desiredtemp + ',"unit" : "' + unit + '"}]';
        if ($scope.meatProbeConnected) {
            tempDesiredString = '"Temperatures" : [{"id" : "0","desired" : ' + desiredtemp + ',"unit" : "' + unit + '"}, {"id" : "1","desired" : ' + $scope.editDesiredProbeTemp + ',"unit" : "' + unit + '"}]';
        }

        if ($scope.editModeTimeUpdate) {
            finalString = '{"Device" : {' + OperationoperationTimeString + tempDesiredString + '}}';
        } else {
            finalString = '{"Device" : {' + tempDesiredString + '}}';
        }
        return finalString;
    }

    function callServieCenter() {
        debugMessage("call service center");
        nativeInterface.runOnNative("callDial", '{"selectedCountry" : "' + $scope.selectedCountry + '"}');
    }

    function getLocalStorageData(item) {
        if (typeof (Storage) !== "undefined") {
            return localStorage.getItem(item);
        } else {
            ;//NULL
        }
    }

    function setLocalStorageData(item, value) {
        debugMessage('setLocalStorageData');
        if (typeof (Storage) !== "undefined") {
            localStorage.setItem(item, value);
        } else {
            ;//NULL
        }
    }

    function clearLocalStorage() {
        debugMessage('clearLocalStorage');
        localStorage.clear();
    }

    function keyPadScroll(e) {
        debugMessage("keyPadScroll " + e.currentTarget.id);
        if ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_EDIT_MY_FAVORITE_DETAIL_PAGE) {
            $scope.MFFocused = true;
            if (document.getElementById('MFPage') !== undefined) {
                document.getElementById('MFPage').style.height = '140%';
            }
            if (e.currentTarget.id !== undefined || e.currentTarget.id !== '') {
                document.getElementById(e.currentTarget.id).scrollIntoView();
            }
        }
    }

    function showDummyInbox() {
        debugMessage("showDummyInbox");
        if (window.navigator.platform !== 'iPhone' || window.navigator.platform !== 'iPad') {
            $scope.isTempFocusOn = true;
        }
    }

    function hideDummyInbox() {
        debugMessage("hideDummyInbox");
        $scope.isTempFocusOn = false;
    }

    function disableDummyInbox() {
        debugMessage("disableDummyInbox");
        if (document.getElementById("dummyInputBox") !== null) {
            document.getElementById("dummyInputBox").disabled = true;
        }
    }

    function loadMFData() {
        debugMessage('loadMFData ' + JSON.stringify($scope.MFContents));
        var newdate = new Date();
        newdate.setHours(0, $scope.MFContents[19], 0);
        $scope.desiredMFMode = $scope.MFContents[4];
        $scope.desiredMFModeText = $scope.MFContents[5];
        $scope.desiredMFDesc = $scope.MFContents[2];
        $scope.desiredMFHr = Number(newdate.getHours());
        $scope.desiredMFMin = Number(newdate.getMinutes());
        if ($scope.TempUnit === "F") {
            $scope.desiredMFTemp = Number($scope.MFContents[13]);
            $scope.MFMin = $scope.MFContents[14];
            $scope.MFMax = $scope.MFContents[15];
        } else {
            $scope.desiredMFTemp = Number($scope.MFContents[16]);
            $scope.MFMin = $scope.MFContents[17];
            $scope.MFMax = $scope.MFContents[18];

        }
        if ($scope.MFContents[22] === null || $scope.MFContents[22] === undefined || $scope.MFContents[22] === '') {
            $scope.currentRecipeName = getMyCookingRecipeName();
        } else {
            $scope.currentRecipeName = $scope.MFContents[22];
        }
        if ($scope.MFContents[0] === null || $scope.MFContents[0] === undefined || $scope.MFContents[0] === '') {
            $scope.MFRandomID = Math.random();
        } else {
            $scope.MFRandomID = $scope.MFContents[0];
        }
        $scope.desiredMFRecipeID = $scope.MFRandomID;
        $scope.desiredMFRecipeName = $scope.currentRecipeName;
        //angular.copy($scope.currentRecipeName, $scope.desiredMFRecipeName);
        //angular.copy($scope.MFRandomID, $scope.desiredMFRecipeID);

    }

    function menuMFItemClick(recipeInfo) {
        angular.copy(recipeInfo, $scope.MFContents);
        //$scope.MFContents = recipeInfo;
        $scope.desiredMFMode = recipeInfo[4];
        scrollScreen();
        $scope.MFMenuVisible = false;
        var newdate = new Date();
        newdate.setHours(0, $scope.MFContents[19], 0);
        $scope.desiredMFMode = $scope.MFContents[4];
        $scope.desiredMFModeText = $scope.MFContents[5];
        $scope.desiredMFDesc = $scope.MFContents[2];
        $scope.desiredMFHr = Number(newdate.getHours());
        $scope.desiredMFMin = Number(newdate.getMinutes());
        if ($scope.TempUnit === "F") {
            $scope.desiredMFTemp = Number($scope.MFContents[13]);
            $scope.MFMin = $scope.MFContents[14];
            $scope.MFMax = $scope.MFContents[15];
        } else {
            $scope.desiredMFTemp = Number($scope.MFContents[16]);
            $scope.MFMin = $scope.MFContents[17];
            $scope.MFMax = $scope.MFContents[18];

        }
    }

    function insertDataIntoFavoriteTable(recipeMode, recipeName, recipeTemp, recipeTime) {
        debugMessage('insertDataIntoFavoriteTable ' + recipeMode + " " + recipeName + " " + recipeTemp + " " + recipeTime);
        var myCookingContants = [], //$scope.MFContents, //getModeRowValue($scope.MFContents, $scope.displayReadyMode),
                favoriteTableData = getLocalStorageData(WALLOVEN_LOCALSTORAGE.FAVDB);
        angular.copy($scope.MFContents, myCookingContants);
        if (favoriteTableData === null || favoriteTableData.length === 0) {
            myCookingContants[0] = Math.random();
            myCookingContants[4] = recipeMode;
            myCookingContants[19] = recipeTime;
            myCookingContants[22] = recipeName;
            if ($scope.TempUnit === 'F') {
                myCookingContants[13] = recipeTemp;
                myCookingContants[16] = FtoC(recipeTemp);
            } else {
                myCookingContants[13] = CtoF(recipeTemp);
                myCookingContants[16] = recipeTemp;
            }
            myCookingContants[6] = selectedCavity === 'SINGLE' ? 'YES' : 'NO';
            myCookingContants[7] = selectedCavity === 'SINGLEFLEXUPPER' ? 'YES' : 'NO';
            myCookingContants[8] = selectedCavity === 'SINGLEFLEXLOWER' ? 'YES' : 'NO';
            myCookingContants[9] = selectedCavity === 'DUALUPPER' ? 'YES' : 'NO';
            myCookingContants[10] = selectedCavity === 'DUALLOWER' || selectedCavity === 'LOWERFLEX' ? 'YES' : 'NO';
            myCookingContants[11] = selectedCavity === 'DUALFLEXUPPER' ? 'YES' : 'NO';
            myCookingContants[12] = selectedCavity === 'DUALFLEXLOWER' ? 'YES' : 'NO';
            setLocalStorageData(WALLOVEN_LOCALSTORAGE.FAVDB, JSON.stringify([myCookingContants]));
        } else {
            var newLocalStorage = JSON.parse(getLocalStorageData(WALLOVEN_LOCALSTORAGE.FAVDB));
            myCookingContants[0] = Math.random();
            myCookingContants[4] = recipeMode;
            myCookingContants[19] = recipeTime;
            myCookingContants[22] = recipeName;
            if ($scope.TempUnit === 'F') {
                myCookingContants[13] = recipeTemp;
                myCookingContants[16] = FtoC(recipeTemp);
            } else {
                myCookingContants[13] = CtoF(recipeTemp);
                myCookingContants[16] = recipeTemp;
            }
            myCookingContants[6] = selectedCavity === 'SINGLE' ? 'YES' : 'NO';
            myCookingContants[7] = selectedCavity === 'SINGLEFLEXUPPER' ? 'YES' : 'NO';
            myCookingContants[8] = selectedCavity === 'SINGLEFLEXLOWER' ? 'YES' : 'NO';
            myCookingContants[9] = selectedCavity === 'DUALUPPER' ? 'YES' : 'NO';
            myCookingContants[10] = selectedCavity === 'DUALLOWER' || selectedCavity === 'LOWERFLEX' ? 'YES' : 'NO';
            myCookingContants[11] = selectedCavity === 'DUALFLEXUPPER' ? 'YES' : 'NO';
            myCookingContants[12] = selectedCavity === 'DUALFLEXLOWER' ? 'YES' : 'NO';
            newLocalStorage.push(myCookingContants);
            setLocalStorageData(WALLOVEN_LOCALSTORAGE.FAVDB, JSON.stringify(newLocalStorage));
        }
        updateMyFavItems();
        debugMessage("insertDataIntoFavoriteTable " + JSON.stringify(newLocalStorage));
    }

    function validateRecipeName(name) {
        debugMessage('validation for recipe name ' + name);
        if (name !== undefined && name.trim() === '') {
            showToast($scope.translation.WEBMOB_device_range_alarm_mycooking_enter_recipe_name);
            return false;
        }
        var newLocalStorage = JSON.parse(getLocalStorageData(WALLOVEN_LOCALSTORAGE.FAVDB));
        if (newLocalStorage === null || newLocalStorage.length === 0) {
            return true;
        }
        for (var i = 0; i < newLocalStorage.length; i++) {
            if (newLocalStorage[i][22] !== undefined && newLocalStorage[i][22].trim() === name.trim()) {
                showToast($scope.translation.WEBMOB_device_range_alarm_mycooking_name_duplicated);
                return false;
            }
        }
        return true;
    }

    function getMyCookingRecipeName() {
        var defaultRecipeName = $scope.translation.WEBMOB_device_walloven_myfavorite, j = 1;
        var newLocalStorage = JSON.parse(getLocalStorageData(WALLOVEN_LOCALSTORAGE.FAVDB));
        if (newLocalStorage === null) {
            return defaultRecipeName + ' 1';
        }
        while (true) {
            var uniqueNameFound = true;
            defaultRecipeName = $scope.translation.WEBMOB_device_walloven_myfavorite + ' ' + j;
            for (var i = 0; i < newLocalStorage.length; i++) {
                if (newLocalStorage[i][22] !== undefined && newLocalStorage[i][22].trim() === (defaultRecipeName).trim()) {
                    uniqueNameFound = false;
                    break;
                }
            }
            if (uniqueNameFound) {
                break;
            }
            j++;
        }

        return defaultRecipeName;
    }

    function recipeUpdated() {
        debugMessage('recipeUpdated');
        if ($scope.currentScreen !== WALLOVEN_SCREENS.WALLOVEN_EDIT_MY_FAVORITE_DETAIL_PAGE) {
            return false;
        }
        var newLocalStorage = JSON.parse(getLocalStorageData(WALLOVEN_LOCALSTORAGE.FAVDB));
        if (newLocalStorage === null || newLocalStorage.length === 0) {
            return false;
        }
        for (var k = 0; k < newLocalStorage.length; k++) {
            if ($scope.MFRandomID === newLocalStorage[k][0]) {
                newLocalStorage[k] = $scope.MFContents;
                debugMessage('recipeUpdated old  ' + newLocalStorage[k]);
                var recipeName = document.getElementById("inputMFName").value;

                if (recipeName !== $scope.desiredMFRecipeName) {
                    if (validateRecipeName(recipeName)) {
                        if (recipeName !== $scope.currentRecipeName) {
                            angular.copy(recipeName, $scope.currentRecipeName);
                        }
                        $scope.desiredMFRecipeName = recipeName;
                    } else {
                        return;
                    }
                }

                newLocalStorage[k][0] = $scope.MFRandomID;
                newLocalStorage[k][4] = $scope.desiredMFMode;
                newLocalStorage[k][22] = $scope.desiredMFRecipeName;
                var newdate = new Date();
                var newdate = new Date();
                newdate.setHours(Number($scope.desiredMFHr), Number($scope.desiredMFMin), 0);
                newLocalStorage[k][19] = newdate.getHours() * 60 + newdate.getMinutes();
                if ($scope.TempUnit === "F") {
                    newLocalStorage[k][13] = $scope.desiredMFTemp;
                    newLocalStorage[k][16] = FtoC($scope.desiredMFTemp);
                } else {
                    newLocalStorage[k][13] = CtoF($scope.desiredMFTemp);
                    newLocalStorage[k][16] = $scope.desiredMFTemp;
                }
                debugMessage('recipeUpdated new ' + newLocalStorage[k]);
                localStorage.clear();
                setLocalStorageData(WALLOVEN_LOCALSTORAGE.FAVDB, JSON.stringify(newLocalStorage));
                validateCurrentScreen('MyFavoritePage');
                return true;
            }
        }
        return false;
    }

    function saveButtonMF() {
        if (!$scope.MFFocused) {
            debugMessage('saveButtonMF');
            if (!recipeUpdated()) {
                saveRecipe();
            }
        }
    }

    function cancelSaveRecipe() {
        if (!$scope.MFFocused) {
            debugMessage('cancelSaveRecipe');
            onBackPressed();
        }
    }

    function saveRecipe() {
        debugMessage('saveRecipe');
        if (!validateRecipeName(document.getElementById("inputMFName").value)) {
            return;
        }

        if ($scope.myFavoriteList !== undefined && $scope.myFavoriteList !== null && $scope.myFavoriteList.length >= 10) {
            showToast($scope.translation.OVENMOB_LCD_please_delete_an_existing);
            return;
        }

        var time, newdate = new Date();
        newdate.setHours(Number($scope.desiredMFHr), Number($scope.desiredMFMin), 0);
        time = newdate.getHours() * 60 + newdate.getMinutes();
        insertDataIntoFavoriteTable($scope.desiredMFMode, document.getElementById("inputMFName").value, $scope.desiredMFTemp, time);
        validateCurrentScreen('MyFavoritePage');
    }

    function myFavListItem(recipe) {
        debugMessage('myFavListItem ' + recipe);
        if (!$scope.multiselect) {
            $scope.MFContents = recipe;
            loadMFData();
            validateCurrentScreen('MyFavoriteRecipeDetailPage');
        } else {
            var index = $scope.editMyCookingSelectedDeleteItems.indexOf(recipe[22]);
            if (index === -1) {
                $scope.editMyCookingSelectedDeleteItems.push(recipe[22]);
            } else {
                $scope.editMyCookingSelectedDeleteItems.splice(index, 1);
            }
            if ($scope.editMyCookingSelectedDeleteItems.length > 0) {
                $scope.selectAllText = $scope.translation.WEBMOB_device_walloven_selected;
            }
        }
    }

    function addMFCooking() {
        debugMessage('addMFCooking');
        $scope.MFContents = [];
        if ($scope.ovenFunctionContents === undefined) {
            initializeScreenDB();
            readDBValue();
            setDataCurrentScreen();
        }
        angular.copy($scope.ovenFunctionContents[0], $scope.MFContents);
        //$scope.MFContents = $scope.ovenFunctionContents[0];
        $scope.MFContents[22] = '';
        $scope.MFContents[0] = '';
        loadMFData();
        validateCurrentScreen('EditMyFavoriteDetailPage');
    }

    function editMFCooking() {
        debugMessage('editMFCooking');
        validateCurrentScreen('EditMyFavoriteDetailPage');
    }

    function deleteMFCooking() {
        if ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_MY_FAVORITE_PAGE) {
            debugMessage('deleteMyCookings : readyToDelete :' + $scope.myFavoriteList.length + ' && multiselect : ' + $scope.multiselect);
            if ($scope.myFavoriteList.length > 0) {
                $scope.editMyCookingSelectedDeleteItems = [];
                $scope.multiselect = !$scope.multiselect;
                $scope.headerBarVisible = !$scope.multiselect;
            }
        }
        if ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_MY_FAVORITE_RECIPE_DETAIL_PAGE) {
            $scope.editMyCookingSelectedDeleteItems = [];
            $scope.editMyCookingSelectedDeleteItems.push($scope.desiredMFRecipeName);
            deleteMyCookingsConfirmed();
        }
    }

    function selectAllDeleteMFCooking() {
        if ($scope.myFavoriteList.length !== $scope.editMyCookingSelectedDeleteItems.length) {
            debugMessage('selectAllEditMyCooking for delete');
            $scope.editMyCookingSelectedDeleteItems = [];
            for (var i = 0; i < $scope.myFavoriteList.length; i++) {
                $scope.editMyCookingSelectedDeleteItems.push($scope.myFavoriteList[i][22]);
            }
        } else {
            debugMessage('selectAllEditMyCooking empty selected list');
            $scope.editMyCookingSelectedDeleteItems = [];
        }
        $scope.selectAllText = $scope.translation.WEBMOB_device_walloven_selected;
    }

    function deleteMyCookings() {
        if ($scope.multiselect) {
            debugMessage('deleteMyCookingsConfirmed');
            deleteMyCookingsConfirmed();
        }
    }

    function deleteMyCookingsConfirmed() {
        var name;
        if ($scope.editMyCookingSelectedDeleteItems.length === 1) {
            name = $scope.editMyCookingSelectedDeleteItems[0] + " " + $scope.translation.WEBMOB_device_range_alarm_mycooking_delete_recipe;
        } else {
            name = $scope.editMyCookingSelectedDeleteItems.length + " " + $scope.translation.WEBMOB_device_range_alarm_mycooking_delete_recipe;
        }
        showcustDialog(WALLOVEN_ALERT_STATE.ALERT_DELETE_MY_COOKING, $scope.translation.WEBMOB_common_delete, name, $scope.translation.WEBMOB_common_cancel_capital, $scope.translation.WEBMOB_common_delete);
    }

    function isSelectedToDelete(item) {
        for (var i = 0; i < $scope.editMyCookingSelectedDeleteItems.length; i++) {
            if ($scope.editMyCookingSelectedDeleteItems[i] === item[22]) {
                return true;
            }
        }
        return false;
    }

    function smartcareerrorcheck() {
        if (!$scope.isStatic) {
            $scope.checkResponse.push(WALLOVEN_COMMANDS.smartCareDiagnosis);
            debugMessage("Send command for smartCareDiagnosis " + getDiagnosisCommand());
            SHPService.sendSHPCommand(CONSTANTS.PUT, getDiagnosisCommand(), "/" + $scope.peerId + "/devices/0/diagnosis");
        }
    }

    function getDiagnosisCommand() {
        return '{"Diagnosis": {"diagnosisStart": "Run"}}';
    }

    function starRecipeToMF() {
        debugMessage("starRecipeToMF");
        if ($scope.recipeStarted) {
            if ($scope.MFContents[22] !== null || $scope.MFContents[22] !== undefined || $scope.MFContents[22] !== '') {
                $scope.editMyCookingSelectedDeleteItems = [];
                $scope.editMyCookingSelectedDeleteItems.push($scope.MFContents[22]);
                deleteMyCookingsConfirmed();
            }
            return;
        }

        updateMyFavItems();

        if ($scope.myFavoriteList !== undefined && $scope.myFavoriteList !== null && $scope.myFavoriteList.length >= 10) {
            showToast($scope.translation.OVENMOB_LCD_please_delete_an_existing);
            return;
        }

        $scope.recipeStarted = true;
        var mode, temp, time, newdate = new Date(), recipeName = '';
        $scope.MFContents = [];
        $scope.MFContents = $scope.DisplayContents;
        $scope.MFContents[22] = '';
        $scope.MFContents[0] = '';
        mode = $scope.deviceMode;
        temp = $scope.desiredTemp;
        newdate.setHours(Number($scope.desiredHours), Number($scope.desiredMinutes), 0);
        time = newdate.getHours() * 60 + newdate.getMinutes();
        recipeName = getMyCookingRecipeName();
        $scope.MFContents[22] = recipeName;
        insertDataIntoFavoriteTable(mode, recipeName, temp, time);
        showToast($scope.translation.WEBMOB_device_walloven_save_as + " " + recipeName);
    }

    function updateMyFavItems() {
        $scope.myCookingContentsLocalStorage = JSON.parse(getLocalStorageData(WALLOVEN_LOCALSTORAGE.FAVDB));
        $scope.myFavoriteList = [];
        $scope.myFavoriteListItemsSingle = [];
        $scope.myFavoriteListItemsSingleFlexUpper = [];
        $scope.myFavoriteListItemsSingleFlexLower = [];
        $scope.myFavoriteListItemsDualUpper = [];
        $scope.myFavoriteListItemsDualLower = [];
        $scope.myFavoriteListItemsDualFLexUpper = [];
        $scope.myFavoriteListItemsDualFLexLower = [];

        if ($scope.myCookingContentsLocalStorage === null || $scope.myCookingContentsLocalStorage.length === 0) {
            debugMessage('return due to empty ' + $scope.myCookingContentsLocalStorage);
            return;
        }
        for (var i = 0; i < $scope.myCookingContentsLocalStorage.length; i++) {
            if ($scope.myCookingContentsLocalStorage[i][6] === 'YES') {
                $scope.myFavoriteListItemsSingle.push($scope.myCookingContentsLocalStorage[i]);
            }
            if ($scope.myCookingContentsLocalStorage[i][7] === 'YES') {
                $scope.myFavoriteListItemsSingleFlexUpper.push($scope.myCookingContentsLocalStorage[i]);
            }
            if ($scope.myCookingContentsLocalStorage[i][8] === 'YES') {
                $scope.myFavoriteListItemsSingleFlexLower.push($scope.myCookingContentsLocalStorage[i]);
            }
            if ($scope.myCookingContentsLocalStorage[i][9] === 'YES') {
                $scope.myFavoriteListItemsDualUpper.push($scope.myCookingContentsLocalStorage[i]);
            }
            if ($scope.myCookingContentsLocalStorage[i][10] === 'YES') {
                $scope.myFavoriteListItemsDualLower.push($scope.myCookingContentsLocalStorage[i]);
            }
            if ($scope.myCookingContentsLocalStorage[i][11] === 'YES') {
                $scope.myFavoriteListItemsDualFLexUpper.push($scope.myCookingContentsLocalStorage[i]);
            }
            if ($scope.myCookingContentsLocalStorage[i][12] === 'YES') {
                $scope.myFavoriteListItemsDualFLexLower.push($scope.myCookingContentsLocalStorage[i]);
            }
        }

        if (selectedCavity === 'SINGLE') {
            $scope.myFavoriteList = $scope.myFavoriteListItemsSingle;
        } else if (selectedCavity === 'SINGLEFLEXUPPER') {
            $scope.myFavoriteList = $scope.myFavoriteListItemsSingleFlexUpper;
        } else if (selectedCavity === 'SINGLEFLEXLOWER') {
            $scope.myFavoriteList = $scope.myFavoriteListItemsSingleFlexLower;
        } else if (selectedCavity === 'DUALUPPER') {
            $scope.myFavoriteList = $scope.myFavoriteListItemsDualUpper;
        } else if (selectedCavity === 'DUALLOWER') {
            $scope.myFavoriteList = $scope.myFavoriteListItemsDualLower;
        } else if (selectedCavity === 'DUALFLEXUPPER') {
            $scope.myFavoriteList = $scope.myFavoriteListItemsDualFLexUpper;
        } else if (selectedCavity === 'DUALFLEXLOWER') {
            $scope.myFavoriteList = $scope.myFavoriteListItemsDualFLexLower;
        } else if (selectedCavity === 'LOWERFLEX') {
            $scope.myFavoriteList = $scope.myFavoriteListItemsDualLower;
        } else if (selectedCavity === '') {
            //TODO
        }
        //debugMessage('$scope.myFavoriteList > ' + JSON.stringify($scope.myFavoriteList));
    }

    $scope.$watch(function () {
        return $scope.showFullScreenPopup;
    }, function () {
        if (angular.isDefined($scope.currentScreen)) {
            debugMessage("currentScreen");
            if ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_MY_FAVORITE_RECIPE_DETAIL_PAGE) {
                fixScreen();
            }
        }
    });

    if ($scope.isStatic) {
        parseStaticData();
    }
    //clearLocalStorage();   

    function checkOvenStartState() {
        var disable = false;

        /*
         * Steam bake and Steam Roast mode need to check water tank's status.
         * waterInlet_Open : cannot start
         * waterInlet_Closed : can start
         * 
         * waterTankInSwitch_Off : cannot start
         * waterTankInSwitch_On : can start   
         */
        var mode = ($scope.currentScreen === WALLOVEN_SCREENS.WALLOVEN_MY_FAVORITE_RECIPE_DETAIL_PAGE) ? $scope.desiredMFMode : $scope.deviceMode;
        if (($scope.idZero.Mode.options[0].waterInlet === "Open" || $scope.idOne.Mode.options[0].waterInlet === "Open"
                || $scope.idTwo.Mode.options[0].waterInlet === "Open" || $scope.idZero.Mode.options[0].waterTankInSwitch === "Off"
                || $scope.idOne.Mode.options[0].waterTankInSwitch === "Off" || $scope.idTwo.Mode.options[0].waterTankInSwitch === "Off")
                && (mode === 'SteamRoast' || mode === 'SteamBake')) {
            disable = true;
        }

        //when upper or lower is working as "Self Clean" or "Pyro Free", then the other cavity cannot start.
        if (($scope.idZero.Mode.modes[0] === "SelfClean" && $scope.idZero.Operation.state === "Run")
                || ($scope.idOne.Mode.modes[0] === "SelfClean" && $scope.idOne.Operation.state === "Run")
                || ($scope.idTwo.Mode.modes[0] === "SelfClean" && $scope.idTwo.Operation.state === "Run")
                || ($scope.idZero.Mode.modes[0] === "PyroFree" && $scope.idZero.Operation.state === "Run")
                || ($scope.idOne.Mode.modes[0] === "PyroFree" && $scope.idOne.Operation.state === "Run")
                || ($scope.idTwo.Mode.modes[0] === "PyroFree" && $scope.idTwo.Operation.state === "Run")) {
            disable = true;
        }
        return disable;
    }
}

app.directive('selectText', ['$window', function ($window) {
        return {
            restrict: 'A',
            link: function ($scope, element) {
                element.on('click', function (e) {
                    if ($scope.MFFocused) {
                        e.stopImmediatePropagation();
                        $window.document.getElementById("inputMFName").blur();
                        return;
                    }
                    if (!$window.getSelection().toString()) {
                        this.setSelectionRange(0, this.value.length);
                    }
                });
            }
        };
    }]);
